# ! [ cfg_attr ( feature = "rt" , feature ( global_asm ) ) ] # ! [ cfg_attr ( feature = "rt" , feature ( macro_reexport ) ) ] # ! [ cfg_attr ( feature = "rt" , feature ( used ) ) ] # ! [ doc = "Peripheral access API for XMC4200 microcontrollers (generated using svd2rust v0.11.4)\n\nYou can find an overview of the API [here].\n\n[here]: https://docs.rs/svd2rust/0.11.4/svd2rust/#peripheral-api" ] # ! [ deny ( missing_docs ) ] # ! [ deny ( warnings ) ] # ! [ allow ( non_camel_case_types ) ] # ! [ feature ( const_fn ) ] # ! [ no_std ]extern crate cortex_m ;
#[macro_reexport(default_handler, exception)]
#[cfg(feature = "rt")]
extern crate cortex_m_rt ;
extern crate bare_metal ;
extern crate vcell ;
use core::ops::Deref;
use bare_metal::Peripheral;
#[doc = r" Number available in the NVIC for configuring priority"]
pub const NVIC_PRIO_BITS: u8 = 6;
pub use interrupt::Interrupt;
#[doc(hidden)]
pub mod interrupt {
    use bare_metal::Nr;
    #[cfg(all(target_arch = "arm", feature = "rt"))]
    global_asm!(
        "
                    .thumb_func
                    DH_TRAMPOLINE:
                        b DEFAULT_HANDLER
                    "
    );
    #[doc = r" Hack to compile on x86"]
    #[cfg(all(target_arch = "x86_64", feature = "rt"))]
    global_asm!(
        "
                    DH_TRAMPOLINE:
                        jmp DEFAULT_HANDLER
                    "
    );
    #[cfg(feature = "rt")]
    global_asm!(
        "\n.weak SCU_0\nSCU_0 = DH_TRAMPOLINE\n.weak ERU0_0\nERU0_0 = DH_TRAMPOLINE\n.weak ERU0_1\nERU0_1 = DH_TRAMPOLINE\n.weak ERU0_2\nERU0_2 = DH_TRAMPOLINE\n.weak ERU0_3\nERU0_3 = DH_TRAMPOLINE\n.weak ERU1_0\nERU1_0 = DH_TRAMPOLINE\n.weak ERU1_1\nERU1_1 = DH_TRAMPOLINE\n.weak ERU1_2\nERU1_2 = DH_TRAMPOLINE\n.weak ERU1_3\nERU1_3 = DH_TRAMPOLINE\n.weak PMU0_0\nPMU0_0 = DH_TRAMPOLINE\n.weak VADC0_C0_0\nVADC0_C0_0 = DH_TRAMPOLINE\n.weak VADC0_C0_1\nVADC0_C0_1 = DH_TRAMPOLINE\n.weak VADC0_C0_2\nVADC0_C0_2 = DH_TRAMPOLINE\n.weak VADC0_C0_3\nVADC0_C0_3 = DH_TRAMPOLINE\n.weak VADC0_G0_0\nVADC0_G0_0 = DH_TRAMPOLINE\n.weak VADC0_G0_1\nVADC0_G0_1 = DH_TRAMPOLINE\n.weak VADC0_G0_2\nVADC0_G0_2 = DH_TRAMPOLINE\n.weak VADC0_G0_3\nVADC0_G0_3 = DH_TRAMPOLINE\n.weak VADC0_G1_0\nVADC0_G1_0 = DH_TRAMPOLINE\n.weak VADC0_G1_1\nVADC0_G1_1 = DH_TRAMPOLINE\n.weak VADC0_G1_2\nVADC0_G1_2 = DH_TRAMPOLINE\n.weak VADC0_G1_3\nVADC0_G1_3 = DH_TRAMPOLINE\n.weak DAC0_0\nDAC0_0 = DH_TRAMPOLINE\n.weak DAC0_1\nDAC0_1 = DH_TRAMPOLINE\n.weak CCU40_0\nCCU40_0 = DH_TRAMPOLINE\n.weak CCU40_1\nCCU40_1 = DH_TRAMPOLINE\n.weak CCU40_2\nCCU40_2 = DH_TRAMPOLINE\n.weak CCU40_3\nCCU40_3 = DH_TRAMPOLINE\n.weak CCU41_0\nCCU41_0 = DH_TRAMPOLINE\n.weak CCU41_1\nCCU41_1 = DH_TRAMPOLINE\n.weak CCU41_2\nCCU41_2 = DH_TRAMPOLINE\n.weak CCU41_3\nCCU41_3 = DH_TRAMPOLINE\n.weak CCU80_0\nCCU80_0 = DH_TRAMPOLINE\n.weak CCU80_1\nCCU80_1 = DH_TRAMPOLINE\n.weak CCU80_2\nCCU80_2 = DH_TRAMPOLINE\n.weak CCU80_3\nCCU80_3 = DH_TRAMPOLINE\n.weak POSIF0_0\nPOSIF0_0 = DH_TRAMPOLINE\n.weak POSIF0_1\nPOSIF0_1 = DH_TRAMPOLINE\n.weak HRPWM_0\nHRPWM_0 = DH_TRAMPOLINE\n.weak HRPWM_1\nHRPWM_1 = DH_TRAMPOLINE\n.weak HRPWM_2\nHRPWM_2 = DH_TRAMPOLINE\n.weak HRPWM_3\nHRPWM_3 = DH_TRAMPOLINE\n.weak CAN0_0\nCAN0_0 = DH_TRAMPOLINE\n.weak CAN0_1\nCAN0_1 = DH_TRAMPOLINE\n.weak CAN0_2\nCAN0_2 = DH_TRAMPOLINE\n.weak CAN0_3\nCAN0_3 = DH_TRAMPOLINE\n.weak CAN0_4\nCAN0_4 = DH_TRAMPOLINE\n.weak CAN0_5\nCAN0_5 = DH_TRAMPOLINE\n.weak CAN0_6\nCAN0_6 = DH_TRAMPOLINE\n.weak CAN0_7\nCAN0_7 = DH_TRAMPOLINE\n.weak USIC0_0\nUSIC0_0 = DH_TRAMPOLINE\n.weak USIC0_1\nUSIC0_1 = DH_TRAMPOLINE\n.weak USIC0_2\nUSIC0_2 = DH_TRAMPOLINE\n.weak USIC0_3\nUSIC0_3 = DH_TRAMPOLINE\n.weak USIC0_4\nUSIC0_4 = DH_TRAMPOLINE\n.weak USIC0_5\nUSIC0_5 = DH_TRAMPOLINE\n.weak USIC1_0\nUSIC1_0 = DH_TRAMPOLINE\n.weak USIC1_1\nUSIC1_1 = DH_TRAMPOLINE\n.weak USIC1_2\nUSIC1_2 = DH_TRAMPOLINE\n.weak USIC1_3\nUSIC1_3 = DH_TRAMPOLINE\n.weak USIC1_4\nUSIC1_4 = DH_TRAMPOLINE\n.weak USIC1_5\nUSIC1_5 = DH_TRAMPOLINE\n.weak LEDTS0_0\nLEDTS0_0 = DH_TRAMPOLINE\n.weak FCE0_0\nFCE0_0 = DH_TRAMPOLINE\n.weak GPDMA0_0\nGPDMA0_0 = DH_TRAMPOLINE\n.weak USB0_0\nUSB0_0 = DH_TRAMPOLINE"
    );
    #[cfg(feature = "rt")]
    extern "C" {
        fn SCU_0();
        fn ERU0_0();
        fn ERU0_1();
        fn ERU0_2();
        fn ERU0_3();
        fn ERU1_0();
        fn ERU1_1();
        fn ERU1_2();
        fn ERU1_3();
        fn PMU0_0();
        fn VADC0_C0_0();
        fn VADC0_C0_1();
        fn VADC0_C0_2();
        fn VADC0_C0_3();
        fn VADC0_G0_0();
        fn VADC0_G0_1();
        fn VADC0_G0_2();
        fn VADC0_G0_3();
        fn VADC0_G1_0();
        fn VADC0_G1_1();
        fn VADC0_G1_2();
        fn VADC0_G1_3();
        fn DAC0_0();
        fn DAC0_1();
        fn CCU40_0();
        fn CCU40_1();
        fn CCU40_2();
        fn CCU40_3();
        fn CCU41_0();
        fn CCU41_1();
        fn CCU41_2();
        fn CCU41_3();
        fn CCU80_0();
        fn CCU80_1();
        fn CCU80_2();
        fn CCU80_3();
        fn POSIF0_0();
        fn POSIF0_1();
        fn HRPWM_0();
        fn HRPWM_1();
        fn HRPWM_2();
        fn HRPWM_3();
        fn CAN0_0();
        fn CAN0_1();
        fn CAN0_2();
        fn CAN0_3();
        fn CAN0_4();
        fn CAN0_5();
        fn CAN0_6();
        fn CAN0_7();
        fn USIC0_0();
        fn USIC0_1();
        fn USIC0_2();
        fn USIC0_3();
        fn USIC0_4();
        fn USIC0_5();
        fn USIC1_0();
        fn USIC1_1();
        fn USIC1_2();
        fn USIC1_3();
        fn USIC1_4();
        fn USIC1_5();
        fn LEDTS0_0();
        fn FCE0_0();
        fn GPDMA0_0();
        fn USB0_0();
    }
    #[allow(private_no_mangle_statics)]
    #[cfg(feature = "rt")]
    #[doc(hidden)]
    #[link_section = ".vector_table.interrupts"]
    #[no_mangle]
    #[used]
    pub static INTERRUPTS: [Option<unsafe extern "C" fn()>; 108] = [
        Some(SCU_0),
        Some(ERU0_0),
        Some(ERU0_1),
        Some(ERU0_2),
        Some(ERU0_3),
        Some(ERU1_0),
        Some(ERU1_1),
        Some(ERU1_2),
        Some(ERU1_3),
        None,
        None,
        None,
        Some(PMU0_0),
        None,
        Some(VADC0_C0_0),
        Some(VADC0_C0_1),
        Some(VADC0_C0_2),
        Some(VADC0_C0_3),
        Some(VADC0_G0_0),
        Some(VADC0_G0_1),
        Some(VADC0_G0_2),
        Some(VADC0_G0_3),
        Some(VADC0_G1_0),
        Some(VADC0_G1_1),
        Some(VADC0_G1_2),
        Some(VADC0_G1_3),
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        Some(DAC0_0),
        Some(DAC0_1),
        Some(CCU40_0),
        Some(CCU40_1),
        Some(CCU40_2),
        Some(CCU40_3),
        Some(CCU41_0),
        Some(CCU41_1),
        Some(CCU41_2),
        Some(CCU41_3),
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        None,
        Some(CCU80_0),
        Some(CCU80_1),
        Some(CCU80_2),
        Some(CCU80_3),
        None,
        None,
        None,
        None,
        Some(POSIF0_0),
        Some(POSIF0_1),
        None,
        None,
        Some(HRPWM_0),
        Some(HRPWM_1),
        Some(HRPWM_2),
        Some(HRPWM_3),
        Some(CAN0_0),
        Some(CAN0_1),
        Some(CAN0_2),
        Some(CAN0_3),
        Some(CAN0_4),
        Some(CAN0_5),
        Some(CAN0_6),
        Some(CAN0_7),
        Some(USIC0_0),
        Some(USIC0_1),
        Some(USIC0_2),
        Some(USIC0_3),
        Some(USIC0_4),
        Some(USIC0_5),
        Some(USIC1_0),
        Some(USIC1_1),
        Some(USIC1_2),
        Some(USIC1_3),
        Some(USIC1_4),
        Some(USIC1_5),
        None,
        None,
        None,
        None,
        None,
        None,
        Some(LEDTS0_0),
        None,
        Some(FCE0_0),
        Some(GPDMA0_0),
        None,
        Some(USB0_0),
    ];
    #[doc = r" Enumeration of all the interrupts"]
    pub enum Interrupt {
        #[doc = "0 - System Control"]
        SCU_0,
        #[doc = "1 - External Request Unit 0"]
        ERU0_0,
        #[doc = "2 - External Request Unit 0"]
        ERU0_1,
        #[doc = "3 - External Request Unit 0"]
        ERU0_2,
        #[doc = "4 - External Request Unit 0"]
        ERU0_3,
        #[doc = "5 - External Request Unit 1"]
        ERU1_0,
        #[doc = "6 - External Request Unit 1"]
        ERU1_1,
        #[doc = "7 - External Request Unit 1"]
        ERU1_2,
        #[doc = "8 - External Request Unit 1"]
        ERU1_3,
        #[doc = "12 - Program Management Unit"]
        PMU0_0,
        #[doc = "14 - Analog to Digital Converter Common Block 0"]
        VADC0_C0_0,
        #[doc = "15 - Analog to Digital Converter Common Block 0"]
        VADC0_C0_1,
        #[doc = "16 - Analog to Digital Converter Common Block 0"]
        VADC0_C0_2,
        #[doc = "17 - Analog to Digital Converter Common Block 0"]
        VADC0_C0_3,
        #[doc = "18 - Analog to Digital Converter Group 0"]
        VADC0_G0_0,
        #[doc = "19 - Analog to Digital Converter Group 0"]
        VADC0_G0_1,
        #[doc = "20 - Analog to Digital Converter Group 0"]
        VADC0_G0_2,
        #[doc = "21 - Analog to Digital Converter Group 0"]
        VADC0_G0_3,
        #[doc = "22 - Analog to Digital Converter Group 1"]
        VADC0_G1_0,
        #[doc = "23 - Analog to Digital Converter Group 1"]
        VADC0_G1_1,
        #[doc = "24 - Analog to Digital Converter Group 1"]
        VADC0_G1_2,
        #[doc = "25 - Analog to Digital Converter Group 1"]
        VADC0_G1_3,
        #[doc = "42 - Digital to Analog Converter"]
        DAC0_0,
        #[doc = "43 - Digital to Analog Converter"]
        DAC0_1,
        #[doc = "44 - Capture Compare Unit 4 (Module 0)"]
        CCU40_0,
        #[doc = "45 - Capture Compare Unit 4 (Module 0)"]
        CCU40_1,
        #[doc = "46 - Capture Compare Unit 4 (Module 0)"]
        CCU40_2,
        #[doc = "47 - Capture Compare Unit 4 (Module 0)"]
        CCU40_3,
        #[doc = "48 - Capture Compare Unit 4 (Module 1)"]
        CCU41_0,
        #[doc = "49 - Capture Compare Unit 4 (Module 1)"]
        CCU41_1,
        #[doc = "50 - Capture Compare Unit 4 (Module 1)"]
        CCU41_2,
        #[doc = "51 - Capture Compare Unit 4 (Module 1)"]
        CCU41_3,
        #[doc = "60 - Capture Compare Unit 8 (Module 0)"]
        CCU80_0,
        #[doc = "61 - Capture Compare Unit 8 (Module 0)"]
        CCU80_1,
        #[doc = "62 - Capture Compare Unit 8 (Module 0)"]
        CCU80_2,
        #[doc = "63 - Capture Compare Unit 8 (Module 0)"]
        CCU80_3,
        #[doc = "68 - Position Interface (Module 0)"]
        POSIF0_0,
        #[doc = "69 - Position Interface (Module 0)"]
        POSIF0_1,
        #[doc = "72 - High Resolution Pulse Width Modulation (Module 0)"]
        HRPWM_0,
        #[doc = "73 - High Resolution Pulse Width Modulation (Module 0)"]
        HRPWM_1,
        #[doc = "74 - High Resolution Pulse Width Modulation (Module 0)"]
        HRPWM_2,
        #[doc = "75 - High Resolution Pulse Width Modulation (Module 0)"]
        HRPWM_3,
        #[doc = "76 - MultiCAN"]
        CAN0_0,
        #[doc = "77 - MultiCAN"]
        CAN0_1,
        #[doc = "78 - MultiCAN"]
        CAN0_2,
        #[doc = "79 - MultiCAN"]
        CAN0_3,
        #[doc = "80 - MultiCAN"]
        CAN0_4,
        #[doc = "81 - MultiCAN"]
        CAN0_5,
        #[doc = "82 - MultiCAN"]
        CAN0_6,
        #[doc = "83 - MultiCAN"]
        CAN0_7,
        #[doc = "84 - Universal Serial Interface Channel (Module 0)"]
        USIC0_0,
        #[doc = "85 - Universal Serial Interface Channel (Module 0)"]
        USIC0_1,
        #[doc = "86 - Universal Serial Interface Channel (Module 0)"]
        USIC0_2,
        #[doc = "87 - Universal Serial Interface Channel (Module 0)"]
        USIC0_3,
        #[doc = "88 - Universal Serial Interface Channel (Module 0)"]
        USIC0_4,
        #[doc = "89 - Universal Serial Interface Channel (Module 0)"]
        USIC0_5,
        #[doc = "90 - Universal Serial Interface Channel (Module 1)"]
        USIC1_0,
        #[doc = "91 - Universal Serial Interface Channel (Module 1)"]
        USIC1_1,
        #[doc = "92 - Universal Serial Interface Channel (Module 1)"]
        USIC1_2,
        #[doc = "93 - Universal Serial Interface Channel (Module 1)"]
        USIC1_3,
        #[doc = "94 - Universal Serial Interface Channel (Module 1)"]
        USIC1_4,
        #[doc = "95 - Universal Serial Interface Channel (Module 1)"]
        USIC1_5,
        #[doc = "102 - LED and Touch Sense Control Unit (Module 0)"]
        LEDTS0_0,
        #[doc = "104 - Flexible CRC Engine"]
        FCE0_0,
        #[doc = "105 - General Purpose DMA Unit 0"]
        GPDMA0_0,
        #[doc = "107 - Universal Serial Bus (Module 0)"]
        USB0_0,
    }
    unsafe impl Nr for Interrupt {
        #[inline]
        fn nr(&self) -> u8 {
            match *self {
                Interrupt::SCU_0 => 0,
                Interrupt::ERU0_0 => 1,
                Interrupt::ERU0_1 => 2,
                Interrupt::ERU0_2 => 3,
                Interrupt::ERU0_3 => 4,
                Interrupt::ERU1_0 => 5,
                Interrupt::ERU1_1 => 6,
                Interrupt::ERU1_2 => 7,
                Interrupt::ERU1_3 => 8,
                Interrupt::PMU0_0 => 12,
                Interrupt::VADC0_C0_0 => 14,
                Interrupt::VADC0_C0_1 => 15,
                Interrupt::VADC0_C0_2 => 16,
                Interrupt::VADC0_C0_3 => 17,
                Interrupt::VADC0_G0_0 => 18,
                Interrupt::VADC0_G0_1 => 19,
                Interrupt::VADC0_G0_2 => 20,
                Interrupt::VADC0_G0_3 => 21,
                Interrupt::VADC0_G1_0 => 22,
                Interrupt::VADC0_G1_1 => 23,
                Interrupt::VADC0_G1_2 => 24,
                Interrupt::VADC0_G1_3 => 25,
                Interrupt::DAC0_0 => 42,
                Interrupt::DAC0_1 => 43,
                Interrupt::CCU40_0 => 44,
                Interrupt::CCU40_1 => 45,
                Interrupt::CCU40_2 => 46,
                Interrupt::CCU40_3 => 47,
                Interrupt::CCU41_0 => 48,
                Interrupt::CCU41_1 => 49,
                Interrupt::CCU41_2 => 50,
                Interrupt::CCU41_3 => 51,
                Interrupt::CCU80_0 => 60,
                Interrupt::CCU80_1 => 61,
                Interrupt::CCU80_2 => 62,
                Interrupt::CCU80_3 => 63,
                Interrupt::POSIF0_0 => 68,
                Interrupt::POSIF0_1 => 69,
                Interrupt::HRPWM_0 => 72,
                Interrupt::HRPWM_1 => 73,
                Interrupt::HRPWM_2 => 74,
                Interrupt::HRPWM_3 => 75,
                Interrupt::CAN0_0 => 76,
                Interrupt::CAN0_1 => 77,
                Interrupt::CAN0_2 => 78,
                Interrupt::CAN0_3 => 79,
                Interrupt::CAN0_4 => 80,
                Interrupt::CAN0_5 => 81,
                Interrupt::CAN0_6 => 82,
                Interrupt::CAN0_7 => 83,
                Interrupt::USIC0_0 => 84,
                Interrupt::USIC0_1 => 85,
                Interrupt::USIC0_2 => 86,
                Interrupt::USIC0_3 => 87,
                Interrupt::USIC0_4 => 88,
                Interrupt::USIC0_5 => 89,
                Interrupt::USIC1_0 => 90,
                Interrupt::USIC1_1 => 91,
                Interrupt::USIC1_2 => 92,
                Interrupt::USIC1_3 => 93,
                Interrupt::USIC1_4 => 94,
                Interrupt::USIC1_5 => 95,
                Interrupt::LEDTS0_0 => 102,
                Interrupt::FCE0_0 => 104,
                Interrupt::GPDMA0_0 => 105,
                Interrupt::USB0_0 => 107,
            }
        }
    }
    #[cfg(feature = "rt")]
    #[macro_export]
    macro_rules ! interrupt { ( $ NAME : ident , $ path : path , locals : { $ ( $ lvar : ident : $ lty : ident = $ lval : expr ; ) * } ) => { # [ allow ( non_snake_case ) ] mod $ NAME { pub struct Locals { $ ( pub $ lvar : $ lty , ) * } } # [ allow ( non_snake_case ) ] # [ no_mangle ] pub extern "C" fn $ NAME ( ) { let _ = $ crate :: interrupt :: Interrupt :: $ NAME ; static mut LOCALS : self :: $ NAME :: Locals = self :: $ NAME :: Locals { $ ( $ lvar : $ lval , ) * } ; let f : fn ( & mut self :: $ NAME :: Locals ) = $ path ; f ( unsafe { & mut LOCALS } ) ; } } ; ( $ NAME : ident , $ path : path ) => { # [ allow ( non_snake_case ) ] # [ no_mangle ] pub extern "C" fn $ NAME ( ) { let _ = $ crate :: interrupt :: Interrupt :: $ NAME ; let f : fn ( ) = $ path ; f ( ) ; } } }
}
pub use cortex_m::peripheral::CPUID;
pub use cortex_m::peripheral::DCB;
pub use cortex_m::peripheral::DWT;
pub use cortex_m::peripheral::FPB;
pub use cortex_m::peripheral::FPU;
pub use cortex_m::peripheral::ITM;
pub use cortex_m::peripheral::MPU;
pub use cortex_m::peripheral::NVIC;
pub use cortex_m::peripheral::SCB;
pub use cortex_m::peripheral::SYST;
pub use cortex_m::peripheral::TPIU;
#[doc = "Cortex-M4 Private Peripheral Block"]
pub const PPB: Peripheral<PPB> = unsafe { Peripheral::new(0xe000_e000) };
#[doc = "Cortex-M4 Private Peripheral Block"]
pub mod ppb {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        _reserved0: [u8; 8usize],
        #[doc = "0x08 - Auxiliary Control Register"]
        pub actlr: ACTLR,
        _reserved1: [u8; 4usize],
        #[doc = "0x10 - SysTick Control and Status Register"]
        pub syst_csr: SYST_CSR,
        #[doc = "0x14 - SysTick Reload Value Register"]
        pub syst_rvr: SYST_RVR,
        #[doc = "0x18 - SysTick Current Value Register"]
        pub syst_cvr: SYST_CVR,
        #[doc = "0x1c - SysTick Calibration Value Register r"]
        pub syst_calib: SYST_CALIB,
        _reserved2: [u8; 224usize],
        #[doc = "0x100 - Interrupt Set-enable Register 0"]
        pub nvic_iser0: NVIC_ISER0,
        #[doc = "0x104 - Interrupt Set-enable Register 1"]
        pub nvic_iser1: NVIC_ISER1,
        #[doc = "0x108 - Interrupt Set-enable Register 2"]
        pub nvic_iser2: NVIC_ISER2,
        #[doc = "0x10c - Interrupt Set-enable Register 3"]
        pub nvic_iser3: NVIC_ISER3,
        _reserved3: [u8; 112usize],
        #[doc = "0x180 - Interrupt Clear-enable Register 0"]
        pub nvic_icer0: NVIC_ICER0,
        #[doc = "0x184 - Interrupt Clear-enable Register 1"]
        pub nvic_icer1: NVIC_ICER1,
        #[doc = "0x188 - Interrupt Clear-enable Register 2"]
        pub nvic_icer2: NVIC_ICER2,
        #[doc = "0x18c - Interrupt Clear-enable Register 3"]
        pub nvic_icer3: NVIC_ICER3,
        _reserved4: [u8; 112usize],
        #[doc = "0x200 - Interrupt Set-pending Register 0"]
        pub nvic_ispr0: NVIC_ISPR0,
        #[doc = "0x204 - Interrupt Set-pending Register 1"]
        pub nvic_ispr1: NVIC_ISPR1,
        #[doc = "0x208 - Interrupt Set-pending Register 2"]
        pub nvic_ispr2: NVIC_ISPR2,
        #[doc = "0x20c - Interrupt Set-pending Register 3"]
        pub nvic_ispr3: NVIC_ISPR3,
        _reserved5: [u8; 112usize],
        #[doc = "0x280 - Interrupt Clear-pending Register 0"]
        pub nvic_icpr0: NVIC_ICPR0,
        #[doc = "0x284 - Interrupt Clear-pending Register 1"]
        pub nvic_icpr1: NVIC_ICPR1,
        #[doc = "0x288 - Interrupt Clear-pending Register 2"]
        pub nvic_icpr2: NVIC_ICPR2,
        #[doc = "0x28c - Interrupt Clear-pending Register 3"]
        pub nvic_icpr3: NVIC_ICPR3,
        _reserved6: [u8; 112usize],
        #[doc = "0x300 - Interrupt Active Bit Register 0"]
        pub nvic_iabr0: NVIC_IABR0,
        #[doc = "0x304 - Interrupt Active Bit Register 1"]
        pub nvic_iabr1: NVIC_IABR1,
        #[doc = "0x308 - Interrupt Active Bit Register 2"]
        pub nvic_iabr2: NVIC_IABR2,
        #[doc = "0x30c - Interrupt Active Bit Register 3"]
        pub nvic_iabr3: NVIC_IABR3,
        _reserved7: [u8; 240usize],
        #[doc = "0x400 - Interrupt Priority Register 0"]
        pub nvic_ipr0: NVIC_IPR0,
        #[doc = "0x404 - Interrupt Priority Register 1"]
        pub nvic_ipr1: NVIC_IPR1,
        #[doc = "0x408 - Interrupt Priority Register 2"]
        pub nvic_ipr2: NVIC_IPR2,
        #[doc = "0x40c - Interrupt Priority Register 3"]
        pub nvic_ipr3: NVIC_IPR3,
        #[doc = "0x410 - Interrupt Priority Register 4"]
        pub nvic_ipr4: NVIC_IPR4,
        #[doc = "0x414 - Interrupt Priority Register 5"]
        pub nvic_ipr5: NVIC_IPR5,
        #[doc = "0x418 - Interrupt Priority Register 6"]
        pub nvic_ipr6: NVIC_IPR6,
        #[doc = "0x41c - Interrupt Priority Register 7"]
        pub nvic_ipr7: NVIC_IPR7,
        #[doc = "0x420 - Interrupt Priority Register 8"]
        pub nvic_ipr8: NVIC_IPR8,
        #[doc = "0x424 - Interrupt Priority Register 9"]
        pub nvic_ipr9: NVIC_IPR9,
        #[doc = "0x428 - Interrupt Priority Register 10"]
        pub nvic_ipr10: NVIC_IPR10,
        #[doc = "0x42c - Interrupt Priority Register 11"]
        pub nvic_ipr11: NVIC_IPR11,
        #[doc = "0x430 - Interrupt Priority Register 12"]
        pub nvic_ipr12: NVIC_IPR12,
        #[doc = "0x434 - Interrupt Priority Register 13"]
        pub nvic_ipr13: NVIC_IPR13,
        #[doc = "0x438 - Interrupt Priority Register 14"]
        pub nvic_ipr14: NVIC_IPR14,
        #[doc = "0x43c - Interrupt Priority Register 15"]
        pub nvic_ipr15: NVIC_IPR15,
        #[doc = "0x440 - Interrupt Priority Register 16"]
        pub nvic_ipr16: NVIC_IPR16,
        #[doc = "0x444 - Interrupt Priority Register 17"]
        pub nvic_ipr17: NVIC_IPR17,
        #[doc = "0x448 - Interrupt Priority Register 18"]
        pub nvic_ipr18: NVIC_IPR18,
        #[doc = "0x44c - Interrupt Priority Register 19"]
        pub nvic_ipr19: NVIC_IPR19,
        #[doc = "0x450 - Interrupt Priority Register 20"]
        pub nvic_ipr20: NVIC_IPR20,
        #[doc = "0x454 - Interrupt Priority Register 21"]
        pub nvic_ipr21: NVIC_IPR21,
        #[doc = "0x458 - Interrupt Priority Register 22"]
        pub nvic_ipr22: NVIC_IPR22,
        #[doc = "0x45c - Interrupt Priority Register 23"]
        pub nvic_ipr23: NVIC_IPR23,
        #[doc = "0x460 - Interrupt Priority Register 24"]
        pub nvic_ipr24: NVIC_IPR24,
        #[doc = "0x464 - Interrupt Priority Register 25"]
        pub nvic_ipr25: NVIC_IPR25,
        #[doc = "0x468 - Interrupt Priority Register 26"]
        pub nvic_ipr26: NVIC_IPR26,
        #[doc = "0x46c - Interrupt Priority Register 27"]
        pub nvic_ipr27: NVIC_IPR27,
        _reserved8: [u8; 2192usize],
        #[doc = "0xd00 - CPUID Base Register"]
        pub cpuid: CPUID,
        #[doc = "0xd04 - Interrupt Control and State Register"]
        pub icsr: ICSR,
        #[doc = "0xd08 - Vector Table Offset Register"]
        pub vtor: VTOR,
        #[doc = "0xd0c - Application Interrupt and Reset Control Register"]
        pub aircr: AIRCR,
        #[doc = "0xd10 - System Control Register"]
        pub scr: SCR,
        #[doc = "0xd14 - Configuration and Control Register"]
        pub ccr: CCR,
        #[doc = "0xd18 - System Handler Priority Register 1"]
        pub shpr1: SHPR1,
        #[doc = "0xd1c - System Handler Priority Register 2"]
        pub shpr2: SHPR2,
        #[doc = "0xd20 - System Handler Priority Register 3"]
        pub shpr3: SHPR3,
        #[doc = "0xd24 - System Handler Control and State Register"]
        pub shcsr: SHCSR,
        #[doc = "0xd28 - Configurable Fault Status Register"]
        pub cfsr: CFSR,
        #[doc = "0xd2c - HardFault Status Register"]
        pub hfsr: HFSR,
        _reserved9: [u8; 4usize],
        #[doc = "0xd34 - MemManage Fault Address Register"]
        pub mmfar: MMFAR,
        #[doc = "0xd38 - BusFault Address Register"]
        pub bfar: BFAR,
        #[doc = "0xd3c - Auxiliary Fault Status Register"]
        pub afsr: AFSR,
        _reserved10: [u8; 72usize],
        #[doc = "0xd88 - Coprocessor Access Control Register"]
        pub cpacr: CPACR,
        _reserved11: [u8; 4usize],
        #[doc = "0xd90 - MPU Type Register"]
        pub mpu_type: MPU_TYPE,
        #[doc = "0xd94 - MPU Control Register"]
        pub mpu_ctrl: MPU_CTRL,
        #[doc = "0xd98 - MPU Region Number Register"]
        pub mpu_rnr: MPU_RNR,
        #[doc = "0xd9c - MPU Region Base Address Register"]
        pub mpu_rbar: MPU_RBAR,
        #[doc = "0xda0 - MPU Region Attribute and Size Register"]
        pub mpu_rasr: MPU_RASR,
        #[doc = "0xda4 - MPU Region Base Address Register A1"]
        pub mpu_rbar_a1: MPU_RBAR_A1,
        #[doc = "0xda8 - MPU Region Attribute and Size Register A1"]
        pub mpu_rasr_a1: MPU_RASR_A1,
        #[doc = "0xdac - MPU Region Base Address Register A2"]
        pub mpu_rbar_a2: MPU_RBAR_A2,
        #[doc = "0xdb0 - MPU Region Attribute and Size Register A2"]
        pub mpu_rasr_a2: MPU_RASR_A2,
        #[doc = "0xdb4 - MPU Region Base Address Register A3"]
        pub mpu_rbar_a3: MPU_RBAR_A3,
        #[doc = "0xdb8 - MPU Region Attribute and Size Register A3"]
        pub mpu_rasr_a3: MPU_RASR_A3,
        _reserved12: [u8; 324usize],
        #[doc = "0xf00 - Software Trigger Interrupt Register"]
        pub stir: STIR,
        _reserved13: [u8; 48usize],
        #[doc = "0xf34 - Floating-point Context Control Register"]
        pub fpccr: FPCCR,
        #[doc = "0xf38 - Floating-point Context Address Register"]
        pub fpcar: FPCAR,
        #[doc = "0xf3c - Floating-point Default Status Control Register"]
        pub fpdscr: FPDSCR,
    }
    #[doc = "Auxiliary Control Register"]
    pub struct ACTLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Auxiliary Control Register"]
    pub mod actlr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ACTLR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISMCYCINTR {
            bits: bool,
        }
        impl DISMCYCINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISDEFWBUFR {
            bits: bool,
        }
        impl DISDEFWBUFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISFOLDR {
            bits: bool,
        }
        impl DISFOLDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISFPCAR {
            bits: bool,
        }
        impl DISFPCAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISOOFPR {
            bits: bool,
        }
        impl DISOOFPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISMCYCINTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISMCYCINTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISDEFWBUFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISDEFWBUFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISFOLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISFOLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISFPCAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISFPCAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISOOFPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISOOFPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Disable load/store multiple"]
            #[inline]
            pub fn dismcycint(&self) -> DISMCYCINTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISMCYCINTR { bits }
            }
            #[doc = "Bit 1 - Disable write buffer"]
            #[inline]
            pub fn disdefwbuf(&self) -> DISDEFWBUFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISDEFWBUFR { bits }
            }
            #[doc = "Bit 2 - Disable IT folding"]
            #[inline]
            pub fn disfold(&self) -> DISFOLDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISFOLDR { bits }
            }
            #[doc = "Bit 8 - Disable FPCA update"]
            #[inline]
            pub fn disfpca(&self) -> DISFPCAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISFPCAR { bits }
            }
            #[doc = "Bit 9 - Disable out of order FP execution"]
            #[inline]
            pub fn disoofp(&self) -> DISOOFPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISOOFPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Disable load/store multiple"]
            #[inline]
            pub fn dismcycint(&mut self) -> _DISMCYCINTW {
                _DISMCYCINTW { w: self }
            }
            #[doc = "Bit 1 - Disable write buffer"]
            #[inline]
            pub fn disdefwbuf(&mut self) -> _DISDEFWBUFW {
                _DISDEFWBUFW { w: self }
            }
            #[doc = "Bit 2 - Disable IT folding"]
            #[inline]
            pub fn disfold(&mut self) -> _DISFOLDW {
                _DISFOLDW { w: self }
            }
            #[doc = "Bit 8 - Disable FPCA update"]
            #[inline]
            pub fn disfpca(&mut self) -> _DISFPCAW {
                _DISFPCAW { w: self }
            }
            #[doc = "Bit 9 - Disable out of order FP execution"]
            #[inline]
            pub fn disoofp(&mut self) -> _DISOOFPW {
                _DISOOFPW { w: self }
            }
        }
    }
    #[doc = "SysTick Control and Status Register"]
    pub struct SYST_CSR {
        register: VolatileCell<u32>,
    }
    #[doc = "SysTick Control and Status Register"]
    pub mod syst_csr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SYST_CSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENABLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENABLER {
            #[doc = "counter disabled"]
            VALUE1,
            #[doc = "counter enabled."]
            VALUE2,
        }
        impl ENABLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENABLER::VALUE1 => false,
                    ENABLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENABLER {
                match value {
                    false => ENABLER::VALUE1,
                    true => ENABLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENABLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENABLER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TICKINT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TICKINTR {
            #[doc = "counting down to zero does not assert the SysTick exception request"]
            VALUE1,
            #[doc = "counting down to zero to asserts the SysTick exception request."]
            VALUE2,
        }
        impl TICKINTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TICKINTR::VALUE1 => false,
                    TICKINTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TICKINTR {
                match value {
                    false => TICKINTR::VALUE1,
                    true => TICKINTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TICKINTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TICKINTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CLKSOURCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLKSOURCER {
            #[doc = "external clock"]
            VALUE1,
            #[doc = "processor clock."]
            VALUE2,
        }
        impl CLKSOURCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CLKSOURCER::VALUE1 => false,
                    CLKSOURCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CLKSOURCER {
                match value {
                    false => CLKSOURCER::VALUE1,
                    true => CLKSOURCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CLKSOURCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CLKSOURCER::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct COUNTFLAGR {
            bits: bool,
        }
        impl COUNTFLAGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `ENABLE`"]
        pub enum ENABLEW {
            #[doc = "counter disabled"]
            VALUE1,
            #[doc = "counter enabled."]
            VALUE2,
        }
        impl ENABLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENABLEW::VALUE1 => false,
                    ENABLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENABLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENABLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENABLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "counter disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENABLEW::VALUE1)
            }
            #[doc = "counter enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENABLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TICKINT`"]
        pub enum TICKINTW {
            #[doc = "counting down to zero does not assert the SysTick exception request"]
            VALUE1,
            #[doc = "counting down to zero to asserts the SysTick exception request."]
            VALUE2,
        }
        impl TICKINTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TICKINTW::VALUE1 => false,
                    TICKINTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TICKINTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TICKINTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TICKINTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "counting down to zero does not assert the SysTick exception request"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TICKINTW::VALUE1)
            }
            #[doc = "counting down to zero to asserts the SysTick exception request."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TICKINTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CLKSOURCE`"]
        pub enum CLKSOURCEW {
            #[doc = "external clock"]
            VALUE1,
            #[doc = "processor clock."]
            VALUE2,
        }
        impl CLKSOURCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CLKSOURCEW::VALUE1 => false,
                    CLKSOURCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLKSOURCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLKSOURCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLKSOURCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "external clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CLKSOURCEW::VALUE1)
            }
            #[doc = "processor clock."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CLKSOURCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _COUNTFLAGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _COUNTFLAGW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Enable"]
            #[inline]
            pub fn enable(&self) -> ENABLER {
                ENABLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Tick Interrupt Enable"]
            #[inline]
            pub fn tickint(&self) -> TICKINTR {
                TICKINTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Indicates the clock source:"]
            #[inline]
            pub fn clksource(&self) -> CLKSOURCER {
                CLKSOURCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Counter Flag"]
            #[inline]
            pub fn countflag(&self) -> COUNTFLAGR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                COUNTFLAGR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x04 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Enable"]
            #[inline]
            pub fn enable(&mut self) -> _ENABLEW {
                _ENABLEW { w: self }
            }
            #[doc = "Bit 1 - Tick Interrupt Enable"]
            #[inline]
            pub fn tickint(&mut self) -> _TICKINTW {
                _TICKINTW { w: self }
            }
            #[doc = "Bit 2 - Indicates the clock source:"]
            #[inline]
            pub fn clksource(&mut self) -> _CLKSOURCEW {
                _CLKSOURCEW { w: self }
            }
            #[doc = "Bit 16 - Counter Flag"]
            #[inline]
            pub fn countflag(&mut self) -> _COUNTFLAGW {
                _COUNTFLAGW { w: self }
            }
        }
    }
    #[doc = "SysTick Reload Value Register"]
    pub struct SYST_RVR {
        register: VolatileCell<u32>,
    }
    #[doc = "SysTick Reload Value Register"]
    pub mod syst_rvr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SYST_RVR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RELOADR {
            bits: u32,
        }
        impl RELOADR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _RELOADW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RELOADW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x00ff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:23 - Reload Value"]
            #[inline]
            pub fn reload(&self) -> RELOADR {
                let bits = {
                    const MASK: u32 = 0x00ff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                RELOADR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:23 - Reload Value"]
            #[inline]
            pub fn reload(&mut self) -> _RELOADW {
                _RELOADW { w: self }
            }
        }
    }
    #[doc = "SysTick Current Value Register"]
    pub struct SYST_CVR {
        register: VolatileCell<u32>,
    }
    #[doc = "SysTick Current Value Register"]
    pub mod syst_cvr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SYST_CVR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CURRENTR {
            bits: u32,
        }
        impl CURRENTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CURRENTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CURRENTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x00ff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:23 - Current Value"]
            #[inline]
            pub fn current(&self) -> CURRENTR {
                let bits = {
                    const MASK: u32 = 0x00ff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                CURRENTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:23 - Current Value"]
            #[inline]
            pub fn current(&mut self) -> _CURRENTW {
                _CURRENTW { w: self }
            }
        }
    }
    #[doc = "SysTick Calibration Value Register r"]
    pub struct SYST_CALIB {
        register: VolatileCell<u32>,
    }
    #[doc = "SysTick Calibration Value Register r"]
    pub mod syst_calib {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SYST_CALIB {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TENMSR {
            bits: u32,
        }
        impl TENMSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SKEW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SKEWR {
            #[doc = "TENMS value is exact"]
            VALUE1,
            #[doc = "TENMS value is inexact, or not given."]
            VALUE2,
        }
        impl SKEWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SKEWR::VALUE1 => false,
                    SKEWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SKEWR {
                match value {
                    false => SKEWR::VALUE1,
                    true => SKEWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SKEWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SKEWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NOREF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NOREFR {
            #[doc = "reference clock provided"]
            VALUE1,
            #[doc = "no reference clock provided."]
            VALUE2,
        }
        impl NOREFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NOREFR::VALUE1 => false,
                    NOREFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NOREFR {
                match value {
                    false => NOREFR::VALUE1,
                    true => NOREFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NOREFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NOREFR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _TENMSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TENMSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x00ff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SKEW`"]
        pub enum SKEWW {
            #[doc = "TENMS value is exact"]
            VALUE1,
            #[doc = "TENMS value is inexact, or not given."]
            VALUE2,
        }
        impl SKEWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SKEWW::VALUE1 => false,
                    SKEWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SKEWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SKEWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SKEWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TENMS value is exact"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SKEWW::VALUE1)
            }
            #[doc = "TENMS value is inexact, or not given."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SKEWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NOREF`"]
        pub enum NOREFW {
            #[doc = "reference clock provided"]
            VALUE1,
            #[doc = "no reference clock provided."]
            VALUE2,
        }
        impl NOREFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NOREFW::VALUE1 => false,
                    NOREFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NOREFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NOREFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NOREFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "reference clock provided"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NOREFW::VALUE1)
            }
            #[doc = "no reference clock provided."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NOREFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:23 - Ten Milliseconds Reload Value"]
            #[inline]
            pub fn tenms(&self) -> TENMSR {
                let bits = {
                    const MASK: u32 = 0x00ff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TENMSR { bits }
            }
            #[doc = "Bit 30 - Ten Milliseconds Skewed"]
            #[inline]
            pub fn skew(&self) -> SKEWR {
                SKEWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - No Reference Clock"]
            #[inline]
            pub fn noref(&self) -> NOREFR {
                NOREFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0xc000_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:23 - Ten Milliseconds Reload Value"]
            #[inline]
            pub fn tenms(&mut self) -> _TENMSW {
                _TENMSW { w: self }
            }
            #[doc = "Bit 30 - Ten Milliseconds Skewed"]
            #[inline]
            pub fn skew(&mut self) -> _SKEWW {
                _SKEWW { w: self }
            }
            #[doc = "Bit 31 - No Reference Clock"]
            #[inline]
            pub fn noref(&mut self) -> _NOREFW {
                _NOREFW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-enable Register 0"]
    pub struct NVIC_ISER0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-enable Register 0"]
    pub mod nvic_iser0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISER0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETENAR::VALUE3 => 0,
                    SETENAR::VALUE4 => 0x01,
                    SETENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETENAR {
                match value {
                    0 => SETENAR::VALUE3,
                    1 => SETENAR::VALUE4,
                    i => SETENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETENA`"]
        pub enum SETENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl SETENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETENAW::VALUE3 => 0,
                    SETENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&self) -> SETENAR {
                SETENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&mut self) -> _SETENAW {
                _SETENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-enable Register 1"]
    pub struct NVIC_ISER1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-enable Register 1"]
    pub mod nvic_iser1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISER1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETENAR::VALUE3 => 0,
                    SETENAR::VALUE4 => 0x01,
                    SETENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETENAR {
                match value {
                    0 => SETENAR::VALUE3,
                    1 => SETENAR::VALUE4,
                    i => SETENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETENA`"]
        pub enum SETENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl SETENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETENAW::VALUE3 => 0,
                    SETENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&self) -> SETENAR {
                SETENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&mut self) -> _SETENAW {
                _SETENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-enable Register 2"]
    pub struct NVIC_ISER2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-enable Register 2"]
    pub mod nvic_iser2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISER2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETENAR::VALUE3 => 0,
                    SETENAR::VALUE4 => 0x01,
                    SETENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETENAR {
                match value {
                    0 => SETENAR::VALUE3,
                    1 => SETENAR::VALUE4,
                    i => SETENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETENA`"]
        pub enum SETENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl SETENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETENAW::VALUE3 => 0,
                    SETENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&self) -> SETENAR {
                SETENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&mut self) -> _SETENAW {
                _SETENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-enable Register 3"]
    pub struct NVIC_ISER3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-enable Register 3"]
    pub mod nvic_iser3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISER3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETENAR::VALUE3 => 0,
                    SETENAR::VALUE4 => 0x01,
                    SETENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETENAR {
                match value {
                    0 => SETENAR::VALUE3,
                    1 => SETENAR::VALUE4,
                    i => SETENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETENA`"]
        pub enum SETENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl SETENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETENAW::VALUE3 => 0,
                    SETENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&self) -> SETENAR {
                SETENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-enable bits"]
            #[inline]
            pub fn setena(&mut self) -> _SETENAW {
                _SETENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-enable Register 0"]
    pub struct NVIC_ICER0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-enable Register 0"]
    pub mod nvic_icer0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICER0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRENAR::VALUE3 => 0,
                    CLRENAR::VALUE4 => 0x01,
                    CLRENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRENAR {
                match value {
                    0 => CLRENAR::VALUE3,
                    1 => CLRENAR::VALUE4,
                    i => CLRENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRENA`"]
        pub enum CLRENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl CLRENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRENAW::VALUE3 => 0,
                    CLRENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&self) -> CLRENAR {
                CLRENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&mut self) -> _CLRENAW {
                _CLRENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-enable Register 1"]
    pub struct NVIC_ICER1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-enable Register 1"]
    pub mod nvic_icer1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICER1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRENAR::VALUE3 => 0,
                    CLRENAR::VALUE4 => 0x01,
                    CLRENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRENAR {
                match value {
                    0 => CLRENAR::VALUE3,
                    1 => CLRENAR::VALUE4,
                    i => CLRENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRENA`"]
        pub enum CLRENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl CLRENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRENAW::VALUE3 => 0,
                    CLRENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&self) -> CLRENAR {
                CLRENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&mut self) -> _CLRENAW {
                _CLRENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-enable Register 2"]
    pub struct NVIC_ICER2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-enable Register 2"]
    pub mod nvic_icer2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICER2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRENAR::VALUE3 => 0,
                    CLRENAR::VALUE4 => 0x01,
                    CLRENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRENAR {
                match value {
                    0 => CLRENAR::VALUE3,
                    1 => CLRENAR::VALUE4,
                    i => CLRENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRENA`"]
        pub enum CLRENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl CLRENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRENAW::VALUE3 => 0,
                    CLRENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&self) -> CLRENAR {
                CLRENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&mut self) -> _CLRENAW {
                _CLRENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-enable Register 3"]
    pub struct NVIC_ICER3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-enable Register 3"]
    pub mod nvic_icer3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICER3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRENAR {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRENAR::VALUE3 => 0,
                    CLRENAR::VALUE4 => 0x01,
                    CLRENAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRENAR {
                match value {
                    0 => CLRENAR::VALUE3,
                    1 => CLRENAR::VALUE4,
                    i => CLRENAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRENAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRENAR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRENA`"]
        pub enum CLRENAW {
            #[doc = "interrupt disabled"]
            VALUE3,
            #[doc = "interrupt enabled."]
            VALUE4,
        }
        impl CLRENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRENAW::VALUE3 => 0,
                    CLRENAW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRENAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt disabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE3)
            }
            #[doc = "interrupt enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRENAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&self) -> CLRENAR {
                CLRENAR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt clear-enable bits."]
            #[inline]
            pub fn clrena(&mut self) -> _CLRENAW {
                _CLRENAW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-pending Register 0"]
    pub struct NVIC_ISPR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-pending Register 0"]
    pub mod nvic_ispr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISPR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETPENDR::VALUE3 => 0,
                    SETPENDR::VALUE4 => 0x01,
                    SETPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETPENDR {
                match value {
                    0 => SETPENDR::VALUE3,
                    1 => SETPENDR::VALUE4,
                    i => SETPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETPEND`"]
        pub enum SETPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl SETPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETPENDW::VALUE3 => 0,
                    SETPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&self) -> SETPENDR {
                SETPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&mut self) -> _SETPENDW {
                _SETPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-pending Register 1"]
    pub struct NVIC_ISPR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-pending Register 1"]
    pub mod nvic_ispr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISPR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETPENDR::VALUE3 => 0,
                    SETPENDR::VALUE4 => 0x01,
                    SETPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETPENDR {
                match value {
                    0 => SETPENDR::VALUE3,
                    1 => SETPENDR::VALUE4,
                    i => SETPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETPEND`"]
        pub enum SETPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl SETPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETPENDW::VALUE3 => 0,
                    SETPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&self) -> SETPENDR {
                SETPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&mut self) -> _SETPENDW {
                _SETPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-pending Register 2"]
    pub struct NVIC_ISPR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-pending Register 2"]
    pub mod nvic_ispr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISPR2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETPENDR::VALUE3 => 0,
                    SETPENDR::VALUE4 => 0x01,
                    SETPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETPENDR {
                match value {
                    0 => SETPENDR::VALUE3,
                    1 => SETPENDR::VALUE4,
                    i => SETPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETPEND`"]
        pub enum SETPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl SETPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETPENDW::VALUE3 => 0,
                    SETPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&self) -> SETPENDR {
                SETPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&mut self) -> _SETPENDW {
                _SETPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Set-pending Register 3"]
    pub struct NVIC_ISPR3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Set-pending Register 3"]
    pub mod nvic_ispr3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ISPR3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SETPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SETPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl SETPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    SETPENDR::VALUE3 => 0,
                    SETPENDR::VALUE4 => 0x01,
                    SETPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> SETPENDR {
                match value {
                    0 => SETPENDR::VALUE3,
                    1 => SETPENDR::VALUE4,
                    i => SETPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SETPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SETPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SETPEND`"]
        pub enum SETPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl SETPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    SETPENDW::VALUE3 => 0,
                    SETPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SETPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SETPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&self) -> SETPENDR {
                SETPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn setpend(&mut self) -> _SETPENDW {
                _SETPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-pending Register 0"]
    pub struct NVIC_ICPR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-pending Register 0"]
    pub mod nvic_icpr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICPR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRPENDR::VALUE3 => 0,
                    CLRPENDR::VALUE4 => 0x01,
                    CLRPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRPENDR {
                match value {
                    0 => CLRPENDR::VALUE3,
                    1 => CLRPENDR::VALUE4,
                    i => CLRPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRPEND`"]
        pub enum CLRPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl CLRPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRPENDW::VALUE3 => 0,
                    CLRPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&self) -> CLRPENDR {
                CLRPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&mut self) -> _CLRPENDW {
                _CLRPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-pending Register 1"]
    pub struct NVIC_ICPR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-pending Register 1"]
    pub mod nvic_icpr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICPR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRPENDR::VALUE3 => 0,
                    CLRPENDR::VALUE4 => 0x01,
                    CLRPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRPENDR {
                match value {
                    0 => CLRPENDR::VALUE3,
                    1 => CLRPENDR::VALUE4,
                    i => CLRPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRPEND`"]
        pub enum CLRPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl CLRPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRPENDW::VALUE3 => 0,
                    CLRPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&self) -> CLRPENDR {
                CLRPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&mut self) -> _CLRPENDW {
                _CLRPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-pending Register 2"]
    pub struct NVIC_ICPR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-pending Register 2"]
    pub mod nvic_icpr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICPR2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRPENDR::VALUE3 => 0,
                    CLRPENDR::VALUE4 => 0x01,
                    CLRPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRPENDR {
                match value {
                    0 => CLRPENDR::VALUE3,
                    1 => CLRPENDR::VALUE4,
                    i => CLRPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRPEND`"]
        pub enum CLRPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl CLRPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRPENDW::VALUE3 => 0,
                    CLRPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&self) -> CLRPENDR {
                CLRPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&mut self) -> _CLRPENDW {
                _CLRPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Clear-pending Register 3"]
    pub struct NVIC_ICPR3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Clear-pending Register 3"]
    pub mod nvic_icpr3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_ICPR3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLRPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLRPENDR {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl CLRPENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    CLRPENDR::VALUE3 => 0,
                    CLRPENDR::VALUE4 => 0x01,
                    CLRPENDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> CLRPENDR {
                match value {
                    0 => CLRPENDR::VALUE3,
                    1 => CLRPENDR::VALUE4,
                    i => CLRPENDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLRPENDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLRPENDR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLRPEND`"]
        pub enum CLRPENDW {
            #[doc = "interrupt is not pending"]
            VALUE3,
            #[doc = "interrupt is pending."]
            VALUE4,
        }
        impl CLRPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    CLRPENDW::VALUE3 => 0,
                    CLRPENDW::VALUE4 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRPENDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt is not pending"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE3)
            }
            #[doc = "interrupt is pending."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLRPENDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&self) -> CLRPENDR {
                CLRPENDR::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt set-pending bits."]
            #[inline]
            pub fn clrpend(&mut self) -> _CLRPENDW {
                _CLRPENDW { w: self }
            }
        }
    }
    #[doc = "Interrupt Active Bit Register 0"]
    pub struct NVIC_IABR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Active Bit Register 0"]
    pub mod nvic_iabr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IABR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ACTIVE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACTIVER {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl ACTIVER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    ACTIVER::VALUE1 => 0,
                    ACTIVER::VALUE2 => 0x01,
                    ACTIVER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> ACTIVER {
                match value {
                    0 => ACTIVER::VALUE1,
                    1 => ACTIVER::VALUE2,
                    i => ACTIVER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACTIVER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACTIVER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ACTIVE`"]
        pub enum ACTIVEW {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
        }
        impl ACTIVEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    ACTIVEW::VALUE1 => 0,
                    ACTIVEW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACTIVEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACTIVEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACTIVEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt not active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE1)
            }
            #[doc = "interrupt active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&self) -> ACTIVER {
                ACTIVER::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&mut self) -> _ACTIVEW {
                _ACTIVEW { w: self }
            }
        }
    }
    #[doc = "Interrupt Active Bit Register 1"]
    pub struct NVIC_IABR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Active Bit Register 1"]
    pub mod nvic_iabr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IABR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ACTIVE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACTIVER {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl ACTIVER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    ACTIVER::VALUE1 => 0,
                    ACTIVER::VALUE2 => 0x01,
                    ACTIVER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> ACTIVER {
                match value {
                    0 => ACTIVER::VALUE1,
                    1 => ACTIVER::VALUE2,
                    i => ACTIVER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACTIVER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACTIVER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ACTIVE`"]
        pub enum ACTIVEW {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
        }
        impl ACTIVEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    ACTIVEW::VALUE1 => 0,
                    ACTIVEW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACTIVEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACTIVEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACTIVEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt not active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE1)
            }
            #[doc = "interrupt active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&self) -> ACTIVER {
                ACTIVER::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&mut self) -> _ACTIVEW {
                _ACTIVEW { w: self }
            }
        }
    }
    #[doc = "Interrupt Active Bit Register 2"]
    pub struct NVIC_IABR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Active Bit Register 2"]
    pub mod nvic_iabr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IABR2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ACTIVE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACTIVER {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl ACTIVER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    ACTIVER::VALUE1 => 0,
                    ACTIVER::VALUE2 => 0x01,
                    ACTIVER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> ACTIVER {
                match value {
                    0 => ACTIVER::VALUE1,
                    1 => ACTIVER::VALUE2,
                    i => ACTIVER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACTIVER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACTIVER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ACTIVE`"]
        pub enum ACTIVEW {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
        }
        impl ACTIVEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    ACTIVEW::VALUE1 => 0,
                    ACTIVEW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACTIVEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACTIVEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACTIVEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt not active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE1)
            }
            #[doc = "interrupt active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&self) -> ACTIVER {
                ACTIVER::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&mut self) -> _ACTIVEW {
                _ACTIVEW { w: self }
            }
        }
    }
    #[doc = "Interrupt Active Bit Register 3"]
    pub struct NVIC_IABR3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Active Bit Register 3"]
    pub mod nvic_iabr3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IABR3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ACTIVE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACTIVER {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u32),
        }
        impl ACTIVER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                match *self {
                    ACTIVER::VALUE1 => 0,
                    ACTIVER::VALUE2 => 0x01,
                    ACTIVER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u32) -> ACTIVER {
                match value {
                    0 => ACTIVER::VALUE1,
                    1 => ACTIVER::VALUE2,
                    i => ACTIVER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACTIVER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACTIVER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ACTIVE`"]
        pub enum ACTIVEW {
            #[doc = "interrupt not active"]
            VALUE1,
            #[doc = "interrupt active"]
            VALUE2,
        }
        impl ACTIVEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u32 {
                match *self {
                    ACTIVEW::VALUE1 => 0,
                    ACTIVEW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACTIVEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACTIVEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACTIVEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "interrupt not active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE1)
            }
            #[doc = "interrupt active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACTIVEW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&self) -> ACTIVER {
                ACTIVER::_from({
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Interrupt active flags:"]
            #[inline]
            pub fn active(&mut self) -> _ACTIVEW {
                _ACTIVEW { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 0"]
    pub struct NVIC_IPR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 0"]
    pub mod nvic_ipr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 1"]
    pub struct NVIC_IPR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 1"]
    pub mod nvic_ipr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 2"]
    pub struct NVIC_IPR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 2"]
    pub mod nvic_ipr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 3"]
    pub struct NVIC_IPR3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 3"]
    pub mod nvic_ipr3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 4"]
    pub struct NVIC_IPR4 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 4"]
    pub mod nvic_ipr4 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR4 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 5"]
    pub struct NVIC_IPR5 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 5"]
    pub mod nvic_ipr5 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR5 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 6"]
    pub struct NVIC_IPR6 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 6"]
    pub mod nvic_ipr6 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR6 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 7"]
    pub struct NVIC_IPR7 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 7"]
    pub mod nvic_ipr7 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR7 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 8"]
    pub struct NVIC_IPR8 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 8"]
    pub mod nvic_ipr8 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR8 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 9"]
    pub struct NVIC_IPR9 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 9"]
    pub mod nvic_ipr9 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR9 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 10"]
    pub struct NVIC_IPR10 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 10"]
    pub mod nvic_ipr10 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR10 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 11"]
    pub struct NVIC_IPR11 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 11"]
    pub mod nvic_ipr11 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR11 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 12"]
    pub struct NVIC_IPR12 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 12"]
    pub mod nvic_ipr12 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR12 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 13"]
    pub struct NVIC_IPR13 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 13"]
    pub mod nvic_ipr13 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR13 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 14"]
    pub struct NVIC_IPR14 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 14"]
    pub mod nvic_ipr14 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR14 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 15"]
    pub struct NVIC_IPR15 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 15"]
    pub mod nvic_ipr15 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR15 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 16"]
    pub struct NVIC_IPR16 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 16"]
    pub mod nvic_ipr16 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR16 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 17"]
    pub struct NVIC_IPR17 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 17"]
    pub mod nvic_ipr17 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR17 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 18"]
    pub struct NVIC_IPR18 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 18"]
    pub mod nvic_ipr18 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR18 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 19"]
    pub struct NVIC_IPR19 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 19"]
    pub mod nvic_ipr19 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR19 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 20"]
    pub struct NVIC_IPR20 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 20"]
    pub mod nvic_ipr20 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR20 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 21"]
    pub struct NVIC_IPR21 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 21"]
    pub mod nvic_ipr21 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR21 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 22"]
    pub struct NVIC_IPR22 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 22"]
    pub mod nvic_ipr22 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR22 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 23"]
    pub struct NVIC_IPR23 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 23"]
    pub mod nvic_ipr23 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR23 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 24"]
    pub struct NVIC_IPR24 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 24"]
    pub mod nvic_ipr24 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR24 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 25"]
    pub struct NVIC_IPR25 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 25"]
    pub mod nvic_ipr25 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR25 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 26"]
    pub struct NVIC_IPR26 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 26"]
    pub mod nvic_ipr26 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR26 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "Interrupt Priority Register 27"]
    pub struct NVIC_IPR27 {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Priority Register 27"]
    pub mod nvic_ipr27 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NVIC_IPR27 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_0R {
            bits: u8,
        }
        impl PRI_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_1R {
            bits: u8,
        }
        impl PRI_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_2R {
            bits: u8,
        }
        impl PRI_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_3R {
            bits: u8,
        }
        impl PRI_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&self) -> PRI_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_0R { bits }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&self) -> PRI_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_1R { bits }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&self) -> PRI_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_2R { bits }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&self) -> PRI_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority value 0"]
            #[inline]
            pub fn pri_0(&mut self) -> _PRI_0W {
                _PRI_0W { w: self }
            }
            #[doc = "Bits 8:15 - Priority value 1"]
            #[inline]
            pub fn pri_1(&mut self) -> _PRI_1W {
                _PRI_1W { w: self }
            }
            #[doc = "Bits 16:23 - Priority value 2"]
            #[inline]
            pub fn pri_2(&mut self) -> _PRI_2W {
                _PRI_2W { w: self }
            }
            #[doc = "Bits 24:31 - Priority value 3"]
            #[inline]
            pub fn pri_3(&mut self) -> _PRI_3W {
                _PRI_3W { w: self }
            }
        }
    }
    #[doc = "CPUID Base Register"]
    pub struct CPUID {
        register: VolatileCell<u32>,
    }
    #[doc = "CPUID Base Register"]
    pub mod cpuid {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CPUID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `Revision`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REVISIONR {
            #[doc = "Patch 1"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REVISIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REVISIONR::VALUE1 => 0x01,
                    REVISIONR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REVISIONR {
                match value {
                    1 => REVISIONR::VALUE1,
                    i => REVISIONR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REVISIONR::VALUE1
            }
        }
        #[doc = "Possible values of the field `PartNo`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PARTNOR {
            #[doc = "Cortex-M4"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u16),
        }
        impl PARTNOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                match *self {
                    PARTNOR::VALUE1 => 0x0c24,
                    PARTNOR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u16) -> PARTNOR {
                match value {
                    3108 => PARTNOR::VALUE1,
                    i => PARTNOR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PARTNOR::VALUE1
            }
        }
        #[doc = r" Value of the field"]
        pub struct CONSTANTR {
            bits: u8,
        }
        impl CONSTANTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `Variant`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VARIANTR {
            #[doc = "Revision 0"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl VARIANTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    VARIANTR::VALUE1 => 0,
                    VARIANTR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> VARIANTR {
                match value {
                    0 => VARIANTR::VALUE1,
                    i => VARIANTR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VARIANTR::VALUE1
            }
        }
        #[doc = "Possible values of the field `Implementer`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IMPLEMENTERR {
            #[doc = "ARM"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl IMPLEMENTERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    IMPLEMENTERR::VALUE1 => 0x41,
                    IMPLEMENTERR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> IMPLEMENTERR {
                match value {
                    65 => IMPLEMENTERR::VALUE1,
                    i => IMPLEMENTERR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IMPLEMENTERR::VALUE1
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Revision number"]
            #[inline]
            pub fn revision(&self) -> REVISIONR {
                REVISIONR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:15 - Part number of the processor"]
            #[inline]
            pub fn part_no(&self) -> PARTNOR {
                PARTNOR::_from({
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                })
            }
            #[doc = "Bits 16:19 - Reads as 0xF"]
            #[inline]
            pub fn constant(&self) -> CONSTANTR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CONSTANTR { bits }
            }
            #[doc = "Bits 20:23 - Variant number"]
            #[inline]
            pub fn variant(&self) -> VARIANTR {
                VARIANTR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:31 - Implementer code"]
            #[inline]
            pub fn implementer(&self) -> IMPLEMENTERR {
                IMPLEMENTERR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
    }
    #[doc = "Interrupt Control and State Register"]
    pub struct ICSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Control and State Register"]
    pub mod icsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ICSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `VECTACTIVE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VECTACTIVER {
            #[doc = "Thread mode"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u16),
        }
        impl VECTACTIVER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                match *self {
                    VECTACTIVER::VALUE1 => 0,
                    VECTACTIVER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u16) -> VECTACTIVER {
                match value {
                    0 => VECTACTIVER::VALUE1,
                    i => VECTACTIVER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VECTACTIVER::VALUE1
            }
        }
        #[doc = "Possible values of the field `RETTOBASE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RETTOBASER {
            #[doc = "there are preempted active exceptions to execute"]
            VALUE1,
            #[doc = "there are no active exceptions, or the currently-executing exception is the only active exception."]
            VALUE2,
        }
        impl RETTOBASER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RETTOBASER::VALUE1 => false,
                    RETTOBASER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RETTOBASER {
                match value {
                    false => RETTOBASER::VALUE1,
                    true => RETTOBASER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RETTOBASER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RETTOBASER::VALUE2
            }
        }
        #[doc = "Possible values of the field `VECTPENDING`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VECTPENDINGR {
            #[doc = "no pending exceptions"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl VECTPENDINGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    VECTPENDINGR::VALUE1 => 0,
                    VECTPENDINGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> VECTPENDINGR {
                match value {
                    0 => VECTPENDINGR::VALUE1,
                    i => VECTPENDINGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VECTPENDINGR::VALUE1
            }
        }
        #[doc = "Possible values of the field `ISRPENDING`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ISRPENDINGR {
            #[doc = "interrupt not pending"]
            VALUE1,
            #[doc = "interrupt pending."]
            VALUE2,
        }
        impl ISRPENDINGR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ISRPENDINGR::VALUE1 => false,
                    ISRPENDINGR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ISRPENDINGR {
                match value {
                    false => ISRPENDINGR::VALUE1,
                    true => ISRPENDINGR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ISRPENDINGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ISRPENDINGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PENDSTSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PENDSTSETR {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "changes SysTick exception state to pending."]
            VALUE2,
        }
        impl PENDSTSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PENDSTSETR::VALUE1 => false,
                    PENDSTSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PENDSTSETR {
                match value {
                    false => PENDSTSETR::VALUE1,
                    true => PENDSTSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PENDSTSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PENDSTSETR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PENDSVSETR {
            bits: bool,
        }
        impl PENDSVSETR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NMIPENDSETR {
            bits: bool,
        }
        impl NMIPENDSETR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `PENDSTCLR`"]
        pub enum PENDSTCLRW {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "removes the pending state from the SysTick exception."]
            VALUE2,
        }
        impl PENDSTCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PENDSTCLRW::VALUE1 => false,
                    PENDSTCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PENDSTCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PENDSTCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PENDSTCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PENDSTCLRW::VALUE1)
            }
            #[doc = "removes the pending state from the SysTick exception."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PENDSTCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PENDSTSET`"]
        pub enum PENDSTSETW {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "changes SysTick exception state to pending."]
            VALUE2,
        }
        impl PENDSTSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PENDSTSETW::VALUE1 => false,
                    PENDSTSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PENDSTSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PENDSTSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PENDSTSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PENDSTSETW::VALUE1)
            }
            #[doc = "changes SysTick exception state to pending."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PENDSTSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PENDSVCLR`"]
        pub enum PENDSVCLRW {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "removes the pending state from the PendSV exception."]
            VALUE2,
        }
        impl PENDSVCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PENDSVCLRW::VALUE1 => false,
                    PENDSVCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PENDSVCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PENDSVCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PENDSVCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PENDSVCLRW::VALUE1)
            }
            #[doc = "removes the pending state from the PendSV exception."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PENDSVCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PENDSVSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PENDSVSETW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NMIPENDSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NMIPENDSETW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:8 - Active exception number"]
            #[inline]
            pub fn vectactive(&self) -> VECTACTIVER {
                VECTACTIVER::_from({
                    const MASK: u16 = 0x01ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                })
            }
            #[doc = "Bit 11 - Return to Base"]
            #[inline]
            pub fn rettobase(&self) -> RETTOBASER {
                RETTOBASER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 12:17 - Vector Pending"]
            #[inline]
            pub fn vectpending(&self) -> VECTPENDINGR {
                VECTPENDINGR::_from({
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 22 - Interrupt pending flag"]
            #[inline]
            pub fn isrpending(&self) -> ISRPENDINGR {
                ISRPENDINGR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - SysTick exception set-pending bit"]
            #[inline]
            pub fn pendstset(&self) -> PENDSTSETR {
                PENDSTSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - PendSV set-pending bit: 0b0=no effect, 0b1=changes PendSV exception state to pending., 0b0=PendSV exception is not pending, 0b1=PendSV exception is pending.,"]
            #[inline]
            pub fn pendsvset(&self) -> PENDSVSETR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PENDSVSETR { bits }
            }
            #[doc = "Bit 31 - NMI set-pending bit: 0b0=no effect, 0b1=changes NMI exception state to pending., 0b0=NMI exception is not pending, 0b1=NMI exception is pending.,"]
            #[inline]
            pub fn nmipendset(&self) -> NMIPENDSETR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NMIPENDSETR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 25 - SysTick exception clear-pending bit"]
            #[inline]
            pub fn pendstclr(&mut self) -> _PENDSTCLRW {
                _PENDSTCLRW { w: self }
            }
            #[doc = "Bit 26 - SysTick exception set-pending bit"]
            #[inline]
            pub fn pendstset(&mut self) -> _PENDSTSETW {
                _PENDSTSETW { w: self }
            }
            #[doc = "Bit 27 - PendSV clear-pending bit"]
            #[inline]
            pub fn pendsvclr(&mut self) -> _PENDSVCLRW {
                _PENDSVCLRW { w: self }
            }
            #[doc = "Bit 28 - PendSV set-pending bit: 0b0=no effect, 0b1=changes PendSV exception state to pending., 0b0=PendSV exception is not pending, 0b1=PendSV exception is pending.,"]
            #[inline]
            pub fn pendsvset(&mut self) -> _PENDSVSETW {
                _PENDSVSETW { w: self }
            }
            #[doc = "Bit 31 - NMI set-pending bit: 0b0=no effect, 0b1=changes NMI exception state to pending., 0b0=NMI exception is not pending, 0b1=NMI exception is pending.,"]
            #[inline]
            pub fn nmipendset(&mut self) -> _NMIPENDSETW {
                _NMIPENDSETW { w: self }
            }
        }
    }
    #[doc = "Vector Table Offset Register"]
    pub struct VTOR {
        register: VolatileCell<u32>,
    }
    #[doc = "Vector Table Offset Register"]
    pub mod vtor {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::VTOR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TBLOFFR {
            bits: u32,
        }
        impl TBLOFFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBLOFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBLOFFW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x003f_ffff;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 10:31 - Vector table base offset field"]
            #[inline]
            pub fn tbloff(&self) -> TBLOFFR {
                let bits = {
                    const MASK: u32 = 0x003f_ffff;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TBLOFFR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 10:31 - Vector table base offset field"]
            #[inline]
            pub fn tbloff(&mut self) -> _TBLOFFW {
                _TBLOFFW { w: self }
            }
        }
    }
    #[doc = "Application Interrupt and Reset Control Register"]
    pub struct AIRCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Application Interrupt and Reset Control Register"]
    pub mod aircr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::AIRCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRIGROUPR {
            bits: u8,
        }
        impl PRIGROUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ENDIANNESS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDIANNESSR {
            #[doc = "Little-endian"]
            VALUE1,
            #[doc = "Big-endian."]
            VALUE2,
        }
        impl ENDIANNESSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENDIANNESSR::VALUE1 => false,
                    ENDIANNESSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENDIANNESSR {
                match value {
                    false => ENDIANNESSR::VALUE1,
                    true => ENDIANNESSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDIANNESSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDIANNESSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct VECTKEYR {
            bits: u16,
        }
        impl VECTKEYR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _VECTRESETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VECTRESETW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _VECTCLRACTIVEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VECTCLRACTIVEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SYSRESETREQ`"]
        pub enum SYSRESETREQW {
            #[doc = "no system reset request"]
            VALUE1,
            #[doc = "asserts a signal to the outer system that requests a reset."]
            VALUE2,
        }
        impl SYSRESETREQW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SYSRESETREQW::VALUE1 => false,
                    SYSRESETREQW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSRESETREQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSRESETREQW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SYSRESETREQW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no system reset request"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SYSRESETREQW::VALUE1)
            }
            #[doc = "asserts a signal to the outer system that requests a reset."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SYSRESETREQW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRIGROUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRIGROUPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _VECTKEYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VECTKEYW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 8:10 - Interrupt priority grouping field"]
            #[inline]
            pub fn prigroup(&self) -> PRIGROUPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRIGROUPR { bits }
            }
            #[doc = "Bit 15 - Data endianness bit"]
            #[inline]
            pub fn endianness(&self) -> ENDIANNESSR {
                ENDIANNESSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:31 - Register key"]
            #[inline]
            pub fn vectkey(&self) -> VECTKEYR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                VECTKEYR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0xfa05_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Reserved for Debug use."]
            #[inline]
            pub fn vectreset(&mut self) -> _VECTRESETW {
                _VECTRESETW { w: self }
            }
            #[doc = "Bit 1 - Reserved for Debug use."]
            #[inline]
            pub fn vectclractive(&mut self) -> _VECTCLRACTIVEW {
                _VECTCLRACTIVEW { w: self }
            }
            #[doc = "Bit 2 - System reset request"]
            #[inline]
            pub fn sysresetreq(&mut self) -> _SYSRESETREQW {
                _SYSRESETREQW { w: self }
            }
            #[doc = "Bits 8:10 - Interrupt priority grouping field"]
            #[inline]
            pub fn prigroup(&mut self) -> _PRIGROUPW {
                _PRIGROUPW { w: self }
            }
            #[doc = "Bits 16:31 - Register key"]
            #[inline]
            pub fn vectkey(&mut self) -> _VECTKEYW {
                _VECTKEYW { w: self }
            }
        }
    }
    #[doc = "System Control Register"]
    pub struct SCR {
        register: VolatileCell<u32>,
    }
    #[doc = "System Control Register"]
    pub mod scr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SLEEPONEXIT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SLEEPONEXITR {
            #[doc = "do not sleep when returning to Thread mode."]
            VALUE1,
            #[doc = "enter sleep, or deep sleep, on return from an ISR."]
            VALUE2,
        }
        impl SLEEPONEXITR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SLEEPONEXITR::VALUE1 => false,
                    SLEEPONEXITR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SLEEPONEXITR {
                match value {
                    false => SLEEPONEXITR::VALUE1,
                    true => SLEEPONEXITR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SLEEPONEXITR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SLEEPONEXITR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SLEEPDEEP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SLEEPDEEPR {
            #[doc = "sleep"]
            VALUE1,
            #[doc = "deep sleep"]
            VALUE2,
        }
        impl SLEEPDEEPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SLEEPDEEPR::VALUE1 => false,
                    SLEEPDEEPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SLEEPDEEPR {
                match value {
                    false => SLEEPDEEPR::VALUE1,
                    true => SLEEPDEEPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SLEEPDEEPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SLEEPDEEPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SEVONPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEVONPENDR {
            #[doc = "only enabled interrupts or events can wakeup the processor, disabled interrupts are excluded"]
            VALUE1,
            #[doc = "enabled events and all interrupts, including disabled interrupts, can wakeup the processor."]
            VALUE2,
        }
        impl SEVONPENDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SEVONPENDR::VALUE1 => false,
                    SEVONPENDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SEVONPENDR {
                match value {
                    false => SEVONPENDR::VALUE1,
                    true => SEVONPENDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEVONPENDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEVONPENDR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SLEEPONEXIT`"]
        pub enum SLEEPONEXITW {
            #[doc = "do not sleep when returning to Thread mode."]
            VALUE1,
            #[doc = "enter sleep, or deep sleep, on return from an ISR."]
            VALUE2,
        }
        impl SLEEPONEXITW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SLEEPONEXITW::VALUE1 => false,
                    SLEEPONEXITW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLEEPONEXITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLEEPONEXITW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SLEEPONEXITW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "do not sleep when returning to Thread mode."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SLEEPONEXITW::VALUE1)
            }
            #[doc = "enter sleep, or deep sleep, on return from an ISR."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SLEEPONEXITW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SLEEPDEEP`"]
        pub enum SLEEPDEEPW {
            #[doc = "sleep"]
            VALUE1,
            #[doc = "deep sleep"]
            VALUE2,
        }
        impl SLEEPDEEPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SLEEPDEEPW::VALUE1 => false,
                    SLEEPDEEPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLEEPDEEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLEEPDEEPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SLEEPDEEPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "sleep"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SLEEPDEEPW::VALUE1)
            }
            #[doc = "deep sleep"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SLEEPDEEPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SEVONPEND`"]
        pub enum SEVONPENDW {
            #[doc = "only enabled interrupts or events can wakeup the processor, disabled interrupts are excluded"]
            VALUE1,
            #[doc = "enabled events and all interrupts, including disabled interrupts, can wakeup the processor."]
            VALUE2,
        }
        impl SEVONPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEVONPENDW::VALUE1 => false,
                    SEVONPENDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEVONPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEVONPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEVONPENDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "only enabled interrupts or events can wakeup the processor, disabled interrupts are excluded"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEVONPENDW::VALUE1)
            }
            #[doc = "enabled events and all interrupts, including disabled interrupts, can wakeup the processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEVONPENDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 1 - Sleep on Exit"]
            #[inline]
            pub fn sleeponexit(&self) -> SLEEPONEXITR {
                SLEEPONEXITR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Sleep or Deep Sleep"]
            #[inline]
            pub fn sleepdeep(&self) -> SLEEPDEEPR {
                SLEEPDEEPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Send Event on Pending bit:"]
            #[inline]
            pub fn sevonpend(&self) -> SEVONPENDR {
                SEVONPENDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 1 - Sleep on Exit"]
            #[inline]
            pub fn sleeponexit(&mut self) -> _SLEEPONEXITW {
                _SLEEPONEXITW { w: self }
            }
            #[doc = "Bit 2 - Sleep or Deep Sleep"]
            #[inline]
            pub fn sleepdeep(&mut self) -> _SLEEPDEEPW {
                _SLEEPDEEPW { w: self }
            }
            #[doc = "Bit 4 - Send Event on Pending bit:"]
            #[inline]
            pub fn sevonpend(&mut self) -> _SEVONPENDW {
                _SEVONPENDW { w: self }
            }
        }
    }
    #[doc = "Configuration and Control Register"]
    pub struct CCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Configuration and Control Register"]
    pub mod ccr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `NONBASETHRDENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NONBASETHRDENAR {
            #[doc = "processor can enter Thread mode only when no exception is active."]
            VALUE1,
            #[doc = "processor can enter Thread mode from any level under the control of an EXC_RETURN value, see Exception returnException return occurs when the processor is in Handler mode and executes one of the following instructions to load the EXC_RETURN value into the PC:an LDM or POP instruction that loads the PCan LDR instruction with PC as the destinationa BX instruction using any register.EXC_RETURN is the value loaded into the LR on exception entry. The exception mechanism relies on this value to detect when the processor has completed an exception handler. The lowest five bits of this value provide information on the return stack and processor mode. shows the EXC_RETURN values with a description of the exception return behavior. All EXC_RETURN values have bits[31:5] set to one. When this value is loaded into the PC it indicates to the processor that the exception is complete, and the processor initiates the appropriate exception return sequence.Exception return behaviorEXC_RETURN[31:0]Description 0xFFFFFFF1 Return to Handler mode, exception return uses non-floating-point state from the MSP and execution uses MSP after return. 0xFFFFFFF9 Return to Thread mode, exception return uses non-floating-point state from MSP and execution uses MSP after return. 0xFFFFFFFD Return to Thread mode, exception return uses non-floating-point state from the PSP and execution uses PSP after return. 0xFFFFFFE1 Return to Handler mode, exception return uses floating-point-state from MSP and execution uses MSP after return. 0xFFFFFFE9 Return to Thread mode, exception return uses floating-point state from MSP and execution uses MSP after return. 0xFFFFFFED Return to Thread mode, exception return uses floating-point state from PSP and execution uses PSP after return. ."]
            VALUE2,
        }
        impl NONBASETHRDENAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NONBASETHRDENAR::VALUE1 => false,
                    NONBASETHRDENAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NONBASETHRDENAR {
                match value {
                    false => NONBASETHRDENAR::VALUE1,
                    true => NONBASETHRDENAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NONBASETHRDENAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NONBASETHRDENAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USERSETMPEND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USERSETMPENDR {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl USERSETMPENDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USERSETMPENDR::VALUE1 => false,
                    USERSETMPENDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USERSETMPENDR {
                match value {
                    false => USERSETMPENDR::VALUE1,
                    true => USERSETMPENDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USERSETMPENDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USERSETMPENDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UNALIGN_TRP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UNALIGN_TRPR {
            #[doc = "do not trap unaligned halfword and word accesses"]
            VALUE1,
            #[doc = "trap unaligned halfword and word accesses."]
            VALUE2,
        }
        impl UNALIGN_TRPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UNALIGN_TRPR::VALUE1 => false,
                    UNALIGN_TRPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UNALIGN_TRPR {
                match value {
                    false => UNALIGN_TRPR::VALUE1,
                    true => UNALIGN_TRPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UNALIGN_TRPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UNALIGN_TRPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DIV_0_TRP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIV_0_TRPR {
            #[doc = "do not trap divide by 0"]
            VALUE1,
            #[doc = "trap divide by 0."]
            VALUE2,
        }
        impl DIV_0_TRPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIV_0_TRPR::VALUE1 => false,
                    DIV_0_TRPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIV_0_TRPR {
                match value {
                    false => DIV_0_TRPR::VALUE1,
                    true => DIV_0_TRPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIV_0_TRPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIV_0_TRPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFHFNMIGN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFHFNMIGNR {
            #[doc = "data bus faults caused by load and store instructions cause a lock-up"]
            VALUE1,
            #[doc = "handlers running at priority -1 and -2 ignore data bus faults caused by load and store instructions."]
            VALUE2,
        }
        impl BFHFNMIGNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFHFNMIGNR::VALUE1 => false,
                    BFHFNMIGNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFHFNMIGNR {
                match value {
                    false => BFHFNMIGNR::VALUE1,
                    true => BFHFNMIGNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFHFNMIGNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFHFNMIGNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STKALIGN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STKALIGNR {
            #[doc = "4-byte aligned"]
            VALUE1,
            #[doc = "8-byte aligned."]
            VALUE2,
        }
        impl STKALIGNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STKALIGNR::VALUE1 => false,
                    STKALIGNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STKALIGNR {
                match value {
                    false => STKALIGNR::VALUE1,
                    true => STKALIGNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STKALIGNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STKALIGNR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `NONBASETHRDENA`"]
        pub enum NONBASETHRDENAW {
            #[doc = "processor can enter Thread mode only when no exception is active."]
            VALUE1,
            #[doc = "processor can enter Thread mode from any level under the control of an EXC_RETURN value, see Exception returnException return occurs when the processor is in Handler mode and executes one of the following instructions to load the EXC_RETURN value into the PC:an LDM or POP instruction that loads the PCan LDR instruction with PC as the destinationa BX instruction using any register.EXC_RETURN is the value loaded into the LR on exception entry. The exception mechanism relies on this value to detect when the processor has completed an exception handler. The lowest five bits of this value provide information on the return stack and processor mode. shows the EXC_RETURN values with a description of the exception return behavior. All EXC_RETURN values have bits[31:5] set to one. When this value is loaded into the PC it indicates to the processor that the exception is complete, and the processor initiates the appropriate exception return sequence.Exception return behaviorEXC_RETURN[31:0]Description 0xFFFFFFF1 Return to Handler mode, exception return uses non-floating-point state from the MSP and execution uses MSP after return. 0xFFFFFFF9 Return to Thread mode, exception return uses non-floating-point state from MSP and execution uses MSP after return. 0xFFFFFFFD Return to Thread mode, exception return uses non-floating-point state from the PSP and execution uses PSP after return. 0xFFFFFFE1 Return to Handler mode, exception return uses floating-point-state from MSP and execution uses MSP after return. 0xFFFFFFE9 Return to Thread mode, exception return uses floating-point state from MSP and execution uses MSP after return. 0xFFFFFFED Return to Thread mode, exception return uses floating-point state from PSP and execution uses PSP after return. ."]
            VALUE2,
        }
        impl NONBASETHRDENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NONBASETHRDENAW::VALUE1 => false,
                    NONBASETHRDENAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NONBASETHRDENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NONBASETHRDENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NONBASETHRDENAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "processor can enter Thread mode only when no exception is active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NONBASETHRDENAW::VALUE1)
            }
            #[doc = "processor can enter Thread mode from any level under the control of an EXC_RETURN value, see Exception returnException return occurs when the processor is in Handler mode and executes one of the following instructions to load the EXC_RETURN value into the PC:an LDM or POP instruction that loads the PCan LDR instruction with PC as the destinationa BX instruction using any register.EXC_RETURN is the value loaded into the LR on exception entry. The exception mechanism relies on this value to detect when the processor has completed an exception handler. The lowest five bits of this value provide information on the return stack and processor mode. shows the EXC_RETURN values with a description of the exception return behavior. All EXC_RETURN values have bits[31:5] set to one. When this value is loaded into the PC it indicates to the processor that the exception is complete, and the processor initiates the appropriate exception return sequence.Exception return behaviorEXC_RETURN[31:0]Description 0xFFFFFFF1 Return to Handler mode, exception return uses non-floating-point state from the MSP and execution uses MSP after return. 0xFFFFFFF9 Return to Thread mode, exception return uses non-floating-point state from MSP and execution uses MSP after return. 0xFFFFFFFD Return to Thread mode, exception return uses non-floating-point state from the PSP and execution uses PSP after return. 0xFFFFFFE1 Return to Handler mode, exception return uses floating-point-state from MSP and execution uses MSP after return. 0xFFFFFFE9 Return to Thread mode, exception return uses floating-point state from MSP and execution uses MSP after return. 0xFFFFFFED Return to Thread mode, exception return uses floating-point state from PSP and execution uses PSP after return. ."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NONBASETHRDENAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USERSETMPEND`"]
        pub enum USERSETMPENDW {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl USERSETMPENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USERSETMPENDW::VALUE1 => false,
                    USERSETMPENDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USERSETMPENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USERSETMPENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USERSETMPENDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USERSETMPENDW::VALUE1)
            }
            #[doc = "enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USERSETMPENDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UNALIGN_TRP`"]
        pub enum UNALIGN_TRPW {
            #[doc = "do not trap unaligned halfword and word accesses"]
            VALUE1,
            #[doc = "trap unaligned halfword and word accesses."]
            VALUE2,
        }
        impl UNALIGN_TRPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UNALIGN_TRPW::VALUE1 => false,
                    UNALIGN_TRPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UNALIGN_TRPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UNALIGN_TRPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UNALIGN_TRPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "do not trap unaligned halfword and word accesses"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UNALIGN_TRPW::VALUE1)
            }
            #[doc = "trap unaligned halfword and word accesses."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UNALIGN_TRPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIV_0_TRP`"]
        pub enum DIV_0_TRPW {
            #[doc = "do not trap divide by 0"]
            VALUE1,
            #[doc = "trap divide by 0."]
            VALUE2,
        }
        impl DIV_0_TRPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIV_0_TRPW::VALUE1 => false,
                    DIV_0_TRPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIV_0_TRPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIV_0_TRPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIV_0_TRPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "do not trap divide by 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIV_0_TRPW::VALUE1)
            }
            #[doc = "trap divide by 0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIV_0_TRPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFHFNMIGN`"]
        pub enum BFHFNMIGNW {
            #[doc = "data bus faults caused by load and store instructions cause a lock-up"]
            VALUE1,
            #[doc = "handlers running at priority -1 and -2 ignore data bus faults caused by load and store instructions."]
            VALUE2,
        }
        impl BFHFNMIGNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFHFNMIGNW::VALUE1 => false,
                    BFHFNMIGNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFHFNMIGNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFHFNMIGNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFHFNMIGNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "data bus faults caused by load and store instructions cause a lock-up"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFHFNMIGNW::VALUE1)
            }
            #[doc = "handlers running at priority -1 and -2 ignore data bus faults caused by load and store instructions."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFHFNMIGNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STKALIGN`"]
        pub enum STKALIGNW {
            #[doc = "4-byte aligned"]
            VALUE1,
            #[doc = "8-byte aligned."]
            VALUE2,
        }
        impl STKALIGNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STKALIGNW::VALUE1 => false,
                    STKALIGNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STKALIGNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STKALIGNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STKALIGNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "4-byte aligned"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STKALIGNW::VALUE1)
            }
            #[doc = "8-byte aligned."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STKALIGNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Non Base Thread Mode Enable"]
            #[inline]
            pub fn nonbasethrdena(&self) -> NONBASETHRDENAR {
                NONBASETHRDENAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - User Set Pending Enable"]
            #[inline]
            pub fn usersetmpend(&self) -> USERSETMPENDR {
                USERSETMPENDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Unaligned Access Trap Enable"]
            #[inline]
            pub fn unalign_trp(&self) -> UNALIGN_TRPR {
                UNALIGN_TRPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Divide by Zero Trap Enable"]
            #[inline]
            pub fn div_0_trp(&self) -> DIV_0_TRPR {
                DIV_0_TRPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Bus Fault Hard Fault and NMI Ignore"]
            #[inline]
            pub fn bfhfnmign(&self) -> BFHFNMIGNR {
                BFHFNMIGNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Stack Alignment"]
            #[inline]
            pub fn stkalign(&self) -> STKALIGNR {
                STKALIGNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0200 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Non Base Thread Mode Enable"]
            #[inline]
            pub fn nonbasethrdena(&mut self) -> _NONBASETHRDENAW {
                _NONBASETHRDENAW { w: self }
            }
            #[doc = "Bit 1 - User Set Pending Enable"]
            #[inline]
            pub fn usersetmpend(&mut self) -> _USERSETMPENDW {
                _USERSETMPENDW { w: self }
            }
            #[doc = "Bit 3 - Unaligned Access Trap Enable"]
            #[inline]
            pub fn unalign_trp(&mut self) -> _UNALIGN_TRPW {
                _UNALIGN_TRPW { w: self }
            }
            #[doc = "Bit 4 - Divide by Zero Trap Enable"]
            #[inline]
            pub fn div_0_trp(&mut self) -> _DIV_0_TRPW {
                _DIV_0_TRPW { w: self }
            }
            #[doc = "Bit 8 - Bus Fault Hard Fault and NMI Ignore"]
            #[inline]
            pub fn bfhfnmign(&mut self) -> _BFHFNMIGNW {
                _BFHFNMIGNW { w: self }
            }
            #[doc = "Bit 9 - Stack Alignment"]
            #[inline]
            pub fn stkalign(&mut self) -> _STKALIGNW {
                _STKALIGNW { w: self }
            }
        }
    }
    #[doc = "System Handler Priority Register 1"]
    pub struct SHPR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "System Handler Priority Register 1"]
    pub mod shpr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SHPR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_4R {
            bits: u8,
        }
        impl PRI_4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_5R {
            bits: u8,
        }
        impl PRI_5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_6R {
            bits: u8,
        }
        impl PRI_6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Priority of system handler 4, MemManage"]
            #[inline]
            pub fn pri_4(&self) -> PRI_4R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_4R { bits }
            }
            #[doc = "Bits 8:15 - Priority of system handler 5, BusFault"]
            #[inline]
            pub fn pri_5(&self) -> PRI_5R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_5R { bits }
            }
            #[doc = "Bits 16:23 - Priority of system handler 6, UsageFault"]
            #[inline]
            pub fn pri_6(&self) -> PRI_6R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_6R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Priority of system handler 4, MemManage"]
            #[inline]
            pub fn pri_4(&mut self) -> _PRI_4W {
                _PRI_4W { w: self }
            }
            #[doc = "Bits 8:15 - Priority of system handler 5, BusFault"]
            #[inline]
            pub fn pri_5(&mut self) -> _PRI_5W {
                _PRI_5W { w: self }
            }
            #[doc = "Bits 16:23 - Priority of system handler 6, UsageFault"]
            #[inline]
            pub fn pri_6(&mut self) -> _PRI_6W {
                _PRI_6W { w: self }
            }
        }
    }
    #[doc = "System Handler Priority Register 2"]
    pub struct SHPR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "System Handler Priority Register 2"]
    pub mod shpr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SHPR2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_11R {
            bits: u8,
        }
        impl PRI_11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_11W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 24:31 - Priority of system handler 11, SVCall"]
            #[inline]
            pub fn pri_11(&self) -> PRI_11R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_11R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 24:31 - Priority of system handler 11, SVCall"]
            #[inline]
            pub fn pri_11(&mut self) -> _PRI_11W {
                _PRI_11W { w: self }
            }
        }
    }
    #[doc = "System Handler Priority Register 3"]
    pub struct SHPR3 {
        register: VolatileCell<u32>,
    }
    #[doc = "System Handler Priority Register 3"]
    pub mod shpr3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SHPR3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_14R {
            bits: u8,
        }
        impl PRI_14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRI_15R {
            bits: u8,
        }
        impl PRI_15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_14W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRI_15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRI_15W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 16:23 - Priority of system handler 14"]
            #[inline]
            pub fn pri_14(&self) -> PRI_14R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_14R { bits }
            }
            #[doc = "Bits 24:31 - Priority of system handler 15"]
            #[inline]
            pub fn pri_15(&self) -> PRI_15R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRI_15R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 16:23 - Priority of system handler 14"]
            #[inline]
            pub fn pri_14(&mut self) -> _PRI_14W {
                _PRI_14W { w: self }
            }
            #[doc = "Bits 24:31 - Priority of system handler 15"]
            #[inline]
            pub fn pri_15(&mut self) -> _PRI_15W {
                _PRI_15W { w: self }
            }
        }
    }
    #[doc = "System Handler Control and State Register"]
    pub struct SHCSR {
        register: VolatileCell<u32>,
    }
    #[doc = "System Handler Control and State Register"]
    pub mod shcsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SHCSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MEMFAULTACTR {
            bits: bool,
        }
        impl MEMFAULTACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BUSFAULTACTR {
            bits: bool,
        }
        impl BUSFAULTACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USGFAULTACTR {
            bits: bool,
        }
        impl USGFAULTACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SVCALLACTR {
            bits: bool,
        }
        impl SVCALLACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MONITORACTR {
            bits: bool,
        }
        impl MONITORACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PENDSVACTR {
            bits: bool,
        }
        impl PENDSVACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SYSTICKACTR {
            bits: bool,
        }
        impl SYSTICKACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USGFAULTPENDEDR {
            bits: bool,
        }
        impl USGFAULTPENDEDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MEMFAULTPENDEDR {
            bits: bool,
        }
        impl MEMFAULTPENDEDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BUSFAULTPENDEDR {
            bits: bool,
        }
        impl BUSFAULTPENDEDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SVCALLPENDEDR {
            bits: bool,
        }
        impl SVCALLPENDEDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MEMFAULTENAR {
            bits: bool,
        }
        impl MEMFAULTENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BUSFAULTENAR {
            bits: bool,
        }
        impl BUSFAULTENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USGFAULTENAR {
            bits: bool,
        }
        impl USGFAULTENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _MEMFAULTACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MEMFAULTACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BUSFAULTACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BUSFAULTACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USGFAULTACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USGFAULTACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVCALLACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVCALLACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MONITORACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MONITORACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PENDSVACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PENDSVACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSTICKACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSTICKACTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USGFAULTPENDEDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USGFAULTPENDEDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MEMFAULTPENDEDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MEMFAULTPENDEDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BUSFAULTPENDEDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BUSFAULTPENDEDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVCALLPENDEDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVCALLPENDEDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MEMFAULTENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MEMFAULTENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BUSFAULTENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BUSFAULTENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USGFAULTENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USGFAULTENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - MemManage exception active bit"]
            #[inline]
            pub fn memfaultact(&self) -> MEMFAULTACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MEMFAULTACTR { bits }
            }
            #[doc = "Bit 1 - BusFault exception active bit"]
            #[inline]
            pub fn busfaultact(&self) -> BUSFAULTACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BUSFAULTACTR { bits }
            }
            #[doc = "Bit 3 - UsageFault exception active bit"]
            #[inline]
            pub fn usgfaultact(&self) -> USGFAULTACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USGFAULTACTR { bits }
            }
            #[doc = "Bit 7 - SVCall active bit"]
            #[inline]
            pub fn svcallact(&self) -> SVCALLACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SVCALLACTR { bits }
            }
            #[doc = "Bit 8 - Debug monitor active bit"]
            #[inline]
            pub fn monitoract(&self) -> MONITORACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MONITORACTR { bits }
            }
            #[doc = "Bit 10 - PendSV exception active bit"]
            #[inline]
            pub fn pendsvact(&self) -> PENDSVACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PENDSVACTR { bits }
            }
            #[doc = "Bit 11 - SysTick exception active bit"]
            #[inline]
            pub fn systickact(&self) -> SYSTICKACTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SYSTICKACTR { bits }
            }
            #[doc = "Bit 12 - UsageFault exception pending bit"]
            #[inline]
            pub fn usgfaultpended(&self) -> USGFAULTPENDEDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USGFAULTPENDEDR { bits }
            }
            #[doc = "Bit 13 - MemManage exception pending bit"]
            #[inline]
            pub fn memfaultpended(&self) -> MEMFAULTPENDEDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MEMFAULTPENDEDR { bits }
            }
            #[doc = "Bit 14 - BusFault exception pending bit"]
            #[inline]
            pub fn busfaultpended(&self) -> BUSFAULTPENDEDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BUSFAULTPENDEDR { bits }
            }
            #[doc = "Bit 15 - SVCall pending bit"]
            #[inline]
            pub fn svcallpended(&self) -> SVCALLPENDEDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SVCALLPENDEDR { bits }
            }
            #[doc = "Bit 16 - MemManage enable bit"]
            #[inline]
            pub fn memfaultena(&self) -> MEMFAULTENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MEMFAULTENAR { bits }
            }
            #[doc = "Bit 17 - BusFault enable bit"]
            #[inline]
            pub fn busfaultena(&self) -> BUSFAULTENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BUSFAULTENAR { bits }
            }
            #[doc = "Bit 18 - UsageFault enable bit"]
            #[inline]
            pub fn usgfaultena(&self) -> USGFAULTENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USGFAULTENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - MemManage exception active bit"]
            #[inline]
            pub fn memfaultact(&mut self) -> _MEMFAULTACTW {
                _MEMFAULTACTW { w: self }
            }
            #[doc = "Bit 1 - BusFault exception active bit"]
            #[inline]
            pub fn busfaultact(&mut self) -> _BUSFAULTACTW {
                _BUSFAULTACTW { w: self }
            }
            #[doc = "Bit 3 - UsageFault exception active bit"]
            #[inline]
            pub fn usgfaultact(&mut self) -> _USGFAULTACTW {
                _USGFAULTACTW { w: self }
            }
            #[doc = "Bit 7 - SVCall active bit"]
            #[inline]
            pub fn svcallact(&mut self) -> _SVCALLACTW {
                _SVCALLACTW { w: self }
            }
            #[doc = "Bit 8 - Debug monitor active bit"]
            #[inline]
            pub fn monitoract(&mut self) -> _MONITORACTW {
                _MONITORACTW { w: self }
            }
            #[doc = "Bit 10 - PendSV exception active bit"]
            #[inline]
            pub fn pendsvact(&mut self) -> _PENDSVACTW {
                _PENDSVACTW { w: self }
            }
            #[doc = "Bit 11 - SysTick exception active bit"]
            #[inline]
            pub fn systickact(&mut self) -> _SYSTICKACTW {
                _SYSTICKACTW { w: self }
            }
            #[doc = "Bit 12 - UsageFault exception pending bit"]
            #[inline]
            pub fn usgfaultpended(&mut self) -> _USGFAULTPENDEDW {
                _USGFAULTPENDEDW { w: self }
            }
            #[doc = "Bit 13 - MemManage exception pending bit"]
            #[inline]
            pub fn memfaultpended(&mut self) -> _MEMFAULTPENDEDW {
                _MEMFAULTPENDEDW { w: self }
            }
            #[doc = "Bit 14 - BusFault exception pending bit"]
            #[inline]
            pub fn busfaultpended(&mut self) -> _BUSFAULTPENDEDW {
                _BUSFAULTPENDEDW { w: self }
            }
            #[doc = "Bit 15 - SVCall pending bit"]
            #[inline]
            pub fn svcallpended(&mut self) -> _SVCALLPENDEDW {
                _SVCALLPENDEDW { w: self }
            }
            #[doc = "Bit 16 - MemManage enable bit"]
            #[inline]
            pub fn memfaultena(&mut self) -> _MEMFAULTENAW {
                _MEMFAULTENAW { w: self }
            }
            #[doc = "Bit 17 - BusFault enable bit"]
            #[inline]
            pub fn busfaultena(&mut self) -> _BUSFAULTENAW {
                _BUSFAULTENAW { w: self }
            }
            #[doc = "Bit 18 - UsageFault enable bit"]
            #[inline]
            pub fn usgfaultena(&mut self) -> _USGFAULTENAW {
                _USGFAULTENAW { w: self }
            }
        }
    }
    #[doc = "Configurable Fault Status Register"]
    pub struct CFSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Configurable Fault Status Register"]
    pub mod cfsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CFSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `IACCVIOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IACCVIOLR {
            #[doc = "no instruction access violation fault"]
            VALUE1,
            #[doc = "the processor attempted an instruction fetch from a location that does not permit execution."]
            VALUE2,
        }
        impl IACCVIOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IACCVIOLR::VALUE1 => false,
                    IACCVIOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IACCVIOLR {
                match value {
                    false => IACCVIOLR::VALUE1,
                    true => IACCVIOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IACCVIOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IACCVIOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DACCVIOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DACCVIOLR {
            #[doc = "no data access violation fault"]
            VALUE1,
            #[doc = "the processor attempted a load or store at a location that does not permit the operation."]
            VALUE2,
        }
        impl DACCVIOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DACCVIOLR::VALUE1 => false,
                    DACCVIOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DACCVIOLR {
                match value {
                    false => DACCVIOLR::VALUE1,
                    true => DACCVIOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DACCVIOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DACCVIOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MUNSTKERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MUNSTKERRR {
            #[doc = "no unstacking fault"]
            VALUE1,
            #[doc = "unstack for an exception return has caused one or more access violations."]
            VALUE2,
        }
        impl MUNSTKERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MUNSTKERRR::VALUE1 => false,
                    MUNSTKERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MUNSTKERRR {
                match value {
                    false => MUNSTKERRR::VALUE1,
                    true => MUNSTKERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MUNSTKERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MUNSTKERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSTKERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSTKERRR {
            #[doc = "no stacking fault"]
            VALUE1,
            #[doc = "stacking for an exception entry has caused one or more access violations."]
            VALUE2,
        }
        impl MSTKERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSTKERRR::VALUE1 => false,
                    MSTKERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSTKERRR {
                match value {
                    false => MSTKERRR::VALUE1,
                    true => MSTKERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSTKERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSTKERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MLSPERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MLSPERRR {
            #[doc = "No MemManage fault occurred during floating-point lazy state preservation"]
            VALUE1,
            #[doc = "A MemManage fault occurred during floating-point lazy state preservation"]
            VALUE2,
        }
        impl MLSPERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MLSPERRR::VALUE1 => false,
                    MLSPERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MLSPERRR {
                match value {
                    false => MLSPERRR::VALUE1,
                    true => MLSPERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MLSPERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MLSPERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MMARVALID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MMARVALIDR {
            #[doc = "value in MMAR is not a valid fault address"]
            VALUE1,
            #[doc = "MMAR holds a valid fault address."]
            VALUE2,
        }
        impl MMARVALIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MMARVALIDR::VALUE1 => false,
                    MMARVALIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MMARVALIDR {
                match value {
                    false => MMARVALIDR::VALUE1,
                    true => MMARVALIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MMARVALIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MMARVALIDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IBUSERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IBUSERRR {
            #[doc = "no instruction bus error"]
            VALUE1,
            #[doc = "instruction bus error."]
            VALUE2,
        }
        impl IBUSERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IBUSERRR::VALUE1 => false,
                    IBUSERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IBUSERRR {
                match value {
                    false => IBUSERRR::VALUE1,
                    true => IBUSERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IBUSERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IBUSERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRECISERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRECISERRR {
            #[doc = "no precise data bus error"]
            VALUE1,
            #[doc = "a data bus error has occurred, and the PC value stacked for the exception return points to the instruction that caused the fault."]
            VALUE2,
        }
        impl PRECISERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRECISERRR::VALUE1 => false,
                    PRECISERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRECISERRR {
                match value {
                    false => PRECISERRR::VALUE1,
                    true => PRECISERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRECISERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRECISERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IMPRECISERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IMPRECISERRR {
            #[doc = "no imprecise data bus error"]
            VALUE1,
            #[doc = "a data bus error has occurred, but the return address in the stack frame is not related to the instruction that caused the error."]
            VALUE2,
        }
        impl IMPRECISERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IMPRECISERRR::VALUE1 => false,
                    IMPRECISERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IMPRECISERRR {
                match value {
                    false => IMPRECISERRR::VALUE1,
                    true => IMPRECISERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IMPRECISERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IMPRECISERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UNSTKERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UNSTKERRR {
            #[doc = "no unstacking fault"]
            VALUE1,
            #[doc = "stacking for an exception entry has caused one or more BusFaults."]
            VALUE2,
        }
        impl UNSTKERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UNSTKERRR::VALUE1 => false,
                    UNSTKERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UNSTKERRR {
                match value {
                    false => UNSTKERRR::VALUE1,
                    true => UNSTKERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UNSTKERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UNSTKERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STKERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STKERRR {
            #[doc = "no stacking fault"]
            VALUE1,
            #[doc = "stacking for an exception entry has caused one or more BusFaults."]
            VALUE2,
        }
        impl STKERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STKERRR::VALUE1 => false,
                    STKERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STKERRR {
                match value {
                    false => STKERRR::VALUE1,
                    true => STKERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STKERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STKERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LSPERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LSPERRR {
            #[doc = "No bus fault occurred during floating-point lazy state preservation."]
            VALUE1,
            #[doc = "A bus fault occurred during floating-point lazy state preservation"]
            VALUE2,
        }
        impl LSPERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LSPERRR::VALUE1 => false,
                    LSPERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LSPERRR {
                match value {
                    false => LSPERRR::VALUE1,
                    true => LSPERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LSPERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LSPERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFARVALID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFARVALIDR {
            #[doc = "value in BFAR is not a valid fault address"]
            VALUE1,
            #[doc = "BFAR holds a valid fault address."]
            VALUE2,
        }
        impl BFARVALIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFARVALIDR::VALUE1 => false,
                    BFARVALIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFARVALIDR {
                match value {
                    false => BFARVALIDR::VALUE1,
                    true => BFARVALIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFARVALIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFARVALIDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UNDEFINSTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UNDEFINSTRR {
            #[doc = "no undefined instruction UsageFault"]
            VALUE1,
            #[doc = "the processor has attempted to execute an undefined instruction."]
            VALUE2,
        }
        impl UNDEFINSTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UNDEFINSTRR::VALUE1 => false,
                    UNDEFINSTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UNDEFINSTRR {
                match value {
                    false => UNDEFINSTRR::VALUE1,
                    true => UNDEFINSTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UNDEFINSTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UNDEFINSTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `INVSTATE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INVSTATER {
            #[doc = "no invalid state UsageFault"]
            VALUE1,
            #[doc = "the processor has attempted to execute an instruction that makes illegal use of the EPSR."]
            VALUE2,
        }
        impl INVSTATER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INVSTATER::VALUE1 => false,
                    INVSTATER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INVSTATER {
                match value {
                    false => INVSTATER::VALUE1,
                    true => INVSTATER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INVSTATER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INVSTATER::VALUE2
            }
        }
        #[doc = "Possible values of the field `INVPC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INVPCR {
            #[doc = "no invalid PC load UsageFault"]
            VALUE1,
            #[doc = "the processor has attempted an illegal load of EXC_RETURN to the PC, as a result of an invalid context, or an invalid EXC_RETURN value."]
            VALUE2,
        }
        impl INVPCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INVPCR::VALUE1 => false,
                    INVPCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INVPCR {
                match value {
                    false => INVPCR::VALUE1,
                    true => INVPCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INVPCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INVPCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NOCP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NOCPR {
            #[doc = "no UsageFault caused by attempting to access a coprocessor"]
            VALUE1,
            #[doc = "the processor has attempted to access a coprocessor."]
            VALUE2,
        }
        impl NOCPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NOCPR::VALUE1 => false,
                    NOCPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NOCPR {
                match value {
                    false => NOCPR::VALUE1,
                    true => NOCPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NOCPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NOCPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UNALIGNED`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UNALIGNEDR {
            #[doc = "no unaligned access fault, or unaligned access trapping not enabled"]
            VALUE1,
            #[doc = "the processor has made an unaligned memory access."]
            VALUE2,
        }
        impl UNALIGNEDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UNALIGNEDR::VALUE1 => false,
                    UNALIGNEDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UNALIGNEDR {
                match value {
                    false => UNALIGNEDR::VALUE1,
                    true => UNALIGNEDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UNALIGNEDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UNALIGNEDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DIVBYZERO`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIVBYZEROR {
            #[doc = "no divide by zero fault, or divide by zero trapping not enabled"]
            VALUE1,
            #[doc = "the processor has executed an SDIV or UDIV instruction with a divisor of 0"]
            VALUE2,
        }
        impl DIVBYZEROR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIVBYZEROR::VALUE1 => false,
                    DIVBYZEROR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIVBYZEROR {
                match value {
                    false => DIVBYZEROR::VALUE1,
                    true => DIVBYZEROR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIVBYZEROR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIVBYZEROR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `IACCVIOL`"]
        pub enum IACCVIOLW {
            #[doc = "no instruction access violation fault"]
            VALUE1,
            #[doc = "the processor attempted an instruction fetch from a location that does not permit execution."]
            VALUE2,
        }
        impl IACCVIOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IACCVIOLW::VALUE1 => false,
                    IACCVIOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IACCVIOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IACCVIOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IACCVIOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no instruction access violation fault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IACCVIOLW::VALUE1)
            }
            #[doc = "the processor attempted an instruction fetch from a location that does not permit execution."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IACCVIOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DACCVIOL`"]
        pub enum DACCVIOLW {
            #[doc = "no data access violation fault"]
            VALUE1,
            #[doc = "the processor attempted a load or store at a location that does not permit the operation."]
            VALUE2,
        }
        impl DACCVIOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DACCVIOLW::VALUE1 => false,
                    DACCVIOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DACCVIOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DACCVIOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DACCVIOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no data access violation fault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DACCVIOLW::VALUE1)
            }
            #[doc = "the processor attempted a load or store at a location that does not permit the operation."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DACCVIOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MUNSTKERR`"]
        pub enum MUNSTKERRW {
            #[doc = "no unstacking fault"]
            VALUE1,
            #[doc = "unstack for an exception return has caused one or more access violations."]
            VALUE2,
        }
        impl MUNSTKERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MUNSTKERRW::VALUE1 => false,
                    MUNSTKERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MUNSTKERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MUNSTKERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MUNSTKERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no unstacking fault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MUNSTKERRW::VALUE1)
            }
            #[doc = "unstack for an exception return has caused one or more access violations."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MUNSTKERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSTKERR`"]
        pub enum MSTKERRW {
            #[doc = "no stacking fault"]
            VALUE1,
            #[doc = "stacking for an exception entry has caused one or more access violations."]
            VALUE2,
        }
        impl MSTKERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSTKERRW::VALUE1 => false,
                    MSTKERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSTKERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSTKERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSTKERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no stacking fault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSTKERRW::VALUE1)
            }
            #[doc = "stacking for an exception entry has caused one or more access violations."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSTKERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MLSPERR`"]
        pub enum MLSPERRW {
            #[doc = "No MemManage fault occurred during floating-point lazy state preservation"]
            VALUE1,
            #[doc = "A MemManage fault occurred during floating-point lazy state preservation"]
            VALUE2,
        }
        impl MLSPERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MLSPERRW::VALUE1 => false,
                    MLSPERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MLSPERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MLSPERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MLSPERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No MemManage fault occurred during floating-point lazy state preservation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MLSPERRW::VALUE1)
            }
            #[doc = "A MemManage fault occurred during floating-point lazy state preservation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MLSPERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MMARVALID`"]
        pub enum MMARVALIDW {
            #[doc = "value in MMAR is not a valid fault address"]
            VALUE1,
            #[doc = "MMAR holds a valid fault address."]
            VALUE2,
        }
        impl MMARVALIDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MMARVALIDW::VALUE1 => false,
                    MMARVALIDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MMARVALIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MMARVALIDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MMARVALIDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "value in MMAR is not a valid fault address"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MMARVALIDW::VALUE1)
            }
            #[doc = "MMAR holds a valid fault address."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MMARVALIDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IBUSERR`"]
        pub enum IBUSERRW {
            #[doc = "no instruction bus error"]
            VALUE1,
            #[doc = "instruction bus error."]
            VALUE2,
        }
        impl IBUSERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IBUSERRW::VALUE1 => false,
                    IBUSERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IBUSERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IBUSERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IBUSERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no instruction bus error"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IBUSERRW::VALUE1)
            }
            #[doc = "instruction bus error."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IBUSERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PRECISERR`"]
        pub enum PRECISERRW {
            #[doc = "no precise data bus error"]
            VALUE1,
            #[doc = "a data bus error has occurred, and the PC value stacked for the exception return points to the instruction that caused the fault."]
            VALUE2,
        }
        impl PRECISERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PRECISERRW::VALUE1 => false,
                    PRECISERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRECISERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRECISERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRECISERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no precise data bus error"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRECISERRW::VALUE1)
            }
            #[doc = "a data bus error has occurred, and the PC value stacked for the exception return points to the instruction that caused the fault."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRECISERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IMPRECISERR`"]
        pub enum IMPRECISERRW {
            #[doc = "no imprecise data bus error"]
            VALUE1,
            #[doc = "a data bus error has occurred, but the return address in the stack frame is not related to the instruction that caused the error."]
            VALUE2,
        }
        impl IMPRECISERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IMPRECISERRW::VALUE1 => false,
                    IMPRECISERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IMPRECISERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IMPRECISERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IMPRECISERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no imprecise data bus error"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IMPRECISERRW::VALUE1)
            }
            #[doc = "a data bus error has occurred, but the return address in the stack frame is not related to the instruction that caused the error."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IMPRECISERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UNSTKERR`"]
        pub enum UNSTKERRW {
            #[doc = "no unstacking fault"]
            VALUE1,
            #[doc = "stacking for an exception entry has caused one or more BusFaults."]
            VALUE2,
        }
        impl UNSTKERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UNSTKERRW::VALUE1 => false,
                    UNSTKERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UNSTKERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UNSTKERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UNSTKERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no unstacking fault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UNSTKERRW::VALUE1)
            }
            #[doc = "stacking for an exception entry has caused one or more BusFaults."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UNSTKERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STKERR`"]
        pub enum STKERRW {
            #[doc = "no stacking fault"]
            VALUE1,
            #[doc = "stacking for an exception entry has caused one or more BusFaults."]
            VALUE2,
        }
        impl STKERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STKERRW::VALUE1 => false,
                    STKERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STKERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STKERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STKERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no stacking fault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STKERRW::VALUE1)
            }
            #[doc = "stacking for an exception entry has caused one or more BusFaults."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STKERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LSPERR`"]
        pub enum LSPERRW {
            #[doc = "No bus fault occurred during floating-point lazy state preservation."]
            VALUE1,
            #[doc = "A bus fault occurred during floating-point lazy state preservation"]
            VALUE2,
        }
        impl LSPERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LSPERRW::VALUE1 => false,
                    LSPERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LSPERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LSPERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LSPERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No bus fault occurred during floating-point lazy state preservation."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LSPERRW::VALUE1)
            }
            #[doc = "A bus fault occurred during floating-point lazy state preservation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LSPERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFARVALID`"]
        pub enum BFARVALIDW {
            #[doc = "value in BFAR is not a valid fault address"]
            VALUE1,
            #[doc = "BFAR holds a valid fault address."]
            VALUE2,
        }
        impl BFARVALIDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFARVALIDW::VALUE1 => false,
                    BFARVALIDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFARVALIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFARVALIDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFARVALIDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "value in BFAR is not a valid fault address"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFARVALIDW::VALUE1)
            }
            #[doc = "BFAR holds a valid fault address."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFARVALIDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UNDEFINSTR`"]
        pub enum UNDEFINSTRW {
            #[doc = "no undefined instruction UsageFault"]
            VALUE1,
            #[doc = "the processor has attempted to execute an undefined instruction."]
            VALUE2,
        }
        impl UNDEFINSTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UNDEFINSTRW::VALUE1 => false,
                    UNDEFINSTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UNDEFINSTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UNDEFINSTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UNDEFINSTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no undefined instruction UsageFault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UNDEFINSTRW::VALUE1)
            }
            #[doc = "the processor has attempted to execute an undefined instruction."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UNDEFINSTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INVSTATE`"]
        pub enum INVSTATEW {
            #[doc = "no invalid state UsageFault"]
            VALUE1,
            #[doc = "the processor has attempted to execute an instruction that makes illegal use of the EPSR."]
            VALUE2,
        }
        impl INVSTATEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INVSTATEW::VALUE1 => false,
                    INVSTATEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INVSTATEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INVSTATEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INVSTATEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no invalid state UsageFault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INVSTATEW::VALUE1)
            }
            #[doc = "the processor has attempted to execute an instruction that makes illegal use of the EPSR."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INVSTATEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INVPC`"]
        pub enum INVPCW {
            #[doc = "no invalid PC load UsageFault"]
            VALUE1,
            #[doc = "the processor has attempted an illegal load of EXC_RETURN to the PC, as a result of an invalid context, or an invalid EXC_RETURN value."]
            VALUE2,
        }
        impl INVPCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INVPCW::VALUE1 => false,
                    INVPCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INVPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INVPCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INVPCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no invalid PC load UsageFault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INVPCW::VALUE1)
            }
            #[doc = "the processor has attempted an illegal load of EXC_RETURN to the PC, as a result of an invalid context, or an invalid EXC_RETURN value."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INVPCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NOCP`"]
        pub enum NOCPW {
            #[doc = "no UsageFault caused by attempting to access a coprocessor"]
            VALUE1,
            #[doc = "the processor has attempted to access a coprocessor."]
            VALUE2,
        }
        impl NOCPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NOCPW::VALUE1 => false,
                    NOCPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NOCPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NOCPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NOCPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no UsageFault caused by attempting to access a coprocessor"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NOCPW::VALUE1)
            }
            #[doc = "the processor has attempted to access a coprocessor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NOCPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UNALIGNED`"]
        pub enum UNALIGNEDW {
            #[doc = "no unaligned access fault, or unaligned access trapping not enabled"]
            VALUE1,
            #[doc = "the processor has made an unaligned memory access."]
            VALUE2,
        }
        impl UNALIGNEDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UNALIGNEDW::VALUE1 => false,
                    UNALIGNEDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UNALIGNEDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UNALIGNEDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UNALIGNEDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no unaligned access fault, or unaligned access trapping not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UNALIGNEDW::VALUE1)
            }
            #[doc = "the processor has made an unaligned memory access."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UNALIGNEDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIVBYZERO`"]
        pub enum DIVBYZEROW {
            #[doc = "no divide by zero fault, or divide by zero trapping not enabled"]
            VALUE1,
            #[doc = "the processor has executed an SDIV or UDIV instruction with a divisor of 0"]
            VALUE2,
        }
        impl DIVBYZEROW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIVBYZEROW::VALUE1 => false,
                    DIVBYZEROW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIVBYZEROW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIVBYZEROW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIVBYZEROW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no divide by zero fault, or divide by zero trapping not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIVBYZEROW::VALUE1)
            }
            #[doc = "the processor has executed an SDIV or UDIV instruction with a divisor of 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIVBYZEROW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Instruction access violation flag"]
            #[inline]
            pub fn iaccviol(&self) -> IACCVIOLR {
                IACCVIOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Data access violation flag"]
            #[inline]
            pub fn daccviol(&self) -> DACCVIOLR {
                DACCVIOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - MemManage fault on unstacking for a return from exception"]
            #[inline]
            pub fn munstkerr(&self) -> MUNSTKERRR {
                MUNSTKERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - MemManage fault on stacking for exception entry"]
            #[inline]
            pub fn mstkerr(&self) -> MSTKERRR {
                MSTKERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - MemManage fault during floating point lazy state preservation"]
            #[inline]
            pub fn mlsperr(&self) -> MLSPERRR {
                MLSPERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - MemManage Fault Address Register (MMFAR) valid flag"]
            #[inline]
            pub fn mmarvalid(&self) -> MMARVALIDR {
                MMARVALIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Instruction bus error"]
            #[inline]
            pub fn ibuserr(&self) -> IBUSERRR {
                IBUSERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Precise data bus error"]
            #[inline]
            pub fn preciserr(&self) -> PRECISERRR {
                PRECISERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Imprecise data bus error"]
            #[inline]
            pub fn impreciserr(&self) -> IMPRECISERRR {
                IMPRECISERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - BusFault on unstacking for a return from exception"]
            #[inline]
            pub fn unstkerr(&self) -> UNSTKERRR {
                UNSTKERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - BusFault on stacking for exception entry"]
            #[inline]
            pub fn stkerr(&self) -> STKERRR {
                STKERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - BusFault during floating point lazy state preservation"]
            #[inline]
            pub fn lsperr(&self) -> LSPERRR {
                LSPERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - BusFault Address Register (BFAR) valid flag"]
            #[inline]
            pub fn bfarvalid(&self) -> BFARVALIDR {
                BFARVALIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Undefined instruction UsageFault"]
            #[inline]
            pub fn undefinstr(&self) -> UNDEFINSTRR {
                UNDEFINSTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Invalid state UsageFault"]
            #[inline]
            pub fn invstate(&self) -> INVSTATER {
                INVSTATER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Invalid PC load UsageFault"]
            #[inline]
            pub fn invpc(&self) -> INVPCR {
                INVPCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - No coprocessor UsageFault"]
            #[inline]
            pub fn nocp(&self) -> NOCPR {
                NOCPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Unaligned access UsageFault"]
            #[inline]
            pub fn unaligned(&self) -> UNALIGNEDR {
                UNALIGNEDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Divide by zero UsageFault"]
            #[inline]
            pub fn divbyzero(&self) -> DIVBYZEROR {
                DIVBYZEROR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Instruction access violation flag"]
            #[inline]
            pub fn iaccviol(&mut self) -> _IACCVIOLW {
                _IACCVIOLW { w: self }
            }
            #[doc = "Bit 1 - Data access violation flag"]
            #[inline]
            pub fn daccviol(&mut self) -> _DACCVIOLW {
                _DACCVIOLW { w: self }
            }
            #[doc = "Bit 3 - MemManage fault on unstacking for a return from exception"]
            #[inline]
            pub fn munstkerr(&mut self) -> _MUNSTKERRW {
                _MUNSTKERRW { w: self }
            }
            #[doc = "Bit 4 - MemManage fault on stacking for exception entry"]
            #[inline]
            pub fn mstkerr(&mut self) -> _MSTKERRW {
                _MSTKERRW { w: self }
            }
            #[doc = "Bit 5 - MemManage fault during floating point lazy state preservation"]
            #[inline]
            pub fn mlsperr(&mut self) -> _MLSPERRW {
                _MLSPERRW { w: self }
            }
            #[doc = "Bit 7 - MemManage Fault Address Register (MMFAR) valid flag"]
            #[inline]
            pub fn mmarvalid(&mut self) -> _MMARVALIDW {
                _MMARVALIDW { w: self }
            }
            #[doc = "Bit 8 - Instruction bus error"]
            #[inline]
            pub fn ibuserr(&mut self) -> _IBUSERRW {
                _IBUSERRW { w: self }
            }
            #[doc = "Bit 9 - Precise data bus error"]
            #[inline]
            pub fn preciserr(&mut self) -> _PRECISERRW {
                _PRECISERRW { w: self }
            }
            #[doc = "Bit 10 - Imprecise data bus error"]
            #[inline]
            pub fn impreciserr(&mut self) -> _IMPRECISERRW {
                _IMPRECISERRW { w: self }
            }
            #[doc = "Bit 11 - BusFault on unstacking for a return from exception"]
            #[inline]
            pub fn unstkerr(&mut self) -> _UNSTKERRW {
                _UNSTKERRW { w: self }
            }
            #[doc = "Bit 12 - BusFault on stacking for exception entry"]
            #[inline]
            pub fn stkerr(&mut self) -> _STKERRW {
                _STKERRW { w: self }
            }
            #[doc = "Bit 13 - BusFault during floating point lazy state preservation"]
            #[inline]
            pub fn lsperr(&mut self) -> _LSPERRW {
                _LSPERRW { w: self }
            }
            #[doc = "Bit 15 - BusFault Address Register (BFAR) valid flag"]
            #[inline]
            pub fn bfarvalid(&mut self) -> _BFARVALIDW {
                _BFARVALIDW { w: self }
            }
            #[doc = "Bit 16 - Undefined instruction UsageFault"]
            #[inline]
            pub fn undefinstr(&mut self) -> _UNDEFINSTRW {
                _UNDEFINSTRW { w: self }
            }
            #[doc = "Bit 17 - Invalid state UsageFault"]
            #[inline]
            pub fn invstate(&mut self) -> _INVSTATEW {
                _INVSTATEW { w: self }
            }
            #[doc = "Bit 18 - Invalid PC load UsageFault"]
            #[inline]
            pub fn invpc(&mut self) -> _INVPCW {
                _INVPCW { w: self }
            }
            #[doc = "Bit 19 - No coprocessor UsageFault"]
            #[inline]
            pub fn nocp(&mut self) -> _NOCPW {
                _NOCPW { w: self }
            }
            #[doc = "Bit 24 - Unaligned access UsageFault"]
            #[inline]
            pub fn unaligned(&mut self) -> _UNALIGNEDW {
                _UNALIGNEDW { w: self }
            }
            #[doc = "Bit 25 - Divide by zero UsageFault"]
            #[inline]
            pub fn divbyzero(&mut self) -> _DIVBYZEROW {
                _DIVBYZEROW { w: self }
            }
        }
    }
    #[doc = "HardFault Status Register"]
    pub struct HFSR {
        register: VolatileCell<u32>,
    }
    #[doc = "HardFault Status Register"]
    pub mod hfsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HFSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `VECTTBL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VECTTBLR {
            #[doc = "no BusFault on vector table read"]
            VALUE1,
            #[doc = "BusFault on vector table read"]
            VALUE2,
        }
        impl VECTTBLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VECTTBLR::VALUE1 => false,
                    VECTTBLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VECTTBLR {
                match value {
                    false => VECTTBLR::VALUE1,
                    true => VECTTBLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VECTTBLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VECTTBLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FORCED`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FORCEDR {
            #[doc = "no forced HardFault"]
            VALUE1,
            #[doc = "forced HardFault."]
            VALUE2,
        }
        impl FORCEDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FORCEDR::VALUE1 => false,
                    FORCEDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FORCEDR {
                match value {
                    false => FORCEDR::VALUE1,
                    true => FORCEDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FORCEDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FORCEDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEBUGEVTR {
            bits: bool,
        }
        impl DEBUGEVTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `VECTTBL`"]
        pub enum VECTTBLW {
            #[doc = "no BusFault on vector table read"]
            VALUE1,
            #[doc = "BusFault on vector table read"]
            VALUE2,
        }
        impl VECTTBLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VECTTBLW::VALUE1 => false,
                    VECTTBLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VECTTBLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VECTTBLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VECTTBLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no BusFault on vector table read"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VECTTBLW::VALUE1)
            }
            #[doc = "BusFault on vector table read"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VECTTBLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FORCED`"]
        pub enum FORCEDW {
            #[doc = "no forced HardFault"]
            VALUE1,
            #[doc = "forced HardFault."]
            VALUE2,
        }
        impl FORCEDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FORCEDW::VALUE1 => false,
                    FORCEDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FORCEDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FORCEDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FORCEDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no forced HardFault"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FORCEDW::VALUE1)
            }
            #[doc = "forced HardFault."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FORCEDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEBUGEVTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEBUGEVTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 1 - BusFault on vector table read"]
            #[inline]
            pub fn vecttbl(&self) -> VECTTBLR {
                VECTTBLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Forced HardFault"]
            #[inline]
            pub fn forced(&self) -> FORCEDR {
                FORCEDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Reserved for Debug use"]
            #[inline]
            pub fn debugevt(&self) -> DEBUGEVTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DEBUGEVTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 1 - BusFault on vector table read"]
            #[inline]
            pub fn vecttbl(&mut self) -> _VECTTBLW {
                _VECTTBLW { w: self }
            }
            #[doc = "Bit 30 - Forced HardFault"]
            #[inline]
            pub fn forced(&mut self) -> _FORCEDW {
                _FORCEDW { w: self }
            }
            #[doc = "Bit 31 - Reserved for Debug use"]
            #[inline]
            pub fn debugevt(&mut self) -> _DEBUGEVTW {
                _DEBUGEVTW { w: self }
            }
        }
    }
    #[doc = "MemManage Fault Address Register"]
    pub struct MMFAR {
        register: VolatileCell<u32>,
    }
    #[doc = "MemManage Fault Address Register"]
    pub mod mmfar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MMFAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRESSR {
            bits: u32,
        }
        impl ADDRESSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRESSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRESSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Address causing the fault"]
            #[inline]
            pub fn address(&self) -> ADDRESSR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRESSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Address causing the fault"]
            #[inline]
            pub fn address(&mut self) -> _ADDRESSW {
                _ADDRESSW { w: self }
            }
        }
    }
    #[doc = "BusFault Address Register"]
    pub struct BFAR {
        register: VolatileCell<u32>,
    }
    #[doc = "BusFault Address Register"]
    pub mod bfar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BFAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRESSR {
            bits: u32,
        }
        impl ADDRESSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRESSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRESSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Address causing the fault"]
            #[inline]
            pub fn address(&self) -> ADDRESSR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRESSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Address causing the fault"]
            #[inline]
            pub fn address(&mut self) -> _ADDRESSW {
                _ADDRESSW { w: self }
            }
        }
    }
    #[doc = "Auxiliary Fault Status Register"]
    pub struct AFSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Auxiliary Fault Status Register"]
    pub mod afsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::AFSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct VALUER {
            bits: u32,
        }
        impl VALUER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _VALUEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VALUEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Reserved"]
            #[inline]
            pub fn value(&self) -> VALUER {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                VALUER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Reserved"]
            #[inline]
            pub fn value(&mut self) -> _VALUEW {
                _VALUEW { w: self }
            }
        }
    }
    #[doc = "Coprocessor Access Control Register"]
    pub struct CPACR {
        register: VolatileCell<u32>,
    }
    #[doc = "Coprocessor Access Control Register"]
    pub mod cpacr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CPACR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CP10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CP10R {
            #[doc = "Access denied. Any attempted access generates a NOCP UsageFault."]
            VALUE1,
            #[doc = "Privileged access only. An unprivileged access generates a NOCP fault."]
            VALUE2,
            #[doc = "Full access."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CP10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CP10R::VALUE1 => 0,
                    CP10R::VALUE2 => 0x01,
                    CP10R::VALUE4 => 0x03,
                    CP10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CP10R {
                match value {
                    0 => CP10R::VALUE1,
                    1 => CP10R::VALUE2,
                    3 => CP10R::VALUE4,
                    i => CP10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CP10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CP10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CP10R::VALUE4
            }
        }
        #[doc = "Possible values of the field `CP11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CP11R {
            #[doc = "Access denied. Any attempted access generates a NOCP UsageFault."]
            VALUE1,
            #[doc = "Privileged access only. An unprivileged access generates a NOCP fault."]
            VALUE2,
            #[doc = "Full access."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CP11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CP11R::VALUE1 => 0,
                    CP11R::VALUE2 => 0x01,
                    CP11R::VALUE4 => 0x03,
                    CP11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CP11R {
                match value {
                    0 => CP11R::VALUE1,
                    1 => CP11R::VALUE2,
                    3 => CP11R::VALUE4,
                    i => CP11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CP11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CP11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CP11R::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CP10`"]
        pub enum CP10W {
            #[doc = "Access denied. Any attempted access generates a NOCP UsageFault."]
            VALUE1,
            #[doc = "Privileged access only. An unprivileged access generates a NOCP fault."]
            VALUE2,
            #[doc = "Full access."]
            VALUE4,
        }
        impl CP10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CP10W::VALUE1 => 0,
                    CP10W::VALUE2 => 1,
                    CP10W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CP10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CP10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CP10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Access denied. Any attempted access generates a NOCP UsageFault."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CP10W::VALUE1)
            }
            #[doc = "Privileged access only. An unprivileged access generates a NOCP fault."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CP10W::VALUE2)
            }
            #[doc = "Full access."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CP10W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CP11`"]
        pub enum CP11W {
            #[doc = "Access denied. Any attempted access generates a NOCP UsageFault."]
            VALUE1,
            #[doc = "Privileged access only. An unprivileged access generates a NOCP fault."]
            VALUE2,
            #[doc = "Full access."]
            VALUE4,
        }
        impl CP11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CP11W::VALUE1 => 0,
                    CP11W::VALUE2 => 1,
                    CP11W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CP11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CP11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CP11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Access denied. Any attempted access generates a NOCP UsageFault."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CP11W::VALUE1)
            }
            #[doc = "Privileged access only. An unprivileged access generates a NOCP fault."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CP11W::VALUE2)
            }
            #[doc = "Full access."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CP11W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 20:21 - Access privileges for coprocessor 10"]
            #[inline]
            pub fn cp10(&self) -> CP10R {
                CP10R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Access privileges for coprocessor 11"]
            #[inline]
            pub fn cp11(&self) -> CP11R {
                CP11R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 20:21 - Access privileges for coprocessor 10"]
            #[inline]
            pub fn cp10(&mut self) -> _CP10W {
                _CP10W { w: self }
            }
            #[doc = "Bits 22:23 - Access privileges for coprocessor 11"]
            #[inline]
            pub fn cp11(&mut self) -> _CP11W {
                _CP11W { w: self }
            }
        }
    }
    #[doc = "MPU Type Register"]
    pub struct MPU_TYPE {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Type Register"]
    pub mod mpu_type {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MPU_TYPE {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct SEPARATER {
            bits: bool,
        }
        impl SEPARATER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DREGIONR {
            bits: u8,
        }
        impl DREGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct IREGIONR {
            bits: u8,
        }
        impl IREGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Support for unified or separate instruction and date memory maps"]
            #[inline]
            pub fn separate(&self) -> SEPARATER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SEPARATER { bits }
            }
            #[doc = "Bits 8:15 - Number of supported MPU data regions"]
            #[inline]
            pub fn dregion(&self) -> DREGIONR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DREGIONR { bits }
            }
            #[doc = "Bits 16:23 - Number of supported MPU instruction regions"]
            #[inline]
            pub fn iregion(&self) -> IREGIONR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                IREGIONR { bits }
            }
        }
    }
    #[doc = "MPU Control Register"]
    pub struct MPU_CTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Control Register"]
    pub mod mpu_ctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_CTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENABLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENABLER {
            #[doc = "MPU disabled"]
            VALUE1,
            #[doc = "MPU enabled."]
            VALUE2,
        }
        impl ENABLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENABLER::VALUE1 => false,
                    ENABLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENABLER {
                match value {
                    false => ENABLER::VALUE1,
                    true => ENABLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENABLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENABLER::VALUE2
            }
        }
        #[doc = "Possible values of the field `HFNMIENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HFNMIENAR {
            #[doc = "MPU is disabled during hard fault, NMI, and FAULTMASK handlers, regardless of the value of the ENABLE bit"]
            VALUE1,
            #[doc = "the MPU is enabled during hard fault, NMI, and FAULTMASK handlers."]
            VALUE2,
        }
        impl HFNMIENAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HFNMIENAR::VALUE1 => false,
                    HFNMIENAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HFNMIENAR {
                match value {
                    false => HFNMIENAR::VALUE1,
                    true => HFNMIENAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HFNMIENAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HFNMIENAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRIVDEFENA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRIVDEFENAR {
            #[doc = "If the MPU is enabled, disables use of the default memory map. Any memory access to a location not covered by any enabled region causes a fault."]
            VALUE1,
            #[doc = "If the MPU is enabled, enables use of the default memory map as a background region for privileged software accesses."]
            VALUE2,
        }
        impl PRIVDEFENAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRIVDEFENAR::VALUE1 => false,
                    PRIVDEFENAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRIVDEFENAR {
                match value {
                    false => PRIVDEFENAR::VALUE1,
                    true => PRIVDEFENAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRIVDEFENAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRIVDEFENAR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ENABLE`"]
        pub enum ENABLEW {
            #[doc = "MPU disabled"]
            VALUE1,
            #[doc = "MPU enabled."]
            VALUE2,
        }
        impl ENABLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENABLEW::VALUE1 => false,
                    ENABLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENABLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENABLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENABLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MPU disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENABLEW::VALUE1)
            }
            #[doc = "MPU enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENABLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HFNMIENA`"]
        pub enum HFNMIENAW {
            #[doc = "MPU is disabled during hard fault, NMI, and FAULTMASK handlers, regardless of the value of the ENABLE bit"]
            VALUE1,
            #[doc = "the MPU is enabled during hard fault, NMI, and FAULTMASK handlers."]
            VALUE2,
        }
        impl HFNMIENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HFNMIENAW::VALUE1 => false,
                    HFNMIENAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HFNMIENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HFNMIENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HFNMIENAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MPU is disabled during hard fault, NMI, and FAULTMASK handlers, regardless of the value of the ENABLE bit"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HFNMIENAW::VALUE1)
            }
            #[doc = "the MPU is enabled during hard fault, NMI, and FAULTMASK handlers."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HFNMIENAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PRIVDEFENA`"]
        pub enum PRIVDEFENAW {
            #[doc = "If the MPU is enabled, disables use of the default memory map. Any memory access to a location not covered by any enabled region causes a fault."]
            VALUE1,
            #[doc = "If the MPU is enabled, enables use of the default memory map as a background region for privileged software accesses."]
            VALUE2,
        }
        impl PRIVDEFENAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PRIVDEFENAW::VALUE1 => false,
                    PRIVDEFENAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRIVDEFENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRIVDEFENAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRIVDEFENAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "If the MPU is enabled, disables use of the default memory map. Any memory access to a location not covered by any enabled region causes a fault."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRIVDEFENAW::VALUE1)
            }
            #[doc = "If the MPU is enabled, enables use of the default memory map as a background region for privileged software accesses."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRIVDEFENAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Enable MPU"]
            #[inline]
            pub fn enable(&self) -> ENABLER {
                ENABLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Enable the operation of MPU during hard fault, NMI, and FAULTMASK handlers"]
            #[inline]
            pub fn hfnmiena(&self) -> HFNMIENAR {
                HFNMIENAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Enables privileged software access to the default memory map"]
            #[inline]
            pub fn privdefena(&self) -> PRIVDEFENAR {
                PRIVDEFENAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Enable MPU"]
            #[inline]
            pub fn enable(&mut self) -> _ENABLEW {
                _ENABLEW { w: self }
            }
            #[doc = "Bit 1 - Enable the operation of MPU during hard fault, NMI, and FAULTMASK handlers"]
            #[inline]
            pub fn hfnmiena(&mut self) -> _HFNMIENAW {
                _HFNMIENAW { w: self }
            }
            #[doc = "Bit 2 - Enables privileged software access to the default memory map"]
            #[inline]
            pub fn privdefena(&mut self) -> _PRIVDEFENAW {
                _PRIVDEFENAW { w: self }
            }
        }
    }
    #[doc = "MPU Region Number Register"]
    pub struct MPU_RNR {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Number Register"]
    pub mod mpu_rnr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RNR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct REGIONR {
            bits: u8,
        }
        impl REGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _REGIONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REGIONW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Region"]
            #[inline]
            pub fn region(&self) -> REGIONR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REGIONR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Region"]
            #[inline]
            pub fn region(&mut self) -> _REGIONW {
                _REGIONW { w: self }
            }
        }
    }
    #[doc = "MPU Region Base Address Register"]
    pub struct MPU_RBAR {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Base Address Register"]
    pub mod mpu_rbar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RBAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct REGIONR {
            bits: u8,
        }
        impl REGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `VALID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VALIDR {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VALIDR::VALUE1 => false,
                    VALIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VALIDR {
                match value {
                    false => VALIDR::VALUE1,
                    true => VALIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VALIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VALIDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRR {
            bits: u32,
        }
        impl ADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _REGIONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REGIONW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VALID`"]
        pub enum VALIDW {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VALIDW::VALUE1 => false,
                    VALIDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VALIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VALIDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VALIDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VALIDW::VALUE1)
            }
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VALIDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x007f_ffff;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&self) -> REGIONR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REGIONR { bits }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&self) -> VALIDR {
                VALIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&self) -> ADDRR {
                let bits = {
                    const MASK: u32 = 0x007f_ffff;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&mut self) -> _REGIONW {
                _REGIONW { w: self }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&mut self) -> _VALIDW {
                _VALIDW { w: self }
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&mut self) -> _ADDRW {
                _ADDRW { w: self }
            }
        }
    }
    #[doc = "MPU Region Attribute and Size Register"]
    pub struct MPU_RASR {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Attribute and Size Register"]
    pub mod mpu_rasr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RASR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENABLER {
            bits: bool,
        }
        impl ENABLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SIZER {
            bits: u8,
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRDR {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRDR::VALUE1 => 0,
                    SRDR::VALUE2 => 0x01,
                    SRDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRDR {
                match value {
                    0 => SRDR::VALUE1,
                    1 => SRDR::VALUE2,
                    i => SRDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct BR {
            bits: bool,
        }
        impl BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR {
            bits: bool,
        }
        impl CR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SR {
            bits: bool,
        }
        impl SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TEXR {
            bits: u8,
        }
        impl TEXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct APR {
            bits: u8,
        }
        impl APR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `XN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XNR {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    XNR::VALUE1 => false,
                    XNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> XNR {
                match value {
                    false => XNR::VALUE1,
                    true => XNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XNR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENABLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENABLEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRD`"]
        pub enum SRDW {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
        }
        impl SRDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRDW::VALUE1 => 0,
                    SRDW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "corresponding sub-region is enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRDW::VALUE1)
            }
            #[doc = "corresponding sub-region is disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRDW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEXW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _APW<'a> {
            w: &'a mut W,
        }
        impl<'a> _APW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XN`"]
        pub enum XNW {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XNW::VALUE1 => false,
                    XNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "instruction fetches enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XNW::VALUE1)
            }
            #[doc = "instruction fetches disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&self) -> ENABLER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENABLER { bits }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SIZER { bits }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&self) -> SRDR {
                SRDR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&self) -> BR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BR { bits }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&self) -> CR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CR { bits }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&self) -> SR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SR { bits }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&self) -> TEXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TEXR { bits }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&self) -> APR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                APR { bits }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&self) -> XNR {
                XNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&mut self) -> _ENABLEW {
                _ENABLEW { w: self }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&mut self) -> _SIZEW {
                _SIZEW { w: self }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&mut self) -> _SRDW {
                _SRDW { w: self }
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&mut self) -> _BW {
                _BW { w: self }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&mut self) -> _CW {
                _CW { w: self }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&mut self) -> _SW {
                _SW { w: self }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&mut self) -> _TEXW {
                _TEXW { w: self }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&mut self) -> _APW {
                _APW { w: self }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&mut self) -> _XNW {
                _XNW { w: self }
            }
        }
    }
    #[doc = "MPU Region Base Address Register A1"]
    pub struct MPU_RBAR_A1 {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Base Address Register A1"]
    pub mod mpu_rbar_a1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RBAR_A1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct REGIONR {
            bits: u8,
        }
        impl REGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `VALID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VALIDR {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VALIDR::VALUE1 => false,
                    VALIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VALIDR {
                match value {
                    false => VALIDR::VALUE1,
                    true => VALIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VALIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VALIDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRR {
            bits: u32,
        }
        impl ADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _REGIONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REGIONW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VALID`"]
        pub enum VALIDW {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VALIDW::VALUE1 => false,
                    VALIDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VALIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VALIDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VALIDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VALIDW::VALUE1)
            }
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VALIDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x007f_ffff;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&self) -> REGIONR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REGIONR { bits }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&self) -> VALIDR {
                VALIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&self) -> ADDRR {
                let bits = {
                    const MASK: u32 = 0x007f_ffff;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&mut self) -> _REGIONW {
                _REGIONW { w: self }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&mut self) -> _VALIDW {
                _VALIDW { w: self }
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&mut self) -> _ADDRW {
                _ADDRW { w: self }
            }
        }
    }
    #[doc = "MPU Region Attribute and Size Register A1"]
    pub struct MPU_RASR_A1 {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Attribute and Size Register A1"]
    pub mod mpu_rasr_a1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RASR_A1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENABLER {
            bits: bool,
        }
        impl ENABLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SIZER {
            bits: u8,
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRDR {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRDR::VALUE1 => 0,
                    SRDR::VALUE2 => 0x01,
                    SRDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRDR {
                match value {
                    0 => SRDR::VALUE1,
                    1 => SRDR::VALUE2,
                    i => SRDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct BR {
            bits: bool,
        }
        impl BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR {
            bits: bool,
        }
        impl CR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SR {
            bits: bool,
        }
        impl SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TEXR {
            bits: u8,
        }
        impl TEXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct APR {
            bits: u8,
        }
        impl APR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `XN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XNR {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    XNR::VALUE1 => false,
                    XNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> XNR {
                match value {
                    false => XNR::VALUE1,
                    true => XNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XNR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENABLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENABLEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRD`"]
        pub enum SRDW {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
        }
        impl SRDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRDW::VALUE1 => 0,
                    SRDW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "corresponding sub-region is enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRDW::VALUE1)
            }
            #[doc = "corresponding sub-region is disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRDW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEXW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _APW<'a> {
            w: &'a mut W,
        }
        impl<'a> _APW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XN`"]
        pub enum XNW {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XNW::VALUE1 => false,
                    XNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "instruction fetches enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XNW::VALUE1)
            }
            #[doc = "instruction fetches disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&self) -> ENABLER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENABLER { bits }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SIZER { bits }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&self) -> SRDR {
                SRDR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&self) -> BR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BR { bits }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&self) -> CR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CR { bits }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&self) -> SR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SR { bits }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&self) -> TEXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TEXR { bits }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&self) -> APR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                APR { bits }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&self) -> XNR {
                XNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&mut self) -> _ENABLEW {
                _ENABLEW { w: self }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&mut self) -> _SIZEW {
                _SIZEW { w: self }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&mut self) -> _SRDW {
                _SRDW { w: self }
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&mut self) -> _BW {
                _BW { w: self }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&mut self) -> _CW {
                _CW { w: self }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&mut self) -> _SW {
                _SW { w: self }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&mut self) -> _TEXW {
                _TEXW { w: self }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&mut self) -> _APW {
                _APW { w: self }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&mut self) -> _XNW {
                _XNW { w: self }
            }
        }
    }
    #[doc = "MPU Region Base Address Register A2"]
    pub struct MPU_RBAR_A2 {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Base Address Register A2"]
    pub mod mpu_rbar_a2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RBAR_A2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct REGIONR {
            bits: u8,
        }
        impl REGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `VALID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VALIDR {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VALIDR::VALUE1 => false,
                    VALIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VALIDR {
                match value {
                    false => VALIDR::VALUE1,
                    true => VALIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VALIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VALIDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRR {
            bits: u32,
        }
        impl ADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _REGIONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REGIONW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VALID`"]
        pub enum VALIDW {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VALIDW::VALUE1 => false,
                    VALIDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VALIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VALIDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VALIDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VALIDW::VALUE1)
            }
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VALIDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x007f_ffff;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&self) -> REGIONR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REGIONR { bits }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&self) -> VALIDR {
                VALIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&self) -> ADDRR {
                let bits = {
                    const MASK: u32 = 0x007f_ffff;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&mut self) -> _REGIONW {
                _REGIONW { w: self }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&mut self) -> _VALIDW {
                _VALIDW { w: self }
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&mut self) -> _ADDRW {
                _ADDRW { w: self }
            }
        }
    }
    #[doc = "MPU Region Attribute and Size Register A2"]
    pub struct MPU_RASR_A2 {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Attribute and Size Register A2"]
    pub mod mpu_rasr_a2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RASR_A2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENABLER {
            bits: bool,
        }
        impl ENABLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SIZER {
            bits: u8,
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRDR {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRDR::VALUE1 => 0,
                    SRDR::VALUE2 => 0x01,
                    SRDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRDR {
                match value {
                    0 => SRDR::VALUE1,
                    1 => SRDR::VALUE2,
                    i => SRDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct BR {
            bits: bool,
        }
        impl BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR {
            bits: bool,
        }
        impl CR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SR {
            bits: bool,
        }
        impl SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TEXR {
            bits: u8,
        }
        impl TEXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct APR {
            bits: u8,
        }
        impl APR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `XN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XNR {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    XNR::VALUE1 => false,
                    XNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> XNR {
                match value {
                    false => XNR::VALUE1,
                    true => XNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XNR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENABLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENABLEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRD`"]
        pub enum SRDW {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
        }
        impl SRDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRDW::VALUE1 => 0,
                    SRDW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "corresponding sub-region is enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRDW::VALUE1)
            }
            #[doc = "corresponding sub-region is disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRDW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEXW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _APW<'a> {
            w: &'a mut W,
        }
        impl<'a> _APW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XN`"]
        pub enum XNW {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XNW::VALUE1 => false,
                    XNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "instruction fetches enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XNW::VALUE1)
            }
            #[doc = "instruction fetches disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&self) -> ENABLER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENABLER { bits }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SIZER { bits }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&self) -> SRDR {
                SRDR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&self) -> BR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BR { bits }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&self) -> CR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CR { bits }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&self) -> SR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SR { bits }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&self) -> TEXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TEXR { bits }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&self) -> APR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                APR { bits }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&self) -> XNR {
                XNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&mut self) -> _ENABLEW {
                _ENABLEW { w: self }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&mut self) -> _SIZEW {
                _SIZEW { w: self }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&mut self) -> _SRDW {
                _SRDW { w: self }
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&mut self) -> _BW {
                _BW { w: self }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&mut self) -> _CW {
                _CW { w: self }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&mut self) -> _SW {
                _SW { w: self }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&mut self) -> _TEXW {
                _TEXW { w: self }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&mut self) -> _APW {
                _APW { w: self }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&mut self) -> _XNW {
                _XNW { w: self }
            }
        }
    }
    #[doc = "MPU Region Base Address Register A3"]
    pub struct MPU_RBAR_A3 {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Base Address Register A3"]
    pub mod mpu_rbar_a3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RBAR_A3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct REGIONR {
            bits: u8,
        }
        impl REGIONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `VALID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VALIDR {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VALIDR::VALUE1 => false,
                    VALIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VALIDR {
                match value {
                    false => VALIDR::VALUE1,
                    true => VALIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VALIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VALIDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRR {
            bits: u32,
        }
        impl ADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _REGIONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REGIONW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VALID`"]
        pub enum VALIDW {
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            VALUE1,
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            VALUE2,
        }
        impl VALIDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VALIDW::VALUE1 => false,
                    VALIDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VALIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VALIDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VALIDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MPU_RNR not changed, and the processor: - updates the base address for the region specified in the MPU_RNR - ignores the value of the REGION field"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VALIDW::VALUE1)
            }
            #[doc = "the processor: - updates the value of the MPU_RNR to the value of the REGION field - updates the base address for the region specified in the REGION field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VALIDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x007f_ffff;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&self) -> REGIONR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REGIONR { bits }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&self) -> VALIDR {
                VALIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&self) -> ADDRR {
                let bits = {
                    const MASK: u32 = 0x007f_ffff;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - MPU region field"]
            #[inline]
            pub fn region(&mut self) -> _REGIONW {
                _REGIONW { w: self }
            }
            #[doc = "Bit 4 - MPU Region Number valid bit"]
            #[inline]
            pub fn valid(&mut self) -> _VALIDW {
                _VALIDW { w: self }
            }
            #[doc = "Bits 9:31 - Region base address field"]
            #[inline]
            pub fn addr(&mut self) -> _ADDRW {
                _ADDRW { w: self }
            }
        }
    }
    #[doc = "MPU Region Attribute and Size Register A3"]
    pub struct MPU_RASR_A3 {
        register: VolatileCell<u32>,
    }
    #[doc = "MPU Region Attribute and Size Register A3"]
    pub mod mpu_rasr_a3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MPU_RASR_A3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENABLER {
            bits: bool,
        }
        impl ENABLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SIZER {
            bits: u8,
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRDR {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRDR::VALUE1 => 0,
                    SRDR::VALUE2 => 0x01,
                    SRDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRDR {
                match value {
                    0 => SRDR::VALUE1,
                    1 => SRDR::VALUE2,
                    i => SRDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct BR {
            bits: bool,
        }
        impl BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR {
            bits: bool,
        }
        impl CR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SR {
            bits: bool,
        }
        impl SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TEXR {
            bits: u8,
        }
        impl TEXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct APR {
            bits: u8,
        }
        impl APR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `XN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XNR {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    XNR::VALUE1 => false,
                    XNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> XNR {
                match value {
                    false => XNR::VALUE1,
                    true => XNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XNR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENABLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENABLEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRD`"]
        pub enum SRDW {
            #[doc = "corresponding sub-region is enabled"]
            VALUE1,
            #[doc = "corresponding sub-region is disabled"]
            VALUE2,
        }
        impl SRDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRDW::VALUE1 => 0,
                    SRDW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "corresponding sub-region is enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRDW::VALUE1)
            }
            #[doc = "corresponding sub-region is disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRDW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEXW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _APW<'a> {
            w: &'a mut W,
        }
        impl<'a> _APW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XN`"]
        pub enum XNW {
            #[doc = "instruction fetches enabled"]
            VALUE1,
            #[doc = "instruction fetches disabled."]
            VALUE2,
        }
        impl XNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XNW::VALUE1 => false,
                    XNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "instruction fetches enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XNW::VALUE1)
            }
            #[doc = "instruction fetches disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&self) -> ENABLER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENABLER { bits }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SIZER { bits }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&self) -> SRDR {
                SRDR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&self) -> BR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BR { bits }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&self) -> CR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CR { bits }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&self) -> SR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SR { bits }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&self) -> TEXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TEXR { bits }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&self) -> APR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                APR { bits }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&self) -> XNR {
                XNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Region enable bit."]
            #[inline]
            pub fn enable(&mut self) -> _ENABLEW {
                _ENABLEW { w: self }
            }
            #[doc = "Bits 1:5 - MPU protection region size"]
            #[inline]
            pub fn size(&mut self) -> _SIZEW {
                _SIZEW { w: self }
            }
            #[doc = "Bits 8:15 - Subregion disable bits"]
            #[inline]
            pub fn srd(&mut self) -> _SRDW {
                _SRDW { w: self }
            }
            #[doc = "Bit 16 - Memory access attribute"]
            #[inline]
            pub fn b(&mut self) -> _BW {
                _BW { w: self }
            }
            #[doc = "Bit 17 - Memory access attribute"]
            #[inline]
            pub fn c(&mut self) -> _CW {
                _CW { w: self }
            }
            #[doc = "Bit 18 - Shareable bit"]
            #[inline]
            pub fn s(&mut self) -> _SW {
                _SW { w: self }
            }
            #[doc = "Bits 19:21 - Memory access attribute"]
            #[inline]
            pub fn tex(&mut self) -> _TEXW {
                _TEXW { w: self }
            }
            #[doc = "Bits 24:26 - Access permission field"]
            #[inline]
            pub fn ap(&mut self) -> _APW {
                _APW { w: self }
            }
            #[doc = "Bit 28 - Instruction access disable bit"]
            #[inline]
            pub fn xn(&mut self) -> _XNW {
                _XNW { w: self }
            }
        }
    }
    #[doc = "Software Trigger Interrupt Register"]
    pub struct STIR {
        register: VolatileCell<u32>,
    }
    #[doc = "Software Trigger Interrupt Register"]
    pub mod stir {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::STIR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _INTIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INTIDW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x01ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:8 - Interrupt ID of the interrupt to trigger"]
            #[inline]
            pub fn intid(&mut self) -> _INTIDW {
                _INTIDW { w: self }
            }
        }
    }
    #[doc = "Floating-point Context Control Register"]
    pub struct FPCCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating-point Context Control Register"]
    pub mod fpccr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPCCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `LSPACT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LSPACTR {
            #[doc = "Lazy state preservation is not active."]
            VALUE1,
            #[doc = "Lazy state preservation is active. floating-point stack frame has been allocated but saving state to it has been deferred."]
            VALUE2,
        }
        impl LSPACTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LSPACTR::VALUE1 => false,
                    LSPACTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LSPACTR {
                match value {
                    false => LSPACTR::VALUE1,
                    true => LSPACTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LSPACTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LSPACTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USERR {
            #[doc = "Privilege level was not user when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Privilege level was user when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl USERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USERR::VALUE1 => false,
                    USERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USERR {
                match value {
                    false => USERR::VALUE1,
                    true => USERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USERR::VALUE2
            }
        }
        #[doc = "Possible values of the field `THREAD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum THREADR {
            #[doc = "Mode was not Thread Mode when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Mode was Thread Mode when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl THREADR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    THREADR::VALUE1 => false,
                    THREADR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> THREADR {
                match value {
                    false => THREADR::VALUE1,
                    true => THREADR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == THREADR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == THREADR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HFRDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HFRDYR {
            #[doc = "Priority did not permit setting the HardFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Priority permitted setting the HardFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl HFRDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HFRDYR::VALUE1 => false,
                    HFRDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HFRDYR {
                match value {
                    false => HFRDYR::VALUE1,
                    true => HFRDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HFRDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HFRDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MMRDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MMRDYR {
            #[doc = "MemManage is disabled or priority did not permit setting the MemManage handler to the pending state when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "MemManage is enabled and priority permitted setting the MemManage handler to the pending state when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl MMRDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MMRDYR::VALUE1 => false,
                    MMRDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MMRDYR {
                match value {
                    false => MMRDYR::VALUE1,
                    true => MMRDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MMRDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MMRDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFRDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFRDYR {
            #[doc = "BusFault is disabled or priority did not permit setting the BusFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "BusFault is enabled and priority permitted setting the BusFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl BFRDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFRDYR::VALUE1 => false,
                    BFRDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFRDYR {
                match value {
                    false => BFRDYR::VALUE1,
                    true => BFRDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFRDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFRDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MONRDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MONRDYR {
            #[doc = "Debug Monitor is disabled or priority did not permit setting MON_PEND when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Debug Monitor is enabled and priority permits setting MON_PEND when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl MONRDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MONRDYR::VALUE1 => false,
                    MONRDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MONRDYR {
                match value {
                    false => MONRDYR::VALUE1,
                    true => MONRDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MONRDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MONRDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LSPEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LSPENR {
            #[doc = "Disable automatic lazy state preservation for floating-point context."]
            VALUE1,
            #[doc = "Enable automatic lazy state preservation for floating-point context."]
            VALUE2,
        }
        impl LSPENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LSPENR::VALUE1 => false,
                    LSPENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LSPENR {
                match value {
                    false => LSPENR::VALUE1,
                    true => LSPENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LSPENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LSPENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASPEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASPENR {
            #[doc = "Disable CONTROL setting on execution of a floating-point instruction."]
            VALUE1,
            #[doc = "Enable CONTROL setting on execution of a floating-point instruction."]
            VALUE2,
        }
        impl ASPENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASPENR::VALUE1 => false,
                    ASPENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASPENR {
                match value {
                    false => ASPENR::VALUE1,
                    true => ASPENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASPENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASPENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `LSPACT`"]
        pub enum LSPACTW {
            #[doc = "Lazy state preservation is not active."]
            VALUE1,
            #[doc = "Lazy state preservation is active. floating-point stack frame has been allocated but saving state to it has been deferred."]
            VALUE2,
        }
        impl LSPACTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LSPACTW::VALUE1 => false,
                    LSPACTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LSPACTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LSPACTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LSPACTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Lazy state preservation is not active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LSPACTW::VALUE1)
            }
            #[doc = "Lazy state preservation is active. floating-point stack frame has been allocated but saving state to it has been deferred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LSPACTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USER`"]
        pub enum USERW {
            #[doc = "Privilege level was not user when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Privilege level was user when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl USERW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USERW::VALUE1 => false,
                    USERW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USERW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USERW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Privilege level was not user when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USERW::VALUE1)
            }
            #[doc = "Privilege level was user when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USERW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `THREAD`"]
        pub enum THREADW {
            #[doc = "Mode was not Thread Mode when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Mode was Thread Mode when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl THREADW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    THREADW::VALUE1 => false,
                    THREADW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _THREADW<'a> {
            w: &'a mut W,
        }
        impl<'a> _THREADW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: THREADW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Mode was not Thread Mode when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(THREADW::VALUE1)
            }
            #[doc = "Mode was Thread Mode when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(THREADW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HFRDY`"]
        pub enum HFRDYW {
            #[doc = "Priority did not permit setting the HardFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Priority permitted setting the HardFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl HFRDYW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HFRDYW::VALUE1 => false,
                    HFRDYW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HFRDYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HFRDYW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HFRDYW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Priority did not permit setting the HardFault handler to the pending state when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HFRDYW::VALUE1)
            }
            #[doc = "Priority permitted setting the HardFault handler to the pending state when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HFRDYW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MMRDY`"]
        pub enum MMRDYW {
            #[doc = "MemManage is disabled or priority did not permit setting the MemManage handler to the pending state when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "MemManage is enabled and priority permitted setting the MemManage handler to the pending state when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl MMRDYW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MMRDYW::VALUE1 => false,
                    MMRDYW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MMRDYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MMRDYW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MMRDYW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MemManage is disabled or priority did not permit setting the MemManage handler to the pending state when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MMRDYW::VALUE1)
            }
            #[doc = "MemManage is enabled and priority permitted setting the MemManage handler to the pending state when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MMRDYW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFRDY`"]
        pub enum BFRDYW {
            #[doc = "BusFault is disabled or priority did not permit setting the BusFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "BusFault is enabled and priority permitted setting the BusFault handler to the pending state when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl BFRDYW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFRDYW::VALUE1 => false,
                    BFRDYW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFRDYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFRDYW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFRDYW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "BusFault is disabled or priority did not permit setting the BusFault handler to the pending state when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFRDYW::VALUE1)
            }
            #[doc = "BusFault is enabled and priority permitted setting the BusFault handler to the pending state when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFRDYW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MONRDY`"]
        pub enum MONRDYW {
            #[doc = "Debug Monitor is disabled or priority did not permit setting MON_PEND when the floating-point stack frame was allocated."]
            VALUE1,
            #[doc = "Debug Monitor is enabled and priority permits setting MON_PEND when the floating-point stack frame was allocated."]
            VALUE2,
        }
        impl MONRDYW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MONRDYW::VALUE1 => false,
                    MONRDYW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MONRDYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MONRDYW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MONRDYW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Debug Monitor is disabled or priority did not permit setting MON_PEND when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MONRDYW::VALUE1)
            }
            #[doc = "Debug Monitor is enabled and priority permits setting MON_PEND when the floating-point stack frame was allocated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MONRDYW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LSPEN`"]
        pub enum LSPENW {
            #[doc = "Disable automatic lazy state preservation for floating-point context."]
            VALUE1,
            #[doc = "Enable automatic lazy state preservation for floating-point context."]
            VALUE2,
        }
        impl LSPENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LSPENW::VALUE1 => false,
                    LSPENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LSPENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LSPENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LSPENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable automatic lazy state preservation for floating-point context."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LSPENW::VALUE1)
            }
            #[doc = "Enable automatic lazy state preservation for floating-point context."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LSPENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASPEN`"]
        pub enum ASPENW {
            #[doc = "Disable CONTROL setting on execution of a floating-point instruction."]
            VALUE1,
            #[doc = "Enable CONTROL setting on execution of a floating-point instruction."]
            VALUE2,
        }
        impl ASPENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASPENW::VALUE1 => false,
                    ASPENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASPENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASPENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASPENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable CONTROL setting on execution of a floating-point instruction."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASPENW::VALUE1)
            }
            #[doc = "Enable CONTROL setting on execution of a floating-point instruction."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASPENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Lazy State Preservation Active"]
            #[inline]
            pub fn lspact(&self) -> LSPACTR {
                LSPACTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - User allocated Stack Frame"]
            #[inline]
            pub fn user(&self) -> USERR {
                USERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Thread Mode allocated Stack Frame"]
            #[inline]
            pub fn thread(&self) -> THREADR {
                THREADR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - HardFault Ready"]
            #[inline]
            pub fn hfrdy(&self) -> HFRDYR {
                HFRDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - MemManage Ready"]
            #[inline]
            pub fn mmrdy(&self) -> MMRDYR {
                MMRDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - BusFault Ready"]
            #[inline]
            pub fn bfrdy(&self) -> BFRDYR {
                BFRDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Monitor Ready"]
            #[inline]
            pub fn monrdy(&self) -> MONRDYR {
                MONRDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Lazy State Preservation Enabled"]
            #[inline]
            pub fn lspen(&self) -> LSPENR {
                LSPENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Automatic State Preservation"]
            #[inline]
            pub fn aspen(&self) -> ASPENR {
                ASPENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Lazy State Preservation Active"]
            #[inline]
            pub fn lspact(&mut self) -> _LSPACTW {
                _LSPACTW { w: self }
            }
            #[doc = "Bit 1 - User allocated Stack Frame"]
            #[inline]
            pub fn user(&mut self) -> _USERW {
                _USERW { w: self }
            }
            #[doc = "Bit 3 - Thread Mode allocated Stack Frame"]
            #[inline]
            pub fn thread(&mut self) -> _THREADW {
                _THREADW { w: self }
            }
            #[doc = "Bit 4 - HardFault Ready"]
            #[inline]
            pub fn hfrdy(&mut self) -> _HFRDYW {
                _HFRDYW { w: self }
            }
            #[doc = "Bit 5 - MemManage Ready"]
            #[inline]
            pub fn mmrdy(&mut self) -> _MMRDYW {
                _MMRDYW { w: self }
            }
            #[doc = "Bit 6 - BusFault Ready"]
            #[inline]
            pub fn bfrdy(&mut self) -> _BFRDYW {
                _BFRDYW { w: self }
            }
            #[doc = "Bit 8 - Monitor Ready"]
            #[inline]
            pub fn monrdy(&mut self) -> _MONRDYW {
                _MONRDYW { w: self }
            }
            #[doc = "Bit 30 - Lazy State Preservation Enabled"]
            #[inline]
            pub fn lspen(&mut self) -> _LSPENW {
                _LSPENW { w: self }
            }
            #[doc = "Bit 31 - Automatic State Preservation"]
            #[inline]
            pub fn aspen(&mut self) -> _ASPENW {
                _ASPENW { w: self }
            }
        }
    }
    #[doc = "Floating-point Context Address Register"]
    pub struct FPCAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating-point Context Address Register"]
    pub mod fpcar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPCAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRESSR {
            bits: u32,
        }
        impl ADDRESSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRESSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRESSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x1fff_ffff;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:31 - Address"]
            #[inline]
            pub fn address(&self) -> ADDRESSR {
                let bits = {
                    const MASK: u32 = 0x1fff_ffff;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ADDRESSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:31 - Address"]
            #[inline]
            pub fn address(&mut self) -> _ADDRESSW {
                _ADDRESSW { w: self }
            }
        }
    }
    #[doc = "Floating-point Default Status Control Register"]
    pub struct FPDSCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating-point Default Status Control Register"]
    pub mod fpdscr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPDSCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RMODER {
            bits: u8,
        }
        impl RMODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FZR {
            bits: bool,
        }
        impl FZR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DNR {
            bits: bool,
        }
        impl DNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHPR {
            bits: bool,
        }
        impl AHPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMODEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _FZW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FZW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DNW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 22:23 - Default value for FPSCR.RMode"]
            #[inline]
            pub fn rmode(&self) -> RMODER {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RMODER { bits }
            }
            #[doc = "Bit 24 - Default value for FPSCR.FZ"]
            #[inline]
            pub fn fz(&self) -> FZR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FZR { bits }
            }
            #[doc = "Bit 25 - Default value for FPSCR.DN"]
            #[inline]
            pub fn dn(&self) -> DNR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DNR { bits }
            }
            #[doc = "Bit 26 - Default value for FPSCR.AHP"]
            #[inline]
            pub fn ahp(&self) -> AHPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 22:23 - Default value for FPSCR.RMode"]
            #[inline]
            pub fn rmode(&mut self) -> _RMODEW {
                _RMODEW { w: self }
            }
            #[doc = "Bit 24 - Default value for FPSCR.FZ"]
            #[inline]
            pub fn fz(&mut self) -> _FZW {
                _FZW { w: self }
            }
            #[doc = "Bit 25 - Default value for FPSCR.DN"]
            #[inline]
            pub fn dn(&mut self) -> _DNW {
                _DNW { w: self }
            }
            #[doc = "Bit 26 - Default value for FPSCR.AHP"]
            #[inline]
            pub fn ahp(&mut self) -> _AHPW {
                _AHPW { w: self }
            }
        }
    }
}
#[doc = "Cortex-M4 Private Peripheral Block"]
pub struct PPB {
    register_block: ppb::RegisterBlock,
}
impl Deref for PPB {
    type Target = ppb::RegisterBlock;
    fn deref(&self) -> &ppb::RegisterBlock {
        &self.register_block
    }
}
#[doc = "DMA Line Router"]
pub const DLR: Peripheral<DLR> = unsafe { Peripheral::new(0x5000_4900) };
#[doc = "DMA Line Router"]
pub mod dlr {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Overrun Status"]
        pub ovrstat: OVRSTAT,
        #[doc = "0x04 - Overrun Clear"]
        pub ovrclr: OVRCLR,
        #[doc = "0x08 - Service Request Selection 0"]
        pub srsel0: SRSEL0,
        _reserved0: [u8; 4usize],
        #[doc = "0x10 - Line Enable"]
        pub lnen: LNEN,
    }
    #[doc = "Overrun Status"]
    pub struct OVRSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Overrun Status"]
    pub mod ovrstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::OVRSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN0R {
            bits: bool,
        }
        impl LN0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN1R {
            bits: bool,
        }
        impl LN1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN2R {
            bits: bool,
        }
        impl LN2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN3R {
            bits: bool,
        }
        impl LN3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN4R {
            bits: bool,
        }
        impl LN4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN5R {
            bits: bool,
        }
        impl LN5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN6R {
            bits: bool,
        }
        impl LN6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LN7R {
            bits: bool,
        }
        impl LN7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Line 0 Overrun Status"]
            #[inline]
            pub fn ln0(&self) -> LN0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN0R { bits }
            }
            #[doc = "Bit 1 - Line 1 Overrun Status"]
            #[inline]
            pub fn ln1(&self) -> LN1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN1R { bits }
            }
            #[doc = "Bit 2 - Line 2 Overrun Status"]
            #[inline]
            pub fn ln2(&self) -> LN2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN2R { bits }
            }
            #[doc = "Bit 3 - Line 3 Overrun Status"]
            #[inline]
            pub fn ln3(&self) -> LN3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN3R { bits }
            }
            #[doc = "Bit 4 - Line 4 Overrun Status"]
            #[inline]
            pub fn ln4(&self) -> LN4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN4R { bits }
            }
            #[doc = "Bit 5 - Line 5 Overrun Status"]
            #[inline]
            pub fn ln5(&self) -> LN5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN5R { bits }
            }
            #[doc = "Bit 6 - Line 6 Overrun Status"]
            #[inline]
            pub fn ln6(&self) -> LN6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN6R { bits }
            }
            #[doc = "Bit 7 - Line 7 Overrun Status"]
            #[inline]
            pub fn ln7(&self) -> LN7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LN7R { bits }
            }
        }
    }
    #[doc = "Overrun Clear"]
    pub struct OVRCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Overrun Clear"]
    pub mod ovrclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OVRCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Line 0 Overrun Status Clear"]
            #[inline]
            pub fn ln0(&mut self) -> _LN0W {
                _LN0W { w: self }
            }
            #[doc = "Bit 1 - Line 1 Overrun Status Clear"]
            #[inline]
            pub fn ln1(&mut self) -> _LN1W {
                _LN1W { w: self }
            }
            #[doc = "Bit 2 - Line 2 Overrun Status Clear"]
            #[inline]
            pub fn ln2(&mut self) -> _LN2W {
                _LN2W { w: self }
            }
            #[doc = "Bit 3 - Line 3 Overrun Status Clear"]
            #[inline]
            pub fn ln3(&mut self) -> _LN3W {
                _LN3W { w: self }
            }
            #[doc = "Bit 4 - Line 4 Overrun Status Clear"]
            #[inline]
            pub fn ln4(&mut self) -> _LN4W {
                _LN4W { w: self }
            }
            #[doc = "Bit 5 - Line 5 Overrun Status Clear"]
            #[inline]
            pub fn ln5(&mut self) -> _LN5W {
                _LN5W { w: self }
            }
            #[doc = "Bit 6 - Line 6 Overrun Status Clear"]
            #[inline]
            pub fn ln6(&mut self) -> _LN6W {
                _LN6W { w: self }
            }
            #[doc = "Bit 7 - Line 7 Overrun Status Clear"]
            #[inline]
            pub fn ln7(&mut self) -> _LN7W {
                _LN7W { w: self }
            }
        }
    }
    #[doc = "Service Request Selection 0"]
    pub struct SRSEL0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Selection 0"]
    pub mod srsel0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRSEL0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS0R {
            bits: u8,
        }
        impl RS0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS1R {
            bits: u8,
        }
        impl RS1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS2R {
            bits: u8,
        }
        impl RS2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS3R {
            bits: u8,
        }
        impl RS3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS4R {
            bits: u8,
        }
        impl RS4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS5R {
            bits: u8,
        }
        impl RS5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS6R {
            bits: u8,
        }
        impl RS6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RS7R {
            bits: u8,
        }
        impl RS7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RS7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Request Source for Line 0"]
            #[inline]
            pub fn rs0(&self) -> RS0R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS0R { bits }
            }
            #[doc = "Bits 4:7 - Request Source for Line 1"]
            #[inline]
            pub fn rs1(&self) -> RS1R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS1R { bits }
            }
            #[doc = "Bits 8:11 - Request Source for Line 2"]
            #[inline]
            pub fn rs2(&self) -> RS2R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS2R { bits }
            }
            #[doc = "Bits 12:15 - Request Source for Line 3"]
            #[inline]
            pub fn rs3(&self) -> RS3R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS3R { bits }
            }
            #[doc = "Bits 16:19 - Request Source for Line 4"]
            #[inline]
            pub fn rs4(&self) -> RS4R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS4R { bits }
            }
            #[doc = "Bits 20:23 - Request Source for Line 5"]
            #[inline]
            pub fn rs5(&self) -> RS5R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS5R { bits }
            }
            #[doc = "Bits 24:27 - Request Source for Line 6"]
            #[inline]
            pub fn rs6(&self) -> RS6R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS6R { bits }
            }
            #[doc = "Bits 28:31 - Request Source for Line 7"]
            #[inline]
            pub fn rs7(&self) -> RS7R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RS7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Request Source for Line 0"]
            #[inline]
            pub fn rs0(&mut self) -> _RS0W {
                _RS0W { w: self }
            }
            #[doc = "Bits 4:7 - Request Source for Line 1"]
            #[inline]
            pub fn rs1(&mut self) -> _RS1W {
                _RS1W { w: self }
            }
            #[doc = "Bits 8:11 - Request Source for Line 2"]
            #[inline]
            pub fn rs2(&mut self) -> _RS2W {
                _RS2W { w: self }
            }
            #[doc = "Bits 12:15 - Request Source for Line 3"]
            #[inline]
            pub fn rs3(&mut self) -> _RS3W {
                _RS3W { w: self }
            }
            #[doc = "Bits 16:19 - Request Source for Line 4"]
            #[inline]
            pub fn rs4(&mut self) -> _RS4W {
                _RS4W { w: self }
            }
            #[doc = "Bits 20:23 - Request Source for Line 5"]
            #[inline]
            pub fn rs5(&mut self) -> _RS5W {
                _RS5W { w: self }
            }
            #[doc = "Bits 24:27 - Request Source for Line 6"]
            #[inline]
            pub fn rs6(&mut self) -> _RS6W {
                _RS6W { w: self }
            }
            #[doc = "Bits 28:31 - Request Source for Line 7"]
            #[inline]
            pub fn rs7(&mut self) -> _RS7W {
                _RS7W { w: self }
            }
        }
    }
    #[doc = "Line Enable"]
    pub struct LNEN {
        register: VolatileCell<u32>,
    }
    #[doc = "Line Enable"]
    pub mod lnen {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LNEN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `LN0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN0R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN0R::VALUE1 => false,
                    LN0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN0R {
                match value {
                    false => LN0R::VALUE1,
                    true => LN0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN1R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN1R::VALUE1 => false,
                    LN1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN1R {
                match value {
                    false => LN1R::VALUE1,
                    true => LN1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN2R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN2R::VALUE1 => false,
                    LN2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN2R {
                match value {
                    false => LN2R::VALUE1,
                    true => LN2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN3R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN3R::VALUE1 => false,
                    LN3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN3R {
                match value {
                    false => LN3R::VALUE1,
                    true => LN3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN4R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN4R::VALUE1 => false,
                    LN4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN4R {
                match value {
                    false => LN4R::VALUE1,
                    true => LN4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN5R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN5R::VALUE1 => false,
                    LN5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN5R {
                match value {
                    false => LN5R::VALUE1,
                    true => LN5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN6R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN6R::VALUE1 => false,
                    LN6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN6R {
                match value {
                    false => LN6R::VALUE1,
                    true => LN6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LN7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LN7R {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LN7R::VALUE1 => false,
                    LN7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LN7R {
                match value {
                    false => LN7R::VALUE1,
                    true => LN7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LN7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LN7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `LN0`"]
        pub enum LN0W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN0W::VALUE1 => false,
                    LN0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN0W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN1`"]
        pub enum LN1W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN1W::VALUE1 => false,
                    LN1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN1W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN2`"]
        pub enum LN2W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN2W::VALUE1 => false,
                    LN2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN2W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN3`"]
        pub enum LN3W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN3W::VALUE1 => false,
                    LN3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN3W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN4`"]
        pub enum LN4W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN4W::VALUE1 => false,
                    LN4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN4W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN5`"]
        pub enum LN5W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN5W::VALUE1 => false,
                    LN5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN5W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN6`"]
        pub enum LN6W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN6W::VALUE1 => false,
                    LN6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN6W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LN7`"]
        pub enum LN7W {
            #[doc = "Disables the line"]
            VALUE1,
            #[doc = "Enables the line and resets a pending request"]
            VALUE2,
        }
        impl LN7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LN7W::VALUE1 => false,
                    LN7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LN7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LN7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LN7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables the line"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LN7W::VALUE1)
            }
            #[doc = "Enables the line and resets a pending request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LN7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Line 0 Enable"]
            #[inline]
            pub fn ln0(&self) -> LN0R {
                LN0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Line 1 Enable"]
            #[inline]
            pub fn ln1(&self) -> LN1R {
                LN1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Line 2 Enable"]
            #[inline]
            pub fn ln2(&self) -> LN2R {
                LN2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Line 3 Enable"]
            #[inline]
            pub fn ln3(&self) -> LN3R {
                LN3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Line 4 Enable"]
            #[inline]
            pub fn ln4(&self) -> LN4R {
                LN4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Line 5 Enable"]
            #[inline]
            pub fn ln5(&self) -> LN5R {
                LN5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Line 6 Enable"]
            #[inline]
            pub fn ln6(&self) -> LN6R {
                LN6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Line 7 Enable"]
            #[inline]
            pub fn ln7(&self) -> LN7R {
                LN7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Line 0 Enable"]
            #[inline]
            pub fn ln0(&mut self) -> _LN0W {
                _LN0W { w: self }
            }
            #[doc = "Bit 1 - Line 1 Enable"]
            #[inline]
            pub fn ln1(&mut self) -> _LN1W {
                _LN1W { w: self }
            }
            #[doc = "Bit 2 - Line 2 Enable"]
            #[inline]
            pub fn ln2(&mut self) -> _LN2W {
                _LN2W { w: self }
            }
            #[doc = "Bit 3 - Line 3 Enable"]
            #[inline]
            pub fn ln3(&mut self) -> _LN3W {
                _LN3W { w: self }
            }
            #[doc = "Bit 4 - Line 4 Enable"]
            #[inline]
            pub fn ln4(&mut self) -> _LN4W {
                _LN4W { w: self }
            }
            #[doc = "Bit 5 - Line 5 Enable"]
            #[inline]
            pub fn ln5(&mut self) -> _LN5W {
                _LN5W { w: self }
            }
            #[doc = "Bit 6 - Line 6 Enable"]
            #[inline]
            pub fn ln6(&mut self) -> _LN6W {
                _LN6W { w: self }
            }
            #[doc = "Bit 7 - Line 7 Enable"]
            #[inline]
            pub fn ln7(&mut self) -> _LN7W {
                _LN7W { w: self }
            }
        }
    }
}
#[doc = "DMA Line Router"]
pub struct DLR {
    register_block: dlr::RegisterBlock,
}
impl Deref for DLR {
    type Target = dlr::RegisterBlock;
    fn deref(&self) -> &dlr::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Event Request Unit 0"]
pub const ERU0: Peripheral<ERU0> = unsafe { Peripheral::new(0x5000_4800) };
#[doc = "Event Request Unit 0"]
pub mod eru0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Event Input Select"]
        pub exisel: EXISEL,
        _reserved0: [u8; 12usize],
        #[doc = "0x10 - Event Input Control"]
        pub exicon: [EXICON; 4],
        #[doc = "0x20 - Event Output Trigger Control"]
        pub exocon: [EXOCON; 4],
    }
    #[doc = "Event Input Select"]
    pub struct EXISEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Event Input Select"]
    pub mod exisel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EXISEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `EXS0A`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS0AR {
            #[doc = "Input ERU_0A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_0A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_0A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_0A3 is selected"]
            VALUE4,
        }
        impl EXS0AR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS0AR::VALUE1 => 0,
                    EXS0AR::VALUE2 => 0x01,
                    EXS0AR::VALUE3 => 0x02,
                    EXS0AR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS0AR {
                match value {
                    0 => EXS0AR::VALUE1,
                    1 => EXS0AR::VALUE2,
                    2 => EXS0AR::VALUE3,
                    3 => EXS0AR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS0AR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS0AR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS0AR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS0AR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS0B`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS0BR {
            #[doc = "Input ERU_0B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_0B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_0B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_0B3 is selected"]
            VALUE4,
        }
        impl EXS0BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS0BR::VALUE1 => 0,
                    EXS0BR::VALUE2 => 0x01,
                    EXS0BR::VALUE3 => 0x02,
                    EXS0BR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS0BR {
                match value {
                    0 => EXS0BR::VALUE1,
                    1 => EXS0BR::VALUE2,
                    2 => EXS0BR::VALUE3,
                    3 => EXS0BR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS0BR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS0BR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS0BR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS0BR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS1A`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS1AR {
            #[doc = "Input ERU_1A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_1A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_1A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_1A3 is selected"]
            VALUE4,
        }
        impl EXS1AR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS1AR::VALUE1 => 0,
                    EXS1AR::VALUE2 => 0x01,
                    EXS1AR::VALUE3 => 0x02,
                    EXS1AR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS1AR {
                match value {
                    0 => EXS1AR::VALUE1,
                    1 => EXS1AR::VALUE2,
                    2 => EXS1AR::VALUE3,
                    3 => EXS1AR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS1AR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS1AR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS1AR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS1AR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS1B`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS1BR {
            #[doc = "Input ERU_1B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_1B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_1B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_1B3 is selected"]
            VALUE4,
        }
        impl EXS1BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS1BR::VALUE1 => 0,
                    EXS1BR::VALUE2 => 0x01,
                    EXS1BR::VALUE3 => 0x02,
                    EXS1BR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS1BR {
                match value {
                    0 => EXS1BR::VALUE1,
                    1 => EXS1BR::VALUE2,
                    2 => EXS1BR::VALUE3,
                    3 => EXS1BR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS1BR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS1BR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS1BR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS1BR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS2A`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS2AR {
            #[doc = "Input ERU_2A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_2A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_2A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_2A3 is selected"]
            VALUE4,
        }
        impl EXS2AR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS2AR::VALUE1 => 0,
                    EXS2AR::VALUE2 => 0x01,
                    EXS2AR::VALUE3 => 0x02,
                    EXS2AR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS2AR {
                match value {
                    0 => EXS2AR::VALUE1,
                    1 => EXS2AR::VALUE2,
                    2 => EXS2AR::VALUE3,
                    3 => EXS2AR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS2AR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS2AR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS2AR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS2AR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS2B`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS2BR {
            #[doc = "Input ERU_2B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_2B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_2B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_2B3 is selected"]
            VALUE4,
        }
        impl EXS2BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS2BR::VALUE1 => 0,
                    EXS2BR::VALUE2 => 0x01,
                    EXS2BR::VALUE3 => 0x02,
                    EXS2BR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS2BR {
                match value {
                    0 => EXS2BR::VALUE1,
                    1 => EXS2BR::VALUE2,
                    2 => EXS2BR::VALUE3,
                    3 => EXS2BR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS2BR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS2BR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS2BR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS2BR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS3A`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS3AR {
            #[doc = "Input ERU_3A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_3A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_3A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_3A3 is selected"]
            VALUE4,
        }
        impl EXS3AR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS3AR::VALUE1 => 0,
                    EXS3AR::VALUE2 => 0x01,
                    EXS3AR::VALUE3 => 0x02,
                    EXS3AR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS3AR {
                match value {
                    0 => EXS3AR::VALUE1,
                    1 => EXS3AR::VALUE2,
                    2 => EXS3AR::VALUE3,
                    3 => EXS3AR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS3AR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS3AR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS3AR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS3AR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EXS3B`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXS3BR {
            #[doc = "Input ERU_3B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_3B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_3B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_3B3 is selected"]
            VALUE4,
        }
        impl EXS3BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EXS3BR::VALUE1 => 0,
                    EXS3BR::VALUE2 => 0x01,
                    EXS3BR::VALUE3 => 0x02,
                    EXS3BR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EXS3BR {
                match value {
                    0 => EXS3BR::VALUE1,
                    1 => EXS3BR::VALUE2,
                    2 => EXS3BR::VALUE3,
                    3 => EXS3BR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXS3BR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXS3BR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EXS3BR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EXS3BR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `EXS0A`"]
        pub enum EXS0AW {
            #[doc = "Input ERU_0A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_0A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_0A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_0A3 is selected"]
            VALUE4,
        }
        impl EXS0AW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS0AW::VALUE1 => 0,
                    EXS0AW::VALUE2 => 1,
                    EXS0AW::VALUE3 => 2,
                    EXS0AW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS0AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS0AW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS0AW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_0A0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS0AW::VALUE1)
            }
            #[doc = "Input ERU_0A1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS0AW::VALUE2)
            }
            #[doc = "Input ERU_0A2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS0AW::VALUE3)
            }
            #[doc = "Input ERU_0A3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS0AW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS0B`"]
        pub enum EXS0BW {
            #[doc = "Input ERU_0B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_0B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_0B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_0B3 is selected"]
            VALUE4,
        }
        impl EXS0BW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS0BW::VALUE1 => 0,
                    EXS0BW::VALUE2 => 1,
                    EXS0BW::VALUE3 => 2,
                    EXS0BW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS0BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS0BW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS0BW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_0B0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS0BW::VALUE1)
            }
            #[doc = "Input ERU_0B1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS0BW::VALUE2)
            }
            #[doc = "Input ERU_0B2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS0BW::VALUE3)
            }
            #[doc = "Input ERU_0B3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS0BW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS1A`"]
        pub enum EXS1AW {
            #[doc = "Input ERU_1A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_1A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_1A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_1A3 is selected"]
            VALUE4,
        }
        impl EXS1AW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS1AW::VALUE1 => 0,
                    EXS1AW::VALUE2 => 1,
                    EXS1AW::VALUE3 => 2,
                    EXS1AW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS1AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS1AW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS1AW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_1A0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS1AW::VALUE1)
            }
            #[doc = "Input ERU_1A1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS1AW::VALUE2)
            }
            #[doc = "Input ERU_1A2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS1AW::VALUE3)
            }
            #[doc = "Input ERU_1A3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS1AW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS1B`"]
        pub enum EXS1BW {
            #[doc = "Input ERU_1B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_1B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_1B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_1B3 is selected"]
            VALUE4,
        }
        impl EXS1BW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS1BW::VALUE1 => 0,
                    EXS1BW::VALUE2 => 1,
                    EXS1BW::VALUE3 => 2,
                    EXS1BW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS1BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS1BW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS1BW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_1B0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS1BW::VALUE1)
            }
            #[doc = "Input ERU_1B1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS1BW::VALUE2)
            }
            #[doc = "Input ERU_1B2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS1BW::VALUE3)
            }
            #[doc = "Input ERU_1B3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS1BW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS2A`"]
        pub enum EXS2AW {
            #[doc = "Input ERU_2A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_2A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_2A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_2A3 is selected"]
            VALUE4,
        }
        impl EXS2AW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS2AW::VALUE1 => 0,
                    EXS2AW::VALUE2 => 1,
                    EXS2AW::VALUE3 => 2,
                    EXS2AW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS2AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS2AW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS2AW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_2A0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS2AW::VALUE1)
            }
            #[doc = "Input ERU_2A1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS2AW::VALUE2)
            }
            #[doc = "Input ERU_2A2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS2AW::VALUE3)
            }
            #[doc = "Input ERU_2A3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS2AW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS2B`"]
        pub enum EXS2BW {
            #[doc = "Input ERU_2B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_2B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_2B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_2B3 is selected"]
            VALUE4,
        }
        impl EXS2BW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS2BW::VALUE1 => 0,
                    EXS2BW::VALUE2 => 1,
                    EXS2BW::VALUE3 => 2,
                    EXS2BW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS2BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS2BW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS2BW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_2B0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS2BW::VALUE1)
            }
            #[doc = "Input ERU_2B1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS2BW::VALUE2)
            }
            #[doc = "Input ERU_2B2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS2BW::VALUE3)
            }
            #[doc = "Input ERU_2B3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS2BW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS3A`"]
        pub enum EXS3AW {
            #[doc = "Input ERU_3A0 is selected"]
            VALUE1,
            #[doc = "Input ERU_3A1 is selected"]
            VALUE2,
            #[doc = "Input ERU_3A2 is selected"]
            VALUE3,
            #[doc = "Input ERU_3A3 is selected"]
            VALUE4,
        }
        impl EXS3AW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS3AW::VALUE1 => 0,
                    EXS3AW::VALUE2 => 1,
                    EXS3AW::VALUE3 => 2,
                    EXS3AW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS3AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS3AW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS3AW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_3A0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS3AW::VALUE1)
            }
            #[doc = "Input ERU_3A1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS3AW::VALUE2)
            }
            #[doc = "Input ERU_3A2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS3AW::VALUE3)
            }
            #[doc = "Input ERU_3A3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS3AW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXS3B`"]
        pub enum EXS3BW {
            #[doc = "Input ERU_3B0 is selected"]
            VALUE1,
            #[doc = "Input ERU_3B1 is selected"]
            VALUE2,
            #[doc = "Input ERU_3B2 is selected"]
            VALUE3,
            #[doc = "Input ERU_3B3 is selected"]
            VALUE4,
        }
        impl EXS3BW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EXS3BW::VALUE1 => 0,
                    EXS3BW::VALUE2 => 1,
                    EXS3BW::VALUE3 => 2,
                    EXS3BW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXS3BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXS3BW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXS3BW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input ERU_3B0 is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXS3BW::VALUE1)
            }
            #[doc = "Input ERU_3B1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXS3BW::VALUE2)
            }
            #[doc = "Input ERU_3B2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EXS3BW::VALUE3)
            }
            #[doc = "Input ERU_3B3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EXS3BW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Event Source Select for A0 (ERS0)"]
            #[inline]
            pub fn exs0a(&self) -> EXS0AR {
                EXS0AR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Event Source Select for B0 (ERS0)"]
            #[inline]
            pub fn exs0b(&self) -> EXS0BR {
                EXS0BR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Event Source Select for A1 (ERS1)"]
            #[inline]
            pub fn exs1a(&self) -> EXS1AR {
                EXS1AR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Event Source Select for B1 (ERS1)"]
            #[inline]
            pub fn exs1b(&self) -> EXS1BR {
                EXS1BR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Event Source Select for A2 (ERS2)"]
            #[inline]
            pub fn exs2a(&self) -> EXS2AR {
                EXS2AR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Event Source Select for B2 (ERS2)"]
            #[inline]
            pub fn exs2b(&self) -> EXS2BR {
                EXS2BR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Event Source Select for A3 (ERS3)"]
            #[inline]
            pub fn exs3a(&self) -> EXS3AR {
                EXS3AR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Event Source Select for B3 (ERS3)"]
            #[inline]
            pub fn exs3b(&self) -> EXS3BR {
                EXS3BR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Event Source Select for A0 (ERS0)"]
            #[inline]
            pub fn exs0a(&mut self) -> _EXS0AW {
                _EXS0AW { w: self }
            }
            #[doc = "Bits 2:3 - Event Source Select for B0 (ERS0)"]
            #[inline]
            pub fn exs0b(&mut self) -> _EXS0BW {
                _EXS0BW { w: self }
            }
            #[doc = "Bits 4:5 - Event Source Select for A1 (ERS1)"]
            #[inline]
            pub fn exs1a(&mut self) -> _EXS1AW {
                _EXS1AW { w: self }
            }
            #[doc = "Bits 6:7 - Event Source Select for B1 (ERS1)"]
            #[inline]
            pub fn exs1b(&mut self) -> _EXS1BW {
                _EXS1BW { w: self }
            }
            #[doc = "Bits 8:9 - Event Source Select for A2 (ERS2)"]
            #[inline]
            pub fn exs2a(&mut self) -> _EXS2AW {
                _EXS2AW { w: self }
            }
            #[doc = "Bits 10:11 - Event Source Select for B2 (ERS2)"]
            #[inline]
            pub fn exs2b(&mut self) -> _EXS2BW {
                _EXS2BW { w: self }
            }
            #[doc = "Bits 12:13 - Event Source Select for A3 (ERS3)"]
            #[inline]
            pub fn exs3a(&mut self) -> _EXS3AW {
                _EXS3AW { w: self }
            }
            #[doc = "Bits 14:15 - Event Source Select for B3 (ERS3)"]
            #[inline]
            pub fn exs3b(&mut self) -> _EXS3BW {
                _EXS3BW { w: self }
            }
        }
    }
    #[doc = "Event Input Control"]
    pub struct EXICON {
        register: VolatileCell<u32>,
    }
    #[doc = "Event Input Control"]
    pub mod exicon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EXICON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PER {
            #[doc = "The trigger pulse generation is disabled"]
            VALUE1,
            #[doc = "The trigger pulse generation is enabled"]
            VALUE2,
        }
        impl PER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PER::VALUE1 => false,
                    PER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PER {
                match value {
                    false => PER::VALUE1,
                    true => PER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PER::VALUE2
            }
        }
        #[doc = "Possible values of the field `LD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LDR {
            #[doc = "The status flag FL is not cleared by hardware and is used as \"sticky\" bit. Once set, it is not influenced by any edge until it becomes cleared by software."]
            VALUE1,
            #[doc = "The status flag FL rebuilds a level detection of the desired event. It becomes automatically set with a rising edge if RE = 1 or with a falling edge if FE = 1. It becomes automatically cleared with a rising edge if RE = 0 or with a falling edge if FE = 0."]
            VALUE2,
        }
        impl LDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LDR::VALUE1 => false,
                    LDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LDR {
                match value {
                    false => LDR::VALUE1,
                    true => LDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RER {
            #[doc = "A rising edge is not considered as edge event"]
            VALUE1,
            #[doc = "A rising edge is considered as edge event"]
            VALUE2,
        }
        impl RER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RER::VALUE1 => false,
                    RER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RER {
                match value {
                    false => RER::VALUE1,
                    true => RER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RER::VALUE2
            }
        }
        #[doc = "Possible values of the field `FE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FER {
            #[doc = "A falling edge is not considered as edge event"]
            VALUE1,
            #[doc = "A falling edge is considered as edge event"]
            VALUE2,
        }
        impl FER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FER::VALUE1 => false,
                    FER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FER {
                match value {
                    false => FER::VALUE1,
                    true => FER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FER::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCSR {
            #[doc = "Trigger pulses are sent to OGU0"]
            VALUE1,
            #[doc = "Trigger pulses are sent to OGU1"]
            VALUE2,
            #[doc = "Trigger pulses are sent to OGU2"]
            VALUE3,
            #[doc = "Trigger pulses are sent to OGU3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl OCSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    OCSR::VALUE1 => 0,
                    OCSR::VALUE2 => 0x01,
                    OCSR::VALUE3 => 0x02,
                    OCSR::VALUE4 => 0x03,
                    OCSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> OCSR {
                match value {
                    0 => OCSR::VALUE1,
                    1 => OCSR::VALUE2,
                    2 => OCSR::VALUE3,
                    3 => OCSR::VALUE4,
                    i => OCSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == OCSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == OCSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `FL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FLR {
            #[doc = "The enabled edge event has not been detected"]
            VALUE1,
            #[doc = "The enabled edge event has been detected"]
            VALUE2,
        }
        impl FLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FLR::VALUE1 => false,
                    FLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FLR {
                match value {
                    false => FLR::VALUE1,
                    true => FLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SSR {
            #[doc = "Input A without additional combination"]
            VALUE1,
            #[doc = "Input B without additional combination"]
            VALUE2,
            #[doc = "Input A OR input B"]
            VALUE3,
            #[doc = "Input A AND input B"]
            VALUE4,
        }
        impl SSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SSR::VALUE1 => 0,
                    SSR::VALUE2 => 0x01,
                    SSR::VALUE3 => 0x02,
                    SSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SSR {
                match value {
                    0 => SSR::VALUE1,
                    1 => SSR::VALUE2,
                    2 => SSR::VALUE3,
                    3 => SSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `NA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAR {
            #[doc = "Input A is used directly"]
            VALUE1,
            #[doc = "Input A is inverted"]
            VALUE2,
        }
        impl NAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAR::VALUE1 => false,
                    NAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAR {
                match value {
                    false => NAR::VALUE1,
                    true => NAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NBR {
            #[doc = "Input B is used directly"]
            VALUE1,
            #[doc = "Input B is inverted"]
            VALUE2,
        }
        impl NBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NBR::VALUE1 => false,
                    NBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NBR {
                match value {
                    false => NBR::VALUE1,
                    true => NBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PE`"]
        pub enum PEW {
            #[doc = "The trigger pulse generation is disabled"]
            VALUE1,
            #[doc = "The trigger pulse generation is enabled"]
            VALUE2,
        }
        impl PEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEW::VALUE1 => false,
                    PEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The trigger pulse generation is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEW::VALUE1)
            }
            #[doc = "The trigger pulse generation is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LD`"]
        pub enum LDW {
            #[doc = "The status flag FL is not cleared by hardware and is used as \"sticky\" bit. Once set, it is not influenced by any edge until it becomes cleared by software."]
            VALUE1,
            #[doc = "The status flag FL rebuilds a level detection of the desired event. It becomes automatically set with a rising edge if RE = 1 or with a falling edge if FE = 1. It becomes automatically cleared with a rising edge if RE = 0 or with a falling edge if FE = 0."]
            VALUE2,
        }
        impl LDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LDW::VALUE1 => false,
                    LDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The status flag FL is not cleared by hardware and is used as \"sticky\" bit. Once set, it is not influenced by any edge until it becomes cleared by software."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LDW::VALUE1)
            }
            #[doc = "The status flag FL rebuilds a level detection of the desired event. It becomes automatically set with a rising edge if RE = 1 or with a falling edge if FE = 1. It becomes automatically cleared with a rising edge if RE = 0 or with a falling edge if FE = 0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RE`"]
        pub enum REW {
            #[doc = "A rising edge is not considered as edge event"]
            VALUE1,
            #[doc = "A rising edge is considered as edge event"]
            VALUE2,
        }
        impl REW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REW::VALUE1 => false,
                    REW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A rising edge is not considered as edge event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REW::VALUE1)
            }
            #[doc = "A rising edge is considered as edge event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FE`"]
        pub enum FEW {
            #[doc = "A falling edge is not considered as edge event"]
            VALUE1,
            #[doc = "A falling edge is considered as edge event"]
            VALUE2,
        }
        impl FEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FEW::VALUE1 => false,
                    FEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A falling edge is not considered as edge event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FEW::VALUE1)
            }
            #[doc = "A falling edge is considered as edge event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS`"]
        pub enum OCSW {
            #[doc = "Trigger pulses are sent to OGU0"]
            VALUE1,
            #[doc = "Trigger pulses are sent to OGU1"]
            VALUE2,
            #[doc = "Trigger pulses are sent to OGU2"]
            VALUE3,
            #[doc = "Trigger pulses are sent to OGU3"]
            VALUE4,
        }
        impl OCSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OCSW::VALUE1 => 0,
                    OCSW::VALUE2 => 1,
                    OCSW::VALUE3 => 2,
                    OCSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Trigger pulses are sent to OGU0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCSW::VALUE1)
            }
            #[doc = "Trigger pulses are sent to OGU1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCSW::VALUE2)
            }
            #[doc = "Trigger pulses are sent to OGU2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(OCSW::VALUE3)
            }
            #[doc = "Trigger pulses are sent to OGU3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(OCSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FL`"]
        pub enum FLW {
            #[doc = "The enabled edge event has not been detected"]
            VALUE1,
            #[doc = "The enabled edge event has been detected"]
            VALUE2,
        }
        impl FLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLW::VALUE1 => false,
                    FLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The enabled edge event has not been detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLW::VALUE1)
            }
            #[doc = "The enabled edge event has been detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SS`"]
        pub enum SSW {
            #[doc = "Input A without additional combination"]
            VALUE1,
            #[doc = "Input B without additional combination"]
            VALUE2,
            #[doc = "Input A OR input B"]
            VALUE3,
            #[doc = "Input A AND input B"]
            VALUE4,
        }
        impl SSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SSW::VALUE1 => 0,
                    SSW::VALUE2 => 1,
                    SSW::VALUE3 => 2,
                    SSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Input A without additional combination"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SSW::VALUE1)
            }
            #[doc = "Input B without additional combination"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SSW::VALUE2)
            }
            #[doc = "Input A OR input B"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SSW::VALUE3)
            }
            #[doc = "Input A AND input B"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NA`"]
        pub enum NAW {
            #[doc = "Input A is used directly"]
            VALUE1,
            #[doc = "Input A is inverted"]
            VALUE2,
        }
        impl NAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NAW::VALUE1 => false,
                    NAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Input A is used directly"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NAW::VALUE1)
            }
            #[doc = "Input A is inverted"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NB`"]
        pub enum NBW {
            #[doc = "Input B is used directly"]
            VALUE1,
            #[doc = "Input B is inverted"]
            VALUE2,
        }
        impl NBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NBW::VALUE1 => false,
                    NBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Input B is used directly"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NBW::VALUE1)
            }
            #[doc = "Input B is inverted"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Output Trigger Pulse Enable for ETLx"]
            #[inline]
            pub fn pe(&self) -> PER {
                PER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Rebuild Level Detection for Status Flag for ETLx"]
            #[inline]
            pub fn ld(&self) -> LDR {
                LDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Rising Edge Detection Enable ETLx"]
            #[inline]
            pub fn re(&self) -> RER {
                RER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Falling Edge Detection Enable ETLx"]
            #[inline]
            pub fn fe(&self) -> FER {
                FER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:6 - Output Channel Select for ETLx Output Trigger Pulse"]
            #[inline]
            pub fn ocs(&self) -> OCSR {
                OCSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 7 - Status Flag for ETLx"]
            #[inline]
            pub fn fl(&self) -> FLR {
                FLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 8:9 - Input Source Select for ERSx"]
            #[inline]
            pub fn ss(&self) -> SSR {
                SSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Input A Negation Select for ERSx"]
            #[inline]
            pub fn na(&self) -> NAR {
                NAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Input B Negation Select for ERSx"]
            #[inline]
            pub fn nb(&self) -> NBR {
                NBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Output Trigger Pulse Enable for ETLx"]
            #[inline]
            pub fn pe(&mut self) -> _PEW {
                _PEW { w: self }
            }
            #[doc = "Bit 1 - Rebuild Level Detection for Status Flag for ETLx"]
            #[inline]
            pub fn ld(&mut self) -> _LDW {
                _LDW { w: self }
            }
            #[doc = "Bit 2 - Rising Edge Detection Enable ETLx"]
            #[inline]
            pub fn re(&mut self) -> _REW {
                _REW { w: self }
            }
            #[doc = "Bit 3 - Falling Edge Detection Enable ETLx"]
            #[inline]
            pub fn fe(&mut self) -> _FEW {
                _FEW { w: self }
            }
            #[doc = "Bits 4:6 - Output Channel Select for ETLx Output Trigger Pulse"]
            #[inline]
            pub fn ocs(&mut self) -> _OCSW {
                _OCSW { w: self }
            }
            #[doc = "Bit 7 - Status Flag for ETLx"]
            #[inline]
            pub fn fl(&mut self) -> _FLW {
                _FLW { w: self }
            }
            #[doc = "Bits 8:9 - Input Source Select for ERSx"]
            #[inline]
            pub fn ss(&mut self) -> _SSW {
                _SSW { w: self }
            }
            #[doc = "Bit 10 - Input A Negation Select for ERSx"]
            #[inline]
            pub fn na(&mut self) -> _NAW {
                _NAW { w: self }
            }
            #[doc = "Bit 11 - Input B Negation Select for ERSx"]
            #[inline]
            pub fn nb(&mut self) -> _NBW {
                _NBW { w: self }
            }
        }
    }
    #[doc = "Event Output Trigger Control"]
    pub struct EXOCON {
        register: VolatileCell<u32>,
    }
    #[doc = "Event Output Trigger Control"]
    pub mod exocon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EXOCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ISS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ISSR {
            #[doc = "The peripheral trigger function is disabled"]
            VALUE1,
            #[doc = "Input ERU_OGUy1 is selected"]
            VALUE2,
            #[doc = "Input ERU_OGUy2 is selected"]
            VALUE3,
            #[doc = "Input ERU_OGUy3 is selected"]
            VALUE4,
        }
        impl ISSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ISSR::VALUE1 => 0,
                    ISSR::VALUE2 => 0x01,
                    ISSR::VALUE3 => 0x02,
                    ISSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ISSR {
                match value {
                    0 => ISSR::VALUE1,
                    1 => ISSR::VALUE2,
                    2 => ISSR::VALUE3,
                    3 => ISSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ISSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ISSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ISSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ISSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `GEEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GEENR {
            #[doc = "The event detection is disabled"]
            VALUE1,
            #[doc = "The event detection is enabled"]
            VALUE2,
        }
        impl GEENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GEENR::VALUE1 => false,
                    GEENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GEENR {
                match value {
                    false => GEENR::VALUE1,
                    true => GEENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GEENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GEENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDRR {
            #[doc = "A pattern miss is detected"]
            VALUE1,
            #[doc = "A pattern match is detected"]
            VALUE2,
        }
        impl PDRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDRR::VALUE1 => false,
                    PDRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDRR {
                match value {
                    false => PDRR::VALUE1,
                    true => PDRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `GP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GPR {
            #[doc = "ERU_GOUTy is always disabled and ERU_IOUTy can not be activated"]
            VALUE1,
            #[doc = "ERU_GOUTy is always enabled and ERU_IOUTy becomes activated with each activation of ERU_TOUTy"]
            VALUE2,
            #[doc = "ERU_GOUTy is equal to ERU_PDOUTy and ERU_IOUTy becomes activated with an activation of ERU_TOUTy while the desired pattern is detected (pattern match PDR = 1)"]
            VALUE3,
            #[doc = "ERU_GOUTy is inverted to ERU_PDOUTy and ERU_IOUTy becomes activated with an activation of ERU_TOUTy while the desired pattern is not detected (pattern miss PDR = 0)"]
            VALUE4,
        }
        impl GPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    GPR::VALUE1 => 0,
                    GPR::VALUE2 => 0x01,
                    GPR::VALUE3 => 0x02,
                    GPR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> GPR {
                match value {
                    0 => GPR::VALUE1,
                    1 => GPR::VALUE2,
                    2 => GPR::VALUE3,
                    3 => GPR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == GPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == GPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `IPEN0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IPEN0R {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IPEN0R::VALUE1 => false,
                    IPEN0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IPEN0R {
                match value {
                    false => IPEN0R::VALUE1,
                    true => IPEN0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IPEN0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IPEN0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `IPEN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IPEN1R {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IPEN1R::VALUE1 => false,
                    IPEN1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IPEN1R {
                match value {
                    false => IPEN1R::VALUE1,
                    true => IPEN1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IPEN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IPEN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `IPEN2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IPEN2R {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IPEN2R::VALUE1 => false,
                    IPEN2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IPEN2R {
                match value {
                    false => IPEN2R::VALUE1,
                    true => IPEN2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IPEN2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IPEN2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `IPEN3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IPEN3R {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IPEN3R::VALUE1 => false,
                    IPEN3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IPEN3R {
                match value {
                    false => IPEN3R::VALUE1,
                    true => IPEN3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IPEN3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IPEN3R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ISS`"]
        pub enum ISSW {
            #[doc = "The peripheral trigger function is disabled"]
            VALUE1,
            #[doc = "Input ERU_OGUy1 is selected"]
            VALUE2,
            #[doc = "Input ERU_OGUy2 is selected"]
            VALUE3,
            #[doc = "Input ERU_OGUy3 is selected"]
            VALUE4,
        }
        impl ISSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ISSW::VALUE1 => 0,
                    ISSW::VALUE2 => 1,
                    ISSW::VALUE3 => 2,
                    ISSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ISSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ISSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ISSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The peripheral trigger function is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ISSW::VALUE1)
            }
            #[doc = "Input ERU_OGUy1 is selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ISSW::VALUE2)
            }
            #[doc = "Input ERU_OGUy2 is selected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ISSW::VALUE3)
            }
            #[doc = "Input ERU_OGUy3 is selected"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ISSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GEEN`"]
        pub enum GEENW {
            #[doc = "The event detection is disabled"]
            VALUE1,
            #[doc = "The event detection is enabled"]
            VALUE2,
        }
        impl GEENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GEENW::VALUE1 => false,
                    GEENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GEENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GEENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GEENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The event detection is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GEENW::VALUE1)
            }
            #[doc = "The event detection is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GEENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GP`"]
        pub enum GPW {
            #[doc = "ERU_GOUTy is always disabled and ERU_IOUTy can not be activated"]
            VALUE1,
            #[doc = "ERU_GOUTy is always enabled and ERU_IOUTy becomes activated with each activation of ERU_TOUTy"]
            VALUE2,
            #[doc = "ERU_GOUTy is equal to ERU_PDOUTy and ERU_IOUTy becomes activated with an activation of ERU_TOUTy while the desired pattern is detected (pattern match PDR = 1)"]
            VALUE3,
            #[doc = "ERU_GOUTy is inverted to ERU_PDOUTy and ERU_IOUTy becomes activated with an activation of ERU_TOUTy while the desired pattern is not detected (pattern miss PDR = 0)"]
            VALUE4,
        }
        impl GPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GPW::VALUE1 => 0,
                    GPW::VALUE2 => 1,
                    GPW::VALUE3 => 2,
                    GPW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GPW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "ERU_GOUTy is always disabled and ERU_IOUTy can not be activated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GPW::VALUE1)
            }
            #[doc = "ERU_GOUTy is always enabled and ERU_IOUTy becomes activated with each activation of ERU_TOUTy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GPW::VALUE2)
            }
            #[doc = "ERU_GOUTy is equal to ERU_PDOUTy and ERU_IOUTy becomes activated with an activation of ERU_TOUTy while the desired pattern is detected (pattern match PDR = 1)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(GPW::VALUE3)
            }
            #[doc = "ERU_GOUTy is inverted to ERU_PDOUTy and ERU_IOUTy becomes activated with an activation of ERU_TOUTy while the desired pattern is not detected (pattern miss PDR = 0)"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(GPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IPEN0`"]
        pub enum IPEN0W {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IPEN0W::VALUE1 => false,
                    IPEN0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IPEN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _IPEN0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IPEN0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IPEN0W::VALUE1)
            }
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IPEN0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IPEN1`"]
        pub enum IPEN1W {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IPEN1W::VALUE1 => false,
                    IPEN1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IPEN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _IPEN1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IPEN1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IPEN1W::VALUE1)
            }
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IPEN1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IPEN2`"]
        pub enum IPEN2W {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IPEN2W::VALUE1 => false,
                    IPEN2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IPEN2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _IPEN2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IPEN2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IPEN2W::VALUE1)
            }
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IPEN2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IPEN3`"]
        pub enum IPEN3W {
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            VALUE1,
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            VALUE2,
        }
        impl IPEN3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IPEN3W::VALUE1 => false,
                    IPEN3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IPEN3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _IPEN3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IPEN3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flag EXICONx.FL is excluded from the pattern detection"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IPEN3W::VALUE1)
            }
            #[doc = "Flag EXICONx.FL is included in the pattern detection"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IPEN3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Internal Trigger Source Selection"]
            #[inline]
            pub fn iss(&self) -> ISSR {
                ISSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - Gating Event Enable"]
            #[inline]
            pub fn geen(&self) -> GEENR {
                GEENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Pattern Detection Result Flag"]
            #[inline]
            pub fn pdr(&self) -> PDRR {
                PDRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:5 - Gating Selection for Pattern Detection Result"]
            #[inline]
            pub fn gp(&self) -> GPR {
                GPR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 12 - Pattern Detection Enable for ETL0"]
            #[inline]
            pub fn ipen0(&self) -> IPEN0R {
                IPEN0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Pattern Detection Enable for ETL1"]
            #[inline]
            pub fn ipen1(&self) -> IPEN1R {
                IPEN1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Pattern Detection Enable for ETL2"]
            #[inline]
            pub fn ipen2(&self) -> IPEN2R {
                IPEN2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Pattern Detection Enable for ETL3"]
            #[inline]
            pub fn ipen3(&self) -> IPEN3R {
                IPEN3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x08 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Internal Trigger Source Selection"]
            #[inline]
            pub fn iss(&mut self) -> _ISSW {
                _ISSW { w: self }
            }
            #[doc = "Bit 2 - Gating Event Enable"]
            #[inline]
            pub fn geen(&mut self) -> _GEENW {
                _GEENW { w: self }
            }
            #[doc = "Bits 4:5 - Gating Selection for Pattern Detection Result"]
            #[inline]
            pub fn gp(&mut self) -> _GPW {
                _GPW { w: self }
            }
            #[doc = "Bit 12 - Pattern Detection Enable for ETL0"]
            #[inline]
            pub fn ipen0(&mut self) -> _IPEN0W {
                _IPEN0W { w: self }
            }
            #[doc = "Bit 13 - Pattern Detection Enable for ETL1"]
            #[inline]
            pub fn ipen1(&mut self) -> _IPEN1W {
                _IPEN1W { w: self }
            }
            #[doc = "Bit 14 - Pattern Detection Enable for ETL2"]
            #[inline]
            pub fn ipen2(&mut self) -> _IPEN2W {
                _IPEN2W { w: self }
            }
            #[doc = "Bit 15 - Pattern Detection Enable for ETL3"]
            #[inline]
            pub fn ipen3(&mut self) -> _IPEN3W {
                _IPEN3W { w: self }
            }
        }
    }
}
#[doc = "Event Request Unit 0"]
pub struct ERU0 {
    register_block: eru0::RegisterBlock,
}
impl Deref for ERU0 {
    type Target = eru0::RegisterBlock;
    fn deref(&self) -> &eru0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Event Request Unit 1"]
pub const ERU1: Peripheral<ERU1> = unsafe { Peripheral::new(0x4004_4000) };
#[doc = r" Register block"]
pub struct ERU1 {
    register_block: eru0::RegisterBlock,
}
impl Deref for ERU1 {
    type Target = eru0::RegisterBlock;
    fn deref(&self) -> &eru0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0: Peripheral<GPDMA0> = unsafe { Peripheral::new(0x5001_42c0) };
#[doc = "General Purpose DMA Unit 0"]
pub mod gpdma0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Raw IntTfr Status"]
        pub rawtfr: RAWTFR,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Raw IntBlock Status"]
        pub rawblock: RAWBLOCK,
        _reserved1: [u8; 4usize],
        #[doc = "0x10 - Raw IntSrcTran Status"]
        pub rawsrctran: RAWSRCTRAN,
        _reserved2: [u8; 4usize],
        #[doc = "0x18 - Raw IntBlock Status"]
        pub rawdsttran: RAWDSTTRAN,
        _reserved3: [u8; 4usize],
        #[doc = "0x20 - Raw IntErr Status"]
        pub rawerr: RAWERR,
        _reserved4: [u8; 4usize],
        #[doc = "0x28 - IntTfr Status"]
        pub statustfr: STATUSTFR,
        _reserved5: [u8; 4usize],
        #[doc = "0x30 - IntBlock Status"]
        pub statusblock: STATUSBLOCK,
        _reserved6: [u8; 4usize],
        #[doc = "0x38 - IntSrcTran Status"]
        pub statussrctran: STATUSSRCTRAN,
        _reserved7: [u8; 4usize],
        #[doc = "0x40 - IntBlock Status"]
        pub statusdsttran: STATUSDSTTRAN,
        _reserved8: [u8; 4usize],
        #[doc = "0x48 - IntErr Status"]
        pub statuserr: STATUSERR,
        _reserved9: [u8; 4usize],
        #[doc = "0x50 - Mask for Raw IntTfr Status"]
        pub masktfr: MASKTFR,
        _reserved10: [u8; 4usize],
        #[doc = "0x58 - Mask for Raw IntBlock Status"]
        pub maskblock: MASKBLOCK,
        _reserved11: [u8; 4usize],
        #[doc = "0x60 - Mask for Raw IntSrcTran Status"]
        pub masksrctran: MASKSRCTRAN,
        _reserved12: [u8; 4usize],
        #[doc = "0x68 - Mask for Raw IntBlock Status"]
        pub maskdsttran: MASKDSTTRAN,
        _reserved13: [u8; 4usize],
        #[doc = "0x70 - Mask for Raw IntErr Status"]
        pub maskerr: MASKERR,
        _reserved14: [u8; 4usize],
        #[doc = "0x78 - IntTfr Status"]
        pub cleartfr: CLEARTFR,
        _reserved15: [u8; 4usize],
        #[doc = "0x80 - IntBlock Status"]
        pub clearblock: CLEARBLOCK,
        _reserved16: [u8; 4usize],
        #[doc = "0x88 - IntSrcTran Status"]
        pub clearsrctran: CLEARSRCTRAN,
        _reserved17: [u8; 4usize],
        #[doc = "0x90 - IntBlock Status"]
        pub cleardsttran: CLEARDSTTRAN,
        _reserved18: [u8; 4usize],
        #[doc = "0x98 - IntErr Status"]
        pub clearerr: CLEARERR,
        _reserved19: [u8; 4usize],
        #[doc = "0xa0 - Combined Interrupt Status Register"]
        pub statusint: STATUSINT,
        _reserved20: [u8; 4usize],
        #[doc = "0xa8 - Source Software Transaction Request Register"]
        pub reqsrcreg: REQSRCREG,
        _reserved21: [u8; 4usize],
        #[doc = "0xb0 - Destination Software Transaction Request Register"]
        pub reqdstreg: REQDSTREG,
        _reserved22: [u8; 4usize],
        #[doc = "0xb8 - Single Source Transaction Request Register"]
        pub sglreqsrcreg: SGLREQSRCREG,
        _reserved23: [u8; 4usize],
        #[doc = "0xc0 - Single Destination Transaction Request Register"]
        pub sglreqdstreg: SGLREQDSTREG,
        _reserved24: [u8; 4usize],
        #[doc = "0xc8 - Last Source Transaction Request Register"]
        pub lstsrcreg: LSTSRCREG,
        _reserved25: [u8; 4usize],
        #[doc = "0xd0 - Last Destination Transaction Request Register"]
        pub lstdstreg: LSTDSTREG,
        _reserved26: [u8; 4usize],
        #[doc = "0xd8 - GPDMA Configuration Register"]
        pub dmacfgreg: DMACFGREG,
        _reserved27: [u8; 4usize],
        #[doc = "0xe0 - GPDMA Channel Enable Register"]
        pub chenreg: CHENREG,
        _reserved28: [u8; 4usize],
        #[doc = "0xe8 - GPDMA0 ID Register"]
        pub id: ID,
        _reserved29: [u8; 76usize],
        #[doc = "0x138 - GPDMA Component Type"]
        pub type_: TYPE,
        #[doc = "0x13c - DMA Component Version"]
        pub version: VERSION,
    }
    #[doc = "Raw IntTfr Status"]
    pub struct RAWTFR {
        register: VolatileCell<u32>,
    }
    #[doc = "Raw IntTfr Status"]
    pub mod rawtfr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RAWTFR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Raw IntBlock Status"]
    pub struct RAWBLOCK {
        register: VolatileCell<u32>,
    }
    #[doc = "Raw IntBlock Status"]
    pub mod rawblock {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RAWBLOCK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Raw IntSrcTran Status"]
    pub struct RAWSRCTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "Raw IntSrcTran Status"]
    pub mod rawsrctran {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RAWSRCTRAN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Raw IntBlock Status"]
    pub struct RAWDSTTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "Raw IntBlock Status"]
    pub mod rawdsttran {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RAWDSTTRAN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Raw IntErr Status"]
    pub struct RAWERR {
        register: VolatileCell<u32>,
    }
    #[doc = "Raw IntErr Status"]
    pub mod rawerr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RAWERR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Raw Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Raw Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Raw Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Raw Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Raw Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Raw Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Raw Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Raw Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "IntTfr Status"]
    pub struct STATUSTFR {
        register: VolatileCell<u32>,
    }
    #[doc = "IntTfr Status"]
    pub mod statustfr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STATUSTFR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
    }
    #[doc = "IntBlock Status"]
    pub struct STATUSBLOCK {
        register: VolatileCell<u32>,
    }
    #[doc = "IntBlock Status"]
    pub mod statusblock {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STATUSBLOCK {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
    }
    #[doc = "IntSrcTran Status"]
    pub struct STATUSSRCTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "IntSrcTran Status"]
    pub mod statussrctran {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STATUSSRCTRAN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
    }
    #[doc = "IntBlock Status"]
    pub struct STATUSDSTTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "IntBlock Status"]
    pub mod statusdsttran {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STATUSDSTTRAN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
    }
    #[doc = "IntErr Status"]
    pub struct STATUSERR {
        register: VolatileCell<u32>,
    }
    #[doc = "IntErr Status"]
    pub mod statuserr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STATUSERR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Interrupt Status for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Interrupt Status for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Interrupt Status for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Interrupt Status for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Interrupt Status for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Interrupt Status for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Interrupt Status for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Interrupt Status for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
    }
    #[doc = "Mask for Raw IntTfr Status"]
    pub struct MASKTFR {
        register: VolatileCell<u32>,
    }
    #[doc = "Mask for Raw IntTfr Status"]
    pub mod masktfr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MASKTFR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Write enable for mask bit of channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Write enable for mask bit of channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Write enable for mask bit of channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Write enable for mask bit of channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Write enable for mask bit of channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Write enable for mask bit of channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Write enable for mask bit of channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Write enable for mask bit of channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Mask for Raw IntBlock Status"]
    pub struct MASKBLOCK {
        register: VolatileCell<u32>,
    }
    #[doc = "Mask for Raw IntBlock Status"]
    pub mod maskblock {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MASKBLOCK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Write enable for mask bit of channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Write enable for mask bit of channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Write enable for mask bit of channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Write enable for mask bit of channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Write enable for mask bit of channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Write enable for mask bit of channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Write enable for mask bit of channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Write enable for mask bit of channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Mask for Raw IntSrcTran Status"]
    pub struct MASKSRCTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "Mask for Raw IntSrcTran Status"]
    pub mod masksrctran {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MASKSRCTRAN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Write enable for mask bit of channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Write enable for mask bit of channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Write enable for mask bit of channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Write enable for mask bit of channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Write enable for mask bit of channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Write enable for mask bit of channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Write enable for mask bit of channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Write enable for mask bit of channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Mask for Raw IntBlock Status"]
    pub struct MASKDSTTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "Mask for Raw IntBlock Status"]
    pub mod maskdsttran {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MASKDSTTRAN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Write enable for mask bit of channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Write enable for mask bit of channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Write enable for mask bit of channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Write enable for mask bit of channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Write enable for mask bit of channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Write enable for mask bit of channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Write enable for mask bit of channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Write enable for mask bit of channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Mask for Raw IntErr Status"]
    pub struct MASKERR {
        register: VolatileCell<u32>,
    }
    #[doc = "Mask for Raw IntErr Status"]
    pub mod maskerr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MASKERR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "masked"]
            VALUE1,
            #[doc = "unmasked"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "masked"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "unmasked"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Write enable for mask bit of channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Write enable for mask bit of channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Write enable for mask bit of channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Write enable for mask bit of channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Write enable for mask bit of channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Write enable for mask bit of channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Write enable for mask bit of channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Write enable for mask bit of channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Mask bit for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Mask bit for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Mask bit for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Mask bit for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Mask bit for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Mask bit for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Mask bit for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Mask bit for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "IntTfr Status"]
    pub struct CLEARTFR {
        register: VolatileCell<u32>,
    }
    #[doc = "IntTfr Status"]
    pub mod cleartfr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLEARTFR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Interrupt Status and Raw Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Clear Interrupt Status and Raw Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Clear Interrupt Status and Raw Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Clear Interrupt Status and Raw Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Clear Interrupt Status and Raw Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Clear Interrupt Status and Raw Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Clear Interrupt Status and Raw Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Clear Interrupt Status and Raw Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "IntBlock Status"]
    pub struct CLEARBLOCK {
        register: VolatileCell<u32>,
    }
    #[doc = "IntBlock Status"]
    pub mod clearblock {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLEARBLOCK {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Interrupt Status and Raw Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Clear Interrupt Status and Raw Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Clear Interrupt Status and Raw Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Clear Interrupt Status and Raw Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Clear Interrupt Status and Raw Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Clear Interrupt Status and Raw Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Clear Interrupt Status and Raw Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Clear Interrupt Status and Raw Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "IntSrcTran Status"]
    pub struct CLEARSRCTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "IntSrcTran Status"]
    pub mod clearsrctran {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLEARSRCTRAN {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Interrupt Status and Raw Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Clear Interrupt Status and Raw Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Clear Interrupt Status and Raw Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Clear Interrupt Status and Raw Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Clear Interrupt Status and Raw Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Clear Interrupt Status and Raw Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Clear Interrupt Status and Raw Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Clear Interrupt Status and Raw Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "IntBlock Status"]
    pub struct CLEARDSTTRAN {
        register: VolatileCell<u32>,
    }
    #[doc = "IntBlock Status"]
    pub mod cleardsttran {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLEARDSTTRAN {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Interrupt Status and Raw Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Clear Interrupt Status and Raw Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Clear Interrupt Status and Raw Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Clear Interrupt Status and Raw Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Clear Interrupt Status and Raw Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Clear Interrupt Status and Raw Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Clear Interrupt Status and Raw Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Clear Interrupt Status and Raw Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "IntErr Status"]
    pub struct CLEARERR {
        register: VolatileCell<u32>,
    }
    #[doc = "IntErr Status"]
    pub mod clearerr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLEARERR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "no effect"]
            VALUE1,
            #[doc = "clear status"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "clear status"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Interrupt Status and Raw Status for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Clear Interrupt Status and Raw Status for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Clear Interrupt Status and Raw Status for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Clear Interrupt Status and Raw Status for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Clear Interrupt Status and Raw Status for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Clear Interrupt Status and Raw Status for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Clear Interrupt Status and Raw Status for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Clear Interrupt Status and Raw Status for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Combined Interrupt Status Register"]
    pub struct STATUSINT {
        register: VolatileCell<u32>,
    }
    #[doc = "Combined Interrupt Status Register"]
    pub mod statusint {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STATUSINT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct ERRR {
            bits: bool,
        }
        impl ERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSTTR {
            bits: bool,
        }
        impl DSTTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRCTR {
            bits: bool,
        }
        impl SRCTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BLOCKR {
            bits: bool,
        }
        impl BLOCKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TFRR {
            bits: bool,
        }
        impl TFRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 4 - OR of the contents of STATUSERR register"]
            #[inline]
            pub fn err(&self) -> ERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ERRR { bits }
            }
            #[doc = "Bit 3 - OR of the contents of STATUSDSTTRAN register"]
            #[inline]
            pub fn dstt(&self) -> DSTTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DSTTR { bits }
            }
            #[doc = "Bit 2 - OR of the contents of STATUSSRCTRAN register"]
            #[inline]
            pub fn srct(&self) -> SRCTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SRCTR { bits }
            }
            #[doc = "Bit 1 - OR of the contents of STATUSBLOCK register"]
            #[inline]
            pub fn block(&self) -> BLOCKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BLOCKR { bits }
            }
            #[doc = "Bit 0 - OR of the contents of STATUSTFR register"]
            #[inline]
            pub fn tfr(&self) -> TFRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TFRR { bits }
            }
        }
    }
    #[doc = "Source Software Transaction Request Register"]
    pub struct REQSRCREG {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Software Transaction Request Register"]
    pub mod reqsrcreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::REQSRCREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Source request write enable for channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Source request write enable for channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Source request write enable for channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Source request write enable for channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Source request write enable for channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Source request write enable for channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Source request write enable for channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Source request write enable for channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Destination Software Transaction Request Register"]
    pub struct REQDSTREG {
        register: VolatileCell<u32>,
    }
    #[doc = "Destination Software Transaction Request Register"]
    pub mod reqdstreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::REQDSTREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Source request write enable for channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Source request write enable for channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Source request write enable for channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Source request write enable for channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Source request write enable for channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Source request write enable for channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Source request write enable for channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Source request write enable for channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Single Source Transaction Request Register"]
    pub struct SGLREQSRCREG {
        register: VolatileCell<u32>,
    }
    #[doc = "Single Source Transaction Request Register"]
    pub mod sglreqsrcreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SGLREQSRCREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Source request write enable for channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Source request write enable for channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Source request write enable for channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Source request write enable for channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Source request write enable for channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Source request write enable for channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Source request write enable for channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Source request write enable for channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Single Destination Transaction Request Register"]
    pub struct SGLREQDSTREG {
        register: VolatileCell<u32>,
    }
    #[doc = "Single Destination Transaction Request Register"]
    pub mod sglreqdstreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SGLREQDSTREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH0R {
            bits: bool,
        }
        impl CH0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH1R {
            bits: bool,
        }
        impl CH1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH2R {
            bits: bool,
        }
        impl CH2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH3R {
            bits: bool,
        }
        impl CH3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH4R {
            bits: bool,
        }
        impl CH4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH5R {
            bits: bool,
        }
        impl CH5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH6R {
            bits: bool,
        }
        impl CH6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH7R {
            bits: bool,
        }
        impl CH7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH0R { bits }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH1R { bits }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH2R { bits }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH3R { bits }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH4R { bits }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH5R { bits }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH6R { bits }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CH7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Source request write enable for channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Source request write enable for channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Source request write enable for channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Source request write enable for channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Source request write enable for channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Source request write enable for channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Source request write enable for channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Source request write enable for channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Source request for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Source request for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Source request for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Source request for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Source request for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Source request for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Source request for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Source request for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Last Source Transaction Request Register"]
    pub struct LSTSRCREG {
        register: VolatileCell<u32>,
    }
    #[doc = "Last Source Transaction Request Register"]
    pub mod lstsrcreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LSTSRCREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source last request for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Source last request for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Source last request for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Source last request for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Source last request for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Source last request for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Source last request for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Source last request for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Source last transaction request write enable for channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Source last transaction request write enable for channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Source last transaction request write enable for channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Source last transaction request write enable for channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Source last transaction request write enable for channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Source last transaction request write enable for channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Source last transaction request write enable for channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Source last transaction request write enable for channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Source last request for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Source last request for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Source last request for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Source last request for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Source last request for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Source last request for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Source last request for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Source last request for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "Last Destination Transaction Request Register"]
    pub struct LSTDSTREG {
        register: VolatileCell<u32>,
    }
    #[doc = "Last Destination Transaction Request Register"]
    pub mod lstdstreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LSTDSTREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH0R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH0R::VALUE1 => false,
                    CH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH0R {
                match value {
                    false => CH0R::VALUE1,
                    true => CH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH1R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH1R::VALUE1 => false,
                    CH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH1R {
                match value {
                    false => CH1R::VALUE1,
                    true => CH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH2R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH2R::VALUE1 => false,
                    CH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH2R {
                match value {
                    false => CH2R::VALUE1,
                    true => CH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH3R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH3R::VALUE1 => false,
                    CH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH3R {
                match value {
                    false => CH3R::VALUE1,
                    true => CH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH4R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH4R::VALUE1 => false,
                    CH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH4R {
                match value {
                    false => CH4R::VALUE1,
                    true => CH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH5R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH5R::VALUE1 => false,
                    CH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH5R {
                match value {
                    false => CH5R::VALUE1,
                    true => CH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH6R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH6R::VALUE1 => false,
                    CH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH6R {
                match value {
                    false => CH6R::VALUE1,
                    true => CH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH7R {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH7R::VALUE1 => false,
                    CH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH7R {
                match value {
                    false => CH7R::VALUE1,
                    true => CH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WE_CH0`"]
        pub enum WE_CH0W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH0W::VALUE1 => false,
                    WE_CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH1`"]
        pub enum WE_CH1W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH1W::VALUE1 => false,
                    WE_CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH2`"]
        pub enum WE_CH2W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH2W::VALUE1 => false,
                    WE_CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH3`"]
        pub enum WE_CH3W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH3W::VALUE1 => false,
                    WE_CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH4`"]
        pub enum WE_CH4W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH4W::VALUE1 => false,
                    WE_CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH5`"]
        pub enum WE_CH5W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH5W::VALUE1 => false,
                    WE_CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH6`"]
        pub enum WE_CH6W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH6W::VALUE1 => false,
                    WE_CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WE_CH7`"]
        pub enum WE_CH7W {
            #[doc = "write disabled"]
            VALUE1,
            #[doc = "write enabled"]
            VALUE2,
        }
        impl WE_CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WE_CH7W::VALUE1 => false,
                    WE_CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WE_CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "write disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE1)
            }
            #[doc = "write enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WE_CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH0`"]
        pub enum CH0W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH0W::VALUE1 => false,
                    CH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH0W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH1`"]
        pub enum CH1W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH1W::VALUE1 => false,
                    CH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH1W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH2`"]
        pub enum CH2W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH2W::VALUE1 => false,
                    CH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH2W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH3`"]
        pub enum CH3W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH3W::VALUE1 => false,
                    CH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH3W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH4`"]
        pub enum CH4W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH4W::VALUE1 => false,
                    CH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH4W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH5`"]
        pub enum CH5W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH5W::VALUE1 => false,
                    CH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH5W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH6`"]
        pub enum CH6W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH6W::VALUE1 => false,
                    CH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH6W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH7`"]
        pub enum CH7W {
            #[doc = "Not last transaction in current block"]
            VALUE1,
            #[doc = "Last transaction in current block"]
            VALUE2,
        }
        impl CH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH7W::VALUE1 => false,
                    CH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not last transaction in current block"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH7W::VALUE1)
            }
            #[doc = "Last transaction in current block"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Destination last request for channel 0"]
            #[inline]
            pub fn ch0(&self) -> CH0R {
                CH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Destination last request for channel 1"]
            #[inline]
            pub fn ch1(&self) -> CH1R {
                CH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Destination last request for channel 2"]
            #[inline]
            pub fn ch2(&self) -> CH2R {
                CH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Destination last request for channel 3"]
            #[inline]
            pub fn ch3(&self) -> CH3R {
                CH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Destination last request for channel 4"]
            #[inline]
            pub fn ch4(&self) -> CH4R {
                CH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Destination last request for channel 5"]
            #[inline]
            pub fn ch5(&self) -> CH5R {
                CH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Destination last request for channel 6"]
            #[inline]
            pub fn ch6(&self) -> CH6R {
                CH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Destination last request for channel 7"]
            #[inline]
            pub fn ch7(&self) -> CH7R {
                CH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Destination last transaction request write enable for channel 0"]
            #[inline]
            pub fn we_ch0(&mut self) -> _WE_CH0W {
                _WE_CH0W { w: self }
            }
            #[doc = "Bit 9 - Destination last transaction request write enable for channel 1"]
            #[inline]
            pub fn we_ch1(&mut self) -> _WE_CH1W {
                _WE_CH1W { w: self }
            }
            #[doc = "Bit 10 - Destination last transaction request write enable for channel 2"]
            #[inline]
            pub fn we_ch2(&mut self) -> _WE_CH2W {
                _WE_CH2W { w: self }
            }
            #[doc = "Bit 11 - Destination last transaction request write enable for channel 3"]
            #[inline]
            pub fn we_ch3(&mut self) -> _WE_CH3W {
                _WE_CH3W { w: self }
            }
            #[doc = "Bit 12 - Destination last transaction request write enable for channel 4"]
            #[inline]
            pub fn we_ch4(&mut self) -> _WE_CH4W {
                _WE_CH4W { w: self }
            }
            #[doc = "Bit 13 - Destination last transaction request write enable for channel 5"]
            #[inline]
            pub fn we_ch5(&mut self) -> _WE_CH5W {
                _WE_CH5W { w: self }
            }
            #[doc = "Bit 14 - Destination last transaction request write enable for channel 6"]
            #[inline]
            pub fn we_ch6(&mut self) -> _WE_CH6W {
                _WE_CH6W { w: self }
            }
            #[doc = "Bit 15 - Destination last transaction request write enable for channel 7"]
            #[inline]
            pub fn we_ch7(&mut self) -> _WE_CH7W {
                _WE_CH7W { w: self }
            }
            #[doc = "Bit 0 - Destination last request for channel 0"]
            #[inline]
            pub fn ch0(&mut self) -> _CH0W {
                _CH0W { w: self }
            }
            #[doc = "Bit 1 - Destination last request for channel 1"]
            #[inline]
            pub fn ch1(&mut self) -> _CH1W {
                _CH1W { w: self }
            }
            #[doc = "Bit 2 - Destination last request for channel 2"]
            #[inline]
            pub fn ch2(&mut self) -> _CH2W {
                _CH2W { w: self }
            }
            #[doc = "Bit 3 - Destination last request for channel 3"]
            #[inline]
            pub fn ch3(&mut self) -> _CH3W {
                _CH3W { w: self }
            }
            #[doc = "Bit 4 - Destination last request for channel 4"]
            #[inline]
            pub fn ch4(&mut self) -> _CH4W {
                _CH4W { w: self }
            }
            #[doc = "Bit 5 - Destination last request for channel 5"]
            #[inline]
            pub fn ch5(&mut self) -> _CH5W {
                _CH5W { w: self }
            }
            #[doc = "Bit 6 - Destination last request for channel 6"]
            #[inline]
            pub fn ch6(&mut self) -> _CH6W {
                _CH6W { w: self }
            }
            #[doc = "Bit 7 - Destination last request for channel 7"]
            #[inline]
            pub fn ch7(&mut self) -> _CH7W {
                _CH7W { w: self }
            }
        }
    }
    #[doc = "GPDMA Configuration Register"]
    pub struct DMACFGREG {
        register: VolatileCell<u32>,
    }
    #[doc = "GPDMA Configuration Register"]
    pub mod dmacfgreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DMACFGREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DMA_EN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DMA_ENR {
            #[doc = "GPDMA Disabled"]
            VALUE1,
            #[doc = "GPDMA Enabled."]
            VALUE2,
        }
        impl DMA_ENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DMA_ENR::VALUE1 => false,
                    DMA_ENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DMA_ENR {
                match value {
                    false => DMA_ENR::VALUE1,
                    true => DMA_ENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DMA_ENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DMA_ENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DMA_EN`"]
        pub enum DMA_ENW {
            #[doc = "GPDMA Disabled"]
            VALUE1,
            #[doc = "GPDMA Enabled."]
            VALUE2,
        }
        impl DMA_ENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DMA_ENW::VALUE1 => false,
                    DMA_ENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMA_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMA_ENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMA_ENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "GPDMA Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMA_ENW::VALUE1)
            }
            #[doc = "GPDMA Enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMA_ENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - GPDMA Enable bit."]
            #[inline]
            pub fn dma_en(&self) -> DMA_ENR {
                DMA_ENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - GPDMA Enable bit."]
            #[inline]
            pub fn dma_en(&mut self) -> _DMA_ENW {
                _DMA_ENW { w: self }
            }
        }
    }
    #[doc = "GPDMA Channel Enable Register"]
    pub struct CHENREG {
        register: VolatileCell<u32>,
    }
    #[doc = "GPDMA Channel Enable Register"]
    pub mod chenreg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CHENREG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CH`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHR {
            #[doc = "Disable the Channel"]
            VALUE1,
            #[doc = "Enable the Channel"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CHR::VALUE1 => 0,
                    CHR::VALUE2 => 0x01,
                    CHR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CHR {
                match value {
                    0 => CHR::VALUE1,
                    1 => CHR::VALUE2,
                    i => CHR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _WE_CHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WE_CHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH`"]
        pub enum CHW {
            #[doc = "Disable the Channel"]
            VALUE1,
            #[doc = "Enable the Channel"]
            VALUE2,
        }
        impl CHW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CHW::VALUE1 => 0,
                    CHW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Disable the Channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHW::VALUE1)
            }
            #[doc = "Enable the Channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Enables/Disables the channel"]
            #[inline]
            pub fn ch(&self) -> CHR {
                CHR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 8:15 - Channel enable write enable"]
            #[inline]
            pub fn we_ch(&mut self) -> _WE_CHW {
                _WE_CHW { w: self }
            }
            #[doc = "Bits 0:7 - Enables/Disables the channel"]
            #[inline]
            pub fn ch(&mut self) -> _CHW {
                _CHW { w: self }
            }
        }
    }
    #[doc = "GPDMA0 ID Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "GPDMA0 ID Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct VALUER {
            bits: u32,
        }
        impl VALUER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Hardcoded GPDMA Peripheral ID"]
            #[inline]
            pub fn value(&self) -> VALUER {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                VALUER { bits }
            }
        }
    }
    #[doc = "GPDMA Component Type"]
    pub struct TYPE {
        register: VolatileCell<u32>,
    }
    #[doc = "GPDMA Component Type"]
    pub mod type_ {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TYPE {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct VALUER {
            bits: u32,
        }
        impl VALUER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Component Type"]
            #[inline]
            pub fn value(&self) -> VALUER {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                VALUER { bits }
            }
        }
    }
    #[doc = "DMA Component Version"]
    pub struct VERSION {
        register: VolatileCell<u32>,
    }
    #[doc = "DMA Component Version"]
    pub mod version {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::VERSION {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct VALUER {
            bits: u32,
        }
        impl VALUER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Version number of the component"]
            #[inline]
            pub fn value(&self) -> VALUER {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                VALUER { bits }
            }
        }
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub struct GPDMA0 {
    register_block: gpdma0::RegisterBlock,
}
impl Deref for GPDMA0 {
    type Target = gpdma0::RegisterBlock;
    fn deref(&self) -> &gpdma0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH0: Peripheral<GPDMA0_CH0> = unsafe { Peripheral::new(0x5001_4000) };
#[doc = "General Purpose DMA Unit 0"]
pub mod gpdma0_ch0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Source Address Register"]
        pub sar: SAR,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Destination Address Register"]
        pub dar: DAR,
        _reserved1: [u8; 4usize],
        #[doc = "0x10 - Linked List Pointer Register"]
        pub llp: LLP,
        _reserved2: [u8; 4usize],
        #[doc = "0x18 - Control Register Low"]
        pub ctll: CTLL,
        #[doc = "0x1c - Control Register High"]
        pub ctlh: CTLH,
        #[doc = "0x20 - Source Status Register"]
        pub sstat: SSTAT,
        _reserved3: [u8; 4usize],
        #[doc = "0x28 - Destination Status Register"]
        pub dstat: DSTAT,
        _reserved4: [u8; 4usize],
        #[doc = "0x30 - Source Status Address Register"]
        pub sstatar: SSTATAR,
        _reserved5: [u8; 4usize],
        #[doc = "0x38 - Destination Status Address Register"]
        pub dstatar: DSTATAR,
        _reserved6: [u8; 4usize],
        #[doc = "0x40 - Configuration Register Low"]
        pub cfgl: CFGL,
        #[doc = "0x44 - Configuration Register High"]
        pub cfgh: CFGH,
        #[doc = "0x48 - Source Gather Register"]
        pub sgr: SGR,
        _reserved7: [u8; 4usize],
        #[doc = "0x50 - Destination Scatter Register"]
        pub dsr: DSR,
    }
    #[doc = "Source Address Register"]
    pub struct SAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Address Register"]
    pub mod sar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SARR {
            bits: u32,
        }
        impl SARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SARW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SARW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Current Source Address of DMA transfer"]
            #[inline]
            pub fn sar(&self) -> SARR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SARR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Current Source Address of DMA transfer"]
            #[inline]
            pub fn sar(&mut self) -> _SARW {
                _SARW { w: self }
            }
        }
    }
    #[doc = "Destination Address Register"]
    pub struct DAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Destination Address Register"]
    pub mod dar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DARR {
            bits: u32,
        }
        impl DARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DARW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DARW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Current Destination address of DMA transfer"]
            #[inline]
            pub fn dar(&self) -> DARR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DARR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Current Destination address of DMA transfer"]
            #[inline]
            pub fn dar(&mut self) -> _DARW {
                _DARW { w: self }
            }
        }
    }
    #[doc = "Linked List Pointer Register"]
    pub struct LLP {
        register: VolatileCell<u32>,
    }
    #[doc = "Linked List Pointer Register"]
    pub mod llp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LLP {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LOCR {
            bits: u32,
        }
        impl LOCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x3fff_ffff;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 2:31 - Starting Address In Memory"]
            #[inline]
            pub fn loc(&self) -> LOCR {
                let bits = {
                    const MASK: u32 = 0x3fff_ffff;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                LOCR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 2:31 - Starting Address In Memory"]
            #[inline]
            pub fn loc(&mut self) -> _LOCW {
                _LOCW { w: self }
            }
        }
    }
    #[doc = "Control Register Low"]
    pub struct CTLL {
        register: VolatileCell<u32>,
    }
    #[doc = "Control Register Low"]
    pub mod ctll {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTLL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LLP_SRC_ENR {
            bits: bool,
        }
        impl LLP_SRC_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LLP_DST_ENR {
            bits: bool,
        }
        impl LLP_DST_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TT_FCR {
            bits: u8,
        }
        impl TT_FCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DST_SCATTER_EN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DST_SCATTER_ENR {
            #[doc = "Scatter disabled"]
            VALUE1,
            #[doc = "Scatter enabled"]
            VALUE2,
        }
        impl DST_SCATTER_ENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DST_SCATTER_ENR::VALUE1 => false,
                    DST_SCATTER_ENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DST_SCATTER_ENR {
                match value {
                    false => DST_SCATTER_ENR::VALUE1,
                    true => DST_SCATTER_ENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DST_SCATTER_ENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DST_SCATTER_ENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRC_GATHER_EN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRC_GATHER_ENR {
            #[doc = "Gather disabled"]
            VALUE1,
            #[doc = "Gather enabled"]
            VALUE2,
        }
        impl SRC_GATHER_ENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRC_GATHER_ENR::VALUE1 => false,
                    SRC_GATHER_ENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRC_GATHER_ENR {
                match value {
                    false => SRC_GATHER_ENR::VALUE1,
                    true => SRC_GATHER_ENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRC_GATHER_ENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRC_GATHER_ENR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRC_MSIZER {
            bits: u8,
        }
        impl SRC_MSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEST_MSIZER {
            bits: u8,
        }
        impl DEST_MSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SINC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SINCR {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SINCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SINCR::VALUE1 => 0,
                    SINCR::VALUE2 => 0x01,
                    SINCR::VALUE3 => 0x02,
                    SINCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SINCR {
                match value {
                    0 => SINCR::VALUE1,
                    1 => SINCR::VALUE2,
                    2 => SINCR::VALUE3,
                    i => SINCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SINCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SINCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SINCR::VALUE3
            }
        }
        #[doc = "Possible values of the field `DINC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DINCR {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DINCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DINCR::VALUE1 => 0,
                    DINCR::VALUE2 => 0x01,
                    DINCR::VALUE3 => 0x02,
                    DINCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DINCR {
                match value {
                    0 => DINCR::VALUE1,
                    1 => DINCR::VALUE2,
                    2 => DINCR::VALUE3,
                    i => DINCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DINCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DINCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DINCR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRC_TR_WIDTHR {
            bits: u8,
        }
        impl SRC_TR_WIDTHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DST_TR_WIDTHR {
            bits: u8,
        }
        impl DST_TR_WIDTHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INT_ENR {
            bits: bool,
        }
        impl INT_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _LLP_SRC_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LLP_SRC_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LLP_DST_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LLP_DST_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TT_FCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TT_FCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DST_SCATTER_EN`"]
        pub enum DST_SCATTER_ENW {
            #[doc = "Scatter disabled"]
            VALUE1,
            #[doc = "Scatter enabled"]
            VALUE2,
        }
        impl DST_SCATTER_ENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DST_SCATTER_ENW::VALUE1 => false,
                    DST_SCATTER_ENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DST_SCATTER_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DST_SCATTER_ENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DST_SCATTER_ENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Scatter disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DST_SCATTER_ENW::VALUE1)
            }
            #[doc = "Scatter enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DST_SCATTER_ENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRC_GATHER_EN`"]
        pub enum SRC_GATHER_ENW {
            #[doc = "Gather disabled"]
            VALUE1,
            #[doc = "Gather enabled"]
            VALUE2,
        }
        impl SRC_GATHER_ENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRC_GATHER_ENW::VALUE1 => false,
                    SRC_GATHER_ENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_GATHER_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_GATHER_ENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRC_GATHER_ENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Gather disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRC_GATHER_ENW::VALUE1)
            }
            #[doc = "Gather enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRC_GATHER_ENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_MSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_MSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEST_MSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEST_MSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SINC`"]
        pub enum SINCW {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
        }
        impl SINCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SINCW::VALUE1 => 0,
                    SINCW::VALUE2 => 1,
                    SINCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SINCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SINCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SINCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Increment"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SINCW::VALUE1)
            }
            #[doc = "Decrement"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SINCW::VALUE2)
            }
            #[doc = "No change"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SINCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DINC`"]
        pub enum DINCW {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
        }
        impl DINCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DINCW::VALUE1 => 0,
                    DINCW::VALUE2 => 1,
                    DINCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DINCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DINCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DINCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Increment"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DINCW::VALUE1)
            }
            #[doc = "Decrement"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DINCW::VALUE2)
            }
            #[doc = "No change"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DINCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_TR_WIDTHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_TR_WIDTHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DST_TR_WIDTHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DST_TR_WIDTHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INT_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INT_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 28 - Linked List Pointer for Source Enable"]
            #[inline]
            pub fn llp_src_en(&self) -> LLP_SRC_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LLP_SRC_ENR { bits }
            }
            #[doc = "Bit 27 - Linked List Pointer for Destination Enable"]
            #[inline]
            pub fn llp_dst_en(&self) -> LLP_DST_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LLP_DST_ENR { bits }
            }
            #[doc = "Bits 20:22 - Transfer Type and Flow Control"]
            #[inline]
            pub fn tt_fc(&self) -> TT_FCR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TT_FCR { bits }
            }
            #[doc = "Bit 18 - Destination scatter enable"]
            #[inline]
            pub fn dst_scatter_en(&self) -> DST_SCATTER_ENR {
                DST_SCATTER_ENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Source gather enable"]
            #[inline]
            pub fn src_gather_en(&self) -> SRC_GATHER_ENR {
                SRC_GATHER_ENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 14:16 - Source Burst Transaction Length"]
            #[inline]
            pub fn src_msize(&self) -> SRC_MSIZER {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SRC_MSIZER { bits }
            }
            #[doc = "Bits 11:13 - Destination Burst Transaction Length"]
            #[inline]
            pub fn dest_msize(&self) -> DEST_MSIZER {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DEST_MSIZER { bits }
            }
            #[doc = "Bits 9:10 - Source Address Increment"]
            #[inline]
            pub fn sinc(&self) -> SINCR {
                SINCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 7:8 - Destination Address Increment"]
            #[inline]
            pub fn dinc(&self) -> DINCR {
                DINCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:6 - Source Transfer Width"]
            #[inline]
            pub fn src_tr_width(&self) -> SRC_TR_WIDTHR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SRC_TR_WIDTHR { bits }
            }
            #[doc = "Bits 1:3 - Destination Transfer Width"]
            #[inline]
            pub fn dst_tr_width(&self) -> DST_TR_WIDTHR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DST_TR_WIDTHR { bits }
            }
            #[doc = "Bit 0 - Interrupt Enable Bit"]
            #[inline]
            pub fn int_en(&self) -> INT_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INT_ENR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0030_4801 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 28 - Linked List Pointer for Source Enable"]
            #[inline]
            pub fn llp_src_en(&mut self) -> _LLP_SRC_ENW {
                _LLP_SRC_ENW { w: self }
            }
            #[doc = "Bit 27 - Linked List Pointer for Destination Enable"]
            #[inline]
            pub fn llp_dst_en(&mut self) -> _LLP_DST_ENW {
                _LLP_DST_ENW { w: self }
            }
            #[doc = "Bits 20:22 - Transfer Type and Flow Control"]
            #[inline]
            pub fn tt_fc(&mut self) -> _TT_FCW {
                _TT_FCW { w: self }
            }
            #[doc = "Bit 18 - Destination scatter enable"]
            #[inline]
            pub fn dst_scatter_en(&mut self) -> _DST_SCATTER_ENW {
                _DST_SCATTER_ENW { w: self }
            }
            #[doc = "Bit 17 - Source gather enable"]
            #[inline]
            pub fn src_gather_en(&mut self) -> _SRC_GATHER_ENW {
                _SRC_GATHER_ENW { w: self }
            }
            #[doc = "Bits 14:16 - Source Burst Transaction Length"]
            #[inline]
            pub fn src_msize(&mut self) -> _SRC_MSIZEW {
                _SRC_MSIZEW { w: self }
            }
            #[doc = "Bits 11:13 - Destination Burst Transaction Length"]
            #[inline]
            pub fn dest_msize(&mut self) -> _DEST_MSIZEW {
                _DEST_MSIZEW { w: self }
            }
            #[doc = "Bits 9:10 - Source Address Increment"]
            #[inline]
            pub fn sinc(&mut self) -> _SINCW {
                _SINCW { w: self }
            }
            #[doc = "Bits 7:8 - Destination Address Increment"]
            #[inline]
            pub fn dinc(&mut self) -> _DINCW {
                _DINCW { w: self }
            }
            #[doc = "Bits 4:6 - Source Transfer Width"]
            #[inline]
            pub fn src_tr_width(&mut self) -> _SRC_TR_WIDTHW {
                _SRC_TR_WIDTHW { w: self }
            }
            #[doc = "Bits 1:3 - Destination Transfer Width"]
            #[inline]
            pub fn dst_tr_width(&mut self) -> _DST_TR_WIDTHW {
                _DST_TR_WIDTHW { w: self }
            }
            #[doc = "Bit 0 - Interrupt Enable Bit"]
            #[inline]
            pub fn int_en(&mut self) -> _INT_ENW {
                _INT_ENW { w: self }
            }
        }
    }
    #[doc = "Control Register High"]
    pub struct CTLH {
        register: VolatileCell<u32>,
    }
    #[doc = "Control Register High"]
    pub mod ctlh {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTLH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DONER {
            bits: bool,
        }
        impl DONER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BLOCK_TSR {
            bits: u16,
        }
        impl BLOCK_TSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DONEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DONEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BLOCK_TSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BLOCK_TSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 12 - Done bit"]
            #[inline]
            pub fn done(&self) -> DONER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DONER { bits }
            }
            #[doc = "Bits 0:11 - Block Transfer Size"]
            #[inline]
            pub fn block_ts(&self) -> BLOCK_TSR {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BLOCK_TSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x02 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 12 - Done bit"]
            #[inline]
            pub fn done(&mut self) -> _DONEW {
                _DONEW { w: self }
            }
            #[doc = "Bits 0:11 - Block Transfer Size"]
            #[inline]
            pub fn block_ts(&mut self) -> _BLOCK_TSW {
                _BLOCK_TSW { w: self }
            }
        }
    }
    #[doc = "Source Status Register"]
    pub struct SSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Status Register"]
    pub mod sstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SSTAT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SSTATR {
            bits: u32,
        }
        impl SSTATR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTATW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Source Status"]
            #[inline]
            pub fn sstat(&self) -> SSTATR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SSTATR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Source Status"]
            #[inline]
            pub fn sstat(&mut self) -> _SSTATW {
                _SSTATW { w: self }
            }
        }
    }
    #[doc = "Destination Status Register"]
    pub struct DSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Destination Status Register"]
    pub mod dstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DSTAT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSTATR {
            bits: u32,
        }
        impl DSTATR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSTATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSTATW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Destination Status"]
            #[inline]
            pub fn dstat(&self) -> DSTATR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DSTATR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Destination Status"]
            #[inline]
            pub fn dstat(&mut self) -> _DSTATW {
                _DSTATW { w: self }
            }
        }
    }
    #[doc = "Source Status Address Register"]
    pub struct SSTATAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Status Address Register"]
    pub mod sstatar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SSTATAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SSTATARR {
            bits: u32,
        }
        impl SSTATARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTATARW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTATARW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Source Status Address"]
            #[inline]
            pub fn sstatar(&self) -> SSTATARR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SSTATARR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Source Status Address"]
            #[inline]
            pub fn sstatar(&mut self) -> _SSTATARW {
                _SSTATARW { w: self }
            }
        }
    }
    #[doc = "Destination Status Address Register"]
    pub struct DSTATAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Destination Status Address Register"]
    pub mod dstatar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DSTATAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSTATARR {
            bits: u32,
        }
        impl DSTATARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSTATARW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSTATARW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Destination Status Address"]
            #[inline]
            pub fn dstatar(&self) -> DSTATARR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DSTATARR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Destination Status Address"]
            #[inline]
            pub fn dstatar(&mut self) -> _DSTATARW {
                _DSTATARW { w: self }
            }
        }
    }
    #[doc = "Configuration Register Low"]
    pub struct CFGL {
        register: VolatileCell<u32>,
    }
    #[doc = "Configuration Register Low"]
    pub mod cfgl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CFGL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RELOAD_DSTR {
            bits: bool,
        }
        impl RELOAD_DSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RELOAD_SRCR {
            bits: bool,
        }
        impl RELOAD_SRCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MAX_ABRSTR {
            bits: u16,
        }
        impl MAX_ABRSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRC_HS_POL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRC_HS_POLR {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl SRC_HS_POLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRC_HS_POLR::VALUE1 => false,
                    SRC_HS_POLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRC_HS_POLR {
                match value {
                    false => SRC_HS_POLR::VALUE1,
                    true => SRC_HS_POLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRC_HS_POLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRC_HS_POLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DST_HS_POL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DST_HS_POLR {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl DST_HS_POLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DST_HS_POLR::VALUE1 => false,
                    DST_HS_POLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DST_HS_POLR {
                match value {
                    false => DST_HS_POLR::VALUE1,
                    true => DST_HS_POLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DST_HS_POLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DST_HS_POLR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct LOCK_BR {
            bits: bool,
        }
        impl LOCK_BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LOCK_CHR {
            bits: bool,
        }
        impl LOCK_CHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `LOCK_B_L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOCK_B_LR {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl LOCK_B_LR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LOCK_B_LR::VALUE1 => 0,
                    LOCK_B_LR::VALUE2 => 0x01,
                    LOCK_B_LR::VALUE3 => 0x02,
                    LOCK_B_LR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LOCK_B_LR {
                match value {
                    0 => LOCK_B_LR::VALUE1,
                    1 => LOCK_B_LR::VALUE2,
                    2 => LOCK_B_LR::VALUE3,
                    i => LOCK_B_LR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOCK_B_LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOCK_B_LR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LOCK_B_LR::VALUE3
            }
        }
        #[doc = "Possible values of the field `LOCK_CH_L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOCK_CH_LR {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl LOCK_CH_LR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LOCK_CH_LR::VALUE1 => 0,
                    LOCK_CH_LR::VALUE2 => 0x01,
                    LOCK_CH_LR::VALUE3 => 0x02,
                    LOCK_CH_LR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LOCK_CH_LR {
                match value {
                    0 => LOCK_CH_LR::VALUE1,
                    1 => LOCK_CH_LR::VALUE2,
                    2 => LOCK_CH_LR::VALUE3,
                    i => LOCK_CH_LR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOCK_CH_LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOCK_CH_LR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LOCK_CH_LR::VALUE3
            }
        }
        #[doc = "Possible values of the field `HS_SEL_SRC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HS_SEL_SRCR {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware-initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_SRCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HS_SEL_SRCR::VALUE1 => false,
                    HS_SEL_SRCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HS_SEL_SRCR {
                match value {
                    false => HS_SEL_SRCR::VALUE1,
                    true => HS_SEL_SRCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HS_SEL_SRCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HS_SEL_SRCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HS_SEL_DST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HS_SEL_DSTR {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware- initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_DSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HS_SEL_DSTR::VALUE1 => false,
                    HS_SEL_DSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HS_SEL_DSTR {
                match value {
                    false => HS_SEL_DSTR::VALUE1,
                    true => HS_SEL_DSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HS_SEL_DSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HS_SEL_DSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FIFO_EMPTY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFO_EMPTYR {
            #[doc = "Channel FIFO empty"]
            VALUE1,
            #[doc = "Channel FIFO not empty"]
            VALUE2,
        }
        impl FIFO_EMPTYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFO_EMPTYR::VALUE1 => true,
                    FIFO_EMPTYR::VALUE2 => false,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFO_EMPTYR {
                match value {
                    true => FIFO_EMPTYR::VALUE1,
                    false => FIFO_EMPTYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFO_EMPTYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFO_EMPTYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH_SUSP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH_SUSPR {
            #[doc = "Not suspended."]
            VALUE1,
            #[doc = "Suspend DMA transfer from the source."]
            VALUE2,
        }
        impl CH_SUSPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH_SUSPR::VALUE1 => false,
                    CH_SUSPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH_SUSPR {
                match value {
                    false => CH_SUSPR::VALUE1,
                    true => CH_SUSPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH_SUSPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH_SUSPR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH_PRIORR {
            bits: u8,
        }
        impl CH_PRIORR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _RELOAD_DSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RELOAD_DSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RELOAD_SRCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RELOAD_SRCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MAX_ABRSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MAX_ABRSTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRC_HS_POL`"]
        pub enum SRC_HS_POLW {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl SRC_HS_POLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRC_HS_POLW::VALUE1 => false,
                    SRC_HS_POLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_HS_POLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_HS_POLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRC_HS_POLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active high"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRC_HS_POLW::VALUE1)
            }
            #[doc = "Active low"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRC_HS_POLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DST_HS_POL`"]
        pub enum DST_HS_POLW {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl DST_HS_POLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DST_HS_POLW::VALUE1 => false,
                    DST_HS_POLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DST_HS_POLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DST_HS_POLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DST_HS_POLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active high"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DST_HS_POLW::VALUE1)
            }
            #[doc = "Active low"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DST_HS_POLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_BW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_CHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_CHW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOCK_B_L`"]
        pub enum LOCK_B_LW {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
        }
        impl LOCK_B_LW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LOCK_B_LW::VALUE1 => 0,
                    LOCK_B_LW::VALUE2 => 1,
                    LOCK_B_LW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_B_LW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_B_LW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOCK_B_LW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Over complete DMA transfer"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOCK_B_LW::VALUE1)
            }
            #[doc = "Over complete DMA block transfer"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOCK_B_LW::VALUE2)
            }
            #[doc = "Over complete DMA transaction"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LOCK_B_LW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOCK_CH_L`"]
        pub enum LOCK_CH_LW {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
        }
        impl LOCK_CH_LW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LOCK_CH_LW::VALUE1 => 0,
                    LOCK_CH_LW::VALUE2 => 1,
                    LOCK_CH_LW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_CH_LW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_CH_LW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOCK_CH_LW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Over complete DMA transfer"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOCK_CH_LW::VALUE1)
            }
            #[doc = "Over complete DMA block transfer"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOCK_CH_LW::VALUE2)
            }
            #[doc = "Over complete DMA transaction"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LOCK_CH_LW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HS_SEL_SRC`"]
        pub enum HS_SEL_SRCW {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware-initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_SRCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HS_SEL_SRCW::VALUE1 => false,
                    HS_SEL_SRCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HS_SEL_SRCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HS_SEL_SRCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HS_SEL_SRCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HS_SEL_SRCW::VALUE1)
            }
            #[doc = "Software handshaking interface. Hardware-initiated transaction requests are ignored."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HS_SEL_SRCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HS_SEL_DST`"]
        pub enum HS_SEL_DSTW {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware- initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_DSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HS_SEL_DSTW::VALUE1 => false,
                    HS_SEL_DSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HS_SEL_DSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HS_SEL_DSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HS_SEL_DSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HS_SEL_DSTW::VALUE1)
            }
            #[doc = "Software handshaking interface. Hardware- initiated transaction requests are ignored."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HS_SEL_DSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH_SUSP`"]
        pub enum CH_SUSPW {
            #[doc = "Not suspended."]
            VALUE1,
            #[doc = "Suspend DMA transfer from the source."]
            VALUE2,
        }
        impl CH_SUSPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH_SUSPW::VALUE1 => false,
                    CH_SUSPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH_SUSPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH_SUSPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH_SUSPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not suspended."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH_SUSPW::VALUE1)
            }
            #[doc = "Suspend DMA transfer from the source."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH_SUSPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH_PRIORW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH_PRIORW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 31 - Automatic Destination Reload"]
            #[inline]
            pub fn reload_dst(&self) -> RELOAD_DSTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RELOAD_DSTR { bits }
            }
            #[doc = "Bit 30 - Automatic Source Reload"]
            #[inline]
            pub fn reload_src(&self) -> RELOAD_SRCR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RELOAD_SRCR { bits }
            }
            #[doc = "Bits 20:29 - Maximum AMBA Burst Length"]
            #[inline]
            pub fn max_abrst(&self) -> MAX_ABRSTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MAX_ABRSTR { bits }
            }
            #[doc = "Bit 19 - Source Handshaking Interface Polarity"]
            #[inline]
            pub fn src_hs_pol(&self) -> SRC_HS_POLR {
                SRC_HS_POLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Destination Handshaking Interface Polarity"]
            #[inline]
            pub fn dst_hs_pol(&self) -> DST_HS_POLR {
                DST_HS_POLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Bus Lock Bit"]
            #[inline]
            pub fn lock_b(&self) -> LOCK_BR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LOCK_BR { bits }
            }
            #[doc = "Bit 16 - Channel Lock Bit"]
            #[inline]
            pub fn lock_ch(&self) -> LOCK_CHR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LOCK_CHR { bits }
            }
            #[doc = "Bits 14:15 - Bus Lock Level"]
            #[inline]
            pub fn lock_b_l(&self) -> LOCK_B_LR {
                LOCK_B_LR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Channel Lock Level"]
            #[inline]
            pub fn lock_ch_l(&self) -> LOCK_CH_LR {
                LOCK_CH_LR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 11 - Source Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_src(&self) -> HS_SEL_SRCR {
                HS_SEL_SRCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Destination Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_dst(&self) -> HS_SEL_DSTR {
                HS_SEL_DSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Indicates if there is data left in the channel FIFO"]
            #[inline]
            pub fn fifo_empty(&self) -> FIFO_EMPTYR {
                FIFO_EMPTYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Channel Suspend"]
            #[inline]
            pub fn ch_susp(&self) -> CH_SUSPR {
                CH_SUSPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 5:7 - Channel priority"]
            #[inline]
            pub fn ch_prior(&self) -> CH_PRIORR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CH_PRIORR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0e00 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 31 - Automatic Destination Reload"]
            #[inline]
            pub fn reload_dst(&mut self) -> _RELOAD_DSTW {
                _RELOAD_DSTW { w: self }
            }
            #[doc = "Bit 30 - Automatic Source Reload"]
            #[inline]
            pub fn reload_src(&mut self) -> _RELOAD_SRCW {
                _RELOAD_SRCW { w: self }
            }
            #[doc = "Bits 20:29 - Maximum AMBA Burst Length"]
            #[inline]
            pub fn max_abrst(&mut self) -> _MAX_ABRSTW {
                _MAX_ABRSTW { w: self }
            }
            #[doc = "Bit 19 - Source Handshaking Interface Polarity"]
            #[inline]
            pub fn src_hs_pol(&mut self) -> _SRC_HS_POLW {
                _SRC_HS_POLW { w: self }
            }
            #[doc = "Bit 18 - Destination Handshaking Interface Polarity"]
            #[inline]
            pub fn dst_hs_pol(&mut self) -> _DST_HS_POLW {
                _DST_HS_POLW { w: self }
            }
            #[doc = "Bit 17 - Bus Lock Bit"]
            #[inline]
            pub fn lock_b(&mut self) -> _LOCK_BW {
                _LOCK_BW { w: self }
            }
            #[doc = "Bit 16 - Channel Lock Bit"]
            #[inline]
            pub fn lock_ch(&mut self) -> _LOCK_CHW {
                _LOCK_CHW { w: self }
            }
            #[doc = "Bits 14:15 - Bus Lock Level"]
            #[inline]
            pub fn lock_b_l(&mut self) -> _LOCK_B_LW {
                _LOCK_B_LW { w: self }
            }
            #[doc = "Bits 12:13 - Channel Lock Level"]
            #[inline]
            pub fn lock_ch_l(&mut self) -> _LOCK_CH_LW {
                _LOCK_CH_LW { w: self }
            }
            #[doc = "Bit 11 - Source Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_src(&mut self) -> _HS_SEL_SRCW {
                _HS_SEL_SRCW { w: self }
            }
            #[doc = "Bit 10 - Destination Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_dst(&mut self) -> _HS_SEL_DSTW {
                _HS_SEL_DSTW { w: self }
            }
            #[doc = "Bit 8 - Channel Suspend"]
            #[inline]
            pub fn ch_susp(&mut self) -> _CH_SUSPW {
                _CH_SUSPW { w: self }
            }
            #[doc = "Bits 5:7 - Channel priority"]
            #[inline]
            pub fn ch_prior(&mut self) -> _CH_PRIORW {
                _CH_PRIORW { w: self }
            }
        }
    }
    #[doc = "Configuration Register High"]
    pub struct CFGH {
        register: VolatileCell<u32>,
    }
    #[doc = "Configuration Register High"]
    pub mod cfgh {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CFGH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEST_PERR {
            bits: u8,
        }
        impl DEST_PERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRC_PERR {
            bits: u8,
        }
        impl SRC_PERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SS_UPD_ENR {
            bits: bool,
        }
        impl SS_UPD_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DS_UPD_ENR {
            bits: bool,
        }
        impl DS_UPD_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PROTCTLR {
            bits: u8,
        }
        impl PROTCTLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FIFO_MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFO_MODER {
            #[doc = "Space/data available for single AHB transfer of the specified transfer width."]
            VALUE1,
            #[doc = "Data available is greater than or equal to half the FIFO depth for destination transfers and space available is greater than half the fifo depth for source transfers. The exceptions are at the end of a burst transaction request or at the end of a block transfer."]
            VALUE2,
        }
        impl FIFO_MODER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFO_MODER::VALUE1 => false,
                    FIFO_MODER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFO_MODER {
                match value {
                    false => FIFO_MODER::VALUE1,
                    true => FIFO_MODER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFO_MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFO_MODER::VALUE2
            }
        }
        #[doc = "Possible values of the field `FCMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCMODER {
            #[doc = "Source transaction requests are serviced when they occur. Data pre-fetching is enabled."]
            VALUE1,
            #[doc = "Source transaction requests are not serviced until a destination transaction request occurs. In this mode, the amount of data transferred from the source is limited so that it is guaranteed to be transferred to the destination prior to block termination by the destination. Data pre-fetching is disabled."]
            VALUE2,
        }
        impl FCMODER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCMODER::VALUE1 => false,
                    FCMODER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCMODER {
                match value {
                    false => FCMODER::VALUE1,
                    true => FCMODER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCMODER::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEST_PERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEST_PERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_PERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_PERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS_UPD_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS_UPD_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DS_UPD_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DS_UPD_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PROTCTLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PROTCTLW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FIFO_MODE`"]
        pub enum FIFO_MODEW {
            #[doc = "Space/data available for single AHB transfer of the specified transfer width."]
            VALUE1,
            #[doc = "Data available is greater than or equal to half the FIFO depth for destination transfers and space available is greater than half the fifo depth for source transfers. The exceptions are at the end of a burst transaction request or at the end of a block transfer."]
            VALUE2,
        }
        impl FIFO_MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FIFO_MODEW::VALUE1 => false,
                    FIFO_MODEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FIFO_MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FIFO_MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FIFO_MODEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Space/data available for single AHB transfer of the specified transfer width."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FIFO_MODEW::VALUE1)
            }
            #[doc = "Data available is greater than or equal to half the FIFO depth for destination transfers and space available is greater than half the fifo depth for source transfers. The exceptions are at the end of a burst transaction request or at the end of a block transfer."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FIFO_MODEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FCMODE`"]
        pub enum FCMODEW {
            #[doc = "Source transaction requests are serviced when they occur. Data pre-fetching is enabled."]
            VALUE1,
            #[doc = "Source transaction requests are not serviced until a destination transaction request occurs. In this mode, the amount of data transferred from the source is limited so that it is guaranteed to be transferred to the destination prior to block termination by the destination. Data pre-fetching is disabled."]
            VALUE2,
        }
        impl FCMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FCMODEW::VALUE1 => false,
                    FCMODEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FCMODEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Source transaction requests are serviced when they occur. Data pre-fetching is enabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FCMODEW::VALUE1)
            }
            #[doc = "Source transaction requests are not serviced until a destination transaction request occurs. In this mode, the amount of data transferred from the source is limited so that it is guaranteed to be transferred to the destination prior to block termination by the destination. Data pre-fetching is disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FCMODEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 11:14 - Destination Peripheral"]
            #[inline]
            pub fn dest_per(&self) -> DEST_PERR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DEST_PERR { bits }
            }
            #[doc = "Bits 7:10 - Source Peripheral"]
            #[inline]
            pub fn src_per(&self) -> SRC_PERR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SRC_PERR { bits }
            }
            #[doc = "Bit 6 - Source Status Update Enable"]
            #[inline]
            pub fn ss_upd_en(&self) -> SS_UPD_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SS_UPD_ENR { bits }
            }
            #[doc = "Bit 5 - Destination Status Update Enable"]
            #[inline]
            pub fn ds_upd_en(&self) -> DS_UPD_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DS_UPD_ENR { bits }
            }
            #[doc = "Bits 2:4 - Protection Control"]
            #[inline]
            pub fn protctl(&self) -> PROTCTLR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PROTCTLR { bits }
            }
            #[doc = "Bit 1 - FIFO Mode Select"]
            #[inline]
            pub fn fifo_mode(&self) -> FIFO_MODER {
                FIFO_MODER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 0 - Flow Control Mode"]
            #[inline]
            pub fn fcmode(&self) -> FCMODER {
                FCMODER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x04 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 11:14 - Destination Peripheral"]
            #[inline]
            pub fn dest_per(&mut self) -> _DEST_PERW {
                _DEST_PERW { w: self }
            }
            #[doc = "Bits 7:10 - Source Peripheral"]
            #[inline]
            pub fn src_per(&mut self) -> _SRC_PERW {
                _SRC_PERW { w: self }
            }
            #[doc = "Bit 6 - Source Status Update Enable"]
            #[inline]
            pub fn ss_upd_en(&mut self) -> _SS_UPD_ENW {
                _SS_UPD_ENW { w: self }
            }
            #[doc = "Bit 5 - Destination Status Update Enable"]
            #[inline]
            pub fn ds_upd_en(&mut self) -> _DS_UPD_ENW {
                _DS_UPD_ENW { w: self }
            }
            #[doc = "Bits 2:4 - Protection Control"]
            #[inline]
            pub fn protctl(&mut self) -> _PROTCTLW {
                _PROTCTLW { w: self }
            }
            #[doc = "Bit 1 - FIFO Mode Select"]
            #[inline]
            pub fn fifo_mode(&mut self) -> _FIFO_MODEW {
                _FIFO_MODEW { w: self }
            }
            #[doc = "Bit 0 - Flow Control Mode"]
            #[inline]
            pub fn fcmode(&mut self) -> _FCMODEW {
                _FCMODEW { w: self }
            }
        }
    }
    #[doc = "Source Gather Register"]
    pub struct SGR {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Gather Register"]
    pub mod sgr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SGR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SGCR {
            bits: u16,
        }
        impl SGCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SGIR {
            bits: u32,
        }
        impl SGIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SGCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SGCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SGIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SGIW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x000f_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 20:31 - Source gather count"]
            #[inline]
            pub fn sgc(&self) -> SGCR {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SGCR { bits }
            }
            #[doc = "Bits 0:19 - Source gather interval"]
            #[inline]
            pub fn sgi(&self) -> SGIR {
                let bits = {
                    const MASK: u32 = 0x000f_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SGIR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 20:31 - Source gather count"]
            #[inline]
            pub fn sgc(&mut self) -> _SGCW {
                _SGCW { w: self }
            }
            #[doc = "Bits 0:19 - Source gather interval"]
            #[inline]
            pub fn sgi(&mut self) -> _SGIW {
                _SGIW { w: self }
            }
        }
    }
    #[doc = "Destination Scatter Register"]
    pub struct DSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Destination Scatter Register"]
    pub mod dsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSCR {
            bits: u16,
        }
        impl DSCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSIR {
            bits: u32,
        }
        impl DSIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSIW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x000f_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 20:31 - Destination scatter count"]
            #[inline]
            pub fn dsc(&self) -> DSCR {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSCR { bits }
            }
            #[doc = "Bits 0:19 - Destination scatter interval"]
            #[inline]
            pub fn dsi(&self) -> DSIR {
                let bits = {
                    const MASK: u32 = 0x000f_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DSIR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 20:31 - Destination scatter count"]
            #[inline]
            pub fn dsc(&mut self) -> _DSCW {
                _DSCW { w: self }
            }
            #[doc = "Bits 0:19 - Destination scatter interval"]
            #[inline]
            pub fn dsi(&mut self) -> _DSIW {
                _DSIW { w: self }
            }
        }
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub struct GPDMA0_CH0 {
    register_block: gpdma0_ch0::RegisterBlock,
}
impl Deref for GPDMA0_CH0 {
    type Target = gpdma0_ch0::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH1: Peripheral<GPDMA0_CH1> = unsafe { Peripheral::new(0x5001_4058) };
#[doc = r" Register block"]
pub struct GPDMA0_CH1 {
    register_block: gpdma0_ch0::RegisterBlock,
}
impl Deref for GPDMA0_CH1 {
    type Target = gpdma0_ch0::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH2: Peripheral<GPDMA0_CH2> = unsafe { Peripheral::new(0x5001_40b0) };
#[doc = "General Purpose DMA Unit 0"]
pub mod gpdma0_ch2 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Source Address Register"]
        pub sar: SAR,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Destination Address Register"]
        pub dar: DAR,
        _reserved1: [u8; 12usize],
        #[doc = "0x18 - Control Register Low"]
        pub ctll: CTLL,
        #[doc = "0x1c - Control Register High"]
        pub ctlh: CTLH,
        _reserved2: [u8; 32usize],
        #[doc = "0x40 - Configuration Register Low"]
        pub cfgl: CFGL,
        #[doc = "0x44 - Configuration Register High"]
        pub cfgh: CFGH,
    }
    #[doc = "Source Address Register"]
    pub struct SAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Address Register"]
    pub mod sar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SARR {
            bits: u32,
        }
        impl SARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SARW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SARW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Current Source Address of DMA transfer"]
            #[inline]
            pub fn sar(&self) -> SARR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SARR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Current Source Address of DMA transfer"]
            #[inline]
            pub fn sar(&mut self) -> _SARW {
                _SARW { w: self }
            }
        }
    }
    #[doc = "Destination Address Register"]
    pub struct DAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Destination Address Register"]
    pub mod dar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DARR {
            bits: u32,
        }
        impl DARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DARW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DARW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Current Destination address of DMA transfer"]
            #[inline]
            pub fn dar(&self) -> DARR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DARR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Current Destination address of DMA transfer"]
            #[inline]
            pub fn dar(&mut self) -> _DARW {
                _DARW { w: self }
            }
        }
    }
    #[doc = "Control Register Low"]
    pub struct CTLL {
        register: VolatileCell<u32>,
    }
    #[doc = "Control Register Low"]
    pub mod ctll {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTLL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TT_FCR {
            bits: u8,
        }
        impl TT_FCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRC_MSIZER {
            bits: u8,
        }
        impl SRC_MSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEST_MSIZER {
            bits: u8,
        }
        impl DEST_MSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SINC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SINCR {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SINCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SINCR::VALUE1 => 0,
                    SINCR::VALUE2 => 0x01,
                    SINCR::VALUE3 => 0x02,
                    SINCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SINCR {
                match value {
                    0 => SINCR::VALUE1,
                    1 => SINCR::VALUE2,
                    2 => SINCR::VALUE3,
                    i => SINCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SINCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SINCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SINCR::VALUE3
            }
        }
        #[doc = "Possible values of the field `DINC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DINCR {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DINCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DINCR::VALUE1 => 0,
                    DINCR::VALUE2 => 0x01,
                    DINCR::VALUE3 => 0x02,
                    DINCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DINCR {
                match value {
                    0 => DINCR::VALUE1,
                    1 => DINCR::VALUE2,
                    2 => DINCR::VALUE3,
                    i => DINCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DINCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DINCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DINCR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRC_TR_WIDTHR {
            bits: u8,
        }
        impl SRC_TR_WIDTHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DST_TR_WIDTHR {
            bits: u8,
        }
        impl DST_TR_WIDTHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INT_ENR {
            bits: bool,
        }
        impl INT_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _TT_FCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TT_FCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_MSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_MSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEST_MSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEST_MSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SINC`"]
        pub enum SINCW {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
        }
        impl SINCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SINCW::VALUE1 => 0,
                    SINCW::VALUE2 => 1,
                    SINCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SINCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SINCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SINCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Increment"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SINCW::VALUE1)
            }
            #[doc = "Decrement"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SINCW::VALUE2)
            }
            #[doc = "No change"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SINCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DINC`"]
        pub enum DINCW {
            #[doc = "Increment"]
            VALUE1,
            #[doc = "Decrement"]
            VALUE2,
            #[doc = "No change"]
            VALUE3,
        }
        impl DINCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DINCW::VALUE1 => 0,
                    DINCW::VALUE2 => 1,
                    DINCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DINCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DINCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DINCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Increment"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DINCW::VALUE1)
            }
            #[doc = "Decrement"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DINCW::VALUE2)
            }
            #[doc = "No change"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DINCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_TR_WIDTHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_TR_WIDTHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DST_TR_WIDTHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DST_TR_WIDTHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INT_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INT_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 20:22 - Transfer Type and Flow Control"]
            #[inline]
            pub fn tt_fc(&self) -> TT_FCR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TT_FCR { bits }
            }
            #[doc = "Bits 14:16 - Source Burst Transaction Length"]
            #[inline]
            pub fn src_msize(&self) -> SRC_MSIZER {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SRC_MSIZER { bits }
            }
            #[doc = "Bits 11:13 - Destination Burst Transaction Length"]
            #[inline]
            pub fn dest_msize(&self) -> DEST_MSIZER {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DEST_MSIZER { bits }
            }
            #[doc = "Bits 9:10 - Source Address Increment"]
            #[inline]
            pub fn sinc(&self) -> SINCR {
                SINCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 7:8 - Destination Address Increment"]
            #[inline]
            pub fn dinc(&self) -> DINCR {
                DINCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:6 - Source Transfer Width"]
            #[inline]
            pub fn src_tr_width(&self) -> SRC_TR_WIDTHR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SRC_TR_WIDTHR { bits }
            }
            #[doc = "Bits 1:3 - Destination Transfer Width"]
            #[inline]
            pub fn dst_tr_width(&self) -> DST_TR_WIDTHR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DST_TR_WIDTHR { bits }
            }
            #[doc = "Bit 0 - Interrupt Enable Bit"]
            #[inline]
            pub fn int_en(&self) -> INT_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INT_ENR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0030_4801 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 20:22 - Transfer Type and Flow Control"]
            #[inline]
            pub fn tt_fc(&mut self) -> _TT_FCW {
                _TT_FCW { w: self }
            }
            #[doc = "Bits 14:16 - Source Burst Transaction Length"]
            #[inline]
            pub fn src_msize(&mut self) -> _SRC_MSIZEW {
                _SRC_MSIZEW { w: self }
            }
            #[doc = "Bits 11:13 - Destination Burst Transaction Length"]
            #[inline]
            pub fn dest_msize(&mut self) -> _DEST_MSIZEW {
                _DEST_MSIZEW { w: self }
            }
            #[doc = "Bits 9:10 - Source Address Increment"]
            #[inline]
            pub fn sinc(&mut self) -> _SINCW {
                _SINCW { w: self }
            }
            #[doc = "Bits 7:8 - Destination Address Increment"]
            #[inline]
            pub fn dinc(&mut self) -> _DINCW {
                _DINCW { w: self }
            }
            #[doc = "Bits 4:6 - Source Transfer Width"]
            #[inline]
            pub fn src_tr_width(&mut self) -> _SRC_TR_WIDTHW {
                _SRC_TR_WIDTHW { w: self }
            }
            #[doc = "Bits 1:3 - Destination Transfer Width"]
            #[inline]
            pub fn dst_tr_width(&mut self) -> _DST_TR_WIDTHW {
                _DST_TR_WIDTHW { w: self }
            }
            #[doc = "Bit 0 - Interrupt Enable Bit"]
            #[inline]
            pub fn int_en(&mut self) -> _INT_ENW {
                _INT_ENW { w: self }
            }
        }
    }
    #[doc = "Control Register High"]
    pub struct CTLH {
        register: VolatileCell<u32>,
    }
    #[doc = "Control Register High"]
    pub mod ctlh {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTLH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DONER {
            bits: bool,
        }
        impl DONER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BLOCK_TSR {
            bits: u16,
        }
        impl BLOCK_TSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DONEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DONEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BLOCK_TSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BLOCK_TSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 12 - Done bit"]
            #[inline]
            pub fn done(&self) -> DONER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DONER { bits }
            }
            #[doc = "Bits 0:11 - Block Transfer Size"]
            #[inline]
            pub fn block_ts(&self) -> BLOCK_TSR {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BLOCK_TSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x02 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 12 - Done bit"]
            #[inline]
            pub fn done(&mut self) -> _DONEW {
                _DONEW { w: self }
            }
            #[doc = "Bits 0:11 - Block Transfer Size"]
            #[inline]
            pub fn block_ts(&mut self) -> _BLOCK_TSW {
                _BLOCK_TSW { w: self }
            }
        }
    }
    #[doc = "Configuration Register Low"]
    pub struct CFGL {
        register: VolatileCell<u32>,
    }
    #[doc = "Configuration Register Low"]
    pub mod cfgl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CFGL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MAX_ABRSTR {
            bits: u16,
        }
        impl MAX_ABRSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRC_HS_POL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRC_HS_POLR {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl SRC_HS_POLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRC_HS_POLR::VALUE1 => false,
                    SRC_HS_POLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRC_HS_POLR {
                match value {
                    false => SRC_HS_POLR::VALUE1,
                    true => SRC_HS_POLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRC_HS_POLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRC_HS_POLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DST_HS_POL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DST_HS_POLR {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl DST_HS_POLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DST_HS_POLR::VALUE1 => false,
                    DST_HS_POLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DST_HS_POLR {
                match value {
                    false => DST_HS_POLR::VALUE1,
                    true => DST_HS_POLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DST_HS_POLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DST_HS_POLR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct LOCK_BR {
            bits: bool,
        }
        impl LOCK_BR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LOCK_CHR {
            bits: bool,
        }
        impl LOCK_CHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `LOCK_B_L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOCK_B_LR {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl LOCK_B_LR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LOCK_B_LR::VALUE1 => 0,
                    LOCK_B_LR::VALUE2 => 0x01,
                    LOCK_B_LR::VALUE3 => 0x02,
                    LOCK_B_LR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LOCK_B_LR {
                match value {
                    0 => LOCK_B_LR::VALUE1,
                    1 => LOCK_B_LR::VALUE2,
                    2 => LOCK_B_LR::VALUE3,
                    i => LOCK_B_LR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOCK_B_LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOCK_B_LR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LOCK_B_LR::VALUE3
            }
        }
        #[doc = "Possible values of the field `LOCK_CH_L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOCK_CH_LR {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl LOCK_CH_LR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LOCK_CH_LR::VALUE1 => 0,
                    LOCK_CH_LR::VALUE2 => 0x01,
                    LOCK_CH_LR::VALUE3 => 0x02,
                    LOCK_CH_LR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LOCK_CH_LR {
                match value {
                    0 => LOCK_CH_LR::VALUE1,
                    1 => LOCK_CH_LR::VALUE2,
                    2 => LOCK_CH_LR::VALUE3,
                    i => LOCK_CH_LR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOCK_CH_LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOCK_CH_LR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LOCK_CH_LR::VALUE3
            }
        }
        #[doc = "Possible values of the field `HS_SEL_SRC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HS_SEL_SRCR {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware-initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_SRCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HS_SEL_SRCR::VALUE1 => false,
                    HS_SEL_SRCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HS_SEL_SRCR {
                match value {
                    false => HS_SEL_SRCR::VALUE1,
                    true => HS_SEL_SRCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HS_SEL_SRCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HS_SEL_SRCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HS_SEL_DST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HS_SEL_DSTR {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware- initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_DSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HS_SEL_DSTR::VALUE1 => false,
                    HS_SEL_DSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HS_SEL_DSTR {
                match value {
                    false => HS_SEL_DSTR::VALUE1,
                    true => HS_SEL_DSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HS_SEL_DSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HS_SEL_DSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FIFO_EMPTY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFO_EMPTYR {
            #[doc = "Channel FIFO empty"]
            VALUE1,
            #[doc = "Channel FIFO not empty"]
            VALUE2,
        }
        impl FIFO_EMPTYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFO_EMPTYR::VALUE1 => true,
                    FIFO_EMPTYR::VALUE2 => false,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFO_EMPTYR {
                match value {
                    true => FIFO_EMPTYR::VALUE1,
                    false => FIFO_EMPTYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFO_EMPTYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFO_EMPTYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CH_SUSP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CH_SUSPR {
            #[doc = "Not suspended."]
            VALUE1,
            #[doc = "Suspend DMA transfer from the source."]
            VALUE2,
        }
        impl CH_SUSPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CH_SUSPR::VALUE1 => false,
                    CH_SUSPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CH_SUSPR {
                match value {
                    false => CH_SUSPR::VALUE1,
                    true => CH_SUSPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CH_SUSPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CH_SUSPR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CH_PRIORR {
            bits: u8,
        }
        impl CH_PRIORR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _MAX_ABRSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MAX_ABRSTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRC_HS_POL`"]
        pub enum SRC_HS_POLW {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl SRC_HS_POLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRC_HS_POLW::VALUE1 => false,
                    SRC_HS_POLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_HS_POLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_HS_POLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRC_HS_POLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active high"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRC_HS_POLW::VALUE1)
            }
            #[doc = "Active low"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRC_HS_POLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DST_HS_POL`"]
        pub enum DST_HS_POLW {
            #[doc = "Active high"]
            VALUE1,
            #[doc = "Active low"]
            VALUE2,
        }
        impl DST_HS_POLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DST_HS_POLW::VALUE1 => false,
                    DST_HS_POLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DST_HS_POLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DST_HS_POLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DST_HS_POLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active high"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DST_HS_POLW::VALUE1)
            }
            #[doc = "Active low"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DST_HS_POLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_BW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_BW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_CHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_CHW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOCK_B_L`"]
        pub enum LOCK_B_LW {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
        }
        impl LOCK_B_LW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LOCK_B_LW::VALUE1 => 0,
                    LOCK_B_LW::VALUE2 => 1,
                    LOCK_B_LW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_B_LW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_B_LW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOCK_B_LW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Over complete DMA transfer"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOCK_B_LW::VALUE1)
            }
            #[doc = "Over complete DMA block transfer"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOCK_B_LW::VALUE2)
            }
            #[doc = "Over complete DMA transaction"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LOCK_B_LW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOCK_CH_L`"]
        pub enum LOCK_CH_LW {
            #[doc = "Over complete DMA transfer"]
            VALUE1,
            #[doc = "Over complete DMA block transfer"]
            VALUE2,
            #[doc = "Over complete DMA transaction"]
            VALUE3,
        }
        impl LOCK_CH_LW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LOCK_CH_LW::VALUE1 => 0,
                    LOCK_CH_LW::VALUE2 => 1,
                    LOCK_CH_LW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOCK_CH_LW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOCK_CH_LW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOCK_CH_LW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Over complete DMA transfer"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOCK_CH_LW::VALUE1)
            }
            #[doc = "Over complete DMA block transfer"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOCK_CH_LW::VALUE2)
            }
            #[doc = "Over complete DMA transaction"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LOCK_CH_LW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HS_SEL_SRC`"]
        pub enum HS_SEL_SRCW {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware-initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_SRCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HS_SEL_SRCW::VALUE1 => false,
                    HS_SEL_SRCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HS_SEL_SRCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HS_SEL_SRCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HS_SEL_SRCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HS_SEL_SRCW::VALUE1)
            }
            #[doc = "Software handshaking interface. Hardware-initiated transaction requests are ignored."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HS_SEL_SRCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HS_SEL_DST`"]
        pub enum HS_SEL_DSTW {
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            VALUE1,
            #[doc = "Software handshaking interface. Hardware- initiated transaction requests are ignored."]
            VALUE2,
        }
        impl HS_SEL_DSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HS_SEL_DSTW::VALUE1 => false,
                    HS_SEL_DSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HS_SEL_DSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HS_SEL_DSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HS_SEL_DSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Hardware handshaking interface. Software-initiated transaction requests are ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HS_SEL_DSTW::VALUE1)
            }
            #[doc = "Software handshaking interface. Hardware- initiated transaction requests are ignored."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HS_SEL_DSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CH_SUSP`"]
        pub enum CH_SUSPW {
            #[doc = "Not suspended."]
            VALUE1,
            #[doc = "Suspend DMA transfer from the source."]
            VALUE2,
        }
        impl CH_SUSPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CH_SUSPW::VALUE1 => false,
                    CH_SUSPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH_SUSPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH_SUSPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CH_SUSPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not suspended."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CH_SUSPW::VALUE1)
            }
            #[doc = "Suspend DMA transfer from the source."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CH_SUSPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CH_PRIORW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CH_PRIORW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 20:29 - Maximum AMBA Burst Length"]
            #[inline]
            pub fn max_abrst(&self) -> MAX_ABRSTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MAX_ABRSTR { bits }
            }
            #[doc = "Bit 19 - Source Handshaking Interface Polarity"]
            #[inline]
            pub fn src_hs_pol(&self) -> SRC_HS_POLR {
                SRC_HS_POLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Destination Handshaking Interface Polarity"]
            #[inline]
            pub fn dst_hs_pol(&self) -> DST_HS_POLR {
                DST_HS_POLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Bus Lock Bit"]
            #[inline]
            pub fn lock_b(&self) -> LOCK_BR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LOCK_BR { bits }
            }
            #[doc = "Bit 16 - Channel Lock Bit"]
            #[inline]
            pub fn lock_ch(&self) -> LOCK_CHR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LOCK_CHR { bits }
            }
            #[doc = "Bits 14:15 - Bus Lock Level"]
            #[inline]
            pub fn lock_b_l(&self) -> LOCK_B_LR {
                LOCK_B_LR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Channel Lock Level"]
            #[inline]
            pub fn lock_ch_l(&self) -> LOCK_CH_LR {
                LOCK_CH_LR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 11 - Source Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_src(&self) -> HS_SEL_SRCR {
                HS_SEL_SRCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Destination Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_dst(&self) -> HS_SEL_DSTR {
                HS_SEL_DSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Indicates if there is data left in the channel FIFO"]
            #[inline]
            pub fn fifo_empty(&self) -> FIFO_EMPTYR {
                FIFO_EMPTYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Channel Suspend"]
            #[inline]
            pub fn ch_susp(&self) -> CH_SUSPR {
                CH_SUSPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 5:7 - Channel priority"]
            #[inline]
            pub fn ch_prior(&self) -> CH_PRIORR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CH_PRIORR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0e00 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 20:29 - Maximum AMBA Burst Length"]
            #[inline]
            pub fn max_abrst(&mut self) -> _MAX_ABRSTW {
                _MAX_ABRSTW { w: self }
            }
            #[doc = "Bit 19 - Source Handshaking Interface Polarity"]
            #[inline]
            pub fn src_hs_pol(&mut self) -> _SRC_HS_POLW {
                _SRC_HS_POLW { w: self }
            }
            #[doc = "Bit 18 - Destination Handshaking Interface Polarity"]
            #[inline]
            pub fn dst_hs_pol(&mut self) -> _DST_HS_POLW {
                _DST_HS_POLW { w: self }
            }
            #[doc = "Bit 17 - Bus Lock Bit"]
            #[inline]
            pub fn lock_b(&mut self) -> _LOCK_BW {
                _LOCK_BW { w: self }
            }
            #[doc = "Bit 16 - Channel Lock Bit"]
            #[inline]
            pub fn lock_ch(&mut self) -> _LOCK_CHW {
                _LOCK_CHW { w: self }
            }
            #[doc = "Bits 14:15 - Bus Lock Level"]
            #[inline]
            pub fn lock_b_l(&mut self) -> _LOCK_B_LW {
                _LOCK_B_LW { w: self }
            }
            #[doc = "Bits 12:13 - Channel Lock Level"]
            #[inline]
            pub fn lock_ch_l(&mut self) -> _LOCK_CH_LW {
                _LOCK_CH_LW { w: self }
            }
            #[doc = "Bit 11 - Source Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_src(&mut self) -> _HS_SEL_SRCW {
                _HS_SEL_SRCW { w: self }
            }
            #[doc = "Bit 10 - Destination Software or Hardware Handshaking Select"]
            #[inline]
            pub fn hs_sel_dst(&mut self) -> _HS_SEL_DSTW {
                _HS_SEL_DSTW { w: self }
            }
            #[doc = "Bit 8 - Channel Suspend"]
            #[inline]
            pub fn ch_susp(&mut self) -> _CH_SUSPW {
                _CH_SUSPW { w: self }
            }
            #[doc = "Bits 5:7 - Channel priority"]
            #[inline]
            pub fn ch_prior(&mut self) -> _CH_PRIORW {
                _CH_PRIORW { w: self }
            }
        }
    }
    #[doc = "Configuration Register High"]
    pub struct CFGH {
        register: VolatileCell<u32>,
    }
    #[doc = "Configuration Register High"]
    pub mod cfgh {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CFGH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEST_PERR {
            bits: u8,
        }
        impl DEST_PERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SRC_PERR {
            bits: u8,
        }
        impl SRC_PERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PROTCTLR {
            bits: u8,
        }
        impl PROTCTLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FIFO_MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFO_MODER {
            #[doc = "Space/data available for single AHB transfer of the specified transfer width."]
            VALUE1,
            #[doc = "Data available is greater than or equal to half the FIFO depth for destination transfers and space available is greater than half the fifo depth for source transfers. The exceptions are at the end of a burst transaction request or at the end of a block transfer."]
            VALUE2,
        }
        impl FIFO_MODER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFO_MODER::VALUE1 => false,
                    FIFO_MODER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFO_MODER {
                match value {
                    false => FIFO_MODER::VALUE1,
                    true => FIFO_MODER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFO_MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFO_MODER::VALUE2
            }
        }
        #[doc = "Possible values of the field `FCMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCMODER {
            #[doc = "Source transaction requests are serviced when they occur. Data pre-fetching is enabled."]
            VALUE1,
            #[doc = "Source transaction requests are not serviced until a destination transaction request occurs. In this mode, the amount of data transferred from the source is limited so that it is guaranteed to be transferred to the destination prior to block termination by the destination. Data pre-fetching is disabled."]
            VALUE2,
        }
        impl FCMODER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCMODER::VALUE1 => false,
                    FCMODER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCMODER {
                match value {
                    false => FCMODER::VALUE1,
                    true => FCMODER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCMODER::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEST_PERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEST_PERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRC_PERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRC_PERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PROTCTLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PROTCTLW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FIFO_MODE`"]
        pub enum FIFO_MODEW {
            #[doc = "Space/data available for single AHB transfer of the specified transfer width."]
            VALUE1,
            #[doc = "Data available is greater than or equal to half the FIFO depth for destination transfers and space available is greater than half the fifo depth for source transfers. The exceptions are at the end of a burst transaction request or at the end of a block transfer."]
            VALUE2,
        }
        impl FIFO_MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FIFO_MODEW::VALUE1 => false,
                    FIFO_MODEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FIFO_MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FIFO_MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FIFO_MODEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Space/data available for single AHB transfer of the specified transfer width."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FIFO_MODEW::VALUE1)
            }
            #[doc = "Data available is greater than or equal to half the FIFO depth for destination transfers and space available is greater than half the fifo depth for source transfers. The exceptions are at the end of a burst transaction request or at the end of a block transfer."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FIFO_MODEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FCMODE`"]
        pub enum FCMODEW {
            #[doc = "Source transaction requests are serviced when they occur. Data pre-fetching is enabled."]
            VALUE1,
            #[doc = "Source transaction requests are not serviced until a destination transaction request occurs. In this mode, the amount of data transferred from the source is limited so that it is guaranteed to be transferred to the destination prior to block termination by the destination. Data pre-fetching is disabled."]
            VALUE2,
        }
        impl FCMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FCMODEW::VALUE1 => false,
                    FCMODEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FCMODEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Source transaction requests are serviced when they occur. Data pre-fetching is enabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FCMODEW::VALUE1)
            }
            #[doc = "Source transaction requests are not serviced until a destination transaction request occurs. In this mode, the amount of data transferred from the source is limited so that it is guaranteed to be transferred to the destination prior to block termination by the destination. Data pre-fetching is disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FCMODEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 11:14 - Destination Peripheral"]
            #[inline]
            pub fn dest_per(&self) -> DEST_PERR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DEST_PERR { bits }
            }
            #[doc = "Bits 7:10 - Source Peripheral"]
            #[inline]
            pub fn src_per(&self) -> SRC_PERR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SRC_PERR { bits }
            }
            #[doc = "Bits 2:4 - Protection Control"]
            #[inline]
            pub fn protctl(&self) -> PROTCTLR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PROTCTLR { bits }
            }
            #[doc = "Bit 1 - FIFO Mode Select"]
            #[inline]
            pub fn fifo_mode(&self) -> FIFO_MODER {
                FIFO_MODER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 0 - Flow Control Mode"]
            #[inline]
            pub fn fcmode(&self) -> FCMODER {
                FCMODER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x04 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 11:14 - Destination Peripheral"]
            #[inline]
            pub fn dest_per(&mut self) -> _DEST_PERW {
                _DEST_PERW { w: self }
            }
            #[doc = "Bits 7:10 - Source Peripheral"]
            #[inline]
            pub fn src_per(&mut self) -> _SRC_PERW {
                _SRC_PERW { w: self }
            }
            #[doc = "Bits 2:4 - Protection Control"]
            #[inline]
            pub fn protctl(&mut self) -> _PROTCTLW {
                _PROTCTLW { w: self }
            }
            #[doc = "Bit 1 - FIFO Mode Select"]
            #[inline]
            pub fn fifo_mode(&mut self) -> _FIFO_MODEW {
                _FIFO_MODEW { w: self }
            }
            #[doc = "Bit 0 - Flow Control Mode"]
            #[inline]
            pub fn fcmode(&mut self) -> _FCMODEW {
                _FCMODEW { w: self }
            }
        }
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub struct GPDMA0_CH2 {
    register_block: gpdma0_ch2::RegisterBlock,
}
impl Deref for GPDMA0_CH2 {
    type Target = gpdma0_ch2::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH3: Peripheral<GPDMA0_CH3> = unsafe { Peripheral::new(0x5001_4108) };
#[doc = r" Register block"]
pub struct GPDMA0_CH3 {
    register_block: gpdma0_ch2::RegisterBlock,
}
impl Deref for GPDMA0_CH3 {
    type Target = gpdma0_ch2::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH4: Peripheral<GPDMA0_CH4> = unsafe { Peripheral::new(0x5001_4160) };
#[doc = r" Register block"]
pub struct GPDMA0_CH4 {
    register_block: gpdma0_ch2::RegisterBlock,
}
impl Deref for GPDMA0_CH4 {
    type Target = gpdma0_ch2::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH5: Peripheral<GPDMA0_CH5> = unsafe { Peripheral::new(0x5001_41b8) };
#[doc = r" Register block"]
pub struct GPDMA0_CH5 {
    register_block: gpdma0_ch2::RegisterBlock,
}
impl Deref for GPDMA0_CH5 {
    type Target = gpdma0_ch2::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH6: Peripheral<GPDMA0_CH6> = unsafe { Peripheral::new(0x5001_4210) };
#[doc = r" Register block"]
pub struct GPDMA0_CH6 {
    register_block: gpdma0_ch2::RegisterBlock,
}
impl Deref for GPDMA0_CH6 {
    type Target = gpdma0_ch2::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "General Purpose DMA Unit 0"]
pub const GPDMA0_CH7: Peripheral<GPDMA0_CH7> = unsafe { Peripheral::new(0x5001_4268) };
#[doc = r" Register block"]
pub struct GPDMA0_CH7 {
    register_block: gpdma0_ch2::RegisterBlock,
}
impl Deref for GPDMA0_CH7 {
    type Target = gpdma0_ch2::RegisterBlock;
    fn deref(&self) -> &gpdma0_ch2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Flexible CRC Engine"]
pub const FCE: Peripheral<FCE> = unsafe { Peripheral::new(0x5002_0000) };
#[doc = "Flexible CRC Engine"]
pub mod fce {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Clock Control Register"]
        pub clc: CLC,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Module Identification Register"]
        pub id: ID,
    }
    #[doc = "Clock Control Register"]
    pub struct CLC {
        register: VolatileCell<u32>,
    }
    #[doc = "Clock Control Register"]
    pub mod clc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISRR {
            bits: bool,
        }
        impl DISRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISSR {
            bits: bool,
        }
        impl DISSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Module Disable Request Bit"]
            #[inline]
            pub fn disr(&self) -> DISRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISRR { bits }
            }
            #[doc = "Bit 1 - Module Disable Status Bit"]
            #[inline]
            pub fn diss(&self) -> DISSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x03 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Module Disable Request Bit"]
            #[inline]
            pub fn disr(&mut self) -> _DISRW {
                _DISRW { w: self }
            }
        }
    }
    #[doc = "Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision Number"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number Value"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
}
#[doc = "Flexible CRC Engine"]
pub struct FCE {
    register_block: fce::RegisterBlock,
}
impl Deref for FCE {
    type Target = fce::RegisterBlock;
    fn deref(&self) -> &fce::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Flexible CRC Engine"]
pub const FCE_KE0: Peripheral<FCE_KE0> = unsafe { Peripheral::new(0x5002_0020) };
#[doc = "Flexible CRC Engine"]
pub mod fce_ke0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Input Register"]
        pub ir: IR,
        #[doc = "0x04 - CRC Result Register"]
        pub res: RES,
        #[doc = "0x08 - CRC Configuration Register"]
        pub cfg: CFG,
        #[doc = "0x0c - CRC Status Register"]
        pub sts: STS,
        #[doc = "0x10 - CRC Length Register"]
        pub length: LENGTH,
        #[doc = "0x14 - CRC Check Register"]
        pub check: CHECK,
        #[doc = "0x18 - CRC Register"]
        pub crc: CRC,
        #[doc = "0x1c - CRC Test Register"]
        pub ctr: CTR,
    }
    #[doc = "Input Register"]
    pub struct IR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Register"]
    pub mod ir {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct IRR {
            bits: u32,
        }
        impl IRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _IRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Input Register"]
            #[inline]
            pub fn ir(&self) -> IRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Input Register"]
            #[inline]
            pub fn ir(&mut self) -> _IRW {
                _IRW { w: self }
            }
        }
    }
    #[doc = "CRC Result Register"]
    pub struct RES {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Result Register"]
    pub mod res {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RES {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESR {
            bits: u32,
        }
        impl RESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Result Register"]
            #[inline]
            pub fn res(&self) -> RESR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                RESR { bits }
            }
        }
    }
    #[doc = "CRC Configuration Register"]
    pub struct CFG {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Configuration Register"]
    pub mod cfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CMI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMIR {
            #[doc = "CRC Mismatch Interrupt is disabled"]
            VALUE1,
            #[doc = "CRC Mismatch Interrupt is enabled"]
            VALUE2,
        }
        impl CMIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMIR::VALUE1 => false,
                    CMIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMIR {
                match value {
                    false => CMIR::VALUE1,
                    true => CMIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEIR {
            #[doc = "Configuration Error Interrupt is disabled"]
            VALUE1,
            #[doc = "Configuration Error Interrupt is enabled"]
            VALUE2,
        }
        impl CEIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEIR::VALUE1 => false,
                    CEIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEIR {
                match value {
                    false => CEIR::VALUE1,
                    true => CEIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LEI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LEIR {
            #[doc = "Length Error Interrupt is disabled"]
            VALUE1,
            #[doc = "Length Error Interrupt is enabled"]
            VALUE2,
        }
        impl LEIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LEIR::VALUE1 => false,
                    LEIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LEIR {
                match value {
                    false => LEIR::VALUE1,
                    true => LEIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LEIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LEIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BEI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BEIR {
            #[doc = "Bus Error Interrupt is disabled"]
            VALUE1,
            #[doc = "Bus Error Interrupt is enabled"]
            VALUE2,
        }
        impl BEIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BEIR::VALUE1 => false,
                    BEIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BEIR {
                match value {
                    false => BEIR::VALUE1,
                    true => BEIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BEIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BEIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCER {
            #[doc = "CRC check comparison at the end of a message is disabled"]
            VALUE1,
            #[doc = "CRC check comparison at the end of a message is enabled"]
            VALUE2,
        }
        impl CCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCER::VALUE1 => false,
                    CCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCER {
                match value {
                    false => CCER::VALUE1,
                    true => CCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCER::VALUE2
            }
        }
        #[doc = "Possible values of the field `ALR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ALRR {
            #[doc = "Disables automatic reload of the LENGTH field."]
            VALUE1,
            #[doc = "Enables automatic reload of the LENGTH field at the end of a message."]
            VALUE2,
        }
        impl ALRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ALRR::VALUE1 => false,
                    ALRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ALRR {
                match value {
                    false => ALRR::VALUE1,
                    true => ALRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ALRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ALRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REFIN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REFINR {
            #[doc = "IR Byte Wise Reflection is disabled"]
            VALUE1,
            #[doc = "IR Byte Wise Reflection is enabled"]
            VALUE2,
        }
        impl REFINR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REFINR::VALUE1 => false,
                    REFINR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REFINR {
                match value {
                    false => REFINR::VALUE1,
                    true => REFINR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REFINR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REFINR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REFOUT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REFOUTR {
            #[doc = "CRC 32-bit wise is disabled"]
            VALUE1,
            #[doc = "CRC 32-bit wise is enabled"]
            VALUE2,
        }
        impl REFOUTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REFOUTR::VALUE1 => false,
                    REFOUTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REFOUTR {
                match value {
                    false => REFOUTR::VALUE1,
                    true => REFOUTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REFOUTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REFOUTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `XSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XSELR {
            #[doc = "0x00000000"]
            VALUE1,
            #[doc = "0xFFFFFFFF"]
            VALUE2,
        }
        impl XSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    XSELR::VALUE1 => false,
                    XSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> XSELR {
                match value {
                    false => XSELR::VALUE1,
                    true => XSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XSELR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CMI`"]
        pub enum CMIW {
            #[doc = "CRC Mismatch Interrupt is disabled"]
            VALUE1,
            #[doc = "CRC Mismatch Interrupt is enabled"]
            VALUE2,
        }
        impl CMIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMIW::VALUE1 => false,
                    CMIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "CRC Mismatch Interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMIW::VALUE1)
            }
            #[doc = "CRC Mismatch Interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEI`"]
        pub enum CEIW {
            #[doc = "Configuration Error Interrupt is disabled"]
            VALUE1,
            #[doc = "Configuration Error Interrupt is enabled"]
            VALUE2,
        }
        impl CEIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEIW::VALUE1 => false,
                    CEIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Configuration Error Interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEIW::VALUE1)
            }
            #[doc = "Configuration Error Interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LEI`"]
        pub enum LEIW {
            #[doc = "Length Error Interrupt is disabled"]
            VALUE1,
            #[doc = "Length Error Interrupt is enabled"]
            VALUE2,
        }
        impl LEIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LEIW::VALUE1 => false,
                    LEIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LEIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LEIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LEIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Length Error Interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LEIW::VALUE1)
            }
            #[doc = "Length Error Interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LEIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BEI`"]
        pub enum BEIW {
            #[doc = "Bus Error Interrupt is disabled"]
            VALUE1,
            #[doc = "Bus Error Interrupt is enabled"]
            VALUE2,
        }
        impl BEIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BEIW::VALUE1 => false,
                    BEIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BEIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BEIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BEIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Bus Error Interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BEIW::VALUE1)
            }
            #[doc = "Bus Error Interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BEIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCE`"]
        pub enum CCEW {
            #[doc = "CRC check comparison at the end of a message is disabled"]
            VALUE1,
            #[doc = "CRC check comparison at the end of a message is enabled"]
            VALUE2,
        }
        impl CCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCEW::VALUE1 => false,
                    CCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "CRC check comparison at the end of a message is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCEW::VALUE1)
            }
            #[doc = "CRC check comparison at the end of a message is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ALR`"]
        pub enum ALRW {
            #[doc = "Disables automatic reload of the LENGTH field."]
            VALUE1,
            #[doc = "Enables automatic reload of the LENGTH field at the end of a message."]
            VALUE2,
        }
        impl ALRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ALRW::VALUE1 => false,
                    ALRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ALRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disables automatic reload of the LENGTH field."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ALRW::VALUE1)
            }
            #[doc = "Enables automatic reload of the LENGTH field at the end of a message."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ALRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REFIN`"]
        pub enum REFINW {
            #[doc = "IR Byte Wise Reflection is disabled"]
            VALUE1,
            #[doc = "IR Byte Wise Reflection is enabled"]
            VALUE2,
        }
        impl REFINW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REFINW::VALUE1 => false,
                    REFINW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REFINW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REFINW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REFINW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "IR Byte Wise Reflection is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REFINW::VALUE1)
            }
            #[doc = "IR Byte Wise Reflection is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REFINW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REFOUT`"]
        pub enum REFOUTW {
            #[doc = "CRC 32-bit wise is disabled"]
            VALUE1,
            #[doc = "CRC 32-bit wise is enabled"]
            VALUE2,
        }
        impl REFOUTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REFOUTW::VALUE1 => false,
                    REFOUTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REFOUTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REFOUTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REFOUTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "CRC 32-bit wise is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REFOUTW::VALUE1)
            }
            #[doc = "CRC 32-bit wise is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REFOUTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XSEL`"]
        pub enum XSELW {
            #[doc = "0x00000000"]
            VALUE1,
            #[doc = "0xFFFFFFFF"]
            VALUE2,
        }
        impl XSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XSELW::VALUE1 => false,
                    XSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "0x00000000"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XSELW::VALUE1)
            }
            #[doc = "0xFFFFFFFF"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - CRC Mismatch Interrupt"]
            #[inline]
            pub fn cmi(&self) -> CMIR {
                CMIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Configuration Error Interrupt"]
            #[inline]
            pub fn cei(&self) -> CEIR {
                CEIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Length Error Interrupt"]
            #[inline]
            pub fn lei(&self) -> LEIR {
                LEIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Bus Error Interrupt"]
            #[inline]
            pub fn bei(&self) -> BEIR {
                BEIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - CRC Check Comparison"]
            #[inline]
            pub fn cce(&self) -> CCER {
                CCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Automatic Length Reload"]
            #[inline]
            pub fn alr(&self) -> ALRR {
                ALRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - IR Byte Wise Reflection"]
            #[inline]
            pub fn refin(&self) -> REFINR {
                REFINR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - CRC 32-Bit Wise Reflection"]
            #[inline]
            pub fn refout(&self) -> REFOUTR {
                REFOUTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Selects the value to be xored with the final CRC"]
            #[inline]
            pub fn xsel(&self) -> XSELR {
                XSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0700 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CRC Mismatch Interrupt"]
            #[inline]
            pub fn cmi(&mut self) -> _CMIW {
                _CMIW { w: self }
            }
            #[doc = "Bit 1 - Configuration Error Interrupt"]
            #[inline]
            pub fn cei(&mut self) -> _CEIW {
                _CEIW { w: self }
            }
            #[doc = "Bit 2 - Length Error Interrupt"]
            #[inline]
            pub fn lei(&mut self) -> _LEIW {
                _LEIW { w: self }
            }
            #[doc = "Bit 3 - Bus Error Interrupt"]
            #[inline]
            pub fn bei(&mut self) -> _BEIW {
                _BEIW { w: self }
            }
            #[doc = "Bit 4 - CRC Check Comparison"]
            #[inline]
            pub fn cce(&mut self) -> _CCEW {
                _CCEW { w: self }
            }
            #[doc = "Bit 5 - Automatic Length Reload"]
            #[inline]
            pub fn alr(&mut self) -> _ALRW {
                _ALRW { w: self }
            }
            #[doc = "Bit 8 - IR Byte Wise Reflection"]
            #[inline]
            pub fn refin(&mut self) -> _REFINW {
                _REFINW { w: self }
            }
            #[doc = "Bit 9 - CRC 32-Bit Wise Reflection"]
            #[inline]
            pub fn refout(&mut self) -> _REFOUTW {
                _REFOUTW { w: self }
            }
            #[doc = "Bit 10 - Selects the value to be xored with the final CRC"]
            #[inline]
            pub fn xsel(&mut self) -> _XSELW {
                _XSELW { w: self }
            }
        }
    }
    #[doc = "CRC Status Register"]
    pub struct STS {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Status Register"]
    pub mod sts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::STS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMFR {
            bits: bool,
        }
        impl CMFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CEFR {
            bits: bool,
        }
        impl CEFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LEFR {
            bits: bool,
        }
        impl LEFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BEFR {
            bits: bool,
        }
        impl BEFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LEFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LEFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BEFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BEFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - CRC Mismatch Flag"]
            #[inline]
            pub fn cmf(&self) -> CMFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CMFR { bits }
            }
            #[doc = "Bit 1 - Configuration Error Flag"]
            #[inline]
            pub fn cef(&self) -> CEFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CEFR { bits }
            }
            #[doc = "Bit 2 - Length Error Flag"]
            #[inline]
            pub fn lef(&self) -> LEFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LEFR { bits }
            }
            #[doc = "Bit 3 - Bus Error Flag"]
            #[inline]
            pub fn bef(&self) -> BEFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BEFR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CRC Mismatch Flag"]
            #[inline]
            pub fn cmf(&mut self) -> _CMFW {
                _CMFW { w: self }
            }
            #[doc = "Bit 1 - Configuration Error Flag"]
            #[inline]
            pub fn cef(&mut self) -> _CEFW {
                _CEFW { w: self }
            }
            #[doc = "Bit 2 - Length Error Flag"]
            #[inline]
            pub fn lef(&mut self) -> _LEFW {
                _LEFW { w: self }
            }
            #[doc = "Bit 3 - Bus Error Flag"]
            #[inline]
            pub fn bef(&mut self) -> _BEFW {
                _BEFW { w: self }
            }
        }
    }
    #[doc = "CRC Length Register"]
    pub struct LENGTH {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Length Register"]
    pub mod length {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LENGTH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LENGTHR {
            bits: u16,
        }
        impl LENGTHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _LENGTHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LENGTHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Message Length Register"]
            #[inline]
            pub fn length(&self) -> LENGTHR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                LENGTHR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Message Length Register"]
            #[inline]
            pub fn length(&mut self) -> _LENGTHW {
                _LENGTHW { w: self }
            }
        }
    }
    #[doc = "CRC Check Register"]
    pub struct CHECK {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Check Register"]
    pub mod check {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CHECK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CHECKR {
            bits: u32,
        }
        impl CHECKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHECKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHECKW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - CHECK Register"]
            #[inline]
            pub fn check(&self) -> CHECKR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                CHECKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - CHECK Register"]
            #[inline]
            pub fn check(&mut self) -> _CHECKW {
                _CHECKW { w: self }
            }
        }
    }
    #[doc = "CRC Register"]
    pub struct CRC {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Register"]
    pub mod crc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CRC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CRCR {
            bits: u32,
        }
        impl CRCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - CRC Register"]
            #[inline]
            pub fn crc(&self) -> CRCR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                CRCR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - CRC Register"]
            #[inline]
            pub fn crc(&mut self) -> _CRCW {
                _CRCW { w: self }
            }
        }
    }
    #[doc = "CRC Test Register"]
    pub struct CTR {
        register: VolatileCell<u32>,
    }
    #[doc = "CRC Test Register"]
    pub mod ctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct FCMR {
            bits: bool,
        }
        impl FCMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct FRM_CFGR {
            bits: bool,
        }
        impl FRM_CFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct FRM_CHECKR {
            bits: bool,
        }
        impl FRM_CHECKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _FRM_CFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FRM_CFGW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _FRM_CHECKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FRM_CHECKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Force CRC Mismatch"]
            #[inline]
            pub fn fcm(&self) -> FCMR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FCMR { bits }
            }
            #[doc = "Bit 1 - Force CFG Register Mismatch"]
            #[inline]
            pub fn frm_cfg(&self) -> FRM_CFGR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FRM_CFGR { bits }
            }
            #[doc = "Bit 2 - Force Check Register Mismatch"]
            #[inline]
            pub fn frm_check(&self) -> FRM_CHECKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FRM_CHECKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Force CRC Mismatch"]
            #[inline]
            pub fn fcm(&mut self) -> _FCMW {
                _FCMW { w: self }
            }
            #[doc = "Bit 1 - Force CFG Register Mismatch"]
            #[inline]
            pub fn frm_cfg(&mut self) -> _FRM_CFGW {
                _FRM_CFGW { w: self }
            }
            #[doc = "Bit 2 - Force Check Register Mismatch"]
            #[inline]
            pub fn frm_check(&mut self) -> _FRM_CHECKW {
                _FRM_CHECKW { w: self }
            }
        }
    }
}
#[doc = "Flexible CRC Engine"]
pub struct FCE_KE0 {
    register_block: fce_ke0::RegisterBlock,
}
impl Deref for FCE_KE0 {
    type Target = fce_ke0::RegisterBlock;
    fn deref(&self) -> &fce_ke0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Flexible CRC Engine"]
pub const FCE_KE1: Peripheral<FCE_KE1> = unsafe { Peripheral::new(0x5002_0040) };
#[doc = r" Register block"]
pub struct FCE_KE1 {
    register_block: fce_ke0::RegisterBlock,
}
impl Deref for FCE_KE1 {
    type Target = fce_ke0::RegisterBlock;
    fn deref(&self) -> &fce_ke0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Flexible CRC Engine"]
pub const FCE_KE2: Peripheral<FCE_KE2> = unsafe { Peripheral::new(0x5002_0060) };
#[doc = r" Register block"]
pub struct FCE_KE2 {
    register_block: fce_ke0::RegisterBlock,
}
impl Deref for FCE_KE2 {
    type Target = fce_ke0::RegisterBlock;
    fn deref(&self) -> &fce_ke0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Flexible CRC Engine"]
pub const FCE_KE3: Peripheral<FCE_KE3> = unsafe { Peripheral::new(0x5002_0080) };
#[doc = r" Register block"]
pub struct FCE_KE3 {
    register_block: fce_ke0::RegisterBlock,
}
impl Deref for FCE_KE3 {
    type Target = fce_ke0::RegisterBlock;
    fn deref(&self) -> &fce_ke0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Peripheral Bridge AHB 0"]
pub const PBA0: Peripheral<PBA0> = unsafe { Peripheral::new(0x4000_0000) };
#[doc = "Peripheral Bridge AHB 0"]
pub mod pba0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Peripheral Bridge Status Register"]
        pub sts: STS,
        #[doc = "0x04 - PBA Write Error Address Register"]
        pub waddr: WADDR,
    }
    #[doc = "Peripheral Bridge Status Register"]
    pub struct STS {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral Bridge Status Register"]
    pub mod sts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::STS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `WERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WERRR {
            #[doc = "no write error occurred."]
            VALUE1,
            #[doc = "write error occurred, interrupt request is pending."]
            VALUE2,
        }
        impl WERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WERRR::VALUE1 => false,
                    WERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WERRR {
                match value {
                    false => WERRR::VALUE1,
                    true => WERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WERRR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WERR`"]
        pub enum WERRW {
            #[doc = "no write error occurred."]
            VALUE1,
            #[doc = "write error occurred, interrupt request is pending."]
            VALUE2,
        }
        impl WERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WERRW::VALUE1 => false,
                    WERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "no write error occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WERRW::VALUE1)
            }
            #[doc = "write error occurred, interrupt request is pending."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Bufferable Write Access Error"]
            #[inline]
            pub fn werr(&self) -> WERRR {
                WERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Bufferable Write Access Error"]
            #[inline]
            pub fn werr(&mut self) -> _WERRW {
                _WERRW { w: self }
            }
        }
    }
    #[doc = "PBA Write Error Address Register"]
    pub struct WADDR {
        register: VolatileCell<u32>,
    }
    #[doc = "PBA Write Error Address Register"]
    pub mod waddr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::WADDR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct WADDRR {
            bits: u32,
        }
        impl WADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Write Error Address"]
            #[inline]
            pub fn waddr(&self) -> WADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                WADDRR { bits }
            }
        }
    }
}
#[doc = "Peripheral Bridge AHB 0"]
pub struct PBA0 {
    register_block: pba0::RegisterBlock,
}
impl Deref for PBA0 {
    type Target = pba0::RegisterBlock;
    fn deref(&self) -> &pba0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Peripheral Bridge AHB 1"]
pub const PBA1: Peripheral<PBA1> = unsafe { Peripheral::new(0x4800_0000) };
#[doc = r" Register block"]
pub struct PBA1 {
    register_block: pba0::RegisterBlock,
}
impl Deref for PBA1 {
    type Target = pba0::RegisterBlock;
    fn deref(&self) -> &pba0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Flash Memory Controller"]
pub const FLASH0: Peripheral<FLASH0> = unsafe { Peripheral::new(0x5800_1000) };
#[doc = "Flash Memory Controller"]
pub mod flash0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        _reserved0: [u8; 4104usize],
        #[doc = "0x1008 - Flash Module Identification Register"]
        pub id: ID,
        _reserved1: [u8; 4usize],
        #[doc = "0x1010 - Flash Status Register"]
        pub fsr: FSR,
        #[doc = "0x1014 - Flash Configuration Register"]
        pub fcon: FCON,
        #[doc = "0x1018 - Margin Control Register PFLASH"]
        pub marp: MARP,
        _reserved2: [u8; 4usize],
        #[doc = "0x1020 - Flash Protection Configuration Register User 0"]
        pub procon0: PROCON0,
        #[doc = "0x1024 - Flash Protection Configuration Register User 1"]
        pub procon1: PROCON1,
        #[doc = "0x1028 - Flash Protection Configuration Register User 2"]
        pub procon2: PROCON2,
    }
    #[doc = "Flash Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Flash Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision Number"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number Value"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "Flash Status Register"]
    pub struct FSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Flash Status Register"]
    pub mod fsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::FSR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PBUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PBUSYR {
            #[doc = "PFLASH ready, not busy; PFLASH in read mode."]
            VALUE1,
            #[doc = "PFLASH busy; PFLASH not in read mode."]
            VALUE2,
        }
        impl PBUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PBUSYR::VALUE1 => false,
                    PBUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PBUSYR {
                match value {
                    false => PBUSYR::VALUE1,
                    true => PBUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PBUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PBUSYR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct FABUSYR {
            bits: bool,
        }
        impl FABUSYR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `PROG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PROGR {
            #[doc = "There is no program operation requested or in progress or just finished."]
            VALUE1,
            #[doc = "Programming operation (write page) requested (from FIM) or in action or finished."]
            VALUE2,
        }
        impl PROGR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PROGR::VALUE1 => false,
                    PROGR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PROGR {
                match value {
                    false => PROGR::VALUE1,
                    true => PROGR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PROGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PROGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERASE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERASER {
            #[doc = "There is no erase operation requested or in progress or just finished"]
            VALUE1,
            #[doc = "Erase operation requested (from FIM) or in action or finished."]
            VALUE2,
        }
        impl ERASER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERASER::VALUE1 => false,
                    ERASER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERASER {
                match value {
                    false => ERASER::VALUE1,
                    true => ERASER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERASER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERASER::VALUE2
            }
        }
        #[doc = "Possible values of the field `PFPAGE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PFPAGER {
            #[doc = "Program Flash not in page mode"]
            VALUE1,
            #[doc = "Program Flash in page mode; assembly buffer of PFLASH (256 byte) is in use (being filled up)"]
            VALUE2,
        }
        impl PFPAGER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PFPAGER::VALUE1 => false,
                    PFPAGER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PFPAGER {
                match value {
                    false => PFPAGER::VALUE1,
                    true => PFPAGER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PFPAGER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PFPAGER::VALUE2
            }
        }
        #[doc = "Possible values of the field `PFOPER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PFOPERR {
            #[doc = "No operation error reported by Program Flash"]
            VALUE1,
            #[doc = "Flash array operation aborted, because of a Flash array failure, e.g. an ECC error in microcode."]
            VALUE2,
        }
        impl PFOPERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PFOPERR::VALUE1 => false,
                    PFOPERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PFOPERR {
                match value {
                    false => PFOPERR::VALUE1,
                    true => PFOPERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PFOPERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PFOPERR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SQER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SQERR {
            #[doc = "No sequence error"]
            VALUE1,
            #[doc = "Command state machine operation unsuccessful because of improper address or command sequence."]
            VALUE2,
        }
        impl SQERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SQERR::VALUE1 => false,
                    SQERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SQERR {
                match value {
                    false => SQERR::VALUE1,
                    true => SQERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SQERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SQERR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PROER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PROERR {
            #[doc = "No protection error"]
            VALUE1,
            #[doc = "Protection error."]
            VALUE2,
        }
        impl PROERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PROERR::VALUE1 => false,
                    PROERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PROERR {
                match value {
                    false => PROERR::VALUE1,
                    true => PROERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PROERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PROERR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PFSBER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PFSBERR {
            #[doc = "No Single-Bit Error detected during read access to PFLASH"]
            VALUE1,
            #[doc = "Single-Bit Error detected and corrected"]
            VALUE2,
        }
        impl PFSBERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PFSBERR::VALUE1 => false,
                    PFSBERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PFSBERR {
                match value {
                    false => PFSBERR::VALUE1,
                    true => PFSBERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PFSBERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PFSBERR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PFDBER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PFDBERR {
            #[doc = "No Double-Bit Error detected during read access to PFLASH"]
            VALUE1,
            #[doc = "Double-Bit Error detected in PFLASH"]
            VALUE2,
        }
        impl PFDBERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PFDBERR::VALUE1 => false,
                    PFDBERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PFDBERR {
                match value {
                    false => PFDBERR::VALUE1,
                    true => PFDBERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PFDBERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PFDBERR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PROIN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PROINR {
            #[doc = "No protection is installed"]
            VALUE1,
            #[doc = "Read or/and write protection for one or more users is configured and correctly confirmed in the User Configuration Block(s)."]
            VALUE2,
        }
        impl PROINR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PROINR::VALUE1 => false,
                    PROINR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PROINR {
                match value {
                    false => PROINR::VALUE1,
                    true => PROINR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PROINR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PROINR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPROIN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPROINR {
            #[doc = "No read protection installed"]
            VALUE1,
            #[doc = "Read protection and global write protection is configured and correctly confirmed in the User Configuration Block 0."]
            VALUE2,
        }
        impl RPROINR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPROINR::VALUE1 => false,
                    RPROINR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPROINR {
                match value {
                    false => RPROINR::VALUE1,
                    true => RPROINR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPROINR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPROINR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPRODIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPRODISR {
            #[doc = "Read protection (if installed) is not disabled"]
            VALUE1,
            #[doc = "Read and global write protection is temporarily disabled."]
            VALUE2,
        }
        impl RPRODISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPRODISR::VALUE1 => false,
                    RPRODISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPRODISR {
                match value {
                    false => RPRODISR::VALUE1,
                    true => RPRODISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPRODISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPRODISR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WPROIN0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WPROIN0R {
            #[doc = "No write protection installed for user 0"]
            VALUE1,
            #[doc = "Sector write protection for user 0 is configured and correctly confirmed in the User Configuration Block 0."]
            VALUE2,
        }
        impl WPROIN0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WPROIN0R::VALUE1 => false,
                    WPROIN0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WPROIN0R {
                match value {
                    false => WPROIN0R::VALUE1,
                    true => WPROIN0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WPROIN0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WPROIN0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `WPROIN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WPROIN1R {
            #[doc = "No write protection installed for user 1"]
            VALUE1,
            #[doc = "Sector write protection for user 1 is configured and correctly confirmed in the User Configuration Block 1."]
            VALUE2,
        }
        impl WPROIN1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WPROIN1R::VALUE1 => false,
                    WPROIN1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WPROIN1R {
                match value {
                    false => WPROIN1R::VALUE1,
                    true => WPROIN1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WPROIN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WPROIN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `WPROIN2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WPROIN2R {
            #[doc = "No OTP write protection installed for user 2"]
            VALUE1,
            #[doc = "Sector OTP write protection with ROM functionality is configured and correctly confirmed in the UCB2. The protection is locked for ever."]
            VALUE2,
        }
        impl WPROIN2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WPROIN2R::VALUE1 => false,
                    WPROIN2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WPROIN2R {
                match value {
                    false => WPROIN2R::VALUE1,
                    true => WPROIN2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WPROIN2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WPROIN2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `WPRODIS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WPRODIS0R {
            #[doc = "All protected sectors of user 0 are locked if write protection is installed"]
            VALUE1,
            #[doc = "All write-protected sectors of user 0 are temporarily unlocked, if not coincidently locked by user 2 or via read protection."]
            VALUE2,
        }
        impl WPRODIS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WPRODIS0R::VALUE1 => false,
                    WPRODIS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WPRODIS0R {
                match value {
                    false => WPRODIS0R::VALUE1,
                    true => WPRODIS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WPRODIS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WPRODIS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `WPRODIS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WPRODIS1R {
            #[doc = "All protected sectors of user 1 are locked if write protection is installed"]
            VALUE1,
            #[doc = "All write-protected sectors of user 1 are temporarily unlocked, if not coincidently locked by user 0 or user 2 or via read protection."]
            VALUE2,
        }
        impl WPRODIS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WPRODIS1R::VALUE1 => false,
                    WPRODIS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WPRODIS1R {
                match value {
                    false => WPRODIS1R::VALUE1,
                    true => WPRODIS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WPRODIS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WPRODIS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `SLM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SLMR {
            #[doc = "Flash not in sleep mode"]
            VALUE1,
            #[doc = "Flash is in sleep or shut down mode"]
            VALUE2,
        }
        impl SLMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SLMR::VALUE1 => false,
                    SLMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SLMR {
                match value {
                    false => SLMR::VALUE1,
                    true => SLMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SLMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SLMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VER`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VERR {
            #[doc = "The page is correctly programmed or the sector correctly erased. All programmed or erased bits have full expected quality."]
            VALUE1,
            #[doc = "A program verify error or an erase verify error has been detected. Full quality (retention time) of all programmed (\"1\") or erased (\"0\") bits cannot be guaranteed."]
            VALUE2,
        }
        impl VERR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VERR::VALUE1 => false,
                    VERR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VERR {
                match value {
                    false => VERR::VALUE1,
                    true => VERR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VERR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VERR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Program Flash Busy"]
            #[inline]
            pub fn pbusy(&self) -> PBUSYR {
                PBUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Flash Array Busy"]
            #[inline]
            pub fn fabusy(&self) -> FABUSYR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FABUSYR { bits }
            }
            #[doc = "Bit 4 - Programming State"]
            #[inline]
            pub fn prog(&self) -> PROGR {
                PROGR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Erase State"]
            #[inline]
            pub fn erase(&self) -> ERASER {
                ERASER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Program Flash in Page Mode"]
            #[inline]
            pub fn pfpage(&self) -> PFPAGER {
                PFPAGER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Program Flash Operation Error"]
            #[inline]
            pub fn pfoper(&self) -> PFOPERR {
                PFOPERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Command Sequence Error"]
            #[inline]
            pub fn sqer(&self) -> SQERR {
                SQERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Protection Error"]
            #[inline]
            pub fn proer(&self) -> PROERR {
                PROERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - PFLASH Single-Bit Error and Correction"]
            #[inline]
            pub fn pfsber(&self) -> PFSBERR {
                PFSBERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - PFLASH Double-Bit Error"]
            #[inline]
            pub fn pfdber(&self) -> PFDBERR {
                PFDBERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Protection Installed"]
            #[inline]
            pub fn proin(&self) -> PROINR {
                PROINR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Read Protection Installed"]
            #[inline]
            pub fn rproin(&self) -> RPROINR {
                RPROINR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - Read Protection Disable State"]
            #[inline]
            pub fn rprodis(&self) -> RPRODISR {
                RPRODISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - Sector Write Protection Installed for User 0"]
            #[inline]
            pub fn wproin0(&self) -> WPROIN0R {
                WPROIN0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 22 - Sector Write Protection Installed for User 1"]
            #[inline]
            pub fn wproin1(&self) -> WPROIN1R {
                WPROIN1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - Sector OTP Protection Installed for User 2"]
            #[inline]
            pub fn wproin2(&self) -> WPROIN2R {
                WPROIN2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Sector Write Protection Disabled for User 0"]
            #[inline]
            pub fn wprodis0(&self) -> WPRODIS0R {
                WPRODIS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Sector Write Protection Disabled for User 1"]
            #[inline]
            pub fn wprodis1(&self) -> WPRODIS1R {
                WPRODIS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - Flash Sleep Mode"]
            #[inline]
            pub fn slm(&self) -> SLMR {
                SLMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Verify Error"]
            #[inline]
            pub fn ver(&self) -> VERR {
                VERR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Flash Configuration Register"]
    pub struct FCON {
        register: VolatileCell<u32>,
    }
    #[doc = "Flash Configuration Register"]
    pub mod fcon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `WSPFLASH`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WSPFLASHR {
            #[doc = "PFLASH access in one clock cycle"]
            VALUE1,
            #[doc = "PFLASH access in one clock cycle"]
            VALUE2,
            #[doc = "PFLASH access in two clock cycles"]
            VALUE3,
            #[doc = "PFLASH access in three clock cycles"]
            VALUE4,
            #[doc = "PFLASH access in fifteen clock cycles."]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl WSPFLASHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    WSPFLASHR::VALUE1 => 0,
                    WSPFLASHR::VALUE2 => 0x01,
                    WSPFLASHR::VALUE3 => 0x02,
                    WSPFLASHR::VALUE4 => 0x03,
                    WSPFLASHR::VALUE5 => 0x0f,
                    WSPFLASHR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> WSPFLASHR {
                match value {
                    0 => WSPFLASHR::VALUE1,
                    1 => WSPFLASHR::VALUE2,
                    2 => WSPFLASHR::VALUE3,
                    3 => WSPFLASHR::VALUE4,
                    15 => WSPFLASHR::VALUE5,
                    i => WSPFLASHR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WSPFLASHR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WSPFLASHR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == WSPFLASHR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == WSPFLASHR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == WSPFLASHR::VALUE5
            }
        }
        #[doc = "Possible values of the field `WSECPF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WSECPFR {
            #[doc = "No additional wait state for error correction"]
            VALUE1,
            #[doc = "One additional wait state for error correction during read access to Program Flash. If enabled, this wait state is only used for the first transfer of a burst transfer."]
            VALUE2,
        }
        impl WSECPFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WSECPFR::VALUE1 => false,
                    WSECPFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WSECPFR {
                match value {
                    false => WSECPFR::VALUE1,
                    true => WSECPFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WSECPFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WSECPFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IDLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IDLER {
            #[doc = "Normal/standard Flash read operation"]
            VALUE1,
            #[doc = "Dynamic idle of Program Flash enabled for power saving; static prefetching disabled"]
            VALUE2,
        }
        impl IDLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IDLER::VALUE1 => false,
                    IDLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IDLER {
                match value {
                    false => IDLER::VALUE1,
                    true => IDLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IDLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IDLER::VALUE2
            }
        }
        #[doc = "Possible values of the field `ESLDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ESLDISR {
            #[doc = "External sleep request signal input is enabled"]
            VALUE1,
            #[doc = "Externally requested Flash sleep is disabled"]
            VALUE2,
        }
        impl ESLDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ESLDISR::VALUE1 => false,
                    ESLDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ESLDISR {
                match value {
                    false => ESLDISR::VALUE1,
                    true => ESLDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ESLDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ESLDISR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SLEEP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SLEEPR {
            #[doc = "Normal state or wake-up"]
            VALUE1,
            #[doc = "Flash sleep mode is requested"]
            VALUE2,
        }
        impl SLEEPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SLEEPR::VALUE1 => false,
                    SLEEPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SLEEPR {
                match value {
                    false => SLEEPR::VALUE1,
                    true => SLEEPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SLEEPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SLEEPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPAR {
            #[doc = "The Flash-internal read protection is not activated. Bits DCF, DDF are not taken into account. Bits DCF, DDFx can be cleared"]
            VALUE1,
            #[doc = "The Flash-internal read protection is activated. Bits DCF, DDF are enabled and evaluated."]
            VALUE2,
        }
        impl RPAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPAR::VALUE1 => false,
                    RPAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPAR {
                match value {
                    false => RPAR::VALUE1,
                    true => RPAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DCF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCFR {
            #[doc = "Code fetching from the Flash memory area is allowed."]
            VALUE1,
            #[doc = "Code fetching from the Flash memory area is not allowed. This bit is not taken into account while RPA='0'."]
            VALUE2,
        }
        impl DCFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCFR::VALUE1 => false,
                    DCFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCFR {
                match value {
                    false => DCFR::VALUE1,
                    true => DCFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DDF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DDFR {
            #[doc = "Data read access to the Flash memory area is allowed."]
            VALUE1,
            #[doc = "Data read access to the Flash memory area is not allowed. This bit is not taken into account while RPA='0'."]
            VALUE2,
        }
        impl DDFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DDFR::VALUE1 => false,
                    DDFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DDFR {
                match value {
                    false => DDFR::VALUE1,
                    true => DDFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DDFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DDFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VOPERM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VOPERMR {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "Flash interrupt because of Verify Error or Operation Error in Flash array (FSI) is enabled"]
            VALUE2,
        }
        impl VOPERMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VOPERMR::VALUE1 => false,
                    VOPERMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VOPERMR {
                match value {
                    false => VOPERMR::VALUE1,
                    true => VOPERMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VOPERMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VOPERMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SQERM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SQERMR {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "Flash interrupt because of Sequence Error is enabled"]
            VALUE2,
        }
        impl SQERMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SQERMR::VALUE1 => false,
                    SQERMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SQERMR {
                match value {
                    false => SQERMR::VALUE1,
                    true => SQERMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SQERMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SQERMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PROERM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PROERMR {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "Flash interrupt because of Protection Error is enabled"]
            VALUE2,
        }
        impl PROERMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PROERMR::VALUE1 => false,
                    PROERMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PROERMR {
                match value {
                    false => PROERMR::VALUE1,
                    true => PROERMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PROERMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PROERMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PFSBERM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PFSBERMR {
            #[doc = "No Single-Bit Error interrupt enabled"]
            VALUE1,
            #[doc = "Single-Bit Error interrupt enabled for PFLASH"]
            VALUE2,
        }
        impl PFSBERMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PFSBERMR::VALUE1 => false,
                    PFSBERMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PFSBERMR {
                match value {
                    false => PFSBERMR::VALUE1,
                    true => PFSBERMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PFSBERMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PFSBERMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PFDBERM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PFDBERMR {
            #[doc = "Double-Bit Error interrupt for PFLASH not enabled"]
            VALUE1,
            #[doc = "Double-Bit Error interrupt for PFLASH enabled. Especially intended for margin check"]
            VALUE2,
        }
        impl PFDBERMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PFDBERMR::VALUE1 => false,
                    PFDBERMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PFDBERMR {
                match value {
                    false => PFDBERMR::VALUE1,
                    true => PFDBERMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PFDBERMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PFDBERMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EOBM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EOBMR {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "EOB interrupt is enabled"]
            VALUE2,
        }
        impl EOBMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EOBMR::VALUE1 => false,
                    EOBMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EOBMR {
                match value {
                    false => EOBMR::VALUE1,
                    true => EOBMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EOBMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EOBMR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WSPFLASH`"]
        pub enum WSPFLASHW {
            #[doc = "PFLASH access in one clock cycle"]
            VALUE1,
            #[doc = "PFLASH access in one clock cycle"]
            VALUE2,
            #[doc = "PFLASH access in two clock cycles"]
            VALUE3,
            #[doc = "PFLASH access in three clock cycles"]
            VALUE4,
            #[doc = "PFLASH access in fifteen clock cycles."]
            VALUE5,
        }
        impl WSPFLASHW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WSPFLASHW::VALUE1 => 0,
                    WSPFLASHW::VALUE2 => 1,
                    WSPFLASHW::VALUE3 => 2,
                    WSPFLASHW::VALUE4 => 3,
                    WSPFLASHW::VALUE5 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WSPFLASHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WSPFLASHW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WSPFLASHW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "PFLASH access in one clock cycle"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WSPFLASHW::VALUE1)
            }
            #[doc = "PFLASH access in one clock cycle"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WSPFLASHW::VALUE2)
            }
            #[doc = "PFLASH access in two clock cycles"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(WSPFLASHW::VALUE3)
            }
            #[doc = "PFLASH access in three clock cycles"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(WSPFLASHW::VALUE4)
            }
            #[doc = "PFLASH access in fifteen clock cycles."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(WSPFLASHW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WSECPF`"]
        pub enum WSECPFW {
            #[doc = "No additional wait state for error correction"]
            VALUE1,
            #[doc = "One additional wait state for error correction during read access to Program Flash. If enabled, this wait state is only used for the first transfer of a burst transfer."]
            VALUE2,
        }
        impl WSECPFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WSECPFW::VALUE1 => false,
                    WSECPFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WSECPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WSECPFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WSECPFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No additional wait state for error correction"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WSECPFW::VALUE1)
            }
            #[doc = "One additional wait state for error correction during read access to Program Flash. If enabled, this wait state is only used for the first transfer of a burst transfer."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WSECPFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IDLE`"]
        pub enum IDLEW {
            #[doc = "Normal/standard Flash read operation"]
            VALUE1,
            #[doc = "Dynamic idle of Program Flash enabled for power saving; static prefetching disabled"]
            VALUE2,
        }
        impl IDLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IDLEW::VALUE1 => false,
                    IDLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IDLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IDLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IDLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal/standard Flash read operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IDLEW::VALUE1)
            }
            #[doc = "Dynamic idle of Program Flash enabled for power saving; static prefetching disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IDLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ESLDIS`"]
        pub enum ESLDISW {
            #[doc = "External sleep request signal input is enabled"]
            VALUE1,
            #[doc = "Externally requested Flash sleep is disabled"]
            VALUE2,
        }
        impl ESLDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ESLDISW::VALUE1 => false,
                    ESLDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ESLDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ESLDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ESLDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External sleep request signal input is enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ESLDISW::VALUE1)
            }
            #[doc = "Externally requested Flash sleep is disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ESLDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SLEEP`"]
        pub enum SLEEPW {
            #[doc = "Normal state or wake-up"]
            VALUE1,
            #[doc = "Flash sleep mode is requested"]
            VALUE2,
        }
        impl SLEEPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SLEEPW::VALUE1 => false,
                    SLEEPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLEEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLEEPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SLEEPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal state or wake-up"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SLEEPW::VALUE1)
            }
            #[doc = "Flash sleep mode is requested"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SLEEPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCF`"]
        pub enum DCFW {
            #[doc = "Code fetching from the Flash memory area is allowed."]
            VALUE1,
            #[doc = "Code fetching from the Flash memory area is not allowed. This bit is not taken into account while RPA='0'."]
            VALUE2,
        }
        impl DCFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCFW::VALUE1 => false,
                    DCFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Code fetching from the Flash memory area is allowed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCFW::VALUE1)
            }
            #[doc = "Code fetching from the Flash memory area is not allowed. This bit is not taken into account while RPA='0'."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DDF`"]
        pub enum DDFW {
            #[doc = "Data read access to the Flash memory area is allowed."]
            VALUE1,
            #[doc = "Data read access to the Flash memory area is not allowed. This bit is not taken into account while RPA='0'."]
            VALUE2,
        }
        impl DDFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DDFW::VALUE1 => false,
                    DDFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DDFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DDFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DDFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Data read access to the Flash memory area is allowed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DDFW::VALUE1)
            }
            #[doc = "Data read access to the Flash memory area is not allowed. This bit is not taken into account while RPA='0'."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DDFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VOPERM`"]
        pub enum VOPERMW {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "Flash interrupt because of Verify Error or Operation Error in Flash array (FSI) is enabled"]
            VALUE2,
        }
        impl VOPERMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VOPERMW::VALUE1 => false,
                    VOPERMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VOPERMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VOPERMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VOPERMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Interrupt not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VOPERMW::VALUE1)
            }
            #[doc = "Flash interrupt because of Verify Error or Operation Error in Flash array (FSI) is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VOPERMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SQERM`"]
        pub enum SQERMW {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "Flash interrupt because of Sequence Error is enabled"]
            VALUE2,
        }
        impl SQERMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SQERMW::VALUE1 => false,
                    SQERMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SQERMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SQERMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SQERMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Interrupt not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SQERMW::VALUE1)
            }
            #[doc = "Flash interrupt because of Sequence Error is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SQERMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PROERM`"]
        pub enum PROERMW {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "Flash interrupt because of Protection Error is enabled"]
            VALUE2,
        }
        impl PROERMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PROERMW::VALUE1 => false,
                    PROERMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PROERMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PROERMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PROERMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Interrupt not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PROERMW::VALUE1)
            }
            #[doc = "Flash interrupt because of Protection Error is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PROERMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PFSBERM`"]
        pub enum PFSBERMW {
            #[doc = "No Single-Bit Error interrupt enabled"]
            VALUE1,
            #[doc = "Single-Bit Error interrupt enabled for PFLASH"]
            VALUE2,
        }
        impl PFSBERMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PFSBERMW::VALUE1 => false,
                    PFSBERMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PFSBERMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PFSBERMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PFSBERMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No Single-Bit Error interrupt enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PFSBERMW::VALUE1)
            }
            #[doc = "Single-Bit Error interrupt enabled for PFLASH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PFSBERMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PFDBERM`"]
        pub enum PFDBERMW {
            #[doc = "Double-Bit Error interrupt for PFLASH not enabled"]
            VALUE1,
            #[doc = "Double-Bit Error interrupt for PFLASH enabled. Especially intended for margin check"]
            VALUE2,
        }
        impl PFDBERMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PFDBERMW::VALUE1 => false,
                    PFDBERMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PFDBERMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PFDBERMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PFDBERMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Double-Bit Error interrupt for PFLASH not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PFDBERMW::VALUE1)
            }
            #[doc = "Double-Bit Error interrupt for PFLASH enabled. Especially intended for margin check"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PFDBERMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EOBM`"]
        pub enum EOBMW {
            #[doc = "Interrupt not enabled"]
            VALUE1,
            #[doc = "EOB interrupt is enabled"]
            VALUE2,
        }
        impl EOBMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EOBMW::VALUE1 => false,
                    EOBMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EOBMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EOBMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EOBMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Interrupt not enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EOBMW::VALUE1)
            }
            #[doc = "EOB interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EOBMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Wait States for read access to PFLASH"]
            #[inline]
            pub fn wspflash(&self) -> WSPFLASHR {
                WSPFLASHR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Wait State for Error Correction of PFLASH"]
            #[inline]
            pub fn wsecpf(&self) -> WSECPFR {
                WSECPFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Dynamic Flash Idle"]
            #[inline]
            pub fn idle(&self) -> IDLER {
                IDLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - External Sleep Request Disable"]
            #[inline]
            pub fn esldis(&self) -> ESLDISR {
                ESLDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Flash SLEEP"]
            #[inline]
            pub fn sleep(&self) -> SLEEPR {
                SLEEPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Read Protection Activated"]
            #[inline]
            pub fn rpa(&self) -> RPAR {
                RPAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Disable Code Fetch from Flash Memory"]
            #[inline]
            pub fn dcf(&self) -> DCFR {
                DCFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Disable Any Data Fetch from Flash"]
            #[inline]
            pub fn ddf(&self) -> DDFR {
                DDFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Verify and Operation Error Interrupt Mask"]
            #[inline]
            pub fn voperm(&self) -> VOPERMR {
                VOPERMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Command Sequence Error Interrupt Mask"]
            #[inline]
            pub fn sqerm(&self) -> SQERMR {
                SQERMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Protection Error Interrupt Mask"]
            #[inline]
            pub fn proerm(&self) -> PROERMR {
                PROERMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - PFLASH Single-Bit Error Interrupt Mask"]
            #[inline]
            pub fn pfsberm(&self) -> PFSBERMR {
                PFSBERMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - PFLASH Double-Bit Error Interrupt Mask"]
            #[inline]
            pub fn pfdberm(&self) -> PFDBERMR {
                PFDBERMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - End of Busy Interrupt Mask"]
            #[inline]
            pub fn eobm(&self) -> EOBMR {
                EOBMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x06 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Wait States for read access to PFLASH"]
            #[inline]
            pub fn wspflash(&mut self) -> _WSPFLASHW {
                _WSPFLASHW { w: self }
            }
            #[doc = "Bit 4 - Wait State for Error Correction of PFLASH"]
            #[inline]
            pub fn wsecpf(&mut self) -> _WSECPFW {
                _WSECPFW { w: self }
            }
            #[doc = "Bit 13 - Dynamic Flash Idle"]
            #[inline]
            pub fn idle(&mut self) -> _IDLEW {
                _IDLEW { w: self }
            }
            #[doc = "Bit 14 - External Sleep Request Disable"]
            #[inline]
            pub fn esldis(&mut self) -> _ESLDISW {
                _ESLDISW { w: self }
            }
            #[doc = "Bit 15 - Flash SLEEP"]
            #[inline]
            pub fn sleep(&mut self) -> _SLEEPW {
                _SLEEPW { w: self }
            }
            #[doc = "Bit 17 - Disable Code Fetch from Flash Memory"]
            #[inline]
            pub fn dcf(&mut self) -> _DCFW {
                _DCFW { w: self }
            }
            #[doc = "Bit 18 - Disable Any Data Fetch from Flash"]
            #[inline]
            pub fn ddf(&mut self) -> _DDFW {
                _DDFW { w: self }
            }
            #[doc = "Bit 24 - Verify and Operation Error Interrupt Mask"]
            #[inline]
            pub fn voperm(&mut self) -> _VOPERMW {
                _VOPERMW { w: self }
            }
            #[doc = "Bit 25 - Command Sequence Error Interrupt Mask"]
            #[inline]
            pub fn sqerm(&mut self) -> _SQERMW {
                _SQERMW { w: self }
            }
            #[doc = "Bit 26 - Protection Error Interrupt Mask"]
            #[inline]
            pub fn proerm(&mut self) -> _PROERMW {
                _PROERMW { w: self }
            }
            #[doc = "Bit 27 - PFLASH Single-Bit Error Interrupt Mask"]
            #[inline]
            pub fn pfsberm(&mut self) -> _PFSBERMW {
                _PFSBERMW { w: self }
            }
            #[doc = "Bit 29 - PFLASH Double-Bit Error Interrupt Mask"]
            #[inline]
            pub fn pfdberm(&mut self) -> _PFDBERMW {
                _PFDBERMW { w: self }
            }
            #[doc = "Bit 31 - End of Busy Interrupt Mask"]
            #[inline]
            pub fn eobm(&mut self) -> _EOBMW {
                _EOBMW { w: self }
            }
        }
    }
    #[doc = "Margin Control Register PFLASH"]
    pub struct MARP {
        register: VolatileCell<u32>,
    }
    #[doc = "Margin Control Register PFLASH"]
    pub mod marp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MARP {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MARGIN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MARGINR {
            #[doc = "Standard (default) margin."]
            VALUE1,
            #[doc = "Tight margin for 0 (low) level. Suboptimal 0-bits are read as 1s."]
            VALUE2,
            #[doc = "Tight margin for 1 (high) level. Suboptimal 1-bits are read as 0s."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MARGINR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MARGINR::VALUE1 => 0,
                    MARGINR::VALUE2 => 0x01,
                    MARGINR::VALUE3 => 0x04,
                    MARGINR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MARGINR {
                match value {
                    0 => MARGINR::VALUE1,
                    1 => MARGINR::VALUE2,
                    4 => MARGINR::VALUE3,
                    i => MARGINR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MARGINR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MARGINR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MARGINR::VALUE3
            }
        }
        #[doc = "Possible values of the field `TRAPDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRAPDISR {
            #[doc = "If a double-bit error occurs in PFLASH, a bus error trap is generated."]
            VALUE1,
            #[doc = "The double-bit error trap is disabled. Shall be used only during margin check"]
            VALUE2,
        }
        impl TRAPDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRAPDISR::VALUE1 => false,
                    TRAPDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRAPDISR {
                match value {
                    false => TRAPDISR::VALUE1,
                    true => TRAPDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRAPDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRAPDISR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `MARGIN`"]
        pub enum MARGINW {
            #[doc = "Standard (default) margin."]
            VALUE1,
            #[doc = "Tight margin for 0 (low) level. Suboptimal 0-bits are read as 1s."]
            VALUE2,
            #[doc = "Tight margin for 1 (high) level. Suboptimal 1-bits are read as 0s."]
            VALUE3,
        }
        impl MARGINW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MARGINW::VALUE1 => 0,
                    MARGINW::VALUE2 => 1,
                    MARGINW::VALUE3 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MARGINW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MARGINW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MARGINW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Standard (default) margin."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MARGINW::VALUE1)
            }
            #[doc = "Tight margin for 0 (low) level. Suboptimal 0-bits are read as 1s."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MARGINW::VALUE2)
            }
            #[doc = "Tight margin for 1 (high) level. Suboptimal 1-bits are read as 0s."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MARGINW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRAPDIS`"]
        pub enum TRAPDISW {
            #[doc = "If a double-bit error occurs in PFLASH, a bus error trap is generated."]
            VALUE1,
            #[doc = "The double-bit error trap is disabled. Shall be used only during margin check"]
            VALUE2,
        }
        impl TRAPDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRAPDISW::VALUE1 => false,
                    TRAPDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRAPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRAPDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRAPDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "If a double-bit error occurs in PFLASH, a bus error trap is generated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRAPDISW::VALUE1)
            }
            #[doc = "The double-bit error trap is disabled. Shall be used only during margin check"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRAPDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - PFLASH Margin Selection"]
            #[inline]
            pub fn margin(&self) -> MARGINR {
                MARGINR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - PFLASH Double-Bit Error Trap Disable"]
            #[inline]
            pub fn trapdis(&self) -> TRAPDISR {
                TRAPDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - PFLASH Margin Selection"]
            #[inline]
            pub fn margin(&mut self) -> _MARGINW {
                _MARGINW { w: self }
            }
            #[doc = "Bit 15 - PFLASH Double-Bit Error Trap Disable"]
            #[inline]
            pub fn trapdis(&mut self) -> _TRAPDISW {
                _TRAPDISW { w: self }
            }
        }
    }
    #[doc = "Flash Protection Configuration Register User 0"]
    pub struct PROCON0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Flash Protection Configuration Register User 0"]
    pub mod procon0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PROCON0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S0LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0LR::VALUE1 => false,
                    S0LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0LR {
                match value {
                    false => S0LR::VALUE1,
                    true => S0LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S1LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1LR::VALUE1 => false,
                    S1LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1LR {
                match value {
                    false => S1LR::VALUE1,
                    true => S1LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S2LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2LR::VALUE1 => false,
                    S2LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2LR {
                match value {
                    false => S2LR::VALUE1,
                    true => S2LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S3LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3LR::VALUE1 => false,
                    S3LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3LR {
                match value {
                    false => S3LR::VALUE1,
                    true => S3LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S4L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S4LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S4LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S4LR::VALUE1 => false,
                    S4LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S4LR {
                match value {
                    false => S4LR::VALUE1,
                    true => S4LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S4LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S4LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S5L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S5LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S5LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S5LR::VALUE1 => false,
                    S5LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S5LR {
                match value {
                    false => S5LR::VALUE1,
                    true => S5LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S5LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S5LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S6L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S6LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S6LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S6LR::VALUE1 => false,
                    S6LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S6LR {
                match value {
                    false => S6LR::VALUE1,
                    true => S6LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S6LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S6LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S7L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S7LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S7LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S7LR::VALUE1 => false,
                    S7LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S7LR {
                match value {
                    false => S7LR::VALUE1,
                    true => S7LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S7LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S7LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S8L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S8LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S8LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S8LR::VALUE1 => false,
                    S8LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S8LR {
                match value {
                    false => S8LR::VALUE1,
                    true => S8LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S8LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S8LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPRO`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPROR {
            #[doc = "No read protection configured"]
            VALUE1,
            #[doc = "Read protection and global write protection is configured by user 0 (master user)"]
            VALUE2,
        }
        impl RPROR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPROR::VALUE1 => false,
                    RPROR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPROR {
                match value {
                    false => RPROR::VALUE1,
                    true => RPROR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPROR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPROR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Sector 0 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s0l(&self) -> S0LR {
                S0LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Sector 1 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s1l(&self) -> S1LR {
                S1LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Sector 2 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s2l(&self) -> S2LR {
                S2LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Sector 3 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s3l(&self) -> S3LR {
                S3LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Sector 4 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s4l(&self) -> S4LR {
                S4LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Sector 5 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s5l(&self) -> S5LR {
                S5LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Sector 6 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s6l(&self) -> S6LR {
                S6LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Sector 7 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s7l(&self) -> S7LR {
                S7LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Sector 8 Locked for Write Protection by User 0"]
            #[inline]
            pub fn s8l(&self) -> S8LR {
                S8LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Read Protection Configuration"]
            #[inline]
            pub fn rpro(&self) -> RPROR {
                RPROR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Flash Protection Configuration Register User 1"]
    pub struct PROCON1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Flash Protection Configuration Register User 1"]
    pub mod procon1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PROCON1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S0LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0LR::VALUE1 => false,
                    S0LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0LR {
                match value {
                    false => S0LR::VALUE1,
                    true => S0LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S1LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1LR::VALUE1 => false,
                    S1LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1LR {
                match value {
                    false => S1LR::VALUE1,
                    true => S1LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S2LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2LR::VALUE1 => false,
                    S2LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2LR {
                match value {
                    false => S2LR::VALUE1,
                    true => S2LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S3LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3LR::VALUE1 => false,
                    S3LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3LR {
                match value {
                    false => S3LR::VALUE1,
                    true => S3LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S4L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S4LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S4LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S4LR::VALUE1 => false,
                    S4LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S4LR {
                match value {
                    false => S4LR::VALUE1,
                    true => S4LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S4LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S4LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S5L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S5LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S5LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S5LR::VALUE1 => false,
                    S5LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S5LR {
                match value {
                    false => S5LR::VALUE1,
                    true => S5LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S5LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S5LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S6L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S6LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S6LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S6LR::VALUE1 => false,
                    S6LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S6LR {
                match value {
                    false => S6LR::VALUE1,
                    true => S6LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S6LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S6LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S7L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S7LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S7LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S7LR::VALUE1 => false,
                    S7LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S7LR {
                match value {
                    false => S7LR::VALUE1,
                    true => S7LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S7LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S7LR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S8L`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S8LR {
            #[doc = "No write protection is configured for sector n."]
            VALUE1,
            #[doc = "Write protection is configured for sector n."]
            VALUE2,
        }
        impl S8LR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S8LR::VALUE1 => false,
                    S8LR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S8LR {
                match value {
                    false => S8LR::VALUE1,
                    true => S8LR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S8LR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S8LR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Sector 0 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s0l(&self) -> S0LR {
                S0LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Sector 1 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s1l(&self) -> S1LR {
                S1LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Sector 2 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s2l(&self) -> S2LR {
                S2LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Sector 3 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s3l(&self) -> S3LR {
                S3LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Sector 4 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s4l(&self) -> S4LR {
                S4LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Sector 5 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s5l(&self) -> S5LR {
                S5LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Sector 6 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s6l(&self) -> S6LR {
                S6LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Sector 7 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s7l(&self) -> S7LR {
                S7LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Sector 8 Locked for Write Protection by User 1"]
            #[inline]
            pub fn s8l(&self) -> S8LR {
                S8LR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Flash Protection Configuration Register User 2"]
    pub struct PROCON2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Flash Protection Configuration Register User 2"]
    pub mod procon2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PROCON2 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S0ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0ROMR::VALUE1 => false,
                    S0ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0ROMR {
                match value {
                    false => S0ROMR::VALUE1,
                    true => S0ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S1ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1ROMR::VALUE1 => false,
                    S1ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1ROMR {
                match value {
                    false => S1ROMR::VALUE1,
                    true => S1ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S2ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2ROMR::VALUE1 => false,
                    S2ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2ROMR {
                match value {
                    false => S2ROMR::VALUE1,
                    true => S2ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S3ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3ROMR::VALUE1 => false,
                    S3ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3ROMR {
                match value {
                    false => S3ROMR::VALUE1,
                    true => S3ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S4ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S4ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S4ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S4ROMR::VALUE1 => false,
                    S4ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S4ROMR {
                match value {
                    false => S4ROMR::VALUE1,
                    true => S4ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S4ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S4ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S5ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S5ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S5ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S5ROMR::VALUE1 => false,
                    S5ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S5ROMR {
                match value {
                    false => S5ROMR::VALUE1,
                    true => S5ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S5ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S5ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S6ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S6ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S6ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S6ROMR::VALUE1 => false,
                    S6ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S6ROMR {
                match value {
                    false => S6ROMR::VALUE1,
                    true => S6ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S6ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S6ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S7ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S7ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S7ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S7ROMR::VALUE1 => false,
                    S7ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S7ROMR {
                match value {
                    false => S7ROMR::VALUE1,
                    true => S7ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S7ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S7ROMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S8ROM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S8ROMR {
            #[doc = "No ROM functionality configured for sector n."]
            VALUE1,
            #[doc = "ROM functionality is configured for sector n. Re-programming of this sector is no longer possible."]
            VALUE2,
        }
        impl S8ROMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S8ROMR::VALUE1 => false,
                    S8ROMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S8ROMR {
                match value {
                    false => S8ROMR::VALUE1,
                    true => S8ROMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S8ROMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S8ROMR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Sector 0 Locked Forever by User 2"]
            #[inline]
            pub fn s0rom(&self) -> S0ROMR {
                S0ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Sector 1 Locked Forever by User 2"]
            #[inline]
            pub fn s1rom(&self) -> S1ROMR {
                S1ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Sector 2 Locked Forever by User 2"]
            #[inline]
            pub fn s2rom(&self) -> S2ROMR {
                S2ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Sector 3 Locked Forever by User 2"]
            #[inline]
            pub fn s3rom(&self) -> S3ROMR {
                S3ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Sector 4 Locked Forever by User 2"]
            #[inline]
            pub fn s4rom(&self) -> S4ROMR {
                S4ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Sector 5 Locked Forever by User 2"]
            #[inline]
            pub fn s5rom(&self) -> S5ROMR {
                S5ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Sector 6 Locked Forever by User 2"]
            #[inline]
            pub fn s6rom(&self) -> S6ROMR {
                S6ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Sector 7 Locked Forever by User 2"]
            #[inline]
            pub fn s7rom(&self) -> S7ROMR {
                S7ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Sector 8 Locked Forever by User 2"]
            #[inline]
            pub fn s8rom(&self) -> S8ROMR {
                S8ROMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
}
#[doc = "Flash Memory Controller"]
pub struct FLASH0 {
    register_block: flash0::RegisterBlock,
}
impl Deref for FLASH0 {
    type Target = flash0::RegisterBlock;
    fn deref(&self) -> &flash0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Prefetch Unit"]
pub const PREF: Peripheral<PREF> = unsafe { Peripheral::new(0x5800_4000) };
#[doc = "Prefetch Unit"]
pub mod pref {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Prefetch Configuration Register"]
        pub pcon: PCON,
    }
    #[doc = "Prefetch Configuration Register"]
    pub struct PCON {
        register: VolatileCell<u32>,
    }
    #[doc = "Prefetch Configuration Register"]
    pub mod pcon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `IBYP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IBYPR {
            #[doc = "Instruction prefetch buffer not bypassed."]
            VALUE1,
            #[doc = "Instruction prefetch buffer bypassed."]
            VALUE2,
        }
        impl IBYPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IBYPR::VALUE1 => false,
                    IBYPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IBYPR {
                match value {
                    false => IBYPR::VALUE1,
                    true => IBYPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IBYPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IBYPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DBYP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DBYPR {
            #[doc = "Prefetch Data buffer not bypassed."]
            VALUE1,
            #[doc = "Prefetch Data buffer bypassed."]
            VALUE2,
        }
        impl DBYPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DBYPR::VALUE1 => false,
                    DBYPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DBYPR {
                match value {
                    false => DBYPR::VALUE1,
                    true => DBYPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DBYPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DBYPR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `IBYP`"]
        pub enum IBYPW {
            #[doc = "Instruction prefetch buffer not bypassed."]
            VALUE1,
            #[doc = "Instruction prefetch buffer bypassed."]
            VALUE2,
        }
        impl IBYPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IBYPW::VALUE1 => false,
                    IBYPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IBYPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IBYPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IBYPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Instruction prefetch buffer not bypassed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IBYPW::VALUE1)
            }
            #[doc = "Instruction prefetch buffer bypassed."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IBYPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IINV`"]
        pub enum IINVW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Initiate invalidation of entire instruction cache."]
            VALUE2,
        }
        impl IINVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IINVW::VALUE1 => false,
                    IINVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IINVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IINVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IINVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IINVW::VALUE1)
            }
            #[doc = "Initiate invalidation of entire instruction cache."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IINVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DBYP`"]
        pub enum DBYPW {
            #[doc = "Prefetch Data buffer not bypassed."]
            VALUE1,
            #[doc = "Prefetch Data buffer bypassed."]
            VALUE2,
        }
        impl DBYPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DBYPW::VALUE1 => false,
                    DBYPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DBYPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DBYPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DBYPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Prefetch Data buffer not bypassed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DBYPW::VALUE1)
            }
            #[doc = "Prefetch Data buffer bypassed."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DBYPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Instruction Prefetch Buffer Bypass"]
            #[inline]
            pub fn ibyp(&self) -> IBYPR {
                IBYPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Data Buffer Bypass"]
            #[inline]
            pub fn dbyp(&self) -> DBYPR {
                DBYPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Instruction Prefetch Buffer Bypass"]
            #[inline]
            pub fn ibyp(&mut self) -> _IBYPW {
                _IBYPW { w: self }
            }
            #[doc = "Bit 1 - Instruction Prefetch Buffer Invalidate"]
            #[inline]
            pub fn iinv(&mut self) -> _IINVW {
                _IINVW { w: self }
            }
            #[doc = "Bit 4 - Data Buffer Bypass"]
            #[inline]
            pub fn dbyp(&mut self) -> _DBYPW {
                _DBYPW { w: self }
            }
        }
    }
}
#[doc = "Prefetch Unit"]
pub struct PREF {
    register_block: pref::RegisterBlock,
}
impl Deref for PREF {
    type Target = pref::RegisterBlock;
    fn deref(&self) -> &pref::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Program Management Unit"]
pub const PMU0: Peripheral<PMU0> = unsafe { Peripheral::new(0x5800_0508) };
#[doc = "Program Management Unit"]
pub mod pmu0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - PMU0 Identification Register"]
        pub id: ID,
    }
    #[doc = "PMU0 Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "PMU0 Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision Number"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number Value"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
}
#[doc = "Program Management Unit"]
pub struct PMU0 {
    register_block: pmu0::RegisterBlock,
}
impl Deref for PMU0 {
    type Target = pmu0::RegisterBlock;
    fn deref(&self) -> &pmu0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Watch Dog Timer"]
pub const WDT: Peripheral<WDT> = unsafe { Peripheral::new(0x5000_8000) };
#[doc = "Watch Dog Timer"]
pub mod wdt {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - WDT ID Register"]
        pub id: ID,
        #[doc = "0x04 - WDT Control Register"]
        pub ctr: CTR,
        #[doc = "0x08 - WDT Service Register"]
        pub srv: SRV,
        #[doc = "0x0c - WDT Timer Register"]
        pub tim: TIM,
        #[doc = "0x10 - WDT Window Lower Bound Register"]
        pub wlb: WLB,
        #[doc = "0x14 - WDT Window Upper Bound Register"]
        pub wub: WUB,
        #[doc = "0x18 - WDT Status Register"]
        pub wdtsts: WDTSTS,
        #[doc = "0x1c - WDT Clear Register"]
        pub wdtclr: WDTCLR,
    }
    #[doc = "WDT ID Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT ID Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "WDT Control Register"]
    pub struct CTR {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Control Register"]
    pub mod ctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENBR {
            bits: bool,
        }
        impl ENBR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRER {
            bits: bool,
        }
        impl PRER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSPR {
            bits: bool,
        }
        impl DSPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPWR {
            bits: u8,
        }
        impl SPWR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PREW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PREW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPWW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Enable"]
            #[inline]
            pub fn enb(&self) -> ENBR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENBR { bits }
            }
            #[doc = "Bit 1 - Pre-warning"]
            #[inline]
            pub fn pre(&self) -> PRER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PRER { bits }
            }
            #[doc = "Bit 4 - Debug Suspend"]
            #[inline]
            pub fn dsp(&self) -> DSPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DSPR { bits }
            }
            #[doc = "Bits 8:15 - Service Indication Pulse Width"]
            #[inline]
            pub fn spw(&self) -> SPWR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SPWR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Enable"]
            #[inline]
            pub fn enb(&mut self) -> _ENBW {
                _ENBW { w: self }
            }
            #[doc = "Bit 1 - Pre-warning"]
            #[inline]
            pub fn pre(&mut self) -> _PREW {
                _PREW { w: self }
            }
            #[doc = "Bit 4 - Debug Suspend"]
            #[inline]
            pub fn dsp(&mut self) -> _DSPW {
                _DSPW { w: self }
            }
            #[doc = "Bits 8:15 - Service Indication Pulse Width"]
            #[inline]
            pub fn spw(&mut self) -> _SPWW {
                _SPWW { w: self }
            }
        }
    }
    #[doc = "WDT Service Register"]
    pub struct SRV {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Service Register"]
    pub mod srv {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRV {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Service"]
            #[inline]
            pub fn srv(&mut self) -> _SRVW {
                _SRVW { w: self }
            }
        }
    }
    #[doc = "WDT Timer Register"]
    pub struct TIM {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Timer Register"]
    pub mod tim {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TIM {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct TIMR {
            bits: u32,
        }
        impl TIMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Timer Value"]
            #[inline]
            pub fn tim(&self) -> TIMR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TIMR { bits }
            }
        }
    }
    #[doc = "WDT Window Lower Bound Register"]
    pub struct WLB {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Window Lower Bound Register"]
    pub mod wlb {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::WLB {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct WLBR {
            bits: u32,
        }
        impl WLBR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _WLBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WLBW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Window Lower Bound"]
            #[inline]
            pub fn wlb(&self) -> WLBR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                WLBR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Window Lower Bound"]
            #[inline]
            pub fn wlb(&mut self) -> _WLBW {
                _WLBW { w: self }
            }
        }
    }
    #[doc = "WDT Window Upper Bound Register"]
    pub struct WUB {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Window Upper Bound Register"]
    pub mod wub {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::WUB {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct WUBR {
            bits: u32,
        }
        impl WUBR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _WUBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WUBW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Window Upper Bound"]
            #[inline]
            pub fn wub(&self) -> WUBR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                WUBR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0xffff_ffff }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Window Upper Bound"]
            #[inline]
            pub fn wub(&mut self) -> _WUBW {
                _WUBW { w: self }
            }
        }
    }
    #[doc = "WDT Status Register"]
    pub struct WDTSTS {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Status Register"]
    pub mod wdtsts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::WDTSTS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct ALMSR {
            bits: bool,
        }
        impl ALMSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Pre-warning Alarm"]
            #[inline]
            pub fn alms(&self) -> ALMSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ALMSR { bits }
            }
        }
    }
    #[doc = "WDT Clear Register"]
    pub struct WDTCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Clear Register"]
    pub mod wdtclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::WDTCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALMCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Pre-warning Alarm"]
            #[inline]
            pub fn almc(&mut self) -> _ALMCW {
                _ALMCW { w: self }
            }
        }
    }
}
#[doc = "Watch Dog Timer"]
pub struct WDT {
    register_block: wdt::RegisterBlock,
}
impl Deref for WDT {
    type Target = wdt::RegisterBlock;
    fn deref(&self) -> &wdt::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Real Time Clock"]
pub const RTC: Peripheral<RTC> = unsafe { Peripheral::new(0x5000_4a00) };
#[doc = "Real Time Clock"]
pub mod rtc {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - RTC ID Register"]
        pub id: ID,
        #[doc = "0x04 - RTC Control Register"]
        pub ctr: CTR,
        #[doc = "0x08 - RTC Raw Service Request Register"]
        pub rawstat: RAWSTAT,
        #[doc = "0x0c - RTC Service Request Status Register"]
        pub stssr: STSSR,
        #[doc = "0x10 - RTC Service Request Mask Register"]
        pub msksr: MSKSR,
        #[doc = "0x14 - RTC Clear Service Request Register"]
        pub clrsr: CLRSR,
        #[doc = "0x18 - RTC Alarm Time Register 0"]
        pub atim0: ATIM0,
        #[doc = "0x1c - RTC Alarm Time Register 1"]
        pub atim1: ATIM1,
        #[doc = "0x20 - RTC Time Register 0"]
        pub tim0: TIM0,
        #[doc = "0x24 - RTC Time Register 1"]
        pub tim1: TIM1,
    }
    #[doc = "RTC ID Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC ID Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "RTC Control Register"]
    pub struct CTR {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Control Register"]
    pub mod ctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENBR {
            bits: bool,
        }
        impl ENBR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TAER {
            bits: bool,
        }
        impl TAER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ESECR {
            bits: bool,
        }
        impl ESECR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMICR {
            bits: bool,
        }
        impl EMICR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EHOCR {
            bits: bool,
        }
        impl EHOCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EDACR {
            bits: bool,
        }
        impl EDACR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMOCR {
            bits: bool,
        }
        impl EMOCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EYECR {
            bits: bool,
        }
        impl EYECR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DIVR {
            bits: u16,
        }
        impl DIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TAEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TAEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ESECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ESECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMICW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMICW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EHOCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EHOCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EDACW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EDACW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMOCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMOCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EYECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EYECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - RTC Module Enable"]
            #[inline]
            pub fn enb(&self) -> ENBR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENBR { bits }
            }
            #[doc = "Bit 2 - Timer Alarm Enable for Hibernation Wake-up"]
            #[inline]
            pub fn tae(&self) -> TAER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TAER { bits }
            }
            #[doc = "Bit 8 - Enable Seconds Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn esec(&self) -> ESECR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ESECR { bits }
            }
            #[doc = "Bit 9 - Enable Minutes Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn emic(&self) -> EMICR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EMICR { bits }
            }
            #[doc = "Bit 10 - Enable Hours Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn ehoc(&self) -> EHOCR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EHOCR { bits }
            }
            #[doc = "Bit 11 - Enable Days Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn edac(&self) -> EDACR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EDACR { bits }
            }
            #[doc = "Bit 13 - Enable Months Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn emoc(&self) -> EMOCR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EMOCR { bits }
            }
            #[doc = "Bit 14 - Enable Years Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn eyec(&self) -> EYECR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EYECR { bits }
            }
            #[doc = "Bits 16:31 - RTC Clock Divider Value"]
            #[inline]
            pub fn div(&self) -> DIVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DIVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x7fff_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - RTC Module Enable"]
            #[inline]
            pub fn enb(&mut self) -> _ENBW {
                _ENBW { w: self }
            }
            #[doc = "Bit 2 - Timer Alarm Enable for Hibernation Wake-up"]
            #[inline]
            pub fn tae(&mut self) -> _TAEW {
                _TAEW { w: self }
            }
            #[doc = "Bit 8 - Enable Seconds Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn esec(&mut self) -> _ESECW {
                _ESECW { w: self }
            }
            #[doc = "Bit 9 - Enable Minutes Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn emic(&mut self) -> _EMICW {
                _EMICW { w: self }
            }
            #[doc = "Bit 10 - Enable Hours Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn ehoc(&mut self) -> _EHOCW {
                _EHOCW { w: self }
            }
            #[doc = "Bit 11 - Enable Days Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn edac(&mut self) -> _EDACW {
                _EDACW { w: self }
            }
            #[doc = "Bit 13 - Enable Months Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn emoc(&mut self) -> _EMOCW {
                _EMOCW { w: self }
            }
            #[doc = "Bit 14 - Enable Years Comparison for Hibernation Wake-up"]
            #[inline]
            pub fn eyec(&mut self) -> _EYECW {
                _EYECW { w: self }
            }
            #[doc = "Bits 16:31 - RTC Clock Divider Value"]
            #[inline]
            pub fn div(&mut self) -> _DIVW {
                _DIVW { w: self }
            }
        }
    }
    #[doc = "RTC Raw Service Request Register"]
    pub struct RAWSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Raw Service Request Register"]
    pub mod rawstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RAWSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct RPSER {
            bits: bool,
        }
        impl RPSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RPMIR {
            bits: bool,
        }
        impl RPMIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RPHOR {
            bits: bool,
        }
        impl RPHOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RPDAR {
            bits: bool,
        }
        impl RPDAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RPMOR {
            bits: bool,
        }
        impl RPMOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RPYER {
            bits: bool,
        }
        impl RPYER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RAIR {
            bits: bool,
        }
        impl RAIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Raw Periodic Seconds Service Request"]
            #[inline]
            pub fn rpse(&self) -> RPSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RPSER { bits }
            }
            #[doc = "Bit 1 - Raw Periodic Minutes Service Request"]
            #[inline]
            pub fn rpmi(&self) -> RPMIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RPMIR { bits }
            }
            #[doc = "Bit 2 - Raw Periodic Hours Service Request"]
            #[inline]
            pub fn rpho(&self) -> RPHOR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RPHOR { bits }
            }
            #[doc = "Bit 3 - Raw Periodic Days Service Request"]
            #[inline]
            pub fn rpda(&self) -> RPDAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RPDAR { bits }
            }
            #[doc = "Bit 5 - Raw Periodic Months Service Request"]
            #[inline]
            pub fn rpmo(&self) -> RPMOR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RPMOR { bits }
            }
            #[doc = "Bit 6 - Raw Periodic Years Service Request"]
            #[inline]
            pub fn rpye(&self) -> RPYER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RPYER { bits }
            }
            #[doc = "Bit 8 - Raw Alarm Service Request"]
            #[inline]
            pub fn rai(&self) -> RAIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RAIR { bits }
            }
        }
    }
    #[doc = "RTC Service Request Status Register"]
    pub struct STSSR {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Service Request Status Register"]
    pub mod stssr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::STSSR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPSER {
            bits: bool,
        }
        impl SPSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPMIR {
            bits: bool,
        }
        impl SPMIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPHOR {
            bits: bool,
        }
        impl SPHOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPDAR {
            bits: bool,
        }
        impl SPDAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPMOR {
            bits: bool,
        }
        impl SPMOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPYER {
            bits: bool,
        }
        impl SPYER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SAIR {
            bits: bool,
        }
        impl SAIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Periodic Seconds Service Request Status after Masking"]
            #[inline]
            pub fn spse(&self) -> SPSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SPSER { bits }
            }
            #[doc = "Bit 1 - Periodic Minutes Service Request Status after Masking"]
            #[inline]
            pub fn spmi(&self) -> SPMIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SPMIR { bits }
            }
            #[doc = "Bit 2 - Periodic Hours Service Request Status after Masking"]
            #[inline]
            pub fn spho(&self) -> SPHOR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SPHOR { bits }
            }
            #[doc = "Bit 3 - Periodic Days Service Request Status after Masking"]
            #[inline]
            pub fn spda(&self) -> SPDAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SPDAR { bits }
            }
            #[doc = "Bit 5 - Periodic Months Service Request Status after Masking"]
            #[inline]
            pub fn spmo(&self) -> SPMOR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SPMOR { bits }
            }
            #[doc = "Bit 6 - Periodic Years Service Request Status after Masking"]
            #[inline]
            pub fn spye(&self) -> SPYER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SPYER { bits }
            }
            #[doc = "Bit 8 - Alarm Service Request Status after Masking"]
            #[inline]
            pub fn sai(&self) -> SAIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SAIR { bits }
            }
        }
    }
    #[doc = "RTC Service Request Mask Register"]
    pub struct MSKSR {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Service Request Mask Register"]
    pub mod msksr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MSKSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPSER {
            bits: bool,
        }
        impl MPSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPMIR {
            bits: bool,
        }
        impl MPMIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPHOR {
            bits: bool,
        }
        impl MPHOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPDAR {
            bits: bool,
        }
        impl MPDAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPMOR {
            bits: bool,
        }
        impl MPMOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPYER {
            bits: bool,
        }
        impl MPYER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct MAIR {
            bits: bool,
        }
        impl MAIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPMIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPMIW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPHOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPHOW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPDAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPDAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPMOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPMOW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPYEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPYEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MAIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MAIW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Periodic Seconds Interrupt Mask"]
            #[inline]
            pub fn mpse(&self) -> MPSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MPSER { bits }
            }
            #[doc = "Bit 1 - Periodic Minutes Interrupt Mask"]
            #[inline]
            pub fn mpmi(&self) -> MPMIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MPMIR { bits }
            }
            #[doc = "Bit 2 - Periodic Hours Interrupt Mask"]
            #[inline]
            pub fn mpho(&self) -> MPHOR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MPHOR { bits }
            }
            #[doc = "Bit 3 - Periodic Days Interrupt Mask"]
            #[inline]
            pub fn mpda(&self) -> MPDAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MPDAR { bits }
            }
            #[doc = "Bit 5 - Periodic Months Interrupt Mask"]
            #[inline]
            pub fn mpmo(&self) -> MPMOR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MPMOR { bits }
            }
            #[doc = "Bit 6 - Periodic Years Interrupt Mask"]
            #[inline]
            pub fn mpye(&self) -> MPYER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MPYER { bits }
            }
            #[doc = "Bit 8 - Alarm Interrupt Mask"]
            #[inline]
            pub fn mai(&self) -> MAIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                MAIR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Periodic Seconds Interrupt Mask"]
            #[inline]
            pub fn mpse(&mut self) -> _MPSEW {
                _MPSEW { w: self }
            }
            #[doc = "Bit 1 - Periodic Minutes Interrupt Mask"]
            #[inline]
            pub fn mpmi(&mut self) -> _MPMIW {
                _MPMIW { w: self }
            }
            #[doc = "Bit 2 - Periodic Hours Interrupt Mask"]
            #[inline]
            pub fn mpho(&mut self) -> _MPHOW {
                _MPHOW { w: self }
            }
            #[doc = "Bit 3 - Periodic Days Interrupt Mask"]
            #[inline]
            pub fn mpda(&mut self) -> _MPDAW {
                _MPDAW { w: self }
            }
            #[doc = "Bit 5 - Periodic Months Interrupt Mask"]
            #[inline]
            pub fn mpmo(&mut self) -> _MPMOW {
                _MPMOW { w: self }
            }
            #[doc = "Bit 6 - Periodic Years Interrupt Mask"]
            #[inline]
            pub fn mpye(&mut self) -> _MPYEW {
                _MPYEW { w: self }
            }
            #[doc = "Bit 8 - Alarm Interrupt Mask"]
            #[inline]
            pub fn mai(&mut self) -> _MAIW {
                _MAIW { w: self }
            }
        }
    }
    #[doc = "RTC Clear Service Request Register"]
    pub struct CLRSR {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Clear Service Request Register"]
    pub mod clrsr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLRSR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPMIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPMIW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPHOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPHOW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPDAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPDAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPMOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPMOW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPYEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPYEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RAIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RAIW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Periodic Seconds Interrupt Clear"]
            #[inline]
            pub fn rpse(&mut self) -> _RPSEW {
                _RPSEW { w: self }
            }
            #[doc = "Bit 1 - Periodic Minutes Interrupt Clear"]
            #[inline]
            pub fn rpmi(&mut self) -> _RPMIW {
                _RPMIW { w: self }
            }
            #[doc = "Bit 2 - Periodic Hours Interrupt Clear"]
            #[inline]
            pub fn rpho(&mut self) -> _RPHOW {
                _RPHOW { w: self }
            }
            #[doc = "Bit 3 - Periodic Days Interrupt Clear"]
            #[inline]
            pub fn rpda(&mut self) -> _RPDAW {
                _RPDAW { w: self }
            }
            #[doc = "Bit 5 - Periodic Months Interrupt Clear"]
            #[inline]
            pub fn rpmo(&mut self) -> _RPMOW {
                _RPMOW { w: self }
            }
            #[doc = "Bit 6 - Periodic Years Interrupt Clear"]
            #[inline]
            pub fn rpye(&mut self) -> _RPYEW {
                _RPYEW { w: self }
            }
            #[doc = "Bit 8 - Alarm Interrupt Clear"]
            #[inline]
            pub fn rai(&mut self) -> _RAIW {
                _RAIW { w: self }
            }
        }
    }
    #[doc = "RTC Alarm Time Register 0"]
    pub struct ATIM0 {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Alarm Time Register 0"]
    pub mod atim0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ATIM0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ASER {
            bits: u8,
        }
        impl ASER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct AMIR {
            bits: u8,
        }
        impl AMIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHOR {
            bits: u8,
        }
        impl AHOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADAR {
            bits: u8,
        }
        impl ADAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AMIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AMIW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADAW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Alarm Seconds Compare Value"]
            #[inline]
            pub fn ase(&self) -> ASER {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ASER { bits }
            }
            #[doc = "Bits 8:13 - Alarm Minutes Compare Value"]
            #[inline]
            pub fn ami(&self) -> AMIR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AMIR { bits }
            }
            #[doc = "Bits 16:20 - Alarm Hours Compare Value"]
            #[inline]
            pub fn aho(&self) -> AHOR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AHOR { bits }
            }
            #[doc = "Bits 24:28 - Alarm Days Compare Value"]
            #[inline]
            pub fn ada(&self) -> ADAR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ADAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Alarm Seconds Compare Value"]
            #[inline]
            pub fn ase(&mut self) -> _ASEW {
                _ASEW { w: self }
            }
            #[doc = "Bits 8:13 - Alarm Minutes Compare Value"]
            #[inline]
            pub fn ami(&mut self) -> _AMIW {
                _AMIW { w: self }
            }
            #[doc = "Bits 16:20 - Alarm Hours Compare Value"]
            #[inline]
            pub fn aho(&mut self) -> _AHOW {
                _AHOW { w: self }
            }
            #[doc = "Bits 24:28 - Alarm Days Compare Value"]
            #[inline]
            pub fn ada(&mut self) -> _ADAW {
                _ADAW { w: self }
            }
        }
    }
    #[doc = "RTC Alarm Time Register 1"]
    pub struct ATIM1 {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Alarm Time Register 1"]
    pub mod atim1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ATIM1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct AMOR {
            bits: u8,
        }
        impl AMOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct AYER {
            bits: u16,
        }
        impl AYER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _AMOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AMOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AYEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AYEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 8:11 - Alarm Month Compare Value"]
            #[inline]
            pub fn amo(&self) -> AMOR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AMOR { bits }
            }
            #[doc = "Bits 16:31 - Alarm Year Compare Value"]
            #[inline]
            pub fn aye(&self) -> AYER {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                AYER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 8:11 - Alarm Month Compare Value"]
            #[inline]
            pub fn amo(&mut self) -> _AMOW {
                _AMOW { w: self }
            }
            #[doc = "Bits 16:31 - Alarm Year Compare Value"]
            #[inline]
            pub fn aye(&mut self) -> _AYEW {
                _AYEW { w: self }
            }
        }
    }
    #[doc = "RTC Time Register 0"]
    pub struct TIM0 {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Time Register 0"]
    pub mod tim0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TIM0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SER {
            bits: u8,
        }
        impl SER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MIR {
            bits: u8,
        }
        impl MIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct HOR {
            bits: u8,
        }
        impl HOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DAR {
            bits: u8,
        }
        impl DAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MIW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _HOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DAW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Seconds Time Value"]
            #[inline]
            pub fn se(&self) -> SER {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SER { bits }
            }
            #[doc = "Bits 8:13 - Minutes Time Value"]
            #[inline]
            pub fn mi(&self) -> MIR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MIR { bits }
            }
            #[doc = "Bits 16:20 - Hours Time Value"]
            #[inline]
            pub fn ho(&self) -> HOR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HOR { bits }
            }
            #[doc = "Bits 24:28 - Days Time Value"]
            #[inline]
            pub fn da(&self) -> DAR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Seconds Time Value"]
            #[inline]
            pub fn se(&mut self) -> _SEW {
                _SEW { w: self }
            }
            #[doc = "Bits 8:13 - Minutes Time Value"]
            #[inline]
            pub fn mi(&mut self) -> _MIW {
                _MIW { w: self }
            }
            #[doc = "Bits 16:20 - Hours Time Value"]
            #[inline]
            pub fn ho(&mut self) -> _HOW {
                _HOW { w: self }
            }
            #[doc = "Bits 24:28 - Days Time Value"]
            #[inline]
            pub fn da(&mut self) -> _DAW {
                _DAW { w: self }
            }
        }
    }
    #[doc = "RTC Time Register 1"]
    pub struct TIM1 {
        register: VolatileCell<u32>,
    }
    #[doc = "RTC Time Register 1"]
    pub mod tim1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TIM1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DAWER {
            bits: u8,
        }
        impl DAWER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOR {
            bits: u8,
        }
        impl MOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct YER {
            bits: u16,
        }
        impl YER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DAWEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DAWEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _YEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _YEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Days of Week Time Value"]
            #[inline]
            pub fn dawe(&self) -> DAWER {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DAWER { bits }
            }
            #[doc = "Bits 8:11 - Month Time Value"]
            #[inline]
            pub fn mo(&self) -> MOR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOR { bits }
            }
            #[doc = "Bits 16:31 - Year Time Value"]
            #[inline]
            pub fn ye(&self) -> YER {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                YER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Days of Week Time Value"]
            #[inline]
            pub fn dawe(&mut self) -> _DAWEW {
                _DAWEW { w: self }
            }
            #[doc = "Bits 8:11 - Month Time Value"]
            #[inline]
            pub fn mo(&mut self) -> _MOW {
                _MOW { w: self }
            }
            #[doc = "Bits 16:31 - Year Time Value"]
            #[inline]
            pub fn ye(&mut self) -> _YEW {
                _YEW { w: self }
            }
        }
    }
}
#[doc = "Real Time Clock"]
pub struct RTC {
    register_block: rtc::RegisterBlock,
}
impl Deref for RTC {
    type Target = rtc::RegisterBlock;
    fn deref(&self) -> &rtc::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_CLK: Peripheral<SCU_CLK> = unsafe { Peripheral::new(0x5000_4600) };
#[doc = "System Control Unit"]
pub mod scu_clk {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Clock Status Register"]
        pub clkstat: CLKSTAT,
        #[doc = "0x04 - CLK Set Register"]
        pub clkset: CLKSET,
        #[doc = "0x08 - CLK Clear Register"]
        pub clkclr: CLKCLR,
        #[doc = "0x0c - System Clock Control Register"]
        pub sysclkcr: SYSCLKCR,
        #[doc = "0x10 - CPU Clock Control Register"]
        pub cpuclkcr: CPUCLKCR,
        #[doc = "0x14 - Peripheral Bus Clock Control Register"]
        pub pbclkcr: PBCLKCR,
        #[doc = "0x18 - USB Clock Control Register"]
        pub usbclkcr: USBCLKCR,
        _reserved0: [u8; 4usize],
        #[doc = "0x20 - CCU Clock Control Register"]
        pub ccuclkcr: CCUCLKCR,
        #[doc = "0x24 - WDT Clock Control Register"]
        pub wdtclkcr: WDTCLKCR,
        #[doc = "0x28 - External Clock Control"]
        pub extclkcr: EXTCLKCR,
        #[doc = "0x2c - Multi-Link Clock Control"]
        pub mlinkclkcr: MLINKCLKCR,
        #[doc = "0x30 - Sleep Control Register"]
        pub sleepcr: SLEEPCR,
        #[doc = "0x34 - Deep Sleep Control Register"]
        pub dsleepcr: DSLEEPCR,
        _reserved1: [u8; 8usize],
        #[doc = "0x40 - Peripheral 0 Clock Gating Status"]
        pub cgatstat0: CGATSTAT0,
        #[doc = "0x44 - Peripheral 0 Clock Gating Set"]
        pub cgatset0: CGATSET0,
        #[doc = "0x48 - Peripheral 0 Clock Gating Clear"]
        pub cgatclr0: CGATCLR0,
        #[doc = "0x4c - Peripheral 1 Clock Gating Status"]
        pub cgatstat1: CGATSTAT1,
        #[doc = "0x50 - Peripheral 1 Clock Gating Set"]
        pub cgatset1: CGATSET1,
        #[doc = "0x54 - Peripheral 1 Clock Gating Clear"]
        pub cgatclr1: CGATCLR1,
        #[doc = "0x58 - Peripheral 2 Clock Gating Status"]
        pub cgatstat2: CGATSTAT2,
        #[doc = "0x5c - Peripheral 2 Clock Gating Set"]
        pub cgatset2: CGATSET2,
        #[doc = "0x60 - Peripheral 2 Clock Gating Clear"]
        pub cgatclr2: CGATCLR2,
    }
    #[doc = "Clock Status Register"]
    pub struct CLKSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Clock Status Register"]
    pub mod clkstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CLKSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `USBCST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBCSTR {
            #[doc = "Clock disabled"]
            VALUE1,
            #[doc = "Clock enabled"]
            VALUE2,
        }
        impl USBCSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBCSTR::VALUE1 => false,
                    USBCSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBCSTR {
                match value {
                    false => USBCSTR::VALUE1,
                    true => USBCSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBCSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBCSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCUCST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCUCSTR {
            #[doc = "Clock disabled"]
            VALUE1,
            #[doc = "Clock enabled"]
            VALUE2,
        }
        impl CCUCSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCUCSTR::VALUE1 => false,
                    CCUCSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCUCSTR {
                match value {
                    false => CCUCSTR::VALUE1,
                    true => CCUCSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCUCSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCUCSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WDTCST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTCSTR {
            #[doc = "Clock disabled"]
            VALUE1,
            #[doc = "Clock enabled"]
            VALUE2,
        }
        impl WDTCSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WDTCSTR::VALUE1 => false,
                    WDTCSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WDTCSTR {
                match value {
                    false => WDTCSTR::VALUE1,
                    true => WDTCSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTCSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTCSTR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - USB Clock Status"]
            #[inline]
            pub fn usbcst(&self) -> USBCSTR {
                USBCSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - CCU Clock Status"]
            #[inline]
            pub fn ccucst(&self) -> CCUCSTR {
                CCUCSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - WDT Clock Status"]
            #[inline]
            pub fn wdtcst(&self) -> WDTCSTR {
                WDTCSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "CLK Set Register"]
    pub struct CLKSET {
        register: VolatileCell<u32>,
    }
    #[doc = "CLK Set Register"]
    pub mod clkset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLKSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `USBCEN`"]
        pub enum USBCENW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl USBCENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBCENW::VALUE1 => false,
                    USBCENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBCENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBCENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBCENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBCENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBCENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCUCEN`"]
        pub enum CCUCENW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl CCUCENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCUCENW::VALUE1 => false,
                    CCUCENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCUCENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCUCENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCUCENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCUCENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCUCENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WDTCEN`"]
        pub enum WDTCENW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl WDTCENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTCENW::VALUE1 => false,
                    WDTCENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTCENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTCENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTCENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTCENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTCENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - USB Clock Enable"]
            #[inline]
            pub fn usbcen(&mut self) -> _USBCENW {
                _USBCENW { w: self }
            }
            #[doc = "Bit 4 - CCU Clock Enable"]
            #[inline]
            pub fn ccucen(&mut self) -> _CCUCENW {
                _CCUCENW { w: self }
            }
            #[doc = "Bit 5 - WDT Clock Enable"]
            #[inline]
            pub fn wdtcen(&mut self) -> _WDTCENW {
                _WDTCENW { w: self }
            }
        }
    }
    #[doc = "CLK Clear Register"]
    pub struct CLKCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "CLK Clear Register"]
    pub mod clkclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLKCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `USBCDI`"]
        pub enum USBCDIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable clock"]
            VALUE2,
        }
        impl USBCDIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBCDIW::VALUE1 => false,
                    USBCDIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBCDIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBCDIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBCDIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBCDIW::VALUE1)
            }
            #[doc = "Disable clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBCDIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCUCDI`"]
        pub enum CCUCDIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable clock"]
            VALUE2,
        }
        impl CCUCDIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCUCDIW::VALUE1 => false,
                    CCUCDIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCUCDIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCUCDIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCUCDIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCUCDIW::VALUE1)
            }
            #[doc = "Disable clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCUCDIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WDTCDI`"]
        pub enum WDTCDIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable clock"]
            VALUE2,
        }
        impl WDTCDIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTCDIW::VALUE1 => false,
                    WDTCDIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTCDIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTCDIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTCDIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTCDIW::VALUE1)
            }
            #[doc = "Disable clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTCDIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - USB Clock Disable"]
            #[inline]
            pub fn usbcdi(&mut self) -> _USBCDIW {
                _USBCDIW { w: self }
            }
            #[doc = "Bit 4 - CCU Clock Disable"]
            #[inline]
            pub fn ccucdi(&mut self) -> _CCUCDIW {
                _CCUCDIW { w: self }
            }
            #[doc = "Bit 5 - WDT Clock Disable"]
            #[inline]
            pub fn wdtcdi(&mut self) -> _WDTCDIW {
                _WDTCDIW { w: self }
            }
        }
    }
    #[doc = "System Clock Control Register"]
    pub struct SYSCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "System Clock Control Register"]
    pub mod sysclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SYSCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SYSDIVR {
            bits: u8,
        }
        impl SYSDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SYSSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SYSSELR {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SYSSELR::VALUE1 => false,
                    SYSSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SYSSELR {
                match value {
                    false => SYSSELR::VALUE1,
                    true => SYSSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SYSSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SYSSELR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SYSSEL`"]
        pub enum SYSSELW {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SYSSELW::VALUE1 => false,
                    SYSSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SYSSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fOFI clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE1)
            }
            #[doc = "fPLL clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - System Clock Division Value"]
            #[inline]
            pub fn sysdiv(&self) -> SYSDIVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SYSDIVR { bits }
            }
            #[doc = "Bit 16 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&self) -> SYSSELR {
                SYSSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - System Clock Division Value"]
            #[inline]
            pub fn sysdiv(&mut self) -> _SYSDIVW {
                _SYSDIVW { w: self }
            }
            #[doc = "Bit 16 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&mut self) -> _SYSSELW {
                _SYSSELW { w: self }
            }
        }
    }
    #[doc = "CPU Clock Control Register"]
    pub struct CPUCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "CPU Clock Control Register"]
    pub mod cpuclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CPUCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CPUDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CPUDIVR {
            #[doc = "fCPU = fSYS"]
            VALUE1,
            #[doc = "fCPU = fSYS / 2"]
            VALUE2,
        }
        impl CPUDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CPUDIVR::VALUE1 => false,
                    CPUDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CPUDIVR {
                match value {
                    false => CPUDIVR::VALUE1,
                    true => CPUDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CPUDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CPUDIVR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CPUDIV`"]
        pub enum CPUDIVW {
            #[doc = "fCPU = fSYS"]
            VALUE1,
            #[doc = "fCPU = fSYS / 2"]
            VALUE2,
        }
        impl CPUDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CPUDIVW::VALUE1 => false,
                    CPUDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CPUDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CPUDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CPUDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fCPU = fSYS"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CPUDIVW::VALUE1)
            }
            #[doc = "fCPU = fSYS / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CPUDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - CPU Clock Divider Enable"]
            #[inline]
            pub fn cpudiv(&self) -> CPUDIVR {
                CPUDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CPU Clock Divider Enable"]
            #[inline]
            pub fn cpudiv(&mut self) -> _CPUDIVW {
                _CPUDIVW { w: self }
            }
        }
    }
    #[doc = "Peripheral Bus Clock Control Register"]
    pub struct PBCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral Bus Clock Control Register"]
    pub mod pbclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PBCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PBDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PBDIVR {
            #[doc = "fPERIPH = fCPU"]
            VALUE1,
            #[doc = "fPERIPH = fCPU / 2"]
            VALUE2,
        }
        impl PBDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PBDIVR::VALUE1 => false,
                    PBDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PBDIVR {
                match value {
                    false => PBDIVR::VALUE1,
                    true => PBDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PBDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PBDIVR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PBDIV`"]
        pub enum PBDIVW {
            #[doc = "fPERIPH = fCPU"]
            VALUE1,
            #[doc = "fPERIPH = fCPU / 2"]
            VALUE2,
        }
        impl PBDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PBDIVW::VALUE1 => false,
                    PBDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PBDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PBDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PBDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fPERIPH = fCPU"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PBDIVW::VALUE1)
            }
            #[doc = "fPERIPH = fCPU / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PBDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - PB Clock Divider Enable"]
            #[inline]
            pub fn pbdiv(&self) -> PBDIVR {
                PBDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - PB Clock Divider Enable"]
            #[inline]
            pub fn pbdiv(&mut self) -> _PBDIVW {
                _PBDIVW { w: self }
            }
        }
    }
    #[doc = "USB Clock Control Register"]
    pub struct USBCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "USB Clock Control Register"]
    pub mod usbclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::USBCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBDIVR {
            bits: u8,
        }
        impl USBDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `USBSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBSELR {
            #[doc = "USB PLL Clock"]
            VALUE1,
            #[doc = "PLL Clock"]
            VALUE2,
        }
        impl USBSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBSELR::VALUE1 => false,
                    USBSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBSELR {
                match value {
                    false => USBSELR::VALUE1,
                    true => USBSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBSELR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBSEL`"]
        pub enum USBSELW {
            #[doc = "USB PLL Clock"]
            VALUE1,
            #[doc = "PLL Clock"]
            VALUE2,
        }
        impl USBSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBSELW::VALUE1 => false,
                    USBSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "USB PLL Clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBSELW::VALUE1)
            }
            #[doc = "PLL Clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - USB Clock Divider Value"]
            #[inline]
            pub fn usbdiv(&self) -> USBDIVR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                USBDIVR { bits }
            }
            #[doc = "Bit 16 - USB Clock Selection Value"]
            #[inline]
            pub fn usbsel(&self) -> USBSELR {
                USBSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - USB Clock Divider Value"]
            #[inline]
            pub fn usbdiv(&mut self) -> _USBDIVW {
                _USBDIVW { w: self }
            }
            #[doc = "Bit 16 - USB Clock Selection Value"]
            #[inline]
            pub fn usbsel(&mut self) -> _USBSELW {
                _USBSELW { w: self }
            }
        }
    }
    #[doc = "CCU Clock Control Register"]
    pub struct CCUCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "CCU Clock Control Register"]
    pub mod ccuclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CCUCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CCUDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCUDIVR {
            #[doc = "fCCU = fSYS"]
            VALUE1,
            #[doc = "fCCU = fSYS / 2"]
            VALUE2,
        }
        impl CCUDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCUDIVR::VALUE1 => false,
                    CCUDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCUDIVR {
                match value {
                    false => CCUDIVR::VALUE1,
                    true => CCUDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCUDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCUDIVR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CCUDIV`"]
        pub enum CCUDIVW {
            #[doc = "fCCU = fSYS"]
            VALUE1,
            #[doc = "fCCU = fSYS / 2"]
            VALUE2,
        }
        impl CCUDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCUDIVW::VALUE1 => false,
                    CCUDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCUDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCUDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCUDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fCCU = fSYS"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCUDIVW::VALUE1)
            }
            #[doc = "fCCU = fSYS / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCUDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - CCU Clock Divider Enable"]
            #[inline]
            pub fn ccudiv(&self) -> CCUDIVR {
                CCUDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CCU Clock Divider Enable"]
            #[inline]
            pub fn ccudiv(&mut self) -> _CCUDIVW {
                _CCUDIVW { w: self }
            }
        }
    }
    #[doc = "WDT Clock Control Register"]
    pub struct WDTCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "WDT Clock Control Register"]
    pub mod wdtclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::WDTCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct WDTDIVR {
            bits: u8,
        }
        impl WDTDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `WDTSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTSELR {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fSTDBY clock"]
            VALUE2,
            #[doc = "fPLL clock"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl WDTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    WDTSELR::VALUE1 => 0,
                    WDTSELR::VALUE2 => 0x01,
                    WDTSELR::VALUE3 => 0x02,
                    WDTSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> WDTSELR {
                match value {
                    0 => WDTSELR::VALUE1,
                    1 => WDTSELR::VALUE2,
                    2 => WDTSELR::VALUE3,
                    i => WDTSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == WDTSELR::VALUE3
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WDTSEL`"]
        pub enum WDTSELW {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fSTDBY clock"]
            VALUE2,
            #[doc = "fPLL clock"]
            VALUE3,
        }
        impl WDTSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WDTSELW::VALUE1 => 0,
                    WDTSELW::VALUE2 => 1,
                    WDTSELW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTSELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "fOFI clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTSELW::VALUE1)
            }
            #[doc = "fSTDBY clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTSELW::VALUE2)
            }
            #[doc = "fPLL clock"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(WDTSELW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - WDT Clock Divider Value"]
            #[inline]
            pub fn wdtdiv(&self) -> WDTDIVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                WDTDIVR { bits }
            }
            #[doc = "Bits 16:17 - WDT Clock Selection Value"]
            #[inline]
            pub fn wdtsel(&self) -> WDTSELR {
                WDTSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - WDT Clock Divider Value"]
            #[inline]
            pub fn wdtdiv(&mut self) -> _WDTDIVW {
                _WDTDIVW { w: self }
            }
            #[doc = "Bits 16:17 - WDT Clock Selection Value"]
            #[inline]
            pub fn wdtsel(&mut self) -> _WDTSELW {
                _WDTSELW { w: self }
            }
        }
    }
    #[doc = "External Clock Control"]
    pub struct EXTCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "External Clock Control"]
    pub mod extclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EXTCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ECKSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ECKSELR {
            #[doc = "fSYS clock"]
            VALUE1,
            #[doc = "fUSB clock"]
            VALUE3,
            #[doc = "fPLL clock divided according to ECKDIV bit field configuration"]
            VALUE4,
            #[doc = "fSTDBY clock"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ECKSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ECKSELR::VALUE1 => 0,
                    ECKSELR::VALUE3 => 0x02,
                    ECKSELR::VALUE4 => 0x03,
                    ECKSELR::VALUE5 => 0x04,
                    ECKSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ECKSELR {
                match value {
                    0 => ECKSELR::VALUE1,
                    2 => ECKSELR::VALUE3,
                    3 => ECKSELR::VALUE4,
                    4 => ECKSELR::VALUE5,
                    i => ECKSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ECKSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ECKSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ECKSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == ECKSELR::VALUE5
            }
        }
        #[doc = r" Value of the field"]
        pub struct ECKDIVR {
            bits: u16,
        }
        impl ECKDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `ECKSEL`"]
        pub enum ECKSELW {
            #[doc = "fSYS clock"]
            VALUE1,
            #[doc = "fUSB clock"]
            VALUE3,
            #[doc = "fPLL clock divided according to ECKDIV bit field configuration"]
            VALUE4,
            #[doc = "fSTDBY clock"]
            VALUE5,
        }
        impl ECKSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ECKSELW::VALUE1 => 0,
                    ECKSELW::VALUE3 => 2,
                    ECKSELW::VALUE4 => 3,
                    ECKSELW::VALUE5 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ECKSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ECKSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ECKSELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "fSYS clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ECKSELW::VALUE1)
            }
            #[doc = "fUSB clock"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ECKSELW::VALUE3)
            }
            #[doc = "fPLL clock divided according to ECKDIV bit field configuration"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ECKSELW::VALUE4)
            }
            #[doc = "fSTDBY clock"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(ECKSELW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ECKDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ECKDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x01ff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - External Clock Selection Value"]
            #[inline]
            pub fn ecksel(&self) -> ECKSELR {
                ECKSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:24 - External Clock Divider Value"]
            #[inline]
            pub fn eckdiv(&self) -> ECKDIVR {
                let bits = {
                    const MASK: u16 = 0x01ff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ECKDIVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - External Clock Selection Value"]
            #[inline]
            pub fn ecksel(&mut self) -> _ECKSELW {
                _ECKSELW { w: self }
            }
            #[doc = "Bits 16:24 - External Clock Divider Value"]
            #[inline]
            pub fn eckdiv(&mut self) -> _ECKDIVW {
                _ECKDIVW { w: self }
            }
        }
    }
    #[doc = "Multi-Link Clock Control"]
    pub struct MLINKCLKCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Multi-Link Clock Control"]
    pub mod mlinkclkcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MLINKCLKCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SYSDIVR {
            bits: u8,
        }
        impl SYSDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SYSSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SYSSELR {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SYSSELR::VALUE1 => false,
                    SYSSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SYSSELR {
                match value {
                    false => SYSSELR::VALUE1,
                    true => SYSSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SYSSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SYSSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CPUDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CPUDIVR {
            #[doc = "fCPU = fSYS"]
            VALUE1,
            #[doc = "fCPU = fSYS / 2"]
            VALUE2,
        }
        impl CPUDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CPUDIVR::VALUE1 => false,
                    CPUDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CPUDIVR {
                match value {
                    false => CPUDIVR::VALUE1,
                    true => CPUDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CPUDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CPUDIVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PBDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PBDIVR {
            #[doc = "fPERIPH = fCPU"]
            VALUE1,
            #[doc = "fPERIPH = fCPU / 2"]
            VALUE2,
        }
        impl PBDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PBDIVR::VALUE1 => false,
                    PBDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PBDIVR {
                match value {
                    false => PBDIVR::VALUE1,
                    true => PBDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PBDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PBDIVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCUDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCUDIVR {
            #[doc = "fCCU = fSYS"]
            VALUE1,
            #[doc = "fCCU = fSYS / 2"]
            VALUE2,
        }
        impl CCUDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCUDIVR::VALUE1 => false,
                    CCUDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCUDIVR {
                match value {
                    false => CCUDIVR::VALUE1,
                    true => CCUDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCUDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCUDIVR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct WDTDIVR {
            bits: u8,
        }
        impl WDTDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `WDTSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTSELR {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fSTDBY clock"]
            VALUE2,
            #[doc = "fPLL clock"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl WDTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    WDTSELR::VALUE1 => 0,
                    WDTSELR::VALUE2 => 0x01,
                    WDTSELR::VALUE3 => 0x02,
                    WDTSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> WDTSELR {
                match value {
                    0 => WDTSELR::VALUE1,
                    1 => WDTSELR::VALUE2,
                    2 => WDTSELR::VALUE3,
                    i => WDTSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == WDTSELR::VALUE3
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SYSSEL`"]
        pub enum SYSSELW {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SYSSELW::VALUE1 => false,
                    SYSSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SYSSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fOFI clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE1)
            }
            #[doc = "fPLL clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CPUDIV`"]
        pub enum CPUDIVW {
            #[doc = "fCPU = fSYS"]
            VALUE1,
            #[doc = "fCPU = fSYS / 2"]
            VALUE2,
        }
        impl CPUDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CPUDIVW::VALUE1 => false,
                    CPUDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CPUDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CPUDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CPUDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fCPU = fSYS"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CPUDIVW::VALUE1)
            }
            #[doc = "fCPU = fSYS / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CPUDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PBDIV`"]
        pub enum PBDIVW {
            #[doc = "fPERIPH = fCPU"]
            VALUE1,
            #[doc = "fPERIPH = fCPU / 2"]
            VALUE2,
        }
        impl PBDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PBDIVW::VALUE1 => false,
                    PBDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PBDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PBDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PBDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fPERIPH = fCPU"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PBDIVW::VALUE1)
            }
            #[doc = "fPERIPH = fCPU / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PBDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCUDIV`"]
        pub enum CCUDIVW {
            #[doc = "fCCU = fSYS"]
            VALUE1,
            #[doc = "fCCU = fSYS / 2"]
            VALUE2,
        }
        impl CCUDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCUDIVW::VALUE1 => false,
                    CCUDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCUDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCUDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCUDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fCCU = fSYS"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCUDIVW::VALUE1)
            }
            #[doc = "fCCU = fSYS / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCUDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WDTSEL`"]
        pub enum WDTSELW {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fSTDBY clock"]
            VALUE2,
            #[doc = "fPLL clock"]
            VALUE3,
        }
        impl WDTSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WDTSELW::VALUE1 => 0,
                    WDTSELW::VALUE2 => 1,
                    WDTSELW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTSELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "fOFI clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTSELW::VALUE1)
            }
            #[doc = "fSTDBY clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTSELW::VALUE2)
            }
            #[doc = "fPLL clock"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(WDTSELW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - System Clock Division Value"]
            #[inline]
            pub fn sysdiv(&self) -> SYSDIVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SYSDIVR { bits }
            }
            #[doc = "Bit 8 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&self) -> SYSSELR {
                SYSSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - CPU Clock Divider Enable"]
            #[inline]
            pub fn cpudiv(&self) -> CPUDIVR {
                CPUDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - PB Clock Divider Enable"]
            #[inline]
            pub fn pbdiv(&self) -> PBDIVR {
                PBDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - CCU Clock Divider Enable"]
            #[inline]
            pub fn ccudiv(&self) -> CCUDIVR {
                CCUDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:23 - WDT Clock Divider Value"]
            #[inline]
            pub fn wdtdiv(&self) -> WDTDIVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                WDTDIVR { bits }
            }
            #[doc = "Bits 24:25 - WDT Clock Selection Value"]
            #[inline]
            pub fn wdtsel(&self) -> WDTSELR {
                WDTSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - System Clock Division Value"]
            #[inline]
            pub fn sysdiv(&mut self) -> _SYSDIVW {
                _SYSDIVW { w: self }
            }
            #[doc = "Bit 8 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&mut self) -> _SYSSELW {
                _SYSSELW { w: self }
            }
            #[doc = "Bit 10 - CPU Clock Divider Enable"]
            #[inline]
            pub fn cpudiv(&mut self) -> _CPUDIVW {
                _CPUDIVW { w: self }
            }
            #[doc = "Bit 12 - PB Clock Divider Enable"]
            #[inline]
            pub fn pbdiv(&mut self) -> _PBDIVW {
                _PBDIVW { w: self }
            }
            #[doc = "Bit 14 - CCU Clock Divider Enable"]
            #[inline]
            pub fn ccudiv(&mut self) -> _CCUDIVW {
                _CCUDIVW { w: self }
            }
            #[doc = "Bits 16:23 - WDT Clock Divider Value"]
            #[inline]
            pub fn wdtdiv(&mut self) -> _WDTDIVW {
                _WDTDIVW { w: self }
            }
            #[doc = "Bits 24:25 - WDT Clock Selection Value"]
            #[inline]
            pub fn wdtsel(&mut self) -> _WDTSELW {
                _WDTSELW { w: self }
            }
        }
    }
    #[doc = "Sleep Control Register"]
    pub struct SLEEPCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Sleep Control Register"]
    pub mod sleepcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SLEEPCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SYSSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SYSSELR {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SYSSELR::VALUE1 => false,
                    SYSSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SYSSELR {
                match value {
                    false => SYSSELR::VALUE1,
                    true => SYSSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SYSSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SYSSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USBCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBCRR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl USBCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBCRR::VALUE1 => false,
                    USBCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBCRR {
                match value {
                    false => USBCRR::VALUE1,
                    true => USBCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCUCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCUCRR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl CCUCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCUCRR::VALUE1 => false,
                    CCUCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCUCRR {
                match value {
                    false => CCUCRR::VALUE1,
                    true => CCUCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCUCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCUCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WDTCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTCRR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl WDTCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WDTCRR::VALUE1 => false,
                    WDTCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WDTCRR {
                match value {
                    false => WDTCRR::VALUE1,
                    true => WDTCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTCRR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SYSSEL`"]
        pub enum SYSSELW {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SYSSELW::VALUE1 => false,
                    SYSSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SYSSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fOFI clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE1)
            }
            #[doc = "fPLL clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBCR`"]
        pub enum USBCRW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl USBCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBCRW::VALUE1 => false,
                    USBCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBCRW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCUCR`"]
        pub enum CCUCRW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl CCUCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCUCRW::VALUE1 => false,
                    CCUCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCUCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCUCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCUCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCUCRW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCUCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WDTCR`"]
        pub enum WDTCRW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl WDTCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTCRW::VALUE1 => false,
                    WDTCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTCRW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&self) -> SYSSELR {
                SYSSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - USB Clock Control"]
            #[inline]
            pub fn usbcr(&self) -> USBCRR {
                USBCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - CCU Clock Control"]
            #[inline]
            pub fn ccucr(&self) -> CCUCRR {
                CCUCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - WDT Clock Control"]
            #[inline]
            pub fn wdtcr(&self) -> WDTCRR {
                WDTCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&mut self) -> _SYSSELW {
                _SYSSELW { w: self }
            }
            #[doc = "Bit 16 - USB Clock Control"]
            #[inline]
            pub fn usbcr(&mut self) -> _USBCRW {
                _USBCRW { w: self }
            }
            #[doc = "Bit 20 - CCU Clock Control"]
            #[inline]
            pub fn ccucr(&mut self) -> _CCUCRW {
                _CCUCRW { w: self }
            }
            #[doc = "Bit 21 - WDT Clock Control"]
            #[inline]
            pub fn wdtcr(&mut self) -> _WDTCRW {
                _WDTCRW { w: self }
            }
        }
    }
    #[doc = "Deep Sleep Control Register"]
    pub struct DSLEEPCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Deep Sleep Control Register"]
    pub mod dsleepcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DSLEEPCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SYSSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SYSSELR {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SYSSELR::VALUE1 => false,
                    SYSSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SYSSELR {
                match value {
                    false => SYSSELR::VALUE1,
                    true => SYSSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SYSSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SYSSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FPDN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FPDNR {
            #[doc = "Flash power down module"]
            VALUE1,
            #[doc = "No effect"]
            VALUE2,
        }
        impl FPDNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FPDNR::VALUE1 => true,
                    FPDNR::VALUE2 => false,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FPDNR {
                match value {
                    true => FPDNR::VALUE1,
                    false => FPDNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FPDNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FPDNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLLPDN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLLPDNR {
            #[doc = "Switch off main PLL"]
            VALUE1,
            #[doc = "No effect"]
            VALUE2,
        }
        impl PLLPDNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLLPDNR::VALUE1 => true,
                    PLLPDNR::VALUE2 => false,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLLPDNR {
                match value {
                    true => PLLPDNR::VALUE1,
                    false => PLLPDNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLLPDNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLLPDNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOPDN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOPDNR {
            #[doc = "Switch off VCO of main PLL"]
            VALUE1,
            #[doc = "No effect"]
            VALUE2,
        }
        impl VCOPDNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOPDNR::VALUE1 => true,
                    VCOPDNR::VALUE2 => false,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOPDNR {
                match value {
                    true => VCOPDNR::VALUE1,
                    false => VCOPDNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOPDNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOPDNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USBCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBCRR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl USBCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBCRR::VALUE1 => false,
                    USBCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBCRR {
                match value {
                    false => USBCRR::VALUE1,
                    true => USBCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCUCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCUCRR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl CCUCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCUCRR::VALUE1 => false,
                    CCUCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCUCRR {
                match value {
                    false => CCUCRR::VALUE1,
                    true => CCUCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCUCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCUCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WDTCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTCRR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl WDTCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WDTCRR::VALUE1 => false,
                    WDTCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WDTCRR {
                match value {
                    false => WDTCRR::VALUE1,
                    true => WDTCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTCRR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SYSSEL`"]
        pub enum SYSSELW {
            #[doc = "fOFI clock"]
            VALUE1,
            #[doc = "fPLL clock"]
            VALUE2,
        }
        impl SYSSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SYSSELW::VALUE1 => false,
                    SYSSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYSSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYSSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SYSSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fOFI clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE1)
            }
            #[doc = "fPLL clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SYSSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FPDN`"]
        pub enum FPDNW {
            #[doc = "Flash power down module"]
            VALUE1,
            #[doc = "No effect"]
            VALUE2,
        }
        impl FPDNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FPDNW::VALUE1 => true,
                    FPDNW::VALUE2 => false,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FPDNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FPDNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FPDNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flash power down module"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FPDNW::VALUE1)
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FPDNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLLPDN`"]
        pub enum PLLPDNW {
            #[doc = "Switch off main PLL"]
            VALUE1,
            #[doc = "No effect"]
            VALUE2,
        }
        impl PLLPDNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PLLPDNW::VALUE1 => true,
                    PLLPDNW::VALUE2 => false,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLLPDNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLLPDNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLLPDNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Switch off main PLL"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLLPDNW::VALUE1)
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLLPDNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VCOPDN`"]
        pub enum VCOPDNW {
            #[doc = "Switch off VCO of main PLL"]
            VALUE1,
            #[doc = "No effect"]
            VALUE2,
        }
        impl VCOPDNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOPDNW::VALUE1 => true,
                    VCOPDNW::VALUE2 => false,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOPDNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOPDNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOPDNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Switch off VCO of main PLL"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOPDNW::VALUE1)
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOPDNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBCR`"]
        pub enum USBCRW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl USBCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBCRW::VALUE1 => false,
                    USBCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBCRW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCUCR`"]
        pub enum CCUCRW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl CCUCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCUCRW::VALUE1 => false,
                    CCUCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCUCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCUCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCUCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCUCRW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCUCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WDTCR`"]
        pub enum WDTCRW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl WDTCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTCRW::VALUE1 => false,
                    WDTCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTCRW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&self) -> SYSSELR {
                SYSSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Flash Power Down"]
            #[inline]
            pub fn fpdn(&self) -> FPDNR {
                FPDNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - PLL Power Down"]
            #[inline]
            pub fn pllpdn(&self) -> PLLPDNR {
                PLLPDNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - VCO Power Down"]
            #[inline]
            pub fn vcopdn(&self) -> VCOPDNR {
                VCOPDNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - USB Clock Control"]
            #[inline]
            pub fn usbcr(&self) -> USBCRR {
                USBCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - CCU Clock Control"]
            #[inline]
            pub fn ccucr(&self) -> CCUCRR {
                CCUCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - WDT Clock Control"]
            #[inline]
            pub fn wdtcr(&self) -> WDTCRR {
                WDTCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - System Clock Selection Value"]
            #[inline]
            pub fn syssel(&mut self) -> _SYSSELW {
                _SYSSELW { w: self }
            }
            #[doc = "Bit 11 - Flash Power Down"]
            #[inline]
            pub fn fpdn(&mut self) -> _FPDNW {
                _FPDNW { w: self }
            }
            #[doc = "Bit 12 - PLL Power Down"]
            #[inline]
            pub fn pllpdn(&mut self) -> _PLLPDNW {
                _PLLPDNW { w: self }
            }
            #[doc = "Bit 13 - VCO Power Down"]
            #[inline]
            pub fn vcopdn(&mut self) -> _VCOPDNW {
                _VCOPDNW { w: self }
            }
            #[doc = "Bit 16 - USB Clock Control"]
            #[inline]
            pub fn usbcr(&mut self) -> _USBCRW {
                _USBCRW { w: self }
            }
            #[doc = "Bit 20 - CCU Clock Control"]
            #[inline]
            pub fn ccucr(&mut self) -> _CCUCRW {
                _CCUCRW { w: self }
            }
            #[doc = "Bit 21 - WDT Clock Control"]
            #[inline]
            pub fn wdtcr(&mut self) -> _WDTCRW {
                _WDTCRW { w: self }
            }
        }
    }
    #[doc = "Peripheral 0 Clock Gating Status"]
    pub struct CGATSTAT0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 0 Clock Gating Status"]
    pub mod cgatstat0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CGATSTAT0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `VADC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VADCR {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl VADCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VADCR::VALUE1 => false,
                    VADCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VADCR {
                match value {
                    false => VADCR::VALUE1,
                    true => VADCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VADCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VADCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCU40`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCU40R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl CCU40R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCU40R::VALUE1 => false,
                    CCU40R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCU40R {
                match value {
                    false => CCU40R::VALUE1,
                    true => CCU40R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCU40R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCU40R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCU41`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCU41R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl CCU41R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCU41R::VALUE1 => false,
                    CCU41R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCU41R {
                match value {
                    false => CCU41R::VALUE1,
                    true => CCU41R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCU41R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCU41R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCU80`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCU80R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl CCU80R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCU80R::VALUE1 => false,
                    CCU80R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCU80R {
                match value {
                    false => CCU80R::VALUE1,
                    true => CCU80R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCU80R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCU80R::VALUE2
            }
        }
        #[doc = "Possible values of the field `POSIF0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum POSIF0R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl POSIF0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    POSIF0R::VALUE1 => false,
                    POSIF0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> POSIF0R {
                match value {
                    false => POSIF0R::VALUE1,
                    true => POSIF0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == POSIF0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == POSIF0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `USIC0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USIC0R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl USIC0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USIC0R::VALUE1 => false,
                    USIC0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USIC0R {
                match value {
                    false => USIC0R::VALUE1,
                    true => USIC0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USIC0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USIC0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERU1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERU1R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl ERU1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERU1R::VALUE1 => false,
                    ERU1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERU1R {
                match value {
                    false => ERU1R::VALUE1,
                    true => ERU1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERU1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERU1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `HRPWM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRPWM0R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl HRPWM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRPWM0R::VALUE1 => false,
                    HRPWM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRPWM0R {
                match value {
                    false => HRPWM0R::VALUE1,
                    true => HRPWM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRPWM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRPWM0R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - VADC Gating Status"]
            #[inline]
            pub fn vadc(&self) -> VADCR {
                VADCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - CCU40 Gating Status"]
            #[inline]
            pub fn ccu40(&self) -> CCU40R {
                CCU40R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - CCU41 Gating Status"]
            #[inline]
            pub fn ccu41(&self) -> CCU41R {
                CCU41R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - CCU80 Gating Status"]
            #[inline]
            pub fn ccu80(&self) -> CCU80R {
                CCU80R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - POSIF0 Gating Status"]
            #[inline]
            pub fn posif0(&self) -> POSIF0R {
                POSIF0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - USIC0 Gating Status"]
            #[inline]
            pub fn usic0(&self) -> USIC0R {
                USIC0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - ERU1 Gating Status"]
            #[inline]
            pub fn eru1(&self) -> ERU1R {
                ERU1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - HRPWM0 Gating Status"]
            #[inline]
            pub fn hrpwm0(&self) -> HRPWM0R {
                HRPWM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Peripheral 0 Clock Gating Set"]
    pub struct CGATSET0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 0 Clock Gating Set"]
    pub mod cgatset0 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CGATSET0 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `VADC`"]
        pub enum VADCW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl VADCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VADCW::VALUE1 => false,
                    VADCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VADCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VADCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VADCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VADCW::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VADCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU40`"]
        pub enum CCU40W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl CCU40W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU40W::VALUE1 => false,
                    CCU40W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU40W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU40W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU40W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU40W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU40W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU41`"]
        pub enum CCU41W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl CCU41W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU41W::VALUE1 => false,
                    CCU41W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU41W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU41W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU41W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU41W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU41W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU80`"]
        pub enum CCU80W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl CCU80W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU80W::VALUE1 => false,
                    CCU80W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU80W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU80W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU80W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU80W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU80W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POSIF0`"]
        pub enum POSIF0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl POSIF0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POSIF0W::VALUE1 => false,
                    POSIF0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POSIF0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _POSIF0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POSIF0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POSIF0W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POSIF0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC0`"]
        pub enum USIC0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl USIC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC0W::VALUE1 => false,
                    USIC0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC0W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU1`"]
        pub enum ERU1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl ERU1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU1W::VALUE1 => false,
                    ERU1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU1W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRPWM0`"]
        pub enum HRPWM0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl HRPWM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRPWM0W::VALUE1 => false,
                    HRPWM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRPWM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRPWM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRPWM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRPWM0W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRPWM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - VADC Gating Set"]
            #[inline]
            pub fn vadc(&mut self) -> _VADCW {
                _VADCW { w: self }
            }
            #[doc = "Bit 2 - CCU40 Gating Set"]
            #[inline]
            pub fn ccu40(&mut self) -> _CCU40W {
                _CCU40W { w: self }
            }
            #[doc = "Bit 3 - CCU41 Gating Set"]
            #[inline]
            pub fn ccu41(&mut self) -> _CCU41W {
                _CCU41W { w: self }
            }
            #[doc = "Bit 7 - CCU80 Gating Set"]
            #[inline]
            pub fn ccu80(&mut self) -> _CCU80W {
                _CCU80W { w: self }
            }
            #[doc = "Bit 9 - POSIF0 Gating Set"]
            #[inline]
            pub fn posif0(&mut self) -> _POSIF0W {
                _POSIF0W { w: self }
            }
            #[doc = "Bit 11 - USIC0 Gating Set"]
            #[inline]
            pub fn usic0(&mut self) -> _USIC0W {
                _USIC0W { w: self }
            }
            #[doc = "Bit 16 - ERU1 Gating Set"]
            #[inline]
            pub fn eru1(&mut self) -> _ERU1W {
                _ERU1W { w: self }
            }
            #[doc = "Bit 23 - HRPWM0 Gating Set"]
            #[inline]
            pub fn hrpwm0(&mut self) -> _HRPWM0W {
                _HRPWM0W { w: self }
            }
        }
    }
    #[doc = "Peripheral 0 Clock Gating Clear"]
    pub struct CGATCLR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 0 Clock Gating Clear"]
    pub mod cgatclr0 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CGATCLR0 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `VADC`"]
        pub enum VADCW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl VADCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VADCW::VALUE1 => false,
                    VADCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VADCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VADCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VADCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VADCW::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VADCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU40`"]
        pub enum CCU40W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl CCU40W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU40W::VALUE1 => false,
                    CCU40W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU40W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU40W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU40W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU40W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU40W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU41`"]
        pub enum CCU41W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl CCU41W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU41W::VALUE1 => false,
                    CCU41W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU41W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU41W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU41W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU41W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU41W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU80`"]
        pub enum CCU80W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl CCU80W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU80W::VALUE1 => false,
                    CCU80W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU80W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU80W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU80W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU80W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU80W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POSIF0`"]
        pub enum POSIF0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl POSIF0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POSIF0W::VALUE1 => false,
                    POSIF0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POSIF0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _POSIF0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POSIF0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POSIF0W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POSIF0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC0`"]
        pub enum USIC0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl USIC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC0W::VALUE1 => false,
                    USIC0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC0W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU1`"]
        pub enum ERU1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl ERU1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU1W::VALUE1 => false,
                    ERU1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU1W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRPWM0`"]
        pub enum HRPWM0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl HRPWM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRPWM0W::VALUE1 => false,
                    HRPWM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRPWM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRPWM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRPWM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRPWM0W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRPWM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - VADC Gating Clear"]
            #[inline]
            pub fn vadc(&mut self) -> _VADCW {
                _VADCW { w: self }
            }
            #[doc = "Bit 2 - CCU40 Gating Clear"]
            #[inline]
            pub fn ccu40(&mut self) -> _CCU40W {
                _CCU40W { w: self }
            }
            #[doc = "Bit 3 - CCU41 Gating Clear"]
            #[inline]
            pub fn ccu41(&mut self) -> _CCU41W {
                _CCU41W { w: self }
            }
            #[doc = "Bit 7 - CCU80 Gating Clear"]
            #[inline]
            pub fn ccu80(&mut self) -> _CCU80W {
                _CCU80W { w: self }
            }
            #[doc = "Bit 9 - POSIF0 Gating Clear"]
            #[inline]
            pub fn posif0(&mut self) -> _POSIF0W {
                _POSIF0W { w: self }
            }
            #[doc = "Bit 11 - USIC0 Gating Clear"]
            #[inline]
            pub fn usic0(&mut self) -> _USIC0W {
                _USIC0W { w: self }
            }
            #[doc = "Bit 16 - ERU1 Gating Clear"]
            #[inline]
            pub fn eru1(&mut self) -> _ERU1W {
                _ERU1W { w: self }
            }
            #[doc = "Bit 23 - HRPWM0 Gating Clear"]
            #[inline]
            pub fn hrpwm0(&mut self) -> _HRPWM0W {
                _HRPWM0W { w: self }
            }
        }
    }
    #[doc = "Peripheral 1 Clock Gating Status"]
    pub struct CGATSTAT1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 1 Clock Gating Status"]
    pub mod cgatstat1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CGATSTAT1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `LEDTSCU0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LEDTSCU0R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl LEDTSCU0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LEDTSCU0R::VALUE1 => false,
                    LEDTSCU0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LEDTSCU0R {
                match value {
                    false => LEDTSCU0R::VALUE1,
                    true => LEDTSCU0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LEDTSCU0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LEDTSCU0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCAN0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCAN0R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl MCAN0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCAN0R::VALUE1 => false,
                    MCAN0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCAN0R {
                match value {
                    false => MCAN0R::VALUE1,
                    true => MCAN0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCAN0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCAN0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DAC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DACR {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl DACR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DACR::VALUE1 => false,
                    DACR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DACR {
                match value {
                    false => DACR::VALUE1,
                    true => DACR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DACR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DACR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USIC1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USIC1R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl USIC1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USIC1R::VALUE1 => false,
                    USIC1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USIC1R {
                match value {
                    false => USIC1R::VALUE1,
                    true => USIC1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USIC1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USIC1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPORTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPORTSR {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl PPORTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPORTSR::VALUE1 => false,
                    PPORTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPORTSR {
                match value {
                    false => PPORTSR::VALUE1,
                    true => PPORTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPORTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPORTSR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 3 - LEDTS Gating Status"]
            #[inline]
            pub fn ledtscu0(&self) -> LEDTSCU0R {
                LEDTSCU0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - MultiCAN Gating Status"]
            #[inline]
            pub fn mcan0(&self) -> MCAN0R {
                MCAN0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - DAC Gating Status"]
            #[inline]
            pub fn dac(&self) -> DACR {
                DACR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - USIC1 Gating Status"]
            #[inline]
            pub fn usic1(&self) -> USIC1R {
                USIC1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - PORTS Gating Status"]
            #[inline]
            pub fn pports(&self) -> PPORTSR {
                PPORTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Peripheral 1 Clock Gating Set"]
    pub struct CGATSET1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 1 Clock Gating Set"]
    pub mod cgatset1 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CGATSET1 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `LEDTSCU0`"]
        pub enum LEDTSCU0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl LEDTSCU0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LEDTSCU0W::VALUE1 => false,
                    LEDTSCU0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LEDTSCU0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LEDTSCU0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LEDTSCU0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LEDTSCU0W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LEDTSCU0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCAN0`"]
        pub enum MCAN0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl MCAN0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCAN0W::VALUE1 => false,
                    MCAN0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCAN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCAN0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCAN0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCAN0W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCAN0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DAC`"]
        pub enum DACW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl DACW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DACW::VALUE1 => false,
                    DACW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DACW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DACW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DACW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DACW::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DACW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC1`"]
        pub enum USIC1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl USIC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC1W::VALUE1 => false,
                    USIC1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC1W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPORTS`"]
        pub enum PPORTSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl PPORTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPORTSW::VALUE1 => false,
                    PPORTSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPORTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPORTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPORTSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPORTSW::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPORTSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 3 - LEDTS Gating Set"]
            #[inline]
            pub fn ledtscu0(&mut self) -> _LEDTSCU0W {
                _LEDTSCU0W { w: self }
            }
            #[doc = "Bit 4 - MultiCAN Gating Set"]
            #[inline]
            pub fn mcan0(&mut self) -> _MCAN0W {
                _MCAN0W { w: self }
            }
            #[doc = "Bit 5 - DAC Gating Set"]
            #[inline]
            pub fn dac(&mut self) -> _DACW {
                _DACW { w: self }
            }
            #[doc = "Bit 7 - USIC1 Gating Set"]
            #[inline]
            pub fn usic1(&mut self) -> _USIC1W {
                _USIC1W { w: self }
            }
            #[doc = "Bit 9 - PORTS Gating Set"]
            #[inline]
            pub fn pports(&mut self) -> _PPORTSW {
                _PPORTSW { w: self }
            }
        }
    }
    #[doc = "Peripheral 1 Clock Gating Clear"]
    pub struct CGATCLR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 1 Clock Gating Clear"]
    pub mod cgatclr1 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CGATCLR1 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `LEDTSCU0`"]
        pub enum LEDTSCU0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl LEDTSCU0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LEDTSCU0W::VALUE1 => false,
                    LEDTSCU0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LEDTSCU0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LEDTSCU0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LEDTSCU0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LEDTSCU0W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LEDTSCU0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCAN0`"]
        pub enum MCAN0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl MCAN0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCAN0W::VALUE1 => false,
                    MCAN0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCAN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCAN0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCAN0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCAN0W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCAN0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DAC`"]
        pub enum DACW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl DACW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DACW::VALUE1 => false,
                    DACW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DACW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DACW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DACW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DACW::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DACW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC1`"]
        pub enum USIC1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl USIC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC1W::VALUE1 => false,
                    USIC1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC1W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPORTS`"]
        pub enum PPORTSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl PPORTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPORTSW::VALUE1 => false,
                    PPORTSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPORTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPORTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPORTSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPORTSW::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPORTSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 3 - LEDTS Gating Clear"]
            #[inline]
            pub fn ledtscu0(&mut self) -> _LEDTSCU0W {
                _LEDTSCU0W { w: self }
            }
            #[doc = "Bit 4 - MultiCAN Gating Clear"]
            #[inline]
            pub fn mcan0(&mut self) -> _MCAN0W {
                _MCAN0W { w: self }
            }
            #[doc = "Bit 5 - DAC Gating Clear"]
            #[inline]
            pub fn dac(&mut self) -> _DACW {
                _DACW { w: self }
            }
            #[doc = "Bit 7 - USIC1 Gating Clear"]
            #[inline]
            pub fn usic1(&mut self) -> _USIC1W {
                _USIC1W { w: self }
            }
            #[doc = "Bit 9 - PORTS Gating Clear"]
            #[inline]
            pub fn pports(&mut self) -> _PPORTSW {
                _PPORTSW { w: self }
            }
        }
    }
    #[doc = "Peripheral 2 Clock Gating Status"]
    pub struct CGATSTAT2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 2 Clock Gating Status"]
    pub mod cgatstat2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CGATSTAT2 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `WDT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTR {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl WDTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WDTR::VALUE1 => false,
                    WDTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WDTR {
                match value {
                    false => WDTR::VALUE1,
                    true => WDTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DMA0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DMA0R {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl DMA0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DMA0R::VALUE1 => false,
                    DMA0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DMA0R {
                match value {
                    false => DMA0R::VALUE1,
                    true => DMA0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DMA0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DMA0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `FCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCER {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl FCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCER::VALUE1 => false,
                    FCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCER {
                match value {
                    false => FCER::VALUE1,
                    true => FCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCER::VALUE2
            }
        }
        #[doc = "Possible values of the field `USB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBR {
            #[doc = "Gating de-asserted"]
            VALUE1,
            #[doc = "Gating asserted"]
            VALUE2,
        }
        impl USBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBR::VALUE1 => false,
                    USBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBR {
                match value {
                    false => USBR::VALUE1,
                    true => USBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 1 - WDT Gating Status"]
            #[inline]
            pub fn wdt(&self) -> WDTR {
                WDTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - DMA0 Gating Status"]
            #[inline]
            pub fn dma0(&self) -> DMA0R {
                DMA0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - FCE Gating Status"]
            #[inline]
            pub fn fce(&self) -> FCER {
                FCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - USB Gating Status"]
            #[inline]
            pub fn usb(&self) -> USBR {
                USBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Peripheral 2 Clock Gating Set"]
    pub struct CGATSET2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 2 Clock Gating Set"]
    pub mod cgatset2 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CGATSET2 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `WDT`"]
        pub enum WDTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl WDTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTW::VALUE1 => false,
                    WDTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTW::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DMA0`"]
        pub enum DMA0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl DMA0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DMA0W::VALUE1 => false,
                    DMA0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMA0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMA0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMA0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMA0W::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMA0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FCE`"]
        pub enum FCEW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl FCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FCEW::VALUE1 => false,
                    FCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FCEW::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USB`"]
        pub enum USBW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable gating"]
            VALUE2,
        }
        impl USBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBW::VALUE1 => false,
                    USBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBW::VALUE1)
            }
            #[doc = "Enable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 1 - WDT Gating Set"]
            #[inline]
            pub fn wdt(&mut self) -> _WDTW {
                _WDTW { w: self }
            }
            #[doc = "Bit 4 - DMA0 Gating Set"]
            #[inline]
            pub fn dma0(&mut self) -> _DMA0W {
                _DMA0W { w: self }
            }
            #[doc = "Bit 6 - FCE Gating Set"]
            #[inline]
            pub fn fce(&mut self) -> _FCEW {
                _FCEW { w: self }
            }
            #[doc = "Bit 7 - USB Gating Set"]
            #[inline]
            pub fn usb(&mut self) -> _USBW {
                _USBW { w: self }
            }
        }
    }
    #[doc = "Peripheral 2 Clock Gating Clear"]
    pub struct CGATCLR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Peripheral 2 Clock Gating Clear"]
    pub mod cgatclr2 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CGATCLR2 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `WDT`"]
        pub enum WDTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl WDTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTW::VALUE1 => false,
                    WDTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTW::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DMA0`"]
        pub enum DMA0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl DMA0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DMA0W::VALUE1 => false,
                    DMA0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMA0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMA0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMA0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMA0W::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMA0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FCE`"]
        pub enum FCEW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl FCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FCEW::VALUE1 => false,
                    FCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FCEW::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USB`"]
        pub enum USBW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable gating"]
            VALUE2,
        }
        impl USBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBW::VALUE1 => false,
                    USBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBW::VALUE1)
            }
            #[doc = "Disable gating"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 1 - WDT Gating Clear"]
            #[inline]
            pub fn wdt(&mut self) -> _WDTW {
                _WDTW { w: self }
            }
            #[doc = "Bit 4 - DMA0 Gating Clear"]
            #[inline]
            pub fn dma0(&mut self) -> _DMA0W {
                _DMA0W { w: self }
            }
            #[doc = "Bit 6 - FCE Gating Clear"]
            #[inline]
            pub fn fce(&mut self) -> _FCEW {
                _FCEW { w: self }
            }
            #[doc = "Bit 7 - USB Gating Clear"]
            #[inline]
            pub fn usb(&mut self) -> _USBW {
                _USBW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_CLK {
    register_block: scu_clk::RegisterBlock,
}
impl Deref for SCU_CLK {
    type Target = scu_clk::RegisterBlock;
    fn deref(&self) -> &scu_clk::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_OSC: Peripheral<SCU_OSC> = unsafe { Peripheral::new(0x5000_4700) };
#[doc = "System Control Unit"]
pub mod scu_osc {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - OSC_HP Status Register"]
        pub oschpstat: OSCHPSTAT,
        #[doc = "0x04 - OSC_HP Control Register"]
        pub oschpctrl: OSCHPCTRL,
        _reserved0: [u8; 4usize],
        #[doc = "0x0c - Clock Calibration Constant Register"]
        pub clkcalconst: CLKCALCONST,
    }
    #[doc = "OSC_HP Status Register"]
    pub struct OSCHPSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "OSC_HP Status Register"]
    pub mod oschpstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::OSCHPSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct X1DR {
            bits: bool,
        }
        impl X1DR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - XTAL1 Data Value"]
            #[inline]
            pub fn x1d(&self) -> X1DR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                X1DR { bits }
            }
        }
    }
    #[doc = "OSC_HP Control Register"]
    pub struct OSCHPCTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "OSC_HP Control Register"]
    pub mod oschpctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OSCHPCTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `X1DEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum X1DENR {
            #[doc = "Bit X1D is not updated"]
            VALUE1,
            #[doc = "Bit X1D can be updated"]
            VALUE2,
        }
        impl X1DENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    X1DENR::VALUE1 => false,
                    X1DENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> X1DENR {
                match value {
                    false => X1DENR::VALUE1,
                    true => X1DENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == X1DENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == X1DENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SHBY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SHBYR {
            #[doc = "The shaper is not bypassed"]
            VALUE1,
            #[doc = "The shaper is bypassed"]
            VALUE2,
        }
        impl SHBYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SHBYR::VALUE1 => false,
                    SHBYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SHBYR {
                match value {
                    false => SHBYR::VALUE1,
                    true => SHBYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SHBYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SHBYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MODER {
            #[doc = "External Crystal Mode and External Input Clock Mode. The oscillator Power-Saving Mode is not entered."]
            VALUE1,
            #[doc = "OSC is disabled. The oscillator Power-Saving Mode is not entered."]
            VALUE2,
            #[doc = "External Input Clock Mode and the oscillator Power-Saving Mode is entered"]
            VALUE3,
            #[doc = "OSC is disabled. The oscillator Power-Saving Mode is entered."]
            VALUE4,
        }
        impl MODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MODER::VALUE1 => 0,
                    MODER::VALUE2 => 0x01,
                    MODER::VALUE3 => 0x02,
                    MODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MODER {
                match value {
                    0 => MODER::VALUE1,
                    1 => MODER::VALUE2,
                    2 => MODER::VALUE3,
                    3 => MODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MODER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct OSCVALR {
            bits: u8,
        }
        impl OSCVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `X1DEN`"]
        pub enum X1DENW {
            #[doc = "Bit X1D is not updated"]
            VALUE1,
            #[doc = "Bit X1D can be updated"]
            VALUE2,
        }
        impl X1DENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    X1DENW::VALUE1 => false,
                    X1DENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _X1DENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _X1DENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: X1DENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Bit X1D is not updated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(X1DENW::VALUE1)
            }
            #[doc = "Bit X1D can be updated"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(X1DENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SHBY`"]
        pub enum SHBYW {
            #[doc = "The shaper is not bypassed"]
            VALUE1,
            #[doc = "The shaper is bypassed"]
            VALUE2,
        }
        impl SHBYW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SHBYW::VALUE1 => false,
                    SHBYW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SHBYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SHBYW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SHBYW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The shaper is not bypassed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SHBYW::VALUE1)
            }
            #[doc = "The shaper is bypassed"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SHBYW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MODE`"]
        pub enum MODEW {
            #[doc = "External Crystal Mode and External Input Clock Mode. The oscillator Power-Saving Mode is not entered."]
            VALUE1,
            #[doc = "OSC is disabled. The oscillator Power-Saving Mode is not entered."]
            VALUE2,
            #[doc = "External Input Clock Mode and the oscillator Power-Saving Mode is entered"]
            VALUE3,
            #[doc = "OSC is disabled. The oscillator Power-Saving Mode is entered."]
            VALUE4,
        }
        impl MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MODEW::VALUE1 => 0,
                    MODEW::VALUE2 => 1,
                    MODEW::VALUE3 => 2,
                    MODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Crystal Mode and External Input Clock Mode. The oscillator Power-Saving Mode is not entered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MODEW::VALUE1)
            }
            #[doc = "OSC is disabled. The oscillator Power-Saving Mode is not entered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MODEW::VALUE2)
            }
            #[doc = "External Input Clock Mode and the oscillator Power-Saving Mode is entered"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MODEW::VALUE3)
            }
            #[doc = "OSC is disabled. The oscillator Power-Saving Mode is entered."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - XTAL1 Data Enable"]
            #[inline]
            pub fn x1den(&self) -> X1DENR {
                X1DENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Shaper Bypass"]
            #[inline]
            pub fn shby(&self) -> SHBYR {
                SHBYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:5 - Oscillator Mode"]
            #[inline]
            pub fn mode(&self) -> MODER {
                MODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - OSC Frequency Value"]
            #[inline]
            pub fn oscval(&self) -> OSCVALR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OSCVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x33 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - XTAL1 Data Enable"]
            #[inline]
            pub fn x1den(&mut self) -> _X1DENW {
                _X1DENW { w: self }
            }
            #[doc = "Bit 1 - Shaper Bypass"]
            #[inline]
            pub fn shby(&mut self) -> _SHBYW {
                _SHBYW { w: self }
            }
            #[doc = "Bits 4:5 - Oscillator Mode"]
            #[inline]
            pub fn mode(&mut self) -> _MODEW {
                _MODEW { w: self }
            }
            #[doc = "Bits 16:19 - OSC Frequency Value"]
            #[inline]
            pub fn oscval(&mut self) -> _OSCVALW {
                _OSCVALW { w: self }
            }
        }
    }
    #[doc = "Clock Calibration Constant Register"]
    pub struct CLKCALCONST {
        register: VolatileCell<u32>,
    }
    #[doc = "Clock Calibration Constant Register"]
    pub mod clkcalconst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLKCALCONST {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CALIBCONSTR {
            bits: u8,
        }
        impl CALIBCONSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CALIBCONSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CALIBCONSTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Clock Calibration Constant Value"]
            #[inline]
            pub fn calibconst(&self) -> CALIBCONSTR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CALIBCONSTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Clock Calibration Constant Value"]
            #[inline]
            pub fn calibconst(&mut self) -> _CALIBCONSTW {
                _CALIBCONSTW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_OSC {
    register_block: scu_osc::RegisterBlock,
}
impl Deref for SCU_OSC {
    type Target = scu_osc::RegisterBlock;
    fn deref(&self) -> &scu_osc::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_PLL: Peripheral<SCU_PLL> = unsafe { Peripheral::new(0x5000_4710) };
#[doc = "System Control Unit"]
pub mod scu_pll {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - PLL Status Register"]
        pub pllstat: PLLSTAT,
        #[doc = "0x04 - PLL Configuration 0 Register"]
        pub pllcon0: PLLCON0,
        #[doc = "0x08 - PLL Configuration 1 Register"]
        pub pllcon1: PLLCON1,
        #[doc = "0x0c - PLL Configuration 2 Register"]
        pub pllcon2: PLLCON2,
        #[doc = "0x10 - USB PLL Status Register"]
        pub usbpllstat: USBPLLSTAT,
        #[doc = "0x14 - USB PLL Configuration Register"]
        pub usbpllcon: USBPLLCON,
        _reserved0: [u8; 16usize],
        #[doc = "0x28 - Clock Multiplexing Status Register"]
        pub clkmxstat: CLKMXSTAT,
    }
    #[doc = "PLL Status Register"]
    pub struct PLLSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "PLL Status Register"]
    pub mod pllstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PLLSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `VCOBYST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOBYSTR {
            #[doc = "Free-running / Normal Mode is entered"]
            VALUE1,
            #[doc = "Prescaler Mode is entered"]
            VALUE2,
        }
        impl VCOBYSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOBYSTR::VALUE1 => false,
                    VCOBYSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOBYSTR {
                match value {
                    false => VCOBYSTR::VALUE1,
                    true => VCOBYSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOBYSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOBYSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PWDSTAT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PWDSTATR {
            #[doc = "PLL Power-saving Mode was not entered"]
            VALUE1,
            #[doc = "PLL Power-saving Mode was entered"]
            VALUE2,
        }
        impl PWDSTATR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PWDSTATR::VALUE1 => false,
                    PWDSTATR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PWDSTATR {
                match value {
                    false => PWDSTATR::VALUE1,
                    true => PWDSTATR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PWDSTATR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PWDSTATR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOLOCK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOLOCKR {
            #[doc = "PLL not locked"]
            VALUE1,
            #[doc = "PLL locked"]
            VALUE2,
        }
        impl VCOLOCKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOLOCKR::VALUE1 => false,
                    VCOLOCKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOLOCKR {
                match value {
                    false => VCOLOCKR::VALUE1,
                    true => VCOLOCKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOLOCKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOLOCKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `K1RDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum K1RDYR {
            #[doc = "K1-Divider does not operate with the new value"]
            VALUE1,
            #[doc = "K1-Divider operate with the new value"]
            VALUE2,
        }
        impl K1RDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    K1RDYR::VALUE1 => false,
                    K1RDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> K1RDYR {
                match value {
                    false => K1RDYR::VALUE1,
                    true => K1RDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == K1RDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == K1RDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `K2RDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum K2RDYR {
            #[doc = "K2-Divider does not operate with the new value"]
            VALUE1,
            #[doc = "K2-Divider operate with the new value"]
            VALUE2,
        }
        impl K2RDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    K2RDYR::VALUE1 => false,
                    K2RDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> K2RDYR {
                match value {
                    false => K2RDYR::VALUE1,
                    true => K2RDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == K2RDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == K2RDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BYR {
            #[doc = "Bypass Mode is not entered"]
            VALUE1,
            #[doc = "Bypass Mode is entered. Input fOSC is selected as output fPLL."]
            VALUE2,
        }
        impl BYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BYR::VALUE1 => false,
                    BYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BYR {
                match value {
                    false => BYR::VALUE1,
                    true => BYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLLLV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLLLVR {
            #[doc = "The OSC frequency is not usable. Frequency fREF is too low."]
            VALUE1,
            #[doc = "The OSC frequency is usable"]
            VALUE2,
        }
        impl PLLLVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLLLVR::VALUE1 => false,
                    PLLLVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLLLVR {
                match value {
                    false => PLLLVR::VALUE1,
                    true => PLLLVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLLLVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLLLVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLLHV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLLHVR {
            #[doc = "The OSC frequency is not usable. Frequency fOSC is too high."]
            VALUE1,
            #[doc = "The OSC frequency is usable"]
            VALUE2,
        }
        impl PLLHVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLLHVR::VALUE1 => false,
                    PLLHVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLLHVR {
                match value {
                    false => PLLHVR::VALUE1,
                    true => PLLHVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLLHVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLLHVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLLSP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLLSPR {
            #[doc = "The OSC frequency is not usable. Spikes are detected that disturb a locked operation"]
            VALUE1,
            #[doc = "The OSC frequency is usable"]
            VALUE2,
        }
        impl PLLSPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLLSPR::VALUE1 => false,
                    PLLSPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLLSPR {
                match value {
                    false => PLLSPR::VALUE1,
                    true => PLLSPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLLSPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLLSPR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - VCO Bypass Status"]
            #[inline]
            pub fn vcobyst(&self) -> VCOBYSTR {
                VCOBYSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - PLL Power-saving Mode Status"]
            #[inline]
            pub fn pwdstat(&self) -> PWDSTATR {
                PWDSTATR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - PLL LOCK Status"]
            #[inline]
            pub fn vcolock(&self) -> VCOLOCKR {
                VCOLOCKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - K1 Divider Ready Status"]
            #[inline]
            pub fn k1rdy(&self) -> K1RDYR {
                K1RDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - K2 Divider Ready Status"]
            #[inline]
            pub fn k2rdy(&self) -> K2RDYR {
                K2RDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Bypass Mode Status"]
            #[inline]
            pub fn by(&self) -> BYR {
                BYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Oscillator for PLL Valid Low Status Bit"]
            #[inline]
            pub fn plllv(&self) -> PLLLVR {
                PLLLVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Oscillator for PLL Valid High Status Bit"]
            #[inline]
            pub fn pllhv(&self) -> PLLHVR {
                PLLHVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Oscillator for PLL Valid Spike Status Bit"]
            #[inline]
            pub fn pllsp(&self) -> PLLSPR {
                PLLSPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "PLL Configuration 0 Register"]
    pub struct PLLCON0 {
        register: VolatileCell<u32>,
    }
    #[doc = "PLL Configuration 0 Register"]
    pub mod pllcon0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PLLCON0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `VCOBYP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOBYPR {
            #[doc = "Normal operation, VCO is not bypassed"]
            VALUE1,
            #[doc = "Prescaler Mode, VCO is bypassed"]
            VALUE2,
        }
        impl VCOBYPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOBYPR::VALUE1 => false,
                    VCOBYPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOBYPR {
                match value {
                    false => VCOBYPR::VALUE1,
                    true => VCOBYPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOBYPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOBYPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOPWD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOPWDR {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The VCO is put into a Power Saving Mode and can no longer be used. Only the Bypass and Prescaler Mode are active if previously selected."]
            VALUE2,
        }
        impl VCOPWDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOPWDR::VALUE1 => false,
                    VCOPWDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOPWDR {
                match value {
                    false => VCOPWDR::VALUE1,
                    true => VCOPWDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOPWDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOPWDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOTRR {
            #[doc = "VCO bandwidth is operation in the normal range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE1,
            #[doc = "VCO bandwidth is operation in the test range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE2,
        }
        impl VCOTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOTRR::VALUE1 => false,
                    VCOTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOTRR {
                match value {
                    false => VCOTRR::VALUE1,
                    true => VCOTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FINDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FINDISR {
            #[doc = "connect oscillator to the VCO part"]
            VALUE1,
            #[doc = "disconnect oscillator from the VCO part."]
            VALUE2,
        }
        impl FINDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FINDISR::VALUE1 => false,
                    FINDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FINDISR {
                match value {
                    false => FINDISR::VALUE1,
                    true => FINDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FINDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FINDISR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCDISCDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCDISCDISR {
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is set"]
            VALUE1,
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is cleared"]
            VALUE2,
        }
        impl OSCDISCDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCDISCDISR::VALUE1 => false,
                    OSCDISCDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCDISCDISR {
                match value {
                    false => OSCDISCDISR::VALUE1,
                    true => OSCDISCDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCDISCDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCDISCDISR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLLPWD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLLPWDR {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The complete PLL block is put into a Power Saving Mode and can no longer be used. Only the Bypass Mode is active if previously selected."]
            VALUE2,
        }
        impl PLLPWDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLLPWDR::VALUE1 => false,
                    PLLPWDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLLPWDR {
                match value {
                    false => PLLPWDR::VALUE1,
                    true => PLLPWDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLLPWDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLLPWDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCRES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCRESR {
            #[doc = "The Oscillator Watchdog of the PLL is not cleared and remains active"]
            VALUE1,
            #[doc = "The Oscillator Watchdog of the PLL is cleared and restarted"]
            VALUE2,
        }
        impl OSCRESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCRESR::VALUE1 => false,
                    OSCRESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCRESR {
                match value {
                    false => OSCRESR::VALUE1,
                    true => OSCRESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCRESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCRESR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AOTREN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AOTRENR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl AOTRENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AOTRENR::VALUE1 => false,
                    AOTRENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AOTRENR {
                match value {
                    false => AOTRENR::VALUE1,
                    true => AOTRENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AOTRENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AOTRENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FOTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FOTRR {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Force fixed-value trimming"]
            VALUE2,
        }
        impl FOTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FOTRR::VALUE1 => false,
                    FOTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FOTRR {
                match value {
                    false => FOTRR::VALUE1,
                    true => FOTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FOTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FOTRR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `VCOBYP`"]
        pub enum VCOBYPW {
            #[doc = "Normal operation, VCO is not bypassed"]
            VALUE1,
            #[doc = "Prescaler Mode, VCO is bypassed"]
            VALUE2,
        }
        impl VCOBYPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOBYPW::VALUE1 => false,
                    VCOBYPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOBYPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOBYPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOBYPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal operation, VCO is not bypassed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOBYPW::VALUE1)
            }
            #[doc = "Prescaler Mode, VCO is bypassed"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOBYPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VCOPWD`"]
        pub enum VCOPWDW {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The VCO is put into a Power Saving Mode and can no longer be used. Only the Bypass and Prescaler Mode are active if previously selected."]
            VALUE2,
        }
        impl VCOPWDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOPWDW::VALUE1 => false,
                    VCOPWDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOPWDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOPWDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOPWDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal behavior"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOPWDW::VALUE1)
            }
            #[doc = "The VCO is put into a Power Saving Mode and can no longer be used. Only the Bypass and Prescaler Mode are active if previously selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOPWDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VCOTR`"]
        pub enum VCOTRW {
            #[doc = "VCO bandwidth is operation in the normal range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE1,
            #[doc = "VCO bandwidth is operation in the test range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE2,
        }
        impl VCOTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOTRW::VALUE1 => false,
                    VCOTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "VCO bandwidth is operation in the normal range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOTRW::VALUE1)
            }
            #[doc = "VCO bandwidth is operation in the test range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FINDIS`"]
        pub enum FINDISW {
            #[doc = "connect oscillator to the VCO part"]
            VALUE1,
            #[doc = "disconnect oscillator from the VCO part."]
            VALUE2,
        }
        impl FINDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FINDISW::VALUE1 => false,
                    FINDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FINDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FINDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FINDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "connect oscillator to the VCO part"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FINDISW::VALUE1)
            }
            #[doc = "disconnect oscillator from the VCO part."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FINDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCDISCDIS`"]
        pub enum OSCDISCDISW {
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is set"]
            VALUE1,
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is cleared"]
            VALUE2,
        }
        impl OSCDISCDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCDISCDISW::VALUE1 => false,
                    OSCDISCDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCDISCDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCDISCDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCDISCDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is set"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCDISCDISW::VALUE1)
            }
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is cleared"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCDISCDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLLPWD`"]
        pub enum PLLPWDW {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The complete PLL block is put into a Power Saving Mode and can no longer be used. Only the Bypass Mode is active if previously selected."]
            VALUE2,
        }
        impl PLLPWDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PLLPWDW::VALUE1 => false,
                    PLLPWDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLLPWDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLLPWDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLLPWDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal behavior"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLLPWDW::VALUE1)
            }
            #[doc = "The complete PLL block is put into a Power Saving Mode and can no longer be used. Only the Bypass Mode is active if previously selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLLPWDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCRES`"]
        pub enum OSCRESW {
            #[doc = "The Oscillator Watchdog of the PLL is not cleared and remains active"]
            VALUE1,
            #[doc = "The Oscillator Watchdog of the PLL is cleared and restarted"]
            VALUE2,
        }
        impl OSCRESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCRESW::VALUE1 => false,
                    OSCRESW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCRESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCRESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCRESW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The Oscillator Watchdog of the PLL is not cleared and remains active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCRESW::VALUE1)
            }
            #[doc = "The Oscillator Watchdog of the PLL is cleared and restarted"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCRESW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AOTREN`"]
        pub enum AOTRENW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl AOTRENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AOTRENW::VALUE1 => false,
                    AOTRENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AOTRENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AOTRENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AOTRENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AOTRENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AOTRENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FOTR`"]
        pub enum FOTRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Force fixed-value trimming"]
            VALUE2,
        }
        impl FOTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FOTRW::VALUE1 => false,
                    FOTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FOTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FOTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FOTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FOTRW::VALUE1)
            }
            #[doc = "Force fixed-value trimming"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FOTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - VCO Bypass"]
            #[inline]
            pub fn vcobyp(&self) -> VCOBYPR {
                VCOBYPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - VCO Power Saving Mode"]
            #[inline]
            pub fn vcopwd(&self) -> VCOPWDR {
                VCOPWDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - VCO Trim Control"]
            #[inline]
            pub fn vcotr(&self) -> VCOTRR {
                VCOTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Disconnect Oscillator from VCO"]
            #[inline]
            pub fn findis(&self) -> FINDISR {
                FINDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Oscillator Disconnect Disable"]
            #[inline]
            pub fn oscdiscdis(&self) -> OSCDISCDISR {
                OSCDISCDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - PLL Power Saving Mode"]
            #[inline]
            pub fn pllpwd(&self) -> PLLPWDR {
                PLLPWDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Oscillator Watchdog Reset"]
            #[inline]
            pub fn oscres(&self) -> OSCRESR {
                OSCRESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - Automatic Oscillator Calibration Enable"]
            #[inline]
            pub fn aotren(&self) -> AOTRENR {
                AOTRENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - Factory Oscillator Calibration"]
            #[inline]
            pub fn fotr(&self) -> FOTRR {
                FOTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0003_0003 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - VCO Bypass"]
            #[inline]
            pub fn vcobyp(&mut self) -> _VCOBYPW {
                _VCOBYPW { w: self }
            }
            #[doc = "Bit 1 - VCO Power Saving Mode"]
            #[inline]
            pub fn vcopwd(&mut self) -> _VCOPWDW {
                _VCOPWDW { w: self }
            }
            #[doc = "Bit 2 - VCO Trim Control"]
            #[inline]
            pub fn vcotr(&mut self) -> _VCOTRW {
                _VCOTRW { w: self }
            }
            #[doc = "Bit 4 - Disconnect Oscillator from VCO"]
            #[inline]
            pub fn findis(&mut self) -> _FINDISW {
                _FINDISW { w: self }
            }
            #[doc = "Bit 6 - Oscillator Disconnect Disable"]
            #[inline]
            pub fn oscdiscdis(&mut self) -> _OSCDISCDISW {
                _OSCDISCDISW { w: self }
            }
            #[doc = "Bit 16 - PLL Power Saving Mode"]
            #[inline]
            pub fn pllpwd(&mut self) -> _PLLPWDW {
                _PLLPWDW { w: self }
            }
            #[doc = "Bit 17 - Oscillator Watchdog Reset"]
            #[inline]
            pub fn oscres(&mut self) -> _OSCRESW {
                _OSCRESW { w: self }
            }
            #[doc = "Bit 18 - Restart VCO Lock Detection"]
            #[inline]
            pub fn resld(&mut self) -> _RESLDW {
                _RESLDW { w: self }
            }
            #[doc = "Bit 19 - Automatic Oscillator Calibration Enable"]
            #[inline]
            pub fn aotren(&mut self) -> _AOTRENW {
                _AOTRENW { w: self }
            }
            #[doc = "Bit 20 - Factory Oscillator Calibration"]
            #[inline]
            pub fn fotr(&mut self) -> _FOTRW {
                _FOTRW { w: self }
            }
        }
    }
    #[doc = "PLL Configuration 1 Register"]
    pub struct PLLCON1 {
        register: VolatileCell<u32>,
    }
    #[doc = "PLL Configuration 1 Register"]
    pub mod pllcon1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PLLCON1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct K1DIVR {
            bits: u8,
        }
        impl K1DIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct NDIVR {
            bits: u8,
        }
        impl NDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct K2DIVR {
            bits: u8,
        }
        impl K2DIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PDIVR {
            bits: u8,
        }
        impl PDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _K1DIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _K1DIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _K2DIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _K2DIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:6 - K1-Divider Value"]
            #[inline]
            pub fn k1div(&self) -> K1DIVR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                K1DIVR { bits }
            }
            #[doc = "Bits 8:14 - N-Divider Value"]
            #[inline]
            pub fn ndiv(&self) -> NDIVR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                NDIVR { bits }
            }
            #[doc = "Bits 16:22 - K2-Divider Value"]
            #[inline]
            pub fn k2div(&self) -> K2DIVR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                K2DIVR { bits }
            }
            #[doc = "Bits 24:27 - P-Divider Value"]
            #[inline]
            pub fn pdiv(&self) -> PDIVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PDIVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:6 - K1-Divider Value"]
            #[inline]
            pub fn k1div(&mut self) -> _K1DIVW {
                _K1DIVW { w: self }
            }
            #[doc = "Bits 8:14 - N-Divider Value"]
            #[inline]
            pub fn ndiv(&mut self) -> _NDIVW {
                _NDIVW { w: self }
            }
            #[doc = "Bits 16:22 - K2-Divider Value"]
            #[inline]
            pub fn k2div(&mut self) -> _K2DIVW {
                _K2DIVW { w: self }
            }
            #[doc = "Bits 24:27 - P-Divider Value"]
            #[inline]
            pub fn pdiv(&mut self) -> _PDIVW {
                _PDIVW { w: self }
            }
        }
    }
    #[doc = "PLL Configuration 2 Register"]
    pub struct PLLCON2 {
        register: VolatileCell<u32>,
    }
    #[doc = "PLL Configuration 2 Register"]
    pub mod pllcon2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PLLCON2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PINSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PINSELR {
            #[doc = "PLL external oscillator selected"]
            VALUE1,
            #[doc = "Backup clock fofi selected"]
            VALUE2,
        }
        impl PINSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PINSELR::VALUE1 => false,
                    PINSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PINSELR {
                match value {
                    false => PINSELR::VALUE1,
                    true => PINSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PINSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PINSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `K1INSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum K1INSELR {
            #[doc = "PLL external oscillator selected"]
            VALUE1,
            #[doc = "Backup clock fofi selected"]
            VALUE2,
        }
        impl K1INSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    K1INSELR::VALUE1 => false,
                    K1INSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> K1INSELR {
                match value {
                    false => K1INSELR::VALUE1,
                    true => K1INSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == K1INSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == K1INSELR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PINSEL`"]
        pub enum PINSELW {
            #[doc = "PLL external oscillator selected"]
            VALUE1,
            #[doc = "Backup clock fofi selected"]
            VALUE2,
        }
        impl PINSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PINSELW::VALUE1 => false,
                    PINSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PINSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PINSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PINSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "PLL external oscillator selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PINSELW::VALUE1)
            }
            #[doc = "Backup clock fofi selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PINSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `K1INSEL`"]
        pub enum K1INSELW {
            #[doc = "PLL external oscillator selected"]
            VALUE1,
            #[doc = "Backup clock fofi selected"]
            VALUE2,
        }
        impl K1INSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    K1INSELW::VALUE1 => false,
                    K1INSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _K1INSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _K1INSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: K1INSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "PLL external oscillator selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(K1INSELW::VALUE1)
            }
            #[doc = "Backup clock fofi selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(K1INSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - P-Divider Input Selection"]
            #[inline]
            pub fn pinsel(&self) -> PINSELR {
                PINSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - K1-Divider Input Selection"]
            #[inline]
            pub fn k1insel(&self) -> K1INSELR {
                K1INSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x01 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - P-Divider Input Selection"]
            #[inline]
            pub fn pinsel(&mut self) -> _PINSELW {
                _PINSELW { w: self }
            }
            #[doc = "Bit 8 - K1-Divider Input Selection"]
            #[inline]
            pub fn k1insel(&mut self) -> _K1INSELW {
                _K1INSELW { w: self }
            }
        }
    }
    #[doc = "USB PLL Status Register"]
    pub struct USBPLLSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "USB PLL Status Register"]
    pub mod usbpllstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::USBPLLSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `VCOBYST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOBYSTR {
            #[doc = "Normal Mode is entered"]
            VALUE1,
            #[doc = "Prescaler Mode is entered"]
            VALUE2,
        }
        impl VCOBYSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOBYSTR::VALUE1 => false,
                    VCOBYSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOBYSTR {
                match value {
                    false => VCOBYSTR::VALUE1,
                    true => VCOBYSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOBYSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOBYSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PWDSTAT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PWDSTATR {
            #[doc = "PLL Power-saving Mode was not entered"]
            VALUE1,
            #[doc = "PLL Power-saving Mode was entered"]
            VALUE2,
        }
        impl PWDSTATR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PWDSTATR::VALUE1 => false,
                    PWDSTATR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PWDSTATR {
                match value {
                    false => PWDSTATR::VALUE1,
                    true => PWDSTATR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PWDSTATR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PWDSTATR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOLOCK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOLOCKR {
            #[doc = "The frequency difference of fREF and fDIV is greater than allowed. The VCO part of the PLL can not lock on a target frequency."]
            VALUE1,
            #[doc = "The frequency difference of fREF and fDIV is small enough to enable a stable VCO operation"]
            VALUE2,
        }
        impl VCOLOCKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOLOCKR::VALUE1 => false,
                    VCOLOCKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOLOCKR {
                match value {
                    false => VCOLOCKR::VALUE1,
                    true => VCOLOCKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOLOCKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOLOCKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BYR {
            #[doc = "Bypass Mode is not entered"]
            VALUE1,
            #[doc = "Bypass Mode is entered. Input fOSC is selected as output fPLL."]
            VALUE2,
        }
        impl BYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BYR::VALUE1 => false,
                    BYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BYR {
                match value {
                    false => BYR::VALUE1,
                    true => BYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOLOCKED`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOLOCKEDR {
            #[doc = "PLL not locked"]
            VALUE1,
            #[doc = "PLL locked"]
            VALUE2,
        }
        impl VCOLOCKEDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOLOCKEDR::VALUE1 => false,
                    VCOLOCKEDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOLOCKEDR {
                match value {
                    false => VCOLOCKEDR::VALUE1,
                    true => VCOLOCKEDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOLOCKEDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOLOCKEDR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - VCO Bypass Status"]
            #[inline]
            pub fn vcobyst(&self) -> VCOBYSTR {
                VCOBYSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - PLL Power-saving Mode Status"]
            #[inline]
            pub fn pwdstat(&self) -> PWDSTATR {
                PWDSTATR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - PLL VCO Lock Status"]
            #[inline]
            pub fn vcolock(&self) -> VCOLOCKR {
                VCOLOCKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Bypass Mode Status"]
            #[inline]
            pub fn by(&self) -> BYR {
                BYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - PLL LOCK Status"]
            #[inline]
            pub fn vcolocked(&self) -> VCOLOCKEDR {
                VCOLOCKEDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "USB PLL Configuration Register"]
    pub struct USBPLLCON {
        register: VolatileCell<u32>,
    }
    #[doc = "USB PLL Configuration Register"]
    pub mod usbpllcon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::USBPLLCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `VCOBYP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOBYPR {
            #[doc = "Normal operation, VCO is not bypassed"]
            VALUE1,
            #[doc = "Prescaler Mode, VCO is bypassed"]
            VALUE2,
        }
        impl VCOBYPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOBYPR::VALUE1 => false,
                    VCOBYPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOBYPR {
                match value {
                    false => VCOBYPR::VALUE1,
                    true => VCOBYPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOBYPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOBYPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOPWD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOPWDR {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The VCO is put into a Power Saving Mode"]
            VALUE2,
        }
        impl VCOPWDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOPWDR::VALUE1 => false,
                    VCOPWDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOPWDR {
                match value {
                    false => VCOPWDR::VALUE1,
                    true => VCOPWDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOPWDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOPWDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VCOTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VCOTRR {
            #[doc = "VCO bandwidth is operating in the normal range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE1,
            #[doc = "VCO bandwidth is operating in the test range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE2,
        }
        impl VCOTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VCOTRR::VALUE1 => false,
                    VCOTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VCOTRR {
                match value {
                    false => VCOTRR::VALUE1,
                    true => VCOTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VCOTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VCOTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FINDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FINDISR {
            #[doc = "Connect oscillator to the VCO part"]
            VALUE1,
            #[doc = "Disconnect oscillator from the VCO part."]
            VALUE2,
        }
        impl FINDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FINDISR::VALUE1 => false,
                    FINDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FINDISR {
                match value {
                    false => FINDISR::VALUE1,
                    true => FINDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FINDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FINDISR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCDISCDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCDISCDISR {
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is set"]
            VALUE1,
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is cleared"]
            VALUE2,
        }
        impl OSCDISCDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCDISCDISR::VALUE1 => false,
                    OSCDISCDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCDISCDISR {
                match value {
                    false => OSCDISCDISR::VALUE1,
                    true => OSCDISCDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCDISCDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCDISCDISR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct NDIVR {
            bits: u8,
        }
        impl NDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `PLLPWD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLLPWDR {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The complete PLL block is put into a Power Saving Mode. Only the Bypass Mode is active if previously selected."]
            VALUE2,
        }
        impl PLLPWDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLLPWDR::VALUE1 => false,
                    PLLPWDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLLPWDR {
                match value {
                    false => PLLPWDR::VALUE1,
                    true => PLLPWDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLLPWDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLLPWDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PDIVR {
            bits: u8,
        }
        impl PDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `VCOBYP`"]
        pub enum VCOBYPW {
            #[doc = "Normal operation, VCO is not bypassed"]
            VALUE1,
            #[doc = "Prescaler Mode, VCO is bypassed"]
            VALUE2,
        }
        impl VCOBYPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOBYPW::VALUE1 => false,
                    VCOBYPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOBYPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOBYPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOBYPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal operation, VCO is not bypassed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOBYPW::VALUE1)
            }
            #[doc = "Prescaler Mode, VCO is bypassed"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOBYPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VCOPWD`"]
        pub enum VCOPWDW {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The VCO is put into a Power Saving Mode"]
            VALUE2,
        }
        impl VCOPWDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOPWDW::VALUE1 => false,
                    VCOPWDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOPWDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOPWDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOPWDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal behavior"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOPWDW::VALUE1)
            }
            #[doc = "The VCO is put into a Power Saving Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOPWDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VCOTR`"]
        pub enum VCOTRW {
            #[doc = "VCO bandwidth is operating in the normal range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE1,
            #[doc = "VCO bandwidth is operating in the test range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            VALUE2,
        }
        impl VCOTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOTRW::VALUE1 => false,
                    VCOTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "VCO bandwidth is operating in the normal range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOTRW::VALUE1)
            }
            #[doc = "VCO bandwidth is operating in the test range. VCO output frequency is between 260 and 520 MHz for a input frequency between 8 and 16 MHz."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FINDIS`"]
        pub enum FINDISW {
            #[doc = "Connect oscillator to the VCO part"]
            VALUE1,
            #[doc = "Disconnect oscillator from the VCO part."]
            VALUE2,
        }
        impl FINDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FINDISW::VALUE1 => false,
                    FINDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FINDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FINDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FINDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Connect oscillator to the VCO part"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FINDISW::VALUE1)
            }
            #[doc = "Disconnect oscillator from the VCO part."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FINDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCDISCDIS`"]
        pub enum OSCDISCDISW {
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is set"]
            VALUE1,
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is cleared"]
            VALUE2,
        }
        impl OSCDISCDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCDISCDISW::VALUE1 => false,
                    OSCDISCDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCDISCDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCDISCDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCDISCDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is set"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCDISCDISW::VALUE1)
            }
            #[doc = "In case of a PLL loss-of-lock bit FINDIS is cleared"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCDISCDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLLPWD`"]
        pub enum PLLPWDW {
            #[doc = "Normal behavior"]
            VALUE1,
            #[doc = "The complete PLL block is put into a Power Saving Mode. Only the Bypass Mode is active if previously selected."]
            VALUE2,
        }
        impl PLLPWDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PLLPWDW::VALUE1 => false,
                    PLLPWDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLLPWDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLLPWDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLLPWDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal behavior"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLLPWDW::VALUE1)
            }
            #[doc = "The complete PLL block is put into a Power Saving Mode. Only the Bypass Mode is active if previously selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLLPWDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - VCO Bypass"]
            #[inline]
            pub fn vcobyp(&self) -> VCOBYPR {
                VCOBYPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - VCO Power Saving Mode"]
            #[inline]
            pub fn vcopwd(&self) -> VCOPWDR {
                VCOPWDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - VCO Trim Control"]
            #[inline]
            pub fn vcotr(&self) -> VCOTRR {
                VCOTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Disconnect Oscillator from VCO"]
            #[inline]
            pub fn findis(&self) -> FINDISR {
                FINDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Oscillator Disconnect Disable"]
            #[inline]
            pub fn oscdiscdis(&self) -> OSCDISCDISR {
                OSCDISCDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 8:14 - N-Divider Value"]
            #[inline]
            pub fn ndiv(&self) -> NDIVR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                NDIVR { bits }
            }
            #[doc = "Bit 16 - PLL Power Saving Mode"]
            #[inline]
            pub fn pllpwd(&self) -> PLLPWDR {
                PLLPWDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 24:27 - P-Divider Value"]
            #[inline]
            pub fn pdiv(&self) -> PDIVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PDIVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0001_0003 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - VCO Bypass"]
            #[inline]
            pub fn vcobyp(&mut self) -> _VCOBYPW {
                _VCOBYPW { w: self }
            }
            #[doc = "Bit 1 - VCO Power Saving Mode"]
            #[inline]
            pub fn vcopwd(&mut self) -> _VCOPWDW {
                _VCOPWDW { w: self }
            }
            #[doc = "Bit 2 - VCO Trim Control"]
            #[inline]
            pub fn vcotr(&mut self) -> _VCOTRW {
                _VCOTRW { w: self }
            }
            #[doc = "Bit 4 - Disconnect Oscillator from VCO"]
            #[inline]
            pub fn findis(&mut self) -> _FINDISW {
                _FINDISW { w: self }
            }
            #[doc = "Bit 6 - Oscillator Disconnect Disable"]
            #[inline]
            pub fn oscdiscdis(&mut self) -> _OSCDISCDISW {
                _OSCDISCDISW { w: self }
            }
            #[doc = "Bits 8:14 - N-Divider Value"]
            #[inline]
            pub fn ndiv(&mut self) -> _NDIVW {
                _NDIVW { w: self }
            }
            #[doc = "Bit 16 - PLL Power Saving Mode"]
            #[inline]
            pub fn pllpwd(&mut self) -> _PLLPWDW {
                _PLLPWDW { w: self }
            }
            #[doc = "Bit 18 - Restart VCO Lock Detection"]
            #[inline]
            pub fn resld(&mut self) -> _RESLDW {
                _RESLDW { w: self }
            }
            #[doc = "Bits 24:27 - P-Divider Value"]
            #[inline]
            pub fn pdiv(&mut self) -> _PDIVW {
                _PDIVW { w: self }
            }
        }
    }
    #[doc = "Clock Multiplexing Status Register"]
    pub struct CLKMXSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Clock Multiplexing Status Register"]
    pub mod clkmxstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CLKMXSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `SYSCLKMUX`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SYSCLKMUXR {
            #[doc = "fOFI clock active"]
            VALUE1,
            #[doc = "fPLL clock active"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SYSCLKMUXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SYSCLKMUXR::VALUE1 => 0x01,
                    SYSCLKMUXR::VALUE2 => 0x02,
                    SYSCLKMUXR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SYSCLKMUXR {
                match value {
                    1 => SYSCLKMUXR::VALUE1,
                    2 => SYSCLKMUXR::VALUE2,
                    i => SYSCLKMUXR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SYSCLKMUXR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SYSCLKMUXR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Status of System clock multiplexing upon source switching"]
            #[inline]
            pub fn sysclkmux(&self) -> SYSCLKMUXR {
                SYSCLKMUXR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_PLL {
    register_block: scu_pll::RegisterBlock,
}
impl Deref for SCU_PLL {
    type Target = scu_pll::RegisterBlock;
    fn deref(&self) -> &scu_pll::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_GENERAL: Peripheral<SCU_GENERAL> = unsafe { Peripheral::new(0x5000_4000) };
#[doc = "System Control Unit"]
pub mod scu_general {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - SCU Module ID Register"]
        pub id: ID,
        #[doc = "0x04 - Chip ID Register"]
        pub idchip: IDCHIP,
        #[doc = "0x08 - Manufactory ID Register"]
        pub idmanuf: IDMANUF,
        _reserved0: [u8; 4usize],
        #[doc = "0x10 - Startup Configuration Register"]
        pub stcon: STCON,
        _reserved1: [u8; 24usize],
        #[doc = "0x2c - General Purpose Register 0"]
        pub gpr0: GPR0,
        #[doc = "0x30 - General Purpose Register 1"]
        pub gpr1: GPR1,
        _reserved2: [u8; 24usize],
        #[doc = "0x4c - CCU Control Register"]
        pub ccucon: CCUCON,
        _reserved3: [u8; 60usize],
        #[doc = "0x8c - Die Temperature Sensor Control Register"]
        pub dtscon: DTSCON,
        #[doc = "0x90 - Die Temperature Sensor Status Register"]
        pub dtsstat: DTSSTAT,
        _reserved4: [u8; 12usize],
        #[doc = "0xa0 - Out of Range Comparator Enable Register 0"]
        pub g0orcen: G0ORCEN,
        #[doc = "0xa4 - Out of Range Comparator Enable Register 1"]
        pub g1orcen: G1ORCEN,
        #[doc = "0xa8 - Die Temperature Sensor Limit Register"]
        pub dtemplim: DTEMPLIM,
        #[doc = "0xac - Die Temperature Sensor Alarm Register"]
        pub dtempalarm: DTEMPALARM,
        _reserved5: [u8; 20usize],
        #[doc = "0xc4 - Mirror Write Status Register"]
        pub mirrsts: MIRRSTS,
        #[doc = "0xc8 - Retention Memory Access Control Register"]
        pub rmacr: RMACR,
        #[doc = "0xcc - Retention Memory Access Data Register"]
        pub rmdata: RMDATA,
        #[doc = "0xd0 - Mirror All Status"]
        pub mirrallstat: MIRRALLSTAT,
        #[doc = "0xd4 - Mirror All Request"]
        pub mirrallreq: MIRRALLREQ,
    }
    #[doc = "SCU Module ID Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Module ID Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "Chip ID Register"]
    pub struct IDCHIP {
        register: VolatileCell<u32>,
    }
    #[doc = "Chip ID Register"]
    pub mod idchip {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IDCHIP {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct IDCHIPR {
            bits: u32,
        }
        impl IDCHIPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Chip ID"]
            #[inline]
            pub fn idchip(&self) -> IDCHIPR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IDCHIPR { bits }
            }
        }
    }
    #[doc = "Manufactory ID Register"]
    pub struct IDMANUF {
        register: VolatileCell<u32>,
    }
    #[doc = "Manufactory ID Register"]
    pub mod idmanuf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IDMANUF {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEPTR {
            bits: u8,
        }
        impl DEPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MANUFR {
            bits: u16,
        }
        impl MANUFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Department Identification Number"]
            #[inline]
            pub fn dept(&self) -> DEPTR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DEPTR { bits }
            }
            #[doc = "Bits 5:15 - Manufacturer Identification Number"]
            #[inline]
            pub fn manuf(&self) -> MANUFR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MANUFR { bits }
            }
        }
    }
    #[doc = "Startup Configuration Register"]
    pub struct STCON {
        register: VolatileCell<u32>,
    }
    #[doc = "Startup Configuration Register"]
    pub mod stcon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::STCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HWCON`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HWCONR {
            #[doc = "Normal mode, JTAG"]
            VALUE1,
            #[doc = "ASC BSL enabled"]
            VALUE2,
            #[doc = "BMI customized boot enabled"]
            VALUE3,
            #[doc = "CAN BSL enabled"]
            VALUE4,
        }
        impl HWCONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HWCONR::VALUE1 => 0,
                    HWCONR::VALUE2 => 0x01,
                    HWCONR::VALUE3 => 0x02,
                    HWCONR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HWCONR {
                match value {
                    0 => HWCONR::VALUE1,
                    1 => HWCONR::VALUE2,
                    2 => HWCONR::VALUE3,
                    3 => HWCONR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HWCONR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HWCONR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HWCONR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == HWCONR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SWCON`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SWCONR {
            #[doc = "Normal mode, boot from Boot ROM"]
            VALUE1,
            #[doc = "ASC BSL enabled"]
            VALUE2,
            #[doc = "BMI customized boot enabled"]
            VALUE3,
            #[doc = "CAN BSL enabled"]
            VALUE4,
            #[doc = "Boot from Code SRAM"]
            VALUE5,
            #[doc = "Boot from alternate Flash Address 0"]
            VALUE6,
            #[doc = "Boot from alternate Flash Address 1"]
            VALUE7,
            #[doc = "Enable fallback Alternate Boot Mode (ABM)"]
            VALUE8,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SWCONR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SWCONR::VALUE1 => 0,
                    SWCONR::VALUE2 => 0x01,
                    SWCONR::VALUE3 => 0x02,
                    SWCONR::VALUE4 => 0x03,
                    SWCONR::VALUE5 => 0x04,
                    SWCONR::VALUE6 => 0x08,
                    SWCONR::VALUE7 => 0x0c,
                    SWCONR::VALUE8 => 0x0e,
                    SWCONR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SWCONR {
                match value {
                    0 => SWCONR::VALUE1,
                    1 => SWCONR::VALUE2,
                    2 => SWCONR::VALUE3,
                    3 => SWCONR::VALUE4,
                    4 => SWCONR::VALUE5,
                    8 => SWCONR::VALUE6,
                    12 => SWCONR::VALUE7,
                    14 => SWCONR::VALUE8,
                    i => SWCONR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SWCONR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SWCONR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SWCONR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SWCONR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SWCONR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SWCONR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == SWCONR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == SWCONR::VALUE8
            }
        }
        #[doc = "Values that can be written to the field `SWCON`"]
        pub enum SWCONW {
            #[doc = "Normal mode, boot from Boot ROM"]
            VALUE1,
            #[doc = "ASC BSL enabled"]
            VALUE2,
            #[doc = "BMI customized boot enabled"]
            VALUE3,
            #[doc = "CAN BSL enabled"]
            VALUE4,
            #[doc = "Boot from Code SRAM"]
            VALUE5,
            #[doc = "Boot from alternate Flash Address 0"]
            VALUE6,
            #[doc = "Boot from alternate Flash Address 1"]
            VALUE7,
            #[doc = "Enable fallback Alternate Boot Mode (ABM)"]
            VALUE8,
        }
        impl SWCONW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SWCONW::VALUE1 => 0,
                    SWCONW::VALUE2 => 1,
                    SWCONW::VALUE3 => 2,
                    SWCONW::VALUE4 => 3,
                    SWCONW::VALUE5 => 4,
                    SWCONW::VALUE6 => 8,
                    SWCONW::VALUE7 => 12,
                    SWCONW::VALUE8 => 14,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SWCONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SWCONW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SWCONW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Normal mode, boot from Boot ROM"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SWCONW::VALUE1)
            }
            #[doc = "ASC BSL enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SWCONW::VALUE2)
            }
            #[doc = "BMI customized boot enabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SWCONW::VALUE3)
            }
            #[doc = "CAN BSL enabled"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SWCONW::VALUE4)
            }
            #[doc = "Boot from Code SRAM"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SWCONW::VALUE5)
            }
            #[doc = "Boot from alternate Flash Address 0"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SWCONW::VALUE6)
            }
            #[doc = "Boot from alternate Flash Address 1"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(SWCONW::VALUE7)
            }
            #[doc = "Enable fallback Alternate Boot Mode (ABM)"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(SWCONW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - HW Configuration"]
            #[inline]
            pub fn hwcon(&self) -> HWCONR {
                HWCONR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - SW Configuration"]
            #[inline]
            pub fn swcon(&self) -> SWCONR {
                SWCONR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 8:11 - SW Configuration"]
            #[inline]
            pub fn swcon(&mut self) -> _SWCONW {
                _SWCONW { w: self }
            }
        }
    }
    #[doc = "General Purpose Register 0"]
    pub struct GPR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "General Purpose Register 0"]
    pub mod gpr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GPR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATR {
            bits: u32,
        }
        impl DATR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - User Data"]
            #[inline]
            pub fn dat(&self) -> DATR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DATR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - User Data"]
            #[inline]
            pub fn dat(&mut self) -> _DATW {
                _DATW { w: self }
            }
        }
    }
    #[doc = "General Purpose Register 1"]
    pub struct GPR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "General Purpose Register 1"]
    pub mod gpr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GPR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATR {
            bits: u32,
        }
        impl DATR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - User Data"]
            #[inline]
            pub fn dat(&self) -> DATR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DATR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - User Data"]
            #[inline]
            pub fn dat(&mut self) -> _DATW {
                _DATW { w: self }
            }
        }
    }
    #[doc = "CCU Control Register"]
    pub struct CCUCON {
        register: VolatileCell<u32>,
    }
    #[doc = "CCU Control Register"]
    pub mod ccucon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CCUCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `GSC40`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GSC40R {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSC40R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GSC40R::VALUE1 => false,
                    GSC40R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GSC40R {
                match value {
                    false => GSC40R::VALUE1,
                    true => GSC40R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GSC40R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GSC40R::VALUE2
            }
        }
        #[doc = "Possible values of the field `GSC41`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GSC41R {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSC41R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GSC41R::VALUE1 => false,
                    GSC41R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GSC41R {
                match value {
                    false => GSC41R::VALUE1,
                    true => GSC41R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GSC41R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GSC41R::VALUE2
            }
        }
        #[doc = "Possible values of the field `GSC80`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GSC80R {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSC80R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GSC80R::VALUE1 => false,
                    GSC80R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GSC80R {
                match value {
                    false => GSC80R::VALUE1,
                    true => GSC80R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GSC80R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GSC80R::VALUE2
            }
        }
        #[doc = "Possible values of the field `GSHR0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GSHR0R {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSHR0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GSHR0R::VALUE1 => false,
                    GSHR0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GSHR0R {
                match value {
                    false => GSHR0R::VALUE1,
                    true => GSHR0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GSHR0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GSHR0R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `GSC40`"]
        pub enum GSC40W {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSC40W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GSC40W::VALUE1 => false,
                    GSC40W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GSC40W<'a> {
            w: &'a mut W,
        }
        impl<'a> _GSC40W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GSC40W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GSC40W::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GSC40W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GSC41`"]
        pub enum GSC41W {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSC41W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GSC41W::VALUE1 => false,
                    GSC41W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GSC41W<'a> {
            w: &'a mut W,
        }
        impl<'a> _GSC41W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GSC41W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GSC41W::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GSC41W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GSC80`"]
        pub enum GSC80W {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSC80W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GSC80W::VALUE1 => false,
                    GSC80W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GSC80W<'a> {
            w: &'a mut W,
        }
        impl<'a> _GSC80W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GSC80W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GSC80W::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GSC80W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GSHR0`"]
        pub enum GSHR0W {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl GSHR0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GSHR0W::VALUE1 => false,
                    GSHR0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GSHR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _GSHR0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GSHR0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GSHR0W::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GSHR0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Global Start Control CCU40"]
            #[inline]
            pub fn gsc40(&self) -> GSC40R {
                GSC40R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Global Start Control CCU41"]
            #[inline]
            pub fn gsc41(&self) -> GSC41R {
                GSC41R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Global Start Control CCU80"]
            #[inline]
            pub fn gsc80(&self) -> GSC80R {
                GSC80R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Global Start Control HRPWM0"]
            #[inline]
            pub fn gshr0(&self) -> GSHR0R {
                GSHR0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Global Start Control CCU40"]
            #[inline]
            pub fn gsc40(&mut self) -> _GSC40W {
                _GSC40W { w: self }
            }
            #[doc = "Bit 1 - Global Start Control CCU41"]
            #[inline]
            pub fn gsc41(&mut self) -> _GSC41W {
                _GSC41W { w: self }
            }
            #[doc = "Bit 8 - Global Start Control CCU80"]
            #[inline]
            pub fn gsc80(&mut self) -> _GSC80W {
                _GSC80W { w: self }
            }
            #[doc = "Bit 24 - Global Start Control HRPWM0"]
            #[inline]
            pub fn gshr0(&mut self) -> _GSHR0W {
                _GSHR0W { w: self }
            }
        }
    }
    #[doc = "Die Temperature Sensor Control Register"]
    pub struct DTSCON {
        register: VolatileCell<u32>,
    }
    #[doc = "Die Temperature Sensor Control Register"]
    pub mod dtscon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DTSCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PWD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PWDR {
            #[doc = "The DTS is powered"]
            VALUE1,
            #[doc = "The DTS is not powered"]
            VALUE2,
        }
        impl PWDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PWDR::VALUE1 => false,
                    PWDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PWDR {
                match value {
                    false => PWDR::VALUE1,
                    true => PWDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PWDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PWDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct OFFSETR {
            bits: u8,
        }
        impl OFFSETR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct GAINR {
            bits: u8,
        }
        impl GAINR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct REFTRIMR {
            bits: u8,
        }
        impl REFTRIMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct BGTRIMR {
            bits: u8,
        }
        impl BGTRIMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `PWD`"]
        pub enum PWDW {
            #[doc = "The DTS is powered"]
            VALUE1,
            #[doc = "The DTS is not powered"]
            VALUE2,
        }
        impl PWDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PWDW::VALUE1 => false,
                    PWDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PWDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PWDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PWDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The DTS is powered"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PWDW::VALUE1)
            }
            #[doc = "The DTS is not powered"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PWDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `START`"]
        pub enum STARTW {
            #[doc = "No DTS measurement is started"]
            VALUE1,
            #[doc = "A DTS measurement is started"]
            VALUE2,
        }
        impl STARTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STARTW::VALUE1 => false,
                    STARTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STARTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STARTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STARTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No DTS measurement is started"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STARTW::VALUE1)
            }
            #[doc = "A DTS measurement is started"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STARTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OFFSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OFFSETW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GAINW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GAINW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _REFTRIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REFTRIMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BGTRIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BGTRIMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Sensor Power Down"]
            #[inline]
            pub fn pwd(&self) -> PWDR {
                PWDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:10 - Offset Calibration Value"]
            #[inline]
            pub fn offset(&self) -> OFFSETR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OFFSETR { bits }
            }
            #[doc = "Bits 11:16 - Gain Calibration Value"]
            #[inline]
            pub fn gain(&self) -> GAINR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GAINR { bits }
            }
            #[doc = "Bits 17:19 - Reference Trim Calibration Value"]
            #[inline]
            pub fn reftrim(&self) -> REFTRIMR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REFTRIMR { bits }
            }
            #[doc = "Bits 20:23 - Bandgap Trim Calibration Value"]
            #[inline]
            pub fn bgtrim(&self) -> BGTRIMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BGTRIMR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x01 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Sensor Power Down"]
            #[inline]
            pub fn pwd(&mut self) -> _PWDW {
                _PWDW { w: self }
            }
            #[doc = "Bit 1 - Sensor Measurement Start"]
            #[inline]
            pub fn start(&mut self) -> _STARTW {
                _STARTW { w: self }
            }
            #[doc = "Bits 4:10 - Offset Calibration Value"]
            #[inline]
            pub fn offset(&mut self) -> _OFFSETW {
                _OFFSETW { w: self }
            }
            #[doc = "Bits 11:16 - Gain Calibration Value"]
            #[inline]
            pub fn gain(&mut self) -> _GAINW {
                _GAINW { w: self }
            }
            #[doc = "Bits 17:19 - Reference Trim Calibration Value"]
            #[inline]
            pub fn reftrim(&mut self) -> _REFTRIMW {
                _REFTRIMW { w: self }
            }
            #[doc = "Bits 20:23 - Bandgap Trim Calibration Value"]
            #[inline]
            pub fn bgtrim(&mut self) -> _BGTRIMW {
                _BGTRIMW { w: self }
            }
        }
    }
    #[doc = "Die Temperature Sensor Status Register"]
    pub struct DTSSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Die Temperature Sensor Status Register"]
    pub mod dtsstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DTSSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `RDY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RDYR {
            #[doc = "The DTS is not ready"]
            VALUE1,
            #[doc = "The DTS is ready"]
            VALUE2,
        }
        impl RDYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RDYR::VALUE1 => false,
                    RDYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RDYR {
                match value {
                    false => RDYR::VALUE1,
                    true => RDYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RDYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RDYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BUSYR {
            #[doc = "not busy"]
            VALUE1,
            #[doc = "busy"]
            VALUE2,
        }
        impl BUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BUSYR::VALUE1 => false,
                    BUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BUSYR {
                match value {
                    false => BUSYR::VALUE1,
                    true => BUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BUSYR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - Result of the DTS Measurement"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
            #[doc = "Bit 14 - Sensor Ready Status"]
            #[inline]
            pub fn rdy(&self) -> RDYR {
                RDYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Sensor Busy Status"]
            #[inline]
            pub fn busy(&self) -> BUSYR {
                BUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Out of Range Comparator Enable Register 0"]
    pub struct G0ORCEN {
        register: VolatileCell<u32>,
    }
    #[doc = "Out of Range Comparator Enable Register 0"]
    pub mod g0orcen {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::G0ORCEN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENORC6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENORC6R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENORC6R::VALUE1 => false,
                    ENORC6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENORC6R {
                match value {
                    false => ENORC6R::VALUE1,
                    true => ENORC6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENORC6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENORC6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENORC7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENORC7R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENORC7R::VALUE1 => false,
                    ENORC7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENORC7R {
                match value {
                    false => ENORC7R::VALUE1,
                    true => ENORC7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENORC7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENORC7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ENORC6`"]
        pub enum ENORC6W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENORC6W::VALUE1 => false,
                    ENORC6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENORC6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENORC6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENORC6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENORC6W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENORC6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENORC7`"]
        pub enum ENORC7W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENORC7W::VALUE1 => false,
                    ENORC7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENORC7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENORC7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENORC7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENORC7W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENORC7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 6 - Enable Out of Range Comparator, Channel 6"]
            #[inline]
            pub fn enorc6(&self) -> ENORC6R {
                ENORC6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Enable Out of Range Comparator, Channel 7"]
            #[inline]
            pub fn enorc7(&self) -> ENORC7R {
                ENORC7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 6 - Enable Out of Range Comparator, Channel 6"]
            #[inline]
            pub fn enorc6(&mut self) -> _ENORC6W {
                _ENORC6W { w: self }
            }
            #[doc = "Bit 7 - Enable Out of Range Comparator, Channel 7"]
            #[inline]
            pub fn enorc7(&mut self) -> _ENORC7W {
                _ENORC7W { w: self }
            }
        }
    }
    #[doc = "Out of Range Comparator Enable Register 1"]
    pub struct G1ORCEN {
        register: VolatileCell<u32>,
    }
    #[doc = "Out of Range Comparator Enable Register 1"]
    pub mod g1orcen {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::G1ORCEN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENORC6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENORC6R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENORC6R::VALUE1 => false,
                    ENORC6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENORC6R {
                match value {
                    false => ENORC6R::VALUE1,
                    true => ENORC6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENORC6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENORC6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENORC7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENORC7R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENORC7R::VALUE1 => false,
                    ENORC7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENORC7R {
                match value {
                    false => ENORC7R::VALUE1,
                    true => ENORC7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENORC7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENORC7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ENORC6`"]
        pub enum ENORC6W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENORC6W::VALUE1 => false,
                    ENORC6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENORC6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENORC6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENORC6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENORC6W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENORC6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENORC7`"]
        pub enum ENORC7W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ENORC7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENORC7W::VALUE1 => false,
                    ENORC7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENORC7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENORC7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENORC7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENORC7W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENORC7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 6 - Enable Out of Range Comparator, Channel 6"]
            #[inline]
            pub fn enorc6(&self) -> ENORC6R {
                ENORC6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Enable Out of Range Comparator, Channel 7"]
            #[inline]
            pub fn enorc7(&self) -> ENORC7R {
                ENORC7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 6 - Enable Out of Range Comparator, Channel 6"]
            #[inline]
            pub fn enorc6(&mut self) -> _ENORC6W {
                _ENORC6W { w: self }
            }
            #[doc = "Bit 7 - Enable Out of Range Comparator, Channel 7"]
            #[inline]
            pub fn enorc7(&mut self) -> _ENORC7W {
                _ENORC7W { w: self }
            }
        }
    }
    #[doc = "Die Temperature Sensor Limit Register"]
    pub struct DTEMPLIM {
        register: VolatileCell<u32>,
    }
    #[doc = "Die Temperature Sensor Limit Register"]
    pub mod dtemplim {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DTEMPLIM {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LOWERR {
            bits: u16,
        }
        impl LOWERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct UPPERR {
            bits: u16,
        }
        impl UPPERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOWERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOWERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _UPPERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UPPERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - Lower Limit"]
            #[inline]
            pub fn lower(&self) -> LOWERR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                LOWERR { bits }
            }
            #[doc = "Bits 16:25 - Upper Limit"]
            #[inline]
            pub fn upper(&self) -> UPPERR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                UPPERR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:9 - Lower Limit"]
            #[inline]
            pub fn lower(&mut self) -> _LOWERW {
                _LOWERW { w: self }
            }
            #[doc = "Bits 16:25 - Upper Limit"]
            #[inline]
            pub fn upper(&mut self) -> _UPPERW {
                _UPPERW { w: self }
            }
        }
    }
    #[doc = "Die Temperature Sensor Alarm Register"]
    pub struct DTEMPALARM {
        register: VolatileCell<u32>,
    }
    #[doc = "Die Temperature Sensor Alarm Register"]
    pub mod dtempalarm {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DTEMPALARM {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `UNDERFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UNDERFLR {
            #[doc = "No temperature underflow was detected"]
            VALUE1,
            #[doc = "A temperature underflow was detected"]
            VALUE2,
        }
        impl UNDERFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UNDERFLR::VALUE1 => false,
                    UNDERFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UNDERFLR {
                match value {
                    false => UNDERFLR::VALUE1,
                    true => UNDERFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UNDERFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UNDERFLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OVERFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OVERFLR {
            #[doc = "No temperature overflow was detected"]
            VALUE1,
            #[doc = "A temperature overflow was detected"]
            VALUE2,
        }
        impl OVERFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OVERFLR::VALUE1 => false,
                    OVERFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OVERFLR {
                match value {
                    false => OVERFLR::VALUE1,
                    true => OVERFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OVERFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OVERFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Lower Limit Underflow"]
            #[inline]
            pub fn underfl(&self) -> UNDERFLR {
                UNDERFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Upper Limit Overflow"]
            #[inline]
            pub fn overfl(&self) -> OVERFLR {
                OVERFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Mirror Write Status Register"]
    pub struct MIRRSTS {
        register: VolatileCell<u32>,
    }
    #[doc = "Mirror Write Status Register"]
    pub mod mirrsts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MIRRSTS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `HDCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCLRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl HDCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCLRR::VALUE1 => false,
                    HDCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCLRR {
                match value {
                    false => HDCLRR::VALUE1,
                    true => HDCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDSETR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl HDSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDSETR::VALUE1 => false,
                    HDSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDSETR {
                match value {
                    false => HDSETR::VALUE1,
                    true => HDSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl HDCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCRR::VALUE1 => false,
                    HDCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCRR {
                match value {
                    false => HDCRR::VALUE1,
                    true => HDCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCSICTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCSICTRLR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl OSCSICTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCSICTRLR::VALUE1 => false,
                    OSCSICTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCSICTRLR {
                match value {
                    false => OSCSICTRLR::VALUE1,
                    true => OSCSICTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCSICTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCSICTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCULCTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCULCTRLR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl OSCULCTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCULCTRLR::VALUE1 => false,
                    OSCULCTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCULCTRLR {
                match value {
                    false => OSCULCTRLR::VALUE1,
                    true => OSCULCTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCULCTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCULCTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_CTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_CTRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_CTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_CTRR::VALUE1 => false,
                    RTC_CTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_CTRR {
                match value {
                    false => RTC_CTRR::VALUE1,
                    true => RTC_CTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_CTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_CTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM0R {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_ATIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM0R::VALUE1 => false,
                    RTC_ATIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM0R {
                match value {
                    false => RTC_ATIM0R::VALUE1,
                    true => RTC_ATIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM1R {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_ATIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM1R::VALUE1 => false,
                    RTC_ATIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM1R {
                match value {
                    false => RTC_ATIM1R::VALUE1,
                    true => RTC_ATIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM0R {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_TIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM0R::VALUE1 => false,
                    RTC_TIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM0R {
                match value {
                    false => RTC_TIM0R::VALUE1,
                    true => RTC_TIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM1R {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_TIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM1R::VALUE1 => false,
                    RTC_TIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM1R {
                match value {
                    false => RTC_TIM1R::VALUE1,
                    true => RTC_TIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RMX`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RMXR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RMXR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RMXR::VALUE1 => false,
                    RMXR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RMXR {
                match value {
                    false => RMXR::VALUE1,
                    true => RMXR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RMXR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RMXR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_MSKSR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_MSKSRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_MSKSRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_MSKSRR::VALUE1 => false,
                    RTC_MSKSRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_MSKSRR {
                match value {
                    false => RTC_MSKSRR::VALUE1,
                    true => RTC_MSKSRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_MSKSRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_MSKSRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_CLRSR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_CLRSRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl RTC_CLRSRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_CLRSRR::VALUE1 => false,
                    RTC_CLRSRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_CLRSRR {
                match value {
                    false => RTC_CLRSRR::VALUE1,
                    true => RTC_CLRSRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_CLRSRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_CLRSRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACCONF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCONFR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl LPACCONFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCONFR::VALUE1 => false,
                    LPACCONFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCONFR {
                match value {
                    false => LPACCONFR::VALUE1,
                    true => LPACCONFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCONFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCONFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH0R {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl LPACTH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH0R::VALUE1 => false,
                    LPACTH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH0R {
                match value {
                    false => LPACTH0R::VALUE1,
                    true => LPACTH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH1R {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl LPACTH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH1R::VALUE1 => false,
                    LPACTH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH1R {
                match value {
                    false => LPACTH1R::VALUE1,
                    true => LPACTH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCLRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl LPACCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCLRR::VALUE1 => false,
                    LPACCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCLRR {
                match value {
                    false => LPACCLRR::VALUE1,
                    true => LPACCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSETR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl LPACSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSETR::VALUE1 => false,
                    LPACSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSETR {
                match value {
                    false => LPACSETR::VALUE1,
                    true => LPACSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTCLRR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl HINTCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTCLRR::VALUE1 => false,
                    HINTCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTCLRR {
                match value {
                    false => HINTCLRR::VALUE1,
                    true => HINTCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSETR {
            #[doc = "Ready"]
            VALUE1,
            #[doc = "Busy"]
            VALUE2,
        }
        impl HINTSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSETR::VALUE1 => false,
                    HINTSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSETR {
                match value {
                    false => HINTSETR::VALUE1,
                    true => HINTSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSETR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 1 - HDCLR Mirror Register Write Status"]
            #[inline]
            pub fn hdclr(&self) -> HDCLRR {
                HDCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - HDSET Mirror Register Write Status"]
            #[inline]
            pub fn hdset(&self) -> HDSETR {
                HDSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - HDCR Mirror Register Write Status"]
            #[inline]
            pub fn hdcr(&self) -> HDCRR {
                HDCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - OSCSICTRL Mirror Register Write Status"]
            #[inline]
            pub fn oscsictrl(&self) -> OSCSICTRLR {
                OSCSICTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - OSCULCTRL Mirror Register Write Status"]
            #[inline]
            pub fn osculctrl(&self) -> OSCULCTRLR {
                OSCULCTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - RTC CTR Mirror Register Write Status"]
            #[inline]
            pub fn rtc_ctr(&self) -> RTC_CTRR {
                RTC_CTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - RTC ATIM0 Mirror Register Write Status"]
            #[inline]
            pub fn rtc_atim0(&self) -> RTC_ATIM0R {
                RTC_ATIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - RTC ATIM1 Mirror Register Write Status"]
            #[inline]
            pub fn rtc_atim1(&self) -> RTC_ATIM1R {
                RTC_ATIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - RTC TIM0 Mirror Register Write Status"]
            #[inline]
            pub fn rtc_tim0(&self) -> RTC_TIM0R {
                RTC_TIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - RTC TIM1 Mirror Register Write Status"]
            #[inline]
            pub fn rtc_tim1(&self) -> RTC_TIM1R {
                RTC_TIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Retention Memory Access Register Update Status"]
            #[inline]
            pub fn rmx(&self) -> RMXR {
                RMXR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - RTC MSKSSR Mirror Register Write Status"]
            #[inline]
            pub fn rtc_msksr(&self) -> RTC_MSKSRR {
                RTC_MSKSRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - RTC CLRSR Mirror Register Write Status"]
            #[inline]
            pub fn rtc_clrsr(&self) -> RTC_CLRSRR {
                RTC_CLRSRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - LPACCONF Mirror Register Write Interrupt Set"]
            #[inline]
            pub fn lpacconf(&self) -> LPACCONFR {
                LPACCONFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - LPACTH0 Mirror Register Write Interrupt Set"]
            #[inline]
            pub fn lpacth0(&self) -> LPACTH0R {
                LPACTH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - LPACTH1 Mirror Register Write Interrupt Set"]
            #[inline]
            pub fn lpacth1(&self) -> LPACTH1R {
                LPACTH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - LPACCLR Mirror Register Write Status"]
            #[inline]
            pub fn lpacclr(&self) -> LPACCLRR {
                LPACCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - LPACSET Mirror Register Write Status"]
            #[inline]
            pub fn lpacset(&self) -> LPACSETR {
                LPACSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - HINTCLR Mirror Register Write Status"]
            #[inline]
            pub fn hintclr(&self) -> HINTCLRR {
                HINTCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - HINTSET Mirror Register Write Status"]
            #[inline]
            pub fn hintset(&self) -> HINTSETR {
                HINTSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Retention Memory Access Control Register"]
    pub struct RMACR {
        register: VolatileCell<u32>,
    }
    #[doc = "Retention Memory Access Control Register"]
    pub mod rmacr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RMACR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `RDWR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RDWRR {
            #[doc = "transfer data from Retention Memory in Hibernate domain to RMDATA register"]
            VALUE1,
            #[doc = "transfer data from RMDATA into Retention Memory in Hibernate domain"]
            VALUE2,
        }
        impl RDWRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RDWRR::VALUE1 => false,
                    RDWRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RDWRR {
                match value {
                    false => RDWRR::VALUE1,
                    true => RDWRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RDWRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RDWRR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct ADDRR {
            bits: u8,
        }
        impl ADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `RDWR`"]
        pub enum RDWRW {
            #[doc = "transfer data from Retention Memory in Hibernate domain to RMDATA register"]
            VALUE1,
            #[doc = "transfer data from RMDATA into Retention Memory in Hibernate domain"]
            VALUE2,
        }
        impl RDWRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RDWRW::VALUE1 => false,
                    RDWRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RDWRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RDWRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RDWRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "transfer data from Retention Memory in Hibernate domain to RMDATA register"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RDWRW::VALUE1)
            }
            #[doc = "transfer data from RMDATA into Retention Memory in Hibernate domain"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RDWRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Hibernate Retention Memory Register Update Control"]
            #[inline]
            pub fn rdwr(&self) -> RDWRR {
                RDWRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:19 - Hibernate Retention Memory Register Address Select"]
            #[inline]
            pub fn addr(&self) -> ADDRR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Hibernate Retention Memory Register Update Control"]
            #[inline]
            pub fn rdwr(&mut self) -> _RDWRW {
                _RDWRW { w: self }
            }
            #[doc = "Bits 16:19 - Hibernate Retention Memory Register Address Select"]
            #[inline]
            pub fn addr(&mut self) -> _ADDRW {
                _ADDRW { w: self }
            }
        }
    }
    #[doc = "Retention Memory Access Data Register"]
    pub struct RMDATA {
        register: VolatileCell<u32>,
    }
    #[doc = "Retention Memory Access Data Register"]
    pub mod rmdata {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RMDATA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATAR {
            bits: u32,
        }
        impl DATAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATAW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Hibernate Retention Memory Data"]
            #[inline]
            pub fn data(&self) -> DATAR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DATAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Hibernate Retention Memory Data"]
            #[inline]
            pub fn data(&mut self) -> _DATAW {
                _DATAW { w: self }
            }
        }
    }
    #[doc = "Mirror All Status"]
    pub struct MIRRALLSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Mirror All Status"]
    pub mod mirrallstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MIRRALLSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `BUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BUSYR {
            #[doc = "No update is pening"]
            VALUE1,
            #[doc = "Update is pending"]
            VALUE2,
        }
        impl BUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BUSYR::VALUE1 => false,
                    BUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BUSYR {
                match value {
                    false => BUSYR::VALUE1,
                    true => BUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BUSYR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Mirror All Execution Status"]
            #[inline]
            pub fn busy(&self) -> BUSYR {
                BUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Mirror All Request"]
    pub struct MIRRALLREQ {
        register: VolatileCell<u32>,
    }
    #[doc = "Mirror All Request"]
    pub mod mirrallreq {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MIRRALLREQ {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `REQ`"]
        pub enum REQW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Start mirror update"]
            VALUE2,
        }
        impl REQW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REQW::VALUE1 => false,
                    REQW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REQW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REQW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REQW::VALUE1)
            }
            #[doc = "Start mirror update"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REQW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Mirror All Execution Request"]
            #[inline]
            pub fn req(&mut self) -> _REQW {
                _REQW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_GENERAL {
    register_block: scu_general::RegisterBlock,
}
impl Deref for SCU_GENERAL {
    type Target = scu_general::RegisterBlock;
    fn deref(&self) -> &scu_general::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_INTERRUPT: Peripheral<SCU_INTERRUPT> = unsafe { Peripheral::new(0x5000_4074) };
#[doc = "System Control Unit"]
pub mod scu_interrupt {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - SCU Service Request Status"]
        pub srstat: SRSTAT,
        #[doc = "0x04 - SCU Raw Service Request Status"]
        pub srraw: SRRAW,
        #[doc = "0x08 - SCU Service Request Mask"]
        pub srmsk: SRMSK,
        #[doc = "0x0c - SCU Service Request Clear"]
        pub srclr: SRCLR,
        #[doc = "0x10 - SCU Service Request Set"]
        pub srset: SRSET,
        #[doc = "0x14 - SCU Service Request Mask"]
        pub nmireqen: NMIREQEN,
    }
    #[doc = "SCU Service Request Status"]
    pub struct SRSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Service Request Status"]
    pub mod srstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::SRSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PRWARN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRWARNR {
            #[doc = "Inactive"]
            VALUE1,
            #[doc = "Active"]
            VALUE2,
        }
        impl PRWARNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRWARNR::VALUE1 => false,
                    PRWARNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRWARNR {
                match value {
                    false => PRWARNR::VALUE1,
                    true => PRWARNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRWARNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRWARNR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PIR {
            bits: bool,
        }
        impl PIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AIR {
            bits: bool,
        }
        impl AIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DLROVRR {
            bits: bool,
        }
        impl DLROVRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `LPACCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCRR::VALUE1 => false,
                    LPACCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCRR {
                match value {
                    false => LPACCRR::VALUE1,
                    true => LPACCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH0R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACTH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH0R::VALUE1 => false,
                    LPACTH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH0R {
                match value {
                    false => LPACTH0R::VALUE1,
                    true => LPACTH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH1R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACTH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH1R::VALUE1 => false,
                    LPACTH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH1R {
                match value {
                    false => LPACTH1R::VALUE1,
                    true => LPACTH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSTR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSTR::VALUE1 => false,
                    LPACSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSTR {
                match value {
                    false => LPACSTR::VALUE1,
                    true => LPACSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCLRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCLRR::VALUE1 => false,
                    LPACCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCLRR {
                match value {
                    false => LPACCLRR::VALUE1,
                    true => LPACCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSETR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSETR::VALUE1 => false,
                    LPACSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSETR {
                match value {
                    false => LPACSETR::VALUE1,
                    true => LPACSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSTR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HINTSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSTR::VALUE1 => false,
                    HINTSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSTR {
                match value {
                    false => HINTSTR::VALUE1,
                    true => HINTSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTCLRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HINTCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTCLRR::VALUE1 => false,
                    HINTCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTCLRR {
                match value {
                    false => HINTCLRR::VALUE1,
                    true => HINTCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSETR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HINTSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSETR::VALUE1 => false,
                    HINTSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSETR {
                match value {
                    false => HINTSETR::VALUE1,
                    true => HINTSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCLRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HDCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCLRR::VALUE1 => false,
                    HDCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCLRR {
                match value {
                    false => HDCLRR::VALUE1,
                    true => HDCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDSETR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HDSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDSETR::VALUE1 => false,
                    HDSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDSETR {
                match value {
                    false => HDSETR::VALUE1,
                    true => HDSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HDCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCRR::VALUE1 => false,
                    HDCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCRR {
                match value {
                    false => HDCRR::VALUE1,
                    true => HDCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCSICTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCSICTRLR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl OSCSICTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCSICTRLR::VALUE1 => false,
                    OSCSICTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCSICTRLR {
                match value {
                    false => OSCSICTRLR::VALUE1,
                    true => OSCSICTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCSICTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCSICTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCULCTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCULCTRLR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl OSCULCTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCULCTRLR::VALUE1 => false,
                    OSCULCTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCULCTRLR {
                match value {
                    false => OSCULCTRLR::VALUE1,
                    true => OSCULCTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCULCTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCULCTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_CTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_CTRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_CTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_CTRR::VALUE1 => false,
                    RTC_CTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_CTRR {
                match value {
                    false => RTC_CTRR::VALUE1,
                    true => RTC_CTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_CTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_CTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM0R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_ATIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM0R::VALUE1 => false,
                    RTC_ATIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM0R {
                match value {
                    false => RTC_ATIM0R::VALUE1,
                    true => RTC_ATIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM1R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_ATIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM1R::VALUE1 => false,
                    RTC_ATIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM1R {
                match value {
                    false => RTC_ATIM1R::VALUE1,
                    true => RTC_ATIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM0R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_TIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM0R::VALUE1 => false,
                    RTC_TIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM0R {
                match value {
                    false => RTC_TIM0R::VALUE1,
                    true => RTC_TIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM1R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_TIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM1R::VALUE1 => false,
                    RTC_TIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM1R {
                match value {
                    false => RTC_TIM1R::VALUE1,
                    true => RTC_TIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RMX`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RMXR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RMXR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RMXR::VALUE1 => false,
                    RMXR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RMXR {
                match value {
                    false => RMXR::VALUE1,
                    true => RMXR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RMXR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RMXR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - WDT pre-warning Interrupt Status"]
            #[inline]
            pub fn prwarn(&self) -> PRWARNR {
                PRWARNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - RTC Periodic Interrupt Status"]
            #[inline]
            pub fn pi(&self) -> PIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PIR { bits }
            }
            #[doc = "Bit 2 - Alarm Interrupt Status"]
            #[inline]
            pub fn ai(&self) -> AIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AIR { bits }
            }
            #[doc = "Bit 3 - DLR Request Overrun Interrupt Status"]
            #[inline]
            pub fn dlrovr(&self) -> DLROVRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DLROVRR { bits }
            }
            #[doc = "Bit 6 - LPACLR Mirror Register Update Status"]
            #[inline]
            pub fn lpaccr(&self) -> LPACCRR {
                LPACCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - LPACTH0 Mirror Register Update Status"]
            #[inline]
            pub fn lpacth0(&self) -> LPACTH0R {
                LPACTH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - LPACTH1 Mirror Register Update Status"]
            #[inline]
            pub fn lpacth1(&self) -> LPACTH1R {
                LPACTH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - LPACST Mirror Register Update Status"]
            #[inline]
            pub fn lpacst(&self) -> LPACSTR {
                LPACSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - LPACCLR Mirror Register Update Status"]
            #[inline]
            pub fn lpacclr(&self) -> LPACCLRR {
                LPACCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - LPACSET Mirror Register Update Status"]
            #[inline]
            pub fn lpacset(&self) -> LPACSETR {
                LPACSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - HINTST Mirror Register Update Status"]
            #[inline]
            pub fn hintst(&self) -> HINTSTR {
                HINTSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - HINTCLR Mirror Register Update Status"]
            #[inline]
            pub fn hintclr(&self) -> HINTCLRR {
                HINTCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - HINTSET Mirror Register Update Status"]
            #[inline]
            pub fn hintset(&self) -> HINTSETR {
                HINTSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - HDCLR Mirror Register Update Status"]
            #[inline]
            pub fn hdclr(&self) -> HDCLRR {
                HDCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - HDSET Mirror Register Update Status"]
            #[inline]
            pub fn hdset(&self) -> HDSETR {
                HDSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - HDCR Mirror Register Update Status"]
            #[inline]
            pub fn hdcr(&self) -> HDCRR {
                HDCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - OSCSICTRL Mirror Register Update Status"]
            #[inline]
            pub fn oscsictrl(&self) -> OSCSICTRLR {
                OSCSICTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - OSCULCTRL Mirror Register Update Status"]
            #[inline]
            pub fn osculctrl(&self) -> OSCULCTRLR {
                OSCULCTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - RTC CTR Mirror Register Update Status"]
            #[inline]
            pub fn rtc_ctr(&self) -> RTC_CTRR {
                RTC_CTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - RTC ATIM0 Mirror Register Update Status"]
            #[inline]
            pub fn rtc_atim0(&self) -> RTC_ATIM0R {
                RTC_ATIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - RTC ATIM1 Mirror Register Update Status"]
            #[inline]
            pub fn rtc_atim1(&self) -> RTC_ATIM1R {
                RTC_ATIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - RTC TIM0 Mirror Register Update Status"]
            #[inline]
            pub fn rtc_tim0(&self) -> RTC_TIM0R {
                RTC_TIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - RTC TIM1 Mirror Register Update Status"]
            #[inline]
            pub fn rtc_tim1(&self) -> RTC_TIM1R {
                RTC_TIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Retention Memory Mirror Register Update Status"]
            #[inline]
            pub fn rmx(&self) -> RMXR {
                RMXR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "SCU Raw Service Request Status"]
    pub struct SRRAW {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Raw Service Request Status"]
    pub mod srraw {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::SRRAW {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PRWARN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRWARNR {
            #[doc = "Inactive"]
            VALUE1,
            #[doc = "Active"]
            VALUE2,
        }
        impl PRWARNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRWARNR::VALUE1 => false,
                    PRWARNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRWARNR {
                match value {
                    false => PRWARNR::VALUE1,
                    true => PRWARNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRWARNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRWARNR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PIR {
            bits: bool,
        }
        impl PIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AIR {
            bits: bool,
        }
        impl AIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DLROVRR {
            bits: bool,
        }
        impl DLROVRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `LPACCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCRR::VALUE1 => false,
                    LPACCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCRR {
                match value {
                    false => LPACCRR::VALUE1,
                    true => LPACCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH0R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACTH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH0R::VALUE1 => false,
                    LPACTH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH0R {
                match value {
                    false => LPACTH0R::VALUE1,
                    true => LPACTH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH1R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACTH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH1R::VALUE1 => false,
                    LPACTH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH1R {
                match value {
                    false => LPACTH1R::VALUE1,
                    true => LPACTH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSTR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSTR::VALUE1 => false,
                    LPACSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSTR {
                match value {
                    false => LPACSTR::VALUE1,
                    true => LPACSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCLRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCLRR::VALUE1 => false,
                    LPACCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCLRR {
                match value {
                    false => LPACCLRR::VALUE1,
                    true => LPACCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSETR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl LPACSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSETR::VALUE1 => false,
                    LPACSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSETR {
                match value {
                    false => LPACSETR::VALUE1,
                    true => LPACSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSTR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HINTSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSTR::VALUE1 => false,
                    HINTSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSTR {
                match value {
                    false => HINTSTR::VALUE1,
                    true => HINTSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTCLRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HINTCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTCLRR::VALUE1 => false,
                    HINTCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTCLRR {
                match value {
                    false => HINTCLRR::VALUE1,
                    true => HINTCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSETR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HINTSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSETR::VALUE1 => false,
                    HINTSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSETR {
                match value {
                    false => HINTSETR::VALUE1,
                    true => HINTSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCLRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HDCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCLRR::VALUE1 => false,
                    HDCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCLRR {
                match value {
                    false => HDCLRR::VALUE1,
                    true => HDCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDSETR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HDSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDSETR::VALUE1 => false,
                    HDSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDSETR {
                match value {
                    false => HDSETR::VALUE1,
                    true => HDSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl HDCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCRR::VALUE1 => false,
                    HDCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCRR {
                match value {
                    false => HDCRR::VALUE1,
                    true => HDCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCSICTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCSICTRLR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl OSCSICTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCSICTRLR::VALUE1 => false,
                    OSCSICTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCSICTRLR {
                match value {
                    false => OSCSICTRLR::VALUE1,
                    true => OSCSICTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCSICTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCSICTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCULCTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCULCTRLR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl OSCULCTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCULCTRLR::VALUE1 => false,
                    OSCULCTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCULCTRLR {
                match value {
                    false => OSCULCTRLR::VALUE1,
                    true => OSCULCTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCULCTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCULCTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_CTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_CTRR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_CTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_CTRR::VALUE1 => false,
                    RTC_CTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_CTRR {
                match value {
                    false => RTC_CTRR::VALUE1,
                    true => RTC_CTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_CTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_CTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM0R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_ATIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM0R::VALUE1 => false,
                    RTC_ATIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM0R {
                match value {
                    false => RTC_ATIM0R::VALUE1,
                    true => RTC_ATIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM1R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_ATIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM1R::VALUE1 => false,
                    RTC_ATIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM1R {
                match value {
                    false => RTC_ATIM1R::VALUE1,
                    true => RTC_ATIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM0R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_TIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM0R::VALUE1 => false,
                    RTC_TIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM0R {
                match value {
                    false => RTC_TIM0R::VALUE1,
                    true => RTC_TIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM1R {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RTC_TIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM1R::VALUE1 => false,
                    RTC_TIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM1R {
                match value {
                    false => RTC_TIM1R::VALUE1,
                    true => RTC_TIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RMX`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RMXR {
            #[doc = "Not updated"]
            VALUE1,
            #[doc = "Update completed"]
            VALUE2,
        }
        impl RMXR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RMXR::VALUE1 => false,
                    RMXR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RMXR {
                match value {
                    false => RMXR::VALUE1,
                    true => RMXR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RMXR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RMXR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - WDT pre-warning Interrupt Status Before Masking"]
            #[inline]
            pub fn prwarn(&self) -> PRWARNR {
                PRWARNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - RTC Raw Periodic Interrupt Status Before Masking"]
            #[inline]
            pub fn pi(&self) -> PIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PIR { bits }
            }
            #[doc = "Bit 2 - RTC Raw Alarm Interrupt Status Before Masking"]
            #[inline]
            pub fn ai(&self) -> AIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AIR { bits }
            }
            #[doc = "Bit 3 - DLR Request Overrun Interrupt Status Before Masking"]
            #[inline]
            pub fn dlrovr(&self) -> DLROVRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DLROVRR { bits }
            }
            #[doc = "Bit 6 - LPACLR Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn lpaccr(&self) -> LPACCRR {
                LPACCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - LPACTH0 Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn lpacth0(&self) -> LPACTH0R {
                LPACTH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - LPACTH1 Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn lpacth1(&self) -> LPACTH1R {
                LPACTH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - LPACST Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn lpacst(&self) -> LPACSTR {
                LPACSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - LPACCLR Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn lpacclr(&self) -> LPACCLRR {
                LPACCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - LPACSET Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn lpacset(&self) -> LPACSETR {
                LPACSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - HINTST Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn hintst(&self) -> HINTSTR {
                HINTSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - HINTCLR Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn hintclr(&self) -> HINTCLRR {
                HINTCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - HINTSET Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn hintset(&self) -> HINTSETR {
                HINTSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - HDCLR Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn hdclr(&self) -> HDCLRR {
                HDCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - HDSET Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn hdset(&self) -> HDSETR {
                HDSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - HDCR Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn hdcr(&self) -> HDCRR {
                HDCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - OSCSICTRL Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn oscsictrl(&self) -> OSCSICTRLR {
                OSCSICTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - OSCULCTRL Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn osculctrl(&self) -> OSCULCTRLR {
                OSCULCTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - RTC CTR Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn rtc_ctr(&self) -> RTC_CTRR {
                RTC_CTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - RTC ATIM0 Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn rtc_atim0(&self) -> RTC_ATIM0R {
                RTC_ATIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - RTC ATIM1 Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn rtc_atim1(&self) -> RTC_ATIM1R {
                RTC_ATIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - RTC TIM0 Mirror Register Update Before Masking Status"]
            #[inline]
            pub fn rtc_tim0(&self) -> RTC_TIM0R {
                RTC_TIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - RTC TIM1 Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn rtc_tim1(&self) -> RTC_TIM1R {
                RTC_TIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Retention Memory Mirror Register Update Status Before Masking"]
            #[inline]
            pub fn rmx(&self) -> RMXR {
                RMXR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "SCU Service Request Mask"]
    pub struct SRMSK {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Service Request Mask"]
    pub mod srmsk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRMSK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PRWARN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRWARNR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PRWARNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRWARNR::VALUE1 => false,
                    PRWARNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRWARNR {
                match value {
                    false => PRWARNR::VALUE1,
                    true => PRWARNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRWARNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRWARNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PIR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PIR::VALUE1 => false,
                    PIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PIR {
                match value {
                    false => PIR::VALUE1,
                    true => PIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl AIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIR::VALUE1 => false,
                    AIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIR {
                match value {
                    false => AIR::VALUE1,
                    true => AIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLROVR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLROVRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl DLROVRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLROVRR::VALUE1 => false,
                    DLROVRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLROVRR {
                match value {
                    false => DLROVRR::VALUE1,
                    true => DLROVRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLROVRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLROVRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCRR::VALUE1 => false,
                    LPACCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCRR {
                match value {
                    false => LPACCRR::VALUE1,
                    true => LPACCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH0R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACTH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH0R::VALUE1 => false,
                    LPACTH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH0R {
                match value {
                    false => LPACTH0R::VALUE1,
                    true => LPACTH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACTH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACTH1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACTH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACTH1R::VALUE1 => false,
                    LPACTH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACTH1R {
                match value {
                    false => LPACTH1R::VALUE1,
                    true => LPACTH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACTH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACTH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSTR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSTR::VALUE1 => false,
                    LPACSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSTR {
                match value {
                    false => LPACSTR::VALUE1,
                    true => LPACSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACCLRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACCLRR::VALUE1 => false,
                    LPACCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACCLRR {
                match value {
                    false => LPACCLRR::VALUE1,
                    true => LPACCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPACSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPACSETR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LPACSETR::VALUE1 => false,
                    LPACSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LPACSETR {
                match value {
                    false => LPACSETR::VALUE1,
                    true => LPACSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPACSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPACSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSTR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HINTSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSTR::VALUE1 => false,
                    HINTSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSTR {
                match value {
                    false => HINTSTR::VALUE1,
                    true => HINTSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTCLRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HINTCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTCLRR::VALUE1 => false,
                    HINTCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTCLRR {
                match value {
                    false => HINTCLRR::VALUE1,
                    true => HINTCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HINTSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HINTSETR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HINTSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HINTSETR::VALUE1 => false,
                    HINTSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HINTSETR {
                match value {
                    false => HINTSETR::VALUE1,
                    true => HINTSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HINTSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HINTSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCLR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCLRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HDCLRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCLRR::VALUE1 => false,
                    HDCLRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCLRR {
                match value {
                    false => HDCLRR::VALUE1,
                    true => HDCLRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCLRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCLRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDSET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDSETR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HDSETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDSETR::VALUE1 => false,
                    HDSETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDSETR {
                match value {
                    false => HDSETR::VALUE1,
                    true => HDSETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDSETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDSETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HDCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HDCRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HDCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HDCRR::VALUE1 => false,
                    HDCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HDCRR {
                match value {
                    false => HDCRR::VALUE1,
                    true => HDCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HDCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HDCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCSICTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCSICTRLR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl OSCSICTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCSICTRLR::VALUE1 => false,
                    OSCSICTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCSICTRLR {
                match value {
                    false => OSCSICTRLR::VALUE1,
                    true => OSCSICTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCSICTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCSICTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OSCULCTRL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OSCULCTRLR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl OSCULCTRLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OSCULCTRLR::VALUE1 => false,
                    OSCULCTRLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OSCULCTRLR {
                match value {
                    false => OSCULCTRLR::VALUE1,
                    true => OSCULCTRLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OSCULCTRLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OSCULCTRLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_CTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_CTRR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_CTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_CTRR::VALUE1 => false,
                    RTC_CTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_CTRR {
                match value {
                    false => RTC_CTRR::VALUE1,
                    true => RTC_CTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_CTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_CTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM0R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_ATIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM0R::VALUE1 => false,
                    RTC_ATIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM0R {
                match value {
                    false => RTC_ATIM0R::VALUE1,
                    true => RTC_ATIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_ATIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_ATIM1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_ATIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_ATIM1R::VALUE1 => false,
                    RTC_ATIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_ATIM1R {
                match value {
                    false => RTC_ATIM1R::VALUE1,
                    true => RTC_ATIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_ATIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_ATIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM0R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_TIM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM0R::VALUE1 => false,
                    RTC_TIM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM0R {
                match value {
                    false => RTC_TIM0R::VALUE1,
                    true => RTC_TIM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTC_TIM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTC_TIM1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_TIM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTC_TIM1R::VALUE1 => false,
                    RTC_TIM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTC_TIM1R {
                match value {
                    false => RTC_TIM1R::VALUE1,
                    true => RTC_TIM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTC_TIM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTC_TIM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RMX`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RMXR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RMXR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RMXR::VALUE1 => false,
                    RMXR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RMXR {
                match value {
                    false => RMXR::VALUE1,
                    true => RMXR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RMXR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RMXR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PRWARN`"]
        pub enum PRWARNW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PRWARNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PRWARNW::VALUE1 => false,
                    PRWARNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRWARNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRWARNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRWARNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PI`"]
        pub enum PIW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PIW::VALUE1 => false,
                    PIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PIW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AI`"]
        pub enum AIW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl AIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIW::VALUE1 => false,
                    AIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLROVR`"]
        pub enum DLROVRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl DLROVRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLROVRW::VALUE1 => false,
                    DLROVRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLROVRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLROVRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLROVRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLROVRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLROVRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACCR`"]
        pub enum LPACCRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACCRW::VALUE1 => false,
                    LPACCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACCRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACTH0`"]
        pub enum LPACTH0W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACTH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACTH0W::VALUE1 => false,
                    LPACTH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACTH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACTH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACTH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACTH0W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACTH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACTH1`"]
        pub enum LPACTH1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACTH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACTH1W::VALUE1 => false,
                    LPACTH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACTH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACTH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACTH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACTH1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACTH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACST`"]
        pub enum LPACSTW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACSTW::VALUE1 => false,
                    LPACSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACSTW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACCLR`"]
        pub enum LPACCLRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACCLRW::VALUE1 => false,
                    LPACCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACCLRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACSET`"]
        pub enum LPACSETW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl LPACSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACSETW::VALUE1 => false,
                    LPACSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACSETW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTST`"]
        pub enum HINTSTW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HINTSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTSTW::VALUE1 => false,
                    HINTSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTSTW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTCLR`"]
        pub enum HINTCLRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HINTCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTCLRW::VALUE1 => false,
                    HINTCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTCLRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTSET`"]
        pub enum HINTSETW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HINTSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTSETW::VALUE1 => false,
                    HINTSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTSETW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCLR`"]
        pub enum HDCLRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HDCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCLRW::VALUE1 => false,
                    HDCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCLRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDSET`"]
        pub enum HDSETW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HDSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDSETW::VALUE1 => false,
                    HDSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDSETW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCR`"]
        pub enum HDCRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl HDCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCRW::VALUE1 => false,
                    HDCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCSICTRL`"]
        pub enum OSCSICTRLW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl OSCSICTRLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCSICTRLW::VALUE1 => false,
                    OSCSICTRLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCSICTRLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCSICTRLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCSICTRLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCSICTRLW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCSICTRLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCULCTRL`"]
        pub enum OSCULCTRLW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl OSCULCTRLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCULCTRLW::VALUE1 => false,
                    OSCULCTRLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCULCTRLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCULCTRLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCULCTRLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCULCTRLW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCULCTRLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_CTR`"]
        pub enum RTC_CTRW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_CTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_CTRW::VALUE1 => false,
                    RTC_CTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_CTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_CTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_CTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_CTRW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_CTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_ATIM0`"]
        pub enum RTC_ATIM0W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_ATIM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_ATIM0W::VALUE1 => false,
                    RTC_ATIM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_ATIM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_ATIM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_ATIM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_ATIM0W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_ATIM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_ATIM1`"]
        pub enum RTC_ATIM1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_ATIM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_ATIM1W::VALUE1 => false,
                    RTC_ATIM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_ATIM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_ATIM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_ATIM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_ATIM1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_ATIM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_TIM0`"]
        pub enum RTC_TIM0W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_TIM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_TIM0W::VALUE1 => false,
                    RTC_TIM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_TIM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_TIM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_TIM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_TIM0W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_TIM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_TIM1`"]
        pub enum RTC_TIM1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RTC_TIM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_TIM1W::VALUE1 => false,
                    RTC_TIM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_TIM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_TIM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_TIM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_TIM1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_TIM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RMX`"]
        pub enum RMXW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl RMXW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RMXW::VALUE1 => false,
                    RMXW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMXW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RMXW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RMXW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RMXW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - WDT pre-warning Interrupt Mask"]
            #[inline]
            pub fn prwarn(&self) -> PRWARNR {
                PRWARNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - RTC Periodic Interrupt Mask"]
            #[inline]
            pub fn pi(&self) -> PIR {
                PIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - RTC Alarm Interrupt Mask"]
            #[inline]
            pub fn ai(&self) -> AIR {
                AIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - DLR Request Overrun Interrupt Mask"]
            #[inline]
            pub fn dlrovr(&self) -> DLROVRR {
                DLROVRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - LPACLR Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpaccr(&self) -> LPACCRR {
                LPACCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - LPACTH0 Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacth0(&self) -> LPACTH0R {
                LPACTH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - LPACTH1 Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacth1(&self) -> LPACTH1R {
                LPACTH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - LPACST Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacst(&self) -> LPACSTR {
                LPACSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - LPACCLR Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacclr(&self) -> LPACCLRR {
                LPACCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - LPACSET Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacset(&self) -> LPACSETR {
                LPACSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - HINTST Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn hintst(&self) -> HINTSTR {
                HINTSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - HINTCLR Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn hintclr(&self) -> HINTCLRR {
                HINTCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - HINTSET Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn hintset(&self) -> HINTSETR {
                HINTSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - HDCLR Mirror Register Update Mask"]
            #[inline]
            pub fn hdclr(&self) -> HDCLRR {
                HDCLRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - HDSET Mirror Register Update Mask"]
            #[inline]
            pub fn hdset(&self) -> HDSETR {
                HDSETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - HDCR Mirror Register Update Mask"]
            #[inline]
            pub fn hdcr(&self) -> HDCRR {
                HDCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - OSCSICTRL Mirror Register Update Mask"]
            #[inline]
            pub fn oscsictrl(&self) -> OSCSICTRLR {
                OSCSICTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - OSCULCTRL Mirror Register Update Mask"]
            #[inline]
            pub fn osculctrl(&self) -> OSCULCTRLR {
                OSCULCTRLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - RTC CTR Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_ctr(&self) -> RTC_CTRR {
                RTC_CTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - RTC ATIM0 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_atim0(&self) -> RTC_ATIM0R {
                RTC_ATIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - RTC ATIM1 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_atim1(&self) -> RTC_ATIM1R {
                RTC_ATIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - RTC TIM0 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_tim0(&self) -> RTC_TIM0R {
                RTC_TIM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - RTC TIM1 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_tim1(&self) -> RTC_TIM1R {
                RTC_TIM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Retention Memory Mirror Register Update Mask"]
            #[inline]
            pub fn rmx(&self) -> RMXR {
                RMXR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - WDT pre-warning Interrupt Mask"]
            #[inline]
            pub fn prwarn(&mut self) -> _PRWARNW {
                _PRWARNW { w: self }
            }
            #[doc = "Bit 1 - RTC Periodic Interrupt Mask"]
            #[inline]
            pub fn pi(&mut self) -> _PIW {
                _PIW { w: self }
            }
            #[doc = "Bit 2 - RTC Alarm Interrupt Mask"]
            #[inline]
            pub fn ai(&mut self) -> _AIW {
                _AIW { w: self }
            }
            #[doc = "Bit 3 - DLR Request Overrun Interrupt Mask"]
            #[inline]
            pub fn dlrovr(&mut self) -> _DLROVRW {
                _DLROVRW { w: self }
            }
            #[doc = "Bit 6 - LPACLR Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpaccr(&mut self) -> _LPACCRW {
                _LPACCRW { w: self }
            }
            #[doc = "Bit 7 - LPACTH0 Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacth0(&mut self) -> _LPACTH0W {
                _LPACTH0W { w: self }
            }
            #[doc = "Bit 8 - LPACTH1 Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacth1(&mut self) -> _LPACTH1W {
                _LPACTH1W { w: self }
            }
            #[doc = "Bit 9 - LPACST Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacst(&mut self) -> _LPACSTW {
                _LPACSTW { w: self }
            }
            #[doc = "Bit 10 - LPACCLR Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacclr(&mut self) -> _LPACCLRW {
                _LPACCLRW { w: self }
            }
            #[doc = "Bit 11 - LPACSET Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn lpacset(&mut self) -> _LPACSETW {
                _LPACSETW { w: self }
            }
            #[doc = "Bit 12 - HINTST Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn hintst(&mut self) -> _HINTSTW {
                _HINTSTW { w: self }
            }
            #[doc = "Bit 13 - HINTCLR Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn hintclr(&mut self) -> _HINTCLRW {
                _HINTCLRW { w: self }
            }
            #[doc = "Bit 14 - HINTSET Mirror Register Update Interrupt Mask"]
            #[inline]
            pub fn hintset(&mut self) -> _HINTSETW {
                _HINTSETW { w: self }
            }
            #[doc = "Bit 17 - HDCLR Mirror Register Update Mask"]
            #[inline]
            pub fn hdclr(&mut self) -> _HDCLRW {
                _HDCLRW { w: self }
            }
            #[doc = "Bit 18 - HDSET Mirror Register Update Mask"]
            #[inline]
            pub fn hdset(&mut self) -> _HDSETW {
                _HDSETW { w: self }
            }
            #[doc = "Bit 19 - HDCR Mirror Register Update Mask"]
            #[inline]
            pub fn hdcr(&mut self) -> _HDCRW {
                _HDCRW { w: self }
            }
            #[doc = "Bit 21 - OSCSICTRL Mirror Register Update Mask"]
            #[inline]
            pub fn oscsictrl(&mut self) -> _OSCSICTRLW {
                _OSCSICTRLW { w: self }
            }
            #[doc = "Bit 23 - OSCULCTRL Mirror Register Update Mask"]
            #[inline]
            pub fn osculctrl(&mut self) -> _OSCULCTRLW {
                _OSCULCTRLW { w: self }
            }
            #[doc = "Bit 24 - RTC CTR Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_ctr(&mut self) -> _RTC_CTRW {
                _RTC_CTRW { w: self }
            }
            #[doc = "Bit 25 - RTC ATIM0 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_atim0(&mut self) -> _RTC_ATIM0W {
                _RTC_ATIM0W { w: self }
            }
            #[doc = "Bit 26 - RTC ATIM1 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_atim1(&mut self) -> _RTC_ATIM1W {
                _RTC_ATIM1W { w: self }
            }
            #[doc = "Bit 27 - RTC TIM0 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_tim0(&mut self) -> _RTC_TIM0W {
                _RTC_TIM0W { w: self }
            }
            #[doc = "Bit 28 - RTC TIM1 Mirror Register Update Mask"]
            #[inline]
            pub fn rtc_tim1(&mut self) -> _RTC_TIM1W {
                _RTC_TIM1W { w: self }
            }
            #[doc = "Bit 29 - Retention Memory Mirror Register Update Mask"]
            #[inline]
            pub fn rmx(&mut self) -> _RMXW {
                _RMXW { w: self }
            }
        }
    }
    #[doc = "SCU Service Request Clear"]
    pub struct SRCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Service Request Clear"]
    pub mod srclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `PRWARN`"]
        pub enum PRWARNW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl PRWARNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PRWARNW::VALUE1 => false,
                    PRWARNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRWARNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRWARNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRWARNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PI`"]
        pub enum PIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl PIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PIW::VALUE1 => false,
                    PIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PIW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AI`"]
        pub enum AIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl AIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIW::VALUE1 => false,
                    AIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLROVR`"]
        pub enum DLROVRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl DLROVRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLROVRW::VALUE1 => false,
                    DLROVRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLROVRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLROVRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLROVRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLROVRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLROVRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACCR`"]
        pub enum LPACCRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl LPACCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACCRW::VALUE1 => false,
                    LPACCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACCRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACTH0`"]
        pub enum LPACTH0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl LPACTH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACTH0W::VALUE1 => false,
                    LPACTH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACTH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACTH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACTH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACTH0W::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACTH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACTH1`"]
        pub enum LPACTH1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl LPACTH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACTH1W::VALUE1 => false,
                    LPACTH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACTH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACTH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACTH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACTH1W::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACTH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACST`"]
        pub enum LPACSTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl LPACSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACSTW::VALUE1 => false,
                    LPACSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACSTW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACCLR`"]
        pub enum LPACCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl LPACCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACCLRW::VALUE1 => false,
                    LPACCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACCLRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACSET`"]
        pub enum LPACSETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl LPACSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACSETW::VALUE1 => false,
                    LPACSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACSETW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTST`"]
        pub enum HINTSTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl HINTSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTSTW::VALUE1 => false,
                    HINTSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTSTW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTCLR`"]
        pub enum HINTCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl HINTCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTCLRW::VALUE1 => false,
                    HINTCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTCLRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTSET`"]
        pub enum HINTSETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl HINTSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTSETW::VALUE1 => false,
                    HINTSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTSETW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCLR`"]
        pub enum HDCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl HDCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCLRW::VALUE1 => false,
                    HDCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCLRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDSET`"]
        pub enum HDSETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl HDSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDSETW::VALUE1 => false,
                    HDSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDSETW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCR`"]
        pub enum HDCRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl HDCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCRW::VALUE1 => false,
                    HDCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCSICTRL`"]
        pub enum OSCSICTRLW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl OSCSICTRLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCSICTRLW::VALUE1 => false,
                    OSCSICTRLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCSICTRLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCSICTRLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCSICTRLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCSICTRLW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCSICTRLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCULCTRL`"]
        pub enum OSCULCTRLW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl OSCULCTRLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCULCTRLW::VALUE1 => false,
                    OSCULCTRLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCULCTRLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCULCTRLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCULCTRLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCULCTRLW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCULCTRLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_CTR`"]
        pub enum RTC_CTRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl RTC_CTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_CTRW::VALUE1 => false,
                    RTC_CTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_CTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_CTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_CTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_CTRW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_CTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_ATIM0`"]
        pub enum RTC_ATIM0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl RTC_ATIM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_ATIM0W::VALUE1 => false,
                    RTC_ATIM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_ATIM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_ATIM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_ATIM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_ATIM0W::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_ATIM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_ATIM1`"]
        pub enum RTC_ATIM1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl RTC_ATIM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_ATIM1W::VALUE1 => false,
                    RTC_ATIM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_ATIM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_ATIM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_ATIM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_ATIM1W::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_ATIM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_TIM0`"]
        pub enum RTC_TIM0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl RTC_TIM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_TIM0W::VALUE1 => false,
                    RTC_TIM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_TIM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_TIM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_TIM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_TIM0W::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_TIM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_TIM1`"]
        pub enum RTC_TIM1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl RTC_TIM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_TIM1W::VALUE1 => false,
                    RTC_TIM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_TIM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_TIM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_TIM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_TIM1W::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_TIM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RMX`"]
        pub enum RMXW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the status bit"]
            VALUE2,
        }
        impl RMXW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RMXW::VALUE1 => false,
                    RMXW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMXW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RMXW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RMXW::VALUE1)
            }
            #[doc = "Clear the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RMXW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - WDT pre-warning Interrupt Clear"]
            #[inline]
            pub fn prwarn(&mut self) -> _PRWARNW {
                _PRWARNW { w: self }
            }
            #[doc = "Bit 1 - RTC Periodic Interrupt Clear"]
            #[inline]
            pub fn pi(&mut self) -> _PIW {
                _PIW { w: self }
            }
            #[doc = "Bit 2 - RTC Alarm Interrupt Clear"]
            #[inline]
            pub fn ai(&mut self) -> _AIW {
                _AIW { w: self }
            }
            #[doc = "Bit 3 - DLR Request Overrun Interrupt clear"]
            #[inline]
            pub fn dlrovr(&mut self) -> _DLROVRW {
                _DLROVRW { w: self }
            }
            #[doc = "Bit 6 - LPACLR Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn lpaccr(&mut self) -> _LPACCRW {
                _LPACCRW { w: self }
            }
            #[doc = "Bit 7 - LPACTH0 Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn lpacth0(&mut self) -> _LPACTH0W {
                _LPACTH0W { w: self }
            }
            #[doc = "Bit 8 - LPACTH1 Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn lpacth1(&mut self) -> _LPACTH1W {
                _LPACTH1W { w: self }
            }
            #[doc = "Bit 9 - LPACST Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn lpacst(&mut self) -> _LPACSTW {
                _LPACSTW { w: self }
            }
            #[doc = "Bit 10 - LPACCLR Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn lpacclr(&mut self) -> _LPACCLRW {
                _LPACCLRW { w: self }
            }
            #[doc = "Bit 11 - LPACSET Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn lpacset(&mut self) -> _LPACSETW {
                _LPACSETW { w: self }
            }
            #[doc = "Bit 12 - HINTST Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn hintst(&mut self) -> _HINTSTW {
                _HINTSTW { w: self }
            }
            #[doc = "Bit 13 - HINTCLR Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn hintclr(&mut self) -> _HINTCLRW {
                _HINTCLRW { w: self }
            }
            #[doc = "Bit 14 - HINTSET Mirror Register Update Interrupt Clear"]
            #[inline]
            pub fn hintset(&mut self) -> _HINTSETW {
                _HINTSETW { w: self }
            }
            #[doc = "Bit 17 - HDCLR Mirror Register Update Clear"]
            #[inline]
            pub fn hdclr(&mut self) -> _HDCLRW {
                _HDCLRW { w: self }
            }
            #[doc = "Bit 18 - HDSET Mirror Register Update Clear"]
            #[inline]
            pub fn hdset(&mut self) -> _HDSETW {
                _HDSETW { w: self }
            }
            #[doc = "Bit 19 - HDCR Mirror Register Update Clear"]
            #[inline]
            pub fn hdcr(&mut self) -> _HDCRW {
                _HDCRW { w: self }
            }
            #[doc = "Bit 21 - OSCSICTRL Mirror Register Update Clear"]
            #[inline]
            pub fn oscsictrl(&mut self) -> _OSCSICTRLW {
                _OSCSICTRLW { w: self }
            }
            #[doc = "Bit 23 - OSCULCTRL Mirror Register Update Clear"]
            #[inline]
            pub fn osculctrl(&mut self) -> _OSCULCTRLW {
                _OSCULCTRLW { w: self }
            }
            #[doc = "Bit 24 - RTC CTR Mirror Register Update Clear"]
            #[inline]
            pub fn rtc_ctr(&mut self) -> _RTC_CTRW {
                _RTC_CTRW { w: self }
            }
            #[doc = "Bit 25 - RTC ATIM0 Mirror Register Update Clear"]
            #[inline]
            pub fn rtc_atim0(&mut self) -> _RTC_ATIM0W {
                _RTC_ATIM0W { w: self }
            }
            #[doc = "Bit 26 - RTC ATIM1 Mirror Register Update Clear"]
            #[inline]
            pub fn rtc_atim1(&mut self) -> _RTC_ATIM1W {
                _RTC_ATIM1W { w: self }
            }
            #[doc = "Bit 27 - RTC TIM0 Mirror Register Update Clear"]
            #[inline]
            pub fn rtc_tim0(&mut self) -> _RTC_TIM0W {
                _RTC_TIM0W { w: self }
            }
            #[doc = "Bit 28 - RTC TIM1 Mirror Register Update Clear"]
            #[inline]
            pub fn rtc_tim1(&mut self) -> _RTC_TIM1W {
                _RTC_TIM1W { w: self }
            }
            #[doc = "Bit 29 - Retention Memory Mirror Register Update Clear"]
            #[inline]
            pub fn rmx(&mut self) -> _RMXW {
                _RMXW { w: self }
            }
        }
    }
    #[doc = "SCU Service Request Set"]
    pub struct SRSET {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Service Request Set"]
    pub mod srset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `PRWARN`"]
        pub enum PRWARNW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl PRWARNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PRWARNW::VALUE1 => false,
                    PRWARNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRWARNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRWARNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRWARNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PI`"]
        pub enum PIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl PIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PIW::VALUE1 => false,
                    PIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PIW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AI`"]
        pub enum AIW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl AIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIW::VALUE1 => false,
                    AIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLROVR`"]
        pub enum DLROVRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl DLROVRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLROVRW::VALUE1 => false,
                    DLROVRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLROVRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLROVRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLROVRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLROVRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLROVRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACCR`"]
        pub enum LPACCRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl LPACCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACCRW::VALUE1 => false,
                    LPACCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACCRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACTH0`"]
        pub enum LPACTH0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl LPACTH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACTH0W::VALUE1 => false,
                    LPACTH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACTH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACTH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACTH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACTH0W::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACTH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACTH1`"]
        pub enum LPACTH1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl LPACTH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACTH1W::VALUE1 => false,
                    LPACTH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACTH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACTH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACTH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACTH1W::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACTH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACST`"]
        pub enum LPACSTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl LPACSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACSTW::VALUE1 => false,
                    LPACSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACSTW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACCLR`"]
        pub enum LPACCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl LPACCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACCLRW::VALUE1 => false,
                    LPACCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACCLRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPACSET`"]
        pub enum LPACSETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl LPACSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LPACSETW::VALUE1 => false,
                    LPACSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPACSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPACSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPACSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPACSETW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPACSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTST`"]
        pub enum HINTSTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl HINTSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTSTW::VALUE1 => false,
                    HINTSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTSTW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTCLR`"]
        pub enum HINTCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl HINTCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTCLRW::VALUE1 => false,
                    HINTCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTCLRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HINTSET`"]
        pub enum HINTSETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl HINTSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HINTSETW::VALUE1 => false,
                    HINTSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HINTSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HINTSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HINTSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HINTSETW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HINTSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCRCLR`"]
        pub enum HDCRCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl HDCRCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCRCLRW::VALUE1 => false,
                    HDCRCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCRCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCRCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCRCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCRCLRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCRCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCRSET`"]
        pub enum HDCRSETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl HDCRSETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCRSETW::VALUE1 => false,
                    HDCRSETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCRSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCRSETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCRSETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCRSETW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCRSETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HDCR`"]
        pub enum HDCRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl HDCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HDCRW::VALUE1 => false,
                    HDCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HDCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HDCRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HDCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCSICTRL`"]
        pub enum OSCSICTRLW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl OSCSICTRLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCSICTRLW::VALUE1 => false,
                    OSCSICTRLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCSICTRLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCSICTRLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCSICTRLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCSICTRLW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCSICTRLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OSCULCTRL`"]
        pub enum OSCULCTRLW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl OSCULCTRLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OSCULCTRLW::VALUE1 => false,
                    OSCULCTRLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSCULCTRLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSCULCTRLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OSCULCTRLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OSCULCTRLW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OSCULCTRLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_CTR`"]
        pub enum RTC_CTRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl RTC_CTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_CTRW::VALUE1 => false,
                    RTC_CTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_CTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_CTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_CTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_CTRW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_CTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_ATIM0`"]
        pub enum RTC_ATIM0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl RTC_ATIM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_ATIM0W::VALUE1 => false,
                    RTC_ATIM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_ATIM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_ATIM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_ATIM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_ATIM0W::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_ATIM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_ATIM1`"]
        pub enum RTC_ATIM1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl RTC_ATIM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_ATIM1W::VALUE1 => false,
                    RTC_ATIM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_ATIM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_ATIM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_ATIM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_ATIM1W::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_ATIM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_TIM0`"]
        pub enum RTC_TIM0W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl RTC_TIM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_TIM0W::VALUE1 => false,
                    RTC_TIM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_TIM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_TIM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_TIM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_TIM0W::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_TIM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTC_TIM1`"]
        pub enum RTC_TIM1W {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl RTC_TIM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTC_TIM1W::VALUE1 => false,
                    RTC_TIM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTC_TIM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTC_TIM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTC_TIM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTC_TIM1W::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTC_TIM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RMX`"]
        pub enum RMXW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "set the status bit"]
            VALUE2,
        }
        impl RMXW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RMXW::VALUE1 => false,
                    RMXW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMXW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RMXW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RMXW::VALUE1)
            }
            #[doc = "set the status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RMXW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - WDT pre-warning Interrupt Set"]
            #[inline]
            pub fn prwarn(&mut self) -> _PRWARNW {
                _PRWARNW { w: self }
            }
            #[doc = "Bit 1 - RTC Periodic Interrupt Set"]
            #[inline]
            pub fn pi(&mut self) -> _PIW {
                _PIW { w: self }
            }
            #[doc = "Bit 2 - RTC Alarm Interrupt Set"]
            #[inline]
            pub fn ai(&mut self) -> _AIW {
                _AIW { w: self }
            }
            #[doc = "Bit 3 - DLR Request Overrun Interrupt Set"]
            #[inline]
            pub fn dlrovr(&mut self) -> _DLROVRW {
                _DLROVRW { w: self }
            }
            #[doc = "Bit 6 - LPACLR Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn lpaccr(&mut self) -> _LPACCRW {
                _LPACCRW { w: self }
            }
            #[doc = "Bit 7 - LPACTH0 Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn lpacth0(&mut self) -> _LPACTH0W {
                _LPACTH0W { w: self }
            }
            #[doc = "Bit 8 - LPACTH1 Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn lpacth1(&mut self) -> _LPACTH1W {
                _LPACTH1W { w: self }
            }
            #[doc = "Bit 9 - LPACST Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn lpacst(&mut self) -> _LPACSTW {
                _LPACSTW { w: self }
            }
            #[doc = "Bit 10 - LPACCLR Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn lpacclr(&mut self) -> _LPACCLRW {
                _LPACCLRW { w: self }
            }
            #[doc = "Bit 11 - LPACSET Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn lpacset(&mut self) -> _LPACSETW {
                _LPACSETW { w: self }
            }
            #[doc = "Bit 12 - HINTST Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn hintst(&mut self) -> _HINTSTW {
                _HINTSTW { w: self }
            }
            #[doc = "Bit 13 - HINTCLR Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn hintclr(&mut self) -> _HINTCLRW {
                _HINTCLRW { w: self }
            }
            #[doc = "Bit 14 - HINTSET Mirror Register Update Interrupt Set"]
            #[inline]
            pub fn hintset(&mut self) -> _HINTSETW {
                _HINTSETW { w: self }
            }
            #[doc = "Bit 17 - HDCRCLR Mirror Register Update Set"]
            #[inline]
            pub fn hdcrclr(&mut self) -> _HDCRCLRW {
                _HDCRCLRW { w: self }
            }
            #[doc = "Bit 18 - HDCRSET Mirror Register Update Set"]
            #[inline]
            pub fn hdcrset(&mut self) -> _HDCRSETW {
                _HDCRSETW { w: self }
            }
            #[doc = "Bit 19 - HDCR Mirror Register Update Set"]
            #[inline]
            pub fn hdcr(&mut self) -> _HDCRW {
                _HDCRW { w: self }
            }
            #[doc = "Bit 21 - OSCSICTRL Mirror Register Update Set"]
            #[inline]
            pub fn oscsictrl(&mut self) -> _OSCSICTRLW {
                _OSCSICTRLW { w: self }
            }
            #[doc = "Bit 23 - OSCULCTRL Mirror Register Update Set"]
            #[inline]
            pub fn osculctrl(&mut self) -> _OSCULCTRLW {
                _OSCULCTRLW { w: self }
            }
            #[doc = "Bit 24 - RTC CTR Mirror Register Update Set"]
            #[inline]
            pub fn rtc_ctr(&mut self) -> _RTC_CTRW {
                _RTC_CTRW { w: self }
            }
            #[doc = "Bit 25 - RTC ATIM0 Mirror Register Update Set"]
            #[inline]
            pub fn rtc_atim0(&mut self) -> _RTC_ATIM0W {
                _RTC_ATIM0W { w: self }
            }
            #[doc = "Bit 26 - RTC ATIM1 Mirror Register Update Set"]
            #[inline]
            pub fn rtc_atim1(&mut self) -> _RTC_ATIM1W {
                _RTC_ATIM1W { w: self }
            }
            #[doc = "Bit 27 - RTC TIM0 Mirror Register Update Set"]
            #[inline]
            pub fn rtc_tim0(&mut self) -> _RTC_TIM0W {
                _RTC_TIM0W { w: self }
            }
            #[doc = "Bit 28 - RTC TIM1 Mirror Register Update Set"]
            #[inline]
            pub fn rtc_tim1(&mut self) -> _RTC_TIM1W {
                _RTC_TIM1W { w: self }
            }
            #[doc = "Bit 29 - Retention Memory Mirror Register Update Set"]
            #[inline]
            pub fn rmx(&mut self) -> _RMXW {
                _RMXW { w: self }
            }
        }
    }
    #[doc = "SCU Service Request Mask"]
    pub struct NMIREQEN {
        register: VolatileCell<u32>,
    }
    #[doc = "SCU Service Request Mask"]
    pub mod nmireqen {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NMIREQEN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PRWARN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRWARNR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PRWARNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRWARNR::VALUE1 => false,
                    PRWARNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRWARNR {
                match value {
                    false => PRWARNR::VALUE1,
                    true => PRWARNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRWARNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRWARNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PIR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PIR::VALUE1 => false,
                    PIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PIR {
                match value {
                    false => PIR::VALUE1,
                    true => PIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl AIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIR::VALUE1 => false,
                    AIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIR {
                match value {
                    false => AIR::VALUE1,
                    true => AIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERU00`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERU00R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU00R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERU00R::VALUE1 => false,
                    ERU00R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERU00R {
                match value {
                    false => ERU00R::VALUE1,
                    true => ERU00R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERU00R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERU00R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERU01`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERU01R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU01R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERU01R::VALUE1 => false,
                    ERU01R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERU01R {
                match value {
                    false => ERU01R::VALUE1,
                    true => ERU01R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERU01R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERU01R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERU02`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERU02R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU02R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERU02R::VALUE1 => false,
                    ERU02R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERU02R {
                match value {
                    false => ERU02R::VALUE1,
                    true => ERU02R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERU02R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERU02R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERU03`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERU03R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU03R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERU03R::VALUE1 => false,
                    ERU03R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERU03R {
                match value {
                    false => ERU03R::VALUE1,
                    true => ERU03R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERU03R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERU03R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PRWARN`"]
        pub enum PRWARNW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PRWARNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PRWARNW::VALUE1 => false,
                    PRWARNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRWARNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRWARNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRWARNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRWARNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PI`"]
        pub enum PIW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PIW::VALUE1 => false,
                    PIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PIW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AI`"]
        pub enum AIW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl AIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIW::VALUE1 => false,
                    AIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU00`"]
        pub enum ERU00W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU00W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU00W::VALUE1 => false,
                    ERU00W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU00W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU00W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU00W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU00W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU00W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU01`"]
        pub enum ERU01W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU01W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU01W::VALUE1 => false,
                    ERU01W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU01W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU01W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU01W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU01W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU01W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU02`"]
        pub enum ERU02W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU02W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU02W::VALUE1 => false,
                    ERU02W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU02W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU02W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU02W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU02W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU02W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU03`"]
        pub enum ERU03W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl ERU03W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU03W::VALUE1 => false,
                    ERU03W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU03W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU03W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU03W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU03W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU03W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Promote Pre-Warning Interrupt Request to NMI Request"]
            #[inline]
            pub fn prwarn(&self) -> PRWARNR {
                PRWARNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Promote RTC Periodic Interrupt request to NMI Request"]
            #[inline]
            pub fn pi(&self) -> PIR {
                PIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Promote RTC Alarm Interrupt Request to NMI Request"]
            #[inline]
            pub fn ai(&self) -> AIR {
                AIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Promote Channel 0 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru00(&self) -> ERU00R {
                ERU00R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Promote Channel 1 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru01(&self) -> ERU01R {
                ERU01R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Promote Channel 2 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru02(&self) -> ERU02R {
                ERU02R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - Promote Channel 3 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru03(&self) -> ERU03R {
                ERU03R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Promote Pre-Warning Interrupt Request to NMI Request"]
            #[inline]
            pub fn prwarn(&mut self) -> _PRWARNW {
                _PRWARNW { w: self }
            }
            #[doc = "Bit 1 - Promote RTC Periodic Interrupt request to NMI Request"]
            #[inline]
            pub fn pi(&mut self) -> _PIW {
                _PIW { w: self }
            }
            #[doc = "Bit 2 - Promote RTC Alarm Interrupt Request to NMI Request"]
            #[inline]
            pub fn ai(&mut self) -> _AIW {
                _AIW { w: self }
            }
            #[doc = "Bit 16 - Promote Channel 0 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru00(&mut self) -> _ERU00W {
                _ERU00W { w: self }
            }
            #[doc = "Bit 17 - Promote Channel 1 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru01(&mut self) -> _ERU01W {
                _ERU01W { w: self }
            }
            #[doc = "Bit 18 - Promote Channel 2 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru02(&mut self) -> _ERU02W {
                _ERU02W { w: self }
            }
            #[doc = "Bit 19 - Promote Channel 3 Interrupt of ERU0 Request to NMI Request"]
            #[inline]
            pub fn eru03(&mut self) -> _ERU03W {
                _ERU03W { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_INTERRUPT {
    register_block: scu_interrupt::RegisterBlock,
}
impl Deref for SCU_INTERRUPT {
    type Target = scu_interrupt::RegisterBlock;
    fn deref(&self) -> &scu_interrupt::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_PARITY: Peripheral<SCU_PARITY> = unsafe { Peripheral::new(0x5000_413c) };
#[doc = "System Control Unit"]
pub mod scu_parity {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Parity Error Enable Register"]
        pub peen: PEEN,
        #[doc = "0x04 - Memory Checking Control Register"]
        pub mchkcon: MCHKCON,
        #[doc = "0x08 - Parity Error Trap Enable Register"]
        pub pete: PETE,
        #[doc = "0x0c - Parity Error Reset Enable Register"]
        pub persten: PERSTEN,
        _reserved0: [u8; 4usize],
        #[doc = "0x14 - Parity Error Flag Register"]
        pub peflag: PEFLAG,
        #[doc = "0x18 - Parity Memory Test Pattern Register"]
        pub pmtpr: PMTPR,
        #[doc = "0x1c - Parity Memory Test Select Register"]
        pub pmtsr: PMTSR,
    }
    #[doc = "Parity Error Enable Register"]
    pub struct PEEN {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Error Enable Register"]
    pub mod peen {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PEEN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PEENPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENPSR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENPSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENPSR::VALUE1 => false,
                    PEENPSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENPSR {
                match value {
                    false => PEENPSR::VALUE1,
                    true => PEENPSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENPSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEENDS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENDS1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENDS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENDS1R::VALUE1 => false,
                    PEENDS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENDS1R {
                match value {
                    false => PEENDS1R::VALUE1,
                    true => PEENDS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENDS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENDS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEENU0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENU0R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENU0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENU0R::VALUE1 => false,
                    PEENU0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENU0R {
                match value {
                    false => PEENU0R::VALUE1,
                    true => PEENU0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENU0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENU0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEENU1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENU1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENU1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENU1R::VALUE1 => false,
                    PEENU1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENU1R {
                match value {
                    false => PEENU1R::VALUE1,
                    true => PEENU1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENU1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENU1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEENMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENMCR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENMCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENMCR::VALUE1 => false,
                    PEENMCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENMCR {
                match value {
                    false => PEENMCR::VALUE1,
                    true => PEENMCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENMCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEENPPRF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENPPRFR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENPPRFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENPPRFR::VALUE1 => false,
                    PEENPPRFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENPPRFR {
                match value {
                    false => PEENPPRFR::VALUE1,
                    true => PEENPPRFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENPPRFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENPPRFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEENUSB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEENUSBR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENUSBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEENUSBR::VALUE1 => false,
                    PEENUSBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEENUSBR {
                match value {
                    false => PEENUSBR::VALUE1,
                    true => PEENUSBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEENUSBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEENUSBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PEENPS`"]
        pub enum PEENPSW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENPSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENPSW::VALUE1 => false,
                    PEENPSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENPSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENPSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENPSW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENPSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEENDS1`"]
        pub enum PEENDS1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENDS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENDS1W::VALUE1 => false,
                    PEENDS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENDS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENDS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENDS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENDS1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENDS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEENU0`"]
        pub enum PEENU0W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENU0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENU0W::VALUE1 => false,
                    PEENU0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENU0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENU0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENU0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENU0W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENU0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEENU1`"]
        pub enum PEENU1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENU1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENU1W::VALUE1 => false,
                    PEENU1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENU1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENU1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENU1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENU1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENU1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEENMC`"]
        pub enum PEENMCW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENMCW::VALUE1 => false,
                    PEENMCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENMCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENMCW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENMCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEENPPRF`"]
        pub enum PEENPPRFW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENPPRFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENPPRFW::VALUE1 => false,
                    PEENPPRFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENPPRFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENPPRFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENPPRFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENPPRFW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENPPRFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEENUSB`"]
        pub enum PEENUSBW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PEENUSBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEENUSBW::VALUE1 => false,
                    PEENUSBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEENUSBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEENUSBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEENUSBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEENUSBW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEENUSBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Parity Error Enable for PSRAM"]
            #[inline]
            pub fn peenps(&self) -> PEENPSR {
                PEENPSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Parity Error Enable for DSRAM1"]
            #[inline]
            pub fn peends1(&self) -> PEENDS1R {
                PEENDS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Parity Error Enable for USIC0 Memory"]
            #[inline]
            pub fn peenu0(&self) -> PEENU0R {
                PEENU0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Parity Error Enable for USIC1 Memory"]
            #[inline]
            pub fn peenu1(&self) -> PEENU1R {
                PEENU1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Parity Error Enable for MultiCAN Memory"]
            #[inline]
            pub fn peenmc(&self) -> PEENMCR {
                PEENMCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Parity Error Enable for PMU Prefetch Memory"]
            #[inline]
            pub fn peenpprf(&self) -> PEENPPRFR {
                PEENPPRFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Parity Error Enable for USB Memory"]
            #[inline]
            pub fn peenusb(&self) -> PEENUSBR {
                PEENUSBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Parity Error Enable for PSRAM"]
            #[inline]
            pub fn peenps(&mut self) -> _PEENPSW {
                _PEENPSW { w: self }
            }
            #[doc = "Bit 1 - Parity Error Enable for DSRAM1"]
            #[inline]
            pub fn peends1(&mut self) -> _PEENDS1W {
                _PEENDS1W { w: self }
            }
            #[doc = "Bit 8 - Parity Error Enable for USIC0 Memory"]
            #[inline]
            pub fn peenu0(&mut self) -> _PEENU0W {
                _PEENU0W { w: self }
            }
            #[doc = "Bit 9 - Parity Error Enable for USIC1 Memory"]
            #[inline]
            pub fn peenu1(&mut self) -> _PEENU1W {
                _PEENU1W { w: self }
            }
            #[doc = "Bit 12 - Parity Error Enable for MultiCAN Memory"]
            #[inline]
            pub fn peenmc(&mut self) -> _PEENMCW {
                _PEENMCW { w: self }
            }
            #[doc = "Bit 13 - Parity Error Enable for PMU Prefetch Memory"]
            #[inline]
            pub fn peenpprf(&mut self) -> _PEENPPRFW {
                _PEENPPRFW { w: self }
            }
            #[doc = "Bit 16 - Parity Error Enable for USB Memory"]
            #[inline]
            pub fn peenusb(&mut self) -> _PEENUSBW {
                _PEENUSBW { w: self }
            }
        }
    }
    #[doc = "Memory Checking Control Register"]
    pub struct MCHKCON {
        register: VolatileCell<u32>,
    }
    #[doc = "Memory Checking Control Register"]
    pub mod mchkcon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MCHKCON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SELPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELPSR {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl SELPSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELPSR::VALUE1 => false,
                    SELPSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELPSR {
                match value {
                    false => SELPSR::VALUE1,
                    true => SELPSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELPSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELDS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELDS1R {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl SELDS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELDS1R::VALUE1 => false,
                    SELDS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELDS1R {
                match value {
                    false => SELDS1R::VALUE1,
                    true => SELDS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELDS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELDS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `USIC0DRA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USIC0DRAR {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl USIC0DRAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USIC0DRAR::VALUE1 => false,
                    USIC0DRAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USIC0DRAR {
                match value {
                    false => USIC0DRAR::VALUE1,
                    true => USIC0DRAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USIC0DRAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USIC0DRAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USIC1DRA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USIC1DRAR {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl USIC1DRAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USIC1DRAR::VALUE1 => false,
                    USIC1DRAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USIC1DRAR {
                match value {
                    false => USIC1DRAR::VALUE1,
                    true => USIC1DRAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USIC1DRAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USIC1DRAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCANDRA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCANDRAR {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl MCANDRAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCANDRAR::VALUE1 => false,
                    MCANDRAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCANDRAR {
                match value {
                    false => MCANDRAR::VALUE1,
                    true => MCANDRAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCANDRAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCANDRAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPRFDRA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPRFDRAR {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl PPRFDRAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPRFDRAR::VALUE1 => false,
                    PPRFDRAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPRFDRAR {
                match value {
                    false => PPRFDRAR::VALUE1,
                    true => PPRFDRAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPRFDRAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPRFDRAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELUSB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELUSBR {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl SELUSBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELUSBR::VALUE1 => false,
                    SELUSBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELUSBR {
                match value {
                    false => SELUSBR::VALUE1,
                    true => SELUSBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELUSBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELUSBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SELPS`"]
        pub enum SELPSW {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl SELPSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELPSW::VALUE1 => false,
                    SELPSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELPSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELPSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELPSW::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELPSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELDS1`"]
        pub enum SELDS1W {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl SELDS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELDS1W::VALUE1 => false,
                    SELDS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELDS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELDS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELDS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELDS1W::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELDS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC0DRA`"]
        pub enum USIC0DRAW {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl USIC0DRAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC0DRAW::VALUE1 => false,
                    USIC0DRAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC0DRAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC0DRAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC0DRAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC0DRAW::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC0DRAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC1DRA`"]
        pub enum USIC1DRAW {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl USIC1DRAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC1DRAW::VALUE1 => false,
                    USIC1DRAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC1DRAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC1DRAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC1DRAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC1DRAW::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC1DRAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCANDRA`"]
        pub enum MCANDRAW {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl MCANDRAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCANDRAW::VALUE1 => false,
                    MCANDRAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCANDRAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCANDRAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCANDRAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCANDRAW::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCANDRAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPRFDRA`"]
        pub enum PPRFDRAW {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl PPRFDRAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPRFDRAW::VALUE1 => false,
                    PPRFDRAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPRFDRAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPRFDRAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPRFDRAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPRFDRAW::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPRFDRAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELUSB`"]
        pub enum SELUSBW {
            #[doc = "Not selected"]
            VALUE1,
            #[doc = "Selected"]
            VALUE2,
        }
        impl SELUSBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELUSBW::VALUE1 => false,
                    SELUSBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELUSBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELUSBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELUSBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Not selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELUSBW::VALUE1)
            }
            #[doc = "Selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELUSBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Select Memory Check for PSRAM"]
            #[inline]
            pub fn selps(&self) -> SELPSR {
                SELPSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Select Memory Check for DSRAM1"]
            #[inline]
            pub fn selds1(&self) -> SELDS1R {
                SELDS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Select Memory Check for USIC0"]
            #[inline]
            pub fn usic0dra(&self) -> USIC0DRAR {
                USIC0DRAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Select Memory Check for USIC1"]
            #[inline]
            pub fn usic1dra(&self) -> USIC1DRAR {
                USIC1DRAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Select Memory Check for MultiCAN"]
            #[inline]
            pub fn mcandra(&self) -> MCANDRAR {
                MCANDRAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Select Memory Check for PMU"]
            #[inline]
            pub fn pprfdra(&self) -> PPRFDRAR {
                PPRFDRAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Select Memory Check for USB SRAM"]
            #[inline]
            pub fn selusb(&self) -> SELUSBR {
                SELUSBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Select Memory Check for PSRAM"]
            #[inline]
            pub fn selps(&mut self) -> _SELPSW {
                _SELPSW { w: self }
            }
            #[doc = "Bit 1 - Select Memory Check for DSRAM1"]
            #[inline]
            pub fn selds1(&mut self) -> _SELDS1W {
                _SELDS1W { w: self }
            }
            #[doc = "Bit 8 - Select Memory Check for USIC0"]
            #[inline]
            pub fn usic0dra(&mut self) -> _USIC0DRAW {
                _USIC0DRAW { w: self }
            }
            #[doc = "Bit 9 - Select Memory Check for USIC1"]
            #[inline]
            pub fn usic1dra(&mut self) -> _USIC1DRAW {
                _USIC1DRAW { w: self }
            }
            #[doc = "Bit 12 - Select Memory Check for MultiCAN"]
            #[inline]
            pub fn mcandra(&mut self) -> _MCANDRAW {
                _MCANDRAW { w: self }
            }
            #[doc = "Bit 13 - Select Memory Check for PMU"]
            #[inline]
            pub fn pprfdra(&mut self) -> _PPRFDRAW {
                _PPRFDRAW { w: self }
            }
            #[doc = "Bit 16 - Select Memory Check for USB SRAM"]
            #[inline]
            pub fn selusb(&mut self) -> _SELUSBW {
                _SELUSBW { w: self }
            }
        }
    }
    #[doc = "Parity Error Trap Enable Register"]
    pub struct PETE {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Error Trap Enable Register"]
    pub mod pete {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PETE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PETEPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEPSR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEPSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEPSR::VALUE1 => false,
                    PETEPSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEPSR {
                match value {
                    false => PETEPSR::VALUE1,
                    true => PETEPSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEPSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PETEDS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEDS1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEDS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEDS1R::VALUE1 => false,
                    PETEDS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEDS1R {
                match value {
                    false => PETEDS1R::VALUE1,
                    true => PETEDS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEDS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEDS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PETEU0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEU0R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEU0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEU0R::VALUE1 => false,
                    PETEU0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEU0R {
                match value {
                    false => PETEU0R::VALUE1,
                    true => PETEU0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEU0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEU0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PETEU1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEU1R {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEU1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEU1R::VALUE1 => false,
                    PETEU1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEU1R {
                match value {
                    false => PETEU1R::VALUE1,
                    true => PETEU1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEU1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEU1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PETEMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEMCR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEMCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEMCR::VALUE1 => false,
                    PETEMCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEMCR {
                match value {
                    false => PETEMCR::VALUE1,
                    true => PETEMCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEMCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PETEPPRF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEPPRFR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEPPRFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEPPRFR::VALUE1 => false,
                    PETEPPRFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEPPRFR {
                match value {
                    false => PETEPPRFR::VALUE1,
                    true => PETEPPRFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEPPRFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEPPRFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PETEUSB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETEUSBR {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEUSBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETEUSBR::VALUE1 => false,
                    PETEUSBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETEUSBR {
                match value {
                    false => PETEUSBR::VALUE1,
                    true => PETEUSBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETEUSBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETEUSBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PETEPS`"]
        pub enum PETEPSW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEPSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEPSW::VALUE1 => false,
                    PETEPSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEPSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEPSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEPSW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEPSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PETEDS1`"]
        pub enum PETEDS1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEDS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEDS1W::VALUE1 => false,
                    PETEDS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEDS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEDS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEDS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEDS1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEDS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PETEU0`"]
        pub enum PETEU0W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEU0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEU0W::VALUE1 => false,
                    PETEU0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEU0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEU0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEU0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEU0W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEU0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PETEU1`"]
        pub enum PETEU1W {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEU1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEU1W::VALUE1 => false,
                    PETEU1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEU1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEU1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEU1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEU1W::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEU1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PETEMC`"]
        pub enum PETEMCW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEMCW::VALUE1 => false,
                    PETEMCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEMCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEMCW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEMCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PETEPPRF`"]
        pub enum PETEPPRFW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEPPRFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEPPRFW::VALUE1 => false,
                    PETEPPRFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEPPRFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEPPRFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEPPRFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEPPRFW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEPPRFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PETEUSB`"]
        pub enum PETEUSBW {
            #[doc = "Disabled"]
            VALUE1,
            #[doc = "Enabled"]
            VALUE2,
        }
        impl PETEUSBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETEUSBW::VALUE1 => false,
                    PETEUSBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETEUSBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETEUSBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETEUSBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETEUSBW::VALUE1)
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETEUSBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Parity Error Trap Enable for PSRAM"]
            #[inline]
            pub fn peteps(&self) -> PETEPSR {
                PETEPSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Parity Error Trap Enable for DSRAM1"]
            #[inline]
            pub fn peteds1(&self) -> PETEDS1R {
                PETEDS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Parity Error Trap Enable for USIC0 Memory"]
            #[inline]
            pub fn peteu0(&self) -> PETEU0R {
                PETEU0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Parity Error Trap Enable for USIC1 Memory"]
            #[inline]
            pub fn peteu1(&self) -> PETEU1R {
                PETEU1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Parity Error Trap Enable for MultiCAN Memory"]
            #[inline]
            pub fn petemc(&self) -> PETEMCR {
                PETEMCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Parity Error Trap Enable for PMU Prefetch Memory"]
            #[inline]
            pub fn petepprf(&self) -> PETEPPRFR {
                PETEPPRFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Parity Error Trap Enable for USB Memory"]
            #[inline]
            pub fn peteusb(&self) -> PETEUSBR {
                PETEUSBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Parity Error Trap Enable for PSRAM"]
            #[inline]
            pub fn peteps(&mut self) -> _PETEPSW {
                _PETEPSW { w: self }
            }
            #[doc = "Bit 1 - Parity Error Trap Enable for DSRAM1"]
            #[inline]
            pub fn peteds1(&mut self) -> _PETEDS1W {
                _PETEDS1W { w: self }
            }
            #[doc = "Bit 8 - Parity Error Trap Enable for USIC0 Memory"]
            #[inline]
            pub fn peteu0(&mut self) -> _PETEU0W {
                _PETEU0W { w: self }
            }
            #[doc = "Bit 9 - Parity Error Trap Enable for USIC1 Memory"]
            #[inline]
            pub fn peteu1(&mut self) -> _PETEU1W {
                _PETEU1W { w: self }
            }
            #[doc = "Bit 12 - Parity Error Trap Enable for MultiCAN Memory"]
            #[inline]
            pub fn petemc(&mut self) -> _PETEMCW {
                _PETEMCW { w: self }
            }
            #[doc = "Bit 13 - Parity Error Trap Enable for PMU Prefetch Memory"]
            #[inline]
            pub fn petepprf(&mut self) -> _PETEPPRFW {
                _PETEPPRFW { w: self }
            }
            #[doc = "Bit 16 - Parity Error Trap Enable for USB Memory"]
            #[inline]
            pub fn peteusb(&mut self) -> _PETEUSBW {
                _PETEUSBW { w: self }
            }
        }
    }
    #[doc = "Parity Error Reset Enable Register"]
    pub struct PERSTEN {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Error Reset Enable Register"]
    pub mod persten {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PERSTEN {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `RSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSENR {
            #[doc = "Reset request disabled"]
            VALUE1,
            #[doc = "Reset request enabled"]
            VALUE2,
        }
        impl RSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSENR::VALUE1 => false,
                    RSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSENR {
                match value {
                    false => RSENR::VALUE1,
                    true => RSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `RSEN`"]
        pub enum RSENW {
            #[doc = "Reset request disabled"]
            VALUE1,
            #[doc = "Reset request enabled"]
            VALUE2,
        }
        impl RSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSENW::VALUE1 => false,
                    RSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Reset request disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSENW::VALUE1)
            }
            #[doc = "Reset request enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - System Reset Enable upon Parity Error Trap"]
            #[inline]
            pub fn rsen(&self) -> RSENR {
                RSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - System Reset Enable upon Parity Error Trap"]
            #[inline]
            pub fn rsen(&mut self) -> _RSENW {
                _RSENW { w: self }
            }
        }
    }
    #[doc = "Parity Error Flag Register"]
    pub struct PEFLAG {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Error Flag Register"]
    pub mod peflag {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PEFLAG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PEFPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEFPSR {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFPSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEFPSR::VALUE1 => false,
                    PEFPSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEFPSR {
                match value {
                    false => PEFPSR::VALUE1,
                    true => PEFPSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEFPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEFPSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEFDS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEFDS1R {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFDS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEFDS1R::VALUE1 => false,
                    PEFDS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEFDS1R {
                match value {
                    false => PEFDS1R::VALUE1,
                    true => PEFDS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEFDS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEFDS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEFU0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEFU0R {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFU0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEFU0R::VALUE1 => false,
                    PEFU0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEFU0R {
                match value {
                    false => PEFU0R::VALUE1,
                    true => PEFU0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEFU0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEFU0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEFU1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEFU1R {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFU1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEFU1R::VALUE1 => false,
                    PEFU1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEFU1R {
                match value {
                    false => PEFU1R::VALUE1,
                    true => PEFU1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEFU1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEFU1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEFMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEFMCR {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFMCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEFMCR::VALUE1 => false,
                    PEFMCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEFMCR {
                match value {
                    false => PEFMCR::VALUE1,
                    true => PEFMCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEFMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEFMCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEFPPRF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEFPPRFR {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFPPRFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEFPPRFR::VALUE1 => false,
                    PEFPPRFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEFPPRFR {
                match value {
                    false => PEFPPRFR::VALUE1,
                    true => PEFPPRFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEFPPRFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEFPPRFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PEUSB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PEUSBR {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEUSBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PEUSBR::VALUE1 => false,
                    PEUSBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PEUSBR {
                match value {
                    false => PEUSBR::VALUE1,
                    true => PEUSBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PEUSBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PEUSBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PEFPS`"]
        pub enum PEFPSW {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFPSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEFPSW::VALUE1 => false,
                    PEFPSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEFPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEFPSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEFPSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEFPSW::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEFPSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEFDS1`"]
        pub enum PEFDS1W {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFDS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEFDS1W::VALUE1 => false,
                    PEFDS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEFDS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEFDS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEFDS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEFDS1W::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEFDS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEFU0`"]
        pub enum PEFU0W {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFU0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEFU0W::VALUE1 => false,
                    PEFU0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEFU0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEFU0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEFU0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEFU0W::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEFU0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEFU1`"]
        pub enum PEFU1W {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFU1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEFU1W::VALUE1 => false,
                    PEFU1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEFU1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEFU1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEFU1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEFU1W::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEFU1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEFMC`"]
        pub enum PEFMCW {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEFMCW::VALUE1 => false,
                    PEFMCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEFMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEFMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEFMCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEFMCW::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEFMCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEFPPRF`"]
        pub enum PEFPPRFW {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEFPPRFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEFPPRFW::VALUE1 => false,
                    PEFPPRFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEFPPRFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEFPPRFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEFPPRFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEFPPRFW::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEFPPRFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PEUSB`"]
        pub enum PEUSBW {
            #[doc = "No parity error detected"]
            VALUE1,
            #[doc = "Parity error detected"]
            VALUE2,
        }
        impl PEUSBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PEUSBW::VALUE1 => false,
                    PEUSBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PEUSBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PEUSBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PEUSBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No parity error detected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PEUSBW::VALUE1)
            }
            #[doc = "Parity error detected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PEUSBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Parity Error Flag for PSRAM"]
            #[inline]
            pub fn pefps(&self) -> PEFPSR {
                PEFPSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Parity Error Flag for DSRAM1"]
            #[inline]
            pub fn pefds1(&self) -> PEFDS1R {
                PEFDS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Parity Error Flag for USIC0 Memory"]
            #[inline]
            pub fn pefu0(&self) -> PEFU0R {
                PEFU0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Parity Error Flag for USIC1 Memory"]
            #[inline]
            pub fn pefu1(&self) -> PEFU1R {
                PEFU1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Parity Error Flag for MultiCAN Memory"]
            #[inline]
            pub fn pefmc(&self) -> PEFMCR {
                PEFMCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Parity Error Flag for PMU Prefetch Memory"]
            #[inline]
            pub fn pefpprf(&self) -> PEFPPRFR {
                PEFPPRFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Parity Error Flag for USB Memory"]
            #[inline]
            pub fn peusb(&self) -> PEUSBR {
                PEUSBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Parity Error Flag for PSRAM"]
            #[inline]
            pub fn pefps(&mut self) -> _PEFPSW {
                _PEFPSW { w: self }
            }
            #[doc = "Bit 1 - Parity Error Flag for DSRAM1"]
            #[inline]
            pub fn pefds1(&mut self) -> _PEFDS1W {
                _PEFDS1W { w: self }
            }
            #[doc = "Bit 8 - Parity Error Flag for USIC0 Memory"]
            #[inline]
            pub fn pefu0(&mut self) -> _PEFU0W {
                _PEFU0W { w: self }
            }
            #[doc = "Bit 9 - Parity Error Flag for USIC1 Memory"]
            #[inline]
            pub fn pefu1(&mut self) -> _PEFU1W {
                _PEFU1W { w: self }
            }
            #[doc = "Bit 12 - Parity Error Flag for MultiCAN Memory"]
            #[inline]
            pub fn pefmc(&mut self) -> _PEFMCW {
                _PEFMCW { w: self }
            }
            #[doc = "Bit 13 - Parity Error Flag for PMU Prefetch Memory"]
            #[inline]
            pub fn pefpprf(&mut self) -> _PEFPPRFW {
                _PEFPPRFW { w: self }
            }
            #[doc = "Bit 16 - Parity Error Flag for USB Memory"]
            #[inline]
            pub fn peusb(&mut self) -> _PEUSBW {
                _PEUSBW { w: self }
            }
        }
    }
    #[doc = "Parity Memory Test Pattern Register"]
    pub struct PMTPR {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Memory Test Pattern Register"]
    pub mod pmtpr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PMTPR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRDR {
            bits: u8,
        }
        impl PRDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PWRR {
            bits: u8,
        }
        impl PWRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PWRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PWRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 8:15 - Parity Read Values for Memory Test"]
            #[inline]
            pub fn prd(&self) -> PRDR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PRDR { bits }
            }
            #[doc = "Bits 0:7 - Parity Write Values for Memory Test"]
            #[inline]
            pub fn pwr(&self) -> PWRR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PWRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Parity Write Values for Memory Test"]
            #[inline]
            pub fn pwr(&mut self) -> _PWRW {
                _PWRW { w: self }
            }
        }
    }
    #[doc = "Parity Memory Test Select Register"]
    pub struct PMTSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Memory Test Select Register"]
    pub mod pmtsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PMTSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MTENPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTENPSR {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTENPSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTENPSR::VALUE1 => false,
                    MTENPSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTENPSR {
                match value {
                    false => MTENPSR::VALUE1,
                    true => MTENPSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTENPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTENPSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MTENDS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTENDS1R {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTENDS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTENDS1R::VALUE1 => false,
                    MTENDS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTENDS1R {
                match value {
                    false => MTENDS1R::VALUE1,
                    true => MTENDS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTENDS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTENDS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MTEU0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTEU0R {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEU0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTEU0R::VALUE1 => false,
                    MTEU0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTEU0R {
                match value {
                    false => MTEU0R::VALUE1,
                    true => MTEU0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTEU0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTEU0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MTEU1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTEU1R {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEU1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTEU1R::VALUE1 => false,
                    MTEU1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTEU1R {
                match value {
                    false => MTEU1R::VALUE1,
                    true => MTEU1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTEU1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTEU1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MTEMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTEMCR {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEMCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTEMCR::VALUE1 => false,
                    MTEMCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTEMCR {
                match value {
                    false => MTEMCR::VALUE1,
                    true => MTEMCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTEMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTEMCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MTEPPRF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTEPPRFR {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEPPRFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTEPPRFR::VALUE1 => false,
                    MTEPPRFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTEPPRFR {
                match value {
                    false => MTEPPRFR::VALUE1,
                    true => MTEPPRFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTEPPRFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTEPPRFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MTUSB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MTUSBR {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTUSBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MTUSBR::VALUE1 => false,
                    MTUSBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MTUSBR {
                match value {
                    false => MTUSBR::VALUE1,
                    true => MTUSBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MTUSBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MTUSBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `MTENPS`"]
        pub enum MTENPSW {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTENPSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTENPSW::VALUE1 => false,
                    MTENPSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTENPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTENPSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTENPSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTENPSW::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTENPSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MTENDS1`"]
        pub enum MTENDS1W {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTENDS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTENDS1W::VALUE1 => false,
                    MTENDS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTENDS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTENDS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTENDS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTENDS1W::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTENDS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MTEU0`"]
        pub enum MTEU0W {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEU0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTEU0W::VALUE1 => false,
                    MTEU0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTEU0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTEU0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTEU0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTEU0W::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTEU0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MTEU1`"]
        pub enum MTEU1W {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEU1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTEU1W::VALUE1 => false,
                    MTEU1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTEU1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTEU1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTEU1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTEU1W::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTEU1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MTEMC`"]
        pub enum MTEMCW {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTEMCW::VALUE1 => false,
                    MTEMCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTEMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTEMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTEMCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTEMCW::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTEMCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MTEPPRF`"]
        pub enum MTEPPRFW {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTEPPRFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTEPPRFW::VALUE1 => false,
                    MTEPPRFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTEPPRFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTEPPRFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTEPPRFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTEPPRFW::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTEPPRFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MTUSB`"]
        pub enum MTUSBW {
            #[doc = "Standard operation"]
            VALUE1,
            #[doc = "Parity bits under test"]
            VALUE2,
        }
        impl MTUSBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MTUSBW::VALUE1 => false,
                    MTUSBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTUSBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTUSBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTUSBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTUSBW::VALUE1)
            }
            #[doc = "Parity bits under test"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTUSBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Test Enable Control for PSRAM"]
            #[inline]
            pub fn mtenps(&self) -> MTENPSR {
                MTENPSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Test Enable Control for DSRAM1"]
            #[inline]
            pub fn mtends1(&self) -> MTENDS1R {
                MTENDS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Test Enable Control for USIC0 Memory"]
            #[inline]
            pub fn mteu0(&self) -> MTEU0R {
                MTEU0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Test Enable Control for USIC1 Memory"]
            #[inline]
            pub fn mteu1(&self) -> MTEU1R {
                MTEU1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Test Enable Control for MultiCAN Memory"]
            #[inline]
            pub fn mtemc(&self) -> MTEMCR {
                MTEMCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Test Enable Control for PMU Prefetch Memory"]
            #[inline]
            pub fn mtepprf(&self) -> MTEPPRFR {
                MTEPPRFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Test Enable Control for USB Memory"]
            #[inline]
            pub fn mtusb(&self) -> MTUSBR {
                MTUSBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Test Enable Control for PSRAM"]
            #[inline]
            pub fn mtenps(&mut self) -> _MTENPSW {
                _MTENPSW { w: self }
            }
            #[doc = "Bit 1 - Test Enable Control for DSRAM1"]
            #[inline]
            pub fn mtends1(&mut self) -> _MTENDS1W {
                _MTENDS1W { w: self }
            }
            #[doc = "Bit 8 - Test Enable Control for USIC0 Memory"]
            #[inline]
            pub fn mteu0(&mut self) -> _MTEU0W {
                _MTEU0W { w: self }
            }
            #[doc = "Bit 9 - Test Enable Control for USIC1 Memory"]
            #[inline]
            pub fn mteu1(&mut self) -> _MTEU1W {
                _MTEU1W { w: self }
            }
            #[doc = "Bit 12 - Test Enable Control for MultiCAN Memory"]
            #[inline]
            pub fn mtemc(&mut self) -> _MTEMCW {
                _MTEMCW { w: self }
            }
            #[doc = "Bit 13 - Test Enable Control for PMU Prefetch Memory"]
            #[inline]
            pub fn mtepprf(&mut self) -> _MTEPPRFW {
                _MTEPPRFW { w: self }
            }
            #[doc = "Bit 16 - Test Enable Control for USB Memory"]
            #[inline]
            pub fn mtusb(&mut self) -> _MTUSBW {
                _MTUSBW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_PARITY {
    register_block: scu_parity::RegisterBlock,
}
impl Deref for SCU_PARITY {
    type Target = scu_parity::RegisterBlock;
    fn deref(&self) -> &scu_parity::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_TRAP: Peripheral<SCU_TRAP> = unsafe { Peripheral::new(0x5000_4160) };
#[doc = "System Control Unit"]
pub mod scu_trap {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Trap Status Register"]
        pub trapstat: TRAPSTAT,
        #[doc = "0x04 - Trap Raw Status Register"]
        pub trapraw: TRAPRAW,
        #[doc = "0x08 - Trap Disable Register"]
        pub trapdis: TRAPDIS,
        #[doc = "0x0c - Trap Clear Register"]
        pub trapclr: TRAPCLR,
        #[doc = "0x10 - Trap Set Register"]
        pub trapset: TRAPSET,
    }
    #[doc = "Trap Status Register"]
    pub struct TRAPSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Trap Status Register"]
    pub mod trapstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TRAPSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `SOSCWDGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SOSCWDGTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl SOSCWDGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SOSCWDGTR::VALUE1 => false,
                    SOSCWDGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SOSCWDGTR {
                match value {
                    false => SOSCWDGTR::VALUE1,
                    true => SOSCWDGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SOSCWDGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SOSCWDGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SVCOLCKT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SVCOLCKTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl SVCOLCKTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SVCOLCKTR::VALUE1 => false,
                    SVCOLCKTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SVCOLCKTR {
                match value {
                    false => SVCOLCKTR::VALUE1,
                    true => SVCOLCKTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SVCOLCKTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SVCOLCKTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UVCOLCKT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UVCOLCKTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl UVCOLCKTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UVCOLCKTR::VALUE1 => false,
                    UVCOLCKTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UVCOLCKTR {
                match value {
                    false => UVCOLCKTR::VALUE1,
                    true => UVCOLCKTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UVCOLCKTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UVCOLCKTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl PETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETR::VALUE1 => false,
                    PETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETR {
                match value {
                    false => PETR::VALUE1,
                    true => PETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRWNT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRWNTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl BRWNTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRWNTR::VALUE1 => false,
                    BRWNTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRWNTR {
                match value {
                    false => BRWNTR::VALUE1,
                    true => BRWNTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRWNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRWNTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ULPWDGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ULPWDGTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl ULPWDGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ULPWDGTR::VALUE1 => false,
                    ULPWDGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ULPWDGTR {
                match value {
                    false => ULPWDGTR::VALUE1,
                    true => ULPWDGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ULPWDGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ULPWDGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWERR0T`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWERR0TR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl BWERR0TR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWERR0TR::VALUE1 => false,
                    BWERR0TR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWERR0TR {
                match value {
                    false => BWERR0TR::VALUE1,
                    true => BWERR0TR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWERR0TR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWERR0TR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWERR1T`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWERR1TR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl BWERR1TR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWERR1TR::VALUE1 => false,
                    BWERR1TR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWERR1TR {
                match value {
                    false => BWERR1TR::VALUE1,
                    true => BWERR1TR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWERR1TR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWERR1TR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPHIT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPHITR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl TEMPHITR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPHITR::VALUE1 => false,
                    TEMPHITR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPHITR {
                match value {
                    false => TEMPHITR::VALUE1,
                    true => TEMPHITR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPHITR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPHITR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPLOT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPLOTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl TEMPLOTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPLOTR::VALUE1 => false,
                    TEMPLOTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPLOTR {
                match value {
                    false => TEMPLOTR::VALUE1,
                    true => TEMPLOTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPLOTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPLOTR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - System OSC WDT Trap Status"]
            #[inline]
            pub fn soscwdgt(&self) -> SOSCWDGTR {
                SOSCWDGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - System VCO Lock Trap Status"]
            #[inline]
            pub fn svcolckt(&self) -> SVCOLCKTR {
                SVCOLCKTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - USB VCO Lock Trap Status"]
            #[inline]
            pub fn uvcolckt(&self) -> UVCOLCKTR {
                UVCOLCKTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Parity Error Trap Status"]
            #[inline]
            pub fn pet(&self) -> PETR {
                PETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Brown Out Trap Status"]
            #[inline]
            pub fn brwnt(&self) -> BRWNTR {
                BRWNTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - OSC_ULP WDG Trap Status"]
            #[inline]
            pub fn ulpwdgt(&self) -> ULPWDGTR {
                ULPWDGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Peripheral Bridge 0 Trap Status"]
            #[inline]
            pub fn bwerr0t(&self) -> BWERR0TR {
                BWERR0TR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Peripheral Bridge 1 Trap Status"]
            #[inline]
            pub fn bwerr1t(&self) -> BWERR1TR {
                BWERR1TR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Die Temperature Too High Trap Status"]
            #[inline]
            pub fn temphit(&self) -> TEMPHITR {
                TEMPHITR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Die Temperature Too Low Trap Status"]
            #[inline]
            pub fn templot(&self) -> TEMPLOTR {
                TEMPLOTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Trap Raw Status Register"]
    pub struct TRAPRAW {
        register: VolatileCell<u32>,
    }
    #[doc = "Trap Raw Status Register"]
    pub mod trapraw {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TRAPRAW {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `SOSCWDGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SOSCWDGTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl SOSCWDGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SOSCWDGTR::VALUE1 => false,
                    SOSCWDGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SOSCWDGTR {
                match value {
                    false => SOSCWDGTR::VALUE1,
                    true => SOSCWDGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SOSCWDGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SOSCWDGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SVCOLCKT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SVCOLCKTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl SVCOLCKTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SVCOLCKTR::VALUE1 => false,
                    SVCOLCKTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SVCOLCKTR {
                match value {
                    false => SVCOLCKTR::VALUE1,
                    true => SVCOLCKTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SVCOLCKTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SVCOLCKTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UVCOLCKT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UVCOLCKTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl UVCOLCKTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UVCOLCKTR::VALUE1 => false,
                    UVCOLCKTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UVCOLCKTR {
                match value {
                    false => UVCOLCKTR::VALUE1,
                    true => UVCOLCKTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UVCOLCKTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UVCOLCKTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl PETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETR::VALUE1 => false,
                    PETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETR {
                match value {
                    false => PETR::VALUE1,
                    true => PETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRWNT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRWNTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl BRWNTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRWNTR::VALUE1 => false,
                    BRWNTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRWNTR {
                match value {
                    false => BRWNTR::VALUE1,
                    true => BRWNTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRWNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRWNTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ULPWDGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ULPWDGTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl ULPWDGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ULPWDGTR::VALUE1 => false,
                    ULPWDGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ULPWDGTR {
                match value {
                    false => ULPWDGTR::VALUE1,
                    true => ULPWDGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ULPWDGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ULPWDGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWERR0T`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWERR0TR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl BWERR0TR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWERR0TR::VALUE1 => false,
                    BWERR0TR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWERR0TR {
                match value {
                    false => BWERR0TR::VALUE1,
                    true => BWERR0TR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWERR0TR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWERR0TR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWERR1T`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWERR1TR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl BWERR1TR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWERR1TR::VALUE1 => false,
                    BWERR1TR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWERR1TR {
                match value {
                    false => BWERR1TR::VALUE1,
                    true => BWERR1TR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWERR1TR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWERR1TR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPHIT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPHITR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl TEMPHITR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPHITR::VALUE1 => false,
                    TEMPHITR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPHITR {
                match value {
                    false => TEMPHITR::VALUE1,
                    true => TEMPHITR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPHITR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPHITR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPLOT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPLOTR {
            #[doc = "No pending trap request"]
            VALUE1,
            #[doc = "Pending trap request"]
            VALUE2,
        }
        impl TEMPLOTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPLOTR::VALUE1 => false,
                    TEMPLOTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPLOTR {
                match value {
                    false => TEMPLOTR::VALUE1,
                    true => TEMPLOTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPLOTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPLOTR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - System OSC WDT Trap Raw Status"]
            #[inline]
            pub fn soscwdgt(&self) -> SOSCWDGTR {
                SOSCWDGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - System VCO Lock Trap Raw Status"]
            #[inline]
            pub fn svcolckt(&self) -> SVCOLCKTR {
                SVCOLCKTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - USB VCO Lock Trap Raw Status"]
            #[inline]
            pub fn uvcolckt(&self) -> UVCOLCKTR {
                UVCOLCKTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Parity Error Trap Raw Status"]
            #[inline]
            pub fn pet(&self) -> PETR {
                PETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Brown Out Trap Raw Status"]
            #[inline]
            pub fn brwnt(&self) -> BRWNTR {
                BRWNTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - OSC_ULP WDG Trap RAW Status"]
            #[inline]
            pub fn ulpwdgt(&self) -> ULPWDGTR {
                ULPWDGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Peripheral Bridge 0 Trap Raw Status"]
            #[inline]
            pub fn bwerr0t(&self) -> BWERR0TR {
                BWERR0TR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Peripheral Bridge 1 Trap Raw Status"]
            #[inline]
            pub fn bwerr1t(&self) -> BWERR1TR {
                BWERR1TR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Die Temperature Too High Trap Raw Status"]
            #[inline]
            pub fn temphit(&self) -> TEMPHITR {
                TEMPHITR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Die Temperature Too Low Trap Raw Status"]
            #[inline]
            pub fn templot(&self) -> TEMPLOTR {
                TEMPLOTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Trap Disable Register"]
    pub struct TRAPDIS {
        register: VolatileCell<u32>,
    }
    #[doc = "Trap Disable Register"]
    pub mod trapdis {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TRAPDIS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SOSCWDGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SOSCWDGTR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl SOSCWDGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SOSCWDGTR::VALUE1 => false,
                    SOSCWDGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SOSCWDGTR {
                match value {
                    false => SOSCWDGTR::VALUE1,
                    true => SOSCWDGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SOSCWDGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SOSCWDGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SVCOLCKT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SVCOLCKTR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl SVCOLCKTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SVCOLCKTR::VALUE1 => false,
                    SVCOLCKTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SVCOLCKTR {
                match value {
                    false => SVCOLCKTR::VALUE1,
                    true => SVCOLCKTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SVCOLCKTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SVCOLCKTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `UVCOLCKT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UVCOLCKTR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl UVCOLCKTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    UVCOLCKTR::VALUE1 => false,
                    UVCOLCKTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> UVCOLCKTR {
                match value {
                    false => UVCOLCKTR::VALUE1,
                    true => UVCOLCKTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UVCOLCKTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UVCOLCKTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PET`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PETR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl PETR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PETR::VALUE1 => false,
                    PETR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PETR {
                match value {
                    false => PETR::VALUE1,
                    true => PETR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PETR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PETR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRWNT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRWNTR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl BRWNTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRWNTR::VALUE1 => false,
                    BRWNTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRWNTR {
                match value {
                    false => BRWNTR::VALUE1,
                    true => BRWNTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRWNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRWNTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ULPWDGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ULPWDGTR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl ULPWDGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ULPWDGTR::VALUE1 => false,
                    ULPWDGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ULPWDGTR {
                match value {
                    false => ULPWDGTR::VALUE1,
                    true => ULPWDGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ULPWDGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ULPWDGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWERR0T`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWERR0TR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl BWERR0TR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWERR0TR::VALUE1 => false,
                    BWERR0TR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWERR0TR {
                match value {
                    false => BWERR0TR::VALUE1,
                    true => BWERR0TR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWERR0TR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWERR0TR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWERR1T`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWERR1TR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl BWERR1TR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWERR1TR::VALUE1 => false,
                    BWERR1TR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWERR1TR {
                match value {
                    false => BWERR1TR::VALUE1,
                    true => BWERR1TR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWERR1TR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWERR1TR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPHIT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPHITR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl TEMPHITR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPHITR::VALUE1 => false,
                    TEMPHITR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPHITR {
                match value {
                    false => TEMPHITR::VALUE1,
                    true => TEMPHITR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPHITR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPHITR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPLOT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPLOTR {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl TEMPLOTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPLOTR::VALUE1 => false,
                    TEMPLOTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPLOTR {
                match value {
                    false => TEMPLOTR::VALUE1,
                    true => TEMPLOTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPLOTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPLOTR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SOSCWDGT`"]
        pub enum SOSCWDGTW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl SOSCWDGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SOSCWDGTW::VALUE1 => false,
                    SOSCWDGTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOSCWDGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOSCWDGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SOSCWDGTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SOSCWDGTW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SOSCWDGTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SVCOLCKT`"]
        pub enum SVCOLCKTW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl SVCOLCKTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SVCOLCKTW::VALUE1 => false,
                    SVCOLCKTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVCOLCKTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVCOLCKTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SVCOLCKTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SVCOLCKTW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SVCOLCKTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UVCOLCKT`"]
        pub enum UVCOLCKTW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl UVCOLCKTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UVCOLCKTW::VALUE1 => false,
                    UVCOLCKTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UVCOLCKTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UVCOLCKTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UVCOLCKTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UVCOLCKTW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UVCOLCKTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PET`"]
        pub enum PETW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl PETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETW::VALUE1 => false,
                    PETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRWNT`"]
        pub enum BRWNTW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl BRWNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRWNTW::VALUE1 => false,
                    BRWNTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRWNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRWNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRWNTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRWNTW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRWNTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ULPWDGT`"]
        pub enum ULPWDGTW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl ULPWDGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ULPWDGTW::VALUE1 => false,
                    ULPWDGTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ULPWDGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ULPWDGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ULPWDGTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ULPWDGTW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ULPWDGTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWERR0T`"]
        pub enum BWERR0TW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl BWERR0TW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWERR0TW::VALUE1 => false,
                    BWERR0TW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWERR0TW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWERR0TW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWERR0TW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWERR0TW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWERR0TW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWERR1T`"]
        pub enum BWERR1TW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl BWERR1TW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWERR1TW::VALUE1 => false,
                    BWERR1TW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWERR1TW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWERR1TW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWERR1TW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWERR1TW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWERR1TW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TEMPHIT`"]
        pub enum TEMPHITW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl TEMPHITW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TEMPHITW::VALUE1 => false,
                    TEMPHITW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEMPHITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEMPHITW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TEMPHITW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TEMPHITW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TEMPHITW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TEMPLOT`"]
        pub enum TEMPLOTW {
            #[doc = "Trap request enabled"]
            VALUE1,
            #[doc = "Trap request disabled"]
            VALUE2,
        }
        impl TEMPLOTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TEMPLOTW::VALUE1 => false,
                    TEMPLOTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEMPLOTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEMPLOTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TEMPLOTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap request enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TEMPLOTW::VALUE1)
            }
            #[doc = "Trap request disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TEMPLOTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - System OSC WDT Trap Disable"]
            #[inline]
            pub fn soscwdgt(&self) -> SOSCWDGTR {
                SOSCWDGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - System VCO Lock Trap Disable"]
            #[inline]
            pub fn svcolckt(&self) -> SVCOLCKTR {
                SVCOLCKTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - USB VCO Lock Trap Disable"]
            #[inline]
            pub fn uvcolckt(&self) -> UVCOLCKTR {
                UVCOLCKTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Parity Error Trap Disable"]
            #[inline]
            pub fn pet(&self) -> PETR {
                PETR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Brown Out Trap Disable"]
            #[inline]
            pub fn brwnt(&self) -> BRWNTR {
                BRWNTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Wake-up Trap Disable"]
            #[inline]
            pub fn ulpwdgt(&self) -> ULPWDGTR {
                ULPWDGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Peripheral Bridge 0 Trap Disable"]
            #[inline]
            pub fn bwerr0t(&self) -> BWERR0TR {
                BWERR0TR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Peripheral Bridge 1 Trap Disable"]
            #[inline]
            pub fn bwerr1t(&self) -> BWERR1TR {
                BWERR1TR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Die Temperature Too High Trap Disable"]
            #[inline]
            pub fn temphit(&self) -> TEMPHITR {
                TEMPHITR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Die Temperature Too Low Trap Disable"]
            #[inline]
            pub fn templot(&self) -> TEMPLOTR {
                TEMPLOTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x31ff }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - System OSC WDT Trap Disable"]
            #[inline]
            pub fn soscwdgt(&mut self) -> _SOSCWDGTW {
                _SOSCWDGTW { w: self }
            }
            #[doc = "Bit 2 - System VCO Lock Trap Disable"]
            #[inline]
            pub fn svcolckt(&mut self) -> _SVCOLCKTW {
                _SVCOLCKTW { w: self }
            }
            #[doc = "Bit 3 - USB VCO Lock Trap Disable"]
            #[inline]
            pub fn uvcolckt(&mut self) -> _UVCOLCKTW {
                _UVCOLCKTW { w: self }
            }
            #[doc = "Bit 4 - Parity Error Trap Disable"]
            #[inline]
            pub fn pet(&mut self) -> _PETW {
                _PETW { w: self }
            }
            #[doc = "Bit 5 - Brown Out Trap Disable"]
            #[inline]
            pub fn brwnt(&mut self) -> _BRWNTW {
                _BRWNTW { w: self }
            }
            #[doc = "Bit 6 - Wake-up Trap Disable"]
            #[inline]
            pub fn ulpwdgt(&mut self) -> _ULPWDGTW {
                _ULPWDGTW { w: self }
            }
            #[doc = "Bit 7 - Peripheral Bridge 0 Trap Disable"]
            #[inline]
            pub fn bwerr0t(&mut self) -> _BWERR0TW {
                _BWERR0TW { w: self }
            }
            #[doc = "Bit 8 - Peripheral Bridge 1 Trap Disable"]
            #[inline]
            pub fn bwerr1t(&mut self) -> _BWERR1TW {
                _BWERR1TW { w: self }
            }
            #[doc = "Bit 12 - Die Temperature Too High Trap Disable"]
            #[inline]
            pub fn temphit(&mut self) -> _TEMPHITW {
                _TEMPHITW { w: self }
            }
            #[doc = "Bit 13 - Die Temperature Too Low Trap Disable"]
            #[inline]
            pub fn templot(&mut self) -> _TEMPLOTW {
                _TEMPLOTW { w: self }
            }
        }
    }
    #[doc = "Trap Clear Register"]
    pub struct TRAPCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Trap Clear Register"]
    pub mod trapclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TRAPCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `SOSCWDGT`"]
        pub enum SOSCWDGTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl SOSCWDGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SOSCWDGTW::VALUE1 => false,
                    SOSCWDGTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOSCWDGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOSCWDGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SOSCWDGTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SOSCWDGTW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SOSCWDGTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SVCOLCKT`"]
        pub enum SVCOLCKTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl SVCOLCKTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SVCOLCKTW::VALUE1 => false,
                    SVCOLCKTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVCOLCKTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVCOLCKTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SVCOLCKTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SVCOLCKTW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SVCOLCKTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UVCOLCKT`"]
        pub enum UVCOLCKTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl UVCOLCKTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UVCOLCKTW::VALUE1 => false,
                    UVCOLCKTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UVCOLCKTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UVCOLCKTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UVCOLCKTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UVCOLCKTW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UVCOLCKTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PET`"]
        pub enum PETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl PETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETW::VALUE1 => false,
                    PETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRWNT`"]
        pub enum BRWNTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl BRWNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRWNTW::VALUE1 => false,
                    BRWNTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRWNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRWNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRWNTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRWNTW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRWNTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ULPWDGT`"]
        pub enum ULPWDGTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl ULPWDGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ULPWDGTW::VALUE1 => false,
                    ULPWDGTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ULPWDGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ULPWDGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ULPWDGTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ULPWDGTW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ULPWDGTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWERR0T`"]
        pub enum BWERR0TW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl BWERR0TW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWERR0TW::VALUE1 => false,
                    BWERR0TW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWERR0TW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWERR0TW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWERR0TW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWERR0TW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWERR0TW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWERR1T`"]
        pub enum BWERR1TW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl BWERR1TW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWERR1TW::VALUE1 => false,
                    BWERR1TW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWERR1TW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWERR1TW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWERR1TW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWERR1TW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWERR1TW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TEMPHIT`"]
        pub enum TEMPHITW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl TEMPHITW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TEMPHITW::VALUE1 => false,
                    TEMPHITW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEMPHITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEMPHITW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TEMPHITW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TEMPHITW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TEMPHITW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TEMPLOT`"]
        pub enum TEMPLOTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear trap request"]
            VALUE2,
        }
        impl TEMPLOTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TEMPLOTW::VALUE1 => false,
                    TEMPLOTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEMPLOTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEMPLOTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TEMPLOTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TEMPLOTW::VALUE1)
            }
            #[doc = "Clear trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TEMPLOTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - System OSC WDT Trap Clear"]
            #[inline]
            pub fn soscwdgt(&mut self) -> _SOSCWDGTW {
                _SOSCWDGTW { w: self }
            }
            #[doc = "Bit 2 - System VCO Lock Trap Clear"]
            #[inline]
            pub fn svcolckt(&mut self) -> _SVCOLCKTW {
                _SVCOLCKTW { w: self }
            }
            #[doc = "Bit 3 - USB VCO Lock Trap Clear"]
            #[inline]
            pub fn uvcolckt(&mut self) -> _UVCOLCKTW {
                _UVCOLCKTW { w: self }
            }
            #[doc = "Bit 4 - Parity Error Trap Clear"]
            #[inline]
            pub fn pet(&mut self) -> _PETW {
                _PETW { w: self }
            }
            #[doc = "Bit 5 - Brown Out Trap Clear"]
            #[inline]
            pub fn brwnt(&mut self) -> _BRWNTW {
                _BRWNTW { w: self }
            }
            #[doc = "Bit 6 - OSC_ULP WDG Trap Clear"]
            #[inline]
            pub fn ulpwdgt(&mut self) -> _ULPWDGTW {
                _ULPWDGTW { w: self }
            }
            #[doc = "Bit 7 - Peripheral Bridge 0 Trap Clear"]
            #[inline]
            pub fn bwerr0t(&mut self) -> _BWERR0TW {
                _BWERR0TW { w: self }
            }
            #[doc = "Bit 8 - Peripheral Bridge 1 Trap Clear"]
            #[inline]
            pub fn bwerr1t(&mut self) -> _BWERR1TW {
                _BWERR1TW { w: self }
            }
            #[doc = "Bit 12 - Die Temperature Too High Trap Clear"]
            #[inline]
            pub fn temphit(&mut self) -> _TEMPHITW {
                _TEMPHITW { w: self }
            }
            #[doc = "Bit 13 - Die Temperature Too Low Trap Clear"]
            #[inline]
            pub fn templot(&mut self) -> _TEMPLOTW {
                _TEMPLOTW { w: self }
            }
        }
    }
    #[doc = "Trap Set Register"]
    pub struct TRAPSET {
        register: VolatileCell<u32>,
    }
    #[doc = "Trap Set Register"]
    pub mod trapset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TRAPSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `SOSCWDGT`"]
        pub enum SOSCWDGTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl SOSCWDGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SOSCWDGTW::VALUE1 => false,
                    SOSCWDGTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOSCWDGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOSCWDGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SOSCWDGTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SOSCWDGTW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SOSCWDGTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SVCOLCKT`"]
        pub enum SVCOLCKTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl SVCOLCKTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SVCOLCKTW::VALUE1 => false,
                    SVCOLCKTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVCOLCKTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVCOLCKTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SVCOLCKTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SVCOLCKTW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SVCOLCKTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UVCOLCKT`"]
        pub enum UVCOLCKTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl UVCOLCKTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    UVCOLCKTW::VALUE1 => false,
                    UVCOLCKTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UVCOLCKTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UVCOLCKTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UVCOLCKTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UVCOLCKTW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UVCOLCKTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PET`"]
        pub enum PETW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl PETW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PETW::VALUE1 => false,
                    PETW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PETW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PETW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PETW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PETW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRWNT`"]
        pub enum BRWNTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl BRWNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRWNTW::VALUE1 => false,
                    BRWNTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRWNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRWNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRWNTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRWNTW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRWNTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ULPWDT`"]
        pub enum ULPWDTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl ULPWDTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ULPWDTW::VALUE1 => false,
                    ULPWDTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ULPWDTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ULPWDTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ULPWDTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ULPWDTW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ULPWDTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWERR0T`"]
        pub enum BWERR0TW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl BWERR0TW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWERR0TW::VALUE1 => false,
                    BWERR0TW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWERR0TW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWERR0TW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWERR0TW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWERR0TW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWERR0TW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWERR1T`"]
        pub enum BWERR1TW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl BWERR1TW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWERR1TW::VALUE1 => false,
                    BWERR1TW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWERR1TW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWERR1TW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWERR1TW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWERR1TW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWERR1TW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TEMPHIT`"]
        pub enum TEMPHITW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl TEMPHITW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TEMPHITW::VALUE1 => false,
                    TEMPHITW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEMPHITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEMPHITW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TEMPHITW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TEMPHITW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TEMPHITW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TEMPLOT`"]
        pub enum TEMPLOTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set trap request"]
            VALUE2,
        }
        impl TEMPLOTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TEMPLOTW::VALUE1 => false,
                    TEMPLOTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TEMPLOTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEMPLOTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TEMPLOTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TEMPLOTW::VALUE1)
            }
            #[doc = "Set trap request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TEMPLOTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - System OSC WDT Trap Set"]
            #[inline]
            pub fn soscwdgt(&mut self) -> _SOSCWDGTW {
                _SOSCWDGTW { w: self }
            }
            #[doc = "Bit 2 - System VCO Lock Trap Set"]
            #[inline]
            pub fn svcolckt(&mut self) -> _SVCOLCKTW {
                _SVCOLCKTW { w: self }
            }
            #[doc = "Bit 3 - USB VCO Lock Trap Set"]
            #[inline]
            pub fn uvcolckt(&mut self) -> _UVCOLCKTW {
                _UVCOLCKTW { w: self }
            }
            #[doc = "Bit 4 - Parity Error Trap Set"]
            #[inline]
            pub fn pet(&mut self) -> _PETW {
                _PETW { w: self }
            }
            #[doc = "Bit 5 - Brown Out Trap Set"]
            #[inline]
            pub fn brwnt(&mut self) -> _BRWNTW {
                _BRWNTW { w: self }
            }
            #[doc = "Bit 6 - OSC_ULP WDG Trap Set"]
            #[inline]
            pub fn ulpwdt(&mut self) -> _ULPWDTW {
                _ULPWDTW { w: self }
            }
            #[doc = "Bit 7 - Peripheral Bridge 0 Trap Set"]
            #[inline]
            pub fn bwerr0t(&mut self) -> _BWERR0TW {
                _BWERR0TW { w: self }
            }
            #[doc = "Bit 8 - Peripheral Bridge 1 Trap Set"]
            #[inline]
            pub fn bwerr1t(&mut self) -> _BWERR1TW {
                _BWERR1TW { w: self }
            }
            #[doc = "Bit 12 - Die Temperature Too High Trap Set"]
            #[inline]
            pub fn temphit(&mut self) -> _TEMPHITW {
                _TEMPHITW { w: self }
            }
            #[doc = "Bit 13 - Die Temperature Too Low Trap Set"]
            #[inline]
            pub fn templot(&mut self) -> _TEMPLOTW {
                _TEMPLOTW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_TRAP {
    register_block: scu_trap::RegisterBlock,
}
impl Deref for SCU_TRAP {
    type Target = scu_trap::RegisterBlock;
    fn deref(&self) -> &scu_trap::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_HIBERNATE: Peripheral<SCU_HIBERNATE> = unsafe { Peripheral::new(0x5000_4300) };
#[doc = "System Control Unit"]
pub mod scu_hibernate {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Hibernate Domain Status Register"]
        pub hdstat: HDSTAT,
        #[doc = "0x04 - Hibernate Domain Status Clear Register"]
        pub hdclr: HDCLR,
        #[doc = "0x08 - Hibernate Domain Status Set Register"]
        pub hdset: HDSET,
        #[doc = "0x0c - Hibernate Domain Control Register"]
        pub hdcr: HDCR,
        _reserved0: [u8; 4usize],
        #[doc = "0x14 - fOSI Control Register"]
        pub oscsictrl: OSCSICTRL,
        #[doc = "0x18 - OSC_ULP Status Register"]
        pub osculstat: OSCULSTAT,
        #[doc = "0x1c - OSC_ULP Control Register"]
        pub osculctrl: OSCULCTRL,
        #[doc = "0x20 - Analog Wake-up Configuration Register"]
        pub lpacconf: LPACCONF,
        #[doc = "0x24 - LPAC Threshold Register 0"]
        pub lpacth0: LPACTH0,
        #[doc = "0x28 - LPAC Threshold Register 1"]
        pub lpacth1: LPACTH1,
        #[doc = "0x2c - Hibernate Analog Control State Register"]
        pub lpacst: LPACST,
        #[doc = "0x30 - LPAC Control Clear Register"]
        pub lpacclr: LPACCLR,
        #[doc = "0x34 - LPAC Control Set Register"]
        pub lpacset: LPACSET,
        #[doc = "0x38 - Hibernate Internal Control State Register"]
        pub hintst: HINTST,
        #[doc = "0x3c - Hibernate Internal Control Clear Register"]
        pub hintclr: HINTCLR,
        #[doc = "0x40 - Hibernate Internal Control Set Register"]
        pub hintset: HINTSET,
    }
    #[doc = "Hibernate Domain Status Register"]
    pub struct HDSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Domain Status Register"]
    pub mod hdstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::HDSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `EPEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPEVR {
            #[doc = "Wake-up on positive edge pin event inactive"]
            VALUE1,
            #[doc = "Wake-up on positive edge pin event active"]
            VALUE2,
        }
        impl EPEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EPEVR::VALUE1 => false,
                    EPEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EPEVR {
                match value {
                    false => EPEVR::VALUE1,
                    true => EPEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENEVR {
            #[doc = "Wake-up on negative edge pin event inactive"]
            VALUE1,
            #[doc = "Wake-up on negative edge pin event active"]
            VALUE2,
        }
        impl ENEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENEVR::VALUE1 => false,
                    ENEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENEVR {
                match value {
                    false => ENEVR::VALUE1,
                    true => ENEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTCEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTCEVR {
            #[doc = "Wake-up on RTC event inactive"]
            VALUE1,
            #[doc = "Wake-up on RTC event active"]
            VALUE2,
        }
        impl RTCEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTCEVR::VALUE1 => false,
                    RTCEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTCEVR {
                match value {
                    false => RTCEVR::VALUE1,
                    true => RTCEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTCEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTCEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ULPWDG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ULPWDGR {
            #[doc = "Watchdog alarm did not occur"]
            VALUE1,
            #[doc = "Watchdog alarm occurred"]
            VALUE2,
        }
        impl ULPWDGR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ULPWDGR::VALUE1 => false,
                    ULPWDGR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ULPWDGR {
                match value {
                    false => ULPWDGR::VALUE1,
                    true => ULPWDGR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ULPWDGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ULPWDGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIBNOUT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBNOUTR {
            #[doc = "Hibernate not driven active to pads"]
            VALUE1,
            #[doc = "Hibernate driven active to pads"]
            VALUE2,
        }
        impl HIBNOUTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBNOUTR::VALUE1 => false,
                    HIBNOUTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBNOUTR {
                match value {
                    false => HIBNOUTR::VALUE1,
                    true => HIBNOUTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBNOUTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBNOUTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VBATPEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VBATPEVR {
            #[doc = "Wake-up on rising above threshold event inactive"]
            VALUE1,
            #[doc = "Wake-up on rising above threshold event active"]
            VALUE2,
        }
        impl VBATPEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VBATPEVR::VALUE1 => false,
                    VBATPEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VBATPEVR {
                match value {
                    false => VBATPEVR::VALUE1,
                    true => VBATPEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VBATPEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VBATPEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VBATNEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VBATNEVR {
            #[doc = "Wake-up on falling below threshold event inactive"]
            VALUE1,
            #[doc = "Wake-up on falling below threshold event active"]
            VALUE2,
        }
        impl VBATNEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VBATNEVR::VALUE1 => false,
                    VBATNEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VBATNEVR {
                match value {
                    false => VBATNEVR::VALUE1,
                    true => VBATNEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VBATNEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VBATNEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHIBIO0PEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHIBIO0PEVR {
            #[doc = "Wake-up on rising above threshold event inactive"]
            VALUE1,
            #[doc = "Wake-up on rising above threshold event active"]
            VALUE2,
        }
        impl AHIBIO0PEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHIBIO0PEVR::VALUE1 => false,
                    AHIBIO0PEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHIBIO0PEVR {
                match value {
                    false => AHIBIO0PEVR::VALUE1,
                    true => AHIBIO0PEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHIBIO0PEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHIBIO0PEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHIBIO0NEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHIBIO0NEVR {
            #[doc = "Wake-up on falling below threshold event inactive"]
            VALUE1,
            #[doc = "Wake-up on falling below threshold event active"]
            VALUE2,
        }
        impl AHIBIO0NEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHIBIO0NEVR::VALUE1 => false,
                    AHIBIO0NEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHIBIO0NEVR {
                match value {
                    false => AHIBIO0NEVR::VALUE1,
                    true => AHIBIO0NEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHIBIO0NEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHIBIO0NEVR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Wake-up Pin Event Positive Edge"]
            #[inline]
            pub fn epev(&self) -> EPEVR {
                EPEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Wake-up Pin Event Negative Edge"]
            #[inline]
            pub fn enev(&self) -> ENEVR {
                ENEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - RTC Event"]
            #[inline]
            pub fn rtcev(&self) -> RTCEVR {
                RTCEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - ULP WDG Alarm Status"]
            #[inline]
            pub fn ulpwdg(&self) -> ULPWDGR {
                ULPWDGR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Hibernate Control Status"]
            #[inline]
            pub fn hibnout(&self) -> HIBNOUTR {
                HIBNOUTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Wake-Up on LPAC Positive Edge of VBAT Threshold Crossing"]
            #[inline]
            pub fn vbatpev(&self) -> VBATPEVR {
                VBATPEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Wake-Up on LPAC Negative Edge of VBAT Threshold Crossing"]
            #[inline]
            pub fn vbatnev(&self) -> VBATNEVR {
                VBATNEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Wake-Up on LPAC Positive Edge of HIB_IO_0 Threshold Crossing"]
            #[inline]
            pub fn ahibio0pev(&self) -> AHIBIO0PEVR {
                AHIBIO0PEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Wake-Up on LPAC Negative Edge of HIB_IO_0 Threshold Crossing"]
            #[inline]
            pub fn ahibio0nev(&self) -> AHIBIO0NEVR {
                AHIBIO0NEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Hibernate Domain Status Clear Register"]
    pub struct HDCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Domain Status Clear Register"]
    pub mod hdclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HDCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `EPEV`"]
        pub enum EPEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl EPEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EPEVW::VALUE1 => false,
                    EPEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENEV`"]
        pub enum ENEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl ENEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENEVW::VALUE1 => false,
                    ENEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTCEV`"]
        pub enum RTCEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl RTCEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTCEVW::VALUE1 => false,
                    RTCEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTCEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTCEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTCEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTCEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTCEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ULPWDG`"]
        pub enum ULPWDGW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear watchdog alarm"]
            VALUE2,
        }
        impl ULPWDGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ULPWDGW::VALUE1 => false,
                    ULPWDGW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ULPWDGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ULPWDGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ULPWDGW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ULPWDGW::VALUE1)
            }
            #[doc = "Clear watchdog alarm"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ULPWDGW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATPEV`"]
        pub enum VBATPEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl VBATPEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATPEVW::VALUE1 => false,
                    VBATPEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATPEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATPEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATPEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATPEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATPEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATNEV`"]
        pub enum VBATNEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl VBATNEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATNEVW::VALUE1 => false,
                    VBATNEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATNEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATNEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATNEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATNEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATNEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0PEV`"]
        pub enum AHIBIO0PEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl AHIBIO0PEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0PEVW::VALUE1 => false,
                    AHIBIO0PEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0PEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0PEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0PEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0PEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0PEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0NEV`"]
        pub enum AHIBIO0NEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear wake-up event"]
            VALUE2,
        }
        impl AHIBIO0NEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0NEVW::VALUE1 => false,
                    AHIBIO0NEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0NEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0NEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0NEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0NEVW::VALUE1)
            }
            #[doc = "Clear wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0NEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Wake-up Pin Event Positive Edge Clear"]
            #[inline]
            pub fn epev(&mut self) -> _EPEVW {
                _EPEVW { w: self }
            }
            #[doc = "Bit 1 - Wake-up Pin Event Negative Edge Clear"]
            #[inline]
            pub fn enev(&mut self) -> _ENEVW {
                _ENEVW { w: self }
            }
            #[doc = "Bit 2 - RTC Event Clear"]
            #[inline]
            pub fn rtcev(&mut self) -> _RTCEVW {
                _RTCEVW { w: self }
            }
            #[doc = "Bit 3 - ULP WDG Alarm Clear"]
            #[inline]
            pub fn ulpwdg(&mut self) -> _ULPWDGW {
                _ULPWDGW { w: self }
            }
            #[doc = "Bit 8 - Wake-Up on LPAC Positive Edge of VBAT Threshold Crossing Clear"]
            #[inline]
            pub fn vbatpev(&mut self) -> _VBATPEVW {
                _VBATPEVW { w: self }
            }
            #[doc = "Bit 9 - Wake-Up on LPAC Negative Edge of VBAT Threshold Crossing Clear"]
            #[inline]
            pub fn vbatnev(&mut self) -> _VBATNEVW {
                _VBATNEVW { w: self }
            }
            #[doc = "Bit 10 - Wake-Up on LPAC Positive Edge of HIB_IO_0 Threshold Crossing Clear"]
            #[inline]
            pub fn ahibio0pev(&mut self) -> _AHIBIO0PEVW {
                _AHIBIO0PEVW { w: self }
            }
            #[doc = "Bit 11 - Wake-Up on LPAC Negative Edge of HIB_IO_0 Threshold Crossing Clear"]
            #[inline]
            pub fn ahibio0nev(&mut self) -> _AHIBIO0NEVW {
                _AHIBIO0NEVW { w: self }
            }
        }
    }
    #[doc = "Hibernate Domain Status Set Register"]
    pub struct HDSET {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Domain Status Set Register"]
    pub mod hdset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HDSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `EPEV`"]
        pub enum EPEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl EPEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EPEVW::VALUE1 => false,
                    EPEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENEV`"]
        pub enum ENEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl ENEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENEVW::VALUE1 => false,
                    ENEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTCEV`"]
        pub enum RTCEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl RTCEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTCEVW::VALUE1 => false,
                    RTCEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTCEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTCEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTCEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTCEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTCEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ULPWDG`"]
        pub enum ULPWDGW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set watchdog alarm"]
            VALUE2,
        }
        impl ULPWDGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ULPWDGW::VALUE1 => false,
                    ULPWDGW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ULPWDGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ULPWDGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ULPWDGW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ULPWDGW::VALUE1)
            }
            #[doc = "Set watchdog alarm"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ULPWDGW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATPEV`"]
        pub enum VBATPEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl VBATPEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATPEVW::VALUE1 => false,
                    VBATPEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATPEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATPEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATPEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATPEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATPEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATNEV`"]
        pub enum VBATNEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl VBATNEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATNEVW::VALUE1 => false,
                    VBATNEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATNEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATNEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATNEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATNEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATNEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0PEV`"]
        pub enum AHIBIO0PEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl AHIBIO0PEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0PEVW::VALUE1 => false,
                    AHIBIO0PEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0PEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0PEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0PEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0PEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0PEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0NEV`"]
        pub enum AHIBIO0NEVW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Set wake-up event"]
            VALUE2,
        }
        impl AHIBIO0NEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0NEVW::VALUE1 => false,
                    AHIBIO0NEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0NEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0NEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0NEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0NEVW::VALUE1)
            }
            #[doc = "Set wake-up event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0NEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Wake-up Pin Event Positive Edge Set"]
            #[inline]
            pub fn epev(&mut self) -> _EPEVW {
                _EPEVW { w: self }
            }
            #[doc = "Bit 1 - Wake-up Pin Event Negative Edge Set"]
            #[inline]
            pub fn enev(&mut self) -> _ENEVW {
                _ENEVW { w: self }
            }
            #[doc = "Bit 2 - RTC Event Set"]
            #[inline]
            pub fn rtcev(&mut self) -> _RTCEVW {
                _RTCEVW { w: self }
            }
            #[doc = "Bit 3 - ULP WDG Alarm Set"]
            #[inline]
            pub fn ulpwdg(&mut self) -> _ULPWDGW {
                _ULPWDGW { w: self }
            }
            #[doc = "Bit 8 - Wake-Up on LPAC Positive Edge of VBAT Threshold Crossing Set"]
            #[inline]
            pub fn vbatpev(&mut self) -> _VBATPEVW {
                _VBATPEVW { w: self }
            }
            #[doc = "Bit 9 - Wake-Up on LPAC Negative Edge of VBAT Threshold Crossing Set"]
            #[inline]
            pub fn vbatnev(&mut self) -> _VBATNEVW {
                _VBATNEVW { w: self }
            }
            #[doc = "Bit 10 - Wake-Up on LPAC Positive Edge of HIB_IO_0 Threshold Crossing Set"]
            #[inline]
            pub fn ahibio0pev(&mut self) -> _AHIBIO0PEVW {
                _AHIBIO0PEVW { w: self }
            }
            #[doc = "Bit 11 - Wake-Up on LPAC Negative Edge of HIB_IO_0 Threshold Crossing Set"]
            #[inline]
            pub fn ahibio0nev(&mut self) -> _AHIBIO0NEVW {
                _AHIBIO0NEVW { w: self }
            }
        }
    }
    #[doc = "Hibernate Domain Control Register"]
    pub struct HDCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Domain Control Register"]
    pub mod hdcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HDCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `WKPEP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WKPEPR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl WKPEPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WKPEPR::VALUE1 => false,
                    WKPEPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WKPEPR {
                match value {
                    false => WKPEPR::VALUE1,
                    true => WKPEPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WKPEPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WKPEPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WKPEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WKPENR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl WKPENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WKPENR::VALUE1 => false,
                    WKPENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WKPENR {
                match value {
                    false => WKPENR::VALUE1,
                    true => WKPENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WKPENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WKPENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTCER {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl RTCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTCER::VALUE1 => false,
                    RTCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTCER {
                match value {
                    false => RTCER::VALUE1,
                    true => RTCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTCER::VALUE2
            }
        }
        #[doc = "Possible values of the field `ULPWDGEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ULPWDGENR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl ULPWDGENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ULPWDGENR::VALUE1 => false,
                    ULPWDGENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ULPWDGENR {
                match value {
                    false => ULPWDGENR::VALUE1,
                    true => ULPWDGENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ULPWDGENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ULPWDGENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBR {
            #[doc = "External hibernate request inactive"]
            VALUE1,
            #[doc = "External hibernate request active"]
            VALUE2,
        }
        impl HIBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBR::VALUE1 => false,
                    HIBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBR {
                match value {
                    false => HIBR::VALUE1,
                    true => HIBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `XTALGPI1SEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XTALGPI1SELR {
            #[doc = "RTC_XTAL_1 input selected"]
            VALUE1,
            #[doc = "Analog comparator output for HIB_IO_1 or pre-selected digital IO input"]
            VALUE2,
        }
        impl XTALGPI1SELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    XTALGPI1SELR::VALUE1 => false,
                    XTALGPI1SELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> XTALGPI1SELR {
                match value {
                    false => XTALGPI1SELR::VALUE1,
                    true => XTALGPI1SELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XTALGPI1SELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XTALGPI1SELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RCS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RCSR {
            #[doc = "fOSI selected"]
            VALUE1,
            #[doc = "fULP selected"]
            VALUE2,
        }
        impl RCSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RCSR::VALUE1 => false,
                    RCSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RCSR {
                match value {
                    false => RCSR::VALUE1,
                    true => RCSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RCSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RCSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STDBYSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STDBYSELR {
            #[doc = "fOSI selected"]
            VALUE1,
            #[doc = "fULP selected"]
            VALUE2,
        }
        impl STDBYSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STDBYSELR::VALUE1 => false,
                    STDBYSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STDBYSELR {
                match value {
                    false => STDBYSELR::VALUE1,
                    true => STDBYSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STDBYSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STDBYSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WKUPSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WKUPSELR {
            #[doc = "HIB_IO_1 pin selected"]
            VALUE1,
            #[doc = "HIB_IO_0 pin selected"]
            VALUE2,
        }
        impl WKUPSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WKUPSELR::VALUE1 => false,
                    WKUPSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WKUPSELR {
                match value {
                    false => WKUPSELR::VALUE1,
                    true => WKUPSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WKUPSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WKUPSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `GPI0SEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GPI0SELR {
            #[doc = "HIB_IO_0 pin selected"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(bool),
        }
        impl GPI0SELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GPI0SELR::VALUE2 => true,
                    GPI0SELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GPI0SELR {
                match value {
                    true => GPI0SELR::VALUE2,
                    i => GPI0SELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GPI0SELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIBIO0POL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBIO0POLR {
            #[doc = "Direct value"]
            VALUE1,
            #[doc = "Inverted value"]
            VALUE2,
        }
        impl HIBIO0POLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBIO0POLR::VALUE1 => false,
                    HIBIO0POLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBIO0POLR {
                match value {
                    false => HIBIO0POLR::VALUE1,
                    true => HIBIO0POLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBIO0POLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBIO0POLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ADIG0SEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ADIG0SELR {
            #[doc = "Digital input"]
            VALUE1,
            #[doc = "Analog comparator result for HIB_IO_0"]
            VALUE2,
        }
        impl ADIG0SELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ADIG0SELR::VALUE1 => false,
                    ADIG0SELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ADIG0SELR {
                match value {
                    false => ADIG0SELR::VALUE1,
                    true => ADIG0SELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ADIG0SELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ADIG0SELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIBIO0SEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBIO0SELR {
            #[doc = "Direct input, No input pull device connected"]
            VALUE1,
            #[doc = "Direct input, Input pull-down device connected"]
            VALUE2,
            #[doc = "Direct input, Input pull-up device connected"]
            VALUE3,
            #[doc = "Push-pull HIB Control output"]
            VALUE4,
            #[doc = "Push-pull WDT service output"]
            VALUE5,
            #[doc = "Push-pull GPIO output"]
            VALUE6,
            #[doc = "Open-drain HIB Control output"]
            VALUE7,
            #[doc = "Open-drain WDT service output"]
            VALUE8,
            #[doc = "Open-drain GPIO output"]
            VALUE9,
            #[doc = "Analog input"]
            VALUE10,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HIBIO0SELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HIBIO0SELR::VALUE1 => 0,
                    HIBIO0SELR::VALUE2 => 0x01,
                    HIBIO0SELR::VALUE3 => 0x02,
                    HIBIO0SELR::VALUE4 => 0x08,
                    HIBIO0SELR::VALUE5 => 0x09,
                    HIBIO0SELR::VALUE6 => 0x0a,
                    HIBIO0SELR::VALUE7 => 0x0c,
                    HIBIO0SELR::VALUE8 => 0x0d,
                    HIBIO0SELR::VALUE9 => 0x0e,
                    HIBIO0SELR::VALUE10 => 0x0f,
                    HIBIO0SELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HIBIO0SELR {
                match value {
                    0 => HIBIO0SELR::VALUE1,
                    1 => HIBIO0SELR::VALUE2,
                    2 => HIBIO0SELR::VALUE3,
                    8 => HIBIO0SELR::VALUE4,
                    9 => HIBIO0SELR::VALUE5,
                    10 => HIBIO0SELR::VALUE6,
                    12 => HIBIO0SELR::VALUE7,
                    13 => HIBIO0SELR::VALUE8,
                    14 => HIBIO0SELR::VALUE9,
                    15 => HIBIO0SELR::VALUE10,
                    i => HIBIO0SELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBIO0SELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBIO0SELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HIBIO0SELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == HIBIO0SELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == HIBIO0SELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == HIBIO0SELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == HIBIO0SELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == HIBIO0SELR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == HIBIO0SELR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == HIBIO0SELR::VALUE10
            }
        }
        #[doc = "Possible values of the field `VBATLO`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VBATLOR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl VBATLOR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VBATLOR::VALUE1 => false,
                    VBATLOR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VBATLOR {
                match value {
                    false => VBATLOR::VALUE1,
                    true => VBATLOR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VBATLOR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VBATLOR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VBATHI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VBATHIR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl VBATHIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VBATHIR::VALUE1 => false,
                    VBATHIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VBATHIR {
                match value {
                    false => VBATHIR::VALUE1,
                    true => VBATHIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VBATHIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VBATHIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHIBIO0LO`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHIBIO0LOR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl AHIBIO0LOR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHIBIO0LOR::VALUE1 => false,
                    AHIBIO0LOR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHIBIO0LOR {
                match value {
                    false => AHIBIO0LOR::VALUE1,
                    true => AHIBIO0LOR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHIBIO0LOR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHIBIO0LOR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHIBIO0HI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHIBIO0HIR {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl AHIBIO0HIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHIBIO0HIR::VALUE1 => false,
                    AHIBIO0HIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHIBIO0HIR {
                match value {
                    false => AHIBIO0HIR::VALUE1,
                    true => AHIBIO0HIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHIBIO0HIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHIBIO0HIR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WKPEP`"]
        pub enum WKPEPW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl WKPEPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WKPEPW::VALUE1 => false,
                    WKPEPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WKPEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WKPEPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WKPEPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WKPEPW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WKPEPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WKPEN`"]
        pub enum WKPENW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl WKPENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WKPENW::VALUE1 => false,
                    WKPENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WKPENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WKPENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WKPENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WKPENW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WKPENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RTCE`"]
        pub enum RTCEW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl RTCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RTCEW::VALUE1 => false,
                    RTCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RTCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RTCEW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RTCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ULPWDGEN`"]
        pub enum ULPWDGENW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl ULPWDGENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ULPWDGENW::VALUE1 => false,
                    ULPWDGENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ULPWDGENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ULPWDGENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ULPWDGENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ULPWDGENW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ULPWDGENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIB`"]
        pub enum HIBW {
            #[doc = "External hibernate request inactive"]
            VALUE1,
            #[doc = "External hibernate request active"]
            VALUE2,
        }
        impl HIBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBW::VALUE1 => false,
                    HIBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External hibernate request inactive"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBW::VALUE1)
            }
            #[doc = "External hibernate request active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTALGPI1SEL`"]
        pub enum XTALGPI1SELW {
            #[doc = "RTC_XTAL_1 input selected"]
            VALUE1,
            #[doc = "Analog comparator output for HIB_IO_1 or pre-selected digital IO input"]
            VALUE2,
        }
        impl XTALGPI1SELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XTALGPI1SELW::VALUE1 => false,
                    XTALGPI1SELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTALGPI1SELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTALGPI1SELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTALGPI1SELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "RTC_XTAL_1 input selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTALGPI1SELW::VALUE1)
            }
            #[doc = "Analog comparator output for HIB_IO_1 or pre-selected digital IO input"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTALGPI1SELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RCS`"]
        pub enum RCSW {
            #[doc = "fOSI selected"]
            VALUE1,
            #[doc = "fULP selected"]
            VALUE2,
        }
        impl RCSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RCSW::VALUE1 => false,
                    RCSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RCSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fOSI selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RCSW::VALUE1)
            }
            #[doc = "fULP selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RCSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STDBYSEL`"]
        pub enum STDBYSELW {
            #[doc = "fOSI selected"]
            VALUE1,
            #[doc = "fULP selected"]
            VALUE2,
        }
        impl STDBYSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STDBYSELW::VALUE1 => false,
                    STDBYSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STDBYSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STDBYSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STDBYSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "fOSI selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STDBYSELW::VALUE1)
            }
            #[doc = "fULP selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STDBYSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WKUPSEL`"]
        pub enum WKUPSELW {
            #[doc = "HIB_IO_1 pin selected"]
            VALUE1,
            #[doc = "HIB_IO_0 pin selected"]
            VALUE2,
        }
        impl WKUPSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WKUPSELW::VALUE1 => false,
                    WKUPSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WKUPSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WKUPSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WKUPSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HIB_IO_1 pin selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WKUPSELW::VALUE1)
            }
            #[doc = "HIB_IO_0 pin selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WKUPSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GPI0SEL`"]
        pub enum GPI0SELW {
            #[doc = "HIB_IO_0 pin selected"]
            VALUE2,
        }
        impl GPI0SELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GPI0SELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GPI0SELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GPI0SELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GPI0SELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HIB_IO_0 pin selected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GPI0SELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIBIO0POL`"]
        pub enum HIBIO0POLW {
            #[doc = "Direct value"]
            VALUE1,
            #[doc = "Inverted value"]
            VALUE2,
        }
        impl HIBIO0POLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBIO0POLW::VALUE1 => false,
                    HIBIO0POLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBIO0POLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBIO0POLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBIO0POLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Direct value"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBIO0POLW::VALUE1)
            }
            #[doc = "Inverted value"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBIO0POLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ADIG0SEL`"]
        pub enum ADIG0SELW {
            #[doc = "Digital input"]
            VALUE1,
            #[doc = "Analog comparator result for HIB_IO_0"]
            VALUE2,
        }
        impl ADIG0SELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ADIG0SELW::VALUE1 => false,
                    ADIG0SELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ADIG0SELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ADIG0SELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ADIG0SELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital input"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ADIG0SELW::VALUE1)
            }
            #[doc = "Analog comparator result for HIB_IO_0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ADIG0SELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIBIO0SEL`"]
        pub enum HIBIO0SELW {
            #[doc = "Direct input, No input pull device connected"]
            VALUE1,
            #[doc = "Direct input, Input pull-down device connected"]
            VALUE2,
            #[doc = "Direct input, Input pull-up device connected"]
            VALUE3,
            #[doc = "Push-pull HIB Control output"]
            VALUE4,
            #[doc = "Push-pull WDT service output"]
            VALUE5,
            #[doc = "Push-pull GPIO output"]
            VALUE6,
            #[doc = "Open-drain HIB Control output"]
            VALUE7,
            #[doc = "Open-drain WDT service output"]
            VALUE8,
            #[doc = "Open-drain GPIO output"]
            VALUE9,
            #[doc = "Analog input"]
            VALUE10,
        }
        impl HIBIO0SELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HIBIO0SELW::VALUE1 => 0,
                    HIBIO0SELW::VALUE2 => 1,
                    HIBIO0SELW::VALUE3 => 2,
                    HIBIO0SELW::VALUE4 => 8,
                    HIBIO0SELW::VALUE5 => 9,
                    HIBIO0SELW::VALUE6 => 10,
                    HIBIO0SELW::VALUE7 => 12,
                    HIBIO0SELW::VALUE8 => 13,
                    HIBIO0SELW::VALUE9 => 14,
                    HIBIO0SELW::VALUE10 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBIO0SELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBIO0SELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBIO0SELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Direct input, No input pull device connected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE1)
            }
            #[doc = "Direct input, Input pull-down device connected"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE2)
            }
            #[doc = "Direct input, Input pull-up device connected"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE3)
            }
            #[doc = "Push-pull HIB Control output"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE4)
            }
            #[doc = "Push-pull WDT service output"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE5)
            }
            #[doc = "Push-pull GPIO output"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE6)
            }
            #[doc = "Open-drain HIB Control output"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE7)
            }
            #[doc = "Open-drain WDT service output"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE8)
            }
            #[doc = "Open-drain GPIO output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE9)
            }
            #[doc = "Analog input"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(HIBIO0SELW::VALUE10)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATLO`"]
        pub enum VBATLOW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl VBATLOW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATLOW::VALUE1 => false,
                    VBATLOW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATLOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATLOW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATLOW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATLOW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATLOW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATHI`"]
        pub enum VBATHIW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl VBATHIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATHIW::VALUE1 => false,
                    VBATHIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATHIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATHIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATHIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATHIW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATHIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0LO`"]
        pub enum AHIBIO0LOW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl AHIBIO0LOW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0LOW::VALUE1 => false,
                    AHIBIO0LOW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0LOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0LOW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0LOW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0LOW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0LOW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0HI`"]
        pub enum AHIBIO0HIW {
            #[doc = "Wake-up event disabled"]
            VALUE1,
            #[doc = "Wake-up event enabled"]
            VALUE2,
        }
        impl AHIBIO0HIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0HIW::VALUE1 => false,
                    AHIBIO0HIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0HIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0HIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0HIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wake-up event disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0HIW::VALUE1)
            }
            #[doc = "Wake-up event enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0HIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Wake-Up on Pin Event Positive Edge Enable"]
            #[inline]
            pub fn wkpep(&self) -> WKPEPR {
                WKPEPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Wake-up on Pin Event Negative Edge Enable"]
            #[inline]
            pub fn wkpen(&self) -> WKPENR {
                WKPENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Wake-up on RTC Event Enable"]
            #[inline]
            pub fn rtce(&self) -> RTCER {
                RTCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - ULP WDG Alarm Enable"]
            #[inline]
            pub fn ulpwdgen(&self) -> ULPWDGENR {
                ULPWDGENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Hibernate Request Value Set"]
            #[inline]
            pub fn hib(&self) -> HIBR {
                HIBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Multiplex Control for RTC_XTAL_1 Select as GPI Input"]
            #[inline]
            pub fn xtalgpi1sel(&self) -> XTALGPI1SELR {
                XTALGPI1SELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - fRTC Clock Selection"]
            #[inline]
            pub fn rcs(&self) -> RCSR {
                RCSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - fSTDBY Clock Selection"]
            #[inline]
            pub fn stdbysel(&self) -> STDBYSELR {
                STDBYSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Wake-Up from Hibernate Trigger Input Selection"]
            #[inline]
            pub fn wkupsel(&self) -> WKUPSELR {
                WKUPSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - General Purpose Input 0 Selection"]
            #[inline]
            pub fn gpi0sel(&self) -> GPI0SELR {
                GPI0SELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - HIBIO0 Polarity Set"]
            #[inline]
            pub fn hibio0pol(&self) -> HIBIO0POLR {
                HIBIO0POLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Select Analog Channel 0 or Digital Output Path"]
            #[inline]
            pub fn adig0sel(&self) -> ADIG0SELR {
                ADIG0SELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:19 - HIB_IO_0 Pin I/O Control (default HIBOUT)"]
            #[inline]
            pub fn hibio0sel(&self) -> HIBIO0SELR {
                HIBIO0SELR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 24 - Wake-Up on VBAT Falling Below Threshold Enable"]
            #[inline]
            pub fn vbatlo(&self) -> VBATLOR {
                VBATLOR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Wake-Up on VBAT Rising Above Threshold Enable"]
            #[inline]
            pub fn vbathi(&self) -> VBATHIR {
                VBATHIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Wake-Up on Analog HIB_IO_0 Falling Below Threshold Enable"]
            #[inline]
            pub fn ahibio0lo(&self) -> AHIBIO0LOR {
                AHIBIO0LOR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - Wake-Up on Analog HIB_IO_0 Rising Above Threshold Enable"]
            #[inline]
            pub fn ahibio0hi(&self) -> AHIBIO0HIR {
                AHIBIO0HIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x000c_2000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Wake-Up on Pin Event Positive Edge Enable"]
            #[inline]
            pub fn wkpep(&mut self) -> _WKPEPW {
                _WKPEPW { w: self }
            }
            #[doc = "Bit 1 - Wake-up on Pin Event Negative Edge Enable"]
            #[inline]
            pub fn wkpen(&mut self) -> _WKPENW {
                _WKPENW { w: self }
            }
            #[doc = "Bit 2 - Wake-up on RTC Event Enable"]
            #[inline]
            pub fn rtce(&mut self) -> _RTCEW {
                _RTCEW { w: self }
            }
            #[doc = "Bit 3 - ULP WDG Alarm Enable"]
            #[inline]
            pub fn ulpwdgen(&mut self) -> _ULPWDGENW {
                _ULPWDGENW { w: self }
            }
            #[doc = "Bit 4 - Hibernate Request Value Set"]
            #[inline]
            pub fn hib(&mut self) -> _HIBW {
                _HIBW { w: self }
            }
            #[doc = "Bit 5 - Multiplex Control for RTC_XTAL_1 Select as GPI Input"]
            #[inline]
            pub fn xtalgpi1sel(&mut self) -> _XTALGPI1SELW {
                _XTALGPI1SELW { w: self }
            }
            #[doc = "Bit 6 - fRTC Clock Selection"]
            #[inline]
            pub fn rcs(&mut self) -> _RCSW {
                _RCSW { w: self }
            }
            #[doc = "Bit 7 - fSTDBY Clock Selection"]
            #[inline]
            pub fn stdbysel(&mut self) -> _STDBYSELW {
                _STDBYSELW { w: self }
            }
            #[doc = "Bit 8 - Wake-Up from Hibernate Trigger Input Selection"]
            #[inline]
            pub fn wkupsel(&mut self) -> _WKUPSELW {
                _WKUPSELW { w: self }
            }
            #[doc = "Bit 10 - General Purpose Input 0 Selection"]
            #[inline]
            pub fn gpi0sel(&mut self) -> _GPI0SELW {
                _GPI0SELW { w: self }
            }
            #[doc = "Bit 12 - HIBIO0 Polarity Set"]
            #[inline]
            pub fn hibio0pol(&mut self) -> _HIBIO0POLW {
                _HIBIO0POLW { w: self }
            }
            #[doc = "Bit 14 - Select Analog Channel 0 or Digital Output Path"]
            #[inline]
            pub fn adig0sel(&mut self) -> _ADIG0SELW {
                _ADIG0SELW { w: self }
            }
            #[doc = "Bits 16:19 - HIB_IO_0 Pin I/O Control (default HIBOUT)"]
            #[inline]
            pub fn hibio0sel(&mut self) -> _HIBIO0SELW {
                _HIBIO0SELW { w: self }
            }
            #[doc = "Bit 24 - Wake-Up on VBAT Falling Below Threshold Enable"]
            #[inline]
            pub fn vbatlo(&mut self) -> _VBATLOW {
                _VBATLOW { w: self }
            }
            #[doc = "Bit 25 - Wake-Up on VBAT Rising Above Threshold Enable"]
            #[inline]
            pub fn vbathi(&mut self) -> _VBATHIW {
                _VBATHIW { w: self }
            }
            #[doc = "Bit 26 - Wake-Up on Analog HIB_IO_0 Falling Below Threshold Enable"]
            #[inline]
            pub fn ahibio0lo(&mut self) -> _AHIBIO0LOW {
                _AHIBIO0LOW { w: self }
            }
            #[doc = "Bit 27 - Wake-Up on Analog HIB_IO_0 Rising Above Threshold Enable"]
            #[inline]
            pub fn ahibio0hi(&mut self) -> _AHIBIO0HIW {
                _AHIBIO0HIW { w: self }
            }
        }
    }
    #[doc = "fOSI Control Register"]
    pub struct OSCSICTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "fOSI Control Register"]
    pub mod oscsictrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OSCSICTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PWD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PWDR {
            #[doc = "Enabled"]
            VALUE1,
            #[doc = "Disabled"]
            VALUE2,
        }
        impl PWDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PWDR::VALUE1 => false,
                    PWDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PWDR {
                match value {
                    false => PWDR::VALUE1,
                    true => PWDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PWDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PWDR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PWD`"]
        pub enum PWDW {
            #[doc = "Enabled"]
            VALUE1,
            #[doc = "Disabled"]
            VALUE2,
        }
        impl PWDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PWDW::VALUE1 => false,
                    PWDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PWDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PWDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PWDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PWDW::VALUE1)
            }
            #[doc = "Disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PWDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Turn OFF the fOSI Clock Source"]
            #[inline]
            pub fn pwd(&self) -> PWDR {
                PWDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x01 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Turn OFF the fOSI Clock Source"]
            #[inline]
            pub fn pwd(&mut self) -> _PWDW {
                _PWDW { w: self }
            }
        }
    }
    #[doc = "OSC_ULP Status Register"]
    pub struct OSCULSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "OSC_ULP Status Register"]
    pub mod osculstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::OSCULSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct X1DR {
            bits: bool,
        }
        impl X1DR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - XTAL1 Data Value"]
            #[inline]
            pub fn x1d(&self) -> X1DR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                X1DR { bits }
            }
        }
    }
    #[doc = "OSC_ULP Control Register"]
    pub struct OSCULCTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "OSC_ULP Control Register"]
    pub mod osculctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OSCULCTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `X1DEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum X1DENR {
            #[doc = "Data input inactivated, power down"]
            VALUE1,
            #[doc = "Data input active"]
            VALUE2,
        }
        impl X1DENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    X1DENR::VALUE1 => false,
                    X1DENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> X1DENR {
                match value {
                    false => X1DENR::VALUE1,
                    true => X1DENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == X1DENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == X1DENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MODER {
            #[doc = "Oscillator is enabled, in operation"]
            VALUE1,
            #[doc = "Oscillator is enabled, in bypass mode"]
            VALUE2,
            #[doc = "Oscillator in power down"]
            VALUE3,
            #[doc = "Oscillator in power down, can be used as GPI"]
            VALUE4,
        }
        impl MODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MODER::VALUE1 => 0,
                    MODER::VALUE2 => 0x01,
                    MODER::VALUE3 => 0x02,
                    MODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MODER {
                match value {
                    0 => MODER::VALUE1,
                    1 => MODER::VALUE2,
                    2 => MODER::VALUE3,
                    3 => MODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MODER::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `X1DEN`"]
        pub enum X1DENW {
            #[doc = "Data input inactivated, power down"]
            VALUE1,
            #[doc = "Data input active"]
            VALUE2,
        }
        impl X1DENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    X1DENW::VALUE1 => false,
                    X1DENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _X1DENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _X1DENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: X1DENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Data input inactivated, power down"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(X1DENW::VALUE1)
            }
            #[doc = "Data input active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(X1DENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MODE`"]
        pub enum MODEW {
            #[doc = "Oscillator is enabled, in operation"]
            VALUE1,
            #[doc = "Oscillator is enabled, in bypass mode"]
            VALUE2,
            #[doc = "Oscillator in power down"]
            VALUE3,
            #[doc = "Oscillator in power down, can be used as GPI"]
            VALUE4,
        }
        impl MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MODEW::VALUE1 => 0,
                    MODEW::VALUE2 => 1,
                    MODEW::VALUE3 => 2,
                    MODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Oscillator is enabled, in operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MODEW::VALUE1)
            }
            #[doc = "Oscillator is enabled, in bypass mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MODEW::VALUE2)
            }
            #[doc = "Oscillator in power down"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MODEW::VALUE3)
            }
            #[doc = "Oscillator in power down, can be used as GPI"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - XTAL1 Data General Purpose Input Enable"]
            #[inline]
            pub fn x1den(&self) -> X1DENR {
                X1DENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:5 - Oscillator Mode"]
            #[inline]
            pub fn mode(&self) -> MODER {
                MODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x20 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - XTAL1 Data General Purpose Input Enable"]
            #[inline]
            pub fn x1den(&mut self) -> _X1DENW {
                _X1DENW { w: self }
            }
            #[doc = "Bits 4:5 - Oscillator Mode"]
            #[inline]
            pub fn mode(&mut self) -> _MODEW {
                _MODEW { w: self }
            }
        }
    }
    #[doc = "Analog Wake-up Configuration Register"]
    pub struct LPACCONF {
        register: VolatileCell<u32>,
    }
    #[doc = "Analog Wake-up Configuration Register"]
    pub mod lpacconf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LPACCONF {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CMPEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMPENR {
            #[doc = "Comparator permanently in power down"]
            VALUE1,
            #[doc = "Comparator activated for VBAT input"]
            VALUE2,
            #[doc = "Comparator activated for HIB_IO_0 input"]
            VALUE3,
            #[doc = "Comparator activated for HIB_IO_1 input"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CMPENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMPENR::VALUE1 => 0,
                    CMPENR::VALUE2 => 0x01,
                    CMPENR::VALUE3 => 0x02,
                    CMPENR::VALUE4 => 0x04,
                    CMPENR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMPENR {
                match value {
                    0 => CMPENR::VALUE1,
                    1 => CMPENR::VALUE2,
                    2 => CMPENR::VALUE3,
                    4 => CMPENR::VALUE4,
                    i => CMPENR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMPENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMPENR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMPENR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMPENR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TRIGSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRIGSELR {
            #[doc = "Sub-second interval counter"]
            VALUE1,
            #[doc = "RTC alarm event"]
            VALUE2,
            #[doc = "RTC periodic event"]
            VALUE3,
            #[doc = "On digital WKUP input positive edge event"]
            VALUE4,
            #[doc = "On digital WKUP input negative edge event"]
            VALUE5,
            #[doc = "Continuous measurement"]
            VALUE6,
            #[doc = "Single-shot on software request"]
            VALUE7,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TRIGSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRIGSELR::VALUE1 => 0,
                    TRIGSELR::VALUE2 => 0x01,
                    TRIGSELR::VALUE3 => 0x02,
                    TRIGSELR::VALUE4 => 0x03,
                    TRIGSELR::VALUE5 => 0x05,
                    TRIGSELR::VALUE6 => 0x06,
                    TRIGSELR::VALUE7 => 0x07,
                    TRIGSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRIGSELR {
                match value {
                    0 => TRIGSELR::VALUE1,
                    1 => TRIGSELR::VALUE2,
                    2 => TRIGSELR::VALUE3,
                    3 => TRIGSELR::VALUE4,
                    5 => TRIGSELR::VALUE5,
                    6 => TRIGSELR::VALUE6,
                    7 => TRIGSELR::VALUE7,
                    i => TRIGSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRIGSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRIGSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRIGSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TRIGSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == TRIGSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == TRIGSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == TRIGSELR::VALUE7
            }
        }
        #[doc = r" Value of the field"]
        pub struct CONVDELR {
            bits: bool,
        }
        impl CONVDELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INTERVCNTR {
            bits: u16,
        }
        impl INTERVCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SETTLECNTR {
            bits: u8,
        }
        impl SETTLECNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `CMPEN`"]
        pub enum CMPENW {
            #[doc = "Comparator permanently in power down"]
            VALUE1,
            #[doc = "Comparator activated for VBAT input"]
            VALUE2,
            #[doc = "Comparator activated for HIB_IO_0 input"]
            VALUE3,
            #[doc = "Comparator activated for HIB_IO_1 input"]
            VALUE4,
        }
        impl CMPENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMPENW::VALUE1 => 0,
                    CMPENW::VALUE2 => 1,
                    CMPENW::VALUE3 => 2,
                    CMPENW::VALUE4 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMPENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMPENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMPENW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Comparator permanently in power down"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMPENW::VALUE1)
            }
            #[doc = "Comparator activated for VBAT input"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMPENW::VALUE2)
            }
            #[doc = "Comparator activated for HIB_IO_0 input"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMPENW::VALUE3)
            }
            #[doc = "Comparator activated for HIB_IO_1 input"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMPENW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRIGSEL`"]
        pub enum TRIGSELW {
            #[doc = "Sub-second interval counter"]
            VALUE1,
            #[doc = "RTC alarm event"]
            VALUE2,
            #[doc = "RTC periodic event"]
            VALUE3,
            #[doc = "On digital WKUP input positive edge event"]
            VALUE4,
            #[doc = "On digital WKUP input negative edge event"]
            VALUE5,
            #[doc = "Continuous measurement"]
            VALUE6,
            #[doc = "Single-shot on software request"]
            VALUE7,
        }
        impl TRIGSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRIGSELW::VALUE1 => 0,
                    TRIGSELW::VALUE2 => 1,
                    TRIGSELW::VALUE3 => 2,
                    TRIGSELW::VALUE4 => 3,
                    TRIGSELW::VALUE5 => 5,
                    TRIGSELW::VALUE6 => 6,
                    TRIGSELW::VALUE7 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIGSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIGSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRIGSELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Sub-second interval counter"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE1)
            }
            #[doc = "RTC alarm event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE2)
            }
            #[doc = "RTC periodic event"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE3)
            }
            #[doc = "On digital WKUP input positive edge event"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE4)
            }
            #[doc = "On digital WKUP input negative edge event"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE5)
            }
            #[doc = "Continuous measurement"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE6)
            }
            #[doc = "Single-shot on software request"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(TRIGSELW::VALUE7)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CONVDELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CONVDELW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INTERVCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INTERVCNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETTLECNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETTLECNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Compare Enable for Input Selection"]
            #[inline]
            pub fn cmpen(&self) -> CMPENR {
                CMPENR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:6 - Analog Compare Trigger Select"]
            #[inline]
            pub fn trigsel(&self) -> TRIGSELR {
                TRIGSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 12 - Conversion Delay"]
            #[inline]
            pub fn convdel(&self) -> CONVDELR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CONVDELR { bits }
            }
            #[doc = "Bits 16:27 - Sub-second Interval Counter"]
            #[inline]
            pub fn intervcnt(&self) -> INTERVCNTR {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INTERVCNTR { bits }
            }
            #[doc = "Bits 28:31 - LPAC Settle Time Counter"]
            #[inline]
            pub fn settlecnt(&self) -> SETTLECNTR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SETTLECNTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x7000_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Compare Enable for Input Selection"]
            #[inline]
            pub fn cmpen(&mut self) -> _CMPENW {
                _CMPENW { w: self }
            }
            #[doc = "Bits 4:6 - Analog Compare Trigger Select"]
            #[inline]
            pub fn trigsel(&mut self) -> _TRIGSELW {
                _TRIGSELW { w: self }
            }
            #[doc = "Bit 12 - Conversion Delay"]
            #[inline]
            pub fn convdel(&mut self) -> _CONVDELW {
                _CONVDELW { w: self }
            }
            #[doc = "Bits 16:27 - Sub-second Interval Counter"]
            #[inline]
            pub fn intervcnt(&mut self) -> _INTERVCNTW {
                _INTERVCNTW { w: self }
            }
            #[doc = "Bits 28:31 - LPAC Settle Time Counter"]
            #[inline]
            pub fn settlecnt(&mut self) -> _SETTLECNTW {
                _SETTLECNTW { w: self }
            }
        }
    }
    #[doc = "LPAC Threshold Register 0"]
    pub struct LPACTH0 {
        register: VolatileCell<u32>,
    }
    #[doc = "LPAC Threshold Register 0"]
    pub mod lpacth0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LPACTH0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct VBATLOR {
            bits: u8,
        }
        impl VBATLOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct VBATHIR {
            bits: u8,
        }
        impl VBATHIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATLOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATLOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATHIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATHIW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - VBAT Lower Threshold Value"]
            #[inline]
            pub fn vbatlo(&self) -> VBATLOR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                VBATLOR { bits }
            }
            #[doc = "Bits 8:13 - VBAT Upper Threshold Value"]
            #[inline]
            pub fn vbathi(&self) -> VBATHIR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                VBATHIR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - VBAT Lower Threshold Value"]
            #[inline]
            pub fn vbatlo(&mut self) -> _VBATLOW {
                _VBATLOW { w: self }
            }
            #[doc = "Bits 8:13 - VBAT Upper Threshold Value"]
            #[inline]
            pub fn vbathi(&mut self) -> _VBATHIW {
                _VBATHIW { w: self }
            }
        }
    }
    #[doc = "LPAC Threshold Register 1"]
    pub struct LPACTH1 {
        register: VolatileCell<u32>,
    }
    #[doc = "LPAC Threshold Register 1"]
    pub mod lpacth1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LPACTH1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHIBIO0LOR {
            bits: u8,
        }
        impl AHIBIO0LOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHIBIO0HIR {
            bits: u8,
        }
        impl AHIBIO0HIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0LOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0LOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0HIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0HIW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Analog HIB_IO_0 Lower Threshold Value"]
            #[inline]
            pub fn ahibio0lo(&self) -> AHIBIO0LOR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AHIBIO0LOR { bits }
            }
            #[doc = "Bits 8:13 - Analog HIB_IO_0 Upper Threshold Value"]
            #[inline]
            pub fn ahibio0hi(&self) -> AHIBIO0HIR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AHIBIO0HIR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Analog HIB_IO_0 Lower Threshold Value"]
            #[inline]
            pub fn ahibio0lo(&mut self) -> _AHIBIO0LOW {
                _AHIBIO0LOW { w: self }
            }
            #[doc = "Bits 8:13 - Analog HIB_IO_0 Upper Threshold Value"]
            #[inline]
            pub fn ahibio0hi(&mut self) -> _AHIBIO0HIW {
                _AHIBIO0HIW { w: self }
            }
        }
    }
    #[doc = "Hibernate Analog Control State Register"]
    pub struct LPACST {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Analog Control State Register"]
    pub mod lpacst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::LPACST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `VBATSCMP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VBATSCMPR {
            #[doc = "Ready to start new compare operation"]
            VALUE1,
            #[doc = "Compare operation completed"]
            VALUE2,
        }
        impl VBATSCMPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VBATSCMPR::VALUE1 => false,
                    VBATSCMPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VBATSCMPR {
                match value {
                    false => VBATSCMPR::VALUE1,
                    true => VBATSCMPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VBATSCMPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VBATSCMPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHIBIO0SCMP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHIBIO0SCMPR {
            #[doc = "Ready to start new compare operation"]
            VALUE1,
            #[doc = "Compare operation completed"]
            VALUE2,
        }
        impl AHIBIO0SCMPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHIBIO0SCMPR::VALUE1 => false,
                    AHIBIO0SCMPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHIBIO0SCMPR {
                match value {
                    false => AHIBIO0SCMPR::VALUE1,
                    true => AHIBIO0SCMPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHIBIO0SCMPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHIBIO0SCMPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VBATVAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VBATVALR {
            #[doc = "Below programmed threshold"]
            VALUE1,
            #[doc = "Above programmed threshold"]
            VALUE2,
        }
        impl VBATVALR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VBATVALR::VALUE1 => false,
                    VBATVALR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VBATVALR {
                match value {
                    false => VBATVALR::VALUE1,
                    true => VBATVALR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VBATVALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VBATVALR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHIBIO0VAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHIBIO0VALR {
            #[doc = "Below programmed threshold"]
            VALUE1,
            #[doc = "Above programmed threshold"]
            VALUE2,
        }
        impl AHIBIO0VALR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHIBIO0VALR::VALUE1 => false,
                    AHIBIO0VALR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHIBIO0VALR {
                match value {
                    false => AHIBIO0VALR::VALUE1,
                    true => AHIBIO0VALR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHIBIO0VALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHIBIO0VALR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Trigger VBAT Single Compare Operation Status"]
            #[inline]
            pub fn vbatscmp(&self) -> VBATSCMPR {
                VBATSCMPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Trigger HIB_IO_0 Input Single Compare Operation Status"]
            #[inline]
            pub fn ahibio0scmp(&self) -> AHIBIO0SCMPR {
                AHIBIO0SCMPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - VBAT Compare Operation Result"]
            #[inline]
            pub fn vbatval(&self) -> VBATVALR {
                VBATVALR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - HIB_IO_0 Input Compare Operation Result"]
            #[inline]
            pub fn ahibio0val(&self) -> AHIBIO0VALR {
                AHIBIO0VALR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "LPAC Control Clear Register"]
    pub struct LPACCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "LPAC Control Clear Register"]
    pub mod lpacclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LPACCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `VBATSCMP`"]
        pub enum VBATSCMPW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the sticky bit"]
            VALUE2,
        }
        impl VBATSCMPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATSCMPW::VALUE1 => false,
                    VBATSCMPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATSCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATSCMPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATSCMPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATSCMPW::VALUE1)
            }
            #[doc = "Clear the sticky bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATSCMPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0SCMP`"]
        pub enum AHIBIO0SCMPW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clear the sticky bit"]
            VALUE2,
        }
        impl AHIBIO0SCMPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0SCMPW::VALUE1 => false,
                    AHIBIO0SCMPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0SCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0SCMPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0SCMPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0SCMPW::VALUE1)
            }
            #[doc = "Clear the sticky bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0SCMPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATVAL`"]
        pub enum VBATVALW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Below programmed threshold"]
            VALUE2,
        }
        impl VBATVALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATVALW::VALUE1 => false,
                    VBATVALW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATVALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATVALW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATVALW::VALUE1)
            }
            #[doc = "Below programmed threshold"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATVALW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0VAL`"]
        pub enum AHIBIO0VALW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Below programmed threshold"]
            VALUE2,
        }
        impl AHIBIO0VALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0VALW::VALUE1 => false,
                    AHIBIO0VALW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0VALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0VALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0VALW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0VALW::VALUE1)
            }
            #[doc = "Below programmed threshold"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0VALW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Trigger VBAT Single Compare Operation Clear"]
            #[inline]
            pub fn vbatscmp(&mut self) -> _VBATSCMPW {
                _VBATSCMPW { w: self }
            }
            #[doc = "Bit 1 - Trigger HIB_IO_0 Input Single Compare Operation Clear"]
            #[inline]
            pub fn ahibio0scmp(&mut self) -> _AHIBIO0SCMPW {
                _AHIBIO0SCMPW { w: self }
            }
            #[doc = "Bit 16 - VBAT Compare Operation Initial Value Clear"]
            #[inline]
            pub fn vbatval(&mut self) -> _VBATVALW {
                _VBATVALW { w: self }
            }
            #[doc = "Bit 17 - HIB_IO_0 Input Compare Initial Value Clear"]
            #[inline]
            pub fn ahibio0val(&mut self) -> _AHIBIO0VALW {
                _AHIBIO0VALW { w: self }
            }
        }
    }
    #[doc = "LPAC Control Set Register"]
    pub struct LPACSET {
        register: VolatileCell<u32>,
    }
    #[doc = "LPAC Control Set Register"]
    pub mod lpacset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LPACSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `VBATSCMP`"]
        pub enum VBATSCMPW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Start compare operation"]
            VALUE2,
        }
        impl VBATSCMPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATSCMPW::VALUE1 => false,
                    VBATSCMPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATSCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATSCMPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATSCMPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATSCMPW::VALUE1)
            }
            #[doc = "Start compare operation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATSCMPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0SCMP`"]
        pub enum AHIBIO0SCMPW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Start compare operation"]
            VALUE2,
        }
        impl AHIBIO0SCMPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0SCMPW::VALUE1 => false,
                    AHIBIO0SCMPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0SCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0SCMPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0SCMPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0SCMPW::VALUE1)
            }
            #[doc = "Start compare operation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0SCMPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VBATVAL`"]
        pub enum VBATVALW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Above programmed threshold"]
            VALUE2,
        }
        impl VBATVALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VBATVALW::VALUE1 => false,
                    VBATVALW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VBATVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VBATVALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VBATVALW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VBATVALW::VALUE1)
            }
            #[doc = "Above programmed threshold"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VBATVALW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHIBIO0VAL`"]
        pub enum AHIBIO0VALW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Above programmed threshold"]
            VALUE2,
        }
        impl AHIBIO0VALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHIBIO0VALW::VALUE1 => false,
                    AHIBIO0VALW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHIBIO0VALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHIBIO0VALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHIBIO0VALW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHIBIO0VALW::VALUE1)
            }
            #[doc = "Above programmed threshold"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHIBIO0VALW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Trigger VBAT Single Compare Operation Set"]
            #[inline]
            pub fn vbatscmp(&mut self) -> _VBATSCMPW {
                _VBATSCMPW { w: self }
            }
            #[doc = "Bit 1 - Trigger HIB_IO_0 Input Single Compare Operation Set"]
            #[inline]
            pub fn ahibio0scmp(&mut self) -> _AHIBIO0SCMPW {
                _AHIBIO0SCMPW { w: self }
            }
            #[doc = "Bit 16 - VBAT Compare Operation Initial Value Set"]
            #[inline]
            pub fn vbatval(&mut self) -> _VBATVALW {
                _VBATVALW { w: self }
            }
            #[doc = "Bit 17 - HIB_IO_0 Input Compare Initial Value Set"]
            #[inline]
            pub fn ahibio0val(&mut self) -> _AHIBIO0VALW {
                _AHIBIO0VALW { w: self }
            }
        }
    }
    #[doc = "Hibernate Internal Control State Register"]
    pub struct HINTST {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Internal Control State Register"]
    pub mod hintst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::HINTST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `HIBNINT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBNINTR {
            #[doc = "Hibernate not entered"]
            VALUE1,
            #[doc = "Hibernate entered"]
            VALUE2,
        }
        impl HIBNINTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBNINTR::VALUE1 => false,
                    HIBNINTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBNINTR {
                match value {
                    false => HIBNINTR::VALUE1,
                    true => HIBNINTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBNINTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBNINTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FLASHOFF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FLASHOFFR {
            #[doc = "VDDP supply of Flash switched on"]
            VALUE1,
            #[doc = "VDDP supply of Flash switched off"]
            VALUE2,
        }
        impl FLASHOFFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FLASHOFFR::VALUE1 => false,
                    FLASHOFFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FLASHOFFR {
                match value {
                    false => FLASHOFFR::VALUE1,
                    true => FLASHOFFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FLASHOFFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FLASHOFFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FLASHPD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FLASHPDR {
            #[doc = "Normal mode"]
            VALUE1,
            #[doc = "Power down mode effectively entered"]
            VALUE2,
        }
        impl FLASHPDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FLASHPDR::VALUE1 => false,
                    FLASHPDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FLASHPDR {
                match value {
                    false => FLASHPDR::VALUE1,
                    true => FLASHPDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FLASHPDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FLASHPDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `POFFD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum POFFDR {
            #[doc = "Pull-up on"]
            VALUE1,
            #[doc = "Pull-up off"]
            VALUE2,
        }
        impl POFFDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    POFFDR::VALUE1 => false,
                    POFFDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> POFFDR {
                match value {
                    false => POFFDR::VALUE1,
                    true => POFFDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == POFFDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == POFFDR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PPODELR {
            bits: u8,
        }
        impl PPODELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `POFFH`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum POFFHR {
            #[doc = "Pull-up on"]
            VALUE1,
            #[doc = "Pull-up off"]
            VALUE2,
        }
        impl POFFHR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    POFFHR::VALUE1 => false,
                    POFFHR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> POFFHR {
                match value {
                    false => POFFHR::VALUE1,
                    true => POFFHR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == POFFHR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == POFFHR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Internally Controlled Hibernate Sequence Request State"]
            #[inline]
            pub fn hibnint(&self) -> HIBNINTR {
                HIBNINTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - VDDP Supply Switch of Flash State"]
            #[inline]
            pub fn flashoff(&self) -> FLASHOFFR {
                FLASHOFFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Flash Power Down State"]
            #[inline]
            pub fn flashpd(&self) -> FLASHPDR {
                FLASHPDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - PORST Pull-up OFF Direct Control State"]
            #[inline]
            pub fn poffd(&self) -> POFFDR {
                POFFDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:17 - Delay on PORTS Pull-up Switching OFF on Hibernate Request"]
            #[inline]
            pub fn ppodel(&self) -> PPODELR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PPODELR { bits }
            }
            #[doc = "Bit 20 - PORST Pull-up OFF in Hibernate Mode State"]
            #[inline]
            pub fn poffh(&self) -> POFFHR {
                POFFHR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Hibernate Internal Control Clear Register"]
    pub struct HINTCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Internal Control Clear Register"]
    pub mod hintclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HINTCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `HIBNINT`"]
        pub enum HIBNINTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Hibernate bit clear"]
            VALUE2,
        }
        impl HIBNINTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBNINTW::VALUE1 => false,
                    HIBNINTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBNINTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBNINTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBNINTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBNINTW::VALUE1)
            }
            #[doc = "Hibernate bit clear"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBNINTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLASHOFF`"]
        pub enum FLASHOFFW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Switch on VDDP supply of Flash"]
            VALUE2,
        }
        impl FLASHOFFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLASHOFFW::VALUE1 => false,
                    FLASHOFFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLASHOFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLASHOFFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLASHOFFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLASHOFFW::VALUE1)
            }
            #[doc = "Switch on VDDP supply of Flash"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLASHOFFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLASHPD`"]
        pub enum FLASHPDW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Flash power down mode leave request"]
            VALUE2,
        }
        impl FLASHPDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLASHPDW::VALUE1 => false,
                    FLASHPDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLASHPDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLASHPDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLASHPDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLASHPDW::VALUE1)
            }
            #[doc = "Flash power down mode leave request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLASHPDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POFFD`"]
        pub enum POFFDW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Pull-up on"]
            VALUE2,
        }
        impl POFFDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POFFDW::VALUE1 => false,
                    POFFDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POFFDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POFFDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POFFDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POFFDW::VALUE1)
            }
            #[doc = "Pull-up on"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POFFDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPODELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPODELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POFFH`"]
        pub enum POFFHW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Pull-up on"]
            VALUE2,
        }
        impl POFFHW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POFFHW::VALUE1 => false,
                    POFFHW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POFFHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POFFHW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POFFHW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POFFHW::VALUE1)
            }
            #[doc = "Pull-up on"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POFFHW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Internally Controlled Hibernate Sequence Request Clear"]
            #[inline]
            pub fn hibnint(&mut self) -> _HIBNINTW {
                _HIBNINTW { w: self }
            }
            #[doc = "Bit 2 - VDDP Supply Switch of Flash Clear"]
            #[inline]
            pub fn flashoff(&mut self) -> _FLASHOFFW {
                _FLASHOFFW { w: self }
            }
            #[doc = "Bit 3 - Flash Power Down Clear"]
            #[inline]
            pub fn flashpd(&mut self) -> _FLASHPDW {
                _FLASHPDW { w: self }
            }
            #[doc = "Bit 4 - PORST Pull-up OFF Direct Control Clear"]
            #[inline]
            pub fn poffd(&mut self) -> _POFFDW {
                _POFFDW { w: self }
            }
            #[doc = "Bits 16:17 - Delay on PORTS Pull-up Switching OFF on Hibernate Request Clear"]
            #[inline]
            pub fn ppodel(&mut self) -> _PPODELW {
                _PPODELW { w: self }
            }
            #[doc = "Bit 20 - PORST Pull-up OFF in Hibernate Mode Clear"]
            #[inline]
            pub fn poffh(&mut self) -> _POFFHW {
                _POFFHW { w: self }
            }
        }
    }
    #[doc = "Hibernate Internal Control Set Register"]
    pub struct HINTSET {
        register: VolatileCell<u32>,
    }
    #[doc = "Hibernate Internal Control Set Register"]
    pub mod hintset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HINTSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `HIBNINT`"]
        pub enum HIBNINTW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Hardware controlled hibernate sequence request active"]
            VALUE2,
        }
        impl HIBNINTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBNINTW::VALUE1 => false,
                    HIBNINTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBNINTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBNINTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBNINTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBNINTW::VALUE1)
            }
            #[doc = "Hardware controlled hibernate sequence request active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBNINTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VCOREOFF`"]
        pub enum VCOREOFFW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "VDDC off to EVR set"]
            VALUE2,
        }
        impl VCOREOFFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VCOREOFFW::VALUE1 => false,
                    VCOREOFFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VCOREOFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VCOREOFFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VCOREOFFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VCOREOFFW::VALUE1)
            }
            #[doc = "VDDC off to EVR set"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VCOREOFFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLASHOFF`"]
        pub enum FLASHOFFW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Switch off VDDP supply of Flash"]
            VALUE2,
        }
        impl FLASHOFFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLASHOFFW::VALUE1 => false,
                    FLASHOFFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLASHOFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLASHOFFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLASHOFFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLASHOFFW::VALUE1)
            }
            #[doc = "Switch off VDDP supply of Flash"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLASHOFFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLASHPD`"]
        pub enum FLASHPDW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Flash power down mode request set"]
            VALUE2,
        }
        impl FLASHPDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLASHPDW::VALUE1 => false,
                    FLASHPDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLASHPDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLASHPDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLASHPDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLASHPDW::VALUE1)
            }
            #[doc = "Flash power down mode request set"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLASHPDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POFFD`"]
        pub enum POFFDW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Pull-up off"]
            VALUE2,
        }
        impl POFFDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POFFDW::VALUE1 => false,
                    POFFDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POFFDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POFFDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POFFDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POFFDW::VALUE1)
            }
            #[doc = "Pull-up off"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POFFDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPODELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPODELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POFFH`"]
        pub enum POFFHW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Pull-up off"]
            VALUE2,
        }
        impl POFFHW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POFFHW::VALUE1 => false,
                    POFFHW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POFFHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POFFHW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POFFHW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POFFHW::VALUE1)
            }
            #[doc = "Pull-up off"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POFFHW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Internally Controlled Hibernate Sequence Request Set"]
            #[inline]
            pub fn hibnint(&mut self) -> _HIBNINTW {
                _HIBNINTW { w: self }
            }
            #[doc = "Bit 1 - VDDC Generation off on EVR Set"]
            #[inline]
            pub fn vcoreoff(&mut self) -> _VCOREOFFW {
                _VCOREOFFW { w: self }
            }
            #[doc = "Bit 2 - VDDP Supply Switch of Flash Set"]
            #[inline]
            pub fn flashoff(&mut self) -> _FLASHOFFW {
                _FLASHOFFW { w: self }
            }
            #[doc = "Bit 3 - Flash Power Down Set"]
            #[inline]
            pub fn flashpd(&mut self) -> _FLASHPDW {
                _FLASHPDW { w: self }
            }
            #[doc = "Bit 4 - PORST Pull-up OFF Direct Control Set"]
            #[inline]
            pub fn poffd(&mut self) -> _POFFDW {
                _POFFDW { w: self }
            }
            #[doc = "Bits 16:17 - Delay on PORTS Pull-up Switching OFF on Hibernate Request Set"]
            #[inline]
            pub fn ppodel(&mut self) -> _PPODELW {
                _PPODELW { w: self }
            }
            #[doc = "Bit 20 - PORST Pull-up OFF in Hibernate Mode Set"]
            #[inline]
            pub fn poffh(&mut self) -> _POFFHW {
                _POFFHW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_HIBERNATE {
    register_block: scu_hibernate::RegisterBlock,
}
impl Deref for SCU_HIBERNATE {
    type Target = scu_hibernate::RegisterBlock;
    fn deref(&self) -> &scu_hibernate::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_POWER: Peripheral<SCU_POWER> = unsafe { Peripheral::new(0x5000_4200) };
#[doc = "System Control Unit"]
pub mod scu_power {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - PCU Status Register"]
        pub pwrstat: PWRSTAT,
        #[doc = "0x04 - PCU Set Control Register"]
        pub pwrset: PWRSET,
        #[doc = "0x08 - PCU Clear Control Register"]
        pub pwrclr: PWRCLR,
        _reserved0: [u8; 4usize],
        #[doc = "0x10 - EVR Status Register"]
        pub evrstat: EVRSTAT,
        #[doc = "0x14 - EVR VADC Status Register"]
        pub evrvadcstat: EVRVADCSTAT,
        _reserved1: [u8; 20usize],
        #[doc = "0x2c - Power Monitor Control"]
        pub pwrmon: PWRMON,
    }
    #[doc = "PCU Status Register"]
    pub struct PWRSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "PCU Status Register"]
    pub mod pwrstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PWRSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `HIBEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBENR {
            #[doc = "Inactive"]
            VALUE1,
            #[doc = "Active"]
            VALUE2,
        }
        impl HIBENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBENR::VALUE1 => false,
                    HIBENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBENR {
                match value {
                    false => HIBENR::VALUE1,
                    true => HIBENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USBPHYPDQ`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBPHYPDQR {
            #[doc = "Power-down"]
            VALUE1,
            #[doc = "Active"]
            VALUE2,
        }
        impl USBPHYPDQR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBPHYPDQR::VALUE1 => false,
                    USBPHYPDQR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBPHYPDQR {
                match value {
                    false => USBPHYPDQR::VALUE1,
                    true => USBPHYPDQR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBPHYPDQR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBPHYPDQR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USBPUWQ`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBPUWQR {
            #[doc = "Pull-up active"]
            VALUE1,
            #[doc = "Pull-up not active"]
            VALUE2,
        }
        impl USBPUWQR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBPUWQR::VALUE1 => false,
                    USBPUWQR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBPUWQR {
                match value {
                    false => USBPUWQR::VALUE1,
                    true => USBPUWQR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBPUWQR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBPUWQR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Hibernate Domain Enable Status"]
            #[inline]
            pub fn hiben(&self) -> HIBENR {
                HIBENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - USB PHY Transceiver State"]
            #[inline]
            pub fn usbphypdq(&self) -> USBPHYPDQR {
                USBPHYPDQR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - USB Weak Pull-Up at PADN State"]
            #[inline]
            pub fn usbpuwq(&self) -> USBPUWQR {
                USBPUWQR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "PCU Set Control Register"]
    pub struct PWRSET {
        register: VolatileCell<u32>,
    }
    #[doc = "PCU Set Control Register"]
    pub mod pwrset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PWRSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `HIB`"]
        pub enum HIBW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable Hibernate domain"]
            VALUE2,
        }
        impl HIBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBW::VALUE1 => false,
                    HIBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBW::VALUE1)
            }
            #[doc = "Enable Hibernate domain"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBPHYPDQ`"]
        pub enum USBPHYPDQW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Active"]
            VALUE2,
        }
        impl USBPHYPDQW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBPHYPDQW::VALUE1 => false,
                    USBPHYPDQW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBPHYPDQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBPHYPDQW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBPHYPDQW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBPHYPDQW::VALUE1)
            }
            #[doc = "Active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBPHYPDQW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBPUWQ`"]
        pub enum USBPUWQW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Pull-up not active"]
            VALUE2,
        }
        impl USBPUWQW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBPUWQW::VALUE1 => false,
                    USBPUWQW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBPUWQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBPUWQW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBPUWQW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBPUWQW::VALUE1)
            }
            #[doc = "Pull-up not active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBPUWQW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Set Hibernate Domain Enable"]
            #[inline]
            pub fn hib(&mut self) -> _HIBW {
                _HIBW { w: self }
            }
            #[doc = "Bit 16 - Set USB PHY Transceiver Disable"]
            #[inline]
            pub fn usbphypdq(&mut self) -> _USBPHYPDQW {
                _USBPHYPDQW { w: self }
            }
            #[doc = "Bit 18 - Set USB Weak Pull-Up at PADN Enable"]
            #[inline]
            pub fn usbpuwq(&mut self) -> _USBPUWQW {
                _USBPUWQW { w: self }
            }
        }
    }
    #[doc = "PCU Clear Control Register"]
    pub struct PWRCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "PCU Clear Control Register"]
    pub mod pwrclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PWRCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `HIB`"]
        pub enum HIBW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable Hibernate domain"]
            VALUE2,
        }
        impl HIBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBW::VALUE1 => false,
                    HIBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBW::VALUE1)
            }
            #[doc = "Disable Hibernate domain"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBPHYPDQ`"]
        pub enum USBPHYPDQW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Power-down"]
            VALUE2,
        }
        impl USBPHYPDQW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBPHYPDQW::VALUE1 => false,
                    USBPHYPDQW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBPHYPDQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBPHYPDQW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBPHYPDQW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBPHYPDQW::VALUE1)
            }
            #[doc = "Power-down"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBPHYPDQW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBPUWQ`"]
        pub enum USBPUWQW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Pull-up active"]
            VALUE2,
        }
        impl USBPUWQW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBPUWQW::VALUE1 => false,
                    USBPUWQW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBPUWQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBPUWQW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBPUWQW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBPUWQW::VALUE1)
            }
            #[doc = "Pull-up active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBPUWQW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Disable Hibernate Domain"]
            #[inline]
            pub fn hib(&mut self) -> _HIBW {
                _HIBW { w: self }
            }
            #[doc = "Bit 16 - Clear USB PHY Transceiver Disable"]
            #[inline]
            pub fn usbphypdq(&mut self) -> _USBPHYPDQW {
                _USBPHYPDQW { w: self }
            }
            #[doc = "Bit 18 - Clear USB Weak Pull-Up at PADN Enable"]
            #[inline]
            pub fn usbpuwq(&mut self) -> _USBPUWQW {
                _USBPUWQW { w: self }
            }
        }
    }
    #[doc = "EVR Status Register"]
    pub struct EVRSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "EVR Status Register"]
    pub mod evrstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::EVRSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `OV13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OV13R {
            #[doc = "No overvoltage condition"]
            VALUE1,
            #[doc = "Regulator is in overvoltage"]
            VALUE2,
        }
        impl OV13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OV13R::VALUE1 => false,
                    OV13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OV13R {
                match value {
                    false => OV13R::VALUE1,
                    true => OV13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OV13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OV13R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 1 - Regulator Overvoltage for 1.3 V"]
            #[inline]
            pub fn ov13(&self) -> OV13R {
                OV13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "EVR VADC Status Register"]
    pub struct EVRVADCSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "EVR VADC Status Register"]
    pub mod evrvadcstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::EVRVADCSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct VADC13VR {
            bits: u8,
        }
        impl VADC13VR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct VADC33VR {
            bits: u8,
        }
        impl VADC33VR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - VADC 1.3 V Conversion Result"]
            #[inline]
            pub fn vadc13v(&self) -> VADC13VR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                VADC13VR { bits }
            }
            #[doc = "Bits 8:15 - VADC 3.3 V Conversion Result"]
            #[inline]
            pub fn vadc33v(&self) -> VADC33VR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                VADC33VR { bits }
            }
        }
    }
    #[doc = "Power Monitor Control"]
    pub struct PWRMON {
        register: VolatileCell<u32>,
    }
    #[doc = "Power Monitor Control"]
    pub mod pwrmon {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PWRMON {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct THRSR {
            bits: u8,
        }
        impl THRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INTVR {
            bits: u8,
        }
        impl INTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENBR {
            bits: bool,
        }
        impl ENBR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _THRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _THRSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INTVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INTVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Threshold"]
            #[inline]
            pub fn thrs(&self) -> THRSR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                THRSR { bits }
            }
            #[doc = "Bits 8:15 - Interval"]
            #[inline]
            pub fn intv(&self) -> INTVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                INTVR { bits }
            }
            #[doc = "Bit 16 - Enable"]
            #[inline]
            pub fn enb(&self) -> ENBR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENBR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Threshold"]
            #[inline]
            pub fn thrs(&mut self) -> _THRSW {
                _THRSW { w: self }
            }
            #[doc = "Bits 8:15 - Interval"]
            #[inline]
            pub fn intv(&mut self) -> _INTVW {
                _INTVW { w: self }
            }
            #[doc = "Bit 16 - Enable"]
            #[inline]
            pub fn enb(&mut self) -> _ENBW {
                _ENBW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_POWER {
    register_block: scu_power::RegisterBlock,
}
impl Deref for SCU_POWER {
    type Target = scu_power::RegisterBlock;
    fn deref(&self) -> &scu_power::RegisterBlock {
        &self.register_block
    }
}
#[doc = "System Control Unit"]
pub const SCU_RESET: Peripheral<SCU_RESET> = unsafe { Peripheral::new(0x5000_4400) };
#[doc = "System Control Unit"]
pub mod scu_reset {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - RCU Reset Status"]
        pub rststat: RSTSTAT,
        #[doc = "0x04 - RCU Reset Set Register"]
        pub rstset: RSTSET,
        #[doc = "0x08 - RCU Reset Clear Register"]
        pub rstclr: RSTCLR,
        #[doc = "0x0c - RCU Peripheral 0 Reset Status"]
        pub prstat0: PRSTAT0,
        #[doc = "0x10 - RCU Peripheral 0 Reset Set"]
        pub prset0: PRSET0,
        #[doc = "0x14 - RCU Peripheral 0 Reset Clear"]
        pub prclr0: PRCLR0,
        #[doc = "0x18 - RCU Peripheral 1 Reset Status"]
        pub prstat1: PRSTAT1,
        #[doc = "0x1c - RCU Peripheral 1 Reset Set"]
        pub prset1: PRSET1,
        #[doc = "0x20 - RCU Peripheral 1 Reset Clear"]
        pub prclr1: PRCLR1,
        #[doc = "0x24 - RCU Peripheral 2 Reset Status"]
        pub prstat2: PRSTAT2,
        #[doc = "0x28 - RCU Peripheral 2 Reset Set"]
        pub prset2: PRSET2,
        #[doc = "0x2c - RCU Peripheral 2 Reset Clear"]
        pub prclr2: PRCLR2,
    }
    #[doc = "RCU Reset Status"]
    pub struct RSTSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Reset Status"]
    pub mod rststat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RSTSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `RSTSTAT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSTSTATR {
            #[doc = "PORST reset"]
            VALUE1,
            #[doc = "SWD reset"]
            VALUE2,
            #[doc = "PV reset"]
            VALUE3,
            #[doc = "CPU system reset"]
            VALUE4,
            #[doc = "CPU lockup reset"]
            VALUE5,
            #[doc = "WDT reset"]
            VALUE6,
            #[doc = "Parity Error reset"]
            VALUE8,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl RSTSTATR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    RSTSTATR::VALUE1 => 0x01,
                    RSTSTATR::VALUE2 => 0x02,
                    RSTSTATR::VALUE3 => 0x04,
                    RSTSTATR::VALUE4 => 0x08,
                    RSTSTATR::VALUE5 => 0x10,
                    RSTSTATR::VALUE6 => 0x20,
                    RSTSTATR::VALUE8 => 0x80,
                    RSTSTATR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> RSTSTATR {
                match value {
                    1 => RSTSTATR::VALUE1,
                    2 => RSTSTATR::VALUE2,
                    4 => RSTSTATR::VALUE3,
                    8 => RSTSTATR::VALUE4,
                    16 => RSTSTATR::VALUE5,
                    32 => RSTSTATR::VALUE6,
                    128 => RSTSTATR::VALUE8,
                    i => RSTSTATR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSTSTATR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSTSTATR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == RSTSTATR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == RSTSTATR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == RSTSTATR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == RSTSTATR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == RSTSTATR::VALUE8
            }
        }
        #[doc = "Possible values of the field `HIBWK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBWKR {
            #[doc = "No Wake-up"]
            VALUE1,
            #[doc = "Wake-up event"]
            VALUE2,
        }
        impl HIBWKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBWKR::VALUE1 => false,
                    HIBWKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBWKR {
                match value {
                    false => HIBWKR::VALUE1,
                    true => HIBWKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBWKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBWKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIBRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIBRSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl HIBRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIBRSR::VALUE1 => false,
                    HIBRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIBRSR {
                match value {
                    false => HIBRSR::VALUE1,
                    true => HIBRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIBRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIBRSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LCKEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LCKENR {
            #[doc = "Reset by Lockup disabled"]
            VALUE1,
            #[doc = "Reset by Lockup enabled"]
            VALUE2,
        }
        impl LCKENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LCKENR::VALUE1 => false,
                    LCKENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LCKENR {
                match value {
                    false => LCKENR::VALUE1,
                    true => LCKENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LCKENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LCKENR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Reset Status Information"]
            #[inline]
            pub fn rststat(&self) -> RSTSTATR {
                RSTSTATR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 8 - Hibernate Wake-up Status"]
            #[inline]
            pub fn hibwk(&self) -> HIBWKR {
                HIBWKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Hibernate Reset Status"]
            #[inline]
            pub fn hibrs(&self) -> HIBRSR {
                HIBRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Enable Lockup Status"]
            #[inline]
            pub fn lcken(&self) -> LCKENR {
                LCKENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "RCU Reset Set Register"]
    pub struct RSTSET {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Reset Set Register"]
    pub mod rstset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RSTSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `HIBWK`"]
        pub enum HIBWKW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset status bit"]
            VALUE2,
        }
        impl HIBWKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBWKW::VALUE1 => false,
                    HIBWKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBWKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBWKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBWKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBWKW::VALUE1)
            }
            #[doc = "Assert reset status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBWKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIBRS`"]
        pub enum HIBRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl HIBRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBRSW::VALUE1 => false,
                    HIBRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBRSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LCKEN`"]
        pub enum LCKENW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Enable reset when Lockup gets asserted"]
            VALUE2,
        }
        impl LCKENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LCKENW::VALUE1 => false,
                    LCKENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LCKENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LCKENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LCKENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LCKENW::VALUE1)
            }
            #[doc = "Enable reset when Lockup gets asserted"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LCKENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Set Hibernate Wake-up Reset Status"]
            #[inline]
            pub fn hibwk(&mut self) -> _HIBWKW {
                _HIBWKW { w: self }
            }
            #[doc = "Bit 9 - Set Hibernate Reset"]
            #[inline]
            pub fn hibrs(&mut self) -> _HIBRSW {
                _HIBRSW { w: self }
            }
            #[doc = "Bit 10 - Enable Lockup Reset"]
            #[inline]
            pub fn lcken(&mut self) -> _LCKENW {
                _LCKENW { w: self }
            }
        }
    }
    #[doc = "RCU Reset Clear Register"]
    pub struct RSTCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Reset Clear Register"]
    pub mod rstclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RSTCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `RSCLR`"]
        pub enum RSCLRW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Clears field RSTSTAT.RSTSTAT"]
            VALUE2,
        }
        impl RSCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSCLRW::VALUE1 => false,
                    RSCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSCLRW::VALUE1)
            }
            #[doc = "Clears field RSTSTAT.RSTSTAT"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIBWK`"]
        pub enum HIBWKW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset status bit"]
            VALUE2,
        }
        impl HIBWKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBWKW::VALUE1 => false,
                    HIBWKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBWKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBWKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBWKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBWKW::VALUE1)
            }
            #[doc = "De-assert reset status bit"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBWKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIBRS`"]
        pub enum HIBRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl HIBRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIBRSW::VALUE1 => false,
                    HIBRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIBRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIBRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIBRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIBRSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIBRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LCKEN`"]
        pub enum LCKENW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Disable reset when Lockup gets asserted"]
            VALUE2,
        }
        impl LCKENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LCKENW::VALUE1 => false,
                    LCKENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LCKENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LCKENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LCKENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LCKENW::VALUE1)
            }
            #[doc = "Disable reset when Lockup gets asserted"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LCKENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Reset Status"]
            #[inline]
            pub fn rsclr(&mut self) -> _RSCLRW {
                _RSCLRW { w: self }
            }
            #[doc = "Bit 8 - Clear Hibernate Wake-up Reset Status"]
            #[inline]
            pub fn hibwk(&mut self) -> _HIBWKW {
                _HIBWKW { w: self }
            }
            #[doc = "Bit 9 - Clear Hibernate Reset"]
            #[inline]
            pub fn hibrs(&mut self) -> _HIBRSW {
                _HIBRSW { w: self }
            }
            #[doc = "Bit 10 - Enable Lockup Reset"]
            #[inline]
            pub fn lcken(&mut self) -> _LCKENW {
                _LCKENW { w: self }
            }
        }
    }
    #[doc = "RCU Peripheral 0 Reset Status"]
    pub struct PRSTAT0 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 0 Reset Status"]
    pub mod prstat0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PRSTAT0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `VADCRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VADCRSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl VADCRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VADCRSR::VALUE1 => false,
                    VADCRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VADCRSR {
                match value {
                    false => VADCRSR::VALUE1,
                    true => VADCRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VADCRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VADCRSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCU40RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCU40RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl CCU40RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCU40RSR::VALUE1 => false,
                    CCU40RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCU40RSR {
                match value {
                    false => CCU40RSR::VALUE1,
                    true => CCU40RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCU40RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCU40RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCU41RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCU41RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl CCU41RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCU41RSR::VALUE1 => false,
                    CCU41RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCU41RSR {
                match value {
                    false => CCU41RSR::VALUE1,
                    true => CCU41RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCU41RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCU41RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCU80RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCU80RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl CCU80RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCU80RSR::VALUE1 => false,
                    CCU80RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCU80RSR {
                match value {
                    false => CCU80RSR::VALUE1,
                    true => CCU80RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCU80RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCU80RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `POSIF0RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum POSIF0RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl POSIF0RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    POSIF0RSR::VALUE1 => false,
                    POSIF0RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> POSIF0RSR {
                match value {
                    false => POSIF0RSR::VALUE1,
                    true => POSIF0RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == POSIF0RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == POSIF0RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USIC0RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USIC0RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl USIC0RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USIC0RSR::VALUE1 => false,
                    USIC0RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USIC0RSR {
                match value {
                    false => USIC0RSR::VALUE1,
                    true => USIC0RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USIC0RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USIC0RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERU1RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERU1RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl ERU1RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERU1RSR::VALUE1 => false,
                    ERU1RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERU1RSR {
                match value {
                    false => ERU1RSR::VALUE1,
                    true => ERU1RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERU1RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERU1RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HRPWM0RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRPWM0RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl HRPWM0RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRPWM0RSR::VALUE1 => false,
                    HRPWM0RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRPWM0RSR {
                match value {
                    false => HRPWM0RSR::VALUE1,
                    true => HRPWM0RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRPWM0RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRPWM0RSR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - VADC Reset Status"]
            #[inline]
            pub fn vadcrs(&self) -> VADCRSR {
                VADCRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - CCU40 Reset Status"]
            #[inline]
            pub fn ccu40rs(&self) -> CCU40RSR {
                CCU40RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - CCU41 Reset Status"]
            #[inline]
            pub fn ccu41rs(&self) -> CCU41RSR {
                CCU41RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - CCU80 Reset Status"]
            #[inline]
            pub fn ccu80rs(&self) -> CCU80RSR {
                CCU80RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - POSIF0 Reset Status"]
            #[inline]
            pub fn posif0rs(&self) -> POSIF0RSR {
                POSIF0RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - USIC0 Reset Status"]
            #[inline]
            pub fn usic0rs(&self) -> USIC0RSR {
                USIC0RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - ERU1 Reset Status"]
            #[inline]
            pub fn eru1rs(&self) -> ERU1RSR {
                ERU1RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - HRPWM0 Reset Status"]
            #[inline]
            pub fn hrpwm0rs(&self) -> HRPWM0RSR {
                HRPWM0RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "RCU Peripheral 0 Reset Set"]
    pub struct PRSET0 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 0 Reset Set"]
    pub mod prset0 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRSET0 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `VADCRS`"]
        pub enum VADCRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl VADCRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VADCRSW::VALUE1 => false,
                    VADCRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VADCRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VADCRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VADCRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VADCRSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VADCRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU40RS`"]
        pub enum CCU40RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl CCU40RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU40RSW::VALUE1 => false,
                    CCU40RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU40RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU40RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU40RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU40RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU40RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU41RS`"]
        pub enum CCU41RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl CCU41RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU41RSW::VALUE1 => false,
                    CCU41RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU41RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU41RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU41RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU41RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU41RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU80RS`"]
        pub enum CCU80RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl CCU80RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU80RSW::VALUE1 => false,
                    CCU80RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU80RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU80RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU80RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU80RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU80RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POSIF0RS`"]
        pub enum POSIF0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl POSIF0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POSIF0RSW::VALUE1 => false,
                    POSIF0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POSIF0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POSIF0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POSIF0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POSIF0RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POSIF0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC0RS`"]
        pub enum USIC0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl USIC0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC0RSW::VALUE1 => false,
                    USIC0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC0RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU1RS`"]
        pub enum ERU1RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl ERU1RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU1RSW::VALUE1 => false,
                    ERU1RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU1RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU1RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU1RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU1RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU1RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRPWM0RS`"]
        pub enum HRPWM0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl HRPWM0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRPWM0RSW::VALUE1 => false,
                    HRPWM0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRPWM0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRPWM0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRPWM0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRPWM0RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRPWM0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - VADC Reset Assert"]
            #[inline]
            pub fn vadcrs(&mut self) -> _VADCRSW {
                _VADCRSW { w: self }
            }
            #[doc = "Bit 2 - CCU40 Reset Assert"]
            #[inline]
            pub fn ccu40rs(&mut self) -> _CCU40RSW {
                _CCU40RSW { w: self }
            }
            #[doc = "Bit 3 - CCU41 Reset Assert"]
            #[inline]
            pub fn ccu41rs(&mut self) -> _CCU41RSW {
                _CCU41RSW { w: self }
            }
            #[doc = "Bit 7 - CCU80 Reset Assert"]
            #[inline]
            pub fn ccu80rs(&mut self) -> _CCU80RSW {
                _CCU80RSW { w: self }
            }
            #[doc = "Bit 9 - POSIF0 Reset Assert"]
            #[inline]
            pub fn posif0rs(&mut self) -> _POSIF0RSW {
                _POSIF0RSW { w: self }
            }
            #[doc = "Bit 11 - USIC0 Reset Assert"]
            #[inline]
            pub fn usic0rs(&mut self) -> _USIC0RSW {
                _USIC0RSW { w: self }
            }
            #[doc = "Bit 16 - ERU1 Reset Assert"]
            #[inline]
            pub fn eru1rs(&mut self) -> _ERU1RSW {
                _ERU1RSW { w: self }
            }
            #[doc = "Bit 23 - HRPWM0 Reset Assert"]
            #[inline]
            pub fn hrpwm0rs(&mut self) -> _HRPWM0RSW {
                _HRPWM0RSW { w: self }
            }
        }
    }
    #[doc = "RCU Peripheral 0 Reset Clear"]
    pub struct PRCLR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 0 Reset Clear"]
    pub mod prclr0 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRCLR0 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `VADCRS`"]
        pub enum VADCRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl VADCRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VADCRSW::VALUE1 => false,
                    VADCRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VADCRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VADCRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VADCRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VADCRSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VADCRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU40RS`"]
        pub enum CCU40RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl CCU40RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU40RSW::VALUE1 => false,
                    CCU40RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU40RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU40RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU40RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU40RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU40RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU41RS`"]
        pub enum CCU41RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl CCU41RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU41RSW::VALUE1 => false,
                    CCU41RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU41RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU41RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU41RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU41RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU41RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCU80RS`"]
        pub enum CCU80RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl CCU80RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCU80RSW::VALUE1 => false,
                    CCU80RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCU80RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCU80RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCU80RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCU80RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCU80RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `POSIF0RS`"]
        pub enum POSIF0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl POSIF0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    POSIF0RSW::VALUE1 => false,
                    POSIF0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POSIF0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POSIF0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POSIF0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POSIF0RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POSIF0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC0RS`"]
        pub enum USIC0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl USIC0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC0RSW::VALUE1 => false,
                    USIC0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC0RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERU1RS`"]
        pub enum ERU1RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl ERU1RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERU1RSW::VALUE1 => false,
                    ERU1RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERU1RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERU1RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERU1RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERU1RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERU1RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRPWM0RS`"]
        pub enum HRPWM0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl HRPWM0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRPWM0RSW::VALUE1 => false,
                    HRPWM0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRPWM0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRPWM0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRPWM0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRPWM0RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRPWM0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - VADC Reset Clear"]
            #[inline]
            pub fn vadcrs(&mut self) -> _VADCRSW {
                _VADCRSW { w: self }
            }
            #[doc = "Bit 2 - CCU40 Reset Clear"]
            #[inline]
            pub fn ccu40rs(&mut self) -> _CCU40RSW {
                _CCU40RSW { w: self }
            }
            #[doc = "Bit 3 - CCU41 Reset Clear"]
            #[inline]
            pub fn ccu41rs(&mut self) -> _CCU41RSW {
                _CCU41RSW { w: self }
            }
            #[doc = "Bit 7 - CCU80 Reset Clear"]
            #[inline]
            pub fn ccu80rs(&mut self) -> _CCU80RSW {
                _CCU80RSW { w: self }
            }
            #[doc = "Bit 9 - POSIF0 Reset Clear"]
            #[inline]
            pub fn posif0rs(&mut self) -> _POSIF0RSW {
                _POSIF0RSW { w: self }
            }
            #[doc = "Bit 11 - USIC0 Reset Clear"]
            #[inline]
            pub fn usic0rs(&mut self) -> _USIC0RSW {
                _USIC0RSW { w: self }
            }
            #[doc = "Bit 16 - ERU1 Reset Clear"]
            #[inline]
            pub fn eru1rs(&mut self) -> _ERU1RSW {
                _ERU1RSW { w: self }
            }
            #[doc = "Bit 23 - HRPWM0 Reset Clear"]
            #[inline]
            pub fn hrpwm0rs(&mut self) -> _HRPWM0RSW {
                _HRPWM0RSW { w: self }
            }
        }
    }
    #[doc = "RCU Peripheral 1 Reset Status"]
    pub struct PRSTAT1 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 1 Reset Status"]
    pub mod prstat1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PRSTAT1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `LEDTSCU0RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LEDTSCU0RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl LEDTSCU0RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LEDTSCU0RSR::VALUE1 => false,
                    LEDTSCU0RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LEDTSCU0RSR {
                match value {
                    false => LEDTSCU0RSR::VALUE1,
                    true => LEDTSCU0RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LEDTSCU0RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LEDTSCU0RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCAN0RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCAN0RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl MCAN0RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCAN0RSR::VALUE1 => false,
                    MCAN0RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCAN0RSR {
                match value {
                    false => MCAN0RSR::VALUE1,
                    true => MCAN0RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCAN0RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCAN0RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DACRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DACRSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl DACRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DACRSR::VALUE1 => false,
                    DACRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DACRSR {
                match value {
                    false => DACRSR::VALUE1,
                    true => DACRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DACRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DACRSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USIC1RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USIC1RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl USIC1RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USIC1RSR::VALUE1 => false,
                    USIC1RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USIC1RSR {
                match value {
                    false => USIC1RSR::VALUE1,
                    true => USIC1RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USIC1RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USIC1RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPORTSRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPORTSRSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl PPORTSRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPORTSRSR::VALUE1 => false,
                    PPORTSRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPORTSRSR {
                match value {
                    false => PPORTSRSR::VALUE1,
                    true => PPORTSRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPORTSRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPORTSRSR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 3 - LEDTS Reset Status"]
            #[inline]
            pub fn ledtscu0rs(&self) -> LEDTSCU0RSR {
                LEDTSCU0RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - MultiCAN Reset Status"]
            #[inline]
            pub fn mcan0rs(&self) -> MCAN0RSR {
                MCAN0RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - DAC Reset Status"]
            #[inline]
            pub fn dacrs(&self) -> DACRSR {
                DACRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - USIC1 Reset Status"]
            #[inline]
            pub fn usic1rs(&self) -> USIC1RSR {
                USIC1RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - PORTS Reset Status"]
            #[inline]
            pub fn pportsrs(&self) -> PPORTSRSR {
                PPORTSRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "RCU Peripheral 1 Reset Set"]
    pub struct PRSET1 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 1 Reset Set"]
    pub mod prset1 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRSET1 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `LEDTSCU0RS`"]
        pub enum LEDTSCU0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl LEDTSCU0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LEDTSCU0RSW::VALUE1 => false,
                    LEDTSCU0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LEDTSCU0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LEDTSCU0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LEDTSCU0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LEDTSCU0RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LEDTSCU0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCAN0RS`"]
        pub enum MCAN0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl MCAN0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCAN0RSW::VALUE1 => false,
                    MCAN0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCAN0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCAN0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCAN0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCAN0RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCAN0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DACRS`"]
        pub enum DACRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl DACRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DACRSW::VALUE1 => false,
                    DACRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DACRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DACRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DACRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DACRSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DACRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC1RS`"]
        pub enum USIC1RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl USIC1RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC1RSW::VALUE1 => false,
                    USIC1RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC1RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC1RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC1RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC1RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC1RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPORTSRS`"]
        pub enum PPORTSRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl PPORTSRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPORTSRSW::VALUE1 => false,
                    PPORTSRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPORTSRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPORTSRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPORTSRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPORTSRSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPORTSRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 3 - LEDTS Reset Assert"]
            #[inline]
            pub fn ledtscu0rs(&mut self) -> _LEDTSCU0RSW {
                _LEDTSCU0RSW { w: self }
            }
            #[doc = "Bit 4 - MultiCAN Reset Assert"]
            #[inline]
            pub fn mcan0rs(&mut self) -> _MCAN0RSW {
                _MCAN0RSW { w: self }
            }
            #[doc = "Bit 5 - DAC Reset Assert"]
            #[inline]
            pub fn dacrs(&mut self) -> _DACRSW {
                _DACRSW { w: self }
            }
            #[doc = "Bit 7 - USIC1 Reset Assert"]
            #[inline]
            pub fn usic1rs(&mut self) -> _USIC1RSW {
                _USIC1RSW { w: self }
            }
            #[doc = "Bit 9 - PORTS Reset Assert"]
            #[inline]
            pub fn pportsrs(&mut self) -> _PPORTSRSW {
                _PPORTSRSW { w: self }
            }
        }
    }
    #[doc = "RCU Peripheral 1 Reset Clear"]
    pub struct PRCLR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 1 Reset Clear"]
    pub mod prclr1 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRCLR1 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `LEDTSCU0RS`"]
        pub enum LEDTSCU0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl LEDTSCU0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LEDTSCU0RSW::VALUE1 => false,
                    LEDTSCU0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LEDTSCU0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LEDTSCU0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LEDTSCU0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LEDTSCU0RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LEDTSCU0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCAN0RS`"]
        pub enum MCAN0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl MCAN0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCAN0RSW::VALUE1 => false,
                    MCAN0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCAN0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCAN0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCAN0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCAN0RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCAN0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DACRS`"]
        pub enum DACRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl DACRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DACRSW::VALUE1 => false,
                    DACRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DACRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DACRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DACRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DACRSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DACRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USIC1RS`"]
        pub enum USIC1RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl USIC1RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USIC1RSW::VALUE1 => false,
                    USIC1RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USIC1RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USIC1RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USIC1RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USIC1RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USIC1RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPORTSRS`"]
        pub enum PPORTSRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl PPORTSRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPORTSRSW::VALUE1 => false,
                    PPORTSRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPORTSRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPORTSRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPORTSRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPORTSRSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPORTSRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 3 - LEDTS Reset Clear"]
            #[inline]
            pub fn ledtscu0rs(&mut self) -> _LEDTSCU0RSW {
                _LEDTSCU0RSW { w: self }
            }
            #[doc = "Bit 4 - MultiCAN Reset Clear"]
            #[inline]
            pub fn mcan0rs(&mut self) -> _MCAN0RSW {
                _MCAN0RSW { w: self }
            }
            #[doc = "Bit 5 - DAC Reset Clear"]
            #[inline]
            pub fn dacrs(&mut self) -> _DACRSW {
                _DACRSW { w: self }
            }
            #[doc = "Bit 7 - USIC1 Reset Clear"]
            #[inline]
            pub fn usic1rs(&mut self) -> _USIC1RSW {
                _USIC1RSW { w: self }
            }
            #[doc = "Bit 9 - PORTS Reset Clear"]
            #[inline]
            pub fn pportsrs(&mut self) -> _PPORTSRSW {
                _PPORTSRSW { w: self }
            }
        }
    }
    #[doc = "RCU Peripheral 2 Reset Status"]
    pub struct PRSTAT2 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 2 Reset Status"]
    pub mod prstat2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PRSTAT2 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `WDTRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WDTRSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl WDTRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WDTRSR::VALUE1 => false,
                    WDTRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WDTRSR {
                match value {
                    false => WDTRSR::VALUE1,
                    true => WDTRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WDTRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WDTRSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DMA0RS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DMA0RSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl DMA0RSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DMA0RSR::VALUE1 => false,
                    DMA0RSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DMA0RSR {
                match value {
                    false => DMA0RSR::VALUE1,
                    true => DMA0RSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DMA0RSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DMA0RSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FCERS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCERSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl FCERSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCERSR::VALUE1 => false,
                    FCERSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCERSR {
                match value {
                    false => FCERSR::VALUE1,
                    true => FCERSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCERSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCERSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `USBRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum USBRSR {
            #[doc = "Reset de-asserted"]
            VALUE1,
            #[doc = "Reset asserted"]
            VALUE2,
        }
        impl USBRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    USBRSR::VALUE1 => false,
                    USBRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> USBRSR {
                match value {
                    false => USBRSR::VALUE1,
                    true => USBRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == USBRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == USBRSR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 1 - WDT Reset Status"]
            #[inline]
            pub fn wdtrs(&self) -> WDTRSR {
                WDTRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - DMA0 Reset Status"]
            #[inline]
            pub fn dma0rs(&self) -> DMA0RSR {
                DMA0RSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - FCE Reset Status"]
            #[inline]
            pub fn fcers(&self) -> FCERSR {
                FCERSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - USB Reset Status"]
            #[inline]
            pub fn usbrs(&self) -> USBRSR {
                USBRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "RCU Peripheral 2 Reset Set"]
    pub struct PRSET2 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 2 Reset Set"]
    pub mod prset2 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRSET2 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `WDTRS`"]
        pub enum WDTRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl WDTRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTRSW::VALUE1 => false,
                    WDTRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTRSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DMA0RS`"]
        pub enum DMA0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl DMA0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DMA0RSW::VALUE1 => false,
                    DMA0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMA0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMA0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMA0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMA0RSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMA0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FCERS`"]
        pub enum FCERSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl FCERSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FCERSW::VALUE1 => false,
                    FCERSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCERSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCERSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FCERSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FCERSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FCERSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBRS`"]
        pub enum USBRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "Assert reset"]
            VALUE2,
        }
        impl USBRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBRSW::VALUE1 => false,
                    USBRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBRSW::VALUE1)
            }
            #[doc = "Assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 1 - WDT Reset Assert"]
            #[inline]
            pub fn wdtrs(&mut self) -> _WDTRSW {
                _WDTRSW { w: self }
            }
            #[doc = "Bit 4 - DMA0 Reset Assert"]
            #[inline]
            pub fn dma0rs(&mut self) -> _DMA0RSW {
                _DMA0RSW { w: self }
            }
            #[doc = "Bit 6 - FCE Reset Assert"]
            #[inline]
            pub fn fcers(&mut self) -> _FCERSW {
                _FCERSW { w: self }
            }
            #[doc = "Bit 7 - USB Reset Assert"]
            #[inline]
            pub fn usbrs(&mut self) -> _USBRSW {
                _USBRSW { w: self }
            }
        }
    }
    #[doc = "RCU Peripheral 2 Reset Clear"]
    pub struct PRCLR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "RCU Peripheral 2 Reset Clear"]
    pub mod prclr2 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRCLR2 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `WDTRS`"]
        pub enum WDTRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl WDTRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WDTRSW::VALUE1 => false,
                    WDTRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WDTRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WDTRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WDTRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WDTRSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WDTRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DMA0RS`"]
        pub enum DMA0RSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl DMA0RSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DMA0RSW::VALUE1 => false,
                    DMA0RSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMA0RSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMA0RSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMA0RSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMA0RSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMA0RSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FCERS`"]
        pub enum FCERSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl FCERSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FCERSW::VALUE1 => false,
                    FCERSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FCERSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FCERSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FCERSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FCERSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FCERSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `USBRS`"]
        pub enum USBRSW {
            #[doc = "No effect"]
            VALUE1,
            #[doc = "De-assert reset"]
            VALUE2,
        }
        impl USBRSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    USBRSW::VALUE1 => false,
                    USBRSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBRSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: USBRSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(USBRSW::VALUE1)
            }
            #[doc = "De-assert reset"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(USBRSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 1 - WDT Reset Clear"]
            #[inline]
            pub fn wdtrs(&mut self) -> _WDTRSW {
                _WDTRSW { w: self }
            }
            #[doc = "Bit 4 - DMA0 Reset Clear"]
            #[inline]
            pub fn dma0rs(&mut self) -> _DMA0RSW {
                _DMA0RSW { w: self }
            }
            #[doc = "Bit 6 - FCE Reset Clear"]
            #[inline]
            pub fn fcers(&mut self) -> _FCERSW {
                _FCERSW { w: self }
            }
            #[doc = "Bit 7 - USB Reset Clear"]
            #[inline]
            pub fn usbrs(&mut self) -> _USBRSW {
                _USBRSW { w: self }
            }
        }
    }
}
#[doc = "System Control Unit"]
pub struct SCU_RESET {
    register_block: scu_reset::RegisterBlock,
}
impl Deref for SCU_RESET {
    type Target = scu_reset::RegisterBlock;
    fn deref(&self) -> &scu_reset::RegisterBlock {
        &self.register_block
    }
}
#[doc = "LED and Touch Sense Unit 0"]
pub const LEDTS0: Peripheral<LEDTS0> = unsafe { Peripheral::new(0x4801_0000) };
#[doc = "LED and Touch Sense Unit 0"]
pub mod ledts0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Module Identification Register"]
        pub id: ID,
        #[doc = "0x04 - Global Control Register"]
        pub globctl: GLOBCTL,
        #[doc = "0x08 - Function Control Register"]
        pub fnctl: FNCTL,
        #[doc = "0x0c - Event Flag Register"]
        pub evfr: EVFR,
        #[doc = "0x10 - Touch-sense TS-Counter Value"]
        pub tsval: TSVAL,
        #[doc = "0x14 - Line Pattern Register 0"]
        pub line0: LINE0,
        #[doc = "0x18 - Line Pattern Register 1"]
        pub line1: LINE1,
        #[doc = "0x1c - LED Compare Register 0"]
        pub ldcmp0: LDCMP0,
        #[doc = "0x20 - LED Compare Register 1"]
        pub ldcmp1: LDCMP1,
        #[doc = "0x24 - Touch-sense Compare Register 0"]
        pub tscmp0: TSCMP0,
        #[doc = "0x28 - Touch-sense Compare Register 1"]
        pub tscmp1: TSCMP1,
    }
    #[doc = "Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision Number"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number Value"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "Global Control Register"]
    pub struct GLOBCTL {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Control Register"]
    pub mod globctl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBCTL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TS_ENR {
            bits: bool,
        }
        impl TS_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct LD_ENR {
            bits: bool,
        }
        impl LD_ENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `CMTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMTRR {
            #[doc = "Kernel generates its own clock for LEDTS-counter based on SFR setting"]
            VALUE1,
            #[doc = "LEDTS-counter takes its clock from another master kernel"]
            VALUE2,
        }
        impl CMTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMTRR::VALUE1 => false,
                    CMTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMTRR {
                match value {
                    false => CMTRR::VALUE1,
                    true => CMTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENSYNC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENSYNCR {
            #[doc = "No synchronization"]
            VALUE1,
            #[doc = "Synchronization enabled on Kernel0 autoscan time period"]
            VALUE2,
        }
        impl ENSYNCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENSYNCR::VALUE1 => false,
                    ENSYNCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENSYNCR {
                match value {
                    false => ENSYNCR::VALUE1,
                    true => ENSYNCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENSYNCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENSYNCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SUSCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSCFGR {
            #[doc = "Ignore suspend request"]
            VALUE1,
            #[doc = "Enable suspend according to request"]
            VALUE2,
        }
        impl SUSCFGR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SUSCFGR::VALUE1 => false,
                    SUSCFGR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SUSCFGR {
                match value {
                    false => SUSCFGR::VALUE1,
                    true => SUSCFGR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSCFGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MASKVAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MASKVALR {
            #[doc = "Mask LSB bit"]
            VALUE1,
            #[doc = "Mask 2 LSB bits"]
            VALUE2,
            #[doc = "Mask 8 LSB bits"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MASKVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MASKVALR::VALUE1 => 0,
                    MASKVALR::VALUE2 => 0x01,
                    MASKVALR::VALUE3 => 0x07,
                    MASKVALR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MASKVALR {
                match value {
                    0 => MASKVALR::VALUE1,
                    1 => MASKVALR::VALUE2,
                    7 => MASKVALR::VALUE3,
                    i => MASKVALR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MASKVALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MASKVALR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MASKVALR::VALUE3
            }
        }
        #[doc = "Possible values of the field `FENVAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FENVALR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl FENVALR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FENVALR::VALUE1 => false,
                    FENVALR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FENVALR {
                match value {
                    false => FENVALR::VALUE1,
                    true => FENVALR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FENVALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FENVALR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ITS_EN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ITS_ENR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl ITS_ENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ITS_ENR::VALUE1 => false,
                    ITS_ENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ITS_ENR {
                match value {
                    false => ITS_ENR::VALUE1,
                    true => ITS_ENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ITS_ENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ITS_ENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ITF_EN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ITF_ENR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl ITF_ENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ITF_ENR::VALUE1 => false,
                    ITF_ENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ITF_ENR {
                match value {
                    false => ITF_ENR::VALUE1,
                    true => ITF_ENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ITF_ENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ITF_ENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ITP_EN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ITP_ENR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable (valid only for case of hardware-enabled pad turn control)"]
            VALUE2,
        }
        impl ITP_ENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ITP_ENR::VALUE1 => false,
                    ITP_ENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ITP_ENR {
                match value {
                    false => ITP_ENR::VALUE1,
                    true => ITP_ENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ITP_ENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ITP_ENR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CLK_PSR {
            bits: u16,
        }
        impl CLK_PSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _TS_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TS_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LD_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LD_ENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMTR`"]
        pub enum CMTRW {
            #[doc = "Kernel generates its own clock for LEDTS-counter based on SFR setting"]
            VALUE1,
            #[doc = "LEDTS-counter takes its clock from another master kernel"]
            VALUE2,
        }
        impl CMTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMTRW::VALUE1 => false,
                    CMTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Kernel generates its own clock for LEDTS-counter based on SFR setting"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMTRW::VALUE1)
            }
            #[doc = "LEDTS-counter takes its clock from another master kernel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENSYNC`"]
        pub enum ENSYNCW {
            #[doc = "No synchronization"]
            VALUE1,
            #[doc = "Synchronization enabled on Kernel0 autoscan time period"]
            VALUE2,
        }
        impl ENSYNCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENSYNCW::VALUE1 => false,
                    ENSYNCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENSYNCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENSYNCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENSYNCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No synchronization"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENSYNCW::VALUE1)
            }
            #[doc = "Synchronization enabled on Kernel0 autoscan time period"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENSYNCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUSCFG`"]
        pub enum SUSCFGW {
            #[doc = "Ignore suspend request"]
            VALUE1,
            #[doc = "Enable suspend according to request"]
            VALUE2,
        }
        impl SUSCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SUSCFGW::VALUE1 => false,
                    SUSCFGW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUSCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUSCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUSCFGW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore suspend request"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE1)
            }
            #[doc = "Enable suspend according to request"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MASKVAL`"]
        pub enum MASKVALW {
            #[doc = "Mask LSB bit"]
            VALUE1,
            #[doc = "Mask 2 LSB bits"]
            VALUE2,
            #[doc = "Mask 8 LSB bits"]
            VALUE3,
        }
        impl MASKVALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MASKVALW::VALUE1 => 0,
                    MASKVALW::VALUE2 => 1,
                    MASKVALW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MASKVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MASKVALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MASKVALW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Mask LSB bit"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MASKVALW::VALUE1)
            }
            #[doc = "Mask 2 LSB bits"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MASKVALW::VALUE2)
            }
            #[doc = "Mask 8 LSB bits"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MASKVALW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FENVAL`"]
        pub enum FENVALW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl FENVALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FENVALW::VALUE1 => false,
                    FENVALW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FENVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FENVALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FENVALW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FENVALW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FENVALW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ITS_EN`"]
        pub enum ITS_ENW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl ITS_ENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ITS_ENW::VALUE1 => false,
                    ITS_ENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ITS_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ITS_ENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ITS_ENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ITS_ENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ITS_ENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ITF_EN`"]
        pub enum ITF_ENW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl ITF_ENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ITF_ENW::VALUE1 => false,
                    ITF_ENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ITF_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ITF_ENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ITF_ENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ITF_ENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ITF_ENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ITP_EN`"]
        pub enum ITP_ENW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable (valid only for case of hardware-enabled pad turn control)"]
            VALUE2,
        }
        impl ITP_ENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ITP_ENW::VALUE1 => false,
                    ITP_ENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ITP_ENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ITP_ENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ITP_ENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ITP_ENW::VALUE1)
            }
            #[doc = "Enable (valid only for case of hardware-enabled pad turn control)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ITP_ENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLK_PSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLK_PSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Touch-Sense Function Enable"]
            #[inline]
            pub fn ts_en(&self) -> TS_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TS_ENR { bits }
            }
            #[doc = "Bit 1 - LED Function Enable"]
            #[inline]
            pub fn ld_en(&self) -> LD_ENR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                LD_ENR { bits }
            }
            #[doc = "Bit 2 - Clock Master Disable"]
            #[inline]
            pub fn cmtr(&self) -> CMTRR {
                CMTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Enable Autoscan Time Period Synchronization"]
            #[inline]
            pub fn ensync(&self) -> ENSYNCR {
                ENSYNCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Suspend Request Configuration"]
            #[inline]
            pub fn suscfg(&self) -> SUSCFGR {
                SUSCFGR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:11 - Mask Number of LSB Bits for Event Validation"]
            #[inline]
            pub fn maskval(&self) -> MASKVALR {
                MASKVALR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 12 - Enable (Extended) Time Frame Validation"]
            #[inline]
            pub fn fenval(&self) -> FENVALR {
                FENVALR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Enable Time Slice Interrupt"]
            #[inline]
            pub fn its_en(&self) -> ITS_ENR {
                ITS_ENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Enable (Extended) Time Frame Interrupt"]
            #[inline]
            pub fn itf_en(&self) -> ITF_ENR {
                ITF_ENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Enable Autoscan Time Period Interrupt"]
            #[inline]
            pub fn itp_en(&self) -> ITP_ENR {
                ITP_ENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:31 - LEDTS-Counter Clock Pre-Scale Factor"]
            #[inline]
            pub fn clk_ps(&self) -> CLK_PSR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CLK_PSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Touch-Sense Function Enable"]
            #[inline]
            pub fn ts_en(&mut self) -> _TS_ENW {
                _TS_ENW { w: self }
            }
            #[doc = "Bit 1 - LED Function Enable"]
            #[inline]
            pub fn ld_en(&mut self) -> _LD_ENW {
                _LD_ENW { w: self }
            }
            #[doc = "Bit 2 - Clock Master Disable"]
            #[inline]
            pub fn cmtr(&mut self) -> _CMTRW {
                _CMTRW { w: self }
            }
            #[doc = "Bit 3 - Enable Autoscan Time Period Synchronization"]
            #[inline]
            pub fn ensync(&mut self) -> _ENSYNCW {
                _ENSYNCW { w: self }
            }
            #[doc = "Bit 8 - Suspend Request Configuration"]
            #[inline]
            pub fn suscfg(&mut self) -> _SUSCFGW {
                _SUSCFGW { w: self }
            }
            #[doc = "Bits 9:11 - Mask Number of LSB Bits for Event Validation"]
            #[inline]
            pub fn maskval(&mut self) -> _MASKVALW {
                _MASKVALW { w: self }
            }
            #[doc = "Bit 12 - Enable (Extended) Time Frame Validation"]
            #[inline]
            pub fn fenval(&mut self) -> _FENVALW {
                _FENVALW { w: self }
            }
            #[doc = "Bit 13 - Enable Time Slice Interrupt"]
            #[inline]
            pub fn its_en(&mut self) -> _ITS_ENW {
                _ITS_ENW { w: self }
            }
            #[doc = "Bit 14 - Enable (Extended) Time Frame Interrupt"]
            #[inline]
            pub fn itf_en(&mut self) -> _ITF_ENW {
                _ITF_ENW { w: self }
            }
            #[doc = "Bit 15 - Enable Autoscan Time Period Interrupt"]
            #[inline]
            pub fn itp_en(&mut self) -> _ITP_ENW {
                _ITP_ENW { w: self }
            }
            #[doc = "Bits 16:31 - LEDTS-Counter Clock Pre-Scale Factor"]
            #[inline]
            pub fn clk_ps(&mut self) -> _CLK_PSW {
                _CLK_PSW { w: self }
            }
        }
    }
    #[doc = "Function Control Register"]
    pub struct FNCTL {
        register: VolatileCell<u32>,
    }
    #[doc = "Function Control Register"]
    pub mod fnctl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FNCTL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PADT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PADTR {
            #[doc = "TSIN0"]
            VALUE1,
            #[doc = "TSIN7"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PADTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PADTR::VALUE1 => 0,
                    PADTR::VALUE2 => 0x07,
                    PADTR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PADTR {
                match value {
                    0 => PADTR::VALUE1,
                    7 => PADTR::VALUE2,
                    i => PADTR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PADTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PADTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PADTSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PADTSWR {
            #[doc = "The hardware automatically enables the touch-sense inputs in sequence round-robin, starting from TSIN0."]
            VALUE1,
            #[doc = "Disable hardware control for software control only. The touch-sense input is configured in bit PADT."]
            VALUE2,
        }
        impl PADTSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PADTSWR::VALUE1 => false,
                    PADTSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PADTSWR {
                match value {
                    false => PADTSWR::VALUE1,
                    true => PADTSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PADTSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PADTSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EPULL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPULLR {
            #[doc = "HW over-rule to enable internal pull-up is active on TSIN[x] for set duration in touch-sense time slice. With this setting, it is not specified to assign the COLA to any pin."]
            VALUE1,
            #[doc = "Enable external pull-up: Output 1 on pin COLA for whole duration of touch-sense time slice."]
            VALUE2,
        }
        impl EPULLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EPULLR::VALUE1 => false,
                    EPULLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EPULLR {
                match value {
                    false => EPULLR::VALUE1,
                    true => EPULLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPULLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPULLR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct FNCOLR {
            bits: u8,
        }
        impl FNCOLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ACCCNT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACCCNTR {
            #[doc = "1 time"]
            VALUE1,
            #[doc = "2 times"]
            VALUE2,
            #[doc = "16 times"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ACCCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ACCCNTR::VALUE1 => 0,
                    ACCCNTR::VALUE2 => 0x01,
                    ACCCNTR::VALUE3 => 0x0f,
                    ACCCNTR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ACCCNTR {
                match value {
                    0 => ACCCNTR::VALUE1,
                    1 => ACCCNTR::VALUE2,
                    15 => ACCCNTR::VALUE3,
                    i => ACCCNTR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACCCNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACCCNTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ACCCNTR::VALUE3
            }
        }
        #[doc = "Possible values of the field `TSCCMP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSCCMPR {
            #[doc = "Disable common compare for touch-sense"]
            VALUE1,
            #[doc = "Enable common compare for touch-sense"]
            VALUE2,
        }
        impl TSCCMPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSCCMPR::VALUE1 => false,
                    TSCCMPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSCCMPR {
                match value {
                    false => TSCCMPR::VALUE1,
                    true => TSCCMPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSCCMPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSCCMPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSOEXT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSOEXTR {
            #[doc = "Extend by 1 ledts_clk"]
            VALUE1,
            #[doc = "Extend by 4 ledts_clk"]
            VALUE2,
            #[doc = "Extend by 8 ledts_clk"]
            VALUE3,
            #[doc = "Extend by 16 ledts_clk"]
            VALUE4,
        }
        impl TSOEXTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TSOEXTR::VALUE1 => 0,
                    TSOEXTR::VALUE2 => 0x01,
                    TSOEXTR::VALUE3 => 0x02,
                    TSOEXTR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TSOEXTR {
                match value {
                    0 => TSOEXTR::VALUE1,
                    1 => TSOEXTR::VALUE2,
                    2 => TSOEXTR::VALUE3,
                    3 => TSOEXTR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSOEXTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSOEXTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TSOEXTR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TSOEXTR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TSCTRR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSCTRRR {
            #[doc = "Disable TS-counter automatic reset"]
            VALUE1,
            #[doc = "Enable TS-counter automatic reset to 00H on the first pad turn of a new TSIN[x]. Triggered on compare match in time slice."]
            VALUE2,
        }
        impl TSCTRRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSCTRRR::VALUE1 => false,
                    TSCTRRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSCTRRR {
                match value {
                    false => TSCTRRR::VALUE1,
                    true => TSCTRRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSCTRRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSCTRRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSCTRSAT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSCTRSATR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable. TS-counter stops counting in the touch-sense time slice(s) of the same (extended) frame when it reaches FFH. Counter starts to count again on the first pad turn of a new TSIN[x], triggered on compare match."]
            VALUE2,
        }
        impl TSCTRSATR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSCTRSATR::VALUE1 => false,
                    TSCTRSATR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSCTRSATR {
                match value {
                    false => TSCTRSATR::VALUE1,
                    true => TSCTRSATR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSCTRSATR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSCTRSATR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NR_TSIN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NR_TSINR {
            #[doc = "1"]
            VALUE1,
            #[doc = "8"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl NR_TSINR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    NR_TSINR::VALUE1 => 0,
                    NR_TSINR::VALUE2 => 0x07,
                    NR_TSINR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> NR_TSINR {
                match value {
                    0 => NR_TSINR::VALUE1,
                    7 => NR_TSINR::VALUE2,
                    i => NR_TSINR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NR_TSINR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NR_TSINR::VALUE2
            }
        }
        #[doc = "Possible values of the field `COLLEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum COLLEVR {
            #[doc = "Active low"]
            VALUE1,
            #[doc = "Active high"]
            VALUE2,
        }
        impl COLLEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    COLLEVR::VALUE1 => false,
                    COLLEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> COLLEVR {
                match value {
                    false => COLLEVR::VALUE1,
                    true => COLLEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == COLLEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == COLLEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NR_LEDCOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NR_LEDCOLR {
            #[doc = "1 LED column"]
            VALUE1,
            #[doc = "2 LED columns"]
            VALUE2,
            #[doc = "3 LED columns"]
            VALUE3,
            #[doc = "4 LED columns"]
            VALUE4,
            #[doc = "5 LED columns"]
            VALUE5,
            #[doc = "6 LED columns"]
            VALUE6,
            #[doc = "7 LED columns"]
            VALUE7,
            #[doc = "8 LED columns (max. LED columns = 7 if bit TS_EN = 1)"]
            VALUE8,
        }
        impl NR_LEDCOLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    NR_LEDCOLR::VALUE1 => 0,
                    NR_LEDCOLR::VALUE2 => 0x01,
                    NR_LEDCOLR::VALUE3 => 0x02,
                    NR_LEDCOLR::VALUE4 => 0x03,
                    NR_LEDCOLR::VALUE5 => 0x04,
                    NR_LEDCOLR::VALUE6 => 0x05,
                    NR_LEDCOLR::VALUE7 => 0x06,
                    NR_LEDCOLR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> NR_LEDCOLR {
                match value {
                    0 => NR_LEDCOLR::VALUE1,
                    1 => NR_LEDCOLR::VALUE2,
                    2 => NR_LEDCOLR::VALUE3,
                    3 => NR_LEDCOLR::VALUE4,
                    4 => NR_LEDCOLR::VALUE5,
                    5 => NR_LEDCOLR::VALUE6,
                    6 => NR_LEDCOLR::VALUE7,
                    7 => NR_LEDCOLR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NR_LEDCOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NR_LEDCOLR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == NR_LEDCOLR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == NR_LEDCOLR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == NR_LEDCOLR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == NR_LEDCOLR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == NR_LEDCOLR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == NR_LEDCOLR::VALUE8
            }
        }
        #[doc = "Values that can be written to the field `PADT`"]
        pub enum PADTW {
            #[doc = "TSIN0"]
            VALUE1,
            #[doc = "TSIN7"]
            VALUE2,
        }
        impl PADTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PADTW::VALUE1 => 0,
                    PADTW::VALUE2 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PADTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PADTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PADTW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "TSIN0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PADTW::VALUE1)
            }
            #[doc = "TSIN7"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PADTW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PADTSW`"]
        pub enum PADTSWW {
            #[doc = "The hardware automatically enables the touch-sense inputs in sequence round-robin, starting from TSIN0."]
            VALUE1,
            #[doc = "Disable hardware control for software control only. The touch-sense input is configured in bit PADT."]
            VALUE2,
        }
        impl PADTSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PADTSWW::VALUE1 => false,
                    PADTSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PADTSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PADTSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PADTSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The hardware automatically enables the touch-sense inputs in sequence round-robin, starting from TSIN0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PADTSWW::VALUE1)
            }
            #[doc = "Disable hardware control for software control only. The touch-sense input is configured in bit PADT."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PADTSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EPULL`"]
        pub enum EPULLW {
            #[doc = "HW over-rule to enable internal pull-up is active on TSIN[x] for set duration in touch-sense time slice. With this setting, it is not specified to assign the COLA to any pin."]
            VALUE1,
            #[doc = "Enable external pull-up: Output 1 on pin COLA for whole duration of touch-sense time slice."]
            VALUE2,
        }
        impl EPULLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EPULLW::VALUE1 => false,
                    EPULLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPULLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPULLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPULLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HW over-rule to enable internal pull-up is active on TSIN[x] for set duration in touch-sense time slice. With this setting, it is not specified to assign the COLA to any pin."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPULLW::VALUE1)
            }
            #[doc = "Enable external pull-up: Output 1 on pin COLA for whole duration of touch-sense time slice."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPULLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ACCCNT`"]
        pub enum ACCCNTW {
            #[doc = "1 time"]
            VALUE1,
            #[doc = "2 times"]
            VALUE2,
            #[doc = "16 times"]
            VALUE3,
        }
        impl ACCCNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ACCCNTW::VALUE1 => 0,
                    ACCCNTW::VALUE2 => 1,
                    ACCCNTW::VALUE3 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACCCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACCCNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACCCNTW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "1 time"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACCCNTW::VALUE1)
            }
            #[doc = "2 times"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACCCNTW::VALUE2)
            }
            #[doc = "16 times"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ACCCNTW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSCCMP`"]
        pub enum TSCCMPW {
            #[doc = "Disable common compare for touch-sense"]
            VALUE1,
            #[doc = "Enable common compare for touch-sense"]
            VALUE2,
        }
        impl TSCCMPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSCCMPW::VALUE1 => false,
                    TSCCMPW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSCCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSCCMPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSCCMPW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable common compare for touch-sense"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSCCMPW::VALUE1)
            }
            #[doc = "Enable common compare for touch-sense"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSCCMPW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSOEXT`"]
        pub enum TSOEXTW {
            #[doc = "Extend by 1 ledts_clk"]
            VALUE1,
            #[doc = "Extend by 4 ledts_clk"]
            VALUE2,
            #[doc = "Extend by 8 ledts_clk"]
            VALUE3,
            #[doc = "Extend by 16 ledts_clk"]
            VALUE4,
        }
        impl TSOEXTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TSOEXTW::VALUE1 => 0,
                    TSOEXTW::VALUE2 => 1,
                    TSOEXTW::VALUE3 => 2,
                    TSOEXTW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSOEXTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSOEXTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSOEXTW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Extend by 1 ledts_clk"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSOEXTW::VALUE1)
            }
            #[doc = "Extend by 4 ledts_clk"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSOEXTW::VALUE2)
            }
            #[doc = "Extend by 8 ledts_clk"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TSOEXTW::VALUE3)
            }
            #[doc = "Extend by 16 ledts_clk"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TSOEXTW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSCTRR`"]
        pub enum TSCTRRW {
            #[doc = "Disable TS-counter automatic reset"]
            VALUE1,
            #[doc = "Enable TS-counter automatic reset to 00H on the first pad turn of a new TSIN[x]. Triggered on compare match in time slice."]
            VALUE2,
        }
        impl TSCTRRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSCTRRW::VALUE1 => false,
                    TSCTRRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSCTRRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSCTRRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSCTRRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable TS-counter automatic reset"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSCTRRW::VALUE1)
            }
            #[doc = "Enable TS-counter automatic reset to 00H on the first pad turn of a new TSIN[x]. Triggered on compare match in time slice."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSCTRRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSCTRSAT`"]
        pub enum TSCTRSATW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable. TS-counter stops counting in the touch-sense time slice(s) of the same (extended) frame when it reaches FFH. Counter starts to count again on the first pad turn of a new TSIN[x], triggered on compare match."]
            VALUE2,
        }
        impl TSCTRSATW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSCTRSATW::VALUE1 => false,
                    TSCTRSATW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSCTRSATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSCTRSATW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSCTRSATW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSCTRSATW::VALUE1)
            }
            #[doc = "Enable. TS-counter stops counting in the touch-sense time slice(s) of the same (extended) frame when it reaches FFH. Counter starts to count again on the first pad turn of a new TSIN[x], triggered on compare match."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSCTRSATW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NR_TSIN`"]
        pub enum NR_TSINW {
            #[doc = "1"]
            VALUE1,
            #[doc = "8"]
            VALUE2,
        }
        impl NR_TSINW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NR_TSINW::VALUE1 => 0,
                    NR_TSINW::VALUE2 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NR_TSINW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NR_TSINW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NR_TSINW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NR_TSINW::VALUE1)
            }
            #[doc = "8"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NR_TSINW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `COLLEV`"]
        pub enum COLLEVW {
            #[doc = "Active low"]
            VALUE1,
            #[doc = "Active high"]
            VALUE2,
        }
        impl COLLEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    COLLEVW::VALUE1 => false,
                    COLLEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _COLLEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _COLLEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: COLLEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active low"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(COLLEVW::VALUE1)
            }
            #[doc = "Active high"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(COLLEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NR_LEDCOL`"]
        pub enum NR_LEDCOLW {
            #[doc = "1 LED column"]
            VALUE1,
            #[doc = "2 LED columns"]
            VALUE2,
            #[doc = "3 LED columns"]
            VALUE3,
            #[doc = "4 LED columns"]
            VALUE4,
            #[doc = "5 LED columns"]
            VALUE5,
            #[doc = "6 LED columns"]
            VALUE6,
            #[doc = "7 LED columns"]
            VALUE7,
            #[doc = "8 LED columns (max. LED columns = 7 if bit TS_EN = 1)"]
            VALUE8,
        }
        impl NR_LEDCOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NR_LEDCOLW::VALUE1 => 0,
                    NR_LEDCOLW::VALUE2 => 1,
                    NR_LEDCOLW::VALUE3 => 2,
                    NR_LEDCOLW::VALUE4 => 3,
                    NR_LEDCOLW::VALUE5 => 4,
                    NR_LEDCOLW::VALUE6 => 5,
                    NR_LEDCOLW::VALUE7 => 6,
                    NR_LEDCOLW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NR_LEDCOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NR_LEDCOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NR_LEDCOLW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "1 LED column"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE1)
            }
            #[doc = "2 LED columns"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE2)
            }
            #[doc = "3 LED columns"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE3)
            }
            #[doc = "4 LED columns"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE4)
            }
            #[doc = "5 LED columns"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE5)
            }
            #[doc = "6 LED columns"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE6)
            }
            #[doc = "7 LED columns"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE7)
            }
            #[doc = "8 LED columns (max. LED columns = 7 if bit TS_EN = 1)"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(NR_LEDCOLW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Touch-Sense TSIN Pad Turn"]
            #[inline]
            pub fn padt(&self) -> PADTR {
                PADTR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Software Control for Touch-Sense Pad Turn"]
            #[inline]
            pub fn padtsw(&self) -> PADTSWR {
                PADTSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Enable External Pull-up Configuration on Pin COLA"]
            #[inline]
            pub fn epull(&self) -> EPULLR {
                EPULLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 5:7 - Previous Active Function/LED Column Status"]
            #[inline]
            pub fn fncol(&self) -> FNCOLR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FNCOLR { bits }
            }
            #[doc = "Bits 16:19 - Accumulate Count on Touch-Sense Input"]
            #[inline]
            pub fn acccnt(&self) -> ACCCNTR {
                ACCCNTR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Common Compare Enable for Touch-Sense"]
            #[inline]
            pub fn tsccmp(&self) -> TSCCMPR {
                TSCCMPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 21:22 - Extension for Touch-Sense Output for Pin-Low-Level"]
            #[inline]
            pub fn tsoext(&self) -> TSOEXTR {
                TSOEXTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 23 - TS-Counter Auto Reset"]
            #[inline]
            pub fn tsctrr(&self) -> TSCTRRR {
                TSCTRRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Saturation of TS-Counter"]
            #[inline]
            pub fn tsctrsat(&self) -> TSCTRSATR {
                TSCTRSATR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 25:27 - Number of Touch-Sense Input"]
            #[inline]
            pub fn nr_tsin(&self) -> NR_TSINR {
                NR_TSINR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 28 - Active Level of LED Column"]
            #[inline]
            pub fn collev(&self) -> COLLEVR {
                COLLEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 29:31 - Number of LED Columns"]
            #[inline]
            pub fn nr_ledcol(&self) -> NR_LEDCOLR {
                NR_LEDCOLR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Touch-Sense TSIN Pad Turn"]
            #[inline]
            pub fn padt(&mut self) -> _PADTW {
                _PADTW { w: self }
            }
            #[doc = "Bit 3 - Software Control for Touch-Sense Pad Turn"]
            #[inline]
            pub fn padtsw(&mut self) -> _PADTSWW {
                _PADTSWW { w: self }
            }
            #[doc = "Bit 4 - Enable External Pull-up Configuration on Pin COLA"]
            #[inline]
            pub fn epull(&mut self) -> _EPULLW {
                _EPULLW { w: self }
            }
            #[doc = "Bits 16:19 - Accumulate Count on Touch-Sense Input"]
            #[inline]
            pub fn acccnt(&mut self) -> _ACCCNTW {
                _ACCCNTW { w: self }
            }
            #[doc = "Bit 20 - Common Compare Enable for Touch-Sense"]
            #[inline]
            pub fn tsccmp(&mut self) -> _TSCCMPW {
                _TSCCMPW { w: self }
            }
            #[doc = "Bits 21:22 - Extension for Touch-Sense Output for Pin-Low-Level"]
            #[inline]
            pub fn tsoext(&mut self) -> _TSOEXTW {
                _TSOEXTW { w: self }
            }
            #[doc = "Bit 23 - TS-Counter Auto Reset"]
            #[inline]
            pub fn tsctrr(&mut self) -> _TSCTRRW {
                _TSCTRRW { w: self }
            }
            #[doc = "Bit 24 - Saturation of TS-Counter"]
            #[inline]
            pub fn tsctrsat(&mut self) -> _TSCTRSATW {
                _TSCTRSATW { w: self }
            }
            #[doc = "Bits 25:27 - Number of Touch-Sense Input"]
            #[inline]
            pub fn nr_tsin(&mut self) -> _NR_TSINW {
                _NR_TSINW { w: self }
            }
            #[doc = "Bit 28 - Active Level of LED Column"]
            #[inline]
            pub fn collev(&mut self) -> _COLLEVW {
                _COLLEVW { w: self }
            }
            #[doc = "Bits 29:31 - Number of LED Columns"]
            #[inline]
            pub fn nr_ledcol(&mut self) -> _NR_LEDCOLW {
                _NR_LEDCOLW { w: self }
            }
        }
    }
    #[doc = "Event Flag Register"]
    pub struct EVFR {
        register: VolatileCell<u32>,
    }
    #[doc = "Event Flag Register"]
    pub mod evfr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EVFR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TSFR {
            bits: bool,
        }
        impl TSFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TFFR {
            bits: bool,
        }
        impl TFFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TPFR {
            bits: bool,
        }
        impl TPFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TSCTROVF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSCTROVFR {
            #[doc = "No overflow has occurred."]
            VALUE1,
            #[doc = "The TS-counter has overflowed at least once."]
            VALUE2,
        }
        impl TSCTROVFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSCTROVFR::VALUE1 => false,
                    TSCTROVFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSCTROVFR {
                match value {
                    false => TSCTROVFR::VALUE1,
                    true => TSCTROVFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSCTROVFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSCTROVFR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CTSF`"]
        pub enum CTSFW {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bit TSF is cleared."]
            VALUE2,
        }
        impl CTSFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CTSFW::VALUE1 => false,
                    CTSFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTSFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTSFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTSFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTSFW::VALUE1)
            }
            #[doc = "Bit TSF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTSFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTFF`"]
        pub enum CTFFW {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bit TFF is cleared."]
            VALUE2,
        }
        impl CTFFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CTFFW::VALUE1 => false,
                    CTFFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTFFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTFFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTFFW::VALUE1)
            }
            #[doc = "Bit TFF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTFFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTPF`"]
        pub enum CTPFW {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bit TPF is cleared."]
            VALUE2,
        }
        impl CTPFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CTPFW::VALUE1 => false,
                    CTPFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTPFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTPFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTPFW::VALUE1)
            }
            #[doc = "Bit TPF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTPFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Time Slice Interrupt Flag"]
            #[inline]
            pub fn tsf(&self) -> TSFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TSFR { bits }
            }
            #[doc = "Bit 1 - (Extended) Time Frame Interrupt Flag"]
            #[inline]
            pub fn tff(&self) -> TFFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TFFR { bits }
            }
            #[doc = "Bit 2 - Autoscan Time Period Interrupt Flag"]
            #[inline]
            pub fn tpf(&self) -> TPFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TPFR { bits }
            }
            #[doc = "Bit 3 - TS-Counter Overflow Indication"]
            #[inline]
            pub fn tsctrovf(&self) -> TSCTROVFR {
                TSCTROVFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 16 - Clear Time Slice Interrupt Flag"]
            #[inline]
            pub fn ctsf(&mut self) -> _CTSFW {
                _CTSFW { w: self }
            }
            #[doc = "Bit 17 - Clear (Extended) Time Frame Interrupt Flag"]
            #[inline]
            pub fn ctff(&mut self) -> _CTFFW {
                _CTFFW { w: self }
            }
            #[doc = "Bit 18 - Clear Autoscan Time Period Interrupt Flag"]
            #[inline]
            pub fn ctpf(&mut self) -> _CTPFW {
                _CTPFW { w: self }
            }
        }
    }
    #[doc = "Touch-sense TS-Counter Value"]
    pub struct TSVAL {
        register: VolatileCell<u32>,
    }
    #[doc = "Touch-sense TS-Counter Value"]
    pub mod tsval {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TSVAL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TSCTRVALRR {
            bits: u16,
        }
        impl TSCTRVALRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TSCTRVALR {
            bits: u16,
        }
        impl TSCTRVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSCTRVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSCTRVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Shadow TS-Counter (Read)"]
            #[inline]
            pub fn tsctrvalr(&self) -> TSCTRVALRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TSCTRVALRR { bits }
            }
            #[doc = "Bits 16:31 - TS-Counter Value"]
            #[inline]
            pub fn tsctrval(&self) -> TSCTRVALR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TSCTRVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 16:31 - TS-Counter Value"]
            #[inline]
            pub fn tsctrval(&mut self) -> _TSCTRVALW {
                _TSCTRVALW { w: self }
            }
        }
    }
    #[doc = "Line Pattern Register 0"]
    pub struct LINE0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Line Pattern Register 0"]
    pub mod line0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LINE0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_0R {
            bits: u8,
        }
        impl LINE_0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_1R {
            bits: u8,
        }
        impl LINE_1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_2R {
            bits: u8,
        }
        impl LINE_2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_3R {
            bits: u8,
        }
        impl LINE_3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Output on LINE[x]"]
            #[inline]
            pub fn line_0(&self) -> LINE_0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_0R { bits }
            }
            #[doc = "Bits 8:15 - Output on LINE[x]"]
            #[inline]
            pub fn line_1(&self) -> LINE_1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_1R { bits }
            }
            #[doc = "Bits 16:23 - Output on LINE[x]"]
            #[inline]
            pub fn line_2(&self) -> LINE_2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_2R { bits }
            }
            #[doc = "Bits 24:31 - Output on LINE[x]"]
            #[inline]
            pub fn line_3(&self) -> LINE_3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Output on LINE[x]"]
            #[inline]
            pub fn line_0(&mut self) -> _LINE_0W {
                _LINE_0W { w: self }
            }
            #[doc = "Bits 8:15 - Output on LINE[x]"]
            #[inline]
            pub fn line_1(&mut self) -> _LINE_1W {
                _LINE_1W { w: self }
            }
            #[doc = "Bits 16:23 - Output on LINE[x]"]
            #[inline]
            pub fn line_2(&mut self) -> _LINE_2W {
                _LINE_2W { w: self }
            }
            #[doc = "Bits 24:31 - Output on LINE[x]"]
            #[inline]
            pub fn line_3(&mut self) -> _LINE_3W {
                _LINE_3W { w: self }
            }
        }
    }
    #[doc = "Line Pattern Register 1"]
    pub struct LINE1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Line Pattern Register 1"]
    pub mod line1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LINE1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_4R {
            bits: u8,
        }
        impl LINE_4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_5R {
            bits: u8,
        }
        impl LINE_5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_6R {
            bits: u8,
        }
        impl LINE_6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LINE_AR {
            bits: u8,
        }
        impl LINE_AR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LINE_AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LINE_AW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Output on LINE[x]"]
            #[inline]
            pub fn line_4(&self) -> LINE_4R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_4R { bits }
            }
            #[doc = "Bits 8:15 - Output on LINE[x]"]
            #[inline]
            pub fn line_5(&self) -> LINE_5R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_5R { bits }
            }
            #[doc = "Bits 16:23 - Output on LINE[x]"]
            #[inline]
            pub fn line_6(&self) -> LINE_6R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_6R { bits }
            }
            #[doc = "Bits 24:31 - Output on LINE[x]"]
            #[inline]
            pub fn line_a(&self) -> LINE_AR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LINE_AR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Output on LINE[x]"]
            #[inline]
            pub fn line_4(&mut self) -> _LINE_4W {
                _LINE_4W { w: self }
            }
            #[doc = "Bits 8:15 - Output on LINE[x]"]
            #[inline]
            pub fn line_5(&mut self) -> _LINE_5W {
                _LINE_5W { w: self }
            }
            #[doc = "Bits 16:23 - Output on LINE[x]"]
            #[inline]
            pub fn line_6(&mut self) -> _LINE_6W {
                _LINE_6W { w: self }
            }
            #[doc = "Bits 24:31 - Output on LINE[x]"]
            #[inline]
            pub fn line_a(&mut self) -> _LINE_AW {
                _LINE_AW { w: self }
            }
        }
    }
    #[doc = "LED Compare Register 0"]
    pub struct LDCMP0 {
        register: VolatileCell<u32>,
    }
    #[doc = "LED Compare Register 0"]
    pub mod ldcmp0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LDCMP0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD0R {
            bits: u8,
        }
        impl CMP_LD0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD1R {
            bits: u8,
        }
        impl CMP_LD1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD2R {
            bits: u8,
        }
        impl CMP_LD2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD3R {
            bits: u8,
        }
        impl CMP_LD3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld0(&self) -> CMP_LD0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD0R { bits }
            }
            #[doc = "Bits 8:15 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld1(&self) -> CMP_LD1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD1R { bits }
            }
            #[doc = "Bits 16:23 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld2(&self) -> CMP_LD2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD2R { bits }
            }
            #[doc = "Bits 24:31 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld3(&self) -> CMP_LD3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld0(&mut self) -> _CMP_LD0W {
                _CMP_LD0W { w: self }
            }
            #[doc = "Bits 8:15 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld1(&mut self) -> _CMP_LD1W {
                _CMP_LD1W { w: self }
            }
            #[doc = "Bits 16:23 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld2(&mut self) -> _CMP_LD2W {
                _CMP_LD2W { w: self }
            }
            #[doc = "Bits 24:31 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld3(&mut self) -> _CMP_LD3W {
                _CMP_LD3W { w: self }
            }
        }
    }
    #[doc = "LED Compare Register 1"]
    pub struct LDCMP1 {
        register: VolatileCell<u32>,
    }
    #[doc = "LED Compare Register 1"]
    pub mod ldcmp1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::LDCMP1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD4R {
            bits: u8,
        }
        impl CMP_LD4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD5R {
            bits: u8,
        }
        impl CMP_LD5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LD6R {
            bits: u8,
        }
        impl CMP_LD6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_LDA_TSCOMR {
            bits: u8,
        }
        impl CMP_LDA_TSCOMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LD6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LD6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_LDA_TSCOMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_LDA_TSCOMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld4(&self) -> CMP_LD4R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD4R { bits }
            }
            #[doc = "Bits 8:15 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld5(&self) -> CMP_LD5R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD5R { bits }
            }
            #[doc = "Bits 16:23 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld6(&self) -> CMP_LD6R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LD6R { bits }
            }
            #[doc = "Bits 24:31 - Compare Value for LED COLA / Common Compare Value for Touch-sense Pad Turns"]
            #[inline]
            pub fn cmp_lda_tscom(&self) -> CMP_LDA_TSCOMR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_LDA_TSCOMR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld4(&mut self) -> _CMP_LD4W {
                _CMP_LD4W { w: self }
            }
            #[doc = "Bits 8:15 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld5(&mut self) -> _CMP_LD5W {
                _CMP_LD5W { w: self }
            }
            #[doc = "Bits 16:23 - Compare Value for LED COL[x]"]
            #[inline]
            pub fn cmp_ld6(&mut self) -> _CMP_LD6W {
                _CMP_LD6W { w: self }
            }
            #[doc = "Bits 24:31 - Compare Value for LED COLA / Common Compare Value for Touch-sense Pad Turns"]
            #[inline]
            pub fn cmp_lda_tscom(&mut self) -> _CMP_LDA_TSCOMW {
                _CMP_LDA_TSCOMW { w: self }
            }
        }
    }
    #[doc = "Touch-sense Compare Register 0"]
    pub struct TSCMP0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Touch-sense Compare Register 0"]
    pub mod tscmp0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TSCMP0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS0R {
            bits: u8,
        }
        impl CMP_TS0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS1R {
            bits: u8,
        }
        impl CMP_TS1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS2R {
            bits: u8,
        }
        impl CMP_TS2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS3R {
            bits: u8,
        }
        impl CMP_TS3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts0(&self) -> CMP_TS0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS0R { bits }
            }
            #[doc = "Bits 8:15 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts1(&self) -> CMP_TS1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS1R { bits }
            }
            #[doc = "Bits 16:23 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts2(&self) -> CMP_TS2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS2R { bits }
            }
            #[doc = "Bits 24:31 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts3(&self) -> CMP_TS3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts0(&mut self) -> _CMP_TS0W {
                _CMP_TS0W { w: self }
            }
            #[doc = "Bits 8:15 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts1(&mut self) -> _CMP_TS1W {
                _CMP_TS1W { w: self }
            }
            #[doc = "Bits 16:23 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts2(&mut self) -> _CMP_TS2W {
                _CMP_TS2W { w: self }
            }
            #[doc = "Bits 24:31 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts3(&mut self) -> _CMP_TS3W {
                _CMP_TS3W { w: self }
            }
        }
    }
    #[doc = "Touch-sense Compare Register 1"]
    pub struct TSCMP1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Touch-sense Compare Register 1"]
    pub mod tscmp1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TSCMP1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS4R {
            bits: u8,
        }
        impl CMP_TS4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS5R {
            bits: u8,
        }
        impl CMP_TS5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS6R {
            bits: u8,
        }
        impl CMP_TS6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CMP_TS7R {
            bits: u8,
        }
        impl CMP_TS7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMP_TS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMP_TS7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts4(&self) -> CMP_TS4R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS4R { bits }
            }
            #[doc = "Bits 8:15 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts5(&self) -> CMP_TS5R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS5R { bits }
            }
            #[doc = "Bits 16:23 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts6(&self) -> CMP_TS6R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS6R { bits }
            }
            #[doc = "Bits 24:31 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts7(&self) -> CMP_TS7R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CMP_TS7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts4(&mut self) -> _CMP_TS4W {
                _CMP_TS4W { w: self }
            }
            #[doc = "Bits 8:15 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts5(&mut self) -> _CMP_TS5W {
                _CMP_TS5W { w: self }
            }
            #[doc = "Bits 16:23 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts6(&mut self) -> _CMP_TS6W {
                _CMP_TS6W { w: self }
            }
            #[doc = "Bits 24:31 - Compare Value for Touch-Sense TSIN[x]"]
            #[inline]
            pub fn cmp_ts7(&mut self) -> _CMP_TS7W {
                _CMP_TS7W { w: self }
            }
        }
    }
}
#[doc = "LED and Touch Sense Unit 0"]
pub struct LEDTS0 {
    register_block: ledts0::RegisterBlock,
}
impl Deref for LEDTS0 {
    type Target = ledts0::RegisterBlock;
    fn deref(&self) -> &ledts0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0: Peripheral<USB0> = unsafe { Peripheral::new(0x5004_0000) };
#[doc = "Universal Serial Bus"]
pub mod usb0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        _reserved0: [u8; 8usize],
        #[doc = "0x08 - AHB Configuration Register"]
        pub gahbcfg: GAHBCFG,
        #[doc = "0x0c - USB Configuration Register"]
        pub gusbcfg: GUSBCFG,
        #[doc = "0x10 - Reset Register"]
        pub grstctl: GRSTCTL,
        #[doc = "0x14 - Interrupt Register"]
        pub gintsts: GINTSTS,
        #[doc = "0x18 - Interrupt Mask Register"]
        pub gintmsk: GINTMSK,
        #[doc = "0x1c - Receive Status Debug Read Register"]
        pub grxstsr: GRXSTSR,
        #[doc = "0x20 - Receive Status Read and Pop Register"]
        pub grxstsp: GRXSTSP,
        #[doc = "0x24 - Receive FIFO Size Register"]
        pub grxfsiz: GRXFSIZ,
        #[doc = "0x28 - Non-Periodic Transmit FIFO Size Register"]
        pub gnptxfsiz: GNPTXFSIZ,
        _reserved1: [u8; 16usize],
        #[doc = "0x3c - USB Module Identification Register"]
        pub guid: GUID,
        _reserved2: [u8; 28usize],
        #[doc = "0x5c - Global DFIFO Software Config Register"]
        pub gdfifocfg: GDFIFOCFG,
        _reserved3: [u8; 164usize],
        #[doc = "0x104 - Device IN Endpoint 1 Transmit FIFO Size Register"]
        pub dieptxf1: DIEPTXF1,
        #[doc = "0x108 - Device IN Endpoint 2 Transmit FIFO Size Register"]
        pub dieptxf2: DIEPTXF2,
        #[doc = "0x10c - Device IN Endpoint 3 Transmit FIFO Size Register"]
        pub dieptxf3: DIEPTXF3,
        #[doc = "0x110 - Device IN Endpoint 4 Transmit FIFO Size Register"]
        pub dieptxf4: DIEPTXF4,
        #[doc = "0x114 - Device IN Endpoint 5 Transmit FIFO Size Register"]
        pub dieptxf5: DIEPTXF5,
        #[doc = "0x118 - Device IN Endpoint 6 Transmit FIFO Size Register"]
        pub dieptxf6: DIEPTXF6,
        _reserved4: [u8; 1764usize],
        #[doc = "0x800 - Device Configuration Register"]
        pub dcfg: DCFG,
        #[doc = "0x804 - Device Control Register"]
        pub dctl: DCTL,
        #[doc = "0x808 - Device Status Register"]
        pub dsts: DSTS,
        _reserved5: [u8; 4usize],
        #[doc = "0x810 - Device IN Endpoint Common Interrupt Mask Register"]
        pub diepmsk: DIEPMSK,
        #[doc = "0x814 - Device OUT Endpoint Common Interrupt Mask Register"]
        pub doepmsk: DOEPMSK,
        #[doc = "0x818 - Device All Endpoints Interrupt Register"]
        pub daint: DAINT,
        #[doc = "0x81c - Device All Endpoints Interrupt Mask Register"]
        pub daintmsk: DAINTMSK,
        _reserved6: [u8; 8usize],
        #[doc = "0x828 - Device VBUS Discharge Time Register"]
        pub dvbusdis: DVBUSDIS,
        #[doc = "0x82c - Device VBUS Pulsing Time Register"]
        pub dvbuspulse: DVBUSPULSE,
        _reserved7: [u8; 4usize],
        #[doc = "0x834 - Device IN Endpoint FIFO Empty Interrupt Mask Register"]
        pub diepempmsk: DIEPEMPMSK,
        _reserved8: [u8; 1480usize],
        #[doc = "0xe00 - Power and Clock Gating Control Register"]
        pub pcgcctl: PCGCCTL,
    }
    #[doc = "AHB Configuration Register"]
    pub struct GAHBCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "AHB Configuration Register"]
    pub mod gahbcfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GAHBCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `GlblIntrMsk`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GLBLINTRMSKR {
            #[doc = "Mask the interrupt assertion to the application."]
            VALUE1,
            #[doc = "Unmask the interrupt assertion to the application."]
            VALUE2,
        }
        impl GLBLINTRMSKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GLBLINTRMSKR::VALUE1 => false,
                    GLBLINTRMSKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GLBLINTRMSKR {
                match value {
                    false => GLBLINTRMSKR::VALUE1,
                    true => GLBLINTRMSKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GLBLINTRMSKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GLBLINTRMSKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HBstLen`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HBSTLENR {
            #[doc = "Single"]
            VALUE1,
            #[doc = "INCR"]
            VALUE2,
            #[doc = "INCR4"]
            VALUE3,
            #[doc = "INCR8"]
            VALUE4,
            #[doc = "INCR16"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HBSTLENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HBSTLENR::VALUE1 => 0,
                    HBSTLENR::VALUE2 => 0x01,
                    HBSTLENR::VALUE3 => 0x03,
                    HBSTLENR::VALUE4 => 0x05,
                    HBSTLENR::VALUE5 => 0x07,
                    HBSTLENR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HBSTLENR {
                match value {
                    0 => HBSTLENR::VALUE1,
                    1 => HBSTLENR::VALUE2,
                    3 => HBSTLENR::VALUE3,
                    5 => HBSTLENR::VALUE4,
                    7 => HBSTLENR::VALUE5,
                    i => HBSTLENR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HBSTLENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HBSTLENR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HBSTLENR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == HBSTLENR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == HBSTLENR::VALUE5
            }
        }
        #[doc = "Possible values of the field `DMAEn`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DMAENR {
            #[doc = "Core operates in Slave mode"]
            VALUE1,
            #[doc = "Core operates in a DMA mode"]
            VALUE2,
        }
        impl DMAENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DMAENR::VALUE1 => false,
                    DMAENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DMAENR {
                match value {
                    false => DMAENR::VALUE1,
                    true => DMAENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DMAENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DMAENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NPTxFEmpLvl`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NPTXFEMPLVLR {
            #[doc = "DIEPINTx.TxFEmp interrupt indicates that the IN Endpoint TxFIFO is half empty"]
            VALUE1,
            #[doc = "DIEPINTx.TxFEmp interrupt indicates that the IN Endpoint TxFIFO is completely empty"]
            VALUE2,
        }
        impl NPTXFEMPLVLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NPTXFEMPLVLR::VALUE1 => false,
                    NPTXFEMPLVLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NPTXFEMPLVLR {
                match value {
                    false => NPTXFEMPLVLR::VALUE1,
                    true => NPTXFEMPLVLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NPTXFEMPLVLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NPTXFEMPLVLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AHBSingle`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AHBSINGLER {
            #[doc = "The remaining data in a transfer is sent using INCR burst size. This is the default mode."]
            VALUE1,
            #[doc = "The remaining data in a transfer is sent using single burst size."]
            VALUE2,
        }
        impl AHBSINGLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AHBSINGLER::VALUE1 => false,
                    AHBSINGLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AHBSINGLER {
                match value {
                    false => AHBSINGLER::VALUE1,
                    true => AHBSINGLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AHBSINGLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AHBSINGLER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `GlblIntrMsk`"]
        pub enum GLBLINTRMSKW {
            #[doc = "Mask the interrupt assertion to the application."]
            VALUE1,
            #[doc = "Unmask the interrupt assertion to the application."]
            VALUE2,
        }
        impl GLBLINTRMSKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GLBLINTRMSKW::VALUE1 => false,
                    GLBLINTRMSKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GLBLINTRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GLBLINTRMSKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GLBLINTRMSKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Mask the interrupt assertion to the application."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GLBLINTRMSKW::VALUE1)
            }
            #[doc = "Unmask the interrupt assertion to the application."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GLBLINTRMSKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HBstLen`"]
        pub enum HBSTLENW {
            #[doc = "Single"]
            VALUE1,
            #[doc = "INCR"]
            VALUE2,
            #[doc = "INCR4"]
            VALUE3,
            #[doc = "INCR8"]
            VALUE4,
            #[doc = "INCR16"]
            VALUE5,
        }
        impl HBSTLENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HBSTLENW::VALUE1 => 0,
                    HBSTLENW::VALUE2 => 1,
                    HBSTLENW::VALUE3 => 3,
                    HBSTLENW::VALUE4 => 5,
                    HBSTLENW::VALUE5 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HBSTLENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HBSTLENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HBSTLENW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Single"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HBSTLENW::VALUE1)
            }
            #[doc = "INCR"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HBSTLENW::VALUE2)
            }
            #[doc = "INCR4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HBSTLENW::VALUE3)
            }
            #[doc = "INCR8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(HBSTLENW::VALUE4)
            }
            #[doc = "INCR16"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(HBSTLENW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DMAEn`"]
        pub enum DMAENW {
            #[doc = "Core operates in Slave mode"]
            VALUE1,
            #[doc = "Core operates in a DMA mode"]
            VALUE2,
        }
        impl DMAENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DMAENW::VALUE1 => false,
                    DMAENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMAENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMAENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMAENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Core operates in Slave mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMAENW::VALUE1)
            }
            #[doc = "Core operates in a DMA mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMAENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NPTxFEmpLvl`"]
        pub enum NPTXFEMPLVLW {
            #[doc = "DIEPINTx.TxFEmp interrupt indicates that the IN Endpoint TxFIFO is half empty"]
            VALUE1,
            #[doc = "DIEPINTx.TxFEmp interrupt indicates that the IN Endpoint TxFIFO is completely empty"]
            VALUE2,
        }
        impl NPTXFEMPLVLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NPTXFEMPLVLW::VALUE1 => false,
                    NPTXFEMPLVLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NPTXFEMPLVLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NPTXFEMPLVLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NPTXFEMPLVLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DIEPINTx.TxFEmp interrupt indicates that the IN Endpoint TxFIFO is half empty"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NPTXFEMPLVLW::VALUE1)
            }
            #[doc = "DIEPINTx.TxFEmp interrupt indicates that the IN Endpoint TxFIFO is completely empty"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NPTXFEMPLVLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AHBSingle`"]
        pub enum AHBSINGLEW {
            #[doc = "The remaining data in a transfer is sent using INCR burst size. This is the default mode."]
            VALUE1,
            #[doc = "The remaining data in a transfer is sent using single burst size."]
            VALUE2,
        }
        impl AHBSINGLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AHBSINGLEW::VALUE1 => false,
                    AHBSINGLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBSINGLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBSINGLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AHBSINGLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The remaining data in a transfer is sent using INCR burst size. This is the default mode."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AHBSINGLEW::VALUE1)
            }
            #[doc = "The remaining data in a transfer is sent using single burst size."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AHBSINGLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Global Interrupt Mask"]
            #[inline]
            pub fn glbl_intr_msk(&self) -> GLBLINTRMSKR {
                GLBLINTRMSKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 1:4 - Burst Length/Type"]
            #[inline]
            pub fn hbst_len(&self) -> HBSTLENR {
                HBSTLENR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 5 - DMA Enable"]
            #[inline]
            pub fn dmaen(&self) -> DMAENR {
                DMAENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Non-Periodic TxFIFO Empty Level"]
            #[inline]
            pub fn nptx_femp_lvl(&self) -> NPTXFEMPLVLR {
                NPTXFEMPLVLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - AHB Single Support"]
            #[inline]
            pub fn ahbsingle(&self) -> AHBSINGLER {
                AHBSINGLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Global Interrupt Mask"]
            #[inline]
            pub fn glbl_intr_msk(&mut self) -> _GLBLINTRMSKW {
                _GLBLINTRMSKW { w: self }
            }
            #[doc = "Bits 1:4 - Burst Length/Type"]
            #[inline]
            pub fn hbst_len(&mut self) -> _HBSTLENW {
                _HBSTLENW { w: self }
            }
            #[doc = "Bit 5 - DMA Enable"]
            #[inline]
            pub fn dmaen(&mut self) -> _DMAENW {
                _DMAENW { w: self }
            }
            #[doc = "Bit 7 - Non-Periodic TxFIFO Empty Level"]
            #[inline]
            pub fn nptx_femp_lvl(&mut self) -> _NPTXFEMPLVLW {
                _NPTXFEMPLVLW { w: self }
            }
            #[doc = "Bit 23 - AHB Single Support"]
            #[inline]
            pub fn ahbsingle(&mut self) -> _AHBSINGLEW {
                _AHBSINGLEW { w: self }
            }
        }
    }
    #[doc = "USB Configuration Register"]
    pub struct GUSBCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "USB Configuration Register"]
    pub mod gusbcfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GUSBCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TOUTCALR {
            bits: u8,
        }
        impl TOUTCALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `PHYSel`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PHYSELR {
            #[doc = "USB 1.1 full-speed serial transceiver"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(bool),
        }
        impl PHYSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PHYSELR::VALUE2 => true,
                    PHYSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PHYSELR {
                match value {
                    true => PHYSELR::VALUE2,
                    i => PHYSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PHYSELR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBTRDTIMR {
            bits: u8,
        }
        impl USBTRDTIMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `TxEndDelay`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXENDDELAYR {
            #[doc = "Normal mode"]
            VALUE1,
            #[doc = "Introduce Tx end delay timers"]
            VALUE2,
        }
        impl TXENDDELAYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXENDDELAYR::VALUE1 => false,
                    TXENDDELAYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXENDDELAYR {
                match value {
                    false => TXENDDELAYR::VALUE1,
                    true => TXENDDELAYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXENDDELAYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXENDDELAYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ForceDevMode`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FORCEDEVMODER {
            #[doc = "Normal Mode"]
            VALUE1,
            #[doc = "Force Device Mode"]
            VALUE2,
        }
        impl FORCEDEVMODER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FORCEDEVMODER::VALUE1 => false,
                    FORCEDEVMODER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FORCEDEVMODER {
                match value {
                    false => FORCEDEVMODER::VALUE1,
                    true => FORCEDEVMODER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FORCEDEVMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FORCEDEVMODER::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTPR {
            bits: bool,
        }
        impl CTPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _TOUTCALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TOUTCALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBTRDTIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBTRDTIMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TxEndDelay`"]
        pub enum TXENDDELAYW {
            #[doc = "Normal mode"]
            VALUE1,
            #[doc = "Introduce Tx end delay timers"]
            VALUE2,
        }
        impl TXENDDELAYW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TXENDDELAYW::VALUE1 => false,
                    TXENDDELAYW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXENDDELAYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXENDDELAYW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TXENDDELAYW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TXENDDELAYW::VALUE1)
            }
            #[doc = "Introduce Tx end delay timers"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TXENDDELAYW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ForceDevMode`"]
        pub enum FORCEDEVMODEW {
            #[doc = "Normal Mode"]
            VALUE1,
            #[doc = "Force Device Mode"]
            VALUE2,
        }
        impl FORCEDEVMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FORCEDEVMODEW::VALUE1 => false,
                    FORCEDEVMODEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FORCEDEVMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FORCEDEVMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FORCEDEVMODEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal Mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FORCEDEVMODEW::VALUE1)
            }
            #[doc = "Force Device Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FORCEDEVMODEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - FS Timeout Calibration"]
            #[inline]
            pub fn tout_cal(&self) -> TOUTCALR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TOUTCALR { bits }
            }
            #[doc = "Bit 6 - USB 1.1 Full-Speed Serial Transceiver Select"]
            #[inline]
            pub fn physel(&self) -> PHYSELR {
                PHYSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:13 - USB Turnaround Time"]
            #[inline]
            pub fn usbtrd_tim(&self) -> USBTRDTIMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                USBTRDTIMR { bits }
            }
            #[doc = "Bit 28 - Tx End Delay"]
            #[inline]
            pub fn tx_end_delay(&self) -> TXENDDELAYR {
                TXENDDELAYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Force Device Mode"]
            #[inline]
            pub fn force_dev_mode(&self) -> FORCEDEVMODER {
                FORCEDEVMODER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Corrupt Tx packet"]
            #[inline]
            pub fn ctp(&self) -> CTPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x1440 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - FS Timeout Calibration"]
            #[inline]
            pub fn tout_cal(&mut self) -> _TOUTCALW {
                _TOUTCALW { w: self }
            }
            #[doc = "Bits 10:13 - USB Turnaround Time"]
            #[inline]
            pub fn usbtrd_tim(&mut self) -> _USBTRDTIMW {
                _USBTRDTIMW { w: self }
            }
            #[doc = "Bit 28 - Tx End Delay"]
            #[inline]
            pub fn tx_end_delay(&mut self) -> _TXENDDELAYW {
                _TXENDDELAYW { w: self }
            }
            #[doc = "Bit 30 - Force Device Mode"]
            #[inline]
            pub fn force_dev_mode(&mut self) -> _FORCEDEVMODEW {
                _FORCEDEVMODEW { w: self }
            }
            #[doc = "Bit 31 - Corrupt Tx packet"]
            #[inline]
            pub fn ctp(&mut self) -> _CTPW {
                _CTPW { w: self }
            }
        }
    }
    #[doc = "Reset Register"]
    pub struct GRSTCTL {
        register: VolatileCell<u32>,
    }
    #[doc = "Reset Register"]
    pub mod grstctl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GRSTCTL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CSFTRSTR {
            bits: bool,
        }
        impl CSFTRSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RXFFLSHR {
            bits: bool,
        }
        impl RXFFLSHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFFLSHR {
            bits: bool,
        }
        impl TXFFLSHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TxFNum`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXFNUMR {
            #[doc = "Tx FIFO 0 flush in device mode"]
            VALUE1,
            #[doc = "Tx FIFO 1 flush in device mode"]
            VALUE2,
            #[doc = "Tx FIFO 2 flush in device mode"]
            VALUE3,
            #[doc = "Tx FIFO 15 flush in device mode"]
            VALUE4,
            #[doc = "Flush all the transmit FIFOs in device or host mode."]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TXFNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TXFNUMR::VALUE1 => 0,
                    TXFNUMR::VALUE2 => 0x01,
                    TXFNUMR::VALUE3 => 0x02,
                    TXFNUMR::VALUE4 => 0x0f,
                    TXFNUMR::VALUE5 => 0x10,
                    TXFNUMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TXFNUMR {
                match value {
                    0 => TXFNUMR::VALUE1,
                    1 => TXFNUMR::VALUE2,
                    2 => TXFNUMR::VALUE3,
                    15 => TXFNUMR::VALUE4,
                    16 => TXFNUMR::VALUE5,
                    i => TXFNUMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXFNUMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXFNUMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TXFNUMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TXFNUMR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == TXFNUMR::VALUE5
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMAREQR {
            bits: bool,
        }
        impl DMAREQR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBIDLER {
            bits: bool,
        }
        impl AHBIDLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSFTRSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSFTRSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXFFLSHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXFFLSHW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFFLSHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFFLSHW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TxFNum`"]
        pub enum TXFNUMW {
            #[doc = "Tx FIFO 0 flush in device mode"]
            VALUE1,
            #[doc = "Tx FIFO 1 flush in device mode"]
            VALUE2,
            #[doc = "Tx FIFO 2 flush in device mode"]
            VALUE3,
            #[doc = "Tx FIFO 15 flush in device mode"]
            VALUE4,
            #[doc = "Flush all the transmit FIFOs in device or host mode."]
            VALUE5,
        }
        impl TXFNUMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TXFNUMW::VALUE1 => 0,
                    TXFNUMW::VALUE2 => 1,
                    TXFNUMW::VALUE3 => 2,
                    TXFNUMW::VALUE4 => 15,
                    TXFNUMW::VALUE5 => 16,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFNUMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TXFNUMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Tx FIFO 0 flush in device mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TXFNUMW::VALUE1)
            }
            #[doc = "Tx FIFO 1 flush in device mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TXFNUMW::VALUE2)
            }
            #[doc = "Tx FIFO 2 flush in device mode"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TXFNUMW::VALUE3)
            }
            #[doc = "Tx FIFO 15 flush in device mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TXFNUMW::VALUE4)
            }
            #[doc = "Flush all the transmit FIFOs in device or host mode."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(TXFNUMW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Core Soft Reset"]
            #[inline]
            pub fn csft_rst(&self) -> CSFTRSTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CSFTRSTR { bits }
            }
            #[doc = "Bit 4 - RxFIFO Flush"]
            #[inline]
            pub fn rx_fflsh(&self) -> RXFFLSHR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RXFFLSHR { bits }
            }
            #[doc = "Bit 5 - TxFIFO Flush"]
            #[inline]
            pub fn tx_fflsh(&self) -> TXFFLSHR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TXFFLSHR { bits }
            }
            #[doc = "Bits 6:10 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&self) -> TXFNUMR {
                TXFNUMR::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 30 - DMA Request Signal"]
            #[inline]
            pub fn dmareq(&self) -> DMAREQR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DMAREQR { bits }
            }
            #[doc = "Bit 31 - AHB Master Idle"]
            #[inline]
            pub fn ahbidle(&self) -> AHBIDLER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBIDLER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x1000_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Core Soft Reset"]
            #[inline]
            pub fn csft_rst(&mut self) -> _CSFTRSTW {
                _CSFTRSTW { w: self }
            }
            #[doc = "Bit 4 - RxFIFO Flush"]
            #[inline]
            pub fn rx_fflsh(&mut self) -> _RXFFLSHW {
                _RXFFLSHW { w: self }
            }
            #[doc = "Bit 5 - TxFIFO Flush"]
            #[inline]
            pub fn tx_fflsh(&mut self) -> _TXFFLSHW {
                _TXFFLSHW { w: self }
            }
            #[doc = "Bits 6:10 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&mut self) -> _TXFNUMW {
                _TXFNUMW { w: self }
            }
        }
    }
    #[doc = "Interrupt Register"]
    pub struct GINTSTS {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Register"]
    pub mod gintsts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GINTSTS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CurMod`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CURMODR {
            #[doc = "Device mode"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(bool),
        }
        impl CURMODR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CURMODR::VALUE1 => false,
                    CURMODR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CURMODR {
                match value {
                    false => CURMODR::VALUE1,
                    i => CURMODR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CURMODR::VALUE1
            }
        }
        #[doc = r" Value of the field"]
        pub struct SOFR {
            bits: bool,
        }
        impl SOFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RXFLVLR {
            bits: bool,
        }
        impl RXFLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct GINNAKEFFR {
            bits: bool,
        }
        impl GINNAKEFFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct GOUTNAKEFFR {
            bits: bool,
        }
        impl GOUTNAKEFFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ERLYSUSPR {
            bits: bool,
        }
        impl ERLYSUSPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBSUSPR {
            bits: bool,
        }
        impl USBSUSPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBRSTR {
            bits: bool,
        }
        impl USBRSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENUMDONER {
            bits: bool,
        }
        impl ENUMDONER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ISOOUTDROPR {
            bits: bool,
        }
        impl ISOOUTDROPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EOPFR {
            bits: bool,
        }
        impl EOPFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct IEPINTR {
            bits: bool,
        }
        impl IEPINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OEPINTR {
            bits: bool,
        }
        impl OEPINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INCOMPISOINR {
            bits: bool,
        }
        impl INCOMPISOINR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INCOMPLSOOUTR {
            bits: bool,
        }
        impl INCOMPLSOOUTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct WKUPINTR {
            bits: bool,
        }
        impl WKUPINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERLYSUSPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERLYSUSPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBSUSPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBSUSPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBRSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBRSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENUMDONEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENUMDONEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ISOOUTDROPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ISOOUTDROPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EOPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EOPFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INCOMPISOINW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INCOMPISOINW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INCOMPLSOOUTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INCOMPLSOOUTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _WKUPINTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WKUPINTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Current Mode of Operation"]
            #[inline]
            pub fn cur_mod(&self) -> CURMODR {
                CURMODR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Start of Frame"]
            #[inline]
            pub fn sof(&self) -> SOFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SOFR { bits }
            }
            #[doc = "Bit 4 - RxFIFO Non-Empty"]
            #[inline]
            pub fn rx_flvl(&self) -> RXFLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RXFLVLR { bits }
            }
            #[doc = "Bit 6 - Global IN Non-Periodic NAK Effective"]
            #[inline]
            pub fn ginnak_eff(&self) -> GINNAKEFFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GINNAKEFFR { bits }
            }
            #[doc = "Bit 7 - Global OUT NAK Effective"]
            #[inline]
            pub fn goutnak_eff(&self) -> GOUTNAKEFFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GOUTNAKEFFR { bits }
            }
            #[doc = "Bit 10 - Early Suspend"]
            #[inline]
            pub fn erly_susp(&self) -> ERLYSUSPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ERLYSUSPR { bits }
            }
            #[doc = "Bit 11 - USB Suspend"]
            #[inline]
            pub fn usbsusp(&self) -> USBSUSPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBSUSPR { bits }
            }
            #[doc = "Bit 12 - USB Reset"]
            #[inline]
            pub fn usbrst(&self) -> USBRSTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBRSTR { bits }
            }
            #[doc = "Bit 13 - Enumeration Done"]
            #[inline]
            pub fn enum_done(&self) -> ENUMDONER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENUMDONER { bits }
            }
            #[doc = "Bit 14 - Isochronous OUT Packet Dropped Interrupt"]
            #[inline]
            pub fn isoout_drop(&self) -> ISOOUTDROPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ISOOUTDROPR { bits }
            }
            #[doc = "Bit 15 - End of Periodic Frame Interrupt"]
            #[inline]
            pub fn eopf(&self) -> EOPFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EOPFR { bits }
            }
            #[doc = "Bit 18 - IN Endpoints Interrupt"]
            #[inline]
            pub fn iepint(&self) -> IEPINTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                IEPINTR { bits }
            }
            #[doc = "Bit 19 - OUT Endpoints Interrupt"]
            #[inline]
            pub fn oepint(&self) -> OEPINTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OEPINTR { bits }
            }
            #[doc = "Bit 20 - Incomplete Isochronous IN Transfer"]
            #[inline]
            pub fn incomp_isoin(&self) -> INCOMPISOINR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INCOMPISOINR { bits }
            }
            #[doc = "Bit 21 - Incomplete Isochronous OUT Transfer"]
            #[inline]
            pub fn incompl_soout(&self) -> INCOMPLSOOUTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INCOMPLSOOUTR { bits }
            }
            #[doc = "Bit 31 - Resume/Remote Wakeup Detected Interrupt"]
            #[inline]
            pub fn wk_up_int(&self) -> WKUPINTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                WKUPINTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x1400_0020 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 3 - Start of Frame"]
            #[inline]
            pub fn sof(&mut self) -> _SOFW {
                _SOFW { w: self }
            }
            #[doc = "Bit 10 - Early Suspend"]
            #[inline]
            pub fn erly_susp(&mut self) -> _ERLYSUSPW {
                _ERLYSUSPW { w: self }
            }
            #[doc = "Bit 11 - USB Suspend"]
            #[inline]
            pub fn usbsusp(&mut self) -> _USBSUSPW {
                _USBSUSPW { w: self }
            }
            #[doc = "Bit 12 - USB Reset"]
            #[inline]
            pub fn usbrst(&mut self) -> _USBRSTW {
                _USBRSTW { w: self }
            }
            #[doc = "Bit 13 - Enumeration Done"]
            #[inline]
            pub fn enum_done(&mut self) -> _ENUMDONEW {
                _ENUMDONEW { w: self }
            }
            #[doc = "Bit 14 - Isochronous OUT Packet Dropped Interrupt"]
            #[inline]
            pub fn isoout_drop(&mut self) -> _ISOOUTDROPW {
                _ISOOUTDROPW { w: self }
            }
            #[doc = "Bit 15 - End of Periodic Frame Interrupt"]
            #[inline]
            pub fn eopf(&mut self) -> _EOPFW {
                _EOPFW { w: self }
            }
            #[doc = "Bit 20 - Incomplete Isochronous IN Transfer"]
            #[inline]
            pub fn incomp_isoin(&mut self) -> _INCOMPISOINW {
                _INCOMPISOINW { w: self }
            }
            #[doc = "Bit 21 - Incomplete Isochronous OUT Transfer"]
            #[inline]
            pub fn incompl_soout(&mut self) -> _INCOMPLSOOUTW {
                _INCOMPLSOOUTW { w: self }
            }
            #[doc = "Bit 31 - Resume/Remote Wakeup Detected Interrupt"]
            #[inline]
            pub fn wk_up_int(&mut self) -> _WKUPINTW {
                _WKUPINTW { w: self }
            }
        }
    }
    #[doc = "Interrupt Mask Register"]
    pub struct GINTMSK {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Mask Register"]
    pub mod gintmsk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GINTMSK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SOFMSKR {
            bits: bool,
        }
        impl SOFMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RXFLVLMSKR {
            bits: bool,
        }
        impl RXFLVLMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct GINNAKEFFMSKR {
            bits: bool,
        }
        impl GINNAKEFFMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct GOUTNAKEFFMSKR {
            bits: bool,
        }
        impl GOUTNAKEFFMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ERLYSUSPMSKR {
            bits: bool,
        }
        impl ERLYSUSPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBSUSPMSKR {
            bits: bool,
        }
        impl USBSUSPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBRSTMSKR {
            bits: bool,
        }
        impl USBRSTMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENUMDONEMSKR {
            bits: bool,
        }
        impl ENUMDONEMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ISOOUTDROPMSKR {
            bits: bool,
        }
        impl ISOOUTDROPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EOPFMSKR {
            bits: bool,
        }
        impl EOPFMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct IEPINTMSKR {
            bits: bool,
        }
        impl IEPINTMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OEPINTMSKR {
            bits: bool,
        }
        impl OEPINTMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INCOMPISOINMSKR {
            bits: bool,
        }
        impl INCOMPISOINMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INCOMPLSOOUTMSKR {
            bits: bool,
        }
        impl INCOMPLSOOUTMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct WKUPINTMSKR {
            bits: bool,
        }
        impl WKUPINTMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOFMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOFMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXFLVLMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXFLVLMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GINNAKEFFMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GINNAKEFFMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GOUTNAKEFFMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GOUTNAKEFFMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERLYSUSPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERLYSUSPMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBSUSPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBSUSPMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBRSTMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBRSTMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENUMDONEMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENUMDONEMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ISOOUTDROPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ISOOUTDROPMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EOPFMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EOPFMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _IEPINTMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IEPINTMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OEPINTMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OEPINTMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INCOMPISOINMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INCOMPISOINMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INCOMPLSOOUTMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INCOMPLSOOUTMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _WKUPINTMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WKUPINTMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 3 - Start of Frame Mask"]
            #[inline]
            pub fn sof_msk(&self) -> SOFMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SOFMSKR { bits }
            }
            #[doc = "Bit 4 - Receive FIFO Non-Empty Mask"]
            #[inline]
            pub fn rx_flvl_msk(&self) -> RXFLVLMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RXFLVLMSKR { bits }
            }
            #[doc = "Bit 6 - Global Non-periodic IN NAK Effective Mask"]
            #[inline]
            pub fn ginnak_eff_msk(&self) -> GINNAKEFFMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GINNAKEFFMSKR { bits }
            }
            #[doc = "Bit 7 - Global OUT NAK Effective Mask"]
            #[inline]
            pub fn goutnak_eff_msk(&self) -> GOUTNAKEFFMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GOUTNAKEFFMSKR { bits }
            }
            #[doc = "Bit 10 - Early Suspend Mask"]
            #[inline]
            pub fn erly_susp_msk(&self) -> ERLYSUSPMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ERLYSUSPMSKR { bits }
            }
            #[doc = "Bit 11 - USB Suspend Mask"]
            #[inline]
            pub fn usbsusp_msk(&self) -> USBSUSPMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBSUSPMSKR { bits }
            }
            #[doc = "Bit 12 - USB Reset Mask"]
            #[inline]
            pub fn usbrst_msk(&self) -> USBRSTMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBRSTMSKR { bits }
            }
            #[doc = "Bit 13 - Enumeration Done Mask"]
            #[inline]
            pub fn enum_done_msk(&self) -> ENUMDONEMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENUMDONEMSKR { bits }
            }
            #[doc = "Bit 14 - Isochronous OUT Packet Dropped Interrupt Mask"]
            #[inline]
            pub fn isoout_drop_msk(&self) -> ISOOUTDROPMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ISOOUTDROPMSKR { bits }
            }
            #[doc = "Bit 15 - End of Periodic Frame Interrupt Mask"]
            #[inline]
            pub fn eopfmsk(&self) -> EOPFMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EOPFMSKR { bits }
            }
            #[doc = "Bit 18 - IN Endpoints Interrupt Mask"]
            #[inline]
            pub fn iepint_msk(&self) -> IEPINTMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                IEPINTMSKR { bits }
            }
            #[doc = "Bit 19 - OUT Endpoints Interrupt Mask"]
            #[inline]
            pub fn oepint_msk(&self) -> OEPINTMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OEPINTMSKR { bits }
            }
            #[doc = "Bit 20 - Incomplete Isochronous IN Transfer Mask"]
            #[inline]
            pub fn incomp_isoinmsk(&self) -> INCOMPISOINMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INCOMPISOINMSKR { bits }
            }
            #[doc = "Bit 21 - Incomplete Isochronous OUT Transfer Mask"]
            #[inline]
            pub fn incompl_sooutmsk(&self) -> INCOMPLSOOUTMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INCOMPLSOOUTMSKR { bits }
            }
            #[doc = "Bit 31 - Resume/Remote Wakeup Detected Interrupt Mask"]
            #[inline]
            pub fn wk_up_int_msk(&self) -> WKUPINTMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                WKUPINTMSKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 3 - Start of Frame Mask"]
            #[inline]
            pub fn sof_msk(&mut self) -> _SOFMSKW {
                _SOFMSKW { w: self }
            }
            #[doc = "Bit 4 - Receive FIFO Non-Empty Mask"]
            #[inline]
            pub fn rx_flvl_msk(&mut self) -> _RXFLVLMSKW {
                _RXFLVLMSKW { w: self }
            }
            #[doc = "Bit 6 - Global Non-periodic IN NAK Effective Mask"]
            #[inline]
            pub fn ginnak_eff_msk(&mut self) -> _GINNAKEFFMSKW {
                _GINNAKEFFMSKW { w: self }
            }
            #[doc = "Bit 7 - Global OUT NAK Effective Mask"]
            #[inline]
            pub fn goutnak_eff_msk(&mut self) -> _GOUTNAKEFFMSKW {
                _GOUTNAKEFFMSKW { w: self }
            }
            #[doc = "Bit 10 - Early Suspend Mask"]
            #[inline]
            pub fn erly_susp_msk(&mut self) -> _ERLYSUSPMSKW {
                _ERLYSUSPMSKW { w: self }
            }
            #[doc = "Bit 11 - USB Suspend Mask"]
            #[inline]
            pub fn usbsusp_msk(&mut self) -> _USBSUSPMSKW {
                _USBSUSPMSKW { w: self }
            }
            #[doc = "Bit 12 - USB Reset Mask"]
            #[inline]
            pub fn usbrst_msk(&mut self) -> _USBRSTMSKW {
                _USBRSTMSKW { w: self }
            }
            #[doc = "Bit 13 - Enumeration Done Mask"]
            #[inline]
            pub fn enum_done_msk(&mut self) -> _ENUMDONEMSKW {
                _ENUMDONEMSKW { w: self }
            }
            #[doc = "Bit 14 - Isochronous OUT Packet Dropped Interrupt Mask"]
            #[inline]
            pub fn isoout_drop_msk(&mut self) -> _ISOOUTDROPMSKW {
                _ISOOUTDROPMSKW { w: self }
            }
            #[doc = "Bit 15 - End of Periodic Frame Interrupt Mask"]
            #[inline]
            pub fn eopfmsk(&mut self) -> _EOPFMSKW {
                _EOPFMSKW { w: self }
            }
            #[doc = "Bit 18 - IN Endpoints Interrupt Mask"]
            #[inline]
            pub fn iepint_msk(&mut self) -> _IEPINTMSKW {
                _IEPINTMSKW { w: self }
            }
            #[doc = "Bit 19 - OUT Endpoints Interrupt Mask"]
            #[inline]
            pub fn oepint_msk(&mut self) -> _OEPINTMSKW {
                _OEPINTMSKW { w: self }
            }
            #[doc = "Bit 20 - Incomplete Isochronous IN Transfer Mask"]
            #[inline]
            pub fn incomp_isoinmsk(&mut self) -> _INCOMPISOINMSKW {
                _INCOMPISOINMSKW { w: self }
            }
            #[doc = "Bit 21 - Incomplete Isochronous OUT Transfer Mask"]
            #[inline]
            pub fn incompl_sooutmsk(&mut self) -> _INCOMPLSOOUTMSKW {
                _INCOMPLSOOUTMSKW { w: self }
            }
            #[doc = "Bit 31 - Resume/Remote Wakeup Detected Interrupt Mask"]
            #[inline]
            pub fn wk_up_int_msk(&mut self) -> _WKUPINTMSKW {
                _WKUPINTMSKW { w: self }
            }
        }
    }
    #[doc = "Receive Status Debug Read Register"]
    pub struct GRXSTSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Receive Status Debug Read Register"]
    pub mod grxstsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::GRXSTSR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPNUMR {
            bits: u8,
        }
        impl EPNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct BCNTR {
            bits: u16,
        }
        impl BCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DPID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPIDR {
            #[doc = "DATA0"]
            VALUE1,
            #[doc = "DATA1"]
            VALUE2,
            #[doc = "DATA2"]
            VALUE3,
            #[doc = "MDATA"]
            VALUE4,
        }
        impl DPIDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DPIDR::VALUE1 => 0,
                    DPIDR::VALUE2 => 0x02,
                    DPIDR::VALUE3 => 0x01,
                    DPIDR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DPIDR {
                match value {
                    0 => DPIDR::VALUE1,
                    2 => DPIDR::VALUE2,
                    1 => DPIDR::VALUE3,
                    3 => DPIDR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPIDR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DPIDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DPIDR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PktSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PKTSTSR {
            #[doc = "Global OUT NAK (triggers an interrupt)"]
            VALUE1,
            #[doc = "OUT data packet received"]
            VALUE2,
            #[doc = "OUT transfer completed (triggers an interrupt)"]
            VALUE3,
            #[doc = "SETUP transaction completed (triggers an interrupt)"]
            VALUE4,
            #[doc = "SETUP data packet received"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PKTSTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PKTSTSR::VALUE1 => 0x01,
                    PKTSTSR::VALUE2 => 0x02,
                    PKTSTSR::VALUE3 => 0x03,
                    PKTSTSR::VALUE4 => 0x04,
                    PKTSTSR::VALUE5 => 0x06,
                    PKTSTSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PKTSTSR {
                match value {
                    1 => PKTSTSR::VALUE1,
                    2 => PKTSTSR::VALUE2,
                    3 => PKTSTSR::VALUE3,
                    4 => PKTSTSR::VALUE4,
                    6 => PKTSTSR::VALUE5,
                    i => PKTSTSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PKTSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PKTSTSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PKTSTSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PKTSTSR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PKTSTSR::VALUE5
            }
        }
        #[doc = r" Value of the field"]
        pub struct FNR {
            bits: u8,
        }
        impl FNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Endpoint Number"]
            #[inline]
            pub fn epnum(&self) -> EPNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EPNUMR { bits }
            }
            #[doc = "Bits 4:14 - Byte Count"]
            #[inline]
            pub fn bcnt(&self) -> BCNTR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BCNTR { bits }
            }
            #[doc = "Bits 15:16 - Data PID"]
            #[inline]
            pub fn dpid(&self) -> DPIDR {
                DPIDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 17:20 - Packet Status"]
            #[inline]
            pub fn pkt_sts(&self) -> PKTSTSR {
                PKTSTSR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 21:24 - Frame Number"]
            #[inline]
            pub fn fn_(&self) -> FNR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FNR { bits }
            }
        }
    }
    #[doc = "Receive Status Read and Pop Register"]
    pub struct GRXSTSP {
        register: VolatileCell<u32>,
    }
    #[doc = "Receive Status Read and Pop Register"]
    pub mod grxstsp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::GRXSTSP {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPNUMR {
            bits: u8,
        }
        impl EPNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct BCNTR {
            bits: u16,
        }
        impl BCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DPID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPIDR {
            #[doc = "DATA0"]
            VALUE1,
            #[doc = "DATA1"]
            VALUE2,
            #[doc = "DATA2"]
            VALUE3,
            #[doc = "MDATA"]
            VALUE4,
        }
        impl DPIDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DPIDR::VALUE1 => 0,
                    DPIDR::VALUE2 => 0x02,
                    DPIDR::VALUE3 => 0x01,
                    DPIDR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DPIDR {
                match value {
                    0 => DPIDR::VALUE1,
                    2 => DPIDR::VALUE2,
                    1 => DPIDR::VALUE3,
                    3 => DPIDR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPIDR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DPIDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DPIDR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PktSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PKTSTSR {
            #[doc = "Global OUT NAK (triggers an interrupt)"]
            VALUE1,
            #[doc = "OUT data packet received"]
            VALUE2,
            #[doc = "OUT transfer completed (triggers an interrupt)"]
            VALUE3,
            #[doc = "SETUP transaction completed (triggers an interrupt)"]
            VALUE4,
            #[doc = "SETUP data packet received"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PKTSTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PKTSTSR::VALUE1 => 0x01,
                    PKTSTSR::VALUE2 => 0x02,
                    PKTSTSR::VALUE3 => 0x03,
                    PKTSTSR::VALUE4 => 0x04,
                    PKTSTSR::VALUE5 => 0x06,
                    PKTSTSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PKTSTSR {
                match value {
                    1 => PKTSTSR::VALUE1,
                    2 => PKTSTSR::VALUE2,
                    3 => PKTSTSR::VALUE3,
                    4 => PKTSTSR::VALUE4,
                    6 => PKTSTSR::VALUE5,
                    i => PKTSTSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PKTSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PKTSTSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PKTSTSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PKTSTSR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PKTSTSR::VALUE5
            }
        }
        #[doc = r" Value of the field"]
        pub struct FNR {
            bits: u8,
        }
        impl FNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Endpoint Number"]
            #[inline]
            pub fn epnum(&self) -> EPNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EPNUMR { bits }
            }
            #[doc = "Bits 4:14 - Byte Count"]
            #[inline]
            pub fn bcnt(&self) -> BCNTR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BCNTR { bits }
            }
            #[doc = "Bits 15:16 - Data PID"]
            #[inline]
            pub fn dpid(&self) -> DPIDR {
                DPIDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 17:20 - Packet Status"]
            #[inline]
            pub fn pkt_sts(&self) -> PKTSTSR {
                PKTSTSR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 21:24 - Frame Number"]
            #[inline]
            pub fn fn_(&self) -> FNR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FNR { bits }
            }
        }
    }
    #[doc = "Receive FIFO Size Register"]
    pub struct GRXFSIZ {
        register: VolatileCell<u32>,
    }
    #[doc = "Receive FIFO Size Register"]
    pub mod grxfsiz {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GRXFSIZ {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RXFDEPR {
            bits: u16,
        }
        impl RXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - RxFIFO Depth"]
            #[inline]
            pub fn rx_fdep(&self) -> RXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x011a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - RxFIFO Depth"]
            #[inline]
            pub fn rx_fdep(&mut self) -> _RXFDEPW {
                _RXFDEPW { w: self }
            }
        }
    }
    #[doc = "Non-Periodic Transmit FIFO Size Register"]
    pub struct GNPTXFSIZ {
        register: VolatileCell<u32>,
    }
    #[doc = "Non-Periodic Transmit FIFO Size Register"]
    pub mod gnptxfsiz {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GNPTXFSIZ {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPTXF0STADDRR {
            bits: u16,
        }
        impl INEPTXF0STADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPTXF0DEPR {
            bits: u16,
        }
        impl INEPTXF0DEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPTXF0STADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPTXF0STADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPTXF0DEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPTXF0DEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFO0 Transmit RAM Start Address"]
            #[inline]
            pub fn ineptx_f0st_addr(&self) -> INEPTXF0STADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPTXF0STADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO 0 Depth"]
            #[inline]
            pub fn ineptx_f0dep(&self) -> INEPTXF0DEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPTXF0DEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0010_011a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFO0 Transmit RAM Start Address"]
            #[inline]
            pub fn ineptx_f0st_addr(&mut self) -> _INEPTXF0STADDRW {
                _INEPTXF0STADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO 0 Depth"]
            #[inline]
            pub fn ineptx_f0dep(&mut self) -> _INEPTXF0DEPW {
                _INEPTXF0DEPW { w: self }
            }
        }
    }
    #[doc = "USB Module Identification Register"]
    pub struct GUID {
        register: VolatileCell<u32>,
    }
    #[doc = "USB Module Identification Register"]
    pub mod guid {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GUID {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _MOD_REVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MOD_REVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MOD_TYPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MOD_TYPEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MOD_NUMBERW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MOD_NUMBERW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x00b1_c000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn mod_rev(&mut self) -> _MOD_REVW {
                _MOD_REVW { w: self }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&mut self) -> _MOD_TYPEW {
                _MOD_TYPEW { w: self }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn mod_number(&mut self) -> _MOD_NUMBERW {
                _MOD_NUMBERW { w: self }
            }
        }
    }
    #[doc = "Global DFIFO Software Config Register"]
    pub struct GDFIFOCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global DFIFO Software Config Register"]
    pub mod gdfifocfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GDFIFOCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct GDFIFOCFGR {
            bits: u16,
        }
        impl GDFIFOCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPINFOBASEADDRR {
            bits: u16,
        }
        impl EPINFOBASEADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _GDFIFOCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GDFIFOCFGW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPINFOBASEADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPINFOBASEADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - GDFIFOCfg"]
            #[inline]
            pub fn gdfifocfg(&self) -> GDFIFOCFGR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                GDFIFOCFGR { bits }
            }
            #[doc = "Bits 16:31 - EPInfoBaseAddr"]
            #[inline]
            pub fn epinfo_base_addr(&self) -> EPINFOBASEADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                EPINFOBASEADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x027a_02b2 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - GDFIFOCfg"]
            #[inline]
            pub fn gdfifocfg(&mut self) -> _GDFIFOCFGW {
                _GDFIFOCFGW { w: self }
            }
            #[doc = "Bits 16:31 - EPInfoBaseAddr"]
            #[inline]
            pub fn epinfo_base_addr(&mut self) -> _EPINFOBASEADDRW {
                _EPINFOBASEADDRW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint 1 Transmit FIFO Size Register"]
    pub struct DIEPTXF1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint 1 Transmit FIFO Size Register"]
    pub mod dieptxf1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTXF1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFSTADDRR {
            bits: u16,
        }
        impl INEPNTXFSTADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFDEPR {
            bits: u16,
        }
        impl INEPNTXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFSTADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFSTADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&self) -> INEPNTXFSTADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFSTADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&self) -> INEPNTXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100_012a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&mut self) -> _INEPNTXFSTADDRW {
                _INEPNTXFSTADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&mut self) -> _INEPNTXFDEPW {
                _INEPNTXFDEPW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint 2 Transmit FIFO Size Register"]
    pub struct DIEPTXF2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint 2 Transmit FIFO Size Register"]
    pub mod dieptxf2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTXF2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFSTADDRR {
            bits: u16,
        }
        impl INEPNTXFSTADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFDEPR {
            bits: u16,
        }
        impl INEPNTXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFSTADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFSTADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&self) -> INEPNTXFSTADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFSTADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&self) -> INEPNTXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100_022a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&mut self) -> _INEPNTXFSTADDRW {
                _INEPNTXFSTADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&mut self) -> _INEPNTXFDEPW {
                _INEPNTXFDEPW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint 3 Transmit FIFO Size Register"]
    pub struct DIEPTXF3 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint 3 Transmit FIFO Size Register"]
    pub mod dieptxf3 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTXF3 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFSTADDRR {
            bits: u16,
        }
        impl INEPNTXFSTADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFDEPR {
            bits: u16,
        }
        impl INEPNTXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFSTADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFSTADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&self) -> INEPNTXFSTADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFSTADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&self) -> INEPNTXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100_032a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&mut self) -> _INEPNTXFSTADDRW {
                _INEPNTXFSTADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&mut self) -> _INEPNTXFDEPW {
                _INEPNTXFDEPW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint 4 Transmit FIFO Size Register"]
    pub struct DIEPTXF4 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint 4 Transmit FIFO Size Register"]
    pub mod dieptxf4 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTXF4 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFSTADDRR {
            bits: u16,
        }
        impl INEPNTXFSTADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFDEPR {
            bits: u16,
        }
        impl INEPNTXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFSTADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFSTADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&self) -> INEPNTXFSTADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFSTADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&self) -> INEPNTXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100_042a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&mut self) -> _INEPNTXFSTADDRW {
                _INEPNTXFSTADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&mut self) -> _INEPNTXFDEPW {
                _INEPNTXFDEPW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint 5 Transmit FIFO Size Register"]
    pub struct DIEPTXF5 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint 5 Transmit FIFO Size Register"]
    pub mod dieptxf5 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTXF5 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFSTADDRR {
            bits: u16,
        }
        impl INEPNTXFSTADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFDEPR {
            bits: u16,
        }
        impl INEPNTXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFSTADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFSTADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&self) -> INEPNTXFSTADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFSTADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&self) -> INEPNTXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100_052a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&mut self) -> _INEPNTXFSTADDRW {
                _INEPNTXFSTADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&mut self) -> _INEPNTXFDEPW {
                _INEPNTXFDEPW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint 6 Transmit FIFO Size Register"]
    pub struct DIEPTXF6 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint 6 Transmit FIFO Size Register"]
    pub mod dieptxf6 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTXF6 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFSTADDRR {
            bits: u16,
        }
        impl INEPNTXFSTADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNTXFDEPR {
            bits: u16,
        }
        impl INEPNTXFDEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFSTADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFSTADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNTXFDEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNTXFDEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&self) -> INEPNTXFSTADDRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFSTADDRR { bits }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&self) -> INEPNTXFDEPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPNTXFDEPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100_062a }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN Endpoint FIFOn Transmit RAM Start Address"]
            #[inline]
            pub fn inepn_tx_fst_addr(&mut self) -> _INEPNTXFSTADDRW {
                _INEPNTXFSTADDRW { w: self }
            }
            #[doc = "Bits 16:31 - IN Endpoint TxFIFO Depth"]
            #[inline]
            pub fn inepn_tx_fdep(&mut self) -> _INEPNTXFDEPW {
                _INEPNTXFDEPW { w: self }
            }
        }
    }
    #[doc = "Device Configuration Register"]
    pub struct DCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Configuration Register"]
    pub mod dcfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DevSpd`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DEVSPDR {
            #[doc = "Full speed (USB 1.1 transceiver clock is 48 MHz)"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DEVSPDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DEVSPDR::VALUE4 => 0x03,
                    DEVSPDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DEVSPDR {
                match value {
                    3 => DEVSPDR::VALUE4,
                    i => DEVSPDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DEVSPDR::VALUE4
            }
        }
        #[doc = "Possible values of the field `NZStsOUTHShk`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NZSTSOUTHSHKR {
            #[doc = "Send a STALL handshake on a nonzero-length status OUT transaction and do not send the received OUT packet to the application."]
            VALUE1,
            #[doc = "Send the received OUT packet to the application (zero-length or nonzero-length) and send a handshake based on the NAK and STALL bits for the endpoint in the Device Endpoint Control register."]
            VALUE2,
        }
        impl NZSTSOUTHSHKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NZSTSOUTHSHKR::VALUE1 => true,
                    NZSTSOUTHSHKR::VALUE2 => false,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NZSTSOUTHSHKR {
                match value {
                    true => NZSTSOUTHSHKR::VALUE1,
                    false => NZSTSOUTHSHKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NZSTSOUTHSHKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NZSTSOUTHSHKR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct DEVADDRR {
            bits: u8,
        }
        impl DEVADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `PerFrInt`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PERFRINTR {
            #[doc = "80% of the frame interval"]
            VALUE1,
            #[doc = "85%"]
            VALUE2,
            #[doc = "90%"]
            VALUE3,
            #[doc = "95%"]
            VALUE4,
        }
        impl PERFRINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PERFRINTR::VALUE1 => 0,
                    PERFRINTR::VALUE2 => 0x01,
                    PERFRINTR::VALUE3 => 0x02,
                    PERFRINTR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PERFRINTR {
                match value {
                    0 => PERFRINTR::VALUE1,
                    1 => PERFRINTR::VALUE2,
                    2 => PERFRINTR::VALUE3,
                    3 => PERFRINTR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PERFRINTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PERFRINTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PERFRINTR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PERFRINTR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct DESCDMAR {
            bits: bool,
        }
        impl DESCDMAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `PerSchIntvl`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PERSCHINTVLR {
            #[doc = "25% of frame."]
            VALUE1,
            #[doc = "50% of frame."]
            VALUE2,
            #[doc = "75% of frame."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PERSCHINTVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PERSCHINTVLR::VALUE1 => 0,
                    PERSCHINTVLR::VALUE2 => 0x01,
                    PERSCHINTVLR::VALUE3 => 0x02,
                    PERSCHINTVLR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PERSCHINTVLR {
                match value {
                    0 => PERSCHINTVLR::VALUE1,
                    1 => PERSCHINTVLR::VALUE2,
                    2 => PERSCHINTVLR::VALUE3,
                    i => PERSCHINTVLR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PERSCHINTVLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PERSCHINTVLR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PERSCHINTVLR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `DevSpd`"]
        pub enum DEVSPDW {
            #[doc = "Full speed (USB 1.1 transceiver clock is 48 MHz)"]
            VALUE4,
        }
        impl DEVSPDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DEVSPDW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEVSPDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEVSPDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DEVSPDW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Full speed (USB 1.1 transceiver clock is 48 MHz)"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DEVSPDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NZStsOUTHShk`"]
        pub enum NZSTSOUTHSHKW {
            #[doc = "Send a STALL handshake on a nonzero-length status OUT transaction and do not send the received OUT packet to the application."]
            VALUE1,
            #[doc = "Send the received OUT packet to the application (zero-length or nonzero-length) and send a handshake based on the NAK and STALL bits for the endpoint in the Device Endpoint Control register."]
            VALUE2,
        }
        impl NZSTSOUTHSHKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NZSTSOUTHSHKW::VALUE1 => true,
                    NZSTSOUTHSHKW::VALUE2 => false,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NZSTSOUTHSHKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NZSTSOUTHSHKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NZSTSOUTHSHKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Send a STALL handshake on a nonzero-length status OUT transaction and do not send the received OUT packet to the application."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NZSTSOUTHSHKW::VALUE1)
            }
            #[doc = "Send the received OUT packet to the application (zero-length or nonzero-length) and send a handshake based on the NAK and STALL bits for the endpoint in the Device Endpoint Control register."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NZSTSOUTHSHKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DEVADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DEVADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PerFrInt`"]
        pub enum PERFRINTW {
            #[doc = "80% of the frame interval"]
            VALUE1,
            #[doc = "85%"]
            VALUE2,
            #[doc = "90%"]
            VALUE3,
            #[doc = "95%"]
            VALUE4,
        }
        impl PERFRINTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PERFRINTW::VALUE1 => 0,
                    PERFRINTW::VALUE2 => 1,
                    PERFRINTW::VALUE3 => 2,
                    PERFRINTW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PERFRINTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PERFRINTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PERFRINTW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "80% of the frame interval"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PERFRINTW::VALUE1)
            }
            #[doc = "85%"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PERFRINTW::VALUE2)
            }
            #[doc = "90%"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PERFRINTW::VALUE3)
            }
            #[doc = "95%"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PERFRINTW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DESCDMAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DESCDMAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PerSchIntvl`"]
        pub enum PERSCHINTVLW {
            #[doc = "25% of frame."]
            VALUE1,
            #[doc = "50% of frame."]
            VALUE2,
            #[doc = "75% of frame."]
            VALUE3,
        }
        impl PERSCHINTVLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PERSCHINTVLW::VALUE1 => 0,
                    PERSCHINTVLW::VALUE2 => 1,
                    PERSCHINTVLW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PERSCHINTVLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PERSCHINTVLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PERSCHINTVLW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "25% of frame."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PERSCHINTVLW::VALUE1)
            }
            #[doc = "50% of frame."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PERSCHINTVLW::VALUE2)
            }
            #[doc = "75% of frame."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PERSCHINTVLW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Device Speed"]
            #[inline]
            pub fn dev_spd(&self) -> DEVSPDR {
                DEVSPDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - Non-Zero-Length Status OUT Handshake"]
            #[inline]
            pub fn nzsts_outhshk(&self) -> NZSTSOUTHSHKR {
                NZSTSOUTHSHKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:10 - Device Address"]
            #[inline]
            pub fn dev_addr(&self) -> DEVADDRR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DEVADDRR { bits }
            }
            #[doc = "Bits 11:12 - Periodic Frame Interval"]
            #[inline]
            pub fn per_fr_int(&self) -> PERFRINTR {
                PERFRINTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 23 - Enable Scatter/Gather DMA in Device mode."]
            #[inline]
            pub fn desc_dma(&self) -> DESCDMAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DESCDMAR { bits }
            }
            #[doc = "Bits 24:25 - Periodic Scheduling Interval"]
            #[inline]
            pub fn per_sch_intvl(&self) -> PERSCHINTVLR {
                PERSCHINTVLR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0820_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Device Speed"]
            #[inline]
            pub fn dev_spd(&mut self) -> _DEVSPDW {
                _DEVSPDW { w: self }
            }
            #[doc = "Bit 2 - Non-Zero-Length Status OUT Handshake"]
            #[inline]
            pub fn nzsts_outhshk(&mut self) -> _NZSTSOUTHSHKW {
                _NZSTSOUTHSHKW { w: self }
            }
            #[doc = "Bits 4:10 - Device Address"]
            #[inline]
            pub fn dev_addr(&mut self) -> _DEVADDRW {
                _DEVADDRW { w: self }
            }
            #[doc = "Bits 11:12 - Periodic Frame Interval"]
            #[inline]
            pub fn per_fr_int(&mut self) -> _PERFRINTW {
                _PERFRINTW { w: self }
            }
            #[doc = "Bit 23 - Enable Scatter/Gather DMA in Device mode."]
            #[inline]
            pub fn desc_dma(&mut self) -> _DESCDMAW {
                _DESCDMAW { w: self }
            }
            #[doc = "Bits 24:25 - Periodic Scheduling Interval"]
            #[inline]
            pub fn per_sch_intvl(&mut self) -> _PERSCHINTVLW {
                _PERSCHINTVLW { w: self }
            }
        }
    }
    #[doc = "Device Control Register"]
    pub struct DCTL {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Control Register"]
    pub mod dctl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DCTL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RMTWKUPSIGR {
            bits: bool,
        }
        impl RMTWKUPSIGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `SftDiscon`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFTDISCONR {
            #[doc = "Normal operation. When this bit is cleared after a soft disconnect, the core drives a device connect event to the USB host. When the device is reconnected, the USB host restarts device enumeration."]
            VALUE1,
            #[doc = "The core drives a device disconnect event to the USB host."]
            VALUE2,
        }
        impl SFTDISCONR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFTDISCONR::VALUE1 => false,
                    SFTDISCONR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFTDISCONR {
                match value {
                    false => SFTDISCONR::VALUE1,
                    true => SFTDISCONR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFTDISCONR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFTDISCONR::VALUE2
            }
        }
        #[doc = "Possible values of the field `GNPINNakSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GNPINNAKSTSR {
            #[doc = "A handshake is sent out based on the data availability in the transmit FIFO."]
            VALUE1,
            #[doc = "A NAK handshake is sent out on all non-periodic IN endpoints, irrespective of the data availability in the transmit FIFO."]
            VALUE2,
        }
        impl GNPINNAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GNPINNAKSTSR::VALUE1 => false,
                    GNPINNAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GNPINNAKSTSR {
                match value {
                    false => GNPINNAKSTSR::VALUE1,
                    true => GNPINNAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GNPINNAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GNPINNAKSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `GOUTNakSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GOUTNAKSTSR {
            #[doc = "A handshake is sent based on the FIFO Status and the NAK and STALL bit settings."]
            VALUE1,
            #[doc = "No data is written to the RxFIFO, irrespective of space availability. Sends a NAK handshake on all packets, except on SETUP transactions. All isochronous OUT packets are dropped."]
            VALUE2,
        }
        impl GOUTNAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GOUTNAKSTSR::VALUE1 => false,
                    GOUTNAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GOUTNAKSTSR {
                match value {
                    false => GOUTNAKSTSR::VALUE1,
                    true => GOUTNAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GOUTNAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GOUTNAKSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `GMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GMCR {
            #[doc = "Invalid."]
            VALUE1,
            #[doc = "1 packet."]
            VALUE2,
            #[doc = "2 packets."]
            VALUE3,
            #[doc = "3 packets."]
            VALUE4,
        }
        impl GMCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    GMCR::VALUE1 => 0,
                    GMCR::VALUE2 => 0x01,
                    GMCR::VALUE3 => 0x02,
                    GMCR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> GMCR {
                match value {
                    0 => GMCR::VALUE1,
                    1 => GMCR::VALUE2,
                    2 => GMCR::VALUE3,
                    3 => GMCR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GMCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == GMCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == GMCR::VALUE4
            }
        }
        #[doc = "Possible values of the field `IgnrFrmNum`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IGNRFRMNUMR {
            #[doc = "Scatter/Gather enabled: The core transmits the packets only in the frame number in which they are intended to be transmitted. Scatter/Gather disabled: Periodic transfer interrupt feature is disabled; the application must program transfers for periodic endpoints every frame"]
            VALUE1,
            #[doc = "Scatter/Gather enabled: The core ignores the frame number, sending packets immediately as the packets are ready. Scatter/Gather disabled: Periodic transfer interrupt feature is enabled; the application can program transfers for multiple frames for periodic endpoints."]
            VALUE2,
        }
        impl IGNRFRMNUMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IGNRFRMNUMR::VALUE1 => false,
                    IGNRFRMNUMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IGNRFRMNUMR {
                match value {
                    false => IGNRFRMNUMR::VALUE1,
                    true => IGNRFRMNUMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IGNRFRMNUMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IGNRFRMNUMR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct NAKONBBLER {
            bits: bool,
        }
        impl NAKONBBLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `EnContOnBNA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENCONTONBNAR {
            #[doc = "After receiving BNA interrupt, the core disables the endpoint. When the endpoint is re-enabled by the application, the core starts processing from the DOEPDMA descriptor."]
            VALUE1,
            #[doc = "After receiving BNA interrupt, the core disables the endpoint. When the endpoint is re-enabled by the application, the core starts processing from the descriptor that received the BNA interrupt."]
            VALUE2,
        }
        impl ENCONTONBNAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENCONTONBNAR::VALUE1 => false,
                    ENCONTONBNAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENCONTONBNAR {
                match value {
                    false => ENCONTONBNAR::VALUE1,
                    true => ENCONTONBNAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENCONTONBNAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENCONTONBNAR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMTWKUPSIGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMTWKUPSIGW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SftDiscon`"]
        pub enum SFTDISCONW {
            #[doc = "Normal operation. When this bit is cleared after a soft disconnect, the core drives a device connect event to the USB host. When the device is reconnected, the USB host restarts device enumeration."]
            VALUE1,
            #[doc = "The core drives a device disconnect event to the USB host."]
            VALUE2,
        }
        impl SFTDISCONW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFTDISCONW::VALUE1 => false,
                    SFTDISCONW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFTDISCONW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFTDISCONW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFTDISCONW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal operation. When this bit is cleared after a soft disconnect, the core drives a device connect event to the USB host. When the device is reconnected, the USB host restarts device enumeration."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFTDISCONW::VALUE1)
            }
            #[doc = "The core drives a device disconnect event to the USB host."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFTDISCONW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SGNPINNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SGNPINNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CGNPINNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CGNPINNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SGOUTNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SGOUTNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CGOUTNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CGOUTNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GMC`"]
        pub enum GMCW {
            #[doc = "Invalid."]
            VALUE1,
            #[doc = "1 packet."]
            VALUE2,
            #[doc = "2 packets."]
            VALUE3,
            #[doc = "3 packets."]
            VALUE4,
        }
        impl GMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GMCW::VALUE1 => 0,
                    GMCW::VALUE2 => 1,
                    GMCW::VALUE3 => 2,
                    GMCW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GMCW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Invalid."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GMCW::VALUE1)
            }
            #[doc = "1 packet."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GMCW::VALUE2)
            }
            #[doc = "2 packets."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(GMCW::VALUE3)
            }
            #[doc = "3 packets."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(GMCW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IgnrFrmNum`"]
        pub enum IGNRFRMNUMW {
            #[doc = "Scatter/Gather enabled: The core transmits the packets only in the frame number in which they are intended to be transmitted. Scatter/Gather disabled: Periodic transfer interrupt feature is disabled; the application must program transfers for periodic endpoints every frame"]
            VALUE1,
            #[doc = "Scatter/Gather enabled: The core ignores the frame number, sending packets immediately as the packets are ready. Scatter/Gather disabled: Periodic transfer interrupt feature is enabled; the application can program transfers for multiple frames for periodic endpoints."]
            VALUE2,
        }
        impl IGNRFRMNUMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IGNRFRMNUMW::VALUE1 => false,
                    IGNRFRMNUMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IGNRFRMNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IGNRFRMNUMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IGNRFRMNUMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Scatter/Gather enabled: The core transmits the packets only in the frame number in which they are intended to be transmitted. Scatter/Gather disabled: Periodic transfer interrupt feature is disabled; the application must program transfers for periodic endpoints every frame"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IGNRFRMNUMW::VALUE1)
            }
            #[doc = "Scatter/Gather enabled: The core ignores the frame number, sending packets immediately as the packets are ready. Scatter/Gather disabled: Periodic transfer interrupt feature is enabled; the application can program transfers for multiple frames for periodic endpoints."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IGNRFRMNUMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NAKONBBLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NAKONBBLEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EnContOnBNA`"]
        pub enum ENCONTONBNAW {
            #[doc = "After receiving BNA interrupt, the core disables the endpoint. When the endpoint is re-enabled by the application, the core starts processing from the DOEPDMA descriptor."]
            VALUE1,
            #[doc = "After receiving BNA interrupt, the core disables the endpoint. When the endpoint is re-enabled by the application, the core starts processing from the descriptor that received the BNA interrupt."]
            VALUE2,
        }
        impl ENCONTONBNAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENCONTONBNAW::VALUE1 => false,
                    ENCONTONBNAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENCONTONBNAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENCONTONBNAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENCONTONBNAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "After receiving BNA interrupt, the core disables the endpoint. When the endpoint is re-enabled by the application, the core starts processing from the DOEPDMA descriptor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENCONTONBNAW::VALUE1)
            }
            #[doc = "After receiving BNA interrupt, the core disables the endpoint. When the endpoint is re-enabled by the application, the core starts processing from the descriptor that received the BNA interrupt."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENCONTONBNAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Remote Wakeup Signaling"]
            #[inline]
            pub fn rmt_wk_up_sig(&self) -> RMTWKUPSIGR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RMTWKUPSIGR { bits }
            }
            #[doc = "Bit 1 - Soft Disconnect"]
            #[inline]
            pub fn sft_discon(&self) -> SFTDISCONR {
                SFTDISCONR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Global Non-periodic IN NAK Status"]
            #[inline]
            pub fn gnpinnak_sts(&self) -> GNPINNAKSTSR {
                GNPINNAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Global OUT NAK Status"]
            #[inline]
            pub fn goutnak_sts(&self) -> GOUTNAKSTSR {
                GOUTNAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 13:14 - Global Multi Count"]
            #[inline]
            pub fn gmc(&self) -> GMCR {
                GMCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Ignore frame number for isochronous endpoints in case of Scatter/Gather DMA"]
            #[inline]
            pub fn ignr_frm_num(&self) -> IGNRFRMNUMR {
                IGNRFRMNUMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Set NAK automatically on babble"]
            #[inline]
            pub fn nak_on_bble(&self) -> NAKONBBLER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NAKONBBLER { bits }
            }
            #[doc = "Bit 17 - Enable continue on BNA"]
            #[inline]
            pub fn en_cont_on_bna(&self) -> ENCONTONBNAR {
                ENCONTONBNAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x02 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Remote Wakeup Signaling"]
            #[inline]
            pub fn rmt_wk_up_sig(&mut self) -> _RMTWKUPSIGW {
                _RMTWKUPSIGW { w: self }
            }
            #[doc = "Bit 1 - Soft Disconnect"]
            #[inline]
            pub fn sft_discon(&mut self) -> _SFTDISCONW {
                _SFTDISCONW { w: self }
            }
            #[doc = "Bit 7 - Set Global Non-periodic IN NAK"]
            #[inline]
            pub fn sgnpin_nak(&mut self) -> _SGNPINNAKW {
                _SGNPINNAKW { w: self }
            }
            #[doc = "Bit 8 - Clear Global Non-periodic IN NAK"]
            #[inline]
            pub fn cgnpin_nak(&mut self) -> _CGNPINNAKW {
                _CGNPINNAKW { w: self }
            }
            #[doc = "Bit 9 - Set Global OUT NAK"]
            #[inline]
            pub fn sgoutnak(&mut self) -> _SGOUTNAKW {
                _SGOUTNAKW { w: self }
            }
            #[doc = "Bit 10 - Clear Global OUT NAK"]
            #[inline]
            pub fn cgoutnak(&mut self) -> _CGOUTNAKW {
                _CGOUTNAKW { w: self }
            }
            #[doc = "Bits 13:14 - Global Multi Count"]
            #[inline]
            pub fn gmc(&mut self) -> _GMCW {
                _GMCW { w: self }
            }
            #[doc = "Bit 15 - Ignore frame number for isochronous endpoints in case of Scatter/Gather DMA"]
            #[inline]
            pub fn ignr_frm_num(&mut self) -> _IGNRFRMNUMW {
                _IGNRFRMNUMW { w: self }
            }
            #[doc = "Bit 16 - Set NAK automatically on babble"]
            #[inline]
            pub fn nak_on_bble(&mut self) -> _NAKONBBLEW {
                _NAKONBBLEW { w: self }
            }
            #[doc = "Bit 17 - Enable continue on BNA"]
            #[inline]
            pub fn en_cont_on_bna(&mut self) -> _ENCONTONBNAW {
                _ENCONTONBNAW { w: self }
            }
        }
    }
    #[doc = "Device Status Register"]
    pub struct DSTS {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Status Register"]
    pub mod dsts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DSTS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct SUSPSTSR {
            bits: bool,
        }
        impl SUSPSTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `EnumSpd`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENUMSPDR {
            #[doc = "Full speed (PHY clock is running at 48 MHz)"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ENUMSPDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENUMSPDR::VALUE4 => 0x03,
                    ENUMSPDR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENUMSPDR {
                match value {
                    3 => ENUMSPDR::VALUE4,
                    i => ENUMSPDR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ENUMSPDR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct ERRTICERRR {
            bits: bool,
        }
        impl ERRTICERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SOFFNR {
            bits: u16,
        }
        impl SOFFNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Suspend Status"]
            #[inline]
            pub fn susp_sts(&self) -> SUSPSTSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SUSPSTSR { bits }
            }
            #[doc = "Bits 1:2 - Enumerated Speed"]
            #[inline]
            pub fn enum_spd(&self) -> ENUMSPDR {
                ENUMSPDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Erratic Error"]
            #[inline]
            pub fn errtic_err(&self) -> ERRTICERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ERRTICERRR { bits }
            }
            #[doc = "Bits 8:21 - Frame Number of the Received SOF"]
            #[inline]
            pub fn soffn(&self) -> SOFFNR {
                let bits = {
                    const MASK: u16 = 0x3fff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SOFFNR { bits }
            }
        }
    }
    #[doc = "Device IN Endpoint Common Interrupt Mask Register"]
    pub struct DIEPMSK {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint Common Interrupt Mask Register"]
    pub mod diepmsk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPMSK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERCOMPLMSKR {
            bits: bool,
        }
        impl XFERCOMPLMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISBLDMSKR {
            bits: bool,
        }
        impl EPDISBLDMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBERRMSKR {
            bits: bool,
        }
        impl AHBERRMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TIMEOUTMSKR {
            bits: bool,
        }
        impl TIMEOUTMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INTKNTXFEMPMSKR {
            bits: bool,
        }
        impl INTKNTXFEMPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNAKEFFMSKR {
            bits: bool,
        }
        impl INEPNAKEFFMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFIFOUNDRNMSKR {
            bits: bool,
        }
        impl TXFIFOUNDRNMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BNAININTRMSKR {
            bits: bool,
        }
        impl BNAININTRMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NAKMSKR {
            bits: bool,
        }
        impl NAKMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERCOMPLMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERCOMPLMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISBLDMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISBLDMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBERRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBERRMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TIMEOUTMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TIMEOUTMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INTKNTXFEMPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INTKNTXFEMPMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNAKEFFMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNAKEFFMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFIFOUNDRNMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFIFOUNDRNMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNAININTRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNAININTRMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NAKMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NAKMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt Mask"]
            #[inline]
            pub fn xfer_compl_msk(&self) -> XFERCOMPLMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XFERCOMPLMSKR { bits }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt Mask"]
            #[inline]
            pub fn epdisbld_msk(&self) -> EPDISBLDMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISBLDMSKR { bits }
            }
            #[doc = "Bit 2 - AHB Error Mask"]
            #[inline]
            pub fn ahberr_msk(&self) -> AHBERRMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBERRMSKR { bits }
            }
            #[doc = "Bit 3 - Timeout Condition Mask"]
            #[inline]
            pub fn time_outmsk(&self) -> TIMEOUTMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TIMEOUTMSKR { bits }
            }
            #[doc = "Bit 4 - IN Token Received When TxFIFO Empty Mask"]
            #[inline]
            pub fn intkn_txfemp_msk(&self) -> INTKNTXFEMPMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INTKNTXFEMPMSKR { bits }
            }
            #[doc = "Bit 6 - IN Endpoint NAK Effective Mask"]
            #[inline]
            pub fn inepnak_eff_msk(&self) -> INEPNAKEFFMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INEPNAKEFFMSKR { bits }
            }
            #[doc = "Bit 8 - Fifo Underrun Mask"]
            #[inline]
            pub fn txfifo_undrn_msk(&self) -> TXFIFOUNDRNMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TXFIFOUNDRNMSKR { bits }
            }
            #[doc = "Bit 9 - BNA Interrupt Mask"]
            #[inline]
            pub fn bnain_intr_msk(&self) -> BNAININTRMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BNAININTRMSKR { bits }
            }
            #[doc = "Bit 13 - NAK interrupt Mask"]
            #[inline]
            pub fn nakmsk(&self) -> NAKMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NAKMSKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt Mask"]
            #[inline]
            pub fn xfer_compl_msk(&mut self) -> _XFERCOMPLMSKW {
                _XFERCOMPLMSKW { w: self }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt Mask"]
            #[inline]
            pub fn epdisbld_msk(&mut self) -> _EPDISBLDMSKW {
                _EPDISBLDMSKW { w: self }
            }
            #[doc = "Bit 2 - AHB Error Mask"]
            #[inline]
            pub fn ahberr_msk(&mut self) -> _AHBERRMSKW {
                _AHBERRMSKW { w: self }
            }
            #[doc = "Bit 3 - Timeout Condition Mask"]
            #[inline]
            pub fn time_outmsk(&mut self) -> _TIMEOUTMSKW {
                _TIMEOUTMSKW { w: self }
            }
            #[doc = "Bit 4 - IN Token Received When TxFIFO Empty Mask"]
            #[inline]
            pub fn intkn_txfemp_msk(&mut self) -> _INTKNTXFEMPMSKW {
                _INTKNTXFEMPMSKW { w: self }
            }
            #[doc = "Bit 6 - IN Endpoint NAK Effective Mask"]
            #[inline]
            pub fn inepnak_eff_msk(&mut self) -> _INEPNAKEFFMSKW {
                _INEPNAKEFFMSKW { w: self }
            }
            #[doc = "Bit 8 - Fifo Underrun Mask"]
            #[inline]
            pub fn txfifo_undrn_msk(&mut self) -> _TXFIFOUNDRNMSKW {
                _TXFIFOUNDRNMSKW { w: self }
            }
            #[doc = "Bit 9 - BNA Interrupt Mask"]
            #[inline]
            pub fn bnain_intr_msk(&mut self) -> _BNAININTRMSKW {
                _BNAININTRMSKW { w: self }
            }
            #[doc = "Bit 13 - NAK interrupt Mask"]
            #[inline]
            pub fn nakmsk(&mut self) -> _NAKMSKW {
                _NAKMSKW { w: self }
            }
        }
    }
    #[doc = "Device OUT Endpoint Common Interrupt Mask Register"]
    pub struct DOEPMSK {
        register: VolatileCell<u32>,
    }
    #[doc = "Device OUT Endpoint Common Interrupt Mask Register"]
    pub mod doepmsk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPMSK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERCOMPLMSKR {
            bits: bool,
        }
        impl XFERCOMPLMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISBLDMSKR {
            bits: bool,
        }
        impl EPDISBLDMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBERRMSKR {
            bits: bool,
        }
        impl AHBERRMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SETUPMSKR {
            bits: bool,
        }
        impl SETUPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OUTTKNEPDISMSKR {
            bits: bool,
        }
        impl OUTTKNEPDISMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BACK2BACKSETUPR {
            bits: bool,
        }
        impl BACK2BACKSETUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OUTPKTERRMSKR {
            bits: bool,
        }
        impl OUTPKTERRMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BNAOUTINTRMSKR {
            bits: bool,
        }
        impl BNAOUTINTRMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BBLEERRMSKR {
            bits: bool,
        }
        impl BBLEERRMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NAKMSKR {
            bits: bool,
        }
        impl NAKMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NYETMSKR {
            bits: bool,
        }
        impl NYETMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERCOMPLMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERCOMPLMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISBLDMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISBLDMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBERRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBERRMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETUPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETUPMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OUTTKNEPDISMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OUTTKNEPDISMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BACK2BACKSETUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BACK2BACKSETUPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OUTPKTERRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OUTPKTERRMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNAOUTINTRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNAOUTINTRMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BBLEERRMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BBLEERRMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NAKMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NAKMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NYETMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NYETMSKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt Mask"]
            #[inline]
            pub fn xfer_compl_msk(&self) -> XFERCOMPLMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XFERCOMPLMSKR { bits }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt Mask"]
            #[inline]
            pub fn epdisbld_msk(&self) -> EPDISBLDMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISBLDMSKR { bits }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr_msk(&self) -> AHBERRMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBERRMSKR { bits }
            }
            #[doc = "Bit 3 - SETUP Phase Done Mask"]
            #[inline]
            pub fn set_upmsk(&self) -> SETUPMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SETUPMSKR { bits }
            }
            #[doc = "Bit 4 - OUT Token Received when Endpoint Disabled Mask"]
            #[inline]
            pub fn outtkn_epdis_msk(&self) -> OUTTKNEPDISMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OUTTKNEPDISMSKR { bits }
            }
            #[doc = "Bit 6 - Back-to-Back SETUP Packets Received Mask"]
            #[inline]
            pub fn back2back_setup(&self) -> BACK2BACKSETUPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BACK2BACKSETUPR { bits }
            }
            #[doc = "Bit 8 - OUT Packet Error Mask"]
            #[inline]
            pub fn out_pkt_err_msk(&self) -> OUTPKTERRMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OUTPKTERRMSKR { bits }
            }
            #[doc = "Bit 9 - BNA interrupt Mask"]
            #[inline]
            pub fn bna_out_intr_msk(&self) -> BNAOUTINTRMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BNAOUTINTRMSKR { bits }
            }
            #[doc = "Bit 12 - Babble Interrupt Mask"]
            #[inline]
            pub fn bble_err_msk(&self) -> BBLEERRMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BBLEERRMSKR { bits }
            }
            #[doc = "Bit 13 - NAK Interrupt Mask"]
            #[inline]
            pub fn nakmsk(&self) -> NAKMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NAKMSKR { bits }
            }
            #[doc = "Bit 14 - NYET Interrupt Mask"]
            #[inline]
            pub fn nyetmsk(&self) -> NYETMSKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NYETMSKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt Mask"]
            #[inline]
            pub fn xfer_compl_msk(&mut self) -> _XFERCOMPLMSKW {
                _XFERCOMPLMSKW { w: self }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt Mask"]
            #[inline]
            pub fn epdisbld_msk(&mut self) -> _EPDISBLDMSKW {
                _EPDISBLDMSKW { w: self }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr_msk(&mut self) -> _AHBERRMSKW {
                _AHBERRMSKW { w: self }
            }
            #[doc = "Bit 3 - SETUP Phase Done Mask"]
            #[inline]
            pub fn set_upmsk(&mut self) -> _SETUPMSKW {
                _SETUPMSKW { w: self }
            }
            #[doc = "Bit 4 - OUT Token Received when Endpoint Disabled Mask"]
            #[inline]
            pub fn outtkn_epdis_msk(&mut self) -> _OUTTKNEPDISMSKW {
                _OUTTKNEPDISMSKW { w: self }
            }
            #[doc = "Bit 6 - Back-to-Back SETUP Packets Received Mask"]
            #[inline]
            pub fn back2back_setup(&mut self) -> _BACK2BACKSETUPW {
                _BACK2BACKSETUPW { w: self }
            }
            #[doc = "Bit 8 - OUT Packet Error Mask"]
            #[inline]
            pub fn out_pkt_err_msk(&mut self) -> _OUTPKTERRMSKW {
                _OUTPKTERRMSKW { w: self }
            }
            #[doc = "Bit 9 - BNA interrupt Mask"]
            #[inline]
            pub fn bna_out_intr_msk(&mut self) -> _BNAOUTINTRMSKW {
                _BNAOUTINTRMSKW { w: self }
            }
            #[doc = "Bit 12 - Babble Interrupt Mask"]
            #[inline]
            pub fn bble_err_msk(&mut self) -> _BBLEERRMSKW {
                _BBLEERRMSKW { w: self }
            }
            #[doc = "Bit 13 - NAK Interrupt Mask"]
            #[inline]
            pub fn nakmsk(&mut self) -> _NAKMSKW {
                _NAKMSKW { w: self }
            }
            #[doc = "Bit 14 - NYET Interrupt Mask"]
            #[inline]
            pub fn nyetmsk(&mut self) -> _NYETMSKW {
                _NYETMSKW { w: self }
            }
        }
    }
    #[doc = "Device All Endpoints Interrupt Register"]
    pub struct DAINT {
        register: VolatileCell<u32>,
    }
    #[doc = "Device All Endpoints Interrupt Register"]
    pub mod daint {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DAINT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPINTR {
            bits: u16,
        }
        impl INEPINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct OUTEPINTR {
            bits: u16,
        }
        impl OUTEPINTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint Interrupt Bits"]
            #[inline]
            pub fn in_ep_int(&self) -> INEPINTR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPINTR { bits }
            }
            #[doc = "Bits 16:31 - OUT Endpoint Interrupt Bits"]
            #[inline]
            pub fn out_epint(&self) -> OUTEPINTR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                OUTEPINTR { bits }
            }
        }
    }
    #[doc = "Device All Endpoints Interrupt Mask Register"]
    pub struct DAINTMSK {
        register: VolatileCell<u32>,
    }
    #[doc = "Device All Endpoints Interrupt Mask Register"]
    pub mod daintmsk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAINTMSK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPMSKR {
            bits: u16,
        }
        impl INEPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct OUTEPMSKR {
            bits: u16,
        }
        impl OUTEPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPMSKW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OUTEPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OUTEPMSKW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN EP Interrupt Mask Bits"]
            #[inline]
            pub fn in_ep_msk(&self) -> INEPMSKR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPMSKR { bits }
            }
            #[doc = "Bits 16:31 - OUT EP Interrupt Mask Bits"]
            #[inline]
            pub fn out_ep_msk(&self) -> OUTEPMSKR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                OUTEPMSKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN EP Interrupt Mask Bits"]
            #[inline]
            pub fn in_ep_msk(&mut self) -> _INEPMSKW {
                _INEPMSKW { w: self }
            }
            #[doc = "Bits 16:31 - OUT EP Interrupt Mask Bits"]
            #[inline]
            pub fn out_ep_msk(&mut self) -> _OUTEPMSKW {
                _OUTEPMSKW { w: self }
            }
        }
    }
    #[doc = "Device VBUS Discharge Time Register"]
    pub struct DVBUSDIS {
        register: VolatileCell<u32>,
    }
    #[doc = "Device VBUS Discharge Time Register"]
    pub mod dvbusdis {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DVBUSDIS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DVBUSDISR {
            bits: u16,
        }
        impl DVBUSDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DVBUSDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DVBUSDISW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Device Vbus Discharge Time"]
            #[inline]
            pub fn dvbusdis(&self) -> DVBUSDISR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DVBUSDISR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x17d7 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Device Vbus Discharge Time"]
            #[inline]
            pub fn dvbusdis(&mut self) -> _DVBUSDISW {
                _DVBUSDISW { w: self }
            }
        }
    }
    #[doc = "Device VBUS Pulsing Time Register"]
    pub struct DVBUSPULSE {
        register: VolatileCell<u32>,
    }
    #[doc = "Device VBUS Pulsing Time Register"]
    pub mod dvbuspulse {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DVBUSPULSE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DVBUSPULSER {
            bits: u16,
        }
        impl DVBUSPULSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DVBUSPULSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DVBUSPULSEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:11 - Device Vbus Pulsing Time"]
            #[inline]
            pub fn dvbuspulse(&self) -> DVBUSPULSER {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DVBUSPULSER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x05b8 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:11 - Device Vbus Pulsing Time"]
            #[inline]
            pub fn dvbuspulse(&mut self) -> _DVBUSPULSEW {
                _DVBUSPULSEW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint FIFO Empty Interrupt Mask Register"]
    pub struct DIEPEMPMSK {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint FIFO Empty Interrupt Mask Register"]
    pub mod diepempmsk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPEMPMSK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPTXFEMPMSKR {
            bits: u16,
        }
        impl INEPTXFEMPMSKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPTXFEMPMSKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPTXFEMPMSKW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN EP Tx FIFO Empty Interrupt Mask Bits"]
            #[inline]
            pub fn in_ep_txf_emp_msk(&self) -> INEPTXFEMPMSKR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                INEPTXFEMPMSKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - IN EP Tx FIFO Empty Interrupt Mask Bits"]
            #[inline]
            pub fn in_ep_txf_emp_msk(&mut self) -> _INEPTXFEMPMSKW {
                _INEPTXFEMPMSKW { w: self }
            }
        }
    }
    #[doc = "Power and Clock Gating Control Register"]
    pub struct PCGCCTL {
        register: VolatileCell<u32>,
    }
    #[doc = "Power and Clock Gating Control Register"]
    pub mod pcgcctl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCGCCTL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct STOPPCLKR {
            bits: bool,
        }
        impl STOPPCLKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct GATEHCLKR {
            bits: bool,
        }
        impl GATEHCLKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _STOPPCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STOPPCLKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GATEHCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GATEHCLKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Stop Pclk"]
            #[inline]
            pub fn stop_pclk(&self) -> STOPPCLKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STOPPCLKR { bits }
            }
            #[doc = "Bit 1 - Gate Hclk"]
            #[inline]
            pub fn gate_hclk(&self) -> GATEHCLKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GATEHCLKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Stop Pclk"]
            #[inline]
            pub fn stop_pclk(&mut self) -> _STOPPCLKW {
                _STOPPCLKW { w: self }
            }
            #[doc = "Bit 1 - Gate Hclk"]
            #[inline]
            pub fn gate_hclk(&mut self) -> _GATEHCLKW {
                _GATEHCLKW { w: self }
            }
        }
    }
}
#[doc = "Universal Serial Bus"]
pub struct USB0 {
    register_block: usb0::RegisterBlock,
}
impl Deref for USB0 {
    type Target = usb0::RegisterBlock;
    fn deref(&self) -> &usb0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP0: Peripheral<USB0_EP0> = unsafe { Peripheral::new(0x5004_0900) };
#[doc = "Universal Serial Bus"]
pub mod usb0_ep0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Device Control IN Endpoint Control Register"]
        pub diepctl0: DIEPCTL0,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Device Endpoint Interrupt Register"]
        pub diepint0: DIEPINT0,
        _reserved1: [u8; 4usize],
        #[doc = "0x10 - Device IN Endpoint Transfer Size Register"]
        pub dieptsiz0: DIEPTSIZ0,
        #[doc = "0x14 - Device Endpoint DMA Address Register"]
        pub diepdma0: DIEPDMA0,
        #[doc = "0x18 - Device IN Endpoint Transmit FIFO Status Register"]
        pub dtxfsts0: DTXFSTS0,
        #[doc = "0x1c - Device Endpoint DMA Buffer Address Register"]
        pub diepdmab0: DIEPDMAB0,
        _reserved2: [u8; 480usize],
        #[doc = "0x200 - Device Control OUT Endpoint Control Register"]
        pub doepctl0: DOEPCTL0,
        _reserved3: [u8; 4usize],
        #[doc = "0x208 - Device Endpoint Interrupt Register"]
        pub doepint0: DOEPINT0,
        _reserved4: [u8; 4usize],
        #[doc = "0x210 - Device OUT Endpoint Transfer Size Register"]
        pub doeptsiz0: DOEPTSIZ0,
        #[doc = "0x214 - Device Endpoint DMA Address Register"]
        pub doepdma0: DOEPDMA0,
        _reserved5: [u8; 4usize],
        #[doc = "0x21c - Device Endpoint DMA Buffer Address Register"]
        pub doepdmab0: DOEPDMAB0,
    }
    #[doc = "Device Control IN Endpoint Control Register"]
    pub struct DIEPCTL0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Control IN Endpoint Control Register"]
    pub mod diepctl0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPCTL0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MPSR {
            #[doc = "64 bytes"]
            VALUE1,
            #[doc = "32 bytes"]
            VALUE2,
            #[doc = "16 bytes"]
            VALUE3,
            #[doc = "8 bytes"]
            VALUE4,
        }
        impl MPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MPSR::VALUE1 => 0,
                    MPSR::VALUE2 => 0x01,
                    MPSR::VALUE3 => 0x02,
                    MPSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MPSR {
                match value {
                    0 => MPSR::VALUE1,
                    1 => MPSR::VALUE2,
                    2 => MPSR::VALUE3,
                    3 => MPSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MPSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MPSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MPSR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBACTEPR {
            bits: bool,
        }
        impl USBACTEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `NAKSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAKSTSR {
            #[doc = "The core is transmitting non-NAK handshakes based on the FIFO status"]
            VALUE1,
            #[doc = "The core is transmitting NAK handshakes on this endpoint."]
            VALUE2,
        }
        impl NAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAKSTSR::VALUE1 => false,
                    NAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAKSTSR {
                match value {
                    false => NAKSTSR::VALUE1,
                    true => NAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAKSTSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPTYPER {
            bits: u8,
        }
        impl EPTYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct STALLR {
            bits: bool,
        }
        impl STALLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFNUMR {
            bits: u8,
        }
        impl TXFNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISR {
            bits: bool,
        }
        impl EPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPENAR {
            bits: bool,
        }
        impl EPENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `MPS`"]
        pub enum MPSW {
            #[doc = "64 bytes"]
            VALUE1,
            #[doc = "32 bytes"]
            VALUE2,
            #[doc = "16 bytes"]
            VALUE3,
            #[doc = "8 bytes"]
            VALUE4,
        }
        impl MPSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MPSW::VALUE1 => 0,
                    MPSW::VALUE2 => 1,
                    MPSW::VALUE3 => 2,
                    MPSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MPSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "64 bytes"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MPSW::VALUE1)
            }
            #[doc = "32 bytes"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MPSW::VALUE2)
            }
            #[doc = "16 bytes"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MPSW::VALUE3)
            }
            #[doc = "8 bytes"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MPSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STALLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STALLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFNUMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&self) -> MPSR {
                MPSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&self) -> USBACTEPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBACTEPR { bits }
            }
            #[doc = "Bit 17 - NAK Status"]
            #[inline]
            pub fn naksts(&self) -> NAKSTSR {
                NAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&self) -> EPTYPER {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EPTYPER { bits }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&self) -> STALLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STALLR { bits }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&self) -> TXFNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TXFNUMR { bits }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&self) -> EPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISR { bits }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&self) -> EPENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x8000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&mut self) -> _MPSW {
                _MPSW { w: self }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&mut self) -> _STALLW {
                _STALLW { w: self }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&mut self) -> _TXFNUMW {
                _TXFNUMW { w: self }
            }
            #[doc = "Bit 26 - Clear NAK"]
            #[inline]
            pub fn cnak(&mut self) -> _CNAKW {
                _CNAKW { w: self }
            }
            #[doc = "Bit 27 - Set NAK"]
            #[inline]
            pub fn snak(&mut self) -> _SNAKW {
                _SNAKW { w: self }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&mut self) -> _EPDISW {
                _EPDISW { w: self }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&mut self) -> _EPENAW {
                _EPENAW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub struct DIEPINT0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub mod diepint0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPINT0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERCOMPLR {
            bits: bool,
        }
        impl XFERCOMPLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISBLDR {
            bits: bool,
        }
        impl EPDISBLDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBERRR {
            bits: bool,
        }
        impl AHBERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TIMEOUTR {
            bits: bool,
        }
        impl TIMEOUTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INTKNTXFEMPR {
            bits: bool,
        }
        impl INTKNTXFEMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNAKEFFR {
            bits: bool,
        }
        impl INEPNAKEFFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFEMPR {
            bits: bool,
        }
        impl TXFEMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BNAINTRR {
            bits: bool,
        }
        impl BNAINTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERCOMPLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERCOMPLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISBLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISBLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBERRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TIMEOUTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TIMEOUTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INTKNTXFEMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INTKNTXFEMPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNAKEFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNAKEFFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNAINTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNAINTRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&self) -> XFERCOMPLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XFERCOMPLR { bits }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&self) -> EPDISBLDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISBLDR { bits }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&self) -> AHBERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBERRR { bits }
            }
            #[doc = "Bit 3 - Timeout Condition"]
            #[inline]
            pub fn time_out(&self) -> TIMEOUTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TIMEOUTR { bits }
            }
            #[doc = "Bit 4 - IN Token Received When TxFIFO is Empty"]
            #[inline]
            pub fn intkn_txfemp(&self) -> INTKNTXFEMPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INTKNTXFEMPR { bits }
            }
            #[doc = "Bit 6 - IN Endpoint NAK Effective"]
            #[inline]
            pub fn inepnak_eff(&self) -> INEPNAKEFFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INEPNAKEFFR { bits }
            }
            #[doc = "Bit 7 - Transmit FIFO Empty"]
            #[inline]
            pub fn tx_femp(&self) -> TXFEMPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TXFEMPR { bits }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&self) -> BNAINTRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BNAINTRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x80 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&mut self) -> _XFERCOMPLW {
                _XFERCOMPLW { w: self }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&mut self) -> _EPDISBLDW {
                _EPDISBLDW { w: self }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&mut self) -> _AHBERRW {
                _AHBERRW { w: self }
            }
            #[doc = "Bit 3 - Timeout Condition"]
            #[inline]
            pub fn time_out(&mut self) -> _TIMEOUTW {
                _TIMEOUTW { w: self }
            }
            #[doc = "Bit 4 - IN Token Received When TxFIFO is Empty"]
            #[inline]
            pub fn intkn_txfemp(&mut self) -> _INTKNTXFEMPW {
                _INTKNTXFEMPW { w: self }
            }
            #[doc = "Bit 6 - IN Endpoint NAK Effective"]
            #[inline]
            pub fn inepnak_eff(&mut self) -> _INEPNAKEFFW {
                _INEPNAKEFFW { w: self }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&mut self) -> _BNAINTRW {
                _BNAINTRW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint Transfer Size Register"]
    pub struct DIEPTSIZ0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint Transfer Size Register"]
    pub mod dieptsiz0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTSIZ0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERSIZER {
            bits: u8,
        }
        impl XFERSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTCNTR {
            bits: u8,
        }
        impl PKTCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTCNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:6 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&self) -> XFERSIZER {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XFERSIZER { bits }
            }
            #[doc = "Bits 19:20 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&self) -> PKTCNTR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PKTCNTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:6 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&mut self) -> _XFERSIZEW {
                _XFERSIZEW { w: self }
            }
            #[doc = "Bits 19:20 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&mut self) -> _PKTCNTW {
                _PKTCNTW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub struct DIEPDMA0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub mod diepdma0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPDMA0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMAADDRR {
            bits: u32,
        }
        impl DMAADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMAADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMAADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&self) -> DMAADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMAADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&mut self) -> _DMAADDRW {
                _DMAADDRW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint Transmit FIFO Status Register"]
    pub struct DTXFSTS0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint Transmit FIFO Status Register"]
    pub mod dtxfsts0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DTXFSTS0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `INEPTxFSpcAvail`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INEPTXFSPCAVAILR {
            #[doc = "Endpoint TxFIFO is full"]
            VALUE1,
            #[doc = "1 word available"]
            VALUE2,
            #[doc = "2 words available"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u16),
        }
        impl INEPTXFSPCAVAILR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                match *self {
                    INEPTXFSPCAVAILR::VALUE1 => 0,
                    INEPTXFSPCAVAILR::VALUE2 => 0x01,
                    INEPTXFSPCAVAILR::VALUE3 => 0x02,
                    INEPTXFSPCAVAILR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u16) -> INEPTXFSPCAVAILR {
                match value {
                    0 => INEPTXFSPCAVAILR::VALUE1,
                    1 => INEPTXFSPCAVAILR::VALUE2,
                    2 => INEPTXFSPCAVAILR::VALUE3,
                    i => INEPTXFSPCAVAILR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INEPTXFSPCAVAILR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INEPTXFSPCAVAILR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == INEPTXFSPCAVAILR::VALUE3
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint TxFIFO Space Avail"]
            #[inline]
            pub fn ineptx_fspc_avail(&self) -> INEPTXFSPCAVAILR {
                INEPTXFSPCAVAILR::_from({
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                })
            }
        }
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub struct DIEPDMAB0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub mod diepdmab0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DIEPDMAB0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMABUFFERADDRR {
            bits: u32,
        }
        impl DMABUFFERADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Buffer Address"]
            #[inline]
            pub fn dmabuffer_addr(&self) -> DMABUFFERADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMABUFFERADDRR { bits }
            }
        }
    }
    #[doc = "Device Control OUT Endpoint Control Register"]
    pub struct DOEPCTL0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Control OUT Endpoint Control Register"]
    pub mod doepctl0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPCTL0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MPS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MPSR {
            #[doc = "64 bytes"]
            VALUE1,
            #[doc = "32 bytes"]
            VALUE2,
            #[doc = "16 bytes"]
            VALUE3,
            #[doc = "8 bytes"]
            VALUE4,
        }
        impl MPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MPSR::VALUE1 => 0,
                    MPSR::VALUE2 => 0x01,
                    MPSR::VALUE3 => 0x02,
                    MPSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MPSR {
                match value {
                    0 => MPSR::VALUE1,
                    1 => MPSR::VALUE2,
                    2 => MPSR::VALUE3,
                    3 => MPSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MPSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MPSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MPSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MPSR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBACTEPR {
            bits: bool,
        }
        impl USBACTEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `NAKSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAKSTSR {
            #[doc = "The core is transmitting non-NAK handshakes based on the FIFO status."]
            VALUE1,
            #[doc = "The core is transmitting NAK handshakes on this endpoint."]
            VALUE2,
        }
        impl NAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAKSTSR::VALUE1 => false,
                    NAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAKSTSR {
                match value {
                    false => NAKSTSR::VALUE1,
                    true => NAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAKSTSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPTYPER {
            bits: u8,
        }
        impl EPTYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SNPR {
            bits: bool,
        }
        impl SNPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STALLR {
            bits: bool,
        }
        impl STALLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISR {
            bits: bool,
        }
        impl EPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPENAR {
            bits: bool,
        }
        impl EPENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STALLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STALLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&self) -> MPSR {
                MPSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&self) -> USBACTEPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBACTEPR { bits }
            }
            #[doc = "Bit 17 - NAK Status"]
            #[inline]
            pub fn naksts(&self) -> NAKSTSR {
                NAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&self) -> EPTYPER {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EPTYPER { bits }
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&self) -> SNPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SNPR { bits }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&self) -> STALLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STALLR { bits }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&self) -> EPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISR { bits }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&self) -> EPENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x8000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&mut self) -> _SNPW {
                _SNPW { w: self }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&mut self) -> _STALLW {
                _STALLW { w: self }
            }
            #[doc = "Bit 26 - Clear NAK"]
            #[inline]
            pub fn cnak(&mut self) -> _CNAKW {
                _CNAKW { w: self }
            }
            #[doc = "Bit 27 - Set NAK"]
            #[inline]
            pub fn snak(&mut self) -> _SNAKW {
                _SNAKW { w: self }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&mut self) -> _EPENAW {
                _EPENAW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub struct DOEPINT0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub mod doepint0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPINT0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERCOMPLR {
            bits: bool,
        }
        impl XFERCOMPLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISBLDR {
            bits: bool,
        }
        impl EPDISBLDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBERRR {
            bits: bool,
        }
        impl AHBERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SETUPR {
            bits: bool,
        }
        impl SETUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OUTTKNEPDISR {
            bits: bool,
        }
        impl OUTTKNEPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STSPHSERCVDR {
            bits: bool,
        }
        impl STSPHSERCVDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BACK2BACKSETUPR {
            bits: bool,
        }
        impl BACK2BACKSETUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BNAINTRR {
            bits: bool,
        }
        impl BNAINTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTDRPSTSR {
            bits: bool,
        }
        impl PKTDRPSTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BBLEERRINTRPTR {
            bits: bool,
        }
        impl BBLEERRINTRPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NAKINTRPTR {
            bits: bool,
        }
        impl NAKINTRPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NYETINTRPTR {
            bits: bool,
        }
        impl NYETINTRPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERCOMPLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERCOMPLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISBLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISBLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBERRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETUPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OUTTKNEPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OUTTKNEPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STSPHSERCVDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STSPHSERCVDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BACK2BACKSETUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BACK2BACKSETUPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNAINTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNAINTRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTDRPSTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTDRPSTSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BBLEERRINTRPTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BBLEERRINTRPTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NAKINTRPTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NAKINTRPTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NYETINTRPTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NYETINTRPTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&self) -> XFERCOMPLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XFERCOMPLR { bits }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&self) -> EPDISBLDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISBLDR { bits }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&self) -> AHBERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBERRR { bits }
            }
            #[doc = "Bit 3 - SETUP Phase Done"]
            #[inline]
            pub fn set_up(&self) -> SETUPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SETUPR { bits }
            }
            #[doc = "Bit 4 - OUT Token Received When Endpoint Disabled"]
            #[inline]
            pub fn outtkn_epdis(&self) -> OUTTKNEPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OUTTKNEPDISR { bits }
            }
            #[doc = "Bit 5 - Status Phase Received For Control Write"]
            #[inline]
            pub fn sts_phse_rcvd(&self) -> STSPHSERCVDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STSPHSERCVDR { bits }
            }
            #[doc = "Bit 6 - Back-to-Back SETUP Packets Received"]
            #[inline]
            pub fn back2back_setup(&self) -> BACK2BACKSETUPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BACK2BACKSETUPR { bits }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&self) -> BNAINTRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BNAINTRR { bits }
            }
            #[doc = "Bit 11 - Packet Dropped Status"]
            #[inline]
            pub fn pkt_drp_sts(&self) -> PKTDRPSTSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PKTDRPSTSR { bits }
            }
            #[doc = "Bit 12 - BbleErr (Babble Error) interrupt"]
            #[inline]
            pub fn bble_err_intrpt(&self) -> BBLEERRINTRPTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BBLEERRINTRPTR { bits }
            }
            #[doc = "Bit 13 - NAK interrupt"]
            #[inline]
            pub fn nakintrpt(&self) -> NAKINTRPTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NAKINTRPTR { bits }
            }
            #[doc = "Bit 14 - NYET interrupt"]
            #[inline]
            pub fn nyetintrpt(&self) -> NYETINTRPTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NYETINTRPTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x80 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&mut self) -> _XFERCOMPLW {
                _XFERCOMPLW { w: self }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&mut self) -> _EPDISBLDW {
                _EPDISBLDW { w: self }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&mut self) -> _AHBERRW {
                _AHBERRW { w: self }
            }
            #[doc = "Bit 3 - SETUP Phase Done"]
            #[inline]
            pub fn set_up(&mut self) -> _SETUPW {
                _SETUPW { w: self }
            }
            #[doc = "Bit 4 - OUT Token Received When Endpoint Disabled"]
            #[inline]
            pub fn outtkn_epdis(&mut self) -> _OUTTKNEPDISW {
                _OUTTKNEPDISW { w: self }
            }
            #[doc = "Bit 5 - Status Phase Received For Control Write"]
            #[inline]
            pub fn sts_phse_rcvd(&mut self) -> _STSPHSERCVDW {
                _STSPHSERCVDW { w: self }
            }
            #[doc = "Bit 6 - Back-to-Back SETUP Packets Received"]
            #[inline]
            pub fn back2back_setup(&mut self) -> _BACK2BACKSETUPW {
                _BACK2BACKSETUPW { w: self }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&mut self) -> _BNAINTRW {
                _BNAINTRW { w: self }
            }
            #[doc = "Bit 11 - Packet Dropped Status"]
            #[inline]
            pub fn pkt_drp_sts(&mut self) -> _PKTDRPSTSW {
                _PKTDRPSTSW { w: self }
            }
            #[doc = "Bit 12 - BbleErr (Babble Error) interrupt"]
            #[inline]
            pub fn bble_err_intrpt(&mut self) -> _BBLEERRINTRPTW {
                _BBLEERRINTRPTW { w: self }
            }
            #[doc = "Bit 13 - NAK interrupt"]
            #[inline]
            pub fn nakintrpt(&mut self) -> _NAKINTRPTW {
                _NAKINTRPTW { w: self }
            }
            #[doc = "Bit 14 - NYET interrupt"]
            #[inline]
            pub fn nyetintrpt(&mut self) -> _NYETINTRPTW {
                _NYETINTRPTW { w: self }
            }
        }
    }
    #[doc = "Device OUT Endpoint Transfer Size Register"]
    pub struct DOEPTSIZ0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device OUT Endpoint Transfer Size Register"]
    pub mod doeptsiz0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPTSIZ0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERSIZER {
            bits: u8,
        }
        impl XFERSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTCNTR {
            bits: u8,
        }
        impl PKTCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SUPCnt`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUPCNTR {
            #[doc = "1 packet"]
            VALUE1,
            #[doc = "2 packets"]
            VALUE2,
            #[doc = "3 packets"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SUPCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SUPCNTR::VALUE1 => 0x01,
                    SUPCNTR::VALUE2 => 0x02,
                    SUPCNTR::VALUE3 => 0x03,
                    SUPCNTR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SUPCNTR {
                match value {
                    1 => SUPCNTR::VALUE1,
                    2 => SUPCNTR::VALUE2,
                    3 => SUPCNTR::VALUE3,
                    i => SUPCNTR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUPCNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUPCNTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SUPCNTR::VALUE3
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x7f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTCNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUPCnt`"]
        pub enum SUPCNTW {
            #[doc = "1 packet"]
            VALUE1,
            #[doc = "2 packets"]
            VALUE2,
            #[doc = "3 packets"]
            VALUE3,
        }
        impl SUPCNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SUPCNTW::VALUE1 => 1,
                    SUPCNTW::VALUE2 => 2,
                    SUPCNTW::VALUE3 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUPCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUPCNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUPCNTW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "1 packet"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUPCNTW::VALUE1)
            }
            #[doc = "2 packets"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUPCNTW::VALUE2)
            }
            #[doc = "3 packets"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SUPCNTW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:6 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&self) -> XFERSIZER {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XFERSIZER { bits }
            }
            #[doc = "Bits 19:20 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&self) -> PKTCNTR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PKTCNTR { bits }
            }
            #[doc = "Bits 29:30 - SETUP Packet Count"]
            #[inline]
            pub fn supcnt(&self) -> SUPCNTR {
                SUPCNTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:6 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&mut self) -> _XFERSIZEW {
                _XFERSIZEW { w: self }
            }
            #[doc = "Bits 19:20 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&mut self) -> _PKTCNTW {
                _PKTCNTW { w: self }
            }
            #[doc = "Bits 29:30 - SETUP Packet Count"]
            #[inline]
            pub fn supcnt(&mut self) -> _SUPCNTW {
                _SUPCNTW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub struct DOEPDMA0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub mod doepdma0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPDMA0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMAADDRR {
            bits: u32,
        }
        impl DMAADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMAADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMAADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&self) -> DMAADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMAADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&mut self) -> _DMAADDRW {
                _DMAADDRW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub struct DOEPDMAB0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub mod doepdmab0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DOEPDMAB0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMABUFFERADDRR {
            bits: u32,
        }
        impl DMABUFFERADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Buffer Address"]
            #[inline]
            pub fn dmabuffer_addr(&self) -> DMABUFFERADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMABUFFERADDRR { bits }
            }
        }
    }
}
#[doc = "Universal Serial Bus"]
pub struct USB0_EP0 {
    register_block: usb0_ep0::RegisterBlock,
}
impl Deref for USB0_EP0 {
    type Target = usb0_ep0::RegisterBlock;
    fn deref(&self) -> &usb0_ep0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP1: Peripheral<USB0_EP1> = unsafe { Peripheral::new(0x5004_0920) };
#[doc = "Universal Serial Bus"]
pub mod usb0_ep1 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Device Endpoint Control Register [ISOCONT]"]
        pub diepctl_isocont: DIEPCTL_ISOCONT,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Device Endpoint Interrupt Register"]
        pub diepint: DIEPINT,
        _reserved1: [u8; 4usize],
        #[doc = "0x10 - Device Endpoint Transfer Size Register"]
        pub dieptsiz: DIEPTSIZ,
        #[doc = "0x14 - Device Endpoint DMA Address Register"]
        pub diepdma: DIEPDMA,
        #[doc = "0x18 - Device IN Endpoint Transmit FIFO Status Register"]
        pub dtxfsts: DTXFSTS,
        #[doc = "0x1c - Device Endpoint DMA Buffer Address Register"]
        pub diepdmab: DIEPDMAB,
        _reserved2: [u8; 480usize],
        #[doc = "0x200 - Device Endpoint Control Register [ISOCONT]"]
        pub doepctl_isocont: DOEPCTL_ISOCONT,
        _reserved3: [u8; 4usize],
        #[doc = "0x208 - Device Endpoint Interrupt Register"]
        pub doepint: DOEPINT,
        _reserved4: [u8; 4usize],
        #[doc = "0x210 - Device Endpoint Transfer Size Register [ISO]"]
        pub doeptsiz_iso: DOEPTSIZ_ISO,
        #[doc = "0x214 - Device Endpoint DMA Address Register"]
        pub doepdma: DOEPDMA,
        _reserved5: [u8; 4usize],
        #[doc = "0x21c - Device Endpoint DMA Buffer Address Register"]
        pub doepdmab: DOEPDMAB,
    }
    #[doc = "Device Endpoint Control Register [ISOCONT]"]
    pub struct DIEPCTL_ISOCONT {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Control Register [ISOCONT]"]
    pub mod diepctl_isocont {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPCTL_ISOCONT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPSR {
            bits: u16,
        }
        impl MPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBACTEPR {
            bits: bool,
        }
        impl USBACTEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `EO_FrNum`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EO_FRNUMR {
            #[doc = "Even frame"]
            VALUE1,
            #[doc = "Odd rame"]
            VALUE2,
        }
        impl EO_FRNUMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EO_FRNUMR::VALUE1 => false,
                    EO_FRNUMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EO_FRNUMR {
                match value {
                    false => EO_FRNUMR::VALUE1,
                    true => EO_FRNUMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EO_FRNUMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EO_FRNUMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NAKSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAKSTSR {
            #[doc = "The core is transmitting non-NAK handshakes based on the FIFO status."]
            VALUE1,
            #[doc = "The core is transmitting NAK handshakes on this endpoint."]
            VALUE2,
        }
        impl NAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAKSTSR::VALUE1 => false,
                    NAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAKSTSR {
                match value {
                    false => NAKSTSR::VALUE1,
                    true => NAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAKSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EPType`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPTYPER {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EPTYPER::VALUE1 => 0,
                    EPTYPER::VALUE2 => 0x01,
                    EPTYPER::VALUE3 => 0x02,
                    EPTYPER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EPTYPER {
                match value {
                    0 => EPTYPER::VALUE1,
                    1 => EPTYPER::VALUE2,
                    2 => EPTYPER::VALUE3,
                    3 => EPTYPER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPTYPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPTYPER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EPTYPER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EPTYPER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct SNPR {
            bits: bool,
        }
        impl SNPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STALLR {
            bits: bool,
        }
        impl STALLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFNUMR {
            bits: u8,
        }
        impl TXFNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISR {
            bits: bool,
        }
        impl EPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPENAR {
            bits: bool,
        }
        impl EPENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x07ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBACTEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBACTEPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EPType`"]
        pub enum EPTYPEW {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EPTYPEW::VALUE1 => 0,
                    EPTYPEW::VALUE2 => 1,
                    EPTYPEW::VALUE3 => 2,
                    EPTYPEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPTYPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPTYPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPTYPEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE1)
            }
            #[doc = "Isochronous"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE2)
            }
            #[doc = "Bulk"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE3)
            }
            #[doc = "Interrupt"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STALLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STALLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFNUMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETEVENFRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETEVENFRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETODDFRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETODDFRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&self) -> MPSR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MPSR { bits }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&self) -> USBACTEPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBACTEPR { bits }
            }
            #[doc = "Bit 16 - Even/Odd Frame"]
            #[inline]
            pub fn eo_fr_num(&self) -> EO_FRNUMR {
                EO_FRNUMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - NAK Status"]
            #[inline]
            pub fn naksts(&self) -> NAKSTSR {
                NAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&self) -> EPTYPER {
                EPTYPER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&self) -> SNPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SNPR { bits }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&self) -> STALLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STALLR { bits }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&self) -> TXFNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TXFNUMR { bits }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&self) -> EPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISR { bits }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&self) -> EPENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&mut self) -> _MPSW {
                _MPSW { w: self }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&mut self) -> _USBACTEPW {
                _USBACTEPW { w: self }
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&mut self) -> _EPTYPEW {
                _EPTYPEW { w: self }
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&mut self) -> _SNPW {
                _SNPW { w: self }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&mut self) -> _STALLW {
                _STALLW { w: self }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&mut self) -> _TXFNUMW {
                _TXFNUMW { w: self }
            }
            #[doc = "Bit 26 - Clear NAK"]
            #[inline]
            pub fn cnak(&mut self) -> _CNAKW {
                _CNAKW { w: self }
            }
            #[doc = "Bit 27 - Set NAK"]
            #[inline]
            pub fn snak(&mut self) -> _SNAKW {
                _SNAKW { w: self }
            }
            #[doc = "Bit 28 - In non-Scatter/Gather DMA mode: Set Even frame"]
            #[inline]
            pub fn set_even_fr(&mut self) -> _SETEVENFRW {
                _SETEVENFRW { w: self }
            }
            #[doc = "Bit 29 - Set Odd frame"]
            #[inline]
            pub fn set_odd_fr(&mut self) -> _SETODDFRW {
                _SETODDFRW { w: self }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&mut self) -> _EPDISW {
                _EPDISW { w: self }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&mut self) -> _EPENAW {
                _EPENAW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Control Register [INTBULK]"]
    pub struct DIEPCTL_INTBULK {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Control Register [INTBULK]"]
    pub mod diepctl_intbulk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPCTL_INTBULK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPSR {
            bits: u16,
        }
        impl MPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBACTEPR {
            bits: bool,
        }
        impl USBACTEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `DPID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPIDR {
            #[doc = "DATA0"]
            VALUE1,
            #[doc = "DATA1"]
            VALUE2,
        }
        impl DPIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPIDR::VALUE1 => false,
                    DPIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPIDR {
                match value {
                    false => DPIDR::VALUE1,
                    true => DPIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPIDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NAKSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAKSTSR {
            #[doc = "The core is transmitting non-NAK handshakes based on the FIFO status."]
            VALUE1,
            #[doc = "The core is transmitting NAK handshakes on this endpoint."]
            VALUE2,
        }
        impl NAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAKSTSR::VALUE1 => false,
                    NAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAKSTSR {
                match value {
                    false => NAKSTSR::VALUE1,
                    true => NAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAKSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EPType`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPTYPER {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EPTYPER::VALUE1 => 0,
                    EPTYPER::VALUE2 => 0x01,
                    EPTYPER::VALUE3 => 0x02,
                    EPTYPER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EPTYPER {
                match value {
                    0 => EPTYPER::VALUE1,
                    1 => EPTYPER::VALUE2,
                    2 => EPTYPER::VALUE3,
                    3 => EPTYPER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPTYPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPTYPER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EPTYPER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EPTYPER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct SNPR {
            bits: bool,
        }
        impl SNPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STALLR {
            bits: bool,
        }
        impl STALLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFNUMR {
            bits: u8,
        }
        impl TXFNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISR {
            bits: bool,
        }
        impl EPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPENAR {
            bits: bool,
        }
        impl EPENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x07ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBACTEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBACTEPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EPType`"]
        pub enum EPTYPEW {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EPTYPEW::VALUE1 => 0,
                    EPTYPEW::VALUE2 => 1,
                    EPTYPEW::VALUE3 => 2,
                    EPTYPEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPTYPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPTYPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPTYPEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE1)
            }
            #[doc = "Isochronous"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE2)
            }
            #[doc = "Bulk"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE3)
            }
            #[doc = "Interrupt"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STALLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STALLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFNUMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETD0PIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETD0PIDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETD1PIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETD1PIDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&self) -> MPSR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MPSR { bits }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&self) -> USBACTEPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBACTEPR { bits }
            }
            #[doc = "Bit 16 - Endpoint Data PID"]
            #[inline]
            pub fn dpid(&self) -> DPIDR {
                DPIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - NAK Status"]
            #[inline]
            pub fn naksts(&self) -> NAKSTSR {
                NAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&self) -> EPTYPER {
                EPTYPER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&self) -> SNPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SNPR { bits }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&self) -> STALLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STALLR { bits }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&self) -> TXFNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TXFNUMR { bits }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&self) -> EPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISR { bits }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&self) -> EPENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&mut self) -> _MPSW {
                _MPSW { w: self }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&mut self) -> _USBACTEPW {
                _USBACTEPW { w: self }
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&mut self) -> _EPTYPEW {
                _EPTYPEW { w: self }
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&mut self) -> _SNPW {
                _SNPW { w: self }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&mut self) -> _STALLW {
                _STALLW { w: self }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&mut self) -> _TXFNUMW {
                _TXFNUMW { w: self }
            }
            #[doc = "Bit 26 - Clear NAK"]
            #[inline]
            pub fn cnak(&mut self) -> _CNAKW {
                _CNAKW { w: self }
            }
            #[doc = "Bit 27 - Set NAK"]
            #[inline]
            pub fn snak(&mut self) -> _SNAKW {
                _SNAKW { w: self }
            }
            #[doc = "Bit 28 - Set DATA0 PID"]
            #[inline]
            pub fn set_d0pid(&mut self) -> _SETD0PIDW {
                _SETD0PIDW { w: self }
            }
            #[doc = "Bit 29 - 29 Set DATA1 PID"]
            #[inline]
            pub fn set_d1pid(&mut self) -> _SETD1PIDW {
                _SETD1PIDW { w: self }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&mut self) -> _EPDISW {
                _EPDISW { w: self }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&mut self) -> _EPENAW {
                _EPENAW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub struct DIEPINT {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub mod diepint {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPINT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERCOMPLR {
            bits: bool,
        }
        impl XFERCOMPLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISBLDR {
            bits: bool,
        }
        impl EPDISBLDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBERRR {
            bits: bool,
        }
        impl AHBERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TIMEOUTR {
            bits: bool,
        }
        impl TIMEOUTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INTKNTXFEMPR {
            bits: bool,
        }
        impl INTKNTXFEMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct INEPNAKEFFR {
            bits: bool,
        }
        impl INEPNAKEFFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFEMPR {
            bits: bool,
        }
        impl TXFEMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BNAINTRR {
            bits: bool,
        }
        impl BNAINTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERCOMPLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERCOMPLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISBLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISBLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBERRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TIMEOUTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TIMEOUTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INTKNTXFEMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INTKNTXFEMPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _INEPNAKEFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INEPNAKEFFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNAINTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNAINTRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&self) -> XFERCOMPLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XFERCOMPLR { bits }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&self) -> EPDISBLDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISBLDR { bits }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&self) -> AHBERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBERRR { bits }
            }
            #[doc = "Bit 3 - Timeout Condition"]
            #[inline]
            pub fn time_out(&self) -> TIMEOUTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TIMEOUTR { bits }
            }
            #[doc = "Bit 4 - IN Token Received When TxFIFO is Empty"]
            #[inline]
            pub fn intkn_txfemp(&self) -> INTKNTXFEMPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INTKNTXFEMPR { bits }
            }
            #[doc = "Bit 6 - IN Endpoint NAK Effective"]
            #[inline]
            pub fn inepnak_eff(&self) -> INEPNAKEFFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                INEPNAKEFFR { bits }
            }
            #[doc = "Bit 7 - Transmit FIFO Empty"]
            #[inline]
            pub fn tx_femp(&self) -> TXFEMPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TXFEMPR { bits }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&self) -> BNAINTRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BNAINTRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x80 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&mut self) -> _XFERCOMPLW {
                _XFERCOMPLW { w: self }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&mut self) -> _EPDISBLDW {
                _EPDISBLDW { w: self }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&mut self) -> _AHBERRW {
                _AHBERRW { w: self }
            }
            #[doc = "Bit 3 - Timeout Condition"]
            #[inline]
            pub fn time_out(&mut self) -> _TIMEOUTW {
                _TIMEOUTW { w: self }
            }
            #[doc = "Bit 4 - IN Token Received When TxFIFO is Empty"]
            #[inline]
            pub fn intkn_txfemp(&mut self) -> _INTKNTXFEMPW {
                _INTKNTXFEMPW { w: self }
            }
            #[doc = "Bit 6 - IN Endpoint NAK Effective"]
            #[inline]
            pub fn inepnak_eff(&mut self) -> _INEPNAKEFFW {
                _INEPNAKEFFW { w: self }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&mut self) -> _BNAINTRW {
                _BNAINTRW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Transfer Size Register"]
    pub struct DIEPTSIZ {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Transfer Size Register"]
    pub mod dieptsiz {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPTSIZ {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERSIZER {
            bits: u32,
        }
        impl XFERSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTCNTR {
            bits: u16,
        }
        impl PKTCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x0007_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTCNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:18 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&self) -> XFERSIZER {
                let bits = {
                    const MASK: u32 = 0x0007_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                XFERSIZER { bits }
            }
            #[doc = "Bits 19:28 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&self) -> PKTCNTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PKTCNTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:18 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&mut self) -> _XFERSIZEW {
                _XFERSIZEW { w: self }
            }
            #[doc = "Bits 19:28 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&mut self) -> _PKTCNTW {
                _PKTCNTW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub struct DIEPDMA {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub mod diepdma {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DIEPDMA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMAADDRR {
            bits: u32,
        }
        impl DMAADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMAADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMAADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&self) -> DMAADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMAADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&mut self) -> _DMAADDRW {
                _DMAADDRW { w: self }
            }
        }
    }
    #[doc = "Device IN Endpoint Transmit FIFO Status Register"]
    pub struct DTXFSTS {
        register: VolatileCell<u32>,
    }
    #[doc = "Device IN Endpoint Transmit FIFO Status Register"]
    pub mod dtxfsts {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DTXFSTS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `INEPTxFSpcAvail`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INEPTXFSPCAVAILR {
            #[doc = "Endpoint TxFIFO is full"]
            VALUE1,
            #[doc = "1 word available"]
            VALUE2,
            #[doc = "2 words available"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u16),
        }
        impl INEPTXFSPCAVAILR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                match *self {
                    INEPTXFSPCAVAILR::VALUE1 => 0,
                    INEPTXFSPCAVAILR::VALUE2 => 0x01,
                    INEPTXFSPCAVAILR::VALUE3 => 0x02,
                    INEPTXFSPCAVAILR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u16) -> INEPTXFSPCAVAILR {
                match value {
                    0 => INEPTXFSPCAVAILR::VALUE1,
                    1 => INEPTXFSPCAVAILR::VALUE2,
                    2 => INEPTXFSPCAVAILR::VALUE3,
                    i => INEPTXFSPCAVAILR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INEPTXFSPCAVAILR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INEPTXFSPCAVAILR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == INEPTXFSPCAVAILR::VALUE3
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - IN Endpoint TxFIFO Space Avail"]
            #[inline]
            pub fn ineptx_fspc_avail(&self) -> INEPTXFSPCAVAILR {
                INEPTXFSPCAVAILR::_from({
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                })
            }
        }
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub struct DIEPDMAB {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub mod diepdmab {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DIEPDMAB {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMABUFFERADDRR {
            bits: u32,
        }
        impl DMABUFFERADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Buffer Address"]
            #[inline]
            pub fn dmabuffer_addr(&self) -> DMABUFFERADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMABUFFERADDRR { bits }
            }
        }
    }
    #[doc = "Device Endpoint Control Register [ISOCONT]"]
    pub struct DOEPCTL_ISOCONT {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Control Register [ISOCONT]"]
    pub mod doepctl_isocont {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPCTL_ISOCONT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPSR {
            bits: u16,
        }
        impl MPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBACTEPR {
            bits: bool,
        }
        impl USBACTEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `EO_FrNum`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EO_FRNUMR {
            #[doc = "Even frame"]
            VALUE1,
            #[doc = "Odd rame"]
            VALUE2,
        }
        impl EO_FRNUMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EO_FRNUMR::VALUE1 => false,
                    EO_FRNUMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EO_FRNUMR {
                match value {
                    false => EO_FRNUMR::VALUE1,
                    true => EO_FRNUMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EO_FRNUMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EO_FRNUMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NAKSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAKSTSR {
            #[doc = "The core is transmitting non-NAK handshakes based on the FIFO status."]
            VALUE1,
            #[doc = "The core is transmitting NAK handshakes on this endpoint."]
            VALUE2,
        }
        impl NAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAKSTSR::VALUE1 => false,
                    NAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAKSTSR {
                match value {
                    false => NAKSTSR::VALUE1,
                    true => NAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAKSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EPType`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPTYPER {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EPTYPER::VALUE1 => 0,
                    EPTYPER::VALUE2 => 0x01,
                    EPTYPER::VALUE3 => 0x02,
                    EPTYPER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EPTYPER {
                match value {
                    0 => EPTYPER::VALUE1,
                    1 => EPTYPER::VALUE2,
                    2 => EPTYPER::VALUE3,
                    3 => EPTYPER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPTYPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPTYPER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EPTYPER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EPTYPER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct SNPR {
            bits: bool,
        }
        impl SNPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STALLR {
            bits: bool,
        }
        impl STALLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFNUMR {
            bits: u8,
        }
        impl TXFNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISR {
            bits: bool,
        }
        impl EPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPENAR {
            bits: bool,
        }
        impl EPENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x07ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBACTEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBACTEPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EPType`"]
        pub enum EPTYPEW {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EPTYPEW::VALUE1 => 0,
                    EPTYPEW::VALUE2 => 1,
                    EPTYPEW::VALUE3 => 2,
                    EPTYPEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPTYPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPTYPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPTYPEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE1)
            }
            #[doc = "Isochronous"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE2)
            }
            #[doc = "Bulk"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE3)
            }
            #[doc = "Interrupt"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STALLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STALLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFNUMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETEVENFRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETEVENFRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETODDFRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETODDFRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&self) -> MPSR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MPSR { bits }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&self) -> USBACTEPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBACTEPR { bits }
            }
            #[doc = "Bit 16 - Even/Odd Frame"]
            #[inline]
            pub fn eo_fr_num(&self) -> EO_FRNUMR {
                EO_FRNUMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - NAK Status"]
            #[inline]
            pub fn naksts(&self) -> NAKSTSR {
                NAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&self) -> EPTYPER {
                EPTYPER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&self) -> SNPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SNPR { bits }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&self) -> STALLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STALLR { bits }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&self) -> TXFNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TXFNUMR { bits }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&self) -> EPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISR { bits }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&self) -> EPENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&mut self) -> _MPSW {
                _MPSW { w: self }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&mut self) -> _USBACTEPW {
                _USBACTEPW { w: self }
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&mut self) -> _EPTYPEW {
                _EPTYPEW { w: self }
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&mut self) -> _SNPW {
                _SNPW { w: self }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&mut self) -> _STALLW {
                _STALLW { w: self }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&mut self) -> _TXFNUMW {
                _TXFNUMW { w: self }
            }
            #[doc = "Bit 26 - Clear NAK"]
            #[inline]
            pub fn cnak(&mut self) -> _CNAKW {
                _CNAKW { w: self }
            }
            #[doc = "Bit 27 - Set NAK"]
            #[inline]
            pub fn snak(&mut self) -> _SNAKW {
                _SNAKW { w: self }
            }
            #[doc = "Bit 28 - In non-Scatter/Gather DMA mode: Set Even frame"]
            #[inline]
            pub fn set_even_fr(&mut self) -> _SETEVENFRW {
                _SETEVENFRW { w: self }
            }
            #[doc = "Bit 29 - Set Odd frame"]
            #[inline]
            pub fn set_odd_fr(&mut self) -> _SETODDFRW {
                _SETODDFRW { w: self }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&mut self) -> _EPDISW {
                _EPDISW { w: self }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&mut self) -> _EPENAW {
                _EPENAW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Control Register [INTBULK]"]
    pub struct DOEPCTL_INTBULK {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Control Register [INTBULK]"]
    pub mod doepctl_intbulk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPCTL_INTBULK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPSR {
            bits: u16,
        }
        impl MPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct USBACTEPR {
            bits: bool,
        }
        impl USBACTEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `DPID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPIDR {
            #[doc = "DATA0"]
            VALUE1,
            #[doc = "DATA1"]
            VALUE2,
        }
        impl DPIDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPIDR::VALUE1 => false,
                    DPIDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPIDR {
                match value {
                    false => DPIDR::VALUE1,
                    true => DPIDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPIDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NAKSts`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NAKSTSR {
            #[doc = "The core is transmitting non-NAK handshakes based on the FIFO status."]
            VALUE1,
            #[doc = "The core is transmitting NAK handshakes on this endpoint."]
            VALUE2,
        }
        impl NAKSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NAKSTSR::VALUE1 => false,
                    NAKSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NAKSTSR {
                match value {
                    false => NAKSTSR::VALUE1,
                    true => NAKSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NAKSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NAKSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EPType`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPTYPER {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EPTYPER::VALUE1 => 0,
                    EPTYPER::VALUE2 => 0x01,
                    EPTYPER::VALUE3 => 0x02,
                    EPTYPER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EPTYPER {
                match value {
                    0 => EPTYPER::VALUE1,
                    1 => EPTYPER::VALUE2,
                    2 => EPTYPER::VALUE3,
                    3 => EPTYPER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPTYPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPTYPER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EPTYPER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EPTYPER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct SNPR {
            bits: bool,
        }
        impl SNPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STALLR {
            bits: bool,
        }
        impl STALLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TXFNUMR {
            bits: u8,
        }
        impl TXFNUMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISR {
            bits: bool,
        }
        impl EPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPENAR {
            bits: bool,
        }
        impl EPENAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x07ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _USBACTEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _USBACTEPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EPType`"]
        pub enum EPTYPEW {
            #[doc = "Control"]
            VALUE1,
            #[doc = "Isochronous"]
            VALUE2,
            #[doc = "Bulk"]
            VALUE3,
            #[doc = "Interrupt"]
            VALUE4,
        }
        impl EPTYPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EPTYPEW::VALUE1 => 0,
                    EPTYPEW::VALUE2 => 1,
                    EPTYPEW::VALUE3 => 2,
                    EPTYPEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPTYPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPTYPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPTYPEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE1)
            }
            #[doc = "Isochronous"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE2)
            }
            #[doc = "Bulk"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE3)
            }
            #[doc = "Interrupt"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EPTYPEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STALLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STALLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXFNUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXFNUMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SNAKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SNAKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETD0PIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETD0PIDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETD1PIDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETD1PIDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPENAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPENAW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&self) -> MPSR {
                let bits = {
                    const MASK: u16 = 0x07ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MPSR { bits }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&self) -> USBACTEPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                USBACTEPR { bits }
            }
            #[doc = "Bit 16 - Endpoint Data PID"]
            #[inline]
            pub fn dpid(&self) -> DPIDR {
                DPIDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - NAK Status"]
            #[inline]
            pub fn naksts(&self) -> NAKSTSR {
                NAKSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&self) -> EPTYPER {
                EPTYPER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&self) -> SNPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SNPR { bits }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&self) -> STALLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STALLR { bits }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&self) -> TXFNUMR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TXFNUMR { bits }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&self) -> EPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISR { bits }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&self) -> EPENAR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPENAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:10 - Maximum Packet Size"]
            #[inline]
            pub fn mps(&mut self) -> _MPSW {
                _MPSW { w: self }
            }
            #[doc = "Bit 15 - USB Active Endpoint"]
            #[inline]
            pub fn usbact_ep(&mut self) -> _USBACTEPW {
                _USBACTEPW { w: self }
            }
            #[doc = "Bits 18:19 - Endpoint Type"]
            #[inline]
            pub fn eptype(&mut self) -> _EPTYPEW {
                _EPTYPEW { w: self }
            }
            #[doc = "Bit 20 - Snoop Mode"]
            #[inline]
            pub fn snp(&mut self) -> _SNPW {
                _SNPW { w: self }
            }
            #[doc = "Bit 21 - STALL Handshake"]
            #[inline]
            pub fn stall(&mut self) -> _STALLW {
                _STALLW { w: self }
            }
            #[doc = "Bits 22:25 - TxFIFO Number"]
            #[inline]
            pub fn tx_fnum(&mut self) -> _TXFNUMW {
                _TXFNUMW { w: self }
            }
            #[doc = "Bit 26 - Clear NAK"]
            #[inline]
            pub fn cnak(&mut self) -> _CNAKW {
                _CNAKW { w: self }
            }
            #[doc = "Bit 27 - Set NAK"]
            #[inline]
            pub fn snak(&mut self) -> _SNAKW {
                _SNAKW { w: self }
            }
            #[doc = "Bit 28 - Set DATA0 PID"]
            #[inline]
            pub fn set_d0pid(&mut self) -> _SETD0PIDW {
                _SETD0PIDW { w: self }
            }
            #[doc = "Bit 29 - 29 Set DATA1 PID"]
            #[inline]
            pub fn set_d1pid(&mut self) -> _SETD1PIDW {
                _SETD1PIDW { w: self }
            }
            #[doc = "Bit 30 - Endpoint Disable"]
            #[inline]
            pub fn epdis(&mut self) -> _EPDISW {
                _EPDISW { w: self }
            }
            #[doc = "Bit 31 - Endpoint Enable"]
            #[inline]
            pub fn epena(&mut self) -> _EPENAW {
                _EPENAW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub struct DOEPINT {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Interrupt Register"]
    pub mod doepint {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPINT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERCOMPLR {
            bits: bool,
        }
        impl XFERCOMPLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EPDISBLDR {
            bits: bool,
        }
        impl EPDISBLDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct AHBERRR {
            bits: bool,
        }
        impl AHBERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SETUPR {
            bits: bool,
        }
        impl SETUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OUTTKNEPDISR {
            bits: bool,
        }
        impl OUTTKNEPDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STSPHSERCVDR {
            bits: bool,
        }
        impl STSPHSERCVDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BACK2BACKSETUPR {
            bits: bool,
        }
        impl BACK2BACKSETUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BNAINTRR {
            bits: bool,
        }
        impl BNAINTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTDRPSTSR {
            bits: bool,
        }
        impl PKTDRPSTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct BBLEERRINTRPTR {
            bits: bool,
        }
        impl BBLEERRINTRPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NAKINTRPTR {
            bits: bool,
        }
        impl NAKINTRPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct NYETINTRPTR {
            bits: bool,
        }
        impl NYETINTRPTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERCOMPLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERCOMPLW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPDISBLDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPDISBLDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AHBERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AHBERRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETUPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OUTTKNEPDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OUTTKNEPDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STSPHSERCVDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STSPHSERCVDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BACK2BACKSETUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BACK2BACKSETUPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNAINTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNAINTRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTDRPSTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTDRPSTSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BBLEERRINTRPTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BBLEERRINTRPTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NAKINTRPTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NAKINTRPTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _NYETINTRPTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NYETINTRPTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&self) -> XFERCOMPLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XFERCOMPLR { bits }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&self) -> EPDISBLDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EPDISBLDR { bits }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&self) -> AHBERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                AHBERRR { bits }
            }
            #[doc = "Bit 3 - SETUP Phase Done"]
            #[inline]
            pub fn set_up(&self) -> SETUPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SETUPR { bits }
            }
            #[doc = "Bit 4 - OUT Token Received When Endpoint Disabled"]
            #[inline]
            pub fn outtkn_epdis(&self) -> OUTTKNEPDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OUTTKNEPDISR { bits }
            }
            #[doc = "Bit 5 - Status Phase Received For Control Write"]
            #[inline]
            pub fn sts_phse_rcvd(&self) -> STSPHSERCVDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STSPHSERCVDR { bits }
            }
            #[doc = "Bit 6 - Back-to-Back SETUP Packets Received"]
            #[inline]
            pub fn back2back_setup(&self) -> BACK2BACKSETUPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BACK2BACKSETUPR { bits }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&self) -> BNAINTRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BNAINTRR { bits }
            }
            #[doc = "Bit 11 - Packet Dropped Status"]
            #[inline]
            pub fn pkt_drp_sts(&self) -> PKTDRPSTSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PKTDRPSTSR { bits }
            }
            #[doc = "Bit 12 - BbleErr (Babble Error) interrupt"]
            #[inline]
            pub fn bble_err_intrpt(&self) -> BBLEERRINTRPTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                BBLEERRINTRPTR { bits }
            }
            #[doc = "Bit 13 - NAK interrupt"]
            #[inline]
            pub fn nakintrpt(&self) -> NAKINTRPTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NAKINTRPTR { bits }
            }
            #[doc = "Bit 14 - NYET interrupt"]
            #[inline]
            pub fn nyetintrpt(&self) -> NYETINTRPTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                NYETINTRPTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x80 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transfer Completed Interrupt"]
            #[inline]
            pub fn xfer_compl(&mut self) -> _XFERCOMPLW {
                _XFERCOMPLW { w: self }
            }
            #[doc = "Bit 1 - Endpoint Disabled Interrupt"]
            #[inline]
            pub fn epdisbld(&mut self) -> _EPDISBLDW {
                _EPDISBLDW { w: self }
            }
            #[doc = "Bit 2 - AHB Error"]
            #[inline]
            pub fn ahberr(&mut self) -> _AHBERRW {
                _AHBERRW { w: self }
            }
            #[doc = "Bit 3 - SETUP Phase Done"]
            #[inline]
            pub fn set_up(&mut self) -> _SETUPW {
                _SETUPW { w: self }
            }
            #[doc = "Bit 4 - OUT Token Received When Endpoint Disabled"]
            #[inline]
            pub fn outtkn_epdis(&mut self) -> _OUTTKNEPDISW {
                _OUTTKNEPDISW { w: self }
            }
            #[doc = "Bit 5 - Status Phase Received For Control Write"]
            #[inline]
            pub fn sts_phse_rcvd(&mut self) -> _STSPHSERCVDW {
                _STSPHSERCVDW { w: self }
            }
            #[doc = "Bit 6 - Back-to-Back SETUP Packets Received"]
            #[inline]
            pub fn back2back_setup(&mut self) -> _BACK2BACKSETUPW {
                _BACK2BACKSETUPW { w: self }
            }
            #[doc = "Bit 9 - BNA (Buffer Not Available) Interrupt"]
            #[inline]
            pub fn bnaintr(&mut self) -> _BNAINTRW {
                _BNAINTRW { w: self }
            }
            #[doc = "Bit 11 - Packet Dropped Status"]
            #[inline]
            pub fn pkt_drp_sts(&mut self) -> _PKTDRPSTSW {
                _PKTDRPSTSW { w: self }
            }
            #[doc = "Bit 12 - BbleErr (Babble Error) interrupt"]
            #[inline]
            pub fn bble_err_intrpt(&mut self) -> _BBLEERRINTRPTW {
                _BBLEERRINTRPTW { w: self }
            }
            #[doc = "Bit 13 - NAK interrupt"]
            #[inline]
            pub fn nakintrpt(&mut self) -> _NAKINTRPTW {
                _NAKINTRPTW { w: self }
            }
            #[doc = "Bit 14 - NYET interrupt"]
            #[inline]
            pub fn nyetintrpt(&mut self) -> _NYETINTRPTW {
                _NYETINTRPTW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Transfer Size Register [ISO]"]
    pub struct DOEPTSIZ_ISO {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Transfer Size Register [ISO]"]
    pub mod doeptsiz_iso {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPTSIZ_ISO {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERSIZER {
            bits: u32,
        }
        impl XFERSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTCNTR {
            bits: u16,
        }
        impl PKTCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `RxDPID`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXDPIDR {
            #[doc = "DATA0"]
            VALUE1,
            #[doc = "DATA2"]
            VALUE2,
            #[doc = "DATA1"]
            VALUE3,
            #[doc = "MDATA"]
            VALUE4,
        }
        impl RXDPIDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    RXDPIDR::VALUE1 => 0,
                    RXDPIDR::VALUE2 => 0x01,
                    RXDPIDR::VALUE3 => 0x02,
                    RXDPIDR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> RXDPIDR {
                match value {
                    0 => RXDPIDR::VALUE1,
                    1 => RXDPIDR::VALUE2,
                    2 => RXDPIDR::VALUE3,
                    3 => RXDPIDR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXDPIDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXDPIDR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == RXDPIDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == RXDPIDR::VALUE4
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x0007_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTCNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:18 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&self) -> XFERSIZER {
                let bits = {
                    const MASK: u32 = 0x0007_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                XFERSIZER { bits }
            }
            #[doc = "Bits 19:28 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&self) -> PKTCNTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PKTCNTR { bits }
            }
            #[doc = "Bits 29:30 - Received Data PID"]
            #[inline]
            pub fn rx_dpid(&self) -> RXDPIDR {
                RXDPIDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:18 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&mut self) -> _XFERSIZEW {
                _XFERSIZEW { w: self }
            }
            #[doc = "Bits 19:28 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&mut self) -> _PKTCNTW {
                _PKTCNTW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint Transfer Size Register [CONT]"]
    pub struct DOEPTSIZ_CONTROL {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint Transfer Size Register [CONT]"]
    pub mod doeptsiz_control {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPTSIZ_CONTROL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct XFERSIZER {
            bits: u32,
        }
        impl XFERSIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PKTCNTR {
            bits: u16,
        }
        impl PKTCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SUPCnt`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUPCNTR {
            #[doc = "1 packet"]
            VALUE1,
            #[doc = "2 packets"]
            VALUE2,
            #[doc = "3 packets"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SUPCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SUPCNTR::VALUE1 => 0x01,
                    SUPCNTR::VALUE2 => 0x02,
                    SUPCNTR::VALUE3 => 0x03,
                    SUPCNTR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SUPCNTR {
                match value {
                    1 => SUPCNTR::VALUE1,
                    2 => SUPCNTR::VALUE2,
                    3 => SUPCNTR::VALUE3,
                    i => SUPCNTR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUPCNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUPCNTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SUPCNTR::VALUE3
            }
        }
        #[doc = r" Proxy"]
        pub struct _XFERSIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XFERSIZEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x0007_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PKTCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PKTCNTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUPCnt`"]
        pub enum SUPCNTW {
            #[doc = "1 packet"]
            VALUE1,
            #[doc = "2 packets"]
            VALUE2,
            #[doc = "3 packets"]
            VALUE3,
        }
        impl SUPCNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SUPCNTW::VALUE1 => 1,
                    SUPCNTW::VALUE2 => 2,
                    SUPCNTW::VALUE3 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUPCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUPCNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUPCNTW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "1 packet"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUPCNTW::VALUE1)
            }
            #[doc = "2 packets"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUPCNTW::VALUE2)
            }
            #[doc = "3 packets"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SUPCNTW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:18 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&self) -> XFERSIZER {
                let bits = {
                    const MASK: u32 = 0x0007_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                XFERSIZER { bits }
            }
            #[doc = "Bits 19:28 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&self) -> PKTCNTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PKTCNTR { bits }
            }
            #[doc = "Bits 29:30 - SETUP Packet Count"]
            #[inline]
            pub fn supcnt(&self) -> SUPCNTR {
                SUPCNTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:18 - Transfer Size"]
            #[inline]
            pub fn xfer_size(&mut self) -> _XFERSIZEW {
                _XFERSIZEW { w: self }
            }
            #[doc = "Bits 19:28 - Packet Count"]
            #[inline]
            pub fn pkt_cnt(&mut self) -> _PKTCNTW {
                _PKTCNTW { w: self }
            }
            #[doc = "Bits 29:30 - SETUP Packet Count"]
            #[inline]
            pub fn supcnt(&mut self) -> _SUPCNTW {
                _SUPCNTW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub struct DOEPDMA {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Address Register"]
    pub mod doepdma {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DOEPDMA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMAADDRR {
            bits: u32,
        }
        impl DMAADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMAADDRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMAADDRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&self) -> DMAADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMAADDRR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - DMA Address"]
            #[inline]
            pub fn dmaaddr(&mut self) -> _DMAADDRW {
                _DMAADDRW { w: self }
            }
        }
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub struct DOEPDMAB {
        register: VolatileCell<u32>,
    }
    #[doc = "Device Endpoint DMA Buffer Address Register"]
    pub mod doepdmab {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DOEPDMAB {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMABUFFERADDRR {
            bits: u32,
        }
        impl DMABUFFERADDRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - DMA Buffer Address"]
            #[inline]
            pub fn dmabuffer_addr(&self) -> DMABUFFERADDRR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DMABUFFERADDRR { bits }
            }
        }
    }
}
#[doc = "Universal Serial Bus"]
pub struct USB0_EP1 {
    register_block: usb0_ep1::RegisterBlock,
}
impl Deref for USB0_EP1 {
    type Target = usb0_ep1::RegisterBlock;
    fn deref(&self) -> &usb0_ep1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP2: Peripheral<USB0_EP2> = unsafe { Peripheral::new(0x5004_0940) };
#[doc = r" Register block"]
pub struct USB0_EP2 {
    register_block: usb0_ep1::RegisterBlock,
}
impl Deref for USB0_EP2 {
    type Target = usb0_ep1::RegisterBlock;
    fn deref(&self) -> &usb0_ep1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP3: Peripheral<USB0_EP3> = unsafe { Peripheral::new(0x5004_0960) };
#[doc = r" Register block"]
pub struct USB0_EP3 {
    register_block: usb0_ep1::RegisterBlock,
}
impl Deref for USB0_EP3 {
    type Target = usb0_ep1::RegisterBlock;
    fn deref(&self) -> &usb0_ep1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP4: Peripheral<USB0_EP4> = unsafe { Peripheral::new(0x5004_0980) };
#[doc = r" Register block"]
pub struct USB0_EP4 {
    register_block: usb0_ep1::RegisterBlock,
}
impl Deref for USB0_EP4 {
    type Target = usb0_ep1::RegisterBlock;
    fn deref(&self) -> &usb0_ep1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP5: Peripheral<USB0_EP5> = unsafe { Peripheral::new(0x5004_09a0) };
#[doc = r" Register block"]
pub struct USB0_EP5 {
    register_block: usb0_ep1::RegisterBlock,
}
impl Deref for USB0_EP5 {
    type Target = usb0_ep1::RegisterBlock;
    fn deref(&self) -> &usb0_ep1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Bus"]
pub const USB0_EP6: Peripheral<USB0_EP6> = unsafe { Peripheral::new(0x5004_09c0) };
#[doc = r" Register block"]
pub struct USB0_EP6 {
    register_block: usb0_ep1::RegisterBlock,
}
impl Deref for USB0_EP6 {
    type Target = usb0_ep1::RegisterBlock;
    fn deref(&self) -> &usb0_ep1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Interface Controller 0"]
pub const USIC0: Peripheral<USIC0> = unsafe { Peripheral::new(0x4003_0008) };
#[doc = "Universal Serial Interface Controller 0"]
pub mod usic0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Module Identification Register"]
        pub id: ID,
    }
    #[doc = "Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision Number"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number Value"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
}
#[doc = "Universal Serial Interface Controller 0"]
pub struct USIC0 {
    register_block: usic0::RegisterBlock,
}
impl Deref for USIC0 {
    type Target = usic0::RegisterBlock;
    fn deref(&self) -> &usic0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Interface Controller 1"]
pub const USIC1: Peripheral<USIC1> = unsafe { Peripheral::new(0x4802_0008) };
#[doc = r" Register block"]
pub struct USIC1 {
    register_block: usic0::RegisterBlock,
}
impl Deref for USIC1 {
    type Target = usic0::RegisterBlock;
    fn deref(&self) -> &usic0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Interface Controller 0"]
pub const USIC0_CH0: Peripheral<USIC0_CH0> = unsafe { Peripheral::new(0x4003_0000) };
#[doc = "Universal Serial Interface Controller 0"]
pub mod usic0_ch0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        _reserved0: [u8; 4usize],
        #[doc = "0x04 - Channel Configuration Register"]
        pub ccfg: CCFG,
        _reserved1: [u8; 4usize],
        #[doc = "0x0c - Kernel State Configuration Register"]
        pub kscfg: KSCFG,
        #[doc = "0x10 - Fractional Divider Register"]
        pub fdr: FDR,
        #[doc = "0x14 - Baud Rate Generator Register"]
        pub brg: BRG,
        #[doc = "0x18 - Interrupt Node Pointer Register"]
        pub inpr: INPR,
        #[doc = "0x1c - Input Control Register 0"]
        pub dx0cr: DX0CR,
        #[doc = "0x20 - Input Control Register 1"]
        pub dx1cr: DX1CR,
        #[doc = "0x24 - Input Control Register 2"]
        pub dx2cr: DX2CR,
        #[doc = "0x28 - Input Control Register 3"]
        pub dx3cr: DX3CR,
        #[doc = "0x2c - Input Control Register 4"]
        pub dx4cr: DX4CR,
        #[doc = "0x30 - Input Control Register 5"]
        pub dx5cr: DX5CR,
        #[doc = "0x34 - Shift Control Register"]
        pub sctr: SCTR,
        #[doc = "0x38 - Transmit Control/Status Register"]
        pub tcsr: TCSR,
        #[doc = "0x3c - Protocol Control Register"]
        pub pcr: PCR,
        #[doc = "0x40 - Channel Control Register"]
        pub ccr: CCR,
        #[doc = "0x44 - Capture Mode Timer Register"]
        pub cmtr: CMTR,
        #[doc = "0x48 - Protocol Status Register"]
        pub psr: PSR,
        #[doc = "0x4c - Protocol Status Clear Register"]
        pub pscr: PSCR,
        #[doc = "0x50 - Receiver Buffer Status Register"]
        pub rbufsr: RBUFSR,
        #[doc = "0x54 - Receiver Buffer Register"]
        pub rbuf: RBUF,
        #[doc = "0x58 - Receiver Buffer Register for Debugger"]
        pub rbufd: RBUFD,
        #[doc = "0x5c - Receiver Buffer Register 0"]
        pub rbuf0: RBUF0,
        #[doc = "0x60 - Receiver Buffer Register 1"]
        pub rbuf1: RBUF1,
        #[doc = "0x64 - Receiver Buffer 01 Status Register"]
        pub rbuf01sr: RBUF01SR,
        #[doc = "0x68 - Flag Modification Register"]
        pub fmr: FMR,
        _reserved2: [u8; 20usize],
        #[doc = "0x80 - Transmit Buffer"]
        pub tbuf: [TBUF; 32],
        #[doc = "0x100 - Bypass Data Register"]
        pub byp: BYP,
        #[doc = "0x104 - Bypass Control Register"]
        pub bypcr: BYPCR,
        #[doc = "0x108 - Transmitter Buffer Control Register"]
        pub tbctr: TBCTR,
        #[doc = "0x10c - Receiver Buffer Control Register"]
        pub rbctr: RBCTR,
        #[doc = "0x110 - Transmit/Receive Buffer Pointer Register"]
        pub trbptr: TRBPTR,
        #[doc = "0x114 - Transmit/Receive Buffer Status Register"]
        pub trbsr: TRBSR,
        #[doc = "0x118 - Transmit/Receive Buffer Status Clear Register"]
        pub trbscr: TRBSCR,
        #[doc = "0x11c - Receiver Buffer Output Register"]
        pub outr: OUTR,
        #[doc = "0x120 - Receiver Buffer Output Register L for Debugger"]
        pub outdr: OUTDR,
        _reserved3: [u8; 92usize],
        #[doc = "0x180 - Transmit FIFO Buffer"]
        pub in_: [IN; 32],
    }
    #[doc = "Channel Configuration Register"]
    pub struct CCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Configuration Register"]
    pub mod ccfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CCFG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `SSC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SSCR {
            #[doc = "The SSC protocol is not available."]
            VALUE1,
            #[doc = "The SSC protocol is available."]
            VALUE2,
        }
        impl SSCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SSCR::VALUE1 => false,
                    SSCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SSCR {
                match value {
                    false => SSCR::VALUE1,
                    true => SSCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SSCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SSCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASCR {
            #[doc = "The ASC protocol is not available."]
            VALUE1,
            #[doc = "The ASC protocol is available."]
            VALUE2,
        }
        impl ASCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASCR::VALUE1 => false,
                    ASCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASCR {
                match value {
                    false => ASCR::VALUE1,
                    true => ASCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IIC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IICR {
            #[doc = "The IIC protocol is not available."]
            VALUE1,
            #[doc = "The IIC protocol is available."]
            VALUE2,
        }
        impl IICR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IICR::VALUE1 => false,
                    IICR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IICR {
                match value {
                    false => IICR::VALUE1,
                    true => IICR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IICR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IICR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IISR {
            #[doc = "The IIS protocol is not available."]
            VALUE1,
            #[doc = "The IIS protocol is available."]
            VALUE2,
        }
        impl IISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IISR::VALUE1 => false,
                    IISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IISR {
                match value {
                    false => IISR::VALUE1,
                    true => IISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IISR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RBR {
            #[doc = "A receive FIFO buffer is not available."]
            VALUE1,
            #[doc = "A receive FIFO buffer is available."]
            VALUE2,
        }
        impl RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RBR::VALUE1 => false,
                    RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RBR {
                match value {
                    false => RBR::VALUE1,
                    true => RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBR {
            #[doc = "A transmit FIFO buffer is not available."]
            VALUE1,
            #[doc = "A transmit FIFO buffer is available."]
            VALUE2,
        }
        impl TBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBR::VALUE1 => false,
                    TBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBR {
                match value {
                    false => TBR::VALUE1,
                    true => TBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - SSC Protocol Available"]
            #[inline]
            pub fn ssc(&self) -> SSCR {
                SSCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - ASC Protocol Available"]
            #[inline]
            pub fn asc(&self) -> ASCR {
                ASCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - IIC Protocol Available"]
            #[inline]
            pub fn iic(&self) -> IICR {
                IICR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - IIS Protocol Available"]
            #[inline]
            pub fn iis(&self) -> IISR {
                IISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Receive FIFO Buffer Available"]
            #[inline]
            pub fn rb(&self) -> RBR {
                RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Transmit FIFO Buffer Available"]
            #[inline]
            pub fn tb(&self) -> TBR {
                TBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Kernel State Configuration Register"]
    pub struct KSCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Kernel State Configuration Register"]
    pub mod kscfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::KSCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MODEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MODENR {
            #[doc = "The module is switched off immediately (without respecting a stop condition). It does not react on mode control actions and the module clock is switched off. The module does not react on read accesses and ignores write accesses (except to KSCFG)."]
            VALUE1,
            #[doc = "The module is switched on and can operate. After writing 1 to MODEN, it is recommended to read register KSCFG to avoid pipeline effects in the control block before accessing other Service Request Processing registers."]
            VALUE2,
        }
        impl MODENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MODENR::VALUE1 => false,
                    MODENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MODENR {
                match value {
                    false => MODENR::VALUE1,
                    true => MODENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MODENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MODENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NOMCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NOMCFGR {
            #[doc = "Run mode 0 is selected."]
            VALUE1,
            #[doc = "Run mode 1 is selected."]
            VALUE2,
            #[doc = "Stop mode 0 is selected."]
            VALUE3,
            #[doc = "Stop mode 1 is selected."]
            VALUE4,
        }
        impl NOMCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    NOMCFGR::VALUE1 => 0,
                    NOMCFGR::VALUE2 => 0x01,
                    NOMCFGR::VALUE3 => 0x02,
                    NOMCFGR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> NOMCFGR {
                match value {
                    0 => NOMCFGR::VALUE1,
                    1 => NOMCFGR::VALUE2,
                    2 => NOMCFGR::VALUE3,
                    3 => NOMCFGR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NOMCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NOMCFGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == NOMCFGR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == NOMCFGR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct SUMCFGR {
            bits: u8,
        }
        impl SUMCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `MODEN`"]
        pub enum MODENW {
            #[doc = "The module is switched off immediately (without respecting a stop condition). It does not react on mode control actions and the module clock is switched off. The module does not react on read accesses and ignores write accesses (except to KSCFG)."]
            VALUE1,
            #[doc = "The module is switched on and can operate. After writing 1 to MODEN, it is recommended to read register KSCFG to avoid pipeline effects in the control block before accessing other Service Request Processing registers."]
            VALUE2,
        }
        impl MODENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MODENW::VALUE1 => false,
                    MODENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MODENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MODENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MODENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The module is switched off immediately (without respecting a stop condition). It does not react on mode control actions and the module clock is switched off. The module does not react on read accesses and ignores write accesses (except to KSCFG)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MODENW::VALUE1)
            }
            #[doc = "The module is switched on and can operate. After writing 1 to MODEN, it is recommended to read register KSCFG to avoid pipeline effects in the control block before accessing other Service Request Processing registers."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MODENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BPMODEN`"]
        pub enum BPMODENW {
            #[doc = "MODEN is not changed."]
            VALUE1,
            #[doc = "MODEN is updated with the written value."]
            VALUE2,
        }
        impl BPMODENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BPMODENW::VALUE1 => false,
                    BPMODENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BPMODENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BPMODENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BPMODENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "MODEN is not changed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BPMODENW::VALUE1)
            }
            #[doc = "MODEN is updated with the written value."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BPMODENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NOMCFG`"]
        pub enum NOMCFGW {
            #[doc = "Run mode 0 is selected."]
            VALUE1,
            #[doc = "Run mode 1 is selected."]
            VALUE2,
            #[doc = "Stop mode 0 is selected."]
            VALUE3,
            #[doc = "Stop mode 1 is selected."]
            VALUE4,
        }
        impl NOMCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NOMCFGW::VALUE1 => 0,
                    NOMCFGW::VALUE2 => 1,
                    NOMCFGW::VALUE3 => 2,
                    NOMCFGW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NOMCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NOMCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NOMCFGW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Run mode 0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NOMCFGW::VALUE1)
            }
            #[doc = "Run mode 1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NOMCFGW::VALUE2)
            }
            #[doc = "Stop mode 0 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(NOMCFGW::VALUE3)
            }
            #[doc = "Stop mode 1 is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(NOMCFGW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BPNOM`"]
        pub enum BPNOMW {
            #[doc = "NOMCFG is not changed."]
            VALUE1,
            #[doc = "NOMCFG is updated with the written value."]
            VALUE2,
        }
        impl BPNOMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BPNOMW::VALUE1 => false,
                    BPNOMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BPNOMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BPNOMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BPNOMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "NOMCFG is not changed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BPNOMW::VALUE1)
            }
            #[doc = "NOMCFG is updated with the written value."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BPNOMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUMCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUMCFGW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BPSUM`"]
        pub enum BPSUMW {
            #[doc = "SUMCFG is not changed."]
            VALUE1,
            #[doc = "SUMCFG is updated with the written value."]
            VALUE2,
        }
        impl BPSUMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BPSUMW::VALUE1 => false,
                    BPSUMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BPSUMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BPSUMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BPSUMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "SUMCFG is not changed."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BPSUMW::VALUE1)
            }
            #[doc = "SUMCFG is updated with the written value."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BPSUMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Module Enable"]
            #[inline]
            pub fn moden(&self) -> MODENR {
                MODENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:5 - Normal Operation Mode Configuration"]
            #[inline]
            pub fn nomcfg(&self) -> NOMCFGR {
                NOMCFGR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Suspend Mode Configuration"]
            #[inline]
            pub fn sumcfg(&self) -> SUMCFGR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SUMCFGR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Module Enable"]
            #[inline]
            pub fn moden(&mut self) -> _MODENW {
                _MODENW { w: self }
            }
            #[doc = "Bit 1 - Bit Protection for MODEN"]
            #[inline]
            pub fn bpmoden(&mut self) -> _BPMODENW {
                _BPMODENW { w: self }
            }
            #[doc = "Bits 4:5 - Normal Operation Mode Configuration"]
            #[inline]
            pub fn nomcfg(&mut self) -> _NOMCFGW {
                _NOMCFGW { w: self }
            }
            #[doc = "Bit 7 - Bit Protection for NOMCFG"]
            #[inline]
            pub fn bpnom(&mut self) -> _BPNOMW {
                _BPNOMW { w: self }
            }
            #[doc = "Bits 8:9 - Suspend Mode Configuration"]
            #[inline]
            pub fn sumcfg(&mut self) -> _SUMCFGW {
                _SUMCFGW { w: self }
            }
            #[doc = "Bit 11 - Bit Protection for SUMCFG"]
            #[inline]
            pub fn bpsum(&mut self) -> _BPSUMW {
                _BPSUMW { w: self }
            }
        }
    }
    #[doc = "Fractional Divider Register"]
    pub struct FDR {
        register: VolatileCell<u32>,
    }
    #[doc = "Fractional Divider Register"]
    pub mod fdr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FDR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct STEPR {
            bits: u16,
        }
        impl STEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DMR {
            #[doc = "The divider is switched off, fFD = 0."]
            VALUE1,
            #[doc = "Normal divider mode selected."]
            VALUE2,
            #[doc = "Fractional divider mode selected."]
            VALUE3,
            #[doc = "The divider is switched off, fFD = 0."]
            VALUE4,
        }
        impl DMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DMR::VALUE1 => 0,
                    DMR::VALUE2 => 0x01,
                    DMR::VALUE3 => 0x02,
                    DMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DMR {
                match value {
                    0 => DMR::VALUE1,
                    1 => DMR::VALUE2,
                    2 => DMR::VALUE3,
                    3 => DMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DMR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _STEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DM`"]
        pub enum DMW {
            #[doc = "The divider is switched off, fFD = 0."]
            VALUE1,
            #[doc = "Normal divider mode selected."]
            VALUE2,
            #[doc = "Fractional divider mode selected."]
            VALUE3,
            #[doc = "The divider is switched off, fFD = 0."]
            VALUE4,
        }
        impl DMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DMW::VALUE1 => 0,
                    DMW::VALUE2 => 1,
                    DMW::VALUE3 => 2,
                    DMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The divider is switched off, fFD = 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMW::VALUE1)
            }
            #[doc = "Normal divider mode selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMW::VALUE2)
            }
            #[doc = "Fractional divider mode selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DMW::VALUE3)
            }
            #[doc = "The divider is switched off, fFD = 0."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - Step Value"]
            #[inline]
            pub fn step(&self) -> STEPR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                STEPR { bits }
            }
            #[doc = "Bits 14:15 - Divider Mode"]
            #[inline]
            pub fn dm(&self) -> DMR {
                DMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:25 - Result Value"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:9 - Step Value"]
            #[inline]
            pub fn step(&mut self) -> _STEPW {
                _STEPW { w: self }
            }
            #[doc = "Bits 14:15 - Divider Mode"]
            #[inline]
            pub fn dm(&mut self) -> _DMW {
                _DMW { w: self }
            }
        }
    }
    #[doc = "Baud Rate Generator Register"]
    pub struct BRG {
        register: VolatileCell<u32>,
    }
    #[doc = "Baud Rate Generator Register"]
    pub mod brg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BRG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CLKSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLKSELR {
            #[doc = "The fractional divider frequency fFD is selected."]
            VALUE1,
            #[doc = "The trigger signal DX1T defines fPIN. Signal MCLK toggles with fPIN."]
            VALUE3,
            #[doc = "Signal MCLK corresponds to the DX1S signal and the frequency fPIN is derived from the rising edges of DX1S."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CLKSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CLKSELR::VALUE1 => 0,
                    CLKSELR::VALUE3 => 0x02,
                    CLKSELR::VALUE4 => 0x03,
                    CLKSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CLKSELR {
                match value {
                    0 => CLKSELR::VALUE1,
                    2 => CLKSELR::VALUE3,
                    3 => CLKSELR::VALUE4,
                    i => CLKSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CLKSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLKSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLKSELR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TMEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TMENR {
            #[doc = "Timing measurement is disabled: The trigger signals DX0T and DX1T are ignored."]
            VALUE1,
            #[doc = "Timing measurement is enabled: The 10-bit counter is incremented by 1 with fPPP and stops counting when reaching its maximum value. If one of the trigger signals DX0T or DX1T become active, the counter value is captured into bit field CTV, the counter is cleared and a transmit shift event is generated."]
            VALUE2,
        }
        impl TMENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TMENR::VALUE1 => false,
                    TMENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TMENR {
                match value {
                    false => TMENR::VALUE1,
                    true => TMENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TMENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TMENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPPEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPPENR {
            #[doc = "The 2:1 divider for fPPP is disabled. fPPP = fPIN"]
            VALUE1,
            #[doc = "The 2:1 divider for fPPP is enabled. fPPP = fMCLK = fPIN / 2."]
            VALUE2,
        }
        impl PPPENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPPENR::VALUE1 => false,
                    PPPENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPPENR {
                match value {
                    false => PPPENR::VALUE1,
                    true => PPPENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPPENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPPENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CTQSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CTQSELR {
            #[doc = "fCTQIN = fPDIV"]
            VALUE1,
            #[doc = "fCTQIN = fPPP"]
            VALUE2,
            #[doc = "fCTQIN = fSCLK"]
            VALUE3,
            #[doc = "fCTQIN = fMCLK"]
            VALUE4,
        }
        impl CTQSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CTQSELR::VALUE1 => 0,
                    CTQSELR::VALUE2 => 0x01,
                    CTQSELR::VALUE3 => 0x02,
                    CTQSELR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CTQSELR {
                match value {
                    0 => CTQSELR::VALUE1,
                    1 => CTQSELR::VALUE2,
                    2 => CTQSELR::VALUE3,
                    3 => CTQSELR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CTQSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CTQSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CTQSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CTQSELR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCTQR {
            bits: u8,
        }
        impl PCTQR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCTQR {
            bits: u8,
        }
        impl DCTQR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PDIVR {
            bits: u16,
        }
        impl PDIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SCLKOSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCLKOSELR {
            #[doc = "SCLK from the baud rate generator is selected as the SCLKOUT input source."]
            VALUE1,
            #[doc = "The transmit shift clock from DX1 input stage is selected as the SCLKOUT input source."]
            VALUE2,
        }
        impl SCLKOSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCLKOSELR::VALUE1 => false,
                    SCLKOSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCLKOSELR {
                match value {
                    false => SCLKOSELR::VALUE1,
                    true => SCLKOSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCLKOSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCLKOSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCLKCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCLKCFGR {
            #[doc = "The passive level is 0."]
            VALUE1,
            #[doc = "The passive level is 1."]
            VALUE2,
        }
        impl MCLKCFGR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCLKCFGR::VALUE1 => false,
                    MCLKCFGR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCLKCFGR {
                match value {
                    false => MCLKCFGR::VALUE1,
                    true => MCLKCFGR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCLKCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCLKCFGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCLKCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCLKCFGR {
            #[doc = "The passive level is 0 and the delay is disabled."]
            VALUE1,
            #[doc = "The passive level is 1 and the delay is disabled."]
            VALUE2,
            #[doc = "The passive level is 0 and the delay is enabled."]
            VALUE3,
            #[doc = "The passive level is 1 and the delay is enabled."]
            VALUE4,
        }
        impl SCLKCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SCLKCFGR::VALUE1 => 0,
                    SCLKCFGR::VALUE2 => 0x01,
                    SCLKCFGR::VALUE3 => 0x02,
                    SCLKCFGR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SCLKCFGR {
                match value {
                    0 => SCLKCFGR::VALUE1,
                    1 => SCLKCFGR::VALUE2,
                    2 => SCLKCFGR::VALUE3,
                    3 => SCLKCFGR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCLKCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCLKCFGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SCLKCFGR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SCLKCFGR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CLKSEL`"]
        pub enum CLKSELW {
            #[doc = "The fractional divider frequency fFD is selected."]
            VALUE1,
            #[doc = "The trigger signal DX1T defines fPIN. Signal MCLK toggles with fPIN."]
            VALUE3,
            #[doc = "Signal MCLK corresponds to the DX1S signal and the frequency fPIN is derived from the rising edges of DX1S."]
            VALUE4,
        }
        impl CLKSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CLKSELW::VALUE1 => 0,
                    CLKSELW::VALUE3 => 2,
                    CLKSELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLKSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLKSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLKSELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The fractional divider frequency fFD is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CLKSELW::VALUE1)
            }
            #[doc = "The trigger signal DX1T defines fPIN. Signal MCLK toggles with fPIN."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLKSELW::VALUE3)
            }
            #[doc = "Signal MCLK corresponds to the DX1S signal and the frequency fPIN is derived from the rising edges of DX1S."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLKSELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TMEN`"]
        pub enum TMENW {
            #[doc = "Timing measurement is disabled: The trigger signals DX0T and DX1T are ignored."]
            VALUE1,
            #[doc = "Timing measurement is enabled: The 10-bit counter is incremented by 1 with fPPP and stops counting when reaching its maximum value. If one of the trigger signals DX0T or DX1T become active, the counter value is captured into bit field CTV, the counter is cleared and a transmit shift event is generated."]
            VALUE2,
        }
        impl TMENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TMENW::VALUE1 => false,
                    TMENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TMENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TMENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TMENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Timing measurement is disabled: The trigger signals DX0T and DX1T are ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TMENW::VALUE1)
            }
            #[doc = "Timing measurement is enabled: The 10-bit counter is incremented by 1 with fPPP and stops counting when reaching its maximum value. If one of the trigger signals DX0T or DX1T become active, the counter value is captured into bit field CTV, the counter is cleared and a transmit shift event is generated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TMENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPPEN`"]
        pub enum PPPENW {
            #[doc = "The 2:1 divider for fPPP is disabled. fPPP = fPIN"]
            VALUE1,
            #[doc = "The 2:1 divider for fPPP is enabled. fPPP = fMCLK = fPIN / 2."]
            VALUE2,
        }
        impl PPPENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPPENW::VALUE1 => false,
                    PPPENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPPENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPPENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPPENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The 2:1 divider for fPPP is disabled. fPPP = fPIN"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPPENW::VALUE1)
            }
            #[doc = "The 2:1 divider for fPPP is enabled. fPPP = fMCLK = fPIN / 2."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPPENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTQSEL`"]
        pub enum CTQSELW {
            #[doc = "fCTQIN = fPDIV"]
            VALUE1,
            #[doc = "fCTQIN = fPPP"]
            VALUE2,
            #[doc = "fCTQIN = fSCLK"]
            VALUE3,
            #[doc = "fCTQIN = fMCLK"]
            VALUE4,
        }
        impl CTQSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CTQSELW::VALUE1 => 0,
                    CTQSELW::VALUE2 => 1,
                    CTQSELW::VALUE3 => 2,
                    CTQSELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTQSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTQSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTQSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "fCTQIN = fPDIV"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTQSELW::VALUE1)
            }
            #[doc = "fCTQIN = fPPP"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTQSELW::VALUE2)
            }
            #[doc = "fCTQIN = fSCLK"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CTQSELW::VALUE3)
            }
            #[doc = "fCTQIN = fMCLK"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CTQSELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCTQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCTQW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCTQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCTQW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCLKOSEL`"]
        pub enum SCLKOSELW {
            #[doc = "SCLK from the baud rate generator is selected as the SCLKOUT input source."]
            VALUE1,
            #[doc = "The transmit shift clock from DX1 input stage is selected as the SCLKOUT input source."]
            VALUE2,
        }
        impl SCLKOSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCLKOSELW::VALUE1 => false,
                    SCLKOSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCLKOSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCLKOSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCLKOSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "SCLK from the baud rate generator is selected as the SCLKOUT input source."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCLKOSELW::VALUE1)
            }
            #[doc = "The transmit shift clock from DX1 input stage is selected as the SCLKOUT input source."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCLKOSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCLKCFG`"]
        pub enum MCLKCFGW {
            #[doc = "The passive level is 0."]
            VALUE1,
            #[doc = "The passive level is 1."]
            VALUE2,
        }
        impl MCLKCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCLKCFGW::VALUE1 => false,
                    MCLKCFGW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCLKCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCLKCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCLKCFGW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The passive level is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCLKCFGW::VALUE1)
            }
            #[doc = "The passive level is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCLKCFGW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCLKCFG`"]
        pub enum SCLKCFGW {
            #[doc = "The passive level is 0 and the delay is disabled."]
            VALUE1,
            #[doc = "The passive level is 1 and the delay is disabled."]
            VALUE2,
            #[doc = "The passive level is 0 and the delay is enabled."]
            VALUE3,
            #[doc = "The passive level is 1 and the delay is enabled."]
            VALUE4,
        }
        impl SCLKCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SCLKCFGW::VALUE1 => 0,
                    SCLKCFGW::VALUE2 => 1,
                    SCLKCFGW::VALUE3 => 2,
                    SCLKCFGW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCLKCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCLKCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCLKCFGW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The passive level is 0 and the delay is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCLKCFGW::VALUE1)
            }
            #[doc = "The passive level is 1 and the delay is disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCLKCFGW::VALUE2)
            }
            #[doc = "The passive level is 0 and the delay is enabled."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SCLKCFGW::VALUE3)
            }
            #[doc = "The passive level is 1 and the delay is enabled."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SCLKCFGW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Clock Selection"]
            #[inline]
            pub fn clksel(&self) -> CLKSELR {
                CLKSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Timing Measurement Enable"]
            #[inline]
            pub fn tmen(&self) -> TMENR {
                TMENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Enable 2:1 Divider for fPPP"]
            #[inline]
            pub fn pppen(&self) -> PPPENR {
                PPPENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 6:7 - Input Selection for CTQ"]
            #[inline]
            pub fn ctqsel(&self) -> CTQSELR {
                CTQSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Pre-Divider for Time Quanta Counter"]
            #[inline]
            pub fn pctq(&self) -> PCTQR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCTQR { bits }
            }
            #[doc = "Bits 10:14 - Denominator for Time Quanta Counter"]
            #[inline]
            pub fn dctq(&self) -> DCTQR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCTQR { bits }
            }
            #[doc = "Bits 16:25 - Divider Mode: Divider Factor to Generate fPDIV"]
            #[inline]
            pub fn pdiv(&self) -> PDIVR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PDIVR { bits }
            }
            #[doc = "Bit 28 - Shift Clock Output Select"]
            #[inline]
            pub fn sclkosel(&self) -> SCLKOSELR {
                SCLKOSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Master Clock Configuration"]
            #[inline]
            pub fn mclkcfg(&self) -> MCLKCFGR {
                MCLKCFGR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 30:31 - Shift Clock Output Configuration"]
            #[inline]
            pub fn sclkcfg(&self) -> SCLKCFGR {
                SCLKCFGR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Clock Selection"]
            #[inline]
            pub fn clksel(&mut self) -> _CLKSELW {
                _CLKSELW { w: self }
            }
            #[doc = "Bit 3 - Timing Measurement Enable"]
            #[inline]
            pub fn tmen(&mut self) -> _TMENW {
                _TMENW { w: self }
            }
            #[doc = "Bit 4 - Enable 2:1 Divider for fPPP"]
            #[inline]
            pub fn pppen(&mut self) -> _PPPENW {
                _PPPENW { w: self }
            }
            #[doc = "Bits 6:7 - Input Selection for CTQ"]
            #[inline]
            pub fn ctqsel(&mut self) -> _CTQSELW {
                _CTQSELW { w: self }
            }
            #[doc = "Bits 8:9 - Pre-Divider for Time Quanta Counter"]
            #[inline]
            pub fn pctq(&mut self) -> _PCTQW {
                _PCTQW { w: self }
            }
            #[doc = "Bits 10:14 - Denominator for Time Quanta Counter"]
            #[inline]
            pub fn dctq(&mut self) -> _DCTQW {
                _DCTQW { w: self }
            }
            #[doc = "Bits 16:25 - Divider Mode: Divider Factor to Generate fPDIV"]
            #[inline]
            pub fn pdiv(&mut self) -> _PDIVW {
                _PDIVW { w: self }
            }
            #[doc = "Bit 28 - Shift Clock Output Select"]
            #[inline]
            pub fn sclkosel(&mut self) -> _SCLKOSELW {
                _SCLKOSELW { w: self }
            }
            #[doc = "Bit 29 - Master Clock Configuration"]
            #[inline]
            pub fn mclkcfg(&mut self) -> _MCLKCFGW {
                _MCLKCFGW { w: self }
            }
            #[doc = "Bits 30:31 - Shift Clock Output Configuration"]
            #[inline]
            pub fn sclkcfg(&mut self) -> _SCLKCFGW {
                _SCLKCFGW { w: self }
            }
        }
    }
    #[doc = "Interrupt Node Pointer Register"]
    pub struct INPR {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Node Pointer Register"]
    pub mod inpr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::INPR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `TSINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSINPR {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TSINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TSINPR::VALUE1 => 0,
                    TSINPR::VALUE2 => 0x01,
                    TSINPR::VALUE3 => 0x02,
                    TSINPR::VALUE4 => 0x03,
                    TSINPR::VALUE5 => 0x04,
                    TSINPR::VALUE6 => 0x05,
                    TSINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TSINPR {
                match value {
                    0 => TSINPR::VALUE1,
                    1 => TSINPR::VALUE2,
                    2 => TSINPR::VALUE3,
                    3 => TSINPR::VALUE4,
                    4 => TSINPR::VALUE5,
                    5 => TSINPR::VALUE6,
                    i => TSINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TSINPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TSINPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == TSINPR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == TSINPR::VALUE6
            }
        }
        #[doc = r" Value of the field"]
        pub struct TBINPR {
            bits: u8,
        }
        impl TBINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RINPR {
            bits: u8,
        }
        impl RINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct AINPR {
            bits: u8,
        }
        impl AINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PINPR {
            bits: u8,
        }
        impl PINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `TSINP`"]
        pub enum TSINPW {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
        }
        impl TSINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TSINPW::VALUE1 => 0,
                    TSINPW::VALUE2 => 1,
                    TSINPW::VALUE3 => 2,
                    TSINPW::VALUE4 => 3,
                    TSINPW::VALUE5 => 4,
                    TSINPW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Output SR0 becomes activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSINPW::VALUE1)
            }
            #[doc = "Output SR1 becomes activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSINPW::VALUE2)
            }
            #[doc = "Output SR2 becomes activated."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TSINPW::VALUE3)
            }
            #[doc = "Output SR3 becomes activated."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TSINPW::VALUE4)
            }
            #[doc = "Output SR4 becomes activated."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(TSINPW::VALUE5)
            }
            #[doc = "Output SR5 becomes activated."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(TSINPW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBINPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RINPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _AINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AINPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PINPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Transmit Shift Interrupt Node Pointer"]
            #[inline]
            pub fn tsinp(&self) -> TSINPR {
                TSINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:6 - Transmit Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn tbinp(&self) -> TBINPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TBINPR { bits }
            }
            #[doc = "Bits 8:10 - Receive Interrupt Node Pointer"]
            #[inline]
            pub fn rinp(&self) -> RINPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RINPR { bits }
            }
            #[doc = "Bits 12:14 - Alternative Receive Interrupt Node Pointer"]
            #[inline]
            pub fn ainp(&self) -> AINPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AINPR { bits }
            }
            #[doc = "Bits 16:18 - Transmit Shift Interrupt Node Pointer"]
            #[inline]
            pub fn pinp(&self) -> PINPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PINPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Transmit Shift Interrupt Node Pointer"]
            #[inline]
            pub fn tsinp(&mut self) -> _TSINPW {
                _TSINPW { w: self }
            }
            #[doc = "Bits 4:6 - Transmit Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn tbinp(&mut self) -> _TBINPW {
                _TBINPW { w: self }
            }
            #[doc = "Bits 8:10 - Receive Interrupt Node Pointer"]
            #[inline]
            pub fn rinp(&mut self) -> _RINPW {
                _RINPW { w: self }
            }
            #[doc = "Bits 12:14 - Alternative Receive Interrupt Node Pointer"]
            #[inline]
            pub fn ainp(&mut self) -> _AINPW {
                _AINPW { w: self }
            }
            #[doc = "Bits 16:18 - Transmit Shift Interrupt Node Pointer"]
            #[inline]
            pub fn pinp(&mut self) -> _PINPW {
                _PINPW { w: self }
            }
        }
    }
    #[doc = "Input Control Register 0"]
    pub struct DX0CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Control Register 0"]
    pub mod dx0cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DX0CR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSELR::VALUE1 => 0,
                    DSELR::VALUE2 => 0x01,
                    DSELR::VALUE3 => 0x02,
                    DSELR::VALUE4 => 0x03,
                    DSELR::VALUE5 => 0x04,
                    DSELR::VALUE6 => 0x05,
                    DSELR::VALUE7 => 0x06,
                    DSELR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSELR {
                match value {
                    0 => DSELR::VALUE1,
                    1 => DSELR::VALUE2,
                    2 => DSELR::VALUE3,
                    3 => DSELR::VALUE4,
                    4 => DSELR::VALUE5,
                    5 => DSELR::VALUE6,
                    6 => DSELR::VALUE7,
                    7 => DSELR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == DSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == DSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == DSELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == DSELR::VALUE8
            }
        }
        #[doc = "Possible values of the field `INSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSWR {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INSWR::VALUE1 => false,
                    INSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INSWR {
                match value {
                    false => INSWR::VALUE1,
                    true => INSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DFEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DFENR {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DFENR::VALUE1 => false,
                    DFENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DFENR {
                match value {
                    false => DFENR::VALUE1,
                    true => DFENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DFENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DFENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSENR {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSENR::VALUE1 => false,
                    DSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSENR {
                match value {
                    false => DSENR::VALUE1,
                    true => DSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPOLR {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPOLR::VALUE1 => false,
                    DPOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPOLR {
                match value {
                    false => DPOLR::VALUE1,
                    true => DPOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFSELR {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFSELR::VALUE1 => false,
                    SFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFSELR {
                match value {
                    false => SFSELR::VALUE1,
                    true => SFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMR {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMR::VALUE1 => 0,
                    CMR::VALUE2 => 0x01,
                    CMR::VALUE3 => 0x02,
                    CMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMR {
                match value {
                    0 => CMR::VALUE1,
                    1 => CMR::VALUE2,
                    2 => CMR::VALUE3,
                    3 => CMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DXSR {
            #[doc = "The current value of DXnS is 0."]
            VALUE1,
            #[doc = "The current value of DXnS is 1."]
            VALUE2,
        }
        impl DXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DXSR::VALUE1 => false,
                    DXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DXSR {
                match value {
                    false => DXSR::VALUE1,
                    true => DXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DXSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSELW::VALUE1 => 0,
                    DSELW::VALUE2 => 1,
                    DSELW::VALUE3 => 2,
                    DSELW::VALUE4 => 3,
                    DSELW::VALUE5 => 4,
                    DSELW::VALUE6 => 5,
                    DSELW::VALUE7 => 6,
                    DSELW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The data input DXnA is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "The data input DXnB is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = "The data input DXnC is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSELW::VALUE3)
            }
            #[doc = "The data input DXnD is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSELW::VALUE4)
            }
            #[doc = "The data input DXnE is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(DSELW::VALUE5)
            }
            #[doc = "The data input DXnF is selected."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(DSELW::VALUE6)
            }
            #[doc = "The data input DXnG is selected."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(DSELW::VALUE7)
            }
            #[doc = "The data input is always 1."]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(DSELW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSW`"]
        pub enum INSWW {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INSWW::VALUE1 => false,
                    INSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSWW::VALUE1)
            }
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DFEN`"]
        pub enum DFENW {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DFENW::VALUE1 => false,
                    DFENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DFENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DFENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DFENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not digitally filtered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DFENW::VALUE1)
            }
            #[doc = "The input signal is digitally filtered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DFENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEN`"]
        pub enum DSENW {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSENW::VALUE1 => false,
                    DSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSENW::VALUE1)
            }
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPOL`"]
        pub enum DPOLW {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPOLW::VALUE1 => false,
                    DPOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not inverted."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPOLW::VALUE1)
            }
            #[doc = "The input signal is inverted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SFSEL`"]
        pub enum SFSELW {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFSELW::VALUE1 => false,
                    SFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The sampling frequency is fPB."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFSELW::VALUE1)
            }
            #[doc = "The sampling frequency is fFD."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM`"]
        pub enum CMW {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMW::VALUE1 => 0,
                    CMW::VALUE2 => 1,
                    CMW::VALUE3 => 2,
                    CMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The trigger activation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMW::VALUE1)
            }
            #[doc = "A rising edge activates DXnT."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMW::VALUE2)
            }
            #[doc = "A falling edge activates DXnT."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMW::VALUE3)
            }
            #[doc = "Both edges activate DXnT."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&self) -> INSWR {
                INSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&self) -> DFENR {
                DFENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&self) -> DSENR {
                DSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&self) -> DPOLR {
                DPOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&self) -> SFSELR {
                SFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&self) -> CMR {
                CMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Synchronized Data Value"]
            #[inline]
            pub fn dxs(&self) -> DXSR {
                DXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&mut self) -> _INSWW {
                _INSWW { w: self }
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&mut self) -> _DFENW {
                _DFENW { w: self }
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&mut self) -> _DSENW {
                _DSENW { w: self }
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&mut self) -> _DPOLW {
                _DPOLW { w: self }
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&mut self) -> _SFSELW {
                _SFSELW { w: self }
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&mut self) -> _CMW {
                _CMW { w: self }
            }
        }
    }
    #[doc = "Input Control Register 1"]
    pub struct DX1CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Control Register 1"]
    pub mod dx1cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DX1CR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "The data input DX1A is selected."]
            VALUE1,
            #[doc = "The data input DX1B is selected."]
            VALUE2,
            #[doc = "The data input DX1C is selected."]
            VALUE3,
            #[doc = "The data input DX1D is selected."]
            VALUE4,
            #[doc = "The data input DX1E is selected."]
            VALUE5,
            #[doc = "The data input DX1F is selected."]
            VALUE6,
            #[doc = "The data input DX1G is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSELR::VALUE1 => 0,
                    DSELR::VALUE2 => 0x01,
                    DSELR::VALUE3 => 0x02,
                    DSELR::VALUE4 => 0x03,
                    DSELR::VALUE5 => 0x04,
                    DSELR::VALUE6 => 0x05,
                    DSELR::VALUE7 => 0x06,
                    DSELR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSELR {
                match value {
                    0 => DSELR::VALUE1,
                    1 => DSELR::VALUE2,
                    2 => DSELR::VALUE3,
                    3 => DSELR::VALUE4,
                    4 => DSELR::VALUE5,
                    5 => DSELR::VALUE6,
                    6 => DSELR::VALUE7,
                    7 => DSELR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == DSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == DSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == DSELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == DSELR::VALUE8
            }
        }
        #[doc = "Possible values of the field `DCEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCENR {
            #[doc = "The receive shift clock is dependent on INSW selection."]
            VALUE1,
            #[doc = "The receive shift clock is connected to the selected data input line. This setting is used if delay compensation is required in SSC and IIS protocols, else DCEN should always be 0."]
            VALUE2,
        }
        impl DCENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCENR::VALUE1 => false,
                    DCENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCENR {
                match value {
                    false => DCENR::VALUE1,
                    true => DCENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `INSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSWR {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INSWR::VALUE1 => false,
                    INSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INSWR {
                match value {
                    false => INSWR::VALUE1,
                    true => INSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DFEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DFENR {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DFENR::VALUE1 => false,
                    DFENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DFENR {
                match value {
                    false => DFENR::VALUE1,
                    true => DFENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DFENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DFENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSENR {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSENR::VALUE1 => false,
                    DSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSENR {
                match value {
                    false => DSENR::VALUE1,
                    true => DSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPOLR {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPOLR::VALUE1 => false,
                    DPOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPOLR {
                match value {
                    false => DPOLR::VALUE1,
                    true => DPOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFSELR {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFSELR::VALUE1 => false,
                    SFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFSELR {
                match value {
                    false => SFSELR::VALUE1,
                    true => SFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMR {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DX1T."]
            VALUE2,
            #[doc = "A falling edge activates DX1T."]
            VALUE3,
            #[doc = "Both edges activate DX1T."]
            VALUE4,
        }
        impl CMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMR::VALUE1 => 0,
                    CMR::VALUE2 => 0x01,
                    CMR::VALUE3 => 0x02,
                    CMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMR {
                match value {
                    0 => CMR::VALUE1,
                    1 => CMR::VALUE2,
                    2 => CMR::VALUE3,
                    3 => CMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DXSR {
            #[doc = "The current value of DX1S is 0."]
            VALUE1,
            #[doc = "The current value of DX1S is 1."]
            VALUE2,
        }
        impl DXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DXSR::VALUE1 => false,
                    DXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DXSR {
                match value {
                    false => DXSR::VALUE1,
                    true => DXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DXSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "The data input DX1A is selected."]
            VALUE1,
            #[doc = "The data input DX1B is selected."]
            VALUE2,
            #[doc = "The data input DX1C is selected."]
            VALUE3,
            #[doc = "The data input DX1D is selected."]
            VALUE4,
            #[doc = "The data input DX1E is selected."]
            VALUE5,
            #[doc = "The data input DX1F is selected."]
            VALUE6,
            #[doc = "The data input DX1G is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSELW::VALUE1 => 0,
                    DSELW::VALUE2 => 1,
                    DSELW::VALUE3 => 2,
                    DSELW::VALUE4 => 3,
                    DSELW::VALUE5 => 4,
                    DSELW::VALUE6 => 5,
                    DSELW::VALUE7 => 6,
                    DSELW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The data input DX1A is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "The data input DX1B is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = "The data input DX1C is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSELW::VALUE3)
            }
            #[doc = "The data input DX1D is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSELW::VALUE4)
            }
            #[doc = "The data input DX1E is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(DSELW::VALUE5)
            }
            #[doc = "The data input DX1F is selected."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(DSELW::VALUE6)
            }
            #[doc = "The data input DX1G is selected."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(DSELW::VALUE7)
            }
            #[doc = "The data input is always 1."]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(DSELW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCEN`"]
        pub enum DCENW {
            #[doc = "The receive shift clock is dependent on INSW selection."]
            VALUE1,
            #[doc = "The receive shift clock is connected to the selected data input line. This setting is used if delay compensation is required in SSC and IIS protocols, else DCEN should always be 0."]
            VALUE2,
        }
        impl DCENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCENW::VALUE1 => false,
                    DCENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The receive shift clock is dependent on INSW selection."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCENW::VALUE1)
            }
            #[doc = "The receive shift clock is connected to the selected data input line. This setting is used if delay compensation is required in SSC and IIS protocols, else DCEN should always be 0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSW`"]
        pub enum INSWW {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INSWW::VALUE1 => false,
                    INSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSWW::VALUE1)
            }
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DFEN`"]
        pub enum DFENW {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DFENW::VALUE1 => false,
                    DFENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DFENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DFENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DFENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not digitally filtered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DFENW::VALUE1)
            }
            #[doc = "The input signal is digitally filtered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DFENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEN`"]
        pub enum DSENW {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSENW::VALUE1 => false,
                    DSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSENW::VALUE1)
            }
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPOL`"]
        pub enum DPOLW {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPOLW::VALUE1 => false,
                    DPOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not inverted."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPOLW::VALUE1)
            }
            #[doc = "The input signal is inverted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SFSEL`"]
        pub enum SFSELW {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFSELW::VALUE1 => false,
                    SFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The sampling frequency is fPB."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFSELW::VALUE1)
            }
            #[doc = "The sampling frequency is fFD."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM`"]
        pub enum CMW {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DX1T."]
            VALUE2,
            #[doc = "A falling edge activates DX1T."]
            VALUE3,
            #[doc = "Both edges activate DX1T."]
            VALUE4,
        }
        impl CMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMW::VALUE1 => 0,
                    CMW::VALUE2 => 1,
                    CMW::VALUE3 => 2,
                    CMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The trigger activation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMW::VALUE1)
            }
            #[doc = "A rising edge activates DX1T."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMW::VALUE2)
            }
            #[doc = "A falling edge activates DX1T."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMW::VALUE3)
            }
            #[doc = "Both edges activate DX1T."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Delay Compensation Enable"]
            #[inline]
            pub fn dcen(&self) -> DCENR {
                DCENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&self) -> INSWR {
                INSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&self) -> DFENR {
                DFENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&self) -> DSENR {
                DSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&self) -> DPOLR {
                DPOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&self) -> SFSELR {
                SFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&self) -> CMR {
                CMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Synchronized Data Value"]
            #[inline]
            pub fn dxs(&self) -> DXSR {
                DXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 3 - Delay Compensation Enable"]
            #[inline]
            pub fn dcen(&mut self) -> _DCENW {
                _DCENW { w: self }
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&mut self) -> _INSWW {
                _INSWW { w: self }
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&mut self) -> _DFENW {
                _DFENW { w: self }
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&mut self) -> _DSENW {
                _DSENW { w: self }
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&mut self) -> _DPOLW {
                _DPOLW { w: self }
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&mut self) -> _SFSELW {
                _SFSELW { w: self }
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&mut self) -> _CMW {
                _CMW { w: self }
            }
        }
    }
    #[doc = "Input Control Register 2"]
    pub struct DX2CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Control Register 2"]
    pub mod dx2cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DX2CR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSELR::VALUE1 => 0,
                    DSELR::VALUE2 => 0x01,
                    DSELR::VALUE3 => 0x02,
                    DSELR::VALUE4 => 0x03,
                    DSELR::VALUE5 => 0x04,
                    DSELR::VALUE6 => 0x05,
                    DSELR::VALUE7 => 0x06,
                    DSELR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSELR {
                match value {
                    0 => DSELR::VALUE1,
                    1 => DSELR::VALUE2,
                    2 => DSELR::VALUE3,
                    3 => DSELR::VALUE4,
                    4 => DSELR::VALUE5,
                    5 => DSELR::VALUE6,
                    6 => DSELR::VALUE7,
                    7 => DSELR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == DSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == DSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == DSELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == DSELR::VALUE8
            }
        }
        #[doc = "Possible values of the field `INSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSWR {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INSWR::VALUE1 => false,
                    INSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INSWR {
                match value {
                    false => INSWR::VALUE1,
                    true => INSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DFEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DFENR {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DFENR::VALUE1 => false,
                    DFENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DFENR {
                match value {
                    false => DFENR::VALUE1,
                    true => DFENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DFENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DFENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSENR {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSENR::VALUE1 => false,
                    DSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSENR {
                match value {
                    false => DSENR::VALUE1,
                    true => DSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPOLR {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPOLR::VALUE1 => false,
                    DPOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPOLR {
                match value {
                    false => DPOLR::VALUE1,
                    true => DPOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFSELR {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFSELR::VALUE1 => false,
                    SFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFSELR {
                match value {
                    false => SFSELR::VALUE1,
                    true => SFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMR {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMR::VALUE1 => 0,
                    CMR::VALUE2 => 0x01,
                    CMR::VALUE3 => 0x02,
                    CMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMR {
                match value {
                    0 => CMR::VALUE1,
                    1 => CMR::VALUE2,
                    2 => CMR::VALUE3,
                    3 => CMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DXSR {
            #[doc = "The current value of DXnS is 0."]
            VALUE1,
            #[doc = "The current value of DXnS is 1."]
            VALUE2,
        }
        impl DXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DXSR::VALUE1 => false,
                    DXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DXSR {
                match value {
                    false => DXSR::VALUE1,
                    true => DXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DXSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSELW::VALUE1 => 0,
                    DSELW::VALUE2 => 1,
                    DSELW::VALUE3 => 2,
                    DSELW::VALUE4 => 3,
                    DSELW::VALUE5 => 4,
                    DSELW::VALUE6 => 5,
                    DSELW::VALUE7 => 6,
                    DSELW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The data input DXnA is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "The data input DXnB is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = "The data input DXnC is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSELW::VALUE3)
            }
            #[doc = "The data input DXnD is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSELW::VALUE4)
            }
            #[doc = "The data input DXnE is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(DSELW::VALUE5)
            }
            #[doc = "The data input DXnF is selected."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(DSELW::VALUE6)
            }
            #[doc = "The data input DXnG is selected."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(DSELW::VALUE7)
            }
            #[doc = "The data input is always 1."]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(DSELW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSW`"]
        pub enum INSWW {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INSWW::VALUE1 => false,
                    INSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSWW::VALUE1)
            }
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DFEN`"]
        pub enum DFENW {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DFENW::VALUE1 => false,
                    DFENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DFENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DFENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DFENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not digitally filtered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DFENW::VALUE1)
            }
            #[doc = "The input signal is digitally filtered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DFENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEN`"]
        pub enum DSENW {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSENW::VALUE1 => false,
                    DSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSENW::VALUE1)
            }
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPOL`"]
        pub enum DPOLW {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPOLW::VALUE1 => false,
                    DPOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not inverted."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPOLW::VALUE1)
            }
            #[doc = "The input signal is inverted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SFSEL`"]
        pub enum SFSELW {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFSELW::VALUE1 => false,
                    SFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The sampling frequency is fPB."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFSELW::VALUE1)
            }
            #[doc = "The sampling frequency is fFD."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM`"]
        pub enum CMW {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMW::VALUE1 => 0,
                    CMW::VALUE2 => 1,
                    CMW::VALUE3 => 2,
                    CMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The trigger activation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMW::VALUE1)
            }
            #[doc = "A rising edge activates DXnT."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMW::VALUE2)
            }
            #[doc = "A falling edge activates DXnT."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMW::VALUE3)
            }
            #[doc = "Both edges activate DXnT."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&self) -> INSWR {
                INSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&self) -> DFENR {
                DFENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&self) -> DSENR {
                DSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&self) -> DPOLR {
                DPOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&self) -> SFSELR {
                SFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&self) -> CMR {
                CMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Synchronized Data Value"]
            #[inline]
            pub fn dxs(&self) -> DXSR {
                DXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&mut self) -> _INSWW {
                _INSWW { w: self }
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&mut self) -> _DFENW {
                _DFENW { w: self }
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&mut self) -> _DSENW {
                _DSENW { w: self }
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&mut self) -> _DPOLW {
                _DPOLW { w: self }
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&mut self) -> _SFSELW {
                _SFSELW { w: self }
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&mut self) -> _CMW {
                _CMW { w: self }
            }
        }
    }
    #[doc = "Input Control Register 3"]
    pub struct DX3CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Control Register 3"]
    pub mod dx3cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DX3CR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSELR::VALUE1 => 0,
                    DSELR::VALUE2 => 0x01,
                    DSELR::VALUE3 => 0x02,
                    DSELR::VALUE4 => 0x03,
                    DSELR::VALUE5 => 0x04,
                    DSELR::VALUE6 => 0x05,
                    DSELR::VALUE7 => 0x06,
                    DSELR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSELR {
                match value {
                    0 => DSELR::VALUE1,
                    1 => DSELR::VALUE2,
                    2 => DSELR::VALUE3,
                    3 => DSELR::VALUE4,
                    4 => DSELR::VALUE5,
                    5 => DSELR::VALUE6,
                    6 => DSELR::VALUE7,
                    7 => DSELR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == DSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == DSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == DSELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == DSELR::VALUE8
            }
        }
        #[doc = "Possible values of the field `INSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSWR {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INSWR::VALUE1 => false,
                    INSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INSWR {
                match value {
                    false => INSWR::VALUE1,
                    true => INSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DFEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DFENR {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DFENR::VALUE1 => false,
                    DFENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DFENR {
                match value {
                    false => DFENR::VALUE1,
                    true => DFENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DFENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DFENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSENR {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSENR::VALUE1 => false,
                    DSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSENR {
                match value {
                    false => DSENR::VALUE1,
                    true => DSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPOLR {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPOLR::VALUE1 => false,
                    DPOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPOLR {
                match value {
                    false => DPOLR::VALUE1,
                    true => DPOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFSELR {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFSELR::VALUE1 => false,
                    SFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFSELR {
                match value {
                    false => SFSELR::VALUE1,
                    true => SFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMR {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMR::VALUE1 => 0,
                    CMR::VALUE2 => 0x01,
                    CMR::VALUE3 => 0x02,
                    CMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMR {
                match value {
                    0 => CMR::VALUE1,
                    1 => CMR::VALUE2,
                    2 => CMR::VALUE3,
                    3 => CMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DXSR {
            #[doc = "The current value of DXnS is 0."]
            VALUE1,
            #[doc = "The current value of DXnS is 1."]
            VALUE2,
        }
        impl DXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DXSR::VALUE1 => false,
                    DXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DXSR {
                match value {
                    false => DXSR::VALUE1,
                    true => DXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DXSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSELW::VALUE1 => 0,
                    DSELW::VALUE2 => 1,
                    DSELW::VALUE3 => 2,
                    DSELW::VALUE4 => 3,
                    DSELW::VALUE5 => 4,
                    DSELW::VALUE6 => 5,
                    DSELW::VALUE7 => 6,
                    DSELW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The data input DXnA is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "The data input DXnB is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = "The data input DXnC is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSELW::VALUE3)
            }
            #[doc = "The data input DXnD is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSELW::VALUE4)
            }
            #[doc = "The data input DXnE is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(DSELW::VALUE5)
            }
            #[doc = "The data input DXnF is selected."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(DSELW::VALUE6)
            }
            #[doc = "The data input DXnG is selected."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(DSELW::VALUE7)
            }
            #[doc = "The data input is always 1."]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(DSELW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSW`"]
        pub enum INSWW {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INSWW::VALUE1 => false,
                    INSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSWW::VALUE1)
            }
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DFEN`"]
        pub enum DFENW {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DFENW::VALUE1 => false,
                    DFENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DFENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DFENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DFENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not digitally filtered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DFENW::VALUE1)
            }
            #[doc = "The input signal is digitally filtered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DFENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEN`"]
        pub enum DSENW {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSENW::VALUE1 => false,
                    DSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSENW::VALUE1)
            }
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPOL`"]
        pub enum DPOLW {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPOLW::VALUE1 => false,
                    DPOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not inverted."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPOLW::VALUE1)
            }
            #[doc = "The input signal is inverted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SFSEL`"]
        pub enum SFSELW {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFSELW::VALUE1 => false,
                    SFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The sampling frequency is fPB."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFSELW::VALUE1)
            }
            #[doc = "The sampling frequency is fFD."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM`"]
        pub enum CMW {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMW::VALUE1 => 0,
                    CMW::VALUE2 => 1,
                    CMW::VALUE3 => 2,
                    CMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The trigger activation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMW::VALUE1)
            }
            #[doc = "A rising edge activates DXnT."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMW::VALUE2)
            }
            #[doc = "A falling edge activates DXnT."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMW::VALUE3)
            }
            #[doc = "Both edges activate DXnT."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&self) -> INSWR {
                INSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&self) -> DFENR {
                DFENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&self) -> DSENR {
                DSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&self) -> DPOLR {
                DPOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&self) -> SFSELR {
                SFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&self) -> CMR {
                CMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Synchronized Data Value"]
            #[inline]
            pub fn dxs(&self) -> DXSR {
                DXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&mut self) -> _INSWW {
                _INSWW { w: self }
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&mut self) -> _DFENW {
                _DFENW { w: self }
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&mut self) -> _DSENW {
                _DSENW { w: self }
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&mut self) -> _DPOLW {
                _DPOLW { w: self }
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&mut self) -> _SFSELW {
                _SFSELW { w: self }
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&mut self) -> _CMW {
                _CMW { w: self }
            }
        }
    }
    #[doc = "Input Control Register 4"]
    pub struct DX4CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Control Register 4"]
    pub mod dx4cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DX4CR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSELR::VALUE1 => 0,
                    DSELR::VALUE2 => 0x01,
                    DSELR::VALUE3 => 0x02,
                    DSELR::VALUE4 => 0x03,
                    DSELR::VALUE5 => 0x04,
                    DSELR::VALUE6 => 0x05,
                    DSELR::VALUE7 => 0x06,
                    DSELR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSELR {
                match value {
                    0 => DSELR::VALUE1,
                    1 => DSELR::VALUE2,
                    2 => DSELR::VALUE3,
                    3 => DSELR::VALUE4,
                    4 => DSELR::VALUE5,
                    5 => DSELR::VALUE6,
                    6 => DSELR::VALUE7,
                    7 => DSELR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == DSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == DSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == DSELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == DSELR::VALUE8
            }
        }
        #[doc = "Possible values of the field `INSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSWR {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INSWR::VALUE1 => false,
                    INSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INSWR {
                match value {
                    false => INSWR::VALUE1,
                    true => INSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DFEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DFENR {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DFENR::VALUE1 => false,
                    DFENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DFENR {
                match value {
                    false => DFENR::VALUE1,
                    true => DFENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DFENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DFENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSENR {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSENR::VALUE1 => false,
                    DSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSENR {
                match value {
                    false => DSENR::VALUE1,
                    true => DSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPOLR {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPOLR::VALUE1 => false,
                    DPOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPOLR {
                match value {
                    false => DPOLR::VALUE1,
                    true => DPOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFSELR {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFSELR::VALUE1 => false,
                    SFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFSELR {
                match value {
                    false => SFSELR::VALUE1,
                    true => SFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMR {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMR::VALUE1 => 0,
                    CMR::VALUE2 => 0x01,
                    CMR::VALUE3 => 0x02,
                    CMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMR {
                match value {
                    0 => CMR::VALUE1,
                    1 => CMR::VALUE2,
                    2 => CMR::VALUE3,
                    3 => CMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DXSR {
            #[doc = "The current value of DXnS is 0."]
            VALUE1,
            #[doc = "The current value of DXnS is 1."]
            VALUE2,
        }
        impl DXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DXSR::VALUE1 => false,
                    DXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DXSR {
                match value {
                    false => DXSR::VALUE1,
                    true => DXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DXSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSELW::VALUE1 => 0,
                    DSELW::VALUE2 => 1,
                    DSELW::VALUE3 => 2,
                    DSELW::VALUE4 => 3,
                    DSELW::VALUE5 => 4,
                    DSELW::VALUE6 => 5,
                    DSELW::VALUE7 => 6,
                    DSELW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The data input DXnA is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "The data input DXnB is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = "The data input DXnC is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSELW::VALUE3)
            }
            #[doc = "The data input DXnD is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSELW::VALUE4)
            }
            #[doc = "The data input DXnE is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(DSELW::VALUE5)
            }
            #[doc = "The data input DXnF is selected."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(DSELW::VALUE6)
            }
            #[doc = "The data input DXnG is selected."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(DSELW::VALUE7)
            }
            #[doc = "The data input is always 1."]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(DSELW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSW`"]
        pub enum INSWW {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INSWW::VALUE1 => false,
                    INSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSWW::VALUE1)
            }
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DFEN`"]
        pub enum DFENW {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DFENW::VALUE1 => false,
                    DFENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DFENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DFENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DFENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not digitally filtered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DFENW::VALUE1)
            }
            #[doc = "The input signal is digitally filtered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DFENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEN`"]
        pub enum DSENW {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSENW::VALUE1 => false,
                    DSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSENW::VALUE1)
            }
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPOL`"]
        pub enum DPOLW {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPOLW::VALUE1 => false,
                    DPOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not inverted."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPOLW::VALUE1)
            }
            #[doc = "The input signal is inverted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SFSEL`"]
        pub enum SFSELW {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFSELW::VALUE1 => false,
                    SFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The sampling frequency is fPB."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFSELW::VALUE1)
            }
            #[doc = "The sampling frequency is fFD."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM`"]
        pub enum CMW {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMW::VALUE1 => 0,
                    CMW::VALUE2 => 1,
                    CMW::VALUE3 => 2,
                    CMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The trigger activation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMW::VALUE1)
            }
            #[doc = "A rising edge activates DXnT."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMW::VALUE2)
            }
            #[doc = "A falling edge activates DXnT."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMW::VALUE3)
            }
            #[doc = "Both edges activate DXnT."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&self) -> INSWR {
                INSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&self) -> DFENR {
                DFENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&self) -> DSENR {
                DSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&self) -> DPOLR {
                DPOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&self) -> SFSELR {
                SFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&self) -> CMR {
                CMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Synchronized Data Value"]
            #[inline]
            pub fn dxs(&self) -> DXSR {
                DXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&mut self) -> _INSWW {
                _INSWW { w: self }
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&mut self) -> _DFENW {
                _DFENW { w: self }
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&mut self) -> _DSENW {
                _DSENW { w: self }
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&mut self) -> _DPOLW {
                _DPOLW { w: self }
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&mut self) -> _SFSELW {
                _SFSELW { w: self }
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&mut self) -> _CMW {
                _CMW { w: self }
            }
        }
    }
    #[doc = "Input Control Register 5"]
    pub struct DX5CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Control Register 5"]
    pub mod dx5cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DX5CR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSELR::VALUE1 => 0,
                    DSELR::VALUE2 => 0x01,
                    DSELR::VALUE3 => 0x02,
                    DSELR::VALUE4 => 0x03,
                    DSELR::VALUE5 => 0x04,
                    DSELR::VALUE6 => 0x05,
                    DSELR::VALUE7 => 0x06,
                    DSELR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSELR {
                match value {
                    0 => DSELR::VALUE1,
                    1 => DSELR::VALUE2,
                    2 => DSELR::VALUE3,
                    3 => DSELR::VALUE4,
                    4 => DSELR::VALUE5,
                    5 => DSELR::VALUE6,
                    6 => DSELR::VALUE7,
                    7 => DSELR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSELR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == DSELR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == DSELR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == DSELR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == DSELR::VALUE8
            }
        }
        #[doc = "Possible values of the field `INSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSWR {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INSWR::VALUE1 => false,
                    INSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INSWR {
                match value {
                    false => INSWR::VALUE1,
                    true => INSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DFEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DFENR {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DFENR::VALUE1 => false,
                    DFENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DFENR {
                match value {
                    false => DFENR::VALUE1,
                    true => DFENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DFENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DFENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSENR {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSENR::VALUE1 => false,
                    DSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSENR {
                match value {
                    false => DSENR::VALUE1,
                    true => DSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPOL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPOLR {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPOLR::VALUE1 => false,
                    DPOLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPOLR {
                match value {
                    false => DPOLR::VALUE1,
                    true => DPOLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPOLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPOLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SFSELR {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SFSELR::VALUE1 => false,
                    SFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SFSELR {
                match value {
                    false => SFSELR::VALUE1,
                    true => SFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMR {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMR::VALUE1 => 0,
                    CMR::VALUE2 => 0x01,
                    CMR::VALUE3 => 0x02,
                    CMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMR {
                match value {
                    0 => CMR::VALUE1,
                    1 => CMR::VALUE2,
                    2 => CMR::VALUE3,
                    3 => CMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DXSR {
            #[doc = "The current value of DXnS is 0."]
            VALUE1,
            #[doc = "The current value of DXnS is 1."]
            VALUE2,
        }
        impl DXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DXSR::VALUE1 => false,
                    DXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DXSR {
                match value {
                    false => DXSR::VALUE1,
                    true => DXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DXSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "The data input DXnA is selected."]
            VALUE1,
            #[doc = "The data input DXnB is selected."]
            VALUE2,
            #[doc = "The data input DXnC is selected."]
            VALUE3,
            #[doc = "The data input DXnD is selected."]
            VALUE4,
            #[doc = "The data input DXnE is selected."]
            VALUE5,
            #[doc = "The data input DXnF is selected."]
            VALUE6,
            #[doc = "The data input DXnG is selected."]
            VALUE7,
            #[doc = "The data input is always 1."]
            VALUE8,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSELW::VALUE1 => 0,
                    DSELW::VALUE2 => 1,
                    DSELW::VALUE3 => 2,
                    DSELW::VALUE4 => 3,
                    DSELW::VALUE5 => 4,
                    DSELW::VALUE6 => 5,
                    DSELW::VALUE7 => 6,
                    DSELW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The data input DXnA is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "The data input DXnB is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = "The data input DXnC is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSELW::VALUE3)
            }
            #[doc = "The data input DXnD is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSELW::VALUE4)
            }
            #[doc = "The data input DXnE is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(DSELW::VALUE5)
            }
            #[doc = "The data input DXnF is selected."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(DSELW::VALUE6)
            }
            #[doc = "The data input DXnG is selected."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(DSELW::VALUE7)
            }
            #[doc = "The data input is always 1."]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(DSELW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSW`"]
        pub enum INSWW {
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            VALUE1,
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            VALUE2,
        }
        impl INSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INSWW::VALUE1 => false,
                    INSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input of the data shift unit is controlled by the protocol pre-processor."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSWW::VALUE1)
            }
            #[doc = "The input of the data shift unit is connected to the selected data input line. This setting is used if the signals are directly derived from an input pin without treatment by the protocol pre-processor."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DFEN`"]
        pub enum DFENW {
            #[doc = "The input signal is not digitally filtered."]
            VALUE1,
            #[doc = "The input signal is digitally filtered."]
            VALUE2,
        }
        impl DFENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DFENW::VALUE1 => false,
                    DFENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DFENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DFENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DFENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not digitally filtered."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DFENW::VALUE1)
            }
            #[doc = "The input signal is digitally filtered."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DFENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEN`"]
        pub enum DSENW {
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            VALUE1,
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            VALUE2,
        }
        impl DSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSENW::VALUE1 => false,
                    DSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The un-synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSENW::VALUE1)
            }
            #[doc = "The synchronized signal can be taken as input for the data shift unit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPOL`"]
        pub enum DPOLW {
            #[doc = "The input signal is not inverted."]
            VALUE1,
            #[doc = "The input signal is inverted."]
            VALUE2,
        }
        impl DPOLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPOLW::VALUE1 => false,
                    DPOLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPOLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPOLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPOLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The input signal is not inverted."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPOLW::VALUE1)
            }
            #[doc = "The input signal is inverted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPOLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SFSEL`"]
        pub enum SFSELW {
            #[doc = "The sampling frequency is fPB."]
            VALUE1,
            #[doc = "The sampling frequency is fFD."]
            VALUE2,
        }
        impl SFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SFSELW::VALUE1 => false,
                    SFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The sampling frequency is fPB."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SFSELW::VALUE1)
            }
            #[doc = "The sampling frequency is fFD."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM`"]
        pub enum CMW {
            #[doc = "The trigger activation is disabled."]
            VALUE1,
            #[doc = "A rising edge activates DXnT."]
            VALUE2,
            #[doc = "A falling edge activates DXnT."]
            VALUE3,
            #[doc = "Both edges activate DXnT."]
            VALUE4,
        }
        impl CMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMW::VALUE1 => 0,
                    CMW::VALUE2 => 1,
                    CMW::VALUE3 => 2,
                    CMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The trigger activation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMW::VALUE1)
            }
            #[doc = "A rising edge activates DXnT."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMW::VALUE2)
            }
            #[doc = "A falling edge activates DXnT."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMW::VALUE3)
            }
            #[doc = "Both edges activate DXnT."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&self) -> INSWR {
                INSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&self) -> DFENR {
                DFENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&self) -> DSENR {
                DSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&self) -> DPOLR {
                DPOLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&self) -> SFSELR {
                SFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&self) -> CMR {
                CMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Synchronized Data Value"]
            #[inline]
            pub fn dxs(&self) -> DXSR {
                DXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Data Selection for Input Signal"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 4 - Input Switch"]
            #[inline]
            pub fn insw(&mut self) -> _INSWW {
                _INSWW { w: self }
            }
            #[doc = "Bit 5 - Digital Filter Enable"]
            #[inline]
            pub fn dfen(&mut self) -> _DFENW {
                _DFENW { w: self }
            }
            #[doc = "Bit 6 - Data Synchronization Enable"]
            #[inline]
            pub fn dsen(&mut self) -> _DSENW {
                _DSENW { w: self }
            }
            #[doc = "Bit 8 - Data Polarity for DXn"]
            #[inline]
            pub fn dpol(&mut self) -> _DPOLW {
                _DPOLW { w: self }
            }
            #[doc = "Bit 9 - Sampling Frequency Selection"]
            #[inline]
            pub fn sfsel(&mut self) -> _SFSELW {
                _SFSELW { w: self }
            }
            #[doc = "Bits 10:11 - Combination Mode"]
            #[inline]
            pub fn cm(&mut self) -> _CMW {
                _CMW { w: self }
            }
        }
    }
    #[doc = "Shift Control Register"]
    pub struct SCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Shift Control Register"]
    pub mod sctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SDIR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SDIRR {
            #[doc = "Shift LSB first. The first data bit of a data word is located at bit position 0."]
            VALUE1,
            #[doc = "Shift MSB first. The first data bit of a data word is located at the bit position given by bit field SCTR.WLE."]
            VALUE2,
        }
        impl SDIRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SDIRR::VALUE1 => false,
                    SDIRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SDIRR {
                match value {
                    false => SDIRR::VALUE1,
                    true => SDIRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SDIRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SDIRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDLR {
            #[doc = "The passive data level is 0."]
            VALUE1,
            #[doc = "The passive data level is 1."]
            VALUE2,
        }
        impl PDLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDLR::VALUE1 => false,
                    PDLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDLR {
                match value {
                    false => PDLR::VALUE1,
                    true => PDLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSMR {
            #[doc = "Receive and transmit data is shifted in and out one bit at a time through DX0 and DOUT0."]
            VALUE1,
            #[doc = "Receive and transmit data is shifted in and out two bits at a time through two input stages (DX0 and DX3) and DOUT[1:0] respectively."]
            VALUE3,
            #[doc = "Receive and transmit data is shifted in and out four bits at a time through four input stages (DX0, DX[5:3]) and DOUT[3:0] respectively."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DSMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DSMR::VALUE1 => 0,
                    DSMR::VALUE3 => 0x02,
                    DSMR::VALUE4 => 0x03,
                    DSMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DSMR {
                match value {
                    0 => DSMR::VALUE1,
                    2 => DSMR::VALUE3,
                    3 => DSMR::VALUE4,
                    i => DSMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DSMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DSMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `HPCDIR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HPCDIRR {
            #[doc = "The pin(s) with hardware pin control enabled are selected to be in input mode."]
            VALUE1,
            #[doc = "The pin(s) with hardware pin control enabled are selected to be in output mode."]
            VALUE2,
        }
        impl HPCDIRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HPCDIRR::VALUE1 => false,
                    HPCDIRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HPCDIRR {
                match value {
                    false => HPCDIRR::VALUE1,
                    true => HPCDIRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HPCDIRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HPCDIRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DOCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DOCFGR {
            #[doc = "DOUTx = shift data value"]
            VALUE1,
            #[doc = "DOUTx = inverted shift data value"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DOCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DOCFGR::VALUE1 => 0,
                    DOCFGR::VALUE2 => 0x01,
                    DOCFGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DOCFGR {
                match value {
                    0 => DOCFGR::VALUE1,
                    1 => DOCFGR::VALUE2,
                    i => DOCFGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DOCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DOCFGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRMR {
            #[doc = "The shift control signal is considered as inactive and data frame transfers are not possible."]
            VALUE1,
            #[doc = "The shift control signal is considered active if it is at 1-level. This is the setting to be programmed to allow data transfers."]
            VALUE2,
            #[doc = "The shift control signal is considered active if it is at 0-level. It is recommended to avoid this setting and to use the inversion in the DX2 stage in case of a low-active signal."]
            VALUE3,
            #[doc = "The shift control signal is considered active without referring to the actual signal level. Data frame transfer is possible after each edge of the signal."]
            VALUE4,
        }
        impl TRMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRMR::VALUE1 => 0,
                    TRMR::VALUE2 => 0x01,
                    TRMR::VALUE3 => 0x02,
                    TRMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRMR {
                match value {
                    0 => TRMR::VALUE1,
                    1 => TRMR::VALUE2,
                    2 => TRMR::VALUE3,
                    3 => TRMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TRMR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct FLER {
            bits: u8,
        }
        impl FLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `WLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WLER {
            #[doc = "The data word contains 1 data bit located at bit position 0."]
            VALUE1,
            #[doc = "The data word contains 2 data bits located at bit positions [1:0]."]
            VALUE2,
            #[doc = "The data word contains 15 data bits located at bit positions [14:0]."]
            VALUE3,
            #[doc = "The data word contains 16 data bits located at bit positions [15:0]."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl WLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    WLER::VALUE1 => 0,
                    WLER::VALUE2 => 0x01,
                    WLER::VALUE3 => 0x0e,
                    WLER::VALUE4 => 0x0f,
                    WLER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> WLER {
                match value {
                    0 => WLER::VALUE1,
                    1 => WLER::VALUE2,
                    14 => WLER::VALUE3,
                    15 => WLER::VALUE4,
                    i => WLER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WLER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == WLER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == WLER::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SDIR`"]
        pub enum SDIRW {
            #[doc = "Shift LSB first. The first data bit of a data word is located at bit position 0."]
            VALUE1,
            #[doc = "Shift MSB first. The first data bit of a data word is located at the bit position given by bit field SCTR.WLE."]
            VALUE2,
        }
        impl SDIRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SDIRW::VALUE1 => false,
                    SDIRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SDIRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SDIRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shift LSB first. The first data bit of a data word is located at bit position 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SDIRW::VALUE1)
            }
            #[doc = "Shift MSB first. The first data bit of a data word is located at the bit position given by bit field SCTR.WLE."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SDIRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDL`"]
        pub enum PDLW {
            #[doc = "The passive data level is 0."]
            VALUE1,
            #[doc = "The passive data level is 1."]
            VALUE2,
        }
        impl PDLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDLW::VALUE1 => false,
                    PDLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The passive data level is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDLW::VALUE1)
            }
            #[doc = "The passive data level is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSM`"]
        pub enum DSMW {
            #[doc = "Receive and transmit data is shifted in and out one bit at a time through DX0 and DOUT0."]
            VALUE1,
            #[doc = "Receive and transmit data is shifted in and out two bits at a time through two input stages (DX0 and DX3) and DOUT[1:0] respectively."]
            VALUE3,
            #[doc = "Receive and transmit data is shifted in and out four bits at a time through four input stages (DX0, DX[5:3]) and DOUT[3:0] respectively."]
            VALUE4,
        }
        impl DSMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DSMW::VALUE1 => 0,
                    DSMW::VALUE3 => 2,
                    DSMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Receive and transmit data is shifted in and out one bit at a time through DX0 and DOUT0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSMW::VALUE1)
            }
            #[doc = "Receive and transmit data is shifted in and out two bits at a time through two input stages (DX0 and DX3) and DOUT[1:0] respectively."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DSMW::VALUE3)
            }
            #[doc = "Receive and transmit data is shifted in and out four bits at a time through four input stages (DX0, DX[5:3]) and DOUT[3:0] respectively."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DSMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HPCDIR`"]
        pub enum HPCDIRW {
            #[doc = "The pin(s) with hardware pin control enabled are selected to be in input mode."]
            VALUE1,
            #[doc = "The pin(s) with hardware pin control enabled are selected to be in output mode."]
            VALUE2,
        }
        impl HPCDIRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HPCDIRW::VALUE1 => false,
                    HPCDIRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HPCDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HPCDIRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HPCDIRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The pin(s) with hardware pin control enabled are selected to be in input mode."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HPCDIRW::VALUE1)
            }
            #[doc = "The pin(s) with hardware pin control enabled are selected to be in output mode."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HPCDIRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DOCFG`"]
        pub enum DOCFGW {
            #[doc = "DOUTx = shift data value"]
            VALUE1,
            #[doc = "DOUTx = inverted shift data value"]
            VALUE2,
        }
        impl DOCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DOCFGW::VALUE1 => 0,
                    DOCFGW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DOCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DOCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DOCFGW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "DOUTx = shift data value"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DOCFGW::VALUE1)
            }
            #[doc = "DOUTx = inverted shift data value"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DOCFGW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRM`"]
        pub enum TRMW {
            #[doc = "The shift control signal is considered as inactive and data frame transfers are not possible."]
            VALUE1,
            #[doc = "The shift control signal is considered active if it is at 1-level. This is the setting to be programmed to allow data transfers."]
            VALUE2,
            #[doc = "The shift control signal is considered active if it is at 0-level. It is recommended to avoid this setting and to use the inversion in the DX2 stage in case of a low-active signal."]
            VALUE3,
            #[doc = "The shift control signal is considered active without referring to the actual signal level. Data frame transfer is possible after each edge of the signal."]
            VALUE4,
        }
        impl TRMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRMW::VALUE1 => 0,
                    TRMW::VALUE2 => 1,
                    TRMW::VALUE3 => 2,
                    TRMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The shift control signal is considered as inactive and data frame transfers are not possible."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRMW::VALUE1)
            }
            #[doc = "The shift control signal is considered active if it is at 1-level. This is the setting to be programmed to allow data transfers."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRMW::VALUE2)
            }
            #[doc = "The shift control signal is considered active if it is at 0-level. It is recommended to avoid this setting and to use the inversion in the DX2 stage in case of a low-active signal."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRMW::VALUE3)
            }
            #[doc = "The shift control signal is considered active without referring to the actual signal level. Data frame transfer is possible after each edge of the signal."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TRMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WLE`"]
        pub enum WLEW {
            #[doc = "The data word contains 1 data bit located at bit position 0."]
            VALUE1,
            #[doc = "The data word contains 2 data bits located at bit positions [1:0]."]
            VALUE2,
            #[doc = "The data word contains 15 data bits located at bit positions [14:0]."]
            VALUE3,
            #[doc = "The data word contains 16 data bits located at bit positions [15:0]."]
            VALUE4,
        }
        impl WLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WLEW::VALUE1 => 0,
                    WLEW::VALUE2 => 1,
                    WLEW::VALUE3 => 14,
                    WLEW::VALUE4 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WLEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The data word contains 1 data bit located at bit position 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WLEW::VALUE1)
            }
            #[doc = "The data word contains 2 data bits located at bit positions [1:0]."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WLEW::VALUE2)
            }
            #[doc = "The data word contains 15 data bits located at bit positions [14:0]."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(WLEW::VALUE3)
            }
            #[doc = "The data word contains 16 data bits located at bit positions [15:0]."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(WLEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Shift Direction"]
            #[inline]
            pub fn sdir(&self) -> SDIRR {
                SDIRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Passive Data Level"]
            #[inline]
            pub fn pdl(&self) -> PDLR {
                PDLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 2:3 - Data Shift Mode"]
            #[inline]
            pub fn dsm(&self) -> DSMR {
                DSMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Port Control Direction"]
            #[inline]
            pub fn hpcdir(&self) -> HPCDIRR {
                HPCDIRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 6:7 - Data Output Configuration"]
            #[inline]
            pub fn docfg(&self) -> DOCFGR {
                DOCFGR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Transmission Mode"]
            #[inline]
            pub fn trm(&self) -> TRMR {
                TRMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:21 - Frame Length"]
            #[inline]
            pub fn fle(&self) -> FLER {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FLER { bits }
            }
            #[doc = "Bits 24:27 - Word Length"]
            #[inline]
            pub fn wle(&self) -> WLER {
                WLER::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Shift Direction"]
            #[inline]
            pub fn sdir(&mut self) -> _SDIRW {
                _SDIRW { w: self }
            }
            #[doc = "Bit 1 - Passive Data Level"]
            #[inline]
            pub fn pdl(&mut self) -> _PDLW {
                _PDLW { w: self }
            }
            #[doc = "Bits 2:3 - Data Shift Mode"]
            #[inline]
            pub fn dsm(&mut self) -> _DSMW {
                _DSMW { w: self }
            }
            #[doc = "Bit 4 - Port Control Direction"]
            #[inline]
            pub fn hpcdir(&mut self) -> _HPCDIRW {
                _HPCDIRW { w: self }
            }
            #[doc = "Bits 6:7 - Data Output Configuration"]
            #[inline]
            pub fn docfg(&mut self) -> _DOCFGW {
                _DOCFGW { w: self }
            }
            #[doc = "Bits 8:9 - Transmission Mode"]
            #[inline]
            pub fn trm(&mut self) -> _TRMW {
                _TRMW { w: self }
            }
            #[doc = "Bits 16:21 - Frame Length"]
            #[inline]
            pub fn fle(&mut self) -> _FLEW {
                _FLEW { w: self }
            }
            #[doc = "Bits 24:27 - Word Length"]
            #[inline]
            pub fn wle(&mut self) -> _WLEW {
                _WLEW { w: self }
            }
        }
    }
    #[doc = "Transmit Control/Status Register"]
    pub struct TCSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmit Control/Status Register"]
    pub mod tcsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TCSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `WLEMD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WLEMDR {
            #[doc = "The automatic update of SCTR.WLE and TCSR.EOF is disabled."]
            VALUE1,
            #[doc = "The automatic update of SCTR.WLE and TCSR.EOF is enabled."]
            VALUE2,
        }
        impl WLEMDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WLEMDR::VALUE1 => false,
                    WLEMDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WLEMDR {
                match value {
                    false => WLEMDR::VALUE1,
                    true => WLEMDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WLEMDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WLEMDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELMD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELMDR {
            #[doc = "The automatic update of PCR.CTR[23:16] is disabled."]
            VALUE1,
            #[doc = "The automatic update of PCR.CTR[23:16] is disabled."]
            VALUE2,
        }
        impl SELMDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELMDR::VALUE1 => false,
                    SELMDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELMDR {
                match value {
                    false => SELMDR::VALUE1,
                    true => SELMDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELMDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELMDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FLEMD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FLEMDR {
            #[doc = "The automatic update of FLE is disabled."]
            VALUE1,
            #[doc = "The automatic update of FLE is enabled."]
            VALUE2,
        }
        impl FLEMDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FLEMDR::VALUE1 => false,
                    FLEMDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FLEMDR {
                match value {
                    false => FLEMDR::VALUE1,
                    true => FLEMDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FLEMDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FLEMDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WAMD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAMDR {
            #[doc = "The automatic update of bit WA is disabled."]
            VALUE1,
            #[doc = "The automatic update of bit WA is enabled."]
            VALUE2,
        }
        impl WAMDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAMDR::VALUE1 => false,
                    WAMDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAMDR {
                match value {
                    false => WAMDR::VALUE1,
                    true => WAMDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAMDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAMDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HPCMD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HPCMDR {
            #[doc = "The automatic update of bits SCTR.DSM and SCTR.HPCDIR is disabled."]
            VALUE1,
            #[doc = "The automatic update of bits SCTR.DSM and SCTR.HPCDIR is enabled."]
            VALUE2,
        }
        impl HPCMDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HPCMDR::VALUE1 => false,
                    HPCMDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HPCMDR {
                match value {
                    false => HPCMDR::VALUE1,
                    true => HPCMDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HPCMDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HPCMDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SOF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SOFR {
            #[doc = "The data word in TBUF is not considered as first word of a frame."]
            VALUE1,
            #[doc = "The data word in TBUF is considered as first word of a frame. A currently running frame is finished and MSLS becomes deactivated (respecting the programmed delays)."]
            VALUE2,
        }
        impl SOFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SOFR::VALUE1 => false,
                    SOFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SOFR {
                match value {
                    false => SOFR::VALUE1,
                    true => SOFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SOFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SOFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EOF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EOFR {
            #[doc = "The data word in TBUF is not considered as last word of an SSC frame."]
            VALUE1,
            #[doc = "The data word in TBUF is considered as last word of an SSC frame."]
            VALUE2,
        }
        impl EOFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EOFR::VALUE1 => false,
                    EOFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EOFR {
                match value {
                    false => EOFR::VALUE1,
                    true => EOFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EOFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EOFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TDV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TDVR {
            #[doc = "The data word in TBUF is not valid for transmission."]
            VALUE1,
            #[doc = "The data word in TBUF is valid for transmission and a transmission start is possible. New data should not be written to a TBUFx input location while TDV = 1."]
            VALUE2,
        }
        impl TDVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TDVR::VALUE1 => false,
                    TDVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TDVR {
                match value {
                    false => TDVR::VALUE1,
                    true => TDVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TDVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TDVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TDSSM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TDSSMR {
            #[doc = "The data word in TBUF is not considered as invalid after it has been loaded into the transmit shift register. The loading of the TBUF data into the shift register does not clear TDV."]
            VALUE1,
            #[doc = "The data word in TBUF is considered as invalid after it has been loaded into the shift register. In ASC and IIC mode, TDV is cleared with the TBI event, whereas in SSC and IIS mode, it is cleared with the RSI event. TDSSM = 1 has to be programmed if an optional data buffer is used."]
            VALUE2,
        }
        impl TDSSMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TDSSMR::VALUE1 => false,
                    TDSSMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TDSSMR {
                match value {
                    false => TDSSMR::VALUE1,
                    true => TDSSMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TDSSMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TDSSMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TDEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TDENR {
            #[doc = "A transmission start of the data word in TBUF is disabled. If a transmission is started, the passive data level is sent out."]
            VALUE1,
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1."]
            VALUE2,
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1 while DX2S = 0."]
            VALUE3,
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1 while DX2S = 1."]
            VALUE4,
        }
        impl TDENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TDENR::VALUE1 => 0,
                    TDENR::VALUE2 => 0x01,
                    TDENR::VALUE3 => 0x02,
                    TDENR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TDENR {
                match value {
                    0 => TDENR::VALUE1,
                    1 => TDENR::VALUE2,
                    2 => TDENR::VALUE3,
                    3 => TDENR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TDENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TDENR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TDENR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TDENR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TDVTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TDVTRR {
            #[doc = "Bit TCSR.TE is permanently set."]
            VALUE1,
            #[doc = "Bit TCSR.TE is set if DX2T becomes active while TDV = 1."]
            VALUE2,
        }
        impl TDVTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TDVTRR::VALUE1 => false,
                    TDVTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TDVTRR {
                match value {
                    false => TDVTRR::VALUE1,
                    true => TDVTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TDVTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TDVTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAR {
            #[doc = "The data word in TBUF will be transmitted after a falling edge of WA has been detected (referring to PSR.WA)."]
            VALUE1,
            #[doc = "The data word in TBUF will be transmitted after a rising edge of WA has been detected (referring to PSR.WA)."]
            VALUE2,
        }
        impl WAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAR::VALUE1 => false,
                    WAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAR {
                match value {
                    false => WAR::VALUE1,
                    true => WAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSOF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSOFR {
            #[doc = "The latest data word transmission has not been started for the first word of a data frame."]
            VALUE1,
            #[doc = "The latest data word transmission has been started for the first word of a data frame."]
            VALUE2,
        }
        impl TSOFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSOFR::VALUE1 => false,
                    TSOFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSOFR {
                match value {
                    false => TSOFR::VALUE1,
                    true => TSOFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSOFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSOFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TVR {
            #[doc = "The latest start of a data word transmission has taken place while no valid data was available. As a result, the transmission of a data words with passive level (SCTR.PDL) has been started."]
            VALUE1,
            #[doc = "The latest start of a data word transmission has taken place with valid data from TBUF."]
            VALUE2,
        }
        impl TVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TVR::VALUE1 => false,
                    TVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TVR {
                match value {
                    false => TVR::VALUE1,
                    true => TVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TVC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TVCR {
            #[doc = "Since TVC has been set, at least one data buffer underflow condition has occurred."]
            VALUE1,
            #[doc = "Since TVC has been set, no data buffer underflow condition has occurred."]
            VALUE2,
        }
        impl TVCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TVCR::VALUE1 => false,
                    TVCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TVCR {
                match value {
                    false => TVCR::VALUE1,
                    true => TVCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TVCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TVCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TER {
            #[doc = "The trigger event has not yet been detected. A transmission of the data word in TBUF can not be started."]
            VALUE1,
            #[doc = "The trigger event has been detected (or the trigger mechanism is switched off) and a transmission of the data word in TBUF can not be started."]
            VALUE2,
        }
        impl TER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TER::VALUE1 => false,
                    TER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TER {
                match value {
                    false => TER::VALUE1,
                    true => TER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WLEMD`"]
        pub enum WLEMDW {
            #[doc = "The automatic update of SCTR.WLE and TCSR.EOF is disabled."]
            VALUE1,
            #[doc = "The automatic update of SCTR.WLE and TCSR.EOF is enabled."]
            VALUE2,
        }
        impl WLEMDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WLEMDW::VALUE1 => false,
                    WLEMDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WLEMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WLEMDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WLEMDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The automatic update of SCTR.WLE and TCSR.EOF is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WLEMDW::VALUE1)
            }
            #[doc = "The automatic update of SCTR.WLE and TCSR.EOF is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WLEMDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELMD`"]
        pub enum SELMDW {
            #[doc = "The automatic update of PCR.CTR[23:16] is disabled."]
            VALUE1,
            #[doc = "The automatic update of PCR.CTR[23:16] is disabled."]
            VALUE2,
        }
        impl SELMDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELMDW::VALUE1 => false,
                    SELMDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELMDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELMDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The automatic update of PCR.CTR[23:16] is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELMDW::VALUE1)
            }
            #[doc = "The automatic update of PCR.CTR[23:16] is disabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELMDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLEMD`"]
        pub enum FLEMDW {
            #[doc = "The automatic update of FLE is disabled."]
            VALUE1,
            #[doc = "The automatic update of FLE is enabled."]
            VALUE2,
        }
        impl FLEMDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLEMDW::VALUE1 => false,
                    FLEMDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLEMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLEMDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLEMDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The automatic update of FLE is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLEMDW::VALUE1)
            }
            #[doc = "The automatic update of FLE is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLEMDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WAMD`"]
        pub enum WAMDW {
            #[doc = "The automatic update of bit WA is disabled."]
            VALUE1,
            #[doc = "The automatic update of bit WA is enabled."]
            VALUE2,
        }
        impl WAMDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAMDW::VALUE1 => false,
                    WAMDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAMDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAMDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The automatic update of bit WA is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAMDW::VALUE1)
            }
            #[doc = "The automatic update of bit WA is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAMDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HPCMD`"]
        pub enum HPCMDW {
            #[doc = "The automatic update of bits SCTR.DSM and SCTR.HPCDIR is disabled."]
            VALUE1,
            #[doc = "The automatic update of bits SCTR.DSM and SCTR.HPCDIR is enabled."]
            VALUE2,
        }
        impl HPCMDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HPCMDW::VALUE1 => false,
                    HPCMDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HPCMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HPCMDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HPCMDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The automatic update of bits SCTR.DSM and SCTR.HPCDIR is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HPCMDW::VALUE1)
            }
            #[doc = "The automatic update of bits SCTR.DSM and SCTR.HPCDIR is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HPCMDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SOF`"]
        pub enum SOFW {
            #[doc = "The data word in TBUF is not considered as first word of a frame."]
            VALUE1,
            #[doc = "The data word in TBUF is considered as first word of a frame. A currently running frame is finished and MSLS becomes deactivated (respecting the programmed delays)."]
            VALUE2,
        }
        impl SOFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SOFW::VALUE1 => false,
                    SOFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SOFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The data word in TBUF is not considered as first word of a frame."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SOFW::VALUE1)
            }
            #[doc = "The data word in TBUF is considered as first word of a frame. A currently running frame is finished and MSLS becomes deactivated (respecting the programmed delays)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SOFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EOF`"]
        pub enum EOFW {
            #[doc = "The data word in TBUF is not considered as last word of an SSC frame."]
            VALUE1,
            #[doc = "The data word in TBUF is considered as last word of an SSC frame."]
            VALUE2,
        }
        impl EOFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EOFW::VALUE1 => false,
                    EOFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EOFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EOFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EOFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The data word in TBUF is not considered as last word of an SSC frame."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EOFW::VALUE1)
            }
            #[doc = "The data word in TBUF is considered as last word of an SSC frame."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EOFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TDSSM`"]
        pub enum TDSSMW {
            #[doc = "The data word in TBUF is not considered as invalid after it has been loaded into the transmit shift register. The loading of the TBUF data into the shift register does not clear TDV."]
            VALUE1,
            #[doc = "The data word in TBUF is considered as invalid after it has been loaded into the shift register. In ASC and IIC mode, TDV is cleared with the TBI event, whereas in SSC and IIS mode, it is cleared with the RSI event. TDSSM = 1 has to be programmed if an optional data buffer is used."]
            VALUE2,
        }
        impl TDSSMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TDSSMW::VALUE1 => false,
                    TDSSMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TDSSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TDSSMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TDSSMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The data word in TBUF is not considered as invalid after it has been loaded into the transmit shift register. The loading of the TBUF data into the shift register does not clear TDV."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TDSSMW::VALUE1)
            }
            #[doc = "The data word in TBUF is considered as invalid after it has been loaded into the shift register. In ASC and IIC mode, TDV is cleared with the TBI event, whereas in SSC and IIS mode, it is cleared with the RSI event. TDSSM = 1 has to be programmed if an optional data buffer is used."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TDSSMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TDEN`"]
        pub enum TDENW {
            #[doc = "A transmission start of the data word in TBUF is disabled. If a transmission is started, the passive data level is sent out."]
            VALUE1,
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1."]
            VALUE2,
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1 while DX2S = 0."]
            VALUE3,
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1 while DX2S = 1."]
            VALUE4,
        }
        impl TDENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TDENW::VALUE1 => 0,
                    TDENW::VALUE2 => 1,
                    TDENW::VALUE3 => 2,
                    TDENW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TDENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TDENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TDENW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "A transmission start of the data word in TBUF is disabled. If a transmission is started, the passive data level is sent out."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TDENW::VALUE1)
            }
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TDENW::VALUE2)
            }
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1 while DX2S = 0."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TDENW::VALUE3)
            }
            #[doc = "A transmission of the data word in TBUF can be started if TDV = 1 while DX2S = 1."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TDENW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TDVTR`"]
        pub enum TDVTRW {
            #[doc = "Bit TCSR.TE is permanently set."]
            VALUE1,
            #[doc = "Bit TCSR.TE is set if DX2T becomes active while TDV = 1."]
            VALUE2,
        }
        impl TDVTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TDVTRW::VALUE1 => false,
                    TDVTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TDVTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TDVTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TDVTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Bit TCSR.TE is permanently set."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TDVTRW::VALUE1)
            }
            #[doc = "Bit TCSR.TE is set if DX2T becomes active while TDV = 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TDVTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WA`"]
        pub enum WAW {
            #[doc = "The data word in TBUF will be transmitted after a falling edge of WA has been detected (referring to PSR.WA)."]
            VALUE1,
            #[doc = "The data word in TBUF will be transmitted after a rising edge of WA has been detected (referring to PSR.WA)."]
            VALUE2,
        }
        impl WAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAW::VALUE1 => false,
                    WAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The data word in TBUF will be transmitted after a falling edge of WA has been detected (referring to PSR.WA)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAW::VALUE1)
            }
            #[doc = "The data word in TBUF will be transmitted after a rising edge of WA has been detected (referring to PSR.WA)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - WLE Mode"]
            #[inline]
            pub fn wlemd(&self) -> WLEMDR {
                WLEMDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Select Mode"]
            #[inline]
            pub fn selmd(&self) -> SELMDR {
                SELMDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - FLE Mode"]
            #[inline]
            pub fn flemd(&self) -> FLEMDR {
                FLEMDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - WA Mode"]
            #[inline]
            pub fn wamd(&self) -> WAMDR {
                WAMDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Hardware Port Control Mode"]
            #[inline]
            pub fn hpcmd(&self) -> HPCMDR {
                HPCMDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Start Of Frame"]
            #[inline]
            pub fn sof(&self) -> SOFR {
                SOFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - End Of Frame"]
            #[inline]
            pub fn eof(&self) -> EOFR {
                EOFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Transmit Data Valid"]
            #[inline]
            pub fn tdv(&self) -> TDVR {
                TDVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - TBUF Data Single Shot Mode"]
            #[inline]
            pub fn tdssm(&self) -> TDSSMR {
                TDSSMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - TBUF Data Enable"]
            #[inline]
            pub fn tden(&self) -> TDENR {
                TDENR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 12 - TBUF Data Valid Trigger"]
            #[inline]
            pub fn tdvtr(&self) -> TDVTRR {
                TDVTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Word Address"]
            #[inline]
            pub fn wa(&self) -> WAR {
                WAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Transmitted Start Of Frame"]
            #[inline]
            pub fn tsof(&self) -> TSOFR {
                TSOFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Transmission Valid"]
            #[inline]
            pub fn tv(&self) -> TVR {
                TVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - Transmission Valid Cumulated"]
            #[inline]
            pub fn tvc(&self) -> TVCR {
                TVCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - Trigger Event"]
            #[inline]
            pub fn te(&self) -> TER {
                TER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - WLE Mode"]
            #[inline]
            pub fn wlemd(&mut self) -> _WLEMDW {
                _WLEMDW { w: self }
            }
            #[doc = "Bit 1 - Select Mode"]
            #[inline]
            pub fn selmd(&mut self) -> _SELMDW {
                _SELMDW { w: self }
            }
            #[doc = "Bit 2 - FLE Mode"]
            #[inline]
            pub fn flemd(&mut self) -> _FLEMDW {
                _FLEMDW { w: self }
            }
            #[doc = "Bit 3 - WA Mode"]
            #[inline]
            pub fn wamd(&mut self) -> _WAMDW {
                _WAMDW { w: self }
            }
            #[doc = "Bit 4 - Hardware Port Control Mode"]
            #[inline]
            pub fn hpcmd(&mut self) -> _HPCMDW {
                _HPCMDW { w: self }
            }
            #[doc = "Bit 5 - Start Of Frame"]
            #[inline]
            pub fn sof(&mut self) -> _SOFW {
                _SOFW { w: self }
            }
            #[doc = "Bit 6 - End Of Frame"]
            #[inline]
            pub fn eof(&mut self) -> _EOFW {
                _EOFW { w: self }
            }
            #[doc = "Bit 8 - TBUF Data Single Shot Mode"]
            #[inline]
            pub fn tdssm(&mut self) -> _TDSSMW {
                _TDSSMW { w: self }
            }
            #[doc = "Bits 10:11 - TBUF Data Enable"]
            #[inline]
            pub fn tden(&mut self) -> _TDENW {
                _TDENW { w: self }
            }
            #[doc = "Bit 12 - TBUF Data Valid Trigger"]
            #[inline]
            pub fn tdvtr(&mut self) -> _TDVTRW {
                _TDVTRW { w: self }
            }
            #[doc = "Bit 13 - Word Address"]
            #[inline]
            pub fn wa(&mut self) -> _WAW {
                _WAW { w: self }
            }
        }
    }
    #[doc = "Protocol Control Register"]
    pub struct PCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Control Register"]
    pub mod pcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR0R {
            bits: bool,
        }
        impl CTR0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR1R {
            bits: bool,
        }
        impl CTR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR2R {
            bits: bool,
        }
        impl CTR2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR3R {
            bits: bool,
        }
        impl CTR3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR4R {
            bits: bool,
        }
        impl CTR4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR5R {
            bits: bool,
        }
        impl CTR5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR6R {
            bits: bool,
        }
        impl CTR6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR7R {
            bits: bool,
        }
        impl CTR7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR8R {
            bits: bool,
        }
        impl CTR8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR9R {
            bits: bool,
        }
        impl CTR9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR10R {
            bits: bool,
        }
        impl CTR10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR11R {
            bits: bool,
        }
        impl CTR11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR12R {
            bits: bool,
        }
        impl CTR12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR13R {
            bits: bool,
        }
        impl CTR13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR14R {
            bits: bool,
        }
        impl CTR14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR15R {
            bits: bool,
        }
        impl CTR15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR16R {
            bits: bool,
        }
        impl CTR16R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR17R {
            bits: bool,
        }
        impl CTR17R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR18R {
            bits: bool,
        }
        impl CTR18R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR19R {
            bits: bool,
        }
        impl CTR19R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR20R {
            bits: bool,
        }
        impl CTR20R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR21R {
            bits: bool,
        }
        impl CTR21R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR22R {
            bits: bool,
        }
        impl CTR22R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR23R {
            bits: bool,
        }
        impl CTR23R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR24R {
            bits: bool,
        }
        impl CTR24R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR25R {
            bits: bool,
        }
        impl CTR25R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR26R {
            bits: bool,
        }
        impl CTR26R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR27R {
            bits: bool,
        }
        impl CTR27R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR28R {
            bits: bool,
        }
        impl CTR28R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR29R {
            bits: bool,
        }
        impl CTR29R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR30R {
            bits: bool,
        }
        impl CTR30R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTR31R {
            bits: bool,
        }
        impl CTR31R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR16W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR16W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR17W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR17W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR18W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR18W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR19W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR19W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR20W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR20W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR21W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR21W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR22W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR22W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR23W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR23W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR24W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR24W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR25W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR25W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR26W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR26W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR27W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR27W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR28W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR28W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR29W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR29W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR30W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR30W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTR31W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTR31W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Protocol Control Bit 0"]
            #[inline]
            pub fn ctr0(&self) -> CTR0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR0R { bits }
            }
            #[doc = "Bit 1 - Protocol Control Bit 1"]
            #[inline]
            pub fn ctr1(&self) -> CTR1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR1R { bits }
            }
            #[doc = "Bit 2 - Protocol Control Bit 2"]
            #[inline]
            pub fn ctr2(&self) -> CTR2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR2R { bits }
            }
            #[doc = "Bit 3 - Protocol Control Bit 3"]
            #[inline]
            pub fn ctr3(&self) -> CTR3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR3R { bits }
            }
            #[doc = "Bit 4 - Protocol Control Bit 4"]
            #[inline]
            pub fn ctr4(&self) -> CTR4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR4R { bits }
            }
            #[doc = "Bit 5 - Protocol Control Bit 5"]
            #[inline]
            pub fn ctr5(&self) -> CTR5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR5R { bits }
            }
            #[doc = "Bit 6 - Protocol Control Bit 6"]
            #[inline]
            pub fn ctr6(&self) -> CTR6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR6R { bits }
            }
            #[doc = "Bit 7 - Protocol Control Bit 7"]
            #[inline]
            pub fn ctr7(&self) -> CTR7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR7R { bits }
            }
            #[doc = "Bit 8 - Protocol Control Bit 8"]
            #[inline]
            pub fn ctr8(&self) -> CTR8R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR8R { bits }
            }
            #[doc = "Bit 9 - Protocol Control Bit 9"]
            #[inline]
            pub fn ctr9(&self) -> CTR9R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR9R { bits }
            }
            #[doc = "Bit 10 - Protocol Control Bit 10"]
            #[inline]
            pub fn ctr10(&self) -> CTR10R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR10R { bits }
            }
            #[doc = "Bit 11 - Protocol Control Bit 11"]
            #[inline]
            pub fn ctr11(&self) -> CTR11R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR11R { bits }
            }
            #[doc = "Bit 12 - Protocol Control Bit 12"]
            #[inline]
            pub fn ctr12(&self) -> CTR12R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR12R { bits }
            }
            #[doc = "Bit 13 - Protocol Control Bit 13"]
            #[inline]
            pub fn ctr13(&self) -> CTR13R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR13R { bits }
            }
            #[doc = "Bit 14 - Protocol Control Bit 14"]
            #[inline]
            pub fn ctr14(&self) -> CTR14R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR14R { bits }
            }
            #[doc = "Bit 15 - Protocol Control Bit 15"]
            #[inline]
            pub fn ctr15(&self) -> CTR15R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR15R { bits }
            }
            #[doc = "Bit 16 - Protocol Control Bit 16"]
            #[inline]
            pub fn ctr16(&self) -> CTR16R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR16R { bits }
            }
            #[doc = "Bit 17 - Protocol Control Bit 17"]
            #[inline]
            pub fn ctr17(&self) -> CTR17R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR17R { bits }
            }
            #[doc = "Bit 18 - Protocol Control Bit 18"]
            #[inline]
            pub fn ctr18(&self) -> CTR18R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR18R { bits }
            }
            #[doc = "Bit 19 - Protocol Control Bit 19"]
            #[inline]
            pub fn ctr19(&self) -> CTR19R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR19R { bits }
            }
            #[doc = "Bit 20 - Protocol Control Bit 20"]
            #[inline]
            pub fn ctr20(&self) -> CTR20R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR20R { bits }
            }
            #[doc = "Bit 21 - Protocol Control Bit 21"]
            #[inline]
            pub fn ctr21(&self) -> CTR21R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR21R { bits }
            }
            #[doc = "Bit 22 - Protocol Control Bit 22"]
            #[inline]
            pub fn ctr22(&self) -> CTR22R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR22R { bits }
            }
            #[doc = "Bit 23 - Protocol Control Bit 23"]
            #[inline]
            pub fn ctr23(&self) -> CTR23R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR23R { bits }
            }
            #[doc = "Bit 24 - Protocol Control Bit 24"]
            #[inline]
            pub fn ctr24(&self) -> CTR24R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR24R { bits }
            }
            #[doc = "Bit 25 - Protocol Control Bit 25"]
            #[inline]
            pub fn ctr25(&self) -> CTR25R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR25R { bits }
            }
            #[doc = "Bit 26 - Protocol Control Bit 26"]
            #[inline]
            pub fn ctr26(&self) -> CTR26R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR26R { bits }
            }
            #[doc = "Bit 27 - Protocol Control Bit 27"]
            #[inline]
            pub fn ctr27(&self) -> CTR27R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR27R { bits }
            }
            #[doc = "Bit 28 - Protocol Control Bit 28"]
            #[inline]
            pub fn ctr28(&self) -> CTR28R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR28R { bits }
            }
            #[doc = "Bit 29 - Protocol Control Bit 29"]
            #[inline]
            pub fn ctr29(&self) -> CTR29R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR29R { bits }
            }
            #[doc = "Bit 30 - Protocol Control Bit 30"]
            #[inline]
            pub fn ctr30(&self) -> CTR30R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR30R { bits }
            }
            #[doc = "Bit 31 - Protocol Control Bit 31"]
            #[inline]
            pub fn ctr31(&self) -> CTR31R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CTR31R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Protocol Control Bit 0"]
            #[inline]
            pub fn ctr0(&mut self) -> _CTR0W {
                _CTR0W { w: self }
            }
            #[doc = "Bit 1 - Protocol Control Bit 1"]
            #[inline]
            pub fn ctr1(&mut self) -> _CTR1W {
                _CTR1W { w: self }
            }
            #[doc = "Bit 2 - Protocol Control Bit 2"]
            #[inline]
            pub fn ctr2(&mut self) -> _CTR2W {
                _CTR2W { w: self }
            }
            #[doc = "Bit 3 - Protocol Control Bit 3"]
            #[inline]
            pub fn ctr3(&mut self) -> _CTR3W {
                _CTR3W { w: self }
            }
            #[doc = "Bit 4 - Protocol Control Bit 4"]
            #[inline]
            pub fn ctr4(&mut self) -> _CTR4W {
                _CTR4W { w: self }
            }
            #[doc = "Bit 5 - Protocol Control Bit 5"]
            #[inline]
            pub fn ctr5(&mut self) -> _CTR5W {
                _CTR5W { w: self }
            }
            #[doc = "Bit 6 - Protocol Control Bit 6"]
            #[inline]
            pub fn ctr6(&mut self) -> _CTR6W {
                _CTR6W { w: self }
            }
            #[doc = "Bit 7 - Protocol Control Bit 7"]
            #[inline]
            pub fn ctr7(&mut self) -> _CTR7W {
                _CTR7W { w: self }
            }
            #[doc = "Bit 8 - Protocol Control Bit 8"]
            #[inline]
            pub fn ctr8(&mut self) -> _CTR8W {
                _CTR8W { w: self }
            }
            #[doc = "Bit 9 - Protocol Control Bit 9"]
            #[inline]
            pub fn ctr9(&mut self) -> _CTR9W {
                _CTR9W { w: self }
            }
            #[doc = "Bit 10 - Protocol Control Bit 10"]
            #[inline]
            pub fn ctr10(&mut self) -> _CTR10W {
                _CTR10W { w: self }
            }
            #[doc = "Bit 11 - Protocol Control Bit 11"]
            #[inline]
            pub fn ctr11(&mut self) -> _CTR11W {
                _CTR11W { w: self }
            }
            #[doc = "Bit 12 - Protocol Control Bit 12"]
            #[inline]
            pub fn ctr12(&mut self) -> _CTR12W {
                _CTR12W { w: self }
            }
            #[doc = "Bit 13 - Protocol Control Bit 13"]
            #[inline]
            pub fn ctr13(&mut self) -> _CTR13W {
                _CTR13W { w: self }
            }
            #[doc = "Bit 14 - Protocol Control Bit 14"]
            #[inline]
            pub fn ctr14(&mut self) -> _CTR14W {
                _CTR14W { w: self }
            }
            #[doc = "Bit 15 - Protocol Control Bit 15"]
            #[inline]
            pub fn ctr15(&mut self) -> _CTR15W {
                _CTR15W { w: self }
            }
            #[doc = "Bit 16 - Protocol Control Bit 16"]
            #[inline]
            pub fn ctr16(&mut self) -> _CTR16W {
                _CTR16W { w: self }
            }
            #[doc = "Bit 17 - Protocol Control Bit 17"]
            #[inline]
            pub fn ctr17(&mut self) -> _CTR17W {
                _CTR17W { w: self }
            }
            #[doc = "Bit 18 - Protocol Control Bit 18"]
            #[inline]
            pub fn ctr18(&mut self) -> _CTR18W {
                _CTR18W { w: self }
            }
            #[doc = "Bit 19 - Protocol Control Bit 19"]
            #[inline]
            pub fn ctr19(&mut self) -> _CTR19W {
                _CTR19W { w: self }
            }
            #[doc = "Bit 20 - Protocol Control Bit 20"]
            #[inline]
            pub fn ctr20(&mut self) -> _CTR20W {
                _CTR20W { w: self }
            }
            #[doc = "Bit 21 - Protocol Control Bit 21"]
            #[inline]
            pub fn ctr21(&mut self) -> _CTR21W {
                _CTR21W { w: self }
            }
            #[doc = "Bit 22 - Protocol Control Bit 22"]
            #[inline]
            pub fn ctr22(&mut self) -> _CTR22W {
                _CTR22W { w: self }
            }
            #[doc = "Bit 23 - Protocol Control Bit 23"]
            #[inline]
            pub fn ctr23(&mut self) -> _CTR23W {
                _CTR23W { w: self }
            }
            #[doc = "Bit 24 - Protocol Control Bit 24"]
            #[inline]
            pub fn ctr24(&mut self) -> _CTR24W {
                _CTR24W { w: self }
            }
            #[doc = "Bit 25 - Protocol Control Bit 25"]
            #[inline]
            pub fn ctr25(&mut self) -> _CTR25W {
                _CTR25W { w: self }
            }
            #[doc = "Bit 26 - Protocol Control Bit 26"]
            #[inline]
            pub fn ctr26(&mut self) -> _CTR26W {
                _CTR26W { w: self }
            }
            #[doc = "Bit 27 - Protocol Control Bit 27"]
            #[inline]
            pub fn ctr27(&mut self) -> _CTR27W {
                _CTR27W { w: self }
            }
            #[doc = "Bit 28 - Protocol Control Bit 28"]
            #[inline]
            pub fn ctr28(&mut self) -> _CTR28W {
                _CTR28W { w: self }
            }
            #[doc = "Bit 29 - Protocol Control Bit 29"]
            #[inline]
            pub fn ctr29(&mut self) -> _CTR29W {
                _CTR29W { w: self }
            }
            #[doc = "Bit 30 - Protocol Control Bit 30"]
            #[inline]
            pub fn ctr30(&mut self) -> _CTR30W {
                _CTR30W { w: self }
            }
            #[doc = "Bit 31 - Protocol Control Bit 31"]
            #[inline]
            pub fn ctr31(&mut self) -> _CTR31W {
                _CTR31W { w: self }
            }
        }
    }
    #[doc = "Protocol Control Register [ASC Mode]"]
    pub struct PCR_ASCMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Control Register [ASC Mode]"]
    pub mod pcr_ascmode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCR_ASCMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SMD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SMDR {
            #[doc = "Only one sample is taken per bit time. The current input value is sampled."]
            VALUE1,
            #[doc = "Three samples are taken per bit time and a majority decision is made."]
            VALUE2,
        }
        impl SMDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SMDR::VALUE1 => false,
                    SMDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SMDR {
                match value {
                    false => SMDR::VALUE1,
                    true => SMDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SMDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SMDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STPB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STPBR {
            #[doc = "The number of stop bits is 1."]
            VALUE1,
            #[doc = "The number of stop bits is 2."]
            VALUE2,
        }
        impl STPBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STPBR::VALUE1 => false,
                    STPBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STPBR {
                match value {
                    false => STPBR::VALUE1,
                    true => STPBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STPBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STPBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IDM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IDMR {
            #[doc = "The bus idle detection is switched off and bits PSR.TXIDLE and PSR.RXIDLE are set automatically to enable data transfers without checking the inputs before."]
            VALUE1,
            #[doc = "The bus is considered as idle after a number of consecutive passive bit times defined by SCTR.FLE plus 2 (in the case without parity bit) or plus 3 (in the case with parity bit)."]
            VALUE2,
        }
        impl IDMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IDMR::VALUE1 => false,
                    IDMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IDMR {
                match value {
                    false => IDMR::VALUE1,
                    true => IDMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IDMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IDMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SBIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SBIENR {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl SBIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SBIENR::VALUE1 => false,
                    SBIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SBIENR {
                match value {
                    false => SBIENR::VALUE1,
                    true => SBIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SBIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SBIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CDEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CDENR {
            #[doc = "The collision detection is disabled."]
            VALUE1,
            #[doc = "If a collision is detected, the transmitter stops its data transmission, outputs a 1, sets bit PSR.COL and generates a protocol interrupt. In order to allow data transmission again, PSR.COL has to be cleared by software."]
            VALUE2,
        }
        impl CDENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CDENR::VALUE1 => false,
                    CDENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CDENR {
                match value {
                    false => CDENR::VALUE1,
                    true => CDENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CDENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CDENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RNIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RNIENR {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl RNIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RNIENR::VALUE1 => false,
                    RNIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RNIENR {
                match value {
                    false => RNIENR::VALUE1,
                    true => RNIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RNIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RNIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FEIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FEIENR {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl FEIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FEIENR::VALUE1 => false,
                    FEIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FEIENR {
                match value {
                    false => FEIENR::VALUE1,
                    true => FEIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FEIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FEIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FFIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFIENR {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl FFIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFIENR::VALUE1 => false,
                    FFIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFIENR {
                match value {
                    false => FFIENR::VALUE1,
                    true => FFIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFIENR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPR {
            bits: u8,
        }
        impl SPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `PL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLR {
            #[doc = "The pulse length is equal to the bit length (no shortened 0)."]
            VALUE1,
            #[doc = "The pulse length of a 0 bit is 2 time quanta."]
            VALUE2,
            #[doc = "The pulse length of a 0 bit is 3 time quanta."]
            VALUE3,
            #[doc = "The pulse length of a 0 bit is 8 time quanta."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PLR::VALUE1 => 0,
                    PLR::VALUE2 => 0x01,
                    PLR::VALUE3 => 0x02,
                    PLR::VALUE4 => 0x07,
                    PLR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PLR {
                match value {
                    0 => PLR::VALUE1,
                    1 => PLR::VALUE2,
                    2 => PLR::VALUE3,
                    7 => PLR::VALUE4,
                    i => PLR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PLR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PLR::VALUE4
            }
        }
        #[doc = "Possible values of the field `RSTEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSTENR {
            #[doc = "Flag PSR[9] is not modified depending on the receiver status."]
            VALUE1,
            #[doc = "Flag PSR[9] is set during the complete reception of a frame."]
            VALUE2,
        }
        impl RSTENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSTENR::VALUE1 => false,
                    RSTENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSTENR {
                match value {
                    false => RSTENR::VALUE1,
                    true => RSTENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSTENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSTENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSTEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSTENR {
            #[doc = "Flag PSR[9] is not modified depending on the transmitter status."]
            VALUE1,
            #[doc = "Flag PSR[9] is set during the complete transmission of a frame."]
            VALUE2,
        }
        impl TSTENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSTENR::VALUE1 => false,
                    TSTENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSTENR {
                match value {
                    false => TSTENR::VALUE1,
                    true => TSTENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSTENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSTENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCLK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCLKR {
            #[doc = "The MCLK generation is disabled and the MCLK signal is 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCLKR::VALUE1 => false,
                    MCLKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCLKR {
                match value {
                    false => MCLKR::VALUE1,
                    true => MCLKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCLKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCLKR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SMD`"]
        pub enum SMDW {
            #[doc = "Only one sample is taken per bit time. The current input value is sampled."]
            VALUE1,
            #[doc = "Three samples are taken per bit time and a majority decision is made."]
            VALUE2,
        }
        impl SMDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SMDW::VALUE1 => false,
                    SMDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SMDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SMDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Only one sample is taken per bit time. The current input value is sampled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SMDW::VALUE1)
            }
            #[doc = "Three samples are taken per bit time and a majority decision is made."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SMDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STPB`"]
        pub enum STPBW {
            #[doc = "The number of stop bits is 1."]
            VALUE1,
            #[doc = "The number of stop bits is 2."]
            VALUE2,
        }
        impl STPBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STPBW::VALUE1 => false,
                    STPBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STPBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STPBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STPBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The number of stop bits is 1."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STPBW::VALUE1)
            }
            #[doc = "The number of stop bits is 2."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STPBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IDM`"]
        pub enum IDMW {
            #[doc = "The bus idle detection is switched off and bits PSR.TXIDLE and PSR.RXIDLE are set automatically to enable data transfers without checking the inputs before."]
            VALUE1,
            #[doc = "The bus is considered as idle after a number of consecutive passive bit times defined by SCTR.FLE plus 2 (in the case without parity bit) or plus 3 (in the case with parity bit)."]
            VALUE2,
        }
        impl IDMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IDMW::VALUE1 => false,
                    IDMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IDMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IDMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IDMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The bus idle detection is switched off and bits PSR.TXIDLE and PSR.RXIDLE are set automatically to enable data transfers without checking the inputs before."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IDMW::VALUE1)
            }
            #[doc = "The bus is considered as idle after a number of consecutive passive bit times defined by SCTR.FLE plus 2 (in the case without parity bit) or plus 3 (in the case with parity bit)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IDMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SBIEN`"]
        pub enum SBIENW {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl SBIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SBIENW::VALUE1 => false,
                    SBIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SBIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SBIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SBIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SBIENW::VALUE1)
            }
            #[doc = "The interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SBIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CDEN`"]
        pub enum CDENW {
            #[doc = "The collision detection is disabled."]
            VALUE1,
            #[doc = "If a collision is detected, the transmitter stops its data transmission, outputs a 1, sets bit PSR.COL and generates a protocol interrupt. In order to allow data transmission again, PSR.COL has to be cleared by software."]
            VALUE2,
        }
        impl CDENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CDENW::VALUE1 => false,
                    CDENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CDENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CDENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CDENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The collision detection is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CDENW::VALUE1)
            }
            #[doc = "If a collision is detected, the transmitter stops its data transmission, outputs a 1, sets bit PSR.COL and generates a protocol interrupt. In order to allow data transmission again, PSR.COL has to be cleared by software."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CDENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RNIEN`"]
        pub enum RNIENW {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl RNIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RNIENW::VALUE1 => false,
                    RNIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RNIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RNIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RNIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RNIENW::VALUE1)
            }
            #[doc = "The interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RNIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FEIEN`"]
        pub enum FEIENW {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl FEIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FEIENW::VALUE1 => false,
                    FEIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FEIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FEIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FEIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FEIENW::VALUE1)
            }
            #[doc = "The interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FEIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FFIEN`"]
        pub enum FFIENW {
            #[doc = "The interrupt generation is disabled."]
            VALUE1,
            #[doc = "The interrupt generation is enabled."]
            VALUE2,
        }
        impl FFIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FFIENW::VALUE1 => false,
                    FFIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FFIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FFIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FFIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FFIENW::VALUE1)
            }
            #[doc = "The interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FFIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PL`"]
        pub enum PLW {
            #[doc = "The pulse length is equal to the bit length (no shortened 0)."]
            VALUE1,
            #[doc = "The pulse length of a 0 bit is 2 time quanta."]
            VALUE2,
            #[doc = "The pulse length of a 0 bit is 3 time quanta."]
            VALUE3,
            #[doc = "The pulse length of a 0 bit is 8 time quanta."]
            VALUE4,
        }
        impl PLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PLW::VALUE1 => 0,
                    PLW::VALUE2 => 1,
                    PLW::VALUE3 => 2,
                    PLW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The pulse length is equal to the bit length (no shortened 0)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLW::VALUE1)
            }
            #[doc = "The pulse length of a 0 bit is 2 time quanta."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLW::VALUE2)
            }
            #[doc = "The pulse length of a 0 bit is 3 time quanta."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PLW::VALUE3)
            }
            #[doc = "The pulse length of a 0 bit is 8 time quanta."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PLW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSTEN`"]
        pub enum RSTENW {
            #[doc = "Flag PSR[9] is not modified depending on the receiver status."]
            VALUE1,
            #[doc = "Flag PSR[9] is set during the complete reception of a frame."]
            VALUE2,
        }
        impl RSTENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSTENW::VALUE1 => false,
                    RSTENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSTENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSTENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSTENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flag PSR[9] is not modified depending on the receiver status."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSTENW::VALUE1)
            }
            #[doc = "Flag PSR[9] is set during the complete reception of a frame."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSTENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSTEN`"]
        pub enum TSTENW {
            #[doc = "Flag PSR[9] is not modified depending on the transmitter status."]
            VALUE1,
            #[doc = "Flag PSR[9] is set during the complete transmission of a frame."]
            VALUE2,
        }
        impl TSTENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSTENW::VALUE1 => false,
                    TSTENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSTENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSTENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSTENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Flag PSR[9] is not modified depending on the transmitter status."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSTENW::VALUE1)
            }
            #[doc = "Flag PSR[9] is set during the complete transmission of a frame."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSTENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCLK`"]
        pub enum MCLKW {
            #[doc = "The MCLK generation is disabled and the MCLK signal is 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCLKW::VALUE1 => false,
                    MCLKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCLKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCLKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The MCLK generation is disabled and the MCLK signal is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCLKW::VALUE1)
            }
            #[doc = "The MCLK generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCLKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Sample Mode"]
            #[inline]
            pub fn smd(&self) -> SMDR {
                SMDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Stop Bits"]
            #[inline]
            pub fn stpb(&self) -> STPBR {
                STPBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Idle Detection Mode"]
            #[inline]
            pub fn idm(&self) -> IDMR {
                IDMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Synchronization Break Interrupt Enable"]
            #[inline]
            pub fn sbien(&self) -> SBIENR {
                SBIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Collision Detection Enable"]
            #[inline]
            pub fn cden(&self) -> CDENR {
                CDENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Receiver Noise Detection Interrupt Enable"]
            #[inline]
            pub fn rnien(&self) -> RNIENR {
                RNIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Format Error Interrupt Enable"]
            #[inline]
            pub fn feien(&self) -> FEIENR {
                FEIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Frame Finished Interrupt Enable"]
            #[inline]
            pub fn ffien(&self) -> FFIENR {
                FFIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 8:12 - Sample Point"]
            #[inline]
            pub fn sp(&self) -> SPR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SPR { bits }
            }
            #[doc = "Bits 13:15 - Pulse Length"]
            #[inline]
            pub fn pl(&self) -> PLR {
                PLR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Receiver Status Enable"]
            #[inline]
            pub fn rsten(&self) -> RSTENR {
                RSTENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Transmitter Status Enable"]
            #[inline]
            pub fn tsten(&self) -> TSTENR {
                TSTENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&self) -> MCLKR {
                MCLKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Sample Mode"]
            #[inline]
            pub fn smd(&mut self) -> _SMDW {
                _SMDW { w: self }
            }
            #[doc = "Bit 1 - Stop Bits"]
            #[inline]
            pub fn stpb(&mut self) -> _STPBW {
                _STPBW { w: self }
            }
            #[doc = "Bit 2 - Idle Detection Mode"]
            #[inline]
            pub fn idm(&mut self) -> _IDMW {
                _IDMW { w: self }
            }
            #[doc = "Bit 3 - Synchronization Break Interrupt Enable"]
            #[inline]
            pub fn sbien(&mut self) -> _SBIENW {
                _SBIENW { w: self }
            }
            #[doc = "Bit 4 - Collision Detection Enable"]
            #[inline]
            pub fn cden(&mut self) -> _CDENW {
                _CDENW { w: self }
            }
            #[doc = "Bit 5 - Receiver Noise Detection Interrupt Enable"]
            #[inline]
            pub fn rnien(&mut self) -> _RNIENW {
                _RNIENW { w: self }
            }
            #[doc = "Bit 6 - Format Error Interrupt Enable"]
            #[inline]
            pub fn feien(&mut self) -> _FEIENW {
                _FEIENW { w: self }
            }
            #[doc = "Bit 7 - Frame Finished Interrupt Enable"]
            #[inline]
            pub fn ffien(&mut self) -> _FFIENW {
                _FFIENW { w: self }
            }
            #[doc = "Bits 8:12 - Sample Point"]
            #[inline]
            pub fn sp(&mut self) -> _SPW {
                _SPW { w: self }
            }
            #[doc = "Bits 13:15 - Pulse Length"]
            #[inline]
            pub fn pl(&mut self) -> _PLW {
                _PLW { w: self }
            }
            #[doc = "Bit 16 - Receiver Status Enable"]
            #[inline]
            pub fn rsten(&mut self) -> _RSTENW {
                _RSTENW { w: self }
            }
            #[doc = "Bit 17 - Transmitter Status Enable"]
            #[inline]
            pub fn tsten(&mut self) -> _TSTENW {
                _TSTENW { w: self }
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&mut self) -> _MCLKW {
                _MCLKW { w: self }
            }
        }
    }
    #[doc = "Protocol Control Register [SSC Mode]"]
    pub struct PCR_SSCMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Control Register [SSC Mode]"]
    pub mod pcr_sscmode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCR_SSCMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MSLSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSLSENR {
            #[doc = "The MSLS generation is disabled (MSLS = 0). This is the setting for SSC slave mode."]
            VALUE1,
            #[doc = "The MSLS generation is enabled. This is the setting for SSC master mode."]
            VALUE2,
        }
        impl MSLSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSLSENR::VALUE1 => false,
                    MSLSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSLSENR {
                match value {
                    false => MSLSENR::VALUE1,
                    true => MSLSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSLSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSLSENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELCTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELCTRR {
            #[doc = "The coded select mode is enabled."]
            VALUE1,
            #[doc = "The direct select mode is enabled."]
            VALUE2,
        }
        impl SELCTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELCTRR::VALUE1 => false,
                    SELCTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELCTRR {
                match value {
                    false => SELCTRR::VALUE1,
                    true => SELCTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELCTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELCTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELINV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELINVR {
            #[doc = "The SELO outputs have the same polarity as the MSLS signal (active high)."]
            VALUE1,
            #[doc = "The SELO outputs have the inverted polarity to the MSLS signal (active low)."]
            VALUE2,
        }
        impl SELINVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELINVR::VALUE1 => false,
                    SELINVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELINVR {
                match value {
                    false => SELINVR::VALUE1,
                    true => SELINVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELINVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELINVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FEM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FEMR {
            #[doc = "The current data frame is considered as finished when the last bit of a data word has been sent out and the transmit buffer TBUF does not contain new data (TDV = 0)."]
            VALUE1,
            #[doc = "The MSLS signal is kept active also while no new data is available and no other end of frame condition is reached. In this case, the software can accept delays in delivering the data without automatic deactivation of MSLS in multi-word data frames."]
            VALUE2,
        }
        impl FEMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FEMR::VALUE1 => false,
                    FEMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FEMR {
                match value {
                    false => FEMR::VALUE1,
                    true => FEMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FEMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FEMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CTQSEL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CTQSEL1R {
            #[doc = "fCTQIN = fPDIV"]
            VALUE1,
            #[doc = "fCTQIN = fPPP"]
            VALUE2,
            #[doc = "fCTQIN = fSCLK"]
            VALUE3,
            #[doc = "fCTQIN = fMCLK"]
            VALUE4,
        }
        impl CTQSEL1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CTQSEL1R::VALUE1 => 0,
                    CTQSEL1R::VALUE2 => 0x01,
                    CTQSEL1R::VALUE3 => 0x02,
                    CTQSEL1R::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CTQSEL1R {
                match value {
                    0 => CTQSEL1R::VALUE1,
                    1 => CTQSEL1R::VALUE2,
                    2 => CTQSEL1R::VALUE3,
                    3 => CTQSEL1R::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CTQSEL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CTQSEL1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CTQSEL1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CTQSEL1R::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCTQ1R {
            bits: u8,
        }
        impl PCTQ1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCTQ1R {
            bits: u8,
        }
        impl DCTQ1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `PARIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PARIENR {
            #[doc = "A protocol interrupt is not generated with the detection of a parity error."]
            VALUE1,
            #[doc = "A protocol interrupt is generated with the detection of a parity error."]
            VALUE2,
        }
        impl PARIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PARIENR::VALUE1 => false,
                    PARIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PARIENR {
                match value {
                    false => PARIENR::VALUE1,
                    true => PARIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PARIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PARIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSLSIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSLSIENR {
            #[doc = "A protocol interrupt is not generated if a change of signal MSLS is detected."]
            VALUE1,
            #[doc = "A protocol interrupt is generated if a change of signal MSLS is detected."]
            VALUE2,
        }
        impl MSLSIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSLSIENR::VALUE1 => false,
                    MSLSIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSLSIENR {
                match value {
                    false => MSLSIENR::VALUE1,
                    true => MSLSIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSLSIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSLSIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DX2TIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DX2TIENR {
            #[doc = "A protocol interrupt is not generated if DX2T is activated."]
            VALUE1,
            #[doc = "A protocol interrupt is generated if DX2T is activated."]
            VALUE2,
        }
        impl DX2TIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DX2TIENR::VALUE1 => false,
                    DX2TIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DX2TIENR {
                match value {
                    false => DX2TIENR::VALUE1,
                    true => DX2TIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DX2TIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DX2TIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELO`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELOR {
            #[doc = "The corresponding SELOx line cannot be activated."]
            VALUE1,
            #[doc = "The corresponding SELOx line can be activated (according to the mode selected by SELCTR)."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SELOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SELOR::VALUE1 => 0,
                    SELOR::VALUE2 => 0x01,
                    SELOR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SELOR {
                match value {
                    0 => SELOR::VALUE1,
                    1 => SELOR::VALUE2,
                    i => SELOR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELOR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELOR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TIWEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TIWENR {
            #[doc = "No delay between data words of the same frame."]
            VALUE1,
            #[doc = "The inter-word delay Tiw is enabled and introduced between data words of the same frame."]
            VALUE2,
        }
        impl TIWENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TIWENR::VALUE1 => false,
                    TIWENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TIWENR {
                match value {
                    false => TIWENR::VALUE1,
                    true => TIWENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TIWENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TIWENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SLPHSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SLPHSELR {
            #[doc = "Data bits are shifted out with the leading edge of the shift clock signal and latched in with the trailing edge."]
            VALUE1,
            #[doc = "The first data bit is shifted out when the data shift unit receives a low to high transition from the DX2 stage. Subsequent bits are shifted out with the trailing edge of the shift clock signal. Data bits are always latched in with the leading edge."]
            VALUE2,
        }
        impl SLPHSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SLPHSELR::VALUE1 => false,
                    SLPHSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SLPHSELR {
                match value {
                    false => SLPHSELR::VALUE1,
                    true => SLPHSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SLPHSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SLPHSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCLK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCLKR {
            #[doc = "The MCLK generation is disabled and output MCLK = 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCLKR::VALUE1 => false,
                    MCLKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCLKR {
                match value {
                    false => MCLKR::VALUE1,
                    true => MCLKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCLKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCLKR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `MSLSEN`"]
        pub enum MSLSENW {
            #[doc = "The MSLS generation is disabled (MSLS = 0). This is the setting for SSC slave mode."]
            VALUE1,
            #[doc = "The MSLS generation is enabled. This is the setting for SSC master mode."]
            VALUE2,
        }
        impl MSLSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSLSENW::VALUE1 => false,
                    MSLSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSLSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSLSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSLSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The MSLS generation is disabled (MSLS = 0). This is the setting for SSC slave mode."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSLSENW::VALUE1)
            }
            #[doc = "The MSLS generation is enabled. This is the setting for SSC master mode."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSLSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELCTR`"]
        pub enum SELCTRW {
            #[doc = "The coded select mode is enabled."]
            VALUE1,
            #[doc = "The direct select mode is enabled."]
            VALUE2,
        }
        impl SELCTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELCTRW::VALUE1 => false,
                    SELCTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELCTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELCTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELCTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The coded select mode is enabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELCTRW::VALUE1)
            }
            #[doc = "The direct select mode is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELCTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELINV`"]
        pub enum SELINVW {
            #[doc = "The SELO outputs have the same polarity as the MSLS signal (active high)."]
            VALUE1,
            #[doc = "The SELO outputs have the inverted polarity to the MSLS signal (active low)."]
            VALUE2,
        }
        impl SELINVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELINVW::VALUE1 => false,
                    SELINVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELINVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELINVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELINVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The SELO outputs have the same polarity as the MSLS signal (active high)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELINVW::VALUE1)
            }
            #[doc = "The SELO outputs have the inverted polarity to the MSLS signal (active low)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELINVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FEM`"]
        pub enum FEMW {
            #[doc = "The current data frame is considered as finished when the last bit of a data word has been sent out and the transmit buffer TBUF does not contain new data (TDV = 0)."]
            VALUE1,
            #[doc = "The MSLS signal is kept active also while no new data is available and no other end of frame condition is reached. In this case, the software can accept delays in delivering the data without automatic deactivation of MSLS in multi-word data frames."]
            VALUE2,
        }
        impl FEMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FEMW::VALUE1 => false,
                    FEMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FEMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FEMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FEMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The current data frame is considered as finished when the last bit of a data word has been sent out and the transmit buffer TBUF does not contain new data (TDV = 0)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FEMW::VALUE1)
            }
            #[doc = "The MSLS signal is kept active also while no new data is available and no other end of frame condition is reached. In this case, the software can accept delays in delivering the data without automatic deactivation of MSLS in multi-word data frames."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FEMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTQSEL1`"]
        pub enum CTQSEL1W {
            #[doc = "fCTQIN = fPDIV"]
            VALUE1,
            #[doc = "fCTQIN = fPPP"]
            VALUE2,
            #[doc = "fCTQIN = fSCLK"]
            VALUE3,
            #[doc = "fCTQIN = fMCLK"]
            VALUE4,
        }
        impl CTQSEL1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CTQSEL1W::VALUE1 => 0,
                    CTQSEL1W::VALUE2 => 1,
                    CTQSEL1W::VALUE3 => 2,
                    CTQSEL1W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTQSEL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTQSEL1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTQSEL1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "fCTQIN = fPDIV"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTQSEL1W::VALUE1)
            }
            #[doc = "fCTQIN = fPPP"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTQSEL1W::VALUE2)
            }
            #[doc = "fCTQIN = fSCLK"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CTQSEL1W::VALUE3)
            }
            #[doc = "fCTQIN = fMCLK"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CTQSEL1W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCTQ1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCTQ1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCTQ1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCTQ1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PARIEN`"]
        pub enum PARIENW {
            #[doc = "A protocol interrupt is not generated with the detection of a parity error."]
            VALUE1,
            #[doc = "A protocol interrupt is generated with the detection of a parity error."]
            VALUE2,
        }
        impl PARIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PARIENW::VALUE1 => false,
                    PARIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PARIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PARIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PARIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not generated with the detection of a parity error."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PARIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is generated with the detection of a parity error."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PARIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSLSIEN`"]
        pub enum MSLSIENW {
            #[doc = "A protocol interrupt is not generated if a change of signal MSLS is detected."]
            VALUE1,
            #[doc = "A protocol interrupt is generated if a change of signal MSLS is detected."]
            VALUE2,
        }
        impl MSLSIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSLSIENW::VALUE1 => false,
                    MSLSIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSLSIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSLSIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSLSIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not generated if a change of signal MSLS is detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSLSIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is generated if a change of signal MSLS is detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSLSIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DX2TIEN`"]
        pub enum DX2TIENW {
            #[doc = "A protocol interrupt is not generated if DX2T is activated."]
            VALUE1,
            #[doc = "A protocol interrupt is generated if DX2T is activated."]
            VALUE2,
        }
        impl DX2TIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DX2TIENW::VALUE1 => false,
                    DX2TIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DX2TIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DX2TIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DX2TIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not generated if DX2T is activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DX2TIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is generated if DX2T is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DX2TIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELO`"]
        pub enum SELOW {
            #[doc = "The corresponding SELOx line cannot be activated."]
            VALUE1,
            #[doc = "The corresponding SELOx line can be activated (according to the mode selected by SELCTR)."]
            VALUE2,
        }
        impl SELOW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SELOW::VALUE1 => 0,
                    SELOW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELOW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELOW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The corresponding SELOx line cannot be activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELOW::VALUE1)
            }
            #[doc = "The corresponding SELOx line can be activated (according to the mode selected by SELCTR)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELOW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TIWEN`"]
        pub enum TIWENW {
            #[doc = "No delay between data words of the same frame."]
            VALUE1,
            #[doc = "The inter-word delay Tiw is enabled and introduced between data words of the same frame."]
            VALUE2,
        }
        impl TIWENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TIWENW::VALUE1 => false,
                    TIWENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TIWENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TIWENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TIWENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No delay between data words of the same frame."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TIWENW::VALUE1)
            }
            #[doc = "The inter-word delay Tiw is enabled and introduced between data words of the same frame."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TIWENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SLPHSEL`"]
        pub enum SLPHSELW {
            #[doc = "Data bits are shifted out with the leading edge of the shift clock signal and latched in with the trailing edge."]
            VALUE1,
            #[doc = "The first data bit is shifted out when the data shift unit receives a low to high transition from the DX2 stage. Subsequent bits are shifted out with the trailing edge of the shift clock signal. Data bits are always latched in with the leading edge."]
            VALUE2,
        }
        impl SLPHSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SLPHSELW::VALUE1 => false,
                    SLPHSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLPHSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLPHSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SLPHSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Data bits are shifted out with the leading edge of the shift clock signal and latched in with the trailing edge."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SLPHSELW::VALUE1)
            }
            #[doc = "The first data bit is shifted out when the data shift unit receives a low to high transition from the DX2 stage. Subsequent bits are shifted out with the trailing edge of the shift clock signal. Data bits are always latched in with the leading edge."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SLPHSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCLK`"]
        pub enum MCLKW {
            #[doc = "The MCLK generation is disabled and output MCLK = 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCLKW::VALUE1 => false,
                    MCLKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCLKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCLKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The MCLK generation is disabled and output MCLK = 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCLKW::VALUE1)
            }
            #[doc = "The MCLK generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCLKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - MSLS Enable"]
            #[inline]
            pub fn mslsen(&self) -> MSLSENR {
                MSLSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Select Control"]
            #[inline]
            pub fn selctr(&self) -> SELCTRR {
                SELCTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Select Inversion"]
            #[inline]
            pub fn selinv(&self) -> SELINVR {
                SELINVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Frame End Mode"]
            #[inline]
            pub fn fem(&self) -> FEMR {
                FEMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:5 - Input Frequency Selection"]
            #[inline]
            pub fn ctqsel1(&self) -> CTQSEL1R {
                CTQSEL1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Divider Factor PCTQ1 for Tiw and Tnf"]
            #[inline]
            pub fn pctq1(&self) -> PCTQ1R {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCTQ1R { bits }
            }
            #[doc = "Bits 8:12 - Divider Factor DCTQ1 for Tiw and Tnf"]
            #[inline]
            pub fn dctq1(&self) -> DCTQ1R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCTQ1R { bits }
            }
            #[doc = "Bit 13 - Parity Error Interrupt Enable"]
            #[inline]
            pub fn parien(&self) -> PARIENR {
                PARIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - MSLS Interrupt Enable"]
            #[inline]
            pub fn mslsien(&self) -> MSLSIENR {
                MSLSIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - DX2T Interrupt Enable"]
            #[inline]
            pub fn dx2tien(&self) -> DX2TIENR {
                DX2TIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:23 - Select Output"]
            #[inline]
            pub fn selo(&self) -> SELOR {
                SELOR::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 24 - Enable Inter-Word Delay Tiw"]
            #[inline]
            pub fn tiwen(&self) -> TIWENR {
                TIWENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Slave Mode Clock Phase Select"]
            #[inline]
            pub fn slphsel(&self) -> SLPHSELR {
                SLPHSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&self) -> MCLKR {
                MCLKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - MSLS Enable"]
            #[inline]
            pub fn mslsen(&mut self) -> _MSLSENW {
                _MSLSENW { w: self }
            }
            #[doc = "Bit 1 - Select Control"]
            #[inline]
            pub fn selctr(&mut self) -> _SELCTRW {
                _SELCTRW { w: self }
            }
            #[doc = "Bit 2 - Select Inversion"]
            #[inline]
            pub fn selinv(&mut self) -> _SELINVW {
                _SELINVW { w: self }
            }
            #[doc = "Bit 3 - Frame End Mode"]
            #[inline]
            pub fn fem(&mut self) -> _FEMW {
                _FEMW { w: self }
            }
            #[doc = "Bits 4:5 - Input Frequency Selection"]
            #[inline]
            pub fn ctqsel1(&mut self) -> _CTQSEL1W {
                _CTQSEL1W { w: self }
            }
            #[doc = "Bits 6:7 - Divider Factor PCTQ1 for Tiw and Tnf"]
            #[inline]
            pub fn pctq1(&mut self) -> _PCTQ1W {
                _PCTQ1W { w: self }
            }
            #[doc = "Bits 8:12 - Divider Factor DCTQ1 for Tiw and Tnf"]
            #[inline]
            pub fn dctq1(&mut self) -> _DCTQ1W {
                _DCTQ1W { w: self }
            }
            #[doc = "Bit 13 - Parity Error Interrupt Enable"]
            #[inline]
            pub fn parien(&mut self) -> _PARIENW {
                _PARIENW { w: self }
            }
            #[doc = "Bit 14 - MSLS Interrupt Enable"]
            #[inline]
            pub fn mslsien(&mut self) -> _MSLSIENW {
                _MSLSIENW { w: self }
            }
            #[doc = "Bit 15 - DX2T Interrupt Enable"]
            #[inline]
            pub fn dx2tien(&mut self) -> _DX2TIENW {
                _DX2TIENW { w: self }
            }
            #[doc = "Bits 16:23 - Select Output"]
            #[inline]
            pub fn selo(&mut self) -> _SELOW {
                _SELOW { w: self }
            }
            #[doc = "Bit 24 - Enable Inter-Word Delay Tiw"]
            #[inline]
            pub fn tiwen(&mut self) -> _TIWENW {
                _TIWENW { w: self }
            }
            #[doc = "Bit 25 - Slave Mode Clock Phase Select"]
            #[inline]
            pub fn slphsel(&mut self) -> _SLPHSELW {
                _SLPHSELW { w: self }
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&mut self) -> _MCLKW {
                _MCLKW { w: self }
            }
        }
    }
    #[doc = "Protocol Control Register [IIC Mode]"]
    pub struct PCR_IICMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Control Register [IIC Mode]"]
    pub mod pcr_iicmode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCR_IICMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SLADR {
            bits: u16,
        }
        impl SLADR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ACK00`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACK00R {
            #[doc = "The slave device is not sensitive to this address."]
            VALUE1,
            #[doc = "The slave device is sensitive to this address."]
            VALUE2,
        }
        impl ACK00R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ACK00R::VALUE1 => false,
                    ACK00R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ACK00R {
                match value {
                    false => ACK00R::VALUE1,
                    true => ACK00R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACK00R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACK00R::VALUE2
            }
        }
        #[doc = "Possible values of the field `STIM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STIMR {
            #[doc = "A symbol contains 10 time quanta. The timing is adapted for standard mode (100 kBaud)."]
            VALUE1,
            #[doc = "A symbol contains 25 time quanta. The timing is adapted for fast mode (400 kBaud)."]
            VALUE2,
        }
        impl STIMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STIMR::VALUE1 => false,
                    STIMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STIMR {
                match value {
                    false => STIMR::VALUE1,
                    true => STIMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STIMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STIMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCRIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCRIENR {
            #[doc = "The start condition interrupt is disabled."]
            VALUE1,
            #[doc = "The start condition interrupt is enabled."]
            VALUE2,
        }
        impl SCRIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCRIENR::VALUE1 => false,
                    SCRIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCRIENR {
                match value {
                    false => SCRIENR::VALUE1,
                    true => SCRIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCRIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCRIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RSCRIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSCRIENR {
            #[doc = "The repeated start condition interrupt is disabled."]
            VALUE1,
            #[doc = "The repeated start condition interrupt is enabled."]
            VALUE2,
        }
        impl RSCRIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSCRIENR::VALUE1 => false,
                    RSCRIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSCRIENR {
                match value {
                    false => RSCRIENR::VALUE1,
                    true => RSCRIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSCRIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSCRIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PCRIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCRIENR {
            #[doc = "The stop condition interrupt is disabled."]
            VALUE1,
            #[doc = "The stop condition interrupt is enabled."]
            VALUE2,
        }
        impl PCRIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PCRIENR::VALUE1 => false,
                    PCRIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PCRIENR {
                match value {
                    false => PCRIENR::VALUE1,
                    true => PCRIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCRIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCRIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NACKIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NACKIENR {
            #[doc = "The non-acknowledge interrupt is disabled."]
            VALUE1,
            #[doc = "The non-acknowledge interrupt is enabled."]
            VALUE2,
        }
        impl NACKIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NACKIENR::VALUE1 => false,
                    NACKIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NACKIENR {
                match value {
                    false => NACKIENR::VALUE1,
                    true => NACKIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NACKIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NACKIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ARLIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARLIENR {
            #[doc = "The arbitration lost interrupt is disabled."]
            VALUE1,
            #[doc = "The arbitration lost interrupt is enabled."]
            VALUE2,
        }
        impl ARLIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ARLIENR::VALUE1 => false,
                    ARLIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ARLIENR {
                match value {
                    false => ARLIENR::VALUE1,
                    true => ARLIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARLIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARLIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRRIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRRIENR {
            #[doc = "The slave read request interrupt is disabled."]
            VALUE1,
            #[doc = "The slave read request interrupt is enabled."]
            VALUE2,
        }
        impl SRRIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRRIENR::VALUE1 => false,
                    SRRIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRRIENR {
                match value {
                    false => SRRIENR::VALUE1,
                    true => SRRIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRRIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRRIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERRIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERRIENR {
            #[doc = "The error interrupt is disabled."]
            VALUE1,
            #[doc = "The error interrupt is enabled."]
            VALUE2,
        }
        impl ERRIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERRIENR::VALUE1 => false,
                    ERRIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERRIENR {
                match value {
                    false => ERRIENR::VALUE1,
                    true => ERRIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERRIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERRIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SACKDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SACKDISR {
            #[doc = "The generation of an active slave acknowledge is enabled (slave acknowledge with 0 level = more bytes can be received)."]
            VALUE1,
            #[doc = "The generation of an active slave acknowledge is disabled (slave acknowledge with 1 level = reception stopped)."]
            VALUE2,
        }
        impl SACKDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SACKDISR::VALUE1 => false,
                    SACKDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SACKDISR {
                match value {
                    false => SACKDISR::VALUE1,
                    true => SACKDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SACKDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SACKDISR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct HDELR {
            bits: u8,
        }
        impl HDELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ACKIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACKIENR {
            #[doc = "The acknowledge interrupt is disabled."]
            VALUE1,
            #[doc = "The acknowledge interrupt is enabled."]
            VALUE2,
        }
        impl ACKIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ACKIENR::VALUE1 => false,
                    ACKIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ACKIENR {
                match value {
                    false => ACKIENR::VALUE1,
                    true => ACKIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACKIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACKIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCLK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCLKR {
            #[doc = "The MCLK generation is disabled and MCLK is 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCLKR::VALUE1 => false,
                    MCLKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCLKR {
                match value {
                    false => MCLKR::VALUE1,
                    true => MCLKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCLKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCLKR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLADW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLADW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ACK00`"]
        pub enum ACK00W {
            #[doc = "The slave device is not sensitive to this address."]
            VALUE1,
            #[doc = "The slave device is sensitive to this address."]
            VALUE2,
        }
        impl ACK00W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ACK00W::VALUE1 => false,
                    ACK00W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACK00W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACK00W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACK00W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The slave device is not sensitive to this address."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACK00W::VALUE1)
            }
            #[doc = "The slave device is sensitive to this address."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACK00W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STIM`"]
        pub enum STIMW {
            #[doc = "A symbol contains 10 time quanta. The timing is adapted for standard mode (100 kBaud)."]
            VALUE1,
            #[doc = "A symbol contains 25 time quanta. The timing is adapted for fast mode (400 kBaud)."]
            VALUE2,
        }
        impl STIMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STIMW::VALUE1 => false,
                    STIMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STIMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STIMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A symbol contains 10 time quanta. The timing is adapted for standard mode (100 kBaud)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STIMW::VALUE1)
            }
            #[doc = "A symbol contains 25 time quanta. The timing is adapted for fast mode (400 kBaud)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STIMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCRIEN`"]
        pub enum SCRIENW {
            #[doc = "The start condition interrupt is disabled."]
            VALUE1,
            #[doc = "The start condition interrupt is enabled."]
            VALUE2,
        }
        impl SCRIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCRIENW::VALUE1 => false,
                    SCRIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCRIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCRIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCRIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The start condition interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCRIENW::VALUE1)
            }
            #[doc = "The start condition interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCRIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSCRIEN`"]
        pub enum RSCRIENW {
            #[doc = "The repeated start condition interrupt is disabled."]
            VALUE1,
            #[doc = "The repeated start condition interrupt is enabled."]
            VALUE2,
        }
        impl RSCRIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSCRIENW::VALUE1 => false,
                    RSCRIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSCRIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSCRIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSCRIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The repeated start condition interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSCRIENW::VALUE1)
            }
            #[doc = "The repeated start condition interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSCRIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCRIEN`"]
        pub enum PCRIENW {
            #[doc = "The stop condition interrupt is disabled."]
            VALUE1,
            #[doc = "The stop condition interrupt is enabled."]
            VALUE2,
        }
        impl PCRIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PCRIENW::VALUE1 => false,
                    PCRIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCRIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCRIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCRIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The stop condition interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCRIENW::VALUE1)
            }
            #[doc = "The stop condition interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCRIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NACKIEN`"]
        pub enum NACKIENW {
            #[doc = "The non-acknowledge interrupt is disabled."]
            VALUE1,
            #[doc = "The non-acknowledge interrupt is enabled."]
            VALUE2,
        }
        impl NACKIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NACKIENW::VALUE1 => false,
                    NACKIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NACKIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NACKIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NACKIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The non-acknowledge interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NACKIENW::VALUE1)
            }
            #[doc = "The non-acknowledge interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NACKIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARLIEN`"]
        pub enum ARLIENW {
            #[doc = "The arbitration lost interrupt is disabled."]
            VALUE1,
            #[doc = "The arbitration lost interrupt is enabled."]
            VALUE2,
        }
        impl ARLIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ARLIENW::VALUE1 => false,
                    ARLIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARLIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARLIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARLIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The arbitration lost interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARLIENW::VALUE1)
            }
            #[doc = "The arbitration lost interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARLIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRRIEN`"]
        pub enum SRRIENW {
            #[doc = "The slave read request interrupt is disabled."]
            VALUE1,
            #[doc = "The slave read request interrupt is enabled."]
            VALUE2,
        }
        impl SRRIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRRIENW::VALUE1 => false,
                    SRRIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRRIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRRIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRRIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The slave read request interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRRIENW::VALUE1)
            }
            #[doc = "The slave read request interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRRIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERRIEN`"]
        pub enum ERRIENW {
            #[doc = "The error interrupt is disabled."]
            VALUE1,
            #[doc = "The error interrupt is enabled."]
            VALUE2,
        }
        impl ERRIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERRIENW::VALUE1 => false,
                    ERRIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERRIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERRIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERRIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The error interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERRIENW::VALUE1)
            }
            #[doc = "The error interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERRIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SACKDIS`"]
        pub enum SACKDISW {
            #[doc = "The generation of an active slave acknowledge is enabled (slave acknowledge with 0 level = more bytes can be received)."]
            VALUE1,
            #[doc = "The generation of an active slave acknowledge is disabled (slave acknowledge with 1 level = reception stopped)."]
            VALUE2,
        }
        impl SACKDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SACKDISW::VALUE1 => false,
                    SACKDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SACKDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SACKDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SACKDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The generation of an active slave acknowledge is enabled (slave acknowledge with 0 level = more bytes can be received)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SACKDISW::VALUE1)
            }
            #[doc = "The generation of an active slave acknowledge is disabled (slave acknowledge with 1 level = reception stopped)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SACKDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _HDELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HDELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ACKIEN`"]
        pub enum ACKIENW {
            #[doc = "The acknowledge interrupt is disabled."]
            VALUE1,
            #[doc = "The acknowledge interrupt is enabled."]
            VALUE2,
        }
        impl ACKIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ACKIENW::VALUE1 => false,
                    ACKIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACKIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACKIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACKIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The acknowledge interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACKIENW::VALUE1)
            }
            #[doc = "The acknowledge interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACKIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCLK`"]
        pub enum MCLKW {
            #[doc = "The MCLK generation is disabled and MCLK is 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCLKW::VALUE1 => false,
                    MCLKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCLKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCLKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The MCLK generation is disabled and MCLK is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCLKW::VALUE1)
            }
            #[doc = "The MCLK generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCLKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Slave Address"]
            #[inline]
            pub fn slad(&self) -> SLADR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SLADR { bits }
            }
            #[doc = "Bit 16 - Acknowledge 00H"]
            #[inline]
            pub fn ack00(&self) -> ACK00R {
                ACK00R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Symbol Timing"]
            #[inline]
            pub fn stim(&self) -> STIMR {
                STIMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Start Condition Received Interrupt Enable"]
            #[inline]
            pub fn scrien(&self) -> SCRIENR {
                SCRIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - Repeated Start Condition Received Interrupt Enable"]
            #[inline]
            pub fn rscrien(&self) -> RSCRIENR {
                RSCRIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - Stop Condition Received Interrupt Enable"]
            #[inline]
            pub fn pcrien(&self) -> PCRIENR {
                PCRIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - Non-Acknowledge Interrupt Enable"]
            #[inline]
            pub fn nackien(&self) -> NACKIENR {
                NACKIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 22 - Arbitration Lost Interrupt Enable"]
            #[inline]
            pub fn arlien(&self) -> ARLIENR {
                ARLIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - Slave Read Request Interrupt Enable"]
            #[inline]
            pub fn srrien(&self) -> SRRIENR {
                SRRIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Error Interrupt Enable"]
            #[inline]
            pub fn errien(&self) -> ERRIENR {
                ERRIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Slave Acknowledge Disable"]
            #[inline]
            pub fn sackdis(&self) -> SACKDISR {
                SACKDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 26:29 - Hardware Delay"]
            #[inline]
            pub fn hdel(&self) -> HDELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HDELR { bits }
            }
            #[doc = "Bit 30 - Acknowledge Interrupt Enable"]
            #[inline]
            pub fn ackien(&self) -> ACKIENR {
                ACKIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&self) -> MCLKR {
                MCLKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Slave Address"]
            #[inline]
            pub fn slad(&mut self) -> _SLADW {
                _SLADW { w: self }
            }
            #[doc = "Bit 16 - Acknowledge 00H"]
            #[inline]
            pub fn ack00(&mut self) -> _ACK00W {
                _ACK00W { w: self }
            }
            #[doc = "Bit 17 - Symbol Timing"]
            #[inline]
            pub fn stim(&mut self) -> _STIMW {
                _STIMW { w: self }
            }
            #[doc = "Bit 18 - Start Condition Received Interrupt Enable"]
            #[inline]
            pub fn scrien(&mut self) -> _SCRIENW {
                _SCRIENW { w: self }
            }
            #[doc = "Bit 19 - Repeated Start Condition Received Interrupt Enable"]
            #[inline]
            pub fn rscrien(&mut self) -> _RSCRIENW {
                _RSCRIENW { w: self }
            }
            #[doc = "Bit 20 - Stop Condition Received Interrupt Enable"]
            #[inline]
            pub fn pcrien(&mut self) -> _PCRIENW {
                _PCRIENW { w: self }
            }
            #[doc = "Bit 21 - Non-Acknowledge Interrupt Enable"]
            #[inline]
            pub fn nackien(&mut self) -> _NACKIENW {
                _NACKIENW { w: self }
            }
            #[doc = "Bit 22 - Arbitration Lost Interrupt Enable"]
            #[inline]
            pub fn arlien(&mut self) -> _ARLIENW {
                _ARLIENW { w: self }
            }
            #[doc = "Bit 23 - Slave Read Request Interrupt Enable"]
            #[inline]
            pub fn srrien(&mut self) -> _SRRIENW {
                _SRRIENW { w: self }
            }
            #[doc = "Bit 24 - Error Interrupt Enable"]
            #[inline]
            pub fn errien(&mut self) -> _ERRIENW {
                _ERRIENW { w: self }
            }
            #[doc = "Bit 25 - Slave Acknowledge Disable"]
            #[inline]
            pub fn sackdis(&mut self) -> _SACKDISW {
                _SACKDISW { w: self }
            }
            #[doc = "Bits 26:29 - Hardware Delay"]
            #[inline]
            pub fn hdel(&mut self) -> _HDELW {
                _HDELW { w: self }
            }
            #[doc = "Bit 30 - Acknowledge Interrupt Enable"]
            #[inline]
            pub fn ackien(&mut self) -> _ACKIENW {
                _ACKIENW { w: self }
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&mut self) -> _MCLKW {
                _MCLKW { w: self }
            }
        }
    }
    #[doc = "Protocol Control Register [IIS Mode]"]
    pub struct PCR_IISMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Control Register [IIS Mode]"]
    pub mod pcr_iismode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCR_IISMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `WAGEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAGENR {
            #[doc = "The IIS can be used as slave. The generation of the word address signal is disabled. The output signal WA is 0. The MCLKO signal generation depends on PCR.MCLK."]
            VALUE1,
            #[doc = "The IIS can be used as master. The generation of the word address signal is enabled. The signal starts with a 0 after being enabled. The generation of MCLK is enabled, independent of PCR.MCLK. After clearing WAGEN, the USIC module stops the generation of the WA signal within the next 4 WA periods."]
            VALUE2,
        }
        impl WAGENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAGENR::VALUE1 => false,
                    WAGENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAGENR {
                match value {
                    false => WAGENR::VALUE1,
                    true => WAGENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAGENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAGENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DTEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTENR {
            #[doc = "The changes of the WA input signal are ignored and no transfers take place."]
            VALUE1,
            #[doc = "Transfers are enabled."]
            VALUE2,
        }
        impl DTENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTENR::VALUE1 => false,
                    DTENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTENR {
                match value {
                    false => DTENR::VALUE1,
                    true => DTENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SELINV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SELINVR {
            #[doc = "The SELOx outputs have the same polarity as the WA signal."]
            VALUE1,
            #[doc = "The SELOx outputs have the inverted polarity to the WA signal."]
            VALUE2,
        }
        impl SELINVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SELINVR::VALUE1 => false,
                    SELINVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SELINVR {
                match value {
                    false => SELINVR::VALUE1,
                    true => SELINVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SELINVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SELINVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WAFEIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAFEIENR {
            #[doc = "A protocol interrupt is not activated if a falling edge of WA is generated."]
            VALUE1,
            #[doc = "A protocol interrupt is activated if a falling edge of WA is generated."]
            VALUE2,
        }
        impl WAFEIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAFEIENR::VALUE1 => false,
                    WAFEIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAFEIENR {
                match value {
                    false => WAFEIENR::VALUE1,
                    true => WAFEIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAFEIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAFEIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WAREIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAREIENR {
            #[doc = "A protocol interrupt is not activated if a rising edge of WA is generated."]
            VALUE1,
            #[doc = "A protocol interrupt is activated if a rising edge of WA is generated."]
            VALUE2,
        }
        impl WAREIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAREIENR::VALUE1 => false,
                    WAREIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAREIENR {
                match value {
                    false => WAREIENR::VALUE1,
                    true => WAREIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAREIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAREIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENDIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDIENR {
            #[doc = "A protocol interrupt is not activated."]
            VALUE1,
            #[doc = "A protocol interrupt is activated."]
            VALUE2,
        }
        impl ENDIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENDIENR::VALUE1 => false,
                    ENDIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENDIENR {
                match value {
                    false => ENDIENR::VALUE1,
                    true => ENDIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DX2TIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DX2TIENR {
            #[doc = "A protocol interrupt is not generated if DX2T is active."]
            VALUE1,
            #[doc = "A protocol interrupt is generated if DX2T is active."]
            VALUE2,
        }
        impl DX2TIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DX2TIENR::VALUE1 => false,
                    DX2TIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DX2TIENR {
                match value {
                    false => DX2TIENR::VALUE1,
                    true => DX2TIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DX2TIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DX2TIENR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct TDELR {
            bits: u8,
        }
        impl TDELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `MCLK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCLKR {
            #[doc = "The MCLK generation is disabled and MCLK is 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCLKR::VALUE1 => false,
                    MCLKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCLKR {
                match value {
                    false => MCLKR::VALUE1,
                    true => MCLKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCLKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCLKR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WAGEN`"]
        pub enum WAGENW {
            #[doc = "The IIS can be used as slave. The generation of the word address signal is disabled. The output signal WA is 0. The MCLKO signal generation depends on PCR.MCLK."]
            VALUE1,
            #[doc = "The IIS can be used as master. The generation of the word address signal is enabled. The signal starts with a 0 after being enabled. The generation of MCLK is enabled, independent of PCR.MCLK. After clearing WAGEN, the USIC module stops the generation of the WA signal within the next 4 WA periods."]
            VALUE2,
        }
        impl WAGENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAGENW::VALUE1 => false,
                    WAGENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAGENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAGENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAGENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The IIS can be used as slave. The generation of the word address signal is disabled. The output signal WA is 0. The MCLKO signal generation depends on PCR.MCLK."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAGENW::VALUE1)
            }
            #[doc = "The IIS can be used as master. The generation of the word address signal is enabled. The signal starts with a 0 after being enabled. The generation of MCLK is enabled, independent of PCR.MCLK. After clearing WAGEN, the USIC module stops the generation of the WA signal within the next 4 WA periods."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAGENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DTEN`"]
        pub enum DTENW {
            #[doc = "The changes of the WA input signal are ignored and no transfers take place."]
            VALUE1,
            #[doc = "Transfers are enabled."]
            VALUE2,
        }
        impl DTENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DTENW::VALUE1 => false,
                    DTENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DTENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The changes of the WA input signal are ignored and no transfers take place."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DTENW::VALUE1)
            }
            #[doc = "Transfers are enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DTENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SELINV`"]
        pub enum SELINVW {
            #[doc = "The SELOx outputs have the same polarity as the WA signal."]
            VALUE1,
            #[doc = "The SELOx outputs have the inverted polarity to the WA signal."]
            VALUE2,
        }
        impl SELINVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SELINVW::VALUE1 => false,
                    SELINVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELINVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELINVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SELINVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The SELOx outputs have the same polarity as the WA signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SELINVW::VALUE1)
            }
            #[doc = "The SELOx outputs have the inverted polarity to the WA signal."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SELINVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WAFEIEN`"]
        pub enum WAFEIENW {
            #[doc = "A protocol interrupt is not activated if a falling edge of WA is generated."]
            VALUE1,
            #[doc = "A protocol interrupt is activated if a falling edge of WA is generated."]
            VALUE2,
        }
        impl WAFEIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAFEIENW::VALUE1 => false,
                    WAFEIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAFEIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAFEIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAFEIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not activated if a falling edge of WA is generated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAFEIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is activated if a falling edge of WA is generated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAFEIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WAREIEN`"]
        pub enum WAREIENW {
            #[doc = "A protocol interrupt is not activated if a rising edge of WA is generated."]
            VALUE1,
            #[doc = "A protocol interrupt is activated if a rising edge of WA is generated."]
            VALUE2,
        }
        impl WAREIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAREIENW::VALUE1 => false,
                    WAREIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAREIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAREIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAREIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not activated if a rising edge of WA is generated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAREIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is activated if a rising edge of WA is generated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAREIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENDIEN`"]
        pub enum ENDIENW {
            #[doc = "A protocol interrupt is not activated."]
            VALUE1,
            #[doc = "A protocol interrupt is activated."]
            VALUE2,
        }
        impl ENDIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENDIENW::VALUE1 => false,
                    ENDIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENDIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENDIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENDIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENDIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENDIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DX2TIEN`"]
        pub enum DX2TIENW {
            #[doc = "A protocol interrupt is not generated if DX2T is active."]
            VALUE1,
            #[doc = "A protocol interrupt is generated if DX2T is active."]
            VALUE2,
        }
        impl DX2TIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DX2TIENW::VALUE1 => false,
                    DX2TIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DX2TIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DX2TIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DX2TIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A protocol interrupt is not generated if DX2T is active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DX2TIENW::VALUE1)
            }
            #[doc = "A protocol interrupt is generated if DX2T is active."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DX2TIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TDELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TDELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCLK`"]
        pub enum MCLKW {
            #[doc = "The MCLK generation is disabled and MCLK is 0."]
            VALUE1,
            #[doc = "The MCLK generation is enabled."]
            VALUE2,
        }
        impl MCLKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCLKW::VALUE1 => false,
                    MCLKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCLKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCLKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The MCLK generation is disabled and MCLK is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCLKW::VALUE1)
            }
            #[doc = "The MCLK generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCLKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - WA Generation Enable"]
            #[inline]
            pub fn wagen(&self) -> WAGENR {
                WAGENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Data Transfers Enable"]
            #[inline]
            pub fn dten(&self) -> DTENR {
                DTENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Select Inversion"]
            #[inline]
            pub fn selinv(&self) -> SELINVR {
                SELINVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - WA Falling Edge Interrupt Enable"]
            #[inline]
            pub fn wafeien(&self) -> WAFEIENR {
                WAFEIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - WA Rising Edge Interrupt Enable"]
            #[inline]
            pub fn wareien(&self) -> WAREIENR {
                WAREIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - END Interrupt Enable"]
            #[inline]
            pub fn endien(&self) -> ENDIENR {
                ENDIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - DX2T Interrupt Enable"]
            #[inline]
            pub fn dx2tien(&self) -> DX2TIENR {
                DX2TIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:21 - Transfer Delay"]
            #[inline]
            pub fn tdel(&self) -> TDELR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TDELR { bits }
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&self) -> MCLKR {
                MCLKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - WA Generation Enable"]
            #[inline]
            pub fn wagen(&mut self) -> _WAGENW {
                _WAGENW { w: self }
            }
            #[doc = "Bit 1 - Data Transfers Enable"]
            #[inline]
            pub fn dten(&mut self) -> _DTENW {
                _DTENW { w: self }
            }
            #[doc = "Bit 2 - Select Inversion"]
            #[inline]
            pub fn selinv(&mut self) -> _SELINVW {
                _SELINVW { w: self }
            }
            #[doc = "Bit 4 - WA Falling Edge Interrupt Enable"]
            #[inline]
            pub fn wafeien(&mut self) -> _WAFEIENW {
                _WAFEIENW { w: self }
            }
            #[doc = "Bit 5 - WA Rising Edge Interrupt Enable"]
            #[inline]
            pub fn wareien(&mut self) -> _WAREIENW {
                _WAREIENW { w: self }
            }
            #[doc = "Bit 6 - END Interrupt Enable"]
            #[inline]
            pub fn endien(&mut self) -> _ENDIENW {
                _ENDIENW { w: self }
            }
            #[doc = "Bit 15 - DX2T Interrupt Enable"]
            #[inline]
            pub fn dx2tien(&mut self) -> _DX2TIENW {
                _DX2TIENW { w: self }
            }
            #[doc = "Bits 16:21 - Transfer Delay"]
            #[inline]
            pub fn tdel(&mut self) -> _TDELW {
                _TDELW { w: self }
            }
            #[doc = "Bit 31 - Master Clock Enable"]
            #[inline]
            pub fn mclk(&mut self) -> _MCLKW {
                _MCLKW { w: self }
            }
        }
    }
    #[doc = "Channel Control Register"]
    pub struct CCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Control Register"]
    pub mod ccr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MODER {
            #[doc = "The USIC channel is disabled. All protocol-related state machines are set to an idle state."]
            VALUE1,
            #[doc = "The SSC (SPI) protocol is selected."]
            VALUE2,
            #[doc = "The ASC (SCI, UART) protocol is selected."]
            VALUE3,
            #[doc = "The IIS protocol is selected."]
            VALUE4,
            #[doc = "The IIC protocol is selected."]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MODER::VALUE1 => 0,
                    MODER::VALUE2 => 0x01,
                    MODER::VALUE3 => 0x02,
                    MODER::VALUE4 => 0x03,
                    MODER::VALUE5 => 0x04,
                    MODER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MODER {
                match value {
                    0 => MODER::VALUE1,
                    1 => MODER::VALUE2,
                    2 => MODER::VALUE3,
                    3 => MODER::VALUE4,
                    4 => MODER::VALUE5,
                    i => MODER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MODER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == MODER::VALUE5
            }
        }
        #[doc = "Possible values of the field `HPCEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HPCENR {
            #[doc = "The hardware port control is disabled."]
            VALUE1,
            #[doc = "The hardware port control is enabled for DX0 and DOUT0."]
            VALUE2,
            #[doc = "The hardware port control is enabled for DX3, DX0 and DOUT[1:0]."]
            VALUE3,
            #[doc = "The hardware port control is enabled for DX0, DX[5:3] and DOUT[3:0]."]
            VALUE4,
        }
        impl HPCENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HPCENR::VALUE1 => 0,
                    HPCENR::VALUE2 => 0x01,
                    HPCENR::VALUE3 => 0x02,
                    HPCENR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HPCENR {
                match value {
                    0 => HPCENR::VALUE1,
                    1 => HPCENR::VALUE2,
                    2 => HPCENR::VALUE3,
                    3 => HPCENR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HPCENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HPCENR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HPCENR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == HPCENR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PMR {
            #[doc = "The parity generation is disabled."]
            VALUE1,
            #[doc = "Even parity is selected (parity bit = 1 on odd number of 1s in data, parity bit = 0 on even number of 1s in data)."]
            VALUE3,
            #[doc = "Odd parity is selected (parity bit = 0 on odd number of 1s in data, parity bit = 1 on even number of 1s in data)."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PMR::VALUE1 => 0,
                    PMR::VALUE3 => 0x02,
                    PMR::VALUE4 => 0x03,
                    PMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PMR {
                match value {
                    0 => PMR::VALUE1,
                    2 => PMR::VALUE3,
                    3 => PMR::VALUE4,
                    i => PMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `RSIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSIENR {
            #[doc = "The receiver start interrupt is disabled."]
            VALUE1,
            #[doc = "The receiver start interrupt is enabled. In case of a receiver start event, the service request output SRx indicated by INPR.TBINP is activated."]
            VALUE2,
        }
        impl RSIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSIENR::VALUE1 => false,
                    RSIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSIENR {
                match value {
                    false => RSIENR::VALUE1,
                    true => RSIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLIENR {
            #[doc = "The data lost interrupt is disabled."]
            VALUE1,
            #[doc = "The data lost interrupt is enabled. In case of a data lost event, the service request output SRx indicated by INPR.PINP is activated."]
            VALUE2,
        }
        impl DLIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLIENR::VALUE1 => false,
                    DLIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLIENR {
                match value {
                    false => DLIENR::VALUE1,
                    true => DLIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSIENR {
            #[doc = "The transmit shift interrupt is disabled."]
            VALUE1,
            #[doc = "The transmit shift interrupt is enabled. In case of a transmit shift interrupt event, the service request output SRx indicated by INPR.TSINP is activated."]
            VALUE2,
        }
        impl TSIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSIENR::VALUE1 => false,
                    TSIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSIENR {
                match value {
                    false => TSIENR::VALUE1,
                    true => TSIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBIENR {
            #[doc = "The transmit buffer interrupt is disabled."]
            VALUE1,
            #[doc = "The transmit buffer interrupt is enabled. In case of a transmit buffer event, the service request output SRx indicated by INPR.TBINP is activated."]
            VALUE2,
        }
        impl TBIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBIENR::VALUE1 => false,
                    TBIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBIENR {
                match value {
                    false => TBIENR::VALUE1,
                    true => TBIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RIENR {
            #[doc = "The receive interrupt is disabled."]
            VALUE1,
            #[doc = "The receive interrupt is enabled. In case of a receive event, the service request output SRx indicated by INPR.RINP is activated."]
            VALUE2,
        }
        impl RIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RIENR::VALUE1 => false,
                    RIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RIENR {
                match value {
                    false => RIENR::VALUE1,
                    true => RIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIENR {
            #[doc = "The alternative receive interrupt is disabled."]
            VALUE1,
            #[doc = "The alternative receive interrupt is enabled. In case of an alternative receive event, the service request output SRx indicated by INPR.AINP is activated."]
            VALUE2,
        }
        impl AIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIENR::VALUE1 => false,
                    AIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIENR {
                match value {
                    false => AIENR::VALUE1,
                    true => AIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRGIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRGIENR {
            #[doc = "The baud rate generator interrupt is disabled."]
            VALUE1,
            #[doc = "The baud rate generator interrupt is enabled. In case of a baud rate generator event, the service request output SRx indicated by INPR.PINP is activated."]
            VALUE2,
        }
        impl BRGIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRGIENR::VALUE1 => false,
                    BRGIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRGIENR {
                match value {
                    false => BRGIENR::VALUE1,
                    true => BRGIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRGIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRGIENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `MODE`"]
        pub enum MODEW {
            #[doc = "The USIC channel is disabled. All protocol-related state machines are set to an idle state."]
            VALUE1,
            #[doc = "The SSC (SPI) protocol is selected."]
            VALUE2,
            #[doc = "The ASC (SCI, UART) protocol is selected."]
            VALUE3,
            #[doc = "The IIS protocol is selected."]
            VALUE4,
            #[doc = "The IIC protocol is selected."]
            VALUE5,
        }
        impl MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MODEW::VALUE1 => 0,
                    MODEW::VALUE2 => 1,
                    MODEW::VALUE3 => 2,
                    MODEW::VALUE4 => 3,
                    MODEW::VALUE5 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MODEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The USIC channel is disabled. All protocol-related state machines are set to an idle state."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MODEW::VALUE1)
            }
            #[doc = "The SSC (SPI) protocol is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MODEW::VALUE2)
            }
            #[doc = "The ASC (SCI, UART) protocol is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MODEW::VALUE3)
            }
            #[doc = "The IIS protocol is selected."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MODEW::VALUE4)
            }
            #[doc = "The IIC protocol is selected."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(MODEW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HPCEN`"]
        pub enum HPCENW {
            #[doc = "The hardware port control is disabled."]
            VALUE1,
            #[doc = "The hardware port control is enabled for DX0 and DOUT0."]
            VALUE2,
            #[doc = "The hardware port control is enabled for DX3, DX0 and DOUT[1:0]."]
            VALUE3,
            #[doc = "The hardware port control is enabled for DX0, DX[5:3] and DOUT[3:0]."]
            VALUE4,
        }
        impl HPCENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HPCENW::VALUE1 => 0,
                    HPCENW::VALUE2 => 1,
                    HPCENW::VALUE3 => 2,
                    HPCENW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HPCENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HPCENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HPCENW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The hardware port control is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HPCENW::VALUE1)
            }
            #[doc = "The hardware port control is enabled for DX0 and DOUT0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HPCENW::VALUE2)
            }
            #[doc = "The hardware port control is enabled for DX3, DX0 and DOUT[1:0]."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HPCENW::VALUE3)
            }
            #[doc = "The hardware port control is enabled for DX0, DX[5:3] and DOUT[3:0]."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(HPCENW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PM`"]
        pub enum PMW {
            #[doc = "The parity generation is disabled."]
            VALUE1,
            #[doc = "Even parity is selected (parity bit = 1 on odd number of 1s in data, parity bit = 0 on even number of 1s in data)."]
            VALUE3,
            #[doc = "Odd parity is selected (parity bit = 0 on odd number of 1s in data, parity bit = 1 on even number of 1s in data)."]
            VALUE4,
        }
        impl PMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PMW::VALUE1 => 0,
                    PMW::VALUE3 => 2,
                    PMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The parity generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PMW::VALUE1)
            }
            #[doc = "Even parity is selected (parity bit = 1 on odd number of 1s in data, parity bit = 0 on even number of 1s in data)."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PMW::VALUE3)
            }
            #[doc = "Odd parity is selected (parity bit = 0 on odd number of 1s in data, parity bit = 1 on even number of 1s in data)."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSIEN`"]
        pub enum RSIENW {
            #[doc = "The receiver start interrupt is disabled."]
            VALUE1,
            #[doc = "The receiver start interrupt is enabled. In case of a receiver start event, the service request output SRx indicated by INPR.TBINP is activated."]
            VALUE2,
        }
        impl RSIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSIENW::VALUE1 => false,
                    RSIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The receiver start interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSIENW::VALUE1)
            }
            #[doc = "The receiver start interrupt is enabled. In case of a receiver start event, the service request output SRx indicated by INPR.TBINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLIEN`"]
        pub enum DLIENW {
            #[doc = "The data lost interrupt is disabled."]
            VALUE1,
            #[doc = "The data lost interrupt is enabled. In case of a data lost event, the service request output SRx indicated by INPR.PINP is activated."]
            VALUE2,
        }
        impl DLIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLIENW::VALUE1 => false,
                    DLIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The data lost interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLIENW::VALUE1)
            }
            #[doc = "The data lost interrupt is enabled. In case of a data lost event, the service request output SRx indicated by INPR.PINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSIEN`"]
        pub enum TSIENW {
            #[doc = "The transmit shift interrupt is disabled."]
            VALUE1,
            #[doc = "The transmit shift interrupt is enabled. In case of a transmit shift interrupt event, the service request output SRx indicated by INPR.TSINP is activated."]
            VALUE2,
        }
        impl TSIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSIENW::VALUE1 => false,
                    TSIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The transmit shift interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSIENW::VALUE1)
            }
            #[doc = "The transmit shift interrupt is enabled. In case of a transmit shift interrupt event, the service request output SRx indicated by INPR.TSINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBIEN`"]
        pub enum TBIENW {
            #[doc = "The transmit buffer interrupt is disabled."]
            VALUE1,
            #[doc = "The transmit buffer interrupt is enabled. In case of a transmit buffer event, the service request output SRx indicated by INPR.TBINP is activated."]
            VALUE2,
        }
        impl TBIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBIENW::VALUE1 => false,
                    TBIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The transmit buffer interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBIENW::VALUE1)
            }
            #[doc = "The transmit buffer interrupt is enabled. In case of a transmit buffer event, the service request output SRx indicated by INPR.TBINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RIEN`"]
        pub enum RIENW {
            #[doc = "The receive interrupt is disabled."]
            VALUE1,
            #[doc = "The receive interrupt is enabled. In case of a receive event, the service request output SRx indicated by INPR.RINP is activated."]
            VALUE2,
        }
        impl RIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RIENW::VALUE1 => false,
                    RIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The receive interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RIENW::VALUE1)
            }
            #[doc = "The receive interrupt is enabled. In case of a receive event, the service request output SRx indicated by INPR.RINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AIEN`"]
        pub enum AIENW {
            #[doc = "The alternative receive interrupt is disabled."]
            VALUE1,
            #[doc = "The alternative receive interrupt is enabled. In case of an alternative receive event, the service request output SRx indicated by INPR.AINP is activated."]
            VALUE2,
        }
        impl AIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIENW::VALUE1 => false,
                    AIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The alternative receive interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIENW::VALUE1)
            }
            #[doc = "The alternative receive interrupt is enabled. In case of an alternative receive event, the service request output SRx indicated by INPR.AINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRGIEN`"]
        pub enum BRGIENW {
            #[doc = "The baud rate generator interrupt is disabled."]
            VALUE1,
            #[doc = "The baud rate generator interrupt is enabled. In case of a baud rate generator event, the service request output SRx indicated by INPR.PINP is activated."]
            VALUE2,
        }
        impl BRGIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRGIENW::VALUE1 => false,
                    BRGIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRGIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRGIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRGIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The baud rate generator interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRGIENW::VALUE1)
            }
            #[doc = "The baud rate generator interrupt is enabled. In case of a baud rate generator event, the service request output SRx indicated by INPR.PINP is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRGIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Operating Mode"]
            #[inline]
            pub fn mode(&self) -> MODER {
                MODER::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Hardware Port Control Enable"]
            #[inline]
            pub fn hpcen(&self) -> HPCENR {
                HPCENR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Parity Mode"]
            #[inline]
            pub fn pm(&self) -> PMR {
                PMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Receiver Start Interrupt Enable"]
            #[inline]
            pub fn rsien(&self) -> RSIENR {
                RSIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Lost Interrupt Enable"]
            #[inline]
            pub fn dlien(&self) -> DLIENR {
                DLIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Shift Interrupt Enable"]
            #[inline]
            pub fn tsien(&self) -> TSIENR {
                TSIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Interrupt Enable"]
            #[inline]
            pub fn tbien(&self) -> TBIENR {
                TBIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Interrupt Enable"]
            #[inline]
            pub fn rien(&self) -> RIENR {
                RIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Alternative Receive Interrupt Enable"]
            #[inline]
            pub fn aien(&self) -> AIENR {
                AIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Baud Rate Generator Interrupt Enable"]
            #[inline]
            pub fn brgien(&self) -> BRGIENR {
                BRGIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Operating Mode"]
            #[inline]
            pub fn mode(&mut self) -> _MODEW {
                _MODEW { w: self }
            }
            #[doc = "Bits 6:7 - Hardware Port Control Enable"]
            #[inline]
            pub fn hpcen(&mut self) -> _HPCENW {
                _HPCENW { w: self }
            }
            #[doc = "Bits 8:9 - Parity Mode"]
            #[inline]
            pub fn pm(&mut self) -> _PMW {
                _PMW { w: self }
            }
            #[doc = "Bit 10 - Receiver Start Interrupt Enable"]
            #[inline]
            pub fn rsien(&mut self) -> _RSIENW {
                _RSIENW { w: self }
            }
            #[doc = "Bit 11 - Data Lost Interrupt Enable"]
            #[inline]
            pub fn dlien(&mut self) -> _DLIENW {
                _DLIENW { w: self }
            }
            #[doc = "Bit 12 - Transmit Shift Interrupt Enable"]
            #[inline]
            pub fn tsien(&mut self) -> _TSIENW {
                _TSIENW { w: self }
            }
            #[doc = "Bit 13 - Transmit Buffer Interrupt Enable"]
            #[inline]
            pub fn tbien(&mut self) -> _TBIENW {
                _TBIENW { w: self }
            }
            #[doc = "Bit 14 - Receive Interrupt Enable"]
            #[inline]
            pub fn rien(&mut self) -> _RIENW {
                _RIENW { w: self }
            }
            #[doc = "Bit 15 - Alternative Receive Interrupt Enable"]
            #[inline]
            pub fn aien(&mut self) -> _AIENW {
                _AIENW { w: self }
            }
            #[doc = "Bit 16 - Baud Rate Generator Interrupt Enable"]
            #[inline]
            pub fn brgien(&mut self) -> _BRGIENW {
                _BRGIENW { w: self }
            }
        }
    }
    #[doc = "Capture Mode Timer Register"]
    pub struct CMTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Mode Timer Register"]
    pub mod cmtr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CMTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CTVR {
            bits: u16,
        }
        impl CTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - Captured Timer Value"]
            #[inline]
            pub fn ctv(&self) -> CTVR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CTVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:9 - Captured Timer Value"]
            #[inline]
            pub fn ctv(&mut self) -> _CTVW {
                _CTVW { w: self }
            }
        }
    }
    #[doc = "Protocol Status Register"]
    pub struct PSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Status Register"]
    pub mod psr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST0R {
            bits: bool,
        }
        impl ST0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST1R {
            bits: bool,
        }
        impl ST1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST2R {
            bits: bool,
        }
        impl ST2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST3R {
            bits: bool,
        }
        impl ST3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST4R {
            bits: bool,
        }
        impl ST4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST5R {
            bits: bool,
        }
        impl ST5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST6R {
            bits: bool,
        }
        impl ST6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST7R {
            bits: bool,
        }
        impl ST7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST8R {
            bits: bool,
        }
        impl ST8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ST9R {
            bits: bool,
        }
        impl ST9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `RSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSIFR {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSIFR::VALUE1 => false,
                    RSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSIFR {
                match value {
                    false => RSIFR::VALUE1,
                    true => RSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLIFR {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLIFR::VALUE1 => false,
                    DLIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLIFR {
                match value {
                    false => DLIFR::VALUE1,
                    true => DLIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSIFR {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSIFR::VALUE1 => false,
                    TSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSIFR {
                match value {
                    false => TSIFR::VALUE1,
                    true => TSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBIFR {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBIFR::VALUE1 => false,
                    TBIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBIFR {
                match value {
                    false => TBIFR::VALUE1,
                    true => TBIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RIFR {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RIFR::VALUE1 => false,
                    RIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RIFR {
                match value {
                    false => RIFR::VALUE1,
                    true => RIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIFR {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIFR::VALUE1 => false,
                    AIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIFR {
                match value {
                    false => AIFR::VALUE1,
                    true => AIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRGIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRGIFR {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRGIFR::VALUE1 => false,
                    BRGIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRGIFR {
                match value {
                    false => BRGIFR::VALUE1,
                    true => BRGIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRGIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRGIFR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ST9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ST9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSIF`"]
        pub enum RSIFW {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSIFW::VALUE1 => false,
                    RSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receiver start event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSIFW::VALUE1)
            }
            #[doc = "A receiver start event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLIF`"]
        pub enum DLIFW {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLIFW::VALUE1 => false,
                    DLIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A data lost event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLIFW::VALUE1)
            }
            #[doc = "A data lost event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSIF`"]
        pub enum TSIFW {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSIFW::VALUE1 => false,
                    TSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit shift event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSIFW::VALUE1)
            }
            #[doc = "A transmit shift event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBIF`"]
        pub enum TBIFW {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBIFW::VALUE1 => false,
                    TBIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit buffer event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBIFW::VALUE1)
            }
            #[doc = "A transmit buffer event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RIF`"]
        pub enum RIFW {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RIFW::VALUE1 => false,
                    RIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RIFW::VALUE1)
            }
            #[doc = "A receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AIF`"]
        pub enum AIFW {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIFW::VALUE1 => false,
                    AIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An alternative receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIFW::VALUE1)
            }
            #[doc = "An alternative receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRGIF`"]
        pub enum BRGIFW {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRGIFW::VALUE1 => false,
                    BRGIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRGIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRGIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRGIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A baud rate generator event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE1)
            }
            #[doc = "A baud rate generator event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Protocol Status Flag 0"]
            #[inline]
            pub fn st0(&self) -> ST0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST0R { bits }
            }
            #[doc = "Bit 1 - Protocol Status Flag 1"]
            #[inline]
            pub fn st1(&self) -> ST1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST1R { bits }
            }
            #[doc = "Bit 2 - Protocol Status Flag 2"]
            #[inline]
            pub fn st2(&self) -> ST2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST2R { bits }
            }
            #[doc = "Bit 3 - Protocol Status Flag 3"]
            #[inline]
            pub fn st3(&self) -> ST3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST3R { bits }
            }
            #[doc = "Bit 4 - Protocol Status Flag 4"]
            #[inline]
            pub fn st4(&self) -> ST4R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST4R { bits }
            }
            #[doc = "Bit 5 - Protocol Status Flag 5"]
            #[inline]
            pub fn st5(&self) -> ST5R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST5R { bits }
            }
            #[doc = "Bit 6 - Protocol Status Flag 6"]
            #[inline]
            pub fn st6(&self) -> ST6R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST6R { bits }
            }
            #[doc = "Bit 7 - Protocol Status Flag 7"]
            #[inline]
            pub fn st7(&self) -> ST7R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST7R { bits }
            }
            #[doc = "Bit 8 - Protocol Status Flag 8"]
            #[inline]
            pub fn st8(&self) -> ST8R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST8R { bits }
            }
            #[doc = "Bit 9 - Protocol Status Flag 9"]
            #[inline]
            pub fn st9(&self) -> ST9R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ST9R { bits }
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&self) -> RSIFR {
                RSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&self) -> DLIFR {
                DLIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&self) -> TSIFR {
                TSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&self) -> TBIFR {
                TBIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&self) -> RIFR {
                RIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&self) -> AIFR {
                AIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&self) -> BRGIFR {
                BRGIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Protocol Status Flag 0"]
            #[inline]
            pub fn st0(&mut self) -> _ST0W {
                _ST0W { w: self }
            }
            #[doc = "Bit 1 - Protocol Status Flag 1"]
            #[inline]
            pub fn st1(&mut self) -> _ST1W {
                _ST1W { w: self }
            }
            #[doc = "Bit 2 - Protocol Status Flag 2"]
            #[inline]
            pub fn st2(&mut self) -> _ST2W {
                _ST2W { w: self }
            }
            #[doc = "Bit 3 - Protocol Status Flag 3"]
            #[inline]
            pub fn st3(&mut self) -> _ST3W {
                _ST3W { w: self }
            }
            #[doc = "Bit 4 - Protocol Status Flag 4"]
            #[inline]
            pub fn st4(&mut self) -> _ST4W {
                _ST4W { w: self }
            }
            #[doc = "Bit 5 - Protocol Status Flag 5"]
            #[inline]
            pub fn st5(&mut self) -> _ST5W {
                _ST5W { w: self }
            }
            #[doc = "Bit 6 - Protocol Status Flag 6"]
            #[inline]
            pub fn st6(&mut self) -> _ST6W {
                _ST6W { w: self }
            }
            #[doc = "Bit 7 - Protocol Status Flag 7"]
            #[inline]
            pub fn st7(&mut self) -> _ST7W {
                _ST7W { w: self }
            }
            #[doc = "Bit 8 - Protocol Status Flag 8"]
            #[inline]
            pub fn st8(&mut self) -> _ST8W {
                _ST8W { w: self }
            }
            #[doc = "Bit 9 - Protocol Status Flag 9"]
            #[inline]
            pub fn st9(&mut self) -> _ST9W {
                _ST9W { w: self }
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&mut self) -> _RSIFW {
                _RSIFW { w: self }
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&mut self) -> _DLIFW {
                _DLIFW { w: self }
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&mut self) -> _TSIFW {
                _TSIFW { w: self }
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&mut self) -> _TBIFW {
                _TBIFW { w: self }
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&mut self) -> _RIFW {
                _RIFW { w: self }
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&mut self) -> _AIFW {
                _AIFW { w: self }
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&mut self) -> _BRGIFW {
                _BRGIFW { w: self }
            }
        }
    }
    #[doc = "Protocol Status Register [ASC Mode]"]
    pub struct PSR_ASCMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Status Register [ASC Mode]"]
    pub mod psr_ascmode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSR_ASCMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `TXIDLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXIDLER {
            #[doc = "The transmitter line has not yet been idle."]
            VALUE1,
            #[doc = "The transmitter line has been idle and frame transmission is possible."]
            VALUE2,
        }
        impl TXIDLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXIDLER::VALUE1 => false,
                    TXIDLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXIDLER {
                match value {
                    false => TXIDLER::VALUE1,
                    true => TXIDLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXIDLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXIDLER::VALUE2
            }
        }
        #[doc = "Possible values of the field `RXIDLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXIDLER {
            #[doc = "The receiver line has not yet been idle."]
            VALUE1,
            #[doc = "The receiver line has been idle and frame reception is possible."]
            VALUE2,
        }
        impl RXIDLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RXIDLER::VALUE1 => false,
                    RXIDLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RXIDLER {
                match value {
                    false => RXIDLER::VALUE1,
                    true => RXIDLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXIDLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXIDLER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SBD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SBDR {
            #[doc = "A synchronization break has not yet been detected."]
            VALUE1,
            #[doc = "A synchronization break has been detected."]
            VALUE2,
        }
        impl SBDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SBDR::VALUE1 => false,
                    SBDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SBDR {
                match value {
                    false => SBDR::VALUE1,
                    true => SBDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SBDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SBDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `COL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum COLR {
            #[doc = "A collision has not yet been detected and frame transmission is possible."]
            VALUE1,
            #[doc = "A collision has been detected and frame transmission is not possible."]
            VALUE2,
        }
        impl COLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    COLR::VALUE1 => false,
                    COLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> COLR {
                match value {
                    false => COLR::VALUE1,
                    true => COLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == COLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == COLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RNS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RNSR {
            #[doc = "Receiver noise has not been detected."]
            VALUE1,
            #[doc = "Receiver noise has been detected."]
            VALUE2,
        }
        impl RNSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RNSR::VALUE1 => false,
                    RNSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RNSR {
                match value {
                    false => RNSR::VALUE1,
                    true => RNSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RNSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RNSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FER0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FER0R {
            #[doc = "A format error 0 has not been detected."]
            VALUE1,
            #[doc = "A format error 0 has been detected."]
            VALUE2,
        }
        impl FER0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FER0R::VALUE1 => false,
                    FER0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FER0R {
                match value {
                    false => FER0R::VALUE1,
                    true => FER0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FER0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FER0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `FER1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FER1R {
            #[doc = "A format error 1 has not been detected."]
            VALUE1,
            #[doc = "A format error 1 has been detected."]
            VALUE2,
        }
        impl FER1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FER1R::VALUE1 => false,
                    FER1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FER1R {
                match value {
                    false => FER1R::VALUE1,
                    true => FER1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FER1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FER1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RFF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RFFR {
            #[doc = "The received frame is not yet finished."]
            VALUE1,
            #[doc = "The received frame is finished."]
            VALUE2,
        }
        impl RFFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RFFR::VALUE1 => false,
                    RFFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RFFR {
                match value {
                    false => RFFR::VALUE1,
                    true => RFFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RFFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RFFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TFF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TFFR {
            #[doc = "The transmitter frame is not yet finished."]
            VALUE1,
            #[doc = "The transmitter frame is finished."]
            VALUE2,
        }
        impl TFFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TFFR::VALUE1 => false,
                    TFFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TFFR {
                match value {
                    false => TFFR::VALUE1,
                    true => TFFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TFFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TFFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BUSYR {
            #[doc = "A data transfer does not take place."]
            VALUE1,
            #[doc = "A data transfer currently takes place."]
            VALUE2,
        }
        impl BUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BUSYR::VALUE1 => false,
                    BUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BUSYR {
                match value {
                    false => BUSYR::VALUE1,
                    true => BUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BUSYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSIFR {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSIFR::VALUE1 => false,
                    RSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSIFR {
                match value {
                    false => RSIFR::VALUE1,
                    true => RSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLIFR {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLIFR::VALUE1 => false,
                    DLIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLIFR {
                match value {
                    false => DLIFR::VALUE1,
                    true => DLIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSIFR {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSIFR::VALUE1 => false,
                    TSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSIFR {
                match value {
                    false => TSIFR::VALUE1,
                    true => TSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBIFR {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBIFR::VALUE1 => false,
                    TBIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBIFR {
                match value {
                    false => TBIFR::VALUE1,
                    true => TBIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RIFR {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RIFR::VALUE1 => false,
                    RIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RIFR {
                match value {
                    false => RIFR::VALUE1,
                    true => RIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIFR {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIFR::VALUE1 => false,
                    AIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIFR {
                match value {
                    false => AIFR::VALUE1,
                    true => AIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRGIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRGIFR {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRGIFR::VALUE1 => false,
                    BRGIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRGIFR {
                match value {
                    false => BRGIFR::VALUE1,
                    true => BRGIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRGIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRGIFR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `TXIDLE`"]
        pub enum TXIDLEW {
            #[doc = "The transmitter line has not yet been idle."]
            VALUE1,
            #[doc = "The transmitter line has been idle and frame transmission is possible."]
            VALUE2,
        }
        impl TXIDLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TXIDLEW::VALUE1 => false,
                    TXIDLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXIDLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXIDLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TXIDLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The transmitter line has not yet been idle."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TXIDLEW::VALUE1)
            }
            #[doc = "The transmitter line has been idle and frame transmission is possible."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TXIDLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RXIDLE`"]
        pub enum RXIDLEW {
            #[doc = "The receiver line has not yet been idle."]
            VALUE1,
            #[doc = "The receiver line has been idle and frame reception is possible."]
            VALUE2,
        }
        impl RXIDLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RXIDLEW::VALUE1 => false,
                    RXIDLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXIDLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXIDLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RXIDLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The receiver line has not yet been idle."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RXIDLEW::VALUE1)
            }
            #[doc = "The receiver line has been idle and frame reception is possible."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RXIDLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SBD`"]
        pub enum SBDW {
            #[doc = "A synchronization break has not yet been detected."]
            VALUE1,
            #[doc = "A synchronization break has been detected."]
            VALUE2,
        }
        impl SBDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SBDW::VALUE1 => false,
                    SBDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SBDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SBDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SBDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A synchronization break has not yet been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SBDW::VALUE1)
            }
            #[doc = "A synchronization break has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SBDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `COL`"]
        pub enum COLW {
            #[doc = "A collision has not yet been detected and frame transmission is possible."]
            VALUE1,
            #[doc = "A collision has been detected and frame transmission is not possible."]
            VALUE2,
        }
        impl COLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    COLW::VALUE1 => false,
                    COLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _COLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _COLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: COLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A collision has not yet been detected and frame transmission is possible."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(COLW::VALUE1)
            }
            #[doc = "A collision has been detected and frame transmission is not possible."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(COLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RNS`"]
        pub enum RNSW {
            #[doc = "Receiver noise has not been detected."]
            VALUE1,
            #[doc = "Receiver noise has been detected."]
            VALUE2,
        }
        impl RNSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RNSW::VALUE1 => false,
                    RNSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RNSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RNSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RNSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Receiver noise has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RNSW::VALUE1)
            }
            #[doc = "Receiver noise has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RNSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FER0`"]
        pub enum FER0W {
            #[doc = "A format error 0 has not been detected."]
            VALUE1,
            #[doc = "A format error 0 has been detected."]
            VALUE2,
        }
        impl FER0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FER0W::VALUE1 => false,
                    FER0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FER0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _FER0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FER0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A format error 0 has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FER0W::VALUE1)
            }
            #[doc = "A format error 0 has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FER0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FER1`"]
        pub enum FER1W {
            #[doc = "A format error 1 has not been detected."]
            VALUE1,
            #[doc = "A format error 1 has been detected."]
            VALUE2,
        }
        impl FER1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FER1W::VALUE1 => false,
                    FER1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FER1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _FER1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FER1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A format error 1 has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FER1W::VALUE1)
            }
            #[doc = "A format error 1 has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FER1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RFF`"]
        pub enum RFFW {
            #[doc = "The received frame is not yet finished."]
            VALUE1,
            #[doc = "The received frame is finished."]
            VALUE2,
        }
        impl RFFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RFFW::VALUE1 => false,
                    RFFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RFFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RFFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The received frame is not yet finished."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RFFW::VALUE1)
            }
            #[doc = "The received frame is finished."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RFFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TFF`"]
        pub enum TFFW {
            #[doc = "The transmitter frame is not yet finished."]
            VALUE1,
            #[doc = "The transmitter frame is finished."]
            VALUE2,
        }
        impl TFFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TFFW::VALUE1 => false,
                    TFFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TFFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TFFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TFFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The transmitter frame is not yet finished."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TFFW::VALUE1)
            }
            #[doc = "The transmitter frame is finished."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TFFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSIF`"]
        pub enum RSIFW {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSIFW::VALUE1 => false,
                    RSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receiver start event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSIFW::VALUE1)
            }
            #[doc = "A receiver start event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLIF`"]
        pub enum DLIFW {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLIFW::VALUE1 => false,
                    DLIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A data lost event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLIFW::VALUE1)
            }
            #[doc = "A data lost event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSIF`"]
        pub enum TSIFW {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSIFW::VALUE1 => false,
                    TSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit shift event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSIFW::VALUE1)
            }
            #[doc = "A transmit shift event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBIF`"]
        pub enum TBIFW {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBIFW::VALUE1 => false,
                    TBIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit buffer event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBIFW::VALUE1)
            }
            #[doc = "A transmit buffer event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RIF`"]
        pub enum RIFW {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RIFW::VALUE1 => false,
                    RIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RIFW::VALUE1)
            }
            #[doc = "A receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AIF`"]
        pub enum AIFW {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIFW::VALUE1 => false,
                    AIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An alternative receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIFW::VALUE1)
            }
            #[doc = "An alternative receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRGIF`"]
        pub enum BRGIFW {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRGIFW::VALUE1 => false,
                    BRGIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRGIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRGIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRGIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A baud rate generator event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE1)
            }
            #[doc = "A baud rate generator event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Transmission Idle"]
            #[inline]
            pub fn txidle(&self) -> TXIDLER {
                TXIDLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Reception Idle"]
            #[inline]
            pub fn rxidle(&self) -> RXIDLER {
                RXIDLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Synchronization Break Detected"]
            #[inline]
            pub fn sbd(&self) -> SBDR {
                SBDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Collision Detected"]
            #[inline]
            pub fn col(&self) -> COLR {
                COLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Receiver Noise Detected"]
            #[inline]
            pub fn rns(&self) -> RNSR {
                RNSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Format Error in Stop Bit 0"]
            #[inline]
            pub fn fer0(&self) -> FER0R {
                FER0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Format Error in Stop Bit 1"]
            #[inline]
            pub fn fer1(&self) -> FER1R {
                FER1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Receive Frame Finished"]
            #[inline]
            pub fn rff(&self) -> RFFR {
                RFFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Transmitter Frame Finished"]
            #[inline]
            pub fn tff(&self) -> TFFR {
                TFFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Transfer Status BUSY"]
            #[inline]
            pub fn busy(&self) -> BUSYR {
                BUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&self) -> RSIFR {
                RSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&self) -> DLIFR {
                DLIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&self) -> TSIFR {
                TSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&self) -> TBIFR {
                TBIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&self) -> RIFR {
                RIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&self) -> AIFR {
                AIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&self) -> BRGIFR {
                BRGIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Transmission Idle"]
            #[inline]
            pub fn txidle(&mut self) -> _TXIDLEW {
                _TXIDLEW { w: self }
            }
            #[doc = "Bit 1 - Reception Idle"]
            #[inline]
            pub fn rxidle(&mut self) -> _RXIDLEW {
                _RXIDLEW { w: self }
            }
            #[doc = "Bit 2 - Synchronization Break Detected"]
            #[inline]
            pub fn sbd(&mut self) -> _SBDW {
                _SBDW { w: self }
            }
            #[doc = "Bit 3 - Collision Detected"]
            #[inline]
            pub fn col(&mut self) -> _COLW {
                _COLW { w: self }
            }
            #[doc = "Bit 4 - Receiver Noise Detected"]
            #[inline]
            pub fn rns(&mut self) -> _RNSW {
                _RNSW { w: self }
            }
            #[doc = "Bit 5 - Format Error in Stop Bit 0"]
            #[inline]
            pub fn fer0(&mut self) -> _FER0W {
                _FER0W { w: self }
            }
            #[doc = "Bit 6 - Format Error in Stop Bit 1"]
            #[inline]
            pub fn fer1(&mut self) -> _FER1W {
                _FER1W { w: self }
            }
            #[doc = "Bit 7 - Receive Frame Finished"]
            #[inline]
            pub fn rff(&mut self) -> _RFFW {
                _RFFW { w: self }
            }
            #[doc = "Bit 8 - Transmitter Frame Finished"]
            #[inline]
            pub fn tff(&mut self) -> _TFFW {
                _TFFW { w: self }
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&mut self) -> _RSIFW {
                _RSIFW { w: self }
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&mut self) -> _DLIFW {
                _DLIFW { w: self }
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&mut self) -> _TSIFW {
                _TSIFW { w: self }
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&mut self) -> _TBIFW {
                _TBIFW { w: self }
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&mut self) -> _RIFW {
                _RIFW { w: self }
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&mut self) -> _AIFW {
                _AIFW { w: self }
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&mut self) -> _BRGIFW {
                _BRGIFW { w: self }
            }
        }
    }
    #[doc = "Protocol Status Register [SSC Mode]"]
    pub struct PSR_SSCMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Status Register [SSC Mode]"]
    pub mod psr_sscmode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSR_SSCMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MSLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSLSR {
            #[doc = "The internal signal MSLS is inactive (0)."]
            VALUE1,
            #[doc = "The internal signal MSLS is active (1)."]
            VALUE2,
        }
        impl MSLSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSLSR::VALUE1 => false,
                    MSLSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSLSR {
                match value {
                    false => MSLSR::VALUE1,
                    true => MSLSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSLSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DX2S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DX2SR {
            #[doc = "DX2S is 0."]
            VALUE1,
            #[doc = "DX2S is 1."]
            VALUE2,
        }
        impl DX2SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DX2SR::VALUE1 => false,
                    DX2SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DX2SR {
                match value {
                    false => DX2SR::VALUE1,
                    true => DX2SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DX2SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DX2SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSLSEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSLSEVR {
            #[doc = "The MSLS signal has not changed its state."]
            VALUE1,
            #[doc = "The MSLS signal has changed its state."]
            VALUE2,
        }
        impl MSLSEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSLSEVR::VALUE1 => false,
                    MSLSEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSLSEVR {
                match value {
                    false => MSLSEVR::VALUE1,
                    true => MSLSEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSLSEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSLSEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DX2TEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DX2TEVR {
            #[doc = "The DX2T signal has not been activated."]
            VALUE1,
            #[doc = "The DX2T signal has been activated."]
            VALUE2,
        }
        impl DX2TEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DX2TEVR::VALUE1 => false,
                    DX2TEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DX2TEVR {
                match value {
                    false => DX2TEVR::VALUE1,
                    true => DX2TEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DX2TEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DX2TEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PARERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PARERRR {
            #[doc = "A parity error event has not been activated."]
            VALUE1,
            #[doc = "A parity error event has been activated."]
            VALUE2,
        }
        impl PARERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PARERRR::VALUE1 => false,
                    PARERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PARERRR {
                match value {
                    false => PARERRR::VALUE1,
                    true => PARERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PARERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PARERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSIFR {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSIFR::VALUE1 => false,
                    RSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSIFR {
                match value {
                    false => RSIFR::VALUE1,
                    true => RSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLIFR {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLIFR::VALUE1 => false,
                    DLIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLIFR {
                match value {
                    false => DLIFR::VALUE1,
                    true => DLIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSIFR {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSIFR::VALUE1 => false,
                    TSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSIFR {
                match value {
                    false => TSIFR::VALUE1,
                    true => TSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBIFR {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBIFR::VALUE1 => false,
                    TBIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBIFR {
                match value {
                    false => TBIFR::VALUE1,
                    true => TBIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RIFR {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RIFR::VALUE1 => false,
                    RIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RIFR {
                match value {
                    false => RIFR::VALUE1,
                    true => RIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIFR {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIFR::VALUE1 => false,
                    AIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIFR {
                match value {
                    false => AIFR::VALUE1,
                    true => AIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRGIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRGIFR {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRGIFR::VALUE1 => false,
                    BRGIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRGIFR {
                match value {
                    false => BRGIFR::VALUE1,
                    true => BRGIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRGIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRGIFR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `MSLS`"]
        pub enum MSLSW {
            #[doc = "The internal signal MSLS is inactive (0)."]
            VALUE1,
            #[doc = "The internal signal MSLS is active (1)."]
            VALUE2,
        }
        impl MSLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSLSW::VALUE1 => false,
                    MSLSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSLSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The internal signal MSLS is inactive (0)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSLSW::VALUE1)
            }
            #[doc = "The internal signal MSLS is active (1)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSLSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DX2S`"]
        pub enum DX2SW {
            #[doc = "DX2S is 0."]
            VALUE1,
            #[doc = "DX2S is 1."]
            VALUE2,
        }
        impl DX2SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DX2SW::VALUE1 => false,
                    DX2SW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DX2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DX2SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DX2SW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DX2S is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DX2SW::VALUE1)
            }
            #[doc = "DX2S is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DX2SW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSLSEV`"]
        pub enum MSLSEVW {
            #[doc = "The MSLS signal has not changed its state."]
            VALUE1,
            #[doc = "The MSLS signal has changed its state."]
            VALUE2,
        }
        impl MSLSEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSLSEVW::VALUE1 => false,
                    MSLSEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSLSEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSLSEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSLSEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The MSLS signal has not changed its state."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSLSEVW::VALUE1)
            }
            #[doc = "The MSLS signal has changed its state."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSLSEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DX2TEV`"]
        pub enum DX2TEVW {
            #[doc = "The DX2T signal has not been activated."]
            VALUE1,
            #[doc = "The DX2T signal has been activated."]
            VALUE2,
        }
        impl DX2TEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DX2TEVW::VALUE1 => false,
                    DX2TEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DX2TEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DX2TEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DX2TEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The DX2T signal has not been activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DX2TEVW::VALUE1)
            }
            #[doc = "The DX2T signal has been activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DX2TEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PARERR`"]
        pub enum PARERRW {
            #[doc = "A parity error event has not been activated."]
            VALUE1,
            #[doc = "A parity error event has been activated."]
            VALUE2,
        }
        impl PARERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PARERRW::VALUE1 => false,
                    PARERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PARERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PARERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PARERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A parity error event has not been activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PARERRW::VALUE1)
            }
            #[doc = "A parity error event has been activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PARERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSIF`"]
        pub enum RSIFW {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSIFW::VALUE1 => false,
                    RSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receiver start event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSIFW::VALUE1)
            }
            #[doc = "A receiver start event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLIF`"]
        pub enum DLIFW {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLIFW::VALUE1 => false,
                    DLIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A data lost event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLIFW::VALUE1)
            }
            #[doc = "A data lost event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSIF`"]
        pub enum TSIFW {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSIFW::VALUE1 => false,
                    TSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit shift event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSIFW::VALUE1)
            }
            #[doc = "A transmit shift event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBIF`"]
        pub enum TBIFW {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBIFW::VALUE1 => false,
                    TBIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit buffer event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBIFW::VALUE1)
            }
            #[doc = "A transmit buffer event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RIF`"]
        pub enum RIFW {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RIFW::VALUE1 => false,
                    RIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RIFW::VALUE1)
            }
            #[doc = "A receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AIF`"]
        pub enum AIFW {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIFW::VALUE1 => false,
                    AIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An alternative receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIFW::VALUE1)
            }
            #[doc = "An alternative receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRGIF`"]
        pub enum BRGIFW {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRGIFW::VALUE1 => false,
                    BRGIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRGIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRGIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRGIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A baud rate generator event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE1)
            }
            #[doc = "A baud rate generator event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - MSLS Status"]
            #[inline]
            pub fn msls(&self) -> MSLSR {
                MSLSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - DX2S Status"]
            #[inline]
            pub fn dx2s(&self) -> DX2SR {
                DX2SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - MSLS Event Detected"]
            #[inline]
            pub fn mslsev(&self) -> MSLSEVR {
                MSLSEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - DX2T Event Detected"]
            #[inline]
            pub fn dx2tev(&self) -> DX2TEVR {
                DX2TEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Parity Error Event Detected"]
            #[inline]
            pub fn parerr(&self) -> PARERRR {
                PARERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&self) -> RSIFR {
                RSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&self) -> DLIFR {
                DLIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&self) -> TSIFR {
                TSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&self) -> TBIFR {
                TBIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&self) -> RIFR {
                RIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&self) -> AIFR {
                AIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&self) -> BRGIFR {
                BRGIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - MSLS Status"]
            #[inline]
            pub fn msls(&mut self) -> _MSLSW {
                _MSLSW { w: self }
            }
            #[doc = "Bit 1 - DX2S Status"]
            #[inline]
            pub fn dx2s(&mut self) -> _DX2SW {
                _DX2SW { w: self }
            }
            #[doc = "Bit 2 - MSLS Event Detected"]
            #[inline]
            pub fn mslsev(&mut self) -> _MSLSEVW {
                _MSLSEVW { w: self }
            }
            #[doc = "Bit 3 - DX2T Event Detected"]
            #[inline]
            pub fn dx2tev(&mut self) -> _DX2TEVW {
                _DX2TEVW { w: self }
            }
            #[doc = "Bit 4 - Parity Error Event Detected"]
            #[inline]
            pub fn parerr(&mut self) -> _PARERRW {
                _PARERRW { w: self }
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&mut self) -> _RSIFW {
                _RSIFW { w: self }
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&mut self) -> _DLIFW {
                _DLIFW { w: self }
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&mut self) -> _TSIFW {
                _TSIFW { w: self }
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&mut self) -> _TBIFW {
                _TBIFW { w: self }
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&mut self) -> _RIFW {
                _RIFW { w: self }
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&mut self) -> _AIFW {
                _AIFW { w: self }
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&mut self) -> _BRGIFW {
                _BRGIFW { w: self }
            }
        }
    }
    #[doc = "Protocol Status Register [IIC Mode]"]
    pub struct PSR_IICMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Status Register [IIC Mode]"]
    pub mod psr_iicmode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSR_IICMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SLSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SLSELR {
            #[doc = "The device is not selected as slave."]
            VALUE1,
            #[doc = "The device is selected as slave."]
            VALUE2,
        }
        impl SLSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SLSELR::VALUE1 => false,
                    SLSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SLSELR {
                match value {
                    false => SLSELR::VALUE1,
                    true => SLSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SLSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SLSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WTDF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WTDFR {
            #[doc = "A wrong TDF code has not been found."]
            VALUE1,
            #[doc = "A wrong TDF code has been found."]
            VALUE2,
        }
        impl WTDFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WTDFR::VALUE1 => false,
                    WTDFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WTDFR {
                match value {
                    false => WTDFR::VALUE1,
                    true => WTDFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WTDFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WTDFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCRR {
            #[doc = "A start condition has not yet been detected."]
            VALUE1,
            #[doc = "A start condition has been detected."]
            VALUE2,
        }
        impl SCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCRR::VALUE1 => false,
                    SCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCRR {
                match value {
                    false => SCRR::VALUE1,
                    true => SCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RSCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSCRR {
            #[doc = "A repeated start condition has not yet been detected."]
            VALUE1,
            #[doc = "A repeated start condition has been detected."]
            VALUE2,
        }
        impl RSCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSCRR::VALUE1 => false,
                    RSCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSCRR {
                match value {
                    false => RSCRR::VALUE1,
                    true => RSCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCRR {
            #[doc = "A stop condition has not yet been detected."]
            VALUE1,
            #[doc = "A stop condition has been detected."]
            VALUE2,
        }
        impl PCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PCRR::VALUE1 => false,
                    PCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PCRR {
                match value {
                    false => PCRR::VALUE1,
                    true => PCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NACK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NACKR {
            #[doc = "A non-acknowledge has not been received."]
            VALUE1,
            #[doc = "A non-acknowledge has been received."]
            VALUE2,
        }
        impl NACKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NACKR::VALUE1 => false,
                    NACKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NACKR {
                match value {
                    false => NACKR::VALUE1,
                    true => NACKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NACKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NACKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ARL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARLR {
            #[doc = "An arbitration has not been lost."]
            VALUE1,
            #[doc = "An arbitration has been lost."]
            VALUE2,
        }
        impl ARLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ARLR::VALUE1 => false,
                    ARLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ARLR {
                match value {
                    false => ARLR::VALUE1,
                    true => ARLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRRR {
            #[doc = "A slave read request has not been detected."]
            VALUE1,
            #[doc = "A slave read request has been detected."]
            VALUE2,
        }
        impl SRRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRRR::VALUE1 => false,
                    SRRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRRR {
                match value {
                    false => SRRR::VALUE1,
                    true => SRRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERRR {
            #[doc = "An IIC error has not been detected."]
            VALUE1,
            #[doc = "An IIC error has been detected."]
            VALUE2,
        }
        impl ERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERRR::VALUE1 => false,
                    ERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERRR {
                match value {
                    false => ERRR::VALUE1,
                    true => ERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ACK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ACKR {
            #[doc = "An acknowledge has not been received."]
            VALUE1,
            #[doc = "An acknowledge has been received."]
            VALUE2,
        }
        impl ACKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ACKR::VALUE1 => false,
                    ACKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ACKR {
                match value {
                    false => ACKR::VALUE1,
                    true => ACKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ACKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ACKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSIFR {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSIFR::VALUE1 => false,
                    RSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSIFR {
                match value {
                    false => RSIFR::VALUE1,
                    true => RSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLIFR {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLIFR::VALUE1 => false,
                    DLIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLIFR {
                match value {
                    false => DLIFR::VALUE1,
                    true => DLIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSIFR {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSIFR::VALUE1 => false,
                    TSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSIFR {
                match value {
                    false => TSIFR::VALUE1,
                    true => TSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBIFR {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBIFR::VALUE1 => false,
                    TBIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBIFR {
                match value {
                    false => TBIFR::VALUE1,
                    true => TBIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RIFR {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RIFR::VALUE1 => false,
                    RIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RIFR {
                match value {
                    false => RIFR::VALUE1,
                    true => RIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIFR {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIFR::VALUE1 => false,
                    AIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIFR {
                match value {
                    false => AIFR::VALUE1,
                    true => AIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRGIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRGIFR {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRGIFR::VALUE1 => false,
                    BRGIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRGIFR {
                match value {
                    false => BRGIFR::VALUE1,
                    true => BRGIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRGIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRGIFR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SLSEL`"]
        pub enum SLSELW {
            #[doc = "The device is not selected as slave."]
            VALUE1,
            #[doc = "The device is selected as slave."]
            VALUE2,
        }
        impl SLSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SLSELW::VALUE1 => false,
                    SLSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SLSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The device is not selected as slave."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SLSELW::VALUE1)
            }
            #[doc = "The device is selected as slave."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SLSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WTDF`"]
        pub enum WTDFW {
            #[doc = "A wrong TDF code has not been found."]
            VALUE1,
            #[doc = "A wrong TDF code has been found."]
            VALUE2,
        }
        impl WTDFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WTDFW::VALUE1 => false,
                    WTDFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WTDFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WTDFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WTDFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A wrong TDF code has not been found."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WTDFW::VALUE1)
            }
            #[doc = "A wrong TDF code has been found."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WTDFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCR`"]
        pub enum SCRW {
            #[doc = "A start condition has not yet been detected."]
            VALUE1,
            #[doc = "A start condition has been detected."]
            VALUE2,
        }
        impl SCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCRW::VALUE1 => false,
                    SCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A start condition has not yet been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCRW::VALUE1)
            }
            #[doc = "A start condition has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSCR`"]
        pub enum RSCRW {
            #[doc = "A repeated start condition has not yet been detected."]
            VALUE1,
            #[doc = "A repeated start condition has been detected."]
            VALUE2,
        }
        impl RSCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSCRW::VALUE1 => false,
                    RSCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A repeated start condition has not yet been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSCRW::VALUE1)
            }
            #[doc = "A repeated start condition has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCR`"]
        pub enum PCRW {
            #[doc = "A stop condition has not yet been detected."]
            VALUE1,
            #[doc = "A stop condition has been detected."]
            VALUE2,
        }
        impl PCRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PCRW::VALUE1 => false,
                    PCRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A stop condition has not yet been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCRW::VALUE1)
            }
            #[doc = "A stop condition has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NACK`"]
        pub enum NACKW {
            #[doc = "A non-acknowledge has not been received."]
            VALUE1,
            #[doc = "A non-acknowledge has been received."]
            VALUE2,
        }
        impl NACKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NACKW::VALUE1 => false,
                    NACKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NACKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NACKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NACKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A non-acknowledge has not been received."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NACKW::VALUE1)
            }
            #[doc = "A non-acknowledge has been received."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NACKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARL`"]
        pub enum ARLW {
            #[doc = "An arbitration has not been lost."]
            VALUE1,
            #[doc = "An arbitration has been lost."]
            VALUE2,
        }
        impl ARLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ARLW::VALUE1 => false,
                    ARLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An arbitration has not been lost."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARLW::VALUE1)
            }
            #[doc = "An arbitration has been lost."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRR`"]
        pub enum SRRW {
            #[doc = "A slave read request has not been detected."]
            VALUE1,
            #[doc = "A slave read request has been detected."]
            VALUE2,
        }
        impl SRRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRRW::VALUE1 => false,
                    SRRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A slave read request has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRRW::VALUE1)
            }
            #[doc = "A slave read request has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERR`"]
        pub enum ERRW {
            #[doc = "An IIC error has not been detected."]
            VALUE1,
            #[doc = "An IIC error has been detected."]
            VALUE2,
        }
        impl ERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERRW::VALUE1 => false,
                    ERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An IIC error has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERRW::VALUE1)
            }
            #[doc = "An IIC error has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ACK`"]
        pub enum ACKW {
            #[doc = "An acknowledge has not been received."]
            VALUE1,
            #[doc = "An acknowledge has been received."]
            VALUE2,
        }
        impl ACKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ACKW::VALUE1 => false,
                    ACKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ACKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ACKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ACKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An acknowledge has not been received."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ACKW::VALUE1)
            }
            #[doc = "An acknowledge has been received."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ACKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSIF`"]
        pub enum RSIFW {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSIFW::VALUE1 => false,
                    RSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receiver start event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSIFW::VALUE1)
            }
            #[doc = "A receiver start event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLIF`"]
        pub enum DLIFW {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLIFW::VALUE1 => false,
                    DLIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A data lost event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLIFW::VALUE1)
            }
            #[doc = "A data lost event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSIF`"]
        pub enum TSIFW {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSIFW::VALUE1 => false,
                    TSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit shift event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSIFW::VALUE1)
            }
            #[doc = "A transmit shift event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBIF`"]
        pub enum TBIFW {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBIFW::VALUE1 => false,
                    TBIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit buffer event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBIFW::VALUE1)
            }
            #[doc = "A transmit buffer event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RIF`"]
        pub enum RIFW {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RIFW::VALUE1 => false,
                    RIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RIFW::VALUE1)
            }
            #[doc = "A receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AIF`"]
        pub enum AIFW {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIFW::VALUE1 => false,
                    AIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An alternative receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIFW::VALUE1)
            }
            #[doc = "An alternative receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRGIF`"]
        pub enum BRGIFW {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRGIFW::VALUE1 => false,
                    BRGIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRGIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRGIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRGIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A baud rate generator event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE1)
            }
            #[doc = "A baud rate generator event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Slave Select"]
            #[inline]
            pub fn slsel(&self) -> SLSELR {
                SLSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Wrong TDF Code Found"]
            #[inline]
            pub fn wtdf(&self) -> WTDFR {
                WTDFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Start Condition Received"]
            #[inline]
            pub fn scr(&self) -> SCRR {
                SCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Repeated Start Condition Received"]
            #[inline]
            pub fn rscr(&self) -> RSCRR {
                RSCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Stop Condition Received"]
            #[inline]
            pub fn pcr(&self) -> PCRR {
                PCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Non-Acknowledge Received"]
            #[inline]
            pub fn nack(&self) -> NACKR {
                NACKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Arbitration Lost"]
            #[inline]
            pub fn arl(&self) -> ARLR {
                ARLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Slave Read Request"]
            #[inline]
            pub fn srr(&self) -> SRRR {
                SRRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Error"]
            #[inline]
            pub fn err(&self) -> ERRR {
                ERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Acknowledge Received"]
            #[inline]
            pub fn ack(&self) -> ACKR {
                ACKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&self) -> RSIFR {
                RSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&self) -> DLIFR {
                DLIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&self) -> TSIFR {
                TSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&self) -> TBIFR {
                TBIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&self) -> RIFR {
                RIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&self) -> AIFR {
                AIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&self) -> BRGIFR {
                BRGIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Slave Select"]
            #[inline]
            pub fn slsel(&mut self) -> _SLSELW {
                _SLSELW { w: self }
            }
            #[doc = "Bit 1 - Wrong TDF Code Found"]
            #[inline]
            pub fn wtdf(&mut self) -> _WTDFW {
                _WTDFW { w: self }
            }
            #[doc = "Bit 2 - Start Condition Received"]
            #[inline]
            pub fn scr(&mut self) -> _SCRW {
                _SCRW { w: self }
            }
            #[doc = "Bit 3 - Repeated Start Condition Received"]
            #[inline]
            pub fn rscr(&mut self) -> _RSCRW {
                _RSCRW { w: self }
            }
            #[doc = "Bit 4 - Stop Condition Received"]
            #[inline]
            pub fn pcr(&mut self) -> _PCRW {
                _PCRW { w: self }
            }
            #[doc = "Bit 5 - Non-Acknowledge Received"]
            #[inline]
            pub fn nack(&mut self) -> _NACKW {
                _NACKW { w: self }
            }
            #[doc = "Bit 6 - Arbitration Lost"]
            #[inline]
            pub fn arl(&mut self) -> _ARLW {
                _ARLW { w: self }
            }
            #[doc = "Bit 7 - Slave Read Request"]
            #[inline]
            pub fn srr(&mut self) -> _SRRW {
                _SRRW { w: self }
            }
            #[doc = "Bit 8 - Error"]
            #[inline]
            pub fn err(&mut self) -> _ERRW {
                _ERRW { w: self }
            }
            #[doc = "Bit 9 - Acknowledge Received"]
            #[inline]
            pub fn ack(&mut self) -> _ACKW {
                _ACKW { w: self }
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&mut self) -> _RSIFW {
                _RSIFW { w: self }
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&mut self) -> _DLIFW {
                _DLIFW { w: self }
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&mut self) -> _TSIFW {
                _TSIFW { w: self }
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&mut self) -> _TBIFW {
                _TBIFW { w: self }
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&mut self) -> _RIFW {
                _RIFW { w: self }
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&mut self) -> _AIFW {
                _AIFW { w: self }
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&mut self) -> _BRGIFW {
                _BRGIFW { w: self }
            }
        }
    }
    #[doc = "Protocol Status Register [IIS Mode]"]
    pub struct PSR_IISMODE {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Status Register [IIS Mode]"]
    pub mod psr_iismode {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSR_IISMODE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `WA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAR {
            #[doc = "WA has been sampled 0."]
            VALUE1,
            #[doc = "WA has been sampled 1."]
            VALUE2,
        }
        impl WAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAR::VALUE1 => false,
                    WAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAR {
                match value {
                    false => WAR::VALUE1,
                    true => WAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DX2S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DX2SR {
            #[doc = "DX2S is 0."]
            VALUE1,
            #[doc = "DX2S is 1."]
            VALUE2,
        }
        impl DX2SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DX2SR::VALUE1 => false,
                    DX2SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DX2SR {
                match value {
                    false => DX2SR::VALUE1,
                    true => DX2SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DX2SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DX2SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DX2TEV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DX2TEVR {
            #[doc = "The DX2T signal has not been activated."]
            VALUE1,
            #[doc = "The DX2T signal has been activated."]
            VALUE2,
        }
        impl DX2TEVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DX2TEVR::VALUE1 => false,
                    DX2TEVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DX2TEVR {
                match value {
                    false => DX2TEVR::VALUE1,
                    true => DX2TEVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DX2TEVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DX2TEVR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WAFE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WAFER {
            #[doc = "A WA falling edge has not been generated."]
            VALUE1,
            #[doc = "A WA falling edge has been generated."]
            VALUE2,
        }
        impl WAFER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WAFER::VALUE1 => false,
                    WAFER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WAFER {
                match value {
                    false => WAFER::VALUE1,
                    true => WAFER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WAFER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WAFER::VALUE2
            }
        }
        #[doc = "Possible values of the field `WARE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WARER {
            #[doc = "A WA rising edge has not been generated."]
            VALUE1,
            #[doc = "A WA rising edge has been generated."]
            VALUE2,
        }
        impl WARER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WARER::VALUE1 => false,
                    WARER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WARER {
                match value {
                    false => WARER::VALUE1,
                    true => WARER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WARER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WARER::VALUE2
            }
        }
        #[doc = "Possible values of the field `END`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDR {
            #[doc = "The WA generation has not yet ended (if it is running and WAGEN has been cleared)."]
            VALUE1,
            #[doc = "The WA generation has ended (if it has been running)."]
            VALUE2,
        }
        impl ENDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENDR::VALUE1 => false,
                    ENDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENDR {
                match value {
                    false => ENDR::VALUE1,
                    true => ENDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RSIFR {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RSIFR::VALUE1 => false,
                    RSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RSIFR {
                match value {
                    false => RSIFR::VALUE1,
                    true => RSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLIFR {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLIFR::VALUE1 => false,
                    DLIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLIFR {
                match value {
                    false => DLIFR::VALUE1,
                    true => DLIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSIFR {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSIFR::VALUE1 => false,
                    TSIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSIFR {
                match value {
                    false => TSIFR::VALUE1,
                    true => TSIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBIFR {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBIFR::VALUE1 => false,
                    TBIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBIFR {
                match value {
                    false => TBIFR::VALUE1,
                    true => TBIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RIFR {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RIFR::VALUE1 => false,
                    RIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RIFR {
                match value {
                    false => RIFR::VALUE1,
                    true => RIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `AIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum AIFR {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    AIFR::VALUE1 => false,
                    AIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> AIFR {
                match value {
                    false => AIFR::VALUE1,
                    true => AIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == AIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == AIFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BRGIF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BRGIFR {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BRGIFR::VALUE1 => false,
                    BRGIFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BRGIFR {
                match value {
                    false => BRGIFR::VALUE1,
                    true => BRGIFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BRGIFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BRGIFR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `WA`"]
        pub enum WAW {
            #[doc = "WA has been sampled 0."]
            VALUE1,
            #[doc = "WA has been sampled 1."]
            VALUE2,
        }
        impl WAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAW::VALUE1 => false,
                    WAW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "WA has been sampled 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAW::VALUE1)
            }
            #[doc = "WA has been sampled 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DX2S`"]
        pub enum DX2SW {
            #[doc = "DX2S is 0."]
            VALUE1,
            #[doc = "DX2S is 1."]
            VALUE2,
        }
        impl DX2SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DX2SW::VALUE1 => false,
                    DX2SW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DX2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DX2SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DX2SW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DX2S is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DX2SW::VALUE1)
            }
            #[doc = "DX2S is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DX2SW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DX2TEV`"]
        pub enum DX2TEVW {
            #[doc = "The DX2T signal has not been activated."]
            VALUE1,
            #[doc = "The DX2T signal has been activated."]
            VALUE2,
        }
        impl DX2TEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DX2TEVW::VALUE1 => false,
                    DX2TEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DX2TEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DX2TEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DX2TEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The DX2T signal has not been activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DX2TEVW::VALUE1)
            }
            #[doc = "The DX2T signal has been activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DX2TEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WAFE`"]
        pub enum WAFEW {
            #[doc = "A WA falling edge has not been generated."]
            VALUE1,
            #[doc = "A WA falling edge has been generated."]
            VALUE2,
        }
        impl WAFEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAFEW::VALUE1 => false,
                    WAFEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAFEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAFEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAFEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A WA falling edge has not been generated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAFEW::VALUE1)
            }
            #[doc = "A WA falling edge has been generated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAFEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WARE`"]
        pub enum WAREW {
            #[doc = "A WA rising edge has not been generated."]
            VALUE1,
            #[doc = "A WA rising edge has been generated."]
            VALUE2,
        }
        impl WAREW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WAREW::VALUE1 => false,
                    WAREW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WAREW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WAREW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WAREW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A WA rising edge has not been generated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WAREW::VALUE1)
            }
            #[doc = "A WA rising edge has been generated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WAREW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `END`"]
        pub enum ENDW {
            #[doc = "The WA generation has not yet ended (if it is running and WAGEN has been cleared)."]
            VALUE1,
            #[doc = "The WA generation has ended (if it has been running)."]
            VALUE2,
        }
        impl ENDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENDW::VALUE1 => false,
                    ENDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The WA generation has not yet ended (if it is running and WAGEN has been cleared)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENDW::VALUE1)
            }
            #[doc = "The WA generation has ended (if it has been running)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RSIF`"]
        pub enum RSIFW {
            #[doc = "A receiver start event has not occurred."]
            VALUE1,
            #[doc = "A receiver start event has occurred."]
            VALUE2,
        }
        impl RSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RSIFW::VALUE1 => false,
                    RSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receiver start event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RSIFW::VALUE1)
            }
            #[doc = "A receiver start event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLIF`"]
        pub enum DLIFW {
            #[doc = "A data lost event has not occurred."]
            VALUE1,
            #[doc = "A data lost event has occurred."]
            VALUE2,
        }
        impl DLIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLIFW::VALUE1 => false,
                    DLIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A data lost event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLIFW::VALUE1)
            }
            #[doc = "A data lost event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSIF`"]
        pub enum TSIFW {
            #[doc = "A transmit shift event has not occurred."]
            VALUE1,
            #[doc = "A transmit shift event has occurred."]
            VALUE2,
        }
        impl TSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSIFW::VALUE1 => false,
                    TSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit shift event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSIFW::VALUE1)
            }
            #[doc = "A transmit shift event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBIF`"]
        pub enum TBIFW {
            #[doc = "A transmit buffer event has not occurred."]
            VALUE1,
            #[doc = "A transmit buffer event has occurred."]
            VALUE2,
        }
        impl TBIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBIFW::VALUE1 => false,
                    TBIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit buffer event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBIFW::VALUE1)
            }
            #[doc = "A transmit buffer event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RIF`"]
        pub enum RIFW {
            #[doc = "A receive event has not occurred."]
            VALUE1,
            #[doc = "A receive event has occurred."]
            VALUE2,
        }
        impl RIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RIFW::VALUE1 => false,
                    RIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RIFW::VALUE1)
            }
            #[doc = "A receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AIF`"]
        pub enum AIFW {
            #[doc = "An alternative receive event has not occurred."]
            VALUE1,
            #[doc = "An alternative receive event has occurred."]
            VALUE2,
        }
        impl AIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AIFW::VALUE1 => false,
                    AIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An alternative receive event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AIFW::VALUE1)
            }
            #[doc = "An alternative receive event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BRGIF`"]
        pub enum BRGIFW {
            #[doc = "A baud rate generator event has not occurred."]
            VALUE1,
            #[doc = "A baud rate generator event has occurred."]
            VALUE2,
        }
        impl BRGIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BRGIFW::VALUE1 => false,
                    BRGIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRGIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRGIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BRGIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A baud rate generator event has not occurred."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE1)
            }
            #[doc = "A baud rate generator event has occurred."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BRGIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Word Address"]
            #[inline]
            pub fn wa(&self) -> WAR {
                WAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - DX2S Status"]
            #[inline]
            pub fn dx2s(&self) -> DX2SR {
                DX2SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - DX2T Event Detected"]
            #[inline]
            pub fn dx2tev(&self) -> DX2TEVR {
                DX2TEVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - WA Falling Edge Event"]
            #[inline]
            pub fn wafe(&self) -> WAFER {
                WAFER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - WA Rising Edge Event"]
            #[inline]
            pub fn ware(&self) -> WARER {
                WARER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - WA Generation End"]
            #[inline]
            pub fn end(&self) -> ENDR {
                ENDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&self) -> RSIFR {
                RSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&self) -> DLIFR {
                DLIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&self) -> TSIFR {
                TSIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&self) -> TBIFR {
                TBIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&self) -> RIFR {
                RIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&self) -> AIFR {
                AIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&self) -> BRGIFR {
                BRGIFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Word Address"]
            #[inline]
            pub fn wa(&mut self) -> _WAW {
                _WAW { w: self }
            }
            #[doc = "Bit 1 - DX2S Status"]
            #[inline]
            pub fn dx2s(&mut self) -> _DX2SW {
                _DX2SW { w: self }
            }
            #[doc = "Bit 3 - DX2T Event Detected"]
            #[inline]
            pub fn dx2tev(&mut self) -> _DX2TEVW {
                _DX2TEVW { w: self }
            }
            #[doc = "Bit 4 - WA Falling Edge Event"]
            #[inline]
            pub fn wafe(&mut self) -> _WAFEW {
                _WAFEW { w: self }
            }
            #[doc = "Bit 5 - WA Rising Edge Event"]
            #[inline]
            pub fn ware(&mut self) -> _WAREW {
                _WAREW { w: self }
            }
            #[doc = "Bit 6 - WA Generation End"]
            #[inline]
            pub fn end(&mut self) -> _ENDW {
                _ENDW { w: self }
            }
            #[doc = "Bit 10 - Receiver Start Indication Flag"]
            #[inline]
            pub fn rsif(&mut self) -> _RSIFW {
                _RSIFW { w: self }
            }
            #[doc = "Bit 11 - Data Lost Indication Flag"]
            #[inline]
            pub fn dlif(&mut self) -> _DLIFW {
                _DLIFW { w: self }
            }
            #[doc = "Bit 12 - Transmit Shift Indication Flag"]
            #[inline]
            pub fn tsif(&mut self) -> _TSIFW {
                _TSIFW { w: self }
            }
            #[doc = "Bit 13 - Transmit Buffer Indication Flag"]
            #[inline]
            pub fn tbif(&mut self) -> _TBIFW {
                _TBIFW { w: self }
            }
            #[doc = "Bit 14 - Receive Indication Flag"]
            #[inline]
            pub fn rif(&mut self) -> _RIFW {
                _RIFW { w: self }
            }
            #[doc = "Bit 15 - Alternative Receive Indication Flag"]
            #[inline]
            pub fn aif(&mut self) -> _AIFW {
                _AIFW { w: self }
            }
            #[doc = "Bit 16 - Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn brgif(&mut self) -> _BRGIFW {
                _BRGIFW { w: self }
            }
        }
    }
    #[doc = "Protocol Status Clear Register"]
    pub struct PSCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Protocol Status Clear Register"]
    pub mod pscr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSCR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CST0`"]
        pub enum CST0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST0W::VALUE1 => false,
                    CST0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST0W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST1`"]
        pub enum CST1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST1W::VALUE1 => false,
                    CST1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST1W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST2`"]
        pub enum CST2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST2W::VALUE1 => false,
                    CST2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST2W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST3`"]
        pub enum CST3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST3W::VALUE1 => false,
                    CST3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST3W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST4`"]
        pub enum CST4W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST4W::VALUE1 => false,
                    CST4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST4W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST5`"]
        pub enum CST5W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST5W::VALUE1 => false,
                    CST5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST5W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST6`"]
        pub enum CST6W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST6W::VALUE1 => false,
                    CST6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST6W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST7`"]
        pub enum CST7W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST7W::VALUE1 => false,
                    CST7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST7W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST8`"]
        pub enum CST8W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST8W::VALUE1 => false,
                    CST8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST8W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CST9`"]
        pub enum CST9W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.STx is cleared."]
            VALUE2,
        }
        impl CST9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CST9W::VALUE1 => false,
                    CST9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CST9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CST9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CST9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CST9W::VALUE1)
            }
            #[doc = "Flag PSR.STx is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CST9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CRSIF`"]
        pub enum CRSIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.RSIF is cleared."]
            VALUE2,
        }
        impl CRSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CRSIFW::VALUE1 => false,
                    CRSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CRSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CRSIFW::VALUE1)
            }
            #[doc = "Flag PSR.RSIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CRSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CDLIF`"]
        pub enum CDLIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.DLIF is cleared."]
            VALUE2,
        }
        impl CDLIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CDLIFW::VALUE1 => false,
                    CDLIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CDLIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CDLIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CDLIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CDLIFW::VALUE1)
            }
            #[doc = "Flag PSR.DLIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CDLIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTSIF`"]
        pub enum CTSIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.TSIF is cleared."]
            VALUE2,
        }
        impl CTSIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CTSIFW::VALUE1 => false,
                    CTSIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTSIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTSIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTSIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTSIFW::VALUE1)
            }
            #[doc = "Flag PSR.TSIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTSIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTBIF`"]
        pub enum CTBIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.TBIF is cleared."]
            VALUE2,
        }
        impl CTBIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CTBIFW::VALUE1 => false,
                    CTBIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTBIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTBIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTBIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTBIFW::VALUE1)
            }
            #[doc = "Flag PSR.TBIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTBIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CRIF`"]
        pub enum CRIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.RIF is cleared."]
            VALUE2,
        }
        impl CRIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CRIFW::VALUE1 => false,
                    CRIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CRIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CRIFW::VALUE1)
            }
            #[doc = "Flag PSR.RIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CRIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAIF`"]
        pub enum CAIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.AIF is cleared."]
            VALUE2,
        }
        impl CAIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CAIFW::VALUE1 => false,
                    CAIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAIFW::VALUE1)
            }
            #[doc = "Flag PSR.AIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CBRGIF`"]
        pub enum CBRGIFW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Flag PSR.BRGIF is cleared."]
            VALUE2,
        }
        impl CBRGIFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CBRGIFW::VALUE1 => false,
                    CBRGIFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CBRGIFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CBRGIFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CBRGIFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CBRGIFW::VALUE1)
            }
            #[doc = "Flag PSR.BRGIF is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CBRGIFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Status Flag 0 in PSR"]
            #[inline]
            pub fn cst0(&mut self) -> _CST0W {
                _CST0W { w: self }
            }
            #[doc = "Bit 1 - Clear Status Flag 1 in PSR"]
            #[inline]
            pub fn cst1(&mut self) -> _CST1W {
                _CST1W { w: self }
            }
            #[doc = "Bit 2 - Clear Status Flag 2 in PSR"]
            #[inline]
            pub fn cst2(&mut self) -> _CST2W {
                _CST2W { w: self }
            }
            #[doc = "Bit 3 - Clear Status Flag 3 in PSR"]
            #[inline]
            pub fn cst3(&mut self) -> _CST3W {
                _CST3W { w: self }
            }
            #[doc = "Bit 4 - Clear Status Flag 4 in PSR"]
            #[inline]
            pub fn cst4(&mut self) -> _CST4W {
                _CST4W { w: self }
            }
            #[doc = "Bit 5 - Clear Status Flag 5 in PSR"]
            #[inline]
            pub fn cst5(&mut self) -> _CST5W {
                _CST5W { w: self }
            }
            #[doc = "Bit 6 - Clear Status Flag 6 in PSR"]
            #[inline]
            pub fn cst6(&mut self) -> _CST6W {
                _CST6W { w: self }
            }
            #[doc = "Bit 7 - Clear Status Flag 7 in PSR"]
            #[inline]
            pub fn cst7(&mut self) -> _CST7W {
                _CST7W { w: self }
            }
            #[doc = "Bit 8 - Clear Status Flag 8 in PSR"]
            #[inline]
            pub fn cst8(&mut self) -> _CST8W {
                _CST8W { w: self }
            }
            #[doc = "Bit 9 - Clear Status Flag 9 in PSR"]
            #[inline]
            pub fn cst9(&mut self) -> _CST9W {
                _CST9W { w: self }
            }
            #[doc = "Bit 10 - Clear Receiver Start Indication Flag"]
            #[inline]
            pub fn crsif(&mut self) -> _CRSIFW {
                _CRSIFW { w: self }
            }
            #[doc = "Bit 11 - Clear Data Lost Indication Flag"]
            #[inline]
            pub fn cdlif(&mut self) -> _CDLIFW {
                _CDLIFW { w: self }
            }
            #[doc = "Bit 12 - Clear Transmit Shift Indication Flag"]
            #[inline]
            pub fn ctsif(&mut self) -> _CTSIFW {
                _CTSIFW { w: self }
            }
            #[doc = "Bit 13 - Clear Transmit Buffer Indication Flag"]
            #[inline]
            pub fn ctbif(&mut self) -> _CTBIFW {
                _CTBIFW { w: self }
            }
            #[doc = "Bit 14 - Clear Receive Indication Flag"]
            #[inline]
            pub fn crif(&mut self) -> _CRIFW {
                _CRIFW { w: self }
            }
            #[doc = "Bit 15 - Clear Alternative Receive Indication Flag"]
            #[inline]
            pub fn caif(&mut self) -> _CAIFW {
                _CAIFW { w: self }
            }
            #[doc = "Bit 16 - Clear Baud Rate Generator Indication Flag"]
            #[inline]
            pub fn cbrgif(&mut self) -> _CBRGIFW {
                _CBRGIFW { w: self }
            }
        }
    }
    #[doc = "Receiver Buffer Status Register"]
    pub struct RBUFSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Status Register"]
    pub mod rbufsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RBUFSR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct WLENR {
            bits: u8,
        }
        impl WLENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SOFR {
            bits: bool,
        }
        impl SOFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PARR {
            bits: bool,
        }
        impl PARR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PERRR {
            bits: bool,
        }
        impl PERRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RDV0R {
            bits: bool,
        }
        impl RDV0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct RDV1R {
            bits: bool,
        }
        impl RDV1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSR {
            bits: bool,
        }
        impl DSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Received Data Word Length in RBUF or RBUFD"]
            #[inline]
            pub fn wlen(&self) -> WLENR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                WLENR { bits }
            }
            #[doc = "Bit 6 - Start of Frame in RBUF or RBUFD"]
            #[inline]
            pub fn sof(&self) -> SOFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SOFR { bits }
            }
            #[doc = "Bit 8 - Protocol-Related Argument in RBUF or RBUFD"]
            #[inline]
            pub fn par(&self) -> PARR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PARR { bits }
            }
            #[doc = "Bit 9 - Protocol-related Error in RBUF or RBUFD"]
            #[inline]
            pub fn perr(&self) -> PERRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PERRR { bits }
            }
            #[doc = "Bit 13 - Receive Data Valid in RBUF or RBUFD"]
            #[inline]
            pub fn rdv0(&self) -> RDV0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RDV0R { bits }
            }
            #[doc = "Bit 14 - Receive Data Valid in RBUF or RBUFD"]
            #[inline]
            pub fn rdv1(&self) -> RDV1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RDV1R { bits }
            }
            #[doc = "Bit 15 - Data Source of RBUF or RBUFD"]
            #[inline]
            pub fn ds(&self) -> DSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DSR { bits }
            }
        }
    }
    #[doc = "Receiver Buffer Register"]
    pub struct RBUF {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Register"]
    pub mod rbuf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RBUF {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSRR {
            bits: u16,
        }
        impl DSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Received Data"]
            #[inline]
            pub fn dsr(&self) -> DSRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSRR { bits }
            }
        }
    }
    #[doc = "Receiver Buffer Register for Debugger"]
    pub struct RBUFD {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Register for Debugger"]
    pub mod rbufd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RBUFD {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSRR {
            bits: u16,
        }
        impl DSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Data from Shift Register"]
            #[inline]
            pub fn dsr(&self) -> DSRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSRR { bits }
            }
        }
    }
    #[doc = "Receiver Buffer Register 0"]
    pub struct RBUF0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Register 0"]
    pub mod rbuf0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RBUF0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSR0R {
            bits: u16,
        }
        impl DSR0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Data of Shift Registers 0[3:0]"]
            #[inline]
            pub fn dsr0(&self) -> DSR0R {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSR0R { bits }
            }
        }
    }
    #[doc = "Receiver Buffer Register 1"]
    pub struct RBUF1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Register 1"]
    pub mod rbuf1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RBUF1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSR1R {
            bits: u16,
        }
        impl DSR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Data of Shift Registers 1[3:0]"]
            #[inline]
            pub fn dsr1(&self) -> DSR1R {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSR1R { bits }
            }
        }
    }
    #[doc = "Receiver Buffer 01 Status Register"]
    pub struct RBUF01SR {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer 01 Status Register"]
    pub mod rbuf01sr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RBUF01SR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct WLEN0R {
            bits: u8,
        }
        impl WLEN0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SOF0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SOF0R {
            #[doc = "The data in RBUF0 has not been the first data word of a data frame."]
            VALUE1,
            #[doc = "The data in RBUF0 has been the first data word of a data frame."]
            VALUE2,
        }
        impl SOF0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SOF0R::VALUE1 => false,
                    SOF0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SOF0R {
                match value {
                    false => SOF0R::VALUE1,
                    true => SOF0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SOF0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SOF0R::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAR0R {
            bits: bool,
        }
        impl PAR0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `PERR0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PERR0R {
            #[doc = "The received protocol-related argument PAR matches the expected value. The reception of the data word sets bit PSR.RIF and can generate a receive interrupt."]
            VALUE1,
            #[doc = "The received protocol-related argument PAR does not match the expected value. The reception of the data word sets bit PSR.AIF and can generate an alternative receive interrupt."]
            VALUE2,
        }
        impl PERR0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PERR0R::VALUE1 => false,
                    PERR0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PERR0R {
                match value {
                    false => PERR0R::VALUE1,
                    true => PERR0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PERR0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PERR0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RDV00`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RDV00R {
            #[doc = "Register RBUF0 does not contain data that has not yet been read out."]
            VALUE1,
            #[doc = "Register RBUF0 contains data that has not yet been read out."]
            VALUE2,
        }
        impl RDV00R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RDV00R::VALUE1 => false,
                    RDV00R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RDV00R {
                match value {
                    false => RDV00R::VALUE1,
                    true => RDV00R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RDV00R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RDV00R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RDV01`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RDV01R {
            #[doc = "Register RBUF1 does not contain data that has not yet been read out."]
            VALUE1,
            #[doc = "Register RBUF1 contains data that has not yet been read out."]
            VALUE2,
        }
        impl RDV01R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RDV01R::VALUE1 => false,
                    RDV01R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RDV01R {
                match value {
                    false => RDV01R::VALUE1,
                    true => RDV01R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RDV01R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RDV01R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DS0R {
            #[doc = "The register RBUF contains the data of RBUF0 (same for associated status information)."]
            VALUE1,
            #[doc = "The register RBUF contains the data of RBUF1 (same for associated status information)."]
            VALUE2,
        }
        impl DS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DS0R::VALUE1 => false,
                    DS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DS0R {
                match value {
                    false => DS0R::VALUE1,
                    true => DS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `WLEN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WLEN1R {
            #[doc = "One bit has been received."]
            VALUE1,
            #[doc = "Sixteen bits have been received."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl WLEN1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    WLEN1R::VALUE1 => 0,
                    WLEN1R::VALUE2 => 0x0f,
                    WLEN1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> WLEN1R {
                match value {
                    0 => WLEN1R::VALUE1,
                    15 => WLEN1R::VALUE2,
                    i => WLEN1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WLEN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WLEN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `SOF1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SOF1R {
            #[doc = "The data in RBUF1 has not been the first data word of a data frame."]
            VALUE1,
            #[doc = "The data in RBUF1 has been the first data word of a data frame."]
            VALUE2,
        }
        impl SOF1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SOF1R::VALUE1 => false,
                    SOF1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SOF1R {
                match value {
                    false => SOF1R::VALUE1,
                    true => SOF1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SOF1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SOF1R::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAR1R {
            bits: bool,
        }
        impl PAR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `PERR1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PERR1R {
            #[doc = "The received protocol-related argument PAR matches the expected value. The reception of the data word sets bit PSR.RIF and can generate a receive interrupt."]
            VALUE1,
            #[doc = "The received protocol-related argument PAR does not match the expected value. The reception of the data word sets bit PSR.AIF and can generate an alternative receive interrupt."]
            VALUE2,
        }
        impl PERR1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PERR1R::VALUE1 => false,
                    PERR1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PERR1R {
                match value {
                    false => PERR1R::VALUE1,
                    true => PERR1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PERR1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PERR1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RDV10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RDV10R {
            #[doc = "Register RBUF0 does not contain data that has not yet been read out."]
            VALUE1,
            #[doc = "Register RBUF0 contains data that has not yet been read out."]
            VALUE2,
        }
        impl RDV10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RDV10R::VALUE1 => false,
                    RDV10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RDV10R {
                match value {
                    false => RDV10R::VALUE1,
                    true => RDV10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RDV10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RDV10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `RDV11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RDV11R {
            #[doc = "Register RBUF1 does not contain data that has not yet been read out."]
            VALUE1,
            #[doc = "Register RBUF1 contains data that has not yet been read out."]
            VALUE2,
        }
        impl RDV11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RDV11R::VALUE1 => false,
                    RDV11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RDV11R {
                match value {
                    false => RDV11R::VALUE1,
                    true => RDV11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RDV11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RDV11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DS1R {
            #[doc = "The register RBUF contains the data of RBUF0 (same for associated status information)."]
            VALUE1,
            #[doc = "The register RBUF contains the data of RBUF1 (same for associated status information)."]
            VALUE2,
        }
        impl DS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DS1R::VALUE1 => false,
                    DS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DS1R {
                match value {
                    false => DS1R::VALUE1,
                    true => DS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DS1R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Received Data Word Length in RBUF0"]
            #[inline]
            pub fn wlen0(&self) -> WLEN0R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                WLEN0R { bits }
            }
            #[doc = "Bit 6 - Start of Frame in RBUF0"]
            #[inline]
            pub fn sof0(&self) -> SOF0R {
                SOF0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Protocol-Related Argument in RBUF0"]
            #[inline]
            pub fn par0(&self) -> PAR0R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PAR0R { bits }
            }
            #[doc = "Bit 9 - Protocol-related Error in RBUF0"]
            #[inline]
            pub fn perr0(&self) -> PERR0R {
                PERR0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Receive Data Valid in RBUF0"]
            #[inline]
            pub fn rdv00(&self) -> RDV00R {
                RDV00R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Receive Data Valid in RBUF1"]
            #[inline]
            pub fn rdv01(&self) -> RDV01R {
                RDV01R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Data Source"]
            #[inline]
            pub fn ds0(&self) -> DS0R {
                DS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:19 - Received Data Word Length in RBUF1"]
            #[inline]
            pub fn wlen1(&self) -> WLEN1R {
                WLEN1R::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 22 - Start of Frame in RBUF1"]
            #[inline]
            pub fn sof1(&self) -> SOF1R {
                SOF1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Protocol-Related Argument in RBUF1"]
            #[inline]
            pub fn par1(&self) -> PAR1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PAR1R { bits }
            }
            #[doc = "Bit 25 - Protocol-related Error in RBUF1"]
            #[inline]
            pub fn perr1(&self) -> PERR1R {
                PERR1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Receive Data Valid in RBUF0"]
            #[inline]
            pub fn rdv10(&self) -> RDV10R {
                RDV10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Receive Data Valid in RBUF1"]
            #[inline]
            pub fn rdv11(&self) -> RDV11R {
                RDV11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Data Source"]
            #[inline]
            pub fn ds1(&self) -> DS1R {
                DS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Flag Modification Register"]
    pub struct FMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Flag Modification Register"]
    pub mod fmr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FMR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `MTDV`"]
        pub enum MTDVW {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bit TDV is set, TE is unchanged."]
            VALUE2,
            #[doc = "Bits TDV and TE are cleared."]
            VALUE3,
        }
        impl MTDVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MTDVW::VALUE1 => 0,
                    MTDVW::VALUE2 => 1,
                    MTDVW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MTDVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MTDVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MTDVW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MTDVW::VALUE1)
            }
            #[doc = "Bit TDV is set, TE is unchanged."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MTDVW::VALUE2)
            }
            #[doc = "Bits TDV and TE are cleared."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MTDVW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ATVC`"]
        pub enum ATVCW {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bit TCSR.TVC is set."]
            VALUE2,
        }
        impl ATVCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ATVCW::VALUE1 => false,
                    ATVCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ATVCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ATVCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ATVCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ATVCW::VALUE1)
            }
            #[doc = "Bit TCSR.TVC is set."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ATVCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CRDV0`"]
        pub enum CRDV0W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bits RBUF01SR.RDV00 and RBUF01SR.RDV10 are cleared."]
            VALUE2,
        }
        impl CRDV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CRDV0W::VALUE1 => false,
                    CRDV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRDV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRDV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CRDV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CRDV0W::VALUE1)
            }
            #[doc = "Bits RBUF01SR.RDV00 and RBUF01SR.RDV10 are cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CRDV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CRDV1`"]
        pub enum CRDV1W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "Bits RBUF01SR.RDV01 and RBUF01SR.RDV11 are cleared."]
            VALUE2,
        }
        impl CRDV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CRDV1W::VALUE1 => false,
                    CRDV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRDV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRDV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CRDV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CRDV1W::VALUE1)
            }
            #[doc = "Bits RBUF01SR.RDV01 and RBUF01SR.RDV11 are cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CRDV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIO0`"]
        pub enum SIO0W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "The service request output SRx is activated."]
            VALUE2,
        }
        impl SIO0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIO0W::VALUE1 => false,
                    SIO0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIO0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIO0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIO0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIO0W::VALUE1)
            }
            #[doc = "The service request output SRx is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIO0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIO1`"]
        pub enum SIO1W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "The service request output SRx is activated."]
            VALUE2,
        }
        impl SIO1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIO1W::VALUE1 => false,
                    SIO1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIO1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIO1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIO1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIO1W::VALUE1)
            }
            #[doc = "The service request output SRx is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIO1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIO2`"]
        pub enum SIO2W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "The service request output SRx is activated."]
            VALUE2,
        }
        impl SIO2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIO2W::VALUE1 => false,
                    SIO2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIO2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIO2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIO2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIO2W::VALUE1)
            }
            #[doc = "The service request output SRx is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIO2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIO3`"]
        pub enum SIO3W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "The service request output SRx is activated."]
            VALUE2,
        }
        impl SIO3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIO3W::VALUE1 => false,
                    SIO3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIO3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIO3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIO3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIO3W::VALUE1)
            }
            #[doc = "The service request output SRx is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIO3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIO4`"]
        pub enum SIO4W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "The service request output SRx is activated."]
            VALUE2,
        }
        impl SIO4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIO4W::VALUE1 => false,
                    SIO4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIO4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIO4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIO4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIO4W::VALUE1)
            }
            #[doc = "The service request output SRx is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIO4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIO5`"]
        pub enum SIO5W {
            #[doc = "No action."]
            VALUE1,
            #[doc = "The service request output SRx is activated."]
            VALUE2,
        }
        impl SIO5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIO5W::VALUE1 => false,
                    SIO5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIO5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIO5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIO5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIO5W::VALUE1)
            }
            #[doc = "The service request output SRx is activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIO5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Modify Transmit Data Valid"]
            #[inline]
            pub fn mtdv(&mut self) -> _MTDVW {
                _MTDVW { w: self }
            }
            #[doc = "Bit 4 - Activate Bit TVC"]
            #[inline]
            pub fn atvc(&mut self) -> _ATVCW {
                _ATVCW { w: self }
            }
            #[doc = "Bit 14 - Clear Bits RDV for RBUF0"]
            #[inline]
            pub fn crdv0(&mut self) -> _CRDV0W {
                _CRDV0W { w: self }
            }
            #[doc = "Bit 15 - Clear Bit RDV for RBUF1"]
            #[inline]
            pub fn crdv1(&mut self) -> _CRDV1W {
                _CRDV1W { w: self }
            }
            #[doc = "Bit 16 - Set Interrupt Output SRx"]
            #[inline]
            pub fn sio0(&mut self) -> _SIO0W {
                _SIO0W { w: self }
            }
            #[doc = "Bit 17 - Set Interrupt Output SRx"]
            #[inline]
            pub fn sio1(&mut self) -> _SIO1W {
                _SIO1W { w: self }
            }
            #[doc = "Bit 18 - Set Interrupt Output SRx"]
            #[inline]
            pub fn sio2(&mut self) -> _SIO2W {
                _SIO2W { w: self }
            }
            #[doc = "Bit 19 - Set Interrupt Output SRx"]
            #[inline]
            pub fn sio3(&mut self) -> _SIO3W {
                _SIO3W { w: self }
            }
            #[doc = "Bit 20 - Set Interrupt Output SRx"]
            #[inline]
            pub fn sio4(&mut self) -> _SIO4W {
                _SIO4W { w: self }
            }
            #[doc = "Bit 21 - Set Interrupt Output SRx"]
            #[inline]
            pub fn sio5(&mut self) -> _SIO5W {
                _SIO5W { w: self }
            }
        }
    }
    #[doc = "Transmit Buffer"]
    pub struct TBUF {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmit Buffer"]
    pub mod tbuf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TBUF {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TDATAR {
            bits: u16,
        }
        impl TDATAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _TDATAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TDATAW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Transmit Data"]
            #[inline]
            pub fn tdata(&self) -> TDATAR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TDATAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Transmit Data"]
            #[inline]
            pub fn tdata(&mut self) -> _TDATAW {
                _TDATAW { w: self }
            }
        }
    }
    #[doc = "Bypass Data Register"]
    pub struct BYP {
        register: VolatileCell<u32>,
    }
    #[doc = "Bypass Data Register"]
    pub mod byp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BYP {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BDATAR {
            bits: u16,
        }
        impl BDATAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _BDATAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BDATAW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Bypass Data"]
            #[inline]
            pub fn bdata(&self) -> BDATAR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BDATAR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Bypass Data"]
            #[inline]
            pub fn bdata(&mut self) -> _BDATAW {
                _BDATAW { w: self }
            }
        }
    }
    #[doc = "Bypass Control Register"]
    pub struct BYPCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Bypass Control Register"]
    pub mod bypcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BYPCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BWLER {
            bits: u8,
        }
        impl BWLER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `BDSSM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BDSSMR {
            #[doc = "The bypass data is still considered as valid after it has been loaded into TBUF. The loading of the data into TBUF does not clear BDV."]
            VALUE1,
            #[doc = "The bypass data is considered as invalid after it has been loaded into TBUF. The loading of the data into TBUF clears BDV."]
            VALUE2,
        }
        impl BDSSMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BDSSMR::VALUE1 => false,
                    BDSSMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BDSSMR {
                match value {
                    false => BDSSMR::VALUE1,
                    true => BDSSMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BDSSMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BDSSMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BDEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BDENR {
            #[doc = "The transfer of bypass data is disabled."]
            VALUE1,
            #[doc = "The transfer of bypass data to TBUF is possible. Bypass data will be transferred to TBUF according to its priority if BDV = 1."]
            VALUE2,
            #[doc = "Gated bypass data transfer is enabled. Bypass data will be transferred to TBUF according to its priority if BDV = 1 and while DX2S = 0."]
            VALUE3,
            #[doc = "Gated bypass data transfer is enabled. Bypass data will be transferred to TBUF according to its priority if BDV = 1 and while DX2S = 1."]
            VALUE4,
        }
        impl BDENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BDENR::VALUE1 => 0,
                    BDENR::VALUE2 => 0x01,
                    BDENR::VALUE3 => 0x02,
                    BDENR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BDENR {
                match value {
                    0 => BDENR::VALUE1,
                    1 => BDENR::VALUE2,
                    2 => BDENR::VALUE3,
                    3 => BDENR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BDENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BDENR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BDENR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BDENR::VALUE4
            }
        }
        #[doc = "Possible values of the field `BDVTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BDVTRR {
            #[doc = "Bit BDV is not influenced by DX2T."]
            VALUE1,
            #[doc = "Bit BDV is set if DX2T is active."]
            VALUE2,
        }
        impl BDVTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BDVTRR::VALUE1 => false,
                    BDVTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BDVTRR {
                match value {
                    false => BDVTRR::VALUE1,
                    true => BDVTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BDVTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BDVTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BPRIO`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BPRIOR {
            #[doc = "The transmit FIFO data has a higher priority than the bypass data."]
            VALUE1,
            #[doc = "The bypass data has a higher priority than the transmit FIFO data."]
            VALUE2,
        }
        impl BPRIOR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BPRIOR::VALUE1 => false,
                    BPRIOR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BPRIOR {
                match value {
                    false => BPRIOR::VALUE1,
                    true => BPRIOR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BPRIOR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BPRIOR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BDV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BDVR {
            #[doc = "The bypass data is not valid."]
            VALUE1,
            #[doc = "The bypass data is valid."]
            VALUE2,
        }
        impl BDVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BDVR::VALUE1 => false,
                    BDVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BDVR {
                match value {
                    false => BDVR::VALUE1,
                    true => BDVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BDVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BDVR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct BSELOR {
            bits: u8,
        }
        impl BSELOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct BHPCR {
            bits: u8,
        }
        impl BHPCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWLEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BDSSM`"]
        pub enum BDSSMW {
            #[doc = "The bypass data is still considered as valid after it has been loaded into TBUF. The loading of the data into TBUF does not clear BDV."]
            VALUE1,
            #[doc = "The bypass data is considered as invalid after it has been loaded into TBUF. The loading of the data into TBUF clears BDV."]
            VALUE2,
        }
        impl BDSSMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BDSSMW::VALUE1 => false,
                    BDSSMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BDSSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BDSSMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BDSSMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The bypass data is still considered as valid after it has been loaded into TBUF. The loading of the data into TBUF does not clear BDV."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BDSSMW::VALUE1)
            }
            #[doc = "The bypass data is considered as invalid after it has been loaded into TBUF. The loading of the data into TBUF clears BDV."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BDSSMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BDEN`"]
        pub enum BDENW {
            #[doc = "The transfer of bypass data is disabled."]
            VALUE1,
            #[doc = "The transfer of bypass data to TBUF is possible. Bypass data will be transferred to TBUF according to its priority if BDV = 1."]
            VALUE2,
            #[doc = "Gated bypass data transfer is enabled. Bypass data will be transferred to TBUF according to its priority if BDV = 1 and while DX2S = 0."]
            VALUE3,
            #[doc = "Gated bypass data transfer is enabled. Bypass data will be transferred to TBUF according to its priority if BDV = 1 and while DX2S = 1."]
            VALUE4,
        }
        impl BDENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BDENW::VALUE1 => 0,
                    BDENW::VALUE2 => 1,
                    BDENW::VALUE3 => 2,
                    BDENW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BDENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BDENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BDENW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "The transfer of bypass data is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BDENW::VALUE1)
            }
            #[doc = "The transfer of bypass data to TBUF is possible. Bypass data will be transferred to TBUF according to its priority if BDV = 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BDENW::VALUE2)
            }
            #[doc = "Gated bypass data transfer is enabled. Bypass data will be transferred to TBUF according to its priority if BDV = 1 and while DX2S = 0."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BDENW::VALUE3)
            }
            #[doc = "Gated bypass data transfer is enabled. Bypass data will be transferred to TBUF according to its priority if BDV = 1 and while DX2S = 1."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BDENW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BDVTR`"]
        pub enum BDVTRW {
            #[doc = "Bit BDV is not influenced by DX2T."]
            VALUE1,
            #[doc = "Bit BDV is set if DX2T is active."]
            VALUE2,
        }
        impl BDVTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BDVTRW::VALUE1 => false,
                    BDVTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BDVTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BDVTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BDVTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Bit BDV is not influenced by DX2T."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BDVTRW::VALUE1)
            }
            #[doc = "Bit BDV is set if DX2T is active."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BDVTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BPRIO`"]
        pub enum BPRIOW {
            #[doc = "The transmit FIFO data has a higher priority than the bypass data."]
            VALUE1,
            #[doc = "The bypass data has a higher priority than the transmit FIFO data."]
            VALUE2,
        }
        impl BPRIOW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BPRIOW::VALUE1 => false,
                    BPRIOW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BPRIOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BPRIOW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BPRIOW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The transmit FIFO data has a higher priority than the bypass data."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BPRIOW::VALUE1)
            }
            #[doc = "The bypass data has a higher priority than the transmit FIFO data."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BPRIOW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BSELOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BSELOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BHPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BHPCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Bypass Word Length"]
            #[inline]
            pub fn bwle(&self) -> BWLER {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BWLER { bits }
            }
            #[doc = "Bit 8 - Bypass Data Single Shot Mode"]
            #[inline]
            pub fn bdssm(&self) -> BDSSMR {
                BDSSMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 10:11 - Bypass Data Enable"]
            #[inline]
            pub fn bden(&self) -> BDENR {
                BDENR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 12 - Bypass Data Valid Trigger"]
            #[inline]
            pub fn bdvtr(&self) -> BDVTRR {
                BDVTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Bypass Priority"]
            #[inline]
            pub fn bprio(&self) -> BPRIOR {
                BPRIOR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Bypass Data Valid"]
            #[inline]
            pub fn bdv(&self) -> BDVR {
                BDVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:20 - Bypass Select Outputs"]
            #[inline]
            pub fn bselo(&self) -> BSELOR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BSELOR { bits }
            }
            #[doc = "Bits 21:23 - Bypass Hardware Port Control"]
            #[inline]
            pub fn bhpc(&self) -> BHPCR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BHPCR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Bypass Word Length"]
            #[inline]
            pub fn bwle(&mut self) -> _BWLEW {
                _BWLEW { w: self }
            }
            #[doc = "Bit 8 - Bypass Data Single Shot Mode"]
            #[inline]
            pub fn bdssm(&mut self) -> _BDSSMW {
                _BDSSMW { w: self }
            }
            #[doc = "Bits 10:11 - Bypass Data Enable"]
            #[inline]
            pub fn bden(&mut self) -> _BDENW {
                _BDENW { w: self }
            }
            #[doc = "Bit 12 - Bypass Data Valid Trigger"]
            #[inline]
            pub fn bdvtr(&mut self) -> _BDVTRW {
                _BDVTRW { w: self }
            }
            #[doc = "Bit 13 - Bypass Priority"]
            #[inline]
            pub fn bprio(&mut self) -> _BPRIOW {
                _BPRIOW { w: self }
            }
            #[doc = "Bits 16:20 - Bypass Select Outputs"]
            #[inline]
            pub fn bselo(&mut self) -> _BSELOW {
                _BSELOW { w: self }
            }
            #[doc = "Bits 21:23 - Bypass Hardware Port Control"]
            #[inline]
            pub fn bhpc(&mut self) -> _BHPCW {
                _BHPCW { w: self }
            }
        }
    }
    #[doc = "Transmitter Buffer Control Register"]
    pub struct TBCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmitter Buffer Control Register"]
    pub mod tbctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TBCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LIMITR {
            bits: u8,
        }
        impl LIMITR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `STBTM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STBTMR {
            #[doc = "Trigger mode 0: While TRBSR.STBT=1, a standard buffer event will be generated whenever there is a data transfer to TBUF or data write to INx (depending on TBCTR.LOF setting). STBT is cleared when TRBSR.TBFLVL=TBCTR.LIMIT."]
            VALUE1,
            #[doc = "Trigger mode 1: While TRBSR.STBT=1, a standard buffer event will be generated whenever there is a data transfer to TBUF or data write to INx (depending on TBCTR.LOF setting). STBT is cleared when TRBSR.TBFLVL=TBCTR.SIZE."]
            VALUE2,
        }
        impl STBTMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STBTMR::VALUE1 => false,
                    STBTMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STBTMR {
                match value {
                    false => STBTMR::VALUE1,
                    true => STBTMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STBTMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STBTMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STBTEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STBTENR {
            #[doc = "The standard transmit buffer event trigger through bit TRBSR.STBT is disabled."]
            VALUE1,
            #[doc = "The standard transmit buffer event trigger through bit TRBSR.STBT is enabled."]
            VALUE2,
        }
        impl STBTENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STBTENR::VALUE1 => false,
                    STBTENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STBTENR {
                match value {
                    false => STBTENR::VALUE1,
                    true => STBTENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STBTENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STBTENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STBINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STBINPR {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl STBINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STBINPR::VALUE1 => 0,
                    STBINPR::VALUE2 => 0x01,
                    STBINPR::VALUE3 => 0x02,
                    STBINPR::VALUE4 => 0x03,
                    STBINPR::VALUE5 => 0x04,
                    STBINPR::VALUE6 => 0x05,
                    STBINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STBINPR {
                match value {
                    0 => STBINPR::VALUE1,
                    1 => STBINPR::VALUE2,
                    2 => STBINPR::VALUE3,
                    3 => STBINPR::VALUE4,
                    4 => STBINPR::VALUE5,
                    5 => STBINPR::VALUE6,
                    i => STBINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STBINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STBINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STBINPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STBINPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == STBINPR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == STBINPR::VALUE6
            }
        }
        #[doc = "Possible values of the field `ATBINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ATBINPR {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ATBINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ATBINPR::VALUE1 => 0,
                    ATBINPR::VALUE2 => 0x01,
                    ATBINPR::VALUE3 => 0x02,
                    ATBINPR::VALUE4 => 0x03,
                    ATBINPR::VALUE5 => 0x04,
                    ATBINPR::VALUE6 => 0x05,
                    ATBINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ATBINPR {
                match value {
                    0 => ATBINPR::VALUE1,
                    1 => ATBINPR::VALUE2,
                    2 => ATBINPR::VALUE3,
                    3 => ATBINPR::VALUE4,
                    4 => ATBINPR::VALUE5,
                    5 => ATBINPR::VALUE6,
                    i => ATBINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ATBINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ATBINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ATBINPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ATBINPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == ATBINPR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == ATBINPR::VALUE6
            }
        }
        #[doc = "Possible values of the field `SIZE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SIZER {
            #[doc = "The FIFO mechanism is disabled. The buffer does not accept any request for data."]
            VALUE1,
            #[doc = "The FIFO buffer contains 2 entries."]
            VALUE2,
            #[doc = "The FIFO buffer contains 4 entries."]
            VALUE3,
            #[doc = "The FIFO buffer contains 8 entries."]
            VALUE4,
            #[doc = "The FIFO buffer contains 16 entries."]
            VALUE5,
            #[doc = "The FIFO buffer contains 32 entries."]
            VALUE6,
            #[doc = "The FIFO buffer contains 64 entries."]
            VALUE7,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SIZER::VALUE1 => 0,
                    SIZER::VALUE2 => 0x01,
                    SIZER::VALUE3 => 0x02,
                    SIZER::VALUE4 => 0x03,
                    SIZER::VALUE5 => 0x04,
                    SIZER::VALUE6 => 0x05,
                    SIZER::VALUE7 => 0x06,
                    SIZER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SIZER {
                match value {
                    0 => SIZER::VALUE1,
                    1 => SIZER::VALUE2,
                    2 => SIZER::VALUE3,
                    3 => SIZER::VALUE4,
                    4 => SIZER::VALUE5,
                    5 => SIZER::VALUE6,
                    6 => SIZER::VALUE7,
                    i => SIZER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SIZER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SIZER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SIZER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SIZER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SIZER::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SIZER::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == SIZER::VALUE7
            }
        }
        #[doc = "Possible values of the field `LOF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOFR {
            #[doc = "A standard transmit buffer event occurs when the filling level equals the limit value and gets lower due to transmission of a data word."]
            VALUE1,
            #[doc = "A standard transmit buffer interrupt event occurs when the filling level equals the limit value and gets bigger due to a write access to a data input location INx."]
            VALUE2,
        }
        impl LOFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LOFR::VALUE1 => false,
                    LOFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LOFR {
                match value {
                    false => LOFR::VALUE1,
                    true => LOFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STBIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STBIENR {
            #[doc = "The standard transmit buffer interrupt generation is disabled."]
            VALUE1,
            #[doc = "The standard transmit buffer interrupt generation is enabled."]
            VALUE2,
        }
        impl STBIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STBIENR::VALUE1 => false,
                    STBIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STBIENR {
                match value {
                    false => STBIENR::VALUE1,
                    true => STBIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STBIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STBIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBERIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBERIENR {
            #[doc = "The transmit buffer error interrupt generation is disabled."]
            VALUE1,
            #[doc = "The transmit buffer error interrupt generation is enabled."]
            VALUE2,
        }
        impl TBERIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBERIENR::VALUE1 => false,
                    TBERIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBERIENR {
                match value {
                    false => TBERIENR::VALUE1,
                    true => TBERIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBERIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBERIENR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPTRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LIMITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LIMITW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STBTM`"]
        pub enum STBTMW {
            #[doc = "Trigger mode 0: While TRBSR.STBT=1, a standard buffer event will be generated whenever there is a data transfer to TBUF or data write to INx (depending on TBCTR.LOF setting). STBT is cleared when TRBSR.TBFLVL=TBCTR.LIMIT."]
            VALUE1,
            #[doc = "Trigger mode 1: While TRBSR.STBT=1, a standard buffer event will be generated whenever there is a data transfer to TBUF or data write to INx (depending on TBCTR.LOF setting). STBT is cleared when TRBSR.TBFLVL=TBCTR.SIZE."]
            VALUE2,
        }
        impl STBTMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STBTMW::VALUE1 => false,
                    STBTMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STBTMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STBTMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STBTMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trigger mode 0: While TRBSR.STBT=1, a standard buffer event will be generated whenever there is a data transfer to TBUF or data write to INx (depending on TBCTR.LOF setting). STBT is cleared when TRBSR.TBFLVL=TBCTR.LIMIT."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STBTMW::VALUE1)
            }
            #[doc = "Trigger mode 1: While TRBSR.STBT=1, a standard buffer event will be generated whenever there is a data transfer to TBUF or data write to INx (depending on TBCTR.LOF setting). STBT is cleared when TRBSR.TBFLVL=TBCTR.SIZE."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STBTMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STBTEN`"]
        pub enum STBTENW {
            #[doc = "The standard transmit buffer event trigger through bit TRBSR.STBT is disabled."]
            VALUE1,
            #[doc = "The standard transmit buffer event trigger through bit TRBSR.STBT is enabled."]
            VALUE2,
        }
        impl STBTENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STBTENW::VALUE1 => false,
                    STBTENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STBTENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STBTENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STBTENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The standard transmit buffer event trigger through bit TRBSR.STBT is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STBTENW::VALUE1)
            }
            #[doc = "The standard transmit buffer event trigger through bit TRBSR.STBT is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STBTENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STBINP`"]
        pub enum STBINPW {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
        }
        impl STBINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STBINPW::VALUE1 => 0,
                    STBINPW::VALUE2 => 1,
                    STBINPW::VALUE3 => 2,
                    STBINPW::VALUE4 => 3,
                    STBINPW::VALUE5 => 4,
                    STBINPW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STBINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STBINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STBINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Output SR0 becomes activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STBINPW::VALUE1)
            }
            #[doc = "Output SR1 becomes activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STBINPW::VALUE2)
            }
            #[doc = "Output SR2 becomes activated."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STBINPW::VALUE3)
            }
            #[doc = "Output SR3 becomes activated."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STBINPW::VALUE4)
            }
            #[doc = "Output SR4 becomes activated."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(STBINPW::VALUE5)
            }
            #[doc = "Output SR5 becomes activated."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(STBINPW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ATBINP`"]
        pub enum ATBINPW {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
        }
        impl ATBINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ATBINPW::VALUE1 => 0,
                    ATBINPW::VALUE2 => 1,
                    ATBINPW::VALUE3 => 2,
                    ATBINPW::VALUE4 => 3,
                    ATBINPW::VALUE5 => 4,
                    ATBINPW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ATBINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ATBINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ATBINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Output SR0 becomes activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ATBINPW::VALUE1)
            }
            #[doc = "Output SR1 becomes activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ATBINPW::VALUE2)
            }
            #[doc = "Output SR2 becomes activated."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ATBINPW::VALUE3)
            }
            #[doc = "Output SR3 becomes activated."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ATBINPW::VALUE4)
            }
            #[doc = "Output SR4 becomes activated."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(ATBINPW::VALUE5)
            }
            #[doc = "Output SR5 becomes activated."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(ATBINPW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIZE`"]
        pub enum SIZEW {
            #[doc = "The FIFO mechanism is disabled. The buffer does not accept any request for data."]
            VALUE1,
            #[doc = "The FIFO buffer contains 2 entries."]
            VALUE2,
            #[doc = "The FIFO buffer contains 4 entries."]
            VALUE3,
            #[doc = "The FIFO buffer contains 8 entries."]
            VALUE4,
            #[doc = "The FIFO buffer contains 16 entries."]
            VALUE5,
            #[doc = "The FIFO buffer contains 32 entries."]
            VALUE6,
            #[doc = "The FIFO buffer contains 64 entries."]
            VALUE7,
        }
        impl SIZEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SIZEW::VALUE1 => 0,
                    SIZEW::VALUE2 => 1,
                    SIZEW::VALUE3 => 2,
                    SIZEW::VALUE4 => 3,
                    SIZEW::VALUE5 => 4,
                    SIZEW::VALUE6 => 5,
                    SIZEW::VALUE7 => 6,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIZEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIZEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The FIFO mechanism is disabled. The buffer does not accept any request for data."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIZEW::VALUE1)
            }
            #[doc = "The FIFO buffer contains 2 entries."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIZEW::VALUE2)
            }
            #[doc = "The FIFO buffer contains 4 entries."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SIZEW::VALUE3)
            }
            #[doc = "The FIFO buffer contains 8 entries."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SIZEW::VALUE4)
            }
            #[doc = "The FIFO buffer contains 16 entries."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SIZEW::VALUE5)
            }
            #[doc = "The FIFO buffer contains 32 entries."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SIZEW::VALUE6)
            }
            #[doc = "The FIFO buffer contains 64 entries."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(SIZEW::VALUE7)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOF`"]
        pub enum LOFW {
            #[doc = "A standard transmit buffer event occurs when the filling level equals the limit value and gets lower due to transmission of a data word."]
            VALUE1,
            #[doc = "A standard transmit buffer interrupt event occurs when the filling level equals the limit value and gets bigger due to a write access to a data input location INx."]
            VALUE2,
        }
        impl LOFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LOFW::VALUE1 => false,
                    LOFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A standard transmit buffer event occurs when the filling level equals the limit value and gets lower due to transmission of a data word."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOFW::VALUE1)
            }
            #[doc = "A standard transmit buffer interrupt event occurs when the filling level equals the limit value and gets bigger due to a write access to a data input location INx."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STBIEN`"]
        pub enum STBIENW {
            #[doc = "The standard transmit buffer interrupt generation is disabled."]
            VALUE1,
            #[doc = "The standard transmit buffer interrupt generation is enabled."]
            VALUE2,
        }
        impl STBIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STBIENW::VALUE1 => false,
                    STBIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STBIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STBIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STBIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The standard transmit buffer interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STBIENW::VALUE1)
            }
            #[doc = "The standard transmit buffer interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STBIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBERIEN`"]
        pub enum TBERIENW {
            #[doc = "The transmit buffer error interrupt generation is disabled."]
            VALUE1,
            #[doc = "The transmit buffer error interrupt generation is enabled."]
            VALUE2,
        }
        impl TBERIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBERIENW::VALUE1 => false,
                    TBERIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBERIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBERIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBERIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The transmit buffer error interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBERIENW::VALUE1)
            }
            #[doc = "The transmit buffer error interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBERIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 8:13 - Limit For Interrupt Generation"]
            #[inline]
            pub fn limit(&self) -> LIMITR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LIMITR { bits }
            }
            #[doc = "Bit 14 - Standard Transmit Buffer Trigger Mode"]
            #[inline]
            pub fn stbtm(&self) -> STBTMR {
                STBTMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Standard Transmit Buffer Trigger Enable"]
            #[inline]
            pub fn stbten(&self) -> STBTENR {
                STBTENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:18 - Standard Transmit Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn stbinp(&self) -> STBINPR {
                STBINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:21 - Alternative Transmit Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn atbinp(&self) -> ATBINPR {
                ATBINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:26 - Buffer Size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                SIZER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 28 - Buffer Event on Limit Overflow"]
            #[inline]
            pub fn lof(&self) -> LOFR {
                LOFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Standard Transmit Buffer Interrupt Enable"]
            #[inline]
            pub fn stbien(&self) -> STBIENR {
                STBIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Transmit Buffer Error Interrupt Enable"]
            #[inline]
            pub fn tberien(&self) -> TBERIENR {
                TBERIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Data Pointer"]
            #[inline]
            pub fn dptr(&mut self) -> _DPTRW {
                _DPTRW { w: self }
            }
            #[doc = "Bits 8:13 - Limit For Interrupt Generation"]
            #[inline]
            pub fn limit(&mut self) -> _LIMITW {
                _LIMITW { w: self }
            }
            #[doc = "Bit 14 - Standard Transmit Buffer Trigger Mode"]
            #[inline]
            pub fn stbtm(&mut self) -> _STBTMW {
                _STBTMW { w: self }
            }
            #[doc = "Bit 15 - Standard Transmit Buffer Trigger Enable"]
            #[inline]
            pub fn stbten(&mut self) -> _STBTENW {
                _STBTENW { w: self }
            }
            #[doc = "Bits 16:18 - Standard Transmit Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn stbinp(&mut self) -> _STBINPW {
                _STBINPW { w: self }
            }
            #[doc = "Bits 19:21 - Alternative Transmit Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn atbinp(&mut self) -> _ATBINPW {
                _ATBINPW { w: self }
            }
            #[doc = "Bits 24:26 - Buffer Size"]
            #[inline]
            pub fn size(&mut self) -> _SIZEW {
                _SIZEW { w: self }
            }
            #[doc = "Bit 28 - Buffer Event on Limit Overflow"]
            #[inline]
            pub fn lof(&mut self) -> _LOFW {
                _LOFW { w: self }
            }
            #[doc = "Bit 30 - Standard Transmit Buffer Interrupt Enable"]
            #[inline]
            pub fn stbien(&mut self) -> _STBIENW {
                _STBIENW { w: self }
            }
            #[doc = "Bit 31 - Transmit Buffer Error Interrupt Enable"]
            #[inline]
            pub fn tberien(&mut self) -> _TBERIENW {
                _TBERIENW { w: self }
            }
        }
    }
    #[doc = "Receiver Buffer Control Register"]
    pub struct RBCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Control Register"]
    pub mod rbctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RBCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LIMITR {
            bits: u8,
        }
        impl LIMITR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SRBTM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRBTMR {
            #[doc = "Trigger mode 0: While TRBSR.SRBT=1, a standard receive buffer event will be generated whenever there is a new data received or data read out (depending on RBCTR.LOF setting). SRBT is cleared when TRBSR.RBFLVL=RBCTR.LIMIT."]
            VALUE1,
            #[doc = "Trigger mode 1: While TRBSR.SRBT=1, a standard receive buffer event will be generated whenever there is a new data received or data read out (depending on RBCTR.LOF setting). SRBT is cleared when TRBSR.RBFLVL=0."]
            VALUE2,
        }
        impl SRBTMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRBTMR::VALUE1 => false,
                    SRBTMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRBTMR {
                match value {
                    false => SRBTMR::VALUE1,
                    true => SRBTMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRBTMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRBTMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRBTEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRBTENR {
            #[doc = "The standard receive buffer event trigger through bit TRBSR.SRBT is disabled."]
            VALUE1,
            #[doc = "The standard receive buffer event trigger through bit TRBSR.SRBT is enabled."]
            VALUE2,
        }
        impl SRBTENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRBTENR::VALUE1 => false,
                    SRBTENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRBTENR {
                match value {
                    false => SRBTENR::VALUE1,
                    true => SRBTENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRBTENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRBTENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRBINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRBINPR {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRBINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRBINPR::VALUE1 => 0,
                    SRBINPR::VALUE2 => 0x01,
                    SRBINPR::VALUE3 => 0x02,
                    SRBINPR::VALUE4 => 0x03,
                    SRBINPR::VALUE5 => 0x04,
                    SRBINPR::VALUE6 => 0x05,
                    SRBINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRBINPR {
                match value {
                    0 => SRBINPR::VALUE1,
                    1 => SRBINPR::VALUE2,
                    2 => SRBINPR::VALUE3,
                    3 => SRBINPR::VALUE4,
                    4 => SRBINPR::VALUE5,
                    5 => SRBINPR::VALUE6,
                    i => SRBINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRBINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRBINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SRBINPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SRBINPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SRBINPR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SRBINPR::VALUE6
            }
        }
        #[doc = "Possible values of the field `ARBINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARBINPR {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ARBINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ARBINPR::VALUE1 => 0,
                    ARBINPR::VALUE2 => 0x01,
                    ARBINPR::VALUE3 => 0x02,
                    ARBINPR::VALUE4 => 0x03,
                    ARBINPR::VALUE5 => 0x04,
                    ARBINPR::VALUE6 => 0x05,
                    ARBINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ARBINPR {
                match value {
                    0 => ARBINPR::VALUE1,
                    1 => ARBINPR::VALUE2,
                    2 => ARBINPR::VALUE3,
                    3 => ARBINPR::VALUE4,
                    4 => ARBINPR::VALUE5,
                    5 => ARBINPR::VALUE6,
                    i => ARBINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARBINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARBINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ARBINPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ARBINPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == ARBINPR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == ARBINPR::VALUE6
            }
        }
        #[doc = "Possible values of the field `RCIM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RCIMR {
            #[doc = "RCI[4] = PERR, RCI[3:0] = WLEN"]
            VALUE1,
            #[doc = "RCI[4] = SOF, RCI[3:0] = WLEN"]
            VALUE2,
            #[doc = "RCI[4] = 0, RCI[3:0] = WLEN"]
            VALUE3,
            #[doc = "RCI[4] = PERR, RCI[3] = PAR, RCI[2:1] = 00B, RCI[0] = SOF"]
            VALUE4,
        }
        impl RCIMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    RCIMR::VALUE1 => 0,
                    RCIMR::VALUE2 => 0x01,
                    RCIMR::VALUE3 => 0x02,
                    RCIMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> RCIMR {
                match value {
                    0 => RCIMR::VALUE1,
                    1 => RCIMR::VALUE2,
                    2 => RCIMR::VALUE3,
                    3 => RCIMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RCIMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RCIMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == RCIMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == RCIMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SIZE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SIZER {
            #[doc = "The FIFO mechanism is disabled. The buffer does not accept any request for data."]
            VALUE1,
            #[doc = "The FIFO buffer contains 2 entries."]
            VALUE2,
            #[doc = "The FIFO buffer contains 4 entries."]
            VALUE3,
            #[doc = "The FIFO buffer contains 8 entries."]
            VALUE4,
            #[doc = "The FIFO buffer contains 16 entries."]
            VALUE5,
            #[doc = "The FIFO buffer contains 32 entries."]
            VALUE6,
            #[doc = "The FIFO buffer contains 64 entries."]
            VALUE7,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SIZER::VALUE1 => 0,
                    SIZER::VALUE2 => 0x01,
                    SIZER::VALUE3 => 0x02,
                    SIZER::VALUE4 => 0x03,
                    SIZER::VALUE5 => 0x04,
                    SIZER::VALUE6 => 0x05,
                    SIZER::VALUE7 => 0x06,
                    SIZER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SIZER {
                match value {
                    0 => SIZER::VALUE1,
                    1 => SIZER::VALUE2,
                    2 => SIZER::VALUE3,
                    3 => SIZER::VALUE4,
                    4 => SIZER::VALUE5,
                    5 => SIZER::VALUE6,
                    6 => SIZER::VALUE7,
                    i => SIZER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SIZER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SIZER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SIZER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SIZER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SIZER::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SIZER::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == SIZER::VALUE7
            }
        }
        #[doc = "Possible values of the field `RNM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RNMR {
            #[doc = "Filling level mode: A standard receive buffer event occurs when the filling level equals the limit value and changes, either due to a read access from OUTR (LOF = 0) or due to a new received data word (LOF = 1)."]
            VALUE1,
            #[doc = "RCI mode: A standard receive buffer event occurs when register OUTR is updated with a new value if the corresponding value in OUTR.RCI[4] = 0. If OUTR.RCI[4] = 1, an alternative receive buffer event occurs instead of the standard receive buffer event."]
            VALUE2,
        }
        impl RNMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RNMR::VALUE1 => false,
                    RNMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RNMR {
                match value {
                    false => RNMR::VALUE1,
                    true => RNMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RNMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RNMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LOF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOFR {
            #[doc = "A standard receive buffer event occurs when the filling level equals the limit value and gets lower due to a read access from OUTR."]
            VALUE1,
            #[doc = "A standard receive buffer event occurs when the filling level equals the limit value and gets bigger due to the reception of a new data word."]
            VALUE2,
        }
        impl LOFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LOFR::VALUE1 => false,
                    LOFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LOFR {
                match value {
                    false => LOFR::VALUE1,
                    true => LOFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ARBIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARBIENR {
            #[doc = "The alternative receive buffer interrupt generation is disabled."]
            VALUE1,
            #[doc = "The alternative receive buffer interrupt generation is enabled."]
            VALUE2,
        }
        impl ARBIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ARBIENR::VALUE1 => false,
                    ARBIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ARBIENR {
                match value {
                    false => ARBIENR::VALUE1,
                    true => ARBIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARBIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARBIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRBIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRBIENR {
            #[doc = "The standard receive buffer interrupt generation is disabled."]
            VALUE1,
            #[doc = "The standard receive buffer interrupt generation is enabled."]
            VALUE2,
        }
        impl SRBIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRBIENR::VALUE1 => false,
                    SRBIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRBIENR {
                match value {
                    false => SRBIENR::VALUE1,
                    true => SRBIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRBIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRBIENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RBERIEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RBERIENR {
            #[doc = "The receive buffer error interrupt generation is disabled."]
            VALUE1,
            #[doc = "The receive buffer error interrupt generation is enabled."]
            VALUE2,
        }
        impl RBERIENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RBERIENR::VALUE1 => false,
                    RBERIENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RBERIENR {
                match value {
                    false => RBERIENR::VALUE1,
                    true => RBERIENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RBERIENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RBERIENR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPTRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LIMITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LIMITW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRBTM`"]
        pub enum SRBTMW {
            #[doc = "Trigger mode 0: While TRBSR.SRBT=1, a standard receive buffer event will be generated whenever there is a new data received or data read out (depending on RBCTR.LOF setting). SRBT is cleared when TRBSR.RBFLVL=RBCTR.LIMIT."]
            VALUE1,
            #[doc = "Trigger mode 1: While TRBSR.SRBT=1, a standard receive buffer event will be generated whenever there is a new data received or data read out (depending on RBCTR.LOF setting). SRBT is cleared when TRBSR.RBFLVL=0."]
            VALUE2,
        }
        impl SRBTMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRBTMW::VALUE1 => false,
                    SRBTMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRBTMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRBTMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRBTMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trigger mode 0: While TRBSR.SRBT=1, a standard receive buffer event will be generated whenever there is a new data received or data read out (depending on RBCTR.LOF setting). SRBT is cleared when TRBSR.RBFLVL=RBCTR.LIMIT."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRBTMW::VALUE1)
            }
            #[doc = "Trigger mode 1: While TRBSR.SRBT=1, a standard receive buffer event will be generated whenever there is a new data received or data read out (depending on RBCTR.LOF setting). SRBT is cleared when TRBSR.RBFLVL=0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRBTMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRBTEN`"]
        pub enum SRBTENW {
            #[doc = "The standard receive buffer event trigger through bit TRBSR.SRBT is disabled."]
            VALUE1,
            #[doc = "The standard receive buffer event trigger through bit TRBSR.SRBT is enabled."]
            VALUE2,
        }
        impl SRBTENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRBTENW::VALUE1 => false,
                    SRBTENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRBTENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRBTENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRBTENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The standard receive buffer event trigger through bit TRBSR.SRBT is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRBTENW::VALUE1)
            }
            #[doc = "The standard receive buffer event trigger through bit TRBSR.SRBT is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRBTENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRBINP`"]
        pub enum SRBINPW {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
        }
        impl SRBINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRBINPW::VALUE1 => 0,
                    SRBINPW::VALUE2 => 1,
                    SRBINPW::VALUE3 => 2,
                    SRBINPW::VALUE4 => 3,
                    SRBINPW::VALUE5 => 4,
                    SRBINPW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRBINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRBINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRBINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Output SR0 becomes activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRBINPW::VALUE1)
            }
            #[doc = "Output SR1 becomes activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRBINPW::VALUE2)
            }
            #[doc = "Output SR2 becomes activated."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SRBINPW::VALUE3)
            }
            #[doc = "Output SR3 becomes activated."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SRBINPW::VALUE4)
            }
            #[doc = "Output SR4 becomes activated."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SRBINPW::VALUE5)
            }
            #[doc = "Output SR5 becomes activated."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SRBINPW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARBINP`"]
        pub enum ARBINPW {
            #[doc = "Output SR0 becomes activated."]
            VALUE1,
            #[doc = "Output SR1 becomes activated."]
            VALUE2,
            #[doc = "Output SR2 becomes activated."]
            VALUE3,
            #[doc = "Output SR3 becomes activated."]
            VALUE4,
            #[doc = "Output SR4 becomes activated."]
            VALUE5,
            #[doc = "Output SR5 becomes activated."]
            VALUE6,
        }
        impl ARBINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ARBINPW::VALUE1 => 0,
                    ARBINPW::VALUE2 => 1,
                    ARBINPW::VALUE3 => 2,
                    ARBINPW::VALUE4 => 3,
                    ARBINPW::VALUE5 => 4,
                    ARBINPW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARBINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARBINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARBINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Output SR0 becomes activated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARBINPW::VALUE1)
            }
            #[doc = "Output SR1 becomes activated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARBINPW::VALUE2)
            }
            #[doc = "Output SR2 becomes activated."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ARBINPW::VALUE3)
            }
            #[doc = "Output SR3 becomes activated."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ARBINPW::VALUE4)
            }
            #[doc = "Output SR4 becomes activated."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(ARBINPW::VALUE5)
            }
            #[doc = "Output SR5 becomes activated."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(ARBINPW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RCIM`"]
        pub enum RCIMW {
            #[doc = "RCI[4] = PERR, RCI[3:0] = WLEN"]
            VALUE1,
            #[doc = "RCI[4] = SOF, RCI[3:0] = WLEN"]
            VALUE2,
            #[doc = "RCI[4] = 0, RCI[3:0] = WLEN"]
            VALUE3,
            #[doc = "RCI[4] = PERR, RCI[3] = PAR, RCI[2:1] = 00B, RCI[0] = SOF"]
            VALUE4,
        }
        impl RCIMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RCIMW::VALUE1 => 0,
                    RCIMW::VALUE2 => 1,
                    RCIMW::VALUE3 => 2,
                    RCIMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCIMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RCIMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "RCI[4] = PERR, RCI[3:0] = WLEN"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RCIMW::VALUE1)
            }
            #[doc = "RCI[4] = SOF, RCI[3:0] = WLEN"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RCIMW::VALUE2)
            }
            #[doc = "RCI[4] = 0, RCI[3:0] = WLEN"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(RCIMW::VALUE3)
            }
            #[doc = "RCI[4] = PERR, RCI[3] = PAR, RCI[2:1] = 00B, RCI[0] = SOF"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(RCIMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIZE`"]
        pub enum SIZEW {
            #[doc = "The FIFO mechanism is disabled. The buffer does not accept any request for data."]
            VALUE1,
            #[doc = "The FIFO buffer contains 2 entries."]
            VALUE2,
            #[doc = "The FIFO buffer contains 4 entries."]
            VALUE3,
            #[doc = "The FIFO buffer contains 8 entries."]
            VALUE4,
            #[doc = "The FIFO buffer contains 16 entries."]
            VALUE5,
            #[doc = "The FIFO buffer contains 32 entries."]
            VALUE6,
            #[doc = "The FIFO buffer contains 64 entries."]
            VALUE7,
        }
        impl SIZEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SIZEW::VALUE1 => 0,
                    SIZEW::VALUE2 => 1,
                    SIZEW::VALUE3 => 2,
                    SIZEW::VALUE4 => 3,
                    SIZEW::VALUE5 => 4,
                    SIZEW::VALUE6 => 5,
                    SIZEW::VALUE7 => 6,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIZEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIZEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIZEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The FIFO mechanism is disabled. The buffer does not accept any request for data."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIZEW::VALUE1)
            }
            #[doc = "The FIFO buffer contains 2 entries."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIZEW::VALUE2)
            }
            #[doc = "The FIFO buffer contains 4 entries."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SIZEW::VALUE3)
            }
            #[doc = "The FIFO buffer contains 8 entries."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SIZEW::VALUE4)
            }
            #[doc = "The FIFO buffer contains 16 entries."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SIZEW::VALUE5)
            }
            #[doc = "The FIFO buffer contains 32 entries."]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SIZEW::VALUE6)
            }
            #[doc = "The FIFO buffer contains 64 entries."]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(SIZEW::VALUE7)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RNM`"]
        pub enum RNMW {
            #[doc = "Filling level mode: A standard receive buffer event occurs when the filling level equals the limit value and changes, either due to a read access from OUTR (LOF = 0) or due to a new received data word (LOF = 1)."]
            VALUE1,
            #[doc = "RCI mode: A standard receive buffer event occurs when register OUTR is updated with a new value if the corresponding value in OUTR.RCI[4] = 0. If OUTR.RCI[4] = 1, an alternative receive buffer event occurs instead of the standard receive buffer event."]
            VALUE2,
        }
        impl RNMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RNMW::VALUE1 => false,
                    RNMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RNMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RNMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RNMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Filling level mode: A standard receive buffer event occurs when the filling level equals the limit value and changes, either due to a read access from OUTR (LOF = 0) or due to a new received data word (LOF = 1)."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RNMW::VALUE1)
            }
            #[doc = "RCI mode: A standard receive buffer event occurs when register OUTR is updated with a new value if the corresponding value in OUTR.RCI[4] = 0. If OUTR.RCI[4] = 1, an alternative receive buffer event occurs instead of the standard receive buffer event."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RNMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOF`"]
        pub enum LOFW {
            #[doc = "A standard receive buffer event occurs when the filling level equals the limit value and gets lower due to a read access from OUTR."]
            VALUE1,
            #[doc = "A standard receive buffer event occurs when the filling level equals the limit value and gets bigger due to the reception of a new data word."]
            VALUE2,
        }
        impl LOFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LOFW::VALUE1 => false,
                    LOFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A standard receive buffer event occurs when the filling level equals the limit value and gets lower due to a read access from OUTR."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOFW::VALUE1)
            }
            #[doc = "A standard receive buffer event occurs when the filling level equals the limit value and gets bigger due to the reception of a new data word."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARBIEN`"]
        pub enum ARBIENW {
            #[doc = "The alternative receive buffer interrupt generation is disabled."]
            VALUE1,
            #[doc = "The alternative receive buffer interrupt generation is enabled."]
            VALUE2,
        }
        impl ARBIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ARBIENW::VALUE1 => false,
                    ARBIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARBIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARBIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARBIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The alternative receive buffer interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARBIENW::VALUE1)
            }
            #[doc = "The alternative receive buffer interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARBIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRBIEN`"]
        pub enum SRBIENW {
            #[doc = "The standard receive buffer interrupt generation is disabled."]
            VALUE1,
            #[doc = "The standard receive buffer interrupt generation is enabled."]
            VALUE2,
        }
        impl SRBIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRBIENW::VALUE1 => false,
                    SRBIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRBIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRBIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRBIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The standard receive buffer interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRBIENW::VALUE1)
            }
            #[doc = "The standard receive buffer interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRBIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RBERIEN`"]
        pub enum RBERIENW {
            #[doc = "The receive buffer error interrupt generation is disabled."]
            VALUE1,
            #[doc = "The receive buffer error interrupt generation is enabled."]
            VALUE2,
        }
        impl RBERIENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RBERIENW::VALUE1 => false,
                    RBERIENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RBERIENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RBERIENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RBERIENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The receive buffer error interrupt generation is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RBERIENW::VALUE1)
            }
            #[doc = "The receive buffer error interrupt generation is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RBERIENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 8:13 - Limit For Interrupt Generation"]
            #[inline]
            pub fn limit(&self) -> LIMITR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LIMITR { bits }
            }
            #[doc = "Bit 14 - Standard Receive Buffer Trigger Mode"]
            #[inline]
            pub fn srbtm(&self) -> SRBTMR {
                SRBTMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Standard Receive Buffer Trigger Enable"]
            #[inline]
            pub fn srbten(&self) -> SRBTENR {
                SRBTENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:18 - Standard Receive Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn srbinp(&self) -> SRBINPR {
                SRBINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:21 - Alternative Receive Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn arbinp(&self) -> ARBINPR {
                ARBINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Receiver Control Information Mode"]
            #[inline]
            pub fn rcim(&self) -> RCIMR {
                RCIMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:26 - Buffer Size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                SIZER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 27 - Receiver Notification Mode"]
            #[inline]
            pub fn rnm(&self) -> RNMR {
                RNMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - Buffer Event on Limit Overflow"]
            #[inline]
            pub fn lof(&self) -> LOFR {
                LOFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Alternative Receive Buffer Interrupt Enable"]
            #[inline]
            pub fn arbien(&self) -> ARBIENR {
                ARBIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Standard Receive Buffer Interrupt Enable"]
            #[inline]
            pub fn srbien(&self) -> SRBIENR {
                SRBIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Receive Buffer Error Interrupt Enable"]
            #[inline]
            pub fn rberien(&self) -> RBERIENR {
                RBERIENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Data Pointer"]
            #[inline]
            pub fn dptr(&mut self) -> _DPTRW {
                _DPTRW { w: self }
            }
            #[doc = "Bits 8:13 - Limit For Interrupt Generation"]
            #[inline]
            pub fn limit(&mut self) -> _LIMITW {
                _LIMITW { w: self }
            }
            #[doc = "Bit 14 - Standard Receive Buffer Trigger Mode"]
            #[inline]
            pub fn srbtm(&mut self) -> _SRBTMW {
                _SRBTMW { w: self }
            }
            #[doc = "Bit 15 - Standard Receive Buffer Trigger Enable"]
            #[inline]
            pub fn srbten(&mut self) -> _SRBTENW {
                _SRBTENW { w: self }
            }
            #[doc = "Bits 16:18 - Standard Receive Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn srbinp(&mut self) -> _SRBINPW {
                _SRBINPW { w: self }
            }
            #[doc = "Bits 19:21 - Alternative Receive Buffer Interrupt Node Pointer"]
            #[inline]
            pub fn arbinp(&mut self) -> _ARBINPW {
                _ARBINPW { w: self }
            }
            #[doc = "Bits 22:23 - Receiver Control Information Mode"]
            #[inline]
            pub fn rcim(&mut self) -> _RCIMW {
                _RCIMW { w: self }
            }
            #[doc = "Bits 24:26 - Buffer Size"]
            #[inline]
            pub fn size(&mut self) -> _SIZEW {
                _SIZEW { w: self }
            }
            #[doc = "Bit 27 - Receiver Notification Mode"]
            #[inline]
            pub fn rnm(&mut self) -> _RNMW {
                _RNMW { w: self }
            }
            #[doc = "Bit 28 - Buffer Event on Limit Overflow"]
            #[inline]
            pub fn lof(&mut self) -> _LOFW {
                _LOFW { w: self }
            }
            #[doc = "Bit 29 - Alternative Receive Buffer Interrupt Enable"]
            #[inline]
            pub fn arbien(&mut self) -> _ARBIENW {
                _ARBIENW { w: self }
            }
            #[doc = "Bit 30 - Standard Receive Buffer Interrupt Enable"]
            #[inline]
            pub fn srbien(&mut self) -> _SRBIENW {
                _SRBIENW { w: self }
            }
            #[doc = "Bit 31 - Receive Buffer Error Interrupt Enable"]
            #[inline]
            pub fn rberien(&mut self) -> _RBERIENW {
                _RBERIENW { w: self }
            }
        }
    }
    #[doc = "Transmit/Receive Buffer Pointer Register"]
    pub struct TRBPTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmit/Receive Buffer Pointer Register"]
    pub mod trbptr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TRBPTR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct TDIPTRR {
            bits: u8,
        }
        impl TDIPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TDOPTRR {
            bits: u8,
        }
        impl TDOPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RDIPTRR {
            bits: u8,
        }
        impl RDIPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RDOPTRR {
            bits: u8,
        }
        impl RDOPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Transmitter Data Input Pointer"]
            #[inline]
            pub fn tdiptr(&self) -> TDIPTRR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TDIPTRR { bits }
            }
            #[doc = "Bits 8:13 - Transmitter Data Output Pointer"]
            #[inline]
            pub fn tdoptr(&self) -> TDOPTRR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TDOPTRR { bits }
            }
            #[doc = "Bits 16:21 - Receiver Data Input Pointer"]
            #[inline]
            pub fn rdiptr(&self) -> RDIPTRR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RDIPTRR { bits }
            }
            #[doc = "Bits 24:29 - Receiver Data Output Pointer"]
            #[inline]
            pub fn rdoptr(&self) -> RDOPTRR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RDOPTRR { bits }
            }
        }
    }
    #[doc = "Transmit/Receive Buffer Status Register"]
    pub struct TRBSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmit/Receive Buffer Status Register"]
    pub mod trbsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TRBSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SRBI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRBIR {
            #[doc = "A standard receive buffer event has not been detected."]
            VALUE1,
            #[doc = "A standard receive buffer event has been detected."]
            VALUE2,
        }
        impl SRBIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRBIR::VALUE1 => false,
                    SRBIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRBIR {
                match value {
                    false => SRBIR::VALUE1,
                    true => SRBIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRBIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRBIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RBERI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RBERIR {
            #[doc = "A receive buffer error event has not been detected."]
            VALUE1,
            #[doc = "A receive buffer error event has been detected."]
            VALUE2,
        }
        impl RBERIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RBERIR::VALUE1 => false,
                    RBERIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RBERIR {
                match value {
                    false => RBERIR::VALUE1,
                    true => RBERIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RBERIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RBERIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ARBI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARBIR {
            #[doc = "An alternative receive buffer event has not been detected."]
            VALUE1,
            #[doc = "An alternative receive buffer event has been detected."]
            VALUE2,
        }
        impl ARBIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ARBIR::VALUE1 => false,
                    ARBIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ARBIR {
                match value {
                    false => ARBIR::VALUE1,
                    true => ARBIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARBIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARBIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REMPTY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REMPTYR {
            #[doc = "The receive buffer is not empty."]
            VALUE1,
            #[doc = "The receive buffer is empty."]
            VALUE2,
        }
        impl REMPTYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REMPTYR::VALUE1 => false,
                    REMPTYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REMPTYR {
                match value {
                    false => REMPTYR::VALUE1,
                    true => REMPTYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REMPTYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REMPTYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RFULL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RFULLR {
            #[doc = "The receive buffer is not full."]
            VALUE1,
            #[doc = "The receive buffer is full."]
            VALUE2,
        }
        impl RFULLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RFULLR::VALUE1 => false,
                    RFULLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RFULLR {
                match value {
                    false => RFULLR::VALUE1,
                    true => RFULLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RFULLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RFULLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RBUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RBUSR {
            #[doc = "The receive buffer information has been completely updated."]
            VALUE1,
            #[doc = "The OUTR update from the FIFO memory is ongoing. A read from OUTR will be delayed. FIFO pointers from the previous read are not yet updated."]
            VALUE2,
        }
        impl RBUSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RBUSR::VALUE1 => false,
                    RBUSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RBUSR {
                match value {
                    false => RBUSR::VALUE1,
                    true => RBUSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RBUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RBUSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRBT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRBTR {
            #[doc = "A standard receive buffer event is not triggered using this bit."]
            VALUE1,
            #[doc = "A standard receive buffer event is triggered using this bit."]
            VALUE2,
        }
        impl SRBTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRBTR::VALUE1 => false,
                    SRBTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRBTR {
                match value {
                    false => SRBTR::VALUE1,
                    true => SRBTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRBTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRBTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STBI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STBIR {
            #[doc = "A standard transmit buffer event has not been detected."]
            VALUE1,
            #[doc = "A standard transmit buffer event has been detected."]
            VALUE2,
        }
        impl STBIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STBIR::VALUE1 => false,
                    STBIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STBIR {
                match value {
                    false => STBIR::VALUE1,
                    true => STBIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STBIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STBIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBERI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBERIR {
            #[doc = "A transmit buffer error event has not been detected."]
            VALUE1,
            #[doc = "A transmit buffer error event has been detected."]
            VALUE2,
        }
        impl TBERIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBERIR::VALUE1 => false,
                    TBERIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBERIR {
                match value {
                    false => TBERIR::VALUE1,
                    true => TBERIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBERIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBERIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TEMPTY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TEMPTYR {
            #[doc = "The transmit buffer is not empty."]
            VALUE1,
            #[doc = "The transmit buffer is empty."]
            VALUE2,
        }
        impl TEMPTYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TEMPTYR::VALUE1 => false,
                    TEMPTYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TEMPTYR {
                match value {
                    false => TEMPTYR::VALUE1,
                    true => TEMPTYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TEMPTYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TEMPTYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TFULL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TFULLR {
            #[doc = "The transmit buffer is not full."]
            VALUE1,
            #[doc = "The transmit buffer is full."]
            VALUE2,
        }
        impl TFULLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TFULLR::VALUE1 => false,
                    TFULLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TFULLR {
                match value {
                    false => TFULLR::VALUE1,
                    true => TFULLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TFULLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TFULLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TBUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TBUSR {
            #[doc = "The transmit buffer information has been completely updated."]
            VALUE1,
            #[doc = "The FIFO memory update after write to INx is ongoing. A write to INx will be delayed. FIFO pointers from the previous INx write are not yet updated."]
            VALUE2,
        }
        impl TBUSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TBUSR::VALUE1 => false,
                    TBUSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TBUSR {
                match value {
                    false => TBUSR::VALUE1,
                    true => TBUSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TBUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TBUSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STBT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STBTR {
            #[doc = "A standard transmit buffer event is not triggered using this bit."]
            VALUE1,
            #[doc = "A standard transmit buffer event is triggered using this bit."]
            VALUE2,
        }
        impl STBTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STBTR::VALUE1 => false,
                    STBTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STBTR {
                match value {
                    false => STBTR::VALUE1,
                    true => STBTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STBTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STBTR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct RBFLVLR {
            bits: u8,
        }
        impl RBFLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TBFLVLR {
            bits: u8,
        }
        impl TBFLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `SRBI`"]
        pub enum SRBIW {
            #[doc = "A standard receive buffer event has not been detected."]
            VALUE1,
            #[doc = "A standard receive buffer event has been detected."]
            VALUE2,
        }
        impl SRBIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRBIW::VALUE1 => false,
                    SRBIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRBIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRBIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRBIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A standard receive buffer event has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRBIW::VALUE1)
            }
            #[doc = "A standard receive buffer event has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRBIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RBERI`"]
        pub enum RBERIW {
            #[doc = "A receive buffer error event has not been detected."]
            VALUE1,
            #[doc = "A receive buffer error event has been detected."]
            VALUE2,
        }
        impl RBERIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RBERIW::VALUE1 => false,
                    RBERIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RBERIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RBERIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RBERIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A receive buffer error event has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RBERIW::VALUE1)
            }
            #[doc = "A receive buffer error event has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RBERIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARBI`"]
        pub enum ARBIW {
            #[doc = "An alternative receive buffer event has not been detected."]
            VALUE1,
            #[doc = "An alternative receive buffer event has been detected."]
            VALUE2,
        }
        impl ARBIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ARBIW::VALUE1 => false,
                    ARBIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARBIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARBIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARBIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An alternative receive buffer event has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARBIW::VALUE1)
            }
            #[doc = "An alternative receive buffer event has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARBIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STBI`"]
        pub enum STBIW {
            #[doc = "A standard transmit buffer event has not been detected."]
            VALUE1,
            #[doc = "A standard transmit buffer event has been detected."]
            VALUE2,
        }
        impl STBIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STBIW::VALUE1 => false,
                    STBIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STBIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STBIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STBIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A standard transmit buffer event has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STBIW::VALUE1)
            }
            #[doc = "A standard transmit buffer event has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STBIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TBERI`"]
        pub enum TBERIW {
            #[doc = "A transmit buffer error event has not been detected."]
            VALUE1,
            #[doc = "A transmit buffer error event has been detected."]
            VALUE2,
        }
        impl TBERIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TBERIW::VALUE1 => false,
                    TBERIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TBERIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TBERIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TBERIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A transmit buffer error event has not been detected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TBERIW::VALUE1)
            }
            #[doc = "A transmit buffer error event has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TBERIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Standard Receive Buffer Event"]
            #[inline]
            pub fn srbi(&self) -> SRBIR {
                SRBIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Receive Buffer Error Event"]
            #[inline]
            pub fn rberi(&self) -> RBERIR {
                RBERIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Alternative Receive Buffer Event"]
            #[inline]
            pub fn arbi(&self) -> ARBIR {
                ARBIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Receive Buffer Empty"]
            #[inline]
            pub fn rempty(&self) -> REMPTYR {
                REMPTYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Receive Buffer Full"]
            #[inline]
            pub fn rfull(&self) -> RFULLR {
                RFULLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Receive Buffer Busy"]
            #[inline]
            pub fn rbus(&self) -> RBUSR {
                RBUSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Standard Receive Buffer Event Trigger"]
            #[inline]
            pub fn srbt(&self) -> SRBTR {
                SRBTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Standard Transmit Buffer Event"]
            #[inline]
            pub fn stbi(&self) -> STBIR {
                STBIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Transmit Buffer Error Event"]
            #[inline]
            pub fn tberi(&self) -> TBERIR {
                TBERIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Transmit Buffer Empty"]
            #[inline]
            pub fn tempty(&self) -> TEMPTYR {
                TEMPTYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Transmit Buffer Full"]
            #[inline]
            pub fn tfull(&self) -> TFULLR {
                TFULLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Transmit Buffer Busy"]
            #[inline]
            pub fn tbus(&self) -> TBUSR {
                TBUSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Standard Transmit Buffer Event Trigger"]
            #[inline]
            pub fn stbt(&self) -> STBTR {
                STBTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:22 - Receive Buffer Filling Level"]
            #[inline]
            pub fn rbflvl(&self) -> RBFLVLR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RBFLVLR { bits }
            }
            #[doc = "Bits 24:30 - Transmit Buffer Filling Level"]
            #[inline]
            pub fn tbflvl(&self) -> TBFLVLR {
                let bits = {
                    const MASK: u8 = 0x7f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TBFLVLR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0808 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Standard Receive Buffer Event"]
            #[inline]
            pub fn srbi(&mut self) -> _SRBIW {
                _SRBIW { w: self }
            }
            #[doc = "Bit 1 - Receive Buffer Error Event"]
            #[inline]
            pub fn rberi(&mut self) -> _RBERIW {
                _RBERIW { w: self }
            }
            #[doc = "Bit 2 - Alternative Receive Buffer Event"]
            #[inline]
            pub fn arbi(&mut self) -> _ARBIW {
                _ARBIW { w: self }
            }
            #[doc = "Bit 8 - Standard Transmit Buffer Event"]
            #[inline]
            pub fn stbi(&mut self) -> _STBIW {
                _STBIW { w: self }
            }
            #[doc = "Bit 9 - Transmit Buffer Error Event"]
            #[inline]
            pub fn tberi(&mut self) -> _TBERIW {
                _TBERIW { w: self }
            }
        }
    }
    #[doc = "Transmit/Receive Buffer Status Clear Register"]
    pub struct TRBSCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmit/Receive Buffer Status Clear Register"]
    pub mod trbscr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TRBSCR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CSRBI`"]
        pub enum CSRBIW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Clear TRBSR.SRBI."]
            VALUE2,
        }
        impl CSRBIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CSRBIW::VALUE1 => false,
                    CSRBIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSRBIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSRBIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSRBIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSRBIW::VALUE1)
            }
            #[doc = "Clear TRBSR.SRBI."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSRBIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CRBERI`"]
        pub enum CRBERIW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Clear TRBSR.RBERI."]
            VALUE2,
        }
        impl CRBERIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CRBERIW::VALUE1 => false,
                    CRBERIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRBERIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRBERIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CRBERIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CRBERIW::VALUE1)
            }
            #[doc = "Clear TRBSR.RBERI."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CRBERIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CARBI`"]
        pub enum CARBIW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Clear TRBSR.ARBI."]
            VALUE2,
        }
        impl CARBIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CARBIW::VALUE1 => false,
                    CARBIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CARBIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CARBIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CARBIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CARBIW::VALUE1)
            }
            #[doc = "Clear TRBSR.ARBI."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CARBIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CSTBI`"]
        pub enum CSTBIW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Clear TRBSR.STBI."]
            VALUE2,
        }
        impl CSTBIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CSTBIW::VALUE1 => false,
                    CSTBIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSTBIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSTBIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSTBIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSTBIW::VALUE1)
            }
            #[doc = "Clear TRBSR.STBI."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSTBIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CTBERI`"]
        pub enum CTBERIW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Clear TRBSR.TBERI."]
            VALUE2,
        }
        impl CTBERIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CTBERIW::VALUE1 => false,
                    CTBERIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTBERIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTBERIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CTBERIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CTBERIW::VALUE1)
            }
            #[doc = "Clear TRBSR.TBERI."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CTBERIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CBDV`"]
        pub enum CBDVW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "Clear BYPCR.BDV."]
            VALUE2,
        }
        impl CBDVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CBDVW::VALUE1 => false,
                    CBDVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CBDVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CBDVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CBDVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CBDVW::VALUE1)
            }
            #[doc = "Clear BYPCR.BDV."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CBDVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLUSHRB`"]
        pub enum FLUSHRBW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "The receive FIFO buffer is cleared (filling level is cleared and output pointer is set to input pointer value). Should only be used while the FIFO buffer is not taking part in data traffic."]
            VALUE2,
        }
        impl FLUSHRBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLUSHRBW::VALUE1 => false,
                    FLUSHRBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLUSHRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLUSHRBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLUSHRBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLUSHRBW::VALUE1)
            }
            #[doc = "The receive FIFO buffer is cleared (filling level is cleared and output pointer is set to input pointer value). Should only be used while the FIFO buffer is not taking part in data traffic."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLUSHRBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLUSHTB`"]
        pub enum FLUSHTBW {
            #[doc = "No effect."]
            VALUE1,
            #[doc = "The transmit FIFO buffer is cleared (filling level is cleared and output pointer is set to input pointer value). Should only be used while the FIFO buffer is not taking part in data traffic."]
            VALUE2,
        }
        impl FLUSHTBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLUSHTBW::VALUE1 => false,
                    FLUSHTBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLUSHTBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLUSHTBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLUSHTBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No effect."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLUSHTBW::VALUE1)
            }
            #[doc = "The transmit FIFO buffer is cleared (filling level is cleared and output pointer is set to input pointer value). Should only be used while the FIFO buffer is not taking part in data traffic."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLUSHTBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Standard Receive Buffer Event"]
            #[inline]
            pub fn csrbi(&mut self) -> _CSRBIW {
                _CSRBIW { w: self }
            }
            #[doc = "Bit 1 - Clear Receive Buffer Error Event"]
            #[inline]
            pub fn crberi(&mut self) -> _CRBERIW {
                _CRBERIW { w: self }
            }
            #[doc = "Bit 2 - Clear Alternative Receive Buffer Event"]
            #[inline]
            pub fn carbi(&mut self) -> _CARBIW {
                _CARBIW { w: self }
            }
            #[doc = "Bit 8 - Clear Standard Transmit Buffer Event"]
            #[inline]
            pub fn cstbi(&mut self) -> _CSTBIW {
                _CSTBIW { w: self }
            }
            #[doc = "Bit 9 - Clear Transmit Buffer Error Event"]
            #[inline]
            pub fn ctberi(&mut self) -> _CTBERIW {
                _CTBERIW { w: self }
            }
            #[doc = "Bit 10 - Clear Bypass Data Valid"]
            #[inline]
            pub fn cbdv(&mut self) -> _CBDVW {
                _CBDVW { w: self }
            }
            #[doc = "Bit 14 - Flush Receive Buffer"]
            #[inline]
            pub fn flushrb(&mut self) -> _FLUSHRBW {
                _FLUSHRBW { w: self }
            }
            #[doc = "Bit 15 - Flush Transmit Buffer"]
            #[inline]
            pub fn flushtb(&mut self) -> _FLUSHTBW {
                _FLUSHTBW { w: self }
            }
        }
    }
    #[doc = "Receiver Buffer Output Register"]
    pub struct OUTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Output Register"]
    pub mod outr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::OUTR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSRR {
            bits: u16,
        }
        impl DSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RCIR {
            bits: u8,
        }
        impl RCIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Received Data"]
            #[inline]
            pub fn dsr(&self) -> DSRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSRR { bits }
            }
            #[doc = "Bits 16:20 - Receiver Control Information"]
            #[inline]
            pub fn rci(&self) -> RCIR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RCIR { bits }
            }
        }
    }
    #[doc = "Receiver Buffer Output Register L for Debugger"]
    pub struct OUTDR {
        register: VolatileCell<u32>,
    }
    #[doc = "Receiver Buffer Output Register L for Debugger"]
    pub mod outdr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::OUTDR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSRR {
            bits: u16,
        }
        impl DSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RCIR {
            bits: u8,
        }
        impl RCIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Data from Shift Register"]
            #[inline]
            pub fn dsr(&self) -> DSRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSRR { bits }
            }
            #[doc = "Bits 16:20 - Receive Control Information from Shift Register"]
            #[inline]
            pub fn rci(&self) -> RCIR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RCIR { bits }
            }
        }
    }
    #[doc = "Transmit FIFO Buffer"]
    pub struct IN {
        register: VolatileCell<u32>,
    }
    #[doc = "Transmit FIFO Buffer"]
    pub mod in_ {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IN {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _TDATAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TDATAW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Transmit Data"]
            #[inline]
            pub fn tdata(&mut self) -> _TDATAW {
                _TDATAW { w: self }
            }
        }
    }
}
#[doc = "Universal Serial Interface Controller 0"]
pub struct USIC0_CH0 {
    register_block: usic0_ch0::RegisterBlock,
}
impl Deref for USIC0_CH0 {
    type Target = usic0_ch0::RegisterBlock;
    fn deref(&self) -> &usic0_ch0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Interface Controller 0"]
pub const USIC0_CH1: Peripheral<USIC0_CH1> = unsafe { Peripheral::new(0x4003_0200) };
#[doc = r" Register block"]
pub struct USIC0_CH1 {
    register_block: usic0_ch0::RegisterBlock,
}
impl Deref for USIC0_CH1 {
    type Target = usic0_ch0::RegisterBlock;
    fn deref(&self) -> &usic0_ch0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Interface Controller 1"]
pub const USIC1_CH0: Peripheral<USIC1_CH0> = unsafe { Peripheral::new(0x4802_0000) };
#[doc = r" Register block"]
pub struct USIC1_CH0 {
    register_block: usic0_ch0::RegisterBlock,
}
impl Deref for USIC1_CH0 {
    type Target = usic0_ch0::RegisterBlock;
    fn deref(&self) -> &usic0_ch0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Universal Serial Interface Controller 1"]
pub const USIC1_CH1: Peripheral<USIC1_CH1> = unsafe { Peripheral::new(0x4802_0200) };
#[doc = r" Register block"]
pub struct USIC1_CH1 {
    register_block: usic0_ch0::RegisterBlock,
}
impl Deref for USIC1_CH1 {
    type Target = usic0_ch0::RegisterBlock;
    fn deref(&self) -> &usic0_ch0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN: Peripheral<CAN> = unsafe { Peripheral::new(0x4801_4000) };
#[doc = "Controller Area Networks"]
pub mod can {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - CAN Clock Control Register"]
        pub clc: CLC,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Module Identification Register"]
        pub id: ID,
        #[doc = "0x0c - CAN Fractional Divider Register"]
        pub fdr: FDR,
        _reserved1: [u8; 240usize],
        #[doc = "0x100 - List Register"]
        pub list: [LIST; 8],
        _reserved2: [u8; 32usize],
        #[doc = "0x140 - Message Pending Register"]
        pub mspnd: [MSPND; 8],
        _reserved3: [u8; 32usize],
        #[doc = "0x180 - Message Index Register"]
        pub msid: [MSID; 8],
        _reserved4: [u8; 32usize],
        #[doc = "0x1c0 - Message Index Mask Register"]
        pub msimask: MSIMASK,
        #[doc = "0x1c4 - Panel Control Register"]
        pub panctr: PANCTR,
        #[doc = "0x1c8 - Module Control Register"]
        pub mcr: MCR,
        #[doc = "0x1cc - Module Interrupt Trigger Register"]
        pub mitr: MITR,
    }
    #[doc = "CAN Clock Control Register"]
    pub struct CLC {
        register: VolatileCell<u32>,
    }
    #[doc = "CAN Clock Control Register"]
    pub mod clc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISRR {
            bits: bool,
        }
        impl DISRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISSR {
            bits: bool,
        }
        impl DISSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EDISR {
            bits: bool,
        }
        impl EDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SBWEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SBWEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Module Disable Request Bit"]
            #[inline]
            pub fn disr(&self) -> DISRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISRR { bits }
            }
            #[doc = "Bit 1 - Module Disable Status Bit"]
            #[inline]
            pub fn diss(&self) -> DISSR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISSR { bits }
            }
            #[doc = "Bit 3 - Sleep Mode Enable Control"]
            #[inline]
            pub fn edis(&self) -> EDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EDISR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x03 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Module Disable Request Bit"]
            #[inline]
            pub fn disr(&mut self) -> _DISRW {
                _DISRW { w: self }
            }
            #[doc = "Bit 3 - Sleep Mode Enable Control"]
            #[inline]
            pub fn edis(&mut self) -> _EDISW {
                _EDISW { w: self }
            }
            #[doc = "Bit 4 - Module Suspend Bit Write Enable for OCDS"]
            #[inline]
            pub fn sbwe(&mut self) -> _SBWEW {
                _SBWEW { w: self }
            }
        }
    }
    #[doc = "Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `MOD_TYPE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MOD_TYPER {
            #[doc = "Define the module as a 32-bit module."]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MOD_TYPER::VALUE1 => 0xc0,
                    MOD_TYPER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MOD_TYPER {
                match value {
                    192 => MOD_TYPER::VALUE1,
                    i => MOD_TYPER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MOD_TYPER::VALUE1
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision Number"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                MOD_TYPER::_from({
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:31 - Module Number Value"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "CAN Fractional Divider Register"]
    pub struct FDR {
        register: VolatileCell<u32>,
    }
    #[doc = "CAN Fractional Divider Register"]
    pub mod fdr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FDR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct STEPR {
            bits: u16,
        }
        impl STEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SMR {
            bits: bool,
        }
        impl SMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SCR {
            bits: u8,
        }
        impl SCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DMR {
            bits: u8,
        }
        impl DMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SUSACKR {
            bits: bool,
        }
        impl SUSACKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SUSREQR {
            bits: bool,
        }
        impl SUSREQR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENHWR {
            bits: bool,
        }
        impl ENHWR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DISCLKR {
            bits: bool,
        }
        impl DISCLKR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _STEPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STEPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENHWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENHWW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISCLKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - Step Value"]
            #[inline]
            pub fn step(&self) -> STEPR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                STEPR { bits }
            }
            #[doc = "Bit 11 - Suspend Mode"]
            #[inline]
            pub fn sm(&self) -> SMR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SMR { bits }
            }
            #[doc = "Bits 12:13 - Suspend Control"]
            #[inline]
            pub fn sc(&self) -> SCR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SCR { bits }
            }
            #[doc = "Bits 14:15 - Divider Mode"]
            #[inline]
            pub fn dm(&self) -> DMR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DMR { bits }
            }
            #[doc = "Bits 16:25 - Result Value"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
            #[doc = "Bit 28 - Suspend Mode Acknowledge"]
            #[inline]
            pub fn susack(&self) -> SUSACKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SUSACKR { bits }
            }
            #[doc = "Bit 29 - Suspend Mode Request"]
            #[inline]
            pub fn susreq(&self) -> SUSREQR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SUSREQR { bits }
            }
            #[doc = "Bit 30 - Enable Hardware Clock Control"]
            #[inline]
            pub fn enhw(&self) -> ENHWR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENHWR { bits }
            }
            #[doc = "Bit 31 - Disable Clock"]
            #[inline]
            pub fn disclk(&self) -> DISCLKR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                DISCLKR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:9 - Step Value"]
            #[inline]
            pub fn step(&mut self) -> _STEPW {
                _STEPW { w: self }
            }
            #[doc = "Bit 11 - Suspend Mode"]
            #[inline]
            pub fn sm(&mut self) -> _SMW {
                _SMW { w: self }
            }
            #[doc = "Bits 12:13 - Suspend Control"]
            #[inline]
            pub fn sc(&mut self) -> _SCW {
                _SCW { w: self }
            }
            #[doc = "Bits 14:15 - Divider Mode"]
            #[inline]
            pub fn dm(&mut self) -> _DMW {
                _DMW { w: self }
            }
            #[doc = "Bit 30 - Enable Hardware Clock Control"]
            #[inline]
            pub fn enhw(&mut self) -> _ENHWW {
                _ENHWW { w: self }
            }
            #[doc = "Bit 31 - Disable Clock"]
            #[inline]
            pub fn disclk(&mut self) -> _DISCLKW {
                _DISCLKW { w: self }
            }
        }
    }
    #[doc = "List Register"]
    pub struct LIST {
        register: VolatileCell<u32>,
    }
    #[doc = "List Register"]
    pub mod list {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::LIST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct BEGINR {
            bits: u8,
        }
        impl BEGINR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENDR {
            bits: u8,
        }
        impl ENDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SIZER {
            bits: u8,
        }
        impl SIZER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `EMPTY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMPTYR {
            #[doc = "At least one message object is allocated to list i."]
            VALUE1,
            #[doc = "No message object is allocated to the list x. List x is empty."]
            VALUE2,
        }
        impl EMPTYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMPTYR::VALUE1 => false,
                    EMPTYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMPTYR {
                match value {
                    false => EMPTYR::VALUE1,
                    true => EMPTYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMPTYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMPTYR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - List Begin"]
            #[inline]
            pub fn begin(&self) -> BEGINR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BEGINR { bits }
            }
            #[doc = "Bits 8:15 - List End"]
            #[inline]
            pub fn end(&self) -> ENDR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ENDR { bits }
            }
            #[doc = "Bits 16:23 - List Size"]
            #[inline]
            pub fn size(&self) -> SIZER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SIZER { bits }
            }
            #[doc = "Bit 24 - List Empty Indication"]
            #[inline]
            pub fn empty(&self) -> EMPTYR {
                EMPTYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Message Pending Register"]
    pub struct MSPND {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Pending Register"]
    pub mod mspnd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MSPND {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PNDR {
            bits: u32,
        }
        impl PNDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PNDW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Message Pending"]
            #[inline]
            pub fn pnd(&self) -> PNDR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PNDR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Message Pending"]
            #[inline]
            pub fn pnd(&mut self) -> _PNDW {
                _PNDW { w: self }
            }
        }
    }
    #[doc = "Message Index Register"]
    pub struct MSID {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Index Register"]
    pub mod msid {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MSID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct INDEXR {
            bits: u8,
        }
        impl INDEXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Message Pending Index"]
            #[inline]
            pub fn index(&self) -> INDEXR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                INDEXR { bits }
            }
        }
    }
    #[doc = "Message Index Mask Register"]
    pub struct MSIMASK {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Index Mask Register"]
    pub mod msimask {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MSIMASK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct IMR {
            bits: u32,
        }
        impl IMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _IMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0xffff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:31 - Message Index Mask"]
            #[inline]
            pub fn im(&self) -> IMR {
                let bits = {
                    const MASK: u32 = 0xffff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IMR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:31 - Message Index Mask"]
            #[inline]
            pub fn im(&mut self) -> _IMW {
                _IMW { w: self }
            }
        }
    }
    #[doc = "Panel Control Register"]
    pub struct PANCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Panel Control Register"]
    pub mod panctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PANCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PANCMDR {
            bits: u8,
        }
        impl PANCMDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `BUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BUSYR {
            #[doc = "Panel has finished command and is ready to accept a new command."]
            VALUE1,
            #[doc = "Panel operation is in progress."]
            VALUE2,
        }
        impl BUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BUSYR::VALUE1 => false,
                    BUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BUSYR {
                match value {
                    false => BUSYR::VALUE1,
                    true => BUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BUSYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RBUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RBUSYR {
            #[doc = "No update of PANAR1 and PANAR2 is scheduled by the list controller."]
            VALUE1,
            #[doc = "A list command is running (BUSY = 1) that will write results to PANAR1 and PANAR2, but the results are not yet available."]
            VALUE2,
        }
        impl RBUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RBUSYR::VALUE1 => false,
                    RBUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RBUSYR {
                match value {
                    false => RBUSYR::VALUE1,
                    true => RBUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RBUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RBUSYR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PANAR1R {
            bits: u8,
        }
        impl PANAR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PANAR2R {
            bits: u8,
        }
        impl PANAR2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PANCMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PANCMDW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PANAR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PANAR1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PANAR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PANAR2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Panel Command"]
            #[inline]
            pub fn pancmd(&self) -> PANCMDR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PANCMDR { bits }
            }
            #[doc = "Bit 8 - Panel Busy Flag"]
            #[inline]
            pub fn busy(&self) -> BUSYR {
                BUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Result Busy Flag"]
            #[inline]
            pub fn rbusy(&self) -> RBUSYR {
                RBUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:23 - Panel Argument 1"]
            #[inline]
            pub fn panar1(&self) -> PANAR1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PANAR1R { bits }
            }
            #[doc = "Bits 24:31 - Panel Argument 2"]
            #[inline]
            pub fn panar2(&self) -> PANAR2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PANAR2R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0301 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Panel Command"]
            #[inline]
            pub fn pancmd(&mut self) -> _PANCMDW {
                _PANCMDW { w: self }
            }
            #[doc = "Bits 16:23 - Panel Argument 1"]
            #[inline]
            pub fn panar1(&mut self) -> _PANAR1W {
                _PANAR1W { w: self }
            }
            #[doc = "Bits 24:31 - Panel Argument 2"]
            #[inline]
            pub fn panar2(&mut self) -> _PANAR2W {
                _PANAR2W { w: self }
            }
        }
    }
    #[doc = "Module Control Register"]
    pub struct MCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Control Register"]
    pub mod mcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPSELR {
            bits: u8,
        }
        impl MPSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 12:15 - Message Pending Selector"]
            #[inline]
            pub fn mpsel(&self) -> MPSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MPSELR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 12:15 - Message Pending Selector"]
            #[inline]
            pub fn mpsel(&mut self) -> _MPSELW {
                _MPSELW { w: self }
            }
        }
    }
    #[doc = "Module Interrupt Trigger Register"]
    pub struct MITR {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Interrupt Trigger Register"]
    pub mod mitr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MITR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _ITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ITW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Interrupt Trigger"]
            #[inline]
            pub fn it(&mut self) -> _ITW {
                _ITW { w: self }
            }
        }
    }
}
#[doc = "Controller Area Networks"]
pub struct CAN {
    register_block: can::RegisterBlock,
}
impl Deref for CAN {
    type Target = can::RegisterBlock;
    fn deref(&self) -> &can::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_NODE0: Peripheral<CAN_NODE0> = unsafe { Peripheral::new(0x4801_4200) };
#[doc = "Controller Area Networks"]
pub mod can_node0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Node Control Register"]
        pub ncr: NCR,
        #[doc = "0x04 - Node Status Register"]
        pub nsr: NSR,
        #[doc = "0x08 - Node Interrupt Pointer Register"]
        pub nipr: NIPR,
        #[doc = "0x0c - Node Port Control Register"]
        pub npcr: NPCR,
        #[doc = "0x10 - Node Bit Timing Register"]
        pub nbtr: NBTR,
        #[doc = "0x14 - Node Error Counter Register"]
        pub necnt: NECNT,
        #[doc = "0x18 - Node Frame Counter Register"]
        pub nfcr: NFCR,
    }
    #[doc = "Node Control Register"]
    pub struct NCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Control Register"]
    pub mod ncr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `INIT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INITR {
            #[doc = "Resetting bit INIT enables the participation of the node in the CAN traffic. If the CAN node is in the bus-off state, the ongoing bus-off recovery (which does not depend on the INIT bit) is continued. With the end of the bus-off recovery sequence the CAN node is allowed to take part in the CAN traffic. If the CAN node is not in the bus-off state, a sequence of 11 consecutive recessive bits must be detected before the node is allowed to take part in the CAN traffic."]
            VALUE1,
            #[doc = "Setting this bit terminates the participation of this node in the CAN traffic. Any ongoing frame transfer is cancelled and the transmit line goes recessive. If the CAN node is in the bus-off state, then the running bus-off recovery sequence is continued. If the INIT bit is still set after the successful completion of the bus-off recovery sequence, i.e. after detecting 128 sequences of 11 consecutive recessive bits (11 1), then the CAN node leaves the bus-off state but remains inactive as long as INIT remains set."]
            VALUE2,
        }
        impl INITR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INITR::VALUE1 => false,
                    INITR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INITR {
                match value {
                    false => INITR::VALUE1,
                    true => INITR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INITR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INITR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRIER {
            #[doc = "Transfer interrupt is disabled."]
            VALUE1,
            #[doc = "Transfer interrupt is enabled."]
            VALUE2,
        }
        impl TRIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRIER::VALUE1 => false,
                    TRIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRIER {
                match value {
                    false => TRIER::VALUE1,
                    true => TRIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `LECIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LECIER {
            #[doc = "Last error code interrupt is disabled."]
            VALUE1,
            #[doc = "Last error code interrupt is enabled."]
            VALUE2,
        }
        impl LECIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LECIER::VALUE1 => false,
                    LECIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LECIER {
                match value {
                    false => LECIER::VALUE1,
                    true => LECIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LECIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LECIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `ALIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ALIER {
            #[doc = "Alert interrupt is disabled."]
            VALUE1,
            #[doc = "Alert interrupt is enabled."]
            VALUE2,
        }
        impl ALIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ALIER::VALUE1 => false,
                    ALIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ALIER {
                match value {
                    false => ALIER::VALUE1,
                    true => ALIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ALIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ALIER::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CANDISR {
            bits: bool,
        }
        impl CANDISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `CCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCER {
            #[doc = "The Bit Timing Register, the Port Control Register, and the Error Counter Register may only be read. All attempts to modify them are ignored."]
            VALUE1,
            #[doc = "The Bit Timing Register, the Port Control Register, and the Error Counter Register may be read and written."]
            VALUE2,
        }
        impl CCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCER::VALUE1 => false,
                    CCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCER {
                match value {
                    false => CCER::VALUE1,
                    true => CCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCER::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CALMR {
            bits: bool,
        }
        impl CALMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `SUSEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSENR {
            #[doc = "An OCDS suspend trigger is ignored by the CAN node."]
            VALUE1,
            #[doc = "An OCDS suspend trigger disables the CAN node: As soon as the CAN node becomes bus-idle or bus-off, bit INIT is internally forced to 1 to disable the CAN node. The actual value of bit INIT remains unchanged."]
            VALUE2,
        }
        impl SUSENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SUSENR::VALUE1 => false,
                    SUSENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SUSENR {
                match value {
                    false => SUSENR::VALUE1,
                    true => SUSENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `INIT`"]
        pub enum INITW {
            #[doc = "Resetting bit INIT enables the participation of the node in the CAN traffic. If the CAN node is in the bus-off state, the ongoing bus-off recovery (which does not depend on the INIT bit) is continued. With the end of the bus-off recovery sequence the CAN node is allowed to take part in the CAN traffic. If the CAN node is not in the bus-off state, a sequence of 11 consecutive recessive bits must be detected before the node is allowed to take part in the CAN traffic."]
            VALUE1,
            #[doc = "Setting this bit terminates the participation of this node in the CAN traffic. Any ongoing frame transfer is cancelled and the transmit line goes recessive. If the CAN node is in the bus-off state, then the running bus-off recovery sequence is continued. If the INIT bit is still set after the successful completion of the bus-off recovery sequence, i.e. after detecting 128 sequences of 11 consecutive recessive bits (11 1), then the CAN node leaves the bus-off state but remains inactive as long as INIT remains set."]
            VALUE2,
        }
        impl INITW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INITW::VALUE1 => false,
                    INITW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INITW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INITW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INITW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Resetting bit INIT enables the participation of the node in the CAN traffic. If the CAN node is in the bus-off state, the ongoing bus-off recovery (which does not depend on the INIT bit) is continued. With the end of the bus-off recovery sequence the CAN node is allowed to take part in the CAN traffic. If the CAN node is not in the bus-off state, a sequence of 11 consecutive recessive bits must be detected before the node is allowed to take part in the CAN traffic."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INITW::VALUE1)
            }
            #[doc = "Setting this bit terminates the participation of this node in the CAN traffic. Any ongoing frame transfer is cancelled and the transmit line goes recessive. If the CAN node is in the bus-off state, then the running bus-off recovery sequence is continued. If the INIT bit is still set after the successful completion of the bus-off recovery sequence, i.e. after detecting 128 sequences of 11 consecutive recessive bits (11 1), then the CAN node leaves the bus-off state but remains inactive as long as INIT remains set."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INITW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRIE`"]
        pub enum TRIEW {
            #[doc = "Transfer interrupt is disabled."]
            VALUE1,
            #[doc = "Transfer interrupt is enabled."]
            VALUE2,
        }
        impl TRIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRIEW::VALUE1 => false,
                    TRIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Transfer interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRIEW::VALUE1)
            }
            #[doc = "Transfer interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LECIE`"]
        pub enum LECIEW {
            #[doc = "Last error code interrupt is disabled."]
            VALUE1,
            #[doc = "Last error code interrupt is enabled."]
            VALUE2,
        }
        impl LECIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LECIEW::VALUE1 => false,
                    LECIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LECIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LECIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LECIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Last error code interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LECIEW::VALUE1)
            }
            #[doc = "Last error code interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LECIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ALIE`"]
        pub enum ALIEW {
            #[doc = "Alert interrupt is disabled."]
            VALUE1,
            #[doc = "Alert interrupt is enabled."]
            VALUE2,
        }
        impl ALIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ALIEW::VALUE1 => false,
                    ALIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ALIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Alert interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ALIEW::VALUE1)
            }
            #[doc = "Alert interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ALIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CANDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CANDISW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCE`"]
        pub enum CCEW {
            #[doc = "The Bit Timing Register, the Port Control Register, and the Error Counter Register may only be read. All attempts to modify them are ignored."]
            VALUE1,
            #[doc = "The Bit Timing Register, the Port Control Register, and the Error Counter Register may be read and written."]
            VALUE2,
        }
        impl CCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCEW::VALUE1 => false,
                    CCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The Bit Timing Register, the Port Control Register, and the Error Counter Register may only be read. All attempts to modify them are ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCEW::VALUE1)
            }
            #[doc = "The Bit Timing Register, the Port Control Register, and the Error Counter Register may be read and written."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CALMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CALMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUSEN`"]
        pub enum SUSENW {
            #[doc = "An OCDS suspend trigger is ignored by the CAN node."]
            VALUE1,
            #[doc = "An OCDS suspend trigger disables the CAN node: As soon as the CAN node becomes bus-idle or bus-off, bit INIT is internally forced to 1 to disable the CAN node. The actual value of bit INIT remains unchanged."]
            VALUE2,
        }
        impl SUSENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SUSENW::VALUE1 => false,
                    SUSENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUSENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUSENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUSENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "An OCDS suspend trigger is ignored by the CAN node."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUSENW::VALUE1)
            }
            #[doc = "An OCDS suspend trigger disables the CAN node: As soon as the CAN node becomes bus-idle or bus-off, bit INIT is internally forced to 1 to disable the CAN node. The actual value of bit INIT remains unchanged."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUSENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Node Initialization"]
            #[inline]
            pub fn init(&self) -> INITR {
                INITR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Transfer Interrupt Enable"]
            #[inline]
            pub fn trie(&self) -> TRIER {
                TRIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - LEC Indicated Error Interrupt Enable"]
            #[inline]
            pub fn lecie(&self) -> LECIER {
                LECIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Alert Interrupt Enable"]
            #[inline]
            pub fn alie(&self) -> ALIER {
                ALIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - CAN Disable"]
            #[inline]
            pub fn candis(&self) -> CANDISR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CANDISR { bits }
            }
            #[doc = "Bit 6 - Configuration Change Enable"]
            #[inline]
            pub fn cce(&self) -> CCER {
                CCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - CAN Analyzer Mode"]
            #[inline]
            pub fn calm(&self) -> CALMR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CALMR { bits }
            }
            #[doc = "Bit 8 - Suspend Enable"]
            #[inline]
            pub fn susen(&self) -> SUSENR {
                SUSENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x01 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Node Initialization"]
            #[inline]
            pub fn init(&mut self) -> _INITW {
                _INITW { w: self }
            }
            #[doc = "Bit 1 - Transfer Interrupt Enable"]
            #[inline]
            pub fn trie(&mut self) -> _TRIEW {
                _TRIEW { w: self }
            }
            #[doc = "Bit 2 - LEC Indicated Error Interrupt Enable"]
            #[inline]
            pub fn lecie(&mut self) -> _LECIEW {
                _LECIEW { w: self }
            }
            #[doc = "Bit 3 - Alert Interrupt Enable"]
            #[inline]
            pub fn alie(&mut self) -> _ALIEW {
                _ALIEW { w: self }
            }
            #[doc = "Bit 4 - CAN Disable"]
            #[inline]
            pub fn candis(&mut self) -> _CANDISW {
                _CANDISW { w: self }
            }
            #[doc = "Bit 6 - Configuration Change Enable"]
            #[inline]
            pub fn cce(&mut self) -> _CCEW {
                _CCEW { w: self }
            }
            #[doc = "Bit 7 - CAN Analyzer Mode"]
            #[inline]
            pub fn calm(&mut self) -> _CALMW {
                _CALMW { w: self }
            }
            #[doc = "Bit 8 - Suspend Enable"]
            #[inline]
            pub fn susen(&mut self) -> _SUSENW {
                _SUSENW { w: self }
            }
        }
    }
    #[doc = "Node Status Register"]
    pub struct NSR {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Status Register"]
    pub mod nsr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NSR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct LECR {
            bits: u8,
        }
        impl LECR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `TXOK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXOKR {
            #[doc = "No successful transmission since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A message has been transmitted successfully (error-free and acknowledged by at least another node)."]
            VALUE2,
        }
        impl TXOKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXOKR::VALUE1 => false,
                    TXOKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXOKR {
                match value {
                    false => TXOKR::VALUE1,
                    true => TXOKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXOKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXOKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RXOK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXOKR {
            #[doc = "No successful reception since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A message has been received successfully."]
            VALUE2,
        }
        impl RXOKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RXOKR::VALUE1 => false,
                    RXOKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RXOKR {
                match value {
                    false => RXOKR::VALUE1,
                    true => RXOKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXOKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXOKR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct ALERTR {
            bits: bool,
        }
        impl ALERTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `EWRN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EWRNR {
            #[doc = "No warning limit exceeded."]
            VALUE1,
            #[doc = "One of the error counters REC or TEC reached the warning limit EWRNLVL."]
            VALUE2,
        }
        impl EWRNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EWRNR::VALUE1 => false,
                    EWRNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EWRNR {
                match value {
                    false => EWRNR::VALUE1,
                    true => EWRNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EWRNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EWRNR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BOFF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BOFFR {
            #[doc = "CAN controller is not in the bus-off state."]
            VALUE1,
            #[doc = "CAN controller is in the bus-off state."]
            VALUE2,
        }
        impl BOFFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BOFFR::VALUE1 => false,
                    BOFFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BOFFR {
                match value {
                    false => BOFFR::VALUE1,
                    true => BOFFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BOFFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BOFFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LLER {
            #[doc = "No List Length Error since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A List Length Error has been detected during message acceptance filtering. The number of elements in the list that belongs to this CAN node differs from the list SIZE given in the list termination pointer."]
            VALUE2,
        }
        impl LLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LLER::VALUE1 => false,
                    LLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LLER {
                match value {
                    false => LLER::VALUE1,
                    true => LLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LLER::VALUE2
            }
        }
        #[doc = "Possible values of the field `LOE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LOER {
            #[doc = "No List Object Error since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A List Object Error has been detected during message acceptance filtering. A message object with wrong LIST index entry in the Message Object Control Register has been detected."]
            VALUE2,
        }
        impl LOER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LOER::VALUE1 => false,
                    LOER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LOER {
                match value {
                    false => LOER::VALUE1,
                    true => LOER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LOER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LOER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SUSACK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSACKR {
            #[doc = "The CAN node is not in Suspend Mode or a suspend request is pending, but the CAN node has not yet reached bus-idle or bus-off."]
            VALUE1,
            #[doc = "The CAN node is in Suspend Mode: The CAN node is inactive (bit NCR.INIT internally forced to 1) due to an OCDS suspend request."]
            VALUE2,
        }
        impl SUSACKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SUSACKR::VALUE1 => false,
                    SUSACKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SUSACKR {
                match value {
                    false => SUSACKR::VALUE1,
                    true => SUSACKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSACKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSACKR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _LECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LECW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TXOK`"]
        pub enum TXOKW {
            #[doc = "No successful transmission since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A message has been transmitted successfully (error-free and acknowledged by at least another node)."]
            VALUE2,
        }
        impl TXOKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TXOKW::VALUE1 => false,
                    TXOKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXOKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXOKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TXOKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No successful transmission since last (most recent) flag reset."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TXOKW::VALUE1)
            }
            #[doc = "A message has been transmitted successfully (error-free and acknowledged by at least another node)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TXOKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RXOK`"]
        pub enum RXOKW {
            #[doc = "No successful reception since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A message has been received successfully."]
            VALUE2,
        }
        impl RXOKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RXOKW::VALUE1 => false,
                    RXOKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXOKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXOKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RXOKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No successful reception since last (most recent) flag reset."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RXOKW::VALUE1)
            }
            #[doc = "A message has been received successfully."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RXOKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALERTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALERTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LLE`"]
        pub enum LLEW {
            #[doc = "No List Length Error since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A List Length Error has been detected during message acceptance filtering. The number of elements in the list that belongs to this CAN node differs from the list SIZE given in the list termination pointer."]
            VALUE2,
        }
        impl LLEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LLEW::VALUE1 => false,
                    LLEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LLEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LLEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LLEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No List Length Error since last (most recent) flag reset."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LLEW::VALUE1)
            }
            #[doc = "A List Length Error has been detected during message acceptance filtering. The number of elements in the list that belongs to this CAN node differs from the list SIZE given in the list termination pointer."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LLEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LOE`"]
        pub enum LOEW {
            #[doc = "No List Object Error since last (most recent) flag reset."]
            VALUE1,
            #[doc = "A List Object Error has been detected during message acceptance filtering. A message object with wrong LIST index entry in the Message Object Control Register has been detected."]
            VALUE2,
        }
        impl LOEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LOEW::VALUE1 => false,
                    LOEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LOEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LOEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LOEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No List Object Error since last (most recent) flag reset."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LOEW::VALUE1)
            }
            #[doc = "A List Object Error has been detected during message acceptance filtering. A message object with wrong LIST index entry in the Message Object Control Register has been detected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LOEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Last Error Code"]
            #[inline]
            pub fn lec(&self) -> LECR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LECR { bits }
            }
            #[doc = "Bit 3 - Message Transmitted Successfully"]
            #[inline]
            pub fn txok(&self) -> TXOKR {
                TXOKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Message Received Successfully"]
            #[inline]
            pub fn rxok(&self) -> RXOKR {
                RXOKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Alert Warning"]
            #[inline]
            pub fn alert(&self) -> ALERTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ALERTR { bits }
            }
            #[doc = "Bit 6 - Error Warning Status"]
            #[inline]
            pub fn ewrn(&self) -> EWRNR {
                EWRNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Bus-off Status"]
            #[inline]
            pub fn boff(&self) -> BOFFR {
                BOFFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - List Length Error"]
            #[inline]
            pub fn lle(&self) -> LLER {
                LLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - List Object Error"]
            #[inline]
            pub fn loe(&self) -> LOER {
                LOER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Suspend Acknowledge"]
            #[inline]
            pub fn susack(&self) -> SUSACKR {
                SUSACKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Last Error Code"]
            #[inline]
            pub fn lec(&mut self) -> _LECW {
                _LECW { w: self }
            }
            #[doc = "Bit 3 - Message Transmitted Successfully"]
            #[inline]
            pub fn txok(&mut self) -> _TXOKW {
                _TXOKW { w: self }
            }
            #[doc = "Bit 4 - Message Received Successfully"]
            #[inline]
            pub fn rxok(&mut self) -> _RXOKW {
                _RXOKW { w: self }
            }
            #[doc = "Bit 5 - Alert Warning"]
            #[inline]
            pub fn alert(&mut self) -> _ALERTW {
                _ALERTW { w: self }
            }
            #[doc = "Bit 8 - List Length Error"]
            #[inline]
            pub fn lle(&mut self) -> _LLEW {
                _LLEW { w: self }
            }
            #[doc = "Bit 9 - List Object Error"]
            #[inline]
            pub fn loe(&mut self) -> _LOEW {
                _LOEW { w: self }
            }
        }
    }
    #[doc = "Node Interrupt Pointer Register"]
    pub struct NIPR {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Interrupt Pointer Register"]
    pub mod nipr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NIPR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ALINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ALINPR {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ALINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ALINPR::VALUE1 => 0,
                    ALINPR::VALUE2 => 0x01,
                    ALINPR::VALUE3 => 0x07,
                    ALINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ALINPR {
                match value {
                    0 => ALINPR::VALUE1,
                    1 => ALINPR::VALUE2,
                    7 => ALINPR::VALUE3,
                    i => ALINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ALINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ALINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ALINPR::VALUE3
            }
        }
        #[doc = "Possible values of the field `LECINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LECINPR {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl LECINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LECINPR::VALUE1 => 0,
                    LECINPR::VALUE2 => 0x01,
                    LECINPR::VALUE3 => 0x07,
                    LECINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LECINPR {
                match value {
                    0 => LECINPR::VALUE1,
                    1 => LECINPR::VALUE2,
                    7 => LECINPR::VALUE3,
                    i => LECINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LECINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LECINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LECINPR::VALUE3
            }
        }
        #[doc = "Possible values of the field `TRINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRINPR {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TRINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRINPR::VALUE1 => 0,
                    TRINPR::VALUE2 => 0x01,
                    TRINPR::VALUE3 => 0x07,
                    TRINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRINPR {
                match value {
                    0 => TRINPR::VALUE1,
                    1 => TRINPR::VALUE2,
                    7 => TRINPR::VALUE3,
                    i => TRINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRINPR::VALUE3
            }
        }
        #[doc = "Possible values of the field `CFCINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CFCINPR {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CFCINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CFCINPR::VALUE1 => 0,
                    CFCINPR::VALUE2 => 0x01,
                    CFCINPR::VALUE3 => 0x07,
                    CFCINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CFCINPR {
                match value {
                    0 => CFCINPR::VALUE1,
                    1 => CFCINPR::VALUE2,
                    7 => CFCINPR::VALUE3,
                    i => CFCINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CFCINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CFCINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CFCINPR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `ALINP`"]
        pub enum ALINPW {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
        }
        impl ALINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ALINPW::VALUE1 => 0,
                    ALINPW::VALUE2 => 1,
                    ALINPW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ALINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Interrupt output line INT_O0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ALINPW::VALUE1)
            }
            #[doc = "Interrupt output line INT_O1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ALINPW::VALUE2)
            }
            #[doc = "Interrupt output line INT_O7 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ALINPW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LECINP`"]
        pub enum LECINPW {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
        }
        impl LECINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LECINPW::VALUE1 => 0,
                    LECINPW::VALUE2 => 1,
                    LECINPW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LECINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LECINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LECINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Interrupt output line INT_O0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LECINPW::VALUE1)
            }
            #[doc = "Interrupt output line INT_O1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LECINPW::VALUE2)
            }
            #[doc = "Interrupt output line INT_O7 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LECINPW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRINP`"]
        pub enum TRINPW {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
        }
        impl TRINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRINPW::VALUE1 => 0,
                    TRINPW::VALUE2 => 1,
                    TRINPW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Interrupt output line INT_O0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRINPW::VALUE1)
            }
            #[doc = "Interrupt output line INT_O1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRINPW::VALUE2)
            }
            #[doc = "Interrupt output line INT_O7 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRINPW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CFCINP`"]
        pub enum CFCINPW {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
        }
        impl CFCINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CFCINPW::VALUE1 => 0,
                    CFCINPW::VALUE2 => 1,
                    CFCINPW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFCINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFCINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CFCINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Interrupt output line INT_O0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CFCINPW::VALUE1)
            }
            #[doc = "Interrupt output line INT_O1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CFCINPW::VALUE2)
            }
            #[doc = "Interrupt output line INT_O7 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CFCINPW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Alert Interrupt Node Pointer"]
            #[inline]
            pub fn alinp(&self) -> ALINPR {
                ALINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:6 - Last Error Code Interrupt Node Pointer"]
            #[inline]
            pub fn lecinp(&self) -> LECINPR {
                LECINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:10 - Transfer OK Interrupt Node Pointer"]
            #[inline]
            pub fn trinp(&self) -> TRINPR {
                TRINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:14 - Frame Counter Interrupt Node Pointer"]
            #[inline]
            pub fn cfcinp(&self) -> CFCINPR {
                CFCINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Alert Interrupt Node Pointer"]
            #[inline]
            pub fn alinp(&mut self) -> _ALINPW {
                _ALINPW { w: self }
            }
            #[doc = "Bits 4:6 - Last Error Code Interrupt Node Pointer"]
            #[inline]
            pub fn lecinp(&mut self) -> _LECINPW {
                _LECINPW { w: self }
            }
            #[doc = "Bits 8:10 - Transfer OK Interrupt Node Pointer"]
            #[inline]
            pub fn trinp(&mut self) -> _TRINPW {
                _TRINPW { w: self }
            }
            #[doc = "Bits 12:14 - Frame Counter Interrupt Node Pointer"]
            #[inline]
            pub fn cfcinp(&mut self) -> _CFCINPW {
                _CFCINPW { w: self }
            }
        }
    }
    #[doc = "Node Port Control Register"]
    pub struct NPCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Port Control Register"]
    pub mod npcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NPCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RXSELR {
            bits: u8,
        }
        impl RXSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `LBM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LBMR {
            #[doc = "Loop-Back Mode is disabled."]
            VALUE1,
            #[doc = "Loop-Back Mode is enabled. This node is connected to an internal (virtual) loop-back CAN bus. All CAN nodes which are in Loop-Back Mode are connected to this virtual CAN bus so that they can communicate with each other internally. The external transmit line is forced recessive in Loop-Back Mode."]
            VALUE2,
        }
        impl LBMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LBMR::VALUE1 => false,
                    LBMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LBMR {
                match value {
                    false => LBMR::VALUE1,
                    true => LBMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LBMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LBMR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LBM`"]
        pub enum LBMW {
            #[doc = "Loop-Back Mode is disabled."]
            VALUE1,
            #[doc = "Loop-Back Mode is enabled. This node is connected to an internal (virtual) loop-back CAN bus. All CAN nodes which are in Loop-Back Mode are connected to this virtual CAN bus so that they can communicate with each other internally. The external transmit line is forced recessive in Loop-Back Mode."]
            VALUE2,
        }
        impl LBMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LBMW::VALUE1 => false,
                    LBMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LBMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LBMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LBMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Loop-Back Mode is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LBMW::VALUE1)
            }
            #[doc = "Loop-Back Mode is enabled. This node is connected to an internal (virtual) loop-back CAN bus. All CAN nodes which are in Loop-Back Mode are connected to this virtual CAN bus so that they can communicate with each other internally. The external transmit line is forced recessive in Loop-Back Mode."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LBMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Receive Select"]
            #[inline]
            pub fn rxsel(&self) -> RXSELR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RXSELR { bits }
            }
            #[doc = "Bit 8 - Loop-Back Mode"]
            #[inline]
            pub fn lbm(&self) -> LBMR {
                LBMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Receive Select"]
            #[inline]
            pub fn rxsel(&mut self) -> _RXSELW {
                _RXSELW { w: self }
            }
            #[doc = "Bit 8 - Loop-Back Mode"]
            #[inline]
            pub fn lbm(&mut self) -> _LBMW {
                _LBMW { w: self }
            }
        }
    }
    #[doc = "Node Bit Timing Register"]
    pub struct NBTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Bit Timing Register"]
    pub mod nbtr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NBTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BRPR {
            bits: u8,
        }
        impl BRPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SJWR {
            bits: u8,
        }
        impl SJWR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TSEG1R {
            bits: u8,
        }
        impl TSEG1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TSEG2R {
            bits: u8,
        }
        impl TSEG2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DIV8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIV8R {
            #[doc = "A time quantum lasts (BRP+1) clock cycles."]
            VALUE1,
            #[doc = "A time quantum lasts 8 (BRP+1) clock cycles."]
            VALUE2,
        }
        impl DIV8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIV8R::VALUE1 => false,
                    DIV8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIV8R {
                match value {
                    false => DIV8R::VALUE1,
                    true => DIV8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIV8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIV8R::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _BRPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BRPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SJWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SJWW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSEG1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSEG1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSEG2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSEG2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIV8`"]
        pub enum DIV8W {
            #[doc = "A time quantum lasts (BRP+1) clock cycles."]
            VALUE1,
            #[doc = "A time quantum lasts 8 (BRP+1) clock cycles."]
            VALUE2,
        }
        impl DIV8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIV8W::VALUE1 => false,
                    DIV8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIV8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIV8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIV8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A time quantum lasts (BRP+1) clock cycles."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIV8W::VALUE1)
            }
            #[doc = "A time quantum lasts 8 (BRP+1) clock cycles."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIV8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Baud Rate Prescaler"]
            #[inline]
            pub fn brp(&self) -> BRPR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BRPR { bits }
            }
            #[doc = "Bits 6:7 - (Re) Synchronization Jump Width"]
            #[inline]
            pub fn sjw(&self) -> SJWR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SJWR { bits }
            }
            #[doc = "Bits 8:11 - Time Segment Before Sample Point"]
            #[inline]
            pub fn tseg1(&self) -> TSEG1R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TSEG1R { bits }
            }
            #[doc = "Bits 12:14 - Time Segment After Sample Point"]
            #[inline]
            pub fn tseg2(&self) -> TSEG2R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TSEG2R { bits }
            }
            #[doc = "Bit 15 - Divide Prescaler Clock by 8"]
            #[inline]
            pub fn div8(&self) -> DIV8R {
                DIV8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Baud Rate Prescaler"]
            #[inline]
            pub fn brp(&mut self) -> _BRPW {
                _BRPW { w: self }
            }
            #[doc = "Bits 6:7 - (Re) Synchronization Jump Width"]
            #[inline]
            pub fn sjw(&mut self) -> _SJWW {
                _SJWW { w: self }
            }
            #[doc = "Bits 8:11 - Time Segment Before Sample Point"]
            #[inline]
            pub fn tseg1(&mut self) -> _TSEG1W {
                _TSEG1W { w: self }
            }
            #[doc = "Bits 12:14 - Time Segment After Sample Point"]
            #[inline]
            pub fn tseg2(&mut self) -> _TSEG2W {
                _TSEG2W { w: self }
            }
            #[doc = "Bit 15 - Divide Prescaler Clock by 8"]
            #[inline]
            pub fn div8(&mut self) -> _DIV8W {
                _DIV8W { w: self }
            }
        }
    }
    #[doc = "Node Error Counter Register"]
    pub struct NECNT {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Error Counter Register"]
    pub mod necnt {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NECNT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RECR {
            bits: u8,
        }
        impl RECR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TECR {
            bits: u8,
        }
        impl TECR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EWRNLVLR {
            bits: u8,
        }
        impl EWRNLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `LETD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LETDR {
            #[doc = "The last error occurred while the CAN node x was receiver (REC has been incremented)."]
            VALUE1,
            #[doc = "The last error occurred while the CAN node x was transmitter (TEC has been incremented)."]
            VALUE2,
        }
        impl LETDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LETDR::VALUE1 => false,
                    LETDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LETDR {
                match value {
                    false => LETDR::VALUE1,
                    true => LETDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LETDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LETDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LEINC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LEINCR {
            #[doc = "The last error led to an error counter increment of 1."]
            VALUE1,
            #[doc = "The last error led to an error counter increment of 8."]
            VALUE2,
        }
        impl LEINCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LEINCR::VALUE1 => false,
                    LEINCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LEINCR {
                match value {
                    false => LEINCR::VALUE1,
                    true => LEINCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LEINCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LEINCR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _RECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RECW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TECW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EWRNLVLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EWRNLVLW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Receive Error Counter"]
            #[inline]
            pub fn rec(&self) -> RECR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RECR { bits }
            }
            #[doc = "Bits 8:15 - Transmit Error Counter"]
            #[inline]
            pub fn tec(&self) -> TECR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TECR { bits }
            }
            #[doc = "Bits 16:23 - Error Warning Level"]
            #[inline]
            pub fn ewrnlvl(&self) -> EWRNLVLR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EWRNLVLR { bits }
            }
            #[doc = "Bit 24 - Last Error Transfer Direction"]
            #[inline]
            pub fn letd(&self) -> LETDR {
                LETDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Last Error Increment"]
            #[inline]
            pub fn leinc(&self) -> LEINCR {
                LEINCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0060_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Receive Error Counter"]
            #[inline]
            pub fn rec(&mut self) -> _RECW {
                _RECW { w: self }
            }
            #[doc = "Bits 8:15 - Transmit Error Counter"]
            #[inline]
            pub fn tec(&mut self) -> _TECW {
                _TECW { w: self }
            }
            #[doc = "Bits 16:23 - Error Warning Level"]
            #[inline]
            pub fn ewrnlvl(&mut self) -> _EWRNLVLW {
                _EWRNLVLW { w: self }
            }
        }
    }
    #[doc = "Node Frame Counter Register"]
    pub struct NFCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Node Frame Counter Register"]
    pub mod nfcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::NFCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CFCR {
            bits: u16,
        }
        impl CFCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CFSELR {
            #[doc = "The frame counter is incremented (internally) at the beginning of a new bit time. The value is sampled during the SOF bit of a new frame. The sampled value is visible in the CFC field."]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CFSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CFSELR::VALUE1 => 0,
                    CFSELR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CFSELR {
                match value {
                    0 => CFSELR::VALUE1,
                    i => CFSELR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CFSELR::VALUE1
            }
        }
        #[doc = "Possible values of the field `CFMOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CFMODR {
            #[doc = "Frame Count Mode: The frame counter is incremented upon the reception and transmission of frames."]
            VALUE1,
            #[doc = "Time Stamp Mode: The frame counter is used to count bit times."]
            VALUE2,
            #[doc = "Bit Timing Mode: The frame counter is used for analysis of the bit timing."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CFMODR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CFMODR::VALUE1 => 0,
                    CFMODR::VALUE2 => 0x01,
                    CFMODR::VALUE3 => 0x02,
                    CFMODR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CFMODR {
                match value {
                    0 => CFMODR::VALUE1,
                    1 => CFMODR::VALUE2,
                    2 => CFMODR::VALUE3,
                    i => CFMODR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CFMODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CFMODR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CFMODR::VALUE3
            }
        }
        #[doc = "Possible values of the field `CFCIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CFCIER {
            #[doc = "CAN frame counter overflow interrupt is disabled."]
            VALUE1,
            #[doc = "CAN frame counter overflow interrupt is enabled."]
            VALUE2,
        }
        impl CFCIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CFCIER::VALUE1 => false,
                    CFCIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CFCIER {
                match value {
                    false => CFCIER::VALUE1,
                    true => CFCIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CFCIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CFCIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CFCOV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CFCOVR {
            #[doc = "No overflow has occurred since last flag reset."]
            VALUE1,
            #[doc = "An overflow has occurred since last flag reset."]
            VALUE2,
        }
        impl CFCOVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CFCOVR::VALUE1 => false,
                    CFCOVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CFCOVR {
                match value {
                    false => CFCOVR::VALUE1,
                    true => CFCOVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CFCOVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CFCOVR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CFSEL`"]
        pub enum CFSELW {
            #[doc = "The frame counter is incremented (internally) at the beginning of a new bit time. The value is sampled during the SOF bit of a new frame. The sampled value is visible in the CFC field."]
            VALUE1,
        }
        impl CFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CFSELW::VALUE1 => 0,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CFSELW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "The frame counter is incremented (internally) at the beginning of a new bit time. The value is sampled during the SOF bit of a new frame. The sampled value is visible in the CFC field."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CFSELW::VALUE1)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CFMOD`"]
        pub enum CFMODW {
            #[doc = "Frame Count Mode: The frame counter is incremented upon the reception and transmission of frames."]
            VALUE1,
            #[doc = "Time Stamp Mode: The frame counter is used to count bit times."]
            VALUE2,
            #[doc = "Bit Timing Mode: The frame counter is used for analysis of the bit timing."]
            VALUE3,
        }
        impl CFMODW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CFMODW::VALUE1 => 0,
                    CFMODW::VALUE2 => 1,
                    CFMODW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFMODW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFMODW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CFMODW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Frame Count Mode: The frame counter is incremented upon the reception and transmission of frames."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CFMODW::VALUE1)
            }
            #[doc = "Time Stamp Mode: The frame counter is used to count bit times."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CFMODW::VALUE2)
            }
            #[doc = "Bit Timing Mode: The frame counter is used for analysis of the bit timing."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CFMODW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CFCIE`"]
        pub enum CFCIEW {
            #[doc = "CAN frame counter overflow interrupt is disabled."]
            VALUE1,
            #[doc = "CAN frame counter overflow interrupt is enabled."]
            VALUE2,
        }
        impl CFCIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CFCIEW::VALUE1 => false,
                    CFCIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFCIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFCIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CFCIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "CAN frame counter overflow interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CFCIEW::VALUE1)
            }
            #[doc = "CAN frame counter overflow interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CFCIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CFCOV`"]
        pub enum CFCOVW {
            #[doc = "No overflow has occurred since last flag reset."]
            VALUE1,
            #[doc = "An overflow has occurred since last flag reset."]
            VALUE2,
        }
        impl CFCOVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CFCOVW::VALUE1 => false,
                    CFCOVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFCOVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFCOVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CFCOVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No overflow has occurred since last flag reset."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CFCOVW::VALUE1)
            }
            #[doc = "An overflow has occurred since last flag reset."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CFCOVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - CAN Frame Counter"]
            #[inline]
            pub fn cfc(&self) -> CFCR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CFCR { bits }
            }
            #[doc = "Bits 16:18 - CAN Frame Count Selection"]
            #[inline]
            pub fn cfsel(&self) -> CFSELR {
                CFSELR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:20 - CAN Frame Counter Mode"]
            #[inline]
            pub fn cfmod(&self) -> CFMODR {
                CFMODR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 22 - CAN Frame Count Interrupt Enable"]
            #[inline]
            pub fn cfcie(&self) -> CFCIER {
                CFCIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - CAN Frame Counter Overflow Flag"]
            #[inline]
            pub fn cfcov(&self) -> CFCOVR {
                CFCOVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - CAN Frame Counter"]
            #[inline]
            pub fn cfc(&mut self) -> _CFCW {
                _CFCW { w: self }
            }
            #[doc = "Bits 16:18 - CAN Frame Count Selection"]
            #[inline]
            pub fn cfsel(&mut self) -> _CFSELW {
                _CFSELW { w: self }
            }
            #[doc = "Bits 19:20 - CAN Frame Counter Mode"]
            #[inline]
            pub fn cfmod(&mut self) -> _CFMODW {
                _CFMODW { w: self }
            }
            #[doc = "Bit 22 - CAN Frame Count Interrupt Enable"]
            #[inline]
            pub fn cfcie(&mut self) -> _CFCIEW {
                _CFCIEW { w: self }
            }
            #[doc = "Bit 23 - CAN Frame Counter Overflow Flag"]
            #[inline]
            pub fn cfcov(&mut self) -> _CFCOVW {
                _CFCOVW { w: self }
            }
        }
    }
}
#[doc = "Controller Area Networks"]
pub struct CAN_NODE0 {
    register_block: can_node0::RegisterBlock,
}
impl Deref for CAN_NODE0 {
    type Target = can_node0::RegisterBlock;
    fn deref(&self) -> &can_node0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_NODE1: Peripheral<CAN_NODE1> = unsafe { Peripheral::new(0x4801_4300) };
#[doc = r" Register block"]
pub struct CAN_NODE1 {
    register_block: can_node0::RegisterBlock,
}
impl Deref for CAN_NODE1 {
    type Target = can_node0::RegisterBlock;
    fn deref(&self) -> &can_node0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO0: Peripheral<CAN_MO0> = unsafe { Peripheral::new(0x4801_5000) };
#[doc = "Controller Area Networks"]
pub mod can_mo0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Message Object Function Control Register"]
        pub mofcr: MOFCR,
        #[doc = "0x04 - Message Object FIFO/Gateway Pointer Register"]
        pub mofgpr: MOFGPR,
        #[doc = "0x08 - Message Object Interrupt Pointer Register"]
        pub moipr: MOIPR,
        #[doc = "0x0c - Message Object Acceptance Mask Register"]
        pub moamr: MOAMR,
        #[doc = "0x10 - Message Object Data Register Low"]
        pub modatal: MODATAL,
        #[doc = "0x14 - Message Object Data Register High"]
        pub modatah: MODATAH,
        #[doc = "0x18 - Message Object Arbitration Register"]
        pub moar: MOAR,
        #[doc = "0x1c - Message Object Control Register"]
        pub moctr: MOCTR,
    }
    #[doc = "Message Object Function Control Register"]
    pub struct MOFCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Function Control Register"]
    pub mod mofcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MOFCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `MMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MMCR {
            #[doc = "Standard Message Object"]
            VALUE1,
            #[doc = "Receive FIFO Base Object"]
            VALUE2,
            #[doc = "Transmit FIFO Base Object"]
            VALUE3,
            #[doc = "Transmit FIFO Slave Object"]
            VALUE4,
            #[doc = "Gateway Source Object"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MMCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MMCR::VALUE1 => 0,
                    MMCR::VALUE2 => 0x01,
                    MMCR::VALUE3 => 0x02,
                    MMCR::VALUE4 => 0x03,
                    MMCR::VALUE5 => 0x04,
                    MMCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MMCR {
                match value {
                    0 => MMCR::VALUE1,
                    1 => MMCR::VALUE2,
                    2 => MMCR::VALUE3,
                    3 => MMCR::VALUE4,
                    4 => MMCR::VALUE5,
                    i => MMCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MMCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MMCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MMCR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == MMCR::VALUE5
            }
        }
        #[doc = "Possible values of the field `GDFS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GDFSR {
            #[doc = "TXRQ is unchanged in the destination object."]
            VALUE1,
            #[doc = "TXRQ is set in the gateway destination object after the internal transfer from the gateway source to the gateway destination object."]
            VALUE2,
        }
        impl GDFSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GDFSR::VALUE1 => false,
                    GDFSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GDFSR {
                match value {
                    false => GDFSR::VALUE1,
                    true => GDFSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GDFSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GDFSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IDC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IDCR {
            #[doc = "The identifier of the gateway source object is not copied."]
            VALUE1,
            #[doc = "The identifier of the gateway source object (after storing the received frame in the source) is copied to the gateway destination object."]
            VALUE2,
        }
        impl IDCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IDCR::VALUE1 => false,
                    IDCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IDCR {
                match value {
                    false => IDCR::VALUE1,
                    true => IDCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IDCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IDCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DLCC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DLCCR {
            #[doc = "Data length code is not copied."]
            VALUE1,
            #[doc = "Data length code of the gateway source object (after storing the received frame in the source) is copied to the gateway destination object."]
            VALUE2,
        }
        impl DLCCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DLCCR::VALUE1 => false,
                    DLCCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DLCCR {
                match value {
                    false => DLCCR::VALUE1,
                    true => DLCCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DLCCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DLCCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DATC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DATCR {
            #[doc = "Data fields are not copied."]
            VALUE1,
            #[doc = "Data fields in registers MODATALn and MODATAHn of the gateway source object (after storing the received frame in the source) are copied to the gateway destination."]
            VALUE2,
        }
        impl DATCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DATCR::VALUE1 => false,
                    DATCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DATCR {
                match value {
                    false => DATCR::VALUE1,
                    true => DATCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DATCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DATCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RXIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXIER {
            #[doc = "Message receive interrupt is disabled."]
            VALUE1,
            #[doc = "Message receive interrupt is enabled."]
            VALUE2,
        }
        impl RXIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RXIER::VALUE1 => false,
                    RXIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RXIER {
                match value {
                    false => RXIER::VALUE1,
                    true => RXIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TXIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXIER {
            #[doc = "Message transmit interrupt is disabled."]
            VALUE1,
            #[doc = "Message transmit interrupt is enabled."]
            VALUE2,
        }
        impl TXIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXIER::VALUE1 => false,
                    TXIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXIER {
                match value {
                    false => TXIER::VALUE1,
                    true => TXIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `OVIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OVIER {
            #[doc = "FIFO full interrupt is disabled."]
            VALUE1,
            #[doc = "FIFO full interrupt is enabled."]
            VALUE2,
        }
        impl OVIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OVIER::VALUE1 => false,
                    OVIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OVIER {
                match value {
                    false => OVIER::VALUE1,
                    true => OVIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OVIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OVIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `FRREN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FRRENR {
            #[doc = "TXRQ of message object n is set on reception of a matching Remote Frame."]
            VALUE1,
            #[doc = "TXRQ of the message object referenced by the pointer CUR is set on reception of a matching Remote Frame."]
            VALUE2,
        }
        impl FRRENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FRRENR::VALUE1 => false,
                    FRRENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FRRENR {
                match value {
                    false => FRRENR::VALUE1,
                    true => FRRENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FRRENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FRRENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RMM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RMMR {
            #[doc = "Remote monitoring is disabled: Identifier, IDE bit, and DLC of message object n remain unchanged upon the reception of a matching Remote Frame."]
            VALUE1,
            #[doc = "Remote monitoring is enabled: Identifier, IDE bit, and DLC of a matching Remote Frame are copied to transmit object n in order to monitor incoming Remote Frames."]
            VALUE2,
        }
        impl RMMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RMMR::VALUE1 => false,
                    RMMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RMMR {
                match value {
                    false => RMMR::VALUE1,
                    true => RMMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RMMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RMMR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct SDTR {
            bits: bool,
        }
        impl SDTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STTR {
            bits: bool,
        }
        impl STTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct DLCR {
            bits: u8,
        }
        impl DLCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `MMC`"]
        pub enum MMCW {
            #[doc = "Standard Message Object"]
            VALUE1,
            #[doc = "Receive FIFO Base Object"]
            VALUE2,
            #[doc = "Transmit FIFO Base Object"]
            VALUE3,
            #[doc = "Transmit FIFO Slave Object"]
            VALUE4,
            #[doc = "Gateway Source Object"]
            VALUE5,
        }
        impl MMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MMCW::VALUE1 => 0,
                    MMCW::VALUE2 => 1,
                    MMCW::VALUE3 => 2,
                    MMCW::VALUE4 => 3,
                    MMCW::VALUE5 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MMCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Standard Message Object"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MMCW::VALUE1)
            }
            #[doc = "Receive FIFO Base Object"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MMCW::VALUE2)
            }
            #[doc = "Transmit FIFO Base Object"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MMCW::VALUE3)
            }
            #[doc = "Transmit FIFO Slave Object"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MMCW::VALUE4)
            }
            #[doc = "Gateway Source Object"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(MMCW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GDFS`"]
        pub enum GDFSW {
            #[doc = "TXRQ is unchanged in the destination object."]
            VALUE1,
            #[doc = "TXRQ is set in the gateway destination object after the internal transfer from the gateway source to the gateway destination object."]
            VALUE2,
        }
        impl GDFSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GDFSW::VALUE1 => false,
                    GDFSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GDFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GDFSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GDFSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TXRQ is unchanged in the destination object."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GDFSW::VALUE1)
            }
            #[doc = "TXRQ is set in the gateway destination object after the internal transfer from the gateway source to the gateway destination object."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GDFSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IDC`"]
        pub enum IDCW {
            #[doc = "The identifier of the gateway source object is not copied."]
            VALUE1,
            #[doc = "The identifier of the gateway source object (after storing the received frame in the source) is copied to the gateway destination object."]
            VALUE2,
        }
        impl IDCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IDCW::VALUE1 => false,
                    IDCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IDCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IDCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IDCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The identifier of the gateway source object is not copied."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IDCW::VALUE1)
            }
            #[doc = "The identifier of the gateway source object (after storing the received frame in the source) is copied to the gateway destination object."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IDCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DLCC`"]
        pub enum DLCCW {
            #[doc = "Data length code is not copied."]
            VALUE1,
            #[doc = "Data length code of the gateway source object (after storing the received frame in the source) is copied to the gateway destination object."]
            VALUE2,
        }
        impl DLCCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DLCCW::VALUE1 => false,
                    DLCCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLCCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLCCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DLCCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Data length code is not copied."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DLCCW::VALUE1)
            }
            #[doc = "Data length code of the gateway source object (after storing the received frame in the source) is copied to the gateway destination object."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DLCCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DATC`"]
        pub enum DATCW {
            #[doc = "Data fields are not copied."]
            VALUE1,
            #[doc = "Data fields in registers MODATALn and MODATAHn of the gateway source object (after storing the received frame in the source) are copied to the gateway destination."]
            VALUE2,
        }
        impl DATCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DATCW::VALUE1 => false,
                    DATCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DATCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Data fields are not copied."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DATCW::VALUE1)
            }
            #[doc = "Data fields in registers MODATALn and MODATAHn of the gateway source object (after storing the received frame in the source) are copied to the gateway destination."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DATCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RXIE`"]
        pub enum RXIEW {
            #[doc = "Message receive interrupt is disabled."]
            VALUE1,
            #[doc = "Message receive interrupt is enabled."]
            VALUE2,
        }
        impl RXIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RXIEW::VALUE1 => false,
                    RXIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RXIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Message receive interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RXIEW::VALUE1)
            }
            #[doc = "Message receive interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RXIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TXIE`"]
        pub enum TXIEW {
            #[doc = "Message transmit interrupt is disabled."]
            VALUE1,
            #[doc = "Message transmit interrupt is enabled."]
            VALUE2,
        }
        impl TXIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TXIEW::VALUE1 => false,
                    TXIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TXIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Message transmit interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TXIEW::VALUE1)
            }
            #[doc = "Message transmit interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TXIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OVIE`"]
        pub enum OVIEW {
            #[doc = "FIFO full interrupt is disabled."]
            VALUE1,
            #[doc = "FIFO full interrupt is enabled."]
            VALUE2,
        }
        impl OVIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OVIEW::VALUE1 => false,
                    OVIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OVIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OVIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OVIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "FIFO full interrupt is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OVIEW::VALUE1)
            }
            #[doc = "FIFO full interrupt is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OVIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FRREN`"]
        pub enum FRRENW {
            #[doc = "TXRQ of message object n is set on reception of a matching Remote Frame."]
            VALUE1,
            #[doc = "TXRQ of the message object referenced by the pointer CUR is set on reception of a matching Remote Frame."]
            VALUE2,
        }
        impl FRRENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FRRENW::VALUE1 => false,
                    FRRENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FRRENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FRRENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FRRENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TXRQ of message object n is set on reception of a matching Remote Frame."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FRRENW::VALUE1)
            }
            #[doc = "TXRQ of the message object referenced by the pointer CUR is set on reception of a matching Remote Frame."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FRRENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RMM`"]
        pub enum RMMW {
            #[doc = "Remote monitoring is disabled: Identifier, IDE bit, and DLC of message object n remain unchanged upon the reception of a matching Remote Frame."]
            VALUE1,
            #[doc = "Remote monitoring is enabled: Identifier, IDE bit, and DLC of a matching Remote Frame are copied to transmit object n in order to monitor incoming Remote Frames."]
            VALUE2,
        }
        impl RMMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RMMW::VALUE1 => false,
                    RMMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RMMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Remote monitoring is disabled: Identifier, IDE bit, and DLC of message object n remain unchanged upon the reception of a matching Remote Frame."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RMMW::VALUE1)
            }
            #[doc = "Remote monitoring is enabled: Identifier, IDE bit, and DLC of a matching Remote Frame are copied to transmit object n in order to monitor incoming Remote Frames."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RMMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SDTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SDTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DLCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DLCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Message Mode Control"]
            #[inline]
            pub fn mmc(&self) -> MMCR {
                MMCR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 8 - Gateway Data Frame Send"]
            #[inline]
            pub fn gdfs(&self) -> GDFSR {
                GDFSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Identifier Copy"]
            #[inline]
            pub fn idc(&self) -> IDCR {
                IDCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Data Length Code Copy"]
            #[inline]
            pub fn dlcc(&self) -> DLCCR {
                DLCCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Data Copy"]
            #[inline]
            pub fn datc(&self) -> DATCR {
                DATCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Receive Interrupt Enable"]
            #[inline]
            pub fn rxie(&self) -> RXIER {
                RXIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Transmit Interrupt Enable"]
            #[inline]
            pub fn txie(&self) -> TXIER {
                TXIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Overflow Interrupt Enable"]
            #[inline]
            pub fn ovie(&self) -> OVIER {
                OVIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - Foreign Remote Request Enable"]
            #[inline]
            pub fn frren(&self) -> FRRENR {
                FRRENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - Transmit Object Remote Monitoring"]
            #[inline]
            pub fn rmm(&self) -> RMMR {
                RMMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 22 - Single Data Transfer"]
            #[inline]
            pub fn sdt(&self) -> SDTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SDTR { bits }
            }
            #[doc = "Bit 23 - Single Transmit Trial"]
            #[inline]
            pub fn stt(&self) -> STTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STTR { bits }
            }
            #[doc = "Bits 24:27 - Data Length Code"]
            #[inline]
            pub fn dlc(&self) -> DLCR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DLCR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Message Mode Control"]
            #[inline]
            pub fn mmc(&mut self) -> _MMCW {
                _MMCW { w: self }
            }
            #[doc = "Bit 8 - Gateway Data Frame Send"]
            #[inline]
            pub fn gdfs(&mut self) -> _GDFSW {
                _GDFSW { w: self }
            }
            #[doc = "Bit 9 - Identifier Copy"]
            #[inline]
            pub fn idc(&mut self) -> _IDCW {
                _IDCW { w: self }
            }
            #[doc = "Bit 10 - Data Length Code Copy"]
            #[inline]
            pub fn dlcc(&mut self) -> _DLCCW {
                _DLCCW { w: self }
            }
            #[doc = "Bit 11 - Data Copy"]
            #[inline]
            pub fn datc(&mut self) -> _DATCW {
                _DATCW { w: self }
            }
            #[doc = "Bit 16 - Receive Interrupt Enable"]
            #[inline]
            pub fn rxie(&mut self) -> _RXIEW {
                _RXIEW { w: self }
            }
            #[doc = "Bit 17 - Transmit Interrupt Enable"]
            #[inline]
            pub fn txie(&mut self) -> _TXIEW {
                _TXIEW { w: self }
            }
            #[doc = "Bit 18 - Overflow Interrupt Enable"]
            #[inline]
            pub fn ovie(&mut self) -> _OVIEW {
                _OVIEW { w: self }
            }
            #[doc = "Bit 20 - Foreign Remote Request Enable"]
            #[inline]
            pub fn frren(&mut self) -> _FRRENW {
                _FRRENW { w: self }
            }
            #[doc = "Bit 21 - Transmit Object Remote Monitoring"]
            #[inline]
            pub fn rmm(&mut self) -> _RMMW {
                _RMMW { w: self }
            }
            #[doc = "Bit 22 - Single Data Transfer"]
            #[inline]
            pub fn sdt(&mut self) -> _SDTW {
                _SDTW { w: self }
            }
            #[doc = "Bit 23 - Single Transmit Trial"]
            #[inline]
            pub fn stt(&mut self) -> _STTW {
                _STTW { w: self }
            }
            #[doc = "Bits 24:27 - Data Length Code"]
            #[inline]
            pub fn dlc(&mut self) -> _DLCW {
                _DLCW { w: self }
            }
        }
    }
    #[doc = "Message Object FIFO/Gateway Pointer Register"]
    pub struct MOFGPR {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object FIFO/Gateway Pointer Register"]
    pub mod mofgpr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MOFGPR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BOTR {
            bits: u8,
        }
        impl BOTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TOPR {
            bits: u8,
        }
        impl TOPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CURR {
            bits: u8,
        }
        impl CURR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SELR {
            bits: u8,
        }
        impl SELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _BOTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BOTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TOPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TOPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CURW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CURW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Bottom Pointer"]
            #[inline]
            pub fn bot(&self) -> BOTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BOTR { bits }
            }
            #[doc = "Bits 8:15 - Top Pointer"]
            #[inline]
            pub fn top(&self) -> TOPR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TOPR { bits }
            }
            #[doc = "Bits 16:23 - Current Object Pointer"]
            #[inline]
            pub fn cur(&self) -> CURR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CURR { bits }
            }
            #[doc = "Bits 24:31 - Object Select Pointer"]
            #[inline]
            pub fn sel(&self) -> SELR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SELR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Bottom Pointer"]
            #[inline]
            pub fn bot(&mut self) -> _BOTW {
                _BOTW { w: self }
            }
            #[doc = "Bits 8:15 - Top Pointer"]
            #[inline]
            pub fn top(&mut self) -> _TOPW {
                _TOPW { w: self }
            }
            #[doc = "Bits 16:23 - Current Object Pointer"]
            #[inline]
            pub fn cur(&mut self) -> _CURW {
                _CURW { w: self }
            }
            #[doc = "Bits 24:31 - Object Select Pointer"]
            #[inline]
            pub fn sel(&mut self) -> _SELW {
                _SELW { w: self }
            }
        }
    }
    #[doc = "Message Object Interrupt Pointer Register"]
    pub struct MOIPR {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Interrupt Pointer Register"]
    pub mod moipr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MOIPR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `RXINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXINPR {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl RXINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    RXINPR::VALUE1 => 0,
                    RXINPR::VALUE2 => 0x01,
                    RXINPR::VALUE3 => 0x07,
                    RXINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> RXINPR {
                match value {
                    0 => RXINPR::VALUE1,
                    1 => RXINPR::VALUE2,
                    7 => RXINPR::VALUE3,
                    i => RXINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == RXINPR::VALUE3
            }
        }
        #[doc = "Possible values of the field `TXINP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXINPR {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TXINPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TXINPR::VALUE1 => 0,
                    TXINPR::VALUE2 => 0x01,
                    TXINPR::VALUE3 => 0x07,
                    TXINPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TXINPR {
                match value {
                    0 => TXINPR::VALUE1,
                    1 => TXINPR::VALUE2,
                    7 => TXINPR::VALUE3,
                    i => TXINPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXINPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXINPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TXINPR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct MPNR {
            bits: u8,
        }
        impl MPNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CFCVALR {
            bits: u16,
        }
        impl CFCVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `RXINP`"]
        pub enum RXINPW {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
        }
        impl RXINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RXINPW::VALUE1 => 0,
                    RXINPW::VALUE2 => 1,
                    RXINPW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RXINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RXINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RXINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Interrupt output line INT_O0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RXINPW::VALUE1)
            }
            #[doc = "Interrupt output line INT_O1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RXINPW::VALUE2)
            }
            #[doc = "Interrupt output line INT_O7 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(RXINPW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TXINP`"]
        pub enum TXINPW {
            #[doc = "Interrupt output line INT_O0 is selected."]
            VALUE1,
            #[doc = "Interrupt output line INT_O1 is selected."]
            VALUE2,
            #[doc = "Interrupt output line INT_O7 is selected."]
            VALUE3,
        }
        impl TXINPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TXINPW::VALUE1 => 0,
                    TXINPW::VALUE2 => 1,
                    TXINPW::VALUE3 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TXINPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TXINPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TXINPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Interrupt output line INT_O0 is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TXINPW::VALUE1)
            }
            #[doc = "Interrupt output line INT_O1 is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TXINPW::VALUE2)
            }
            #[doc = "Interrupt output line INT_O7 is selected."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TXINPW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPNW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFCVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFCVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Receive Interrupt Node Pointer"]
            #[inline]
            pub fn rxinp(&self) -> RXINPR {
                RXINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:6 - Transmit Interrupt Node Pointer"]
            #[inline]
            pub fn txinp(&self) -> TXINPR {
                TXINPR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:15 - Message Pending Number"]
            #[inline]
            pub fn mpn(&self) -> MPNR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MPNR { bits }
            }
            #[doc = "Bits 16:31 - CAN Frame Counter Value"]
            #[inline]
            pub fn cfcval(&self) -> CFCVALR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CFCVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Receive Interrupt Node Pointer"]
            #[inline]
            pub fn rxinp(&mut self) -> _RXINPW {
                _RXINPW { w: self }
            }
            #[doc = "Bits 4:6 - Transmit Interrupt Node Pointer"]
            #[inline]
            pub fn txinp(&mut self) -> _TXINPW {
                _TXINPW { w: self }
            }
            #[doc = "Bits 8:15 - Message Pending Number"]
            #[inline]
            pub fn mpn(&mut self) -> _MPNW {
                _MPNW { w: self }
            }
            #[doc = "Bits 16:31 - CAN Frame Counter Value"]
            #[inline]
            pub fn cfcval(&mut self) -> _CFCVALW {
                _CFCVALW { w: self }
            }
        }
    }
    #[doc = "Message Object Acceptance Mask Register"]
    pub struct MOAMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Acceptance Mask Register"]
    pub mod moamr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MOAMR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct AMR {
            bits: u32,
        }
        impl AMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `MIDE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MIDER {
            #[doc = "Message object n accepts the reception of both, standard and extended frames."]
            VALUE1,
            #[doc = "Message object n receives frames only with matching IDE bit."]
            VALUE2,
        }
        impl MIDER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MIDER::VALUE1 => false,
                    MIDER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MIDER {
                match value {
                    false => MIDER::VALUE1,
                    true => MIDER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MIDER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MIDER::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _AMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AMW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x1fff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MIDE`"]
        pub enum MIDEW {
            #[doc = "Message object n accepts the reception of both, standard and extended frames."]
            VALUE1,
            #[doc = "Message object n receives frames only with matching IDE bit."]
            VALUE2,
        }
        impl MIDEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MIDEW::VALUE1 => false,
                    MIDEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MIDEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MIDEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MIDEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Message object n accepts the reception of both, standard and extended frames."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MIDEW::VALUE1)
            }
            #[doc = "Message object n receives frames only with matching IDE bit."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MIDEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:28 - Acceptance Mask for Message Identifier"]
            #[inline]
            pub fn am(&self) -> AMR {
                let bits = {
                    const MASK: u32 = 0x1fff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                AMR { bits }
            }
            #[doc = "Bit 29 - Acceptance Mask Bit for Message IDE Bit"]
            #[inline]
            pub fn mide(&self) -> MIDER {
                MIDER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x3fff_ffff }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:28 - Acceptance Mask for Message Identifier"]
            #[inline]
            pub fn am(&mut self) -> _AMW {
                _AMW { w: self }
            }
            #[doc = "Bit 29 - Acceptance Mask Bit for Message IDE Bit"]
            #[inline]
            pub fn mide(&mut self) -> _MIDEW {
                _MIDEW { w: self }
            }
        }
    }
    #[doc = "Message Object Data Register Low"]
    pub struct MODATAL {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Data Register Low"]
    pub mod modatal {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MODATAL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB0R {
            bits: u8,
        }
        impl DB0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB1R {
            bits: u8,
        }
        impl DB1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB2R {
            bits: u8,
        }
        impl DB2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB3R {
            bits: u8,
        }
        impl DB3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Data Byte 0 of Message Object n"]
            #[inline]
            pub fn db0(&self) -> DB0R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB0R { bits }
            }
            #[doc = "Bits 8:15 - Data Byte 1 of Message Object n"]
            #[inline]
            pub fn db1(&self) -> DB1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB1R { bits }
            }
            #[doc = "Bits 16:23 - Data Byte 2 of Message Object n"]
            #[inline]
            pub fn db2(&self) -> DB2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB2R { bits }
            }
            #[doc = "Bits 24:31 - Data Byte 3 of Message Object n"]
            #[inline]
            pub fn db3(&self) -> DB3R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Data Byte 0 of Message Object n"]
            #[inline]
            pub fn db0(&mut self) -> _DB0W {
                _DB0W { w: self }
            }
            #[doc = "Bits 8:15 - Data Byte 1 of Message Object n"]
            #[inline]
            pub fn db1(&mut self) -> _DB1W {
                _DB1W { w: self }
            }
            #[doc = "Bits 16:23 - Data Byte 2 of Message Object n"]
            #[inline]
            pub fn db2(&mut self) -> _DB2W {
                _DB2W { w: self }
            }
            #[doc = "Bits 24:31 - Data Byte 3 of Message Object n"]
            #[inline]
            pub fn db3(&mut self) -> _DB3W {
                _DB3W { w: self }
            }
        }
    }
    #[doc = "Message Object Data Register High"]
    pub struct MODATAH {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Data Register High"]
    pub mod modatah {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MODATAH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB4R {
            bits: u8,
        }
        impl DB4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB5R {
            bits: u8,
        }
        impl DB5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB6R {
            bits: u8,
        }
        impl DB6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DB7R {
            bits: u8,
        }
        impl DB7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DB7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DB7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Data Byte 4 of Message Object n"]
            #[inline]
            pub fn db4(&self) -> DB4R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB4R { bits }
            }
            #[doc = "Bits 8:15 - Data Byte 5 of Message Object n"]
            #[inline]
            pub fn db5(&self) -> DB5R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB5R { bits }
            }
            #[doc = "Bits 16:23 - Data Byte 6 of Message Object n"]
            #[inline]
            pub fn db6(&self) -> DB6R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB6R { bits }
            }
            #[doc = "Bits 24:31 - Data Byte 7 of Message Object n"]
            #[inline]
            pub fn db7(&self) -> DB7R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DB7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Data Byte 4 of Message Object n"]
            #[inline]
            pub fn db4(&mut self) -> _DB4W {
                _DB4W { w: self }
            }
            #[doc = "Bits 8:15 - Data Byte 5 of Message Object n"]
            #[inline]
            pub fn db5(&mut self) -> _DB5W {
                _DB5W { w: self }
            }
            #[doc = "Bits 16:23 - Data Byte 6 of Message Object n"]
            #[inline]
            pub fn db6(&mut self) -> _DB6W {
                _DB6W { w: self }
            }
            #[doc = "Bits 24:31 - Data Byte 7 of Message Object n"]
            #[inline]
            pub fn db7(&mut self) -> _DB7W {
                _DB7W { w: self }
            }
        }
    }
    #[doc = "Message Object Arbitration Register"]
    pub struct MOAR {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Arbitration Register"]
    pub mod moar {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MOAR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct IDR {
            bits: u32,
        }
        impl IDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `IDE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IDER {
            #[doc = "Message object n handles standard frames with 11-bit identifier."]
            VALUE1,
            #[doc = "Message object n handles extended frames with 29-bit identifier."]
            VALUE2,
        }
        impl IDER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IDER::VALUE1 => false,
                    IDER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IDER {
                match value {
                    false => IDER::VALUE1,
                    true => IDER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IDER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IDER::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRIR {
            #[doc = "Applicable only if TTCAN is available."]
            VALUE1,
            #[doc = "Transmit acceptance filtering is based on the list order. This means that message object n is considered for transmission only if there is no other message object with valid transmit request (MSGVAL & TXEN0 & TXEN1 = 1) somewhere before this object in the list."]
            VALUE2,
            #[doc = "Transmit acceptance filtering is based on the CAN identifier. This means, message object n is considered for transmission only if there is no other message object with higher priority identifier + IDE + DIR (with respect to CAN arbitration rules) somewhere in the list (see )."]
            VALUE3,
            #[doc = "Transmit acceptance filtering is based on the list order (as PRI = 01B)."]
            VALUE4,
        }
        impl PRIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PRIR::VALUE1 => 0,
                    PRIR::VALUE2 => 0x01,
                    PRIR::VALUE3 => 0x02,
                    PRIR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PRIR {
                match value {
                    0 => PRIR::VALUE1,
                    1 => PRIR::VALUE2,
                    2 => PRIR::VALUE3,
                    3 => PRIR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRIR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PRIR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PRIR::VALUE4
            }
        }
        #[doc = r" Proxy"]
        pub struct _IDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IDW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x1fff_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IDE`"]
        pub enum IDEW {
            #[doc = "Message object n handles standard frames with 11-bit identifier."]
            VALUE1,
            #[doc = "Message object n handles extended frames with 29-bit identifier."]
            VALUE2,
        }
        impl IDEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IDEW::VALUE1 => false,
                    IDEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IDEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IDEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IDEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Message object n handles standard frames with 11-bit identifier."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IDEW::VALUE1)
            }
            #[doc = "Message object n handles extended frames with 29-bit identifier."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IDEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PRI`"]
        pub enum PRIW {
            #[doc = "Applicable only if TTCAN is available."]
            VALUE1,
            #[doc = "Transmit acceptance filtering is based on the list order. This means that message object n is considered for transmission only if there is no other message object with valid transmit request (MSGVAL & TXEN0 & TXEN1 = 1) somewhere before this object in the list."]
            VALUE2,
            #[doc = "Transmit acceptance filtering is based on the CAN identifier. This means, message object n is considered for transmission only if there is no other message object with higher priority identifier + IDE + DIR (with respect to CAN arbitration rules) somewhere in the list (see )."]
            VALUE3,
            #[doc = "Transmit acceptance filtering is based on the list order (as PRI = 01B)."]
            VALUE4,
        }
        impl PRIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PRIW::VALUE1 => 0,
                    PRIW::VALUE2 => 1,
                    PRIW::VALUE3 => 2,
                    PRIW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRIW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Applicable only if TTCAN is available."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRIW::VALUE1)
            }
            #[doc = "Transmit acceptance filtering is based on the list order. This means that message object n is considered for transmission only if there is no other message object with valid transmit request (MSGVAL & TXEN0 & TXEN1 = 1) somewhere before this object in the list."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRIW::VALUE2)
            }
            #[doc = "Transmit acceptance filtering is based on the CAN identifier. This means, message object n is considered for transmission only if there is no other message object with higher priority identifier + IDE + DIR (with respect to CAN arbitration rules) somewhere in the list (see )."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PRIW::VALUE3)
            }
            #[doc = "Transmit acceptance filtering is based on the list order (as PRI = 01B)."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PRIW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:28 - CAN Identifier of Message Object n"]
            #[inline]
            pub fn id(&self) -> IDR {
                let bits = {
                    const MASK: u32 = 0x1fff_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IDR { bits }
            }
            #[doc = "Bit 29 - Identifier Extension Bit of Message Object n"]
            #[inline]
            pub fn ide(&self) -> IDER {
                IDER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 30:31 - Priority Class"]
            #[inline]
            pub fn pri(&self) -> PRIR {
                PRIR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:28 - CAN Identifier of Message Object n"]
            #[inline]
            pub fn id(&mut self) -> _IDW {
                _IDW { w: self }
            }
            #[doc = "Bit 29 - Identifier Extension Bit of Message Object n"]
            #[inline]
            pub fn ide(&mut self) -> _IDEW {
                _IDEW { w: self }
            }
            #[doc = "Bits 30:31 - Priority Class"]
            #[inline]
            pub fn pri(&mut self) -> _PRIW {
                _PRIW { w: self }
            }
        }
    }
    #[doc = "Message Object Control Register"]
    pub struct MOCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Control Register"]
    pub mod moctr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MOCTR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESRXPNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESRXPNDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETRXPNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETRXPNDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESTXPNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESTXPNDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETTXPNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETTXPNDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESRXUPDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESRXUPDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETRXUPDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETRXUPDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESNEWDATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESNEWDATW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETNEWDATW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETNEWDATW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESMSGLSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESMSGLSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETMSGLSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETMSGLSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESMSGVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESMSGVALW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETMSGVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETMSGVALW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESRTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESRTSELW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETRTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETRTSELW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESRXENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESRXENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETRXENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETRXENW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESTXRQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESTXRQW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETTXRQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETTXRQW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESTXEN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESTXEN0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETTXEN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETTXEN0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESTXEN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESTXEN1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETTXEN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETTXEN1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESDIRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SETDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SETDIRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Reset/Set Receive Pending"]
            #[inline]
            pub fn resrxpnd(&mut self) -> _RESRXPNDW {
                _RESRXPNDW { w: self }
            }
            #[doc = "Bit 16 - Reset/Set Receive Pending"]
            #[inline]
            pub fn setrxpnd(&mut self) -> _SETRXPNDW {
                _SETRXPNDW { w: self }
            }
            #[doc = "Bit 1 - Reset/Set Transmit Pending"]
            #[inline]
            pub fn restxpnd(&mut self) -> _RESTXPNDW {
                _RESTXPNDW { w: self }
            }
            #[doc = "Bit 17 - Reset/Set Transmit Pending"]
            #[inline]
            pub fn settxpnd(&mut self) -> _SETTXPNDW {
                _SETTXPNDW { w: self }
            }
            #[doc = "Bit 2 - Reset/Set Receive Updating"]
            #[inline]
            pub fn resrxupd(&mut self) -> _RESRXUPDW {
                _RESRXUPDW { w: self }
            }
            #[doc = "Bit 18 - Reset/Set Receive Updating"]
            #[inline]
            pub fn setrxupd(&mut self) -> _SETRXUPDW {
                _SETRXUPDW { w: self }
            }
            #[doc = "Bit 3 - Reset/Set New Data"]
            #[inline]
            pub fn resnewdat(&mut self) -> _RESNEWDATW {
                _RESNEWDATW { w: self }
            }
            #[doc = "Bit 19 - Reset/Set New Data"]
            #[inline]
            pub fn setnewdat(&mut self) -> _SETNEWDATW {
                _SETNEWDATW { w: self }
            }
            #[doc = "Bit 4 - Reset/Set Message Lost"]
            #[inline]
            pub fn resmsglst(&mut self) -> _RESMSGLSTW {
                _RESMSGLSTW { w: self }
            }
            #[doc = "Bit 20 - Reset/Set Message Lost"]
            #[inline]
            pub fn setmsglst(&mut self) -> _SETMSGLSTW {
                _SETMSGLSTW { w: self }
            }
            #[doc = "Bit 5 - Reset/Set Message Valid"]
            #[inline]
            pub fn resmsgval(&mut self) -> _RESMSGVALW {
                _RESMSGVALW { w: self }
            }
            #[doc = "Bit 21 - Reset/Set Message Valid"]
            #[inline]
            pub fn setmsgval(&mut self) -> _SETMSGVALW {
                _SETMSGVALW { w: self }
            }
            #[doc = "Bit 6 - Reset/Set Receive/Transmit Selected"]
            #[inline]
            pub fn resrtsel(&mut self) -> _RESRTSELW {
                _RESRTSELW { w: self }
            }
            #[doc = "Bit 22 - Reset/Set Receive/Transmit Selected"]
            #[inline]
            pub fn setrtsel(&mut self) -> _SETRTSELW {
                _SETRTSELW { w: self }
            }
            #[doc = "Bit 7 - Reset/Set Receive Enable"]
            #[inline]
            pub fn resrxen(&mut self) -> _RESRXENW {
                _RESRXENW { w: self }
            }
            #[doc = "Bit 23 - Reset/Set Receive Enable"]
            #[inline]
            pub fn setrxen(&mut self) -> _SETRXENW {
                _SETRXENW { w: self }
            }
            #[doc = "Bit 8 - Reset/Set Transmit Request"]
            #[inline]
            pub fn restxrq(&mut self) -> _RESTXRQW {
                _RESTXRQW { w: self }
            }
            #[doc = "Bit 24 - Reset/Set Transmit Request"]
            #[inline]
            pub fn settxrq(&mut self) -> _SETTXRQW {
                _SETTXRQW { w: self }
            }
            #[doc = "Bit 9 - Reset/Set Transmit Enable 0"]
            #[inline]
            pub fn restxen0(&mut self) -> _RESTXEN0W {
                _RESTXEN0W { w: self }
            }
            #[doc = "Bit 25 - Reset/Set Transmit Enable 0"]
            #[inline]
            pub fn settxen0(&mut self) -> _SETTXEN0W {
                _SETTXEN0W { w: self }
            }
            #[doc = "Bit 10 - Reset/Set Transmit Enable 1"]
            #[inline]
            pub fn restxen1(&mut self) -> _RESTXEN1W {
                _RESTXEN1W { w: self }
            }
            #[doc = "Bit 26 - Reset/Set Transmit Enable 1"]
            #[inline]
            pub fn settxen1(&mut self) -> _SETTXEN1W {
                _SETTXEN1W { w: self }
            }
            #[doc = "Bit 11 - Reset/Set Message Direction"]
            #[inline]
            pub fn resdir(&mut self) -> _RESDIRW {
                _RESDIRW { w: self }
            }
            #[doc = "Bit 27 - Reset/Set Message Direction"]
            #[inline]
            pub fn setdir(&mut self) -> _SETDIRW {
                _SETDIRW { w: self }
            }
        }
    }
    #[doc = "Message Object Status Register"]
    pub struct MOSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Message Object Status Register"]
    pub mod mostat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MOSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `RXPND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXPNDR {
            #[doc = "No CAN message has been received."]
            VALUE1,
            #[doc = "A CAN message has been received by the message object n, either directly or via gateway copy action."]
            VALUE2,
        }
        impl RXPNDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RXPNDR::VALUE1 => false,
                    RXPNDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RXPNDR {
                match value {
                    false => RXPNDR::VALUE1,
                    true => RXPNDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXPNDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXPNDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TXPND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXPNDR {
            #[doc = "No CAN message has been transmitted."]
            VALUE1,
            #[doc = "A CAN message from message object n has been transmitted successfully over the CAN bus."]
            VALUE2,
        }
        impl TXPNDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXPNDR::VALUE1 => false,
                    TXPNDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXPNDR {
                match value {
                    false => TXPNDR::VALUE1,
                    true => TXPNDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXPNDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXPNDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RXUPD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXUPDR {
            #[doc = "No receive update ongoing."]
            VALUE1,
            #[doc = "Message identifier, DLC, and data of the message object are currently updated."]
            VALUE2,
        }
        impl RXUPDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RXUPDR::VALUE1 => false,
                    RXUPDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RXUPDR {
                match value {
                    false => RXUPDR::VALUE1,
                    true => RXUPDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXUPDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXUPDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NEWDAT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NEWDATR {
            #[doc = "No update of the message object n since last flag reset."]
            VALUE1,
            #[doc = "Message object n has been updated."]
            VALUE2,
        }
        impl NEWDATR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NEWDATR::VALUE1 => false,
                    NEWDATR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NEWDATR {
                match value {
                    false => NEWDATR::VALUE1,
                    true => NEWDATR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NEWDATR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NEWDATR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSGLST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSGLSTR {
            #[doc = "No CAN message is lost."]
            VALUE1,
            #[doc = "A CAN message is lost because NEWDAT has become set again when it has already been set."]
            VALUE2,
        }
        impl MSGLSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSGLSTR::VALUE1 => false,
                    MSGLSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSGLSTR {
                match value {
                    false => MSGLSTR::VALUE1,
                    true => MSGLSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSGLSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSGLSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSGVAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSGVALR {
            #[doc = "Message object n is not valid."]
            VALUE1,
            #[doc = "Message object n is valid."]
            VALUE2,
        }
        impl MSGVALR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSGVALR::VALUE1 => false,
                    MSGVALR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSGVALR {
                match value {
                    false => MSGVALR::VALUE1,
                    true => MSGVALR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSGVALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSGVALR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RTSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RTSELR {
            #[doc = "Message object n is not selected for receive or transmit operation."]
            VALUE1,
            #[doc = "Message object n is selected for receive or transmit operation."]
            VALUE2,
        }
        impl RTSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RTSELR::VALUE1 => false,
                    RTSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RTSELR {
                match value {
                    false => RTSELR::VALUE1,
                    true => RTSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RTSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RTSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RXEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RXENR {
            #[doc = "Message object n is not enabled for frame reception."]
            VALUE1,
            #[doc = "Message object n is enabled for frame reception."]
            VALUE2,
        }
        impl RXENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RXENR::VALUE1 => false,
                    RXENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RXENR {
                match value {
                    false => RXENR::VALUE1,
                    true => RXENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RXENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RXENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TXRQ`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXRQR {
            #[doc = "No transmission of message object n is requested."]
            VALUE1,
            #[doc = "Transmission of message object n on the CAN bus is requested."]
            VALUE2,
        }
        impl TXRQR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXRQR::VALUE1 => false,
                    TXRQR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXRQR {
                match value {
                    false => TXRQR::VALUE1,
                    true => TXRQR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXRQR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXRQR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TXEN0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXEN0R {
            #[doc = "Message object n is not enabled for frame transmission."]
            VALUE1,
            #[doc = "Message object n is enabled for frame transmission."]
            VALUE2,
        }
        impl TXEN0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXEN0R::VALUE1 => false,
                    TXEN0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXEN0R {
                match value {
                    false => TXEN0R::VALUE1,
                    true => TXEN0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXEN0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXEN0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `TXEN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TXEN1R {
            #[doc = "Message object n is not enabled for frame transmission."]
            VALUE1,
            #[doc = "Message object n is enabled for frame transmission."]
            VALUE2,
        }
        impl TXEN1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TXEN1R::VALUE1 => false,
                    TXEN1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TXEN1R {
                match value {
                    false => TXEN1R::VALUE1,
                    true => TXEN1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TXEN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TXEN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DIR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIRR {
            #[doc = "Receive Object selected: With TXRQ = 1, a Remote Frame with the identifier of message object n is scheduled for transmission. On reception of a Data Frame with matching identifier, the message is stored in message object n."]
            VALUE1,
            #[doc = "Transmit Object selected: If TXRQ = 1, message object n is scheduled for transmission of a Data Frame. On reception of a Remote Frame with matching identifier, bit TXRQ is set."]
            VALUE2,
        }
        impl DIRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIRR::VALUE1 => false,
                    DIRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIRR {
                match value {
                    false => DIRR::VALUE1,
                    true => DIRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIRR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct LISTR {
            bits: u8,
        }
        impl LISTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PPREVR {
            bits: u8,
        }
        impl PPREVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PNEXTR {
            bits: u8,
        }
        impl PNEXTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Receive Pending"]
            #[inline]
            pub fn rxpnd(&self) -> RXPNDR {
                RXPNDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Transmit Pending"]
            #[inline]
            pub fn txpnd(&self) -> TXPNDR {
                TXPNDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Receive Updating"]
            #[inline]
            pub fn rxupd(&self) -> RXUPDR {
                RXUPDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - New Data"]
            #[inline]
            pub fn newdat(&self) -> NEWDATR {
                NEWDATR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Message Lost"]
            #[inline]
            pub fn msglst(&self) -> MSGLSTR {
                MSGLSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Message Valid"]
            #[inline]
            pub fn msgval(&self) -> MSGVALR {
                MSGVALR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Receive/Transmit Selected"]
            #[inline]
            pub fn rtsel(&self) -> RTSELR {
                RTSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Receive Enable"]
            #[inline]
            pub fn rxen(&self) -> RXENR {
                RXENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Transmit Request"]
            #[inline]
            pub fn txrq(&self) -> TXRQR {
                TXRQR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Transmit Enable 0"]
            #[inline]
            pub fn txen0(&self) -> TXEN0R {
                TXEN0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Transmit Enable 1"]
            #[inline]
            pub fn txen1(&self) -> TXEN1R {
                TXEN1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Message Direction"]
            #[inline]
            pub fn dir(&self) -> DIRR {
                DIRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 12:15 - List Allocation"]
            #[inline]
            pub fn list(&self) -> LISTR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LISTR { bits }
            }
            #[doc = "Bits 16:23 - Pointer to Previous Message Object"]
            #[inline]
            pub fn pprev(&self) -> PPREVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PPREVR { bits }
            }
            #[doc = "Bits 24:31 - Pointer to Next Message Object"]
            #[inline]
            pub fn pnext(&self) -> PNEXTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PNEXTR { bits }
            }
        }
    }
}
#[doc = "Controller Area Networks"]
pub struct CAN_MO0 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO0 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO1: Peripheral<CAN_MO1> = unsafe { Peripheral::new(0x4801_5020) };
#[doc = r" Register block"]
pub struct CAN_MO1 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO1 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO2: Peripheral<CAN_MO2> = unsafe { Peripheral::new(0x4801_5040) };
#[doc = r" Register block"]
pub struct CAN_MO2 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO2 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO3: Peripheral<CAN_MO3> = unsafe { Peripheral::new(0x4801_5060) };
#[doc = r" Register block"]
pub struct CAN_MO3 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO3 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO4: Peripheral<CAN_MO4> = unsafe { Peripheral::new(0x4801_5080) };
#[doc = r" Register block"]
pub struct CAN_MO4 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO4 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO5: Peripheral<CAN_MO5> = unsafe { Peripheral::new(0x4801_50a0) };
#[doc = r" Register block"]
pub struct CAN_MO5 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO5 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO6: Peripheral<CAN_MO6> = unsafe { Peripheral::new(0x4801_50c0) };
#[doc = r" Register block"]
pub struct CAN_MO6 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO6 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO7: Peripheral<CAN_MO7> = unsafe { Peripheral::new(0x4801_50e0) };
#[doc = r" Register block"]
pub struct CAN_MO7 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO7 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO8: Peripheral<CAN_MO8> = unsafe { Peripheral::new(0x4801_5100) };
#[doc = r" Register block"]
pub struct CAN_MO8 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO8 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO9: Peripheral<CAN_MO9> = unsafe { Peripheral::new(0x4801_5120) };
#[doc = r" Register block"]
pub struct CAN_MO9 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO9 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO10: Peripheral<CAN_MO10> = unsafe { Peripheral::new(0x4801_5140) };
#[doc = r" Register block"]
pub struct CAN_MO10 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO10 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO11: Peripheral<CAN_MO11> = unsafe { Peripheral::new(0x4801_5160) };
#[doc = r" Register block"]
pub struct CAN_MO11 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO11 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO12: Peripheral<CAN_MO12> = unsafe { Peripheral::new(0x4801_5180) };
#[doc = r" Register block"]
pub struct CAN_MO12 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO12 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO13: Peripheral<CAN_MO13> = unsafe { Peripheral::new(0x4801_51a0) };
#[doc = r" Register block"]
pub struct CAN_MO13 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO13 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO14: Peripheral<CAN_MO14> = unsafe { Peripheral::new(0x4801_51c0) };
#[doc = r" Register block"]
pub struct CAN_MO14 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO14 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO15: Peripheral<CAN_MO15> = unsafe { Peripheral::new(0x4801_51e0) };
#[doc = r" Register block"]
pub struct CAN_MO15 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO15 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO16: Peripheral<CAN_MO16> = unsafe { Peripheral::new(0x4801_5200) };
#[doc = r" Register block"]
pub struct CAN_MO16 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO16 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO17: Peripheral<CAN_MO17> = unsafe { Peripheral::new(0x4801_5220) };
#[doc = r" Register block"]
pub struct CAN_MO17 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO17 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO18: Peripheral<CAN_MO18> = unsafe { Peripheral::new(0x4801_5240) };
#[doc = r" Register block"]
pub struct CAN_MO18 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO18 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO19: Peripheral<CAN_MO19> = unsafe { Peripheral::new(0x4801_5260) };
#[doc = r" Register block"]
pub struct CAN_MO19 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO19 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO20: Peripheral<CAN_MO20> = unsafe { Peripheral::new(0x4801_5280) };
#[doc = r" Register block"]
pub struct CAN_MO20 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO20 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO21: Peripheral<CAN_MO21> = unsafe { Peripheral::new(0x4801_52a0) };
#[doc = r" Register block"]
pub struct CAN_MO21 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO21 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO22: Peripheral<CAN_MO22> = unsafe { Peripheral::new(0x4801_52c0) };
#[doc = r" Register block"]
pub struct CAN_MO22 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO22 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO23: Peripheral<CAN_MO23> = unsafe { Peripheral::new(0x4801_52e0) };
#[doc = r" Register block"]
pub struct CAN_MO23 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO23 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO24: Peripheral<CAN_MO24> = unsafe { Peripheral::new(0x4801_5300) };
#[doc = r" Register block"]
pub struct CAN_MO24 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO24 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO25: Peripheral<CAN_MO25> = unsafe { Peripheral::new(0x4801_5320) };
#[doc = r" Register block"]
pub struct CAN_MO25 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO25 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO26: Peripheral<CAN_MO26> = unsafe { Peripheral::new(0x4801_5340) };
#[doc = r" Register block"]
pub struct CAN_MO26 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO26 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO27: Peripheral<CAN_MO27> = unsafe { Peripheral::new(0x4801_5360) };
#[doc = r" Register block"]
pub struct CAN_MO27 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO27 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO28: Peripheral<CAN_MO28> = unsafe { Peripheral::new(0x4801_5380) };
#[doc = r" Register block"]
pub struct CAN_MO28 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO28 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO29: Peripheral<CAN_MO29> = unsafe { Peripheral::new(0x4801_53a0) };
#[doc = r" Register block"]
pub struct CAN_MO29 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO29 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO30: Peripheral<CAN_MO30> = unsafe { Peripheral::new(0x4801_53c0) };
#[doc = r" Register block"]
pub struct CAN_MO30 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO30 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO31: Peripheral<CAN_MO31> = unsafe { Peripheral::new(0x4801_53e0) };
#[doc = r" Register block"]
pub struct CAN_MO31 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO31 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO32: Peripheral<CAN_MO32> = unsafe { Peripheral::new(0x4801_5400) };
#[doc = r" Register block"]
pub struct CAN_MO32 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO32 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO33: Peripheral<CAN_MO33> = unsafe { Peripheral::new(0x4801_5420) };
#[doc = r" Register block"]
pub struct CAN_MO33 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO33 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO34: Peripheral<CAN_MO34> = unsafe { Peripheral::new(0x4801_5440) };
#[doc = r" Register block"]
pub struct CAN_MO34 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO34 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO35: Peripheral<CAN_MO35> = unsafe { Peripheral::new(0x4801_5460) };
#[doc = r" Register block"]
pub struct CAN_MO35 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO35 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO36: Peripheral<CAN_MO36> = unsafe { Peripheral::new(0x4801_5480) };
#[doc = r" Register block"]
pub struct CAN_MO36 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO36 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO37: Peripheral<CAN_MO37> = unsafe { Peripheral::new(0x4801_54a0) };
#[doc = r" Register block"]
pub struct CAN_MO37 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO37 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO38: Peripheral<CAN_MO38> = unsafe { Peripheral::new(0x4801_54c0) };
#[doc = r" Register block"]
pub struct CAN_MO38 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO38 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO39: Peripheral<CAN_MO39> = unsafe { Peripheral::new(0x4801_54e0) };
#[doc = r" Register block"]
pub struct CAN_MO39 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO39 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO40: Peripheral<CAN_MO40> = unsafe { Peripheral::new(0x4801_5500) };
#[doc = r" Register block"]
pub struct CAN_MO40 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO40 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO41: Peripheral<CAN_MO41> = unsafe { Peripheral::new(0x4801_5520) };
#[doc = r" Register block"]
pub struct CAN_MO41 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO41 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO42: Peripheral<CAN_MO42> = unsafe { Peripheral::new(0x4801_5540) };
#[doc = r" Register block"]
pub struct CAN_MO42 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO42 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO43: Peripheral<CAN_MO43> = unsafe { Peripheral::new(0x4801_5560) };
#[doc = r" Register block"]
pub struct CAN_MO43 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO43 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO44: Peripheral<CAN_MO44> = unsafe { Peripheral::new(0x4801_5580) };
#[doc = r" Register block"]
pub struct CAN_MO44 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO44 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO45: Peripheral<CAN_MO45> = unsafe { Peripheral::new(0x4801_55a0) };
#[doc = r" Register block"]
pub struct CAN_MO45 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO45 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO46: Peripheral<CAN_MO46> = unsafe { Peripheral::new(0x4801_55c0) };
#[doc = r" Register block"]
pub struct CAN_MO46 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO46 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO47: Peripheral<CAN_MO47> = unsafe { Peripheral::new(0x4801_55e0) };
#[doc = r" Register block"]
pub struct CAN_MO47 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO47 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO48: Peripheral<CAN_MO48> = unsafe { Peripheral::new(0x4801_5600) };
#[doc = r" Register block"]
pub struct CAN_MO48 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO48 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO49: Peripheral<CAN_MO49> = unsafe { Peripheral::new(0x4801_5620) };
#[doc = r" Register block"]
pub struct CAN_MO49 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO49 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO50: Peripheral<CAN_MO50> = unsafe { Peripheral::new(0x4801_5640) };
#[doc = r" Register block"]
pub struct CAN_MO50 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO50 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO51: Peripheral<CAN_MO51> = unsafe { Peripheral::new(0x4801_5660) };
#[doc = r" Register block"]
pub struct CAN_MO51 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO51 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO52: Peripheral<CAN_MO52> = unsafe { Peripheral::new(0x4801_5680) };
#[doc = r" Register block"]
pub struct CAN_MO52 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO52 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO53: Peripheral<CAN_MO53> = unsafe { Peripheral::new(0x4801_56a0) };
#[doc = r" Register block"]
pub struct CAN_MO53 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO53 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO54: Peripheral<CAN_MO54> = unsafe { Peripheral::new(0x4801_56c0) };
#[doc = r" Register block"]
pub struct CAN_MO54 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO54 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO55: Peripheral<CAN_MO55> = unsafe { Peripheral::new(0x4801_56e0) };
#[doc = r" Register block"]
pub struct CAN_MO55 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO55 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO56: Peripheral<CAN_MO56> = unsafe { Peripheral::new(0x4801_5700) };
#[doc = r" Register block"]
pub struct CAN_MO56 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO56 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO57: Peripheral<CAN_MO57> = unsafe { Peripheral::new(0x4801_5720) };
#[doc = r" Register block"]
pub struct CAN_MO57 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO57 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO58: Peripheral<CAN_MO58> = unsafe { Peripheral::new(0x4801_5740) };
#[doc = r" Register block"]
pub struct CAN_MO58 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO58 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO59: Peripheral<CAN_MO59> = unsafe { Peripheral::new(0x4801_5760) };
#[doc = r" Register block"]
pub struct CAN_MO59 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO59 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO60: Peripheral<CAN_MO60> = unsafe { Peripheral::new(0x4801_5780) };
#[doc = r" Register block"]
pub struct CAN_MO60 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO60 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO61: Peripheral<CAN_MO61> = unsafe { Peripheral::new(0x4801_57a0) };
#[doc = r" Register block"]
pub struct CAN_MO61 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO61 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO62: Peripheral<CAN_MO62> = unsafe { Peripheral::new(0x4801_57c0) };
#[doc = r" Register block"]
pub struct CAN_MO62 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO62 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Controller Area Networks"]
pub const CAN_MO63: Peripheral<CAN_MO63> = unsafe { Peripheral::new(0x4801_57e0) };
#[doc = r" Register block"]
pub struct CAN_MO63 {
    register_block: can_mo0::RegisterBlock,
}
impl Deref for CAN_MO63 {
    type Target = can_mo0::RegisterBlock;
    fn deref(&self) -> &can_mo0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Analog to Digital Converter"]
pub const VADC: Peripheral<VADC> = unsafe { Peripheral::new(0x4000_4000) };
#[doc = "Analog to Digital Converter"]
pub mod vadc {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Clock Control Register"]
        pub clc: CLC,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Module Identification Register"]
        pub id: ID,
        _reserved1: [u8; 28usize],
        #[doc = "0x28 - OCDS Control and Status Register"]
        pub ocs: OCS,
        _reserved2: [u8; 84usize],
        #[doc = "0x80 - Global Configuration Register"]
        pub globcfg: GLOBCFG,
        _reserved3: [u8; 28usize],
        #[doc = "0xa0 - Input Class Register, Global"]
        pub globiclass: [GLOBICLASS; 2],
        _reserved4: [u8; 16usize],
        #[doc = "0xb8 - Global Boundary Select Register"]
        pub globbound: GLOBBOUND,
        _reserved5: [u8; 36usize],
        #[doc = "0xe0 - Global Event Flag Register"]
        pub globeflag: GLOBEFLAG,
        _reserved6: [u8; 92usize],
        #[doc = "0x140 - Global Event Node Pointer Register"]
        pub globevnp: GLOBEVNP,
        _reserved7: [u8; 28usize],
        #[doc = "0x160 - Global Test Functions Register"]
        pub globtf: GLOBTF,
        _reserved8: [u8; 28usize],
        #[doc = "0x180 - Background Request Source Channel Select Register"]
        pub brssel: [BRSSEL; 4],
        _reserved9: [u8; 48usize],
        #[doc = "0x1c0 - Background Request Source Pending Register"]
        pub brspnd: [BRSPND; 4],
        _reserved10: [u8; 48usize],
        #[doc = "0x200 - Background Request Source Control Register"]
        pub brsctrl: BRSCTRL,
        #[doc = "0x204 - Background Request Source Mode Register"]
        pub brsmr: BRSMR,
        _reserved11: [u8; 120usize],
        #[doc = "0x280 - Global Result Control Register"]
        pub globrcr: GLOBRCR,
        _reserved12: [u8; 124usize],
        #[doc = "0x300 - Global Result Register"]
        pub globres: GLOBRES,
        _reserved13: [u8; 124usize],
        #[doc = "0x380 - Global Result Register, Debug"]
        pub globresd: GLOBRESD,
        _reserved14: [u8; 108usize],
        #[doc = "0x3f0 - External Multiplexer Select Register"]
        pub emuxsel: EMUXSEL,
    }
    #[doc = "Clock Control Register"]
    pub struct CLC {
        register: VolatileCell<u32>,
    }
    #[doc = "Clock Control Register"]
    pub mod clc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CLC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DISR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DISRR {
            #[doc = "On request: enable the module clock"]
            VALUE1,
            #[doc = "Off request: stop the module clock"]
            VALUE2,
        }
        impl DISRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DISRR::VALUE1 => false,
                    DISRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DISRR {
                match value {
                    false => DISRR::VALUE1,
                    true => DISRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DISRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DISRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DISS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DISSR {
            #[doc = "Module clock is enabled"]
            VALUE1,
            #[doc = "Off: module is not clocked"]
            VALUE2,
        }
        impl DISSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DISSR::VALUE1 => false,
                    DISSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DISSR {
                match value {
                    false => DISSR::VALUE1,
                    true => DISSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DISSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DISSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EDISR {
            #[doc = "Sleep mode request is enabled and functional"]
            VALUE1,
            #[doc = "Module disregards the sleep mode control signal"]
            VALUE2,
        }
        impl EDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EDISR::VALUE1 => false,
                    EDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EDISR {
                match value {
                    false => EDISR::VALUE1,
                    true => EDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EDISR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DISR`"]
        pub enum DISRW {
            #[doc = "On request: enable the module clock"]
            VALUE1,
            #[doc = "Off request: stop the module clock"]
            VALUE2,
        }
        impl DISRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DISRW::VALUE1 => false,
                    DISRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DISRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DISRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DISRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "On request: enable the module clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DISRW::VALUE1)
            }
            #[doc = "Off request: stop the module clock"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DISRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EDIS`"]
        pub enum EDISW {
            #[doc = "Sleep mode request is enabled and functional"]
            VALUE1,
            #[doc = "Module disregards the sleep mode control signal"]
            VALUE2,
        }
        impl EDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EDISW::VALUE1 => false,
                    EDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Sleep mode request is enabled and functional"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EDISW::VALUE1)
            }
            #[doc = "Module disregards the sleep mode control signal"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Module Disable Request Bit"]
            #[inline]
            pub fn disr(&self) -> DISRR {
                DISRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Module Disable Status Bit"]
            #[inline]
            pub fn diss(&self) -> DISSR {
                DISSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Sleep Mode Enable Control"]
            #[inline]
            pub fn edis(&self) -> EDISR {
                EDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x03 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Module Disable Request Bit"]
            #[inline]
            pub fn disr(&mut self) -> _DISRW {
                _DISRW { w: self }
            }
            #[doc = "Bit 3 - Sleep Mode Enable Control"]
            #[inline]
            pub fn edis(&mut self) -> _EDISW {
                _EDISW { w: self }
            }
        }
    }
    #[doc = "Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_REVR {
            bits: u8,
        }
        impl MOD_REVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_TYPER {
            bits: u8,
        }
        impl MOD_TYPER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOD_NUMBERR {
            bits: u16,
        }
        impl MOD_NUMBERR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn mod_rev(&self) -> MOD_REVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_REVR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn mod_type(&self) -> MOD_TYPER {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOD_TYPER { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn mod_number(&self) -> MOD_NUMBERR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MOD_NUMBERR { bits }
            }
        }
    }
    #[doc = "OCDS Control and Status Register"]
    pub struct OCS {
        register: VolatileCell<u32>,
    }
    #[doc = "OCDS Control and Status Register"]
    pub mod ocs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OCS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `TGS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TGSR {
            #[doc = "No Trigger Set output"]
            VALUE1,
            #[doc = "Trigger Set 1: TS16_SSIG, input sample signals"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TGSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TGSR::VALUE1 => 0,
                    TGSR::VALUE2 => 0x01,
                    TGSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TGSR {
                match value {
                    0 => TGSR::VALUE1,
                    1 => TGSR::VALUE2,
                    i => TGSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TGSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TGSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TGB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TGBR {
            #[doc = "Trigger Set is output on OTGB0"]
            VALUE1,
            #[doc = "Trigger Set is output on OTGB1"]
            VALUE2,
        }
        impl TGBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TGBR::VALUE1 => false,
                    TGBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TGBR {
                match value {
                    false => TGBR::VALUE1,
                    true => TGBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TGBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TGBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSR {
            #[doc = "Will not suspend"]
            VALUE1,
            #[doc = "Hard suspend: Clock is switched off immediately."]
            VALUE2,
            #[doc = "Soft suspend mode 0: Stop conversions after the currently running one is completed and its result has been stored. No change for the arbiter."]
            VALUE3,
            #[doc = "Soft suspend mode 1: Stop conversions after the currently running one is completed and its result has been stored. Stop arbiter after the current arbitration round."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SUSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SUSR::VALUE1 => 0,
                    SUSR::VALUE2 => 0x01,
                    SUSR::VALUE3 => 0x02,
                    SUSR::VALUE4 => 0x03,
                    SUSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SUSR {
                match value {
                    0 => SUSR::VALUE1,
                    1 => SUSR::VALUE2,
                    2 => SUSR::VALUE3,
                    3 => SUSR::VALUE4,
                    i => SUSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SUSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SUSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SUSSTA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSSTAR {
            #[doc = "Module is not (yet) suspended"]
            VALUE1,
            #[doc = "Module is suspended"]
            VALUE2,
        }
        impl SUSSTAR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SUSSTAR::VALUE1 => false,
                    SUSSTAR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SUSSTAR {
                match value {
                    false => SUSSTAR::VALUE1,
                    true => SUSSTAR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSSTAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSSTAR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `TGS`"]
        pub enum TGSW {
            #[doc = "No Trigger Set output"]
            VALUE1,
            #[doc = "Trigger Set 1: TS16_SSIG, input sample signals"]
            VALUE2,
        }
        impl TGSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TGSW::VALUE1 => 0,
                    TGSW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TGSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TGSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TGSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "No Trigger Set output"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TGSW::VALUE1)
            }
            #[doc = "Trigger Set 1: TS16_SSIG, input sample signals"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TGSW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TGB`"]
        pub enum TGBW {
            #[doc = "Trigger Set is output on OTGB0"]
            VALUE1,
            #[doc = "Trigger Set is output on OTGB1"]
            VALUE2,
        }
        impl TGBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TGBW::VALUE1 => false,
                    TGBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TGBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TGBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TGBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trigger Set is output on OTGB0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TGBW::VALUE1)
            }
            #[doc = "Trigger Set is output on OTGB1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TGBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TG_PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TG_PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUS`"]
        pub enum SUSW {
            #[doc = "Will not suspend"]
            VALUE1,
            #[doc = "Hard suspend: Clock is switched off immediately."]
            VALUE2,
            #[doc = "Soft suspend mode 0: Stop conversions after the currently running one is completed and its result has been stored. No change for the arbiter."]
            VALUE3,
            #[doc = "Soft suspend mode 1: Stop conversions after the currently running one is completed and its result has been stored. Stop arbiter after the current arbitration round."]
            VALUE4,
        }
        impl SUSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SUSW::VALUE1 => 0,
                    SUSW::VALUE2 => 1,
                    SUSW::VALUE3 => 2,
                    SUSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Will not suspend"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUSW::VALUE1)
            }
            #[doc = "Hard suspend: Clock is switched off immediately."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUSW::VALUE2)
            }
            #[doc = "Soft suspend mode 0: Stop conversions after the currently running one is completed and its result has been stored. No change for the arbiter."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SUSW::VALUE3)
            }
            #[doc = "Soft suspend mode 1: Stop conversions after the currently running one is completed and its result has been stored. Stop arbiter after the current arbitration round."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SUSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUS_PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUS_PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Trigger Set for OTGB0/1"]
            #[inline]
            pub fn tgs(&self) -> TGSR {
                TGSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - OTGB0/1 Bus Select"]
            #[inline]
            pub fn tgb(&self) -> TGBR {
                TGBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 24:27 - OCDS Suspend Control"]
            #[inline]
            pub fn sus(&self) -> SUSR {
                SUSR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 29 - Suspend State"]
            #[inline]
            pub fn sussta(&self) -> SUSSTAR {
                SUSSTAR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Trigger Set for OTGB0/1"]
            #[inline]
            pub fn tgs(&mut self) -> _TGSW {
                _TGSW { w: self }
            }
            #[doc = "Bit 2 - OTGB0/1 Bus Select"]
            #[inline]
            pub fn tgb(&mut self) -> _TGBW {
                _TGBW { w: self }
            }
            #[doc = "Bit 3 - TGS, TGB Write Protection"]
            #[inline]
            pub fn tg_p(&mut self) -> _TG_PW {
                _TG_PW { w: self }
            }
            #[doc = "Bits 24:27 - OCDS Suspend Control"]
            #[inline]
            pub fn sus(&mut self) -> _SUSW {
                _SUSW { w: self }
            }
            #[doc = "Bit 28 - SUS Write Protection"]
            #[inline]
            pub fn sus_p(&mut self) -> _SUS_PW {
                _SUS_PW { w: self }
            }
        }
    }
    #[doc = "Global Configuration Register"]
    pub struct GLOBCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Configuration Register"]
    pub mod globcfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DIVA`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIVAR {
            #[doc = "fADCI = fADC / 2"]
            VALUE1,
            #[doc = "fADCI = fADC / 2"]
            VALUE2,
            #[doc = "fADCI = fADC / 3"]
            VALUE3,
            #[doc = "fADCI = fADC / 32"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DIVAR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DIVAR::VALUE1 => 0,
                    DIVAR::VALUE2 => 0x01,
                    DIVAR::VALUE3 => 0x02,
                    DIVAR::VALUE4 => 0x1f,
                    DIVAR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DIVAR {
                match value {
                    0 => DIVAR::VALUE1,
                    1 => DIVAR::VALUE2,
                    2 => DIVAR::VALUE3,
                    31 => DIVAR::VALUE4,
                    i => DIVAR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIVAR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIVAR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DIVAR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DIVAR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DCMSB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCMSBR {
            #[doc = "1 clock cycles for the MSB (standard)"]
            VALUE1,
            #[doc = "2 clock cycles for the MSB (fADCI > 20 MHz)"]
            VALUE2,
        }
        impl DCMSBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCMSBR::VALUE1 => false,
                    DCMSBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCMSBR {
                match value {
                    false => DCMSBR::VALUE1,
                    true => DCMSBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCMSBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCMSBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DIVD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIVDR {
            #[doc = "fADCD = fADC"]
            VALUE1,
            #[doc = "fADCD = fADC / 2"]
            VALUE2,
            #[doc = "fADCD = fADC / 3"]
            VALUE3,
            #[doc = "fADCD = fADC / 4"]
            VALUE4,
        }
        impl DIVDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DIVDR::VALUE1 => 0,
                    DIVDR::VALUE2 => 0x01,
                    DIVDR::VALUE3 => 0x02,
                    DIVDR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DIVDR {
                match value {
                    0 => DIVDR::VALUE1,
                    1 => DIVDR::VALUE2,
                    2 => DIVDR::VALUE3,
                    3 => DIVDR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIVDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIVDR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DIVDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DIVDR::VALUE4
            }
        }
        #[doc = "Possible values of the field `DPCAL0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPCAL0R {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPCAL0R::VALUE1 => false,
                    DPCAL0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPCAL0R {
                match value {
                    false => DPCAL0R::VALUE1,
                    true => DPCAL0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPCAL0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPCAL0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPCAL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPCAL1R {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPCAL1R::VALUE1 => false,
                    DPCAL1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPCAL1R {
                match value {
                    false => DPCAL1R::VALUE1,
                    true => DPCAL1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPCAL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPCAL1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPCAL2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPCAL2R {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPCAL2R::VALUE1 => false,
                    DPCAL2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPCAL2R {
                match value {
                    false => DPCAL2R::VALUE1,
                    true => DPCAL2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPCAL2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPCAL2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DPCAL3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DPCAL3R {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DPCAL3R::VALUE1 => false,
                    DPCAL3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DPCAL3R {
                match value {
                    false => DPCAL3R::VALUE1,
                    true => DPCAL3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DPCAL3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DPCAL3R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DIVA`"]
        pub enum DIVAW {
            #[doc = "fADCI = fADC / 2"]
            VALUE1,
            #[doc = "fADCI = fADC / 2"]
            VALUE2,
            #[doc = "fADCI = fADC / 3"]
            VALUE3,
            #[doc = "fADCI = fADC / 32"]
            VALUE4,
        }
        impl DIVAW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DIVAW::VALUE1 => 0,
                    DIVAW::VALUE2 => 1,
                    DIVAW::VALUE3 => 2,
                    DIVAW::VALUE4 => 31,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIVAW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIVAW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIVAW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "fADCI = fADC / 2"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIVAW::VALUE1)
            }
            #[doc = "fADCI = fADC / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIVAW::VALUE2)
            }
            #[doc = "fADCI = fADC / 3"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DIVAW::VALUE3)
            }
            #[doc = "fADCI = fADC / 32"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DIVAW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCMSB`"]
        pub enum DCMSBW {
            #[doc = "1 clock cycles for the MSB (standard)"]
            VALUE1,
            #[doc = "2 clock cycles for the MSB (fADCI > 20 MHz)"]
            VALUE2,
        }
        impl DCMSBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCMSBW::VALUE1 => false,
                    DCMSBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCMSBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCMSBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCMSBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "1 clock cycles for the MSB (standard)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCMSBW::VALUE1)
            }
            #[doc = "2 clock cycles for the MSB (fADCI > 20 MHz)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCMSBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIVD`"]
        pub enum DIVDW {
            #[doc = "fADCD = fADC"]
            VALUE1,
            #[doc = "fADCD = fADC / 2"]
            VALUE2,
            #[doc = "fADCD = fADC / 3"]
            VALUE3,
            #[doc = "fADCD = fADC / 4"]
            VALUE4,
        }
        impl DIVDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DIVDW::VALUE1 => 0,
                    DIVDW::VALUE2 => 1,
                    DIVDW::VALUE3 => 2,
                    DIVDW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIVDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIVDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIVDW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "fADCD = fADC"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIVDW::VALUE1)
            }
            #[doc = "fADCD = fADC / 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIVDW::VALUE2)
            }
            #[doc = "fADCD = fADC / 3"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DIVDW::VALUE3)
            }
            #[doc = "fADCD = fADC / 4"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DIVDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIVWC`"]
        pub enum DIVWCW {
            #[doc = "No write access to divider parameters"]
            VALUE1,
            #[doc = "Bitfields DIVA, DCMSB, DIVD can be written"]
            VALUE2,
        }
        impl DIVWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIVWCW::VALUE1 => false,
                    DIVWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIVWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIVWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIVWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to divider parameters"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIVWCW::VALUE1)
            }
            #[doc = "Bitfields DIVA, DCMSB, DIVD can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIVWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPCAL0`"]
        pub enum DPCAL0W {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPCAL0W::VALUE1 => false,
                    DPCAL0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPCAL0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPCAL0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPCAL0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Automatic post-calibration after each conversion of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPCAL0W::VALUE1)
            }
            #[doc = "No post-calibration"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPCAL0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPCAL1`"]
        pub enum DPCAL1W {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPCAL1W::VALUE1 => false,
                    DPCAL1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPCAL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPCAL1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPCAL1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Automatic post-calibration after each conversion of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPCAL1W::VALUE1)
            }
            #[doc = "No post-calibration"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPCAL1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPCAL2`"]
        pub enum DPCAL2W {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPCAL2W::VALUE1 => false,
                    DPCAL2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPCAL2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPCAL2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPCAL2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Automatic post-calibration after each conversion of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPCAL2W::VALUE1)
            }
            #[doc = "No post-calibration"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPCAL2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DPCAL3`"]
        pub enum DPCAL3W {
            #[doc = "Automatic post-calibration after each conversion of group x"]
            VALUE1,
            #[doc = "No post-calibration"]
            VALUE2,
        }
        impl DPCAL3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DPCAL3W::VALUE1 => false,
                    DPCAL3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DPCAL3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DPCAL3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DPCAL3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Automatic post-calibration after each conversion of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DPCAL3W::VALUE1)
            }
            #[doc = "No post-calibration"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DPCAL3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUCAL`"]
        pub enum SUCALW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Initiate the start-up calibration phase (indication in bit GxARBCFG.CAL)"]
            VALUE2,
        }
        impl SUCALW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SUCALW::VALUE1 => false,
                    SUCALW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUCALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUCALW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUCALW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUCALW::VALUE1)
            }
            #[doc = "Initiate the start-up calibration phase (indication in bit GxARBCFG.CAL)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUCALW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Divider Factor for the Analog Internal Clock"]
            #[inline]
            pub fn diva(&self) -> DIVAR {
                DIVAR::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 7 - Double Clock for the MSB Conversion"]
            #[inline]
            pub fn dcmsb(&self) -> DCMSBR {
                DCMSBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 8:9 - Divider Factor for the Arbiter Clock"]
            #[inline]
            pub fn divd(&self) -> DIVDR {
                DIVDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal0(&self) -> DPCAL0R {
                DPCAL0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal1(&self) -> DPCAL1R {
                DPCAL1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal2(&self) -> DPCAL2R {
                DPCAL2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal3(&self) -> DPCAL3R {
                DPCAL3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0f }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Divider Factor for the Analog Internal Clock"]
            #[inline]
            pub fn diva(&mut self) -> _DIVAW {
                _DIVAW { w: self }
            }
            #[doc = "Bit 7 - Double Clock for the MSB Conversion"]
            #[inline]
            pub fn dcmsb(&mut self) -> _DCMSBW {
                _DCMSBW { w: self }
            }
            #[doc = "Bits 8:9 - Divider Factor for the Arbiter Clock"]
            #[inline]
            pub fn divd(&mut self) -> _DIVDW {
                _DIVDW { w: self }
            }
            #[doc = "Bit 15 - Write Control for Divider Parameters"]
            #[inline]
            pub fn divwc(&mut self) -> _DIVWCW {
                _DIVWCW { w: self }
            }
            #[doc = "Bit 16 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal0(&mut self) -> _DPCAL0W {
                _DPCAL0W { w: self }
            }
            #[doc = "Bit 17 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal1(&mut self) -> _DPCAL1W {
                _DPCAL1W { w: self }
            }
            #[doc = "Bit 18 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal2(&mut self) -> _DPCAL2W {
                _DPCAL2W { w: self }
            }
            #[doc = "Bit 19 - Disable Post-Calibration"]
            #[inline]
            pub fn dpcal3(&mut self) -> _DPCAL3W {
                _DPCAL3W { w: self }
            }
            #[doc = "Bit 31 - Start-Up Calibration"]
            #[inline]
            pub fn sucal(&mut self) -> _SUCALW {
                _SUCALW { w: self }
            }
        }
    }
    #[doc = "Input Class Register, Global"]
    pub struct GLOBICLASS {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Class Register, Global"]
    pub mod globiclass {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBICLASS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct STCSR {
            bits: u8,
        }
        impl STCSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CMS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMSR {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CMSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMSR::VALUE1 => 0,
                    CMSR::VALUE2 => 0x01,
                    CMSR::VALUE3 => 0x02,
                    CMSR::VALUE6 => 0x05,
                    CMSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMSR {
                match value {
                    0 => CMSR::VALUE1,
                    1 => CMSR::VALUE2,
                    2 => CMSR::VALUE3,
                    5 => CMSR::VALUE6,
                    i => CMSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == CMSR::VALUE6
            }
        }
        #[doc = r" Value of the field"]
        pub struct STCER {
            bits: u8,
        }
        impl STCER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMER {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CMER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMER::VALUE1 => 0,
                    CMER::VALUE2 => 0x01,
                    CMER::VALUE3 => 0x02,
                    CMER::VALUE6 => 0x05,
                    CMER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMER {
                match value {
                    0 => CMER::VALUE1,
                    1 => CMER::VALUE2,
                    2 => CMER::VALUE3,
                    5 => CMER::VALUE6,
                    i => CMER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == CMER::VALUE6
            }
        }
        #[doc = r" Proxy"]
        pub struct _STCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STCSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMS`"]
        pub enum CMSW {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
        }
        impl CMSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMSW::VALUE1 => 0,
                    CMSW::VALUE2 => 1,
                    CMSW::VALUE3 => 2,
                    CMSW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "12-bit conversion"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMSW::VALUE1)
            }
            #[doc = "10-bit conversion"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMSW::VALUE2)
            }
            #[doc = "8-bit conversion"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMSW::VALUE3)
            }
            #[doc = "10-bit fast compare mode"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(CMSW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STCEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CME`"]
        pub enum CMEW {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
        }
        impl CMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMEW::VALUE1 => 0,
                    CMEW::VALUE2 => 1,
                    CMEW::VALUE3 => 2,
                    CMEW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "12-bit conversion"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMEW::VALUE1)
            }
            #[doc = "10-bit conversion"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMEW::VALUE2)
            }
            #[doc = "8-bit conversion"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMEW::VALUE3)
            }
            #[doc = "10-bit fast compare mode"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(CMEW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Sample Time Control for Standard Conversions"]
            #[inline]
            pub fn stcs(&self) -> STCSR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STCSR { bits }
            }
            #[doc = "Bits 8:10 - Conversion Mode for Standard Conversions"]
            #[inline]
            pub fn cms(&self) -> CMSR {
                CMSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:20 - Sample Time Control for EMUX Conversions"]
            #[inline]
            pub fn stce(&self) -> STCER {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STCER { bits }
            }
            #[doc = "Bits 24:26 - Conversion Mode for EMUX Conversions"]
            #[inline]
            pub fn cme(&self) -> CMER {
                CMER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Sample Time Control for Standard Conversions"]
            #[inline]
            pub fn stcs(&mut self) -> _STCSW {
                _STCSW { w: self }
            }
            #[doc = "Bits 8:10 - Conversion Mode for Standard Conversions"]
            #[inline]
            pub fn cms(&mut self) -> _CMSW {
                _CMSW { w: self }
            }
            #[doc = "Bits 16:20 - Sample Time Control for EMUX Conversions"]
            #[inline]
            pub fn stce(&mut self) -> _STCEW {
                _STCEW { w: self }
            }
            #[doc = "Bits 24:26 - Conversion Mode for EMUX Conversions"]
            #[inline]
            pub fn cme(&mut self) -> _CMEW {
                _CMEW { w: self }
            }
        }
    }
    #[doc = "Global Boundary Select Register"]
    pub struct GLOBBOUND {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Boundary Select Register"]
    pub mod globbound {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBBOUND {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BOUNDARY0R {
            bits: u16,
        }
        impl BOUNDARY0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct BOUNDARY1R {
            bits: u16,
        }
        impl BOUNDARY1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _BOUNDARY0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BOUNDARY0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BOUNDARY1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BOUNDARY1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:11 - Boundary Value 0 for Limit Checking"]
            #[inline]
            pub fn boundary0(&self) -> BOUNDARY0R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BOUNDARY0R { bits }
            }
            #[doc = "Bits 16:27 - Boundary Value 1 for Limit Checking"]
            #[inline]
            pub fn boundary1(&self) -> BOUNDARY1R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BOUNDARY1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:11 - Boundary Value 0 for Limit Checking"]
            #[inline]
            pub fn boundary0(&mut self) -> _BOUNDARY0W {
                _BOUNDARY0W { w: self }
            }
            #[doc = "Bits 16:27 - Boundary Value 1 for Limit Checking"]
            #[inline]
            pub fn boundary1(&mut self) -> _BOUNDARY1W {
                _BOUNDARY1W { w: self }
            }
        }
    }
    #[doc = "Global Event Flag Register"]
    pub struct GLOBEFLAG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Event Flag Register"]
    pub mod globeflag {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBEFLAG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SEVGLB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEVGLBR {
            #[doc = "No source event"]
            VALUE1,
            #[doc = "A source event has occurred"]
            VALUE2,
        }
        impl SEVGLBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SEVGLBR::VALUE1 => false,
                    SEVGLBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SEVGLBR {
                match value {
                    false => SEVGLBR::VALUE1,
                    true => SEVGLBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEVGLBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEVGLBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REVGLB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REVGLBR {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GLOBRES"]
            VALUE2,
        }
        impl REVGLBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REVGLBR::VALUE1 => false,
                    REVGLBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REVGLBR {
                match value {
                    false => REVGLBR::VALUE1,
                    true => REVGLBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REVGLBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REVGLBR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SEVGLB`"]
        pub enum SEVGLBW {
            #[doc = "No source event"]
            VALUE1,
            #[doc = "A source event has occurred"]
            VALUE2,
        }
        impl SEVGLBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEVGLBW::VALUE1 => false,
                    SEVGLBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEVGLBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEVGLBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEVGLBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No source event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEVGLBW::VALUE1)
            }
            #[doc = "A source event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEVGLBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REVGLB`"]
        pub enum REVGLBW {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GLOBRES"]
            VALUE2,
        }
        impl REVGLBW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REVGLBW::VALUE1 => false,
                    REVGLBW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REVGLBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REVGLBW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REVGLBW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REVGLBW::VALUE1)
            }
            #[doc = "New result was stored in register GLOBRES"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REVGLBW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SEVGLBCLR`"]
        pub enum SEVGLBCLRW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the source event flag SEVGLB"]
            VALUE2,
        }
        impl SEVGLBCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEVGLBCLRW::VALUE1 => false,
                    SEVGLBCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEVGLBCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEVGLBCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEVGLBCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEVGLBCLRW::VALUE1)
            }
            #[doc = "Clear the source event flag SEVGLB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEVGLBCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REVGLBCLR`"]
        pub enum REVGLBCLRW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag REVGLB"]
            VALUE2,
        }
        impl REVGLBCLRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REVGLBCLRW::VALUE1 => false,
                    REVGLBCLRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REVGLBCLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REVGLBCLRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REVGLBCLRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REVGLBCLRW::VALUE1)
            }
            #[doc = "Clear the result event flag REVGLB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REVGLBCLRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source Event (Background)"]
            #[inline]
            pub fn sevglb(&self) -> SEVGLBR {
                SEVGLBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Global Result Event"]
            #[inline]
            pub fn revglb(&self) -> REVGLBR {
                REVGLBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Source Event (Background)"]
            #[inline]
            pub fn sevglb(&mut self) -> _SEVGLBW {
                _SEVGLBW { w: self }
            }
            #[doc = "Bit 8 - Global Result Event"]
            #[inline]
            pub fn revglb(&mut self) -> _REVGLBW {
                _REVGLBW { w: self }
            }
            #[doc = "Bit 16 - Clear Source Event (Background)"]
            #[inline]
            pub fn sevglbclr(&mut self) -> _SEVGLBCLRW {
                _SEVGLBCLRW { w: self }
            }
            #[doc = "Bit 24 - Clear Global Result Event"]
            #[inline]
            pub fn revglbclr(&mut self) -> _REVGLBCLRW {
                _REVGLBCLRW { w: self }
            }
        }
    }
    #[doc = "Global Event Node Pointer Register"]
    pub struct GLOBEVNP {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Event Node Pointer Register"]
    pub mod globevnp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBEVNP {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SEV0NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEV0NPR {
            #[doc = "Select shared service request line 0 of common service request group 0"]
            VALUE1,
            #[doc = "Select shared service request line 3 of common service request group 0"]
            VALUE2,
            #[doc = "Select shared service request line 0 of common service request group 1"]
            VALUE3,
            #[doc = "Select shared service request line 3 of common service request group 1"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SEV0NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SEV0NPR::VALUE1 => 0,
                    SEV0NPR::VALUE2 => 0x03,
                    SEV0NPR::VALUE3 => 0x04,
                    SEV0NPR::VALUE4 => 0x07,
                    SEV0NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SEV0NPR {
                match value {
                    0 => SEV0NPR::VALUE1,
                    3 => SEV0NPR::VALUE2,
                    4 => SEV0NPR::VALUE3,
                    7 => SEV0NPR::VALUE4,
                    i => SEV0NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEV0NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEV0NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SEV0NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SEV0NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV0NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV0NPR {
            #[doc = "Select shared service request line 0 of common service request group 0"]
            VALUE1,
            #[doc = "Select shared service request line 3 of common service request group 0"]
            VALUE2,
            #[doc = "Select shared service request line 0 of common service request group 1"]
            VALUE3,
            #[doc = "Select shared service request line 3 of common service request group 1"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV0NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV0NPR::VALUE1 => 0,
                    REV0NPR::VALUE2 => 0x03,
                    REV0NPR::VALUE3 => 0x04,
                    REV0NPR::VALUE4 => 0x07,
                    REV0NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV0NPR {
                match value {
                    0 => REV0NPR::VALUE1,
                    3 => REV0NPR::VALUE2,
                    4 => REV0NPR::VALUE3,
                    7 => REV0NPR::VALUE4,
                    i => REV0NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV0NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV0NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV0NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV0NPR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SEV0NP`"]
        pub enum SEV0NPW {
            #[doc = "Select shared service request line 0 of common service request group 0"]
            VALUE1,
            #[doc = "Select shared service request line 3 of common service request group 0"]
            VALUE2,
            #[doc = "Select shared service request line 0 of common service request group 1"]
            VALUE3,
            #[doc = "Select shared service request line 3 of common service request group 1"]
            VALUE4,
        }
        impl SEV0NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SEV0NPW::VALUE1 => 0,
                    SEV0NPW::VALUE2 => 3,
                    SEV0NPW::VALUE3 => 4,
                    SEV0NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV0NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV0NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV0NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select shared service request line 0 of common service request group 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE1)
            }
            #[doc = "Select shared service request line 3 of common service request group 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0 of common service request group 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3 of common service request group 1"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV0NP`"]
        pub enum REV0NPW {
            #[doc = "Select shared service request line 0 of common service request group 0"]
            VALUE1,
            #[doc = "Select shared service request line 3 of common service request group 0"]
            VALUE2,
            #[doc = "Select shared service request line 0 of common service request group 1"]
            VALUE3,
            #[doc = "Select shared service request line 3 of common service request group 1"]
            VALUE4,
        }
        impl REV0NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV0NPW::VALUE1 => 0,
                    REV0NPW::VALUE2 => 3,
                    REV0NPW::VALUE3 => 4,
                    REV0NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV0NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV0NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV0NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select shared service request line 0 of common service request group 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE1)
            }
            #[doc = "Select shared service request line 3 of common service request group 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0 of common service request group 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3 of common service request group 1"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Backgr. Source"]
            #[inline]
            pub fn sev0np(&self) -> SEV0NPR {
                SEV0NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Backgr. Result"]
            #[inline]
            pub fn rev0np(&self) -> REV0NPR {
                REV0NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Backgr. Source"]
            #[inline]
            pub fn sev0np(&mut self) -> _SEV0NPW {
                _SEV0NPW { w: self }
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Backgr. Result"]
            #[inline]
            pub fn rev0np(&mut self) -> _REV0NPW {
                _REV0NPW { w: self }
            }
        }
    }
    #[doc = "Global Test Functions Register"]
    pub struct GLOBTF {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Test Functions Register"]
    pub mod globtf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBTF {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CDGRR {
            bits: u8,
        }
        impl CDGRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CDEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CDENR {
            #[doc = "All diagnostic pull devices are disconnected"]
            VALUE1,
            #[doc = "Diagnostic pull devices connected as selected by bitfield CDSEL"]
            VALUE2,
        }
        impl CDENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CDENR::VALUE1 => false,
                    CDENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CDENR {
                match value {
                    false => CDENR::VALUE1,
                    true => CDENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CDENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CDENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CDSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CDSELR {
            #[doc = "Connected to VAREF"]
            VALUE1,
            #[doc = "Connected to VAGND"]
            VALUE2,
            #[doc = "Connected to 1/3rd VAREF"]
            VALUE3,
            #[doc = "Connected to 2/3rd VAREF"]
            VALUE4,
        }
        impl CDSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CDSELR::VALUE1 => 0,
                    CDSELR::VALUE2 => 0x01,
                    CDSELR::VALUE3 => 0x02,
                    CDSELR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CDSELR {
                match value {
                    0 => CDSELR::VALUE1,
                    1 => CDSELR::VALUE2,
                    2 => CDSELR::VALUE3,
                    3 => CDSELR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CDSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CDSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CDSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CDSELR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PDD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDDR {
            #[doc = "Disconnected"]
            VALUE1,
            #[doc = "The pull-down diagnostics device is active"]
            VALUE2,
        }
        impl PDDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDDR::VALUE1 => false,
                    PDDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDDR {
                match value {
                    false => PDDR::VALUE1,
                    true => PDDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDDR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _CDGRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CDGRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CDEN`"]
        pub enum CDENW {
            #[doc = "All diagnostic pull devices are disconnected"]
            VALUE1,
            #[doc = "Diagnostic pull devices connected as selected by bitfield CDSEL"]
            VALUE2,
        }
        impl CDENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CDENW::VALUE1 => false,
                    CDENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CDENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CDENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CDENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "All diagnostic pull devices are disconnected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CDENW::VALUE1)
            }
            #[doc = "Diagnostic pull devices connected as selected by bitfield CDSEL"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CDENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CDSEL`"]
        pub enum CDSELW {
            #[doc = "Connected to VAREF"]
            VALUE1,
            #[doc = "Connected to VAGND"]
            VALUE2,
            #[doc = "Connected to 1/3rd VAREF"]
            VALUE3,
            #[doc = "Connected to 2/3rd VAREF"]
            VALUE4,
        }
        impl CDSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CDSELW::VALUE1 => 0,
                    CDSELW::VALUE2 => 1,
                    CDSELW::VALUE3 => 2,
                    CDSELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CDSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CDSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CDSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Connected to VAREF"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CDSELW::VALUE1)
            }
            #[doc = "Connected to VAGND"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CDSELW::VALUE2)
            }
            #[doc = "Connected to 1/3rd VAREF"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CDSELW::VALUE3)
            }
            #[doc = "Connected to 2/3rd VAREF"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CDSELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CDWC`"]
        pub enum CDWCW {
            #[doc = "No write access to parameters"]
            VALUE1,
            #[doc = "Bitfields CDSEL, CDEN, CDGR can be written"]
            VALUE2,
        }
        impl CDWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CDWCW::VALUE1 => false,
                    CDWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CDWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CDWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CDWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to parameters"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CDWCW::VALUE1)
            }
            #[doc = "Bitfields CDSEL, CDEN, CDGR can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CDWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDD`"]
        pub enum PDDW {
            #[doc = "Disconnected"]
            VALUE1,
            #[doc = "The pull-down diagnostics device is active"]
            VALUE2,
        }
        impl PDDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDDW::VALUE1 => false,
                    PDDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disconnected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDDW::VALUE1)
            }
            #[doc = "The pull-down diagnostics device is active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MDWC`"]
        pub enum MDWCW {
            #[doc = "No write access to parameters"]
            VALUE1,
            #[doc = "Bitfield PDD can be written"]
            VALUE2,
        }
        impl MDWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MDWCW::VALUE1 => false,
                    MDWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MDWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MDWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MDWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to parameters"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MDWCW::VALUE1)
            }
            #[doc = "Bitfield PDD can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MDWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 4:7 - Converter Diagnostics Group"]
            #[inline]
            pub fn cdgr(&self) -> CDGRR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CDGRR { bits }
            }
            #[doc = "Bit 8 - Converter Diagnostics Enable"]
            #[inline]
            pub fn cden(&self) -> CDENR {
                CDENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:10 - Converter Diagnostics Pull-Devices Select"]
            #[inline]
            pub fn cdsel(&self) -> CDSELR {
                CDSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Pull-Down Diagnostics Enable"]
            #[inline]
            pub fn pdd(&self) -> PDDR {
                PDDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 4:7 - Converter Diagnostics Group"]
            #[inline]
            pub fn cdgr(&mut self) -> _CDGRW {
                _CDGRW { w: self }
            }
            #[doc = "Bit 8 - Converter Diagnostics Enable"]
            #[inline]
            pub fn cden(&mut self) -> _CDENW {
                _CDENW { w: self }
            }
            #[doc = "Bits 9:10 - Converter Diagnostics Pull-Devices Select"]
            #[inline]
            pub fn cdsel(&mut self) -> _CDSELW {
                _CDSELW { w: self }
            }
            #[doc = "Bit 15 - Write Control for Conversion Diagnostics"]
            #[inline]
            pub fn cdwc(&mut self) -> _CDWCW {
                _CDWCW { w: self }
            }
            #[doc = "Bit 16 - Pull-Down Diagnostics Enable"]
            #[inline]
            pub fn pdd(&mut self) -> _PDDW {
                _PDDW { w: self }
            }
            #[doc = "Bit 23 - Write Control for Multiplexer Diagnostics"]
            #[inline]
            pub fn mdwc(&mut self) -> _MDWCW {
                _MDWCW { w: self }
            }
        }
    }
    #[doc = "Background Request Source Channel Select Register"]
    pub struct BRSSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Background Request Source Channel Select Register"]
    pub mod brssel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BRSSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CHSELG0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG0R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG0R::VALUE1 => false,
                    CHSELG0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG0R {
                match value {
                    false => CHSELG0R::VALUE1,
                    true => CHSELG0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG1R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG1R::VALUE1 => false,
                    CHSELG1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG1R {
                match value {
                    false => CHSELG1R::VALUE1,
                    true => CHSELG1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG2R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG2R::VALUE1 => false,
                    CHSELG2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG2R {
                match value {
                    false => CHSELG2R::VALUE1,
                    true => CHSELG2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG3R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG3R::VALUE1 => false,
                    CHSELG3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG3R {
                match value {
                    false => CHSELG3R::VALUE1,
                    true => CHSELG3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG4R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG4R::VALUE1 => false,
                    CHSELG4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG4R {
                match value {
                    false => CHSELG4R::VALUE1,
                    true => CHSELG4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG5R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG5R::VALUE1 => false,
                    CHSELG5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG5R {
                match value {
                    false => CHSELG5R::VALUE1,
                    true => CHSELG5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG6R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG6R::VALUE1 => false,
                    CHSELG6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG6R {
                match value {
                    false => CHSELG6R::VALUE1,
                    true => CHSELG6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSELG7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSELG7R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSELG7R::VALUE1 => false,
                    CHSELG7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSELG7R {
                match value {
                    false => CHSELG7R::VALUE1,
                    true => CHSELG7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSELG7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSELG7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CHSELG0`"]
        pub enum CHSELG0W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG0W::VALUE1 => false,
                    CHSELG0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG0W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG1`"]
        pub enum CHSELG1W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG1W::VALUE1 => false,
                    CHSELG1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG1W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG2`"]
        pub enum CHSELG2W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG2W::VALUE1 => false,
                    CHSELG2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG2W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG3`"]
        pub enum CHSELG3W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG3W::VALUE1 => false,
                    CHSELG3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG3W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG4`"]
        pub enum CHSELG4W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG4W::VALUE1 => false,
                    CHSELG4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG4W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG5`"]
        pub enum CHSELG5W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG5W::VALUE1 => false,
                    CHSELG5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG5W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG6`"]
        pub enum CHSELG6W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG6W::VALUE1 => false,
                    CHSELG6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG6W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSELG7`"]
        pub enum CHSELG7W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSELG7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSELG7W::VALUE1 => false,
                    CHSELG7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSELG7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSELG7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSELG7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSELG7W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSELG7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Channel Selection Group x"]
            #[inline]
            pub fn chselg0(&self) -> CHSELG0R {
                CHSELG0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Channel Selection Group x"]
            #[inline]
            pub fn chselg1(&self) -> CHSELG1R {
                CHSELG1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channel Selection Group x"]
            #[inline]
            pub fn chselg2(&self) -> CHSELG2R {
                CHSELG2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channel Selection Group x"]
            #[inline]
            pub fn chselg3(&self) -> CHSELG3R {
                CHSELG3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channel Selection Group x"]
            #[inline]
            pub fn chselg4(&self) -> CHSELG4R {
                CHSELG4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channel Selection Group x"]
            #[inline]
            pub fn chselg5(&self) -> CHSELG5R {
                CHSELG5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Channel Selection Group x"]
            #[inline]
            pub fn chselg6(&self) -> CHSELG6R {
                CHSELG6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Channel Selection Group x"]
            #[inline]
            pub fn chselg7(&self) -> CHSELG7R {
                CHSELG7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Channel Selection Group x"]
            #[inline]
            pub fn chselg0(&mut self) -> _CHSELG0W {
                _CHSELG0W { w: self }
            }
            #[doc = "Bit 1 - Channel Selection Group x"]
            #[inline]
            pub fn chselg1(&mut self) -> _CHSELG1W {
                _CHSELG1W { w: self }
            }
            #[doc = "Bit 2 - Channel Selection Group x"]
            #[inline]
            pub fn chselg2(&mut self) -> _CHSELG2W {
                _CHSELG2W { w: self }
            }
            #[doc = "Bit 3 - Channel Selection Group x"]
            #[inline]
            pub fn chselg3(&mut self) -> _CHSELG3W {
                _CHSELG3W { w: self }
            }
            #[doc = "Bit 4 - Channel Selection Group x"]
            #[inline]
            pub fn chselg4(&mut self) -> _CHSELG4W {
                _CHSELG4W { w: self }
            }
            #[doc = "Bit 5 - Channel Selection Group x"]
            #[inline]
            pub fn chselg5(&mut self) -> _CHSELG5W {
                _CHSELG5W { w: self }
            }
            #[doc = "Bit 6 - Channel Selection Group x"]
            #[inline]
            pub fn chselg6(&mut self) -> _CHSELG6W {
                _CHSELG6W { w: self }
            }
            #[doc = "Bit 7 - Channel Selection Group x"]
            #[inline]
            pub fn chselg7(&mut self) -> _CHSELG7W {
                _CHSELG7W { w: self }
            }
        }
    }
    #[doc = "Background Request Source Pending Register"]
    pub struct BRSPND {
        register: VolatileCell<u32>,
    }
    #[doc = "Background Request Source Pending Register"]
    pub mod brspnd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BRSPND {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CHPNDG0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG0R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG0R::VALUE1 => false,
                    CHPNDG0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG0R {
                match value {
                    false => CHPNDG0R::VALUE1,
                    true => CHPNDG0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG1R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG1R::VALUE1 => false,
                    CHPNDG1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG1R {
                match value {
                    false => CHPNDG1R::VALUE1,
                    true => CHPNDG1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG2R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG2R::VALUE1 => false,
                    CHPNDG2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG2R {
                match value {
                    false => CHPNDG2R::VALUE1,
                    true => CHPNDG2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG3R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG3R::VALUE1 => false,
                    CHPNDG3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG3R {
                match value {
                    false => CHPNDG3R::VALUE1,
                    true => CHPNDG3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG4R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG4R::VALUE1 => false,
                    CHPNDG4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG4R {
                match value {
                    false => CHPNDG4R::VALUE1,
                    true => CHPNDG4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG5R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG5R::VALUE1 => false,
                    CHPNDG5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG5R {
                match value {
                    false => CHPNDG5R::VALUE1,
                    true => CHPNDG5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG6R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG6R::VALUE1 => false,
                    CHPNDG6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG6R {
                match value {
                    false => CHPNDG6R::VALUE1,
                    true => CHPNDG6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPNDG7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPNDG7R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPNDG7R::VALUE1 => false,
                    CHPNDG7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPNDG7R {
                match value {
                    false => CHPNDG7R::VALUE1,
                    true => CHPNDG7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPNDG7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPNDG7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG0`"]
        pub enum CHPNDG0W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG0W::VALUE1 => false,
                    CHPNDG0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG0W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG1`"]
        pub enum CHPNDG1W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG1W::VALUE1 => false,
                    CHPNDG1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG1W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG2`"]
        pub enum CHPNDG2W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG2W::VALUE1 => false,
                    CHPNDG2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG2W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG3`"]
        pub enum CHPNDG3W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG3W::VALUE1 => false,
                    CHPNDG3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG3W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG4`"]
        pub enum CHPNDG4W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG4W::VALUE1 => false,
                    CHPNDG4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG4W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG5`"]
        pub enum CHPNDG5W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG5W::VALUE1 => false,
                    CHPNDG5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG5W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG6`"]
        pub enum CHPNDG6W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG6W::VALUE1 => false,
                    CHPNDG6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG6W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPNDG7`"]
        pub enum CHPNDG7W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPNDG7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPNDG7W::VALUE1 => false,
                    CHPNDG7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPNDG7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPNDG7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPNDG7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPNDG7W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPNDG7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg0(&self) -> CHPNDG0R {
                CHPNDG0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg1(&self) -> CHPNDG1R {
                CHPNDG1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg2(&self) -> CHPNDG2R {
                CHPNDG2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg3(&self) -> CHPNDG3R {
                CHPNDG3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg4(&self) -> CHPNDG4R {
                CHPNDG4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg5(&self) -> CHPNDG5R {
                CHPNDG5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg6(&self) -> CHPNDG6R {
                CHPNDG6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg7(&self) -> CHPNDG7R {
                CHPNDG7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg0(&mut self) -> _CHPNDG0W {
                _CHPNDG0W { w: self }
            }
            #[doc = "Bit 1 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg1(&mut self) -> _CHPNDG1W {
                _CHPNDG1W { w: self }
            }
            #[doc = "Bit 2 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg2(&mut self) -> _CHPNDG2W {
                _CHPNDG2W { w: self }
            }
            #[doc = "Bit 3 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg3(&mut self) -> _CHPNDG3W {
                _CHPNDG3W { w: self }
            }
            #[doc = "Bit 4 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg4(&mut self) -> _CHPNDG4W {
                _CHPNDG4W { w: self }
            }
            #[doc = "Bit 5 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg5(&mut self) -> _CHPNDG5W {
                _CHPNDG5W { w: self }
            }
            #[doc = "Bit 6 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg6(&mut self) -> _CHPNDG6W {
                _CHPNDG6W { w: self }
            }
            #[doc = "Bit 7 - Channels Pending Group x"]
            #[inline]
            pub fn chpndg7(&mut self) -> _CHPNDG7W {
                _CHPNDG7W { w: self }
            }
        }
    }
    #[doc = "Background Request Source Control Register"]
    pub struct BRSCTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "Background Request Source Control Register"]
    pub mod brsctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BRSCTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SRCRESREG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRCRESREGR {
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            VALUE1,
            #[doc = "Store result in group result register GxRES1"]
            VALUE2,
            #[doc = "Store result in group result register GxRES15"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRCRESREGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRCRESREGR::VALUE1 => 0,
                    SRCRESREGR::VALUE2 => 0x01,
                    SRCRESREGR::VALUE3 => 0x0f,
                    SRCRESREGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRCRESREGR {
                match value {
                    0 => SRCRESREGR::VALUE1,
                    1 => SRCRESREGR::VALUE2,
                    15 => SRCRESREGR::VALUE3,
                    i => SRCRESREGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRCRESREGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRCRESREGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SRCRESREGR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct XTSELR {
            bits: u8,
        }
        impl XTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct XTLVLR {
            bits: bool,
        }
        impl XTLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `XTMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XTMODER {
            #[doc = "No external trigger"]
            VALUE1,
            #[doc = "Trigger event upon a falling edge"]
            VALUE2,
            #[doc = "Trigger event upon a rising edge"]
            VALUE3,
            #[doc = "Trigger event upon any edge"]
            VALUE4,
        }
        impl XTMODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    XTMODER::VALUE1 => 0,
                    XTMODER::VALUE2 => 0x01,
                    XTMODER::VALUE3 => 0x02,
                    XTMODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> XTMODER {
                match value {
                    0 => XTMODER::VALUE1,
                    1 => XTMODER::VALUE2,
                    2 => XTMODER::VALUE3,
                    3 => XTMODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XTMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XTMODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == XTMODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == XTMODER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct GTSELR {
            bits: u8,
        }
        impl GTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct GTLVLR {
            bits: bool,
        }
        impl GTLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `SRCRESREG`"]
        pub enum SRCRESREGW {
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            VALUE1,
            #[doc = "Store result in group result register GxRES1"]
            VALUE2,
            #[doc = "Store result in group result register GxRES15"]
            VALUE3,
        }
        impl SRCRESREGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRCRESREGW::VALUE1 => 0,
                    SRCRESREGW::VALUE2 => 1,
                    SRCRESREGW::VALUE3 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRCRESREGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRCRESREGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRCRESREGW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE1)
            }
            #[doc = "Store result in group result register GxRES1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE2)
            }
            #[doc = "Store result in group result register GxRES15"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTMODE`"]
        pub enum XTMODEW {
            #[doc = "No external trigger"]
            VALUE1,
            #[doc = "Trigger event upon a falling edge"]
            VALUE2,
            #[doc = "Trigger event upon a rising edge"]
            VALUE3,
            #[doc = "Trigger event upon any edge"]
            VALUE4,
        }
        impl XTMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    XTMODEW::VALUE1 => 0,
                    XTMODEW::VALUE2 => 1,
                    XTMODEW::VALUE3 => 2,
                    XTMODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTMODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No external trigger"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE1)
            }
            #[doc = "Trigger event upon a falling edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE2)
            }
            #[doc = "Trigger event upon a rising edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE3)
            }
            #[doc = "Trigger event upon any edge"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTWC`"]
        pub enum XTWCW {
            #[doc = "No write access to trigger configuration"]
            VALUE1,
            #[doc = "Bitfields XTMODE and XTSEL can be written"]
            VALUE2,
        }
        impl XTWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XTWCW::VALUE1 => false,
                    XTWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to trigger configuration"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTWCW::VALUE1)
            }
            #[doc = "Bitfields XTMODE and XTSEL can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GTSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GTWC`"]
        pub enum GTWCW {
            #[doc = "No write access to gate configuration"]
            VALUE1,
            #[doc = "Bitfield GTSEL can be written"]
            VALUE2,
        }
        impl GTWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GTWCW::VALUE1 => false,
                    GTWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GTWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GTWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GTWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to gate configuration"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GTWCW::VALUE1)
            }
            #[doc = "Bitfield GTSEL can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GTWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Source-specific Result Register"]
            #[inline]
            pub fn srcresreg(&self) -> SRCRESREGR {
                SRCRESREGR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - External Trigger Input Selection"]
            #[inline]
            pub fn xtsel(&self) -> XTSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XTSELR { bits }
            }
            #[doc = "Bit 12 - External Trigger Level"]
            #[inline]
            pub fn xtlvl(&self) -> XTLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XTLVLR { bits }
            }
            #[doc = "Bits 13:14 - Trigger Operating Mode"]
            #[inline]
            pub fn xtmode(&self) -> XTMODER {
                XTMODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Gate Input Selection"]
            #[inline]
            pub fn gtsel(&self) -> GTSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GTSELR { bits }
            }
            #[doc = "Bit 20 - Gate Input Level"]
            #[inline]
            pub fn gtlvl(&self) -> GTLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GTLVLR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Source-specific Result Register"]
            #[inline]
            pub fn srcresreg(&mut self) -> _SRCRESREGW {
                _SRCRESREGW { w: self }
            }
            #[doc = "Bits 8:11 - External Trigger Input Selection"]
            #[inline]
            pub fn xtsel(&mut self) -> _XTSELW {
                _XTSELW { w: self }
            }
            #[doc = "Bits 13:14 - Trigger Operating Mode"]
            #[inline]
            pub fn xtmode(&mut self) -> _XTMODEW {
                _XTMODEW { w: self }
            }
            #[doc = "Bit 15 - Write Control for Trigger Configuration"]
            #[inline]
            pub fn xtwc(&mut self) -> _XTWCW {
                _XTWCW { w: self }
            }
            #[doc = "Bits 16:19 - Gate Input Selection"]
            #[inline]
            pub fn gtsel(&mut self) -> _GTSELW {
                _GTSELW { w: self }
            }
            #[doc = "Bit 23 - Write Control for Gate Configuration"]
            #[inline]
            pub fn gtwc(&mut self) -> _GTWCW {
                _GTWCW { w: self }
            }
        }
    }
    #[doc = "Background Request Source Mode Register"]
    pub struct BRSMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Background Request Source Mode Register"]
    pub mod brsmr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BRSMR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENGTR {
            #[doc = "No conversion requests are issued"]
            VALUE1,
            #[doc = "Conversion requests are issued if at least one pending bit is set"]
            VALUE2,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 1."]
            VALUE3,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 0."]
            VALUE4,
        }
        impl ENGTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENGTR::VALUE1 => 0,
                    ENGTR::VALUE2 => 0x01,
                    ENGTR::VALUE3 => 0x02,
                    ENGTR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENGTR {
                match value {
                    0 => ENGTR::VALUE1,
                    1 => ENGTR::VALUE2,
                    2 => ENGTR::VALUE3,
                    3 => ENGTR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENGTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENGTR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ENGTR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ENTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENTRR {
            #[doc = "External trigger disabled"]
            VALUE1,
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the load event"]
            VALUE2,
        }
        impl ENTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENTRR::VALUE1 => false,
                    ENTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENTRR {
                match value {
                    false => ENTRR::VALUE1,
                    true => ENTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENSI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENSIR {
            #[doc = "No request source interrupt"]
            VALUE1,
            #[doc = "A request source interrupt is generated upon a request source event (last pending conversion is finished)"]
            VALUE2,
        }
        impl ENSIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENSIR::VALUE1 => false,
                    ENSIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENSIR {
                match value {
                    false => ENSIR::VALUE1,
                    true => ENSIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENSIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENSIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCAN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCANR {
            #[doc = "No autoscan"]
            VALUE1,
            #[doc = "Autoscan functionality enabled: a request source event automatically generates a load event"]
            VALUE2,
        }
        impl SCANR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCANR::VALUE1 => false,
                    SCANR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCANR {
                match value {
                    false => SCANR::VALUE1,
                    true => SCANR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCANR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCANR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LDM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LDMR {
            #[doc = "Overwrite mode: Copy all bits from the select registers to the pending registers upon a load event"]
            VALUE1,
            #[doc = "Combine mode: Set all pending bits that are set in the select registers upon a load event (logic OR)"]
            VALUE2,
        }
        impl LDMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LDMR::VALUE1 => false,
                    LDMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LDMR {
                match value {
                    false => LDMR::VALUE1,
                    true => LDMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LDMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LDMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REQGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REQGTR {
            #[doc = "The gate input is low"]
            VALUE1,
            #[doc = "The gate input is high"]
            VALUE2,
        }
        impl REQGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REQGTR::VALUE1 => false,
                    REQGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REQGTR {
                match value {
                    false => REQGTR::VALUE1,
                    true => REQGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REQGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REQGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPTDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPTDISR {
            #[doc = "A cancelled conversion is repeated"]
            VALUE1,
            #[doc = "A cancelled conversion is discarded"]
            VALUE2,
        }
        impl RPTDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPTDISR::VALUE1 => false,
                    RPTDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPTDISR {
                match value {
                    false => RPTDISR::VALUE1,
                    true => RPTDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPTDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPTDISR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ENGT`"]
        pub enum ENGTW {
            #[doc = "No conversion requests are issued"]
            VALUE1,
            #[doc = "Conversion requests are issued if at least one pending bit is set"]
            VALUE2,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 1."]
            VALUE3,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 0."]
            VALUE4,
        }
        impl ENGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENGTW::VALUE1 => 0,
                    ENGTW::VALUE2 => 1,
                    ENGTW::VALUE3 => 2,
                    ENGTW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENGTW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No conversion requests are issued"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENGTW::VALUE1)
            }
            #[doc = "Conversion requests are issued if at least one pending bit is set"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENGTW::VALUE2)
            }
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 1."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENGTW::VALUE3)
            }
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 0."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ENGTW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENTR`"]
        pub enum ENTRW {
            #[doc = "External trigger disabled"]
            VALUE1,
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the load event"]
            VALUE2,
        }
        impl ENTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENTRW::VALUE1 => false,
                    ENTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External trigger disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENTRW::VALUE1)
            }
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the load event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENSI`"]
        pub enum ENSIW {
            #[doc = "No request source interrupt"]
            VALUE1,
            #[doc = "A request source interrupt is generated upon a request source event (last pending conversion is finished)"]
            VALUE2,
        }
        impl ENSIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENSIW::VALUE1 => false,
                    ENSIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENSIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENSIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENSIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No request source interrupt"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENSIW::VALUE1)
            }
            #[doc = "A request source interrupt is generated upon a request source event (last pending conversion is finished)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENSIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCAN`"]
        pub enum SCANW {
            #[doc = "No autoscan"]
            VALUE1,
            #[doc = "Autoscan functionality enabled: a request source event automatically generates a load event"]
            VALUE2,
        }
        impl SCANW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCANW::VALUE1 => false,
                    SCANW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCANW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCANW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCANW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No autoscan"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCANW::VALUE1)
            }
            #[doc = "Autoscan functionality enabled: a request source event automatically generates a load event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCANW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LDM`"]
        pub enum LDMW {
            #[doc = "Overwrite mode: Copy all bits from the select registers to the pending registers upon a load event"]
            VALUE1,
            #[doc = "Combine mode: Set all pending bits that are set in the select registers upon a load event (logic OR)"]
            VALUE2,
        }
        impl LDMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LDMW::VALUE1 => false,
                    LDMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LDMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Overwrite mode: Copy all bits from the select registers to the pending registers upon a load event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LDMW::VALUE1)
            }
            #[doc = "Combine mode: Set all pending bits that are set in the select registers upon a load event (logic OR)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LDMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CLRPND`"]
        pub enum CLRPNDW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "The bits in registers BRSPNDx are cleared"]
            VALUE2,
        }
        impl CLRPNDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CLRPNDW::VALUE1 => false,
                    CLRPNDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRPNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRPNDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRPNDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CLRPNDW::VALUE1)
            }
            #[doc = "The bits in registers BRSPNDx are cleared"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CLRPNDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LDEV`"]
        pub enum LDEVW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "A load event is generated"]
            VALUE2,
        }
        impl LDEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LDEVW::VALUE1 => false,
                    LDEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LDEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LDEVW::VALUE1)
            }
            #[doc = "A load event is generated"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LDEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RPTDIS`"]
        pub enum RPTDISW {
            #[doc = "A cancelled conversion is repeated"]
            VALUE1,
            #[doc = "A cancelled conversion is discarded"]
            VALUE2,
        }
        impl RPTDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RPTDISW::VALUE1 => false,
                    RPTDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPTDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPTDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RPTDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A cancelled conversion is repeated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RPTDISW::VALUE1)
            }
            #[doc = "A cancelled conversion is discarded"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RPTDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Enable Gate"]
            #[inline]
            pub fn engt(&self) -> ENGTR {
                ENGTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - Enable External Trigger"]
            #[inline]
            pub fn entr(&self) -> ENTRR {
                ENTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&self) -> ENSIR {
                ENSIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Autoscan Enable"]
            #[inline]
            pub fn scan(&self) -> SCANR {
                SCANR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Autoscan Source Load Event Mode"]
            #[inline]
            pub fn ldm(&self) -> LDMR {
                LDMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Request Gate Level"]
            #[inline]
            pub fn reqgt(&self) -> REQGTR {
                REQGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Repeat Disable"]
            #[inline]
            pub fn rptdis(&self) -> RPTDISR {
                RPTDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Enable Gate"]
            #[inline]
            pub fn engt(&mut self) -> _ENGTW {
                _ENGTW { w: self }
            }
            #[doc = "Bit 2 - Enable External Trigger"]
            #[inline]
            pub fn entr(&mut self) -> _ENTRW {
                _ENTRW { w: self }
            }
            #[doc = "Bit 3 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&mut self) -> _ENSIW {
                _ENSIW { w: self }
            }
            #[doc = "Bit 4 - Autoscan Enable"]
            #[inline]
            pub fn scan(&mut self) -> _SCANW {
                _SCANW { w: self }
            }
            #[doc = "Bit 5 - Autoscan Source Load Event Mode"]
            #[inline]
            pub fn ldm(&mut self) -> _LDMW {
                _LDMW { w: self }
            }
            #[doc = "Bit 8 - Clear Pending Bits"]
            #[inline]
            pub fn clrpnd(&mut self) -> _CLRPNDW {
                _CLRPNDW { w: self }
            }
            #[doc = "Bit 9 - Generate Load Event"]
            #[inline]
            pub fn ldev(&mut self) -> _LDEVW {
                _LDEVW { w: self }
            }
            #[doc = "Bit 16 - Repeat Disable"]
            #[inline]
            pub fn rptdis(&mut self) -> _RPTDISW {
                _RPTDISW { w: self }
            }
        }
    }
    #[doc = "Global Result Control Register"]
    pub struct GLOBRCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Result Control Register"]
    pub mod globrcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBRCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DRCTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DRCTRR {
            #[doc = "Data reduction disabled"]
            VALUE1,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DRCTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DRCTRR::VALUE1 => 0,
                    DRCTRR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DRCTRR {
                match value {
                    0 => DRCTRR::VALUE1,
                    i => DRCTRR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DRCTRR::VALUE1
            }
        }
        #[doc = "Possible values of the field `WFR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WFRR {
            #[doc = "Overwrite mode"]
            VALUE1,
            #[doc = "Wait-for-read mode enabled for this register"]
            VALUE2,
        }
        impl WFRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WFRR::VALUE1 => false,
                    WFRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WFRR {
                match value {
                    false => WFRR::VALUE1,
                    true => WFRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WFRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WFRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRGEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRGENR {
            #[doc = "No service request"]
            VALUE1,
            #[doc = "Service request after a result event"]
            VALUE2,
        }
        impl SRGENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRGENR::VALUE1 => false,
                    SRGENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRGENR {
                match value {
                    false => SRGENR::VALUE1,
                    true => SRGENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRGENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRGENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `DRCTR`"]
        pub enum DRCTRW {
            #[doc = "Data reduction disabled"]
            VALUE1,
        }
        impl DRCTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DRCTRW::VALUE1 => 0,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DRCTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DRCTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DRCTRW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Data reduction disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DRCTRW::VALUE1)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WFR`"]
        pub enum WFRW {
            #[doc = "Overwrite mode"]
            VALUE1,
            #[doc = "Wait-for-read mode enabled for this register"]
            VALUE2,
        }
        impl WFRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WFRW::VALUE1 => false,
                    WFRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WFRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WFRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WFRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Overwrite mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WFRW::VALUE1)
            }
            #[doc = "Wait-for-read mode enabled for this register"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WFRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRGEN`"]
        pub enum SRGENW {
            #[doc = "No service request"]
            VALUE1,
            #[doc = "Service request after a result event"]
            VALUE2,
        }
        impl SRGENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRGENW::VALUE1 => false,
                    SRGENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRGENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRGENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRGENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No service request"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRGENW::VALUE1)
            }
            #[doc = "Service request after a result event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRGENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 16:19 - Data Reduction Control"]
            #[inline]
            pub fn drctr(&self) -> DRCTRR {
                DRCTRR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 24 - Wait-for-Read Mode Enable"]
            #[inline]
            pub fn wfr(&self) -> WFRR {
                WFRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Service Request Generation Enable"]
            #[inline]
            pub fn srgen(&self) -> SRGENR {
                SRGENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 16:19 - Data Reduction Control"]
            #[inline]
            pub fn drctr(&mut self) -> _DRCTRW {
                _DRCTRW { w: self }
            }
            #[doc = "Bit 24 - Wait-for-Read Mode Enable"]
            #[inline]
            pub fn wfr(&mut self) -> _WFRW {
                _WFRW { w: self }
            }
            #[doc = "Bit 31 - Service Request Generation Enable"]
            #[inline]
            pub fn srgen(&mut self) -> _SRGENW {
                _SRGENW { w: self }
            }
        }
    }
    #[doc = "Global Result Register"]
    pub struct GLOBRES {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Result Register"]
    pub mod globres {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBRES {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct GNRR {
            bits: u8,
        }
        impl GNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CHNRR {
            bits: u8,
        }
        impl CHNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXR {
            bits: u8,
        }
        impl EMUXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CRSR {
            bits: u8,
        }
        impl CRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCRR {
            #[doc = "Signal level was below compare value"]
            VALUE1,
            #[doc = "Signal level was above compare value"]
            VALUE2,
        }
        impl FCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCRR::VALUE1 => false,
                    FCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCRR {
                match value {
                    false => FCRR::VALUE1,
                    true => FCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VFR {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Bitfield RESULT contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and the data reduction counter (overrides a hardware set action)"]
            VALUE2,
        }
        impl VFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VFR::VALUE1 => false,
                    VFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VFR {
                match value {
                    false => VFR::VALUE1,
                    true => VFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VFR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESULTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESULTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF`"]
        pub enum VFW {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Bitfield RESULT contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and the data reduction counter (overrides a hardware set action)"]
            VALUE2,
        }
        impl VFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VFW::VALUE1 => false,
                    VFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VFW::VALUE1)
            }
            #[doc = "Read access: Bitfield RESULT contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and the data reduction counter (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Result of most recent conversion"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
            #[doc = "Bits 16:19 - Group Number"]
            #[inline]
            pub fn gnr(&self) -> GNRR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GNRR { bits }
            }
            #[doc = "Bits 20:24 - Channel Number"]
            #[inline]
            pub fn chnr(&self) -> CHNRR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CHNRR { bits }
            }
            #[doc = "Bits 25:27 - External Multiplexer Setting"]
            #[inline]
            pub fn emux(&self) -> EMUXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXR { bits }
            }
            #[doc = "Bits 28:29 - Converted Request Source"]
            #[inline]
            pub fn crs(&self) -> CRSR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CRSR { bits }
            }
            #[doc = "Bit 30 - Fast Compare Result"]
            #[inline]
            pub fn fcr(&self) -> FCRR {
                FCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Valid Flag"]
            #[inline]
            pub fn vf(&self) -> VFR {
                VFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Result of most recent conversion"]
            #[inline]
            pub fn result(&mut self) -> _RESULTW {
                _RESULTW { w: self }
            }
            #[doc = "Bit 31 - Valid Flag"]
            #[inline]
            pub fn vf(&mut self) -> _VFW {
                _VFW { w: self }
            }
        }
    }
    #[doc = "Global Result Register, Debug"]
    pub struct GLOBRESD {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Result Register, Debug"]
    pub mod globresd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLOBRESD {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct GNRR {
            bits: u8,
        }
        impl GNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CHNRR {
            bits: u8,
        }
        impl CHNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXR {
            bits: u8,
        }
        impl EMUXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CRSR {
            bits: u8,
        }
        impl CRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCRR {
            #[doc = "Signal level was below compare value"]
            VALUE1,
            #[doc = "Signal level was above compare value"]
            VALUE2,
        }
        impl FCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCRR::VALUE1 => false,
                    FCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCRR {
                match value {
                    false => FCRR::VALUE1,
                    true => FCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VFR {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Bitfield RESULT contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and the data reduction counter (overrides a hardware set action)"]
            VALUE2,
        }
        impl VFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VFR::VALUE1 => false,
                    VFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VFR {
                match value {
                    false => VFR::VALUE1,
                    true => VFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VFR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESULTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESULTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF`"]
        pub enum VFW {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Bitfield RESULT contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and the data reduction counter (overrides a hardware set action)"]
            VALUE2,
        }
        impl VFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VFW::VALUE1 => false,
                    VFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VFW::VALUE1)
            }
            #[doc = "Read access: Bitfield RESULT contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and the data reduction counter (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Result of most recent conversion"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
            #[doc = "Bits 16:19 - Group Number"]
            #[inline]
            pub fn gnr(&self) -> GNRR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GNRR { bits }
            }
            #[doc = "Bits 20:24 - Channel Number"]
            #[inline]
            pub fn chnr(&self) -> CHNRR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CHNRR { bits }
            }
            #[doc = "Bits 25:27 - External Multiplexer Setting"]
            #[inline]
            pub fn emux(&self) -> EMUXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXR { bits }
            }
            #[doc = "Bits 28:29 - Converted Request Source"]
            #[inline]
            pub fn crs(&self) -> CRSR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CRSR { bits }
            }
            #[doc = "Bit 30 - Fast Compare Result"]
            #[inline]
            pub fn fcr(&self) -> FCRR {
                FCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Valid Flag"]
            #[inline]
            pub fn vf(&self) -> VFR {
                VFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Result of most recent conversion"]
            #[inline]
            pub fn result(&mut self) -> _RESULTW {
                _RESULTW { w: self }
            }
            #[doc = "Bit 31 - Valid Flag"]
            #[inline]
            pub fn vf(&mut self) -> _VFW {
                _VFW { w: self }
            }
        }
    }
    #[doc = "External Multiplexer Select Register"]
    pub struct EMUXSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "External Multiplexer Select Register"]
    pub mod emuxsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EMUXSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXGRP0R {
            bits: u8,
        }
        impl EMUXGRP0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXGRP1R {
            bits: u8,
        }
        impl EMUXGRP1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMUXGRP0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMUXGRP0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMUXGRP1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMUXGRP1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - External Multiplexer Group for Interface x"]
            #[inline]
            pub fn emuxgrp0(&self) -> EMUXGRP0R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXGRP0R { bits }
            }
            #[doc = "Bits 4:7 - External Multiplexer Group for Interface x"]
            #[inline]
            pub fn emuxgrp1(&self) -> EMUXGRP1R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXGRP1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - External Multiplexer Group for Interface x"]
            #[inline]
            pub fn emuxgrp0(&mut self) -> _EMUXGRP0W {
                _EMUXGRP0W { w: self }
            }
            #[doc = "Bits 4:7 - External Multiplexer Group for Interface x"]
            #[inline]
            pub fn emuxgrp1(&mut self) -> _EMUXGRP1W {
                _EMUXGRP1W { w: self }
            }
        }
    }
}
#[doc = "Analog to Digital Converter"]
pub struct VADC {
    register_block: vadc::RegisterBlock,
}
impl Deref for VADC {
    type Target = vadc::RegisterBlock;
    fn deref(&self) -> &vadc::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Analog to Digital Converter"]
pub const VADC_G0: Peripheral<VADC_G0> = unsafe { Peripheral::new(0x4000_4400) };
#[doc = "Analog to Digital Converter"]
pub mod vadc_g0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        _reserved0: [u8; 128usize],
        #[doc = "0x80 - Arbitration Configuration Register"]
        pub arbcfg: ARBCFG,
        #[doc = "0x84 - Arbitration Priority Register"]
        pub arbpr: ARBPR,
        #[doc = "0x88 - Channel Assignment Register"]
        pub chass: CHASS,
        _reserved1: [u8; 20usize],
        #[doc = "0xa0 - Input Class Register"]
        pub iclass: [ICLASS; 2],
        _reserved2: [u8; 8usize],
        #[doc = "0xb0 - Alias Register"]
        pub alias: ALIAS,
        _reserved3: [u8; 4usize],
        #[doc = "0xb8 - Boundary Select Register"]
        pub bound: BOUND,
        _reserved4: [u8; 4usize],
        #[doc = "0xc0 - Synchronization Control Register"]
        pub synctr: SYNCTR,
        _reserved5: [u8; 4usize],
        #[doc = "0xc8 - Boundary Flag Register"]
        pub bfl: BFL,
        #[doc = "0xcc - Boundary Flag Software Register"]
        pub bfls: BFLS,
        #[doc = "0xd0 - Boundary Flag Control Register"]
        pub bflc: BFLC,
        #[doc = "0xd4 - Boundary Flag Node Pointer Register"]
        pub bflnp: BFLNP,
        _reserved6: [u8; 40usize],
        #[doc = "0x100 - Queue 0 Source Control Register"]
        pub qctrl0: QCTRL0,
        #[doc = "0x104 - Queue 0 Mode Register"]
        pub qmr0: QMR0,
        #[doc = "0x108 - Queue 0 Status Register"]
        pub qsr0: QSR0,
        #[doc = "0x10c - Queue 0 Register 0"]
        pub q0r0: Q0R0,
        #[doc = "0x110 - Queue 0 Input Register"]
        pub qinr0: QINR0,
        _reserved7: [u8; 12usize],
        #[doc = "0x120 - Autoscan Source Control Register"]
        pub asctrl: ASCTRL,
        #[doc = "0x124 - Autoscan Source Mode Register"]
        pub asmr: ASMR,
        #[doc = "0x128 - Autoscan Source Channel Select Register"]
        pub assel: ASSEL,
        #[doc = "0x12c - Autoscan Source Pending Register"]
        pub aspnd: ASPND,
        _reserved8: [u8; 80usize],
        #[doc = "0x180 - Channel Event Flag Register"]
        pub ceflag: CEFLAG,
        #[doc = "0x184 - Result Event Flag Register"]
        pub reflag: REFLAG,
        #[doc = "0x188 - Source Event Flag Register"]
        pub seflag: SEFLAG,
        _reserved9: [u8; 4usize],
        #[doc = "0x190 - Channel Event Flag Clear Register"]
        pub cefclr: CEFCLR,
        #[doc = "0x194 - Result Event Flag Clear Register"]
        pub refclr: REFCLR,
        #[doc = "0x198 - Source Event Flag Clear Register"]
        pub sefclr: SEFCLR,
        _reserved10: [u8; 4usize],
        #[doc = "0x1a0 - Channel Event Node Pointer Register 0"]
        pub cevnp0: CEVNP0,
        _reserved11: [u8; 12usize],
        #[doc = "0x1b0 - Result Event Node Pointer Register 0"]
        pub revnp0: REVNP0,
        #[doc = "0x1b4 - Result Event Node Pointer Register 1"]
        pub revnp1: REVNP1,
        _reserved12: [u8; 8usize],
        #[doc = "0x1c0 - Source Event Node Pointer Register"]
        pub sevnp: SEVNP,
        _reserved13: [u8; 4usize],
        #[doc = "0x1c8 - Service Request Software Activation Trigger"]
        pub sract: SRACT,
        _reserved14: [u8; 36usize],
        #[doc = "0x1f0 - External Multiplexer Control Register"]
        pub emuxctr: EMUXCTR,
        _reserved15: [u8; 4usize],
        #[doc = "0x1f8 - Valid Flag Register"]
        pub vfr: VFR,
        _reserved16: [u8; 4usize],
        #[doc = "0x200 - Channel Ctrl. Reg."]
        pub chctr: [CHCTR; 8],
        _reserved17: [u8; 96usize],
        #[doc = "0x280 - Result Control Register"]
        pub rcr: [RCR; 16],
        _reserved18: [u8; 64usize],
        #[doc = "0x300 - Result Register"]
        pub res: [RES; 16],
        _reserved19: [u8; 64usize],
        #[doc = "0x380 - Result Register, Debug"]
        pub resd: [RESD; 16],
    }
    #[doc = "Arbitration Configuration Register"]
    pub struct ARBCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Arbitration Configuration Register"]
    pub mod arbcfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ARBCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ANONCR {
            bits: u8,
        }
        impl ANONCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ARBRND`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARBRNDR {
            #[doc = "4 arbitration slots per round (tARB = 4 / fADCD)"]
            VALUE1,
            #[doc = "8 arbitration slots per round (tARB = 8 / fADCD)"]
            VALUE2,
            #[doc = "16 arbitration slots per round (tARB = 16 / fADCD)"]
            VALUE3,
            #[doc = "20 arbitration slots per round (tARB = 20 / fADCD)"]
            VALUE4,
        }
        impl ARBRNDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ARBRNDR::VALUE1 => 0,
                    ARBRNDR::VALUE2 => 0x01,
                    ARBRNDR::VALUE3 => 0x02,
                    ARBRNDR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ARBRNDR {
                match value {
                    0 => ARBRNDR::VALUE1,
                    1 => ARBRNDR::VALUE2,
                    2 => ARBRNDR::VALUE3,
                    3 => ARBRNDR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARBRNDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARBRNDR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ARBRNDR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ARBRNDR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ARBM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ARBMR {
            #[doc = "The arbiter runs permanently. This setting is required for a synchronization slave (see ) and for equidistant sampling using the signal ARBCNT (see )."]
            VALUE1,
            #[doc = "The arbiter only runs if at least one conversion request of an enabled request source is pending. This setting ensures a reproducible latency from an incoming request to the conversion start, if the converter is idle. Synchronized conversions are not supported."]
            VALUE2,
        }
        impl ARBMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ARBMR::VALUE1 => false,
                    ARBMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ARBMR {
                match value {
                    false => ARBMR::VALUE1,
                    true => ARBMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ARBMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ARBMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ANONS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ANONSR {
            #[doc = "Analog converter off"]
            VALUE1,
            #[doc = "Normal operation (permanently on)"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ANONSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ANONSR::VALUE1 => 0,
                    ANONSR::VALUE4 => 0x03,
                    ANONSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ANONSR {
                match value {
                    0 => ANONSR::VALUE1,
                    3 => ANONSR::VALUE4,
                    i => ANONSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ANONSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ANONSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CALR {
            #[doc = "Completed or not yet started"]
            VALUE1,
            #[doc = "Start-up calibration phase is active"]
            VALUE2,
        }
        impl CALR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CALR::VALUE1 => false,
                    CALR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CALR {
                match value {
                    false => CALR::VALUE1,
                    true => CALR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CALR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BUSY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BUSYR {
            #[doc = "Not busy"]
            VALUE1,
            #[doc = "Converter is busy with a conversion"]
            VALUE2,
        }
        impl BUSYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BUSYR::VALUE1 => false,
                    BUSYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BUSYR {
                match value {
                    false => BUSYR::VALUE1,
                    true => BUSYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BUSYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BUSYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SAMPLE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SAMPLER {
            #[doc = "Converting or idle"]
            VALUE1,
            #[doc = "Input signal is currently sampled"]
            VALUE2,
        }
        impl SAMPLER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SAMPLER::VALUE1 => false,
                    SAMPLER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SAMPLER {
                match value {
                    false => SAMPLER::VALUE1,
                    true => SAMPLER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SAMPLER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SAMPLER::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _ANONCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ANONCW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARBRND`"]
        pub enum ARBRNDW {
            #[doc = "4 arbitration slots per round (tARB = 4 / fADCD)"]
            VALUE1,
            #[doc = "8 arbitration slots per round (tARB = 8 / fADCD)"]
            VALUE2,
            #[doc = "16 arbitration slots per round (tARB = 16 / fADCD)"]
            VALUE3,
            #[doc = "20 arbitration slots per round (tARB = 20 / fADCD)"]
            VALUE4,
        }
        impl ARBRNDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ARBRNDW::VALUE1 => 0,
                    ARBRNDW::VALUE2 => 1,
                    ARBRNDW::VALUE3 => 2,
                    ARBRNDW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARBRNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARBRNDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARBRNDW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "4 arbitration slots per round (tARB = 4 / fADCD)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARBRNDW::VALUE1)
            }
            #[doc = "8 arbitration slots per round (tARB = 8 / fADCD)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARBRNDW::VALUE2)
            }
            #[doc = "16 arbitration slots per round (tARB = 16 / fADCD)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ARBRNDW::VALUE3)
            }
            #[doc = "20 arbitration slots per round (tARB = 20 / fADCD)"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ARBRNDW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ARBM`"]
        pub enum ARBMW {
            #[doc = "The arbiter runs permanently. This setting is required for a synchronization slave (see ) and for equidistant sampling using the signal ARBCNT (see )."]
            VALUE1,
            #[doc = "The arbiter only runs if at least one conversion request of an enabled request source is pending. This setting ensures a reproducible latency from an incoming request to the conversion start, if the converter is idle. Synchronized conversions are not supported."]
            VALUE2,
        }
        impl ARBMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ARBMW::VALUE1 => false,
                    ARBMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ARBMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ARBMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ARBMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The arbiter runs permanently. This setting is required for a synchronization slave (see ) and for equidistant sampling using the signal ARBCNT (see )."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ARBMW::VALUE1)
            }
            #[doc = "The arbiter only runs if at least one conversion request of an enabled request source is pending. This setting ensures a reproducible latency from an incoming request to the conversion start, if the converter is idle. Synchronized conversions are not supported."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ARBMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Analog Converter Control"]
            #[inline]
            pub fn anonc(&self) -> ANONCR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ANONCR { bits }
            }
            #[doc = "Bits 4:5 - Arbitration Round Length"]
            #[inline]
            pub fn arbrnd(&self) -> ARBRNDR {
                ARBRNDR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 7 - Arbitration Mode"]
            #[inline]
            pub fn arbm(&self) -> ARBMR {
                ARBMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:17 - Analog Converter Control Status"]
            #[inline]
            pub fn anons(&self) -> ANONSR {
                ANONSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 28 - Start-Up Calibration Active Indication"]
            #[inline]
            pub fn cal(&self) -> CALR {
                CALR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Converter Busy Flag"]
            #[inline]
            pub fn busy(&self) -> BUSYR {
                BUSYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Sample Phase Flag"]
            #[inline]
            pub fn sample(&self) -> SAMPLER {
                SAMPLER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Analog Converter Control"]
            #[inline]
            pub fn anonc(&mut self) -> _ANONCW {
                _ANONCW { w: self }
            }
            #[doc = "Bits 4:5 - Arbitration Round Length"]
            #[inline]
            pub fn arbrnd(&mut self) -> _ARBRNDW {
                _ARBRNDW { w: self }
            }
            #[doc = "Bit 7 - Arbitration Mode"]
            #[inline]
            pub fn arbm(&mut self) -> _ARBMW {
                _ARBMW { w: self }
            }
        }
    }
    #[doc = "Arbitration Priority Register"]
    pub struct ARBPR {
        register: VolatileCell<u32>,
    }
    #[doc = "Arbitration Priority Register"]
    pub mod arbpr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ARBPR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PRIO0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRIO0R {
            #[doc = "Lowest priority is selected."]
            VALUE1,
            #[doc = "Highest priority is selected."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PRIO0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PRIO0R::VALUE1 => 0,
                    PRIO0R::VALUE2 => 0x03,
                    PRIO0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PRIO0R {
                match value {
                    0 => PRIO0R::VALUE1,
                    3 => PRIO0R::VALUE2,
                    i => PRIO0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRIO0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRIO0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRIO1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRIO1R {
            #[doc = "Lowest priority is selected."]
            VALUE1,
            #[doc = "Highest priority is selected."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PRIO1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PRIO1R::VALUE1 => 0,
                    PRIO1R::VALUE2 => 0x03,
                    PRIO1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PRIO1R {
                match value {
                    0 => PRIO1R::VALUE1,
                    3 => PRIO1R::VALUE2,
                    i => PRIO1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRIO1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRIO1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRIO2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRIO2R {
            #[doc = "Lowest priority is selected."]
            VALUE1,
            #[doc = "Highest priority is selected."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PRIO2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PRIO2R::VALUE1 => 0,
                    PRIO2R::VALUE2 => 0x03,
                    PRIO2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PRIO2R {
                match value {
                    0 => PRIO2R::VALUE1,
                    3 => PRIO2R::VALUE2,
                    i => PRIO2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRIO2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRIO2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CSM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CSM0R {
            #[doc = "Wait-for-start mode"]
            VALUE1,
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            VALUE2,
        }
        impl CSM0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CSM0R::VALUE1 => false,
                    CSM0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CSM0R {
                match value {
                    false => CSM0R::VALUE1,
                    true => CSM0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CSM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CSM0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CSM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CSM1R {
            #[doc = "Wait-for-start mode"]
            VALUE1,
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            VALUE2,
        }
        impl CSM1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CSM1R::VALUE1 => false,
                    CSM1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CSM1R {
                match value {
                    false => CSM1R::VALUE1,
                    true => CSM1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CSM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CSM1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CSM2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CSM2R {
            #[doc = "Wait-for-start mode"]
            VALUE1,
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            VALUE2,
        }
        impl CSM2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CSM2R::VALUE1 => false,
                    CSM2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CSM2R {
                match value {
                    false => CSM2R::VALUE1,
                    true => CSM2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CSM2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CSM2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASEN0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASEN0R {
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            VALUE1,
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            VALUE2,
        }
        impl ASEN0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASEN0R::VALUE1 => false,
                    ASEN0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASEN0R {
                match value {
                    false => ASEN0R::VALUE1,
                    true => ASEN0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASEN0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASEN0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASEN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASEN1R {
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            VALUE1,
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            VALUE2,
        }
        impl ASEN1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASEN1R::VALUE1 => false,
                    ASEN1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASEN1R {
                match value {
                    false => ASEN1R::VALUE1,
                    true => ASEN1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASEN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASEN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASEN2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASEN2R {
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            VALUE1,
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            VALUE2,
        }
        impl ASEN2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASEN2R::VALUE1 => false,
                    ASEN2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASEN2R {
                match value {
                    false => ASEN2R::VALUE1,
                    true => ASEN2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASEN2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASEN2R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PRIO0`"]
        pub enum PRIO0W {
            #[doc = "Lowest priority is selected."]
            VALUE1,
            #[doc = "Highest priority is selected."]
            VALUE2,
        }
        impl PRIO0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PRIO0W::VALUE1 => 0,
                    PRIO0W::VALUE2 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRIO0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRIO0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRIO0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Lowest priority is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRIO0W::VALUE1)
            }
            #[doc = "Highest priority is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRIO0W::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PRIO1`"]
        pub enum PRIO1W {
            #[doc = "Lowest priority is selected."]
            VALUE1,
            #[doc = "Highest priority is selected."]
            VALUE2,
        }
        impl PRIO1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PRIO1W::VALUE1 => 0,
                    PRIO1W::VALUE2 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRIO1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRIO1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRIO1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Lowest priority is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRIO1W::VALUE1)
            }
            #[doc = "Highest priority is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRIO1W::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PRIO2`"]
        pub enum PRIO2W {
            #[doc = "Lowest priority is selected."]
            VALUE1,
            #[doc = "Highest priority is selected."]
            VALUE2,
        }
        impl PRIO2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PRIO2W::VALUE1 => 0,
                    PRIO2W::VALUE2 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRIO2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRIO2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRIO2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Lowest priority is selected."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRIO2W::VALUE1)
            }
            #[doc = "Highest priority is selected."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRIO2W::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CSM0`"]
        pub enum CSM0W {
            #[doc = "Wait-for-start mode"]
            VALUE1,
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            VALUE2,
        }
        impl CSM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CSM0W::VALUE1 => false,
                    CSM0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSM0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wait-for-start mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSM0W::VALUE1)
            }
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSM0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CSM1`"]
        pub enum CSM1W {
            #[doc = "Wait-for-start mode"]
            VALUE1,
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            VALUE2,
        }
        impl CSM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CSM1W::VALUE1 => false,
                    CSM1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSM1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wait-for-start mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSM1W::VALUE1)
            }
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSM1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CSM2`"]
        pub enum CSM2W {
            #[doc = "Wait-for-start mode"]
            VALUE1,
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            VALUE2,
        }
        impl CSM2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CSM2W::VALUE1 => false,
                    CSM2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSM2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSM2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSM2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wait-for-start mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSM2W::VALUE1)
            }
            #[doc = "Cancel-inject-repeat mode, i.e. this source can cancel conversion of other sources."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSM2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASEN0`"]
        pub enum ASEN0W {
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            VALUE1,
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            VALUE2,
        }
        impl ASEN0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASEN0W::VALUE1 => false,
                    ASEN0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASEN0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASEN0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASEN0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASEN0W::VALUE1)
            }
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASEN0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASEN1`"]
        pub enum ASEN1W {
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            VALUE1,
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            VALUE2,
        }
        impl ASEN1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASEN1W::VALUE1 => false,
                    ASEN1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASEN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASEN1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASEN1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASEN1W::VALUE1)
            }
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASEN1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASEN2`"]
        pub enum ASEN2W {
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            VALUE1,
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            VALUE2,
        }
        impl ASEN2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASEN2W::VALUE1 => false,
                    ASEN2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASEN2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASEN2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASEN2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The corresponding arbitration slot is disabled and considered as empty. Pending conversion requests from the associated request source are disregarded."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASEN2W::VALUE1)
            }
            #[doc = "The corresponding arbitration slot is enabled. Pending conversion requests from the associated request source are arbitrated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASEN2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Priority of Request Source x"]
            #[inline]
            pub fn prio0(&self) -> PRIO0R {
                PRIO0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Priority of Request Source x"]
            #[inline]
            pub fn prio1(&self) -> PRIO1R {
                PRIO1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Priority of Request Source x"]
            #[inline]
            pub fn prio2(&self) -> PRIO2R {
                PRIO2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Conversion Start Mode of Request Source x"]
            #[inline]
            pub fn csm0(&self) -> CSM0R {
                CSM0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Conversion Start Mode of Request Source x"]
            #[inline]
            pub fn csm1(&self) -> CSM1R {
                CSM1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Conversion Start Mode of Request Source x"]
            #[inline]
            pub fn csm2(&self) -> CSM2R {
                CSM2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Arbitration Slot 0 Enable"]
            #[inline]
            pub fn asen0(&self) -> ASEN0R {
                ASEN0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Arbitration Slot 1 Enable"]
            #[inline]
            pub fn asen1(&self) -> ASEN1R {
                ASEN1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Arbitration Slot 2 Enable"]
            #[inline]
            pub fn asen2(&self) -> ASEN2R {
                ASEN2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Priority of Request Source x"]
            #[inline]
            pub fn prio0(&mut self) -> _PRIO0W {
                _PRIO0W { w: self }
            }
            #[doc = "Bits 4:5 - Priority of Request Source x"]
            #[inline]
            pub fn prio1(&mut self) -> _PRIO1W {
                _PRIO1W { w: self }
            }
            #[doc = "Bits 8:9 - Priority of Request Source x"]
            #[inline]
            pub fn prio2(&mut self) -> _PRIO2W {
                _PRIO2W { w: self }
            }
            #[doc = "Bit 3 - Conversion Start Mode of Request Source x"]
            #[inline]
            pub fn csm0(&mut self) -> _CSM0W {
                _CSM0W { w: self }
            }
            #[doc = "Bit 7 - Conversion Start Mode of Request Source x"]
            #[inline]
            pub fn csm1(&mut self) -> _CSM1W {
                _CSM1W { w: self }
            }
            #[doc = "Bit 11 - Conversion Start Mode of Request Source x"]
            #[inline]
            pub fn csm2(&mut self) -> _CSM2W {
                _CSM2W { w: self }
            }
            #[doc = "Bit 24 - Arbitration Slot 0 Enable"]
            #[inline]
            pub fn asen0(&mut self) -> _ASEN0W {
                _ASEN0W { w: self }
            }
            #[doc = "Bit 25 - Arbitration Slot 1 Enable"]
            #[inline]
            pub fn asen1(&mut self) -> _ASEN1W {
                _ASEN1W { w: self }
            }
            #[doc = "Bit 26 - Arbitration Slot 2 Enable"]
            #[inline]
            pub fn asen2(&mut self) -> _ASEN2W {
                _ASEN2W { w: self }
            }
        }
    }
    #[doc = "Channel Assignment Register"]
    pub struct CHASS {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Assignment Register"]
    pub mod chass {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CHASS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ASSCH0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH0R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH0R::VALUE1 => false,
                    ASSCH0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH0R {
                match value {
                    false => ASSCH0R::VALUE1,
                    true => ASSCH0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH1R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH1R::VALUE1 => false,
                    ASSCH1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH1R {
                match value {
                    false => ASSCH1R::VALUE1,
                    true => ASSCH1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH2R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH2R::VALUE1 => false,
                    ASSCH2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH2R {
                match value {
                    false => ASSCH2R::VALUE1,
                    true => ASSCH2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH3R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH3R::VALUE1 => false,
                    ASSCH3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH3R {
                match value {
                    false => ASSCH3R::VALUE1,
                    true => ASSCH3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH4R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH4R::VALUE1 => false,
                    ASSCH4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH4R {
                match value {
                    false => ASSCH4R::VALUE1,
                    true => ASSCH4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH5R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH5R::VALUE1 => false,
                    ASSCH5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH5R {
                match value {
                    false => ASSCH5R::VALUE1,
                    true => ASSCH5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH6R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH6R::VALUE1 => false,
                    ASSCH6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH6R {
                match value {
                    false => ASSCH6R::VALUE1,
                    true => ASSCH6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `ASSCH7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASSCH7R {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASSCH7R::VALUE1 => false,
                    ASSCH7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASSCH7R {
                match value {
                    false => ASSCH7R::VALUE1,
                    true => ASSCH7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASSCH7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASSCH7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ASSCH0`"]
        pub enum ASSCH0W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH0W::VALUE1 => false,
                    ASSCH0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH0W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH1`"]
        pub enum ASSCH1W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH1W::VALUE1 => false,
                    ASSCH1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH1W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH2`"]
        pub enum ASSCH2W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH2W::VALUE1 => false,
                    ASSCH2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH2W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH3`"]
        pub enum ASSCH3W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH3W::VALUE1 => false,
                    ASSCH3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH3W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH4`"]
        pub enum ASSCH4W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH4W::VALUE1 => false,
                    ASSCH4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH4W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH5`"]
        pub enum ASSCH5W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH5W::VALUE1 => false,
                    ASSCH5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH5W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH6`"]
        pub enum ASSCH6W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH6W::VALUE1 => false,
                    ASSCH6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH6W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSCH7`"]
        pub enum ASSCH7W {
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            VALUE1,
            #[doc = "Channel y is a priority channel within group x"]
            VALUE2,
        }
        impl ASSCH7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSCH7W::VALUE1 => false,
                    ASSCH7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSCH7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSCH7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSCH7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Channel y can be a background channel converted with lowest priority"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSCH7W::VALUE1)
            }
            #[doc = "Channel y is a priority channel within group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSCH7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Assignment for Channel 0"]
            #[inline]
            pub fn assch0(&self) -> ASSCH0R {
                ASSCH0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Assignment for Channel 1"]
            #[inline]
            pub fn assch1(&self) -> ASSCH1R {
                ASSCH1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Assignment for Channel 2"]
            #[inline]
            pub fn assch2(&self) -> ASSCH2R {
                ASSCH2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Assignment for Channel 3"]
            #[inline]
            pub fn assch3(&self) -> ASSCH3R {
                ASSCH3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Assignment for Channel 4"]
            #[inline]
            pub fn assch4(&self) -> ASSCH4R {
                ASSCH4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Assignment for Channel 5"]
            #[inline]
            pub fn assch5(&self) -> ASSCH5R {
                ASSCH5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Assignment for Channel 6"]
            #[inline]
            pub fn assch6(&self) -> ASSCH6R {
                ASSCH6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Assignment for Channel 7"]
            #[inline]
            pub fn assch7(&self) -> ASSCH7R {
                ASSCH7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Assignment for Channel 0"]
            #[inline]
            pub fn assch0(&mut self) -> _ASSCH0W {
                _ASSCH0W { w: self }
            }
            #[doc = "Bit 1 - Assignment for Channel 1"]
            #[inline]
            pub fn assch1(&mut self) -> _ASSCH1W {
                _ASSCH1W { w: self }
            }
            #[doc = "Bit 2 - Assignment for Channel 2"]
            #[inline]
            pub fn assch2(&mut self) -> _ASSCH2W {
                _ASSCH2W { w: self }
            }
            #[doc = "Bit 3 - Assignment for Channel 3"]
            #[inline]
            pub fn assch3(&mut self) -> _ASSCH3W {
                _ASSCH3W { w: self }
            }
            #[doc = "Bit 4 - Assignment for Channel 4"]
            #[inline]
            pub fn assch4(&mut self) -> _ASSCH4W {
                _ASSCH4W { w: self }
            }
            #[doc = "Bit 5 - Assignment for Channel 5"]
            #[inline]
            pub fn assch5(&mut self) -> _ASSCH5W {
                _ASSCH5W { w: self }
            }
            #[doc = "Bit 6 - Assignment for Channel 6"]
            #[inline]
            pub fn assch6(&mut self) -> _ASSCH6W {
                _ASSCH6W { w: self }
            }
            #[doc = "Bit 7 - Assignment for Channel 7"]
            #[inline]
            pub fn assch7(&mut self) -> _ASSCH7W {
                _ASSCH7W { w: self }
            }
        }
    }
    #[doc = "Input Class Register"]
    pub struct ICLASS {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Class Register"]
    pub mod iclass {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ICLASS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct STCSR {
            bits: u8,
        }
        impl STCSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CMS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMSR {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CMSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMSR::VALUE1 => 0,
                    CMSR::VALUE2 => 0x01,
                    CMSR::VALUE3 => 0x02,
                    CMSR::VALUE6 => 0x05,
                    CMSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMSR {
                match value {
                    0 => CMSR::VALUE1,
                    1 => CMSR::VALUE2,
                    2 => CMSR::VALUE3,
                    5 => CMSR::VALUE6,
                    i => CMSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == CMSR::VALUE6
            }
        }
        #[doc = r" Value of the field"]
        pub struct STCER {
            bits: u8,
        }
        impl STCER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMER {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CMER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMER::VALUE1 => 0,
                    CMER::VALUE2 => 0x01,
                    CMER::VALUE3 => 0x02,
                    CMER::VALUE6 => 0x05,
                    CMER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMER {
                match value {
                    0 => CMER::VALUE1,
                    1 => CMER::VALUE2,
                    2 => CMER::VALUE3,
                    5 => CMER::VALUE6,
                    i => CMER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == CMER::VALUE6
            }
        }
        #[doc = r" Proxy"]
        pub struct _STCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STCSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMS`"]
        pub enum CMSW {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
        }
        impl CMSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMSW::VALUE1 => 0,
                    CMSW::VALUE2 => 1,
                    CMSW::VALUE3 => 2,
                    CMSW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "12-bit conversion"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMSW::VALUE1)
            }
            #[doc = "10-bit conversion"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMSW::VALUE2)
            }
            #[doc = "8-bit conversion"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMSW::VALUE3)
            }
            #[doc = "10-bit fast compare mode"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(CMSW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STCEW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CME`"]
        pub enum CMEW {
            #[doc = "12-bit conversion"]
            VALUE1,
            #[doc = "10-bit conversion"]
            VALUE2,
            #[doc = "8-bit conversion"]
            VALUE3,
            #[doc = "10-bit fast compare mode"]
            VALUE6,
        }
        impl CMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMEW::VALUE1 => 0,
                    CMEW::VALUE2 => 1,
                    CMEW::VALUE3 => 2,
                    CMEW::VALUE6 => 5,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "12-bit conversion"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMEW::VALUE1)
            }
            #[doc = "10-bit conversion"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMEW::VALUE2)
            }
            #[doc = "8-bit conversion"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMEW::VALUE3)
            }
            #[doc = "10-bit fast compare mode"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(CMEW::VALUE6)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Sample Time Control for Standard Conversions"]
            #[inline]
            pub fn stcs(&self) -> STCSR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STCSR { bits }
            }
            #[doc = "Bits 8:10 - Conversion Mode for Standard Conversions"]
            #[inline]
            pub fn cms(&self) -> CMSR {
                CMSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:20 - Sample Time Control for EMUX Conversions"]
            #[inline]
            pub fn stce(&self) -> STCER {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STCER { bits }
            }
            #[doc = "Bits 24:26 - Conversion Mode for EMUX Conversions"]
            #[inline]
            pub fn cme(&self) -> CMER {
                CMER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Sample Time Control for Standard Conversions"]
            #[inline]
            pub fn stcs(&mut self) -> _STCSW {
                _STCSW { w: self }
            }
            #[doc = "Bits 8:10 - Conversion Mode for Standard Conversions"]
            #[inline]
            pub fn cms(&mut self) -> _CMSW {
                _CMSW { w: self }
            }
            #[doc = "Bits 16:20 - Sample Time Control for EMUX Conversions"]
            #[inline]
            pub fn stce(&mut self) -> _STCEW {
                _STCEW { w: self }
            }
            #[doc = "Bits 24:26 - Conversion Mode for EMUX Conversions"]
            #[inline]
            pub fn cme(&mut self) -> _CMEW {
                _CMEW { w: self }
            }
        }
    }
    #[doc = "Alias Register"]
    pub struct ALIAS {
        register: VolatileCell<u32>,
    }
    #[doc = "Alias Register"]
    pub mod alias {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ALIAS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct ALIAS0R {
            bits: u8,
        }
        impl ALIAS0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct ALIAS1R {
            bits: u8,
        }
        impl ALIAS1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALIAS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALIAS0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ALIAS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ALIAS1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Alias Value for CH0 Conversion Requests"]
            #[inline]
            pub fn alias0(&self) -> ALIAS0R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ALIAS0R { bits }
            }
            #[doc = "Bits 8:12 - Alias Value for CH1 Conversion Requests"]
            #[inline]
            pub fn alias1(&self) -> ALIAS1R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ALIAS1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0100 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Alias Value for CH0 Conversion Requests"]
            #[inline]
            pub fn alias0(&mut self) -> _ALIAS0W {
                _ALIAS0W { w: self }
            }
            #[doc = "Bits 8:12 - Alias Value for CH1 Conversion Requests"]
            #[inline]
            pub fn alias1(&mut self) -> _ALIAS1W {
                _ALIAS1W { w: self }
            }
        }
    }
    #[doc = "Boundary Select Register"]
    pub struct BOUND {
        register: VolatileCell<u32>,
    }
    #[doc = "Boundary Select Register"]
    pub mod bound {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BOUND {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BOUNDARY0R {
            bits: u16,
        }
        impl BOUNDARY0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct BOUNDARY1R {
            bits: u16,
        }
        impl BOUNDARY1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _BOUNDARY0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BOUNDARY0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _BOUNDARY1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BOUNDARY1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:11 - Boundary Value 0 for Limit Checking"]
            #[inline]
            pub fn boundary0(&self) -> BOUNDARY0R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BOUNDARY0R { bits }
            }
            #[doc = "Bits 16:27 - Boundary Value 1 for Limit Checking"]
            #[inline]
            pub fn boundary1(&self) -> BOUNDARY1R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BOUNDARY1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:11 - Boundary Value 0 for Limit Checking"]
            #[inline]
            pub fn boundary0(&mut self) -> _BOUNDARY0W {
                _BOUNDARY0W { w: self }
            }
            #[doc = "Bits 16:27 - Boundary Value 1 for Limit Checking"]
            #[inline]
            pub fn boundary1(&mut self) -> _BOUNDARY1W {
                _BOUNDARY1W { w: self }
            }
        }
    }
    #[doc = "Synchronization Control Register"]
    pub struct SYNCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Synchronization Control Register"]
    pub mod synctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SYNCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `STSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STSELR {
            #[doc = "Kernel is synchronization master: Use own bitfield GxARBCFG.ANONC"]
            VALUE1,
            #[doc = "Kernel is synchronization slave: Control information from input CI1"]
            VALUE2,
            #[doc = "Kernel is synchronization slave: Control information from input CI2"]
            VALUE3,
            #[doc = "Kernel is synchronization slave: Control information from input CI3"]
            VALUE4,
        }
        impl STSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STSELR::VALUE1 => 0,
                    STSELR::VALUE2 => 0x01,
                    STSELR::VALUE3 => 0x02,
                    STSELR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STSELR {
                match value {
                    0 => STSELR::VALUE1,
                    1 => STSELR::VALUE2,
                    2 => STSELR::VALUE3,
                    3 => STSELR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STSELR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EVALR1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EVALR1R {
            #[doc = "No ready input control"]
            VALUE1,
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            VALUE2,
        }
        impl EVALR1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EVALR1R::VALUE1 => false,
                    EVALR1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EVALR1R {
                match value {
                    false => EVALR1R::VALUE1,
                    true => EVALR1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EVALR1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EVALR1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `EVALR2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EVALR2R {
            #[doc = "No ready input control"]
            VALUE1,
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            VALUE2,
        }
        impl EVALR2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EVALR2R::VALUE1 => false,
                    EVALR2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EVALR2R {
                match value {
                    false => EVALR2R::VALUE1,
                    true => EVALR2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EVALR2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EVALR2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `EVALR3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EVALR3R {
            #[doc = "No ready input control"]
            VALUE1,
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            VALUE2,
        }
        impl EVALR3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EVALR3R::VALUE1 => false,
                    EVALR3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EVALR3R {
                match value {
                    false => EVALR3R::VALUE1,
                    true => EVALR3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EVALR3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EVALR3R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `STSEL`"]
        pub enum STSELW {
            #[doc = "Kernel is synchronization master: Use own bitfield GxARBCFG.ANONC"]
            VALUE1,
            #[doc = "Kernel is synchronization slave: Control information from input CI1"]
            VALUE2,
            #[doc = "Kernel is synchronization slave: Control information from input CI2"]
            VALUE3,
            #[doc = "Kernel is synchronization slave: Control information from input CI3"]
            VALUE4,
        }
        impl STSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STSELW::VALUE1 => 0,
                    STSELW::VALUE2 => 1,
                    STSELW::VALUE3 => 2,
                    STSELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Kernel is synchronization master: Use own bitfield GxARBCFG.ANONC"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STSELW::VALUE1)
            }
            #[doc = "Kernel is synchronization slave: Control information from input CI1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STSELW::VALUE2)
            }
            #[doc = "Kernel is synchronization slave: Control information from input CI2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STSELW::VALUE3)
            }
            #[doc = "Kernel is synchronization slave: Control information from input CI3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STSELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EVALR1`"]
        pub enum EVALR1W {
            #[doc = "No ready input control"]
            VALUE1,
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            VALUE2,
        }
        impl EVALR1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EVALR1W::VALUE1 => false,
                    EVALR1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EVALR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _EVALR1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EVALR1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No ready input control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EVALR1W::VALUE1)
            }
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EVALR1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EVALR2`"]
        pub enum EVALR2W {
            #[doc = "No ready input control"]
            VALUE1,
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            VALUE2,
        }
        impl EVALR2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EVALR2W::VALUE1 => false,
                    EVALR2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EVALR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _EVALR2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EVALR2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No ready input control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EVALR2W::VALUE1)
            }
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EVALR2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EVALR3`"]
        pub enum EVALR3W {
            #[doc = "No ready input control"]
            VALUE1,
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            VALUE2,
        }
        impl EVALR3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EVALR3W::VALUE1 => false,
                    EVALR3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EVALR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _EVALR3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EVALR3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No ready input control"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EVALR3W::VALUE1)
            }
            #[doc = "Ready input Rx is considered for the start of a parallel conversion of this conversion group"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EVALR3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Start Selection"]
            #[inline]
            pub fn stsel(&self) -> STSELR {
                STSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Evaluate Ready Input Rx"]
            #[inline]
            pub fn evalr1(&self) -> EVALR1R {
                EVALR1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Evaluate Ready Input Rx"]
            #[inline]
            pub fn evalr2(&self) -> EVALR2R {
                EVALR2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Evaluate Ready Input Rx"]
            #[inline]
            pub fn evalr3(&self) -> EVALR3R {
                EVALR3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Start Selection"]
            #[inline]
            pub fn stsel(&mut self) -> _STSELW {
                _STSELW { w: self }
            }
            #[doc = "Bit 4 - Evaluate Ready Input Rx"]
            #[inline]
            pub fn evalr1(&mut self) -> _EVALR1W {
                _EVALR1W { w: self }
            }
            #[doc = "Bit 5 - Evaluate Ready Input Rx"]
            #[inline]
            pub fn evalr2(&mut self) -> _EVALR2W {
                _EVALR2W { w: self }
            }
            #[doc = "Bit 6 - Evaluate Ready Input Rx"]
            #[inline]
            pub fn evalr3(&mut self) -> _EVALR3W {
                _EVALR3W { w: self }
            }
        }
    }
    #[doc = "Boundary Flag Register"]
    pub struct BFL {
        register: VolatileCell<u32>,
    }
    #[doc = "Boundary Flag Register"]
    pub mod bfl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BFL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `BFL0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL0R {
            #[doc = "Passive state: result has not yet crossed the activation boundary (see bitfield BFAy), or selected gate signal is inactive, or this boundary flag is disabled"]
            VALUE1,
            #[doc = "Active state: result has crossed the activation boundary"]
            VALUE2,
        }
        impl BFL0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFL0R::VALUE1 => false,
                    BFL0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFL0R {
                match value {
                    false => BFL0R::VALUE1,
                    true => BFL0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL1R {
            #[doc = "Passive state: result has not yet crossed the activation boundary (see bitfield BFAy), or selected gate signal is inactive, or this boundary flag is disabled"]
            VALUE1,
            #[doc = "Active state: result has crossed the activation boundary"]
            VALUE2,
        }
        impl BFL1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFL1R::VALUE1 => false,
                    BFL1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFL1R {
                match value {
                    false => BFL1R::VALUE1,
                    true => BFL1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFL2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL2R {
            #[doc = "Passive state: result has not yet crossed the activation boundary (see bitfield BFAy), or selected gate signal is inactive, or this boundary flag is disabled"]
            VALUE1,
            #[doc = "Active state: result has crossed the activation boundary"]
            VALUE2,
        }
        impl BFL2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFL2R::VALUE1 => false,
                    BFL2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFL2R {
                match value {
                    false => BFL2R::VALUE1,
                    true => BFL2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFL3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL3R {
            #[doc = "Passive state: result has not yet crossed the activation boundary (see bitfield BFAy), or selected gate signal is inactive, or this boundary flag is disabled"]
            VALUE1,
            #[doc = "Active state: result has crossed the activation boundary"]
            VALUE2,
        }
        impl BFL3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFL3R::VALUE1 => false,
                    BFL3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFL3R {
                match value {
                    false => BFL3R::VALUE1,
                    true => BFL3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFA0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFA0R {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFA0R::VALUE1 => false,
                    BFA0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFA0R {
                match value {
                    false => BFA0R::VALUE1,
                    true => BFA0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFA0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFA0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFA1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFA1R {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFA1R::VALUE1 => false,
                    BFA1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFA1R {
                match value {
                    false => BFA1R::VALUE1,
                    true => BFA1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFA1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFA1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFA2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFA2R {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFA2R::VALUE1 => false,
                    BFA2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFA2R {
                match value {
                    false => BFA2R::VALUE1,
                    true => BFA2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFA2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFA2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFA3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFA3R {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFA3R::VALUE1 => false,
                    BFA3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFA3R {
                match value {
                    false => BFA3R::VALUE1,
                    true => BFA3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFA3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFA3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFI0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFI0R {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFI0R::VALUE1 => false,
                    BFI0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFI0R {
                match value {
                    false => BFI0R::VALUE1,
                    true => BFI0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFI0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFI0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFI1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFI1R {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFI1R::VALUE1 => false,
                    BFI1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFI1R {
                match value {
                    false => BFI1R::VALUE1,
                    true => BFI1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFI1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFI1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFI2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFI2R {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFI2R::VALUE1 => false,
                    BFI2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFI2R {
                match value {
                    false => BFI2R::VALUE1,
                    true => BFI2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFI2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFI2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `BFI3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFI3R {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BFI3R::VALUE1 => false,
                    BFI3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BFI3R {
                match value {
                    false => BFI3R::VALUE1,
                    true => BFI3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFI3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFI3R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `BFA0`"]
        pub enum BFA0W {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFA0W::VALUE1 => false,
                    BFA0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFA0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFA0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFA0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFA0W::VALUE1)
            }
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFA0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFA1`"]
        pub enum BFA1W {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFA1W::VALUE1 => false,
                    BFA1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFA1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFA1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFA1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFA1W::VALUE1)
            }
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFA1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFA2`"]
        pub enum BFA2W {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFA2W::VALUE1 => false,
                    BFA2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFA2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFA2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFA2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFA2W::VALUE1)
            }
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFA2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFA3`"]
        pub enum BFA3W {
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            VALUE1,
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            VALUE2,
        }
        impl BFA3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFA3W::VALUE1 => false,
                    BFA3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFA3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFA3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFA3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Set boundary flag BFLy if result is above the defined band or compare value, clear if below"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFA3W::VALUE1)
            }
            #[doc = "Set boundary flag BFLy if result is below the defined band or compare value, clear if above"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFA3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFI0`"]
        pub enum BFI0W {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFI0W::VALUE1 => false,
                    BFI0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFI0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFI0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFI0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Use BFLy directly"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFI0W::VALUE1)
            }
            #[doc = "Invert value and use BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFI0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFI1`"]
        pub enum BFI1W {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFI1W::VALUE1 => false,
                    BFI1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFI1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFI1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFI1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Use BFLy directly"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFI1W::VALUE1)
            }
            #[doc = "Invert value and use BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFI1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFI2`"]
        pub enum BFI2W {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFI2W::VALUE1 => false,
                    BFI2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFI2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFI2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFI2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Use BFLy directly"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFI2W::VALUE1)
            }
            #[doc = "Invert value and use BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFI2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFI3`"]
        pub enum BFI3W {
            #[doc = "Use BFLy directly"]
            VALUE1,
            #[doc = "Invert value and use BFLy"]
            VALUE2,
        }
        impl BFI3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFI3W::VALUE1 => false,
                    BFI3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFI3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFI3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFI3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Use BFLy directly"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFI3W::VALUE1)
            }
            #[doc = "Invert value and use BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFI3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Boundary Flag 0"]
            #[inline]
            pub fn bfl0(&self) -> BFL0R {
                BFL0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Boundary Flag 1"]
            #[inline]
            pub fn bfl1(&self) -> BFL1R {
                BFL1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Boundary Flag 2"]
            #[inline]
            pub fn bfl2(&self) -> BFL2R {
                BFL2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Boundary Flag 3"]
            #[inline]
            pub fn bfl3(&self) -> BFL3R {
                BFL3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Boundary Flag 0 Activation Select"]
            #[inline]
            pub fn bfa0(&self) -> BFA0R {
                BFA0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Boundary Flag 1 Activation Select"]
            #[inline]
            pub fn bfa1(&self) -> BFA1R {
                BFA1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Boundary Flag 2 Activation Select"]
            #[inline]
            pub fn bfa2(&self) -> BFA2R {
                BFA2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Boundary Flag 3 Activation Select"]
            #[inline]
            pub fn bfa3(&self) -> BFA3R {
                BFA3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Boundary Flag 0 Inversion Control"]
            #[inline]
            pub fn bfi0(&self) -> BFI0R {
                BFI0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Boundary Flag 1 Inversion Control"]
            #[inline]
            pub fn bfi1(&self) -> BFI1R {
                BFI1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Boundary Flag 2 Inversion Control"]
            #[inline]
            pub fn bfi2(&self) -> BFI2R {
                BFI2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 19 - Boundary Flag 3 Inversion Control"]
            #[inline]
            pub fn bfi3(&self) -> BFI3R {
                BFI3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 8 - Boundary Flag 0 Activation Select"]
            #[inline]
            pub fn bfa0(&mut self) -> _BFA0W {
                _BFA0W { w: self }
            }
            #[doc = "Bit 9 - Boundary Flag 1 Activation Select"]
            #[inline]
            pub fn bfa1(&mut self) -> _BFA1W {
                _BFA1W { w: self }
            }
            #[doc = "Bit 10 - Boundary Flag 2 Activation Select"]
            #[inline]
            pub fn bfa2(&mut self) -> _BFA2W {
                _BFA2W { w: self }
            }
            #[doc = "Bit 11 - Boundary Flag 3 Activation Select"]
            #[inline]
            pub fn bfa3(&mut self) -> _BFA3W {
                _BFA3W { w: self }
            }
            #[doc = "Bit 16 - Boundary Flag 0 Inversion Control"]
            #[inline]
            pub fn bfi0(&mut self) -> _BFI0W {
                _BFI0W { w: self }
            }
            #[doc = "Bit 17 - Boundary Flag 1 Inversion Control"]
            #[inline]
            pub fn bfi1(&mut self) -> _BFI1W {
                _BFI1W { w: self }
            }
            #[doc = "Bit 18 - Boundary Flag 2 Inversion Control"]
            #[inline]
            pub fn bfi2(&mut self) -> _BFI2W {
                _BFI2W { w: self }
            }
            #[doc = "Bit 19 - Boundary Flag 3 Inversion Control"]
            #[inline]
            pub fn bfi3(&mut self) -> _BFI3W {
                _BFI3W { w: self }
            }
        }
    }
    #[doc = "Boundary Flag Software Register"]
    pub struct BFLS {
        register: VolatileCell<u32>,
    }
    #[doc = "Boundary Flag Software Register"]
    pub mod bfls {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BFLS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `BFC0`"]
        pub enum BFC0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear bit BFLy"]
            VALUE2,
        }
        impl BFC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFC0W::VALUE1 => false,
                    BFC0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFC0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFC0W::VALUE1)
            }
            #[doc = "Clear bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFC0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFC1`"]
        pub enum BFC1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear bit BFLy"]
            VALUE2,
        }
        impl BFC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFC1W::VALUE1 => false,
                    BFC1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFC1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFC1W::VALUE1)
            }
            #[doc = "Clear bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFC1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFC2`"]
        pub enum BFC2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear bit BFLy"]
            VALUE2,
        }
        impl BFC2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFC2W::VALUE1 => false,
                    BFC2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFC2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFC2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFC2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFC2W::VALUE1)
            }
            #[doc = "Clear bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFC2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFC3`"]
        pub enum BFC3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear bit BFLy"]
            VALUE2,
        }
        impl BFC3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFC3W::VALUE1 => false,
                    BFC3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFC3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFC3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFC3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFC3W::VALUE1)
            }
            #[doc = "Clear bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFC3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFS0`"]
        pub enum BFS0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Set bit BFLy"]
            VALUE2,
        }
        impl BFS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFS0W::VALUE1 => false,
                    BFS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFS0W::VALUE1)
            }
            #[doc = "Set bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFS1`"]
        pub enum BFS1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Set bit BFLy"]
            VALUE2,
        }
        impl BFS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFS1W::VALUE1 => false,
                    BFS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFS1W::VALUE1)
            }
            #[doc = "Set bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFS2`"]
        pub enum BFS2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Set bit BFLy"]
            VALUE2,
        }
        impl BFS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFS2W::VALUE1 => false,
                    BFS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFS2W::VALUE1)
            }
            #[doc = "Set bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFS3`"]
        pub enum BFS3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Set bit BFLy"]
            VALUE2,
        }
        impl BFS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BFS3W::VALUE1 => false,
                    BFS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFS3W::VALUE1)
            }
            #[doc = "Set bit BFLy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Boundary Flag 0 Clear"]
            #[inline]
            pub fn bfc0(&mut self) -> _BFC0W {
                _BFC0W { w: self }
            }
            #[doc = "Bit 1 - Boundary Flag 1 Clear"]
            #[inline]
            pub fn bfc1(&mut self) -> _BFC1W {
                _BFC1W { w: self }
            }
            #[doc = "Bit 2 - Boundary Flag 2 Clear"]
            #[inline]
            pub fn bfc2(&mut self) -> _BFC2W {
                _BFC2W { w: self }
            }
            #[doc = "Bit 3 - Boundary Flag 3 Clear"]
            #[inline]
            pub fn bfc3(&mut self) -> _BFC3W {
                _BFC3W { w: self }
            }
            #[doc = "Bit 16 - Boundary Flag 0 Set"]
            #[inline]
            pub fn bfs0(&mut self) -> _BFS0W {
                _BFS0W { w: self }
            }
            #[doc = "Bit 17 - Boundary Flag 1 Set"]
            #[inline]
            pub fn bfs1(&mut self) -> _BFS1W {
                _BFS1W { w: self }
            }
            #[doc = "Bit 18 - Boundary Flag 2 Set"]
            #[inline]
            pub fn bfs2(&mut self) -> _BFS2W {
                _BFS2W { w: self }
            }
            #[doc = "Bit 19 - Boundary Flag 3 Set"]
            #[inline]
            pub fn bfs3(&mut self) -> _BFS3W {
                _BFS3W { w: self }
            }
        }
    }
    #[doc = "Boundary Flag Control Register"]
    pub struct BFLC {
        register: VolatileCell<u32>,
    }
    #[doc = "Boundary Flag Control Register"]
    pub mod bflc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BFLC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `BFM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFM0R {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFM0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFM0R::VALUE1 => 0,
                    BFM0R::VALUE2 => 0x01,
                    BFM0R::VALUE3 => 0x02,
                    BFM0R::VALUE4 => 0x03,
                    BFM0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFM0R {
                match value {
                    0 => BFM0R::VALUE1,
                    1 => BFM0R::VALUE2,
                    2 => BFM0R::VALUE3,
                    3 => BFM0R::VALUE4,
                    i => BFM0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFM0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFM0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFM0R::VALUE4
            }
        }
        #[doc = "Possible values of the field `BFM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFM1R {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFM1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFM1R::VALUE1 => 0,
                    BFM1R::VALUE2 => 0x01,
                    BFM1R::VALUE3 => 0x02,
                    BFM1R::VALUE4 => 0x03,
                    BFM1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFM1R {
                match value {
                    0 => BFM1R::VALUE1,
                    1 => BFM1R::VALUE2,
                    2 => BFM1R::VALUE3,
                    3 => BFM1R::VALUE4,
                    i => BFM1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFM1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFM1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFM1R::VALUE4
            }
        }
        #[doc = "Possible values of the field `BFM2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFM2R {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFM2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFM2R::VALUE1 => 0,
                    BFM2R::VALUE2 => 0x01,
                    BFM2R::VALUE3 => 0x02,
                    BFM2R::VALUE4 => 0x03,
                    BFM2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFM2R {
                match value {
                    0 => BFM2R::VALUE1,
                    1 => BFM2R::VALUE2,
                    2 => BFM2R::VALUE3,
                    3 => BFM2R::VALUE4,
                    i => BFM2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFM2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFM2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFM2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFM2R::VALUE4
            }
        }
        #[doc = "Possible values of the field `BFM3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFM3R {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFM3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFM3R::VALUE1 => 0,
                    BFM3R::VALUE2 => 0x01,
                    BFM3R::VALUE3 => 0x02,
                    BFM3R::VALUE4 => 0x03,
                    BFM3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFM3R {
                match value {
                    0 => BFM3R::VALUE1,
                    1 => BFM3R::VALUE2,
                    2 => BFM3R::VALUE3,
                    3 => BFM3R::VALUE4,
                    i => BFM3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFM3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFM3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFM3R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFM3R::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `BFM0`"]
        pub enum BFM0W {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
        }
        impl BFM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFM0W::VALUE1 => 0,
                    BFM0W::VALUE2 => 1,
                    BFM0W::VALUE3 => 2,
                    BFM0W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFM0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Disable boundary flag, BFLy is not changed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFM0W::VALUE1)
            }
            #[doc = "Always enable boundary flag (follow compare results)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFM0W::VALUE2)
            }
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFM0W::VALUE3)
            }
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFM0W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFM1`"]
        pub enum BFM1W {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
        }
        impl BFM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFM1W::VALUE1 => 0,
                    BFM1W::VALUE2 => 1,
                    BFM1W::VALUE3 => 2,
                    BFM1W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFM1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Disable boundary flag, BFLy is not changed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFM1W::VALUE1)
            }
            #[doc = "Always enable boundary flag (follow compare results)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFM1W::VALUE2)
            }
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFM1W::VALUE3)
            }
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFM1W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFM2`"]
        pub enum BFM2W {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
        }
        impl BFM2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFM2W::VALUE1 => 0,
                    BFM2W::VALUE2 => 1,
                    BFM2W::VALUE3 => 2,
                    BFM2W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFM2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFM2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFM2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Disable boundary flag, BFLy is not changed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFM2W::VALUE1)
            }
            #[doc = "Always enable boundary flag (follow compare results)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFM2W::VALUE2)
            }
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFM2W::VALUE3)
            }
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFM2W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFM3`"]
        pub enum BFM3W {
            #[doc = "Disable boundary flag, BFLy is not changed"]
            VALUE1,
            #[doc = "Always enable boundary flag (follow compare results)"]
            VALUE2,
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            VALUE3,
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            VALUE4,
        }
        impl BFM3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFM3W::VALUE1 => 0,
                    BFM3W::VALUE2 => 1,
                    BFM3W::VALUE3 => 2,
                    BFM3W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFM3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFM3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFM3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Disable boundary flag, BFLy is not changed"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFM3W::VALUE1)
            }
            #[doc = "Always enable boundary flag (follow compare results)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFM3W::VALUE2)
            }
            #[doc = "Enable boundary flag while gate of source 0 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFM3W::VALUE3)
            }
            #[doc = "Enable boundary flag while gate of source 1 is active, clear BFLy while gate is inactive"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFM3W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm0(&self) -> BFM0R {
                BFM0R::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm1(&self) -> BFM1R {
                BFM1R::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm2(&self) -> BFM2R {
                BFM2R::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:15 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm3(&self) -> BFM3R {
                BFM3R::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm0(&mut self) -> _BFM0W {
                _BFM0W { w: self }
            }
            #[doc = "Bits 4:7 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm1(&mut self) -> _BFM1W {
                _BFM1W { w: self }
            }
            #[doc = "Bits 8:11 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm2(&mut self) -> _BFM2W {
                _BFM2W { w: self }
            }
            #[doc = "Bits 12:15 - Boundary Flag y Mode Control"]
            #[inline]
            pub fn bfm3(&mut self) -> _BFM3W {
                _BFM3W { w: self }
            }
        }
    }
    #[doc = "Boundary Flag Node Pointer Register"]
    pub struct BFLNP {
        register: VolatileCell<u32>,
    }
    #[doc = "Boundary Flag Node Pointer Register"]
    pub mod bflnp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BFLNP {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `BFL0NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL0NPR {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFL0NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFL0NPR::VALUE1 => 0,
                    BFL0NPR::VALUE2 => 0x03,
                    BFL0NPR::VALUE3 => 0x04,
                    BFL0NPR::VALUE4 => 0x07,
                    BFL0NPR::VALUE5 => 0x0f,
                    BFL0NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFL0NPR {
                match value {
                    0 => BFL0NPR::VALUE1,
                    3 => BFL0NPR::VALUE2,
                    4 => BFL0NPR::VALUE3,
                    7 => BFL0NPR::VALUE4,
                    15 => BFL0NPR::VALUE5,
                    i => BFL0NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL0NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL0NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFL0NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFL0NPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == BFL0NPR::VALUE5
            }
        }
        #[doc = "Possible values of the field `BFL1NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL1NPR {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFL1NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFL1NPR::VALUE1 => 0,
                    BFL1NPR::VALUE2 => 0x03,
                    BFL1NPR::VALUE3 => 0x04,
                    BFL1NPR::VALUE4 => 0x07,
                    BFL1NPR::VALUE5 => 0x0f,
                    BFL1NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFL1NPR {
                match value {
                    0 => BFL1NPR::VALUE1,
                    3 => BFL1NPR::VALUE2,
                    4 => BFL1NPR::VALUE3,
                    7 => BFL1NPR::VALUE4,
                    15 => BFL1NPR::VALUE5,
                    i => BFL1NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL1NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL1NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFL1NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFL1NPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == BFL1NPR::VALUE5
            }
        }
        #[doc = "Possible values of the field `BFL2NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL2NPR {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFL2NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFL2NPR::VALUE1 => 0,
                    BFL2NPR::VALUE2 => 0x03,
                    BFL2NPR::VALUE3 => 0x04,
                    BFL2NPR::VALUE4 => 0x07,
                    BFL2NPR::VALUE5 => 0x0f,
                    BFL2NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFL2NPR {
                match value {
                    0 => BFL2NPR::VALUE1,
                    3 => BFL2NPR::VALUE2,
                    4 => BFL2NPR::VALUE3,
                    7 => BFL2NPR::VALUE4,
                    15 => BFL2NPR::VALUE5,
                    i => BFL2NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL2NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL2NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFL2NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFL2NPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == BFL2NPR::VALUE5
            }
        }
        #[doc = "Possible values of the field `BFL3NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BFL3NPR {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BFL3NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BFL3NPR::VALUE1 => 0,
                    BFL3NPR::VALUE2 => 0x03,
                    BFL3NPR::VALUE3 => 0x04,
                    BFL3NPR::VALUE4 => 0x07,
                    BFL3NPR::VALUE5 => 0x0f,
                    BFL3NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BFL3NPR {
                match value {
                    0 => BFL3NPR::VALUE1,
                    3 => BFL3NPR::VALUE2,
                    4 => BFL3NPR::VALUE3,
                    7 => BFL3NPR::VALUE4,
                    15 => BFL3NPR::VALUE5,
                    i => BFL3NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BFL3NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BFL3NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BFL3NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BFL3NPR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == BFL3NPR::VALUE5
            }
        }
        #[doc = "Values that can be written to the field `BFL0NP`"]
        pub enum BFL0NPW {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
        }
        impl BFL0NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFL0NPW::VALUE1 => 0,
                    BFL0NPW::VALUE2 => 3,
                    BFL0NPW::VALUE3 => 4,
                    BFL0NPW::VALUE4 => 7,
                    BFL0NPW::VALUE5 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFL0NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFL0NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFL0NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select common bondary flag output 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFL0NPW::VALUE1)
            }
            #[doc = "Select common bondary flag output 3"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFL0NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFL0NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFL0NPW::VALUE4)
            }
            #[doc = "Disabled, no common output signal"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(BFL0NPW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFL1NP`"]
        pub enum BFL1NPW {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
        }
        impl BFL1NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFL1NPW::VALUE1 => 0,
                    BFL1NPW::VALUE2 => 3,
                    BFL1NPW::VALUE3 => 4,
                    BFL1NPW::VALUE4 => 7,
                    BFL1NPW::VALUE5 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFL1NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFL1NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFL1NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select common bondary flag output 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFL1NPW::VALUE1)
            }
            #[doc = "Select common bondary flag output 3"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFL1NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFL1NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFL1NPW::VALUE4)
            }
            #[doc = "Disabled, no common output signal"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(BFL1NPW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFL2NP`"]
        pub enum BFL2NPW {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
        }
        impl BFL2NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFL2NPW::VALUE1 => 0,
                    BFL2NPW::VALUE2 => 3,
                    BFL2NPW::VALUE3 => 4,
                    BFL2NPW::VALUE4 => 7,
                    BFL2NPW::VALUE5 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFL2NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFL2NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFL2NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select common bondary flag output 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFL2NPW::VALUE1)
            }
            #[doc = "Select common bondary flag output 3"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFL2NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFL2NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFL2NPW::VALUE4)
            }
            #[doc = "Disabled, no common output signal"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(BFL2NPW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BFL3NP`"]
        pub enum BFL3NPW {
            #[doc = "Select common bondary flag output 0"]
            VALUE1,
            #[doc = "Select common bondary flag output 3"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = "Disabled, no common output signal"]
            VALUE5,
        }
        impl BFL3NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BFL3NPW::VALUE1 => 0,
                    BFL3NPW::VALUE2 => 3,
                    BFL3NPW::VALUE3 => 4,
                    BFL3NPW::VALUE4 => 7,
                    BFL3NPW::VALUE5 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BFL3NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BFL3NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BFL3NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select common bondary flag output 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BFL3NPW::VALUE1)
            }
            #[doc = "Select common bondary flag output 3"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BFL3NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BFL3NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BFL3NPW::VALUE4)
            }
            #[doc = "Disabled, no common output signal"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(BFL3NPW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl0np(&self) -> BFL0NPR {
                BFL0NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl1np(&self) -> BFL1NPR {
                BFL1NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl2np(&self) -> BFL2NPR {
                BFL2NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:15 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl3np(&self) -> BFL3NPR {
                BFL3NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0xffff }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl0np(&mut self) -> _BFL0NPW {
                _BFL0NPW { w: self }
            }
            #[doc = "Bits 4:7 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl1np(&mut self) -> _BFL1NPW {
                _BFL1NPW { w: self }
            }
            #[doc = "Bits 8:11 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl2np(&mut self) -> _BFL2NPW {
                _BFL2NPW { w: self }
            }
            #[doc = "Bits 12:15 - Boundary Flag y Node Pointer"]
            #[inline]
            pub fn bfl3np(&mut self) -> _BFL3NPW {
                _BFL3NPW { w: self }
            }
        }
    }
    #[doc = "Queue 0 Source Control Register"]
    pub struct QCTRL0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Queue 0 Source Control Register"]
    pub mod qctrl0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::QCTRL0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SRCRESREG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRCRESREGR {
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            VALUE1,
            #[doc = "Store result in group result register GxRES1"]
            VALUE2,
            #[doc = "Store result in group result register GxRES15"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRCRESREGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRCRESREGR::VALUE1 => 0,
                    SRCRESREGR::VALUE2 => 0x01,
                    SRCRESREGR::VALUE3 => 0x0f,
                    SRCRESREGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRCRESREGR {
                match value {
                    0 => SRCRESREGR::VALUE1,
                    1 => SRCRESREGR::VALUE2,
                    15 => SRCRESREGR::VALUE3,
                    i => SRCRESREGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRCRESREGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRCRESREGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SRCRESREGR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct XTSELR {
            bits: u8,
        }
        impl XTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct XTLVLR {
            bits: bool,
        }
        impl XTLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `XTMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XTMODER {
            #[doc = "No external trigger"]
            VALUE1,
            #[doc = "Trigger event upon a falling edge"]
            VALUE2,
            #[doc = "Trigger event upon a rising edge"]
            VALUE3,
            #[doc = "Trigger event upon any edge"]
            VALUE4,
        }
        impl XTMODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    XTMODER::VALUE1 => 0,
                    XTMODER::VALUE2 => 0x01,
                    XTMODER::VALUE3 => 0x02,
                    XTMODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> XTMODER {
                match value {
                    0 => XTMODER::VALUE1,
                    1 => XTMODER::VALUE2,
                    2 => XTMODER::VALUE3,
                    3 => XTMODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XTMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XTMODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == XTMODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == XTMODER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct GTSELR {
            bits: u8,
        }
        impl GTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct GTLVLR {
            bits: bool,
        }
        impl GTLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TMEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TMENR {
            #[doc = "No timer mode: standard gating mechanism can be used"]
            VALUE1,
            #[doc = "Timer mode for equidistant sampling enabled: standard gating mechanism must be disabled"]
            VALUE2,
        }
        impl TMENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TMENR::VALUE1 => false,
                    TMENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TMENR {
                match value {
                    false => TMENR::VALUE1,
                    true => TMENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TMENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TMENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SRCRESREG`"]
        pub enum SRCRESREGW {
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            VALUE1,
            #[doc = "Store result in group result register GxRES1"]
            VALUE2,
            #[doc = "Store result in group result register GxRES15"]
            VALUE3,
        }
        impl SRCRESREGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRCRESREGW::VALUE1 => 0,
                    SRCRESREGW::VALUE2 => 1,
                    SRCRESREGW::VALUE3 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRCRESREGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRCRESREGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRCRESREGW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE1)
            }
            #[doc = "Store result in group result register GxRES1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE2)
            }
            #[doc = "Store result in group result register GxRES15"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTMODE`"]
        pub enum XTMODEW {
            #[doc = "No external trigger"]
            VALUE1,
            #[doc = "Trigger event upon a falling edge"]
            VALUE2,
            #[doc = "Trigger event upon a rising edge"]
            VALUE3,
            #[doc = "Trigger event upon any edge"]
            VALUE4,
        }
        impl XTMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    XTMODEW::VALUE1 => 0,
                    XTMODEW::VALUE2 => 1,
                    XTMODEW::VALUE3 => 2,
                    XTMODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTMODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No external trigger"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE1)
            }
            #[doc = "Trigger event upon a falling edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE2)
            }
            #[doc = "Trigger event upon a rising edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE3)
            }
            #[doc = "Trigger event upon any edge"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTWC`"]
        pub enum XTWCW {
            #[doc = "No write access to trigger configuration"]
            VALUE1,
            #[doc = "Bitfields XTMODE and XTSEL can be written"]
            VALUE2,
        }
        impl XTWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XTWCW::VALUE1 => false,
                    XTWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to trigger configuration"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTWCW::VALUE1)
            }
            #[doc = "Bitfields XTMODE and XTSEL can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GTSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GTWC`"]
        pub enum GTWCW {
            #[doc = "No write access to gate configuration"]
            VALUE1,
            #[doc = "Bitfield GTSEL can be written"]
            VALUE2,
        }
        impl GTWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GTWCW::VALUE1 => false,
                    GTWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GTWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GTWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GTWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to gate configuration"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GTWCW::VALUE1)
            }
            #[doc = "Bitfield GTSEL can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GTWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TMEN`"]
        pub enum TMENW {
            #[doc = "No timer mode: standard gating mechanism can be used"]
            VALUE1,
            #[doc = "Timer mode for equidistant sampling enabled: standard gating mechanism must be disabled"]
            VALUE2,
        }
        impl TMENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TMENW::VALUE1 => false,
                    TMENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TMENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TMENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TMENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No timer mode: standard gating mechanism can be used"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TMENW::VALUE1)
            }
            #[doc = "Timer mode for equidistant sampling enabled: standard gating mechanism must be disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TMENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TMWC`"]
        pub enum TMWCW {
            #[doc = "No write access to timer mode"]
            VALUE1,
            #[doc = "Bitfield TMEN can be written"]
            VALUE2,
        }
        impl TMWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TMWCW::VALUE1 => false,
                    TMWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TMWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TMWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TMWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to timer mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TMWCW::VALUE1)
            }
            #[doc = "Bitfield TMEN can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TMWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Source-specific Result Register"]
            #[inline]
            pub fn srcresreg(&self) -> SRCRESREGR {
                SRCRESREGR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - External Trigger Input Selection"]
            #[inline]
            pub fn xtsel(&self) -> XTSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XTSELR { bits }
            }
            #[doc = "Bit 12 - External Trigger Level"]
            #[inline]
            pub fn xtlvl(&self) -> XTLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XTLVLR { bits }
            }
            #[doc = "Bits 13:14 - Trigger Operating Mode"]
            #[inline]
            pub fn xtmode(&self) -> XTMODER {
                XTMODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Gate Input Selection"]
            #[inline]
            pub fn gtsel(&self) -> GTSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GTSELR { bits }
            }
            #[doc = "Bit 20 - Gate Input Level"]
            #[inline]
            pub fn gtlvl(&self) -> GTLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GTLVLR { bits }
            }
            #[doc = "Bit 28 - Timer Mode Enable"]
            #[inline]
            pub fn tmen(&self) -> TMENR {
                TMENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Source-specific Result Register"]
            #[inline]
            pub fn srcresreg(&mut self) -> _SRCRESREGW {
                _SRCRESREGW { w: self }
            }
            #[doc = "Bits 8:11 - External Trigger Input Selection"]
            #[inline]
            pub fn xtsel(&mut self) -> _XTSELW {
                _XTSELW { w: self }
            }
            #[doc = "Bits 13:14 - Trigger Operating Mode"]
            #[inline]
            pub fn xtmode(&mut self) -> _XTMODEW {
                _XTMODEW { w: self }
            }
            #[doc = "Bit 15 - Write Control for Trigger Configuration"]
            #[inline]
            pub fn xtwc(&mut self) -> _XTWCW {
                _XTWCW { w: self }
            }
            #[doc = "Bits 16:19 - Gate Input Selection"]
            #[inline]
            pub fn gtsel(&mut self) -> _GTSELW {
                _GTSELW { w: self }
            }
            #[doc = "Bit 23 - Write Control for Gate Configuration"]
            #[inline]
            pub fn gtwc(&mut self) -> _GTWCW {
                _GTWCW { w: self }
            }
            #[doc = "Bit 28 - Timer Mode Enable"]
            #[inline]
            pub fn tmen(&mut self) -> _TMENW {
                _TMENW { w: self }
            }
            #[doc = "Bit 31 - Write Control for Timer Mode"]
            #[inline]
            pub fn tmwc(&mut self) -> _TMWCW {
                _TMWCW { w: self }
            }
        }
    }
    #[doc = "Queue 0 Mode Register"]
    pub struct QMR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Queue 0 Mode Register"]
    pub mod qmr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::QMR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENGTR {
            #[doc = "No conversion requests are issued"]
            VALUE1,
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register"]
            VALUE2,
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register and REQGTx = 1"]
            VALUE3,
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register and REQGTx = 0"]
            VALUE4,
        }
        impl ENGTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENGTR::VALUE1 => 0,
                    ENGTR::VALUE2 => 0x01,
                    ENGTR::VALUE3 => 0x02,
                    ENGTR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENGTR {
                match value {
                    0 => ENGTR::VALUE1,
                    1 => ENGTR::VALUE2,
                    2 => ENGTR::VALUE3,
                    3 => ENGTR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENGTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENGTR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ENGTR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ENTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENTRR {
            #[doc = "External trigger disabled"]
            VALUE1,
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the trigger event"]
            VALUE2,
        }
        impl ENTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENTRR::VALUE1 => false,
                    ENTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENTRR {
                match value {
                    false => ENTRR::VALUE1,
                    true => ENTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPTDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPTDISR {
            #[doc = "A cancelled conversion is repeated"]
            VALUE1,
            #[doc = "A cancelled conversion is discarded"]
            VALUE2,
        }
        impl RPTDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPTDISR::VALUE1 => false,
                    RPTDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPTDISR {
                match value {
                    false => RPTDISR::VALUE1,
                    true => RPTDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPTDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPTDISR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ENGT`"]
        pub enum ENGTW {
            #[doc = "No conversion requests are issued"]
            VALUE1,
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register"]
            VALUE2,
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register and REQGTx = 1"]
            VALUE3,
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register and REQGTx = 0"]
            VALUE4,
        }
        impl ENGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENGTW::VALUE1 => 0,
                    ENGTW::VALUE2 => 1,
                    ENGTW::VALUE3 => 2,
                    ENGTW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENGTW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No conversion requests are issued"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENGTW::VALUE1)
            }
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENGTW::VALUE2)
            }
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register and REQGTx = 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENGTW::VALUE3)
            }
            #[doc = "Conversion requests are issued if a valid conversion request is pending in the queue 0 register or in the backup register and REQGTx = 0"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ENGTW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENTR`"]
        pub enum ENTRW {
            #[doc = "External trigger disabled"]
            VALUE1,
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the trigger event"]
            VALUE2,
        }
        impl ENTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENTRW::VALUE1 => false,
                    ENTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External trigger disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENTRW::VALUE1)
            }
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the trigger event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CLRV`"]
        pub enum CLRVW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "The next pending valid queue entry in the sequence and the event flag EV are cleared. If there is a valid entry in the queue backup register (QBUR.V = 1), this entry is cleared, otherwise the entry in queue register 0 is cleared."]
            VALUE2,
        }
        impl CLRVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CLRVW::VALUE1 => false,
                    CLRVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CLRVW::VALUE1)
            }
            #[doc = "The next pending valid queue entry in the sequence and the event flag EV are cleared. If there is a valid entry in the queue backup register (QBUR.V = 1), this entry is cleared, otherwise the entry in queue register 0 is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CLRVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TREV`"]
        pub enum TREVW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Generate a trigger event by software"]
            VALUE2,
        }
        impl TREVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TREVW::VALUE1 => false,
                    TREVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TREVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TREVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TREVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TREVW::VALUE1)
            }
            #[doc = "Generate a trigger event by software"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TREVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FLUSH`"]
        pub enum FLUSHW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear all queue entries (including backup stage) and the event flag EV. The queue contains no more valid entry."]
            VALUE2,
        }
        impl FLUSHW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FLUSHW::VALUE1 => false,
                    FLUSHW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FLUSHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FLUSHW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FLUSHW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FLUSHW::VALUE1)
            }
            #[doc = "Clear all queue entries (including backup stage) and the event flag EV. The queue contains no more valid entry."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FLUSHW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV`"]
        pub enum CEVW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear bit EV"]
            VALUE2,
        }
        impl CEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEVW::VALUE1 => false,
                    CEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEVW::VALUE1)
            }
            #[doc = "Clear bit EV"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RPTDIS`"]
        pub enum RPTDISW {
            #[doc = "A cancelled conversion is repeated"]
            VALUE1,
            #[doc = "A cancelled conversion is discarded"]
            VALUE2,
        }
        impl RPTDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RPTDISW::VALUE1 => false,
                    RPTDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPTDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPTDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RPTDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A cancelled conversion is repeated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RPTDISW::VALUE1)
            }
            #[doc = "A cancelled conversion is discarded"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RPTDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Enable Gate"]
            #[inline]
            pub fn engt(&self) -> ENGTR {
                ENGTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - Enable External Trigger"]
            #[inline]
            pub fn entr(&self) -> ENTRR {
                ENTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Repeat Disable"]
            #[inline]
            pub fn rptdis(&self) -> RPTDISR {
                RPTDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Enable Gate"]
            #[inline]
            pub fn engt(&mut self) -> _ENGTW {
                _ENGTW { w: self }
            }
            #[doc = "Bit 2 - Enable External Trigger"]
            #[inline]
            pub fn entr(&mut self) -> _ENTRW {
                _ENTRW { w: self }
            }
            #[doc = "Bit 8 - Clear Valid Bit"]
            #[inline]
            pub fn clrv(&mut self) -> _CLRVW {
                _CLRVW { w: self }
            }
            #[doc = "Bit 9 - Trigger Event"]
            #[inline]
            pub fn trev(&mut self) -> _TREVW {
                _TREVW { w: self }
            }
            #[doc = "Bit 10 - Flush Queue"]
            #[inline]
            pub fn flush(&mut self) -> _FLUSHW {
                _FLUSHW { w: self }
            }
            #[doc = "Bit 11 - Clear Event Flag"]
            #[inline]
            pub fn cev(&mut self) -> _CEVW {
                _CEVW { w: self }
            }
            #[doc = "Bit 16 - Repeat Disable"]
            #[inline]
            pub fn rptdis(&mut self) -> _RPTDISW {
                _RPTDISW { w: self }
            }
        }
    }
    #[doc = "Queue 0 Status Register"]
    pub struct QSR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Queue 0 Status Register"]
    pub mod qsr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::QSR0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `FILL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FILLR {
            #[doc = "There is 1 ( if EMPTY = 0) or no (if EMPTY = 1) valid entry in the queue"]
            VALUE1,
            #[doc = "There are 2 valid entries in the queue"]
            VALUE2,
            #[doc = "There are 3 valid entries in the queue"]
            VALUE3,
            #[doc = "There are 8 valid entries in the queue"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl FILLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    FILLR::VALUE1 => 0,
                    FILLR::VALUE2 => 0x01,
                    FILLR::VALUE3 => 0x02,
                    FILLR::VALUE4 => 0x07,
                    FILLR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> FILLR {
                match value {
                    0 => FILLR::VALUE1,
                    1 => FILLR::VALUE2,
                    2 => FILLR::VALUE3,
                    7 => FILLR::VALUE4,
                    i => FILLR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FILLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FILLR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == FILLR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == FILLR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EMPTY`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMPTYR {
            #[doc = "There are valid entries in the queue (see FILL)"]
            VALUE1,
            #[doc = "No valid entries (queue is empty)"]
            VALUE2,
        }
        impl EMPTYR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMPTYR::VALUE1 => false,
                    EMPTYR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMPTYR {
                match value {
                    false => EMPTYR::VALUE1,
                    true => EMPTYR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMPTYR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMPTYR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REQGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REQGTR {
            #[doc = "The gate input is low"]
            VALUE1,
            #[doc = "The gate input is high"]
            VALUE2,
        }
        impl REQGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REQGTR::VALUE1 => false,
                    REQGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REQGTR {
                match value {
                    false => REQGTR::VALUE1,
                    true => REQGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REQGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REQGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EVR {
            #[doc = "No trigger event"]
            VALUE1,
            #[doc = "A trigger event has been detected"]
            VALUE2,
        }
        impl EVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EVR::VALUE1 => false,
                    EVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EVR {
                match value {
                    false => EVR::VALUE1,
                    true => EVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EVR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Filling Level for Queue 2"]
            #[inline]
            pub fn fill(&self) -> FILLR {
                FILLR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 5 - Queue Empty"]
            #[inline]
            pub fn empty(&self) -> EMPTYR {
                EMPTYR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Request Gate Level"]
            #[inline]
            pub fn reqgt(&self) -> REQGTR {
                REQGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Event Detected"]
            #[inline]
            pub fn ev(&self) -> EVR {
                EVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Queue 0 Register 0"]
    pub struct Q0R0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Queue 0 Register 0"]
    pub mod q0r0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::Q0R0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct REQCHNRR {
            bits: u8,
        }
        impl REQCHNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `RF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RFR {
            #[doc = "The request is discarded after the conversion start."]
            VALUE1,
            #[doc = "The request is automatically refilled into the queue after the conversion start."]
            VALUE2,
        }
        impl RFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RFR::VALUE1 => false,
                    RFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RFR {
                match value {
                    false => RFR::VALUE1,
                    true => RFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RFR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENSI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENSIR {
            #[doc = "No request source interrupt"]
            VALUE1,
            #[doc = "A request source event interrupt is generated upon a request source event (related conversion is finished)"]
            VALUE2,
        }
        impl ENSIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENSIR::VALUE1 => false,
                    ENSIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENSIR {
                match value {
                    false => ENSIR::VALUE1,
                    true => ENSIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENSIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENSIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EXTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EXTRR {
            #[doc = "A valid queue entry immediately leads to a conversion request"]
            VALUE1,
            #[doc = "The request handler waits for a trigger event"]
            VALUE2,
        }
        impl EXTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EXTRR::VALUE1 => false,
                    EXTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EXTRR {
                match value {
                    false => EXTRR::VALUE1,
                    true => EXTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EXTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EXTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `V`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VR {
            #[doc = "No valid queue entry"]
            VALUE1,
            #[doc = "The queue entry is valid and leads to a conversion request"]
            VALUE2,
        }
        impl VR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VR::VALUE1 => false,
                    VR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VR {
                match value {
                    false => VR::VALUE1,
                    true => VR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Request Channel Number"]
            #[inline]
            pub fn reqchnr(&self) -> REQCHNRR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REQCHNRR { bits }
            }
            #[doc = "Bit 5 - Refill"]
            #[inline]
            pub fn rf(&self) -> RFR {
                RFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&self) -> ENSIR {
                ENSIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - External Trigger"]
            #[inline]
            pub fn extr(&self) -> EXTRR {
                EXTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Request Channel Number Valid"]
            #[inline]
            pub fn v(&self) -> VR {
                VR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Queue 0 Input Register"]
    pub struct QINR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Queue 0 Input Register"]
    pub mod qinr0 {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::QINR0 {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _REQCHNRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REQCHNRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RF`"]
        pub enum RFW {
            #[doc = "No refill: this queue entry is converted once and then invalidated"]
            VALUE1,
            #[doc = "Automatic refill: this queue entry is automatically reloaded into QINRx when the related conversion is started"]
            VALUE2,
        }
        impl RFW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RFW::VALUE1 => false,
                    RFW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RFW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RFW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No refill: this queue entry is converted once and then invalidated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RFW::VALUE1)
            }
            #[doc = "Automatic refill: this queue entry is automatically reloaded into QINRx when the related conversion is started"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RFW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENSI`"]
        pub enum ENSIW {
            #[doc = "No request source interrupt"]
            VALUE1,
            #[doc = "A request source event interrupt is generated upon a request source event (related conversion is finished)"]
            VALUE2,
        }
        impl ENSIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENSIW::VALUE1 => false,
                    ENSIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENSIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENSIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENSIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No request source interrupt"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENSIW::VALUE1)
            }
            #[doc = "A request source event interrupt is generated upon a request source event (related conversion is finished)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENSIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EXTR`"]
        pub enum EXTRW {
            #[doc = "A valid queue entry immediately leads to a conversion request."]
            VALUE1,
            #[doc = "A valid queue entry waits for a trigger event to occur before issuing a conversion request."]
            VALUE2,
        }
        impl EXTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EXTRW::VALUE1 => false,
                    EXTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EXTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EXTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EXTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A valid queue entry immediately leads to a conversion request."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EXTRW::VALUE1)
            }
            #[doc = "A valid queue entry waits for a trigger event to occur before issuing a conversion request."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EXTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Request Channel Number"]
            #[inline]
            pub fn reqchnr(&mut self) -> _REQCHNRW {
                _REQCHNRW { w: self }
            }
            #[doc = "Bit 5 - Refill"]
            #[inline]
            pub fn rf(&mut self) -> _RFW {
                _RFW { w: self }
            }
            #[doc = "Bit 6 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&mut self) -> _ENSIW {
                _ENSIW { w: self }
            }
            #[doc = "Bit 7 - External Trigger"]
            #[inline]
            pub fn extr(&mut self) -> _EXTRW {
                _EXTRW { w: self }
            }
        }
    }
    #[doc = "Queue 0 Backup Register"]
    pub struct QBUR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Queue 0 Backup Register"]
    pub mod qbur0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::QBUR0 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct REQCHNRR {
            bits: u8,
        }
        impl REQCHNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct RFR {
            bits: bool,
        }
        impl RFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct ENSIR {
            bits: bool,
        }
        impl ENSIR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct EXTRR {
            bits: bool,
        }
        impl EXTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `V`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VR {
            #[doc = "Backup register not valid"]
            VALUE1,
            #[doc = "Backup register contains a valid entry. This will be requested before a valid entry in queue register 0 (stage 0) will be requested."]
            VALUE2,
        }
        impl VR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VR::VALUE1 => false,
                    VR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VR {
                match value {
                    false => VR::VALUE1,
                    true => VR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Request Channel Number"]
            #[inline]
            pub fn reqchnr(&self) -> REQCHNRR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REQCHNRR { bits }
            }
            #[doc = "Bit 5 - Refill"]
            #[inline]
            pub fn rf(&self) -> RFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                RFR { bits }
            }
            #[doc = "Bit 6 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&self) -> ENSIR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ENSIR { bits }
            }
            #[doc = "Bit 7 - External Trigger"]
            #[inline]
            pub fn extr(&self) -> EXTRR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EXTRR { bits }
            }
            #[doc = "Bit 8 - Request Channel Number Valid"]
            #[inline]
            pub fn v(&self) -> VR {
                VR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Autoscan Source Control Register"]
    pub struct ASCTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "Autoscan Source Control Register"]
    pub mod asctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ASCTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SRCRESREG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRCRESREGR {
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            VALUE1,
            #[doc = "Store result in group result register GxRES1"]
            VALUE2,
            #[doc = "Store result in group result register GxRES15"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SRCRESREGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SRCRESREGR::VALUE1 => 0,
                    SRCRESREGR::VALUE2 => 0x01,
                    SRCRESREGR::VALUE3 => 0x0f,
                    SRCRESREGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SRCRESREGR {
                match value {
                    0 => SRCRESREGR::VALUE1,
                    1 => SRCRESREGR::VALUE2,
                    15 => SRCRESREGR::VALUE3,
                    i => SRCRESREGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRCRESREGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRCRESREGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SRCRESREGR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct XTSELR {
            bits: u8,
        }
        impl XTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct XTLVLR {
            bits: bool,
        }
        impl XTLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `XTMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum XTMODER {
            #[doc = "No external trigger"]
            VALUE1,
            #[doc = "Trigger event upon a falling edge"]
            VALUE2,
            #[doc = "Trigger event upon a rising edge"]
            VALUE3,
            #[doc = "Trigger event upon any edge"]
            VALUE4,
        }
        impl XTMODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    XTMODER::VALUE1 => 0,
                    XTMODER::VALUE2 => 0x01,
                    XTMODER::VALUE3 => 0x02,
                    XTMODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> XTMODER {
                match value {
                    0 => XTMODER::VALUE1,
                    1 => XTMODER::VALUE2,
                    2 => XTMODER::VALUE3,
                    3 => XTMODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == XTMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == XTMODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == XTMODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == XTMODER::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct GTSELR {
            bits: u8,
        }
        impl GTSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct GTLVLR {
            bits: bool,
        }
        impl GTLVLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TMEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TMENR {
            #[doc = "No timer mode: standard gating mechanism can be used"]
            VALUE1,
            #[doc = "Timer mode for equidistant sampling enabled: standard gating mechanism must be disabled"]
            VALUE2,
        }
        impl TMENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TMENR::VALUE1 => false,
                    TMENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TMENR {
                match value {
                    false => TMENR::VALUE1,
                    true => TMENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TMENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TMENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SRCRESREG`"]
        pub enum SRCRESREGW {
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            VALUE1,
            #[doc = "Store result in group result register GxRES1"]
            VALUE2,
            #[doc = "Store result in group result register GxRES15"]
            VALUE3,
        }
        impl SRCRESREGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SRCRESREGW::VALUE1 => 0,
                    SRCRESREGW::VALUE2 => 1,
                    SRCRESREGW::VALUE3 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRCRESREGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRCRESREGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRCRESREGW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Use GxCHCTRy.RESREG to select a group result register"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE1)
            }
            #[doc = "Store result in group result register GxRES1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE2)
            }
            #[doc = "Store result in group result register GxRES15"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SRCRESREGW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTMODE`"]
        pub enum XTMODEW {
            #[doc = "No external trigger"]
            VALUE1,
            #[doc = "Trigger event upon a falling edge"]
            VALUE2,
            #[doc = "Trigger event upon a rising edge"]
            VALUE3,
            #[doc = "Trigger event upon any edge"]
            VALUE4,
        }
        impl XTMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    XTMODEW::VALUE1 => 0,
                    XTMODEW::VALUE2 => 1,
                    XTMODEW::VALUE3 => 2,
                    XTMODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTMODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No external trigger"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE1)
            }
            #[doc = "Trigger event upon a falling edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE2)
            }
            #[doc = "Trigger event upon a rising edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE3)
            }
            #[doc = "Trigger event upon any edge"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(XTMODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `XTWC`"]
        pub enum XTWCW {
            #[doc = "No write access to trigger configuration"]
            VALUE1,
            #[doc = "Bitfields XTMODE and XTSEL can be written"]
            VALUE2,
        }
        impl XTWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    XTWCW::VALUE1 => false,
                    XTWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _XTWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XTWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: XTWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to trigger configuration"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(XTWCW::VALUE1)
            }
            #[doc = "Bitfields XTMODE and XTSEL can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(XTWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _GTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GTSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GTWC`"]
        pub enum GTWCW {
            #[doc = "No write access to gate configuration"]
            VALUE1,
            #[doc = "Bitfield GTSEL can be written"]
            VALUE2,
        }
        impl GTWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GTWCW::VALUE1 => false,
                    GTWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GTWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GTWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GTWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to gate configuration"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GTWCW::VALUE1)
            }
            #[doc = "Bitfield GTSEL can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GTWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TMEN`"]
        pub enum TMENW {
            #[doc = "No timer mode: standard gating mechanism can be used"]
            VALUE1,
            #[doc = "Timer mode for equidistant sampling enabled: standard gating mechanism must be disabled"]
            VALUE2,
        }
        impl TMENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TMENW::VALUE1 => false,
                    TMENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TMENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TMENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TMENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No timer mode: standard gating mechanism can be used"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TMENW::VALUE1)
            }
            #[doc = "Timer mode for equidistant sampling enabled: standard gating mechanism must be disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TMENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TMWC`"]
        pub enum TMWCW {
            #[doc = "No write access to timer mode"]
            VALUE1,
            #[doc = "Bitfield TMEN can be written"]
            VALUE2,
        }
        impl TMWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TMWCW::VALUE1 => false,
                    TMWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TMWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TMWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TMWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to timer mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TMWCW::VALUE1)
            }
            #[doc = "Bitfield TMEN can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TMWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Source-specific Result Register"]
            #[inline]
            pub fn srcresreg(&self) -> SRCRESREGR {
                SRCRESREGR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - External Trigger Input Selection"]
            #[inline]
            pub fn xtsel(&self) -> XTSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XTSELR { bits }
            }
            #[doc = "Bit 12 - External Trigger Level"]
            #[inline]
            pub fn xtlvl(&self) -> XTLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                XTLVLR { bits }
            }
            #[doc = "Bits 13:14 - Trigger Operating Mode"]
            #[inline]
            pub fn xtmode(&self) -> XTMODER {
                XTMODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Gate Input Selection"]
            #[inline]
            pub fn gtsel(&self) -> GTSELR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GTSELR { bits }
            }
            #[doc = "Bit 20 - Gate Input Level"]
            #[inline]
            pub fn gtlvl(&self) -> GTLVLR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                GTLVLR { bits }
            }
            #[doc = "Bit 28 - Timer Mode Enable"]
            #[inline]
            pub fn tmen(&self) -> TMENR {
                TMENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Source-specific Result Register"]
            #[inline]
            pub fn srcresreg(&mut self) -> _SRCRESREGW {
                _SRCRESREGW { w: self }
            }
            #[doc = "Bits 8:11 - External Trigger Input Selection"]
            #[inline]
            pub fn xtsel(&mut self) -> _XTSELW {
                _XTSELW { w: self }
            }
            #[doc = "Bits 13:14 - Trigger Operating Mode"]
            #[inline]
            pub fn xtmode(&mut self) -> _XTMODEW {
                _XTMODEW { w: self }
            }
            #[doc = "Bit 15 - Write Control for Trigger Configuration"]
            #[inline]
            pub fn xtwc(&mut self) -> _XTWCW {
                _XTWCW { w: self }
            }
            #[doc = "Bits 16:19 - Gate Input Selection"]
            #[inline]
            pub fn gtsel(&mut self) -> _GTSELW {
                _GTSELW { w: self }
            }
            #[doc = "Bit 23 - Write Control for Gate Configuration"]
            #[inline]
            pub fn gtwc(&mut self) -> _GTWCW {
                _GTWCW { w: self }
            }
            #[doc = "Bit 28 - Timer Mode Enable"]
            #[inline]
            pub fn tmen(&mut self) -> _TMENW {
                _TMENW { w: self }
            }
            #[doc = "Bit 31 - Write Control for Timer Mode"]
            #[inline]
            pub fn tmwc(&mut self) -> _TMWCW {
                _TMWCW { w: self }
            }
        }
    }
    #[doc = "Autoscan Source Mode Register"]
    pub struct ASMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Autoscan Source Mode Register"]
    pub mod asmr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ASMR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ENGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENGTR {
            #[doc = "No conversion requests are issued"]
            VALUE1,
            #[doc = "Conversion requests are issued if at least one pending bit is set"]
            VALUE2,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 1."]
            VALUE3,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 0."]
            VALUE4,
        }
        impl ENGTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENGTR::VALUE1 => 0,
                    ENGTR::VALUE2 => 0x01,
                    ENGTR::VALUE3 => 0x02,
                    ENGTR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENGTR {
                match value {
                    0 => ENGTR::VALUE1,
                    1 => ENGTR::VALUE2,
                    2 => ENGTR::VALUE3,
                    3 => ENGTR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENGTR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENGTR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ENGTR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ENTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENTRR {
            #[doc = "External trigger disabled"]
            VALUE1,
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the load event"]
            VALUE2,
        }
        impl ENTRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENTRR::VALUE1 => false,
                    ENTRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENTRR {
                match value {
                    false => ENTRR::VALUE1,
                    true => ENTRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENTRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENSI`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENSIR {
            #[doc = "No request source interrupt"]
            VALUE1,
            #[doc = "A request source interrupt is generated upon a request source event (last pending conversion is finished)"]
            VALUE2,
        }
        impl ENSIR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ENSIR::VALUE1 => false,
                    ENSIR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ENSIR {
                match value {
                    false => ENSIR::VALUE1,
                    true => ENSIR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENSIR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENSIR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCAN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCANR {
            #[doc = "No autoscan"]
            VALUE1,
            #[doc = "Autoscan functionality enabled: a request source event automatically generates a load event"]
            VALUE2,
        }
        impl SCANR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCANR::VALUE1 => false,
                    SCANR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCANR {
                match value {
                    false => SCANR::VALUE1,
                    true => SCANR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCANR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCANR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LDM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LDMR {
            #[doc = "Overwrite mode: Copy all bits from the select registers to the pending registers upon a load event"]
            VALUE1,
            #[doc = "Combine mode: Set all pending bits that are set in the select registers upon a load event (logic OR)"]
            VALUE2,
        }
        impl LDMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LDMR::VALUE1 => false,
                    LDMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LDMR {
                match value {
                    false => LDMR::VALUE1,
                    true => LDMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LDMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LDMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REQGT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REQGTR {
            #[doc = "The gate input is low"]
            VALUE1,
            #[doc = "The gate input is high"]
            VALUE2,
        }
        impl REQGTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REQGTR::VALUE1 => false,
                    REQGTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REQGTR {
                match value {
                    false => REQGTR::VALUE1,
                    true => REQGTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REQGTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REQGTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RPTDIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RPTDISR {
            #[doc = "A cancelled conversion is repeated"]
            VALUE1,
            #[doc = "A cancelled conversion is discarded"]
            VALUE2,
        }
        impl RPTDISR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RPTDISR::VALUE1 => false,
                    RPTDISR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RPTDISR {
                match value {
                    false => RPTDISR::VALUE1,
                    true => RPTDISR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RPTDISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RPTDISR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ENGT`"]
        pub enum ENGTW {
            #[doc = "No conversion requests are issued"]
            VALUE1,
            #[doc = "Conversion requests are issued if at least one pending bit is set"]
            VALUE2,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 1."]
            VALUE3,
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 0."]
            VALUE4,
        }
        impl ENGTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENGTW::VALUE1 => 0,
                    ENGTW::VALUE2 => 1,
                    ENGTW::VALUE3 => 2,
                    ENGTW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENGTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENGTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENGTW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No conversion requests are issued"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENGTW::VALUE1)
            }
            #[doc = "Conversion requests are issued if at least one pending bit is set"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENGTW::VALUE2)
            }
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 1."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENGTW::VALUE3)
            }
            #[doc = "Conversion requests are issued if at least one pending bit is set and REQGTx = 0."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ENGTW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENTR`"]
        pub enum ENTRW {
            #[doc = "External trigger disabled"]
            VALUE1,
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the load event"]
            VALUE2,
        }
        impl ENTRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENTRW::VALUE1 => false,
                    ENTRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENTRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENTRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External trigger disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENTRW::VALUE1)
            }
            #[doc = "The selected edge at the selected trigger input signal REQTR generates the load event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENTRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENSI`"]
        pub enum ENSIW {
            #[doc = "No request source interrupt"]
            VALUE1,
            #[doc = "A request source interrupt is generated upon a request source event (last pending conversion is finished)"]
            VALUE2,
        }
        impl ENSIW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ENSIW::VALUE1 => false,
                    ENSIW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENSIW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENSIW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENSIW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No request source interrupt"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENSIW::VALUE1)
            }
            #[doc = "A request source interrupt is generated upon a request source event (last pending conversion is finished)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENSIW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCAN`"]
        pub enum SCANW {
            #[doc = "No autoscan"]
            VALUE1,
            #[doc = "Autoscan functionality enabled: a request source event automatically generates a load event"]
            VALUE2,
        }
        impl SCANW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCANW::VALUE1 => false,
                    SCANW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCANW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCANW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCANW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No autoscan"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCANW::VALUE1)
            }
            #[doc = "Autoscan functionality enabled: a request source event automatically generates a load event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCANW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LDM`"]
        pub enum LDMW {
            #[doc = "Overwrite mode: Copy all bits from the select registers to the pending registers upon a load event"]
            VALUE1,
            #[doc = "Combine mode: Set all pending bits that are set in the select registers upon a load event (logic OR)"]
            VALUE2,
        }
        impl LDMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LDMW::VALUE1 => false,
                    LDMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LDMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Overwrite mode: Copy all bits from the select registers to the pending registers upon a load event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LDMW::VALUE1)
            }
            #[doc = "Combine mode: Set all pending bits that are set in the select registers upon a load event (logic OR)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LDMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CLRPND`"]
        pub enum CLRPNDW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "The bits in register GxASPNDx are cleared"]
            VALUE2,
        }
        impl CLRPNDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CLRPNDW::VALUE1 => false,
                    CLRPNDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLRPNDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLRPNDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLRPNDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CLRPNDW::VALUE1)
            }
            #[doc = "The bits in register GxASPNDx are cleared"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CLRPNDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LDEV`"]
        pub enum LDEVW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "A load event is generated"]
            VALUE2,
        }
        impl LDEVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LDEVW::VALUE1 => false,
                    LDEVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDEVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDEVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LDEVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LDEVW::VALUE1)
            }
            #[doc = "A load event is generated"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LDEVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RPTDIS`"]
        pub enum RPTDISW {
            #[doc = "A cancelled conversion is repeated"]
            VALUE1,
            #[doc = "A cancelled conversion is discarded"]
            VALUE2,
        }
        impl RPTDISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RPTDISW::VALUE1 => false,
                    RPTDISW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPTDISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPTDISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RPTDISW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "A cancelled conversion is repeated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RPTDISW::VALUE1)
            }
            #[doc = "A cancelled conversion is discarded"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RPTDISW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Enable Gate"]
            #[inline]
            pub fn engt(&self) -> ENGTR {
                ENGTR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - Enable External Trigger"]
            #[inline]
            pub fn entr(&self) -> ENTRR {
                ENTRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&self) -> ENSIR {
                ENSIR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Autoscan Enable"]
            #[inline]
            pub fn scan(&self) -> SCANR {
                SCANR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Autoscan Source Load Event Mode"]
            #[inline]
            pub fn ldm(&self) -> LDMR {
                LDMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Request Gate Level"]
            #[inline]
            pub fn reqgt(&self) -> REQGTR {
                REQGTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Repeat Disable"]
            #[inline]
            pub fn rptdis(&self) -> RPTDISR {
                RPTDISR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Enable Gate"]
            #[inline]
            pub fn engt(&mut self) -> _ENGTW {
                _ENGTW { w: self }
            }
            #[doc = "Bit 2 - Enable External Trigger"]
            #[inline]
            pub fn entr(&mut self) -> _ENTRW {
                _ENTRW { w: self }
            }
            #[doc = "Bit 3 - Enable Source Interrupt"]
            #[inline]
            pub fn ensi(&mut self) -> _ENSIW {
                _ENSIW { w: self }
            }
            #[doc = "Bit 4 - Autoscan Enable"]
            #[inline]
            pub fn scan(&mut self) -> _SCANW {
                _SCANW { w: self }
            }
            #[doc = "Bit 5 - Autoscan Source Load Event Mode"]
            #[inline]
            pub fn ldm(&mut self) -> _LDMW {
                _LDMW { w: self }
            }
            #[doc = "Bit 8 - Clear Pending Bits"]
            #[inline]
            pub fn clrpnd(&mut self) -> _CLRPNDW {
                _CLRPNDW { w: self }
            }
            #[doc = "Bit 9 - Generate Load Event"]
            #[inline]
            pub fn ldev(&mut self) -> _LDEVW {
                _LDEVW { w: self }
            }
            #[doc = "Bit 16 - Repeat Disable"]
            #[inline]
            pub fn rptdis(&mut self) -> _RPTDISW {
                _RPTDISW { w: self }
            }
        }
    }
    #[doc = "Autoscan Source Channel Select Register"]
    pub struct ASSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Autoscan Source Channel Select Register"]
    pub mod assel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ASSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CHSEL0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL0R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL0R::VALUE1 => false,
                    CHSEL0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL0R {
                match value {
                    false => CHSEL0R::VALUE1,
                    true => CHSEL0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL1R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL1R::VALUE1 => false,
                    CHSEL1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL1R {
                match value {
                    false => CHSEL1R::VALUE1,
                    true => CHSEL1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL2R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL2R::VALUE1 => false,
                    CHSEL2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL2R {
                match value {
                    false => CHSEL2R::VALUE1,
                    true => CHSEL2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL3R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL3R::VALUE1 => false,
                    CHSEL3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL3R {
                match value {
                    false => CHSEL3R::VALUE1,
                    true => CHSEL3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL4R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL4R::VALUE1 => false,
                    CHSEL4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL4R {
                match value {
                    false => CHSEL4R::VALUE1,
                    true => CHSEL4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL5R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL5R::VALUE1 => false,
                    CHSEL5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL5R {
                match value {
                    false => CHSEL5R::VALUE1,
                    true => CHSEL5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL6R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL6R::VALUE1 => false,
                    CHSEL6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL6R {
                match value {
                    false => CHSEL6R::VALUE1,
                    true => CHSEL6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHSEL7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHSEL7R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHSEL7R::VALUE1 => false,
                    CHSEL7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHSEL7R {
                match value {
                    false => CHSEL7R::VALUE1,
                    true => CHSEL7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHSEL7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHSEL7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CHSEL0`"]
        pub enum CHSEL0W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL0W::VALUE1 => false,
                    CHSEL0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL0W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL1`"]
        pub enum CHSEL1W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL1W::VALUE1 => false,
                    CHSEL1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL1W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL2`"]
        pub enum CHSEL2W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL2W::VALUE1 => false,
                    CHSEL2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL2W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL3`"]
        pub enum CHSEL3W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL3W::VALUE1 => false,
                    CHSEL3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL3W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL4`"]
        pub enum CHSEL4W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL4W::VALUE1 => false,
                    CHSEL4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL4W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL5`"]
        pub enum CHSEL5W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL5W::VALUE1 => false,
                    CHSEL5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL5W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL6`"]
        pub enum CHSEL6W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL6W::VALUE1 => false,
                    CHSEL6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL6W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHSEL7`"]
        pub enum CHSEL7W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "This channel is part of the scan sequence"]
            VALUE2,
        }
        impl CHSEL7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHSEL7W::VALUE1 => false,
                    CHSEL7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHSEL7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHSEL7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHSEL7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHSEL7W::VALUE1)
            }
            #[doc = "This channel is part of the scan sequence"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHSEL7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Channel Selection"]
            #[inline]
            pub fn chsel0(&self) -> CHSEL0R {
                CHSEL0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Channel Selection"]
            #[inline]
            pub fn chsel1(&self) -> CHSEL1R {
                CHSEL1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channel Selection"]
            #[inline]
            pub fn chsel2(&self) -> CHSEL2R {
                CHSEL2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channel Selection"]
            #[inline]
            pub fn chsel3(&self) -> CHSEL3R {
                CHSEL3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channel Selection"]
            #[inline]
            pub fn chsel4(&self) -> CHSEL4R {
                CHSEL4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channel Selection"]
            #[inline]
            pub fn chsel5(&self) -> CHSEL5R {
                CHSEL5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Channel Selection"]
            #[inline]
            pub fn chsel6(&self) -> CHSEL6R {
                CHSEL6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Channel Selection"]
            #[inline]
            pub fn chsel7(&self) -> CHSEL7R {
                CHSEL7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Channel Selection"]
            #[inline]
            pub fn chsel0(&mut self) -> _CHSEL0W {
                _CHSEL0W { w: self }
            }
            #[doc = "Bit 1 - Channel Selection"]
            #[inline]
            pub fn chsel1(&mut self) -> _CHSEL1W {
                _CHSEL1W { w: self }
            }
            #[doc = "Bit 2 - Channel Selection"]
            #[inline]
            pub fn chsel2(&mut self) -> _CHSEL2W {
                _CHSEL2W { w: self }
            }
            #[doc = "Bit 3 - Channel Selection"]
            #[inline]
            pub fn chsel3(&mut self) -> _CHSEL3W {
                _CHSEL3W { w: self }
            }
            #[doc = "Bit 4 - Channel Selection"]
            #[inline]
            pub fn chsel4(&mut self) -> _CHSEL4W {
                _CHSEL4W { w: self }
            }
            #[doc = "Bit 5 - Channel Selection"]
            #[inline]
            pub fn chsel5(&mut self) -> _CHSEL5W {
                _CHSEL5W { w: self }
            }
            #[doc = "Bit 6 - Channel Selection"]
            #[inline]
            pub fn chsel6(&mut self) -> _CHSEL6W {
                _CHSEL6W { w: self }
            }
            #[doc = "Bit 7 - Channel Selection"]
            #[inline]
            pub fn chsel7(&mut self) -> _CHSEL7W {
                _CHSEL7W { w: self }
            }
        }
    }
    #[doc = "Autoscan Source Pending Register"]
    pub struct ASPND {
        register: VolatileCell<u32>,
    }
    #[doc = "Autoscan Source Pending Register"]
    pub mod aspnd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::ASPND {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CHPND0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND0R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND0R::VALUE1 => false,
                    CHPND0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND0R {
                match value {
                    false => CHPND0R::VALUE1,
                    true => CHPND0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND1R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND1R::VALUE1 => false,
                    CHPND1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND1R {
                match value {
                    false => CHPND1R::VALUE1,
                    true => CHPND1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND2R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND2R::VALUE1 => false,
                    CHPND2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND2R {
                match value {
                    false => CHPND2R::VALUE1,
                    true => CHPND2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND3R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND3R::VALUE1 => false,
                    CHPND3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND3R {
                match value {
                    false => CHPND3R::VALUE1,
                    true => CHPND3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND4R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND4R::VALUE1 => false,
                    CHPND4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND4R {
                match value {
                    false => CHPND4R::VALUE1,
                    true => CHPND4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND5R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND5R::VALUE1 => false,
                    CHPND5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND5R {
                match value {
                    false => CHPND5R::VALUE1,
                    true => CHPND5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND6R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND6R::VALUE1 => false,
                    CHPND6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND6R {
                match value {
                    false => CHPND6R::VALUE1,
                    true => CHPND6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHPND7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHPND7R {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHPND7R::VALUE1 => false,
                    CHPND7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHPND7R {
                match value {
                    false => CHPND7R::VALUE1,
                    true => CHPND7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHPND7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHPND7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CHPND0`"]
        pub enum CHPND0W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND0W::VALUE1 => false,
                    CHPND0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND0W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND1`"]
        pub enum CHPND1W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND1W::VALUE1 => false,
                    CHPND1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND1W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND2`"]
        pub enum CHPND2W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND2W::VALUE1 => false,
                    CHPND2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND2W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND3`"]
        pub enum CHPND3W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND3W::VALUE1 => false,
                    CHPND3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND3W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND4`"]
        pub enum CHPND4W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND4W::VALUE1 => false,
                    CHPND4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND4W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND5`"]
        pub enum CHPND5W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND5W::VALUE1 => false,
                    CHPND5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND5W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND6`"]
        pub enum CHPND6W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND6W::VALUE1 => false,
                    CHPND6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND6W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHPND7`"]
        pub enum CHPND7W {
            #[doc = "Ignore this channel"]
            VALUE1,
            #[doc = "Request conversion of this channel"]
            VALUE2,
        }
        impl CHPND7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHPND7W::VALUE1 => false,
                    CHPND7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHPND7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHPND7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHPND7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Ignore this channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHPND7W::VALUE1)
            }
            #[doc = "Request conversion of this channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHPND7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Channels Pending"]
            #[inline]
            pub fn chpnd0(&self) -> CHPND0R {
                CHPND0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Channels Pending"]
            #[inline]
            pub fn chpnd1(&self) -> CHPND1R {
                CHPND1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channels Pending"]
            #[inline]
            pub fn chpnd2(&self) -> CHPND2R {
                CHPND2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channels Pending"]
            #[inline]
            pub fn chpnd3(&self) -> CHPND3R {
                CHPND3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channels Pending"]
            #[inline]
            pub fn chpnd4(&self) -> CHPND4R {
                CHPND4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channels Pending"]
            #[inline]
            pub fn chpnd5(&self) -> CHPND5R {
                CHPND5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Channels Pending"]
            #[inline]
            pub fn chpnd6(&self) -> CHPND6R {
                CHPND6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Channels Pending"]
            #[inline]
            pub fn chpnd7(&self) -> CHPND7R {
                CHPND7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Channels Pending"]
            #[inline]
            pub fn chpnd0(&mut self) -> _CHPND0W {
                _CHPND0W { w: self }
            }
            #[doc = "Bit 1 - Channels Pending"]
            #[inline]
            pub fn chpnd1(&mut self) -> _CHPND1W {
                _CHPND1W { w: self }
            }
            #[doc = "Bit 2 - Channels Pending"]
            #[inline]
            pub fn chpnd2(&mut self) -> _CHPND2W {
                _CHPND2W { w: self }
            }
            #[doc = "Bit 3 - Channels Pending"]
            #[inline]
            pub fn chpnd3(&mut self) -> _CHPND3W {
                _CHPND3W { w: self }
            }
            #[doc = "Bit 4 - Channels Pending"]
            #[inline]
            pub fn chpnd4(&mut self) -> _CHPND4W {
                _CHPND4W { w: self }
            }
            #[doc = "Bit 5 - Channels Pending"]
            #[inline]
            pub fn chpnd5(&mut self) -> _CHPND5W {
                _CHPND5W { w: self }
            }
            #[doc = "Bit 6 - Channels Pending"]
            #[inline]
            pub fn chpnd6(&mut self) -> _CHPND6W {
                _CHPND6W { w: self }
            }
            #[doc = "Bit 7 - Channels Pending"]
            #[inline]
            pub fn chpnd7(&mut self) -> _CHPND7W {
                _CHPND7W { w: self }
            }
        }
    }
    #[doc = "Channel Event Flag Register"]
    pub struct CEFLAG {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Event Flag Register"]
    pub mod ceflag {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CEFLAG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CEV0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV0R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV0R::VALUE1 => false,
                    CEV0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV0R {
                match value {
                    false => CEV0R::VALUE1,
                    true => CEV0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV1R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV1R::VALUE1 => false,
                    CEV1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV1R {
                match value {
                    false => CEV1R::VALUE1,
                    true => CEV1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV2R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV2R::VALUE1 => false,
                    CEV2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV2R {
                match value {
                    false => CEV2R::VALUE1,
                    true => CEV2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV3R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV3R::VALUE1 => false,
                    CEV3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV3R {
                match value {
                    false => CEV3R::VALUE1,
                    true => CEV3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV4R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV4R::VALUE1 => false,
                    CEV4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV4R {
                match value {
                    false => CEV4R::VALUE1,
                    true => CEV4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV5R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV5R::VALUE1 => false,
                    CEV5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV5R {
                match value {
                    false => CEV5R::VALUE1,
                    true => CEV5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV6R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV6R::VALUE1 => false,
                    CEV6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV6R {
                match value {
                    false => CEV6R::VALUE1,
                    true => CEV6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `CEV7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV7R {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CEV7R::VALUE1 => false,
                    CEV7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CEV7R {
                match value {
                    false => CEV7R::VALUE1,
                    true => CEV7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV7R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `CEV0`"]
        pub enum CEV0W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV0W::VALUE1 => false,
                    CEV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV0W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV1`"]
        pub enum CEV1W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV1W::VALUE1 => false,
                    CEV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV1W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV2`"]
        pub enum CEV2W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV2W::VALUE1 => false,
                    CEV2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV2W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV3`"]
        pub enum CEV3W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV3W::VALUE1 => false,
                    CEV3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV3W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV4`"]
        pub enum CEV4W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV4W::VALUE1 => false,
                    CEV4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV4W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV5`"]
        pub enum CEV5W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV5W::VALUE1 => false,
                    CEV5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV5W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV6`"]
        pub enum CEV6W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV6W::VALUE1 => false,
                    CEV6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV6W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV7`"]
        pub enum CEV7W {
            #[doc = "No channel event"]
            VALUE1,
            #[doc = "A channel event has occurred"]
            VALUE2,
        }
        impl CEV7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV7W::VALUE1 => false,
                    CEV7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No channel event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV7W::VALUE1)
            }
            #[doc = "A channel event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Channel Event for Channel 0"]
            #[inline]
            pub fn cev0(&self) -> CEV0R {
                CEV0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Channel Event for Channel 1"]
            #[inline]
            pub fn cev1(&self) -> CEV1R {
                CEV1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channel Event for Channel 2"]
            #[inline]
            pub fn cev2(&self) -> CEV2R {
                CEV2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channel Event for Channel 3"]
            #[inline]
            pub fn cev3(&self) -> CEV3R {
                CEV3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channel Event for Channel 4"]
            #[inline]
            pub fn cev4(&self) -> CEV4R {
                CEV4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channel Event for Channel 5"]
            #[inline]
            pub fn cev5(&self) -> CEV5R {
                CEV5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Channel Event for Channel 6"]
            #[inline]
            pub fn cev6(&self) -> CEV6R {
                CEV6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Channel Event for Channel 7"]
            #[inline]
            pub fn cev7(&self) -> CEV7R {
                CEV7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Channel Event for Channel 0"]
            #[inline]
            pub fn cev0(&mut self) -> _CEV0W {
                _CEV0W { w: self }
            }
            #[doc = "Bit 1 - Channel Event for Channel 1"]
            #[inline]
            pub fn cev1(&mut self) -> _CEV1W {
                _CEV1W { w: self }
            }
            #[doc = "Bit 2 - Channel Event for Channel 2"]
            #[inline]
            pub fn cev2(&mut self) -> _CEV2W {
                _CEV2W { w: self }
            }
            #[doc = "Bit 3 - Channel Event for Channel 3"]
            #[inline]
            pub fn cev3(&mut self) -> _CEV3W {
                _CEV3W { w: self }
            }
            #[doc = "Bit 4 - Channel Event for Channel 4"]
            #[inline]
            pub fn cev4(&mut self) -> _CEV4W {
                _CEV4W { w: self }
            }
            #[doc = "Bit 5 - Channel Event for Channel 5"]
            #[inline]
            pub fn cev5(&mut self) -> _CEV5W {
                _CEV5W { w: self }
            }
            #[doc = "Bit 6 - Channel Event for Channel 6"]
            #[inline]
            pub fn cev6(&mut self) -> _CEV6W {
                _CEV6W { w: self }
            }
            #[doc = "Bit 7 - Channel Event for Channel 7"]
            #[inline]
            pub fn cev7(&mut self) -> _CEV7W {
                _CEV7W { w: self }
            }
        }
    }
    #[doc = "Result Event Flag Register"]
    pub struct REFLAG {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Event Flag Register"]
    pub mod reflag {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::REFLAG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `REV0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV0R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV0R::VALUE1 => false,
                    REV0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV0R {
                match value {
                    false => REV0R::VALUE1,
                    true => REV0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV1R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV1R::VALUE1 => false,
                    REV1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV1R {
                match value {
                    false => REV1R::VALUE1,
                    true => REV1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV2R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV2R::VALUE1 => false,
                    REV2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV2R {
                match value {
                    false => REV2R::VALUE1,
                    true => REV2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV3R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV3R::VALUE1 => false,
                    REV3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV3R {
                match value {
                    false => REV3R::VALUE1,
                    true => REV3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV4R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV4R::VALUE1 => false,
                    REV4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV4R {
                match value {
                    false => REV4R::VALUE1,
                    true => REV4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV5R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV5R::VALUE1 => false,
                    REV5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV5R {
                match value {
                    false => REV5R::VALUE1,
                    true => REV5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV6R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV6R::VALUE1 => false,
                    REV6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV6R {
                match value {
                    false => REV6R::VALUE1,
                    true => REV6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV7R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV7R::VALUE1 => false,
                    REV7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV7R {
                match value {
                    false => REV7R::VALUE1,
                    true => REV7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV8R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV8R::VALUE1 => false,
                    REV8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV8R {
                match value {
                    false => REV8R::VALUE1,
                    true => REV8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV9R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV9R::VALUE1 => false,
                    REV9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV9R {
                match value {
                    false => REV9R::VALUE1,
                    true => REV9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV10R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV10R::VALUE1 => false,
                    REV10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV10R {
                match value {
                    false => REV10R::VALUE1,
                    true => REV10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV11R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV11R::VALUE1 => false,
                    REV11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV11R {
                match value {
                    false => REV11R::VALUE1,
                    true => REV11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV12R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV12R::VALUE1 => false,
                    REV12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV12R {
                match value {
                    false => REV12R::VALUE1,
                    true => REV12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV13R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV13R::VALUE1 => false,
                    REV13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV13R {
                match value {
                    false => REV13R::VALUE1,
                    true => REV13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV14R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV14R::VALUE1 => false,
                    REV14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV14R {
                match value {
                    false => REV14R::VALUE1,
                    true => REV14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `REV15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV15R {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REV15R::VALUE1 => false,
                    REV15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REV15R {
                match value {
                    false => REV15R::VALUE1,
                    true => REV15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `REV0`"]
        pub enum REV0W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV0W::VALUE1 => false,
                    REV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV0W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV1`"]
        pub enum REV1W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV1W::VALUE1 => false,
                    REV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV1W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV2`"]
        pub enum REV2W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV2W::VALUE1 => false,
                    REV2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV2W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV3`"]
        pub enum REV3W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV3W::VALUE1 => false,
                    REV3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV3W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV4`"]
        pub enum REV4W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV4W::VALUE1 => false,
                    REV4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV4W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV5`"]
        pub enum REV5W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV5W::VALUE1 => false,
                    REV5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV5W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV6`"]
        pub enum REV6W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV6W::VALUE1 => false,
                    REV6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV6W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV7`"]
        pub enum REV7W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV7W::VALUE1 => false,
                    REV7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV7W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV8`"]
        pub enum REV8W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV8W::VALUE1 => false,
                    REV8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV8W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV9`"]
        pub enum REV9W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV9W::VALUE1 => false,
                    REV9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV9W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV10`"]
        pub enum REV10W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV10W::VALUE1 => false,
                    REV10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV10W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV11`"]
        pub enum REV11W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV11W::VALUE1 => false,
                    REV11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV11W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV12`"]
        pub enum REV12W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV12W::VALUE1 => false,
                    REV12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV12W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV13`"]
        pub enum REV13W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV13W::VALUE1 => false,
                    REV13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV13W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV14`"]
        pub enum REV14W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV14W::VALUE1 => false,
                    REV14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV14W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV15`"]
        pub enum REV15W {
            #[doc = "No result event"]
            VALUE1,
            #[doc = "New result was stored in register GxRESy"]
            VALUE2,
        }
        impl REV15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV15W::VALUE1 => false,
                    REV15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No result event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV15W::VALUE1)
            }
            #[doc = "New result was stored in register GxRESy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Result Event for Result Register 0"]
            #[inline]
            pub fn rev0(&self) -> REV0R {
                REV0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Result Event for Result Register 1"]
            #[inline]
            pub fn rev1(&self) -> REV1R {
                REV1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Result Event for Result Register 2"]
            #[inline]
            pub fn rev2(&self) -> REV2R {
                REV2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Result Event for Result Register 3"]
            #[inline]
            pub fn rev3(&self) -> REV3R {
                REV3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Result Event for Result Register 4"]
            #[inline]
            pub fn rev4(&self) -> REV4R {
                REV4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Result Event for Result Register 5"]
            #[inline]
            pub fn rev5(&self) -> REV5R {
                REV5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Result Event for Result Register 6"]
            #[inline]
            pub fn rev6(&self) -> REV6R {
                REV6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Result Event for Result Register 7"]
            #[inline]
            pub fn rev7(&self) -> REV7R {
                REV7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Result Event for Result Register 8"]
            #[inline]
            pub fn rev8(&self) -> REV8R {
                REV8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Result Event for Result Register 9"]
            #[inline]
            pub fn rev9(&self) -> REV9R {
                REV9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Result Event for Result Register 10"]
            #[inline]
            pub fn rev10(&self) -> REV10R {
                REV10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Result Event for Result Register 11"]
            #[inline]
            pub fn rev11(&self) -> REV11R {
                REV11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Result Event for Result Register 12"]
            #[inline]
            pub fn rev12(&self) -> REV12R {
                REV12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Result Event for Result Register 13"]
            #[inline]
            pub fn rev13(&self) -> REV13R {
                REV13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Result Event for Result Register 14"]
            #[inline]
            pub fn rev14(&self) -> REV14R {
                REV14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Result Event for Result Register 15"]
            #[inline]
            pub fn rev15(&self) -> REV15R {
                REV15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Result Event for Result Register 0"]
            #[inline]
            pub fn rev0(&mut self) -> _REV0W {
                _REV0W { w: self }
            }
            #[doc = "Bit 1 - Result Event for Result Register 1"]
            #[inline]
            pub fn rev1(&mut self) -> _REV1W {
                _REV1W { w: self }
            }
            #[doc = "Bit 2 - Result Event for Result Register 2"]
            #[inline]
            pub fn rev2(&mut self) -> _REV2W {
                _REV2W { w: self }
            }
            #[doc = "Bit 3 - Result Event for Result Register 3"]
            #[inline]
            pub fn rev3(&mut self) -> _REV3W {
                _REV3W { w: self }
            }
            #[doc = "Bit 4 - Result Event for Result Register 4"]
            #[inline]
            pub fn rev4(&mut self) -> _REV4W {
                _REV4W { w: self }
            }
            #[doc = "Bit 5 - Result Event for Result Register 5"]
            #[inline]
            pub fn rev5(&mut self) -> _REV5W {
                _REV5W { w: self }
            }
            #[doc = "Bit 6 - Result Event for Result Register 6"]
            #[inline]
            pub fn rev6(&mut self) -> _REV6W {
                _REV6W { w: self }
            }
            #[doc = "Bit 7 - Result Event for Result Register 7"]
            #[inline]
            pub fn rev7(&mut self) -> _REV7W {
                _REV7W { w: self }
            }
            #[doc = "Bit 8 - Result Event for Result Register 8"]
            #[inline]
            pub fn rev8(&mut self) -> _REV8W {
                _REV8W { w: self }
            }
            #[doc = "Bit 9 - Result Event for Result Register 9"]
            #[inline]
            pub fn rev9(&mut self) -> _REV9W {
                _REV9W { w: self }
            }
            #[doc = "Bit 10 - Result Event for Result Register 10"]
            #[inline]
            pub fn rev10(&mut self) -> _REV10W {
                _REV10W { w: self }
            }
            #[doc = "Bit 11 - Result Event for Result Register 11"]
            #[inline]
            pub fn rev11(&mut self) -> _REV11W {
                _REV11W { w: self }
            }
            #[doc = "Bit 12 - Result Event for Result Register 12"]
            #[inline]
            pub fn rev12(&mut self) -> _REV12W {
                _REV12W { w: self }
            }
            #[doc = "Bit 13 - Result Event for Result Register 13"]
            #[inline]
            pub fn rev13(&mut self) -> _REV13W {
                _REV13W { w: self }
            }
            #[doc = "Bit 14 - Result Event for Result Register 14"]
            #[inline]
            pub fn rev14(&mut self) -> _REV14W {
                _REV14W { w: self }
            }
            #[doc = "Bit 15 - Result Event for Result Register 15"]
            #[inline]
            pub fn rev15(&mut self) -> _REV15W {
                _REV15W { w: self }
            }
        }
    }
    #[doc = "Source Event Flag Register"]
    pub struct SEFLAG {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Event Flag Register"]
    pub mod seflag {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SEFLAG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SEV0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEV0R {
            #[doc = "No source event"]
            VALUE1,
            #[doc = "A source event has occurred"]
            VALUE2,
        }
        impl SEV0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SEV0R::VALUE1 => false,
                    SEV0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SEV0R {
                match value {
                    false => SEV0R::VALUE1,
                    true => SEV0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEV0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEV0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `SEV1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEV1R {
            #[doc = "No source event"]
            VALUE1,
            #[doc = "A source event has occurred"]
            VALUE2,
        }
        impl SEV1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SEV1R::VALUE1 => false,
                    SEV1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SEV1R {
                match value {
                    false => SEV1R::VALUE1,
                    true => SEV1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEV1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEV1R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SEV0`"]
        pub enum SEV0W {
            #[doc = "No source event"]
            VALUE1,
            #[doc = "A source event has occurred"]
            VALUE2,
        }
        impl SEV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEV0W::VALUE1 => false,
                    SEV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No source event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV0W::VALUE1)
            }
            #[doc = "A source event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SEV1`"]
        pub enum SEV1W {
            #[doc = "No source event"]
            VALUE1,
            #[doc = "A source event has occurred"]
            VALUE2,
        }
        impl SEV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEV1W::VALUE1 => false,
                    SEV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No source event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV1W::VALUE1)
            }
            #[doc = "A source event has occurred"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source Event 0/1"]
            #[inline]
            pub fn sev0(&self) -> SEV0R {
                SEV0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Source Event 0/1"]
            #[inline]
            pub fn sev1(&self) -> SEV1R {
                SEV1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Source Event 0/1"]
            #[inline]
            pub fn sev0(&mut self) -> _SEV0W {
                _SEV0W { w: self }
            }
            #[doc = "Bit 1 - Source Event 0/1"]
            #[inline]
            pub fn sev1(&mut self) -> _SEV1W {
                _SEV1W { w: self }
            }
        }
    }
    #[doc = "Channel Event Flag Clear Register"]
    pub struct CEFCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Event Flag Clear Register"]
    pub mod cefclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CEFCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `CEV0`"]
        pub enum CEV0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV0W::VALUE1 => false,
                    CEV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV0W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV1`"]
        pub enum CEV1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV1W::VALUE1 => false,
                    CEV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV1W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV2`"]
        pub enum CEV2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV2W::VALUE1 => false,
                    CEV2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV2W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV3`"]
        pub enum CEV3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV3W::VALUE1 => false,
                    CEV3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV3W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV4`"]
        pub enum CEV4W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV4W::VALUE1 => false,
                    CEV4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV4W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV5`"]
        pub enum CEV5W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV5W::VALUE1 => false,
                    CEV5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV5W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV6`"]
        pub enum CEV6W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV6W::VALUE1 => false,
                    CEV6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV6W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV7`"]
        pub enum CEV7W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            VALUE2,
        }
        impl CEV7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CEV7W::VALUE1 => false,
                    CEV7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV7W::VALUE1)
            }
            #[doc = "Clear the channel event flag in GxCEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Channel Event for Channel 0"]
            #[inline]
            pub fn cev0(&mut self) -> _CEV0W {
                _CEV0W { w: self }
            }
            #[doc = "Bit 1 - Clear Channel Event for Channel 1"]
            #[inline]
            pub fn cev1(&mut self) -> _CEV1W {
                _CEV1W { w: self }
            }
            #[doc = "Bit 2 - Clear Channel Event for Channel 2"]
            #[inline]
            pub fn cev2(&mut self) -> _CEV2W {
                _CEV2W { w: self }
            }
            #[doc = "Bit 3 - Clear Channel Event for Channel 3"]
            #[inline]
            pub fn cev3(&mut self) -> _CEV3W {
                _CEV3W { w: self }
            }
            #[doc = "Bit 4 - Clear Channel Event for Channel 4"]
            #[inline]
            pub fn cev4(&mut self) -> _CEV4W {
                _CEV4W { w: self }
            }
            #[doc = "Bit 5 - Clear Channel Event for Channel 5"]
            #[inline]
            pub fn cev5(&mut self) -> _CEV5W {
                _CEV5W { w: self }
            }
            #[doc = "Bit 6 - Clear Channel Event for Channel 6"]
            #[inline]
            pub fn cev6(&mut self) -> _CEV6W {
                _CEV6W { w: self }
            }
            #[doc = "Bit 7 - Clear Channel Event for Channel 7"]
            #[inline]
            pub fn cev7(&mut self) -> _CEV7W {
                _CEV7W { w: self }
            }
        }
    }
    #[doc = "Result Event Flag Clear Register"]
    pub struct REFCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Event Flag Clear Register"]
    pub mod refclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::REFCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `REV0`"]
        pub enum REV0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV0W::VALUE1 => false,
                    REV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV0W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV1`"]
        pub enum REV1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV1W::VALUE1 => false,
                    REV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV1W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV2`"]
        pub enum REV2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV2W::VALUE1 => false,
                    REV2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV2W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV3`"]
        pub enum REV3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV3W::VALUE1 => false,
                    REV3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV3W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV4`"]
        pub enum REV4W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV4W::VALUE1 => false,
                    REV4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV4W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV5`"]
        pub enum REV5W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV5W::VALUE1 => false,
                    REV5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV5W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV6`"]
        pub enum REV6W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV6W::VALUE1 => false,
                    REV6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV6W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV7`"]
        pub enum REV7W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV7W::VALUE1 => false,
                    REV7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV7W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV8`"]
        pub enum REV8W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV8W::VALUE1 => false,
                    REV8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV8W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV9`"]
        pub enum REV9W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV9W::VALUE1 => false,
                    REV9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV9W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV10`"]
        pub enum REV10W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV10W::VALUE1 => false,
                    REV10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV10W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV11`"]
        pub enum REV11W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV11W::VALUE1 => false,
                    REV11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV11W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV12`"]
        pub enum REV12W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV12W::VALUE1 => false,
                    REV12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV12W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV13`"]
        pub enum REV13W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV13W::VALUE1 => false,
                    REV13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV13W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV14`"]
        pub enum REV14W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV14W::VALUE1 => false,
                    REV14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV14W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV15`"]
        pub enum REV15W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the result event flag in GxREFLAG"]
            VALUE2,
        }
        impl REV15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REV15W::VALUE1 => false,
                    REV15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV15W::VALUE1)
            }
            #[doc = "Clear the result event flag in GxREFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Result Event for Result Register 0"]
            #[inline]
            pub fn rev0(&mut self) -> _REV0W {
                _REV0W { w: self }
            }
            #[doc = "Bit 1 - Clear Result Event for Result Register 1"]
            #[inline]
            pub fn rev1(&mut self) -> _REV1W {
                _REV1W { w: self }
            }
            #[doc = "Bit 2 - Clear Result Event for Result Register 2"]
            #[inline]
            pub fn rev2(&mut self) -> _REV2W {
                _REV2W { w: self }
            }
            #[doc = "Bit 3 - Clear Result Event for Result Register 3"]
            #[inline]
            pub fn rev3(&mut self) -> _REV3W {
                _REV3W { w: self }
            }
            #[doc = "Bit 4 - Clear Result Event for Result Register 4"]
            #[inline]
            pub fn rev4(&mut self) -> _REV4W {
                _REV4W { w: self }
            }
            #[doc = "Bit 5 - Clear Result Event for Result Register 5"]
            #[inline]
            pub fn rev5(&mut self) -> _REV5W {
                _REV5W { w: self }
            }
            #[doc = "Bit 6 - Clear Result Event for Result Register 6"]
            #[inline]
            pub fn rev6(&mut self) -> _REV6W {
                _REV6W { w: self }
            }
            #[doc = "Bit 7 - Clear Result Event for Result Register 7"]
            #[inline]
            pub fn rev7(&mut self) -> _REV7W {
                _REV7W { w: self }
            }
            #[doc = "Bit 8 - Clear Result Event for Result Register 8"]
            #[inline]
            pub fn rev8(&mut self) -> _REV8W {
                _REV8W { w: self }
            }
            #[doc = "Bit 9 - Clear Result Event for Result Register 9"]
            #[inline]
            pub fn rev9(&mut self) -> _REV9W {
                _REV9W { w: self }
            }
            #[doc = "Bit 10 - Clear Result Event for Result Register 10"]
            #[inline]
            pub fn rev10(&mut self) -> _REV10W {
                _REV10W { w: self }
            }
            #[doc = "Bit 11 - Clear Result Event for Result Register 11"]
            #[inline]
            pub fn rev11(&mut self) -> _REV11W {
                _REV11W { w: self }
            }
            #[doc = "Bit 12 - Clear Result Event for Result Register 12"]
            #[inline]
            pub fn rev12(&mut self) -> _REV12W {
                _REV12W { w: self }
            }
            #[doc = "Bit 13 - Clear Result Event for Result Register 13"]
            #[inline]
            pub fn rev13(&mut self) -> _REV13W {
                _REV13W { w: self }
            }
            #[doc = "Bit 14 - Clear Result Event for Result Register 14"]
            #[inline]
            pub fn rev14(&mut self) -> _REV14W {
                _REV14W { w: self }
            }
            #[doc = "Bit 15 - Clear Result Event for Result Register 15"]
            #[inline]
            pub fn rev15(&mut self) -> _REV15W {
                _REV15W { w: self }
            }
        }
    }
    #[doc = "Source Event Flag Clear Register"]
    pub struct SEFCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Event Flag Clear Register"]
    pub mod sefclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SEFCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `SEV0`"]
        pub enum SEV0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the source event flag in GxSEFLAG"]
            VALUE2,
        }
        impl SEV0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEV0W::VALUE1 => false,
                    SEV0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV0W::VALUE1)
            }
            #[doc = "Clear the source event flag in GxSEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SEV1`"]
        pub enum SEV1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Clear the source event flag in GxSEFLAG"]
            VALUE2,
        }
        impl SEV1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SEV1W::VALUE1 => false,
                    SEV1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV1W::VALUE1)
            }
            #[doc = "Clear the source event flag in GxSEFLAG"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Source Event 0/1"]
            #[inline]
            pub fn sev0(&mut self) -> _SEV0W {
                _SEV0W { w: self }
            }
            #[doc = "Bit 1 - Clear Source Event 0/1"]
            #[inline]
            pub fn sev1(&mut self) -> _SEV1W {
                _SEV1W { w: self }
            }
        }
    }
    #[doc = "Channel Event Node Pointer Register 0"]
    pub struct CEVNP0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Event Node Pointer Register 0"]
    pub mod cevnp0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CEVNP0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CEV0NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV0NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV0NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV0NPR::VALUE1 => 0,
                    CEV0NPR::VALUE2 => 0x03,
                    CEV0NPR::VALUE3 => 0x04,
                    CEV0NPR::VALUE4 => 0x07,
                    CEV0NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV0NPR {
                match value {
                    0 => CEV0NPR::VALUE1,
                    3 => CEV0NPR::VALUE2,
                    4 => CEV0NPR::VALUE3,
                    7 => CEV0NPR::VALUE4,
                    i => CEV0NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV0NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV0NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV0NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV0NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV1NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV1NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV1NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV1NPR::VALUE1 => 0,
                    CEV1NPR::VALUE2 => 0x03,
                    CEV1NPR::VALUE3 => 0x04,
                    CEV1NPR::VALUE4 => 0x07,
                    CEV1NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV1NPR {
                match value {
                    0 => CEV1NPR::VALUE1,
                    3 => CEV1NPR::VALUE2,
                    4 => CEV1NPR::VALUE3,
                    7 => CEV1NPR::VALUE4,
                    i => CEV1NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV1NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV1NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV1NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV1NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV2NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV2NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV2NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV2NPR::VALUE1 => 0,
                    CEV2NPR::VALUE2 => 0x03,
                    CEV2NPR::VALUE3 => 0x04,
                    CEV2NPR::VALUE4 => 0x07,
                    CEV2NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV2NPR {
                match value {
                    0 => CEV2NPR::VALUE1,
                    3 => CEV2NPR::VALUE2,
                    4 => CEV2NPR::VALUE3,
                    7 => CEV2NPR::VALUE4,
                    i => CEV2NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV2NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV2NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV2NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV2NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV3NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV3NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV3NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV3NPR::VALUE1 => 0,
                    CEV3NPR::VALUE2 => 0x03,
                    CEV3NPR::VALUE3 => 0x04,
                    CEV3NPR::VALUE4 => 0x07,
                    CEV3NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV3NPR {
                match value {
                    0 => CEV3NPR::VALUE1,
                    3 => CEV3NPR::VALUE2,
                    4 => CEV3NPR::VALUE3,
                    7 => CEV3NPR::VALUE4,
                    i => CEV3NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV3NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV3NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV3NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV3NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV4NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV4NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV4NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV4NPR::VALUE1 => 0,
                    CEV4NPR::VALUE2 => 0x03,
                    CEV4NPR::VALUE3 => 0x04,
                    CEV4NPR::VALUE4 => 0x07,
                    CEV4NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV4NPR {
                match value {
                    0 => CEV4NPR::VALUE1,
                    3 => CEV4NPR::VALUE2,
                    4 => CEV4NPR::VALUE3,
                    7 => CEV4NPR::VALUE4,
                    i => CEV4NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV4NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV4NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV4NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV4NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV5NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV5NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV5NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV5NPR::VALUE1 => 0,
                    CEV5NPR::VALUE2 => 0x03,
                    CEV5NPR::VALUE3 => 0x04,
                    CEV5NPR::VALUE4 => 0x07,
                    CEV5NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV5NPR {
                match value {
                    0 => CEV5NPR::VALUE1,
                    3 => CEV5NPR::VALUE2,
                    4 => CEV5NPR::VALUE3,
                    7 => CEV5NPR::VALUE4,
                    i => CEV5NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV5NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV5NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV5NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV5NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV6NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV6NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV6NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV6NPR::VALUE1 => 0,
                    CEV6NPR::VALUE2 => 0x03,
                    CEV6NPR::VALUE3 => 0x04,
                    CEV6NPR::VALUE4 => 0x07,
                    CEV6NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV6NPR {
                match value {
                    0 => CEV6NPR::VALUE1,
                    3 => CEV6NPR::VALUE2,
                    4 => CEV6NPR::VALUE3,
                    7 => CEV6NPR::VALUE4,
                    i => CEV6NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV6NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV6NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV6NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV6NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CEV7NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CEV7NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CEV7NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CEV7NPR::VALUE1 => 0,
                    CEV7NPR::VALUE2 => 0x03,
                    CEV7NPR::VALUE3 => 0x04,
                    CEV7NPR::VALUE4 => 0x07,
                    CEV7NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CEV7NPR {
                match value {
                    0 => CEV7NPR::VALUE1,
                    3 => CEV7NPR::VALUE2,
                    4 => CEV7NPR::VALUE3,
                    7 => CEV7NPR::VALUE4,
                    i => CEV7NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CEV7NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CEV7NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CEV7NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CEV7NPR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `CEV0NP`"]
        pub enum CEV0NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV0NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV0NPW::VALUE1 => 0,
                    CEV0NPW::VALUE2 => 3,
                    CEV0NPW::VALUE3 => 4,
                    CEV0NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV0NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV0NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV0NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV0NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV0NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV0NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV0NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV1NP`"]
        pub enum CEV1NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV1NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV1NPW::VALUE1 => 0,
                    CEV1NPW::VALUE2 => 3,
                    CEV1NPW::VALUE3 => 4,
                    CEV1NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV1NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV1NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV1NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV1NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV1NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV1NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV1NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV2NP`"]
        pub enum CEV2NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV2NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV2NPW::VALUE1 => 0,
                    CEV2NPW::VALUE2 => 3,
                    CEV2NPW::VALUE3 => 4,
                    CEV2NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV2NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV2NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV2NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV2NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV2NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV2NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV2NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV3NP`"]
        pub enum CEV3NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV3NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV3NPW::VALUE1 => 0,
                    CEV3NPW::VALUE2 => 3,
                    CEV3NPW::VALUE3 => 4,
                    CEV3NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV3NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV3NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV3NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV3NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV3NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV3NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV3NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV4NP`"]
        pub enum CEV4NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV4NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV4NPW::VALUE1 => 0,
                    CEV4NPW::VALUE2 => 3,
                    CEV4NPW::VALUE3 => 4,
                    CEV4NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV4NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV4NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV4NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV4NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV4NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV4NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV4NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV5NP`"]
        pub enum CEV5NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV5NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV5NPW::VALUE1 => 0,
                    CEV5NPW::VALUE2 => 3,
                    CEV5NPW::VALUE3 => 4,
                    CEV5NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV5NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV5NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV5NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV5NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV5NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV5NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV5NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV6NP`"]
        pub enum CEV6NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV6NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV6NPW::VALUE1 => 0,
                    CEV6NPW::VALUE2 => 3,
                    CEV6NPW::VALUE3 => 4,
                    CEV6NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV6NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV6NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV6NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV6NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV6NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV6NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV6NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CEV7NP`"]
        pub enum CEV7NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl CEV7NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CEV7NPW::VALUE1 => 0,
                    CEV7NPW::VALUE2 => 3,
                    CEV7NPW::VALUE3 => 4,
                    CEV7NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CEV7NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CEV7NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CEV7NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CEV7NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CEV7NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CEV7NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CEV7NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev0np(&self) -> CEV0NPR {
                CEV0NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev1np(&self) -> CEV1NPR {
                CEV1NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev2np(&self) -> CEV2NPR {
                CEV2NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:15 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev3np(&self) -> CEV3NPR {
                CEV3NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev4np(&self) -> CEV4NPR {
                CEV4NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:23 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev5np(&self) -> CEV5NPR {
                CEV5NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:27 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev6np(&self) -> CEV6NPR {
                CEV6NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:31 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev7np(&self) -> CEV7NPR {
                CEV7NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev0np(&mut self) -> _CEV0NPW {
                _CEV0NPW { w: self }
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev1np(&mut self) -> _CEV1NPW {
                _CEV1NPW { w: self }
            }
            #[doc = "Bits 8:11 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev2np(&mut self) -> _CEV2NPW {
                _CEV2NPW { w: self }
            }
            #[doc = "Bits 12:15 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev3np(&mut self) -> _CEV3NPW {
                _CEV3NPW { w: self }
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev4np(&mut self) -> _CEV4NPW {
                _CEV4NPW { w: self }
            }
            #[doc = "Bits 20:23 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev5np(&mut self) -> _CEV5NPW {
                _CEV5NPW { w: self }
            }
            #[doc = "Bits 24:27 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev6np(&mut self) -> _CEV6NPW {
                _CEV6NPW { w: self }
            }
            #[doc = "Bits 28:31 - Service Request Node Pointer Channel Event i"]
            #[inline]
            pub fn cev7np(&mut self) -> _CEV7NPW {
                _CEV7NPW { w: self }
            }
        }
    }
    #[doc = "Result Event Node Pointer Register 0"]
    pub struct REVNP0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Event Node Pointer Register 0"]
    pub mod revnp0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::REVNP0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `REV0NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV0NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV0NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV0NPR::VALUE1 => 0,
                    REV0NPR::VALUE2 => 0x03,
                    REV0NPR::VALUE3 => 0x04,
                    REV0NPR::VALUE4 => 0x07,
                    REV0NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV0NPR {
                match value {
                    0 => REV0NPR::VALUE1,
                    3 => REV0NPR::VALUE2,
                    4 => REV0NPR::VALUE3,
                    7 => REV0NPR::VALUE4,
                    i => REV0NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV0NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV0NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV0NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV0NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV1NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV1NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV1NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV1NPR::VALUE1 => 0,
                    REV1NPR::VALUE2 => 0x03,
                    REV1NPR::VALUE3 => 0x04,
                    REV1NPR::VALUE4 => 0x07,
                    REV1NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV1NPR {
                match value {
                    0 => REV1NPR::VALUE1,
                    3 => REV1NPR::VALUE2,
                    4 => REV1NPR::VALUE3,
                    7 => REV1NPR::VALUE4,
                    i => REV1NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV1NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV1NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV1NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV1NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV2NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV2NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV2NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV2NPR::VALUE1 => 0,
                    REV2NPR::VALUE2 => 0x03,
                    REV2NPR::VALUE3 => 0x04,
                    REV2NPR::VALUE4 => 0x07,
                    REV2NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV2NPR {
                match value {
                    0 => REV2NPR::VALUE1,
                    3 => REV2NPR::VALUE2,
                    4 => REV2NPR::VALUE3,
                    7 => REV2NPR::VALUE4,
                    i => REV2NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV2NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV2NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV2NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV2NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV3NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV3NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV3NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV3NPR::VALUE1 => 0,
                    REV3NPR::VALUE2 => 0x03,
                    REV3NPR::VALUE3 => 0x04,
                    REV3NPR::VALUE4 => 0x07,
                    REV3NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV3NPR {
                match value {
                    0 => REV3NPR::VALUE1,
                    3 => REV3NPR::VALUE2,
                    4 => REV3NPR::VALUE3,
                    7 => REV3NPR::VALUE4,
                    i => REV3NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV3NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV3NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV3NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV3NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV4NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV4NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV4NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV4NPR::VALUE1 => 0,
                    REV4NPR::VALUE2 => 0x03,
                    REV4NPR::VALUE3 => 0x04,
                    REV4NPR::VALUE4 => 0x07,
                    REV4NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV4NPR {
                match value {
                    0 => REV4NPR::VALUE1,
                    3 => REV4NPR::VALUE2,
                    4 => REV4NPR::VALUE3,
                    7 => REV4NPR::VALUE4,
                    i => REV4NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV4NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV4NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV4NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV4NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV5NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV5NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV5NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV5NPR::VALUE1 => 0,
                    REV5NPR::VALUE2 => 0x03,
                    REV5NPR::VALUE3 => 0x04,
                    REV5NPR::VALUE4 => 0x07,
                    REV5NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV5NPR {
                match value {
                    0 => REV5NPR::VALUE1,
                    3 => REV5NPR::VALUE2,
                    4 => REV5NPR::VALUE3,
                    7 => REV5NPR::VALUE4,
                    i => REV5NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV5NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV5NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV5NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV5NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV6NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV6NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV6NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV6NPR::VALUE1 => 0,
                    REV6NPR::VALUE2 => 0x03,
                    REV6NPR::VALUE3 => 0x04,
                    REV6NPR::VALUE4 => 0x07,
                    REV6NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV6NPR {
                match value {
                    0 => REV6NPR::VALUE1,
                    3 => REV6NPR::VALUE2,
                    4 => REV6NPR::VALUE3,
                    7 => REV6NPR::VALUE4,
                    i => REV6NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV6NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV6NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV6NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV6NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV7NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV7NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV7NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV7NPR::VALUE1 => 0,
                    REV7NPR::VALUE2 => 0x03,
                    REV7NPR::VALUE3 => 0x04,
                    REV7NPR::VALUE4 => 0x07,
                    REV7NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV7NPR {
                match value {
                    0 => REV7NPR::VALUE1,
                    3 => REV7NPR::VALUE2,
                    4 => REV7NPR::VALUE3,
                    7 => REV7NPR::VALUE4,
                    i => REV7NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV7NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV7NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV7NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV7NPR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `REV0NP`"]
        pub enum REV0NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV0NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV0NPW::VALUE1 => 0,
                    REV0NPW::VALUE2 => 3,
                    REV0NPW::VALUE3 => 4,
                    REV0NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV0NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV0NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV0NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV0NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV1NP`"]
        pub enum REV1NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV1NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV1NPW::VALUE1 => 0,
                    REV1NPW::VALUE2 => 3,
                    REV1NPW::VALUE3 => 4,
                    REV1NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV1NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV1NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV1NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV1NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV1NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV1NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV1NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV2NP`"]
        pub enum REV2NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV2NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV2NPW::VALUE1 => 0,
                    REV2NPW::VALUE2 => 3,
                    REV2NPW::VALUE3 => 4,
                    REV2NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV2NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV2NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV2NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV2NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV2NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV2NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV2NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV3NP`"]
        pub enum REV3NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV3NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV3NPW::VALUE1 => 0,
                    REV3NPW::VALUE2 => 3,
                    REV3NPW::VALUE3 => 4,
                    REV3NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV3NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV3NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV3NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV3NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV3NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV3NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV3NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV4NP`"]
        pub enum REV4NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV4NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV4NPW::VALUE1 => 0,
                    REV4NPW::VALUE2 => 3,
                    REV4NPW::VALUE3 => 4,
                    REV4NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV4NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV4NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV4NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV4NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV4NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV4NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV4NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV5NP`"]
        pub enum REV5NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV5NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV5NPW::VALUE1 => 0,
                    REV5NPW::VALUE2 => 3,
                    REV5NPW::VALUE3 => 4,
                    REV5NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV5NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV5NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV5NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV5NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV5NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV5NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV5NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV6NP`"]
        pub enum REV6NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV6NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV6NPW::VALUE1 => 0,
                    REV6NPW::VALUE2 => 3,
                    REV6NPW::VALUE3 => 4,
                    REV6NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV6NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV6NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV6NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV6NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV6NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV6NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV6NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV7NP`"]
        pub enum REV7NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV7NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV7NPW::VALUE1 => 0,
                    REV7NPW::VALUE2 => 3,
                    REV7NPW::VALUE3 => 4,
                    REV7NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV7NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV7NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV7NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV7NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV7NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV7NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV7NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev0np(&self) -> REV0NPR {
                REV0NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev1np(&self) -> REV1NPR {
                REV1NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev2np(&self) -> REV2NPR {
                REV2NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:15 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev3np(&self) -> REV3NPR {
                REV3NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev4np(&self) -> REV4NPR {
                REV4NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:23 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev5np(&self) -> REV5NPR {
                REV5NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:27 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev6np(&self) -> REV6NPR {
                REV6NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:31 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev7np(&self) -> REV7NPR {
                REV7NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev0np(&mut self) -> _REV0NPW {
                _REV0NPW { w: self }
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev1np(&mut self) -> _REV1NPW {
                _REV1NPW { w: self }
            }
            #[doc = "Bits 8:11 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev2np(&mut self) -> _REV2NPW {
                _REV2NPW { w: self }
            }
            #[doc = "Bits 12:15 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev3np(&mut self) -> _REV3NPW {
                _REV3NPW { w: self }
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev4np(&mut self) -> _REV4NPW {
                _REV4NPW { w: self }
            }
            #[doc = "Bits 20:23 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev5np(&mut self) -> _REV5NPW {
                _REV5NPW { w: self }
            }
            #[doc = "Bits 24:27 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev6np(&mut self) -> _REV6NPW {
                _REV6NPW { w: self }
            }
            #[doc = "Bits 28:31 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev7np(&mut self) -> _REV7NPW {
                _REV7NPW { w: self }
            }
        }
    }
    #[doc = "Result Event Node Pointer Register 1"]
    pub struct REVNP1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Event Node Pointer Register 1"]
    pub mod revnp1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::REVNP1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `REV8NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV8NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV8NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV8NPR::VALUE1 => 0,
                    REV8NPR::VALUE2 => 0x03,
                    REV8NPR::VALUE3 => 0x04,
                    REV8NPR::VALUE4 => 0x07,
                    REV8NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV8NPR {
                match value {
                    0 => REV8NPR::VALUE1,
                    3 => REV8NPR::VALUE2,
                    4 => REV8NPR::VALUE3,
                    7 => REV8NPR::VALUE4,
                    i => REV8NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV8NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV8NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV8NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV8NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV9NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV9NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV9NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV9NPR::VALUE1 => 0,
                    REV9NPR::VALUE2 => 0x03,
                    REV9NPR::VALUE3 => 0x04,
                    REV9NPR::VALUE4 => 0x07,
                    REV9NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV9NPR {
                match value {
                    0 => REV9NPR::VALUE1,
                    3 => REV9NPR::VALUE2,
                    4 => REV9NPR::VALUE3,
                    7 => REV9NPR::VALUE4,
                    i => REV9NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV9NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV9NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV9NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV9NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV10NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV10NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV10NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV10NPR::VALUE1 => 0,
                    REV10NPR::VALUE2 => 0x03,
                    REV10NPR::VALUE3 => 0x04,
                    REV10NPR::VALUE4 => 0x07,
                    REV10NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV10NPR {
                match value {
                    0 => REV10NPR::VALUE1,
                    3 => REV10NPR::VALUE2,
                    4 => REV10NPR::VALUE3,
                    7 => REV10NPR::VALUE4,
                    i => REV10NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV10NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV10NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV10NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV10NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV11NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV11NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV11NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV11NPR::VALUE1 => 0,
                    REV11NPR::VALUE2 => 0x03,
                    REV11NPR::VALUE3 => 0x04,
                    REV11NPR::VALUE4 => 0x07,
                    REV11NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV11NPR {
                match value {
                    0 => REV11NPR::VALUE1,
                    3 => REV11NPR::VALUE2,
                    4 => REV11NPR::VALUE3,
                    7 => REV11NPR::VALUE4,
                    i => REV11NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV11NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV11NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV11NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV11NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV12NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV12NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV12NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV12NPR::VALUE1 => 0,
                    REV12NPR::VALUE2 => 0x03,
                    REV12NPR::VALUE3 => 0x04,
                    REV12NPR::VALUE4 => 0x07,
                    REV12NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV12NPR {
                match value {
                    0 => REV12NPR::VALUE1,
                    3 => REV12NPR::VALUE2,
                    4 => REV12NPR::VALUE3,
                    7 => REV12NPR::VALUE4,
                    i => REV12NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV12NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV12NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV12NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV12NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV13NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV13NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV13NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV13NPR::VALUE1 => 0,
                    REV13NPR::VALUE2 => 0x03,
                    REV13NPR::VALUE3 => 0x04,
                    REV13NPR::VALUE4 => 0x07,
                    REV13NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV13NPR {
                match value {
                    0 => REV13NPR::VALUE1,
                    3 => REV13NPR::VALUE2,
                    4 => REV13NPR::VALUE3,
                    7 => REV13NPR::VALUE4,
                    i => REV13NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV13NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV13NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV13NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV13NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV14NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV14NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV14NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV14NPR::VALUE1 => 0,
                    REV14NPR::VALUE2 => 0x03,
                    REV14NPR::VALUE3 => 0x04,
                    REV14NPR::VALUE4 => 0x07,
                    REV14NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV14NPR {
                match value {
                    0 => REV14NPR::VALUE1,
                    3 => REV14NPR::VALUE2,
                    4 => REV14NPR::VALUE3,
                    7 => REV14NPR::VALUE4,
                    i => REV14NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV14NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV14NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV14NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV14NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `REV15NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REV15NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl REV15NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    REV15NPR::VALUE1 => 0,
                    REV15NPR::VALUE2 => 0x03,
                    REV15NPR::VALUE3 => 0x04,
                    REV15NPR::VALUE4 => 0x07,
                    REV15NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> REV15NPR {
                match value {
                    0 => REV15NPR::VALUE1,
                    3 => REV15NPR::VALUE2,
                    4 => REV15NPR::VALUE3,
                    7 => REV15NPR::VALUE4,
                    i => REV15NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REV15NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REV15NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == REV15NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == REV15NPR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `REV8NP`"]
        pub enum REV8NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV8NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV8NPW::VALUE1 => 0,
                    REV8NPW::VALUE2 => 3,
                    REV8NPW::VALUE3 => 4,
                    REV8NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV8NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV8NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV8NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV8NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV8NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV8NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV8NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV9NP`"]
        pub enum REV9NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV9NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV9NPW::VALUE1 => 0,
                    REV9NPW::VALUE2 => 3,
                    REV9NPW::VALUE3 => 4,
                    REV9NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV9NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV9NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV9NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV9NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV9NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV9NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV9NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV10NP`"]
        pub enum REV10NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV10NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV10NPW::VALUE1 => 0,
                    REV10NPW::VALUE2 => 3,
                    REV10NPW::VALUE3 => 4,
                    REV10NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV10NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV10NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV10NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV10NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV10NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV10NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV10NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV11NP`"]
        pub enum REV11NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV11NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV11NPW::VALUE1 => 0,
                    REV11NPW::VALUE2 => 3,
                    REV11NPW::VALUE3 => 4,
                    REV11NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV11NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV11NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV11NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV11NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV11NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV11NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV11NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV12NP`"]
        pub enum REV12NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV12NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV12NPW::VALUE1 => 0,
                    REV12NPW::VALUE2 => 3,
                    REV12NPW::VALUE3 => 4,
                    REV12NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV12NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV12NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV12NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV12NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV12NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV12NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV12NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV13NP`"]
        pub enum REV13NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV13NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV13NPW::VALUE1 => 0,
                    REV13NPW::VALUE2 => 3,
                    REV13NPW::VALUE3 => 4,
                    REV13NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV13NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV13NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV13NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV13NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV13NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV13NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV13NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV14NP`"]
        pub enum REV14NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV14NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV14NPW::VALUE1 => 0,
                    REV14NPW::VALUE2 => 3,
                    REV14NPW::VALUE3 => 4,
                    REV14NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV14NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV14NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV14NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV14NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV14NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV14NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV14NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REV15NP`"]
        pub enum REV15NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl REV15NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    REV15NPW::VALUE1 => 0,
                    REV15NPW::VALUE2 => 3,
                    REV15NPW::VALUE3 => 4,
                    REV15NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REV15NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REV15NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REV15NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REV15NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REV15NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(REV15NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(REV15NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev8np(&self) -> REV8NPR {
                REV8NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev9np(&self) -> REV9NPR {
                REV9NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev10np(&self) -> REV10NPR {
                REV10NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:15 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev11np(&self) -> REV11NPR {
                REV11NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev12np(&self) -> REV12NPR {
                REV12NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:23 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev13np(&self) -> REV13NPR {
                REV13NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:27 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev14np(&self) -> REV14NPR {
                REV14NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:31 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev15np(&self) -> REV15NPR {
                REV15NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev8np(&mut self) -> _REV8NPW {
                _REV8NPW { w: self }
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev9np(&mut self) -> _REV9NPW {
                _REV9NPW { w: self }
            }
            #[doc = "Bits 8:11 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev10np(&mut self) -> _REV10NPW {
                _REV10NPW { w: self }
            }
            #[doc = "Bits 12:15 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev11np(&mut self) -> _REV11NPW {
                _REV11NPW { w: self }
            }
            #[doc = "Bits 16:19 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev12np(&mut self) -> _REV12NPW {
                _REV12NPW { w: self }
            }
            #[doc = "Bits 20:23 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev13np(&mut self) -> _REV13NPW {
                _REV13NPW { w: self }
            }
            #[doc = "Bits 24:27 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev14np(&mut self) -> _REV14NPW {
                _REV14NPW { w: self }
            }
            #[doc = "Bits 28:31 - Service Request Node Pointer Result Event i"]
            #[inline]
            pub fn rev15np(&mut self) -> _REV15NPW {
                _REV15NPW { w: self }
            }
        }
    }
    #[doc = "Source Event Node Pointer Register"]
    pub struct SEVNP {
        register: VolatileCell<u32>,
    }
    #[doc = "Source Event Node Pointer Register"]
    pub mod sevnp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SEVNP {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SEV0NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEV0NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SEV0NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SEV0NPR::VALUE1 => 0,
                    SEV0NPR::VALUE2 => 0x03,
                    SEV0NPR::VALUE3 => 0x04,
                    SEV0NPR::VALUE4 => 0x07,
                    SEV0NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SEV0NPR {
                match value {
                    0 => SEV0NPR::VALUE1,
                    3 => SEV0NPR::VALUE2,
                    4 => SEV0NPR::VALUE3,
                    7 => SEV0NPR::VALUE4,
                    i => SEV0NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEV0NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEV0NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SEV0NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SEV0NPR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SEV1NP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SEV1NPR {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SEV1NPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SEV1NPR::VALUE1 => 0,
                    SEV1NPR::VALUE2 => 0x03,
                    SEV1NPR::VALUE3 => 0x04,
                    SEV1NPR::VALUE4 => 0x07,
                    SEV1NPR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SEV1NPR {
                match value {
                    0 => SEV1NPR::VALUE1,
                    3 => SEV1NPR::VALUE2,
                    4 => SEV1NPR::VALUE3,
                    7 => SEV1NPR::VALUE4,
                    i => SEV1NPR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SEV1NPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SEV1NPR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SEV1NPR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SEV1NPR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SEV0NP`"]
        pub enum SEV0NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl SEV0NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SEV0NPW::VALUE1 => 0,
                    SEV0NPW::VALUE2 => 3,
                    SEV0NPW::VALUE3 => 4,
                    SEV0NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV0NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV0NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV0NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SEV0NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SEV1NP`"]
        pub enum SEV1NPW {
            #[doc = "Select service request line 0 of group x"]
            VALUE1,
            #[doc = "Select service request line 3 of group x"]
            VALUE2,
            #[doc = "Select shared service request line 0"]
            VALUE3,
            #[doc = "Select shared service request line 3"]
            VALUE4,
        }
        impl SEV1NPW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SEV1NPW::VALUE1 => 0,
                    SEV1NPW::VALUE2 => 3,
                    SEV1NPW::VALUE3 => 4,
                    SEV1NPW::VALUE4 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SEV1NPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SEV1NPW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SEV1NPW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select service request line 0 of group x"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SEV1NPW::VALUE1)
            }
            #[doc = "Select service request line 3 of group x"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SEV1NPW::VALUE2)
            }
            #[doc = "Select shared service request line 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SEV1NPW::VALUE3)
            }
            #[doc = "Select shared service request line 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SEV1NPW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Source Event i"]
            #[inline]
            pub fn sev0np(&self) -> SEV0NPR {
                SEV0NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Source Event i"]
            #[inline]
            pub fn sev1np(&self) -> SEV1NPR {
                SEV1NPR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Service Request Node Pointer Source Event i"]
            #[inline]
            pub fn sev0np(&mut self) -> _SEV0NPW {
                _SEV0NPW { w: self }
            }
            #[doc = "Bits 4:7 - Service Request Node Pointer Source Event i"]
            #[inline]
            pub fn sev1np(&mut self) -> _SEV1NPW {
                _SEV1NPW { w: self }
            }
        }
    }
    #[doc = "Service Request Software Activation Trigger"]
    pub struct SRACT {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Software Activation Trigger"]
    pub mod sract {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRACT {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = "Values that can be written to the field `AGSR0`"]
        pub enum AGSR0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl AGSR0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AGSR0W::VALUE1 => false,
                    AGSR0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AGSR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _AGSR0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AGSR0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AGSR0W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AGSR0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AGSR1`"]
        pub enum AGSR1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl AGSR1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AGSR1W::VALUE1 => false,
                    AGSR1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AGSR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _AGSR1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AGSR1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AGSR1W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AGSR1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AGSR2`"]
        pub enum AGSR2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl AGSR2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AGSR2W::VALUE1 => false,
                    AGSR2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AGSR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _AGSR2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AGSR2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AGSR2W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AGSR2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `AGSR3`"]
        pub enum AGSR3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl AGSR3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    AGSR3W::VALUE1 => false,
                    AGSR3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _AGSR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _AGSR3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: AGSR3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(AGSR3W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(AGSR3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSR0`"]
        pub enum ASSR0W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl ASSR0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSR0W::VALUE1 => false,
                    ASSR0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSR0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSR0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSR0W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSR0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSR1`"]
        pub enum ASSR1W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl ASSR1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSR1W::VALUE1 => false,
                    ASSR1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSR1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSR1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSR1W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSR1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSR2`"]
        pub enum ASSR2W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl ASSR2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSR2W::VALUE1 => false,
                    ASSR2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSR2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSR2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSR2W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSR2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ASSR3`"]
        pub enum ASSR3W {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Activate the associated service request line"]
            VALUE2,
        }
        impl ASSR3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASSR3W::VALUE1 => false,
                    ASSR3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASSR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASSR3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASSR3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASSR3W::VALUE1)
            }
            #[doc = "Activate the associated service request line"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASSR3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Activate Group Service Request Node 0"]
            #[inline]
            pub fn agsr0(&mut self) -> _AGSR0W {
                _AGSR0W { w: self }
            }
            #[doc = "Bit 1 - Activate Group Service Request Node 1"]
            #[inline]
            pub fn agsr1(&mut self) -> _AGSR1W {
                _AGSR1W { w: self }
            }
            #[doc = "Bit 2 - Activate Group Service Request Node 2"]
            #[inline]
            pub fn agsr2(&mut self) -> _AGSR2W {
                _AGSR2W { w: self }
            }
            #[doc = "Bit 3 - Activate Group Service Request Node 3"]
            #[inline]
            pub fn agsr3(&mut self) -> _AGSR3W {
                _AGSR3W { w: self }
            }
            #[doc = "Bit 8 - Activate Shared Service Request Node 0"]
            #[inline]
            pub fn assr0(&mut self) -> _ASSR0W {
                _ASSR0W { w: self }
            }
            #[doc = "Bit 9 - Activate Shared Service Request Node 1"]
            #[inline]
            pub fn assr1(&mut self) -> _ASSR1W {
                _ASSR1W { w: self }
            }
            #[doc = "Bit 10 - Activate Shared Service Request Node 2"]
            #[inline]
            pub fn assr2(&mut self) -> _ASSR2W {
                _ASSR2W { w: self }
            }
            #[doc = "Bit 11 - Activate Shared Service Request Node 3"]
            #[inline]
            pub fn assr3(&mut self) -> _ASSR3W {
                _ASSR3W { w: self }
            }
        }
    }
    #[doc = "External Multiplexer Control Register"]
    pub struct EMUXCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "External Multiplexer Control Register"]
    pub mod emuxctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::EMUXCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXSETR {
            bits: u8,
        }
        impl EMUXSETR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXACTR {
            bits: u8,
        }
        impl EMUXACTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXCHR {
            bits: u16,
        }
        impl EMUXCHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `EMUXMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMUXMODER {
            #[doc = "Software control (no hardware action)"]
            VALUE1,
            #[doc = "Steady mode (use EMUXSET value)"]
            VALUE2,
            #[doc = "Single-step mode"]
            VALUE3,
            #[doc = "Sequence mode"]
            VALUE4,
        }
        impl EMUXMODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EMUXMODER::VALUE1 => 0,
                    EMUXMODER::VALUE2 => 0x01,
                    EMUXMODER::VALUE3 => 0x02,
                    EMUXMODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EMUXMODER {
                match value {
                    0 => EMUXMODER::VALUE1,
                    1 => EMUXMODER::VALUE2,
                    2 => EMUXMODER::VALUE3,
                    3 => EMUXMODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMUXMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMUXMODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EMUXMODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EMUXMODER::VALUE4
            }
        }
        #[doc = "Possible values of the field `EMXCOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMXCODR {
            #[doc = "Output the channel number in binary code"]
            VALUE1,
            #[doc = "Output the channel number in Gray code"]
            VALUE2,
        }
        impl EMXCODR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMXCODR::VALUE1 => false,
                    EMXCODR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMXCODR {
                match value {
                    false => EMXCODR::VALUE1,
                    true => EMXCODR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMXCODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMXCODR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMXST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMXSTR {
            #[doc = "Use STCE whenever the setting changes"]
            VALUE1,
            #[doc = "Use STCE for each conversion of an external channel"]
            VALUE2,
        }
        impl EMXSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMXSTR::VALUE1 => false,
                    EMXSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMXSTR {
                match value {
                    false => EMXSTR::VALUE1,
                    true => EMXSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMXSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMXSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMXCSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMXCSSR {
            #[doc = "Channel number: Bitfield EMUXCH selects an arbitrary channel"]
            VALUE1,
            #[doc = "Channel enable: Each bit of bitfield EMUXCH selects the associated channel for EMUX control"]
            VALUE2,
        }
        impl EMXCSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMXCSSR::VALUE1 => false,
                    EMXCSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMXCSSR {
                match value {
                    false => EMXCSSR::VALUE1,
                    true => EMXCSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMXCSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMXCSSR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMUXSETW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMUXSETW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMUXCHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMUXCHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMUXMODE`"]
        pub enum EMUXMODEW {
            #[doc = "Software control (no hardware action)"]
            VALUE1,
            #[doc = "Steady mode (use EMUXSET value)"]
            VALUE2,
            #[doc = "Single-step mode"]
            VALUE3,
            #[doc = "Sequence mode"]
            VALUE4,
        }
        impl EMUXMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EMUXMODEW::VALUE1 => 0,
                    EMUXMODEW::VALUE2 => 1,
                    EMUXMODEW::VALUE3 => 2,
                    EMUXMODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMUXMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMUXMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMUXMODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Software control (no hardware action)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMUXMODEW::VALUE1)
            }
            #[doc = "Steady mode (use EMUXSET value)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMUXMODEW::VALUE2)
            }
            #[doc = "Single-step mode"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EMUXMODEW::VALUE3)
            }
            #[doc = "Sequence mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EMUXMODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMXCOD`"]
        pub enum EMXCODW {
            #[doc = "Output the channel number in binary code"]
            VALUE1,
            #[doc = "Output the channel number in Gray code"]
            VALUE2,
        }
        impl EMXCODW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMXCODW::VALUE1 => false,
                    EMXCODW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMXCODW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMXCODW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMXCODW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Output the channel number in binary code"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMXCODW::VALUE1)
            }
            #[doc = "Output the channel number in Gray code"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMXCODW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMXST`"]
        pub enum EMXSTW {
            #[doc = "Use STCE whenever the setting changes"]
            VALUE1,
            #[doc = "Use STCE for each conversion of an external channel"]
            VALUE2,
        }
        impl EMXSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMXSTW::VALUE1 => false,
                    EMXSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMXSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMXSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMXSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Use STCE whenever the setting changes"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMXSTW::VALUE1)
            }
            #[doc = "Use STCE for each conversion of an external channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMXSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMXWC`"]
        pub enum EMXWCW {
            #[doc = "No write access to EMUX cfg."]
            VALUE1,
            #[doc = "Bitfields EMXMODE, EMXCOD, EMXST, EMXCSS can be written"]
            VALUE2,
        }
        impl EMXWCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMXWCW::VALUE1 => false,
                    EMXWCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMXWCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMXWCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMXWCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No write access to EMUX cfg."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMXWCW::VALUE1)
            }
            #[doc = "Bitfields EMXMODE, EMXCOD, EMXST, EMXCSS can be written"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMXWCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - External Multiplexer Start Selection"]
            #[inline]
            pub fn emuxset(&self) -> EMUXSETR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXSETR { bits }
            }
            #[doc = "Bits 8:10 - External Multiplexer Actual Selection"]
            #[inline]
            pub fn emuxact(&self) -> EMUXACTR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXACTR { bits }
            }
            #[doc = "Bits 16:25 - External Multiplexer Channel Select"]
            #[inline]
            pub fn emuxch(&self) -> EMUXCHR {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                EMUXCHR { bits }
            }
            #[doc = "Bits 26:27 - External Multiplexer Mode"]
            #[inline]
            pub fn emuxmode(&self) -> EMUXMODER {
                EMUXMODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 28 - External Multiplexer Coding Scheme"]
            #[inline]
            pub fn emxcod(&self) -> EMXCODR {
                EMXCODR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - External Multiplexer Sample Time Control"]
            #[inline]
            pub fn emxst(&self) -> EMXSTR {
                EMXSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - External Multiplexer Channel Selection Style"]
            #[inline]
            pub fn emxcss(&self) -> EMXCSSR {
                EMXCSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - External Multiplexer Start Selection"]
            #[inline]
            pub fn emuxset(&mut self) -> _EMUXSETW {
                _EMUXSETW { w: self }
            }
            #[doc = "Bits 16:25 - External Multiplexer Channel Select"]
            #[inline]
            pub fn emuxch(&mut self) -> _EMUXCHW {
                _EMUXCHW { w: self }
            }
            #[doc = "Bits 26:27 - External Multiplexer Mode"]
            #[inline]
            pub fn emuxmode(&mut self) -> _EMUXMODEW {
                _EMUXMODEW { w: self }
            }
            #[doc = "Bit 28 - External Multiplexer Coding Scheme"]
            #[inline]
            pub fn emxcod(&mut self) -> _EMXCODW {
                _EMXCODW { w: self }
            }
            #[doc = "Bit 29 - External Multiplexer Sample Time Control"]
            #[inline]
            pub fn emxst(&mut self) -> _EMXSTW {
                _EMXSTW { w: self }
            }
            #[doc = "Bit 31 - Write Control for EMUX Configuration"]
            #[inline]
            pub fn emxwc(&mut self) -> _EMXWCW {
                _EMXWCW { w: self }
            }
        }
    }
    #[doc = "Valid Flag Register"]
    pub struct VFR {
        register: VolatileCell<u32>,
    }
    #[doc = "Valid Flag Register"]
    pub mod vfr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::VFR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `VF0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF0R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF0R::VALUE1 => false,
                    VF0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF0R {
                match value {
                    false => VF0R::VALUE1,
                    true => VF0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF1R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF1R::VALUE1 => false,
                    VF1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF1R {
                match value {
                    false => VF1R::VALUE1,
                    true => VF1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF2R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF2R::VALUE1 => false,
                    VF2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF2R {
                match value {
                    false => VF2R::VALUE1,
                    true => VF2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF3R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF3R::VALUE1 => false,
                    VF3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF3R {
                match value {
                    false => VF3R::VALUE1,
                    true => VF3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF4R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF4R::VALUE1 => false,
                    VF4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF4R {
                match value {
                    false => VF4R::VALUE1,
                    true => VF4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF5R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF5R::VALUE1 => false,
                    VF5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF5R {
                match value {
                    false => VF5R::VALUE1,
                    true => VF5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF6R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF6R::VALUE1 => false,
                    VF6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF6R {
                match value {
                    false => VF6R::VALUE1,
                    true => VF6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF7R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF7R::VALUE1 => false,
                    VF7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF7R {
                match value {
                    false => VF7R::VALUE1,
                    true => VF7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF8R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF8R::VALUE1 => false,
                    VF8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF8R {
                match value {
                    false => VF8R::VALUE1,
                    true => VF8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF9R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF9R::VALUE1 => false,
                    VF9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF9R {
                match value {
                    false => VF9R::VALUE1,
                    true => VF9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF10R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF10R::VALUE1 => false,
                    VF10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF10R {
                match value {
                    false => VF10R::VALUE1,
                    true => VF10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF11R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF11R::VALUE1 => false,
                    VF11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF11R {
                match value {
                    false => VF11R::VALUE1,
                    true => VF11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF12R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF12R::VALUE1 => false,
                    VF12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF12R {
                match value {
                    false => VF12R::VALUE1,
                    true => VF12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF13R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF13R::VALUE1 => false,
                    VF13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF13R {
                match value {
                    false => VF13R::VALUE1,
                    true => VF13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF14R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF14R::VALUE1 => false,
                    VF14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF14R {
                match value {
                    false => VF14R::VALUE1,
                    true => VF14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VF15R {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VF15R::VALUE1 => false,
                    VF15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VF15R {
                match value {
                    false => VF15R::VALUE1,
                    true => VF15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VF15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VF15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `VF0`"]
        pub enum VF0W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF0W::VALUE1 => false,
                    VF0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF0W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF1`"]
        pub enum VF1W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF1W::VALUE1 => false,
                    VF1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF1W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF2`"]
        pub enum VF2W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF2W::VALUE1 => false,
                    VF2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF2W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF3`"]
        pub enum VF3W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF3W::VALUE1 => false,
                    VF3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF3W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF4`"]
        pub enum VF4W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF4W::VALUE1 => false,
                    VF4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF4W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF5`"]
        pub enum VF5W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF5W::VALUE1 => false,
                    VF5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF5W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF6`"]
        pub enum VF6W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF6W::VALUE1 => false,
                    VF6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF6W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF7`"]
        pub enum VF7W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF7W::VALUE1 => false,
                    VF7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF7W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF8`"]
        pub enum VF8W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF8W::VALUE1 => false,
                    VF8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF8W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF9`"]
        pub enum VF9W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF9W::VALUE1 => false,
                    VF9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF9W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF10`"]
        pub enum VF10W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF10W::VALUE1 => false,
                    VF10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF10W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF11`"]
        pub enum VF11W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF11W::VALUE1 => false,
                    VF11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF11W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF12`"]
        pub enum VF12W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF12W::VALUE1 => false,
                    VF12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF12W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF13`"]
        pub enum VF13W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF13W::VALUE1 => false,
                    VF13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF13W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF14`"]
        pub enum VF14W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF14W::VALUE1 => false,
                    VF14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF14W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VF15`"]
        pub enum VF15W {
            #[doc = "Read access: No new valid data available Write access: No effect"]
            VALUE1,
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            VALUE2,
        }
        impl VF15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    VF15W::VALUE1 => false,
                    VF15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VF15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _VF15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VF15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Read access: No new valid data available Write access: No effect"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VF15W::VALUE1)
            }
            #[doc = "Read access: Result register x contains valid data and has not yet been read, or bit FCR has been updated Write access: Clear this valid flag and bitfield DRC in register GxRESy (overrides a hardware set action)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VF15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf0(&self) -> VF0R {
                VF0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf1(&self) -> VF1R {
                VF1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf2(&self) -> VF2R {
                VF2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf3(&self) -> VF3R {
                VF3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf4(&self) -> VF4R {
                VF4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf5(&self) -> VF5R {
                VF5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf6(&self) -> VF6R {
                VF6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf7(&self) -> VF7R {
                VF7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf8(&self) -> VF8R {
                VF8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf9(&self) -> VF9R {
                VF9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf10(&self) -> VF10R {
                VF10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf11(&self) -> VF11R {
                VF11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf12(&self) -> VF12R {
                VF12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf13(&self) -> VF13R {
                VF13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf14(&self) -> VF14R {
                VF14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf15(&self) -> VF15R {
                VF15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf0(&mut self) -> _VF0W {
                _VF0W { w: self }
            }
            #[doc = "Bit 1 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf1(&mut self) -> _VF1W {
                _VF1W { w: self }
            }
            #[doc = "Bit 2 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf2(&mut self) -> _VF2W {
                _VF2W { w: self }
            }
            #[doc = "Bit 3 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf3(&mut self) -> _VF3W {
                _VF3W { w: self }
            }
            #[doc = "Bit 4 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf4(&mut self) -> _VF4W {
                _VF4W { w: self }
            }
            #[doc = "Bit 5 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf5(&mut self) -> _VF5W {
                _VF5W { w: self }
            }
            #[doc = "Bit 6 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf6(&mut self) -> _VF6W {
                _VF6W { w: self }
            }
            #[doc = "Bit 7 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf7(&mut self) -> _VF7W {
                _VF7W { w: self }
            }
            #[doc = "Bit 8 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf8(&mut self) -> _VF8W {
                _VF8W { w: self }
            }
            #[doc = "Bit 9 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf9(&mut self) -> _VF9W {
                _VF9W { w: self }
            }
            #[doc = "Bit 10 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf10(&mut self) -> _VF10W {
                _VF10W { w: self }
            }
            #[doc = "Bit 11 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf11(&mut self) -> _VF11W {
                _VF11W { w: self }
            }
            #[doc = "Bit 12 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf12(&mut self) -> _VF12W {
                _VF12W { w: self }
            }
            #[doc = "Bit 13 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf13(&mut self) -> _VF13W {
                _VF13W { w: self }
            }
            #[doc = "Bit 14 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf14(&mut self) -> _VF14W {
                _VF14W { w: self }
            }
            #[doc = "Bit 15 - Valid Flag of Result Register x"]
            #[inline]
            pub fn vf15(&mut self) -> _VF15W {
                _VF15W { w: self }
            }
        }
    }
    #[doc = "Channel Ctrl. Reg."]
    pub struct CHCTR {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Ctrl. Reg."]
    pub mod chctr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CHCTR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ICLSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ICLSELR {
            #[doc = "Use group-specific class 0"]
            VALUE1,
            #[doc = "Use group-specific class 1"]
            VALUE2,
            #[doc = "Use global class 0"]
            VALUE3,
            #[doc = "Use global class 1"]
            VALUE4,
        }
        impl ICLSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ICLSELR::VALUE1 => 0,
                    ICLSELR::VALUE2 => 0x01,
                    ICLSELR::VALUE3 => 0x02,
                    ICLSELR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ICLSELR {
                match value {
                    0 => ICLSELR::VALUE1,
                    1 => ICLSELR::VALUE2,
                    2 => ICLSELR::VALUE3,
                    3 => ICLSELR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ICLSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ICLSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ICLSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ICLSELR::VALUE4
            }
        }
        #[doc = "Possible values of the field `BNDSELL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BNDSELLR {
            #[doc = "Use group-specific boundary 0"]
            VALUE1,
            #[doc = "Use group-specific boundary 1"]
            VALUE2,
            #[doc = "Use global boundary 0"]
            VALUE3,
            #[doc = "Use global boundary 1"]
            VALUE4,
        }
        impl BNDSELLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BNDSELLR::VALUE1 => 0,
                    BNDSELLR::VALUE2 => 0x01,
                    BNDSELLR::VALUE3 => 0x02,
                    BNDSELLR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BNDSELLR {
                match value {
                    0 => BNDSELLR::VALUE1,
                    1 => BNDSELLR::VALUE2,
                    2 => BNDSELLR::VALUE3,
                    3 => BNDSELLR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BNDSELLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BNDSELLR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BNDSELLR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BNDSELLR::VALUE4
            }
        }
        #[doc = "Possible values of the field `BNDSELU`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BNDSELUR {
            #[doc = "Use group-specific boundary 0"]
            VALUE1,
            #[doc = "Use group-specific boundary 1"]
            VALUE2,
            #[doc = "Use global boundary 0"]
            VALUE3,
            #[doc = "Use global boundary 1"]
            VALUE4,
        }
        impl BNDSELUR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BNDSELUR::VALUE1 => 0,
                    BNDSELUR::VALUE2 => 0x01,
                    BNDSELUR::VALUE3 => 0x02,
                    BNDSELUR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BNDSELUR {
                match value {
                    0 => BNDSELUR::VALUE1,
                    1 => BNDSELUR::VALUE2,
                    2 => BNDSELUR::VALUE3,
                    3 => BNDSELUR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BNDSELUR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BNDSELUR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BNDSELUR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BNDSELUR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CHEVMODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHEVMODER {
            #[doc = "Never"]
            VALUE1,
            #[doc = "NCM: If result is inside the boundary band FCM: If result becomes high (above cmp. val.)"]
            VALUE2,
            #[doc = "NCM: If result is outside the boundary band FCM: If result becomes low (below cmp. val.)"]
            VALUE3,
            #[doc = "NCM: Always (ignore band) FCM: If result switches to either level"]
            VALUE4,
        }
        impl CHEVMODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CHEVMODER::VALUE1 => 0,
                    CHEVMODER::VALUE2 => 0x01,
                    CHEVMODER::VALUE3 => 0x02,
                    CHEVMODER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CHEVMODER {
                match value {
                    0 => CHEVMODER::VALUE1,
                    1 => CHEVMODER::VALUE2,
                    2 => CHEVMODER::VALUE3,
                    3 => CHEVMODER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHEVMODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHEVMODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CHEVMODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CHEVMODER::VALUE4
            }
        }
        #[doc = "Possible values of the field `SYNC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SYNCR {
            #[doc = "No synchroniz. request, standalone operation"]
            VALUE1,
            #[doc = "Request a synchronized conversion of this channel (only taken into account for a master)"]
            VALUE2,
        }
        impl SYNCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SYNCR::VALUE1 => false,
                    SYNCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SYNCR {
                match value {
                    false => SYNCR::VALUE1,
                    true => SYNCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SYNCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SYNCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `REFSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum REFSELR {
            #[doc = "Standard reference input VAREF"]
            VALUE1,
            #[doc = "Alternate reference input from CH0"]
            VALUE2,
        }
        impl REFSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    REFSELR::VALUE1 => false,
                    REFSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> REFSELR {
                match value {
                    false => REFSELR::VALUE1,
                    true => REFSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == REFSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == REFSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RESREG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RESREGR {
            #[doc = "Store result in group result register GxRES0"]
            VALUE1,
            #[doc = "Store result in group result register GxRES15"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl RESREGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    RESREGR::VALUE1 => 0,
                    RESREGR::VALUE2 => 0x0f,
                    RESREGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> RESREGR {
                match value {
                    0 => RESREGR::VALUE1,
                    15 => RESREGR::VALUE2,
                    i => RESREGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RESREGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RESREGR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RESTBS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RESTBSR {
            #[doc = "Store results in the selected group result register"]
            VALUE1,
            #[doc = "Store results in the global result register"]
            VALUE2,
        }
        impl RESTBSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RESTBSR::VALUE1 => false,
                    RESTBSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RESTBSR {
                match value {
                    false => RESTBSR::VALUE1,
                    true => RESTBSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RESTBSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RESTBSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RESPOS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RESPOSR {
            #[doc = "Store results left-aligned"]
            VALUE1,
            #[doc = "Store results right-aligned"]
            VALUE2,
        }
        impl RESPOSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RESPOSR::VALUE1 => false,
                    RESPOSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RESPOSR {
                match value {
                    false => RESPOSR::VALUE1,
                    true => RESPOSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RESPOSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RESPOSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWDCH`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWDCHR {
            #[doc = "Select VAGND"]
            VALUE1,
            #[doc = "Select VAREF"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl BWDCHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BWDCHR::VALUE1 => 0,
                    BWDCHR::VALUE2 => 0x01,
                    BWDCHR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BWDCHR {
                match value {
                    0 => BWDCHR::VALUE1,
                    1 => BWDCHR::VALUE2,
                    i => BWDCHR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWDCHR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWDCHR::VALUE2
            }
        }
        #[doc = "Possible values of the field `BWDEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BWDENR {
            #[doc = "Normal operation"]
            VALUE1,
            #[doc = "Additional preparation phase is enabled"]
            VALUE2,
        }
        impl BWDENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    BWDENR::VALUE1 => false,
                    BWDENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> BWDENR {
                match value {
                    false => BWDENR::VALUE1,
                    true => BWDENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BWDENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BWDENR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ICLSEL`"]
        pub enum ICLSELW {
            #[doc = "Use group-specific class 0"]
            VALUE1,
            #[doc = "Use group-specific class 1"]
            VALUE2,
            #[doc = "Use global class 0"]
            VALUE3,
            #[doc = "Use global class 1"]
            VALUE4,
        }
        impl ICLSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ICLSELW::VALUE1 => 0,
                    ICLSELW::VALUE2 => 1,
                    ICLSELW::VALUE3 => 2,
                    ICLSELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ICLSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ICLSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ICLSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Use group-specific class 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ICLSELW::VALUE1)
            }
            #[doc = "Use group-specific class 1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ICLSELW::VALUE2)
            }
            #[doc = "Use global class 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ICLSELW::VALUE3)
            }
            #[doc = "Use global class 1"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ICLSELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BNDSELL`"]
        pub enum BNDSELLW {
            #[doc = "Use group-specific boundary 0"]
            VALUE1,
            #[doc = "Use group-specific boundary 1"]
            VALUE2,
            #[doc = "Use global boundary 0"]
            VALUE3,
            #[doc = "Use global boundary 1"]
            VALUE4,
        }
        impl BNDSELLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BNDSELLW::VALUE1 => 0,
                    BNDSELLW::VALUE2 => 1,
                    BNDSELLW::VALUE3 => 2,
                    BNDSELLW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNDSELLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNDSELLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BNDSELLW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Use group-specific boundary 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BNDSELLW::VALUE1)
            }
            #[doc = "Use group-specific boundary 1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BNDSELLW::VALUE2)
            }
            #[doc = "Use global boundary 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BNDSELLW::VALUE3)
            }
            #[doc = "Use global boundary 1"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BNDSELLW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BNDSELU`"]
        pub enum BNDSELUW {
            #[doc = "Use group-specific boundary 0"]
            VALUE1,
            #[doc = "Use group-specific boundary 1"]
            VALUE2,
            #[doc = "Use global boundary 0"]
            VALUE3,
            #[doc = "Use global boundary 1"]
            VALUE4,
        }
        impl BNDSELUW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BNDSELUW::VALUE1 => 0,
                    BNDSELUW::VALUE2 => 1,
                    BNDSELUW::VALUE3 => 2,
                    BNDSELUW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BNDSELUW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BNDSELUW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BNDSELUW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Use group-specific boundary 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BNDSELUW::VALUE1)
            }
            #[doc = "Use group-specific boundary 1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BNDSELUW::VALUE2)
            }
            #[doc = "Use global boundary 0"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BNDSELUW::VALUE3)
            }
            #[doc = "Use global boundary 1"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BNDSELUW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHEVMODE`"]
        pub enum CHEVMODEW {
            #[doc = "Never"]
            VALUE1,
            #[doc = "NCM: If result is inside the boundary band FCM: If result becomes high (above cmp. val.)"]
            VALUE2,
            #[doc = "NCM: If result is outside the boundary band FCM: If result becomes low (below cmp. val.)"]
            VALUE3,
            #[doc = "NCM: Always (ignore band) FCM: If result switches to either level"]
            VALUE4,
        }
        impl CHEVMODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CHEVMODEW::VALUE1 => 0,
                    CHEVMODEW::VALUE2 => 1,
                    CHEVMODEW::VALUE3 => 2,
                    CHEVMODEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHEVMODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHEVMODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHEVMODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Never"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHEVMODEW::VALUE1)
            }
            #[doc = "NCM: If result is inside the boundary band FCM: If result becomes high (above cmp. val.)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHEVMODEW::VALUE2)
            }
            #[doc = "NCM: If result is outside the boundary band FCM: If result becomes low (below cmp. val.)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CHEVMODEW::VALUE3)
            }
            #[doc = "NCM: Always (ignore band) FCM: If result switches to either level"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CHEVMODEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SYNC`"]
        pub enum SYNCW {
            #[doc = "No synchroniz. request, standalone operation"]
            VALUE1,
            #[doc = "Request a synchronized conversion of this channel (only taken into account for a master)"]
            VALUE2,
        }
        impl SYNCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SYNCW::VALUE1 => false,
                    SYNCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SYNCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SYNCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SYNCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No synchroniz. request, standalone operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SYNCW::VALUE1)
            }
            #[doc = "Request a synchronized conversion of this channel (only taken into account for a master)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SYNCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `REFSEL`"]
        pub enum REFSELW {
            #[doc = "Standard reference input VAREF"]
            VALUE1,
            #[doc = "Alternate reference input from CH0"]
            VALUE2,
        }
        impl REFSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    REFSELW::VALUE1 => false,
                    REFSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _REFSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REFSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: REFSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Standard reference input VAREF"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(REFSELW::VALUE1)
            }
            #[doc = "Alternate reference input from CH0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(REFSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RESREG`"]
        pub enum RESREGW {
            #[doc = "Store result in group result register GxRES0"]
            VALUE1,
            #[doc = "Store result in group result register GxRES15"]
            VALUE2,
        }
        impl RESREGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RESREGW::VALUE1 => 0,
                    RESREGW::VALUE2 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESREGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESREGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RESREGW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Store result in group result register GxRES0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RESREGW::VALUE1)
            }
            #[doc = "Store result in group result register GxRES15"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RESREGW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RESTBS`"]
        pub enum RESTBSW {
            #[doc = "Store results in the selected group result register"]
            VALUE1,
            #[doc = "Store results in the global result register"]
            VALUE2,
        }
        impl RESTBSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RESTBSW::VALUE1 => false,
                    RESTBSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESTBSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESTBSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RESTBSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Store results in the selected group result register"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RESTBSW::VALUE1)
            }
            #[doc = "Store results in the global result register"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RESTBSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `RESPOS`"]
        pub enum RESPOSW {
            #[doc = "Store results left-aligned"]
            VALUE1,
            #[doc = "Store results right-aligned"]
            VALUE2,
        }
        impl RESPOSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    RESPOSW::VALUE1 => false,
                    RESPOSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESPOSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESPOSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: RESPOSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Store results left-aligned"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(RESPOSW::VALUE1)
            }
            #[doc = "Store results right-aligned"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(RESPOSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWDCH`"]
        pub enum BWDCHW {
            #[doc = "Select VAGND"]
            VALUE1,
            #[doc = "Select VAREF"]
            VALUE2,
        }
        impl BWDCHW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BWDCHW::VALUE1 => 0,
                    BWDCHW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWDCHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWDCHW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWDCHW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Select VAGND"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWDCHW::VALUE1)
            }
            #[doc = "Select VAREF"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWDCHW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BWDEN`"]
        pub enum BWDENW {
            #[doc = "Normal operation"]
            VALUE1,
            #[doc = "Additional preparation phase is enabled"]
            VALUE2,
        }
        impl BWDENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    BWDENW::VALUE1 => false,
                    BWDENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BWDENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BWDENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BWDENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal operation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BWDENW::VALUE1)
            }
            #[doc = "Additional preparation phase is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BWDENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Input Class Select"]
            #[inline]
            pub fn iclsel(&self) -> ICLSELR {
                ICLSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Lower Boundary Select"]
            #[inline]
            pub fn bndsell(&self) -> BNDSELLR {
                BNDSELLR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Upper Boundary Select"]
            #[inline]
            pub fn bndselu(&self) -> BNDSELUR {
                BNDSELUR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Channel Event Mode"]
            #[inline]
            pub fn chevmode(&self) -> CHEVMODER {
                CHEVMODER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Synchronization Request"]
            #[inline]
            pub fn sync(&self) -> SYNCR {
                SYNCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Reference Input Selection"]
            #[inline]
            pub fn refsel(&self) -> REFSELR {
                REFSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:19 - Result Register"]
            #[inline]
            pub fn resreg(&self) -> RESREGR {
                RESREGR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Result Target for Background Source"]
            #[inline]
            pub fn restbs(&self) -> RESTBSR {
                RESTBSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - Result Position"]
            #[inline]
            pub fn respos(&self) -> RESPOSR {
                RESPOSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 28:29 - Broken Wire Detection Channel"]
            #[inline]
            pub fn bwdch(&self) -> BWDCHR {
                BWDCHR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 30 - Broken Wire Detection Enable"]
            #[inline]
            pub fn bwden(&self) -> BWDENR {
                BWDENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Input Class Select"]
            #[inline]
            pub fn iclsel(&mut self) -> _ICLSELW {
                _ICLSELW { w: self }
            }
            #[doc = "Bits 4:5 - Lower Boundary Select"]
            #[inline]
            pub fn bndsell(&mut self) -> _BNDSELLW {
                _BNDSELLW { w: self }
            }
            #[doc = "Bits 6:7 - Upper Boundary Select"]
            #[inline]
            pub fn bndselu(&mut self) -> _BNDSELUW {
                _BNDSELUW { w: self }
            }
            #[doc = "Bits 8:9 - Channel Event Mode"]
            #[inline]
            pub fn chevmode(&mut self) -> _CHEVMODEW {
                _CHEVMODEW { w: self }
            }
            #[doc = "Bit 10 - Synchronization Request"]
            #[inline]
            pub fn sync(&mut self) -> _SYNCW {
                _SYNCW { w: self }
            }
            #[doc = "Bit 11 - Reference Input Selection"]
            #[inline]
            pub fn refsel(&mut self) -> _REFSELW {
                _REFSELW { w: self }
            }
            #[doc = "Bits 16:19 - Result Register"]
            #[inline]
            pub fn resreg(&mut self) -> _RESREGW {
                _RESREGW { w: self }
            }
            #[doc = "Bit 20 - Result Target for Background Source"]
            #[inline]
            pub fn restbs(&mut self) -> _RESTBSW {
                _RESTBSW { w: self }
            }
            #[doc = "Bit 21 - Result Position"]
            #[inline]
            pub fn respos(&mut self) -> _RESPOSW {
                _RESPOSW { w: self }
            }
            #[doc = "Bits 28:29 - Broken Wire Detection Channel"]
            #[inline]
            pub fn bwdch(&mut self) -> _BWDCHW {
                _BWDCHW { w: self }
            }
            #[doc = "Bit 30 - Broken Wire Detection Enable"]
            #[inline]
            pub fn bwden(&mut self) -> _BWDENW {
                _BWDENW { w: self }
            }
        }
    }
    #[doc = "Result Control Register"]
    pub struct RCR {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Control Register"]
    pub mod rcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DRCTRR {
            bits: u8,
        }
        impl DRCTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DMM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DMMR {
            #[doc = "Standard data reduction (accumulation)"]
            VALUE1,
            #[doc = "Result filtering mode"]
            VALUE2,
            #[doc = "Difference mode"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl DMMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DMMR::VALUE1 => 0,
                    DMMR::VALUE2 => 0x01,
                    DMMR::VALUE3 => 0x02,
                    DMMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DMMR {
                match value {
                    0 => DMMR::VALUE1,
                    1 => DMMR::VALUE2,
                    2 => DMMR::VALUE3,
                    i => DMMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DMMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DMMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DMMR::VALUE3
            }
        }
        #[doc = "Possible values of the field `WFR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WFRR {
            #[doc = "Overwrite mode"]
            VALUE1,
            #[doc = "Wait-for-read mode enabled for this register"]
            VALUE2,
        }
        impl WFRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WFRR::VALUE1 => false,
                    WFRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WFRR {
                match value {
                    false => WFRR::VALUE1,
                    true => WFRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WFRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WFRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FENR {
            #[doc = "Separate result register"]
            VALUE1,
            #[doc = "Part of a FIFO structure: copy each new valid result"]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl FENR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    FENR::VALUE1 => 0,
                    FENR::VALUE2 => 0x01,
                    FENR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> FENR {
                match value {
                    0 => FENR::VALUE1,
                    1 => FENR::VALUE2,
                    i => FENR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SRGEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRGENR {
            #[doc = "No service request"]
            VALUE1,
            #[doc = "Service request after a result event"]
            VALUE2,
        }
        impl SRGENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRGENR::VALUE1 => false,
                    SRGENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRGENR {
                match value {
                    false => SRGENR::VALUE1,
                    true => SRGENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRGENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRGENR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _DRCTRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DRCTRW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DMM`"]
        pub enum DMMW {
            #[doc = "Standard data reduction (accumulation)"]
            VALUE1,
            #[doc = "Result filtering mode"]
            VALUE2,
            #[doc = "Difference mode"]
            VALUE3,
        }
        impl DMMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DMMW::VALUE1 => 0,
                    DMMW::VALUE2 => 1,
                    DMMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DMMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DMMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DMMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Standard data reduction (accumulation)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DMMW::VALUE1)
            }
            #[doc = "Result filtering mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DMMW::VALUE2)
            }
            #[doc = "Difference mode"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DMMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WFR`"]
        pub enum WFRW {
            #[doc = "Overwrite mode"]
            VALUE1,
            #[doc = "Wait-for-read mode enabled for this register"]
            VALUE2,
        }
        impl WFRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WFRW::VALUE1 => false,
                    WFRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WFRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WFRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WFRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Overwrite mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WFRW::VALUE1)
            }
            #[doc = "Wait-for-read mode enabled for this register"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WFRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FEN`"]
        pub enum FENW {
            #[doc = "Separate result register"]
            VALUE1,
            #[doc = "Part of a FIFO structure: copy each new valid result"]
            VALUE2,
        }
        impl FENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FENW::VALUE1 => 0,
                    FENW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FENW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Separate result register"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FENW::VALUE1)
            }
            #[doc = "Part of a FIFO structure: copy each new valid result"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FENW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SRGEN`"]
        pub enum SRGENW {
            #[doc = "No service request"]
            VALUE1,
            #[doc = "Service request after a result event"]
            VALUE2,
        }
        impl SRGENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRGENW::VALUE1 => false,
                    SRGENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRGENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRGENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRGENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "No service request"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRGENW::VALUE1)
            }
            #[doc = "Service request after a result event"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRGENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 16:19 - Data Reduction Control"]
            #[inline]
            pub fn drctr(&self) -> DRCTRR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DRCTRR { bits }
            }
            #[doc = "Bits 20:21 - Data Modification Mode"]
            #[inline]
            pub fn dmm(&self) -> DMMR {
                DMMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 24 - Wait-for-Read Mode Enable"]
            #[inline]
            pub fn wfr(&self) -> WFRR {
                WFRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 25:26 - FIFO Mode Enable"]
            #[inline]
            pub fn fen(&self) -> FENR {
                FENR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 31 - Service Request Generation Enable"]
            #[inline]
            pub fn srgen(&self) -> SRGENR {
                SRGENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 16:19 - Data Reduction Control"]
            #[inline]
            pub fn drctr(&mut self) -> _DRCTRW {
                _DRCTRW { w: self }
            }
            #[doc = "Bits 20:21 - Data Modification Mode"]
            #[inline]
            pub fn dmm(&mut self) -> _DMMW {
                _DMMW { w: self }
            }
            #[doc = "Bit 24 - Wait-for-Read Mode Enable"]
            #[inline]
            pub fn wfr(&mut self) -> _WFRW {
                _WFRW { w: self }
            }
            #[doc = "Bits 25:26 - FIFO Mode Enable"]
            #[inline]
            pub fn fen(&mut self) -> _FENW {
                _FENW { w: self }
            }
            #[doc = "Bit 31 - Service Request Generation Enable"]
            #[inline]
            pub fn srgen(&mut self) -> _SRGENW {
                _SRGENW { w: self }
            }
        }
    }
    #[doc = "Result Register"]
    pub struct RES {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Register"]
    pub mod res {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RES {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DRCR {
            bits: u8,
        }
        impl DRCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CHNRR {
            bits: u8,
        }
        impl CHNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXR {
            bits: u8,
        }
        impl EMUXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CRSR {
            #[doc = "Request source 0"]
            VALUE1,
            #[doc = "Request source 1"]
            VALUE2,
            #[doc = "Request source 2"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CRSR::VALUE1 => 0,
                    CRSR::VALUE2 => 0x01,
                    CRSR::VALUE3 => 0x02,
                    CRSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CRSR {
                match value {
                    0 => CRSR::VALUE1,
                    1 => CRSR::VALUE2,
                    2 => CRSR::VALUE3,
                    i => CRSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CRSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CRSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `FCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCRR {
            #[doc = "Signal level was below compare value"]
            VALUE1,
            #[doc = "Signal level was above compare value"]
            VALUE2,
        }
        impl FCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCRR::VALUE1 => false,
                    FCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCRR {
                match value {
                    false => FCRR::VALUE1,
                    true => FCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VFR {
            #[doc = "No new result available"]
            VALUE1,
            #[doc = "Bitfield RESULT has been updated with new result value and has not yet been read, or bit FCR has been updated"]
            VALUE2,
        }
        impl VFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VFR::VALUE1 => false,
                    VFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VFR {
                match value {
                    false => VFR::VALUE1,
                    true => VFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VFR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _RESULTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RESULTW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Result of Most Recent Conversion"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
            #[doc = "Bits 16:19 - Data Reduction Counter"]
            #[inline]
            pub fn drc(&self) -> DRCR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DRCR { bits }
            }
            #[doc = "Bits 20:24 - Channel Number"]
            #[inline]
            pub fn chnr(&self) -> CHNRR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CHNRR { bits }
            }
            #[doc = "Bits 25:27 - External Multiplexer Setting"]
            #[inline]
            pub fn emux(&self) -> EMUXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXR { bits }
            }
            #[doc = "Bits 28:29 - Converted Request Source"]
            #[inline]
            pub fn crs(&self) -> CRSR {
                CRSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 30 - Fast Compare Result"]
            #[inline]
            pub fn fcr(&self) -> FCRR {
                FCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Valid Flag"]
            #[inline]
            pub fn vf(&self) -> VFR {
                VFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Result of Most Recent Conversion"]
            #[inline]
            pub fn result(&mut self) -> _RESULTW {
                _RESULTW { w: self }
            }
        }
    }
    #[doc = "Result Register, Debug"]
    pub struct RESD {
        register: VolatileCell<u32>,
    }
    #[doc = "Result Register, Debug"]
    pub mod resd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::RESD {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct RESULTR {
            bits: u16,
        }
        impl RESULTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DRCR {
            bits: u8,
        }
        impl DRCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct CHNRR {
            bits: u8,
        }
        impl CHNRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct EMUXR {
            bits: u8,
        }
        impl EMUXR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CRSR {
            #[doc = "Request source 0"]
            VALUE1,
            #[doc = "Request source 1"]
            VALUE2,
            #[doc = "Request source 2"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CRSR::VALUE1 => 0,
                    CRSR::VALUE2 => 0x01,
                    CRSR::VALUE3 => 0x02,
                    CRSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CRSR {
                match value {
                    0 => CRSR::VALUE1,
                    1 => CRSR::VALUE2,
                    2 => CRSR::VALUE3,
                    i => CRSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CRSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CRSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `FCR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FCRR {
            #[doc = "Signal level was below compare value"]
            VALUE1,
            #[doc = "Signal level was above compare value"]
            VALUE2,
        }
        impl FCRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FCRR::VALUE1 => false,
                    FCRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FCRR {
                match value {
                    false => FCRR::VALUE1,
                    true => FCRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FCRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FCRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VF`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VFR {
            #[doc = "No new result available"]
            VALUE1,
            #[doc = "Bitfield RESULT has been updated with new result value and has not yet been read, or bit FCR has been updated"]
            VALUE2,
        }
        impl VFR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VFR::VALUE1 => false,
                    VFR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VFR {
                match value {
                    false => VFR::VALUE1,
                    true => VFR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VFR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VFR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Result of Most Recent Conversion"]
            #[inline]
            pub fn result(&self) -> RESULTR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RESULTR { bits }
            }
            #[doc = "Bits 16:19 - Data Reduction Counter"]
            #[inline]
            pub fn drc(&self) -> DRCR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DRCR { bits }
            }
            #[doc = "Bits 20:24 - Channel Number"]
            #[inline]
            pub fn chnr(&self) -> CHNRR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CHNRR { bits }
            }
            #[doc = "Bits 25:27 - External Multiplexer Setting"]
            #[inline]
            pub fn emux(&self) -> EMUXR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EMUXR { bits }
            }
            #[doc = "Bits 28:29 - Converted Request Source"]
            #[inline]
            pub fn crs(&self) -> CRSR {
                CRSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 30 - Fast Compare Result"]
            #[inline]
            pub fn fcr(&self) -> FCRR {
                FCRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - Valid Flag"]
            #[inline]
            pub fn vf(&self) -> VFR {
                VFR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
}
#[doc = "Analog to Digital Converter"]
pub struct VADC_G0 {
    register_block: vadc_g0::RegisterBlock,
}
impl Deref for VADC_G0 {
    type Target = vadc_g0::RegisterBlock;
    fn deref(&self) -> &vadc_g0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Analog to Digital Converter"]
pub const VADC_G1: Peripheral<VADC_G1> = unsafe { Peripheral::new(0x4000_4800) };
#[doc = r" Register block"]
pub struct VADC_G1 {
    register_block: vadc_g0::RegisterBlock,
}
impl Deref for VADC_G1 {
    type Target = vadc_g0::RegisterBlock;
    fn deref(&self) -> &vadc_g0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Digital to Analog Converter"]
pub const DAC: Peripheral<DAC> = unsafe { Peripheral::new(0x4801_8000) };
#[doc = "Digital to Analog Converter"]
pub mod dac {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Module Identification Register"]
        pub id: ID,
        #[doc = "0x04 - DAC0 Configuration Register 0"]
        pub dac0cfg0: DAC0CFG0,
        #[doc = "0x08 - DAC0 Configuration Register 1"]
        pub dac0cfg1: DAC0CFG1,
        #[doc = "0x0c - DAC1 Configuration Register 0"]
        pub dac1cfg0: DAC1CFG0,
        #[doc = "0x10 - DAC1 Configuration Register 1"]
        pub dac1cfg1: DAC1CFG1,
        #[doc = "0x14 - DAC0 Data Register"]
        pub dac0data: DAC0DATA,
        #[doc = "0x18 - DAC1 Data Register"]
        pub dac1data: DAC1DATA,
        #[doc = "0x1c - DAC01 Data Register"]
        pub dac01data: DAC01DATA,
        #[doc = "0x20 - DAC0 Lower Pattern Register"]
        pub dac0patl: DAC0PATL,
        #[doc = "0x24 - DAC0 Higher Pattern Register"]
        pub dac0path: DAC0PATH,
        #[doc = "0x28 - DAC1 Lower Pattern Register"]
        pub dac1patl: DAC1PATL,
        #[doc = "0x2c - DAC1 Higher Pattern Register"]
        pub dac1path: DAC1PATH,
    }
    #[doc = "Module Identification Register"]
    pub struct ID {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification Register"]
    pub mod id {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ID {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODRR {
            bits: u8,
        }
        impl MODRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODTR {
            bits: u8,
        }
        impl MODTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODNR {
            bits: u16,
        }
        impl MODNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn modr(&self) -> MODRR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODRR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn modt(&self) -> MODTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODTR { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn modn(&self) -> MODNR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MODNR { bits }
            }
        }
    }
    #[doc = "DAC0 Configuration Register 0"]
    pub struct DAC0CFG0 {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC0 Configuration Register 0"]
    pub mod dac0cfg0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC0CFG0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct FREQR {
            bits: u32,
        }
        impl FREQR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MODER {
            #[doc = "disable/switch-off DAC"]
            VALUE1,
            #[doc = "Single Value Mode"]
            VALUE2,
            #[doc = "Data Mode"]
            VALUE3,
            #[doc = "Patgen Mode"]
            VALUE4,
            #[doc = "Noise Mode"]
            VALUE5,
            #[doc = "Ramp Mode"]
            VALUE6,
            #[doc = "na"]
            VALUE7,
            #[doc = "na"]
            VALUE8,
        }
        impl MODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MODER::VALUE1 => 0,
                    MODER::VALUE2 => 0x01,
                    MODER::VALUE3 => 0x02,
                    MODER::VALUE4 => 0x03,
                    MODER::VALUE5 => 0x04,
                    MODER::VALUE6 => 0x05,
                    MODER::VALUE7 => 0x06,
                    MODER::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MODER {
                match value {
                    0 => MODER::VALUE1,
                    1 => MODER::VALUE2,
                    2 => MODER::VALUE3,
                    3 => MODER::VALUE4,
                    4 => MODER::VALUE5,
                    5 => MODER::VALUE6,
                    6 => MODER::VALUE7,
                    7 => MODER::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MODER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == MODER::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == MODER::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == MODER::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == MODER::VALUE8
            }
        }
        #[doc = "Possible values of the field `SIGN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SIGNR {
            #[doc = "DAC expects unsigned input data"]
            VALUE1,
            #[doc = "DAC expects signed input data"]
            VALUE2,
        }
        impl SIGNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SIGNR::VALUE1 => false,
                    SIGNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SIGNR {
                match value {
                    false => SIGNR::VALUE1,
                    true => SIGNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SIGNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SIGNR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct FIFOINDR {
            bits: u8,
        }
        impl FIFOINDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FIFOEMP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFOEMPR {
            #[doc = "FIFO not empty"]
            VALUE1,
            #[doc = "FIFO empty"]
            VALUE2,
        }
        impl FIFOEMPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFOEMPR::VALUE1 => false,
                    FIFOEMPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFOEMPR {
                match value {
                    false => FIFOEMPR::VALUE1,
                    true => FIFOEMPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFOEMPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFOEMPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FIFOFUL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFOFULR {
            #[doc = "FIFO not full"]
            VALUE1,
            #[doc = "FIFO full"]
            VALUE2,
        }
        impl FIFOFULR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFOFULR::VALUE1 => false,
                    FIFOFULR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFOFULR {
                match value {
                    false => FIFOFULR::VALUE1,
                    true => FIFOFULR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFOFULR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFOFULR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NEGATE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NEGATER {
            #[doc = "DAC output not negated"]
            VALUE1,
            #[doc = "DAC output negated"]
            VALUE2,
        }
        impl NEGATER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NEGATER::VALUE1 => false,
                    NEGATER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NEGATER {
                match value {
                    false => NEGATER::VALUE1,
                    true => NEGATER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NEGATER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NEGATER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SIGNEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SIGNENR {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl SIGNENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SIGNENR::VALUE1 => false,
                    SIGNENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SIGNENR {
                match value {
                    false => SIGNENR::VALUE1,
                    true => SIGNENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SIGNENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SIGNENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SREN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRENR {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl SRENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRENR::VALUE1 => false,
                    SRENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRENR {
                match value {
                    false => SRENR::VALUE1,
                    true => SRENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RUN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RUNR {
            #[doc = "DAC0 channel disabled"]
            VALUE1,
            #[doc = "DAC0 channel in operation"]
            VALUE2,
        }
        impl RUNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RUNR::VALUE1 => false,
                    RUNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RUNR {
                match value {
                    false => RUNR::VALUE1,
                    true => RUNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RUNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RUNR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _FREQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FREQW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x000f_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MODE`"]
        pub enum MODEW {
            #[doc = "disable/switch-off DAC"]
            VALUE1,
            #[doc = "Single Value Mode"]
            VALUE2,
            #[doc = "Data Mode"]
            VALUE3,
            #[doc = "Patgen Mode"]
            VALUE4,
            #[doc = "Noise Mode"]
            VALUE5,
            #[doc = "Ramp Mode"]
            VALUE6,
            #[doc = "na"]
            VALUE7,
            #[doc = "na"]
            VALUE8,
        }
        impl MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MODEW::VALUE1 => 0,
                    MODEW::VALUE2 => 1,
                    MODEW::VALUE3 => 2,
                    MODEW::VALUE4 => 3,
                    MODEW::VALUE5 => 4,
                    MODEW::VALUE6 => 5,
                    MODEW::VALUE7 => 6,
                    MODEW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "disable/switch-off DAC"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MODEW::VALUE1)
            }
            #[doc = "Single Value Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MODEW::VALUE2)
            }
            #[doc = "Data Mode"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MODEW::VALUE3)
            }
            #[doc = "Patgen Mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MODEW::VALUE4)
            }
            #[doc = "Noise Mode"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(MODEW::VALUE5)
            }
            #[doc = "Ramp Mode"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(MODEW::VALUE6)
            }
            #[doc = "na"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(MODEW::VALUE7)
            }
            #[doc = "na"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(MODEW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIGN`"]
        pub enum SIGNW {
            #[doc = "DAC expects unsigned input data"]
            VALUE1,
            #[doc = "DAC expects signed input data"]
            VALUE2,
        }
        impl SIGNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIGNW::VALUE1 => false,
                    SIGNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIGNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIGNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIGNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DAC expects unsigned input data"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIGNW::VALUE1)
            }
            #[doc = "DAC expects signed input data"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIGNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NEGATE`"]
        pub enum NEGATEW {
            #[doc = "DAC output not negated"]
            VALUE1,
            #[doc = "DAC output negated"]
            VALUE2,
        }
        impl NEGATEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NEGATEW::VALUE1 => false,
                    NEGATEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NEGATEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NEGATEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NEGATEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DAC output not negated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NEGATEW::VALUE1)
            }
            #[doc = "DAC output negated"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NEGATEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIGNEN`"]
        pub enum SIGNENW {
            #[doc = "Disable"]
            VALUE1,
            #[doc = "Enable"]
            VALUE2,
        }
        impl SIGNENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIGNENW::VALUE1 => false,
                    SIGNENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIGNENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIGNENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIGNENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIGNENW::VALUE1)
            }
            #[doc = "Enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIGNENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SREN`"]
        pub enum SRENW {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl SRENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRENW::VALUE1 => false,
                    SRENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRENW::VALUE1)
            }
            #[doc = "enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:19 - Integer Frequency Divider Value"]
            #[inline]
            pub fn freq(&self) -> FREQR {
                let bits = {
                    const MASK: u32 = 0x000f_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FREQR { bits }
            }
            #[doc = "Bits 20:22 - Enables and Sets the Mode for DAC0"]
            #[inline]
            pub fn mode(&self) -> MODER {
                MODER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 23 - Selects Between Signed and Unsigned DAC0 Mode"]
            #[inline]
            pub fn sign(&self) -> SIGNR {
                SIGNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 24:25 - Current write position inside the data FIFO"]
            #[inline]
            pub fn fifoind(&self) -> FIFOINDR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FIFOINDR { bits }
            }
            #[doc = "Bit 26 - Indicate if the FIFO is empty"]
            #[inline]
            pub fn fifoemp(&self) -> FIFOEMPR {
                FIFOEMPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - Indicate if the FIFO is full"]
            #[inline]
            pub fn fifoful(&self) -> FIFOFULR {
                FIFOFULR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - Negates the DAC0 output"]
            #[inline]
            pub fn negate(&self) -> NEGATER {
                NEGATER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Enable Sign Output of DAC0 Pattern Generator"]
            #[inline]
            pub fn signen(&self) -> SIGNENR {
                SIGNENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Enable DAC0 service request interrupt generation"]
            #[inline]
            pub fn sren(&self) -> SRENR {
                SRENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - RUN indicates the current DAC0 operation status"]
            #[inline]
            pub fn run(&self) -> RUNR {
                RUNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:19 - Integer Frequency Divider Value"]
            #[inline]
            pub fn freq(&mut self) -> _FREQW {
                _FREQW { w: self }
            }
            #[doc = "Bits 20:22 - Enables and Sets the Mode for DAC0"]
            #[inline]
            pub fn mode(&mut self) -> _MODEW {
                _MODEW { w: self }
            }
            #[doc = "Bit 23 - Selects Between Signed and Unsigned DAC0 Mode"]
            #[inline]
            pub fn sign(&mut self) -> _SIGNW {
                _SIGNW { w: self }
            }
            #[doc = "Bit 28 - Negates the DAC0 output"]
            #[inline]
            pub fn negate(&mut self) -> _NEGATEW {
                _NEGATEW { w: self }
            }
            #[doc = "Bit 29 - Enable Sign Output of DAC0 Pattern Generator"]
            #[inline]
            pub fn signen(&mut self) -> _SIGNENW {
                _SIGNENW { w: self }
            }
            #[doc = "Bit 30 - Enable DAC0 service request interrupt generation"]
            #[inline]
            pub fn sren(&mut self) -> _SRENW {
                _SRENW { w: self }
            }
        }
    }
    #[doc = "DAC0 Configuration Register 1"]
    pub struct DAC0CFG1 {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC0 Configuration Register 1"]
    pub mod dac0cfg1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC0CFG1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SCALE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCALER {
            #[doc = "no shift = multiplication/division by 1"]
            VALUE1,
            #[doc = "shift by 1 = multiplication/division by 2"]
            VALUE2,
            #[doc = "shift by 2 = multiplication/division by 4"]
            VALUE3,
            #[doc = "shift left by 3 = multiplication/division by 8"]
            VALUE4,
            #[doc = "shift left by 4 = multiplication/division by 16"]
            VALUE5,
            #[doc = "shift left by 5 = multiplication/division by 32"]
            VALUE6,
            #[doc = "shift left by 6 = multiplication/division by 64"]
            VALUE7,
            #[doc = "shift left by 7 = multiplication/division by 128"]
            VALUE8,
        }
        impl SCALER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SCALER::VALUE1 => 0,
                    SCALER::VALUE2 => 0x01,
                    SCALER::VALUE3 => 0x02,
                    SCALER::VALUE4 => 0x03,
                    SCALER::VALUE5 => 0x04,
                    SCALER::VALUE6 => 0x05,
                    SCALER::VALUE7 => 0x06,
                    SCALER::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SCALER {
                match value {
                    0 => SCALER::VALUE1,
                    1 => SCALER::VALUE2,
                    2 => SCALER::VALUE3,
                    3 => SCALER::VALUE4,
                    4 => SCALER::VALUE5,
                    5 => SCALER::VALUE6,
                    6 => SCALER::VALUE7,
                    7 => SCALER::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCALER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCALER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SCALER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SCALER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SCALER::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SCALER::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == SCALER::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == SCALER::VALUE8
            }
        }
        #[doc = "Possible values of the field `MULDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MULDIVR {
            #[doc = "downscale = division (shift SCALE positions to the right)"]
            VALUE1,
            #[doc = "upscale = multiplication (shift SCALE positions to the left)"]
            VALUE2,
        }
        impl MULDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MULDIVR::VALUE1 => false,
                    MULDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MULDIVR {
                match value {
                    false => MULDIVR::VALUE1,
                    true => MULDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MULDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MULDIVR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct OFFSR {
            bits: u8,
        }
        impl OFFSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRIGSELR {
            bits: u8,
        }
        impl TRIGSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `DATMOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DATMODR {
            #[doc = "independent data handling - process data from DATA0 register (bits 11:0) to DAC0 and data from DATA1 register (bits 11:0) to DAC1"]
            VALUE1,
            #[doc = "simultaneous data handling - process data from DAC01 register to both DACs (bits 11:0 to DAC0 and bits 23:12 to DAC1)."]
            VALUE2,
        }
        impl DATMODR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DATMODR::VALUE1 => false,
                    DATMODR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DATMODR {
                match value {
                    false => DATMODR::VALUE1,
                    true => DATMODR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DATMODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DATMODR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct SWTRIGR {
            bits: bool,
        }
        impl SWTRIGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TRIGMOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRIGMODR {
            #[doc = "internal Trigger (integer divided clock - see FREQ parameter)"]
            VALUE1,
            #[doc = "external Trigger (preselected trigger by TRIGSEL parameter)"]
            VALUE2,
            #[doc = "software Trigger (see SWTRIG parameter)"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TRIGMODR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRIGMODR::VALUE1 => 0,
                    TRIGMODR::VALUE2 => 0x01,
                    TRIGMODR::VALUE3 => 0x02,
                    TRIGMODR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRIGMODR {
                match value {
                    0 => TRIGMODR::VALUE1,
                    1 => TRIGMODR::VALUE2,
                    2 => TRIGMODR::VALUE3,
                    i => TRIGMODR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRIGMODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRIGMODR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRIGMODR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct ANACFGR {
            bits: u8,
        }
        impl ANACFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ANAEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ANAENR {
            #[doc = "DAC0 is set to standby (analog output only)"]
            VALUE1,
            #[doc = "enable DAC0 (analog output only)"]
            VALUE2,
        }
        impl ANAENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ANAENR::VALUE1 => false,
                    ANAENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ANAENR {
                match value {
                    false => ANAENR::VALUE1,
                    true => ANAENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ANAENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ANAENR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct REFCFGLR {
            bits: u8,
        }
        impl REFCFGLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `SCALE`"]
        pub enum SCALEW {
            #[doc = "no shift = multiplication/division by 1"]
            VALUE1,
            #[doc = "shift by 1 = multiplication/division by 2"]
            VALUE2,
            #[doc = "shift by 2 = multiplication/division by 4"]
            VALUE3,
            #[doc = "shift left by 3 = multiplication/division by 8"]
            VALUE4,
            #[doc = "shift left by 4 = multiplication/division by 16"]
            VALUE5,
            #[doc = "shift left by 5 = multiplication/division by 32"]
            VALUE6,
            #[doc = "shift left by 6 = multiplication/division by 64"]
            VALUE7,
            #[doc = "shift left by 7 = multiplication/division by 128"]
            VALUE8,
        }
        impl SCALEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SCALEW::VALUE1 => 0,
                    SCALEW::VALUE2 => 1,
                    SCALEW::VALUE3 => 2,
                    SCALEW::VALUE4 => 3,
                    SCALEW::VALUE5 => 4,
                    SCALEW::VALUE6 => 5,
                    SCALEW::VALUE7 => 6,
                    SCALEW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCALEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCALEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCALEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "no shift = multiplication/division by 1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCALEW::VALUE1)
            }
            #[doc = "shift by 1 = multiplication/division by 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCALEW::VALUE2)
            }
            #[doc = "shift by 2 = multiplication/division by 4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SCALEW::VALUE3)
            }
            #[doc = "shift left by 3 = multiplication/division by 8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SCALEW::VALUE4)
            }
            #[doc = "shift left by 4 = multiplication/division by 16"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SCALEW::VALUE5)
            }
            #[doc = "shift left by 5 = multiplication/division by 32"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SCALEW::VALUE6)
            }
            #[doc = "shift left by 6 = multiplication/division by 64"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(SCALEW::VALUE7)
            }
            #[doc = "shift left by 7 = multiplication/division by 128"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(SCALEW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MULDIV`"]
        pub enum MULDIVW {
            #[doc = "downscale = division (shift SCALE positions to the right)"]
            VALUE1,
            #[doc = "upscale = multiplication (shift SCALE positions to the left)"]
            VALUE2,
        }
        impl MULDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MULDIVW::VALUE1 => false,
                    MULDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MULDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MULDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MULDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "downscale = division (shift SCALE positions to the right)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MULDIVW::VALUE1)
            }
            #[doc = "upscale = multiplication (shift SCALE positions to the left)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MULDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OFFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OFFSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIGSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIGSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DATMOD`"]
        pub enum DATMODW {
            #[doc = "independent data handling - process data from DATA0 register (bits 11:0) to DAC0 and data from DATA1 register (bits 11:0) to DAC1"]
            VALUE1,
            #[doc = "simultaneous data handling - process data from DAC01 register to both DACs (bits 11:0 to DAC0 and bits 23:12 to DAC1)."]
            VALUE2,
        }
        impl DATMODW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DATMODW::VALUE1 => false,
                    DATMODW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATMODW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATMODW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DATMODW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "independent data handling - process data from DATA0 register (bits 11:0) to DAC0 and data from DATA1 register (bits 11:0) to DAC1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DATMODW::VALUE1)
            }
            #[doc = "simultaneous data handling - process data from DAC01 register to both DACs (bits 11:0 to DAC0 and bits 23:12 to DAC1)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DATMODW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SWTRIGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SWTRIGW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRIGMOD`"]
        pub enum TRIGMODW {
            #[doc = "internal Trigger (integer divided clock - see FREQ parameter)"]
            VALUE1,
            #[doc = "external Trigger (preselected trigger by TRIGSEL parameter)"]
            VALUE2,
            #[doc = "software Trigger (see SWTRIG parameter)"]
            VALUE3,
        }
        impl TRIGMODW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRIGMODW::VALUE1 => 0,
                    TRIGMODW::VALUE2 => 1,
                    TRIGMODW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIGMODW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIGMODW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRIGMODW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "internal Trigger (integer divided clock - see FREQ parameter)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRIGMODW::VALUE1)
            }
            #[doc = "external Trigger (preselected trigger by TRIGSEL parameter)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRIGMODW::VALUE2)
            }
            #[doc = "software Trigger (see SWTRIG parameter)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRIGMODW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ANACFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ANACFGW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ANAEN`"]
        pub enum ANAENW {
            #[doc = "DAC0 is set to standby (analog output only)"]
            VALUE1,
            #[doc = "enable DAC0 (analog output only)"]
            VALUE2,
        }
        impl ANAENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ANAENW::VALUE1 => false,
                    ANAENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ANAENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ANAENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ANAENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DAC0 is set to standby (analog output only)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ANAENW::VALUE1)
            }
            #[doc = "enable DAC0 (analog output only)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ANAENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _REFCFGLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REFCFGLW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Scale value for up- or downscale of the DAC0 input data in steps by the power of 2 (=shift operation)"]
            #[inline]
            pub fn scale(&self) -> SCALER {
                SCALER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Switch between up- and downscale of the DAC0 input data values"]
            #[inline]
            pub fn muldiv(&self) -> MULDIVR {
                MULDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:11 - 8-bit offset value addition"]
            #[inline]
            pub fn offs(&self) -> OFFSR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OFFSR { bits }
            }
            #[doc = "Bits 12:14 - Selects one of the eight external trigger sources for DAC0"]
            #[inline]
            pub fn trigsel(&self) -> TRIGSELR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TRIGSELR { bits }
            }
            #[doc = "Bit 15 - Switch between independent or simultaneous DAC mode and select the input data register for DAC0 and DAC1"]
            #[inline]
            pub fn datmod(&self) -> DATMODR {
                DATMODR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Software Trigger"]
            #[inline]
            pub fn swtrig(&self) -> SWTRIGR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SWTRIGR { bits }
            }
            #[doc = "Bits 17:18 - Select the trigger source for channel 0"]
            #[inline]
            pub fn trigmod(&self) -> TRIGMODR {
                TRIGMODR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - DAC0 analog configuration/calibration parameters"]
            #[inline]
            pub fn anacfg(&self) -> ANACFGR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ANACFGR { bits }
            }
            #[doc = "Bit 24 - Enable analog DAC for channel 0"]
            #[inline]
            pub fn anaen(&self) -> ANAENR {
                ANAENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 28:31 - Lower 4 band-gap configuration/calibration parameters"]
            #[inline]
            pub fn refcfgl(&self) -> REFCFGLR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REFCFGLR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Scale value for up- or downscale of the DAC0 input data in steps by the power of 2 (=shift operation)"]
            #[inline]
            pub fn scale(&mut self) -> _SCALEW {
                _SCALEW { w: self }
            }
            #[doc = "Bit 3 - Switch between up- and downscale of the DAC0 input data values"]
            #[inline]
            pub fn muldiv(&mut self) -> _MULDIVW {
                _MULDIVW { w: self }
            }
            #[doc = "Bits 4:11 - 8-bit offset value addition"]
            #[inline]
            pub fn offs(&mut self) -> _OFFSW {
                _OFFSW { w: self }
            }
            #[doc = "Bits 12:14 - Selects one of the eight external trigger sources for DAC0"]
            #[inline]
            pub fn trigsel(&mut self) -> _TRIGSELW {
                _TRIGSELW { w: self }
            }
            #[doc = "Bit 15 - Switch between independent or simultaneous DAC mode and select the input data register for DAC0 and DAC1"]
            #[inline]
            pub fn datmod(&mut self) -> _DATMODW {
                _DATMODW { w: self }
            }
            #[doc = "Bit 16 - Software Trigger"]
            #[inline]
            pub fn swtrig(&mut self) -> _SWTRIGW {
                _SWTRIGW { w: self }
            }
            #[doc = "Bits 17:18 - Select the trigger source for channel 0"]
            #[inline]
            pub fn trigmod(&mut self) -> _TRIGMODW {
                _TRIGMODW { w: self }
            }
            #[doc = "Bits 19:23 - DAC0 analog configuration/calibration parameters"]
            #[inline]
            pub fn anacfg(&mut self) -> _ANACFGW {
                _ANACFGW { w: self }
            }
            #[doc = "Bit 24 - Enable analog DAC for channel 0"]
            #[inline]
            pub fn anaen(&mut self) -> _ANAENW {
                _ANAENW { w: self }
            }
            #[doc = "Bits 28:31 - Lower 4 band-gap configuration/calibration parameters"]
            #[inline]
            pub fn refcfgl(&mut self) -> _REFCFGLW {
                _REFCFGLW { w: self }
            }
        }
    }
    #[doc = "DAC1 Configuration Register 0"]
    pub struct DAC1CFG0 {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC1 Configuration Register 0"]
    pub mod dac1cfg0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC1CFG0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct FREQR {
            bits: u32,
        }
        impl FREQR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `MODE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MODER {
            #[doc = "disable/switch-off DAC"]
            VALUE1,
            #[doc = "Single Value Mode"]
            VALUE2,
            #[doc = "Data Mode"]
            VALUE3,
            #[doc = "Patgen Mode"]
            VALUE4,
            #[doc = "Noise Mode"]
            VALUE5,
            #[doc = "Ramp Mode"]
            VALUE6,
            #[doc = "na"]
            VALUE7,
            #[doc = "na"]
            VALUE8,
        }
        impl MODER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MODER::VALUE1 => 0,
                    MODER::VALUE2 => 0x01,
                    MODER::VALUE3 => 0x02,
                    MODER::VALUE4 => 0x03,
                    MODER::VALUE5 => 0x04,
                    MODER::VALUE6 => 0x05,
                    MODER::VALUE7 => 0x06,
                    MODER::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MODER {
                match value {
                    0 => MODER::VALUE1,
                    1 => MODER::VALUE2,
                    2 => MODER::VALUE3,
                    3 => MODER::VALUE4,
                    4 => MODER::VALUE5,
                    5 => MODER::VALUE6,
                    6 => MODER::VALUE7,
                    7 => MODER::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MODER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MODER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MODER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MODER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == MODER::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == MODER::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == MODER::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == MODER::VALUE8
            }
        }
        #[doc = "Possible values of the field `SIGN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SIGNR {
            #[doc = "DAC expects unsigned input data"]
            VALUE1,
            #[doc = "DAC expects signed input data"]
            VALUE2,
        }
        impl SIGNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SIGNR::VALUE1 => false,
                    SIGNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SIGNR {
                match value {
                    false => SIGNR::VALUE1,
                    true => SIGNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SIGNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SIGNR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct FIFOINDR {
            bits: u8,
        }
        impl FIFOINDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FIFOEMP`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFOEMPR {
            #[doc = "FIFO not empty"]
            VALUE1,
            #[doc = "FIFO empty"]
            VALUE2,
        }
        impl FIFOEMPR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFOEMPR::VALUE1 => false,
                    FIFOEMPR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFOEMPR {
                match value {
                    false => FIFOEMPR::VALUE1,
                    true => FIFOEMPR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFOEMPR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFOEMPR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FIFOFUL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FIFOFULR {
            #[doc = "FIFO not full"]
            VALUE1,
            #[doc = "FIFO full"]
            VALUE2,
        }
        impl FIFOFULR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FIFOFULR::VALUE1 => false,
                    FIFOFULR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FIFOFULR {
                match value {
                    false => FIFOFULR::VALUE1,
                    true => FIFOFULR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FIFOFULR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FIFOFULR::VALUE2
            }
        }
        #[doc = "Possible values of the field `NEGATE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum NEGATER {
            #[doc = "DAC output not negated"]
            VALUE1,
            #[doc = "DAC output negated"]
            VALUE2,
        }
        impl NEGATER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    NEGATER::VALUE1 => false,
                    NEGATER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> NEGATER {
                match value {
                    false => NEGATER::VALUE1,
                    true => NEGATER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == NEGATER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == NEGATER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SIGNEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SIGNENR {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl SIGNENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SIGNENR::VALUE1 => false,
                    SIGNENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SIGNENR {
                match value {
                    false => SIGNENR::VALUE1,
                    true => SIGNENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SIGNENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SIGNENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SREN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SRENR {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl SRENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SRENR::VALUE1 => false,
                    SRENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SRENR {
                match value {
                    false => SRENR::VALUE1,
                    true => SRENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SRENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SRENR::VALUE2
            }
        }
        #[doc = "Possible values of the field `RUN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RUNR {
            #[doc = "DAC1 channel disabled"]
            VALUE1,
            #[doc = "DAC1 channel in operation"]
            VALUE2,
        }
        impl RUNR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RUNR::VALUE1 => false,
                    RUNR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RUNR {
                match value {
                    false => RUNR::VALUE1,
                    true => RUNR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RUNR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RUNR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _FREQW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FREQW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u32) -> &'a mut W {
                const MASK: u32 = 0x000f_ffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MODE`"]
        pub enum MODEW {
            #[doc = "disable/switch-off DAC"]
            VALUE1,
            #[doc = "Single Value Mode"]
            VALUE2,
            #[doc = "Data Mode"]
            VALUE3,
            #[doc = "Patgen Mode"]
            VALUE4,
            #[doc = "Noise Mode"]
            VALUE5,
            #[doc = "Ramp Mode"]
            VALUE6,
            #[doc = "na"]
            VALUE7,
            #[doc = "na"]
            VALUE8,
        }
        impl MODEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MODEW::VALUE1 => 0,
                    MODEW::VALUE2 => 1,
                    MODEW::VALUE3 => 2,
                    MODEW::VALUE4 => 3,
                    MODEW::VALUE5 => 4,
                    MODEW::VALUE6 => 5,
                    MODEW::VALUE7 => 6,
                    MODEW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MODEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MODEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MODEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "disable/switch-off DAC"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MODEW::VALUE1)
            }
            #[doc = "Single Value Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MODEW::VALUE2)
            }
            #[doc = "Data Mode"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MODEW::VALUE3)
            }
            #[doc = "Patgen Mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MODEW::VALUE4)
            }
            #[doc = "Noise Mode"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(MODEW::VALUE5)
            }
            #[doc = "Ramp Mode"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(MODEW::VALUE6)
            }
            #[doc = "na"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(MODEW::VALUE7)
            }
            #[doc = "na"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(MODEW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIGN`"]
        pub enum SIGNW {
            #[doc = "DAC expects unsigned input data"]
            VALUE1,
            #[doc = "DAC expects signed input data"]
            VALUE2,
        }
        impl SIGNW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIGNW::VALUE1 => false,
                    SIGNW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIGNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIGNW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIGNW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DAC expects unsigned input data"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIGNW::VALUE1)
            }
            #[doc = "DAC expects signed input data"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIGNW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `NEGATE`"]
        pub enum NEGATEW {
            #[doc = "DAC output not negated"]
            VALUE1,
            #[doc = "DAC output negated"]
            VALUE2,
        }
        impl NEGATEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    NEGATEW::VALUE1 => false,
                    NEGATEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _NEGATEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NEGATEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: NEGATEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DAC output not negated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(NEGATEW::VALUE1)
            }
            #[doc = "DAC output negated"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(NEGATEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SIGNEN`"]
        pub enum SIGNENW {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl SIGNENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SIGNENW::VALUE1 => false,
                    SIGNENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SIGNENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SIGNENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SIGNENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SIGNENW::VALUE1)
            }
            #[doc = "enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SIGNENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SREN`"]
        pub enum SRENW {
            #[doc = "disable"]
            VALUE1,
            #[doc = "enable"]
            VALUE2,
        }
        impl SRENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SRENW::VALUE1 => false,
                    SRENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SRENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "disable"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SRENW::VALUE1)
            }
            #[doc = "enable"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SRENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:19 - Integer Frequency Divider Value"]
            #[inline]
            pub fn freq(&self) -> FREQR {
                let bits = {
                    const MASK: u32 = 0x000f_ffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FREQR { bits }
            }
            #[doc = "Bits 20:22 - Enables and sets the Mode for DAC1"]
            #[inline]
            pub fn mode(&self) -> MODER {
                MODER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 23 - Selects between signed and unsigned DAC1 mode"]
            #[inline]
            pub fn sign(&self) -> SIGNR {
                SIGNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 24:25 - Current write position inside the data FIFO"]
            #[inline]
            pub fn fifoind(&self) -> FIFOINDR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FIFOINDR { bits }
            }
            #[doc = "Bit 26 - Indicate if the FIFO is empty"]
            #[inline]
            pub fn fifoemp(&self) -> FIFOEMPR {
                FIFOEMPR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - Indicate if the FIFO is full"]
            #[inline]
            pub fn fifoful(&self) -> FIFOFULR {
                FIFOFULR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - Negates the DAC1 output"]
            #[inline]
            pub fn negate(&self) -> NEGATER {
                NEGATER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 29 - Enable sign output of DAC1 pattern generator"]
            #[inline]
            pub fn signen(&self) -> SIGNENR {
                SIGNENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 30 - Enable DAC1 service request interrupt generation"]
            #[inline]
            pub fn sren(&self) -> SRENR {
                SRENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 31 - RUN indicates the current DAC1 operation status"]
            #[inline]
            pub fn run(&self) -> RUNR {
                RUNR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:19 - Integer Frequency Divider Value"]
            #[inline]
            pub fn freq(&mut self) -> _FREQW {
                _FREQW { w: self }
            }
            #[doc = "Bits 20:22 - Enables and sets the Mode for DAC1"]
            #[inline]
            pub fn mode(&mut self) -> _MODEW {
                _MODEW { w: self }
            }
            #[doc = "Bit 23 - Selects between signed and unsigned DAC1 mode"]
            #[inline]
            pub fn sign(&mut self) -> _SIGNW {
                _SIGNW { w: self }
            }
            #[doc = "Bit 28 - Negates the DAC1 output"]
            #[inline]
            pub fn negate(&mut self) -> _NEGATEW {
                _NEGATEW { w: self }
            }
            #[doc = "Bit 29 - Enable sign output of DAC1 pattern generator"]
            #[inline]
            pub fn signen(&mut self) -> _SIGNENW {
                _SIGNENW { w: self }
            }
            #[doc = "Bit 30 - Enable DAC1 service request interrupt generation"]
            #[inline]
            pub fn sren(&mut self) -> _SRENW {
                _SRENW { w: self }
            }
        }
    }
    #[doc = "DAC1 Configuration Register 1"]
    pub struct DAC1CFG1 {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC1 Configuration Register 1"]
    pub mod dac1cfg1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC1CFG1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SCALE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCALER {
            #[doc = "no shift = multiplication/division by 1"]
            VALUE1,
            #[doc = "shift by 1 = multiplication/division by 2"]
            VALUE2,
            #[doc = "shift by 2 = multiplication/division by 4"]
            VALUE3,
            #[doc = "shift left by 3 = multiplication/division by 8"]
            VALUE4,
            #[doc = "shift left by 4 = multiplication/division by 16"]
            VALUE5,
            #[doc = "shift left by 5 = multiplication/division by 32"]
            VALUE6,
            #[doc = "shift left by 6 = multiplication/division by 64"]
            VALUE7,
            #[doc = "shift left by 7 = multiplication/division by 128"]
            VALUE8,
        }
        impl SCALER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SCALER::VALUE1 => 0,
                    SCALER::VALUE2 => 0x01,
                    SCALER::VALUE3 => 0x02,
                    SCALER::VALUE4 => 0x03,
                    SCALER::VALUE5 => 0x04,
                    SCALER::VALUE6 => 0x05,
                    SCALER::VALUE7 => 0x06,
                    SCALER::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SCALER {
                match value {
                    0 => SCALER::VALUE1,
                    1 => SCALER::VALUE2,
                    2 => SCALER::VALUE3,
                    3 => SCALER::VALUE4,
                    4 => SCALER::VALUE5,
                    5 => SCALER::VALUE6,
                    6 => SCALER::VALUE7,
                    7 => SCALER::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCALER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCALER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SCALER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SCALER::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SCALER::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SCALER::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == SCALER::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == SCALER::VALUE8
            }
        }
        #[doc = "Possible values of the field `MULDIV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MULDIVR {
            #[doc = "downscale = division (shift SCALE positions to the right)"]
            VALUE1,
            #[doc = "upscale = multiplication (shift SCALE positions to the left)"]
            VALUE2,
        }
        impl MULDIVR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MULDIVR::VALUE1 => false,
                    MULDIVR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MULDIVR {
                match value {
                    false => MULDIVR::VALUE1,
                    true => MULDIVR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MULDIVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MULDIVR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct OFFSR {
            bits: u8,
        }
        impl OFFSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRIGSELR {
            bits: u8,
        }
        impl TRIGSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SWTRIGR {
            bits: bool,
        }
        impl SWTRIGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TRIGMOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRIGMODR {
            #[doc = "internal Trigger (integer divided clock - see FREQ parameter)"]
            VALUE1,
            #[doc = "external Trigger (preselected trigger by TRIGSEL parameter)"]
            VALUE2,
            #[doc = "software Trigger (see SWTRIG parameter)"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TRIGMODR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRIGMODR::VALUE1 => 0,
                    TRIGMODR::VALUE2 => 0x01,
                    TRIGMODR::VALUE3 => 0x02,
                    TRIGMODR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRIGMODR {
                match value {
                    0 => TRIGMODR::VALUE1,
                    1 => TRIGMODR::VALUE2,
                    2 => TRIGMODR::VALUE3,
                    i => TRIGMODR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRIGMODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRIGMODR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRIGMODR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct ANACFGR {
            bits: u8,
        }
        impl ANACFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `ANAEN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ANAENR {
            #[doc = "DAC1 is set to standby (analog output only)"]
            VALUE1,
            #[doc = "enable DAC1 (analog output only)"]
            VALUE2,
        }
        impl ANAENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ANAENR::VALUE1 => false,
                    ANAENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ANAENR {
                match value {
                    false => ANAENR::VALUE1,
                    true => ANAENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ANAENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ANAENR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct REFCFGHR {
            bits: u8,
        }
        impl REFCFGHR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Values that can be written to the field `SCALE`"]
        pub enum SCALEW {
            #[doc = "no shift = multiplication/division by 1"]
            VALUE1,
            #[doc = "shift by 1 = multiplication/division by 2"]
            VALUE2,
            #[doc = "shift by 2 = multiplication/division by 4"]
            VALUE3,
            #[doc = "shift left by 3 = multiplication/division by 8"]
            VALUE4,
            #[doc = "shift left by 4 = multiplication/division by 16"]
            VALUE5,
            #[doc = "shift left by 5 = multiplication/division by 32"]
            VALUE6,
            #[doc = "shift left by 6 = multiplication/division by 64"]
            VALUE7,
            #[doc = "shift left by 7 = multiplication/division by 128"]
            VALUE8,
        }
        impl SCALEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SCALEW::VALUE1 => 0,
                    SCALEW::VALUE2 => 1,
                    SCALEW::VALUE3 => 2,
                    SCALEW::VALUE4 => 3,
                    SCALEW::VALUE5 => 4,
                    SCALEW::VALUE6 => 5,
                    SCALEW::VALUE7 => 6,
                    SCALEW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCALEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCALEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCALEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "no shift = multiplication/division by 1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCALEW::VALUE1)
            }
            #[doc = "shift by 1 = multiplication/division by 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCALEW::VALUE2)
            }
            #[doc = "shift by 2 = multiplication/division by 4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SCALEW::VALUE3)
            }
            #[doc = "shift left by 3 = multiplication/division by 8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SCALEW::VALUE4)
            }
            #[doc = "shift left by 4 = multiplication/division by 16"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SCALEW::VALUE5)
            }
            #[doc = "shift left by 5 = multiplication/division by 32"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SCALEW::VALUE6)
            }
            #[doc = "shift left by 6 = multiplication/division by 64"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(SCALEW::VALUE7)
            }
            #[doc = "shift left by 7 = multiplication/division by 128"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(SCALEW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MULDIV`"]
        pub enum MULDIVW {
            #[doc = "downscale = division (shift SCALE positions to the right)"]
            VALUE1,
            #[doc = "upscale = multiplication (shift SCALE positions to the left)"]
            VALUE2,
        }
        impl MULDIVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MULDIVW::VALUE1 => false,
                    MULDIVW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MULDIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MULDIVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MULDIVW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "downscale = division (shift SCALE positions to the right)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MULDIVW::VALUE1)
            }
            #[doc = "upscale = multiplication (shift SCALE positions to the left)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MULDIVW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OFFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OFFSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIGSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIGSELW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SWTRIGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SWTRIGW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRIGMOD`"]
        pub enum TRIGMODW {
            #[doc = "internal Trigger (integer divided clock - see FREQ parameter)"]
            VALUE1,
            #[doc = "external Trigger (preselected trigger by TRIGSEL parameter)"]
            VALUE2,
            #[doc = "software Trigger (see SWTRIG parameter)"]
            VALUE3,
        }
        impl TRIGMODW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRIGMODW::VALUE1 => 0,
                    TRIGMODW::VALUE2 => 1,
                    TRIGMODW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIGMODW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIGMODW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRIGMODW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "internal Trigger (integer divided clock - see FREQ parameter)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRIGMODW::VALUE1)
            }
            #[doc = "external Trigger (preselected trigger by TRIGSEL parameter)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRIGMODW::VALUE2)
            }
            #[doc = "software Trigger (see SWTRIG parameter)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRIGMODW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ANACFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ANACFGW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ANAEN`"]
        pub enum ANAENW {
            #[doc = "DAC1 is set to standby (analog output only)"]
            VALUE1,
            #[doc = "enable DAC1 (analog output only)"]
            VALUE2,
        }
        impl ANAENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ANAENW::VALUE1 => false,
                    ANAENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ANAENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ANAENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ANAENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "DAC1 is set to standby (analog output only)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ANAENW::VALUE1)
            }
            #[doc = "enable DAC1 (analog output only)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ANAENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _REFCFGHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _REFCFGHW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Scale value for up- or downscale of the DAC1 input data in steps by the power of 2 (=shift operation)"]
            #[inline]
            pub fn scale(&self) -> SCALER {
                SCALER::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 3 - Switch between up- and downscale of the DAC1 input data values"]
            #[inline]
            pub fn muldiv(&self) -> MULDIVR {
                MULDIVR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:11 - 8-bit offset value addition"]
            #[inline]
            pub fn offs(&self) -> OFFSR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OFFSR { bits }
            }
            #[doc = "Bits 12:14 - Selects one of the eight external trigger sources for DAC1"]
            #[inline]
            pub fn trigsel(&self) -> TRIGSELR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TRIGSELR { bits }
            }
            #[doc = "Bit 16 - Software Trigger"]
            #[inline]
            pub fn swtrig(&self) -> SWTRIGR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                SWTRIGR { bits }
            }
            #[doc = "Bits 17:18 - Select the trigger source for channel 1"]
            #[inline]
            pub fn trigmod(&self) -> TRIGMODR {
                TRIGMODR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - DAC1 analog configuration/calibration parameters"]
            #[inline]
            pub fn anacfg(&self) -> ANACFGR {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ANACFGR { bits }
            }
            #[doc = "Bit 24 - Enable analog DAC for channel 1"]
            #[inline]
            pub fn anaen(&self) -> ANAENR {
                ANAENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 28:31 - Higher 4 band-gap configuration/calibration parameters"]
            #[inline]
            pub fn refcfgh(&self) -> REFCFGHR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                REFCFGHR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Scale value for up- or downscale of the DAC1 input data in steps by the power of 2 (=shift operation)"]
            #[inline]
            pub fn scale(&mut self) -> _SCALEW {
                _SCALEW { w: self }
            }
            #[doc = "Bit 3 - Switch between up- and downscale of the DAC1 input data values"]
            #[inline]
            pub fn muldiv(&mut self) -> _MULDIVW {
                _MULDIVW { w: self }
            }
            #[doc = "Bits 4:11 - 8-bit offset value addition"]
            #[inline]
            pub fn offs(&mut self) -> _OFFSW {
                _OFFSW { w: self }
            }
            #[doc = "Bits 12:14 - Selects one of the eight external trigger sources for DAC1"]
            #[inline]
            pub fn trigsel(&mut self) -> _TRIGSELW {
                _TRIGSELW { w: self }
            }
            #[doc = "Bit 16 - Software Trigger"]
            #[inline]
            pub fn swtrig(&mut self) -> _SWTRIGW {
                _SWTRIGW { w: self }
            }
            #[doc = "Bits 17:18 - Select the trigger source for channel 1"]
            #[inline]
            pub fn trigmod(&mut self) -> _TRIGMODW {
                _TRIGMODW { w: self }
            }
            #[doc = "Bits 19:23 - DAC1 analog configuration/calibration parameters"]
            #[inline]
            pub fn anacfg(&mut self) -> _ANACFGW {
                _ANACFGW { w: self }
            }
            #[doc = "Bit 24 - Enable analog DAC for channel 1"]
            #[inline]
            pub fn anaen(&mut self) -> _ANAENW {
                _ANAENW { w: self }
            }
            #[doc = "Bits 28:31 - Higher 4 band-gap configuration/calibration parameters"]
            #[inline]
            pub fn refcfgh(&mut self) -> _REFCFGHW {
                _REFCFGHW { w: self }
            }
        }
    }
    #[doc = "DAC0 Data Register"]
    pub struct DAC0DATA {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC0 Data Register"]
    pub mod dac0data {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC0DATA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATA0R {
            bits: u16,
        }
        impl DATA0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATA0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATA0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:11 - DAC0 Data Bits"]
            #[inline]
            pub fn data0(&self) -> DATA0R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DATA0R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:11 - DAC0 Data Bits"]
            #[inline]
            pub fn data0(&mut self) -> _DATA0W {
                _DATA0W { w: self }
            }
        }
    }
    #[doc = "DAC1 Data Register"]
    pub struct DAC1DATA {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC1 Data Register"]
    pub mod dac1data {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC1DATA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATA1R {
            bits: u16,
        }
        impl DATA1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATA1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATA1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:11 - DAC1 Data Bits"]
            #[inline]
            pub fn data1(&self) -> DATA1R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DATA1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:11 - DAC1 Data Bits"]
            #[inline]
            pub fn data1(&mut self) -> _DATA1W {
                _DATA1W { w: self }
            }
        }
    }
    #[doc = "DAC01 Data Register"]
    pub struct DAC01DATA {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC01 Data Register"]
    pub mod dac01data {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC01DATA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATA0R {
            bits: u16,
        }
        impl DATA0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DATA1R {
            bits: u16,
        }
        impl DATA1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATA0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATA0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DATA1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DATA1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x0fff;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:11 - DAC0 Data Bits"]
            #[inline]
            pub fn data0(&self) -> DATA0R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DATA0R { bits }
            }
            #[doc = "Bits 16:27 - DAC1 Data Bits"]
            #[inline]
            pub fn data1(&self) -> DATA1R {
                let bits = {
                    const MASK: u16 = 0x0fff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DATA1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:11 - DAC0 Data Bits"]
            #[inline]
            pub fn data0(&mut self) -> _DATA0W {
                _DATA0W { w: self }
            }
            #[doc = "Bits 16:27 - DAC1 Data Bits"]
            #[inline]
            pub fn data1(&mut self) -> _DATA1W {
                _DATA1W { w: self }
            }
        }
    }
    #[doc = "DAC0 Lower Pattern Register"]
    pub struct DAC0PATL {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC0 Lower Pattern Register"]
    pub mod dac0patl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC0PATL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT0R {
            bits: u8,
        }
        impl PAT0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT1R {
            bits: u8,
        }
        impl PAT1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT2R {
            bits: u8,
        }
        impl PAT2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT3R {
            bits: u8,
        }
        impl PAT3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT4R {
            bits: u8,
        }
        impl PAT4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT5R {
            bits: u8,
        }
        impl PAT5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Pattern Number 0 for PATGEN of DAC0"]
            #[inline]
            pub fn pat0(&self) -> PAT0R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT0R { bits }
            }
            #[doc = "Bits 5:9 - Pattern Number 1 for PATGEN of DAC0"]
            #[inline]
            pub fn pat1(&self) -> PAT1R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT1R { bits }
            }
            #[doc = "Bits 10:14 - Pattern Number 2 for PATGEN of DAC0"]
            #[inline]
            pub fn pat2(&self) -> PAT2R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT2R { bits }
            }
            #[doc = "Bits 15:19 - Pattern Number 3 for PATGEN of DAC0"]
            #[inline]
            pub fn pat3(&self) -> PAT3R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT3R { bits }
            }
            #[doc = "Bits 20:24 - Pattern Number 4 for PATGEN of DAC0"]
            #[inline]
            pub fn pat4(&self) -> PAT4R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT4R { bits }
            }
            #[doc = "Bits 25:29 - Pattern Number 5 for PATGEN of DAC0"]
            #[inline]
            pub fn pat5(&self) -> PAT5R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT5R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x3568_b0c0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Pattern Number 0 for PATGEN of DAC0"]
            #[inline]
            pub fn pat0(&mut self) -> _PAT0W {
                _PAT0W { w: self }
            }
            #[doc = "Bits 5:9 - Pattern Number 1 for PATGEN of DAC0"]
            #[inline]
            pub fn pat1(&mut self) -> _PAT1W {
                _PAT1W { w: self }
            }
            #[doc = "Bits 10:14 - Pattern Number 2 for PATGEN of DAC0"]
            #[inline]
            pub fn pat2(&mut self) -> _PAT2W {
                _PAT2W { w: self }
            }
            #[doc = "Bits 15:19 - Pattern Number 3 for PATGEN of DAC0"]
            #[inline]
            pub fn pat3(&mut self) -> _PAT3W {
                _PAT3W { w: self }
            }
            #[doc = "Bits 20:24 - Pattern Number 4 for PATGEN of DAC0"]
            #[inline]
            pub fn pat4(&mut self) -> _PAT4W {
                _PAT4W { w: self }
            }
            #[doc = "Bits 25:29 - Pattern Number 5 for PATGEN of DAC0"]
            #[inline]
            pub fn pat5(&mut self) -> _PAT5W {
                _PAT5W { w: self }
            }
        }
    }
    #[doc = "DAC0 Higher Pattern Register"]
    pub struct DAC0PATH {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC0 Higher Pattern Register"]
    pub mod dac0path {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC0PATH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT6R {
            bits: u8,
        }
        impl PAT6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT7R {
            bits: u8,
        }
        impl PAT7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT8R {
            bits: u8,
        }
        impl PAT8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT8W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Pattern Number 6 for PATGEN of DAC0"]
            #[inline]
            pub fn pat6(&self) -> PAT6R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT6R { bits }
            }
            #[doc = "Bits 5:9 - Pattern Number 7 for PATGEN of DAC0"]
            #[inline]
            pub fn pat7(&self) -> PAT7R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT7R { bits }
            }
            #[doc = "Bits 10:14 - Pattern Number 8 for PATGEN of DAC0"]
            #[inline]
            pub fn pat8(&self) -> PAT8R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT8R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x7fdd }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Pattern Number 6 for PATGEN of DAC0"]
            #[inline]
            pub fn pat6(&mut self) -> _PAT6W {
                _PAT6W { w: self }
            }
            #[doc = "Bits 5:9 - Pattern Number 7 for PATGEN of DAC0"]
            #[inline]
            pub fn pat7(&mut self) -> _PAT7W {
                _PAT7W { w: self }
            }
            #[doc = "Bits 10:14 - Pattern Number 8 for PATGEN of DAC0"]
            #[inline]
            pub fn pat8(&mut self) -> _PAT8W {
                _PAT8W { w: self }
            }
        }
    }
    #[doc = "DAC1 Lower Pattern Register"]
    pub struct DAC1PATL {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC1 Lower Pattern Register"]
    pub mod dac1patl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC1PATL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT0R {
            bits: u8,
        }
        impl PAT0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT1R {
            bits: u8,
        }
        impl PAT1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT2R {
            bits: u8,
        }
        impl PAT2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT3R {
            bits: u8,
        }
        impl PAT3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT4R {
            bits: u8,
        }
        impl PAT4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT5R {
            bits: u8,
        }
        impl PAT5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Pattern Number 0 for PATGEN of DAC1"]
            #[inline]
            pub fn pat0(&self) -> PAT0R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT0R { bits }
            }
            #[doc = "Bits 5:9 - Pattern Number 1 for PATGEN of DAC1"]
            #[inline]
            pub fn pat1(&self) -> PAT1R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT1R { bits }
            }
            #[doc = "Bits 10:14 - Pattern Number 2 for PATGEN of DAC1"]
            #[inline]
            pub fn pat2(&self) -> PAT2R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT2R { bits }
            }
            #[doc = "Bits 15:19 - Pattern Number 3 for PATGEN of DAC1"]
            #[inline]
            pub fn pat3(&self) -> PAT3R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT3R { bits }
            }
            #[doc = "Bits 20:24 - Pattern Number 4 for PATGEN of DAC1"]
            #[inline]
            pub fn pat4(&self) -> PAT4R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT4R { bits }
            }
            #[doc = "Bits 25:29 - Pattern Number 5 for PATGEN of DAC1"]
            #[inline]
            pub fn pat5(&self) -> PAT5R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT5R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x3568_b0c0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Pattern Number 0 for PATGEN of DAC1"]
            #[inline]
            pub fn pat0(&mut self) -> _PAT0W {
                _PAT0W { w: self }
            }
            #[doc = "Bits 5:9 - Pattern Number 1 for PATGEN of DAC1"]
            #[inline]
            pub fn pat1(&mut self) -> _PAT1W {
                _PAT1W { w: self }
            }
            #[doc = "Bits 10:14 - Pattern Number 2 for PATGEN of DAC1"]
            #[inline]
            pub fn pat2(&mut self) -> _PAT2W {
                _PAT2W { w: self }
            }
            #[doc = "Bits 15:19 - Pattern Number 3 for PATGEN of DAC1"]
            #[inline]
            pub fn pat3(&mut self) -> _PAT3W {
                _PAT3W { w: self }
            }
            #[doc = "Bits 20:24 - Pattern Number 4 for PATGEN of DAC1"]
            #[inline]
            pub fn pat4(&mut self) -> _PAT4W {
                _PAT4W { w: self }
            }
            #[doc = "Bits 25:29 - Pattern Number 5 for PATGEN of DAC1"]
            #[inline]
            pub fn pat5(&mut self) -> _PAT5W {
                _PAT5W { w: self }
            }
        }
    }
    #[doc = "DAC1 Higher Pattern Register"]
    pub struct DAC1PATH {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC1 Higher Pattern Register"]
    pub mod dac1path {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DAC1PATH {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT6R {
            bits: u8,
        }
        impl PAT6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT7R {
            bits: u8,
        }
        impl PAT7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PAT8R {
            bits: u8,
        }
        impl PAT8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PAT8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PAT8W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:4 - Pattern Number 6 for PATGEN of DAC1"]
            #[inline]
            pub fn pat6(&self) -> PAT6R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT6R { bits }
            }
            #[doc = "Bits 5:9 - Pattern Number 7 for PATGEN of DAC1"]
            #[inline]
            pub fn pat7(&self) -> PAT7R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT7R { bits }
            }
            #[doc = "Bits 10:14 - Pattern Number 8 for PATGEN of DAC1"]
            #[inline]
            pub fn pat8(&self) -> PAT8R {
                let bits = {
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PAT8R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x7fdd }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:4 - Pattern Number 6 for PATGEN of DAC1"]
            #[inline]
            pub fn pat6(&mut self) -> _PAT6W {
                _PAT6W { w: self }
            }
            #[doc = "Bits 5:9 - Pattern Number 7 for PATGEN of DAC1"]
            #[inline]
            pub fn pat7(&mut self) -> _PAT7W {
                _PAT7W { w: self }
            }
            #[doc = "Bits 10:14 - Pattern Number 8 for PATGEN of DAC1"]
            #[inline]
            pub fn pat8(&mut self) -> _PAT8W {
                _PAT8W { w: self }
            }
        }
    }
}
#[doc = "Digital to Analog Converter"]
pub struct DAC {
    register_block: dac::RegisterBlock,
}
impl Deref for DAC {
    type Target = dac::RegisterBlock;
    fn deref(&self) -> &dac::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub const CCU40: Peripheral<CCU40> = unsafe { Peripheral::new(0x4000_c000) };
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub mod ccu40 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Global Control Register"]
        pub gctrl: GCTRL,
        #[doc = "0x04 - Global Status Register"]
        pub gstat: GSTAT,
        #[doc = "0x08 - Global Idle Set"]
        pub gidls: GIDLS,
        #[doc = "0x0c - Global Idle Clear"]
        pub gidlc: GIDLC,
        #[doc = "0x10 - Global Channel Set"]
        pub gcss: GCSS,
        #[doc = "0x14 - Global Channel Clear"]
        pub gcsc: GCSC,
        #[doc = "0x18 - Global Channel Status"]
        pub gcst: GCST,
        _reserved0: [u8; 52usize],
        #[doc = "0x50 - Extended Capture Mode Read"]
        pub ecrd: ECRD,
        _reserved1: [u8; 44usize],
        #[doc = "0x80 - Module Identification"]
        pub midr: MIDR,
    }
    #[doc = "Global Control Register"]
    pub struct GCTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Control Register"]
    pub mod gctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GCTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PRBC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRBCR {
            #[doc = "SW only"]
            VALUE1,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC40 is cleared."]
            VALUE2,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC41 is cleared."]
            VALUE3,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC42 is cleared."]
            VALUE4,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC43 is cleared."]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PRBCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PRBCR::VALUE1 => 0,
                    PRBCR::VALUE2 => 0x01,
                    PRBCR::VALUE3 => 0x02,
                    PRBCR::VALUE4 => 0x03,
                    PRBCR::VALUE5 => 0x04,
                    PRBCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PRBCR {
                match value {
                    0 => PRBCR::VALUE1,
                    1 => PRBCR::VALUE2,
                    2 => PRBCR::VALUE3,
                    3 => PRBCR::VALUE4,
                    4 => PRBCR::VALUE5,
                    i => PRBCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRBCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRBCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PRBCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PRBCR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PRBCR::VALUE5
            }
        }
        #[doc = "Possible values of the field `PCIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCISR {
            #[doc = "Module clock"]
            VALUE1,
            #[doc = "CCU4x.ECLKA"]
            VALUE2,
            #[doc = "CCU4x.ECLKB"]
            VALUE3,
            #[doc = "CCU4x.ECLKC"]
            VALUE4,
        }
        impl PCISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PCISR::VALUE1 => 0,
                    PCISR::VALUE2 => 0x01,
                    PCISR::VALUE3 => 0x02,
                    PCISR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PCISR {
                match value {
                    0 => PCISR::VALUE1,
                    1 => PCISR::VALUE2,
                    2 => PCISR::VALUE3,
                    3 => PCISR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PCISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PCISR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SUSCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSCFGR {
            #[doc = "Suspend request ignored. The module never enters in suspend"]
            VALUE1,
            #[doc = "Stops all the running slices immediately. Safe stop is not applied."]
            VALUE2,
            #[doc = "Stops the block immediately and clamps all the outputs to PASSIVE state. Safe stop is applied."]
            VALUE3,
            #[doc = "Waits for the roll over of each slice to stop and clamp the slices outputs. Safe stop is applied."]
            VALUE4,
        }
        impl SUSCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SUSCFGR::VALUE1 => 0,
                    SUSCFGR::VALUE2 => 0x01,
                    SUSCFGR::VALUE3 => 0x02,
                    SUSCFGR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SUSCFGR {
                match value {
                    0 => SUSCFGR::VALUE1,
                    1 => SUSCFGR::VALUE2,
                    2 => SUSCFGR::VALUE3,
                    3 => SUSCFGR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSCFGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SUSCFGR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SUSCFGR::VALUE4
            }
        }
        #[doc = "Possible values of the field `MSE0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE0R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE0R::VALUE1 => false,
                    MSE0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE0R {
                match value {
                    false => MSE0R::VALUE1,
                    true => MSE0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSE1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE1R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE1R::VALUE1 => false,
                    MSE1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE1R {
                match value {
                    false => MSE1R::VALUE1,
                    true => MSE1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSE2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE2R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE2R::VALUE1 => false,
                    MSE2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE2R {
                match value {
                    false => MSE2R::VALUE1,
                    true => MSE2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSE3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE3R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE3R::VALUE1 => false,
                    MSE3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE3R {
                match value {
                    false => MSE3R::VALUE1,
                    true => MSE3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSDE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSDER {
            #[doc = "Only the shadow transfer for period and compare values is requested"]
            VALUE1,
            #[doc = "Shadow transfer for the compare, period and prescaler compare values is requested"]
            VALUE2,
            #[doc = "Shadow transfer for the compare, period, prescaler and dither compare values is requested"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MSDER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MSDER::VALUE1 => 0,
                    MSDER::VALUE2 => 0x01,
                    MSDER::VALUE4 => 0x03,
                    MSDER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MSDER {
                match value {
                    0 => MSDER::VALUE1,
                    1 => MSDER::VALUE2,
                    3 => MSDER::VALUE4,
                    i => MSDER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSDER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSDER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MSDER::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `PRBC`"]
        pub enum PRBCW {
            #[doc = "SW only"]
            VALUE1,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC40 is cleared."]
            VALUE2,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC41 is cleared."]
            VALUE3,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC42 is cleared."]
            VALUE4,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC43 is cleared."]
            VALUE5,
        }
        impl PRBCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PRBCW::VALUE1 => 0,
                    PRBCW::VALUE2 => 1,
                    PRBCW::VALUE3 => 2,
                    PRBCW::VALUE4 => 3,
                    PRBCW::VALUE5 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRBCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRBCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRBCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "SW only"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRBCW::VALUE1)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC40 is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRBCW::VALUE2)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC41 is cleared."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PRBCW::VALUE3)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC42 is cleared."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PRBCW::VALUE4)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC43 is cleared."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PRBCW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCIS`"]
        pub enum PCISW {
            #[doc = "Module clock"]
            VALUE1,
            #[doc = "CCU4x.ECLKA"]
            VALUE2,
            #[doc = "CCU4x.ECLKB"]
            VALUE3,
            #[doc = "CCU4x.ECLKC"]
            VALUE4,
        }
        impl PCISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PCISW::VALUE1 => 0,
                    PCISW::VALUE2 => 1,
                    PCISW::VALUE3 => 2,
                    PCISW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Module clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCISW::VALUE1)
            }
            #[doc = "CCU4x.ECLKA"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCISW::VALUE2)
            }
            #[doc = "CCU4x.ECLKB"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PCISW::VALUE3)
            }
            #[doc = "CCU4x.ECLKC"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PCISW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUSCFG`"]
        pub enum SUSCFGW {
            #[doc = "Suspend request ignored. The module never enters in suspend"]
            VALUE1,
            #[doc = "Stops all the running slices immediately. Safe stop is not applied."]
            VALUE2,
            #[doc = "Stops the block immediately and clamps all the outputs to PASSIVE state. Safe stop is applied."]
            VALUE3,
            #[doc = "Waits for the roll over of each slice to stop and clamp the slices outputs. Safe stop is applied."]
            VALUE4,
        }
        impl SUSCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SUSCFGW::VALUE1 => 0,
                    SUSCFGW::VALUE2 => 1,
                    SUSCFGW::VALUE3 => 2,
                    SUSCFGW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUSCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUSCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUSCFGW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Suspend request ignored. The module never enters in suspend"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE1)
            }
            #[doc = "Stops all the running slices immediately. Safe stop is not applied."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE2)
            }
            #[doc = "Stops the block immediately and clamps all the outputs to PASSIVE state. Safe stop is applied."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE3)
            }
            #[doc = "Waits for the roll over of each slice to stop and clamp the slices outputs. Safe stop is applied."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE0`"]
        pub enum MSE0W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE0W::VALUE1 => false,
                    MSE0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE0W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE1`"]
        pub enum MSE1W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE1W::VALUE1 => false,
                    MSE1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE1W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE2`"]
        pub enum MSE2W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE2W::VALUE1 => false,
                    MSE2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE2W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE3`"]
        pub enum MSE3W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            VALUE2,
        }
        impl MSE3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE3W::VALUE1 => false,
                    MSE3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE3W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU4x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSDE`"]
        pub enum MSDEW {
            #[doc = "Only the shadow transfer for period and compare values is requested"]
            VALUE1,
            #[doc = "Shadow transfer for the compare, period and prescaler compare values is requested"]
            VALUE2,
            #[doc = "Shadow transfer for the compare, period, prescaler and dither compare values is requested"]
            VALUE4,
        }
        impl MSDEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MSDEW::VALUE1 => 0,
                    MSDEW::VALUE2 => 1,
                    MSDEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSDEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSDEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSDEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Only the shadow transfer for period and compare values is requested"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSDEW::VALUE1)
            }
            #[doc = "Shadow transfer for the compare, period and prescaler compare values is requested"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSDEW::VALUE2)
            }
            #[doc = "Shadow transfer for the compare, period, prescaler and dither compare values is requested"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MSDEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Prescaler Clear Configuration"]
            #[inline]
            pub fn prbc(&self) -> PRBCR {
                PRBCR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Prescaler Input Clock Selection"]
            #[inline]
            pub fn pcis(&self) -> PCISR {
                PCISR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Suspend Mode Configuration"]
            #[inline]
            pub fn suscfg(&self) -> SUSCFGR {
                SUSCFGR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Slice 0 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse0(&self) -> MSE0R {
                MSE0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Slice 1 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse1(&self) -> MSE1R {
                MSE1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Slice 2 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse2(&self) -> MSE2R {
                MSE2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Slice 3 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse3(&self) -> MSE3R {
                MSE3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 14:15 - Multi Channel shadow transfer request configuration"]
            #[inline]
            pub fn msde(&self) -> MSDER {
                MSDER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Prescaler Clear Configuration"]
            #[inline]
            pub fn prbc(&mut self) -> _PRBCW {
                _PRBCW { w: self }
            }
            #[doc = "Bits 4:5 - Prescaler Input Clock Selection"]
            #[inline]
            pub fn pcis(&mut self) -> _PCISW {
                _PCISW { w: self }
            }
            #[doc = "Bits 8:9 - Suspend Mode Configuration"]
            #[inline]
            pub fn suscfg(&mut self) -> _SUSCFGW {
                _SUSCFGW { w: self }
            }
            #[doc = "Bit 10 - Slice 0 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse0(&mut self) -> _MSE0W {
                _MSE0W { w: self }
            }
            #[doc = "Bit 11 - Slice 1 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse1(&mut self) -> _MSE1W {
                _MSE1W { w: self }
            }
            #[doc = "Bit 12 - Slice 2 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse2(&mut self) -> _MSE2W {
                _MSE2W { w: self }
            }
            #[doc = "Bit 13 - Slice 3 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse3(&mut self) -> _MSE3W {
                _MSE3W { w: self }
            }
            #[doc = "Bits 14:15 - Multi Channel shadow transfer request configuration"]
            #[inline]
            pub fn msde(&mut self) -> _MSDEW {
                _MSDEW { w: self }
            }
        }
    }
    #[doc = "Global Status Register"]
    pub struct GSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Status Register"]
    pub mod gstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::GSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S0IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0IR::VALUE1 => false,
                    S0IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0IR {
                match value {
                    false => S0IR::VALUE1,
                    true => S0IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S1IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1IR::VALUE1 => false,
                    S1IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1IR {
                match value {
                    false => S1IR::VALUE1,
                    true => S1IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S2IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2IR::VALUE1 => false,
                    S2IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2IR {
                match value {
                    false => S2IR::VALUE1,
                    true => S2IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S3IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3IR::VALUE1 => false,
                    S3IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3IR {
                match value {
                    false => S3IR::VALUE1,
                    true => S3IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRBR {
            #[doc = "Prescaler is stopped"]
            VALUE1,
            #[doc = "Prescaler is running"]
            VALUE2,
        }
        impl PRBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRBR::VALUE1 => false,
                    PRBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRBR {
                match value {
                    false => PRBR::VALUE1,
                    true => PRBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRBR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - CC40 IDLE status"]
            #[inline]
            pub fn s0i(&self) -> S0IR {
                S0IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - CC41 IDLE status"]
            #[inline]
            pub fn s1i(&self) -> S1IR {
                S1IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - CC42 IDLE status"]
            #[inline]
            pub fn s2i(&self) -> S2IR {
                S2IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - CC43 IDLE status"]
            #[inline]
            pub fn s3i(&self) -> S3IR {
                S3IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Prescaler Run Bit"]
            #[inline]
            pub fn prb(&self) -> PRBR {
                PRBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Global Idle Set"]
    pub struct GIDLS {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Idle Set"]
    pub mod gidls {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GIDLS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS0IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS0IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS1IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS1IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS2IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS2IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS3IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS3IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CPRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CPRBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSICW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSICW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CC40 IDLE mode set"]
            #[inline]
            pub fn ss0i(&mut self) -> _SS0IW {
                _SS0IW { w: self }
            }
            #[doc = "Bit 1 - CC41 IDLE mode set"]
            #[inline]
            pub fn ss1i(&mut self) -> _SS1IW {
                _SS1IW { w: self }
            }
            #[doc = "Bit 2 - CC42 IDLE mode set"]
            #[inline]
            pub fn ss2i(&mut self) -> _SS2IW {
                _SS2IW { w: self }
            }
            #[doc = "Bit 3 - CC43 IDLE mode set"]
            #[inline]
            pub fn ss3i(&mut self) -> _SS3IW {
                _SS3IW { w: self }
            }
            #[doc = "Bit 8 - Prescaler Run Bit Clear"]
            #[inline]
            pub fn cprb(&mut self) -> _CPRBW {
                _CPRBW { w: self }
            }
            #[doc = "Bit 9 - Prescaler clear"]
            #[inline]
            pub fn psic(&mut self) -> _PSICW {
                _PSICW { w: self }
            }
        }
    }
    #[doc = "Global Idle Clear"]
    pub struct GIDLC {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Idle Clear"]
    pub mod gidlc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GIDLC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS0IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS0IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS1IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS1IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS2IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS2IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS3IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS3IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPRBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CC40 IDLE mode clear"]
            #[inline]
            pub fn cs0i(&mut self) -> _CS0IW {
                _CS0IW { w: self }
            }
            #[doc = "Bit 1 - CC41 IDLE mode clear"]
            #[inline]
            pub fn cs1i(&mut self) -> _CS1IW {
                _CS1IW { w: self }
            }
            #[doc = "Bit 2 - CC42 IDLE mode clear"]
            #[inline]
            pub fn cs2i(&mut self) -> _CS2IW {
                _CS2IW { w: self }
            }
            #[doc = "Bit 3 - CC43 IDLE mode clear"]
            #[inline]
            pub fn cs3i(&mut self) -> _CS3IW {
                _CS3IW { w: self }
            }
            #[doc = "Bit 8 - Prescaler Run Bit Set"]
            #[inline]
            pub fn sprb(&mut self) -> _SPRBW {
                _SPRBW { w: self }
            }
        }
    }
    #[doc = "Global Channel Set"]
    pub struct GCSS {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Channel Set"]
    pub mod gcss {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GCSS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0STSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0STSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1STSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1STSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2STSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2STSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3STSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3STSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Slice 0 shadow transfer set enable"]
            #[inline]
            pub fn s0se(&mut self) -> _S0SEW {
                _S0SEW { w: self }
            }
            #[doc = "Bit 1 - Slice 0 Dither shadow transfer set enable"]
            #[inline]
            pub fn s0dse(&mut self) -> _S0DSEW {
                _S0DSEW { w: self }
            }
            #[doc = "Bit 2 - Slice 0 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s0pse(&mut self) -> _S0PSEW {
                _S0PSEW { w: self }
            }
            #[doc = "Bit 4 - Slice 1 shadow transfer set enable"]
            #[inline]
            pub fn s1se(&mut self) -> _S1SEW {
                _S1SEW { w: self }
            }
            #[doc = "Bit 5 - Slice 1 Dither shadow transfer set enable"]
            #[inline]
            pub fn s1dse(&mut self) -> _S1DSEW {
                _S1DSEW { w: self }
            }
            #[doc = "Bit 6 - Slice 1 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s1pse(&mut self) -> _S1PSEW {
                _S1PSEW { w: self }
            }
            #[doc = "Bit 8 - Slice 2 shadow transfer set enable"]
            #[inline]
            pub fn s2se(&mut self) -> _S2SEW {
                _S2SEW { w: self }
            }
            #[doc = "Bit 9 - Slice 2 Dither shadow transfer set enable"]
            #[inline]
            pub fn s2dse(&mut self) -> _S2DSEW {
                _S2DSEW { w: self }
            }
            #[doc = "Bit 10 - Slice 2 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s2pse(&mut self) -> _S2PSEW {
                _S2PSEW { w: self }
            }
            #[doc = "Bit 12 - Slice 3 shadow transfer set enable"]
            #[inline]
            pub fn s3se(&mut self) -> _S3SEW {
                _S3SEW { w: self }
            }
            #[doc = "Bit 13 - Slice 3 Dither shadow transfer set enable"]
            #[inline]
            pub fn s3dse(&mut self) -> _S3DSEW {
                _S3DSEW { w: self }
            }
            #[doc = "Bit 14 - Slice 3 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s3pse(&mut self) -> _S3PSEW {
                _S3PSEW { w: self }
            }
            #[doc = "Bit 16 - Slice 0 status bit set"]
            #[inline]
            pub fn s0sts(&mut self) -> _S0STSW {
                _S0STSW { w: self }
            }
            #[doc = "Bit 17 - Slice 1 status bit set"]
            #[inline]
            pub fn s1sts(&mut self) -> _S1STSW {
                _S1STSW { w: self }
            }
            #[doc = "Bit 18 - Slice 2 status bit set"]
            #[inline]
            pub fn s2sts(&mut self) -> _S2STSW {
                _S2STSW { w: self }
            }
            #[doc = "Bit 19 - Slice 3 status bit set"]
            #[inline]
            pub fn s3sts(&mut self) -> _S3STSW {
                _S3STSW { w: self }
            }
        }
    }
    #[doc = "Global Channel Clear"]
    pub struct GCSC {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Channel Clear"]
    pub mod gcsc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GCSC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0STCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0STCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1STCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1STCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2STCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2STCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3STCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3STCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Slice 0 shadow transfer clear"]
            #[inline]
            pub fn s0sc(&mut self) -> _S0SCW {
                _S0SCW { w: self }
            }
            #[doc = "Bit 1 - Slice 0 Dither shadow transfer clear"]
            #[inline]
            pub fn s0dsc(&mut self) -> _S0DSCW {
                _S0DSCW { w: self }
            }
            #[doc = "Bit 2 - Slice 0 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s0psc(&mut self) -> _S0PSCW {
                _S0PSCW { w: self }
            }
            #[doc = "Bit 4 - Slice 1 shadow transfer clear"]
            #[inline]
            pub fn s1sc(&mut self) -> _S1SCW {
                _S1SCW { w: self }
            }
            #[doc = "Bit 5 - Slice 1 Dither shadow transfer clear"]
            #[inline]
            pub fn s1dsc(&mut self) -> _S1DSCW {
                _S1DSCW { w: self }
            }
            #[doc = "Bit 6 - Slice 1 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s1psc(&mut self) -> _S1PSCW {
                _S1PSCW { w: self }
            }
            #[doc = "Bit 8 - Slice 2 shadow transfer clear"]
            #[inline]
            pub fn s2sc(&mut self) -> _S2SCW {
                _S2SCW { w: self }
            }
            #[doc = "Bit 9 - Slice 2 Dither shadow transfer clear"]
            #[inline]
            pub fn s2dsc(&mut self) -> _S2DSCW {
                _S2DSCW { w: self }
            }
            #[doc = "Bit 10 - Slice 2 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s2psc(&mut self) -> _S2PSCW {
                _S2PSCW { w: self }
            }
            #[doc = "Bit 12 - Slice 3 shadow transfer clear"]
            #[inline]
            pub fn s3sc(&mut self) -> _S3SCW {
                _S3SCW { w: self }
            }
            #[doc = "Bit 13 - Slice 3 Dither shadow transfer clear"]
            #[inline]
            pub fn s3dsc(&mut self) -> _S3DSCW {
                _S3DSCW { w: self }
            }
            #[doc = "Bit 14 - Slice 3 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s3psc(&mut self) -> _S3PSCW {
                _S3PSCW { w: self }
            }
            #[doc = "Bit 16 - Slice 0 status bit clear"]
            #[inline]
            pub fn s0stc(&mut self) -> _S0STCW {
                _S0STCW { w: self }
            }
            #[doc = "Bit 17 - Slice 1 status bit clear"]
            #[inline]
            pub fn s1stc(&mut self) -> _S1STCW {
                _S1STCW { w: self }
            }
            #[doc = "Bit 18 - Slice 2 status bit clear"]
            #[inline]
            pub fn s2stc(&mut self) -> _S2STCW {
                _S2STCW { w: self }
            }
            #[doc = "Bit 19 - Slice 3 status bit clear"]
            #[inline]
            pub fn s3stc(&mut self) -> _S3STCW {
                _S3STCW { w: self }
            }
        }
    }
    #[doc = "Global Channel Status"]
    pub struct GCST {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Channel Status"]
    pub mod gcst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::GCST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S0SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0SSR::VALUE1 => false,
                    S0SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0SSR {
                match value {
                    false => S0SSR::VALUE1,
                    true => S0SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S0DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S0DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0DSSR::VALUE1 => false,
                    S0DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0DSSR {
                match value {
                    false => S0DSSR::VALUE1,
                    true => S0DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S0PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S0PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0PSSR::VALUE1 => false,
                    S0PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0PSSR {
                match value {
                    false => S0PSSR::VALUE1,
                    true => S0PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0PSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S1SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1SSR::VALUE1 => false,
                    S1SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1SSR {
                match value {
                    false => S1SSR::VALUE1,
                    true => S1SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S1DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1DSSR::VALUE1 => false,
                    S1DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1DSSR {
                match value {
                    false => S1DSSR::VALUE1,
                    true => S1DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S1PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1PSSR::VALUE1 => false,
                    S1PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1PSSR {
                match value {
                    false => S1PSSR::VALUE1,
                    true => S1PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1PSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S2SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2SSR::VALUE1 => false,
                    S2SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2SSR {
                match value {
                    false => S2SSR::VALUE1,
                    true => S2SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S2DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2DSSR::VALUE1 => false,
                    S2DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2DSSR {
                match value {
                    false => S2DSSR::VALUE1,
                    true => S2DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S2PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2PSSR::VALUE1 => false,
                    S2PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2PSSR {
                match value {
                    false => S2PSSR::VALUE1,
                    true => S2PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2PSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S3SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3SSR::VALUE1 => false,
                    S3SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3SSR {
                match value {
                    false => S3SSR::VALUE1,
                    true => S3SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S3DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3DSSR::VALUE1 => false,
                    S3DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3DSSR {
                match value {
                    false => S3DSSR::VALUE1,
                    true => S3DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S3PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3PSSR::VALUE1 => false,
                    S3PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3PSSR {
                match value {
                    false => S3PSSR::VALUE1,
                    true => S3PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3PSSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC40STR {
            bits: bool,
        }
        impl CC40STR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC41STR {
            bits: bool,
        }
        impl CC41STR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC42STR {
            bits: bool,
        }
        impl CC42STR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC43STR {
            bits: bool,
        }
        impl CC43STR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Slice 0 shadow transfer status"]
            #[inline]
            pub fn s0ss(&self) -> S0SSR {
                S0SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Slice 0 Dither shadow transfer status"]
            #[inline]
            pub fn s0dss(&self) -> S0DSSR {
                S0DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Slice 0 Prescaler shadow transfer status"]
            #[inline]
            pub fn s0pss(&self) -> S0PSSR {
                S0PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Slice 1 shadow transfer status"]
            #[inline]
            pub fn s1ss(&self) -> S1SSR {
                S1SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Slice 1 Dither shadow transfer status"]
            #[inline]
            pub fn s1dss(&self) -> S1DSSR {
                S1DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Slice 1 Prescaler shadow transfer status"]
            #[inline]
            pub fn s1pss(&self) -> S1PSSR {
                S1PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Slice 2 shadow transfer status"]
            #[inline]
            pub fn s2ss(&self) -> S2SSR {
                S2SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Slice 2 Dither shadow transfer status"]
            #[inline]
            pub fn s2dss(&self) -> S2DSSR {
                S2DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Slice 2 Prescaler shadow transfer status"]
            #[inline]
            pub fn s2pss(&self) -> S2PSSR {
                S2PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Slice 3 shadow transfer status"]
            #[inline]
            pub fn s3ss(&self) -> S3SSR {
                S3SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Slice 3 Dither shadow transfer status"]
            #[inline]
            pub fn s3dss(&self) -> S3DSSR {
                S3DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Slice 3 Prescaler shadow transfer status"]
            #[inline]
            pub fn s3pss(&self) -> S3PSSR {
                S3PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Slice 0 status bit"]
            #[inline]
            pub fn cc40st(&self) -> CC40STR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC40STR { bits }
            }
            #[doc = "Bit 17 - Slice 1 status bit"]
            #[inline]
            pub fn cc41st(&self) -> CC41STR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC41STR { bits }
            }
            #[doc = "Bit 18 - Slice 2 status bit"]
            #[inline]
            pub fn cc42st(&self) -> CC42STR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC42STR { bits }
            }
            #[doc = "Bit 19 - Slice 3 status bit"]
            #[inline]
            pub fn cc43st(&self) -> CC43STR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC43STR { bits }
            }
        }
    }
    #[doc = "Extended Capture Mode Read"]
    pub struct ECRD {
        register: VolatileCell<u32>,
    }
    #[doc = "Extended Capture Mode Read"]
    pub mod ecrd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ECRD {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPVR {
            bits: u16,
        }
        impl CAPVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SPTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SPTRR {
            #[doc = "CC40"]
            VALUE1,
            #[doc = "CC41"]
            VALUE2,
            #[doc = "CC42"]
            VALUE3,
            #[doc = "CC43"]
            VALUE4,
        }
        impl SPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SPTRR::VALUE1 => 0,
                    SPTRR::VALUE2 => 0x01,
                    SPTRR::VALUE3 => 0x02,
                    SPTRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SPTRR {
                match value {
                    0 => SPTRR::VALUE1,
                    1 => SPTRR::VALUE2,
                    2 => SPTRR::VALUE3,
                    3 => SPTRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SPTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SPTRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SPTRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SPTRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `VPTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VPTRR {
            #[doc = "Capture register 0"]
            VALUE1,
            #[doc = "Capture register 1"]
            VALUE2,
            #[doc = "Capture register 2"]
            VALUE3,
            #[doc = "Capture register 3"]
            VALUE4,
        }
        impl VPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    VPTRR::VALUE1 => 0,
                    VPTRR::VALUE2 => 0x01,
                    VPTRR::VALUE3 => 0x02,
                    VPTRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> VPTRR {
                match value {
                    0 => VPTRR::VALUE1,
                    1 => VPTRR::VALUE2,
                    2 => VPTRR::VALUE3,
                    3 => VPTRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VPTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VPTRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == VPTRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == VPTRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into this register"]
            VALUE1,
            #[doc = "A new value has been captured into this register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Timer Capture Value"]
            #[inline]
            pub fn capv(&self) -> CAPVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Capture value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bits 20:21 - Slice pointer"]
            #[inline]
            pub fn sptr(&self) -> SPTRR {
                SPTRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Capture register pointer"]
            #[inline]
            pub fn vptr(&self) -> VPTRR {
                VPTRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 24 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Module Identification"]
    pub struct MIDR {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification"]
    pub mod midr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MIDR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODRR {
            bits: u8,
        }
        impl MODRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODTR {
            bits: u8,
        }
        impl MODTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODNR {
            bits: u16,
        }
        impl MODNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn modr(&self) -> MODRR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODRR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn modt(&self) -> MODTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODTR { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn modn(&self) -> MODNR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MODNR { bits }
            }
        }
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub struct CCU40 {
    register_block: ccu40::RegisterBlock,
}
impl Deref for CCU40 {
    type Target = ccu40::RegisterBlock;
    fn deref(&self) -> &ccu40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 1"]
pub const CCU41: Peripheral<CCU41> = unsafe { Peripheral::new(0x4001_0000) };
#[doc = r" Register block"]
pub struct CCU41 {
    register_block: ccu40::RegisterBlock,
}
impl Deref for CCU41 {
    type Target = ccu40::RegisterBlock;
    fn deref(&self) -> &ccu40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub const CCU40_CC40: Peripheral<CCU40_CC40> = unsafe { Peripheral::new(0x4000_c100) };
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub mod ccu40_cc40 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Input Selector Configuration"]
        pub ins: INS,
        #[doc = "0x04 - Connection Matrix Control"]
        pub cmc: CMC,
        #[doc = "0x08 - Slice Timer Status"]
        pub tcst: TCST,
        #[doc = "0x0c - Slice Timer Run Set"]
        pub tcset: TCSET,
        #[doc = "0x10 - Slice Timer Clear"]
        pub tcclr: TCCLR,
        #[doc = "0x14 - Slice Timer Control"]
        pub tc: TC,
        #[doc = "0x18 - Passive Level Config"]
        pub psl: PSL,
        #[doc = "0x1c - Dither Config"]
        pub dit: DIT,
        #[doc = "0x20 - Dither Shadow Register"]
        pub dits: DITS,
        #[doc = "0x24 - Prescaler Control"]
        pub psc: PSC,
        #[doc = "0x28 - Floating Prescaler Control"]
        pub fpc: FPC,
        #[doc = "0x2c - Floating Prescaler Shadow"]
        pub fpcs: FPCS,
        #[doc = "0x30 - Timer Period Value"]
        pub pr: PR,
        #[doc = "0x34 - Timer Shadow Period Value"]
        pub prs: PRS,
        #[doc = "0x38 - Timer Compare Value"]
        pub cr: CR,
        #[doc = "0x3c - Timer Shadow Compare Value"]
        pub crs: CRS,
        _reserved0: [u8; 48usize],
        #[doc = "0x70 - Timer Value"]
        pub timer: TIMER,
        #[doc = "0x74 - Capture Register 0"]
        pub c0v: C0V,
        #[doc = "0x78 - Capture Register 1"]
        pub c1v: C1V,
        #[doc = "0x7c - Capture Register 2"]
        pub c2v: C2V,
        #[doc = "0x80 - Capture Register 3"]
        pub c3v: C3V,
        _reserved1: [u8; 28usize],
        #[doc = "0xa0 - Interrupt Status"]
        pub ints: INTS,
        #[doc = "0xa4 - Interrupt Enable Control"]
        pub inte: INTE,
        #[doc = "0xa8 - Service Request Selector"]
        pub srs: SRS,
        #[doc = "0xac - Interrupt Status Set"]
        pub sws: SWS,
        #[doc = "0xb0 - Interrupt Status Clear"]
        pub swr: SWR,
    }
    #[doc = "Input Selector Configuration"]
    pub struct INS {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Selector Configuration"]
    pub mod ins {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::INS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `EV0IS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV0ISR {
            #[doc = "CCU4x.INyA"]
            VALUE1,
            #[doc = "CCU4x.INyB"]
            VALUE2,
            #[doc = "CCU4x.INyC"]
            VALUE3,
            #[doc = "CCU4x.INyD"]
            VALUE4,
            #[doc = "CCU4x.INyE"]
            VALUE5,
            #[doc = "CCU4x.INyF"]
            VALUE6,
            #[doc = "CCU4x.INyG"]
            VALUE7,
            #[doc = "CCU4x.INyH"]
            VALUE8,
            #[doc = "CCU4x.INyI"]
            VALUE9,
            #[doc = "CCU4x.INyJ"]
            VALUE10,
            #[doc = "CCU4x.INyK"]
            VALUE11,
            #[doc = "CCU4x.INyL"]
            VALUE12,
            #[doc = "CCU4x.INyM"]
            VALUE13,
            #[doc = "CCU4x.INyN"]
            VALUE14,
            #[doc = "CCU4x.INyO"]
            VALUE15,
            #[doc = "CCU4x.INyP"]
            VALUE16,
        }
        impl EV0ISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV0ISR::VALUE1 => 0,
                    EV0ISR::VALUE2 => 0x01,
                    EV0ISR::VALUE3 => 0x02,
                    EV0ISR::VALUE4 => 0x03,
                    EV0ISR::VALUE5 => 0x04,
                    EV0ISR::VALUE6 => 0x05,
                    EV0ISR::VALUE7 => 0x06,
                    EV0ISR::VALUE8 => 0x07,
                    EV0ISR::VALUE9 => 0x08,
                    EV0ISR::VALUE10 => 0x09,
                    EV0ISR::VALUE11 => 0x0a,
                    EV0ISR::VALUE12 => 0x0b,
                    EV0ISR::VALUE13 => 0x0c,
                    EV0ISR::VALUE14 => 0x0d,
                    EV0ISR::VALUE15 => 0x0e,
                    EV0ISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV0ISR {
                match value {
                    0 => EV0ISR::VALUE1,
                    1 => EV0ISR::VALUE2,
                    2 => EV0ISR::VALUE3,
                    3 => EV0ISR::VALUE4,
                    4 => EV0ISR::VALUE5,
                    5 => EV0ISR::VALUE6,
                    6 => EV0ISR::VALUE7,
                    7 => EV0ISR::VALUE8,
                    8 => EV0ISR::VALUE9,
                    9 => EV0ISR::VALUE10,
                    10 => EV0ISR::VALUE11,
                    11 => EV0ISR::VALUE12,
                    12 => EV0ISR::VALUE13,
                    13 => EV0ISR::VALUE14,
                    14 => EV0ISR::VALUE15,
                    15 => EV0ISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV0ISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV0ISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV0ISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV0ISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == EV0ISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == EV0ISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == EV0ISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == EV0ISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == EV0ISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == EV0ISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == EV0ISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == EV0ISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == EV0ISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == EV0ISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == EV0ISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == EV0ISR::VALUE16
            }
        }
        #[doc = "Possible values of the field `EV1IS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV1ISR {
            #[doc = "CCU4x.INyA"]
            VALUE1,
            #[doc = "CCU4x.INyB"]
            VALUE2,
            #[doc = "CCU4x.INyC"]
            VALUE3,
            #[doc = "CCU4x.INyD"]
            VALUE4,
            #[doc = "CCU4x.INyE"]
            VALUE5,
            #[doc = "CCU4x.INyF"]
            VALUE6,
            #[doc = "CCU4x.INyG"]
            VALUE7,
            #[doc = "CCU4x.INyH"]
            VALUE8,
            #[doc = "CCU4x.INyI"]
            VALUE9,
            #[doc = "CCU4x.INyJ"]
            VALUE10,
            #[doc = "CCU4x.INyK"]
            VALUE11,
            #[doc = "CCU4x.INyL"]
            VALUE12,
            #[doc = "CCU4x.INyM"]
            VALUE13,
            #[doc = "CCU4x.INyN"]
            VALUE14,
            #[doc = "CCU4x.INyO"]
            VALUE15,
            #[doc = "CCU4x.INyP"]
            VALUE16,
        }
        impl EV1ISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV1ISR::VALUE1 => 0,
                    EV1ISR::VALUE2 => 0x01,
                    EV1ISR::VALUE3 => 0x02,
                    EV1ISR::VALUE4 => 0x03,
                    EV1ISR::VALUE5 => 0x04,
                    EV1ISR::VALUE6 => 0x05,
                    EV1ISR::VALUE7 => 0x06,
                    EV1ISR::VALUE8 => 0x07,
                    EV1ISR::VALUE9 => 0x08,
                    EV1ISR::VALUE10 => 0x09,
                    EV1ISR::VALUE11 => 0x0a,
                    EV1ISR::VALUE12 => 0x0b,
                    EV1ISR::VALUE13 => 0x0c,
                    EV1ISR::VALUE14 => 0x0d,
                    EV1ISR::VALUE15 => 0x0e,
                    EV1ISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV1ISR {
                match value {
                    0 => EV1ISR::VALUE1,
                    1 => EV1ISR::VALUE2,
                    2 => EV1ISR::VALUE3,
                    3 => EV1ISR::VALUE4,
                    4 => EV1ISR::VALUE5,
                    5 => EV1ISR::VALUE6,
                    6 => EV1ISR::VALUE7,
                    7 => EV1ISR::VALUE8,
                    8 => EV1ISR::VALUE9,
                    9 => EV1ISR::VALUE10,
                    10 => EV1ISR::VALUE11,
                    11 => EV1ISR::VALUE12,
                    12 => EV1ISR::VALUE13,
                    13 => EV1ISR::VALUE14,
                    14 => EV1ISR::VALUE15,
                    15 => EV1ISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV1ISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV1ISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV1ISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV1ISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == EV1ISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == EV1ISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == EV1ISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == EV1ISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == EV1ISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == EV1ISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == EV1ISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == EV1ISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == EV1ISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == EV1ISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == EV1ISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == EV1ISR::VALUE16
            }
        }
        #[doc = "Possible values of the field `EV2IS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV2ISR {
            #[doc = "CCU4x.INyA"]
            VALUE1,
            #[doc = "CCU4x.INyB"]
            VALUE2,
            #[doc = "CCU4x.INyC"]
            VALUE3,
            #[doc = "CCU4x.INyD"]
            VALUE4,
            #[doc = "CCU4x.INyE"]
            VALUE5,
            #[doc = "CCU4x.INyF"]
            VALUE6,
            #[doc = "CCU4x.INyG"]
            VALUE7,
            #[doc = "CCU4x.INyH"]
            VALUE8,
            #[doc = "CCU4x.INyI"]
            VALUE9,
            #[doc = "CCU4x.INyJ"]
            VALUE10,
            #[doc = "CCU4x.INyK"]
            VALUE11,
            #[doc = "CCU4x.INyL"]
            VALUE12,
            #[doc = "CCU4x.INyM"]
            VALUE13,
            #[doc = "CCU4x.INyN"]
            VALUE14,
            #[doc = "CCU4x.INyO"]
            VALUE15,
            #[doc = "CCU4x.INyP"]
            VALUE16,
        }
        impl EV2ISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV2ISR::VALUE1 => 0,
                    EV2ISR::VALUE2 => 0x01,
                    EV2ISR::VALUE3 => 0x02,
                    EV2ISR::VALUE4 => 0x03,
                    EV2ISR::VALUE5 => 0x04,
                    EV2ISR::VALUE6 => 0x05,
                    EV2ISR::VALUE7 => 0x06,
                    EV2ISR::VALUE8 => 0x07,
                    EV2ISR::VALUE9 => 0x08,
                    EV2ISR::VALUE10 => 0x09,
                    EV2ISR::VALUE11 => 0x0a,
                    EV2ISR::VALUE12 => 0x0b,
                    EV2ISR::VALUE13 => 0x0c,
                    EV2ISR::VALUE14 => 0x0d,
                    EV2ISR::VALUE15 => 0x0e,
                    EV2ISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV2ISR {
                match value {
                    0 => EV2ISR::VALUE1,
                    1 => EV2ISR::VALUE2,
                    2 => EV2ISR::VALUE3,
                    3 => EV2ISR::VALUE4,
                    4 => EV2ISR::VALUE5,
                    5 => EV2ISR::VALUE6,
                    6 => EV2ISR::VALUE7,
                    7 => EV2ISR::VALUE8,
                    8 => EV2ISR::VALUE9,
                    9 => EV2ISR::VALUE10,
                    10 => EV2ISR::VALUE11,
                    11 => EV2ISR::VALUE12,
                    12 => EV2ISR::VALUE13,
                    13 => EV2ISR::VALUE14,
                    14 => EV2ISR::VALUE15,
                    15 => EV2ISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV2ISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV2ISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV2ISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV2ISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == EV2ISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == EV2ISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == EV2ISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == EV2ISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == EV2ISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == EV2ISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == EV2ISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == EV2ISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == EV2ISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == EV2ISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == EV2ISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == EV2ISR::VALUE16
            }
        }
        #[doc = "Possible values of the field `EV0EM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV0EMR {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV0EMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV0EMR::VALUE1 => 0,
                    EV0EMR::VALUE2 => 0x01,
                    EV0EMR::VALUE3 => 0x02,
                    EV0EMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV0EMR {
                match value {
                    0 => EV0EMR::VALUE1,
                    1 => EV0EMR::VALUE2,
                    2 => EV0EMR::VALUE3,
                    3 => EV0EMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV0EMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV0EMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV0EMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV0EMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EV1EM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV1EMR {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV1EMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV1EMR::VALUE1 => 0,
                    EV1EMR::VALUE2 => 0x01,
                    EV1EMR::VALUE3 => 0x02,
                    EV1EMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV1EMR {
                match value {
                    0 => EV1EMR::VALUE1,
                    1 => EV1EMR::VALUE2,
                    2 => EV1EMR::VALUE3,
                    3 => EV1EMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV1EMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV1EMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV1EMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV1EMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EV2EM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV2EMR {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV2EMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV2EMR::VALUE1 => 0,
                    EV2EMR::VALUE2 => 0x01,
                    EV2EMR::VALUE3 => 0x02,
                    EV2EMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV2EMR {
                match value {
                    0 => EV2EMR::VALUE1,
                    1 => EV2EMR::VALUE2,
                    2 => EV2EMR::VALUE3,
                    3 => EV2EMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV2EMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV2EMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV2EMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV2EMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EV0LM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV0LMR {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV0LMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EV0LMR::VALUE1 => false,
                    EV0LMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EV0LMR {
                match value {
                    false => EV0LMR::VALUE1,
                    true => EV0LMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV0LMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV0LMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EV1LM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV1LMR {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV1LMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EV1LMR::VALUE1 => false,
                    EV1LMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EV1LMR {
                match value {
                    false => EV1LMR::VALUE1,
                    true => EV1LMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV1LMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV1LMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EV2LM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV2LMR {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV2LMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EV2LMR::VALUE1 => false,
                    EV2LMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EV2LMR {
                match value {
                    false => EV2LMR::VALUE1,
                    true => EV2LMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV2LMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV2LMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPF0M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPF0MR {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU4"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU4"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU4"]
            VALUE4,
        }
        impl LPF0MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPF0MR::VALUE1 => 0,
                    LPF0MR::VALUE2 => 0x01,
                    LPF0MR::VALUE3 => 0x02,
                    LPF0MR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPF0MR {
                match value {
                    0 => LPF0MR::VALUE1,
                    1 => LPF0MR::VALUE2,
                    2 => LPF0MR::VALUE3,
                    3 => LPF0MR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPF0MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPF0MR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPF0MR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPF0MR::VALUE4
            }
        }
        #[doc = "Possible values of the field `LPF1M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPF1MR {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU4"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU4"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU4"]
            VALUE4,
        }
        impl LPF1MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPF1MR::VALUE1 => 0,
                    LPF1MR::VALUE2 => 0x01,
                    LPF1MR::VALUE3 => 0x02,
                    LPF1MR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPF1MR {
                match value {
                    0 => LPF1MR::VALUE1,
                    1 => LPF1MR::VALUE2,
                    2 => LPF1MR::VALUE3,
                    3 => LPF1MR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPF1MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPF1MR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPF1MR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPF1MR::VALUE4
            }
        }
        #[doc = "Possible values of the field `LPF2M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPF2MR {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU4"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU4"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU4"]
            VALUE4,
        }
        impl LPF2MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPF2MR::VALUE1 => 0,
                    LPF2MR::VALUE2 => 0x01,
                    LPF2MR::VALUE3 => 0x02,
                    LPF2MR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPF2MR {
                match value {
                    0 => LPF2MR::VALUE1,
                    1 => LPF2MR::VALUE2,
                    2 => LPF2MR::VALUE3,
                    3 => LPF2MR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPF2MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPF2MR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPF2MR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPF2MR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `EV0IS`"]
        pub enum EV0ISW {
            #[doc = "CCU4x.INyA"]
            VALUE1,
            #[doc = "CCU4x.INyB"]
            VALUE2,
            #[doc = "CCU4x.INyC"]
            VALUE3,
            #[doc = "CCU4x.INyD"]
            VALUE4,
            #[doc = "CCU4x.INyE"]
            VALUE5,
            #[doc = "CCU4x.INyF"]
            VALUE6,
            #[doc = "CCU4x.INyG"]
            VALUE7,
            #[doc = "CCU4x.INyH"]
            VALUE8,
            #[doc = "CCU4x.INyI"]
            VALUE9,
            #[doc = "CCU4x.INyJ"]
            VALUE10,
            #[doc = "CCU4x.INyK"]
            VALUE11,
            #[doc = "CCU4x.INyL"]
            VALUE12,
            #[doc = "CCU4x.INyM"]
            VALUE13,
            #[doc = "CCU4x.INyN"]
            VALUE14,
            #[doc = "CCU4x.INyO"]
            VALUE15,
            #[doc = "CCU4x.INyP"]
            VALUE16,
        }
        impl EV0ISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV0ISW::VALUE1 => 0,
                    EV0ISW::VALUE2 => 1,
                    EV0ISW::VALUE3 => 2,
                    EV0ISW::VALUE4 => 3,
                    EV0ISW::VALUE5 => 4,
                    EV0ISW::VALUE6 => 5,
                    EV0ISW::VALUE7 => 6,
                    EV0ISW::VALUE8 => 7,
                    EV0ISW::VALUE9 => 8,
                    EV0ISW::VALUE10 => 9,
                    EV0ISW::VALUE11 => 10,
                    EV0ISW::VALUE12 => 11,
                    EV0ISW::VALUE13 => 12,
                    EV0ISW::VALUE14 => 13,
                    EV0ISW::VALUE15 => 14,
                    EV0ISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV0ISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV0ISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV0ISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU4x.INyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE1)
            }
            #[doc = "CCU4x.INyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE2)
            }
            #[doc = "CCU4x.INyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE3)
            }
            #[doc = "CCU4x.INyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE4)
            }
            #[doc = "CCU4x.INyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE5)
            }
            #[doc = "CCU4x.INyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE6)
            }
            #[doc = "CCU4x.INyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE7)
            }
            #[doc = "CCU4x.INyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE8)
            }
            #[doc = "CCU4x.INyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE9)
            }
            #[doc = "CCU4x.INyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE10)
            }
            #[doc = "CCU4x.INyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE11)
            }
            #[doc = "CCU4x.INyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE12)
            }
            #[doc = "CCU4x.INyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE13)
            }
            #[doc = "CCU4x.INyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE14)
            }
            #[doc = "CCU4x.INyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE15)
            }
            #[doc = "CCU4x.INyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV1IS`"]
        pub enum EV1ISW {
            #[doc = "CCU4x.INyA"]
            VALUE1,
            #[doc = "CCU4x.INyB"]
            VALUE2,
            #[doc = "CCU4x.INyC"]
            VALUE3,
            #[doc = "CCU4x.INyD"]
            VALUE4,
            #[doc = "CCU4x.INyE"]
            VALUE5,
            #[doc = "CCU4x.INyF"]
            VALUE6,
            #[doc = "CCU4x.INyG"]
            VALUE7,
            #[doc = "CCU4x.INyH"]
            VALUE8,
            #[doc = "CCU4x.INyI"]
            VALUE9,
            #[doc = "CCU4x.INyJ"]
            VALUE10,
            #[doc = "CCU4x.INyK"]
            VALUE11,
            #[doc = "CCU4x.INyL"]
            VALUE12,
            #[doc = "CCU4x.INyM"]
            VALUE13,
            #[doc = "CCU4x.INyN"]
            VALUE14,
            #[doc = "CCU4x.INyO"]
            VALUE15,
            #[doc = "CCU4x.INyP"]
            VALUE16,
        }
        impl EV1ISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV1ISW::VALUE1 => 0,
                    EV1ISW::VALUE2 => 1,
                    EV1ISW::VALUE3 => 2,
                    EV1ISW::VALUE4 => 3,
                    EV1ISW::VALUE5 => 4,
                    EV1ISW::VALUE6 => 5,
                    EV1ISW::VALUE7 => 6,
                    EV1ISW::VALUE8 => 7,
                    EV1ISW::VALUE9 => 8,
                    EV1ISW::VALUE10 => 9,
                    EV1ISW::VALUE11 => 10,
                    EV1ISW::VALUE12 => 11,
                    EV1ISW::VALUE13 => 12,
                    EV1ISW::VALUE14 => 13,
                    EV1ISW::VALUE15 => 14,
                    EV1ISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV1ISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV1ISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV1ISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU4x.INyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE1)
            }
            #[doc = "CCU4x.INyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE2)
            }
            #[doc = "CCU4x.INyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE3)
            }
            #[doc = "CCU4x.INyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE4)
            }
            #[doc = "CCU4x.INyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE5)
            }
            #[doc = "CCU4x.INyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE6)
            }
            #[doc = "CCU4x.INyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE7)
            }
            #[doc = "CCU4x.INyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE8)
            }
            #[doc = "CCU4x.INyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE9)
            }
            #[doc = "CCU4x.INyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE10)
            }
            #[doc = "CCU4x.INyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE11)
            }
            #[doc = "CCU4x.INyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE12)
            }
            #[doc = "CCU4x.INyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE13)
            }
            #[doc = "CCU4x.INyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE14)
            }
            #[doc = "CCU4x.INyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE15)
            }
            #[doc = "CCU4x.INyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV2IS`"]
        pub enum EV2ISW {
            #[doc = "CCU4x.INyA"]
            VALUE1,
            #[doc = "CCU4x.INyB"]
            VALUE2,
            #[doc = "CCU4x.INyC"]
            VALUE3,
            #[doc = "CCU4x.INyD"]
            VALUE4,
            #[doc = "CCU4x.INyE"]
            VALUE5,
            #[doc = "CCU4x.INyF"]
            VALUE6,
            #[doc = "CCU4x.INyG"]
            VALUE7,
            #[doc = "CCU4x.INyH"]
            VALUE8,
            #[doc = "CCU4x.INyI"]
            VALUE9,
            #[doc = "CCU4x.INyJ"]
            VALUE10,
            #[doc = "CCU4x.INyK"]
            VALUE11,
            #[doc = "CCU4x.INyL"]
            VALUE12,
            #[doc = "CCU4x.INyM"]
            VALUE13,
            #[doc = "CCU4x.INyN"]
            VALUE14,
            #[doc = "CCU4x.INyO"]
            VALUE15,
            #[doc = "CCU4x.INyP"]
            VALUE16,
        }
        impl EV2ISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV2ISW::VALUE1 => 0,
                    EV2ISW::VALUE2 => 1,
                    EV2ISW::VALUE3 => 2,
                    EV2ISW::VALUE4 => 3,
                    EV2ISW::VALUE5 => 4,
                    EV2ISW::VALUE6 => 5,
                    EV2ISW::VALUE7 => 6,
                    EV2ISW::VALUE8 => 7,
                    EV2ISW::VALUE9 => 8,
                    EV2ISW::VALUE10 => 9,
                    EV2ISW::VALUE11 => 10,
                    EV2ISW::VALUE12 => 11,
                    EV2ISW::VALUE13 => 12,
                    EV2ISW::VALUE14 => 13,
                    EV2ISW::VALUE15 => 14,
                    EV2ISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV2ISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV2ISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV2ISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU4x.INyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE1)
            }
            #[doc = "CCU4x.INyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE2)
            }
            #[doc = "CCU4x.INyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE3)
            }
            #[doc = "CCU4x.INyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE4)
            }
            #[doc = "CCU4x.INyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE5)
            }
            #[doc = "CCU4x.INyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE6)
            }
            #[doc = "CCU4x.INyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE7)
            }
            #[doc = "CCU4x.INyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE8)
            }
            #[doc = "CCU4x.INyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE9)
            }
            #[doc = "CCU4x.INyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE10)
            }
            #[doc = "CCU4x.INyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE11)
            }
            #[doc = "CCU4x.INyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE12)
            }
            #[doc = "CCU4x.INyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE13)
            }
            #[doc = "CCU4x.INyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE14)
            }
            #[doc = "CCU4x.INyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE15)
            }
            #[doc = "CCU4x.INyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV0EM`"]
        pub enum EV0EMW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV0EMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV0EMW::VALUE1 => 0,
                    EV0EMW::VALUE2 => 1,
                    EV0EMW::VALUE3 => 2,
                    EV0EMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV0EMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV0EMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV0EMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE1)
            }
            #[doc = "Signal active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE2)
            }
            #[doc = "Signal active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE3)
            }
            #[doc = "Signal active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV1EM`"]
        pub enum EV1EMW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV1EMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV1EMW::VALUE1 => 0,
                    EV1EMW::VALUE2 => 1,
                    EV1EMW::VALUE3 => 2,
                    EV1EMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV1EMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV1EMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV1EMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE1)
            }
            #[doc = "Signal active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE2)
            }
            #[doc = "Signal active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE3)
            }
            #[doc = "Signal active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV2EM`"]
        pub enum EV2EMW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV2EMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV2EMW::VALUE1 => 0,
                    EV2EMW::VALUE2 => 1,
                    EV2EMW::VALUE3 => 2,
                    EV2EMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV2EMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV2EMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV2EMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE1)
            }
            #[doc = "Signal active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE2)
            }
            #[doc = "Signal active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE3)
            }
            #[doc = "Signal active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV0LM`"]
        pub enum EV0LMW {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV0LMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EV0LMW::VALUE1 => false,
                    EV0LMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV0LMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV0LMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV0LMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active on HIGH level"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV0LMW::VALUE1)
            }
            #[doc = "Active on LOW level"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV0LMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV1LM`"]
        pub enum EV1LMW {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV1LMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EV1LMW::VALUE1 => false,
                    EV1LMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV1LMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV1LMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV1LMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active on HIGH level"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV1LMW::VALUE1)
            }
            #[doc = "Active on LOW level"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV1LMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV2LM`"]
        pub enum EV2LMW {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV2LMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EV2LMW::VALUE1 => false,
                    EV2LMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV2LMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV2LMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV2LMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active on HIGH level"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV2LMW::VALUE1)
            }
            #[doc = "Active on LOW level"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV2LMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPF0M`"]
        pub enum LPF0MW {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU4"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU4"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU4"]
            VALUE4,
        }
        impl LPF0MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPF0MW::VALUE1 => 0,
                    LPF0MW::VALUE2 => 1,
                    LPF0MW::VALUE3 => 2,
                    LPF0MW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPF0MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPF0MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPF0MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "LPF is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE1)
            }
            #[doc = "3 clock cycles of fCCU4"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE2)
            }
            #[doc = "5 clock cycles of fCCU4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE3)
            }
            #[doc = "7 clock cycles of fCCU4"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPF1M`"]
        pub enum LPF1MW {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU4"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU4"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU4"]
            VALUE4,
        }
        impl LPF1MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPF1MW::VALUE1 => 0,
                    LPF1MW::VALUE2 => 1,
                    LPF1MW::VALUE3 => 2,
                    LPF1MW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPF1MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPF1MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPF1MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "LPF is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE1)
            }
            #[doc = "3 clock cycles of fCCU4"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE2)
            }
            #[doc = "5 clock cycles of fCCU4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE3)
            }
            #[doc = "7 clock cycles of fCCU4"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPF2M`"]
        pub enum LPF2MW {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU4"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU4"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU4"]
            VALUE4,
        }
        impl LPF2MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPF2MW::VALUE1 => 0,
                    LPF2MW::VALUE2 => 1,
                    LPF2MW::VALUE3 => 2,
                    LPF2MW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPF2MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPF2MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPF2MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "LPF is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE1)
            }
            #[doc = "3 clock cycles of fCCU4"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE2)
            }
            #[doc = "5 clock cycles of fCCU4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE3)
            }
            #[doc = "7 clock cycles of fCCU4"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Event 0 signal selection"]
            #[inline]
            pub fn ev0is(&self) -> EV0ISR {
                EV0ISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Event 1 signal selection"]
            #[inline]
            pub fn ev1is(&self) -> EV1ISR {
                EV1ISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Event 2 signal selection"]
            #[inline]
            pub fn ev2is(&self) -> EV2ISR {
                EV2ISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Event 0 Edge Selection"]
            #[inline]
            pub fn ev0em(&self) -> EV0EMR {
                EV0EMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Event 1 Edge Selection"]
            #[inline]
            pub fn ev1em(&self) -> EV1EMR {
                EV1EMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Event 2 Edge Selection"]
            #[inline]
            pub fn ev2em(&self) -> EV2EMR {
                EV2EMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 22 - Event 0 Level Selection"]
            #[inline]
            pub fn ev0lm(&self) -> EV0LMR {
                EV0LMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - Event 1 Level Selection"]
            #[inline]
            pub fn ev1lm(&self) -> EV1LMR {
                EV1LMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Event 2 Level Selection"]
            #[inline]
            pub fn ev2lm(&self) -> EV2LMR {
                EV2LMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 25:26 - Event 0 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf0m(&self) -> LPF0MR {
                LPF0MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:28 - Event 1 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf1m(&self) -> LPF1MR {
                LPF1MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 29:30 - Event 2 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf2m(&self) -> LPF2MR {
                LPF2MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Event 0 signal selection"]
            #[inline]
            pub fn ev0is(&mut self) -> _EV0ISW {
                _EV0ISW { w: self }
            }
            #[doc = "Bits 4:7 - Event 1 signal selection"]
            #[inline]
            pub fn ev1is(&mut self) -> _EV1ISW {
                _EV1ISW { w: self }
            }
            #[doc = "Bits 8:11 - Event 2 signal selection"]
            #[inline]
            pub fn ev2is(&mut self) -> _EV2ISW {
                _EV2ISW { w: self }
            }
            #[doc = "Bits 16:17 - Event 0 Edge Selection"]
            #[inline]
            pub fn ev0em(&mut self) -> _EV0EMW {
                _EV0EMW { w: self }
            }
            #[doc = "Bits 18:19 - Event 1 Edge Selection"]
            #[inline]
            pub fn ev1em(&mut self) -> _EV1EMW {
                _EV1EMW { w: self }
            }
            #[doc = "Bits 20:21 - Event 2 Edge Selection"]
            #[inline]
            pub fn ev2em(&mut self) -> _EV2EMW {
                _EV2EMW { w: self }
            }
            #[doc = "Bit 22 - Event 0 Level Selection"]
            #[inline]
            pub fn ev0lm(&mut self) -> _EV0LMW {
                _EV0LMW { w: self }
            }
            #[doc = "Bit 23 - Event 1 Level Selection"]
            #[inline]
            pub fn ev1lm(&mut self) -> _EV1LMW {
                _EV1LMW { w: self }
            }
            #[doc = "Bit 24 - Event 2 Level Selection"]
            #[inline]
            pub fn ev2lm(&mut self) -> _EV2LMW {
                _EV2LMW { w: self }
            }
            #[doc = "Bits 25:26 - Event 0 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf0m(&mut self) -> _LPF0MW {
                _LPF0MW { w: self }
            }
            #[doc = "Bits 27:28 - Event 1 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf1m(&mut self) -> _LPF1MW {
                _LPF1MW { w: self }
            }
            #[doc = "Bits 29:30 - Event 2 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf2m(&mut self) -> _LPF2MW {
                _LPF2MW { w: self }
            }
        }
    }
    #[doc = "Connection Matrix Control"]
    pub struct CMC {
        register: VolatileCell<u32>,
    }
    #[doc = "Connection Matrix Control"]
    pub mod cmc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CMC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `STRTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STRTSR {
            #[doc = "External Start Function deactivated"]
            VALUE1,
            #[doc = "External Start Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Start Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Start Function triggered by Event 2"]
            VALUE4,
        }
        impl STRTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STRTSR::VALUE1 => 0,
                    STRTSR::VALUE2 => 0x01,
                    STRTSR::VALUE3 => 0x02,
                    STRTSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STRTSR {
                match value {
                    0 => STRTSR::VALUE1,
                    1 => STRTSR::VALUE2,
                    2 => STRTSR::VALUE3,
                    3 => STRTSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STRTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STRTSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STRTSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STRTSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ENDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDSR {
            #[doc = "External Stop Function deactivated"]
            VALUE1,
            #[doc = "External Stop Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Stop Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Stop Function triggered by Event 2"]
            VALUE4,
        }
        impl ENDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENDSR::VALUE1 => 0,
                    ENDSR::VALUE2 => 0x01,
                    ENDSR::VALUE3 => 0x02,
                    ENDSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENDSR {
                match value {
                    0 => ENDSR::VALUE1,
                    1 => ENDSR::VALUE2,
                    2 => ENDSR::VALUE3,
                    3 => ENDSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENDSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ENDSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CAP0S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CAP0SR {
            #[doc = "External Capture 0 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 0 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 0 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 0 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP0SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CAP0SR::VALUE1 => 0,
                    CAP0SR::VALUE2 => 0x01,
                    CAP0SR::VALUE3 => 0x02,
                    CAP0SR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CAP0SR {
                match value {
                    0 => CAP0SR::VALUE1,
                    1 => CAP0SR::VALUE2,
                    2 => CAP0SR::VALUE3,
                    3 => CAP0SR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CAP0SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CAP0SR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CAP0SR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CAP0SR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CAP1S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CAP1SR {
            #[doc = "External Capture 1 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 1 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 1 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 1 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP1SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CAP1SR::VALUE1 => 0,
                    CAP1SR::VALUE2 => 0x01,
                    CAP1SR::VALUE3 => 0x02,
                    CAP1SR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CAP1SR {
                match value {
                    0 => CAP1SR::VALUE1,
                    1 => CAP1SR::VALUE2,
                    2 => CAP1SR::VALUE3,
                    3 => CAP1SR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CAP1SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CAP1SR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CAP1SR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CAP1SR::VALUE4
            }
        }
        #[doc = "Possible values of the field `GATES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GATESR {
            #[doc = "External Gating Function deactivated"]
            VALUE1,
            #[doc = "External Gating Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Gating Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Gating Function triggered by Event 2"]
            VALUE4,
        }
        impl GATESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    GATESR::VALUE1 => 0,
                    GATESR::VALUE2 => 0x01,
                    GATESR::VALUE3 => 0x02,
                    GATESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> GATESR {
                match value {
                    0 => GATESR::VALUE1,
                    1 => GATESR::VALUE2,
                    2 => GATESR::VALUE3,
                    3 => GATESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GATESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GATESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == GATESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == GATESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `UDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UDSR {
            #[doc = "External Up/Down Function deactivated"]
            VALUE1,
            #[doc = "External Up/Down Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Up/Down Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Up/Down Function triggered by Event 2"]
            VALUE4,
        }
        impl UDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    UDSR::VALUE1 => 0,
                    UDSR::VALUE2 => 0x01,
                    UDSR::VALUE3 => 0x02,
                    UDSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> UDSR {
                match value {
                    0 => UDSR::VALUE1,
                    1 => UDSR::VALUE2,
                    2 => UDSR::VALUE3,
                    3 => UDSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UDSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == UDSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == UDSR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct LDSR {
            bits: u8,
        }
        impl LDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CNTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CNTSR {
            #[doc = "External Count Function deactivated"]
            VALUE1,
            #[doc = "External Count Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Count Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Count Function triggered by Event 2"]
            VALUE4,
        }
        impl CNTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CNTSR::VALUE1 => 0,
                    CNTSR::VALUE2 => 0x01,
                    CNTSR::VALUE3 => 0x02,
                    CNTSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CNTSR {
                match value {
                    0 => CNTSR::VALUE1,
                    1 => CNTSR::VALUE2,
                    2 => CNTSR::VALUE3,
                    3 => CNTSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CNTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CNTSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CNTSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CNTSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `OFS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OFSR {
            #[doc = "Override functionality disabled"]
            VALUE1,
            #[doc = "Status bit trigger override connected to Event 1; Status bit value override connected to Event 2"]
            VALUE2,
        }
        impl OFSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OFSR::VALUE1 => false,
                    OFSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OFSR {
                match value {
                    false => OFSR::VALUE1,
                    true => OFSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OFSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OFSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSR {
            #[doc = "Trap function disabled"]
            VALUE1,
            #[doc = "TRAP function connected to Event 2"]
            VALUE2,
        }
        impl TSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSR::VALUE1 => false,
                    TSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSR {
                match value {
                    false => TSR::VALUE1,
                    true => TSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOSR {
            bits: u8,
        }
        impl MOSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `TCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TCER {
            #[doc = "Timer concatenation is disabled"]
            VALUE1,
            #[doc = "Timer concatenation is enabled"]
            VALUE2,
        }
        impl TCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TCER::VALUE1 => false,
                    TCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TCER {
                match value {
                    false => TCER::VALUE1,
                    true => TCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TCER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `STRTS`"]
        pub enum STRTSW {
            #[doc = "External Start Function deactivated"]
            VALUE1,
            #[doc = "External Start Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Start Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Start Function triggered by Event 2"]
            VALUE4,
        }
        impl STRTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STRTSW::VALUE1 => 0,
                    STRTSW::VALUE2 => 1,
                    STRTSW::VALUE3 => 2,
                    STRTSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STRTSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Start Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STRTSW::VALUE1)
            }
            #[doc = "External Start Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STRTSW::VALUE2)
            }
            #[doc = "External Start Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STRTSW::VALUE3)
            }
            #[doc = "External Start Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STRTSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENDS`"]
        pub enum ENDSW {
            #[doc = "External Stop Function deactivated"]
            VALUE1,
            #[doc = "External Stop Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Stop Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Stop Function triggered by Event 2"]
            VALUE4,
        }
        impl ENDSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENDSW::VALUE1 => 0,
                    ENDSW::VALUE2 => 1,
                    ENDSW::VALUE3 => 2,
                    ENDSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENDSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENDSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Stop Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENDSW::VALUE1)
            }
            #[doc = "External Stop Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENDSW::VALUE2)
            }
            #[doc = "External Stop Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENDSW::VALUE3)
            }
            #[doc = "External Stop Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ENDSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAP0S`"]
        pub enum CAP0SW {
            #[doc = "External Capture 0 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 0 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 0 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 0 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP0SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CAP0SW::VALUE1 => 0,
                    CAP0SW::VALUE2 => 1,
                    CAP0SW::VALUE3 => 2,
                    CAP0SW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAP0SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAP0SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAP0SW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Capture 0 Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE1)
            }
            #[doc = "External Capture 0 Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE2)
            }
            #[doc = "External Capture 0 Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE3)
            }
            #[doc = "External Capture 0 Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAP1S`"]
        pub enum CAP1SW {
            #[doc = "External Capture 1 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 1 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 1 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 1 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP1SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CAP1SW::VALUE1 => 0,
                    CAP1SW::VALUE2 => 1,
                    CAP1SW::VALUE3 => 2,
                    CAP1SW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAP1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAP1SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAP1SW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Capture 1 Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE1)
            }
            #[doc = "External Capture 1 Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE2)
            }
            #[doc = "External Capture 1 Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE3)
            }
            #[doc = "External Capture 1 Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GATES`"]
        pub enum GATESW {
            #[doc = "External Gating Function deactivated"]
            VALUE1,
            #[doc = "External Gating Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Gating Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Gating Function triggered by Event 2"]
            VALUE4,
        }
        impl GATESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GATESW::VALUE1 => 0,
                    GATESW::VALUE2 => 1,
                    GATESW::VALUE3 => 2,
                    GATESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GATESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GATESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GATESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Gating Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GATESW::VALUE1)
            }
            #[doc = "External Gating Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GATESW::VALUE2)
            }
            #[doc = "External Gating Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(GATESW::VALUE3)
            }
            #[doc = "External Gating Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(GATESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UDS`"]
        pub enum UDSW {
            #[doc = "External Up/Down Function deactivated"]
            VALUE1,
            #[doc = "External Up/Down Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Up/Down Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Up/Down Function triggered by Event 2"]
            VALUE4,
        }
        impl UDSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    UDSW::VALUE1 => 0,
                    UDSW::VALUE2 => 1,
                    UDSW::VALUE3 => 2,
                    UDSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UDSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UDSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Up/Down Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UDSW::VALUE1)
            }
            #[doc = "External Up/Down Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UDSW::VALUE2)
            }
            #[doc = "External Up/Down Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(UDSW::VALUE3)
            }
            #[doc = "External Up/Down Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(UDSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CNTS`"]
        pub enum CNTSW {
            #[doc = "External Count Function deactivated"]
            VALUE1,
            #[doc = "External Count Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Count Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Count Function triggered by Event 2"]
            VALUE4,
        }
        impl CNTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CNTSW::VALUE1 => 0,
                    CNTSW::VALUE2 => 1,
                    CNTSW::VALUE3 => 2,
                    CNTSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CNTSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Count Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CNTSW::VALUE1)
            }
            #[doc = "External Count Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CNTSW::VALUE2)
            }
            #[doc = "External Count Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CNTSW::VALUE3)
            }
            #[doc = "External Count Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CNTSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OFS`"]
        pub enum OFSW {
            #[doc = "Override functionality disabled"]
            VALUE1,
            #[doc = "Status bit trigger override connected to Event 1; Status bit value override connected to Event 2"]
            VALUE2,
        }
        impl OFSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OFSW::VALUE1 => false,
                    OFSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OFSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OFSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Override functionality disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OFSW::VALUE1)
            }
            #[doc = "Status bit trigger override connected to Event 1; Status bit value override connected to Event 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OFSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TS`"]
        pub enum TSW {
            #[doc = "Trap function disabled"]
            VALUE1,
            #[doc = "TRAP function connected to Event 2"]
            VALUE2,
        }
        impl TSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSW::VALUE1 => false,
                    TSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSW::VALUE1)
            }
            #[doc = "TRAP function connected to Event 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MOSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MOSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TCE`"]
        pub enum TCEW {
            #[doc = "Timer concatenation is disabled"]
            VALUE1,
            #[doc = "Timer concatenation is enabled"]
            VALUE2,
        }
        impl TCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TCEW::VALUE1 => false,
                    TCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Timer concatenation is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TCEW::VALUE1)
            }
            #[doc = "Timer concatenation is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - External Start Functionality Selector"]
            #[inline]
            pub fn strts(&self) -> STRTSR {
                STRTSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - External Stop Functionality Selector"]
            #[inline]
            pub fn ends(&self) -> ENDSR {
                ENDSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - External Capture 0 Functionality Selector"]
            #[inline]
            pub fn cap0s(&self) -> CAP0SR {
                CAP0SR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - External Capture 1 Functionality Selector"]
            #[inline]
            pub fn cap1s(&self) -> CAP1SR {
                CAP1SR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - External Gate Functionality Selector"]
            #[inline]
            pub fn gates(&self) -> GATESR {
                GATESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - External Up/Down Functionality Selector"]
            #[inline]
            pub fn uds(&self) -> UDSR {
                UDSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - External Timer Load Functionality Selector"]
            #[inline]
            pub fn lds(&self) -> LDSR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LDSR { bits }
            }
            #[doc = "Bits 14:15 - External Count Selector"]
            #[inline]
            pub fn cnts(&self) -> CNTSR {
                CNTSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Override Function Selector"]
            #[inline]
            pub fn ofs(&self) -> OFSR {
                OFSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Trap Function Selector"]
            #[inline]
            pub fn ts(&self) -> TSR {
                TSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - External Modulation Functionality Selector"]
            #[inline]
            pub fn mos(&self) -> MOSR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOSR { bits }
            }
            #[doc = "Bit 20 - Timer Concatenation Enable"]
            #[inline]
            pub fn tce(&self) -> TCER {
                TCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - External Start Functionality Selector"]
            #[inline]
            pub fn strts(&mut self) -> _STRTSW {
                _STRTSW { w: self }
            }
            #[doc = "Bits 2:3 - External Stop Functionality Selector"]
            #[inline]
            pub fn ends(&mut self) -> _ENDSW {
                _ENDSW { w: self }
            }
            #[doc = "Bits 4:5 - External Capture 0 Functionality Selector"]
            #[inline]
            pub fn cap0s(&mut self) -> _CAP0SW {
                _CAP0SW { w: self }
            }
            #[doc = "Bits 6:7 - External Capture 1 Functionality Selector"]
            #[inline]
            pub fn cap1s(&mut self) -> _CAP1SW {
                _CAP1SW { w: self }
            }
            #[doc = "Bits 8:9 - External Gate Functionality Selector"]
            #[inline]
            pub fn gates(&mut self) -> _GATESW {
                _GATESW { w: self }
            }
            #[doc = "Bits 10:11 - External Up/Down Functionality Selector"]
            #[inline]
            pub fn uds(&mut self) -> _UDSW {
                _UDSW { w: self }
            }
            #[doc = "Bits 12:13 - External Timer Load Functionality Selector"]
            #[inline]
            pub fn lds(&mut self) -> _LDSW {
                _LDSW { w: self }
            }
            #[doc = "Bits 14:15 - External Count Selector"]
            #[inline]
            pub fn cnts(&mut self) -> _CNTSW {
                _CNTSW { w: self }
            }
            #[doc = "Bit 16 - Override Function Selector"]
            #[inline]
            pub fn ofs(&mut self) -> _OFSW {
                _OFSW { w: self }
            }
            #[doc = "Bit 17 - Trap Function Selector"]
            #[inline]
            pub fn ts(&mut self) -> _TSW {
                _TSW { w: self }
            }
            #[doc = "Bits 18:19 - External Modulation Functionality Selector"]
            #[inline]
            pub fn mos(&mut self) -> _MOSW {
                _MOSW { w: self }
            }
            #[doc = "Bit 20 - Timer Concatenation Enable"]
            #[inline]
            pub fn tce(&mut self) -> _TCEW {
                _TCEW { w: self }
            }
        }
    }
    #[doc = "Slice Timer Status"]
    pub struct TCST {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Status"]
    pub mod tcst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TCST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `TRB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRBR {
            #[doc = "Timer is stopped"]
            VALUE1,
            #[doc = "Timer is running"]
            VALUE2,
        }
        impl TRBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRBR::VALUE1 => false,
                    TRBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRBR {
                match value {
                    false => TRBR::VALUE1,
                    true => TRBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CDIR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CDIRR {
            #[doc = "Timer is counting up"]
            VALUE1,
            #[doc = "Timer is counting down"]
            VALUE2,
        }
        impl CDIRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CDIRR::VALUE1 => false,
                    CDIRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CDIRR {
                match value {
                    false => CDIRR::VALUE1,
                    true => CDIRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CDIRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CDIRR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Timer Run Bit"]
            #[inline]
            pub fn trb(&self) -> TRBR {
                TRBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Timer Counting Direction"]
            #[inline]
            pub fn cdir(&self) -> CDIRR {
                CDIRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Slice Timer Run Set"]
    pub struct TCSET {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Run Set"]
    pub mod tcset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TCSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRBSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRBSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Timer Run Bit set"]
            #[inline]
            pub fn trbs(&mut self) -> _TRBSW {
                _TRBSW { w: self }
            }
        }
    }
    #[doc = "Slice Timer Clear"]
    pub struct TCCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Clear"]
    pub mod tcclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TCCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRBCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRBCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TCCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TCCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DITCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DITCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Timer Run Bit Clear"]
            #[inline]
            pub fn trbc(&mut self) -> _TRBCW {
                _TRBCW { w: self }
            }
            #[doc = "Bit 1 - Timer Clear"]
            #[inline]
            pub fn tcc(&mut self) -> _TCCW {
                _TCCW { w: self }
            }
            #[doc = "Bit 2 - Dither Counter Clear"]
            #[inline]
            pub fn ditc(&mut self) -> _DITCW {
                _DITCW { w: self }
            }
        }
    }
    #[doc = "Slice Timer Control"]
    pub struct TC {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Control"]
    pub mod tc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `TCM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TCMR {
            #[doc = "Edge aligned mode"]
            VALUE1,
            #[doc = "Center aligned mode"]
            VALUE2,
        }
        impl TCMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TCMR::VALUE1 => false,
                    TCMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TCMR {
                match value {
                    false => TCMR::VALUE1,
                    true => TCMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TCMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TCMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSSM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSSMR {
            #[doc = "Single shot mode is disabled"]
            VALUE1,
            #[doc = "Single shot mode is enabled"]
            VALUE2,
        }
        impl TSSMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSSMR::VALUE1 => false,
                    TSSMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSSMR {
                match value {
                    false => TSSMR::VALUE1,
                    true => TSSMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSSMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSSMR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CLSTR {
            bits: bool,
        }
        impl CLSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `CMOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMODR {
            #[doc = "Compare Mode"]
            VALUE1,
            #[doc = "Capture Mode"]
            VALUE2,
        }
        impl CMODR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMODR::VALUE1 => false,
                    CMODR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMODR {
                match value {
                    false => CMODR::VALUE1,
                    true => CMODR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMODR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ECM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ECMR {
            #[doc = "Normal Capture Mode. Clear of the Full Flag of each capture register is done by accessing the registers individually only."]
            VALUE1,
            #[doc = "Extended Capture Mode. Clear of the Full Flag of each capture register is done not only by accessing the individual registers but also by accessing the ECRD register. When reading the ECRD register, only the capture register register full flag pointed by the ECRD.VPTR is cleared."]
            VALUE2,
        }
        impl ECMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ECMR::VALUE1 => false,
                    ECMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ECMR {
                match value {
                    false => ECMR::VALUE1,
                    true => ECMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ECMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ECMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CAPC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CAPCR {
            #[doc = "Timer is never cleared on a capture event"]
            VALUE1,
            #[doc = "Timer is cleared on a capture event into capture registers 2 and 3. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE2,
            #[doc = "Timer is cleared on a capture event into capture registers 0 and 1. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE3,
            #[doc = "Timer is always cleared in a capture event."]
            VALUE4,
        }
        impl CAPCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CAPCR::VALUE1 => 0,
                    CAPCR::VALUE2 => 0x01,
                    CAPCR::VALUE3 => 0x02,
                    CAPCR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CAPCR {
                match value {
                    0 => CAPCR::VALUE1,
                    1 => CAPCR::VALUE2,
                    2 => CAPCR::VALUE3,
                    3 => CAPCR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CAPCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CAPCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CAPCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CAPCR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ENDM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDMR {
            #[doc = "Clears the timer run bit only (default stop)"]
            VALUE1,
            #[doc = "Clears the timer only (flush)"]
            VALUE2,
            #[doc = "Clears the timer and run bit (flush/stop)"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ENDMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENDMR::VALUE1 => 0,
                    ENDMR::VALUE2 => 0x01,
                    ENDMR::VALUE3 => 0x02,
                    ENDMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENDMR {
                match value {
                    0 => ENDMR::VALUE1,
                    1 => ENDMR::VALUE2,
                    2 => ENDMR::VALUE3,
                    i => ENDMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENDMR::VALUE3
            }
        }
        #[doc = "Possible values of the field `STRM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STRMR {
            #[doc = "Sets run bit only (default start)"]
            VALUE1,
            #[doc = "Clears the timer and sets run bit (flush/start)"]
            VALUE2,
        }
        impl STRMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STRMR::VALUE1 => false,
                    STRMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STRMR {
                match value {
                    false => STRMR::VALUE1,
                    true => STRMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STRMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STRMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCER {
            #[doc = "Capture into CC4yC0VThis register contains the values associated with the Capture 0 field./CC4yC1VThis register contains the values associated with the Capture 1 field. registers control by CCycapt0 and capture into CC4yC3VThis register contains the values associated with the Capture 3 field./CC4yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE1,
            #[doc = "Capture into CC4yC0VThis register contains the values associated with the Capture 0 field./CC4yC1VThis register contains the values associated with the Capture 1 field. and CC4yC3VThis register contains the values associated with the Capture 3 field./CC4yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE2,
        }
        impl SCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCER::VALUE1 => false,
                    SCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCER {
                match value {
                    false => SCER::VALUE1,
                    true => SCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCSR {
            #[doc = "The capture into a specific capture register is done with the rules linked with the full flags, described at ."]
            VALUE1,
            #[doc = "The capture into the capture registers is always done regardless of the full flag status (even if the register has not been read back)."]
            VALUE2,
        }
        impl CCSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCSR::VALUE1 => false,
                    CCSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCSR {
                match value {
                    false => CCSR::VALUE1,
                    true => CCSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DITHE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DITHER {
            #[doc = "Dither is disabled"]
            VALUE1,
            #[doc = "Dither is applied to the Period"]
            VALUE2,
            #[doc = "Dither is applied to the Compare"]
            VALUE3,
            #[doc = "Dither is applied to the Period and Compare"]
            VALUE4,
        }
        impl DITHER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DITHER::VALUE1 => 0,
                    DITHER::VALUE2 => 0x01,
                    DITHER::VALUE3 => 0x02,
                    DITHER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DITHER {
                match value {
                    0 => DITHER::VALUE1,
                    1 => DITHER::VALUE2,
                    2 => DITHER::VALUE3,
                    3 => DITHER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DITHER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DITHER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DITHER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DITHER::VALUE4
            }
        }
        #[doc = "Possible values of the field `DIM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIMR {
            #[doc = "Slice is using its own dither unit"]
            VALUE1,
            #[doc = "Slice is connected to the dither unit of slice 0."]
            VALUE2,
        }
        impl DIMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIMR::VALUE1 => false,
                    DIMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIMR {
                match value {
                    false => DIMR::VALUE1,
                    true => DIMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FPE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FPER {
            #[doc = "Floating prescaler mode is disabled"]
            VALUE1,
            #[doc = "Floating prescaler mode is enabled"]
            VALUE2,
        }
        impl FPER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FPER::VALUE1 => false,
                    FPER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FPER {
                match value {
                    false => FPER::VALUE1,
                    true => FPER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FPER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRAPE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRAPER {
            #[doc = "TRAP functionality has no effect on the output"]
            VALUE1,
            #[doc = "TRAP functionality affects the output"]
            VALUE2,
        }
        impl TRAPER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRAPER::VALUE1 => false,
                    TRAPER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRAPER {
                match value {
                    false => TRAPER::VALUE1,
                    true => TRAPER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRAPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRAPER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRPSE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRPSER {
            #[doc = "Exiting from TRAP state isn't synchronized with the PWM signal"]
            VALUE1,
            #[doc = "Exiting from TRAP state is synchronized with the PWM signal"]
            VALUE2,
        }
        impl TRPSER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRPSER::VALUE1 => false,
                    TRPSER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRPSER {
                match value {
                    false => TRPSER::VALUE1,
                    true => TRPSER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRPSER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRPSER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRPSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRPSWR {
            #[doc = "The slice exits the TRAP state automatically when the TRAP condition is not present"]
            VALUE1,
            #[doc = "The TRAP state can only be exited by a SW request."]
            VALUE2,
        }
        impl TRPSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRPSWR::VALUE1 => false,
                    TRPSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRPSWR {
                match value {
                    false => TRPSWR::VALUE1,
                    true => TRPSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRPSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRPSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMSR {
            #[doc = "External Modulation functionality is not synchronized with the PWM signal"]
            VALUE1,
            #[doc = "External Modulation functionality is synchronized with the PWM signal"]
            VALUE2,
        }
        impl EMSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMSR::VALUE1 => false,
                    EMSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMSR {
                match value {
                    false => EMSR::VALUE1,
                    true => EMSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMTR {
            #[doc = "External Modulation functionality is clearing the CC4yST bit."]
            VALUE1,
            #[doc = "External Modulation functionality is gating the outputs."]
            VALUE2,
        }
        impl EMTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMTR::VALUE1 => false,
                    EMTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMTR {
                match value {
                    false => EMTR::VALUE1,
                    true => EMTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCMER {
            #[doc = "Multi Channel Mode is disabled"]
            VALUE1,
            #[doc = "Multi Channel Mode is enabled"]
            VALUE2,
        }
        impl MCMER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCMER::VALUE1 => false,
                    MCMER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCMER {
                match value {
                    false => MCMER::VALUE1,
                    true => MCMER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCMER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `TCM`"]
        pub enum TCMW {
            #[doc = "Edge aligned mode"]
            VALUE1,
            #[doc = "Center aligned mode"]
            VALUE2,
        }
        impl TCMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TCMW::VALUE1 => false,
                    TCMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TCMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TCMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TCMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Edge aligned mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TCMW::VALUE1)
            }
            #[doc = "Center aligned mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TCMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSSM`"]
        pub enum TSSMW {
            #[doc = "Single shot mode is disabled"]
            VALUE1,
            #[doc = "Single shot mode is enabled"]
            VALUE2,
        }
        impl TSSMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSSMW::VALUE1 => false,
                    TSSMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSSMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSSMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Single shot mode is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSSMW::VALUE1)
            }
            #[doc = "Single shot mode is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSSMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ECM`"]
        pub enum ECMW {
            #[doc = "Normal Capture Mode. Clear of the Full Flag of each capture register is done by accessing the registers individually only."]
            VALUE1,
            #[doc = "Extended Capture Mode. Clear of the Full Flag of each capture register is done not only by accessing the individual registers but also by accessing the ECRD register. When reading the ECRD register, only the capture register register full flag pointed by the ECRD.VPTR is cleared."]
            VALUE2,
        }
        impl ECMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ECMW::VALUE1 => false,
                    ECMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ECMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ECMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ECMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal Capture Mode. Clear of the Full Flag of each capture register is done by accessing the registers individually only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ECMW::VALUE1)
            }
            #[doc = "Extended Capture Mode. Clear of the Full Flag of each capture register is done not only by accessing the individual registers but also by accessing the ECRD register. When reading the ECRD register, only the capture register register full flag pointed by the ECRD.VPTR is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ECMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAPC`"]
        pub enum CAPCW {
            #[doc = "Timer is never cleared on a capture event"]
            VALUE1,
            #[doc = "Timer is cleared on a capture event into capture registers 2 and 3. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE2,
            #[doc = "Timer is cleared on a capture event into capture registers 0 and 1. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE3,
            #[doc = "Timer is always cleared in a capture event."]
            VALUE4,
        }
        impl CAPCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CAPCW::VALUE1 => 0,
                    CAPCW::VALUE2 => 1,
                    CAPCW::VALUE3 => 2,
                    CAPCW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAPCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAPCW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Timer is never cleared on a capture event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAPCW::VALUE1)
            }
            #[doc = "Timer is cleared on a capture event into capture registers 2 and 3. (When SCE = 1#, Timer is always cleared in a capture event)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAPCW::VALUE2)
            }
            #[doc = "Timer is cleared on a capture event into capture registers 0 and 1. (When SCE = 1#, Timer is always cleared in a capture event)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CAPCW::VALUE3)
            }
            #[doc = "Timer is always cleared in a capture event."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CAPCW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENDM`"]
        pub enum ENDMW {
            #[doc = "Clears the timer run bit only (default stop)"]
            VALUE1,
            #[doc = "Clears the timer only (flush)"]
            VALUE2,
            #[doc = "Clears the timer and run bit (flush/stop)"]
            VALUE3,
        }
        impl ENDMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENDMW::VALUE1 => 0,
                    ENDMW::VALUE2 => 1,
                    ENDMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENDMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENDMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENDMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Clears the timer run bit only (default stop)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENDMW::VALUE1)
            }
            #[doc = "Clears the timer only (flush)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENDMW::VALUE2)
            }
            #[doc = "Clears the timer and run bit (flush/stop)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENDMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STRM`"]
        pub enum STRMW {
            #[doc = "Sets run bit only (default start)"]
            VALUE1,
            #[doc = "Clears the timer and sets run bit (flush/start)"]
            VALUE2,
        }
        impl STRMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STRMW::VALUE1 => false,
                    STRMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STRMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Sets run bit only (default start)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STRMW::VALUE1)
            }
            #[doc = "Clears the timer and sets run bit (flush/start)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STRMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCE`"]
        pub enum SCEW {
            #[doc = "Capture into CC4yC0VThis register contains the values associated with the Capture 0 field./CC4yC1VThis register contains the values associated with the Capture 1 field. registers control by CCycapt0 and capture into CC4yC3VThis register contains the values associated with the Capture 3 field./CC4yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE1,
            #[doc = "Capture into CC4yC0VThis register contains the values associated with the Capture 0 field./CC4yC1VThis register contains the values associated with the Capture 1 field. and CC4yC3VThis register contains the values associated with the Capture 3 field./CC4yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE2,
        }
        impl SCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCEW::VALUE1 => false,
                    SCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Capture into CC4yC0VThis register contains the values associated with the Capture 0 field./CC4yC1VThis register contains the values associated with the Capture 1 field. registers control by CCycapt0 and capture into CC4yC3VThis register contains the values associated with the Capture 3 field./CC4yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCEW::VALUE1)
            }
            #[doc = "Capture into CC4yC0VThis register contains the values associated with the Capture 0 field./CC4yC1VThis register contains the values associated with the Capture 1 field. and CC4yC3VThis register contains the values associated with the Capture 3 field./CC4yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCS`"]
        pub enum CCSW {
            #[doc = "The capture into a specific capture register is done with the rules linked with the full flags, described at ."]
            VALUE1,
            #[doc = "The capture into the capture registers is always done regardless of the full flag status (even if the register has not been read back)."]
            VALUE2,
        }
        impl CCSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCSW::VALUE1 => false,
                    CCSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The capture into a specific capture register is done with the rules linked with the full flags, described at ."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCSW::VALUE1)
            }
            #[doc = "The capture into the capture registers is always done regardless of the full flag status (even if the register has not been read back)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DITHE`"]
        pub enum DITHEW {
            #[doc = "Dither is disabled"]
            VALUE1,
            #[doc = "Dither is applied to the Period"]
            VALUE2,
            #[doc = "Dither is applied to the Compare"]
            VALUE3,
            #[doc = "Dither is applied to the Period and Compare"]
            VALUE4,
        }
        impl DITHEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DITHEW::VALUE1 => 0,
                    DITHEW::VALUE2 => 1,
                    DITHEW::VALUE3 => 2,
                    DITHEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DITHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DITHEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DITHEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Dither is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DITHEW::VALUE1)
            }
            #[doc = "Dither is applied to the Period"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DITHEW::VALUE2)
            }
            #[doc = "Dither is applied to the Compare"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DITHEW::VALUE3)
            }
            #[doc = "Dither is applied to the Period and Compare"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DITHEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIM`"]
        pub enum DIMW {
            #[doc = "Slice is using its own dither unit"]
            VALUE1,
            #[doc = "Slice is connected to the dither unit of slice 0."]
            VALUE2,
        }
        impl DIMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIMW::VALUE1 => false,
                    DIMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Slice is using its own dither unit"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIMW::VALUE1)
            }
            #[doc = "Slice is connected to the dither unit of slice 0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FPE`"]
        pub enum FPEW {
            #[doc = "Floating prescaler mode is disabled"]
            VALUE1,
            #[doc = "Floating prescaler mode is enabled"]
            VALUE2,
        }
        impl FPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FPEW::VALUE1 => false,
                    FPEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FPEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Floating prescaler mode is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FPEW::VALUE1)
            }
            #[doc = "Floating prescaler mode is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FPEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRAPE`"]
        pub enum TRAPEW {
            #[doc = "TRAP functionality has no effect on the output"]
            VALUE1,
            #[doc = "TRAP functionality affects the output"]
            VALUE2,
        }
        impl TRAPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRAPEW::VALUE1 => false,
                    TRAPEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRAPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRAPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRAPEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TRAP functionality has no effect on the output"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRAPEW::VALUE1)
            }
            #[doc = "TRAP functionality affects the output"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRAPEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRPSE`"]
        pub enum TRPSEW {
            #[doc = "Exiting from TRAP state isn't synchronized with the PWM signal"]
            VALUE1,
            #[doc = "Exiting from TRAP state is synchronized with the PWM signal"]
            VALUE2,
        }
        impl TRPSEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRPSEW::VALUE1 => false,
                    TRPSEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRPSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRPSEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRPSEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Exiting from TRAP state isn't synchronized with the PWM signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRPSEW::VALUE1)
            }
            #[doc = "Exiting from TRAP state is synchronized with the PWM signal"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRPSEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRPSW`"]
        pub enum TRPSWW {
            #[doc = "The slice exits the TRAP state automatically when the TRAP condition is not present"]
            VALUE1,
            #[doc = "The TRAP state can only be exited by a SW request."]
            VALUE2,
        }
        impl TRPSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRPSWW::VALUE1 => false,
                    TRPSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRPSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRPSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRPSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The slice exits the TRAP state automatically when the TRAP condition is not present"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRPSWW::VALUE1)
            }
            #[doc = "The TRAP state can only be exited by a SW request."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRPSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMS`"]
        pub enum EMSW {
            #[doc = "External Modulation functionality is not synchronized with the PWM signal"]
            VALUE1,
            #[doc = "External Modulation functionality is synchronized with the PWM signal"]
            VALUE2,
        }
        impl EMSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMSW::VALUE1 => false,
                    EMSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External Modulation functionality is not synchronized with the PWM signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMSW::VALUE1)
            }
            #[doc = "External Modulation functionality is synchronized with the PWM signal"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMT`"]
        pub enum EMTW {
            #[doc = "External Modulation functionality is clearing the CC4yST bit."]
            VALUE1,
            #[doc = "External Modulation functionality is gating the outputs."]
            VALUE2,
        }
        impl EMTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMTW::VALUE1 => false,
                    EMTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External Modulation functionality is clearing the CC4yST bit."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMTW::VALUE1)
            }
            #[doc = "External Modulation functionality is gating the outputs."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCME`"]
        pub enum MCMEW {
            #[doc = "Multi Channel Mode is disabled"]
            VALUE1,
            #[doc = "Multi Channel Mode is enabled"]
            VALUE2,
        }
        impl MCMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCMEW::VALUE1 => false,
                    MCMEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCMEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Multi Channel Mode is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCMEW::VALUE1)
            }
            #[doc = "Multi Channel Mode is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCMEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Timer Counting Mode"]
            #[inline]
            pub fn tcm(&self) -> TCMR {
                TCMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Timer Single Shot Mode"]
            #[inline]
            pub fn tssm(&self) -> TSSMR {
                TSSMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Shadow Transfer on Clear"]
            #[inline]
            pub fn clst(&self) -> CLSTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CLSTR { bits }
            }
            #[doc = "Bit 3 - Capture Compare Mode"]
            #[inline]
            pub fn cmod(&self) -> CMODR {
                CMODR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Extended Capture Mode"]
            #[inline]
            pub fn ecm(&self) -> ECMR {
                ECMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 5:6 - Clear on Capture Control"]
            #[inline]
            pub fn capc(&self) -> CAPCR {
                CAPCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Extended Stop Function Control"]
            #[inline]
            pub fn endm(&self) -> ENDMR {
                ENDMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Extended Start Function Control"]
            #[inline]
            pub fn strm(&self) -> STRMR {
                STRMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Equal Capture Event enable"]
            #[inline]
            pub fn sce(&self) -> SCER {
                SCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Continuous Capture Enable"]
            #[inline]
            pub fn ccs(&self) -> CCSR {
                CCSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 13:14 - Dither Enable"]
            #[inline]
            pub fn dithe(&self) -> DITHER {
                DITHER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Dither input selector"]
            #[inline]
            pub fn dim(&self) -> DIMR {
                DIMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Floating Prescaler enable"]
            #[inline]
            pub fn fpe(&self) -> FPER {
                FPER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - TRAP enable"]
            #[inline]
            pub fn trape(&self) -> TRAPER {
                TRAPER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - TRAP Synchronization Enable"]
            #[inline]
            pub fn trpse(&self) -> TRPSER {
                TRPSER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 22 - TRAP State Clear Control"]
            #[inline]
            pub fn trpsw(&self) -> TRPSWR {
                TRPSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - External Modulation Synchronization"]
            #[inline]
            pub fn ems(&self) -> EMSR {
                EMSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - External Modulation Type"]
            #[inline]
            pub fn emt(&self) -> EMTR {
                EMTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Multi Channel Mode Enable"]
            #[inline]
            pub fn mcme(&self) -> MCMER {
                MCMER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Timer Counting Mode"]
            #[inline]
            pub fn tcm(&mut self) -> _TCMW {
                _TCMW { w: self }
            }
            #[doc = "Bit 1 - Timer Single Shot Mode"]
            #[inline]
            pub fn tssm(&mut self) -> _TSSMW {
                _TSSMW { w: self }
            }
            #[doc = "Bit 2 - Shadow Transfer on Clear"]
            #[inline]
            pub fn clst(&mut self) -> _CLSTW {
                _CLSTW { w: self }
            }
            #[doc = "Bit 4 - Extended Capture Mode"]
            #[inline]
            pub fn ecm(&mut self) -> _ECMW {
                _ECMW { w: self }
            }
            #[doc = "Bits 5:6 - Clear on Capture Control"]
            #[inline]
            pub fn capc(&mut self) -> _CAPCW {
                _CAPCW { w: self }
            }
            #[doc = "Bits 8:9 - Extended Stop Function Control"]
            #[inline]
            pub fn endm(&mut self) -> _ENDMW {
                _ENDMW { w: self }
            }
            #[doc = "Bit 10 - Extended Start Function Control"]
            #[inline]
            pub fn strm(&mut self) -> _STRMW {
                _STRMW { w: self }
            }
            #[doc = "Bit 11 - Equal Capture Event enable"]
            #[inline]
            pub fn sce(&mut self) -> _SCEW {
                _SCEW { w: self }
            }
            #[doc = "Bit 12 - Continuous Capture Enable"]
            #[inline]
            pub fn ccs(&mut self) -> _CCSW {
                _CCSW { w: self }
            }
            #[doc = "Bits 13:14 - Dither Enable"]
            #[inline]
            pub fn dithe(&mut self) -> _DITHEW {
                _DITHEW { w: self }
            }
            #[doc = "Bit 15 - Dither input selector"]
            #[inline]
            pub fn dim(&mut self) -> _DIMW {
                _DIMW { w: self }
            }
            #[doc = "Bit 16 - Floating Prescaler enable"]
            #[inline]
            pub fn fpe(&mut self) -> _FPEW {
                _FPEW { w: self }
            }
            #[doc = "Bit 17 - TRAP enable"]
            #[inline]
            pub fn trape(&mut self) -> _TRAPEW {
                _TRAPEW { w: self }
            }
            #[doc = "Bit 21 - TRAP Synchronization Enable"]
            #[inline]
            pub fn trpse(&mut self) -> _TRPSEW {
                _TRPSEW { w: self }
            }
            #[doc = "Bit 22 - TRAP State Clear Control"]
            #[inline]
            pub fn trpsw(&mut self) -> _TRPSWW {
                _TRPSWW { w: self }
            }
            #[doc = "Bit 23 - External Modulation Synchronization"]
            #[inline]
            pub fn ems(&mut self) -> _EMSW {
                _EMSW { w: self }
            }
            #[doc = "Bit 24 - External Modulation Type"]
            #[inline]
            pub fn emt(&mut self) -> _EMTW {
                _EMTW { w: self }
            }
            #[doc = "Bit 25 - Multi Channel Mode Enable"]
            #[inline]
            pub fn mcme(&mut self) -> _MCMEW {
                _MCMEW { w: self }
            }
        }
    }
    #[doc = "Passive Level Config"]
    pub struct PSL {
        register: VolatileCell<u32>,
    }
    #[doc = "Passive Level Config"]
    pub mod psl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PSL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSLR {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSLR::VALUE1 => false,
                    PSLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSLR {
                match value {
                    false => PSLR::VALUE1,
                    true => PSLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSLR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PSL`"]
        pub enum PSLW {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSLW::VALUE1 => false,
                    PSLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Passive Level is LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSLW::VALUE1)
            }
            #[doc = "Passive Level is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Output Passive Level"]
            #[inline]
            pub fn psl(&self) -> PSLR {
                PSLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Output Passive Level"]
            #[inline]
            pub fn psl(&mut self) -> _PSLW {
                _PSLW { w: self }
            }
        }
    }
    #[doc = "Dither Config"]
    pub struct DIT {
        register: VolatileCell<u32>,
    }
    #[doc = "Dither Config"]
    pub mod dit {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DIT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCVR {
            bits: u8,
        }
        impl DCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCNTR {
            bits: u8,
        }
        impl DCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Dither compare Value"]
            #[inline]
            pub fn dcv(&self) -> DCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCVR { bits }
            }
            #[doc = "Bits 8:11 - Dither counter actual value"]
            #[inline]
            pub fn dcnt(&self) -> DCNTR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCNTR { bits }
            }
        }
    }
    #[doc = "Dither Shadow Register"]
    pub struct DITS {
        register: VolatileCell<u32>,
    }
    #[doc = "Dither Shadow Register"]
    pub mod dits {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DITS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCVSR {
            bits: u8,
        }
        impl DCVSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCVSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCVSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Dither Shadow Compare Value"]
            #[inline]
            pub fn dcvs(&self) -> DCVSR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCVSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Dither Shadow Compare Value"]
            #[inline]
            pub fn dcvs(&mut self) -> _DCVSW {
                _DCVSW { w: self }
            }
        }
    }
    #[doc = "Prescaler Control"]
    pub struct PSC {
        register: VolatileCell<u32>,
    }
    #[doc = "Prescaler Control"]
    pub mod psc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PSIVR {
            bits: u8,
        }
        impl PSIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Prescaler Initial Value"]
            #[inline]
            pub fn psiv(&self) -> PSIVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PSIVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Prescaler Initial Value"]
            #[inline]
            pub fn psiv(&mut self) -> _PSIVW {
                _PSIVW { w: self }
            }
        }
    }
    #[doc = "Floating Prescaler Control"]
    pub struct FPC {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating Prescaler Control"]
    pub mod fpc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCMPR {
            bits: u8,
        }
        impl PCMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PVALR {
            bits: u8,
        }
        impl PVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Floating Prescaler Compare Value"]
            #[inline]
            pub fn pcmp(&self) -> PCMPR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCMPR { bits }
            }
            #[doc = "Bits 8:11 - Actual Prescaler Value"]
            #[inline]
            pub fn pval(&self) -> PVALR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 8:11 - Actual Prescaler Value"]
            #[inline]
            pub fn pval(&mut self) -> _PVALW {
                _PVALW { w: self }
            }
        }
    }
    #[doc = "Floating Prescaler Shadow"]
    pub struct FPCS {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating Prescaler Shadow"]
    pub mod fpcs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPCS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCMPR {
            bits: u8,
        }
        impl PCMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCMPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Floating Prescaler Shadow Compare Value"]
            #[inline]
            pub fn pcmp(&self) -> PCMPR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCMPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Floating Prescaler Shadow Compare Value"]
            #[inline]
            pub fn pcmp(&mut self) -> _PCMPW {
                _PCMPW { w: self }
            }
        }
    }
    #[doc = "Timer Period Value"]
    pub struct PR {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Period Value"]
    pub mod pr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRR {
            bits: u16,
        }
        impl PRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Period Register"]
            #[inline]
            pub fn pr(&self) -> PRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PRR { bits }
            }
        }
    }
    #[doc = "Timer Shadow Period Value"]
    pub struct PRS {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Shadow Period Value"]
    pub mod prs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRSR {
            bits: u16,
        }
        impl PRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Period Register"]
            #[inline]
            pub fn prs(&self) -> PRSR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PRSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Period Register"]
            #[inline]
            pub fn prs(&mut self) -> _PRSW {
                _PRSW { w: self }
            }
        }
    }
    #[doc = "Timer Compare Value"]
    pub struct CR {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Compare Value"]
    pub mod cr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CRR {
            bits: u16,
        }
        impl CRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Compare Register"]
            #[inline]
            pub fn cr(&self) -> CRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CRR { bits }
            }
        }
    }
    #[doc = "Timer Shadow Compare Value"]
    pub struct CRS {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Shadow Compare Value"]
    pub mod crs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CRS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CRSR {
            bits: u16,
        }
        impl CRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Compare Register"]
            #[inline]
            pub fn crs(&self) -> CRSR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CRSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Compare Register"]
            #[inline]
            pub fn crs(&mut self) -> _CRSW {
                _CRSW { w: self }
            }
        }
    }
    #[doc = "Timer Value"]
    pub struct TIMER {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Value"]
    pub mod timer {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TIMER {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TVALR {
            bits: u16,
        }
        impl TVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _TVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Timer Value"]
            #[inline]
            pub fn tval(&self) -> TVALR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Timer Value"]
            #[inline]
            pub fn tval(&mut self) -> _TVALW {
                _TVALW { w: self }
            }
        }
    }
    #[doc = "Capture Register 0"]
    pub struct C0V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 0"]
    pub mod c0v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C0V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Capture Register 1"]
    pub struct C1V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 1"]
    pub mod c1v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C1V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Capture Register 2"]
    pub struct C2V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 2"]
    pub mod c2v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C2V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Capture Register 3"]
    pub struct C3V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 3"]
    pub mod c3v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C3V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Interrupt Status"]
    pub struct INTS {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Status"]
    pub mod ints {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::INTS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PMUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PMUSR {
            #[doc = "Period match while counting up not detected"]
            VALUE1,
            #[doc = "Period match while counting up detected"]
            VALUE2,
        }
        impl PMUSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PMUSR::VALUE1 => false,
                    PMUSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PMUSR {
                match value {
                    false => PMUSR::VALUE1,
                    true => PMUSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PMUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PMUSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OMDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OMDSR {
            #[doc = "One match while counting down not detected"]
            VALUE1,
            #[doc = "One match while counting down detected"]
            VALUE2,
        }
        impl OMDSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OMDSR::VALUE1 => false,
                    OMDSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OMDSR {
                match value {
                    false => OMDSR::VALUE1,
                    true => OMDSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OMDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OMDSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMUSR {
            #[doc = "Compare match while counting up not detected"]
            VALUE1,
            #[doc = "Compare match while counting up detected"]
            VALUE2,
        }
        impl CMUSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMUSR::VALUE1 => false,
                    CMUSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMUSR {
                match value {
                    false => CMUSR::VALUE1,
                    true => CMUSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMUSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMDSR {
            #[doc = "Compare match while counting down not detected"]
            VALUE1,
            #[doc = "Compare match while counting down detected"]
            VALUE2,
        }
        impl CMDSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMDSR::VALUE1 => false,
                    CMDSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMDSR {
                match value {
                    false => CMDSR::VALUE1,
                    true => CMDSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMDSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `E0AS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E0ASR {
            #[doc = "Event 0 not detected"]
            VALUE1,
            #[doc = "Event 0 detected"]
            VALUE2,
        }
        impl E0ASR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E0ASR::VALUE1 => false,
                    E0ASR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E0ASR {
                match value {
                    false => E0ASR::VALUE1,
                    true => E0ASR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E0ASR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E0ASR::VALUE2
            }
        }
        #[doc = "Possible values of the field `E1AS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E1ASR {
            #[doc = "Event 1 not detected"]
            VALUE1,
            #[doc = "Event 1 detected"]
            VALUE2,
        }
        impl E1ASR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E1ASR::VALUE1 => false,
                    E1ASR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E1ASR {
                match value {
                    false => E1ASR::VALUE1,
                    true => E1ASR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E1ASR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E1ASR::VALUE2
            }
        }
        #[doc = "Possible values of the field `E2AS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E2ASR {
            #[doc = "Event 2 not detected"]
            VALUE1,
            #[doc = "Event 2 detected"]
            VALUE2,
        }
        impl E2ASR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E2ASR::VALUE1 => false,
                    E2ASR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E2ASR {
                match value {
                    false => E2ASR::VALUE1,
                    true => E2ASR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E2ASR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E2ASR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRPFR {
            bits: bool,
        }
        impl TRPFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Period Match while Counting Up"]
            #[inline]
            pub fn pmus(&self) -> PMUSR {
                PMUSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - One Match while Counting Down"]
            #[inline]
            pub fn omds(&self) -> OMDSR {
                OMDSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Compare Match while Counting Up"]
            #[inline]
            pub fn cmus(&self) -> CMUSR {
                CMUSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Compare Match while Counting Down"]
            #[inline]
            pub fn cmds(&self) -> CMDSR {
                CMDSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Event 0 Detection Status"]
            #[inline]
            pub fn e0as(&self) -> E0ASR {
                E0ASR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Event 1 Detection Status"]
            #[inline]
            pub fn e1as(&self) -> E1ASR {
                E1ASR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Event 2 Detection Status"]
            #[inline]
            pub fn e2as(&self) -> E2ASR {
                E2ASR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Trap Flag Status"]
            #[inline]
            pub fn trpf(&self) -> TRPFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TRPFR { bits }
            }
        }
    }
    #[doc = "Interrupt Enable Control"]
    pub struct INTE {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Enable Control"]
    pub mod inte {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::INTE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PMER {
            #[doc = "Period Match interrupt is disabled"]
            VALUE1,
            #[doc = "Period Match interrupt is enabled"]
            VALUE2,
        }
        impl PMER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PMER::VALUE1 => false,
                    PMER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PMER {
                match value {
                    false => PMER::VALUE1,
                    true => PMER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PMER::VALUE2
            }
        }
        #[doc = "Possible values of the field `OME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OMER {
            #[doc = "One Match interrupt is disabled"]
            VALUE1,
            #[doc = "One Match interrupt is enabled"]
            VALUE2,
        }
        impl OMER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OMER::VALUE1 => false,
                    OMER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OMER {
                match value {
                    false => OMER::VALUE1,
                    true => OMER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OMER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMUE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMUER {
            #[doc = "Compare Match while counting up interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting up interrupt is enabled"]
            VALUE2,
        }
        impl CMUER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMUER::VALUE1 => false,
                    CMUER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMUER {
                match value {
                    false => CMUER::VALUE1,
                    true => CMUER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMUER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMUER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMDE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMDER {
            #[doc = "Compare Match while counting down interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting down interrupt is enabled"]
            VALUE2,
        }
        impl CMDER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMDER::VALUE1 => false,
                    CMDER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMDER {
                match value {
                    false => CMDER::VALUE1,
                    true => CMDER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMDER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMDER::VALUE2
            }
        }
        #[doc = "Possible values of the field `E0AE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E0AER {
            #[doc = "Event 0 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 0 detection interrupt is enabled"]
            VALUE2,
        }
        impl E0AER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E0AER::VALUE1 => false,
                    E0AER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E0AER {
                match value {
                    false => E0AER::VALUE1,
                    true => E0AER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E0AER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E0AER::VALUE2
            }
        }
        #[doc = "Possible values of the field `E1AE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E1AER {
            #[doc = "Event 1 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 1 detection interrupt is enabled"]
            VALUE2,
        }
        impl E1AER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E1AER::VALUE1 => false,
                    E1AER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E1AER {
                match value {
                    false => E1AER::VALUE1,
                    true => E1AER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E1AER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E1AER::VALUE2
            }
        }
        #[doc = "Possible values of the field `E2AE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E2AER {
            #[doc = "Event 2 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 2 detection interrupt is enabled"]
            VALUE2,
        }
        impl E2AER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E2AER::VALUE1 => false,
                    E2AER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E2AER {
                match value {
                    false => E2AER::VALUE1,
                    true => E2AER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E2AER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E2AER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PME`"]
        pub enum PMEW {
            #[doc = "Period Match interrupt is disabled"]
            VALUE1,
            #[doc = "Period Match interrupt is enabled"]
            VALUE2,
        }
        impl PMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PMEW::VALUE1 => false,
                    PMEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PMEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Period Match interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PMEW::VALUE1)
            }
            #[doc = "Period Match interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PMEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OME`"]
        pub enum OMEW {
            #[doc = "One Match interrupt is disabled"]
            VALUE1,
            #[doc = "One Match interrupt is enabled"]
            VALUE2,
        }
        impl OMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OMEW::VALUE1 => false,
                    OMEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OMEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "One Match interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OMEW::VALUE1)
            }
            #[doc = "One Match interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OMEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMUE`"]
        pub enum CMUEW {
            #[doc = "Compare Match while counting up interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting up interrupt is enabled"]
            VALUE2,
        }
        impl CMUEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMUEW::VALUE1 => false,
                    CMUEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMUEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMUEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMUEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Compare Match while counting up interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMUEW::VALUE1)
            }
            #[doc = "Compare Match while counting up interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMUEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMDE`"]
        pub enum CMDEW {
            #[doc = "Compare Match while counting down interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting down interrupt is enabled"]
            VALUE2,
        }
        impl CMDEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMDEW::VALUE1 => false,
                    CMDEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMDEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMDEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMDEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Compare Match while counting down interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMDEW::VALUE1)
            }
            #[doc = "Compare Match while counting down interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMDEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E0AE`"]
        pub enum E0AEW {
            #[doc = "Event 0 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 0 detection interrupt is enabled"]
            VALUE2,
        }
        impl E0AEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    E0AEW::VALUE1 => false,
                    E0AEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E0AEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E0AEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E0AEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Event 0 detection interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E0AEW::VALUE1)
            }
            #[doc = "Event 0 detection interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E0AEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E1AE`"]
        pub enum E1AEW {
            #[doc = "Event 1 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 1 detection interrupt is enabled"]
            VALUE2,
        }
        impl E1AEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    E1AEW::VALUE1 => false,
                    E1AEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E1AEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E1AEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E1AEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Event 1 detection interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E1AEW::VALUE1)
            }
            #[doc = "Event 1 detection interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E1AEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E2AE`"]
        pub enum E2AEW {
            #[doc = "Event 2 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 2 detection interrupt is enabled"]
            VALUE2,
        }
        impl E2AEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    E2AEW::VALUE1 => false,
                    E2AEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E2AEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E2AEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E2AEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Event 2 detection interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E2AEW::VALUE1)
            }
            #[doc = "Event 2 detection interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E2AEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Period match while counting up enable"]
            #[inline]
            pub fn pme(&self) -> PMER {
                PMER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - One match while counting down enable"]
            #[inline]
            pub fn ome(&self) -> OMER {
                OMER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Compare match while counting up enable"]
            #[inline]
            pub fn cmue(&self) -> CMUER {
                CMUER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Compare match while counting down enable"]
            #[inline]
            pub fn cmde(&self) -> CMDER {
                CMDER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Event 0 interrupt enable"]
            #[inline]
            pub fn e0ae(&self) -> E0AER {
                E0AER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Event 1 interrupt enable"]
            #[inline]
            pub fn e1ae(&self) -> E1AER {
                E1AER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Event 2 interrupt enable"]
            #[inline]
            pub fn e2ae(&self) -> E2AER {
                E2AER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Period match while counting up enable"]
            #[inline]
            pub fn pme(&mut self) -> _PMEW {
                _PMEW { w: self }
            }
            #[doc = "Bit 1 - One match while counting down enable"]
            #[inline]
            pub fn ome(&mut self) -> _OMEW {
                _OMEW { w: self }
            }
            #[doc = "Bit 2 - Compare match while counting up enable"]
            #[inline]
            pub fn cmue(&mut self) -> _CMUEW {
                _CMUEW { w: self }
            }
            #[doc = "Bit 3 - Compare match while counting down enable"]
            #[inline]
            pub fn cmde(&mut self) -> _CMDEW {
                _CMDEW { w: self }
            }
            #[doc = "Bit 8 - Event 0 interrupt enable"]
            #[inline]
            pub fn e0ae(&mut self) -> _E0AEW {
                _E0AEW { w: self }
            }
            #[doc = "Bit 9 - Event 1 interrupt enable"]
            #[inline]
            pub fn e1ae(&mut self) -> _E1AEW {
                _E1AEW { w: self }
            }
            #[doc = "Bit 10 - Event 2 interrupt enable"]
            #[inline]
            pub fn e2ae(&mut self) -> _E2AEW {
                _E2AEW { w: self }
            }
        }
    }
    #[doc = "Service Request Selector"]
    pub struct SRS {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Selector"]
    pub mod srs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `POSR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum POSRR {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl POSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    POSRR::VALUE1 => 0,
                    POSRR::VALUE2 => 0x01,
                    POSRR::VALUE3 => 0x02,
                    POSRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> POSRR {
                match value {
                    0 => POSRR::VALUE1,
                    1 => POSRR::VALUE2,
                    2 => POSRR::VALUE3,
                    3 => POSRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == POSRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == POSRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == POSRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == POSRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CMSR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMSRR {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl CMSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CMSRR::VALUE1 => 0,
                    CMSRR::VALUE2 => 0x01,
                    CMSRR::VALUE3 => 0x02,
                    CMSRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CMSRR {
                match value {
                    0 => CMSRR::VALUE1,
                    1 => CMSRR::VALUE2,
                    2 => CMSRR::VALUE3,
                    3 => CMSRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMSRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMSRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CMSRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CMSRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `E0SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E0SRR {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl E0SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    E0SRR::VALUE1 => 0,
                    E0SRR::VALUE2 => 0x01,
                    E0SRR::VALUE3 => 0x02,
                    E0SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> E0SRR {
                match value {
                    0 => E0SRR::VALUE1,
                    1 => E0SRR::VALUE2,
                    2 => E0SRR::VALUE3,
                    3 => E0SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E0SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E0SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == E0SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == E0SRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `E1SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E1SRR {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl E1SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    E1SRR::VALUE1 => 0,
                    E1SRR::VALUE2 => 0x01,
                    E1SRR::VALUE3 => 0x02,
                    E1SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> E1SRR {
                match value {
                    0 => E1SRR::VALUE1,
                    1 => E1SRR::VALUE2,
                    2 => E1SRR::VALUE3,
                    3 => E1SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E1SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E1SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == E1SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == E1SRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `E2SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E2SRR {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl E2SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    E2SRR::VALUE1 => 0,
                    E2SRR::VALUE2 => 0x01,
                    E2SRR::VALUE3 => 0x02,
                    E2SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> E2SRR {
                match value {
                    0 => E2SRR::VALUE1,
                    1 => E2SRR::VALUE2,
                    2 => E2SRR::VALUE3,
                    3 => E2SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E2SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E2SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == E2SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == E2SRR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `POSR`"]
        pub enum POSRW {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl POSRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    POSRW::VALUE1 => 0,
                    POSRW::VALUE2 => 1,
                    POSRW::VALUE3 => 2,
                    POSRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POSRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POSRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POSRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC4ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POSRW::VALUE1)
            }
            #[doc = "Forward to CC4ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POSRW::VALUE2)
            }
            #[doc = "Forward to CC4ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(POSRW::VALUE3)
            }
            #[doc = "Forward to CC4ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(POSRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMSR`"]
        pub enum CMSRW {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl CMSRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CMSRW::VALUE1 => 0,
                    CMSRW::VALUE2 => 1,
                    CMSRW::VALUE3 => 2,
                    CMSRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMSRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMSRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMSRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC4ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMSRW::VALUE1)
            }
            #[doc = "Forward to CC4ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMSRW::VALUE2)
            }
            #[doc = "Forward to CC4ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CMSRW::VALUE3)
            }
            #[doc = "Forward to CC4ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CMSRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E0SR`"]
        pub enum E0SRW {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl E0SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    E0SRW::VALUE1 => 0,
                    E0SRW::VALUE2 => 1,
                    E0SRW::VALUE3 => 2,
                    E0SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E0SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E0SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E0SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC4ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E0SRW::VALUE1)
            }
            #[doc = "Forward to CC4ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E0SRW::VALUE2)
            }
            #[doc = "Forward to CC4ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(E0SRW::VALUE3)
            }
            #[doc = "Forward to CC4ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(E0SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E1SR`"]
        pub enum E1SRW {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl E1SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    E1SRW::VALUE1 => 0,
                    E1SRW::VALUE2 => 1,
                    E1SRW::VALUE3 => 2,
                    E1SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E1SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E1SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E1SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC4ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E1SRW::VALUE1)
            }
            #[doc = "Forward to CC4ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E1SRW::VALUE2)
            }
            #[doc = "Forward to CC4ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(E1SRW::VALUE3)
            }
            #[doc = "Forward to CC4ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(E1SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E2SR`"]
        pub enum E2SRW {
            #[doc = "Forward to CC4ySR0"]
            VALUE1,
            #[doc = "Forward to CC4ySR1"]
            VALUE2,
            #[doc = "Forward to CC4ySR2"]
            VALUE3,
            #[doc = "Forward to CC4ySR3"]
            VALUE4,
        }
        impl E2SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    E2SRW::VALUE1 => 0,
                    E2SRW::VALUE2 => 1,
                    E2SRW::VALUE3 => 2,
                    E2SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E2SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E2SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E2SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC4ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E2SRW::VALUE1)
            }
            #[doc = "Forward to CC4ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E2SRW::VALUE2)
            }
            #[doc = "Forward to CC4ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(E2SRW::VALUE3)
            }
            #[doc = "Forward to CC4ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(E2SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Period/One match Service request selector"]
            #[inline]
            pub fn posr(&self) -> POSRR {
                POSRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Compare match Service request selector"]
            #[inline]
            pub fn cmsr(&self) -> CMSRR {
                CMSRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Event 0 Service request selector"]
            #[inline]
            pub fn e0sr(&self) -> E0SRR {
                E0SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Event 1 Service request selector"]
            #[inline]
            pub fn e1sr(&self) -> E1SRR {
                E1SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Event 2 Service request selector"]
            #[inline]
            pub fn e2sr(&self) -> E2SRR {
                E2SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Period/One match Service request selector"]
            #[inline]
            pub fn posr(&mut self) -> _POSRW {
                _POSRW { w: self }
            }
            #[doc = "Bits 2:3 - Compare match Service request selector"]
            #[inline]
            pub fn cmsr(&mut self) -> _CMSRW {
                _CMSRW { w: self }
            }
            #[doc = "Bits 8:9 - Event 0 Service request selector"]
            #[inline]
            pub fn e0sr(&mut self) -> _E0SRW {
                _E0SRW { w: self }
            }
            #[doc = "Bits 10:11 - Event 1 Service request selector"]
            #[inline]
            pub fn e1sr(&mut self) -> _E1SRW {
                _E1SRW { w: self }
            }
            #[doc = "Bits 12:13 - Event 2 Service request selector"]
            #[inline]
            pub fn e2sr(&mut self) -> _E2SRW {
                _E2SRW { w: self }
            }
        }
    }
    #[doc = "Interrupt Status Set"]
    pub struct SWS {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Status Set"]
    pub mod sws {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SWS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCMUW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCMUW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCMDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SE0AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SE0AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SE1AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SE1AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SE2AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SE2AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRPFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Period match while counting up set"]
            #[inline]
            pub fn spm(&mut self) -> _SPMW {
                _SPMW { w: self }
            }
            #[doc = "Bit 1 - One match while counting down set"]
            #[inline]
            pub fn som(&mut self) -> _SOMW {
                _SOMW { w: self }
            }
            #[doc = "Bit 2 - Compare match while counting up set"]
            #[inline]
            pub fn scmu(&mut self) -> _SCMUW {
                _SCMUW { w: self }
            }
            #[doc = "Bit 3 - Compare match while counting down set"]
            #[inline]
            pub fn scmd(&mut self) -> _SCMDW {
                _SCMDW { w: self }
            }
            #[doc = "Bit 8 - Event 0 detection set"]
            #[inline]
            pub fn se0a(&mut self) -> _SE0AW {
                _SE0AW { w: self }
            }
            #[doc = "Bit 9 - Event 1 detection set"]
            #[inline]
            pub fn se1a(&mut self) -> _SE1AW {
                _SE1AW { w: self }
            }
            #[doc = "Bit 10 - Event 2 detection set"]
            #[inline]
            pub fn se2a(&mut self) -> _SE2AW {
                _SE2AW { w: self }
            }
            #[doc = "Bit 11 - Trap Flag status set"]
            #[inline]
            pub fn strpf(&mut self) -> _STRPFW {
                _STRPFW { w: self }
            }
        }
    }
    #[doc = "Interrupt Status Clear"]
    pub struct SWR {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Status Clear"]
    pub mod swr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SWR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ROMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ROMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCMUW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCMUW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCMDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCMDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RE0AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RE0AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RE1AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RE1AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RE2AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RE2AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTRPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTRPFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Period match while counting up clear"]
            #[inline]
            pub fn rpm(&mut self) -> _RPMW {
                _RPMW { w: self }
            }
            #[doc = "Bit 1 - One match while counting down clear"]
            #[inline]
            pub fn rom(&mut self) -> _ROMW {
                _ROMW { w: self }
            }
            #[doc = "Bit 2 - Compare match while counting up clear"]
            #[inline]
            pub fn rcmu(&mut self) -> _RCMUW {
                _RCMUW { w: self }
            }
            #[doc = "Bit 3 - Compare match while counting down clear"]
            #[inline]
            pub fn rcmd(&mut self) -> _RCMDW {
                _RCMDW { w: self }
            }
            #[doc = "Bit 8 - Event 0 detection clear"]
            #[inline]
            pub fn re0a(&mut self) -> _RE0AW {
                _RE0AW { w: self }
            }
            #[doc = "Bit 9 - Event 1 detection clear"]
            #[inline]
            pub fn re1a(&mut self) -> _RE1AW {
                _RE1AW { w: self }
            }
            #[doc = "Bit 10 - Event 2 detection clear"]
            #[inline]
            pub fn re2a(&mut self) -> _RE2AW {
                _RE2AW { w: self }
            }
            #[doc = "Bit 11 - Trap Flag status clear"]
            #[inline]
            pub fn rtrpf(&mut self) -> _RTRPFW {
                _RTRPFW { w: self }
            }
        }
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub struct CCU40_CC40 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU40_CC40 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub const CCU40_CC41: Peripheral<CCU40_CC41> = unsafe { Peripheral::new(0x4000_c200) };
#[doc = r" Register block"]
pub struct CCU40_CC41 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU40_CC41 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub const CCU40_CC42: Peripheral<CCU40_CC42> = unsafe { Peripheral::new(0x4000_c300) };
#[doc = r" Register block"]
pub struct CCU40_CC42 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU40_CC42 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 0"]
pub const CCU40_CC43: Peripheral<CCU40_CC43> = unsafe { Peripheral::new(0x4000_c400) };
#[doc = r" Register block"]
pub struct CCU40_CC43 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU40_CC43 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 1"]
pub const CCU41_CC40: Peripheral<CCU41_CC40> = unsafe { Peripheral::new(0x4001_0100) };
#[doc = r" Register block"]
pub struct CCU41_CC40 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU41_CC40 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 1"]
pub const CCU41_CC41: Peripheral<CCU41_CC41> = unsafe { Peripheral::new(0x4001_0200) };
#[doc = r" Register block"]
pub struct CCU41_CC41 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU41_CC41 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 1"]
pub const CCU41_CC42: Peripheral<CCU41_CC42> = unsafe { Peripheral::new(0x4001_0300) };
#[doc = r" Register block"]
pub struct CCU41_CC42 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU41_CC42 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 4 - Unit 1"]
pub const CCU41_CC43: Peripheral<CCU41_CC43> = unsafe { Peripheral::new(0x4001_0400) };
#[doc = r" Register block"]
pub struct CCU41_CC43 {
    register_block: ccu40_cc40::RegisterBlock,
}
impl Deref for CCU41_CC43 {
    type Target = ccu40_cc40::RegisterBlock;
    fn deref(&self) -> &ccu40_cc40::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub const CCU80: Peripheral<CCU80> = unsafe { Peripheral::new(0x4002_0000) };
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub mod ccu80 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Global Control Register"]
        pub gctrl: GCTRL,
        #[doc = "0x04 - Global Status Register"]
        pub gstat: GSTAT,
        #[doc = "0x08 - Global Idle Set"]
        pub gidls: GIDLS,
        #[doc = "0x0c - Global Idle Clear"]
        pub gidlc: GIDLC,
        #[doc = "0x10 - Global Channel Set"]
        pub gcss: GCSS,
        #[doc = "0x14 - Global Channel Clear"]
        pub gcsc: GCSC,
        #[doc = "0x18 - Global Channel status"]
        pub gcst: GCST,
        #[doc = "0x1c - Parity Checker Configuration"]
        pub gpchk: GPCHK,
        _reserved0: [u8; 48usize],
        #[doc = "0x50 - Extended Capture Mode Read"]
        pub ecrd: ECRD,
        _reserved1: [u8; 44usize],
        #[doc = "0x80 - Module Identification"]
        pub midr: MIDR,
    }
    #[doc = "Global Control Register"]
    pub struct GCTRL {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Control Register"]
    pub mod gctrl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GCTRL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PRBC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRBCR {
            #[doc = "SW only"]
            VALUE1,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC80 is cleared."]
            VALUE2,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC81 is cleared."]
            VALUE3,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC82 is cleared."]
            VALUE4,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC83 is cleared."]
            VALUE5,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PRBCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PRBCR::VALUE1 => 0,
                    PRBCR::VALUE2 => 0x01,
                    PRBCR::VALUE3 => 0x02,
                    PRBCR::VALUE4 => 0x03,
                    PRBCR::VALUE5 => 0x04,
                    PRBCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PRBCR {
                match value {
                    0 => PRBCR::VALUE1,
                    1 => PRBCR::VALUE2,
                    2 => PRBCR::VALUE3,
                    3 => PRBCR::VALUE4,
                    4 => PRBCR::VALUE5,
                    i => PRBCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRBCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRBCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PRBCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PRBCR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PRBCR::VALUE5
            }
        }
        #[doc = "Possible values of the field `PCIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCISR {
            #[doc = "Module clock"]
            VALUE1,
            #[doc = "CCU8x.ECLKA"]
            VALUE2,
            #[doc = "CCU8x.ECLKB"]
            VALUE3,
            #[doc = "CCU8x.ECLKC"]
            VALUE4,
        }
        impl PCISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PCISR::VALUE1 => 0,
                    PCISR::VALUE2 => 0x01,
                    PCISR::VALUE3 => 0x02,
                    PCISR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PCISR {
                match value {
                    0 => PCISR::VALUE1,
                    1 => PCISR::VALUE2,
                    2 => PCISR::VALUE3,
                    3 => PCISR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PCISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PCISR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SUSCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSCFGR {
            #[doc = "Suspend request ignored. The module never enters in suspend"]
            VALUE1,
            #[doc = "Stops all the running slices immediately. Safe stop is not applied."]
            VALUE2,
            #[doc = "Stops the block immediately and clamps all the outputs to PASSIVE state. Safe stop is applied."]
            VALUE3,
            #[doc = "Waits for the roll over of each slice to stop and clamp the slices outputs. Safe stop is applied."]
            VALUE4,
        }
        impl SUSCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SUSCFGR::VALUE1 => 0,
                    SUSCFGR::VALUE2 => 0x01,
                    SUSCFGR::VALUE3 => 0x02,
                    SUSCFGR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SUSCFGR {
                match value {
                    0 => SUSCFGR::VALUE1,
                    1 => SUSCFGR::VALUE2,
                    2 => SUSCFGR::VALUE3,
                    3 => SUSCFGR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSCFGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SUSCFGR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SUSCFGR::VALUE4
            }
        }
        #[doc = "Possible values of the field `MSE0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE0R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            VALUE2,
        }
        impl MSE0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE0R::VALUE1 => false,
                    MSE0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE0R {
                match value {
                    false => MSE0R::VALUE1,
                    true => MSE0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSE1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE1R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            VALUE2,
        }
        impl MSE1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE1R::VALUE1 => false,
                    MSE1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE1R {
                match value {
                    false => MSE1R::VALUE1,
                    true => MSE1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSE2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE2R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8xMCSS input."]
            VALUE2,
        }
        impl MSE2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE2R::VALUE1 => false,
                    MSE2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE2R {
                match value {
                    false => MSE2R::VALUE1,
                    true => MSE2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSE3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSE3R {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            VALUE2,
        }
        impl MSE3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSE3R::VALUE1 => false,
                    MSE3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSE3R {
                match value {
                    false => MSE3R::VALUE1,
                    true => MSE3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSE3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSE3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSDE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSDER {
            #[doc = "Only the shadow transfer for period and compare values is requested"]
            VALUE1,
            #[doc = "Shadow transfer for the compare, period and prescaler compare values is requested"]
            VALUE2,
            #[doc = "Shadow transfer for the compare, period, prescaler and dither compare values is requested"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl MSDER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MSDER::VALUE1 => 0,
                    MSDER::VALUE2 => 0x01,
                    MSDER::VALUE4 => 0x03,
                    MSDER::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MSDER {
                match value {
                    0 => MSDER::VALUE1,
                    1 => MSDER::VALUE2,
                    3 => MSDER::VALUE4,
                    i => MSDER::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSDER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSDER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MSDER::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `PRBC`"]
        pub enum PRBCW {
            #[doc = "SW only"]
            VALUE1,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC80 is cleared."]
            VALUE2,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC81 is cleared."]
            VALUE3,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC82 is cleared."]
            VALUE4,
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC83 is cleared."]
            VALUE5,
        }
        impl PRBCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PRBCW::VALUE1 => 0,
                    PRBCW::VALUE2 => 1,
                    PRBCW::VALUE3 => 2,
                    PRBCW::VALUE4 => 3,
                    PRBCW::VALUE5 => 4,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRBCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRBCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PRBCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "SW only"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PRBCW::VALUE1)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC80 is cleared."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PRBCW::VALUE2)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC81 is cleared."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PRBCW::VALUE3)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC82 is cleared."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PRBCW::VALUE4)
            }
            #[doc = "GSTATThe register contains the status of the prescaler and each timer slice (idle mode or running)..PRB and prescaler registers are cleared when the Run Bit of CC83 is cleared."]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PRBCW::VALUE5)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCIS`"]
        pub enum PCISW {
            #[doc = "Module clock"]
            VALUE1,
            #[doc = "CCU8x.ECLKA"]
            VALUE2,
            #[doc = "CCU8x.ECLKB"]
            VALUE3,
            #[doc = "CCU8x.ECLKC"]
            VALUE4,
        }
        impl PCISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PCISW::VALUE1 => 0,
                    PCISW::VALUE2 => 1,
                    PCISW::VALUE3 => 2,
                    PCISW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Module clock"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCISW::VALUE1)
            }
            #[doc = "CCU8x.ECLKA"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCISW::VALUE2)
            }
            #[doc = "CCU8x.ECLKB"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PCISW::VALUE3)
            }
            #[doc = "CCU8x.ECLKC"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PCISW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SUSCFG`"]
        pub enum SUSCFGW {
            #[doc = "Suspend request ignored. The module never enters in suspend"]
            VALUE1,
            #[doc = "Stops all the running slices immediately. Safe stop is not applied."]
            VALUE2,
            #[doc = "Stops the block immediately and clamps all the outputs to PASSIVE state. Safe stop is applied."]
            VALUE3,
            #[doc = "Waits for the roll over of each slice to stop and clamp the slices outputs. Safe stop is applied."]
            VALUE4,
        }
        impl SUSCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SUSCFGW::VALUE1 => 0,
                    SUSCFGW::VALUE2 => 1,
                    SUSCFGW::VALUE3 => 2,
                    SUSCFGW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUSCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUSCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUSCFGW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Suspend request ignored. The module never enters in suspend"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE1)
            }
            #[doc = "Stops all the running slices immediately. Safe stop is not applied."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE2)
            }
            #[doc = "Stops the block immediately and clamps all the outputs to PASSIVE state. Safe stop is applied."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE3)
            }
            #[doc = "Waits for the roll over of each slice to stop and clamp the slices outputs. Safe stop is applied."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE0`"]
        pub enum MSE0W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            VALUE2,
        }
        impl MSE0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE0W::VALUE1 => false,
                    MSE0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE0W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE1`"]
        pub enum MSE1W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            VALUE2,
        }
        impl MSE1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE1W::VALUE1 => false,
                    MSE1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE1W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE2`"]
        pub enum MSE2W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8xMCSS input."]
            VALUE2,
        }
        impl MSE2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE2W::VALUE1 => false,
                    MSE2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE2W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU8xMCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSE3`"]
        pub enum MSE3W {
            #[doc = "Shadow transfer can only be requested by SW"]
            VALUE1,
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            VALUE2,
        }
        impl MSE3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSE3W::VALUE1 => false,
                    MSE3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSE3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSE3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSE3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer can only be requested by SW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSE3W::VALUE1)
            }
            #[doc = "Shadow transfer can be requested via SW and via the CCU8x.MCSS input."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSE3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSDE`"]
        pub enum MSDEW {
            #[doc = "Only the shadow transfer for period and compare values is requested"]
            VALUE1,
            #[doc = "Shadow transfer for the compare, period and prescaler compare values is requested"]
            VALUE2,
            #[doc = "Shadow transfer for the compare, period, prescaler and dither compare values is requested"]
            VALUE4,
        }
        impl MSDEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MSDEW::VALUE1 => 0,
                    MSDEW::VALUE2 => 1,
                    MSDEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSDEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSDEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSDEW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Only the shadow transfer for period and compare values is requested"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSDEW::VALUE1)
            }
            #[doc = "Shadow transfer for the compare, period and prescaler compare values is requested"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSDEW::VALUE2)
            }
            #[doc = "Shadow transfer for the compare, period, prescaler and dither compare values is requested"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MSDEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Prescaler Clear Configuration"]
            #[inline]
            pub fn prbc(&self) -> PRBCR {
                PRBCR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Prescaler Input Clock Selection"]
            #[inline]
            pub fn pcis(&self) -> PCISR {
                PCISR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Suspend Mode Configuration"]
            #[inline]
            pub fn suscfg(&self) -> SUSCFGR {
                SUSCFGR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Slice 0 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse0(&self) -> MSE0R {
                MSE0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Slice 1 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse1(&self) -> MSE1R {
                MSE1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Slice 2 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse2(&self) -> MSE2R {
                MSE2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Slice 3 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse3(&self) -> MSE3R {
                MSE3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 14:15 - Multi Channel shadow transfer request configuration"]
            #[inline]
            pub fn msde(&self) -> MSDER {
                MSDER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Prescaler Clear Configuration"]
            #[inline]
            pub fn prbc(&mut self) -> _PRBCW {
                _PRBCW { w: self }
            }
            #[doc = "Bits 4:5 - Prescaler Input Clock Selection"]
            #[inline]
            pub fn pcis(&mut self) -> _PCISW {
                _PCISW { w: self }
            }
            #[doc = "Bits 8:9 - Suspend Mode Configuration"]
            #[inline]
            pub fn suscfg(&mut self) -> _SUSCFGW {
                _SUSCFGW { w: self }
            }
            #[doc = "Bit 10 - Slice 0 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse0(&mut self) -> _MSE0W {
                _MSE0W { w: self }
            }
            #[doc = "Bit 11 - Slice 1 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse1(&mut self) -> _MSE1W {
                _MSE1W { w: self }
            }
            #[doc = "Bit 12 - Slice 2 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse2(&mut self) -> _MSE2W {
                _MSE2W { w: self }
            }
            #[doc = "Bit 13 - Slice 3 Multi Channel shadow transfer enable"]
            #[inline]
            pub fn mse3(&mut self) -> _MSE3W {
                _MSE3W { w: self }
            }
            #[doc = "Bits 14:15 - Multi Channel shadow transfer request configuration"]
            #[inline]
            pub fn msde(&mut self) -> _MSDEW {
                _MSDEW { w: self }
            }
        }
    }
    #[doc = "Global Status Register"]
    pub struct GSTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Status Register"]
    pub mod gstat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::GSTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S0IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0IR::VALUE1 => false,
                    S0IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0IR {
                match value {
                    false => S0IR::VALUE1,
                    true => S0IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S1IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1IR::VALUE1 => false,
                    S1IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1IR {
                match value {
                    false => S1IR::VALUE1,
                    true => S1IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S2IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2IR::VALUE1 => false,
                    S2IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2IR {
                match value {
                    false => S2IR::VALUE1,
                    true => S2IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3I`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3IR {
            #[doc = "Running"]
            VALUE1,
            #[doc = "Idle"]
            VALUE2,
        }
        impl S3IR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3IR::VALUE1 => false,
                    S3IR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3IR {
                match value {
                    false => S3IR::VALUE1,
                    true => S3IR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3IR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3IR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PRB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PRBR {
            #[doc = "Prescaler is stopped"]
            VALUE1,
            #[doc = "Prescaler is running"]
            VALUE2,
        }
        impl PRBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PRBR::VALUE1 => false,
                    PRBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PRBR {
                match value {
                    false => PRBR::VALUE1,
                    true => PRBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PRBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PRBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PCRB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCRBR {
            #[doc = "Parity Checker is stopped"]
            VALUE1,
            #[doc = "Parity Checker is running"]
            VALUE2,
        }
        impl PCRBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PCRBR::VALUE1 => false,
                    PCRBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PCRBR {
                match value {
                    false => PCRBR::VALUE1,
                    true => PCRBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCRBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCRBR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - CC80 IDLE status"]
            #[inline]
            pub fn s0i(&self) -> S0IR {
                S0IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - CC81 IDLE status"]
            #[inline]
            pub fn s1i(&self) -> S1IR {
                S1IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - CC82 IDLE status"]
            #[inline]
            pub fn s2i(&self) -> S2IR {
                S2IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - CC83 IDLE status"]
            #[inline]
            pub fn s3i(&self) -> S3IR {
                S3IR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Prescaler Run Bit"]
            #[inline]
            pub fn prb(&self) -> PRBR {
                PRBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Parity Checker Run Bit"]
            #[inline]
            pub fn pcrb(&self) -> PCRBR {
                PCRBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Global Idle Set"]
    pub struct GIDLS {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Idle Set"]
    pub mod gidls {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GIDLS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS0IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS0IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS1IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS1IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS2IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS2IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SS3IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SS3IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CPRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CPRBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSICW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSICW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CPCHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CPCHW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CC80 IDLE mode set"]
            #[inline]
            pub fn ss0i(&mut self) -> _SS0IW {
                _SS0IW { w: self }
            }
            #[doc = "Bit 1 - CC81 IDLE mode set"]
            #[inline]
            pub fn ss1i(&mut self) -> _SS1IW {
                _SS1IW { w: self }
            }
            #[doc = "Bit 2 - CC82 IDLE mode set"]
            #[inline]
            pub fn ss2i(&mut self) -> _SS2IW {
                _SS2IW { w: self }
            }
            #[doc = "Bit 3 - CC83 IDLE mode set"]
            #[inline]
            pub fn ss3i(&mut self) -> _SS3IW {
                _SS3IW { w: self }
            }
            #[doc = "Bit 8 - Prescaler# Run Bit Clear"]
            #[inline]
            pub fn cprb(&mut self) -> _CPRBW {
                _CPRBW { w: self }
            }
            #[doc = "Bit 9 - Prescaler clear"]
            #[inline]
            pub fn psic(&mut self) -> _PSICW {
                _PSICW { w: self }
            }
            #[doc = "Bit 10 - Parity Checker Run bit clear"]
            #[inline]
            pub fn cpch(&mut self) -> _CPCHW {
                _CPCHW { w: self }
            }
        }
    }
    #[doc = "Global Idle Clear"]
    pub struct GIDLC {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Idle Clear"]
    pub mod gidlc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GIDLC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS0IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS0IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS1IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS1IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS2IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS2IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CS3IW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CS3IW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPRBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPCHW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPCHW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - CC80 IDLE mode clear"]
            #[inline]
            pub fn cs0i(&mut self) -> _CS0IW {
                _CS0IW { w: self }
            }
            #[doc = "Bit 1 - CC81 IDLE mode clear"]
            #[inline]
            pub fn cs1i(&mut self) -> _CS1IW {
                _CS1IW { w: self }
            }
            #[doc = "Bit 2 - CC82 IDLE mode clear"]
            #[inline]
            pub fn cs2i(&mut self) -> _CS2IW {
                _CS2IW { w: self }
            }
            #[doc = "Bit 3 - CC83 IDLE mode clear"]
            #[inline]
            pub fn cs3i(&mut self) -> _CS3IW {
                _CS3IW { w: self }
            }
            #[doc = "Bit 8 - Prescaler Run Bit Set"]
            #[inline]
            pub fn sprb(&mut self) -> _SPRBW {
                _SPRBW { w: self }
            }
            #[doc = "Bit 10 - Parity Checker run bit set"]
            #[inline]
            pub fn spch(&mut self) -> _SPCHW {
                _SPCHW { w: self }
            }
        }
    }
    #[doc = "Global Channel Set"]
    pub struct GCSS {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Channel Set"]
    pub mod gcss {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GCSS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3SEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3SEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3DSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3DSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3PSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0ST1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0ST1SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1ST1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1ST1SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2ST1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2ST1SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3ST1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3ST1SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0ST2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0ST2SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1ST2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1ST2SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2ST2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2ST2SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3ST2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3ST2SW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Slice 0 shadow transfer set enable"]
            #[inline]
            pub fn s0se(&mut self) -> _S0SEW {
                _S0SEW { w: self }
            }
            #[doc = "Bit 1 - Slice 0 Dither shadow transfer set enable"]
            #[inline]
            pub fn s0dse(&mut self) -> _S0DSEW {
                _S0DSEW { w: self }
            }
            #[doc = "Bit 2 - Slice 0 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s0pse(&mut self) -> _S0PSEW {
                _S0PSEW { w: self }
            }
            #[doc = "Bit 4 - Slice 1 shadow transfer set enable"]
            #[inline]
            pub fn s1se(&mut self) -> _S1SEW {
                _S1SEW { w: self }
            }
            #[doc = "Bit 5 - Slice 1 Dither shadow transfer set enable"]
            #[inline]
            pub fn s1dse(&mut self) -> _S1DSEW {
                _S1DSEW { w: self }
            }
            #[doc = "Bit 6 - Slice 1 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s1pse(&mut self) -> _S1PSEW {
                _S1PSEW { w: self }
            }
            #[doc = "Bit 8 - Slice 2 shadow transfer set enable"]
            #[inline]
            pub fn s2se(&mut self) -> _S2SEW {
                _S2SEW { w: self }
            }
            #[doc = "Bit 9 - Slice 2 Dither shadow transfer set enable"]
            #[inline]
            pub fn s2dse(&mut self) -> _S2DSEW {
                _S2DSEW { w: self }
            }
            #[doc = "Bit 10 - Slice 2 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s2pse(&mut self) -> _S2PSEW {
                _S2PSEW { w: self }
            }
            #[doc = "Bit 12 - Slice 3 shadow transfer set enable"]
            #[inline]
            pub fn s3se(&mut self) -> _S3SEW {
                _S3SEW { w: self }
            }
            #[doc = "Bit 13 - Slice 3 Dither shadow transfer set enable"]
            #[inline]
            pub fn s3dse(&mut self) -> _S3DSEW {
                _S3DSEW { w: self }
            }
            #[doc = "Bit 14 - Slice 3 Prescaler shadow transfer set enable"]
            #[inline]
            pub fn s3pse(&mut self) -> _S3PSEW {
                _S3PSEW { w: self }
            }
            #[doc = "Bit 16 - Slice 0 status bit 1 set"]
            #[inline]
            pub fn s0st1s(&mut self) -> _S0ST1SW {
                _S0ST1SW { w: self }
            }
            #[doc = "Bit 17 - Slice 1 status bit 1 set"]
            #[inline]
            pub fn s1st1s(&mut self) -> _S1ST1SW {
                _S1ST1SW { w: self }
            }
            #[doc = "Bit 18 - Slice 2 status bit 1 set"]
            #[inline]
            pub fn s2st1s(&mut self) -> _S2ST1SW {
                _S2ST1SW { w: self }
            }
            #[doc = "Bit 19 - Slice 3 status bit 1 set"]
            #[inline]
            pub fn s3st1s(&mut self) -> _S3ST1SW {
                _S3ST1SW { w: self }
            }
            #[doc = "Bit 20 - Slice 0 status bit 2 set"]
            #[inline]
            pub fn s0st2s(&mut self) -> _S0ST2SW {
                _S0ST2SW { w: self }
            }
            #[doc = "Bit 21 - Slice 1 status bit 2 set"]
            #[inline]
            pub fn s1st2s(&mut self) -> _S1ST2SW {
                _S1ST2SW { w: self }
            }
            #[doc = "Bit 22 - Slice 2 status bit 2 set"]
            #[inline]
            pub fn s2st2s(&mut self) -> _S2ST2SW {
                _S2ST2SW { w: self }
            }
            #[doc = "Bit 23 - Slice 3 status bit 2 set"]
            #[inline]
            pub fn s3st2s(&mut self) -> _S3ST2SW {
                _S3ST2SW { w: self }
            }
        }
    }
    #[doc = "Global Channel Clear"]
    pub struct GCSC {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Channel Clear"]
    pub mod gcsc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GCSC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3SCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3SCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3DSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3DSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3PSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3PSCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0ST1CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0ST1CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1ST1CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1ST1CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2ST1CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2ST1CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3ST1CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3ST1CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0ST2CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0ST2CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1ST2CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1ST2CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2ST2CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2ST2CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S3ST2CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S3ST2CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Slice 0 shadow transfer request clear"]
            #[inline]
            pub fn s0sc(&mut self) -> _S0SCW {
                _S0SCW { w: self }
            }
            #[doc = "Bit 1 - Slice 0 Dither shadow transfer clear"]
            #[inline]
            pub fn s0dsc(&mut self) -> _S0DSCW {
                _S0DSCW { w: self }
            }
            #[doc = "Bit 2 - Slice 0 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s0psc(&mut self) -> _S0PSCW {
                _S0PSCW { w: self }
            }
            #[doc = "Bit 4 - Slice 1 shadow transfer clear"]
            #[inline]
            pub fn s1sc(&mut self) -> _S1SCW {
                _S1SCW { w: self }
            }
            #[doc = "Bit 5 - Slice 1 Dither shadow transfer clear"]
            #[inline]
            pub fn s1dsc(&mut self) -> _S1DSCW {
                _S1DSCW { w: self }
            }
            #[doc = "Bit 6 - Slice 1 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s1psc(&mut self) -> _S1PSCW {
                _S1PSCW { w: self }
            }
            #[doc = "Bit 8 - Slice 2 shadow transfer clear"]
            #[inline]
            pub fn s2sc(&mut self) -> _S2SCW {
                _S2SCW { w: self }
            }
            #[doc = "Bit 9 - Slice 2 Dither shadow transfer clear"]
            #[inline]
            pub fn s2dsc(&mut self) -> _S2DSCW {
                _S2DSCW { w: self }
            }
            #[doc = "Bit 10 - Slice 2 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s2psc(&mut self) -> _S2PSCW {
                _S2PSCW { w: self }
            }
            #[doc = "Bit 12 - Slice 3 shadow transfer clear"]
            #[inline]
            pub fn s3sc(&mut self) -> _S3SCW {
                _S3SCW { w: self }
            }
            #[doc = "Bit 13 - Slice 3 Dither shadow transfer clear"]
            #[inline]
            pub fn s3dsc(&mut self) -> _S3DSCW {
                _S3DSCW { w: self }
            }
            #[doc = "Bit 14 - Slice 3 Prescaler shadow transfer clear"]
            #[inline]
            pub fn s3psc(&mut self) -> _S3PSCW {
                _S3PSCW { w: self }
            }
            #[doc = "Bit 16 - Slice 0 status bit 1 clear"]
            #[inline]
            pub fn s0st1c(&mut self) -> _S0ST1CW {
                _S0ST1CW { w: self }
            }
            #[doc = "Bit 17 - Slice 1 status bit 1 clear"]
            #[inline]
            pub fn s1st1c(&mut self) -> _S1ST1CW {
                _S1ST1CW { w: self }
            }
            #[doc = "Bit 18 - Slice 2 status bit 1 clear"]
            #[inline]
            pub fn s2st1c(&mut self) -> _S2ST1CW {
                _S2ST1CW { w: self }
            }
            #[doc = "Bit 19 - Slice 3 status bit 1 clear"]
            #[inline]
            pub fn s3st1c(&mut self) -> _S3ST1CW {
                _S3ST1CW { w: self }
            }
            #[doc = "Bit 20 - Slice 0 status bit 2 clear"]
            #[inline]
            pub fn s0st2c(&mut self) -> _S0ST2CW {
                _S0ST2CW { w: self }
            }
            #[doc = "Bit 21 - Slice 1 status bit 2 clear"]
            #[inline]
            pub fn s1st2c(&mut self) -> _S1ST2CW {
                _S1ST2CW { w: self }
            }
            #[doc = "Bit 22 - Slice 2 status bit 2 clear"]
            #[inline]
            pub fn s2st2c(&mut self) -> _S2ST2CW {
                _S2ST2CW { w: self }
            }
            #[doc = "Bit 23 - Slice 3 status bit 2 clear"]
            #[inline]
            pub fn s3st2c(&mut self) -> _S3ST2CW {
                _S3ST2CW { w: self }
            }
        }
    }
    #[doc = "Global Channel status"]
    pub struct GCST {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Channel status"]
    pub mod gcst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::GCST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S0SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0SSR::VALUE1 => false,
                    S0SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0SSR {
                match value {
                    false => S0SSR::VALUE1,
                    true => S0SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S0DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S0DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0DSSR::VALUE1 => false,
                    S0DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0DSSR {
                match value {
                    false => S0DSSR::VALUE1,
                    true => S0DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S0PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S0PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0PSSR::VALUE1 => false,
                    S0PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0PSSR {
                match value {
                    false => S0PSSR::VALUE1,
                    true => S0PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0PSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S1SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1SSR::VALUE1 => false,
                    S1SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1SSR {
                match value {
                    false => S1SSR::VALUE1,
                    true => S1SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S1DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1DSSR::VALUE1 => false,
                    S1DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1DSSR {
                match value {
                    false => S1DSSR::VALUE1,
                    true => S1DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S1PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1PSSR::VALUE1 => false,
                    S1PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1PSSR {
                match value {
                    false => S1PSSR::VALUE1,
                    true => S1PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1PSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S2SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2SSR::VALUE1 => false,
                    S2SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2SSR {
                match value {
                    false => S2SSR::VALUE1,
                    true => S2SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S2DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2DSSR::VALUE1 => false,
                    S2DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2DSSR {
                match value {
                    false => S2DSSR::VALUE1,
                    true => S2DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S2PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2PSSR::VALUE1 => false,
                    S2PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2PSSR {
                match value {
                    false => S2PSSR::VALUE1,
                    true => S2PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2PSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3SSR {
            #[doc = "Shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Shadow transfer has been requested"]
            VALUE2,
        }
        impl S3SSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3SSR::VALUE1 => false,
                    S3SSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3SSR {
                match value {
                    false => S3SSR::VALUE1,
                    true => S3SSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3SSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3DSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3DSSR {
            #[doc = "Dither shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Dither shadow transfer has been requested"]
            VALUE2,
        }
        impl S3DSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3DSSR::VALUE1 => false,
                    S3DSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3DSSR {
                match value {
                    false => S3DSSR::VALUE1,
                    true => S3DSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3DSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3DSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S3PSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S3PSSR {
            #[doc = "Prescaler shadow transfer has not been requested"]
            VALUE1,
            #[doc = "Prescaler shadow transfer has been requested"]
            VALUE2,
        }
        impl S3PSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S3PSSR::VALUE1 => false,
                    S3PSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S3PSSR {
                match value {
                    false => S3PSSR::VALUE1,
                    true => S3PSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S3PSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S3PSSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC80ST1R {
            bits: bool,
        }
        impl CC80ST1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC81ST1R {
            bits: bool,
        }
        impl CC81ST1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC82ST1R {
            bits: bool,
        }
        impl CC82ST1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC83ST1R {
            bits: bool,
        }
        impl CC83ST1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC80ST2R {
            bits: bool,
        }
        impl CC80ST2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC81ST2R {
            bits: bool,
        }
        impl CC81ST2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC82ST2R {
            bits: bool,
        }
        impl CC82ST2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CC83ST2R {
            bits: bool,
        }
        impl CC83ST2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Slice 0 shadow transfer status"]
            #[inline]
            pub fn s0ss(&self) -> S0SSR {
                S0SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Slice 0 Dither shadow transfer status"]
            #[inline]
            pub fn s0dss(&self) -> S0DSSR {
                S0DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Slice 0 Prescaler shadow transfer status"]
            #[inline]
            pub fn s0pss(&self) -> S0PSSR {
                S0PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Slice 1 shadow transfer status"]
            #[inline]
            pub fn s1ss(&self) -> S1SSR {
                S1SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Slice 1 Dither shadow transfer status"]
            #[inline]
            pub fn s1dss(&self) -> S1DSSR {
                S1DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Slice 1 Prescaler shadow transfer status"]
            #[inline]
            pub fn s1pss(&self) -> S1PSSR {
                S1PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Slice 2 shadow transfer status"]
            #[inline]
            pub fn s2ss(&self) -> S2SSR {
                S2SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Slice 2 Dither shadow transfer status"]
            #[inline]
            pub fn s2dss(&self) -> S2DSSR {
                S2DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Slice 2 Prescaler shadow transfer status"]
            #[inline]
            pub fn s2pss(&self) -> S2PSSR {
                S2PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Slice 3 shadow transfer status"]
            #[inline]
            pub fn s3ss(&self) -> S3SSR {
                S3SSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Slice 3 Dither shadow transfer status"]
            #[inline]
            pub fn s3dss(&self) -> S3DSSR {
                S3DSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Slice 3 Prescaler shadow transfer status"]
            #[inline]
            pub fn s3pss(&self) -> S3PSSR {
                S3PSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Slice 0 compare channel 1 status bit"]
            #[inline]
            pub fn cc80st1(&self) -> CC80ST1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC80ST1R { bits }
            }
            #[doc = "Bit 17 - Slice 1 compare channel 1 status bit"]
            #[inline]
            pub fn cc81st1(&self) -> CC81ST1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC81ST1R { bits }
            }
            #[doc = "Bit 18 - Slice 2 compare channel 1 status bit"]
            #[inline]
            pub fn cc82st1(&self) -> CC82ST1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC82ST1R { bits }
            }
            #[doc = "Bit 19 - Slice 3 compare channel 1 status bit"]
            #[inline]
            pub fn cc83st1(&self) -> CC83ST1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC83ST1R { bits }
            }
            #[doc = "Bit 20 - Slice 0 compare channel 2 status bit"]
            #[inline]
            pub fn cc80st2(&self) -> CC80ST2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC80ST2R { bits }
            }
            #[doc = "Bit 21 - Slice 1 compare channel 2 status bit"]
            #[inline]
            pub fn cc81st2(&self) -> CC81ST2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC81ST2R { bits }
            }
            #[doc = "Bit 22 - Slice 2 compare channel 2 status bit"]
            #[inline]
            pub fn cc82st2(&self) -> CC82ST2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC82ST2R { bits }
            }
            #[doc = "Bit 23 - Slice 3 compare channel 2 status bit"]
            #[inline]
            pub fn cc83st2(&self) -> CC83ST2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CC83ST2R { bits }
            }
        }
    }
    #[doc = "Parity Checker Configuration"]
    pub struct GPCHK {
        register: VolatileCell<u32>,
    }
    #[doc = "Parity Checker Configuration"]
    pub mod gpchk {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GPCHK {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PASER {
            bits: bool,
        }
        impl PASER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `PACS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PACSR {
            #[doc = "CC80"]
            VALUE1,
            #[doc = "CC81"]
            VALUE2,
            #[doc = "CC82"]
            VALUE3,
            #[doc = "CC83"]
            VALUE4,
        }
        impl PACSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PACSR::VALUE1 => 0,
                    PACSR::VALUE2 => 0x01,
                    PACSR::VALUE3 => 0x02,
                    PACSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PACSR {
                match value {
                    0 => PACSR::VALUE1,
                    1 => PACSR::VALUE2,
                    2 => PACSR::VALUE3,
                    3 => PACSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PACSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PACSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PACSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PACSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PISEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PISELR {
            #[doc = "CC8x.GP01 - driver output is connected to event 1 of slice 0"]
            VALUE1,
            #[doc = "CC8x.GP11 - drive output is connected to event 1 of slice 1"]
            VALUE2,
            #[doc = "CC8x.GP21 - driver output is connected to event 1 of slice 2"]
            VALUE3,
            #[doc = "CC8x.GP31 - driver output is connected to event 1 of slice 3"]
            VALUE4,
        }
        impl PISELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PISELR::VALUE1 => 0,
                    PISELR::VALUE2 => 0x01,
                    PISELR::VALUE3 => 0x02,
                    PISELR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PISELR {
                match value {
                    0 => PISELR::VALUE1,
                    1 => PISELR::VALUE2,
                    2 => PISELR::VALUE3,
                    3 => PISELR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PISELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PISELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PISELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PISELR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PCDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCDSR {
            #[doc = "CCU8x.IGBTA"]
            VALUE1,
            #[doc = "CCU8x.IGBTB"]
            VALUE2,
            #[doc = "CCU8x.IGBTC"]
            VALUE3,
            #[doc = "CCU8x.IGBTD"]
            VALUE4,
        }
        impl PCDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PCDSR::VALUE1 => 0,
                    PCDSR::VALUE2 => 0x01,
                    PCDSR::VALUE3 => 0x02,
                    PCDSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PCDSR {
                match value {
                    0 => PCDSR::VALUE1,
                    1 => PCDSR::VALUE2,
                    2 => PCDSR::VALUE3,
                    3 => PCDSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCDSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PCDSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PCDSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PCTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCTSR {
            #[doc = "Even parity enabled"]
            VALUE1,
            #[doc = "Odd parity enabled"]
            VALUE2,
        }
        impl PCTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PCTSR::VALUE1 => false,
                    PCTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PCTSR {
                match value {
                    false => PCTSR::VALUE1,
                    true => PCTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCTSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCSTR {
            bits: bool,
        }
        impl PCSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCSEL0R {
            bits: u8,
        }
        impl PCSEL0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCSEL1R {
            bits: u8,
        }
        impl PCSEL1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCSEL2R {
            bits: u8,
        }
        impl PCSEL2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCSEL3R {
            bits: u8,
        }
        impl PCSEL3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PASEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PASEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PACS`"]
        pub enum PACSW {
            #[doc = "CC80"]
            VALUE1,
            #[doc = "CC81"]
            VALUE2,
            #[doc = "CC82"]
            VALUE3,
            #[doc = "CC83"]
            VALUE4,
        }
        impl PACSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PACSW::VALUE1 => 0,
                    PACSW::VALUE2 => 1,
                    PACSW::VALUE3 => 2,
                    PACSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PACSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PACSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PACSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CC80"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PACSW::VALUE1)
            }
            #[doc = "CC81"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PACSW::VALUE2)
            }
            #[doc = "CC82"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PACSW::VALUE3)
            }
            #[doc = "CC83"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PACSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PISEL`"]
        pub enum PISELW {
            #[doc = "CC8x.GP01 - driver output is connected to event 1 of slice 0"]
            VALUE1,
            #[doc = "CC8x.GP11 - drive output is connected to event 1 of slice 1"]
            VALUE2,
            #[doc = "CC8x.GP21 - driver output is connected to event 1 of slice 2"]
            VALUE3,
            #[doc = "CC8x.GP31 - driver output is connected to event 1 of slice 3"]
            VALUE4,
        }
        impl PISELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PISELW::VALUE1 => 0,
                    PISELW::VALUE2 => 1,
                    PISELW::VALUE3 => 2,
                    PISELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PISELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PISELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PISELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CC8x.GP01 - driver output is connected to event 1 of slice 0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PISELW::VALUE1)
            }
            #[doc = "CC8x.GP11 - drive output is connected to event 1 of slice 1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PISELW::VALUE2)
            }
            #[doc = "CC8x.GP21 - driver output is connected to event 1 of slice 2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PISELW::VALUE3)
            }
            #[doc = "CC8x.GP31 - driver output is connected to event 1 of slice 3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PISELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCDS`"]
        pub enum PCDSW {
            #[doc = "CCU8x.IGBTA"]
            VALUE1,
            #[doc = "CCU8x.IGBTB"]
            VALUE2,
            #[doc = "CCU8x.IGBTC"]
            VALUE3,
            #[doc = "CCU8x.IGBTD"]
            VALUE4,
        }
        impl PCDSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PCDSW::VALUE1 => 0,
                    PCDSW::VALUE2 => 1,
                    PCDSW::VALUE3 => 2,
                    PCDSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCDSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCDSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU8x.IGBTA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCDSW::VALUE1)
            }
            #[doc = "CCU8x.IGBTB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCDSW::VALUE2)
            }
            #[doc = "CCU8x.IGBTC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PCDSW::VALUE3)
            }
            #[doc = "CCU8x.IGBTD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PCDSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCTS`"]
        pub enum PCTSW {
            #[doc = "Even parity enabled"]
            VALUE1,
            #[doc = "Odd parity enabled"]
            VALUE2,
        }
        impl PCTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PCTSW::VALUE1 => false,
                    PCTSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCTSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Even parity enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCTSW::VALUE1)
            }
            #[doc = "Odd parity enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCTSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCSEL0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCSEL0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCSEL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCSEL1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCSEL2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCSEL2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCSEL3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCSEL3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Parity Checker Automatic start/stop"]
            #[inline]
            pub fn pase(&self) -> PASER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PASER { bits }
            }
            #[doc = "Bits 1:2 - Parity Checker Automatic start/stop selector"]
            #[inline]
            pub fn pacs(&self) -> PACSR {
                PACSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 3:4 - Driver Input signal selector"]
            #[inline]
            pub fn pisel(&self) -> PISELR {
                PISELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 5:6 - Parity Checker Delay Input Selector"]
            #[inline]
            pub fn pcds(&self) -> PCDSR {
                PCDSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 7 - Parity Checker type selector"]
            #[inline]
            pub fn pcts(&self) -> PCTSR {
                PCTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Parity Checker XOR status"]
            #[inline]
            pub fn pcst(&self) -> PCSTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                PCSTR { bits }
            }
            #[doc = "Bits 16:19 - Parity Checker Slice 0 output selection"]
            #[inline]
            pub fn pcsel0(&self) -> PCSEL0R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCSEL0R { bits }
            }
            #[doc = "Bits 20:23 - Parity Checker Slice 1 output selection"]
            #[inline]
            pub fn pcsel1(&self) -> PCSEL1R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCSEL1R { bits }
            }
            #[doc = "Bits 24:27 - Parity Checker Slice 2 output selection"]
            #[inline]
            pub fn pcsel2(&self) -> PCSEL2R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCSEL2R { bits }
            }
            #[doc = "Bits 28:31 - Parity Checker Slice 3 output selection"]
            #[inline]
            pub fn pcsel3(&self) -> PCSEL3R {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCSEL3R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Parity Checker Automatic start/stop"]
            #[inline]
            pub fn pase(&mut self) -> _PASEW {
                _PASEW { w: self }
            }
            #[doc = "Bits 1:2 - Parity Checker Automatic start/stop selector"]
            #[inline]
            pub fn pacs(&mut self) -> _PACSW {
                _PACSW { w: self }
            }
            #[doc = "Bits 3:4 - Driver Input signal selector"]
            #[inline]
            pub fn pisel(&mut self) -> _PISELW {
                _PISELW { w: self }
            }
            #[doc = "Bits 5:6 - Parity Checker Delay Input Selector"]
            #[inline]
            pub fn pcds(&mut self) -> _PCDSW {
                _PCDSW { w: self }
            }
            #[doc = "Bit 7 - Parity Checker type selector"]
            #[inline]
            pub fn pcts(&mut self) -> _PCTSW {
                _PCTSW { w: self }
            }
            #[doc = "Bits 16:19 - Parity Checker Slice 0 output selection"]
            #[inline]
            pub fn pcsel0(&mut self) -> _PCSEL0W {
                _PCSEL0W { w: self }
            }
            #[doc = "Bits 20:23 - Parity Checker Slice 1 output selection"]
            #[inline]
            pub fn pcsel1(&mut self) -> _PCSEL1W {
                _PCSEL1W { w: self }
            }
            #[doc = "Bits 24:27 - Parity Checker Slice 2 output selection"]
            #[inline]
            pub fn pcsel2(&mut self) -> _PCSEL2W {
                _PCSEL2W { w: self }
            }
            #[doc = "Bits 28:31 - Parity Checker Slice 3 output selection"]
            #[inline]
            pub fn pcsel3(&mut self) -> _PCSEL3W {
                _PCSEL3W { w: self }
            }
        }
    }
    #[doc = "Extended Capture Mode Read"]
    pub struct ECRD {
        register: VolatileCell<u32>,
    }
    #[doc = "Extended Capture Mode Read"]
    pub mod ecrd {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ECRD {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPVR {
            bits: u16,
        }
        impl CAPVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SPTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SPTRR {
            #[doc = "CC80"]
            VALUE1,
            #[doc = "CC81"]
            VALUE2,
            #[doc = "CC82"]
            VALUE3,
            #[doc = "CC83"]
            VALUE4,
        }
        impl SPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SPTRR::VALUE1 => 0,
                    SPTRR::VALUE2 => 0x01,
                    SPTRR::VALUE3 => 0x02,
                    SPTRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SPTRR {
                match value {
                    0 => SPTRR::VALUE1,
                    1 => SPTRR::VALUE2,
                    2 => SPTRR::VALUE3,
                    3 => SPTRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SPTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SPTRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SPTRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SPTRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `VPTR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VPTRR {
            #[doc = "Capture register 0"]
            VALUE1,
            #[doc = "Capture register 1"]
            VALUE2,
            #[doc = "Capture register 2"]
            VALUE3,
            #[doc = "Capture register 3"]
            VALUE4,
        }
        impl VPTRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    VPTRR::VALUE1 => 0,
                    VPTRR::VALUE2 => 0x01,
                    VPTRR::VALUE3 => 0x02,
                    VPTRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> VPTRR {
                match value {
                    0 => VPTRR::VALUE1,
                    1 => VPTRR::VALUE2,
                    2 => VPTRR::VALUE3,
                    3 => VPTRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VPTRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VPTRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == VPTRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == VPTRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into this register"]
            VALUE1,
            #[doc = "A new value has been captured into this register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Timer Capture Value"]
            #[inline]
            pub fn capv(&self) -> CAPVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Capture value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bits 20:21 - Slice pointer"]
            #[inline]
            pub fn sptr(&self) -> SPTRR {
                SPTRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Capture register pointer"]
            #[inline]
            pub fn vptr(&self) -> VPTRR {
                VPTRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 24 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Module Identification"]
    pub struct MIDR {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification"]
    pub mod midr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MIDR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODRR {
            bits: u8,
        }
        impl MODRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODTR {
            bits: u8,
        }
        impl MODTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODNR {
            bits: u16,
        }
        impl MODNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn modr(&self) -> MODRR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODRR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn modt(&self) -> MODTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODTR { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn modn(&self) -> MODNR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MODNR { bits }
            }
        }
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub struct CCU80 {
    register_block: ccu80::RegisterBlock,
}
impl Deref for CCU80 {
    type Target = ccu80::RegisterBlock;
    fn deref(&self) -> &ccu80::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub const CCU80_CC80: Peripheral<CCU80_CC80> = unsafe { Peripheral::new(0x4002_0100) };
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub mod ccu80_cc80 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Input Selector Configuration"]
        pub ins: INS,
        #[doc = "0x04 - Connection Matrix Control"]
        pub cmc: CMC,
        #[doc = "0x08 - Slice Timer Status"]
        pub tcst: TCST,
        #[doc = "0x0c - Slice Timer Run Set"]
        pub tcset: TCSET,
        #[doc = "0x10 - Slice Timer Clear"]
        pub tcclr: TCCLR,
        #[doc = "0x14 - Slice Timer Control"]
        pub tc: TC,
        #[doc = "0x18 - Passive Level Config"]
        pub psl: PSL,
        #[doc = "0x1c - Dither Config"]
        pub dit: DIT,
        #[doc = "0x20 - Dither Shadow Register"]
        pub dits: DITS,
        #[doc = "0x24 - Prescaler Control"]
        pub psc: PSC,
        #[doc = "0x28 - Floating Prescaler Control"]
        pub fpc: FPC,
        #[doc = "0x2c - Floating Prescaler Shadow"]
        pub fpcs: FPCS,
        #[doc = "0x30 - Timer Period Value"]
        pub pr: PR,
        #[doc = "0x34 - Timer Shadow Period Value"]
        pub prs: PRS,
        #[doc = "0x38 - Channel 1 Compare Value"]
        pub cr1: CR1,
        #[doc = "0x3c - Channel 1 Compare Shadow Value"]
        pub cr1s: CR1S,
        #[doc = "0x40 - Channel 2 Compare Value"]
        pub cr2: CR2,
        #[doc = "0x44 - Channel 2 Compare Shadow Value"]
        pub cr2s: CR2S,
        #[doc = "0x48 - Channel Control"]
        pub chc: CHC,
        #[doc = "0x4c - Dead Time Control"]
        pub dtc: DTC,
        #[doc = "0x50 - Channel 1 Dead Time Values"]
        pub dc1r: DC1R,
        #[doc = "0x54 - Channel 2 Dead Time Values"]
        pub dc2r: DC2R,
        _reserved0: [u8; 24usize],
        #[doc = "0x70 - Timer Value"]
        pub timer: TIMER,
        #[doc = "0x74 - Capture Register 0"]
        pub c0v: C0V,
        #[doc = "0x78 - Capture Register 1"]
        pub c1v: C1V,
        #[doc = "0x7c - Capture Register 2"]
        pub c2v: C2V,
        #[doc = "0x80 - Capture Register 3"]
        pub c3v: C3V,
        _reserved1: [u8; 28usize],
        #[doc = "0xa0 - Interrupt Status"]
        pub ints: INTS,
        #[doc = "0xa4 - Interrupt Enable Control"]
        pub inte: INTE,
        #[doc = "0xa8 - Service Request Selector"]
        pub srs: SRS,
        #[doc = "0xac - Interrupt Status Set"]
        pub sws: SWS,
        #[doc = "0xb0 - Interrupt Status Clear"]
        pub swr: SWR,
        #[doc = "0xb4 - Shadow transfer control"]
        pub stc: STC,
    }
    #[doc = "Input Selector Configuration"]
    pub struct INS {
        register: VolatileCell<u32>,
    }
    #[doc = "Input Selector Configuration"]
    pub mod ins {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::INS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `EV0IS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV0ISR {
            #[doc = "CCU8x.INyA"]
            VALUE1,
            #[doc = "CCU8x.INyB"]
            VALUE2,
            #[doc = "CCU8x.INyC"]
            VALUE3,
            #[doc = "CCU8x.INyD"]
            VALUE4,
            #[doc = "CCU8x.INyE"]
            VALUE5,
            #[doc = "CCU8x.INyF"]
            VALUE6,
            #[doc = "CCU8x.INyG"]
            VALUE7,
            #[doc = "CCU8x.INyH"]
            VALUE8,
            #[doc = "CCU8x.INyI"]
            VALUE9,
            #[doc = "CCU8x.INyJ"]
            VALUE10,
            #[doc = "CCU8x.INyK"]
            VALUE11,
            #[doc = "CCU8x.INyL"]
            VALUE12,
            #[doc = "CCU8x.INyM"]
            VALUE13,
            #[doc = "CCU8x.INyN"]
            VALUE14,
            #[doc = "CCU8x.INyO"]
            VALUE15,
            #[doc = "CCU8x.INyP"]
            VALUE16,
        }
        impl EV0ISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV0ISR::VALUE1 => 0,
                    EV0ISR::VALUE2 => 0x01,
                    EV0ISR::VALUE3 => 0x02,
                    EV0ISR::VALUE4 => 0x03,
                    EV0ISR::VALUE5 => 0x04,
                    EV0ISR::VALUE6 => 0x05,
                    EV0ISR::VALUE7 => 0x06,
                    EV0ISR::VALUE8 => 0x07,
                    EV0ISR::VALUE9 => 0x08,
                    EV0ISR::VALUE10 => 0x09,
                    EV0ISR::VALUE11 => 0x0a,
                    EV0ISR::VALUE12 => 0x0b,
                    EV0ISR::VALUE13 => 0x0c,
                    EV0ISR::VALUE14 => 0x0d,
                    EV0ISR::VALUE15 => 0x0e,
                    EV0ISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV0ISR {
                match value {
                    0 => EV0ISR::VALUE1,
                    1 => EV0ISR::VALUE2,
                    2 => EV0ISR::VALUE3,
                    3 => EV0ISR::VALUE4,
                    4 => EV0ISR::VALUE5,
                    5 => EV0ISR::VALUE6,
                    6 => EV0ISR::VALUE7,
                    7 => EV0ISR::VALUE8,
                    8 => EV0ISR::VALUE9,
                    9 => EV0ISR::VALUE10,
                    10 => EV0ISR::VALUE11,
                    11 => EV0ISR::VALUE12,
                    12 => EV0ISR::VALUE13,
                    13 => EV0ISR::VALUE14,
                    14 => EV0ISR::VALUE15,
                    15 => EV0ISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV0ISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV0ISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV0ISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV0ISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == EV0ISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == EV0ISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == EV0ISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == EV0ISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == EV0ISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == EV0ISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == EV0ISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == EV0ISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == EV0ISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == EV0ISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == EV0ISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == EV0ISR::VALUE16
            }
        }
        #[doc = "Possible values of the field `EV1IS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV1ISR {
            #[doc = "CCU8x.INyA"]
            VALUE1,
            #[doc = "CCU8x.INyB"]
            VALUE2,
            #[doc = "CCU8x.INyC"]
            VALUE3,
            #[doc = "CCU8x.INyD"]
            VALUE4,
            #[doc = "CCU8x.INyE"]
            VALUE5,
            #[doc = "CCU8x.INyF"]
            VALUE6,
            #[doc = "CCU8x.INyG"]
            VALUE7,
            #[doc = "CCU8x.INyH"]
            VALUE8,
            #[doc = "CCU8x.INyI"]
            VALUE9,
            #[doc = "CCU8x.INyJ"]
            VALUE10,
            #[doc = "CCU8x.INyK"]
            VALUE11,
            #[doc = "CCU8x.INyL"]
            VALUE12,
            #[doc = "CCU8x.INyM"]
            VALUE13,
            #[doc = "CCU8x.INyN"]
            VALUE14,
            #[doc = "CCU8x.INyO"]
            VALUE15,
            #[doc = "CCU8x.INyP"]
            VALUE16,
        }
        impl EV1ISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV1ISR::VALUE1 => 0,
                    EV1ISR::VALUE2 => 0x01,
                    EV1ISR::VALUE3 => 0x02,
                    EV1ISR::VALUE4 => 0x03,
                    EV1ISR::VALUE5 => 0x04,
                    EV1ISR::VALUE6 => 0x05,
                    EV1ISR::VALUE7 => 0x06,
                    EV1ISR::VALUE8 => 0x07,
                    EV1ISR::VALUE9 => 0x08,
                    EV1ISR::VALUE10 => 0x09,
                    EV1ISR::VALUE11 => 0x0a,
                    EV1ISR::VALUE12 => 0x0b,
                    EV1ISR::VALUE13 => 0x0c,
                    EV1ISR::VALUE14 => 0x0d,
                    EV1ISR::VALUE15 => 0x0e,
                    EV1ISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV1ISR {
                match value {
                    0 => EV1ISR::VALUE1,
                    1 => EV1ISR::VALUE2,
                    2 => EV1ISR::VALUE3,
                    3 => EV1ISR::VALUE4,
                    4 => EV1ISR::VALUE5,
                    5 => EV1ISR::VALUE6,
                    6 => EV1ISR::VALUE7,
                    7 => EV1ISR::VALUE8,
                    8 => EV1ISR::VALUE9,
                    9 => EV1ISR::VALUE10,
                    10 => EV1ISR::VALUE11,
                    11 => EV1ISR::VALUE12,
                    12 => EV1ISR::VALUE13,
                    13 => EV1ISR::VALUE14,
                    14 => EV1ISR::VALUE15,
                    15 => EV1ISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV1ISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV1ISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV1ISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV1ISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == EV1ISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == EV1ISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == EV1ISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == EV1ISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == EV1ISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == EV1ISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == EV1ISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == EV1ISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == EV1ISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == EV1ISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == EV1ISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == EV1ISR::VALUE16
            }
        }
        #[doc = "Possible values of the field `EV2IS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV2ISR {
            #[doc = "CCU8x.INyA"]
            VALUE1,
            #[doc = "CCU8x.INyB"]
            VALUE2,
            #[doc = "CCU8x.INyC"]
            VALUE3,
            #[doc = "CCU8x.INyD"]
            VALUE4,
            #[doc = "CCU8x.INyE"]
            VALUE5,
            #[doc = "CCU8x.INyF"]
            VALUE6,
            #[doc = "CCU8x.INyG"]
            VALUE7,
            #[doc = "CCU8x.INyH"]
            VALUE8,
            #[doc = "CCU8x.INyI"]
            VALUE9,
            #[doc = "CCU8x.INyJ"]
            VALUE10,
            #[doc = "CCU8x.INyK"]
            VALUE11,
            #[doc = "CCU8x.INyL"]
            VALUE12,
            #[doc = "CCU8x.INyM"]
            VALUE13,
            #[doc = "CCU8x.INyN"]
            VALUE14,
            #[doc = "CCU8x.INyO"]
            VALUE15,
            #[doc = "CCU8x.INyP"]
            VALUE16,
        }
        impl EV2ISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV2ISR::VALUE1 => 0,
                    EV2ISR::VALUE2 => 0x01,
                    EV2ISR::VALUE3 => 0x02,
                    EV2ISR::VALUE4 => 0x03,
                    EV2ISR::VALUE5 => 0x04,
                    EV2ISR::VALUE6 => 0x05,
                    EV2ISR::VALUE7 => 0x06,
                    EV2ISR::VALUE8 => 0x07,
                    EV2ISR::VALUE9 => 0x08,
                    EV2ISR::VALUE10 => 0x09,
                    EV2ISR::VALUE11 => 0x0a,
                    EV2ISR::VALUE12 => 0x0b,
                    EV2ISR::VALUE13 => 0x0c,
                    EV2ISR::VALUE14 => 0x0d,
                    EV2ISR::VALUE15 => 0x0e,
                    EV2ISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV2ISR {
                match value {
                    0 => EV2ISR::VALUE1,
                    1 => EV2ISR::VALUE2,
                    2 => EV2ISR::VALUE3,
                    3 => EV2ISR::VALUE4,
                    4 => EV2ISR::VALUE5,
                    5 => EV2ISR::VALUE6,
                    6 => EV2ISR::VALUE7,
                    7 => EV2ISR::VALUE8,
                    8 => EV2ISR::VALUE9,
                    9 => EV2ISR::VALUE10,
                    10 => EV2ISR::VALUE11,
                    11 => EV2ISR::VALUE12,
                    12 => EV2ISR::VALUE13,
                    13 => EV2ISR::VALUE14,
                    14 => EV2ISR::VALUE15,
                    15 => EV2ISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV2ISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV2ISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV2ISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV2ISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == EV2ISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == EV2ISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == EV2ISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == EV2ISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == EV2ISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == EV2ISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == EV2ISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == EV2ISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == EV2ISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == EV2ISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == EV2ISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == EV2ISR::VALUE16
            }
        }
        #[doc = "Possible values of the field `EV0EM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV0EMR {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV0EMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV0EMR::VALUE1 => 0,
                    EV0EMR::VALUE2 => 0x01,
                    EV0EMR::VALUE3 => 0x02,
                    EV0EMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV0EMR {
                match value {
                    0 => EV0EMR::VALUE1,
                    1 => EV0EMR::VALUE2,
                    2 => EV0EMR::VALUE3,
                    3 => EV0EMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV0EMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV0EMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV0EMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV0EMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EV1EM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV1EMR {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV1EMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV1EMR::VALUE1 => 0,
                    EV1EMR::VALUE2 => 0x01,
                    EV1EMR::VALUE3 => 0x02,
                    EV1EMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV1EMR {
                match value {
                    0 => EV1EMR::VALUE1,
                    1 => EV1EMR::VALUE2,
                    2 => EV1EMR::VALUE3,
                    3 => EV1EMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV1EMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV1EMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV1EMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV1EMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EV2EM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV2EMR {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV2EMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EV2EMR::VALUE1 => 0,
                    EV2EMR::VALUE2 => 0x01,
                    EV2EMR::VALUE3 => 0x02,
                    EV2EMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EV2EMR {
                match value {
                    0 => EV2EMR::VALUE1,
                    1 => EV2EMR::VALUE2,
                    2 => EV2EMR::VALUE3,
                    3 => EV2EMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV2EMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV2EMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EV2EMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EV2EMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EV0LM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV0LMR {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV0LMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EV0LMR::VALUE1 => false,
                    EV0LMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EV0LMR {
                match value {
                    false => EV0LMR::VALUE1,
                    true => EV0LMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV0LMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV0LMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EV1LM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV1LMR {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV1LMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EV1LMR::VALUE1 => false,
                    EV1LMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EV1LMR {
                match value {
                    false => EV1LMR::VALUE1,
                    true => EV1LMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV1LMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV1LMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EV2LM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EV2LMR {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV2LMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EV2LMR::VALUE1 => false,
                    EV2LMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EV2LMR {
                match value {
                    false => EV2LMR::VALUE1,
                    true => EV2LMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EV2LMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EV2LMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPF0M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPF0MR {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU8"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU8"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU8"]
            VALUE4,
        }
        impl LPF0MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPF0MR::VALUE1 => 0,
                    LPF0MR::VALUE2 => 0x01,
                    LPF0MR::VALUE3 => 0x02,
                    LPF0MR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPF0MR {
                match value {
                    0 => LPF0MR::VALUE1,
                    1 => LPF0MR::VALUE2,
                    2 => LPF0MR::VALUE3,
                    3 => LPF0MR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPF0MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPF0MR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPF0MR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPF0MR::VALUE4
            }
        }
        #[doc = "Possible values of the field `LPF1M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPF1MR {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU8"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU8"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU8"]
            VALUE4,
        }
        impl LPF1MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPF1MR::VALUE1 => 0,
                    LPF1MR::VALUE2 => 0x01,
                    LPF1MR::VALUE3 => 0x02,
                    LPF1MR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPF1MR {
                match value {
                    0 => LPF1MR::VALUE1,
                    1 => LPF1MR::VALUE2,
                    2 => LPF1MR::VALUE3,
                    3 => LPF1MR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPF1MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPF1MR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPF1MR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPF1MR::VALUE4
            }
        }
        #[doc = "Possible values of the field `LPF2M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPF2MR {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU8"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU8"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU8"]
            VALUE4,
        }
        impl LPF2MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPF2MR::VALUE1 => 0,
                    LPF2MR::VALUE2 => 0x01,
                    LPF2MR::VALUE3 => 0x02,
                    LPF2MR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPF2MR {
                match value {
                    0 => LPF2MR::VALUE1,
                    1 => LPF2MR::VALUE2,
                    2 => LPF2MR::VALUE3,
                    3 => LPF2MR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPF2MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPF2MR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPF2MR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPF2MR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `EV0IS`"]
        pub enum EV0ISW {
            #[doc = "CCU8x.INyA"]
            VALUE1,
            #[doc = "CCU8x.INyB"]
            VALUE2,
            #[doc = "CCU8x.INyC"]
            VALUE3,
            #[doc = "CCU8x.INyD"]
            VALUE4,
            #[doc = "CCU8x.INyE"]
            VALUE5,
            #[doc = "CCU8x.INyF"]
            VALUE6,
            #[doc = "CCU8x.INyG"]
            VALUE7,
            #[doc = "CCU8x.INyH"]
            VALUE8,
            #[doc = "CCU8x.INyI"]
            VALUE9,
            #[doc = "CCU8x.INyJ"]
            VALUE10,
            #[doc = "CCU8x.INyK"]
            VALUE11,
            #[doc = "CCU8x.INyL"]
            VALUE12,
            #[doc = "CCU8x.INyM"]
            VALUE13,
            #[doc = "CCU8x.INyN"]
            VALUE14,
            #[doc = "CCU8x.INyO"]
            VALUE15,
            #[doc = "CCU8x.INyP"]
            VALUE16,
        }
        impl EV0ISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV0ISW::VALUE1 => 0,
                    EV0ISW::VALUE2 => 1,
                    EV0ISW::VALUE3 => 2,
                    EV0ISW::VALUE4 => 3,
                    EV0ISW::VALUE5 => 4,
                    EV0ISW::VALUE6 => 5,
                    EV0ISW::VALUE7 => 6,
                    EV0ISW::VALUE8 => 7,
                    EV0ISW::VALUE9 => 8,
                    EV0ISW::VALUE10 => 9,
                    EV0ISW::VALUE11 => 10,
                    EV0ISW::VALUE12 => 11,
                    EV0ISW::VALUE13 => 12,
                    EV0ISW::VALUE14 => 13,
                    EV0ISW::VALUE15 => 14,
                    EV0ISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV0ISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV0ISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV0ISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU8x.INyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE1)
            }
            #[doc = "CCU8x.INyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE2)
            }
            #[doc = "CCU8x.INyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE3)
            }
            #[doc = "CCU8x.INyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE4)
            }
            #[doc = "CCU8x.INyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE5)
            }
            #[doc = "CCU8x.INyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE6)
            }
            #[doc = "CCU8x.INyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE7)
            }
            #[doc = "CCU8x.INyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE8)
            }
            #[doc = "CCU8x.INyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE9)
            }
            #[doc = "CCU8x.INyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE10)
            }
            #[doc = "CCU8x.INyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE11)
            }
            #[doc = "CCU8x.INyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE12)
            }
            #[doc = "CCU8x.INyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE13)
            }
            #[doc = "CCU8x.INyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE14)
            }
            #[doc = "CCU8x.INyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE15)
            }
            #[doc = "CCU8x.INyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(EV0ISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV1IS`"]
        pub enum EV1ISW {
            #[doc = "CCU8x.INyA"]
            VALUE1,
            #[doc = "CCU8x.INyB"]
            VALUE2,
            #[doc = "CCU8x.INyC"]
            VALUE3,
            #[doc = "CCU8x.INyD"]
            VALUE4,
            #[doc = "CCU8x.INyE"]
            VALUE5,
            #[doc = "CCU8x.INyF"]
            VALUE6,
            #[doc = "CCU8x.INyG"]
            VALUE7,
            #[doc = "CCU8x.INyH"]
            VALUE8,
            #[doc = "CCU8x.INyI"]
            VALUE9,
            #[doc = "CCU8x.INyJ"]
            VALUE10,
            #[doc = "CCU8x.INyK"]
            VALUE11,
            #[doc = "CCU8x.INyL"]
            VALUE12,
            #[doc = "CCU8x.INyM"]
            VALUE13,
            #[doc = "CCU8x.INyN"]
            VALUE14,
            #[doc = "CCU8x.INyO"]
            VALUE15,
            #[doc = "CCU8x.INyP"]
            VALUE16,
        }
        impl EV1ISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV1ISW::VALUE1 => 0,
                    EV1ISW::VALUE2 => 1,
                    EV1ISW::VALUE3 => 2,
                    EV1ISW::VALUE4 => 3,
                    EV1ISW::VALUE5 => 4,
                    EV1ISW::VALUE6 => 5,
                    EV1ISW::VALUE7 => 6,
                    EV1ISW::VALUE8 => 7,
                    EV1ISW::VALUE9 => 8,
                    EV1ISW::VALUE10 => 9,
                    EV1ISW::VALUE11 => 10,
                    EV1ISW::VALUE12 => 11,
                    EV1ISW::VALUE13 => 12,
                    EV1ISW::VALUE14 => 13,
                    EV1ISW::VALUE15 => 14,
                    EV1ISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV1ISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV1ISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV1ISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU8x.INyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE1)
            }
            #[doc = "CCU8x.INyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE2)
            }
            #[doc = "CCU8x.INyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE3)
            }
            #[doc = "CCU8x.INyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE4)
            }
            #[doc = "CCU8x.INyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE5)
            }
            #[doc = "CCU8x.INyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE6)
            }
            #[doc = "CCU8x.INyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE7)
            }
            #[doc = "CCU8x.INyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE8)
            }
            #[doc = "CCU8x.INyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE9)
            }
            #[doc = "CCU8x.INyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE10)
            }
            #[doc = "CCU8x.INyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE11)
            }
            #[doc = "CCU8x.INyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE12)
            }
            #[doc = "CCU8x.INyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE13)
            }
            #[doc = "CCU8x.INyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE14)
            }
            #[doc = "CCU8x.INyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE15)
            }
            #[doc = "CCU8x.INyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(EV1ISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV2IS`"]
        pub enum EV2ISW {
            #[doc = "CCU8x.INyA"]
            VALUE1,
            #[doc = "CCU8x.INyB"]
            VALUE2,
            #[doc = "CCU8x.INyC"]
            VALUE3,
            #[doc = "CCU8x.INyD"]
            VALUE4,
            #[doc = "CCU8x.INyE"]
            VALUE5,
            #[doc = "CCU8x.INyF"]
            VALUE6,
            #[doc = "CCU8x.INyG"]
            VALUE7,
            #[doc = "CCU8x.INyH"]
            VALUE8,
            #[doc = "CCU8x.INyI"]
            VALUE9,
            #[doc = "CCU8x.INyJ"]
            VALUE10,
            #[doc = "CCU8x.INyK"]
            VALUE11,
            #[doc = "CCU8x.INyL"]
            VALUE12,
            #[doc = "CCU8x.INyM"]
            VALUE13,
            #[doc = "CCU8x.INyN"]
            VALUE14,
            #[doc = "CCU8x.INyO"]
            VALUE15,
            #[doc = "CCU8x.INyP"]
            VALUE16,
        }
        impl EV2ISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV2ISW::VALUE1 => 0,
                    EV2ISW::VALUE2 => 1,
                    EV2ISW::VALUE3 => 2,
                    EV2ISW::VALUE4 => 3,
                    EV2ISW::VALUE5 => 4,
                    EV2ISW::VALUE6 => 5,
                    EV2ISW::VALUE7 => 6,
                    EV2ISW::VALUE8 => 7,
                    EV2ISW::VALUE9 => 8,
                    EV2ISW::VALUE10 => 9,
                    EV2ISW::VALUE11 => 10,
                    EV2ISW::VALUE12 => 11,
                    EV2ISW::VALUE13 => 12,
                    EV2ISW::VALUE14 => 13,
                    EV2ISW::VALUE15 => 14,
                    EV2ISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV2ISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV2ISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV2ISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CCU8x.INyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE1)
            }
            #[doc = "CCU8x.INyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE2)
            }
            #[doc = "CCU8x.INyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE3)
            }
            #[doc = "CCU8x.INyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE4)
            }
            #[doc = "CCU8x.INyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE5)
            }
            #[doc = "CCU8x.INyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE6)
            }
            #[doc = "CCU8x.INyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE7)
            }
            #[doc = "CCU8x.INyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE8)
            }
            #[doc = "CCU8x.INyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE9)
            }
            #[doc = "CCU8x.INyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE10)
            }
            #[doc = "CCU8x.INyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE11)
            }
            #[doc = "CCU8x.INyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE12)
            }
            #[doc = "CCU8x.INyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE13)
            }
            #[doc = "CCU8x.INyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE14)
            }
            #[doc = "CCU8x.INyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE15)
            }
            #[doc = "CCU8x.INyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(EV2ISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV0EM`"]
        pub enum EV0EMW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV0EMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV0EMW::VALUE1 => 0,
                    EV0EMW::VALUE2 => 1,
                    EV0EMW::VALUE3 => 2,
                    EV0EMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV0EMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV0EMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV0EMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE1)
            }
            #[doc = "Signal active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE2)
            }
            #[doc = "Signal active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE3)
            }
            #[doc = "Signal active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV0EMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV1EM`"]
        pub enum EV1EMW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV1EMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV1EMW::VALUE1 => 0,
                    EV1EMW::VALUE2 => 1,
                    EV1EMW::VALUE3 => 2,
                    EV1EMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV1EMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV1EMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV1EMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE1)
            }
            #[doc = "Signal active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE2)
            }
            #[doc = "Signal active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE3)
            }
            #[doc = "Signal active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV1EMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV2EM`"]
        pub enum EV2EMW {
            #[doc = "No action"]
            VALUE1,
            #[doc = "Signal active on rising edge"]
            VALUE2,
            #[doc = "Signal active on falling edge"]
            VALUE3,
            #[doc = "Signal active on both edges"]
            VALUE4,
        }
        impl EV2EMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EV2EMW::VALUE1 => 0,
                    EV2EMW::VALUE2 => 1,
                    EV2EMW::VALUE3 => 2,
                    EV2EMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV2EMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV2EMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV2EMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "No action"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE1)
            }
            #[doc = "Signal active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE2)
            }
            #[doc = "Signal active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE3)
            }
            #[doc = "Signal active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EV2EMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV0LM`"]
        pub enum EV0LMW {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV0LMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EV0LMW::VALUE1 => false,
                    EV0LMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV0LMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV0LMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV0LMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active on HIGH level"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV0LMW::VALUE1)
            }
            #[doc = "Active on LOW level"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV0LMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV1LM`"]
        pub enum EV1LMW {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV1LMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EV1LMW::VALUE1 => false,
                    EV1LMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV1LMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV1LMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV1LMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active on HIGH level"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV1LMW::VALUE1)
            }
            #[doc = "Active on LOW level"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV1LMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EV2LM`"]
        pub enum EV2LMW {
            #[doc = "Active on HIGH level"]
            VALUE1,
            #[doc = "Active on LOW level"]
            VALUE2,
        }
        impl EV2LMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EV2LMW::VALUE1 => false,
                    EV2LMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EV2LMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EV2LMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EV2LMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Active on HIGH level"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EV2LMW::VALUE1)
            }
            #[doc = "Active on LOW level"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EV2LMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPF0M`"]
        pub enum LPF0MW {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU8"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU8"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU8"]
            VALUE4,
        }
        impl LPF0MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPF0MW::VALUE1 => 0,
                    LPF0MW::VALUE2 => 1,
                    LPF0MW::VALUE3 => 2,
                    LPF0MW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPF0MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPF0MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPF0MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "LPF is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE1)
            }
            #[doc = "3 clock cycles of fCCU8"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE2)
            }
            #[doc = "5 clock cycles of fCCU8"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE3)
            }
            #[doc = "7 clock cycles of fCCU8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPF0MW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPF1M`"]
        pub enum LPF1MW {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU8"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU8"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU8"]
            VALUE4,
        }
        impl LPF1MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPF1MW::VALUE1 => 0,
                    LPF1MW::VALUE2 => 1,
                    LPF1MW::VALUE3 => 2,
                    LPF1MW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPF1MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPF1MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPF1MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "LPF is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE1)
            }
            #[doc = "3 clock cycles of fCCU8"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE2)
            }
            #[doc = "5 clock cycles of fCCU8"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE3)
            }
            #[doc = "7 clock cycles of fCCU8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPF1MW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPF2M`"]
        pub enum LPF2MW {
            #[doc = "LPF is disabled"]
            VALUE1,
            #[doc = "3 clock cycles of fCCU8"]
            VALUE2,
            #[doc = "5 clock cycles of fCCU8"]
            VALUE3,
            #[doc = "7 clock cycles of fCCU8"]
            VALUE4,
        }
        impl LPF2MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPF2MW::VALUE1 => 0,
                    LPF2MW::VALUE2 => 1,
                    LPF2MW::VALUE3 => 2,
                    LPF2MW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPF2MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPF2MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPF2MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "LPF is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE1)
            }
            #[doc = "3 clock cycles of fCCU8"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE2)
            }
            #[doc = "5 clock cycles of fCCU8"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE3)
            }
            #[doc = "7 clock cycles of fCCU8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPF2MW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Event 0 signal selection"]
            #[inline]
            pub fn ev0is(&self) -> EV0ISR {
                EV0ISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Event 1 signal selection"]
            #[inline]
            pub fn ev1is(&self) -> EV1ISR {
                EV1ISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:11 - Event 2 signal selection"]
            #[inline]
            pub fn ev2is(&self) -> EV2ISR {
                EV2ISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Event 0 Edge Selection"]
            #[inline]
            pub fn ev0em(&self) -> EV0EMR {
                EV0EMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Event 1 Edge Selection"]
            #[inline]
            pub fn ev1em(&self) -> EV1EMR {
                EV1EMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Event 2 Edge Selection"]
            #[inline]
            pub fn ev2em(&self) -> EV2EMR {
                EV2EMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 22 - Event 0 Level Selection"]
            #[inline]
            pub fn ev0lm(&self) -> EV0LMR {
                EV0LMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - Event 1 Level Selection"]
            #[inline]
            pub fn ev1lm(&self) -> EV1LMR {
                EV1LMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Event 2 Level Selection"]
            #[inline]
            pub fn ev2lm(&self) -> EV2LMR {
                EV2LMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 25:26 - Event 0 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf0m(&self) -> LPF0MR {
                LPF0MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:28 - Event 1 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf1m(&self) -> LPF1MR {
                LPF1MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 29:30 - Event 2 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf2m(&self) -> LPF2MR {
                LPF2MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Event 0 signal selection"]
            #[inline]
            pub fn ev0is(&mut self) -> _EV0ISW {
                _EV0ISW { w: self }
            }
            #[doc = "Bits 4:7 - Event 1 signal selection"]
            #[inline]
            pub fn ev1is(&mut self) -> _EV1ISW {
                _EV1ISW { w: self }
            }
            #[doc = "Bits 8:11 - Event 2 signal selection"]
            #[inline]
            pub fn ev2is(&mut self) -> _EV2ISW {
                _EV2ISW { w: self }
            }
            #[doc = "Bits 16:17 - Event 0 Edge Selection"]
            #[inline]
            pub fn ev0em(&mut self) -> _EV0EMW {
                _EV0EMW { w: self }
            }
            #[doc = "Bits 18:19 - Event 1 Edge Selection"]
            #[inline]
            pub fn ev1em(&mut self) -> _EV1EMW {
                _EV1EMW { w: self }
            }
            #[doc = "Bits 20:21 - Event 2 Edge Selection"]
            #[inline]
            pub fn ev2em(&mut self) -> _EV2EMW {
                _EV2EMW { w: self }
            }
            #[doc = "Bit 22 - Event 0 Level Selection"]
            #[inline]
            pub fn ev0lm(&mut self) -> _EV0LMW {
                _EV0LMW { w: self }
            }
            #[doc = "Bit 23 - Event 1 Level Selection"]
            #[inline]
            pub fn ev1lm(&mut self) -> _EV1LMW {
                _EV1LMW { w: self }
            }
            #[doc = "Bit 24 - Event 2 Level Selection"]
            #[inline]
            pub fn ev2lm(&mut self) -> _EV2LMW {
                _EV2LMW { w: self }
            }
            #[doc = "Bits 25:26 - Event 0 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf0m(&mut self) -> _LPF0MW {
                _LPF0MW { w: self }
            }
            #[doc = "Bits 27:28 - Event 1 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf1m(&mut self) -> _LPF1MW {
                _LPF1MW { w: self }
            }
            #[doc = "Bits 29:30 - Event 2 Low Pass Filter Configuration"]
            #[inline]
            pub fn lpf2m(&mut self) -> _LPF2MW {
                _LPF2MW { w: self }
            }
        }
    }
    #[doc = "Connection Matrix Control"]
    pub struct CMC {
        register: VolatileCell<u32>,
    }
    #[doc = "Connection Matrix Control"]
    pub mod cmc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CMC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `STRTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STRTSR {
            #[doc = "External Start Function deactivated"]
            VALUE1,
            #[doc = "External Start Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Start Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Start Function triggered by Event 2"]
            VALUE4,
        }
        impl STRTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STRTSR::VALUE1 => 0,
                    STRTSR::VALUE2 => 0x01,
                    STRTSR::VALUE3 => 0x02,
                    STRTSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STRTSR {
                match value {
                    0 => STRTSR::VALUE1,
                    1 => STRTSR::VALUE2,
                    2 => STRTSR::VALUE3,
                    3 => STRTSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STRTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STRTSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STRTSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STRTSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `ENDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDSR {
            #[doc = "External Stop Function deactivated"]
            VALUE1,
            #[doc = "External Stop Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Stop Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Stop Function triggered by Event 2"]
            VALUE4,
        }
        impl ENDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENDSR::VALUE1 => 0,
                    ENDSR::VALUE2 => 0x01,
                    ENDSR::VALUE3 => 0x02,
                    ENDSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENDSR {
                match value {
                    0 => ENDSR::VALUE1,
                    1 => ENDSR::VALUE2,
                    2 => ENDSR::VALUE3,
                    3 => ENDSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENDSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == ENDSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CAP0S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CAP0SR {
            #[doc = "External Capture 0 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 0 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 0 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 0 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP0SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CAP0SR::VALUE1 => 0,
                    CAP0SR::VALUE2 => 0x01,
                    CAP0SR::VALUE3 => 0x02,
                    CAP0SR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CAP0SR {
                match value {
                    0 => CAP0SR::VALUE1,
                    1 => CAP0SR::VALUE2,
                    2 => CAP0SR::VALUE3,
                    3 => CAP0SR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CAP0SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CAP0SR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CAP0SR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CAP0SR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CAP1S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CAP1SR {
            #[doc = "External Capture 1 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 1 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 1 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 1 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP1SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CAP1SR::VALUE1 => 0,
                    CAP1SR::VALUE2 => 0x01,
                    CAP1SR::VALUE3 => 0x02,
                    CAP1SR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CAP1SR {
                match value {
                    0 => CAP1SR::VALUE1,
                    1 => CAP1SR::VALUE2,
                    2 => CAP1SR::VALUE3,
                    3 => CAP1SR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CAP1SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CAP1SR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CAP1SR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CAP1SR::VALUE4
            }
        }
        #[doc = "Possible values of the field `GATES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GATESR {
            #[doc = "External Gating Function deactivated"]
            VALUE1,
            #[doc = "External Gating Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Gating Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Gating Function triggered by Event 2"]
            VALUE4,
        }
        impl GATESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    GATESR::VALUE1 => 0,
                    GATESR::VALUE2 => 0x01,
                    GATESR::VALUE3 => 0x02,
                    GATESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> GATESR {
                match value {
                    0 => GATESR::VALUE1,
                    1 => GATESR::VALUE2,
                    2 => GATESR::VALUE3,
                    3 => GATESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GATESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GATESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == GATESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == GATESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `UDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum UDSR {
            #[doc = "External Up/Down Function deactivated"]
            VALUE1,
            #[doc = "External Up/Down Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Up/Down Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Up/Down Function triggered by Event 2"]
            VALUE4,
        }
        impl UDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    UDSR::VALUE1 => 0,
                    UDSR::VALUE2 => 0x01,
                    UDSR::VALUE3 => 0x02,
                    UDSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> UDSR {
                match value {
                    0 => UDSR::VALUE1,
                    1 => UDSR::VALUE2,
                    2 => UDSR::VALUE3,
                    3 => UDSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == UDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == UDSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == UDSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == UDSR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct LDSR {
            bits: u8,
        }
        impl LDSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `CNTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CNTSR {
            #[doc = "External Count Function deactivated"]
            VALUE1,
            #[doc = "External Count Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Count Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Count Function triggered by Event 2"]
            VALUE4,
        }
        impl CNTSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CNTSR::VALUE1 => 0,
                    CNTSR::VALUE2 => 0x01,
                    CNTSR::VALUE3 => 0x02,
                    CNTSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CNTSR {
                match value {
                    0 => CNTSR::VALUE1,
                    1 => CNTSR::VALUE2,
                    2 => CNTSR::VALUE3,
                    3 => CNTSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CNTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CNTSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CNTSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CNTSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `OFS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OFSR {
            #[doc = "Override functionality disabled"]
            VALUE1,
            #[doc = "Status bit trigger override connected to Event 1; Status bit value override connected to Event 2"]
            VALUE2,
        }
        impl OFSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OFSR::VALUE1 => false,
                    OFSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OFSR {
                match value {
                    false => OFSR::VALUE1,
                    true => OFSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OFSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OFSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSR {
            #[doc = "Trap function disabled"]
            VALUE1,
            #[doc = "TRAP function connected to Event 2"]
            VALUE2,
        }
        impl TSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSR::VALUE1 => false,
                    TSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSR {
                match value {
                    false => TSR::VALUE1,
                    true => TSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct MOSR {
            bits: u8,
        }
        impl MOSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `TCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TCER {
            #[doc = "Timer concatenation is disabled"]
            VALUE1,
            #[doc = "Timer concatenation is enabled"]
            VALUE2,
        }
        impl TCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TCER::VALUE1 => false,
                    TCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TCER {
                match value {
                    false => TCER::VALUE1,
                    true => TCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TCER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `STRTS`"]
        pub enum STRTSW {
            #[doc = "External Start Function deactivated"]
            VALUE1,
            #[doc = "External Start Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Start Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Start Function triggered by Event 2"]
            VALUE4,
        }
        impl STRTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STRTSW::VALUE1 => 0,
                    STRTSW::VALUE2 => 1,
                    STRTSW::VALUE3 => 2,
                    STRTSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STRTSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Start Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STRTSW::VALUE1)
            }
            #[doc = "External Start Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STRTSW::VALUE2)
            }
            #[doc = "External Start Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STRTSW::VALUE3)
            }
            #[doc = "External Start Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STRTSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENDS`"]
        pub enum ENDSW {
            #[doc = "External Stop Function deactivated"]
            VALUE1,
            #[doc = "External Stop Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Stop Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Stop Function triggered by Event 2"]
            VALUE4,
        }
        impl ENDSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENDSW::VALUE1 => 0,
                    ENDSW::VALUE2 => 1,
                    ENDSW::VALUE3 => 2,
                    ENDSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENDSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENDSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Stop Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENDSW::VALUE1)
            }
            #[doc = "External Stop Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENDSW::VALUE2)
            }
            #[doc = "External Stop Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENDSW::VALUE3)
            }
            #[doc = "External Stop Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(ENDSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAP0S`"]
        pub enum CAP0SW {
            #[doc = "External Capture 0 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 0 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 0 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 0 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP0SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CAP0SW::VALUE1 => 0,
                    CAP0SW::VALUE2 => 1,
                    CAP0SW::VALUE3 => 2,
                    CAP0SW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAP0SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAP0SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAP0SW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Capture 0 Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE1)
            }
            #[doc = "External Capture 0 Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE2)
            }
            #[doc = "External Capture 0 Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE3)
            }
            #[doc = "External Capture 0 Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CAP0SW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAP1S`"]
        pub enum CAP1SW {
            #[doc = "External Capture 1 Function deactivated"]
            VALUE1,
            #[doc = "External Capture 1 Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Capture 1 Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Capture 1 Function triggered by Event 2"]
            VALUE4,
        }
        impl CAP1SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CAP1SW::VALUE1 => 0,
                    CAP1SW::VALUE2 => 1,
                    CAP1SW::VALUE3 => 2,
                    CAP1SW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAP1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAP1SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAP1SW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Capture 1 Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE1)
            }
            #[doc = "External Capture 1 Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE2)
            }
            #[doc = "External Capture 1 Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE3)
            }
            #[doc = "External Capture 1 Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CAP1SW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GATES`"]
        pub enum GATESW {
            #[doc = "External Gating Function deactivated"]
            VALUE1,
            #[doc = "External Gating Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Gating Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Gating Function triggered by Event 2"]
            VALUE4,
        }
        impl GATESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GATESW::VALUE1 => 0,
                    GATESW::VALUE2 => 1,
                    GATESW::VALUE3 => 2,
                    GATESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GATESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GATESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GATESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Gating Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GATESW::VALUE1)
            }
            #[doc = "External Gating Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GATESW::VALUE2)
            }
            #[doc = "External Gating Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(GATESW::VALUE3)
            }
            #[doc = "External Gating Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(GATESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `UDS`"]
        pub enum UDSW {
            #[doc = "External Up/Down Function deactivated"]
            VALUE1,
            #[doc = "External Up/Down Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Up/Down Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Up/Down Function triggered by Event 2"]
            VALUE4,
        }
        impl UDSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    UDSW::VALUE1 => 0,
                    UDSW::VALUE2 => 1,
                    UDSW::VALUE3 => 2,
                    UDSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _UDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UDSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: UDSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Up/Down Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(UDSW::VALUE1)
            }
            #[doc = "External Up/Down Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(UDSW::VALUE2)
            }
            #[doc = "External Up/Down Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(UDSW::VALUE3)
            }
            #[doc = "External Up/Down Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(UDSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _LDSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LDSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CNTS`"]
        pub enum CNTSW {
            #[doc = "External Count Function deactivated"]
            VALUE1,
            #[doc = "External Count Function triggered by Event 0"]
            VALUE2,
            #[doc = "External Count Function triggered by Event 1"]
            VALUE3,
            #[doc = "External Count Function triggered by Event 2"]
            VALUE4,
        }
        impl CNTSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CNTSW::VALUE1 => 0,
                    CNTSW::VALUE2 => 1,
                    CNTSW::VALUE3 => 2,
                    CNTSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNTSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNTSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CNTSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Count Function deactivated"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CNTSW::VALUE1)
            }
            #[doc = "External Count Function triggered by Event 0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CNTSW::VALUE2)
            }
            #[doc = "External Count Function triggered by Event 1"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CNTSW::VALUE3)
            }
            #[doc = "External Count Function triggered by Event 2"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CNTSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OFS`"]
        pub enum OFSW {
            #[doc = "Override functionality disabled"]
            VALUE1,
            #[doc = "Status bit trigger override connected to Event 1; Status bit value override connected to Event 2"]
            VALUE2,
        }
        impl OFSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OFSW::VALUE1 => false,
                    OFSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OFSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OFSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Override functionality disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OFSW::VALUE1)
            }
            #[doc = "Status bit trigger override connected to Event 1; Status bit value override connected to Event 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OFSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TS`"]
        pub enum TSW {
            #[doc = "Trap function disabled"]
            VALUE1,
            #[doc = "TRAP function connected to Event 2"]
            VALUE2,
        }
        impl TSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSW::VALUE1 => false,
                    TSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSW::VALUE1)
            }
            #[doc = "TRAP function connected to Event 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MOSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MOSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TCE`"]
        pub enum TCEW {
            #[doc = "Timer concatenation is disabled"]
            VALUE1,
            #[doc = "Timer concatenation is enabled"]
            VALUE2,
        }
        impl TCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TCEW::VALUE1 => false,
                    TCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Timer concatenation is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TCEW::VALUE1)
            }
            #[doc = "Timer concatenation is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - External Start Functionality Selector"]
            #[inline]
            pub fn strts(&self) -> STRTSR {
                STRTSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - External Stop Functionality Selector"]
            #[inline]
            pub fn ends(&self) -> ENDSR {
                ENDSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - External Capture 0 Functionality Selector"]
            #[inline]
            pub fn cap0s(&self) -> CAP0SR {
                CAP0SR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - External Capture 1 Functionality Selector"]
            #[inline]
            pub fn cap1s(&self) -> CAP1SR {
                CAP1SR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - External Gate Functionality Selector"]
            #[inline]
            pub fn gates(&self) -> GATESR {
                GATESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - External Up/Down Functionality Selector"]
            #[inline]
            pub fn uds(&self) -> UDSR {
                UDSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - External Timer Load Functionality Selector"]
            #[inline]
            pub fn lds(&self) -> LDSR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LDSR { bits }
            }
            #[doc = "Bits 14:15 - External Count Selector"]
            #[inline]
            pub fn cnts(&self) -> CNTSR {
                CNTSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Override Function Selector"]
            #[inline]
            pub fn ofs(&self) -> OFSR {
                OFSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Trap Function Selector"]
            #[inline]
            pub fn ts(&self) -> TSR {
                TSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:19 - External Modulation Functionality Selector"]
            #[inline]
            pub fn mos(&self) -> MOSR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MOSR { bits }
            }
            #[doc = "Bit 20 - Timer Concatenation Enable"]
            #[inline]
            pub fn tce(&self) -> TCER {
                TCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - External Start Functionality Selector"]
            #[inline]
            pub fn strts(&mut self) -> _STRTSW {
                _STRTSW { w: self }
            }
            #[doc = "Bits 2:3 - External Stop Functionality Selector"]
            #[inline]
            pub fn ends(&mut self) -> _ENDSW {
                _ENDSW { w: self }
            }
            #[doc = "Bits 4:5 - External Capture 0 Functionality Selector"]
            #[inline]
            pub fn cap0s(&mut self) -> _CAP0SW {
                _CAP0SW { w: self }
            }
            #[doc = "Bits 6:7 - External Capture 1 Functionality Selector"]
            #[inline]
            pub fn cap1s(&mut self) -> _CAP1SW {
                _CAP1SW { w: self }
            }
            #[doc = "Bits 8:9 - External Gate Functionality Selector"]
            #[inline]
            pub fn gates(&mut self) -> _GATESW {
                _GATESW { w: self }
            }
            #[doc = "Bits 10:11 - External Up/Down Functionality Selector"]
            #[inline]
            pub fn uds(&mut self) -> _UDSW {
                _UDSW { w: self }
            }
            #[doc = "Bits 12:13 - External Timer Load Functionality Selector"]
            #[inline]
            pub fn lds(&mut self) -> _LDSW {
                _LDSW { w: self }
            }
            #[doc = "Bits 14:15 - External Count Selector"]
            #[inline]
            pub fn cnts(&mut self) -> _CNTSW {
                _CNTSW { w: self }
            }
            #[doc = "Bit 16 - Override Function Selector"]
            #[inline]
            pub fn ofs(&mut self) -> _OFSW {
                _OFSW { w: self }
            }
            #[doc = "Bit 17 - Trap Function Selector"]
            #[inline]
            pub fn ts(&mut self) -> _TSW {
                _TSW { w: self }
            }
            #[doc = "Bits 18:19 - External Modulation Functionality Selector"]
            #[inline]
            pub fn mos(&mut self) -> _MOSW {
                _MOSW { w: self }
            }
            #[doc = "Bit 20 - Timer Concatenation Enable"]
            #[inline]
            pub fn tce(&mut self) -> _TCEW {
                _TCEW { w: self }
            }
        }
    }
    #[doc = "Slice Timer Status"]
    pub struct TCST {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Status"]
    pub mod tcst {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::TCST {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `TRB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRBR {
            #[doc = "Timer is stopped"]
            VALUE1,
            #[doc = "Timer is running"]
            VALUE2,
        }
        impl TRBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRBR::VALUE1 => false,
                    TRBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRBR {
                match value {
                    false => TRBR::VALUE1,
                    true => TRBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CDIR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CDIRR {
            #[doc = "Timer is counting up"]
            VALUE1,
            #[doc = "Timer is counting down"]
            VALUE2,
        }
        impl CDIRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CDIRR::VALUE1 => false,
                    CDIRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CDIRR {
                match value {
                    false => CDIRR::VALUE1,
                    true => CDIRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CDIRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CDIRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DTR1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTR1R {
            #[doc = "Dead Time counter is idle"]
            VALUE1,
            #[doc = "Dead Time counter is running"]
            VALUE2,
        }
        impl DTR1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTR1R::VALUE1 => false,
                    DTR1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTR1R {
                match value {
                    false => DTR1R::VALUE1,
                    true => DTR1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTR1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTR1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DTR2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTR2R {
            #[doc = "Dead Time counter is idle"]
            VALUE1,
            #[doc = "Dead Time counter is running"]
            VALUE2,
        }
        impl DTR2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTR2R::VALUE1 => false,
                    DTR2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTR2R {
                match value {
                    false => DTR2R::VALUE1,
                    true => DTR2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTR2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTR2R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Timer Run Bit"]
            #[inline]
            pub fn trb(&self) -> TRBR {
                TRBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Timer Counting Direction"]
            #[inline]
            pub fn cdir(&self) -> CDIRR {
                CDIRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Dead Time Counter 1 Run bit"]
            #[inline]
            pub fn dtr1(&self) -> DTR1R {
                DTR1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Dead Time Counter 2 Run bit"]
            #[inline]
            pub fn dtr2(&self) -> DTR2R {
                DTR2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Slice Timer Run Set"]
    pub struct TCSET {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Run Set"]
    pub mod tcset {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TCSET {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRBSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRBSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Timer Run Bit set"]
            #[inline]
            pub fn trbs(&mut self) -> _TRBSW {
                _TRBSW { w: self }
            }
        }
    }
    #[doc = "Slice Timer Clear"]
    pub struct TCCLR {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Clear"]
    pub mod tcclr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TCCLR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRBCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRBCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TCCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TCCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DITCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DITCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTC1CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTC1CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTC2CW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTC2CW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Timer Run Bit Clear"]
            #[inline]
            pub fn trbc(&mut self) -> _TRBCW {
                _TRBCW { w: self }
            }
            #[doc = "Bit 1 - Timer Clear"]
            #[inline]
            pub fn tcc(&mut self) -> _TCCW {
                _TCCW { w: self }
            }
            #[doc = "Bit 2 - Dither Counter Clear"]
            #[inline]
            pub fn ditc(&mut self) -> _DITCW {
                _DITCW { w: self }
            }
            #[doc = "Bit 3 - Dead Time Counter 1 Clear"]
            #[inline]
            pub fn dtc1c(&mut self) -> _DTC1CW {
                _DTC1CW { w: self }
            }
            #[doc = "Bit 4 - Dead Time Counter 2 Clear"]
            #[inline]
            pub fn dtc2c(&mut self) -> _DTC2CW {
                _DTC2CW { w: self }
            }
        }
    }
    #[doc = "Slice Timer Control"]
    pub struct TC {
        register: VolatileCell<u32>,
    }
    #[doc = "Slice Timer Control"]
    pub mod tc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `TCM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TCMR {
            #[doc = "Edge aligned mode"]
            VALUE1,
            #[doc = "Center aligned mode"]
            VALUE2,
        }
        impl TCMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TCMR::VALUE1 => false,
                    TCMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TCMR {
                match value {
                    false => TCMR::VALUE1,
                    true => TCMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TCMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TCMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TSSM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSSMR {
            #[doc = "Single shot mode is disabled"]
            VALUE1,
            #[doc = "Single shot mode is enabled"]
            VALUE2,
        }
        impl TSSMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TSSMR::VALUE1 => false,
                    TSSMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TSSMR {
                match value {
                    false => TSSMR::VALUE1,
                    true => TSSMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSSMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSSMR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct CLSTR {
            bits: bool,
        }
        impl CLSTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `CMOD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMODR {
            #[doc = "Compare Mode"]
            VALUE1,
            #[doc = "Capture Mode"]
            VALUE2,
        }
        impl CMODR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMODR::VALUE1 => false,
                    CMODR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMODR {
                match value {
                    false => CMODR::VALUE1,
                    true => CMODR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMODR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMODR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ECM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ECMR {
            #[doc = "Normal Capture Mode. Clear of the Full Flag of each capture register is done by accessing the registers individually only."]
            VALUE1,
            #[doc = "Extended Capture Mode. Clear of the Full Flag of each capture register is done not only by accessing the individual registers but also by accessing the ECRDThis register holds the information related to the extended capture mode. register. When reading the ECRDThis register holds the information related to the extended capture mode. register, only the capture register register full flag pointed by the ECRDThis register holds the information related to the extended capture mode..VPTR is cleared"]
            VALUE2,
        }
        impl ECMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ECMR::VALUE1 => false,
                    ECMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ECMR {
                match value {
                    false => ECMR::VALUE1,
                    true => ECMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ECMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ECMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CAPC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CAPCR {
            #[doc = "Timer is never cleared on a capture event"]
            VALUE1,
            #[doc = "Timer is cleared on a capture event into capture registers 2 and 3. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE2,
            #[doc = "Timer is cleared on a capture event into capture registers 0 and 1. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE3,
            #[doc = "Timer is always cleared in a capture event."]
            VALUE4,
        }
        impl CAPCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CAPCR::VALUE1 => 0,
                    CAPCR::VALUE2 => 0x01,
                    CAPCR::VALUE3 => 0x02,
                    CAPCR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CAPCR {
                match value {
                    0 => CAPCR::VALUE1,
                    1 => CAPCR::VALUE2,
                    2 => CAPCR::VALUE3,
                    3 => CAPCR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CAPCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CAPCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CAPCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CAPCR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TLSR {
            #[doc = "Timer is loaded with the value of CR1"]
            VALUE1,
            #[doc = "Timer is loaded with the value of CR2"]
            VALUE2,
        }
        impl TLSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TLSR::VALUE1 => false,
                    TLSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TLSR {
                match value {
                    false => TLSR::VALUE1,
                    true => TLSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TLSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ENDM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ENDMR {
            #[doc = "Clears the timer run bit only (default stop)"]
            VALUE1,
            #[doc = "Clears the timer only (flush)"]
            VALUE2,
            #[doc = "Clears the timer and run bit (flush/stop)"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ENDMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ENDMR::VALUE1 => 0,
                    ENDMR::VALUE2 => 0x01,
                    ENDMR::VALUE3 => 0x02,
                    ENDMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ENDMR {
                match value {
                    0 => ENDMR::VALUE1,
                    1 => ENDMR::VALUE2,
                    2 => ENDMR::VALUE3,
                    i => ENDMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ENDMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ENDMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ENDMR::VALUE3
            }
        }
        #[doc = "Possible values of the field `STRM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STRMR {
            #[doc = "Sets run bit only (default start)"]
            VALUE1,
            #[doc = "Clears the timer and sets run bit, if not set (flush/start)"]
            VALUE2,
        }
        impl STRMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STRMR::VALUE1 => false,
                    STRMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STRMR {
                match value {
                    false => STRMR::VALUE1,
                    true => STRMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STRMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STRMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SCE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCER {
            #[doc = "Capture into CC8yC0VThis register contains the values associated with the Capture 0 field./CC8yC1VThis register contains the values associated with the Capture 1 field. registers control by CCycapt0 and capture into CC8yC3VThis register contains the values associated with the Capture 3 field./CC8yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE1,
            #[doc = "Capture into CC8yC0VThis register contains the values associated with the Capture 0 field./CC8yC1VThis register contains the values associated with the Capture 1 field. and CC8yC3VThis register contains the values associated with the Capture 3 field./CC8yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE2,
        }
        impl SCER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SCER::VALUE1 => false,
                    SCER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SCER {
                match value {
                    false => SCER::VALUE1,
                    true => SCER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CCS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CCSR {
            #[doc = "The capture into a specific capture register is done with the rules linked with the full flags, described at ."]
            VALUE1,
            #[doc = "The capture into the capture registers is always done regardless of the full flag status (even if the register has not been read back)."]
            VALUE2,
        }
        impl CCSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CCSR::VALUE1 => false,
                    CCSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CCSR {
                match value {
                    false => CCSR::VALUE1,
                    true => CCSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CCSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CCSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DITHE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DITHER {
            #[doc = "Dither is disabled"]
            VALUE1,
            #[doc = "Dither is applied to the Period"]
            VALUE2,
            #[doc = "Dither is applied to the Compare"]
            VALUE3,
            #[doc = "Dither is applied to the Period and Compare"]
            VALUE4,
        }
        impl DITHER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DITHER::VALUE1 => 0,
                    DITHER::VALUE2 => 0x01,
                    DITHER::VALUE3 => 0x02,
                    DITHER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DITHER {
                match value {
                    0 => DITHER::VALUE1,
                    1 => DITHER::VALUE2,
                    2 => DITHER::VALUE3,
                    3 => DITHER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DITHER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DITHER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DITHER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DITHER::VALUE4
            }
        }
        #[doc = "Possible values of the field `DIM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIMR {
            #[doc = "Slice is using it own dither unit"]
            VALUE1,
            #[doc = "Slice is connected to the dither unit of slice 0."]
            VALUE2,
        }
        impl DIMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIMR::VALUE1 => false,
                    DIMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIMR {
                match value {
                    false => DIMR::VALUE1,
                    true => DIMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `FPE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FPER {
            #[doc = "Floating prescaler mode is disabled"]
            VALUE1,
            #[doc = "Floating prescaler mode is enabled"]
            VALUE2,
        }
        impl FPER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FPER::VALUE1 => false,
                    FPER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FPER {
                match value {
                    false => FPER::VALUE1,
                    true => FPER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FPER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FPER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRAPE0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRAPE0R {
            #[doc = "TRAP functionality has no effect on the CCU8x.OUTy0 output"]
            VALUE1,
            #[doc = "TRAP functionality affects the CCU8x.OUTy0 output"]
            VALUE2,
        }
        impl TRAPE0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRAPE0R::VALUE1 => false,
                    TRAPE0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRAPE0R {
                match value {
                    false => TRAPE0R::VALUE1,
                    true => TRAPE0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRAPE0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRAPE0R::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRAPE1R {
            bits: bool,
        }
        impl TRAPE1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRAPE2R {
            bits: bool,
        }
        impl TRAPE2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRAPE3R {
            bits: bool,
        }
        impl TRAPE3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `TRPSE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRPSER {
            #[doc = "Exiting from TRAP state isn't synchronized with the PWM signal"]
            VALUE1,
            #[doc = "Exiting from TRAP state is synchronized with the PWM signal"]
            VALUE2,
        }
        impl TRPSER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRPSER::VALUE1 => false,
                    TRPSER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRPSER {
                match value {
                    false => TRPSER::VALUE1,
                    true => TRPSER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRPSER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRPSER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRPSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRPSWR {
            #[doc = "The slice exits the TRAP state automatically when the TRAP condition is not present (Trap state cleared by HW and SW)"]
            VALUE1,
            #[doc = "The TRAP state can only be exited by a SW request."]
            VALUE2,
        }
        impl TRPSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRPSWR::VALUE1 => false,
                    TRPSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRPSWR {
                match value {
                    false => TRPSWR::VALUE1,
                    true => TRPSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRPSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRPSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMSR {
            #[doc = "External Modulation functionality is not synchronized with the PWM signal"]
            VALUE1,
            #[doc = "External Modulation functionality is synchronized with the PWM signal"]
            VALUE2,
        }
        impl EMSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMSR::VALUE1 => false,
                    EMSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMSR {
                match value {
                    false => EMSR::VALUE1,
                    true => EMSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMTR {
            #[doc = "External Modulation functionality is clearing the CC8ySTx bits."]
            VALUE1,
            #[doc = "External Modulation functionality is gating the outputs."]
            VALUE2,
        }
        impl EMTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMTR::VALUE1 => false,
                    EMTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMTR {
                match value {
                    false => EMTR::VALUE1,
                    true => EMTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCME1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCME1R {
            #[doc = "Multi Channel Mode in Channel 1 is disabled"]
            VALUE1,
            #[doc = "Multi Channel Mode in Channel 1 is enabled"]
            VALUE2,
        }
        impl MCME1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCME1R::VALUE1 => false,
                    MCME1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCME1R {
                match value {
                    false => MCME1R::VALUE1,
                    true => MCME1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCME1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCME1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `MCME2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCME2R {
            #[doc = "Multi Channel Mode in Channel 2 is disabled"]
            VALUE1,
            #[doc = "Multi Channel Mode in Channel 2 is enabled"]
            VALUE2,
        }
        impl MCME2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCME2R::VALUE1 => false,
                    MCME2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCME2R {
                match value {
                    false => MCME2R::VALUE1,
                    true => MCME2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCME2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCME2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `EME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMER {
            #[doc = "External Modulation functionality doesn't affect any channel"]
            VALUE1,
            #[doc = "External Modulation only applied on channel 1"]
            VALUE2,
            #[doc = "External Modulation only applied on channel 2"]
            VALUE3,
            #[doc = "External Modulation applied on both channels"]
            VALUE4,
        }
        impl EMER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EMER::VALUE1 => 0,
                    EMER::VALUE2 => 0x01,
                    EMER::VALUE3 => 0x02,
                    EMER::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EMER {
                match value {
                    0 => EMER::VALUE1,
                    1 => EMER::VALUE2,
                    2 => EMER::VALUE3,
                    3 => EMER::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMER::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EMER::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EMER::VALUE4
            }
        }
        #[doc = "Possible values of the field `STOS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STOSR {
            #[doc = "CC8yST1 forward to CCU8x.STy"]
            VALUE1,
            #[doc = "CC8yST2 forward to CCU8x.STy"]
            VALUE2,
            #[doc = "CC8yST1 AND CC8yST2 forward to CCU8x.STy"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl STOSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STOSR::VALUE1 => 0,
                    STOSR::VALUE2 => 0x01,
                    STOSR::VALUE3 => 0x02,
                    STOSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STOSR {
                match value {
                    0 => STOSR::VALUE1,
                    1 => STOSR::VALUE2,
                    2 => STOSR::VALUE3,
                    i => STOSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STOSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STOSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STOSR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `TCM`"]
        pub enum TCMW {
            #[doc = "Edge aligned mode"]
            VALUE1,
            #[doc = "Center aligned mode"]
            VALUE2,
        }
        impl TCMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TCMW::VALUE1 => false,
                    TCMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TCMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TCMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TCMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Edge aligned mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TCMW::VALUE1)
            }
            #[doc = "Center aligned mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TCMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSSM`"]
        pub enum TSSMW {
            #[doc = "Single shot mode is disabled"]
            VALUE1,
            #[doc = "Single shot mode is enabled"]
            VALUE2,
        }
        impl TSSMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TSSMW::VALUE1 => false,
                    TSSMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSSMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSSMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Single shot mode is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSSMW::VALUE1)
            }
            #[doc = "Single shot mode is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSSMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ECM`"]
        pub enum ECMW {
            #[doc = "Normal Capture Mode. Clear of the Full Flag of each capture register is done by accessing the registers individually only."]
            VALUE1,
            #[doc = "Extended Capture Mode. Clear of the Full Flag of each capture register is done not only by accessing the individual registers but also by accessing the ECRDThis register holds the information related to the extended capture mode. register. When reading the ECRDThis register holds the information related to the extended capture mode. register, only the capture register register full flag pointed by the ECRDThis register holds the information related to the extended capture mode..VPTR is cleared"]
            VALUE2,
        }
        impl ECMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ECMW::VALUE1 => false,
                    ECMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ECMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ECMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ECMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Normal Capture Mode. Clear of the Full Flag of each capture register is done by accessing the registers individually only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ECMW::VALUE1)
            }
            #[doc = "Extended Capture Mode. Clear of the Full Flag of each capture register is done not only by accessing the individual registers but also by accessing the ECRDThis register holds the information related to the extended capture mode. register. When reading the ECRDThis register holds the information related to the extended capture mode. register, only the capture register register full flag pointed by the ECRDThis register holds the information related to the extended capture mode..VPTR is cleared"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ECMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CAPC`"]
        pub enum CAPCW {
            #[doc = "Timer is never cleared on a capture event"]
            VALUE1,
            #[doc = "Timer is cleared on a capture event into capture registers 2 and 3. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE2,
            #[doc = "Timer is cleared on a capture event into capture registers 0 and 1. (When SCE = 1#, Timer is always cleared in a capture event)"]
            VALUE3,
            #[doc = "Timer is always cleared in a capture event."]
            VALUE4,
        }
        impl CAPCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CAPCW::VALUE1 => 0,
                    CAPCW::VALUE2 => 1,
                    CAPCW::VALUE3 => 2,
                    CAPCW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CAPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CAPCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CAPCW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Timer is never cleared on a capture event"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CAPCW::VALUE1)
            }
            #[doc = "Timer is cleared on a capture event into capture registers 2 and 3. (When SCE = 1#, Timer is always cleared in a capture event)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CAPCW::VALUE2)
            }
            #[doc = "Timer is cleared on a capture event into capture registers 0 and 1. (When SCE = 1#, Timer is always cleared in a capture event)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CAPCW::VALUE3)
            }
            #[doc = "Timer is always cleared in a capture event."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CAPCW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TLS`"]
        pub enum TLSW {
            #[doc = "Timer is loaded with the value of CR1"]
            VALUE1,
            #[doc = "Timer is loaded with the value of CR2"]
            VALUE2,
        }
        impl TLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TLSW::VALUE1 => false,
                    TLSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TLSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Timer is loaded with the value of CR1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TLSW::VALUE1)
            }
            #[doc = "Timer is loaded with the value of CR2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TLSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ENDM`"]
        pub enum ENDMW {
            #[doc = "Clears the timer run bit only (default stop)"]
            VALUE1,
            #[doc = "Clears the timer only (flush)"]
            VALUE2,
            #[doc = "Clears the timer and run bit (flush/stop)"]
            VALUE3,
        }
        impl ENDMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ENDMW::VALUE1 => 0,
                    ENDMW::VALUE2 => 1,
                    ENDMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ENDMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ENDMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ENDMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Clears the timer run bit only (default stop)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ENDMW::VALUE1)
            }
            #[doc = "Clears the timer only (flush)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ENDMW::VALUE2)
            }
            #[doc = "Clears the timer and run bit (flush/stop)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ENDMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STRM`"]
        pub enum STRMW {
            #[doc = "Sets run bit only (default start)"]
            VALUE1,
            #[doc = "Clears the timer and sets run bit, if not set (flush/start)"]
            VALUE2,
        }
        impl STRMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STRMW::VALUE1 => false,
                    STRMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STRMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Sets run bit only (default start)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STRMW::VALUE1)
            }
            #[doc = "Clears the timer and sets run bit, if not set (flush/start)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STRMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCE`"]
        pub enum SCEW {
            #[doc = "Capture into CC8yC0VThis register contains the values associated with the Capture 0 field./CC8yC1VThis register contains the values associated with the Capture 1 field. registers control by CCycapt0 and capture into CC8yC3VThis register contains the values associated with the Capture 3 field./CC8yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE1,
            #[doc = "Capture into CC8yC0VThis register contains the values associated with the Capture 0 field./CC8yC1VThis register contains the values associated with the Capture 1 field. and CC8yC3VThis register contains the values associated with the Capture 3 field./CC8yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            VALUE2,
        }
        impl SCEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SCEW::VALUE1 => false,
                    SCEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Capture into CC8yC0VThis register contains the values associated with the Capture 0 field./CC8yC1VThis register contains the values associated with the Capture 1 field. registers control by CCycapt0 and capture into CC8yC3VThis register contains the values associated with the Capture 3 field./CC8yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCEW::VALUE1)
            }
            #[doc = "Capture into CC8yC0VThis register contains the values associated with the Capture 0 field./CC8yC1VThis register contains the values associated with the Capture 1 field. and CC8yC3VThis register contains the values associated with the Capture 3 field./CC8yC2VThis register contains the values associated with the Capture 2 field. control by CCycapt1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CCS`"]
        pub enum CCSW {
            #[doc = "The capture into a specific capture register is done with the rules linked with the full flags, described at ."]
            VALUE1,
            #[doc = "The capture into the capture registers is always done regardless of the full flag status (even if the register has not been read back)."]
            VALUE2,
        }
        impl CCSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CCSW::VALUE1 => false,
                    CCSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CCSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The capture into a specific capture register is done with the rules linked with the full flags, described at ."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CCSW::VALUE1)
            }
            #[doc = "The capture into the capture registers is always done regardless of the full flag status (even if the register has not been read back)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CCSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DITHE`"]
        pub enum DITHEW {
            #[doc = "Dither is disabled"]
            VALUE1,
            #[doc = "Dither is applied to the Period"]
            VALUE2,
            #[doc = "Dither is applied to the Compare"]
            VALUE3,
            #[doc = "Dither is applied to the Period and Compare"]
            VALUE4,
        }
        impl DITHEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DITHEW::VALUE1 => 0,
                    DITHEW::VALUE2 => 1,
                    DITHEW::VALUE3 => 2,
                    DITHEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DITHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DITHEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DITHEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Dither is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DITHEW::VALUE1)
            }
            #[doc = "Dither is applied to the Period"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DITHEW::VALUE2)
            }
            #[doc = "Dither is applied to the Compare"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DITHEW::VALUE3)
            }
            #[doc = "Dither is applied to the Period and Compare"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DITHEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIM`"]
        pub enum DIMW {
            #[doc = "Slice is using it own dither unit"]
            VALUE1,
            #[doc = "Slice is connected to the dither unit of slice 0."]
            VALUE2,
        }
        impl DIMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIMW::VALUE1 => false,
                    DIMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Slice is using it own dither unit"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIMW::VALUE1)
            }
            #[doc = "Slice is connected to the dither unit of slice 0."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FPE`"]
        pub enum FPEW {
            #[doc = "Floating prescaler mode is disabled"]
            VALUE1,
            #[doc = "Floating prescaler mode is enabled"]
            VALUE2,
        }
        impl FPEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FPEW::VALUE1 => false,
                    FPEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FPEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FPEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FPEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Floating prescaler mode is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FPEW::VALUE1)
            }
            #[doc = "Floating prescaler mode is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FPEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRAPE0`"]
        pub enum TRAPE0W {
            #[doc = "TRAP functionality has no effect on the CCU8x.OUTy0 output"]
            VALUE1,
            #[doc = "TRAP functionality affects the CCU8x.OUTy0 output"]
            VALUE2,
        }
        impl TRAPE0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRAPE0W::VALUE1 => false,
                    TRAPE0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRAPE0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRAPE0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRAPE0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TRAP functionality has no effect on the CCU8x.OUTy0 output"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRAPE0W::VALUE1)
            }
            #[doc = "TRAP functionality affects the CCU8x.OUTy0 output"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRAPE0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRAPE1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRAPE1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRAPE2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRAPE2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRAPE3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRAPE3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRPSE`"]
        pub enum TRPSEW {
            #[doc = "Exiting from TRAP state isn't synchronized with the PWM signal"]
            VALUE1,
            #[doc = "Exiting from TRAP state is synchronized with the PWM signal"]
            VALUE2,
        }
        impl TRPSEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRPSEW::VALUE1 => false,
                    TRPSEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRPSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRPSEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRPSEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Exiting from TRAP state isn't synchronized with the PWM signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRPSEW::VALUE1)
            }
            #[doc = "Exiting from TRAP state is synchronized with the PWM signal"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRPSEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRPSW`"]
        pub enum TRPSWW {
            #[doc = "The slice exits the TRAP state automatically when the TRAP condition is not present (Trap state cleared by HW and SW)"]
            VALUE1,
            #[doc = "The TRAP state can only be exited by a SW request."]
            VALUE2,
        }
        impl TRPSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TRPSWW::VALUE1 => false,
                    TRPSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRPSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRPSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRPSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The slice exits the TRAP state automatically when the TRAP condition is not present (Trap state cleared by HW and SW)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRPSWW::VALUE1)
            }
            #[doc = "The TRAP state can only be exited by a SW request."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRPSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMS`"]
        pub enum EMSW {
            #[doc = "External Modulation functionality is not synchronized with the PWM signal"]
            VALUE1,
            #[doc = "External Modulation functionality is synchronized with the PWM signal"]
            VALUE2,
        }
        impl EMSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMSW::VALUE1 => false,
                    EMSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External Modulation functionality is not synchronized with the PWM signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMSW::VALUE1)
            }
            #[doc = "External Modulation functionality is synchronized with the PWM signal"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMT`"]
        pub enum EMTW {
            #[doc = "External Modulation functionality is clearing the CC8ySTx bits."]
            VALUE1,
            #[doc = "External Modulation functionality is gating the outputs."]
            VALUE2,
        }
        impl EMTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMTW::VALUE1 => false,
                    EMTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External Modulation functionality is clearing the CC8ySTx bits."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMTW::VALUE1)
            }
            #[doc = "External Modulation functionality is gating the outputs."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCME1`"]
        pub enum MCME1W {
            #[doc = "Multi Channel Mode in Channel 1 is disabled"]
            VALUE1,
            #[doc = "Multi Channel Mode in Channel 1 is enabled"]
            VALUE2,
        }
        impl MCME1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCME1W::VALUE1 => false,
                    MCME1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCME1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCME1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCME1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Multi Channel Mode in Channel 1 is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCME1W::VALUE1)
            }
            #[doc = "Multi Channel Mode in Channel 1 is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCME1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCME2`"]
        pub enum MCME2W {
            #[doc = "Multi Channel Mode in Channel 2 is disabled"]
            VALUE1,
            #[doc = "Multi Channel Mode in Channel 2 is enabled"]
            VALUE2,
        }
        impl MCME2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCME2W::VALUE1 => false,
                    MCME2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCME2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCME2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCME2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Multi Channel Mode in Channel 2 is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCME2W::VALUE1)
            }
            #[doc = "Multi Channel Mode in Channel 2 is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCME2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EME`"]
        pub enum EMEW {
            #[doc = "External Modulation functionality doesn't affect any channel"]
            VALUE1,
            #[doc = "External Modulation only applied on channel 1"]
            VALUE2,
            #[doc = "External Modulation only applied on channel 2"]
            VALUE3,
            #[doc = "External Modulation applied on both channels"]
            VALUE4,
        }
        impl EMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EMEW::VALUE1 => 0,
                    EMEW::VALUE2 => 1,
                    EMEW::VALUE3 => 2,
                    EMEW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMEW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External Modulation functionality doesn't affect any channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMEW::VALUE1)
            }
            #[doc = "External Modulation only applied on channel 1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMEW::VALUE2)
            }
            #[doc = "External Modulation only applied on channel 2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EMEW::VALUE3)
            }
            #[doc = "External Modulation applied on both channels"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EMEW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STOS`"]
        pub enum STOSW {
            #[doc = "CC8yST1 forward to CCU8x.STy"]
            VALUE1,
            #[doc = "CC8yST2 forward to CCU8x.STy"]
            VALUE2,
            #[doc = "CC8yST1 AND CC8yST2 forward to CCU8x.STy"]
            VALUE3,
        }
        impl STOSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STOSW::VALUE1 => 0,
                    STOSW::VALUE2 => 1,
                    STOSW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STOSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STOSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STOSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CC8yST1 forward to CCU8x.STy"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STOSW::VALUE1)
            }
            #[doc = "CC8yST2 forward to CCU8x.STy"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STOSW::VALUE2)
            }
            #[doc = "CC8yST1 AND CC8yST2 forward to CCU8x.STy"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STOSW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Timer Counting Mode"]
            #[inline]
            pub fn tcm(&self) -> TCMR {
                TCMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Timer Single Shot Mode"]
            #[inline]
            pub fn tssm(&self) -> TSSMR {
                TSSMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Shadow Transfer on Clear"]
            #[inline]
            pub fn clst(&self) -> CLSTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CLSTR { bits }
            }
            #[doc = "Bit 3 - Capture Compare Mode"]
            #[inline]
            pub fn cmod(&self) -> CMODR {
                CMODR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Extended Capture Mode"]
            #[inline]
            pub fn ecm(&self) -> ECMR {
                ECMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 5:6 - Clear on Capture Control"]
            #[inline]
            pub fn capc(&self) -> CAPCR {
                CAPCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 7 - Timer Load selector"]
            #[inline]
            pub fn tls(&self) -> TLSR {
                TLSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 8:9 - Extended Stop Function Control"]
            #[inline]
            pub fn endm(&self) -> ENDMR {
                ENDMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Extended Start Function Control"]
            #[inline]
            pub fn strm(&self) -> STRMR {
                STRMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Equal Capture Event enable"]
            #[inline]
            pub fn sce(&self) -> SCER {
                SCER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Continuous Capture Enable"]
            #[inline]
            pub fn ccs(&self) -> CCSR {
                CCSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 13:14 - Dither Enable"]
            #[inline]
            pub fn dithe(&self) -> DITHER {
                DITHER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 15 - Dither input selector"]
            #[inline]
            pub fn dim(&self) -> DIMR {
                DIMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Floating Prescaler enable"]
            #[inline]
            pub fn fpe(&self) -> FPER {
                FPER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - TRAP enable for CCU8x.OUTy0"]
            #[inline]
            pub fn trape0(&self) -> TRAPE0R {
                TRAPE0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - TRAP enable for CCU8x.OUTy1"]
            #[inline]
            pub fn trape1(&self) -> TRAPE1R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TRAPE1R { bits }
            }
            #[doc = "Bit 19 - TRAP enable for CCU8x.OUTy2"]
            #[inline]
            pub fn trape2(&self) -> TRAPE2R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TRAPE2R { bits }
            }
            #[doc = "Bit 20 - TRAP enable for CCU8x.OUTy3"]
            #[inline]
            pub fn trape3(&self) -> TRAPE3R {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TRAPE3R { bits }
            }
            #[doc = "Bit 21 - TRAP Synchronization Enable"]
            #[inline]
            pub fn trpse(&self) -> TRPSER {
                TRPSER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 22 - TRAP State Clear Control"]
            #[inline]
            pub fn trpsw(&self) -> TRPSWR {
                TRPSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - External Modulation Synchronization"]
            #[inline]
            pub fn ems(&self) -> EMSR {
                EMSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - External Modulation Type"]
            #[inline]
            pub fn emt(&self) -> EMTR {
                EMTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Multi Channel Mode Enable for Channel 1"]
            #[inline]
            pub fn mcme1(&self) -> MCME1R {
                MCME1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Multi Channel Mode Enable for Channel 2"]
            #[inline]
            pub fn mcme2(&self) -> MCME2R {
                MCME2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 27:28 - External Modulation Channel enable"]
            #[inline]
            pub fn eme(&self) -> EMER {
                EMER::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 29:30 - Status bit output selector"]
            #[inline]
            pub fn stos(&self) -> STOSR {
                STOSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 29;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x1800_0000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Timer Counting Mode"]
            #[inline]
            pub fn tcm(&mut self) -> _TCMW {
                _TCMW { w: self }
            }
            #[doc = "Bit 1 - Timer Single Shot Mode"]
            #[inline]
            pub fn tssm(&mut self) -> _TSSMW {
                _TSSMW { w: self }
            }
            #[doc = "Bit 2 - Shadow Transfer on Clear"]
            #[inline]
            pub fn clst(&mut self) -> _CLSTW {
                _CLSTW { w: self }
            }
            #[doc = "Bit 4 - Extended Capture Mode"]
            #[inline]
            pub fn ecm(&mut self) -> _ECMW {
                _ECMW { w: self }
            }
            #[doc = "Bits 5:6 - Clear on Capture Control"]
            #[inline]
            pub fn capc(&mut self) -> _CAPCW {
                _CAPCW { w: self }
            }
            #[doc = "Bit 7 - Timer Load selector"]
            #[inline]
            pub fn tls(&mut self) -> _TLSW {
                _TLSW { w: self }
            }
            #[doc = "Bits 8:9 - Extended Stop Function Control"]
            #[inline]
            pub fn endm(&mut self) -> _ENDMW {
                _ENDMW { w: self }
            }
            #[doc = "Bit 10 - Extended Start Function Control"]
            #[inline]
            pub fn strm(&mut self) -> _STRMW {
                _STRMW { w: self }
            }
            #[doc = "Bit 11 - Equal Capture Event enable"]
            #[inline]
            pub fn sce(&mut self) -> _SCEW {
                _SCEW { w: self }
            }
            #[doc = "Bit 12 - Continuous Capture Enable"]
            #[inline]
            pub fn ccs(&mut self) -> _CCSW {
                _CCSW { w: self }
            }
            #[doc = "Bits 13:14 - Dither Enable"]
            #[inline]
            pub fn dithe(&mut self) -> _DITHEW {
                _DITHEW { w: self }
            }
            #[doc = "Bit 15 - Dither input selector"]
            #[inline]
            pub fn dim(&mut self) -> _DIMW {
                _DIMW { w: self }
            }
            #[doc = "Bit 16 - Floating Prescaler enable"]
            #[inline]
            pub fn fpe(&mut self) -> _FPEW {
                _FPEW { w: self }
            }
            #[doc = "Bit 17 - TRAP enable for CCU8x.OUTy0"]
            #[inline]
            pub fn trape0(&mut self) -> _TRAPE0W {
                _TRAPE0W { w: self }
            }
            #[doc = "Bit 18 - TRAP enable for CCU8x.OUTy1"]
            #[inline]
            pub fn trape1(&mut self) -> _TRAPE1W {
                _TRAPE1W { w: self }
            }
            #[doc = "Bit 19 - TRAP enable for CCU8x.OUTy2"]
            #[inline]
            pub fn trape2(&mut self) -> _TRAPE2W {
                _TRAPE2W { w: self }
            }
            #[doc = "Bit 20 - TRAP enable for CCU8x.OUTy3"]
            #[inline]
            pub fn trape3(&mut self) -> _TRAPE3W {
                _TRAPE3W { w: self }
            }
            #[doc = "Bit 21 - TRAP Synchronization Enable"]
            #[inline]
            pub fn trpse(&mut self) -> _TRPSEW {
                _TRPSEW { w: self }
            }
            #[doc = "Bit 22 - TRAP State Clear Control"]
            #[inline]
            pub fn trpsw(&mut self) -> _TRPSWW {
                _TRPSWW { w: self }
            }
            #[doc = "Bit 23 - External Modulation Synchronization"]
            #[inline]
            pub fn ems(&mut self) -> _EMSW {
                _EMSW { w: self }
            }
            #[doc = "Bit 24 - External Modulation Type"]
            #[inline]
            pub fn emt(&mut self) -> _EMTW {
                _EMTW { w: self }
            }
            #[doc = "Bit 25 - Multi Channel Mode Enable for Channel 1"]
            #[inline]
            pub fn mcme1(&mut self) -> _MCME1W {
                _MCME1W { w: self }
            }
            #[doc = "Bit 26 - Multi Channel Mode Enable for Channel 2"]
            #[inline]
            pub fn mcme2(&mut self) -> _MCME2W {
                _MCME2W { w: self }
            }
            #[doc = "Bits 27:28 - External Modulation Channel enable"]
            #[inline]
            pub fn eme(&mut self) -> _EMEW {
                _EMEW { w: self }
            }
            #[doc = "Bits 29:30 - Status bit output selector"]
            #[inline]
            pub fn stos(&mut self) -> _STOSW {
                _STOSW { w: self }
            }
        }
    }
    #[doc = "Passive Level Config"]
    pub struct PSL {
        register: VolatileCell<u32>,
    }
    #[doc = "Passive Level Config"]
    pub mod psl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PSL11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSL11R {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSL11R::VALUE1 => false,
                    PSL11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSL11R {
                match value {
                    false => PSL11R::VALUE1,
                    true => PSL11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSL11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSL11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSL12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSL12R {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSL12R::VALUE1 => false,
                    PSL12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSL12R {
                match value {
                    false => PSL12R::VALUE1,
                    true => PSL12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSL12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSL12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSL21`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSL21R {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL21R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSL21R::VALUE1 => false,
                    PSL21R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSL21R {
                match value {
                    false => PSL21R::VALUE1,
                    true => PSL21R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSL21R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSL21R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSL22`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSL22R {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL22R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSL22R::VALUE1 => false,
                    PSL22R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSL22R {
                match value {
                    false => PSL22R::VALUE1,
                    true => PSL22R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSL22R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSL22R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PSL11`"]
        pub enum PSL11W {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSL11W::VALUE1 => false,
                    PSL11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSL11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSL11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSL11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Passive Level is LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSL11W::VALUE1)
            }
            #[doc = "Passive Level is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSL11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSL12`"]
        pub enum PSL12W {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSL12W::VALUE1 => false,
                    PSL12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSL12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSL12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSL12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Passive Level is LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSL12W::VALUE1)
            }
            #[doc = "Passive Level is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSL12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSL21`"]
        pub enum PSL21W {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL21W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSL21W::VALUE1 => false,
                    PSL21W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSL21W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSL21W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSL21W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Passive Level is LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSL21W::VALUE1)
            }
            #[doc = "Passive Level is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSL21W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSL22`"]
        pub enum PSL22W {
            #[doc = "Passive Level is LOW"]
            VALUE1,
            #[doc = "Passive Level is HIGH"]
            VALUE2,
        }
        impl PSL22W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSL22W::VALUE1 => false,
                    PSL22W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSL22W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSL22W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSL22W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Passive Level is LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSL22W::VALUE1)
            }
            #[doc = "Passive Level is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSL22W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Output Passive Level for CCU8x.OUTy0"]
            #[inline]
            pub fn psl11(&self) -> PSL11R {
                PSL11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Output Passive Level for CCU8x.OUTy1"]
            #[inline]
            pub fn psl12(&self) -> PSL12R {
                PSL12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Output Passive Level for CCU8x.OUTy2"]
            #[inline]
            pub fn psl21(&self) -> PSL21R {
                PSL21R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Output Passive Level for CCU8x.OUTy3"]
            #[inline]
            pub fn psl22(&self) -> PSL22R {
                PSL22R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Output Passive Level for CCU8x.OUTy0"]
            #[inline]
            pub fn psl11(&mut self) -> _PSL11W {
                _PSL11W { w: self }
            }
            #[doc = "Bit 1 - Output Passive Level for CCU8x.OUTy1"]
            #[inline]
            pub fn psl12(&mut self) -> _PSL12W {
                _PSL12W { w: self }
            }
            #[doc = "Bit 2 - Output Passive Level for CCU8x.OUTy2"]
            #[inline]
            pub fn psl21(&mut self) -> _PSL21W {
                _PSL21W { w: self }
            }
            #[doc = "Bit 3 - Output Passive Level for CCU8x.OUTy3"]
            #[inline]
            pub fn psl22(&mut self) -> _PSL22W {
                _PSL22W { w: self }
            }
        }
    }
    #[doc = "Dither Config"]
    pub struct DIT {
        register: VolatileCell<u32>,
    }
    #[doc = "Dither Config"]
    pub mod dit {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DIT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCVR {
            bits: u8,
        }
        impl DCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCNTR {
            bits: u8,
        }
        impl DCNTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Dither compare Value"]
            #[inline]
            pub fn dcv(&self) -> DCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCVR { bits }
            }
            #[doc = "Bits 8:11 - Dither counter actual value"]
            #[inline]
            pub fn dcnt(&self) -> DCNTR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCNTR { bits }
            }
        }
    }
    #[doc = "Dither Shadow Register"]
    pub struct DITS {
        register: VolatileCell<u32>,
    }
    #[doc = "Dither Shadow Register"]
    pub mod dits {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DITS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DCVSR {
            bits: u8,
        }
        impl DCVSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCVSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCVSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Dither Shadow Compare Value"]
            #[inline]
            pub fn dcvs(&self) -> DCVSR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DCVSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Dither Shadow Compare Value"]
            #[inline]
            pub fn dcvs(&mut self) -> _DCVSW {
                _DCVSW { w: self }
            }
        }
    }
    #[doc = "Prescaler Control"]
    pub struct PSC {
        register: VolatileCell<u32>,
    }
    #[doc = "Prescaler Control"]
    pub mod psc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PSIVR {
            bits: u8,
        }
        impl PSIVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSIVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSIVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Prescaler Initial Value"]
            #[inline]
            pub fn psiv(&self) -> PSIVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PSIVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Prescaler Initial Value"]
            #[inline]
            pub fn psiv(&mut self) -> _PSIVW {
                _PSIVW { w: self }
            }
        }
    }
    #[doc = "Floating Prescaler Control"]
    pub struct FPC {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating Prescaler Control"]
    pub mod fpc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCMPR {
            bits: u8,
        }
        impl PCMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PVALR {
            bits: u8,
        }
        impl PVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Floating Prescaler Compare Value"]
            #[inline]
            pub fn pcmp(&self) -> PCMPR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCMPR { bits }
            }
            #[doc = "Bits 8:11 - Actual Prescaler Value"]
            #[inline]
            pub fn pval(&self) -> PVALR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 8:11 - Actual Prescaler Value"]
            #[inline]
            pub fn pval(&mut self) -> _PVALW {
                _PVALW { w: self }
            }
        }
    }
    #[doc = "Floating Prescaler Shadow"]
    pub struct FPCS {
        register: VolatileCell<u32>,
    }
    #[doc = "Floating Prescaler Shadow"]
    pub mod fpcs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::FPCS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PCMPR {
            bits: u8,
        }
        impl PCMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCMPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCMPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Floating Prescaler Shadow Compare Value"]
            #[inline]
            pub fn pcmp(&self) -> PCMPR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PCMPR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Floating Prescaler Shadow Compare Value"]
            #[inline]
            pub fn pcmp(&mut self) -> _PCMPW {
                _PCMPW { w: self }
            }
        }
    }
    #[doc = "Timer Period Value"]
    pub struct PR {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Period Value"]
    pub mod pr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRR {
            bits: u16,
        }
        impl PRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Period Register"]
            #[inline]
            pub fn pr(&self) -> PRR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PRR { bits }
            }
        }
    }
    #[doc = "Timer Shadow Period Value"]
    pub struct PRS {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Shadow Period Value"]
    pub mod prs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PRSR {
            bits: u16,
        }
        impl PRSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PRSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Period Register"]
            #[inline]
            pub fn prs(&self) -> PRSR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PRSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Period Register"]
            #[inline]
            pub fn prs(&mut self) -> _PRSW {
                _PRSW { w: self }
            }
        }
    }
    #[doc = "Channel 1 Compare Value"]
    pub struct CR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel 1 Compare Value"]
    pub mod cr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CR1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR1R {
            bits: u16,
        }
        impl CR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Compare Register for Channel 1"]
            #[inline]
            pub fn cr1(&self) -> CR1R {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CR1R { bits }
            }
        }
    }
    #[doc = "Channel 1 Compare Shadow Value"]
    pub struct CR1S {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel 1 Compare Shadow Value"]
    pub mod cr1s {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CR1S {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR1SR {
            bits: u16,
        }
        impl CR1SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CR1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CR1SW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Shadow Compare Register for Channel 1"]
            #[inline]
            pub fn cr1s(&self) -> CR1SR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CR1SR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Shadow Compare Register for Channel 1"]
            #[inline]
            pub fn cr1s(&mut self) -> _CR1SW {
                _CR1SW { w: self }
            }
        }
    }
    #[doc = "Channel 2 Compare Value"]
    pub struct CR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel 2 Compare Value"]
    pub mod cr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CR2 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR2R {
            bits: u16,
        }
        impl CR2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Compare Register for Channel 2"]
            #[inline]
            pub fn cr2(&self) -> CR2R {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CR2R { bits }
            }
        }
    }
    #[doc = "Channel 2 Compare Shadow Value"]
    pub struct CR2S {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel 2 Compare Shadow Value"]
    pub mod cr2s {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CR2S {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR2SR {
            bits: u16,
        }
        impl CR2SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _CR2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CR2SW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Shadow Compare Register for Channel 2"]
            #[inline]
            pub fn cr2s(&self) -> CR2SR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CR2SR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Shadow Compare Register for Channel 2"]
            #[inline]
            pub fn cr2s(&mut self) -> _CR2SW {
                _CR2SW { w: self }
            }
        }
    }
    #[doc = "Channel Control"]
    pub struct CHC {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel Control"]
    pub mod chc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CHC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ASE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ASER {
            #[doc = "Asymmetric PWM is disabled"]
            VALUE1,
            #[doc = "Asymmetric PWM is enabled"]
            VALUE2,
        }
        impl ASER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ASER::VALUE1 => false,
                    ASER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ASER {
                match value {
                    false => ASER::VALUE1,
                    true => ASER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ASER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ASER::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCS1R {
            #[doc = "CC8yST1 signal path is connected to the CCU8x.OUTy0"]
            VALUE1,
            #[doc = "Inverted CC8yST1 signal path is connected to the CCU8x.OUTy0"]
            VALUE2,
        }
        impl OCS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OCS1R::VALUE1 => false,
                    OCS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OCS1R {
                match value {
                    false => OCS1R::VALUE1,
                    true => OCS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCS2R {
            #[doc = "Inverted CC8yST1 signal path is connected to the CCU8x.OUTy1"]
            VALUE1,
            #[doc = "CC8yST1 signal path is connected to the CCU8x.OUTy1"]
            VALUE2,
        }
        impl OCS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OCS2R::VALUE1 => false,
                    OCS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OCS2R {
                match value {
                    false => OCS2R::VALUE1,
                    true => OCS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCS3R {
            #[doc = "CC8yST2 signal path is connected to the CCU8x.OUTy2"]
            VALUE1,
            #[doc = "Inverted CCST2 signal path is connected to the CCU8x.OUTy2"]
            VALUE2,
        }
        impl OCS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OCS3R::VALUE1 => false,
                    OCS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OCS3R {
                match value {
                    false => OCS3R::VALUE1,
                    true => OCS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCS4R {
            #[doc = "Inverted CC8yST2 signal path is connected to the CCU8x.OUTy3"]
            VALUE1,
            #[doc = "CC8yST2 signal path is connected to the CCU8x.OUTy3"]
            VALUE2,
        }
        impl OCS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OCS4R::VALUE1 => false,
                    OCS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OCS4R {
                match value {
                    false => OCS4R::VALUE1,
                    true => OCS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCS4R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ASE`"]
        pub enum ASEW {
            #[doc = "Asymmetric PWM is disabled"]
            VALUE1,
            #[doc = "Asymmetric PWM is enabled"]
            VALUE2,
        }
        impl ASEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ASEW::VALUE1 => false,
                    ASEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ASEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ASEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ASEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Asymmetric PWM is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ASEW::VALUE1)
            }
            #[doc = "Asymmetric PWM is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ASEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS1`"]
        pub enum OCS1W {
            #[doc = "CC8yST1 signal path is connected to the CCU8x.OUTy0"]
            VALUE1,
            #[doc = "Inverted CC8yST1 signal path is connected to the CCU8x.OUTy0"]
            VALUE2,
        }
        impl OCS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OCS1W::VALUE1 => false,
                    OCS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "CC8yST1 signal path is connected to the CCU8x.OUTy0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCS1W::VALUE1)
            }
            #[doc = "Inverted CC8yST1 signal path is connected to the CCU8x.OUTy0"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS2`"]
        pub enum OCS2W {
            #[doc = "Inverted CC8yST1 signal path is connected to the CCU8x.OUTy1"]
            VALUE1,
            #[doc = "CC8yST1 signal path is connected to the CCU8x.OUTy1"]
            VALUE2,
        }
        impl OCS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OCS2W::VALUE1 => false,
                    OCS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Inverted CC8yST1 signal path is connected to the CCU8x.OUTy1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCS2W::VALUE1)
            }
            #[doc = "CC8yST1 signal path is connected to the CCU8x.OUTy1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS3`"]
        pub enum OCS3W {
            #[doc = "CC8yST2 signal path is connected to the CCU8x.OUTy2"]
            VALUE1,
            #[doc = "Inverted CCST2 signal path is connected to the CCU8x.OUTy2"]
            VALUE2,
        }
        impl OCS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OCS3W::VALUE1 => false,
                    OCS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "CC8yST2 signal path is connected to the CCU8x.OUTy2"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCS3W::VALUE1)
            }
            #[doc = "Inverted CCST2 signal path is connected to the CCU8x.OUTy2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS4`"]
        pub enum OCS4W {
            #[doc = "Inverted CC8yST2 signal path is connected to the CCU8x.OUTy3"]
            VALUE1,
            #[doc = "CC8yST2 signal path is connected to the CCU8x.OUTy3"]
            VALUE2,
        }
        impl OCS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OCS4W::VALUE1 => false,
                    OCS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Inverted CC8yST2 signal path is connected to the CCU8x.OUTy3"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCS4W::VALUE1)
            }
            #[doc = "CC8yST2 signal path is connected to the CCU8x.OUTy3"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Asymmetric PWM mode Enable"]
            #[inline]
            pub fn ase(&self) -> ASER {
                ASER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Output selector for CCU8x.OUTy0"]
            #[inline]
            pub fn ocs1(&self) -> OCS1R {
                OCS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Output selector for CCU8x.OUTy1"]
            #[inline]
            pub fn ocs2(&self) -> OCS2R {
                OCS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Output selector for CCU8x.OUTy2"]
            #[inline]
            pub fn ocs3(&self) -> OCS3R {
                OCS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Output selector for CCU8x.OUTy3"]
            #[inline]
            pub fn ocs4(&self) -> OCS4R {
                OCS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Asymmetric PWM mode Enable"]
            #[inline]
            pub fn ase(&mut self) -> _ASEW {
                _ASEW { w: self }
            }
            #[doc = "Bit 1 - Output selector for CCU8x.OUTy0"]
            #[inline]
            pub fn ocs1(&mut self) -> _OCS1W {
                _OCS1W { w: self }
            }
            #[doc = "Bit 2 - Output selector for CCU8x.OUTy1"]
            #[inline]
            pub fn ocs2(&mut self) -> _OCS2W {
                _OCS2W { w: self }
            }
            #[doc = "Bit 3 - Output selector for CCU8x.OUTy2"]
            #[inline]
            pub fn ocs3(&mut self) -> _OCS3W {
                _OCS3W { w: self }
            }
            #[doc = "Bit 4 - Output selector for CCU8x.OUTy3"]
            #[inline]
            pub fn ocs4(&mut self) -> _OCS4W {
                _OCS4W { w: self }
            }
        }
    }
    #[doc = "Dead Time Control"]
    pub struct DTC {
        register: VolatileCell<u32>,
    }
    #[doc = "Dead Time Control"]
    pub mod dtc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DTC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `DTE1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTE1R {
            #[doc = "Dead Time for channel 1 is disabled"]
            VALUE1,
            #[doc = "Dead Time for channel 1 is enabled"]
            VALUE2,
        }
        impl DTE1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTE1R::VALUE1 => false,
                    DTE1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTE1R {
                match value {
                    false => DTE1R::VALUE1,
                    true => DTE1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTE1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTE1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DTE2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTE2R {
            #[doc = "Dead Time for channel 2 is disabled"]
            VALUE1,
            #[doc = "Dead Time for channel 2 is enabled"]
            VALUE2,
        }
        impl DTE2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTE2R::VALUE1 => false,
                    DTE2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTE2R {
                match value {
                    false => DTE2R::VALUE1,
                    true => DTE2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTE2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTE2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DCEN1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCEN1R {
            #[doc = "Dead Time for CC8yST1 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for CC8yST1 path is enabled"]
            VALUE2,
        }
        impl DCEN1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCEN1R::VALUE1 => false,
                    DCEN1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCEN1R {
                match value {
                    false => DCEN1R::VALUE1,
                    true => DCEN1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCEN1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCEN1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DCEN2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCEN2R {
            #[doc = "Dead Time for inverted CC8yST1 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for inverted CC8yST1 path is enabled"]
            VALUE2,
        }
        impl DCEN2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCEN2R::VALUE1 => false,
                    DCEN2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCEN2R {
                match value {
                    false => DCEN2R::VALUE1,
                    true => DCEN2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCEN2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCEN2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DCEN3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCEN3R {
            #[doc = "Dead Time for CC8yST2 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for CC8yST2 path is enabled"]
            VALUE2,
        }
        impl DCEN3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCEN3R::VALUE1 => false,
                    DCEN3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCEN3R {
                match value {
                    false => DCEN3R::VALUE1,
                    true => DCEN3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCEN3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCEN3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DCEN4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DCEN4R {
            #[doc = "Dead Time for inverted CC8yST2 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for inverted CC8yST2 path is enabled"]
            VALUE2,
        }
        impl DCEN4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DCEN4R::VALUE1 => false,
                    DCEN4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DCEN4R {
                match value {
                    false => DCEN4R::VALUE1,
                    true => DCEN4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DCEN4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DCEN4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DTCC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTCCR {
            #[doc = "ftclk"]
            VALUE1,
            #[doc = "ftclk/2"]
            VALUE2,
            #[doc = "ftclk/4"]
            VALUE3,
            #[doc = "ftclk/8"]
            VALUE4,
        }
        impl DTCCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    DTCCR::VALUE1 => 0,
                    DTCCR::VALUE2 => 0x01,
                    DTCCR::VALUE3 => 0x02,
                    DTCCR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> DTCCR {
                match value {
                    0 => DTCCR::VALUE1,
                    1 => DTCCR::VALUE2,
                    2 => DTCCR::VALUE3,
                    3 => DTCCR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTCCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTCCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == DTCCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == DTCCR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `DTE1`"]
        pub enum DTE1W {
            #[doc = "Dead Time for channel 1 is disabled"]
            VALUE1,
            #[doc = "Dead Time for channel 1 is enabled"]
            VALUE2,
        }
        impl DTE1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DTE1W::VALUE1 => false,
                    DTE1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTE1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTE1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DTE1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead Time for channel 1 is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DTE1W::VALUE1)
            }
            #[doc = "Dead Time for channel 1 is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DTE1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DTE2`"]
        pub enum DTE2W {
            #[doc = "Dead Time for channel 2 is disabled"]
            VALUE1,
            #[doc = "Dead Time for channel 2 is enabled"]
            VALUE2,
        }
        impl DTE2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DTE2W::VALUE1 => false,
                    DTE2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTE2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTE2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DTE2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead Time for channel 2 is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DTE2W::VALUE1)
            }
            #[doc = "Dead Time for channel 2 is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DTE2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCEN1`"]
        pub enum DCEN1W {
            #[doc = "Dead Time for CC8yST1 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for CC8yST1 path is enabled"]
            VALUE2,
        }
        impl DCEN1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCEN1W::VALUE1 => false,
                    DCEN1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCEN1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCEN1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCEN1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead Time for CC8yST1 path is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCEN1W::VALUE1)
            }
            #[doc = "Dead Time for CC8yST1 path is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCEN1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCEN2`"]
        pub enum DCEN2W {
            #[doc = "Dead Time for inverted CC8yST1 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for inverted CC8yST1 path is enabled"]
            VALUE2,
        }
        impl DCEN2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCEN2W::VALUE1 => false,
                    DCEN2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCEN2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCEN2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCEN2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead Time for inverted CC8yST1 path is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCEN2W::VALUE1)
            }
            #[doc = "Dead Time for inverted CC8yST1 path is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCEN2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCEN3`"]
        pub enum DCEN3W {
            #[doc = "Dead Time for CC8yST2 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for CC8yST2 path is enabled"]
            VALUE2,
        }
        impl DCEN3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCEN3W::VALUE1 => false,
                    DCEN3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCEN3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCEN3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCEN3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead Time for CC8yST2 path is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCEN3W::VALUE1)
            }
            #[doc = "Dead Time for CC8yST2 path is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCEN3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DCEN4`"]
        pub enum DCEN4W {
            #[doc = "Dead Time for inverted CC8yST2 path is disabled"]
            VALUE1,
            #[doc = "Dead Time for inverted CC8yST2 path is enabled"]
            VALUE2,
        }
        impl DCEN4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DCEN4W::VALUE1 => false,
                    DCEN4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DCEN4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DCEN4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DCEN4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead Time for inverted CC8yST2 path is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DCEN4W::VALUE1)
            }
            #[doc = "Dead Time for inverted CC8yST2 path is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DCEN4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DTCC`"]
        pub enum DTCCW {
            #[doc = "ftclk"]
            VALUE1,
            #[doc = "ftclk/2"]
            VALUE2,
            #[doc = "ftclk/4"]
            VALUE3,
            #[doc = "ftclk/8"]
            VALUE4,
        }
        impl DTCCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DTCCW::VALUE1 => 0,
                    DTCCW::VALUE2 => 1,
                    DTCCW::VALUE3 => 2,
                    DTCCW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTCCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTCCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DTCCW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "ftclk"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DTCCW::VALUE1)
            }
            #[doc = "ftclk/2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DTCCW::VALUE2)
            }
            #[doc = "ftclk/4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(DTCCW::VALUE3)
            }
            #[doc = "ftclk/8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(DTCCW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Dead Time Enable for Channel 1"]
            #[inline]
            pub fn dte1(&self) -> DTE1R {
                DTE1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Dead Time Enable for Channel 2"]
            #[inline]
            pub fn dte2(&self) -> DTE2R {
                DTE2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Dead Time Enable for CC8yST1"]
            #[inline]
            pub fn dcen1(&self) -> DCEN1R {
                DCEN1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Dead Time Enable for inverted CC8yST1"]
            #[inline]
            pub fn dcen2(&self) -> DCEN2R {
                DCEN2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Dead Time Enable for CC8yST2"]
            #[inline]
            pub fn dcen3(&self) -> DCEN3R {
                DCEN3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Dead Time Enable for inverted CC8yST2"]
            #[inline]
            pub fn dcen4(&self) -> DCEN4R {
                DCEN4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 6:7 - Dead Time clock control"]
            #[inline]
            pub fn dtcc(&self) -> DTCCR {
                DTCCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Dead Time Enable for Channel 1"]
            #[inline]
            pub fn dte1(&mut self) -> _DTE1W {
                _DTE1W { w: self }
            }
            #[doc = "Bit 1 - Dead Time Enable for Channel 2"]
            #[inline]
            pub fn dte2(&mut self) -> _DTE2W {
                _DTE2W { w: self }
            }
            #[doc = "Bit 2 - Dead Time Enable for CC8yST1"]
            #[inline]
            pub fn dcen1(&mut self) -> _DCEN1W {
                _DCEN1W { w: self }
            }
            #[doc = "Bit 3 - Dead Time Enable for inverted CC8yST1"]
            #[inline]
            pub fn dcen2(&mut self) -> _DCEN2W {
                _DCEN2W { w: self }
            }
            #[doc = "Bit 4 - Dead Time Enable for CC8yST2"]
            #[inline]
            pub fn dcen3(&mut self) -> _DCEN3W {
                _DCEN3W { w: self }
            }
            #[doc = "Bit 5 - Dead Time Enable for inverted CC8yST2"]
            #[inline]
            pub fn dcen4(&mut self) -> _DCEN4W {
                _DCEN4W { w: self }
            }
            #[doc = "Bits 6:7 - Dead Time clock control"]
            #[inline]
            pub fn dtcc(&mut self) -> _DTCCW {
                _DTCCW { w: self }
            }
        }
    }
    #[doc = "Channel 1 Dead Time Values"]
    pub struct DC1R {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel 1 Dead Time Values"]
    pub mod dc1r {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DC1R {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DT1RR {
            bits: u8,
        }
        impl DT1RR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DT1FR {
            bits: u8,
        }
        impl DT1FR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DT1RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DT1RW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DT1FW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DT1FW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Rise Value for Dead Time of Channel 1"]
            #[inline]
            pub fn dt1r(&self) -> DT1RR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DT1RR { bits }
            }
            #[doc = "Bits 8:15 - Fall Value for Dead Time of Channel 1"]
            #[inline]
            pub fn dt1f(&self) -> DT1FR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DT1FR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Rise Value for Dead Time of Channel 1"]
            #[inline]
            pub fn dt1r(&mut self) -> _DT1RW {
                _DT1RW { w: self }
            }
            #[doc = "Bits 8:15 - Fall Value for Dead Time of Channel 1"]
            #[inline]
            pub fn dt1f(&mut self) -> _DT1FW {
                _DT1FW { w: self }
            }
        }
    }
    #[doc = "Channel 2 Dead Time Values"]
    pub struct DC2R {
        register: VolatileCell<u32>,
    }
    #[doc = "Channel 2 Dead Time Values"]
    pub mod dc2r {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DC2R {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DT2RR {
            bits: u8,
        }
        impl DT2RR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct DT2FR {
            bits: u8,
        }
        impl DT2FR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DT2RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DT2RW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _DT2FW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DT2FW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Rise Value for Dead Time of Channel 2"]
            #[inline]
            pub fn dt2r(&self) -> DT2RR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DT2RR { bits }
            }
            #[doc = "Bits 8:15 - Fall Value for Dead Time of Channel 2"]
            #[inline]
            pub fn dt2f(&self) -> DT2FR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DT2FR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Rise Value for Dead Time of Channel 2"]
            #[inline]
            pub fn dt2r(&mut self) -> _DT2RW {
                _DT2RW { w: self }
            }
            #[doc = "Bits 8:15 - Fall Value for Dead Time of Channel 2"]
            #[inline]
            pub fn dt2f(&mut self) -> _DT2FW {
                _DT2FW { w: self }
            }
        }
    }
    #[doc = "Timer Value"]
    pub struct TIMER {
        register: VolatileCell<u32>,
    }
    #[doc = "Timer Value"]
    pub mod timer {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TIMER {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct TVALR {
            bits: u16,
        }
        impl TVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _TVALW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TVALW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Timer Value"]
            #[inline]
            pub fn tval(&self) -> TVALR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TVALR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Timer Value"]
            #[inline]
            pub fn tval(&mut self) -> _TVALW {
                _TVALW { w: self }
            }
        }
    }
    #[doc = "Capture Register 0"]
    pub struct C0V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 0"]
    pub mod c0v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C0V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Capture Register 1"]
    pub struct C1V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 1"]
    pub mod c1v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C1V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Capture Register 2"]
    pub struct C2V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 2"]
    pub mod c2v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C2V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Capture Register 3"]
    pub struct C3V {
        register: VolatileCell<u32>,
    }
    #[doc = "Capture Register 3"]
    pub mod c3v {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::C3V {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CAPTVR {
            bits: u16,
        }
        impl CAPTVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FPCVR {
            bits: u8,
        }
        impl FPCVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `FFL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FFLR {
            #[doc = "No new value was captured into the specific capture register"]
            VALUE1,
            #[doc = "A new value was captured into the specific register"]
            VALUE2,
        }
        impl FFLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FFLR::VALUE1 => false,
                    FFLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FFLR {
                match value {
                    false => FFLR::VALUE1,
                    true => FFLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FFLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FFLR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Capture Value"]
            #[inline]
            pub fn captv(&self) -> CAPTVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CAPTVR { bits }
            }
            #[doc = "Bits 16:19 - Prescaler Value"]
            #[inline]
            pub fn fpcv(&self) -> FPCVR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FPCVR { bits }
            }
            #[doc = "Bit 20 - Full Flag"]
            #[inline]
            pub fn ffl(&self) -> FFLR {
                FFLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Interrupt Status"]
    pub struct INTS {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Status"]
    pub mod ints {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::INTS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PMUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PMUSR {
            #[doc = "Period match while counting up not detected"]
            VALUE1,
            #[doc = "Period match while counting up detected"]
            VALUE2,
        }
        impl PMUSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PMUSR::VALUE1 => false,
                    PMUSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PMUSR {
                match value {
                    false => PMUSR::VALUE1,
                    true => PMUSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PMUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PMUSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OMDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OMDSR {
            #[doc = "One match while counting down not detected"]
            VALUE1,
            #[doc = "One match while counting down detected"]
            VALUE2,
        }
        impl OMDSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OMDSR::VALUE1 => false,
                    OMDSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OMDSR {
                match value {
                    false => OMDSR::VALUE1,
                    true => OMDSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OMDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OMDSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMU1S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMU1SR {
            #[doc = "Compare match while counting up not detected"]
            VALUE1,
            #[doc = "Compare match while counting up detected"]
            VALUE2,
        }
        impl CMU1SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMU1SR::VALUE1 => false,
                    CMU1SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMU1SR {
                match value {
                    false => CMU1SR::VALUE1,
                    true => CMU1SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMU1SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMU1SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMD1S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMD1SR {
            #[doc = "Compare match while counting down not detected"]
            VALUE1,
            #[doc = "Compare match while counting down detected"]
            VALUE2,
        }
        impl CMD1SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMD1SR::VALUE1 => false,
                    CMD1SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMD1SR {
                match value {
                    false => CMD1SR::VALUE1,
                    true => CMD1SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMD1SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMD1SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMU2S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMU2SR {
            #[doc = "Compare match while counting up not detected"]
            VALUE1,
            #[doc = "Compare match while counting up detected"]
            VALUE2,
        }
        impl CMU2SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMU2SR::VALUE1 => false,
                    CMU2SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMU2SR {
                match value {
                    false => CMU2SR::VALUE1,
                    true => CMU2SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMU2SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMU2SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMD2S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMD2SR {
            #[doc = "Compare match while counting down not detected"]
            VALUE1,
            #[doc = "Compare match while counting down detected"]
            VALUE2,
        }
        impl CMD2SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMD2SR::VALUE1 => false,
                    CMD2SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMD2SR {
                match value {
                    false => CMD2SR::VALUE1,
                    true => CMD2SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMD2SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMD2SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `E0AS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E0ASR {
            #[doc = "Event 0 not detected"]
            VALUE1,
            #[doc = "Event 0 detected"]
            VALUE2,
        }
        impl E0ASR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E0ASR::VALUE1 => false,
                    E0ASR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E0ASR {
                match value {
                    false => E0ASR::VALUE1,
                    true => E0ASR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E0ASR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E0ASR::VALUE2
            }
        }
        #[doc = "Possible values of the field `E1AS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E1ASR {
            #[doc = "Event 1 not detected"]
            VALUE1,
            #[doc = "Event 1 detected"]
            VALUE2,
        }
        impl E1ASR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E1ASR::VALUE1 => false,
                    E1ASR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E1ASR {
                match value {
                    false => E1ASR::VALUE1,
                    true => E1ASR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E1ASR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E1ASR::VALUE2
            }
        }
        #[doc = "Possible values of the field `E2AS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E2ASR {
            #[doc = "Event 2 not detected"]
            VALUE1,
            #[doc = "Event 2 detected"]
            VALUE2,
        }
        impl E2ASR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E2ASR::VALUE1 => false,
                    E2ASR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E2ASR {
                match value {
                    false => E2ASR::VALUE1,
                    true => E2ASR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E2ASR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E2ASR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRPFR {
            bits: bool,
        }
        impl TRPFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Period Match while Counting Up"]
            #[inline]
            pub fn pmus(&self) -> PMUSR {
                PMUSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - One Match while Counting Down"]
            #[inline]
            pub fn omds(&self) -> OMDSR {
                OMDSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channel 1 Compare Match while Counting Up"]
            #[inline]
            pub fn cmu1s(&self) -> CMU1SR {
                CMU1SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channel 1 Compare Match while Counting Down"]
            #[inline]
            pub fn cmd1s(&self) -> CMD1SR {
                CMD1SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channel 2 Compare Match while Counting Up"]
            #[inline]
            pub fn cmu2s(&self) -> CMU2SR {
                CMU2SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channel 2 Compare Match while Counting Down"]
            #[inline]
            pub fn cmd2s(&self) -> CMD2SR {
                CMD2SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Event 0 Detection Status"]
            #[inline]
            pub fn e0as(&self) -> E0ASR {
                E0ASR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Event 1 Detection Status"]
            #[inline]
            pub fn e1as(&self) -> E1ASR {
                E1ASR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Event 2 Detection Status"]
            #[inline]
            pub fn e2as(&self) -> E2ASR {
                E2ASR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Trap Flag Status"]
            #[inline]
            pub fn trpf(&self) -> TRPFR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TRPFR { bits }
            }
        }
    }
    #[doc = "Interrupt Enable Control"]
    pub struct INTE {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Enable Control"]
    pub mod inte {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::INTE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PMER {
            #[doc = "Period Match interrupt is disabled"]
            VALUE1,
            #[doc = "Period Match interrupt is enabled"]
            VALUE2,
        }
        impl PMER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PMER::VALUE1 => false,
                    PMER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PMER {
                match value {
                    false => PMER::VALUE1,
                    true => PMER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PMER::VALUE2
            }
        }
        #[doc = "Possible values of the field `OME`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OMER {
            #[doc = "One Match interrupt is disabled"]
            VALUE1,
            #[doc = "One Match interrupt is enabled"]
            VALUE2,
        }
        impl OMER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OMER::VALUE1 => false,
                    OMER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OMER {
                match value {
                    false => OMER::VALUE1,
                    true => OMER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OMER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OMER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMU1E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMU1ER {
            #[doc = "Compare Match while counting up interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting up interrupt is enabled"]
            VALUE2,
        }
        impl CMU1ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMU1ER::VALUE1 => false,
                    CMU1ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMU1ER {
                match value {
                    false => CMU1ER::VALUE1,
                    true => CMU1ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMU1ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMU1ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMD1E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMD1ER {
            #[doc = "Compare Match while counting down interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting down interrupt is enabled"]
            VALUE2,
        }
        impl CMD1ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMD1ER::VALUE1 => false,
                    CMD1ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMD1ER {
                match value {
                    false => CMD1ER::VALUE1,
                    true => CMD1ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMD1ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMD1ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMU2E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMU2ER {
            #[doc = "Compare Match while counting up interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting up interrupt is enabled"]
            VALUE2,
        }
        impl CMU2ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMU2ER::VALUE1 => false,
                    CMU2ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMU2ER {
                match value {
                    false => CMU2ER::VALUE1,
                    true => CMU2ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMU2ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMU2ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CMD2E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CMD2ER {
            #[doc = "Compare Match while counting down interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting down interrupt is enabled"]
            VALUE2,
        }
        impl CMD2ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CMD2ER::VALUE1 => false,
                    CMD2ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CMD2ER {
                match value {
                    false => CMD2ER::VALUE1,
                    true => CMD2ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CMD2ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CMD2ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `E0AE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E0AER {
            #[doc = "Event 0 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 0 detection interrupt is enabled"]
            VALUE2,
        }
        impl E0AER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E0AER::VALUE1 => false,
                    E0AER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E0AER {
                match value {
                    false => E0AER::VALUE1,
                    true => E0AER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E0AER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E0AER::VALUE2
            }
        }
        #[doc = "Possible values of the field `E1AE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E1AER {
            #[doc = "Event 1 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 1 detection interrupt is enabled"]
            VALUE2,
        }
        impl E1AER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E1AER::VALUE1 => false,
                    E1AER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E1AER {
                match value {
                    false => E1AER::VALUE1,
                    true => E1AER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E1AER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E1AER::VALUE2
            }
        }
        #[doc = "Possible values of the field `E2AE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E2AER {
            #[doc = "Event 2 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 2 detection interrupt is enabled"]
            VALUE2,
        }
        impl E2AER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    E2AER::VALUE1 => false,
                    E2AER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> E2AER {
                match value {
                    false => E2AER::VALUE1,
                    true => E2AER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E2AER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E2AER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PME`"]
        pub enum PMEW {
            #[doc = "Period Match interrupt is disabled"]
            VALUE1,
            #[doc = "Period Match interrupt is enabled"]
            VALUE2,
        }
        impl PMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PMEW::VALUE1 => false,
                    PMEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PMEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Period Match interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PMEW::VALUE1)
            }
            #[doc = "Period Match interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PMEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OME`"]
        pub enum OMEW {
            #[doc = "One Match interrupt is disabled"]
            VALUE1,
            #[doc = "One Match interrupt is enabled"]
            VALUE2,
        }
        impl OMEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OMEW::VALUE1 => false,
                    OMEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OMEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OMEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OMEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "One Match interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OMEW::VALUE1)
            }
            #[doc = "One Match interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OMEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMU1E`"]
        pub enum CMU1EW {
            #[doc = "Compare Match while counting up interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting up interrupt is enabled"]
            VALUE2,
        }
        impl CMU1EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMU1EW::VALUE1 => false,
                    CMU1EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMU1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMU1EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMU1EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Compare Match while counting up interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMU1EW::VALUE1)
            }
            #[doc = "Compare Match while counting up interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMU1EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMD1E`"]
        pub enum CMD1EW {
            #[doc = "Compare Match while counting down interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting down interrupt is enabled"]
            VALUE2,
        }
        impl CMD1EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMD1EW::VALUE1 => false,
                    CMD1EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMD1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMD1EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMD1EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Compare Match while counting down interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMD1EW::VALUE1)
            }
            #[doc = "Compare Match while counting down interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMD1EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMU2E`"]
        pub enum CMU2EW {
            #[doc = "Compare Match while counting up interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting up interrupt is enabled"]
            VALUE2,
        }
        impl CMU2EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMU2EW::VALUE1 => false,
                    CMU2EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMU2EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMU2EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMU2EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Compare Match while counting up interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMU2EW::VALUE1)
            }
            #[doc = "Compare Match while counting up interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMU2EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CMD2E`"]
        pub enum CMD2EW {
            #[doc = "Compare Match while counting down interrupt is disabled"]
            VALUE1,
            #[doc = "Compare Match while counting down interrupt is enabled"]
            VALUE2,
        }
        impl CMD2EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CMD2EW::VALUE1 => false,
                    CMD2EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CMD2EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CMD2EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CMD2EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Compare Match while counting down interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CMD2EW::VALUE1)
            }
            #[doc = "Compare Match while counting down interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CMD2EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E0AE`"]
        pub enum E0AEW {
            #[doc = "Event 0 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 0 detection interrupt is enabled"]
            VALUE2,
        }
        impl E0AEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    E0AEW::VALUE1 => false,
                    E0AEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E0AEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E0AEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E0AEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Event 0 detection interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E0AEW::VALUE1)
            }
            #[doc = "Event 0 detection interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E0AEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E1AE`"]
        pub enum E1AEW {
            #[doc = "Event 1 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 1 detection interrupt is enabled"]
            VALUE2,
        }
        impl E1AEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    E1AEW::VALUE1 => false,
                    E1AEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E1AEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E1AEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E1AEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Event 1 detection interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E1AEW::VALUE1)
            }
            #[doc = "Event 1 detection interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E1AEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E2AE`"]
        pub enum E2AEW {
            #[doc = "Event 2 detection interrupt is disabled"]
            VALUE1,
            #[doc = "Event 2 detection interrupt is enabled"]
            VALUE2,
        }
        impl E2AEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    E2AEW::VALUE1 => false,
                    E2AEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E2AEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E2AEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E2AEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Event 2 detection interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E2AEW::VALUE1)
            }
            #[doc = "Event 2 detection interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E2AEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Period match while counting up enable"]
            #[inline]
            pub fn pme(&self) -> PMER {
                PMER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - One match while counting down enable"]
            #[inline]
            pub fn ome(&self) -> OMER {
                OMER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Channel 1 Compare match while counting up enable"]
            #[inline]
            pub fn cmu1e(&self) -> CMU1ER {
                CMU1ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Channel 1 Compare match while counting down enable"]
            #[inline]
            pub fn cmd1e(&self) -> CMD1ER {
                CMD1ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Channel 2 Compare match while counting up enable"]
            #[inline]
            pub fn cmu2e(&self) -> CMU2ER {
                CMU2ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Channel 2 Compare match while counting down enable"]
            #[inline]
            pub fn cmd2e(&self) -> CMD2ER {
                CMD2ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Event 0 interrupt enable"]
            #[inline]
            pub fn e0ae(&self) -> E0AER {
                E0AER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Event 1 interrupt enable"]
            #[inline]
            pub fn e1ae(&self) -> E1AER {
                E1AER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Event 2 interrupt enable"]
            #[inline]
            pub fn e2ae(&self) -> E2AER {
                E2AER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Period match while counting up enable"]
            #[inline]
            pub fn pme(&mut self) -> _PMEW {
                _PMEW { w: self }
            }
            #[doc = "Bit 1 - One match while counting down enable"]
            #[inline]
            pub fn ome(&mut self) -> _OMEW {
                _OMEW { w: self }
            }
            #[doc = "Bit 2 - Channel 1 Compare match while counting up enable"]
            #[inline]
            pub fn cmu1e(&mut self) -> _CMU1EW {
                _CMU1EW { w: self }
            }
            #[doc = "Bit 3 - Channel 1 Compare match while counting down enable"]
            #[inline]
            pub fn cmd1e(&mut self) -> _CMD1EW {
                _CMD1EW { w: self }
            }
            #[doc = "Bit 4 - Channel 2 Compare match while counting up enable"]
            #[inline]
            pub fn cmu2e(&mut self) -> _CMU2EW {
                _CMU2EW { w: self }
            }
            #[doc = "Bit 5 - Channel 2 Compare match while counting down enable"]
            #[inline]
            pub fn cmd2e(&mut self) -> _CMD2EW {
                _CMD2EW { w: self }
            }
            #[doc = "Bit 8 - Event 0 interrupt enable"]
            #[inline]
            pub fn e0ae(&mut self) -> _E0AEW {
                _E0AEW { w: self }
            }
            #[doc = "Bit 9 - Event 1 interrupt enable"]
            #[inline]
            pub fn e1ae(&mut self) -> _E1AEW {
                _E1AEW { w: self }
            }
            #[doc = "Bit 10 - Event 2 interrupt enable"]
            #[inline]
            pub fn e2ae(&mut self) -> _E2AEW {
                _E2AEW { w: self }
            }
        }
    }
    #[doc = "Service Request Selector"]
    pub struct SRS {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Selector"]
    pub mod srs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `POSR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum POSRR {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl POSRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    POSRR::VALUE1 => 0,
                    POSRR::VALUE2 => 0x01,
                    POSRR::VALUE3 => 0x02,
                    POSRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> POSRR {
                match value {
                    0 => POSRR::VALUE1,
                    1 => POSRR::VALUE2,
                    2 => POSRR::VALUE3,
                    3 => POSRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == POSRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == POSRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == POSRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == POSRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CM1SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CM1SRR {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl CM1SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CM1SRR::VALUE1 => 0,
                    CM1SRR::VALUE2 => 0x01,
                    CM1SRR::VALUE3 => 0x02,
                    CM1SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CM1SRR {
                match value {
                    0 => CM1SRR::VALUE1,
                    1 => CM1SRR::VALUE2,
                    2 => CM1SRR::VALUE3,
                    3 => CM1SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CM1SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CM1SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CM1SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CM1SRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CM2SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CM2SRR {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl CM2SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CM2SRR::VALUE1 => 0,
                    CM2SRR::VALUE2 => 0x01,
                    CM2SRR::VALUE3 => 0x02,
                    CM2SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CM2SRR {
                match value {
                    0 => CM2SRR::VALUE1,
                    1 => CM2SRR::VALUE2,
                    2 => CM2SRR::VALUE3,
                    3 => CM2SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CM2SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CM2SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CM2SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CM2SRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `E0SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E0SRR {
            #[doc = "Forward to CCvySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl E0SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    E0SRR::VALUE1 => 0,
                    E0SRR::VALUE2 => 0x01,
                    E0SRR::VALUE3 => 0x02,
                    E0SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> E0SRR {
                match value {
                    0 => E0SRR::VALUE1,
                    1 => E0SRR::VALUE2,
                    2 => E0SRR::VALUE3,
                    3 => E0SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E0SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E0SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == E0SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == E0SRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `E1SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E1SRR {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl E1SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    E1SRR::VALUE1 => 0,
                    E1SRR::VALUE2 => 0x01,
                    E1SRR::VALUE3 => 0x02,
                    E1SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> E1SRR {
                match value {
                    0 => E1SRR::VALUE1,
                    1 => E1SRR::VALUE2,
                    2 => E1SRR::VALUE3,
                    3 => E1SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E1SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E1SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == E1SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == E1SRR::VALUE4
            }
        }
        #[doc = "Possible values of the field `E2SR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum E2SRR {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CCvySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl E2SRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    E2SRR::VALUE1 => 0,
                    E2SRR::VALUE2 => 0x01,
                    E2SRR::VALUE3 => 0x02,
                    E2SRR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> E2SRR {
                match value {
                    0 => E2SRR::VALUE1,
                    1 => E2SRR::VALUE2,
                    2 => E2SRR::VALUE3,
                    3 => E2SRR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == E2SRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == E2SRR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == E2SRR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == E2SRR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `POSR`"]
        pub enum POSRW {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl POSRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    POSRW::VALUE1 => 0,
                    POSRW::VALUE2 => 1,
                    POSRW::VALUE3 => 2,
                    POSRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _POSRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _POSRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: POSRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC8ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(POSRW::VALUE1)
            }
            #[doc = "Forward to CC8ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(POSRW::VALUE2)
            }
            #[doc = "Forward to CC8ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(POSRW::VALUE3)
            }
            #[doc = "Forward to CC8ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(POSRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM1SR`"]
        pub enum CM1SRW {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl CM1SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CM1SRW::VALUE1 => 0,
                    CM1SRW::VALUE2 => 1,
                    CM1SRW::VALUE3 => 2,
                    CM1SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CM1SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CM1SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CM1SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC8ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CM1SRW::VALUE1)
            }
            #[doc = "Forward to CC8ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CM1SRW::VALUE2)
            }
            #[doc = "Forward to CC8ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CM1SRW::VALUE3)
            }
            #[doc = "Forward to CC8ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CM1SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CM2SR`"]
        pub enum CM2SRW {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl CM2SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CM2SRW::VALUE1 => 0,
                    CM2SRW::VALUE2 => 1,
                    CM2SRW::VALUE3 => 2,
                    CM2SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CM2SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CM2SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CM2SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC8ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CM2SRW::VALUE1)
            }
            #[doc = "Forward to CC8ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CM2SRW::VALUE2)
            }
            #[doc = "Forward to CC8ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CM2SRW::VALUE3)
            }
            #[doc = "Forward to CC8ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CM2SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E0SR`"]
        pub enum E0SRW {
            #[doc = "Forward to CCvySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl E0SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    E0SRW::VALUE1 => 0,
                    E0SRW::VALUE2 => 1,
                    E0SRW::VALUE3 => 2,
                    E0SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E0SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E0SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E0SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CCvySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E0SRW::VALUE1)
            }
            #[doc = "Forward to CC8ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E0SRW::VALUE2)
            }
            #[doc = "Forward to CC8ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(E0SRW::VALUE3)
            }
            #[doc = "Forward to CC8ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(E0SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E1SR`"]
        pub enum E1SRW {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CC8ySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl E1SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    E1SRW::VALUE1 => 0,
                    E1SRW::VALUE2 => 1,
                    E1SRW::VALUE3 => 2,
                    E1SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E1SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E1SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E1SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC8ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E1SRW::VALUE1)
            }
            #[doc = "Forward to CC8ySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E1SRW::VALUE2)
            }
            #[doc = "Forward to CC8ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(E1SRW::VALUE3)
            }
            #[doc = "Forward to CC8ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(E1SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `E2SR`"]
        pub enum E2SRW {
            #[doc = "Forward to CC8ySR0"]
            VALUE1,
            #[doc = "Forward to CCvySR1"]
            VALUE2,
            #[doc = "Forward to CC8ySR2"]
            VALUE3,
            #[doc = "Forward to CC8ySR3"]
            VALUE4,
        }
        impl E2SRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    E2SRW::VALUE1 => 0,
                    E2SRW::VALUE2 => 1,
                    E2SRW::VALUE3 => 2,
                    E2SRW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _E2SRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E2SRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: E2SRW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Forward to CC8ySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(E2SRW::VALUE1)
            }
            #[doc = "Forward to CCvySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(E2SRW::VALUE2)
            }
            #[doc = "Forward to CC8ySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(E2SRW::VALUE3)
            }
            #[doc = "Forward to CC8ySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(E2SRW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Period/One match Service request selector"]
            #[inline]
            pub fn posr(&self) -> POSRR {
                POSRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Channel 1 Compare match Service request selector"]
            #[inline]
            pub fn cm1sr(&self) -> CM1SRR {
                CM1SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Channel 2 Compare match Service request selector"]
            #[inline]
            pub fn cm2sr(&self) -> CM2SRR {
                CM2SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Event 0 Service request selector"]
            #[inline]
            pub fn e0sr(&self) -> E0SRR {
                E0SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Event 1 Service request selector"]
            #[inline]
            pub fn e1sr(&self) -> E1SRR {
                E1SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Event 2 Service request selector"]
            #[inline]
            pub fn e2sr(&self) -> E2SRR {
                E2SRR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Period/One match Service request selector"]
            #[inline]
            pub fn posr(&mut self) -> _POSRW {
                _POSRW { w: self }
            }
            #[doc = "Bits 2:3 - Channel 1 Compare match Service request selector"]
            #[inline]
            pub fn cm1sr(&mut self) -> _CM1SRW {
                _CM1SRW { w: self }
            }
            #[doc = "Bits 4:5 - Channel 2 Compare match Service request selector"]
            #[inline]
            pub fn cm2sr(&mut self) -> _CM2SRW {
                _CM2SRW { w: self }
            }
            #[doc = "Bits 8:9 - Event 0 Service request selector"]
            #[inline]
            pub fn e0sr(&mut self) -> _E0SRW {
                _E0SRW { w: self }
            }
            #[doc = "Bits 10:11 - Event 1 Service request selector"]
            #[inline]
            pub fn e1sr(&mut self) -> _E1SRW {
                _E1SRW { w: self }
            }
            #[doc = "Bits 12:13 - Event 2 Service request selector"]
            #[inline]
            pub fn e2sr(&mut self) -> _E2SRW {
                _E2SRW { w: self }
            }
        }
    }
    #[doc = "Interrupt Status Set"]
    pub struct SWS {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Status Set"]
    pub mod sws {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SWS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SOMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SOMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCM1UW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCM1UW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCM1DW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCM1DW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCM2UW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCM2UW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCM2DW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCM2DW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SE0AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SE0AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SE1AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SE1AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SE2AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SE2AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRPFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Period match while counting up set"]
            #[inline]
            pub fn spm(&mut self) -> _SPMW {
                _SPMW { w: self }
            }
            #[doc = "Bit 1 - One match while counting down set"]
            #[inline]
            pub fn som(&mut self) -> _SOMW {
                _SOMW { w: self }
            }
            #[doc = "Bit 2 - Channel 1 Compare match while counting up set"]
            #[inline]
            pub fn scm1u(&mut self) -> _SCM1UW {
                _SCM1UW { w: self }
            }
            #[doc = "Bit 3 - Channel 1 Compare match while counting down set"]
            #[inline]
            pub fn scm1d(&mut self) -> _SCM1DW {
                _SCM1DW { w: self }
            }
            #[doc = "Bit 4 - Compare match while counting up set"]
            #[inline]
            pub fn scm2u(&mut self) -> _SCM2UW {
                _SCM2UW { w: self }
            }
            #[doc = "Bit 5 - Compare match while counting down set"]
            #[inline]
            pub fn scm2d(&mut self) -> _SCM2DW {
                _SCM2DW { w: self }
            }
            #[doc = "Bit 8 - Event 0 detection set"]
            #[inline]
            pub fn se0a(&mut self) -> _SE0AW {
                _SE0AW { w: self }
            }
            #[doc = "Bit 9 - Event 1 detection set"]
            #[inline]
            pub fn se1a(&mut self) -> _SE1AW {
                _SE1AW { w: self }
            }
            #[doc = "Bit 10 - Event 2 detection set"]
            #[inline]
            pub fn se2a(&mut self) -> _SE2AW {
                _SE2AW { w: self }
            }
            #[doc = "Bit 11 - Trap Flag status set"]
            #[inline]
            pub fn strpf(&mut self) -> _STRPFW {
                _STRPFW { w: self }
            }
        }
    }
    #[doc = "Interrupt Status Clear"]
    pub struct SWR {
        register: VolatileCell<u32>,
    }
    #[doc = "Interrupt Status Clear"]
    pub mod swr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SWR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ROMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ROMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCM1UW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCM1UW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCM1DW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCM1DW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCM2UW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCM2UW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCM2DW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCM2DW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RE0AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RE0AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RE1AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RE1AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RE2AW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RE2AW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RTRPFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RTRPFW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Period match while counting up clear"]
            #[inline]
            pub fn rpm(&mut self) -> _RPMW {
                _RPMW { w: self }
            }
            #[doc = "Bit 1 - One match while counting down clear"]
            #[inline]
            pub fn rom(&mut self) -> _ROMW {
                _ROMW { w: self }
            }
            #[doc = "Bit 2 - Channel 1 Compare match while counting up clear"]
            #[inline]
            pub fn rcm1u(&mut self) -> _RCM1UW {
                _RCM1UW { w: self }
            }
            #[doc = "Bit 3 - Channel 1 Compare match while counting down clear"]
            #[inline]
            pub fn rcm1d(&mut self) -> _RCM1DW {
                _RCM1DW { w: self }
            }
            #[doc = "Bit 4 - Channel 2 Compare match while counting up clear"]
            #[inline]
            pub fn rcm2u(&mut self) -> _RCM2UW {
                _RCM2UW { w: self }
            }
            #[doc = "Bit 5 - Channel 2 Compare match while counting down clear"]
            #[inline]
            pub fn rcm2d(&mut self) -> _RCM2DW {
                _RCM2DW { w: self }
            }
            #[doc = "Bit 8 - Event 0 detection clear"]
            #[inline]
            pub fn re0a(&mut self) -> _RE0AW {
                _RE0AW { w: self }
            }
            #[doc = "Bit 9 - Event 1 detection clear"]
            #[inline]
            pub fn re1a(&mut self) -> _RE1AW {
                _RE1AW { w: self }
            }
            #[doc = "Bit 10 - Event 2 detection clear"]
            #[inline]
            pub fn re2a(&mut self) -> _RE2AW {
                _RE2AW { w: self }
            }
            #[doc = "Bit 11 - Trap Flag status clear"]
            #[inline]
            pub fn rtrpf(&mut self) -> _RTRPFW {
                _RTRPFW { w: self }
            }
        }
    }
    #[doc = "Shadow transfer control"]
    pub struct STC {
        register: VolatileCell<u32>,
    }
    #[doc = "Shadow transfer control"]
    pub mod stc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::STC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `CSE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CSER {
            #[doc = "Cascaded shadow transfer disabled"]
            VALUE1,
            #[doc = "Cascaded shadow transfer enabled"]
            VALUE2,
        }
        impl CSER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CSER::VALUE1 => false,
                    CSER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CSER {
                match value {
                    false => CSER::VALUE1,
                    true => CSER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CSER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CSER::VALUE2
            }
        }
        #[doc = "Possible values of the field `STM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STMR {
            #[doc = "Shadow transfer is done in Period Match and One match."]
            VALUE1,
            #[doc = "Shadow transfer is done only in Period Match."]
            VALUE2,
            #[doc = "Shadow transfer is done only in One Match."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl STMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STMR::VALUE1 => 0,
                    STMR::VALUE2 => 0x01,
                    STMR::VALUE3 => 0x02,
                    STMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STMR {
                match value {
                    0 => STMR::VALUE1,
                    1 => STMR::VALUE2,
                    2 => STMR::VALUE3,
                    i => STMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STMR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `CSE`"]
        pub enum CSEW {
            #[doc = "Cascaded shadow transfer disabled"]
            VALUE1,
            #[doc = "Cascaded shadow transfer enabled"]
            VALUE2,
        }
        impl CSEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CSEW::VALUE1 => false,
                    CSEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Cascaded shadow transfer disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSEW::VALUE1)
            }
            #[doc = "Cascaded shadow transfer enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STM`"]
        pub enum STMW {
            #[doc = "Shadow transfer is done in Period Match and One match."]
            VALUE1,
            #[doc = "Shadow transfer is done only in Period Match."]
            VALUE2,
            #[doc = "Shadow transfer is done only in One Match."]
            VALUE3,
        }
        impl STMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STMW::VALUE1 => 0,
                    STMW::VALUE2 => 1,
                    STMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Shadow transfer is done in Period Match and One match."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STMW::VALUE1)
            }
            #[doc = "Shadow transfer is done only in Period Match."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STMW::VALUE2)
            }
            #[doc = "Shadow transfer is done only in One Match."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Cascaded shadow transfer enable"]
            #[inline]
            pub fn cse(&self) -> CSER {
                CSER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 1:2 - Shadow transfer mode"]
            #[inline]
            pub fn stm(&self) -> STMR {
                STMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Cascaded shadow transfer enable"]
            #[inline]
            pub fn cse(&mut self) -> _CSEW {
                _CSEW { w: self }
            }
            #[doc = "Bits 1:2 - Shadow transfer mode"]
            #[inline]
            pub fn stm(&mut self) -> _STMW {
                _STMW { w: self }
            }
        }
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub struct CCU80_CC80 {
    register_block: ccu80_cc80::RegisterBlock,
}
impl Deref for CCU80_CC80 {
    type Target = ccu80_cc80::RegisterBlock;
    fn deref(&self) -> &ccu80_cc80::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub const CCU80_CC81: Peripheral<CCU80_CC81> = unsafe { Peripheral::new(0x4002_0200) };
#[doc = r" Register block"]
pub struct CCU80_CC81 {
    register_block: ccu80_cc80::RegisterBlock,
}
impl Deref for CCU80_CC81 {
    type Target = ccu80_cc80::RegisterBlock;
    fn deref(&self) -> &ccu80_cc80::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub const CCU80_CC82: Peripheral<CCU80_CC82> = unsafe { Peripheral::new(0x4002_0300) };
#[doc = r" Register block"]
pub struct CCU80_CC82 {
    register_block: ccu80_cc80::RegisterBlock,
}
impl Deref for CCU80_CC82 {
    type Target = ccu80_cc80::RegisterBlock;
    fn deref(&self) -> &ccu80_cc80::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Capture Compare Unit 8 - Unit 0"]
pub const CCU80_CC83: Peripheral<CCU80_CC83> = unsafe { Peripheral::new(0x4002_0400) };
#[doc = r" Register block"]
pub struct CCU80_CC83 {
    register_block: ccu80_cc80::RegisterBlock,
}
impl Deref for CCU80_CC83 {
    type Target = ccu80_cc80::RegisterBlock;
    fn deref(&self) -> &ccu80_cc80::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0: Peripheral<HRPWM0> = unsafe { Peripheral::new(0x4002_0900) };
#[doc = "High Resolution PWM Unit"]
pub mod hrpwm0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Bias and suspend configuration"]
        pub hrbsc: HRBSC,
        _reserved0: [u8; 4usize],
        #[doc = "0x08 - Module identification register"]
        pub midr: MIDR,
        _reserved1: [u8; 8usize],
        #[doc = "0x14 - Global Analog Configuration"]
        pub glbana: GLBANA,
        _reserved2: [u8; 8usize],
        #[doc = "0x20 - Global CSG configuration"]
        pub csgcfg: CSGCFG,
        #[doc = "0x24 - Global CSG run bit set"]
        pub csgsetg: CSGSETG,
        #[doc = "0x28 - Global CSG run bit clear"]
        pub csgclrg: CSGCLRG,
        #[doc = "0x2c - Global CSG run bit status"]
        pub csgstatg: CSGSTATG,
        #[doc = "0x30 - Global CSG slope/prescaler control"]
        pub csgfcg: CSGFCG,
        #[doc = "0x34 - Global CSG slope/prescaler status"]
        pub csgfsg: CSGFSG,
        #[doc = "0x38 - Global CSG shadow/switch trigger"]
        pub csgtrg: CSGTRG,
        #[doc = "0x3c - Global CSG shadow trigger clear"]
        pub csgtrc: CSGTRC,
        #[doc = "0x40 - Global CSG shadow/switch status"]
        pub csgtrsg: CSGTRSG,
        _reserved3: [u8; 28usize],
        #[doc = "0x60 - Global HRC configuration"]
        pub hrccfg: HRCCFG,
        #[doc = "0x64 - Global HRC shadow trigger set"]
        pub hrcstrg: HRCSTRG,
        #[doc = "0x68 - Global HRC shadow trigger clear"]
        pub hrcctrg: HRCCTRG,
        #[doc = "0x6c - Global HRC shadow transfer status"]
        pub hrcstsg: HRCSTSG,
        #[doc = "0x70 - High Resolution Generation Status"]
        pub hrghrs: HRGHRS,
    }
    #[doc = "Bias and suspend configuration"]
    pub struct HRBSC {
        register: VolatileCell<u32>,
    }
    #[doc = "Bias and suspend configuration"]
    pub mod hrbsc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HRBSC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SUSCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SUSCFGR {
            #[doc = "Suspend is ignored."]
            VALUE1,
            #[doc = "CSGy and HRCy units are halted."]
            VALUE2,
            #[doc = "Comparator outputs, HRPWMx.CyO are clamped to passive level and the CSGy units are halted. High resolution channel outputs, HRPWMx.HROUTy0 and HRPWMx.HROUTy1, are clamped to passive state and the HRCy units are halted."]
            VALUE3,
            #[doc = "CSGy units are halted. High resolution channel outputs, HRPWMx.HROUTy0 and HRPWMx.HROUTy1, are clamped to passive state and the HRCy units are halted."]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SUSCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SUSCFGR::VALUE1 => 0,
                    SUSCFGR::VALUE2 => 0x01,
                    SUSCFGR::VALUE3 => 0x02,
                    SUSCFGR::VALUE4 => 0x03,
                    SUSCFGR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SUSCFGR {
                match value {
                    0 => SUSCFGR::VALUE1,
                    1 => SUSCFGR::VALUE2,
                    2 => SUSCFGR::VALUE3,
                    3 => SUSCFGR::VALUE4,
                    i => SUSCFGR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SUSCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SUSCFGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SUSCFGR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SUSCFGR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct HRBER {
            bits: bool,
        }
        impl HRBER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `SUSCFG`"]
        pub enum SUSCFGW {
            #[doc = "Suspend is ignored."]
            VALUE1,
            #[doc = "CSGy and HRCy units are halted."]
            VALUE2,
            #[doc = "Comparator outputs, HRPWMx.CyO are clamped to passive level and the CSGy units are halted. High resolution channel outputs, HRPWMx.HROUTy0 and HRPWMx.HROUTy1, are clamped to passive state and the HRCy units are halted."]
            VALUE3,
            #[doc = "CSGy units are halted. High resolution channel outputs, HRPWMx.HROUTy0 and HRPWMx.HROUTy1, are clamped to passive state and the HRCy units are halted."]
            VALUE4,
        }
        impl SUSCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SUSCFGW::VALUE1 => 0,
                    SUSCFGW::VALUE2 => 1,
                    SUSCFGW::VALUE3 => 2,
                    SUSCFGW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SUSCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SUSCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SUSCFGW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Suspend is ignored."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE1)
            }
            #[doc = "CSGy and HRCy units are halted."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE2)
            }
            #[doc = "Comparator outputs, HRPWMx.CyO are clamped to passive level and the CSGy units are halted. High resolution channel outputs, HRPWMx.HROUTy0 and HRPWMx.HROUTy1, are clamped to passive state and the HRCy units are halted."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE3)
            }
            #[doc = "CSGy units are halted. High resolution channel outputs, HRPWMx.HROUTy0 and HRPWMx.HROUTy1, are clamped to passive state and the HRCy units are halted."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SUSCFGW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRBEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRBEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Suspend configuration"]
            #[inline]
            pub fn suscfg(&self) -> SUSCFGR {
                SUSCFGR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 8 - HRPWM bias enable"]
            #[inline]
            pub fn hrbe(&self) -> HRBER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                HRBER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Suspend configuration"]
            #[inline]
            pub fn suscfg(&mut self) -> _SUSCFGW {
                _SUSCFGW { w: self }
            }
            #[doc = "Bit 8 - HRPWM bias enable"]
            #[inline]
            pub fn hrbe(&mut self) -> _HRBEW {
                _HRBEW { w: self }
            }
        }
    }
    #[doc = "Module identification register"]
    pub struct MIDR {
        register: VolatileCell<u32>,
    }
    #[doc = "Module identification register"]
    pub mod midr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MIDR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODRR {
            bits: u8,
        }
        impl MODRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODTR {
            bits: u8,
        }
        impl MODTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODNR {
            bits: u16,
        }
        impl MODNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn modr(&self) -> MODRR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODRR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn modt(&self) -> MODTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODTR { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn modn(&self) -> MODNR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MODNR { bits }
            }
        }
    }
    #[doc = "Global Analog Configuration"]
    pub struct GLBANA {
        register: VolatileCell<u32>,
    }
    #[doc = "Global Analog Configuration"]
    pub mod glbana {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GLBANA {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SLDLYR {
            bits: u8,
        }
        impl SLDLYR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct FUPR {
            bits: bool,
        }
        impl FUPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct FDNR {
            bits: bool,
        }
        impl FDNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct SLCPR {
            bits: u8,
        }
        impl SLCPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SLIBLDOR {
            bits: u8,
        }
        impl SLIBLDOR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SLIBLFR {
            bits: u8,
        }
        impl SLIBLFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct SLVREFR {
            bits: u8,
        }
        impl SLVREFR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRIBIASR {
            bits: u8,
        }
        impl TRIBIASR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `GHREN`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GHRENR {
            #[doc = "Global high resolution generation is enabled"]
            VALUE1,
            #[doc = "Global high resolution generation is disabled"]
            VALUE2,
        }
        impl GHRENR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    GHRENR::VALUE1 => false,
                    GHRENR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> GHRENR {
                match value {
                    false => GHRENR::VALUE1,
                    true => GHRENR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GHRENR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GHRENR::VALUE2
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLDLYW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLDLYW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _FUPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FUPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _FDNW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FDNW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLCPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLCPW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLIBLDOW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLIBLDOW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLIBLFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLIBLFW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SLVREFW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SLVREFW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRIBIASW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRIBIASW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GHREN`"]
        pub enum GHRENW {
            #[doc = "Global high resolution generation is enabled"]
            VALUE1,
            #[doc = "Global high resolution generation is disabled"]
            VALUE2,
        }
        impl GHRENW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    GHRENW::VALUE1 => false,
                    GHRENW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GHRENW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GHRENW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GHRENW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Global high resolution generation is enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GHRENW::VALUE1)
            }
            #[doc = "Global high resolution generation is disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GHRENW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Delay of lock detection"]
            #[inline]
            pub fn sldly(&self) -> SLDLYR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SLDLYR { bits }
            }
            #[doc = "Bit 2 - Force chargepump up"]
            #[inline]
            pub fn fup(&self) -> FUPR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FUPR { bits }
            }
            #[doc = "Bit 3 - Force chargepump down"]
            #[inline]
            pub fn fdn(&self) -> FDNR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                FDNR { bits }
            }
            #[doc = "Bits 6:8 - HRCs chargepump current selection"]
            #[inline]
            pub fn slcp(&self) -> SLCPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SLCPR { bits }
            }
            #[doc = "Bits 9:10 - HRCs LDO bias current"]
            #[inline]
            pub fn slibldo(&self) -> SLIBLDOR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SLIBLDOR { bits }
            }
            #[doc = "Bits 11:12 - HRCs loop filter bias current"]
            #[inline]
            pub fn sliblf(&self) -> SLIBLFR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SLIBLFR { bits }
            }
            #[doc = "Bits 13:15 - Reference voltage for chargepump and loop filter"]
            #[inline]
            pub fn slvref(&self) -> SLVREFR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SLVREFR { bits }
            }
            #[doc = "Bits 16:17 - Bias trimming"]
            #[inline]
            pub fn tribias(&self) -> TRIBIASR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TRIBIASR { bits }
            }
            #[doc = "Bit 18 - Force chargepump down"]
            #[inline]
            pub fn ghren(&self) -> GHRENR {
                GHRENR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x4b8c }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Delay of lock detection"]
            #[inline]
            pub fn sldly(&mut self) -> _SLDLYW {
                _SLDLYW { w: self }
            }
            #[doc = "Bit 2 - Force chargepump up"]
            #[inline]
            pub fn fup(&mut self) -> _FUPW {
                _FUPW { w: self }
            }
            #[doc = "Bit 3 - Force chargepump down"]
            #[inline]
            pub fn fdn(&mut self) -> _FDNW {
                _FDNW { w: self }
            }
            #[doc = "Bits 6:8 - HRCs chargepump current selection"]
            #[inline]
            pub fn slcp(&mut self) -> _SLCPW {
                _SLCPW { w: self }
            }
            #[doc = "Bits 9:10 - HRCs LDO bias current"]
            #[inline]
            pub fn slibldo(&mut self) -> _SLIBLDOW {
                _SLIBLDOW { w: self }
            }
            #[doc = "Bits 11:12 - HRCs loop filter bias current"]
            #[inline]
            pub fn sliblf(&mut self) -> _SLIBLFW {
                _SLIBLFW { w: self }
            }
            #[doc = "Bits 13:15 - Reference voltage for chargepump and loop filter"]
            #[inline]
            pub fn slvref(&mut self) -> _SLVREFW {
                _SLVREFW { w: self }
            }
            #[doc = "Bits 16:17 - Bias trimming"]
            #[inline]
            pub fn tribias(&mut self) -> _TRIBIASW {
                _TRIBIASW { w: self }
            }
            #[doc = "Bit 18 - Force chargepump down"]
            #[inline]
            pub fn ghren(&mut self) -> _GHRENW {
                _GHRENW { w: self }
            }
        }
    }
    #[doc = "Global CSG configuration"]
    pub struct CSGCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG configuration"]
    pub mod csgcfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CSGCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `C0PM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C0PMR {
            #[doc = "CSG0 unit is powered OFF"]
            VALUE1,
            #[doc = "CSG0 unit is set in Low Speed Mode"]
            VALUE2,
            #[doc = "CSG0 unit is set in High Speed Mode"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C0PMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C0PMR::VALUE1 => 0,
                    C0PMR::VALUE2 => 0x01,
                    C0PMR::VALUE4 => 0x03,
                    C0PMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C0PMR {
                match value {
                    0 => C0PMR::VALUE1,
                    1 => C0PMR::VALUE2,
                    3 => C0PMR::VALUE4,
                    i => C0PMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C0PMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C0PMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == C0PMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `C1PM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C1PMR {
            #[doc = "CSG1 unit is powered OFF"]
            VALUE1,
            #[doc = "CSG1 unit is set in Low Speed Mode"]
            VALUE2,
            #[doc = "CSG1 unit is set in High Speed Mode"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C1PMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C1PMR::VALUE1 => 0,
                    C1PMR::VALUE2 => 0x01,
                    C1PMR::VALUE4 => 0x03,
                    C1PMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C1PMR {
                match value {
                    0 => C1PMR::VALUE1,
                    1 => C1PMR::VALUE2,
                    3 => C1PMR::VALUE4,
                    i => C1PMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C1PMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C1PMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == C1PMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `C2PM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C2PMR {
            #[doc = "CSG2 unit is powered OFF"]
            VALUE1,
            #[doc = "CSG2 unit is set in Low Speed Mode"]
            VALUE2,
            #[doc = "CSG2 unit is set in High Speed Mode"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C2PMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C2PMR::VALUE1 => 0,
                    C2PMR::VALUE2 => 0x01,
                    C2PMR::VALUE4 => 0x03,
                    C2PMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C2PMR {
                match value {
                    0 => C2PMR::VALUE1,
                    1 => C2PMR::VALUE2,
                    3 => C2PMR::VALUE4,
                    i => C2PMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C2PMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C2PMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == C2PMR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct C0CDR {
            bits: bool,
        }
        impl C0CDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct C1CDR {
            bits: bool,
        }
        impl C1CDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct C2CDR {
            bits: bool,
        }
        impl C2CDR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Values that can be written to the field `C0PM`"]
        pub enum C0PMW {
            #[doc = "CSG0 unit is powered OFF"]
            VALUE1,
            #[doc = "CSG0 unit is set in Low Speed Mode"]
            VALUE2,
            #[doc = "CSG0 unit is set in High Speed Mode"]
            VALUE4,
        }
        impl C0PMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C0PMW::VALUE1 => 0,
                    C0PMW::VALUE2 => 1,
                    C0PMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C0PMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C0PMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C0PMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CSG0 unit is powered OFF"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C0PMW::VALUE1)
            }
            #[doc = "CSG0 unit is set in Low Speed Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C0PMW::VALUE2)
            }
            #[doc = "CSG0 unit is set in High Speed Mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(C0PMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C1PM`"]
        pub enum C1PMW {
            #[doc = "CSG1 unit is powered OFF"]
            VALUE1,
            #[doc = "CSG1 unit is set in Low Speed Mode"]
            VALUE2,
            #[doc = "CSG1 unit is set in High Speed Mode"]
            VALUE4,
        }
        impl C1PMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C1PMW::VALUE1 => 0,
                    C1PMW::VALUE2 => 1,
                    C1PMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C1PMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C1PMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C1PMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CSG1 unit is powered OFF"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C1PMW::VALUE1)
            }
            #[doc = "CSG1 unit is set in Low Speed Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C1PMW::VALUE2)
            }
            #[doc = "CSG1 unit is set in High Speed Mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(C1PMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C2PM`"]
        pub enum C2PMW {
            #[doc = "CSG2 unit is powered OFF"]
            VALUE1,
            #[doc = "CSG2 unit is set in Low Speed Mode"]
            VALUE2,
            #[doc = "CSG2 unit is set in High Speed Mode"]
            VALUE4,
        }
        impl C2PMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C2PMW::VALUE1 => 0,
                    C2PMW::VALUE2 => 1,
                    C2PMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C2PMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C2PMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C2PMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CSG2 unit is powered OFF"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C2PMW::VALUE1)
            }
            #[doc = "CSG2 unit is set in Low Speed Mode"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C2PMW::VALUE2)
            }
            #[doc = "CSG2 unit is set in High Speed Mode"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(C2PMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _C0CDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C0CDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _C1CDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C1CDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _C2CDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C2CDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - CSG0 Power Mode"]
            #[inline]
            pub fn c0pm(&self) -> C0PMR {
                C0PMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - CSG1 Power Mode"]
            #[inline]
            pub fn c1pm(&self) -> C1PMR {
                C1PMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - CSG2 Power Mode"]
            #[inline]
            pub fn c2pm(&self) -> C2PMR {
                C2PMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - CSG0 Clock disable"]
            #[inline]
            pub fn c0cd(&self) -> C0CDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                C0CDR { bits }
            }
            #[doc = "Bit 17 - CSG1 Clock disable"]
            #[inline]
            pub fn c1cd(&self) -> C1CDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                C1CDR { bits }
            }
            #[doc = "Bit 18 - CSG2 Clock disable"]
            #[inline]
            pub fn c2cd(&self) -> C2CDR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                C2CDR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - CSG0 Power Mode"]
            #[inline]
            pub fn c0pm(&mut self) -> _C0PMW {
                _C0PMW { w: self }
            }
            #[doc = "Bits 2:3 - CSG1 Power Mode"]
            #[inline]
            pub fn c1pm(&mut self) -> _C1PMW {
                _C1PMW { w: self }
            }
            #[doc = "Bits 4:5 - CSG2 Power Mode"]
            #[inline]
            pub fn c2pm(&mut self) -> _C2PMW {
                _C2PMW { w: self }
            }
            #[doc = "Bit 16 - CSG0 Clock disable"]
            #[inline]
            pub fn c0cd(&mut self) -> _C0CDW {
                _C0CDW { w: self }
            }
            #[doc = "Bit 17 - CSG1 Clock disable"]
            #[inline]
            pub fn c1cd(&mut self) -> _C1CDW {
                _C1CDW { w: self }
            }
            #[doc = "Bit 18 - CSG2 Clock disable"]
            #[inline]
            pub fn c2cd(&mut self) -> _C2CDW {
                _C2CDW { w: self }
            }
        }
    }
    #[doc = "Global CSG run bit set"]
    pub struct CSGSETG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG run bit set"]
    pub mod csgsetg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CSGSETG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SD0RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SD0RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SC0RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SC0RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SC0PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SC0PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SD1RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SD1RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SC1RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SC1RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SC1PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SC1PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SD2RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SD2RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SC2RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SC2RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SC2PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SC2PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - DAC0 run bit set"]
            #[inline]
            pub fn sd0r(&mut self) -> _SD0RW {
                _SD0RW { w: self }
            }
            #[doc = "Bit 1 - CMP0 run bit set"]
            #[inline]
            pub fn sc0r(&mut self) -> _SC0RW {
                _SC0RW { w: self }
            }
            #[doc = "Bit 2 - CMP0 passive level set"]
            #[inline]
            pub fn sc0p(&mut self) -> _SC0PW {
                _SC0PW { w: self }
            }
            #[doc = "Bit 4 - DAC1 run bit set"]
            #[inline]
            pub fn sd1r(&mut self) -> _SD1RW {
                _SD1RW { w: self }
            }
            #[doc = "Bit 5 - CMP1 run bit set"]
            #[inline]
            pub fn sc1r(&mut self) -> _SC1RW {
                _SC1RW { w: self }
            }
            #[doc = "Bit 6 - CMP1 passive level set"]
            #[inline]
            pub fn sc1p(&mut self) -> _SC1PW {
                _SC1PW { w: self }
            }
            #[doc = "Bit 8 - DAC2 run bit set"]
            #[inline]
            pub fn sd2r(&mut self) -> _SD2RW {
                _SD2RW { w: self }
            }
            #[doc = "Bit 9 - CMP2 run bit set"]
            #[inline]
            pub fn sc2r(&mut self) -> _SC2RW {
                _SC2RW { w: self }
            }
            #[doc = "Bit 10 - CMP2 passive level set"]
            #[inline]
            pub fn sc2p(&mut self) -> _SC2PW {
                _SC2PW { w: self }
            }
        }
    }
    #[doc = "Global CSG run bit clear"]
    pub struct CSGCLRG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG run bit clear"]
    pub mod csgclrg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CSGCLRG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _CD0RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CD0RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CC0RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CC0RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CC0PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CC0PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CD1RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CD1RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CC1RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CC1RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CC1PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CC1PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CD2RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CD2RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CC2RW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CC2RW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CC2PW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CC2PW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - DAC0 run bit clear"]
            #[inline]
            pub fn cd0r(&mut self) -> _CD0RW {
                _CD0RW { w: self }
            }
            #[doc = "Bit 1 - CMP0 run bit clear"]
            #[inline]
            pub fn cc0r(&mut self) -> _CC0RW {
                _CC0RW { w: self }
            }
            #[doc = "Bit 2 - CMP0 passive level clear"]
            #[inline]
            pub fn cc0p(&mut self) -> _CC0PW {
                _CC0PW { w: self }
            }
            #[doc = "Bit 4 - DAC1 run bit clear"]
            #[inline]
            pub fn cd1r(&mut self) -> _CD1RW {
                _CD1RW { w: self }
            }
            #[doc = "Bit 5 - CMP1 run bit clear"]
            #[inline]
            pub fn cc1r(&mut self) -> _CC1RW {
                _CC1RW { w: self }
            }
            #[doc = "Bit 6 - CMP1 passive level clear"]
            #[inline]
            pub fn cc1p(&mut self) -> _CC1PW {
                _CC1PW { w: self }
            }
            #[doc = "Bit 8 - DAC2 run bit clear"]
            #[inline]
            pub fn cd2r(&mut self) -> _CD2RW {
                _CD2RW { w: self }
            }
            #[doc = "Bit 9 - CMP2 run bit clear"]
            #[inline]
            pub fn cc2r(&mut self) -> _CC2RW {
                _CC2RW { w: self }
            }
            #[doc = "Bit 10 - CMP2 passive level clear"]
            #[inline]
            pub fn cc2p(&mut self) -> _CC2PW {
                _CC2PW { w: self }
            }
        }
    }
    #[doc = "Global CSG run bit status"]
    pub struct CSGSTATG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG run bit status"]
    pub mod csgstatg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CSGSTATG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `D0RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum D0RBR {
            #[doc = "DAC0 is not running (control logic is disabled)"]
            VALUE1,
            #[doc = "DAC0 is running"]
            VALUE2,
        }
        impl D0RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    D0RBR::VALUE1 => false,
                    D0RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> D0RBR {
                match value {
                    false => D0RBR::VALUE1,
                    true => D0RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == D0RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == D0RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `C0RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C0RBR {
            #[doc = "CMP0 functionality is disabled"]
            VALUE1,
            #[doc = "CMP0 functionality is enabled"]
            VALUE2,
        }
        impl C0RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    C0RBR::VALUE1 => false,
                    C0RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> C0RBR {
                match value {
                    false => C0RBR::VALUE1,
                    true => C0RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C0RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C0RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSLS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSLS0R {
            #[doc = "CMP0 output is not clamped"]
            VALUE1,
            #[doc = "CMP0 output is clamped"]
            VALUE2,
        }
        impl PSLS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSLS0R::VALUE1 => false,
                    PSLS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSLS0R {
                match value {
                    false => PSLS0R::VALUE1,
                    true => PSLS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSLS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSLS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `D1RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum D1RBR {
            #[doc = "DAC1 is not running (control logic is disabled)"]
            VALUE1,
            #[doc = "DAC1 is running"]
            VALUE2,
        }
        impl D1RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    D1RBR::VALUE1 => false,
                    D1RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> D1RBR {
                match value {
                    false => D1RBR::VALUE1,
                    true => D1RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == D1RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == D1RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `C1RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C1RBR {
            #[doc = "CMP1 functionality is disabled"]
            VALUE1,
            #[doc = "CMP1 functionality is enabled"]
            VALUE2,
        }
        impl C1RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    C1RBR::VALUE1 => false,
                    C1RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> C1RBR {
                match value {
                    false => C1RBR::VALUE1,
                    true => C1RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C1RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C1RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSLS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSLS1R {
            #[doc = "CMP1 output is not clamped"]
            VALUE1,
            #[doc = "CMP1 output is clamped"]
            VALUE2,
        }
        impl PSLS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSLS1R::VALUE1 => false,
                    PSLS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSLS1R {
                match value {
                    false => PSLS1R::VALUE1,
                    true => PSLS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSLS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSLS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `D2RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum D2RBR {
            #[doc = "DAC2 is not running (control logic is disabled)"]
            VALUE1,
            #[doc = "DAC1 is running"]
            VALUE2,
        }
        impl D2RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    D2RBR::VALUE1 => false,
                    D2RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> D2RBR {
                match value {
                    false => D2RBR::VALUE1,
                    true => D2RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == D2RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == D2RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `C2RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C2RBR {
            #[doc = "CMP2 functionality is disabled"]
            VALUE1,
            #[doc = "CMP2 functionality is enabled"]
            VALUE2,
        }
        impl C2RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    C2RBR::VALUE1 => false,
                    C2RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> C2RBR {
                match value {
                    false => C2RBR::VALUE1,
                    true => C2RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C2RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C2RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSLS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSLS2R {
            #[doc = "CMP2 output is not clamped"]
            VALUE1,
            #[doc = "CMP2 output is clamped"]
            VALUE2,
        }
        impl PSLS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSLS2R::VALUE1 => false,
                    PSLS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSLS2R {
                match value {
                    false => PSLS2R::VALUE1,
                    true => PSLS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSLS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSLS2R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - DAC0 run bit status"]
            #[inline]
            pub fn d0rb(&self) -> D0RBR {
                D0RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - CMP0 run bit status"]
            #[inline]
            pub fn c0rb(&self) -> C0RBR {
                C0RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - CMP0 output passive status"]
            #[inline]
            pub fn psls0(&self) -> PSLS0R {
                PSLS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - DAC1 run bit status"]
            #[inline]
            pub fn d1rb(&self) -> D1RBR {
                D1RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - CMP1 run bit status"]
            #[inline]
            pub fn c1rb(&self) -> C1RBR {
                C1RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - CMP1 output passive status"]
            #[inline]
            pub fn psls1(&self) -> PSLS1R {
                PSLS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - DAC2 run bit status"]
            #[inline]
            pub fn d2rb(&self) -> D2RBR {
                D2RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - CMP2 run bit status"]
            #[inline]
            pub fn c2rb(&self) -> C2RBR {
                C2RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - CMP2 output passive status"]
            #[inline]
            pub fn psls2(&self) -> PSLS2R {
                PSLS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Global CSG slope/prescaler control"]
    pub struct CSGFCG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG slope/prescaler control"]
    pub mod csgfcg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CSGFCG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0STRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0STRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0STPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0STPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0STRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0STRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0STPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0STPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0CLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0CLRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1STRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1STRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1STPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1STPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1STRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1STRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1STPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1STPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1CLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1CLRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2STRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2STRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _S2STPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S2STPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2STRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2STRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2STPW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2STPW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2CLRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2CLRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Slope 0 start"]
            #[inline]
            pub fn s0str(&mut self) -> _S0STRW {
                _S0STRW { w: self }
            }
            #[doc = "Bit 1 - Slope 0 stop"]
            #[inline]
            pub fn s0stp(&mut self) -> _S0STPW {
                _S0STPW { w: self }
            }
            #[doc = "Bit 2 - Prescaler 0 start"]
            #[inline]
            pub fn ps0str(&mut self) -> _PS0STRW {
                _PS0STRW { w: self }
            }
            #[doc = "Bit 3 - Prescaler 0 stop"]
            #[inline]
            pub fn ps0stp(&mut self) -> _PS0STPW {
                _PS0STPW { w: self }
            }
            #[doc = "Bit 4 - Prescaler 0 clear"]
            #[inline]
            pub fn ps0clr(&mut self) -> _PS0CLRW {
                _PS0CLRW { w: self }
            }
            #[doc = "Bit 8 - Slope 1 start"]
            #[inline]
            pub fn s1str(&mut self) -> _S1STRW {
                _S1STRW { w: self }
            }
            #[doc = "Bit 9 - Slope 1 stop"]
            #[inline]
            pub fn s1stp(&mut self) -> _S1STPW {
                _S1STPW { w: self }
            }
            #[doc = "Bit 10 - Prescaler 1 start"]
            #[inline]
            pub fn ps1str(&mut self) -> _PS1STRW {
                _PS1STRW { w: self }
            }
            #[doc = "Bit 11 - Prescaler 1 stop"]
            #[inline]
            pub fn ps1stp(&mut self) -> _PS1STPW {
                _PS1STPW { w: self }
            }
            #[doc = "Bit 12 - Prescaler 1 clear"]
            #[inline]
            pub fn ps1clr(&mut self) -> _PS1CLRW {
                _PS1CLRW { w: self }
            }
            #[doc = "Bit 16 - Slope 2 start"]
            #[inline]
            pub fn s2str(&mut self) -> _S2STRW {
                _S2STRW { w: self }
            }
            #[doc = "Bit 17 - Slope 2 stop"]
            #[inline]
            pub fn s2stp(&mut self) -> _S2STPW {
                _S2STPW { w: self }
            }
            #[doc = "Bit 18 - Prescaler 2 start"]
            #[inline]
            pub fn ps2str(&mut self) -> _PS2STRW {
                _PS2STRW { w: self }
            }
            #[doc = "Bit 19 - Prescaler 2 stop"]
            #[inline]
            pub fn ps2stp(&mut self) -> _PS2STPW {
                _PS2STPW { w: self }
            }
            #[doc = "Bit 20 - Prescaler 2 clear"]
            #[inline]
            pub fn ps2clr(&mut self) -> _PS2CLRW {
                _PS2CLRW { w: self }
            }
        }
    }
    #[doc = "Global CSG slope/prescaler status"]
    pub struct CSGFSG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG slope/prescaler status"]
    pub mod csgfsg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CSGFSG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `S0RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0RBR {
            #[doc = "Slope generation is stopped."]
            VALUE1,
            #[doc = "Slope generation is running."]
            VALUE2,
        }
        impl S0RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S0RBR::VALUE1 => false,
                    S0RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S0RBR {
                match value {
                    false => S0RBR::VALUE1,
                    true => S0RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `P0RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0RBR {
            #[doc = "Prescaler is stopped. The clock used for the slope generation is halted and therefore the slope is frozen."]
            VALUE1,
            #[doc = "Prescaler is running."]
            VALUE2,
        }
        impl P0RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0RBR::VALUE1 => false,
                    P0RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0RBR {
                match value {
                    false => P0RBR::VALUE1,
                    true => P0RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1RBR {
            #[doc = "Slope generation is stopped."]
            VALUE1,
            #[doc = "Slope generation is running."]
            VALUE2,
        }
        impl S1RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S1RBR::VALUE1 => false,
                    S1RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S1RBR {
                match value {
                    false => S1RBR::VALUE1,
                    true => S1RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1RBR {
            #[doc = "Prescaler is stopped. The clock used for the slope generation is halted and therefore the slope is frozen."]
            VALUE1,
            #[doc = "Prescaler is running."]
            VALUE2,
        }
        impl P1RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1RBR::VALUE1 => false,
                    P1RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1RBR {
                match value {
                    false => P1RBR::VALUE1,
                    true => P1RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S2RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S2RBR {
            #[doc = "Slope generation is stopped."]
            VALUE1,
            #[doc = "Slope generation is running."]
            VALUE2,
        }
        impl S2RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    S2RBR::VALUE1 => false,
                    S2RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> S2RBR {
                match value {
                    false => S2RBR::VALUE1,
                    true => S2RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S2RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S2RBR::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2RBR {
            #[doc = "Prescaler is stopped. The clock used for the slope generation is halted and therefore the slope is frozen."]
            VALUE1,
            #[doc = "Prescaler is running."]
            VALUE2,
        }
        impl P2RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2RBR::VALUE1 => false,
                    P2RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2RBR {
                match value {
                    false => P2RBR::VALUE1,
                    true => P2RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2RBR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - DAC0 slope generation status"]
            #[inline]
            pub fn s0rb(&self) -> S0RBR {
                S0RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - CSG0 prescaler status"]
            #[inline]
            pub fn p0rb(&self) -> P0RBR {
                P0RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - DAC1 slope generation status"]
            #[inline]
            pub fn s1rb(&self) -> S1RBR {
                S1RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - CSG1 prescaler status"]
            #[inline]
            pub fn p1rb(&self) -> P1RBR {
                P1RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - DAC2 slope generation status"]
            #[inline]
            pub fn s2rb(&self) -> S2RBR {
                S2RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - CSG2 prescaler status"]
            #[inline]
            pub fn p2rb(&self) -> P2RBR {
                P2RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Global CSG shadow/switch trigger"]
    pub struct CSGTRG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG shadow/switch trigger"]
    pub mod csgtrg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CSGTRG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _D0SESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D0SESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D0SVSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D0SVSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D1SESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D1SESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D1SVSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D1SVSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D2SESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D2SESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D2SVSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D2SVSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - DAC0 shadow transfer enable set"]
            #[inline]
            pub fn d0ses(&mut self) -> _D0SESW {
                _D0SESW { w: self }
            }
            #[doc = "Bit 1 - CMP0 inverting input switch request"]
            #[inline]
            pub fn d0svs(&mut self) -> _D0SVSW {
                _D0SVSW { w: self }
            }
            #[doc = "Bit 4 - DAC1 shadow transfer enable set"]
            #[inline]
            pub fn d1ses(&mut self) -> _D1SESW {
                _D1SESW { w: self }
            }
            #[doc = "Bit 5 - CMP1 inverting input switch request"]
            #[inline]
            pub fn d1svs(&mut self) -> _D1SVSW {
                _D1SVSW { w: self }
            }
            #[doc = "Bit 8 - DAC2 shadow transfer enable set"]
            #[inline]
            pub fn d2ses(&mut self) -> _D2SESW {
                _D2SESW { w: self }
            }
            #[doc = "Bit 9 - CMP2 inverting input switch request"]
            #[inline]
            pub fn d2svs(&mut self) -> _D2SVSW {
                _D2SVSW { w: self }
            }
        }
    }
    #[doc = "Global CSG shadow trigger clear"]
    pub struct CSGTRC {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG shadow trigger clear"]
    pub mod csgtrc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CSGTRC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _D0SECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D0SECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D1SECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D1SECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _D2SECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _D2SECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - DAC0 shadow transfer enable clear"]
            #[inline]
            pub fn d0sec(&mut self) -> _D0SECW {
                _D0SECW { w: self }
            }
            #[doc = "Bit 4 - DAC1 shadow transfer enable clear"]
            #[inline]
            pub fn d1sec(&mut self) -> _D1SECW {
                _D1SECW { w: self }
            }
            #[doc = "Bit 8 - DAC2 shadow transfer enable clear"]
            #[inline]
            pub fn d2sec(&mut self) -> _D2SECW {
                _D2SECW { w: self }
            }
        }
    }
    #[doc = "Global CSG shadow/switch status"]
    pub struct CSGTRSG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global CSG shadow/switch status"]
    pub mod csgtrsg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CSGTRSG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `D0STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum D0STER {
            #[doc = "Shadow transfer has been performed."]
            VALUE1,
            #[doc = "Shadow transfer has been requested but is still pending completion."]
            VALUE2,
        }
        impl D0STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    D0STER::VALUE1 => false,
                    D0STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> D0STER {
                match value {
                    false => D0STER::VALUE1,
                    true => D0STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == D0STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == D0STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SW0ST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SW0STR {
            #[doc = "Inverting input connected to HRPWMx.C0I[A]"]
            VALUE1,
            #[doc = "Inverting input connected to HRPWMx.C0I[B]"]
            VALUE2,
        }
        impl SW0STR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SW0STR::VALUE1 => false,
                    SW0STR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SW0STR {
                match value {
                    false => SW0STR::VALUE1,
                    true => SW0STR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SW0STR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SW0STR::VALUE2
            }
        }
        #[doc = "Possible values of the field `D1STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum D1STER {
            #[doc = "Shadow transfer has been performed."]
            VALUE1,
            #[doc = "Shadow transfer has been requested but is still pending completion."]
            VALUE2,
        }
        impl D1STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    D1STER::VALUE1 => false,
                    D1STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> D1STER {
                match value {
                    false => D1STER::VALUE1,
                    true => D1STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == D1STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == D1STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SW1ST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SW1STR {
            #[doc = "Inverting input connected to HRPWMx.C1I[A]"]
            VALUE1,
            #[doc = "Inverting input connected to HRPWMx.C1I[B]"]
            VALUE2,
        }
        impl SW1STR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SW1STR::VALUE1 => false,
                    SW1STR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SW1STR {
                match value {
                    false => SW1STR::VALUE1,
                    true => SW1STR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SW1STR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SW1STR::VALUE2
            }
        }
        #[doc = "Possible values of the field `D2STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum D2STER {
            #[doc = "Shadow transfer has been performed."]
            VALUE1,
            #[doc = "Shadow transfer has been requested but is still pending completion."]
            VALUE2,
        }
        impl D2STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    D2STER::VALUE1 => false,
                    D2STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> D2STER {
                match value {
                    false => D2STER::VALUE1,
                    true => D2STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == D2STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == D2STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `SW2ST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SW2STR {
            #[doc = "Inverting input connected to HRPWMx.C2I[A]"]
            VALUE1,
            #[doc = "Inverting input connected to HRPWMx.C2I[B]"]
            VALUE2,
        }
        impl SW2STR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SW2STR::VALUE1 => false,
                    SW2STR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SW2STR {
                match value {
                    false => SW2STR::VALUE1,
                    true => SW2STR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SW2STR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SW2STR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - DAC0 shadow transfer enable"]
            #[inline]
            pub fn d0ste(&self) -> D0STER {
                D0STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - CMP0 inverting input connection status"]
            #[inline]
            pub fn sw0st(&self) -> SW0STR {
                SW0STR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - DAC1 shadow transfer enable"]
            #[inline]
            pub fn d1ste(&self) -> D1STER {
                D1STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - CMP1 inverting input connection status"]
            #[inline]
            pub fn sw1st(&self) -> SW1STR {
                SW1STR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - DAC2 shadow transfer enable"]
            #[inline]
            pub fn d2ste(&self) -> D2STER {
                D2STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - CMP2 inverting input connection status"]
            #[inline]
            pub fn sw2st(&self) -> SW2STR {
                SW2STR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Global HRC configuration"]
    pub struct HRCCFG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global HRC configuration"]
    pub mod hrccfg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HRCCFG {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HRCPM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRCPMR {
            #[doc = "High resolution generation logic is OFF. It is not possible to generate high resolution signals throughout any of the high resolution channels, HRCy."]
            VALUE1,
            #[doc = "High resolution generation logic is ON. In this mode it is possible to generate a high resolution signal placement with the HRCy subunits."]
            VALUE2,
        }
        impl HRCPMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRCPMR::VALUE1 => false,
                    HRCPMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRCPMR {
                match value {
                    false => HRCPMR::VALUE1,
                    true => HRCPMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRCPMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRCPMR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HRC0E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRC0ER {
            #[doc = "HRC0 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC0 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC0 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC0ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRC0ER::VALUE1 => false,
                    HRC0ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRC0ER {
                match value {
                    false => HRC0ER::VALUE1,
                    true => HRC0ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRC0ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRC0ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `HRC1E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRC1ER {
            #[doc = "HRC1 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC1 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC1 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC1ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRC1ER::VALUE1 => false,
                    HRC1ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRC1ER {
                match value {
                    false => HRC1ER::VALUE1,
                    true => HRC1ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRC1ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRC1ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `HRC2E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRC2ER {
            #[doc = "HRC2 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC2 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC2 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC2ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRC2ER::VALUE1 => false,
                    HRC2ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRC2ER {
                match value {
                    false => HRC2ER::VALUE1,
                    true => HRC2ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRC2ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRC2ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `HRC3E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRC3ER {
            #[doc = "HRC3 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC3 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC3 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC3ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRC3ER::VALUE1 => false,
                    HRC3ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRC3ER {
                match value {
                    false => HRC3ER::VALUE1,
                    true => HRC3ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRC3ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRC3ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `CLKC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CLKCR {
            #[doc = "No clock frequency is selected"]
            VALUE1,
            #[doc = "Module clock frequency is 180 MHz"]
            VALUE2,
            #[doc = "Module clock frequency is 120 MHz"]
            VALUE3,
            #[doc = "Module clock frequency is 80 MHz"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl CLKCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CLKCR::VALUE1 => 0,
                    CLKCR::VALUE2 => 0x01,
                    CLKCR::VALUE3 => 0x02,
                    CLKCR::VALUE4 => 0x03,
                    CLKCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CLKCR {
                match value {
                    0 => CLKCR::VALUE1,
                    1 => CLKCR::VALUE2,
                    2 => CLKCR::VALUE3,
                    3 => CLKCR::VALUE4,
                    i => CLKCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CLKCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CLKCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CLKCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CLKCR::VALUE4
            }
        }
        #[doc = "Possible values of the field `LRC0E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LRC0ER {
            #[doc = "HRC0 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC0 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC0 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC0ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LRC0ER::VALUE1 => false,
                    LRC0ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LRC0ER {
                match value {
                    false => LRC0ER::VALUE1,
                    true => LRC0ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LRC0ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LRC0ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `LRC1E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LRC1ER {
            #[doc = "HRC1 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC1 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC1 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC1ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LRC1ER::VALUE1 => false,
                    LRC1ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LRC1ER {
                match value {
                    false => LRC1ER::VALUE1,
                    true => LRC1ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LRC1ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LRC1ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `LRC2E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LRC2ER {
            #[doc = "HRC2 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC2 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC2 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC2ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LRC2ER::VALUE1 => false,
                    LRC2ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LRC2ER {
                match value {
                    false => LRC2ER::VALUE1,
                    true => LRC2ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LRC2ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LRC2ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `LRC3E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LRC3ER {
            #[doc = "HRC3 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC3 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC3 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC3ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    LRC3ER::VALUE1 => false,
                    LRC3ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> LRC3ER {
                match value {
                    false => LRC3ER::VALUE1,
                    true => LRC3ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LRC3ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LRC3ER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `HRCPM`"]
        pub enum HRCPMW {
            #[doc = "High resolution generation logic is OFF. It is not possible to generate high resolution signals throughout any of the high resolution channels, HRCy."]
            VALUE1,
            #[doc = "High resolution generation logic is ON. In this mode it is possible to generate a high resolution signal placement with the HRCy subunits."]
            VALUE2,
        }
        impl HRCPMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRCPMW::VALUE1 => false,
                    HRCPMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRCPMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRCPMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRCPMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "High resolution generation logic is OFF. It is not possible to generate high resolution signals throughout any of the high resolution channels, HRCy."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRCPMW::VALUE1)
            }
            #[doc = "High resolution generation logic is ON. In this mode it is possible to generate a high resolution signal placement with the HRCy subunits."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRCPMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRC0E`"]
        pub enum HRC0EW {
            #[doc = "HRC0 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC0 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC0 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC0EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRC0EW::VALUE1 => false,
                    HRC0EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRC0EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRC0EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRC0EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC0 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC0 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRC0EW::VALUE1)
            }
            #[doc = "HRC0 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRC0EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRC1E`"]
        pub enum HRC1EW {
            #[doc = "HRC1 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC1 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC1 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC1EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRC1EW::VALUE1 => false,
                    HRC1EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRC1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRC1EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRC1EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC1 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC1 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRC1EW::VALUE1)
            }
            #[doc = "HRC1 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRC1EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRC2E`"]
        pub enum HRC2EW {
            #[doc = "HRC2 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC2 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC2 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC2EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRC2EW::VALUE1 => false,
                    HRC2EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRC2EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRC2EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRC2EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC2 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC2 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRC2EW::VALUE1)
            }
            #[doc = "HRC2 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRC2EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRC3E`"]
        pub enum HRC3EW {
            #[doc = "HRC3 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC3 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC3 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            VALUE2,
        }
        impl HRC3EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HRC3EW::VALUE1 => false,
                    HRC3EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRC3EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRC3EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRC3EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC3 High Resolution Path is disabled. In this mode, is not possible to use the High Resolution Path inside of HRC3 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRC3EW::VALUE1)
            }
            #[doc = "HRC3 High Resolution Path is enabled. In this mode it is possible to generate a high resolution PWM signal if HRCPM = 1#."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRC3EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CLKC`"]
        pub enum CLKCW {
            #[doc = "No clock frequency is selected"]
            VALUE1,
            #[doc = "Module clock frequency is 180 MHz"]
            VALUE2,
            #[doc = "Module clock frequency is 120 MHz"]
            VALUE3,
            #[doc = "Module clock frequency is 80 MHz"]
            VALUE4,
        }
        impl CLKCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CLKCW::VALUE1 => 0,
                    CLKCW::VALUE2 => 1,
                    CLKCW::VALUE3 => 2,
                    CLKCW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CLKCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CLKCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CLKCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "No clock frequency is selected"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CLKCW::VALUE1)
            }
            #[doc = "Module clock frequency is 180 MHz"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CLKCW::VALUE2)
            }
            #[doc = "Module clock frequency is 120 MHz"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CLKCW::VALUE3)
            }
            #[doc = "Module clock frequency is 80 MHz"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CLKCW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LRC0E`"]
        pub enum LRC0EW {
            #[doc = "HRC0 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC0 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC0 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC0EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LRC0EW::VALUE1 => false,
                    LRC0EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LRC0EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LRC0EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LRC0EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC0 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC0 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LRC0EW::VALUE1)
            }
            #[doc = "HRC0 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LRC0EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LRC1E`"]
        pub enum LRC1EW {
            #[doc = "HRC1 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC1 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC1 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC1EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LRC1EW::VALUE1 => false,
                    LRC1EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LRC1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LRC1EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LRC1EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC1 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC1 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LRC1EW::VALUE1)
            }
            #[doc = "HRC1 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LRC1EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LRC2E`"]
        pub enum LRC2EW {
            #[doc = "HRC2 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC2 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC2 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC2EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LRC2EW::VALUE1 => false,
                    LRC2EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LRC2EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LRC2EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LRC2EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC2 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC2 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LRC2EW::VALUE1)
            }
            #[doc = "HRC2 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LRC2EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LRC3E`"]
        pub enum LRC3EW {
            #[doc = "HRC3 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC3 to generate an output PWM signal."]
            VALUE1,
            #[doc = "HRC3 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            VALUE2,
        }
        impl LRC3EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    LRC3EW::VALUE1 => false,
                    LRC3EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LRC3EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LRC3EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LRC3EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRC3 Low Resolution Path is disabled. In this mode, is not possible to use the Low Resolution Path inside of HRC3 to generate an output PWM signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LRC3EW::VALUE1)
            }
            #[doc = "HRC3 Low Resolution Path is enabled. In this mode it is possible to generate a an output PWM signal via the Low Resolution Path."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LRC3EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - High resolution channels power mode"]
            #[inline]
            pub fn hrcpm(&self) -> HRCPMR {
                HRCPMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - HRC0 high resolution enable"]
            #[inline]
            pub fn hrc0e(&self) -> HRC0ER {
                HRC0ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - HRC1 high resolution channel enable"]
            #[inline]
            pub fn hrc1e(&self) -> HRC1ER {
                HRC1ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - HRC2 high resolution channel enable"]
            #[inline]
            pub fn hrc2e(&self) -> HRC2ER {
                HRC2ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - HRC3 high resolution channel enable"]
            #[inline]
            pub fn hrc3e(&self) -> HRC3ER {
                HRC3ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 16:18 - Clock information control"]
            #[inline]
            pub fn clkc(&self) -> CLKCR {
                CLKCR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - HRC0 low resolution channel enable"]
            #[inline]
            pub fn lrc0e(&self) -> LRC0ER {
                LRC0ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 21 - HRC1 low resolution channel enable"]
            #[inline]
            pub fn lrc1e(&self) -> LRC1ER {
                LRC1ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 22 - HRC2 low resolution channel enable"]
            #[inline]
            pub fn lrc2e(&self) -> LRC2ER {
                LRC2ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 23 - HRC3 low resolution channel enable"]
            #[inline]
            pub fn lrc3e(&self) -> LRC3ER {
                LRC3ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - High resolution channels power mode"]
            #[inline]
            pub fn hrcpm(&mut self) -> _HRCPMW {
                _HRCPMW { w: self }
            }
            #[doc = "Bit 4 - HRC0 high resolution enable"]
            #[inline]
            pub fn hrc0e(&mut self) -> _HRC0EW {
                _HRC0EW { w: self }
            }
            #[doc = "Bit 5 - HRC1 high resolution channel enable"]
            #[inline]
            pub fn hrc1e(&mut self) -> _HRC1EW {
                _HRC1EW { w: self }
            }
            #[doc = "Bit 6 - HRC2 high resolution channel enable"]
            #[inline]
            pub fn hrc2e(&mut self) -> _HRC2EW {
                _HRC2EW { w: self }
            }
            #[doc = "Bit 7 - HRC3 high resolution channel enable"]
            #[inline]
            pub fn hrc3e(&mut self) -> _HRC3EW {
                _HRC3EW { w: self }
            }
            #[doc = "Bits 16:18 - Clock information control"]
            #[inline]
            pub fn clkc(&mut self) -> _CLKCW {
                _CLKCW { w: self }
            }
            #[doc = "Bit 20 - HRC0 low resolution channel enable"]
            #[inline]
            pub fn lrc0e(&mut self) -> _LRC0EW {
                _LRC0EW { w: self }
            }
            #[doc = "Bit 21 - HRC1 low resolution channel enable"]
            #[inline]
            pub fn lrc1e(&mut self) -> _LRC1EW {
                _LRC1EW { w: self }
            }
            #[doc = "Bit 22 - HRC2 low resolution channel enable"]
            #[inline]
            pub fn lrc2e(&mut self) -> _LRC2EW {
                _LRC2EW { w: self }
            }
            #[doc = "Bit 23 - HRC3 low resolution channel enable"]
            #[inline]
            pub fn lrc3e(&mut self) -> _LRC3EW {
                _LRC3EW { w: self }
            }
        }
    }
    #[doc = "Global HRC shadow trigger set"]
    pub struct HRCSTRG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global HRC shadow trigger set"]
    pub mod hrcstrg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HRCSTRG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _H0ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H0ESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H0DESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H0DESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H1ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H1ESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H1DESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H1DESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H2ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H2ESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H2DESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H2DESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H3ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H3ESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H3DESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H3DESW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - HRC0 high resolution values shadow transfer Enable Set"]
            #[inline]
            pub fn h0es(&mut self) -> _H0ESW {
                _H0ESW { w: self }
            }
            #[doc = "Bit 1 - HRC0 dead time value shadow transfer enable set"]
            #[inline]
            pub fn h0des(&mut self) -> _H0DESW {
                _H0DESW { w: self }
            }
            #[doc = "Bit 4 - HRC1 high resolution values shadow transfer Enable Set"]
            #[inline]
            pub fn h1es(&mut self) -> _H1ESW {
                _H1ESW { w: self }
            }
            #[doc = "Bit 5 - HRC0 dead time value shadow transfer enable set"]
            #[inline]
            pub fn h1des(&mut self) -> _H1DESW {
                _H1DESW { w: self }
            }
            #[doc = "Bit 8 - HRC2 high resolution values shadow transfer Enable Set"]
            #[inline]
            pub fn h2es(&mut self) -> _H2ESW {
                _H2ESW { w: self }
            }
            #[doc = "Bit 9 - HRC0 dead time value shadow transfer enable set"]
            #[inline]
            pub fn h2des(&mut self) -> _H2DESW {
                _H2DESW { w: self }
            }
            #[doc = "Bit 12 - HRC3 high resolution values shadow transfer Enable Set"]
            #[inline]
            pub fn h3es(&mut self) -> _H3ESW {
                _H3ESW { w: self }
            }
            #[doc = "Bit 13 - HRC0 dead time value shadow transfer enable set"]
            #[inline]
            pub fn h3des(&mut self) -> _H3DESW {
                _H3DESW { w: self }
            }
        }
    }
    #[doc = "Global HRC shadow trigger clear"]
    pub struct HRCCTRG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global HRC shadow trigger clear"]
    pub mod hrcctrg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HRCCTRG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _H0ECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H0ECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H0DECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H0DECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H1ECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H1ECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H1DECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H1DECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H2CECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H2CECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H2DECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H2DECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H3ECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H3ECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _H3DECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _H3DECW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - HRC0 high resolution values shadow transfer Enable Clear"]
            #[inline]
            pub fn h0ec(&mut self) -> _H0ECW {
                _H0ECW { w: self }
            }
            #[doc = "Bit 1 - HRC0 dead time value shadow transfer Enable Clear"]
            #[inline]
            pub fn h0dec(&mut self) -> _H0DECW {
                _H0DECW { w: self }
            }
            #[doc = "Bit 4 - HRC1 high resolution values shadow transfer Enable Clear"]
            #[inline]
            pub fn h1ec(&mut self) -> _H1ECW {
                _H1ECW { w: self }
            }
            #[doc = "Bit 5 - HRC1 dead time value shadow transfer Enable Clear"]
            #[inline]
            pub fn h1dec(&mut self) -> _H1DECW {
                _H1DECW { w: self }
            }
            #[doc = "Bit 8 - HRC2 high resolution values shadow transfer Enable Clear"]
            #[inline]
            pub fn h2cec(&mut self) -> _H2CECW {
                _H2CECW { w: self }
            }
            #[doc = "Bit 9 - HRC2 dead time value shadow transfer Enable Clear"]
            #[inline]
            pub fn h2dec(&mut self) -> _H2DECW {
                _H2DECW { w: self }
            }
            #[doc = "Bit 12 - HRC3 high resolution values shadow transfer Enable Clear"]
            #[inline]
            pub fn h3ec(&mut self) -> _H3ECW {
                _H3ECW { w: self }
            }
            #[doc = "Bit 13 - HRC3 dead time value shadow transfer Enable Clear"]
            #[inline]
            pub fn h3dec(&mut self) -> _H3DECW {
                _H3DECW { w: self }
            }
        }
    }
    #[doc = "Global HRC shadow transfer status"]
    pub struct HRCSTSG {
        register: VolatileCell<u32>,
    }
    #[doc = "Global HRC shadow transfer status"]
    pub mod hrcstsg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::HRCSTSG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `H0STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H0STER {
            #[doc = "No shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE2,
        }
        impl H0STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H0STER::VALUE1 => false,
                    H0STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H0STER {
                match value {
                    false => H0STER::VALUE1,
                    true => H0STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H0STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H0STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H0DSTE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H0DSTER {
            #[doc = "No shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE2,
        }
        impl H0DSTER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H0DSTER::VALUE1 => false,
                    H0DSTER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H0DSTER {
                match value {
                    false => H0DSTER::VALUE1,
                    true => H0DSTER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H0DSTER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H0DSTER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H1STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H1STER {
            #[doc = "No shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE2,
        }
        impl H1STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H1STER::VALUE1 => false,
                    H1STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H1STER {
                match value {
                    false => H1STER::VALUE1,
                    true => H1STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H1STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H1STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H1DSTE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H1DSTER {
            #[doc = "No shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE2,
        }
        impl H1DSTER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H1DSTER::VALUE1 => false,
                    H1DSTER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H1DSTER {
                match value {
                    false => H1DSTER::VALUE1,
                    true => H1DSTER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H1DSTER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H1DSTER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H2STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H2STER {
            #[doc = "No shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE2,
        }
        impl H2STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H2STER::VALUE1 => false,
                    H2STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H2STER {
                match value {
                    false => H2STER::VALUE1,
                    true => H2STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H2STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H2STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H2DSTE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H2DSTER {
            #[doc = "No shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE2,
        }
        impl H2DSTER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H2DSTER::VALUE1 => false,
                    H2DSTER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H2DSTER {
                match value {
                    false => H2DSTER::VALUE1,
                    true => H2DSTER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H2DSTER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H2DSTER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H3STE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H3STER {
            #[doc = "No shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values"]
            VALUE2,
        }
        impl H3STER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H3STER::VALUE1 => false,
                    H3STER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H3STER {
                match value {
                    false => H3STER::VALUE1,
                    true => H3STER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H3STER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H3STER::VALUE2
            }
        }
        #[doc = "Possible values of the field `H3DSTE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum H3DSTER {
            #[doc = "No shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE1,
            #[doc = "Shadow transfer pending for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values"]
            VALUE2,
        }
        impl H3DSTER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    H3DSTER::VALUE1 => false,
                    H3DSTER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> H3DSTER {
                match value {
                    false => H3DSTER::VALUE1,
                    true => H3DSTER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == H3DSTER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == H3DSTER::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - HRC0 high resolution values shadow transfer status"]
            #[inline]
            pub fn h0ste(&self) -> H0STER {
                H0STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - HRC0 dead time value shadow transfer status"]
            #[inline]
            pub fn h0dste(&self) -> H0DSTER {
                H0DSTER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - HRC1 high resolution values shadow transfer status"]
            #[inline]
            pub fn h1ste(&self) -> H1STER {
                H1STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - HRC1 dead time value shadow transfer status"]
            #[inline]
            pub fn h1dste(&self) -> H1DSTER {
                H1DSTER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - HRC2 high resolution values shadow transfer status"]
            #[inline]
            pub fn h2ste(&self) -> H2STER {
                H2STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - HRC2 dead time value shadow transfer status"]
            #[inline]
            pub fn h2dste(&self) -> H2DSTER {
                H2DSTER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - HRC3 high resolution values shadow transfer status"]
            #[inline]
            pub fn h3ste(&self) -> H3STER {
                H3STER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - HRC3 dead time value shadow transfer status"]
            #[inline]
            pub fn h3dste(&self) -> H3DSTER {
                H3DSTER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "High Resolution Generation Status"]
    pub struct HRGHRS {
        register: VolatileCell<u32>,
    }
    #[doc = "High Resolution Generation Status"]
    pub mod hrghrs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::HRGHRS {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `HRGR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRGRR {
            #[doc = "High resolution logic is not working"]
            VALUE1,
            #[doc = "High resolution logic is working"]
            VALUE2,
        }
        impl HRGRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HRGRR::VALUE1 => false,
                    HRGRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HRGRR {
                match value {
                    false => HRGRR::VALUE1,
                    true => HRGRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRGRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRGRR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - High Resolution Generation Ready"]
            #[inline]
            pub fn hrgr(&self) -> HRGRR {
                HRGRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
}
#[doc = "High Resolution PWM Unit"]
pub struct HRPWM0 {
    register_block: hrpwm0::RegisterBlock,
}
impl Deref for HRPWM0 {
    type Target = hrpwm0::RegisterBlock;
    fn deref(&self) -> &hrpwm0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_CSG0: Peripheral<HRPWM0_CSG0> = unsafe { Peripheral::new(0x4002_0a00) };
#[doc = "High Resolution PWM Unit"]
pub mod hrpwm0_csg0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - External input selection"]
        pub dci: DCI,
        #[doc = "0x04 - External input selection"]
        pub ies: IES,
        #[doc = "0x08 - Slope generation control"]
        pub sc: SC,
        #[doc = "0x0c - Pulse swallow configuration"]
        pub pc: PC,
        #[doc = "0x10 - DAC reference value 1"]
        pub dsv1: DSV1,
        #[doc = "0x14 - DAC reference value 1"]
        pub dsv2: DSV2,
        #[doc = "0x18 - Shadow reference value 1"]
        pub sdsv1: SDSV1,
        #[doc = "0x1c - Shadow Pulse swallow value"]
        pub spc: SPC,
        #[doc = "0x20 - Comparator configuration"]
        pub cc: CC,
        #[doc = "0x24 - Passive level configuration"]
        pub plc: PLC,
        #[doc = "0x28 - Comparator blanking value"]
        pub blv: BLV,
        #[doc = "0x2c - Service request enable"]
        pub sre: SRE,
        #[doc = "0x30 - Service request line selector"]
        pub srs: SRS,
        #[doc = "0x34 - Service request SW set"]
        pub sws: SWS,
        #[doc = "0x38 - Service request SW clear"]
        pub swc: SWC,
        #[doc = "0x3c - Service request status"]
        pub istat: ISTAT,
    }
    #[doc = "External input selection"]
    pub struct DCI {
        register: VolatileCell<u32>,
    }
    #[doc = "External input selection"]
    pub mod dci {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DCI {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SVIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SVISR {
            #[doc = "HRPWMx.SyIA"]
            VALUE1,
            #[doc = "HRPWMx.SyIB"]
            VALUE2,
            #[doc = "HRPWMx.SyIC"]
            VALUE3,
            #[doc = "HRPWMx.SyID"]
            VALUE4,
            #[doc = "HRPWMx.SyIE"]
            VALUE5,
            #[doc = "HRPWMx.SyIF"]
            VALUE6,
            #[doc = "HRPWMx.SyIG"]
            VALUE7,
            #[doc = "HRPWMx.SyIH"]
            VALUE8,
            #[doc = "HRPWMx.SyII"]
            VALUE9,
            #[doc = "HRPWMx.SyIJ"]
            VALUE10,
            #[doc = "HRPWMx.SyIK"]
            VALUE11,
            #[doc = "HRPWMx.SyIL"]
            VALUE12,
            #[doc = "HRPWMx.SyIM"]
            VALUE13,
            #[doc = "HRPWMx.SyIN"]
            VALUE14,
            #[doc = "HRPWMx.SyIO"]
            VALUE15,
            #[doc = "HRPWMx.SyIP"]
            VALUE16,
        }
        impl SVISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SVISR::VALUE1 => 0,
                    SVISR::VALUE2 => 0x01,
                    SVISR::VALUE3 => 0x02,
                    SVISR::VALUE4 => 0x03,
                    SVISR::VALUE5 => 0x04,
                    SVISR::VALUE6 => 0x05,
                    SVISR::VALUE7 => 0x06,
                    SVISR::VALUE8 => 0x07,
                    SVISR::VALUE9 => 0x08,
                    SVISR::VALUE10 => 0x09,
                    SVISR::VALUE11 => 0x0a,
                    SVISR::VALUE12 => 0x0b,
                    SVISR::VALUE13 => 0x0c,
                    SVISR::VALUE14 => 0x0d,
                    SVISR::VALUE15 => 0x0e,
                    SVISR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SVISR {
                match value {
                    0 => SVISR::VALUE1,
                    1 => SVISR::VALUE2,
                    2 => SVISR::VALUE3,
                    3 => SVISR::VALUE4,
                    4 => SVISR::VALUE5,
                    5 => SVISR::VALUE6,
                    6 => SVISR::VALUE7,
                    7 => SVISR::VALUE8,
                    8 => SVISR::VALUE9,
                    9 => SVISR::VALUE10,
                    10 => SVISR::VALUE11,
                    11 => SVISR::VALUE12,
                    12 => SVISR::VALUE13,
                    13 => SVISR::VALUE14,
                    14 => SVISR::VALUE15,
                    15 => SVISR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SVISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SVISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SVISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SVISR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == SVISR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == SVISR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == SVISR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == SVISR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == SVISR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == SVISR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == SVISR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == SVISR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == SVISR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == SVISR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == SVISR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == SVISR::VALUE16
            }
        }
        #[doc = r" Value of the field"]
        pub struct STRISR {
            bits: u8,
        }
        impl STRISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct STPISR {
            bits: u8,
        }
        impl STPISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRGISR {
            bits: u8,
        }
        impl TRGISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct STISR {
            bits: u8,
        }
        impl STISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = "Possible values of the field `SCS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCSR {
            #[doc = "HRPWMx.MCLK (Module clock is used)"]
            VALUE1,
            #[doc = "HRPWMx.ECLKA (External clock is used)"]
            VALUE2,
            #[doc = "HRPWMx.ECLKB (External clock is used)"]
            VALUE3,
            #[doc = "HRPWMx.ECLKC (External clock is used)"]
            VALUE4,
        }
        impl SCSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SCSR::VALUE1 => 0,
                    SCSR::VALUE2 => 0x01,
                    SCSR::VALUE3 => 0x02,
                    SCSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SCSR {
                match value {
                    0 => SCSR::VALUE1,
                    1 => SCSR::VALUE2,
                    2 => SCSR::VALUE3,
                    3 => SCSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SCSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SCSR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SVIS`"]
        pub enum SVISW {
            #[doc = "HRPWMx.SyIA"]
            VALUE1,
            #[doc = "HRPWMx.SyIB"]
            VALUE2,
            #[doc = "HRPWMx.SyIC"]
            VALUE3,
            #[doc = "HRPWMx.SyID"]
            VALUE4,
            #[doc = "HRPWMx.SyIE"]
            VALUE5,
            #[doc = "HRPWMx.SyIF"]
            VALUE6,
            #[doc = "HRPWMx.SyIG"]
            VALUE7,
            #[doc = "HRPWMx.SyIH"]
            VALUE8,
            #[doc = "HRPWMx.SyII"]
            VALUE9,
            #[doc = "HRPWMx.SyIJ"]
            VALUE10,
            #[doc = "HRPWMx.SyIK"]
            VALUE11,
            #[doc = "HRPWMx.SyIL"]
            VALUE12,
            #[doc = "HRPWMx.SyIM"]
            VALUE13,
            #[doc = "HRPWMx.SyIN"]
            VALUE14,
            #[doc = "HRPWMx.SyIO"]
            VALUE15,
            #[doc = "HRPWMx.SyIP"]
            VALUE16,
        }
        impl SVISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SVISW::VALUE1 => 0,
                    SVISW::VALUE2 => 1,
                    SVISW::VALUE3 => 2,
                    SVISW::VALUE4 => 3,
                    SVISW::VALUE5 => 4,
                    SVISW::VALUE6 => 5,
                    SVISW::VALUE7 => 6,
                    SVISW::VALUE8 => 7,
                    SVISW::VALUE9 => 8,
                    SVISW::VALUE10 => 9,
                    SVISW::VALUE11 => 10,
                    SVISW::VALUE12 => 11,
                    SVISW::VALUE13 => 12,
                    SVISW::VALUE14 => 13,
                    SVISW::VALUE15 => 14,
                    SVISW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SVISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "HRPWMx.SyIA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SVISW::VALUE1)
            }
            #[doc = "HRPWMx.SyIB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SVISW::VALUE2)
            }
            #[doc = "HRPWMx.SyIC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SVISW::VALUE3)
            }
            #[doc = "HRPWMx.SyID"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SVISW::VALUE4)
            }
            #[doc = "HRPWMx.SyIE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(SVISW::VALUE5)
            }
            #[doc = "HRPWMx.SyIF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(SVISW::VALUE6)
            }
            #[doc = "HRPWMx.SyIG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(SVISW::VALUE7)
            }
            #[doc = "HRPWMx.SyIH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(SVISW::VALUE8)
            }
            #[doc = "HRPWMx.SyII"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(SVISW::VALUE9)
            }
            #[doc = "HRPWMx.SyIJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(SVISW::VALUE10)
            }
            #[doc = "HRPWMx.SyIK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(SVISW::VALUE11)
            }
            #[doc = "HRPWMx.SyIL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(SVISW::VALUE12)
            }
            #[doc = "HRPWMx.SyIM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(SVISW::VALUE13)
            }
            #[doc = "HRPWMx.SyIN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(SVISW::VALUE14)
            }
            #[doc = "HRPWMx.SyIO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(SVISW::VALUE15)
            }
            #[doc = "HRPWMx.SyIP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(SVISW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRISW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STPISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STPISW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRGISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRGISW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STISW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCS`"]
        pub enum SCSW {
            #[doc = "HRPWMx.MCLK (Module clock is used)"]
            VALUE1,
            #[doc = "HRPWMx.ECLKA (External clock is used)"]
            VALUE2,
            #[doc = "HRPWMx.ECLKB (External clock is used)"]
            VALUE3,
            #[doc = "HRPWMx.ECLKC (External clock is used)"]
            VALUE4,
        }
        impl SCSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SCSW::VALUE1 => 0,
                    SCSW::VALUE2 => 1,
                    SCSW::VALUE3 => 2,
                    SCSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "HRPWMx.MCLK (Module clock is used)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCSW::VALUE1)
            }
            #[doc = "HRPWMx.ECLKA (External clock is used)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCSW::VALUE2)
            }
            #[doc = "HRPWMx.ECLKB (External clock is used)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SCSW::VALUE3)
            }
            #[doc = "HRPWMx.ECLKC (External clock is used)"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SCSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Value Selector input selection"]
            #[inline]
            pub fn svis(&self) -> SVISR {
                SVISR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:7 - Slope generation start control input selection"]
            #[inline]
            pub fn stris(&self) -> STRISR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STRISR { bits }
            }
            #[doc = "Bits 8:11 - Slope generation stop control input selection"]
            #[inline]
            pub fn stpis(&self) -> STPISR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STPISR { bits }
            }
            #[doc = "Bits 12:15 - External conversion trigger input selection"]
            #[inline]
            pub fn trgis(&self) -> TRGISR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TRGISR { bits }
            }
            #[doc = "Bits 16:19 - External shadow request enable input selection"]
            #[inline]
            pub fn stis(&self) -> STISR {
                let bits = {
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                STISR { bits }
            }
            #[doc = "Bits 20:21 - Slope generation clock selection"]
            #[inline]
            pub fn scs(&self) -> SCSR {
                SCSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Value Selector input selection"]
            #[inline]
            pub fn svis(&mut self) -> _SVISW {
                _SVISW { w: self }
            }
            #[doc = "Bits 4:7 - Slope generation start control input selection"]
            #[inline]
            pub fn stris(&mut self) -> _STRISW {
                _STRISW { w: self }
            }
            #[doc = "Bits 8:11 - Slope generation stop control input selection"]
            #[inline]
            pub fn stpis(&mut self) -> _STPISW {
                _STPISW { w: self }
            }
            #[doc = "Bits 12:15 - External conversion trigger input selection"]
            #[inline]
            pub fn trgis(&mut self) -> _TRGISW {
                _TRGISW { w: self }
            }
            #[doc = "Bits 16:19 - External shadow request enable input selection"]
            #[inline]
            pub fn stis(&mut self) -> _STISW {
                _STISW { w: self }
            }
            #[doc = "Bits 20:21 - Slope generation clock selection"]
            #[inline]
            pub fn scs(&mut self) -> _SCSW {
                _SCSW { w: self }
            }
        }
    }
    #[doc = "External input selection"]
    pub struct IES {
        register: VolatileCell<u32>,
    }
    #[doc = "External input selection"]
    pub mod ies {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IES {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SVLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SVLSR {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active when input is HIGH"]
            VALUE2,
            #[doc = "Active when input is LOW"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SVLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SVLSR::VALUE1 => 0,
                    SVLSR::VALUE2 => 0x01,
                    SVLSR::VALUE3 => 0x02,
                    SVLSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SVLSR {
                match value {
                    0 => SVLSR::VALUE1,
                    1 => SVLSR::VALUE2,
                    2 => SVLSR::VALUE3,
                    i => SVLSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SVLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SVLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SVLSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `STRES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STRESR {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl STRESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STRESR::VALUE1 => 0,
                    STRESR::VALUE2 => 0x01,
                    STRESR::VALUE3 => 0x02,
                    STRESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STRESR {
                match value {
                    0 => STRESR::VALUE1,
                    1 => STRESR::VALUE2,
                    2 => STRESR::VALUE3,
                    3 => STRESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STRESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STRESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STRESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STRESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `STPES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STPESR {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl STPESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STPESR::VALUE1 => 0,
                    STPESR::VALUE2 => 0x01,
                    STPESR::VALUE3 => 0x02,
                    STPESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STPESR {
                match value {
                    0 => STPESR::VALUE1,
                    1 => STPESR::VALUE2,
                    2 => STPESR::VALUE3,
                    3 => STPESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STPESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STPESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STPESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STPESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TRGES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRGESR {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl TRGESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRGESR::VALUE1 => 0,
                    TRGESR::VALUE2 => 0x01,
                    TRGESR::VALUE3 => 0x02,
                    TRGESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRGESR {
                match value {
                    0 => TRGESR::VALUE1,
                    1 => TRGESR::VALUE2,
                    2 => TRGESR::VALUE3,
                    3 => TRGESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRGESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRGESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRGESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TRGESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `STES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STESR {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl STESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STESR::VALUE1 => 0,
                    STESR::VALUE2 => 0x01,
                    STESR::VALUE3 => 0x02,
                    STESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STESR {
                match value {
                    0 => STESR::VALUE1,
                    1 => STESR::VALUE2,
                    2 => STESR::VALUE3,
                    3 => STESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STESR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `SVLS`"]
        pub enum SVLSW {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active when input is HIGH"]
            VALUE2,
            #[doc = "Active when input is LOW"]
            VALUE3,
        }
        impl SVLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SVLSW::VALUE1 => 0,
                    SVLSW::VALUE2 => 1,
                    SVLSW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SVLSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SVLSW::VALUE1)
            }
            #[doc = "Active when input is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SVLSW::VALUE2)
            }
            #[doc = "Active when input is LOW"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SVLSW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STRES`"]
        pub enum STRESW {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl STRESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STRESW::VALUE1 => 0,
                    STRESW::VALUE2 => 1,
                    STRESW::VALUE3 => 2,
                    STRESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STRESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STRESW::VALUE1)
            }
            #[doc = "Active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STRESW::VALUE2)
            }
            #[doc = "Active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STRESW::VALUE3)
            }
            #[doc = "Active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STRESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STPES`"]
        pub enum STPESW {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl STPESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STPESW::VALUE1 => 0,
                    STPESW::VALUE2 => 1,
                    STPESW::VALUE3 => 2,
                    STPESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STPESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STPESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STPESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STPESW::VALUE1)
            }
            #[doc = "Active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STPESW::VALUE2)
            }
            #[doc = "Active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STPESW::VALUE3)
            }
            #[doc = "Active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STPESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRGES`"]
        pub enum TRGESW {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl TRGESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRGESW::VALUE1 => 0,
                    TRGESW::VALUE2 => 1,
                    TRGESW::VALUE3 => 2,
                    TRGESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRGESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRGESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRGESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRGESW::VALUE1)
            }
            #[doc = "Active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRGESW::VALUE2)
            }
            #[doc = "Active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRGESW::VALUE3)
            }
            #[doc = "Active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TRGESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STES`"]
        pub enum STESW {
            #[doc = "Function disabled"]
            VALUE1,
            #[doc = "Active on rising edge"]
            VALUE2,
            #[doc = "Active on falling edge"]
            VALUE3,
            #[doc = "Active on both edges"]
            VALUE4,
        }
        impl STESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STESW::VALUE1 => 0,
                    STESW::VALUE2 => 1,
                    STESW::VALUE3 => 2,
                    STESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Function disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STESW::VALUE1)
            }
            #[doc = "Active on rising edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STESW::VALUE2)
            }
            #[doc = "Active on falling edge"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STESW::VALUE3)
            }
            #[doc = "Active on both edges"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - External value switch function level selection"]
            #[inline]
            pub fn svls(&self) -> SVLSR {
                SVLSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - External start function edge selection"]
            #[inline]
            pub fn stres(&self) -> STRESR {
                STRESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - External stop function edge selection"]
            #[inline]
            pub fn stpes(&self) -> STPESR {
                STPESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - External trigger function edge selection"]
            #[inline]
            pub fn trges(&self) -> TRGESR {
                TRGESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - External shadow transfer enable edge selection"]
            #[inline]
            pub fn stes(&self) -> STESR {
                STESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - External value switch function level selection"]
            #[inline]
            pub fn svls(&mut self) -> _SVLSW {
                _SVLSW { w: self }
            }
            #[doc = "Bits 2:3 - External start function edge selection"]
            #[inline]
            pub fn stres(&mut self) -> _STRESW {
                _STRESW { w: self }
            }
            #[doc = "Bits 4:5 - External stop function edge selection"]
            #[inline]
            pub fn stpes(&mut self) -> _STPESW {
                _STPESW { w: self }
            }
            #[doc = "Bits 6:7 - External trigger function edge selection"]
            #[inline]
            pub fn trges(&mut self) -> _TRGESW {
                _TRGESW { w: self }
            }
            #[doc = "Bits 8:9 - External shadow transfer enable edge selection"]
            #[inline]
            pub fn stes(&mut self) -> _STESW {
                _STESW { w: self }
            }
        }
    }
    #[doc = "Slope generation control"]
    pub struct SC {
        register: VolatileCell<u32>,
    }
    #[doc = "Slope generation control"]
    pub mod sc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PSRM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSRMR {
            #[doc = "External start trigger is ignored"]
            VALUE1,
            #[doc = "Start prescaler"]
            VALUE2,
            #[doc = "Clear prescaler"]
            VALUE3,
            #[doc = "Clear & Start prescaler"]
            VALUE4,
        }
        impl PSRMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PSRMR::VALUE1 => 0,
                    PSRMR::VALUE2 => 0x01,
                    PSRMR::VALUE3 => 0x02,
                    PSRMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PSRMR {
                match value {
                    0 => PSRMR::VALUE1,
                    1 => PSRMR::VALUE2,
                    2 => PSRMR::VALUE3,
                    3 => PSRMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSRMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSRMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PSRMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PSRMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `PSTM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSTMR {
            #[doc = "External stop trigger is ignored"]
            VALUE1,
            #[doc = "Stop prescaler"]
            VALUE2,
            #[doc = "Clear prescaler"]
            VALUE3,
            #[doc = "Clear & Stop prescaler"]
            VALUE4,
        }
        impl PSTMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PSTMR::VALUE1 => 0,
                    PSTMR::VALUE2 => 0x01,
                    PSTMR::VALUE3 => 0x02,
                    PSTMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PSTMR {
                match value {
                    0 => PSTMR::VALUE1,
                    1 => PSTMR::VALUE2,
                    2 => PSTMR::VALUE3,
                    3 => PSTMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSTMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSTMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PSTMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PSTMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `FPD`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FPDR {
            #[doc = "Division by 4 enabled"]
            VALUE1,
            #[doc = "Division by 4 disabled"]
            VALUE2,
        }
        impl FPDR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    FPDR::VALUE1 => false,
                    FPDR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> FPDR {
                match value {
                    false => FPDR::VALUE1,
                    true => FPDR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FPDR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FPDR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSV`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSVR {
            #[doc = "division by 1"]
            VALUE1,
            #[doc = "division by 2"]
            VALUE2,
            #[doc = "division by 4"]
            VALUE3,
            #[doc = "division by 8"]
            VALUE4,
        }
        impl PSVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PSVR::VALUE1 => 0,
                    PSVR::VALUE2 => 0x01,
                    PSVR::VALUE3 => 0x02,
                    PSVR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PSVR {
                match value {
                    0 => PSVR::VALUE1,
                    1 => PSVR::VALUE2,
                    2 => PSVR::VALUE3,
                    3 => PSVR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSVR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSVR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PSVR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PSVR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SCM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SCMR {
            #[doc = "Slope generation disabled. Used when the switch between the two reference values, CSGyDSV1This register contains the actual value used for the DSV1 reference. and CSGyDSV2This register contains the actual value used for the DSV2 reference. is done via external signal."]
            VALUE1,
            #[doc = "Decrementing slope generation."]
            VALUE2,
            #[doc = "Incrementing slope generation."]
            VALUE3,
            #[doc = "Triangular slope generation."]
            VALUE4,
        }
        impl SCMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SCMR::VALUE1 => 0,
                    SCMR::VALUE2 => 0x01,
                    SCMR::VALUE3 => 0x02,
                    SCMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SCMR {
                match value {
                    0 => SCMR::VALUE1,
                    1 => SCMR::VALUE2,
                    2 => SCMR::VALUE3,
                    3 => SCMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SCMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SCMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SCMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SCMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SSRM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SSRMR {
            #[doc = "External start trigger is ignored"]
            VALUE1,
            #[doc = "Start/restart slope generation"]
            VALUE2,
            #[doc = "Resumes slope"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SSRMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SSRMR::VALUE1 => 0,
                    SSRMR::VALUE2 => 0x01,
                    SSRMR::VALUE3 => 0x02,
                    SSRMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SSRMR {
                match value {
                    0 => SSRMR::VALUE1,
                    1 => SSRMR::VALUE2,
                    2 => SSRMR::VALUE3,
                    i => SSRMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SSRMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SSRMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SSRMR::VALUE3
            }
        }
        #[doc = "Possible values of the field `SSTM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SSTMR {
            #[doc = "External stop trigger is ignored"]
            VALUE1,
            #[doc = "Stops/Halts the slope generation"]
            VALUE2,
            #[doc = "Used in hybrid mode. It freezes the slope generation and feeds constantly the value programmed in CSGyDSV2This register contains the actual value used for the DSV2 reference. to the DAC."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SSTMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SSTMR::VALUE1 => 0,
                    SSTMR::VALUE2 => 0x01,
                    SSTMR::VALUE3 => 0x02,
                    SSTMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SSTMR {
                match value {
                    0 => SSTMR::VALUE1,
                    1 => SSTMR::VALUE2,
                    2 => SSTMR::VALUE3,
                    i => SSTMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SSTMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SSTMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SSTMR::VALUE3
            }
        }
        #[doc = "Possible values of the field `SVSC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SVSCR {
            #[doc = "Only CSGyDSV1This register contains the actual value used for the DSV1 reference. value is used for the slope generation: if slope is incrementing, CSGyDSV1This register contains the actual value used for the DSV1 reference. is the bottom reference value from where the ramp starts; if decrementing, then CSGyDSV1This register contains the actual value used for the DSV1 reference. is the upper reference value from where the ramp starts."]
            VALUE1,
            #[doc = "The two reference values are being used: CSGyDSV1This register contains the actual value used for the DSV1 reference. is the low or high reference value from where the ramp starts (incrementing or decrementing respectively); CSGyDSV2This register contains the actual value used for the DSV2 reference. is used as a static value (this value is constantly fed to the DAC after a stop trigger as been detected)."]
            VALUE2,
            #[doc = "The two reference values are used: CSGyDSV1This register contains the actual value used for the DSV1 reference. is the low or high reference value from where the slope starts (incrementing or decrementing respectively); CSGyDSV2This register contains the actual value used for the DSV2 reference. is used as an internal re start condition for the slope."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl SVSCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SVSCR::VALUE1 => 0,
                    SVSCR::VALUE2 => 0x01,
                    SVSCR::VALUE3 => 0x02,
                    SVSCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SVSCR {
                match value {
                    0 => SVSCR::VALUE1,
                    1 => SVSCR::VALUE2,
                    2 => SVSCR::VALUE3,
                    i => SVSCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SVSCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SVSCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SVSCR::VALUE3
            }
        }
        #[doc = "Possible values of the field `SWSM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SWSMR {
            #[doc = "CSGyDSV2This register contains the actual value used for the DSV2 reference. is fed to the DAC and initial conversion trigger is generated."]
            VALUE1,
            #[doc = "CSGyDSV1This register contains the actual value used for the DSV1 reference. is fed to the DAC and initial conversion trigger is generated."]
            VALUE2,
            #[doc = "CSGyDSV2This register contains the actual value used for the DSV2 reference. is fed to the DAC but initial conversion trigger is not generated."]
            VALUE3,
            #[doc = "CSGyDSV1This register contains the actual value used for the DSV1 reference. is fed to the DAC but initial conversion trigger is not generated."]
            VALUE4,
        }
        impl SWSMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SWSMR::VALUE1 => 0,
                    SWSMR::VALUE2 => 0x01,
                    SWSMR::VALUE3 => 0x02,
                    SWSMR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SWSMR {
                match value {
                    0 => SWSMR::VALUE1,
                    1 => SWSMR::VALUE2,
                    2 => SWSMR::VALUE3,
                    3 => SWSMR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SWSMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SWSMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SWSMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SWSMR::VALUE4
            }
        }
        #[doc = "Possible values of the field `GCFG`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum GCFGR {
            #[doc = "Each slope step has an increment/decrement of 1"]
            VALUE1,
            #[doc = "Each slope step has an increment/decrement of 2"]
            VALUE2,
            #[doc = "Each slope step has an increment/decrement of 4"]
            VALUE3,
            #[doc = "Each slope step has an increment/decrement of 8"]
            VALUE4,
        }
        impl GCFGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    GCFGR::VALUE1 => 0,
                    GCFGR::VALUE2 => 0x01,
                    GCFGR::VALUE3 => 0x02,
                    GCFGR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> GCFGR {
                match value {
                    0 => GCFGR::VALUE1,
                    1 => GCFGR::VALUE2,
                    2 => GCFGR::VALUE3,
                    3 => GCFGR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == GCFGR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == GCFGR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == GCFGR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == GCFGR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct ISTR {
            bits: bool,
        }
        impl ISTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `PSE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSER {
            #[doc = "Pulse swallow disabled"]
            VALUE1,
            #[doc = "Pulse swallow enabled"]
            VALUE2,
        }
        impl PSER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSER::VALUE1 => false,
                    PSER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSER {
                match value {
                    false => PSER::VALUE1,
                    true => PSER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSER::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSWM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSWMR {
            #[doc = "16 clock cycle window"]
            VALUE1,
            #[doc = "32 clock cycle window"]
            VALUE2,
            #[doc = "64 clock cycle window"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PSWMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PSWMR::VALUE1 => 0,
                    PSWMR::VALUE2 => 0x01,
                    PSWMR::VALUE3 => 0x02,
                    PSWMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PSWMR {
                match value {
                    0 => PSWMR::VALUE1,
                    1 => PSWMR::VALUE2,
                    2 => PSWMR::VALUE3,
                    i => PSWMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSWMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSWMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PSWMR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `PSRM`"]
        pub enum PSRMW {
            #[doc = "External start trigger is ignored"]
            VALUE1,
            #[doc = "Start prescaler"]
            VALUE2,
            #[doc = "Clear prescaler"]
            VALUE3,
            #[doc = "Clear & Start prescaler"]
            VALUE4,
        }
        impl PSRMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PSRMW::VALUE1 => 0,
                    PSRMW::VALUE2 => 1,
                    PSRMW::VALUE3 => 2,
                    PSRMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSRMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSRMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSRMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External start trigger is ignored"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSRMW::VALUE1)
            }
            #[doc = "Start prescaler"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSRMW::VALUE2)
            }
            #[doc = "Clear prescaler"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PSRMW::VALUE3)
            }
            #[doc = "Clear & Start prescaler"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PSRMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSTM`"]
        pub enum PSTMW {
            #[doc = "External stop trigger is ignored"]
            VALUE1,
            #[doc = "Stop prescaler"]
            VALUE2,
            #[doc = "Clear prescaler"]
            VALUE3,
            #[doc = "Clear & Stop prescaler"]
            VALUE4,
        }
        impl PSTMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PSTMW::VALUE1 => 0,
                    PSTMW::VALUE2 => 1,
                    PSTMW::VALUE3 => 2,
                    PSTMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSTMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSTMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSTMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "External stop trigger is ignored"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSTMW::VALUE1)
            }
            #[doc = "Stop prescaler"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSTMW::VALUE2)
            }
            #[doc = "Clear prescaler"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PSTMW::VALUE3)
            }
            #[doc = "Clear & Stop prescaler"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PSTMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `FPD`"]
        pub enum FPDW {
            #[doc = "Division by 4 enabled"]
            VALUE1,
            #[doc = "Division by 4 disabled"]
            VALUE2,
        }
        impl FPDW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    FPDW::VALUE1 => false,
                    FPDW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FPDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FPDW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FPDW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Division by 4 enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FPDW::VALUE1)
            }
            #[doc = "Division by 4 disabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FPDW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSV`"]
        pub enum PSVW {
            #[doc = "division by 1"]
            VALUE1,
            #[doc = "division by 2"]
            VALUE2,
            #[doc = "division by 4"]
            VALUE3,
            #[doc = "division by 8"]
            VALUE4,
        }
        impl PSVW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PSVW::VALUE1 => 0,
                    PSVW::VALUE2 => 1,
                    PSVW::VALUE3 => 2,
                    PSVW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSVW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSVW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "division by 1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSVW::VALUE1)
            }
            #[doc = "division by 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSVW::VALUE2)
            }
            #[doc = "division by 4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PSVW::VALUE3)
            }
            #[doc = "division by 8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PSVW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SCM`"]
        pub enum SCMW {
            #[doc = "Slope generation disabled. Used when the switch between the two reference values, CSGyDSV1This register contains the actual value used for the DSV1 reference. and CSGyDSV2This register contains the actual value used for the DSV2 reference. is done via external signal."]
            VALUE1,
            #[doc = "Decrementing slope generation."]
            VALUE2,
            #[doc = "Incrementing slope generation."]
            VALUE3,
            #[doc = "Triangular slope generation."]
            VALUE4,
        }
        impl SCMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SCMW::VALUE1 => 0,
                    SCMW::VALUE2 => 1,
                    SCMW::VALUE3 => 2,
                    SCMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SCMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Slope generation disabled. Used when the switch between the two reference values, CSGyDSV1This register contains the actual value used for the DSV1 reference. and CSGyDSV2This register contains the actual value used for the DSV2 reference. is done via external signal."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SCMW::VALUE1)
            }
            #[doc = "Decrementing slope generation."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SCMW::VALUE2)
            }
            #[doc = "Incrementing slope generation."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SCMW::VALUE3)
            }
            #[doc = "Triangular slope generation."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SCMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SSRM`"]
        pub enum SSRMW {
            #[doc = "External start trigger is ignored"]
            VALUE1,
            #[doc = "Start/restart slope generation"]
            VALUE2,
            #[doc = "Resumes slope"]
            VALUE3,
        }
        impl SSRMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SSRMW::VALUE1 => 0,
                    SSRMW::VALUE2 => 1,
                    SSRMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSRMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSRMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SSRMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "External start trigger is ignored"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SSRMW::VALUE1)
            }
            #[doc = "Start/restart slope generation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SSRMW::VALUE2)
            }
            #[doc = "Resumes slope"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SSRMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SSTM`"]
        pub enum SSTMW {
            #[doc = "External stop trigger is ignored"]
            VALUE1,
            #[doc = "Stops/Halts the slope generation"]
            VALUE2,
            #[doc = "Used in hybrid mode. It freezes the slope generation and feeds constantly the value programmed in CSGyDSV2This register contains the actual value used for the DSV2 reference. to the DAC."]
            VALUE3,
        }
        impl SSTMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SSTMW::VALUE1 => 0,
                    SSTMW::VALUE2 => 1,
                    SSTMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SSTMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "External stop trigger is ignored"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SSTMW::VALUE1)
            }
            #[doc = "Stops/Halts the slope generation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SSTMW::VALUE2)
            }
            #[doc = "Used in hybrid mode. It freezes the slope generation and feeds constantly the value programmed in CSGyDSV2This register contains the actual value used for the DSV2 reference. to the DAC."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SSTMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SVSC`"]
        pub enum SVSCW {
            #[doc = "Only CSGyDSV1This register contains the actual value used for the DSV1 reference. value is used for the slope generation: if slope is incrementing, CSGyDSV1This register contains the actual value used for the DSV1 reference. is the bottom reference value from where the ramp starts; if decrementing, then CSGyDSV1This register contains the actual value used for the DSV1 reference. is the upper reference value from where the ramp starts."]
            VALUE1,
            #[doc = "The two reference values are being used: CSGyDSV1This register contains the actual value used for the DSV1 reference. is the low or high reference value from where the ramp starts (incrementing or decrementing respectively); CSGyDSV2This register contains the actual value used for the DSV2 reference. is used as a static value (this value is constantly fed to the DAC after a stop trigger as been detected)."]
            VALUE2,
            #[doc = "The two reference values are used: CSGyDSV1This register contains the actual value used for the DSV1 reference. is the low or high reference value from where the slope starts (incrementing or decrementing respectively); CSGyDSV2This register contains the actual value used for the DSV2 reference. is used as an internal re start condition for the slope."]
            VALUE3,
        }
        impl SVSCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SVSCW::VALUE1 => 0,
                    SVSCW::VALUE2 => 1,
                    SVSCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVSCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVSCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SVSCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Only CSGyDSV1This register contains the actual value used for the DSV1 reference. value is used for the slope generation: if slope is incrementing, CSGyDSV1This register contains the actual value used for the DSV1 reference. is the bottom reference value from where the ramp starts; if decrementing, then CSGyDSV1This register contains the actual value used for the DSV1 reference. is the upper reference value from where the ramp starts."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SVSCW::VALUE1)
            }
            #[doc = "The two reference values are being used: CSGyDSV1This register contains the actual value used for the DSV1 reference. is the low or high reference value from where the ramp starts (incrementing or decrementing respectively); CSGyDSV2This register contains the actual value used for the DSV2 reference. is used as a static value (this value is constantly fed to the DAC after a stop trigger as been detected)."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SVSCW::VALUE2)
            }
            #[doc = "The two reference values are used: CSGyDSV1This register contains the actual value used for the DSV1 reference. is the low or high reference value from where the slope starts (incrementing or decrementing respectively); CSGyDSV2This register contains the actual value used for the DSV2 reference. is used as an internal re start condition for the slope."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SVSCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SWSM`"]
        pub enum SWSMW {
            #[doc = "CSGyDSV2This register contains the actual value used for the DSV2 reference. is fed to the DAC and initial conversion trigger is generated."]
            VALUE1,
            #[doc = "CSGyDSV1This register contains the actual value used for the DSV1 reference. is fed to the DAC and initial conversion trigger is generated."]
            VALUE2,
            #[doc = "CSGyDSV2This register contains the actual value used for the DSV2 reference. is fed to the DAC but initial conversion trigger is not generated."]
            VALUE3,
            #[doc = "CSGyDSV1This register contains the actual value used for the DSV1 reference. is fed to the DAC but initial conversion trigger is not generated."]
            VALUE4,
        }
        impl SWSMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SWSMW::VALUE1 => 0,
                    SWSMW::VALUE2 => 1,
                    SWSMW::VALUE3 => 2,
                    SWSMW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SWSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SWSMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SWSMW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGyDSV2This register contains the actual value used for the DSV2 reference. is fed to the DAC and initial conversion trigger is generated."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SWSMW::VALUE1)
            }
            #[doc = "CSGyDSV1This register contains the actual value used for the DSV1 reference. is fed to the DAC and initial conversion trigger is generated."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SWSMW::VALUE2)
            }
            #[doc = "CSGyDSV2This register contains the actual value used for the DSV2 reference. is fed to the DAC but initial conversion trigger is not generated."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SWSMW::VALUE3)
            }
            #[doc = "CSGyDSV1This register contains the actual value used for the DSV1 reference. is fed to the DAC but initial conversion trigger is not generated."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SWSMW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `GCFG`"]
        pub enum GCFGW {
            #[doc = "Each slope step has an increment/decrement of 1"]
            VALUE1,
            #[doc = "Each slope step has an increment/decrement of 2"]
            VALUE2,
            #[doc = "Each slope step has an increment/decrement of 4"]
            VALUE3,
            #[doc = "Each slope step has an increment/decrement of 8"]
            VALUE4,
        }
        impl GCFGW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GCFGW::VALUE1 => 0,
                    GCFGW::VALUE2 => 1,
                    GCFGW::VALUE3 => 2,
                    GCFGW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _GCFGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GCFGW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: GCFGW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Each slope step has an increment/decrement of 1"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(GCFGW::VALUE1)
            }
            #[doc = "Each slope step has an increment/decrement of 2"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(GCFGW::VALUE2)
            }
            #[doc = "Each slope step has an increment/decrement of 4"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(GCFGW::VALUE3)
            }
            #[doc = "Each slope step has an increment/decrement of 8"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(GCFGW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ISTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ISTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSE`"]
        pub enum PSEW {
            #[doc = "Pulse swallow disabled"]
            VALUE1,
            #[doc = "Pulse swallow enabled"]
            VALUE2,
        }
        impl PSEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSEW::VALUE1 => false,
                    PSEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pulse swallow disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSEW::VALUE1)
            }
            #[doc = "Pulse swallow enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSWM`"]
        pub enum PSWMW {
            #[doc = "16 clock cycle window"]
            VALUE1,
            #[doc = "32 clock cycle window"]
            VALUE2,
            #[doc = "64 clock cycle window"]
            VALUE3,
        }
        impl PSWMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PSWMW::VALUE1 => 0,
                    PSWMW::VALUE2 => 1,
                    PSWMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSWMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSWMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSWMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "16 clock cycle window"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSWMW::VALUE1)
            }
            #[doc = "32 clock cycle window"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSWMW::VALUE2)
            }
            #[doc = "64 clock cycle window"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PSWMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Prescaler external start configuration"]
            #[inline]
            pub fn psrm(&self) -> PSRMR {
                PSRMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Prescaler external stop configuration"]
            #[inline]
            pub fn pstm(&self) -> PSTMR {
                PSTMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 4 - Fixed division disable"]
            #[inline]
            pub fn fpd(&self) -> FPDR {
                FPDR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 5:6 - Prescaler division factor"]
            #[inline]
            pub fn psv(&self) -> PSVR {
                PSVR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Slope control mode"]
            #[inline]
            pub fn scm(&self) -> SCMR {
                SCMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Slope external start configuration"]
            #[inline]
            pub fn ssrm(&self) -> SSRMR {
                SSRMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Slope external stop configuration"]
            #[inline]
            pub fn sstm(&self) -> SSTMR {
                SSTMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Slope reference value mode"]
            #[inline]
            pub fn svsc(&self) -> SVSCR {
                SVSCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Initial DAC start mode"]
            #[inline]
            pub fn swsm(&self) -> SWSMR {
                SWSMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Slope step gain configuration"]
            #[inline]
            pub fn gcfg(&self) -> GCFGR {
                GCFGR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 20 - Immediate shadow transfer"]
            #[inline]
            pub fn ist(&self) -> ISTR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ISTR { bits }
            }
            #[doc = "Bit 21 - Pulse swallow enable"]
            #[inline]
            pub fn pse(&self) -> PSER {
                PSER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 24:25 - Pulse swallow window mode"]
            #[inline]
            pub fn pswm(&self) -> PSWMR {
                PSWMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Prescaler external start configuration"]
            #[inline]
            pub fn psrm(&mut self) -> _PSRMW {
                _PSRMW { w: self }
            }
            #[doc = "Bits 2:3 - Prescaler external stop configuration"]
            #[inline]
            pub fn pstm(&mut self) -> _PSTMW {
                _PSTMW { w: self }
            }
            #[doc = "Bit 4 - Fixed division disable"]
            #[inline]
            pub fn fpd(&mut self) -> _FPDW {
                _FPDW { w: self }
            }
            #[doc = "Bits 5:6 - Prescaler division factor"]
            #[inline]
            pub fn psv(&mut self) -> _PSVW {
                _PSVW { w: self }
            }
            #[doc = "Bits 8:9 - Slope control mode"]
            #[inline]
            pub fn scm(&mut self) -> _SCMW {
                _SCMW { w: self }
            }
            #[doc = "Bits 10:11 - Slope external start configuration"]
            #[inline]
            pub fn ssrm(&mut self) -> _SSRMW {
                _SSRMW { w: self }
            }
            #[doc = "Bits 12:13 - Slope external stop configuration"]
            #[inline]
            pub fn sstm(&mut self) -> _SSTMW {
                _SSTMW { w: self }
            }
            #[doc = "Bits 14:15 - Slope reference value mode"]
            #[inline]
            pub fn svsc(&mut self) -> _SVSCW {
                _SVSCW { w: self }
            }
            #[doc = "Bits 16:17 - Initial DAC start mode"]
            #[inline]
            pub fn swsm(&mut self) -> _SWSMW {
                _SWSMW { w: self }
            }
            #[doc = "Bits 18:19 - Slope step gain configuration"]
            #[inline]
            pub fn gcfg(&mut self) -> _GCFGW {
                _GCFGW { w: self }
            }
            #[doc = "Bit 20 - Immediate shadow transfer"]
            #[inline]
            pub fn ist(&mut self) -> _ISTW {
                _ISTW { w: self }
            }
            #[doc = "Bit 21 - Pulse swallow enable"]
            #[inline]
            pub fn pse(&mut self) -> _PSEW {
                _PSEW { w: self }
            }
            #[doc = "Bits 24:25 - Pulse swallow window mode"]
            #[inline]
            pub fn pswm(&mut self) -> _PSWMW {
                _PSWMW { w: self }
            }
        }
    }
    #[doc = "Pulse swallow configuration"]
    pub struct PC {
        register: VolatileCell<u32>,
    }
    #[doc = "Pulse swallow configuration"]
    pub mod pc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PC {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct PSWVR {
            bits: u8,
        }
        impl PSWVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Pulse swallow configuration"]
            #[inline]
            pub fn pswv(&self) -> PSWVR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PSWVR { bits }
            }
        }
    }
    #[doc = "DAC reference value 1"]
    pub struct DSV1 {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC reference value 1"]
    pub mod dsv1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DSV1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSV1R {
            bits: u16,
        }
        impl DSV1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - DAC reference value 1"]
            #[inline]
            pub fn dsv1(&self) -> DSV1R {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSV1R { bits }
            }
        }
    }
    #[doc = "DAC reference value 1"]
    pub struct DSV2 {
        register: VolatileCell<u32>,
    }
    #[doc = "DAC reference value 1"]
    pub mod dsv2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::DSV2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct DSV2R {
            bits: u16,
        }
        impl DSV2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSV2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSV2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - DAC reference value 2"]
            #[inline]
            pub fn dsv2(&self) -> DSV2R {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DSV2R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:9 - DAC reference value 2"]
            #[inline]
            pub fn dsv2(&mut self) -> _DSV2W {
                _DSV2W { w: self }
            }
        }
    }
    #[doc = "Shadow reference value 1"]
    pub struct SDSV1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Shadow reference value 1"]
    pub mod sdsv1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SDSV1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SDSV1R {
            bits: u16,
        }
        impl SDSV1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SDSV1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SDSV1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0x03ff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:9 - Shadow DAC reference value 1"]
            #[inline]
            pub fn sdsv1(&self) -> SDSV1R {
                let bits = {
                    const MASK: u16 = 0x03ff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SDSV1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:9 - Shadow DAC reference value 1"]
            #[inline]
            pub fn sdsv1(&mut self) -> _SDSV1W {
                _SDSV1W { w: self }
            }
        }
    }
    #[doc = "Shadow Pulse swallow value"]
    pub struct SPC {
        register: VolatileCell<u32>,
    }
    #[doc = "Shadow Pulse swallow value"]
    pub mod spc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SPC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SPSWVR {
            bits: u8,
        }
        impl SPSWVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPSWVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPSWVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x3f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:5 - Shadow pulse swallow value"]
            #[inline]
            pub fn spswv(&self) -> SPSWVR {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SPSWVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:5 - Shadow pulse swallow value"]
            #[inline]
            pub fn spswv(&mut self) -> _SPSWVW {
                _SPSWVW { w: self }
            }
        }
    }
    #[doc = "Comparator configuration"]
    pub struct CC {
        register: VolatileCell<u32>,
    }
    #[doc = "Comparator configuration"]
    pub mod cc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::CC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `IBS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IBSR {
            #[doc = "HRPWMx.BLyA"]
            VALUE1,
            #[doc = "HRPWMx.BLyB"]
            VALUE2,
            #[doc = "HRPWMx.BLyC"]
            VALUE3,
            #[doc = "HRPWMx.BLyD"]
            VALUE4,
            #[doc = "HRPWMx.BLyE"]
            VALUE5,
            #[doc = "HRPWMx.BLyF"]
            VALUE6,
            #[doc = "HRPWMx.BLyG"]
            VALUE7,
            #[doc = "HRPWMx.BLyH"]
            VALUE8,
            #[doc = "HRPWMx.BLyI"]
            VALUE9,
            #[doc = "HRPWMx.BLyJ"]
            VALUE10,
            #[doc = "HRPWMx.BLyK"]
            VALUE11,
            #[doc = "HRPWMx.BLyL"]
            VALUE12,
            #[doc = "HRPWMx.BLyM"]
            VALUE13,
            #[doc = "HRPWMx.BLyN"]
            VALUE14,
            #[doc = "HRPWMx.BLyO"]
            VALUE15,
            #[doc = "HRPWMx.BLyP"]
            VALUE16,
        }
        impl IBSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    IBSR::VALUE1 => 0,
                    IBSR::VALUE2 => 0x01,
                    IBSR::VALUE3 => 0x02,
                    IBSR::VALUE4 => 0x03,
                    IBSR::VALUE5 => 0x04,
                    IBSR::VALUE6 => 0x05,
                    IBSR::VALUE7 => 0x06,
                    IBSR::VALUE8 => 0x07,
                    IBSR::VALUE9 => 0x08,
                    IBSR::VALUE10 => 0x09,
                    IBSR::VALUE11 => 0x0a,
                    IBSR::VALUE12 => 0x0b,
                    IBSR::VALUE13 => 0x0c,
                    IBSR::VALUE14 => 0x0d,
                    IBSR::VALUE15 => 0x0e,
                    IBSR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> IBSR {
                match value {
                    0 => IBSR::VALUE1,
                    1 => IBSR::VALUE2,
                    2 => IBSR::VALUE3,
                    3 => IBSR::VALUE4,
                    4 => IBSR::VALUE5,
                    5 => IBSR::VALUE6,
                    6 => IBSR::VALUE7,
                    7 => IBSR::VALUE8,
                    8 => IBSR::VALUE9,
                    9 => IBSR::VALUE10,
                    10 => IBSR::VALUE11,
                    11 => IBSR::VALUE12,
                    12 => IBSR::VALUE13,
                    13 => IBSR::VALUE14,
                    14 => IBSR::VALUE15,
                    15 => IBSR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IBSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IBSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == IBSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == IBSR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == IBSR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == IBSR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == IBSR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == IBSR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == IBSR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == IBSR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == IBSR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == IBSR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == IBSR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == IBSR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == IBSR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == IBSR::VALUE16
            }
        }
        #[doc = "Possible values of the field `IMCS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IMCSR {
            #[doc = "HRPWMx.CyINA"]
            VALUE1,
            #[doc = "HRPWMx.CyINB"]
            VALUE2,
        }
        impl IMCSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    IMCSR::VALUE1 => false,
                    IMCSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> IMCSR {
                match value {
                    false => IMCSR::VALUE1,
                    true => IMCSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IMCSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IMCSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `IMCC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IMCCR {
            #[doc = "Dynamic switch disabled"]
            VALUE1,
            #[doc = "Comparator input is connected to HRPWMx.CyINB when the control signal is HIGH"]
            VALUE2,
            #[doc = "Comparator input is connected to HRPWMx.CyINA when the control signal is HIGH"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl IMCCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    IMCCR::VALUE1 => 0,
                    IMCCR::VALUE2 => 0x01,
                    IMCCR::VALUE3 => 0x02,
                    IMCCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> IMCCR {
                match value {
                    0 => IMCCR::VALUE1,
                    1 => IMCCR::VALUE2,
                    2 => IMCCR::VALUE3,
                    i => IMCCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IMCCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IMCCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == IMCCR::VALUE3
            }
        }
        #[doc = r" Value of the field"]
        pub struct ESER {
            bits: bool,
        }
        impl ESER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OIER {
            bits: bool,
        }
        impl OIER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct OSER {
            bits: bool,
        }
        impl OSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `BLMC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum BLMCR {
            #[doc = "Blanking disabled"]
            VALUE1,
            #[doc = "Blanking on a LOW to HIGH transition"]
            VALUE2,
            #[doc = "Blanking on a HIGH to LOW transition"]
            VALUE3,
            #[doc = "Blanking on both transitions"]
            VALUE4,
        }
        impl BLMCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    BLMCR::VALUE1 => 0,
                    BLMCR::VALUE2 => 0x01,
                    BLMCR::VALUE3 => 0x02,
                    BLMCR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> BLMCR {
                match value {
                    0 => BLMCR::VALUE1,
                    1 => BLMCR::VALUE2,
                    2 => BLMCR::VALUE3,
                    3 => BLMCR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == BLMCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == BLMCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == BLMCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == BLMCR::VALUE4
            }
        }
        #[doc = r" Value of the field"]
        pub struct EBER {
            bits: bool,
        }
        impl EBER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `COFE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum COFER {
            #[doc = "Filtering stage disabled"]
            VALUE1,
            #[doc = "Filtering stage enabled"]
            VALUE2,
        }
        impl COFER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    COFER::VALUE1 => false,
                    COFER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> COFER {
                match value {
                    false => COFER::VALUE1,
                    true => COFER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == COFER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == COFER::VALUE2
            }
        }
        #[doc = "Possible values of the field `COFM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum COFMR {
            #[doc = "Comparator Output needs to be stable for 2 clock cycles"]
            VALUE1,
            #[doc = "Comparator Output needs to be stable for 3 clock cycles"]
            VALUE2,
            #[doc = "Comparator Output needs to be stable for 4 clock cycles"]
            VALUE3,
            #[doc = "Comparator Output needs to be stable for 5 clock cycles"]
            VALUE4,
            #[doc = "Comparator Output needs to be stable for 14 clock cycles"]
            VALUE5,
            #[doc = "Comparator Output needs to be stable for 15 clock cycles"]
            VALUE6,
            #[doc = "Comparator Output needs to be stable for 16 clock cycles"]
            VALUE7,
            #[doc = "Comparator Output needs to be stable for 32 clock cycles"]
            VALUE8,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl COFMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    COFMR::VALUE1 => 0,
                    COFMR::VALUE2 => 0x01,
                    COFMR::VALUE3 => 0x02,
                    COFMR::VALUE4 => 0x03,
                    COFMR::VALUE5 => 0x0c,
                    COFMR::VALUE6 => 0x0d,
                    COFMR::VALUE7 => 0x0e,
                    COFMR::VALUE8 => 0x0f,
                    COFMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> COFMR {
                match value {
                    0 => COFMR::VALUE1,
                    1 => COFMR::VALUE2,
                    2 => COFMR::VALUE3,
                    3 => COFMR::VALUE4,
                    12 => COFMR::VALUE5,
                    13 => COFMR::VALUE6,
                    14 => COFMR::VALUE7,
                    15 => COFMR::VALUE8,
                    i => COFMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == COFMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == COFMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == COFMR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == COFMR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == COFMR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == COFMR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == COFMR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == COFMR::VALUE8
            }
        }
        #[doc = "Possible values of the field `COFC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum COFCR {
            #[doc = "Filtering is always done if enabled"]
            VALUE1,
            #[doc = "Filtering is only done when CSGyDSV1 value is currently fed to the DAC"]
            VALUE2,
            #[doc = "Filtering is only done when the CSGyDSV2 value is currently fed to the DAC"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl COFCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    COFCR::VALUE1 => 0,
                    COFCR::VALUE2 => 0x01,
                    COFCR::VALUE3 => 0x02,
                    COFCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> COFCR {
                match value {
                    0 => COFCR::VALUE1,
                    1 => COFCR::VALUE2,
                    2 => COFCR::VALUE3,
                    i => COFCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == COFCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == COFCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == COFCR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `IBS`"]
        pub enum IBSW {
            #[doc = "HRPWMx.BLyA"]
            VALUE1,
            #[doc = "HRPWMx.BLyB"]
            VALUE2,
            #[doc = "HRPWMx.BLyC"]
            VALUE3,
            #[doc = "HRPWMx.BLyD"]
            VALUE4,
            #[doc = "HRPWMx.BLyE"]
            VALUE5,
            #[doc = "HRPWMx.BLyF"]
            VALUE6,
            #[doc = "HRPWMx.BLyG"]
            VALUE7,
            #[doc = "HRPWMx.BLyH"]
            VALUE8,
            #[doc = "HRPWMx.BLyI"]
            VALUE9,
            #[doc = "HRPWMx.BLyJ"]
            VALUE10,
            #[doc = "HRPWMx.BLyK"]
            VALUE11,
            #[doc = "HRPWMx.BLyL"]
            VALUE12,
            #[doc = "HRPWMx.BLyM"]
            VALUE13,
            #[doc = "HRPWMx.BLyN"]
            VALUE14,
            #[doc = "HRPWMx.BLyO"]
            VALUE15,
            #[doc = "HRPWMx.BLyP"]
            VALUE16,
        }
        impl IBSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IBSW::VALUE1 => 0,
                    IBSW::VALUE2 => 1,
                    IBSW::VALUE3 => 2,
                    IBSW::VALUE4 => 3,
                    IBSW::VALUE5 => 4,
                    IBSW::VALUE6 => 5,
                    IBSW::VALUE7 => 6,
                    IBSW::VALUE8 => 7,
                    IBSW::VALUE9 => 8,
                    IBSW::VALUE10 => 9,
                    IBSW::VALUE11 => 10,
                    IBSW::VALUE12 => 11,
                    IBSW::VALUE13 => 12,
                    IBSW::VALUE14 => 13,
                    IBSW::VALUE15 => 14,
                    IBSW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IBSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IBSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IBSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "HRPWMx.BLyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IBSW::VALUE1)
            }
            #[doc = "HRPWMx.BLyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IBSW::VALUE2)
            }
            #[doc = "HRPWMx.BLyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(IBSW::VALUE3)
            }
            #[doc = "HRPWMx.BLyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(IBSW::VALUE4)
            }
            #[doc = "HRPWMx.BLyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(IBSW::VALUE5)
            }
            #[doc = "HRPWMx.BLyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(IBSW::VALUE6)
            }
            #[doc = "HRPWMx.BLyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(IBSW::VALUE7)
            }
            #[doc = "HRPWMx.BLyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(IBSW::VALUE8)
            }
            #[doc = "HRPWMx.BLyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(IBSW::VALUE9)
            }
            #[doc = "HRPWMx.BLyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(IBSW::VALUE10)
            }
            #[doc = "HRPWMx.BLyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(IBSW::VALUE11)
            }
            #[doc = "HRPWMx.BLyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(IBSW::VALUE12)
            }
            #[doc = "HRPWMx.BLyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(IBSW::VALUE13)
            }
            #[doc = "HRPWMx.BLyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(IBSW::VALUE14)
            }
            #[doc = "HRPWMx.BLyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(IBSW::VALUE15)
            }
            #[doc = "HRPWMx.BLyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(IBSW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IMCS`"]
        pub enum IMCSW {
            #[doc = "HRPWMx.CyINA"]
            VALUE1,
            #[doc = "HRPWMx.CyINB"]
            VALUE2,
        }
        impl IMCSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    IMCSW::VALUE1 => false,
                    IMCSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IMCSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IMCSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IMCSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRPWMx.CyINA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IMCSW::VALUE1)
            }
            #[doc = "HRPWMx.CyINB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IMCSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `IMCC`"]
        pub enum IMCCW {
            #[doc = "Dynamic switch disabled"]
            VALUE1,
            #[doc = "Comparator input is connected to HRPWMx.CyINB when the control signal is HIGH"]
            VALUE2,
            #[doc = "Comparator input is connected to HRPWMx.CyINA when the control signal is HIGH"]
            VALUE3,
        }
        impl IMCCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IMCCW::VALUE1 => 0,
                    IMCCW::VALUE2 => 1,
                    IMCCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IMCCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IMCCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IMCCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Dynamic switch disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IMCCW::VALUE1)
            }
            #[doc = "Comparator input is connected to HRPWMx.CyINB when the control signal is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IMCCW::VALUE2)
            }
            #[doc = "Comparator input is connected to HRPWMx.CyINA when the control signal is HIGH"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(IMCCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _ESEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ESEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OIEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _OSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `BLMC`"]
        pub enum BLMCW {
            #[doc = "Blanking disabled"]
            VALUE1,
            #[doc = "Blanking on a LOW to HIGH transition"]
            VALUE2,
            #[doc = "Blanking on a HIGH to LOW transition"]
            VALUE3,
            #[doc = "Blanking on both transitions"]
            VALUE4,
        }
        impl BLMCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BLMCW::VALUE1 => 0,
                    BLMCW::VALUE2 => 1,
                    BLMCW::VALUE3 => 2,
                    BLMCW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _BLMCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BLMCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: BLMCW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Blanking disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(BLMCW::VALUE1)
            }
            #[doc = "Blanking on a LOW to HIGH transition"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(BLMCW::VALUE2)
            }
            #[doc = "Blanking on a HIGH to LOW transition"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(BLMCW::VALUE3)
            }
            #[doc = "Blanking on both transitions"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(BLMCW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _EBEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EBEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `COFE`"]
        pub enum COFEW {
            #[doc = "Filtering stage disabled"]
            VALUE1,
            #[doc = "Filtering stage enabled"]
            VALUE2,
        }
        impl COFEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    COFEW::VALUE1 => false,
                    COFEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _COFEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _COFEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: COFEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Filtering stage disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(COFEW::VALUE1)
            }
            #[doc = "Filtering stage enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(COFEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `COFM`"]
        pub enum COFMW {
            #[doc = "Comparator Output needs to be stable for 2 clock cycles"]
            VALUE1,
            #[doc = "Comparator Output needs to be stable for 3 clock cycles"]
            VALUE2,
            #[doc = "Comparator Output needs to be stable for 4 clock cycles"]
            VALUE3,
            #[doc = "Comparator Output needs to be stable for 5 clock cycles"]
            VALUE4,
            #[doc = "Comparator Output needs to be stable for 14 clock cycles"]
            VALUE5,
            #[doc = "Comparator Output needs to be stable for 15 clock cycles"]
            VALUE6,
            #[doc = "Comparator Output needs to be stable for 16 clock cycles"]
            VALUE7,
            #[doc = "Comparator Output needs to be stable for 32 clock cycles"]
            VALUE8,
        }
        impl COFMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    COFMW::VALUE1 => 0,
                    COFMW::VALUE2 => 1,
                    COFMW::VALUE3 => 2,
                    COFMW::VALUE4 => 3,
                    COFMW::VALUE5 => 12,
                    COFMW::VALUE6 => 13,
                    COFMW::VALUE7 => 14,
                    COFMW::VALUE8 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _COFMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _COFMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: COFMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Comparator Output needs to be stable for 2 clock cycles"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(COFMW::VALUE1)
            }
            #[doc = "Comparator Output needs to be stable for 3 clock cycles"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(COFMW::VALUE2)
            }
            #[doc = "Comparator Output needs to be stable for 4 clock cycles"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(COFMW::VALUE3)
            }
            #[doc = "Comparator Output needs to be stable for 5 clock cycles"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(COFMW::VALUE4)
            }
            #[doc = "Comparator Output needs to be stable for 14 clock cycles"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(COFMW::VALUE5)
            }
            #[doc = "Comparator Output needs to be stable for 15 clock cycles"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(COFMW::VALUE6)
            }
            #[doc = "Comparator Output needs to be stable for 16 clock cycles"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(COFMW::VALUE7)
            }
            #[doc = "Comparator Output needs to be stable for 32 clock cycles"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(COFMW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `COFC`"]
        pub enum COFCW {
            #[doc = "Filtering is always done if enabled"]
            VALUE1,
            #[doc = "Filtering is only done when CSGyDSV1 value is currently fed to the DAC"]
            VALUE2,
            #[doc = "Filtering is only done when the CSGyDSV2 value is currently fed to the DAC"]
            VALUE3,
        }
        impl COFCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    COFCW::VALUE1 => 0,
                    COFCW::VALUE2 => 1,
                    COFCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _COFCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _COFCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: COFCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Filtering is always done if enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(COFCW::VALUE1)
            }
            #[doc = "Filtering is only done when CSGyDSV1 value is currently fed to the DAC"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(COFCW::VALUE2)
            }
            #[doc = "Filtering is only done when the CSGyDSV2 value is currently fed to the DAC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(COFCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - External blanking trigger selector"]
            #[inline]
            pub fn ibs(&self) -> IBSR {
                IBSR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 8 - Inverting comparator input selector"]
            #[inline]
            pub fn imcs(&self) -> IMCSR {
                IMCSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 9:10 - Comparator input switching configuration"]
            #[inline]
            pub fn imcc(&self) -> IMCCR {
                IMCCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 11 - External triggered switch enable"]
            #[inline]
            pub fn ese(&self) -> ESER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                ESER { bits }
            }
            #[doc = "Bit 12 - Comparator output inversion enable"]
            #[inline]
            pub fn oie(&self) -> OIER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OIER { bits }
            }
            #[doc = "Bit 13 - Comparator output synchronization enable"]
            #[inline]
            pub fn ose(&self) -> OSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                OSER { bits }
            }
            #[doc = "Bits 14:15 - Blanking mode"]
            #[inline]
            pub fn blmc(&self) -> BLMCR {
                BLMCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - External blanking trigger enabled"]
            #[inline]
            pub fn ebe(&self) -> EBER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                EBER { bits }
            }
            #[doc = "Bit 17 - Comparator output filter enable"]
            #[inline]
            pub fn cofe(&self) -> COFER {
                COFER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:21 - Comparator output filter window"]
            #[inline]
            pub fn cofm(&self) -> COFMR {
                COFMR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Comparator output filter control"]
            #[inline]
            pub fn cofc(&self) -> COFCR {
                COFCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - External blanking trigger selector"]
            #[inline]
            pub fn ibs(&mut self) -> _IBSW {
                _IBSW { w: self }
            }
            #[doc = "Bit 8 - Inverting comparator input selector"]
            #[inline]
            pub fn imcs(&mut self) -> _IMCSW {
                _IMCSW { w: self }
            }
            #[doc = "Bits 9:10 - Comparator input switching configuration"]
            #[inline]
            pub fn imcc(&mut self) -> _IMCCW {
                _IMCCW { w: self }
            }
            #[doc = "Bit 11 - External triggered switch enable"]
            #[inline]
            pub fn ese(&mut self) -> _ESEW {
                _ESEW { w: self }
            }
            #[doc = "Bit 12 - Comparator output inversion enable"]
            #[inline]
            pub fn oie(&mut self) -> _OIEW {
                _OIEW { w: self }
            }
            #[doc = "Bit 13 - Comparator output synchronization enable"]
            #[inline]
            pub fn ose(&mut self) -> _OSEW {
                _OSEW { w: self }
            }
            #[doc = "Bits 14:15 - Blanking mode"]
            #[inline]
            pub fn blmc(&mut self) -> _BLMCW {
                _BLMCW { w: self }
            }
            #[doc = "Bit 16 - External blanking trigger enabled"]
            #[inline]
            pub fn ebe(&mut self) -> _EBEW {
                _EBEW { w: self }
            }
            #[doc = "Bit 17 - Comparator output filter enable"]
            #[inline]
            pub fn cofe(&mut self) -> _COFEW {
                _COFEW { w: self }
            }
            #[doc = "Bits 18:21 - Comparator output filter window"]
            #[inline]
            pub fn cofm(&mut self) -> _COFMW {
                _COFMW { w: self }
            }
            #[doc = "Bits 24:25 - Comparator output filter control"]
            #[inline]
            pub fn cofc(&mut self) -> _COFCW {
                _COFCW { w: self }
            }
        }
    }
    #[doc = "Passive level configuration"]
    pub struct PLC {
        register: VolatileCell<u32>,
    }
    #[doc = "Passive level configuration"]
    pub mod plc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PLC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `IPLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum IPLSR {
            #[doc = "HRPWMx.BLyA"]
            VALUE1,
            #[doc = "HRPWMx.BLyB"]
            VALUE2,
            #[doc = "HRPWMx.BLyC"]
            VALUE3,
            #[doc = "HRPWMx.BLyD"]
            VALUE4,
            #[doc = "HRPWMx.BLyE"]
            VALUE5,
            #[doc = "HRPWMx.BLyF"]
            VALUE6,
            #[doc = "HRPWMx.BLyG"]
            VALUE7,
            #[doc = "HRPWMx.BLyH"]
            VALUE8,
            #[doc = "HRPWMx.BLyI"]
            VALUE9,
            #[doc = "HRPWMx.BLyJ"]
            VALUE10,
            #[doc = "HRPWMx.BLyK"]
            VALUE11,
            #[doc = "HRPWMx.BLyL"]
            VALUE12,
            #[doc = "HRPWMx.BLyM"]
            VALUE13,
            #[doc = "HRPWMx.BLyN"]
            VALUE14,
            #[doc = "HRPWMx.BLyO"]
            VALUE15,
            #[doc = "HRPWMx.BLyP"]
            VALUE16,
        }
        impl IPLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    IPLSR::VALUE1 => 0,
                    IPLSR::VALUE2 => 0x01,
                    IPLSR::VALUE3 => 0x02,
                    IPLSR::VALUE4 => 0x03,
                    IPLSR::VALUE5 => 0x04,
                    IPLSR::VALUE6 => 0x05,
                    IPLSR::VALUE7 => 0x06,
                    IPLSR::VALUE8 => 0x07,
                    IPLSR::VALUE9 => 0x08,
                    IPLSR::VALUE10 => 0x09,
                    IPLSR::VALUE11 => 0x0a,
                    IPLSR::VALUE12 => 0x0b,
                    IPLSR::VALUE13 => 0x0c,
                    IPLSR::VALUE14 => 0x0d,
                    IPLSR::VALUE15 => 0x0e,
                    IPLSR::VALUE16 => 0x0f,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> IPLSR {
                match value {
                    0 => IPLSR::VALUE1,
                    1 => IPLSR::VALUE2,
                    2 => IPLSR::VALUE3,
                    3 => IPLSR::VALUE4,
                    4 => IPLSR::VALUE5,
                    5 => IPLSR::VALUE6,
                    6 => IPLSR::VALUE7,
                    7 => IPLSR::VALUE8,
                    8 => IPLSR::VALUE9,
                    9 => IPLSR::VALUE10,
                    10 => IPLSR::VALUE11,
                    11 => IPLSR::VALUE12,
                    12 => IPLSR::VALUE13,
                    13 => IPLSR::VALUE14,
                    14 => IPLSR::VALUE15,
                    15 => IPLSR::VALUE16,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == IPLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == IPLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == IPLSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == IPLSR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == IPLSR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == IPLSR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == IPLSR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == IPLSR::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == IPLSR::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == IPLSR::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == IPLSR::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == IPLSR::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == IPLSR::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == IPLSR::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == IPLSR::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == IPLSR::VALUE16
            }
        }
        #[doc = "Possible values of the field `PLCL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLCLR {
            #[doc = "Clamping control disabled"]
            VALUE1,
            #[doc = "Output is set to clamped level when the control signal is HIGH"]
            VALUE2,
            #[doc = "Output is set to clamped level when the control signal is LOW"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PLCLR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PLCLR::VALUE1 => 0,
                    PLCLR::VALUE2 => 0x01,
                    PLCLR::VALUE3 => 0x02,
                    PLCLR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PLCLR {
                match value {
                    0 => PLCLR::VALUE1,
                    1 => PLCLR::VALUE2,
                    2 => PLCLR::VALUE3,
                    i => PLCLR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLCLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLCLR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PLCLR::VALUE3
            }
        }
        #[doc = "Possible values of the field `PSL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSLR {
            #[doc = "Output clamped level is LOW"]
            VALUE1,
            #[doc = "Output clamped level is HIGH"]
            VALUE2,
        }
        impl PSLR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSLR::VALUE1 => false,
                    PSLR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSLR {
                match value {
                    false => PSLR::VALUE1,
                    true => PSLR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSLR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSLR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLSW`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLSWR {
            #[doc = "External signal and SW can remove the output from the clamped state"]
            VALUE1,
            #[doc = "Only SW can remove the output from the clamped state"]
            VALUE2,
        }
        impl PLSWR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PLSWR::VALUE1 => false,
                    PLSWR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PLSWR {
                match value {
                    false => PLSWR::VALUE1,
                    true => PLSWR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLSWR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLSWR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PLEC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLECR {
            #[doc = "Passive level is entered immediately"]
            VALUE1,
            #[doc = "Passive level is entered only after the comparator output passes to LOW (output from the blanking stage)"]
            VALUE2,
            #[doc = "Passive level is entered only after the comparator output passes to HIGH (output from the blanking stage)"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PLECR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PLECR::VALUE1 => 0,
                    PLECR::VALUE2 => 0x01,
                    PLECR::VALUE3 => 0x02,
                    PLECR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PLECR {
                match value {
                    0 => PLECR::VALUE1,
                    1 => PLECR::VALUE2,
                    2 => PLECR::VALUE3,
                    i => PLECR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLECR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLECR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PLECR::VALUE3
            }
        }
        #[doc = "Possible values of the field `PLXC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PLXCR {
            #[doc = "Passive level is exit immediately"]
            VALUE1,
            #[doc = "Passive level is exit only after the comparator output passes to LOW (output from the blanking stage)"]
            VALUE2,
            #[doc = "Passive level is exit only after the comparator output passes to HIGH (output from the blanking stage)"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PLXCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PLXCR::VALUE1 => 0,
                    PLXCR::VALUE2 => 0x01,
                    PLXCR::VALUE3 => 0x02,
                    PLXCR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PLXCR {
                match value {
                    0 => PLXCR::VALUE1,
                    1 => PLXCR::VALUE2,
                    2 => PLXCR::VALUE3,
                    i => PLXCR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PLXCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PLXCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PLXCR::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `IPLS`"]
        pub enum IPLSW {
            #[doc = "HRPWMx.BLyA"]
            VALUE1,
            #[doc = "HRPWMx.BLyB"]
            VALUE2,
            #[doc = "HRPWMx.BLyC"]
            VALUE3,
            #[doc = "HRPWMx.BLyD"]
            VALUE4,
            #[doc = "HRPWMx.BLyE"]
            VALUE5,
            #[doc = "HRPWMx.BLyF"]
            VALUE6,
            #[doc = "HRPWMx.BLyG"]
            VALUE7,
            #[doc = "HRPWMx.BLyH"]
            VALUE8,
            #[doc = "HRPWMx.BLyI"]
            VALUE9,
            #[doc = "HRPWMx.BLyJ"]
            VALUE10,
            #[doc = "HRPWMx.BLyK"]
            VALUE11,
            #[doc = "HRPWMx.BLyL"]
            VALUE12,
            #[doc = "HRPWMx.BLyM"]
            VALUE13,
            #[doc = "HRPWMx.BLyN"]
            VALUE14,
            #[doc = "HRPWMx.BLyO"]
            VALUE15,
            #[doc = "HRPWMx.BLyP"]
            VALUE16,
        }
        impl IPLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IPLSW::VALUE1 => 0,
                    IPLSW::VALUE2 => 1,
                    IPLSW::VALUE3 => 2,
                    IPLSW::VALUE4 => 3,
                    IPLSW::VALUE5 => 4,
                    IPLSW::VALUE6 => 5,
                    IPLSW::VALUE7 => 6,
                    IPLSW::VALUE8 => 7,
                    IPLSW::VALUE9 => 8,
                    IPLSW::VALUE10 => 9,
                    IPLSW::VALUE11 => 10,
                    IPLSW::VALUE12 => 11,
                    IPLSW::VALUE13 => 12,
                    IPLSW::VALUE14 => 13,
                    IPLSW::VALUE15 => 14,
                    IPLSW::VALUE16 => 15,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _IPLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IPLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: IPLSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "HRPWMx.BLyA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(IPLSW::VALUE1)
            }
            #[doc = "HRPWMx.BLyB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(IPLSW::VALUE2)
            }
            #[doc = "HRPWMx.BLyC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(IPLSW::VALUE3)
            }
            #[doc = "HRPWMx.BLyD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(IPLSW::VALUE4)
            }
            #[doc = "HRPWMx.BLyE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(IPLSW::VALUE5)
            }
            #[doc = "HRPWMx.BLyF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(IPLSW::VALUE6)
            }
            #[doc = "HRPWMx.BLyG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(IPLSW::VALUE7)
            }
            #[doc = "HRPWMx.BLyH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(IPLSW::VALUE8)
            }
            #[doc = "HRPWMx.BLyI"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(IPLSW::VALUE9)
            }
            #[doc = "HRPWMx.BLyJ"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(IPLSW::VALUE10)
            }
            #[doc = "HRPWMx.BLyK"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(IPLSW::VALUE11)
            }
            #[doc = "HRPWMx.BLyL"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(IPLSW::VALUE12)
            }
            #[doc = "HRPWMx.BLyM"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(IPLSW::VALUE13)
            }
            #[doc = "HRPWMx.BLyN"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(IPLSW::VALUE14)
            }
            #[doc = "HRPWMx.BLyO"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(IPLSW::VALUE15)
            }
            #[doc = "HRPWMx.BLyP"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(IPLSW::VALUE16)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x0f;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLCL`"]
        pub enum PLCLW {
            #[doc = "Clamping control disabled"]
            VALUE1,
            #[doc = "Output is set to clamped level when the control signal is HIGH"]
            VALUE2,
            #[doc = "Output is set to clamped level when the control signal is LOW"]
            VALUE3,
        }
        impl PLCLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PLCLW::VALUE1 => 0,
                    PLCLW::VALUE2 => 1,
                    PLCLW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLCLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLCLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLCLW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Clamping control disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLCLW::VALUE1)
            }
            #[doc = "Output is set to clamped level when the control signal is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLCLW::VALUE2)
            }
            #[doc = "Output is set to clamped level when the control signal is LOW"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PLCLW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSL`"]
        pub enum PSLW {
            #[doc = "Output clamped level is LOW"]
            VALUE1,
            #[doc = "Output clamped level is HIGH"]
            VALUE2,
        }
        impl PSLW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSLW::VALUE1 => false,
                    PSLW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSLW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSLW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSLW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Output clamped level is LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSLW::VALUE1)
            }
            #[doc = "Output clamped level is HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSLW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLSW`"]
        pub enum PLSWW {
            #[doc = "External signal and SW can remove the output from the clamped state"]
            VALUE1,
            #[doc = "Only SW can remove the output from the clamped state"]
            VALUE2,
        }
        impl PLSWW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PLSWW::VALUE1 => false,
                    PLSWW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLSWW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLSWW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLSWW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External signal and SW can remove the output from the clamped state"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLSWW::VALUE1)
            }
            #[doc = "Only SW can remove the output from the clamped state"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLSWW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLEC`"]
        pub enum PLECW {
            #[doc = "Passive level is entered immediately"]
            VALUE1,
            #[doc = "Passive level is entered only after the comparator output passes to LOW (output from the blanking stage)"]
            VALUE2,
            #[doc = "Passive level is entered only after the comparator output passes to HIGH (output from the blanking stage)"]
            VALUE3,
        }
        impl PLECW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PLECW::VALUE1 => 0,
                    PLECW::VALUE2 => 1,
                    PLECW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLECW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLECW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLECW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Passive level is entered immediately"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLECW::VALUE1)
            }
            #[doc = "Passive level is entered only after the comparator output passes to LOW (output from the blanking stage)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLECW::VALUE2)
            }
            #[doc = "Passive level is entered only after the comparator output passes to HIGH (output from the blanking stage)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PLECW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PLXC`"]
        pub enum PLXCW {
            #[doc = "Passive level is exit immediately"]
            VALUE1,
            #[doc = "Passive level is exit only after the comparator output passes to LOW (output from the blanking stage)"]
            VALUE2,
            #[doc = "Passive level is exit only after the comparator output passes to HIGH (output from the blanking stage)"]
            VALUE3,
        }
        impl PLXCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PLXCW::VALUE1 => 0,
                    PLXCW::VALUE2 => 1,
                    PLXCW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PLXCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PLXCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PLXCW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Passive level is exit immediately"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PLXCW::VALUE1)
            }
            #[doc = "Passive level is exit only after the comparator output passes to LOW (output from the blanking stage)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PLXCW::VALUE2)
            }
            #[doc = "Passive level is exit only after the comparator output passes to HIGH (output from the blanking stage)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PLXCW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:3 - Clamping control signal selector"]
            #[inline]
            pub fn ipls(&self) -> IPLSR {
                IPLSR::_from({
                    const MASK: u8 = 0x0f;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Clamping control signal level selection"]
            #[inline]
            pub fn plcl(&self) -> PLCLR {
                PLCLR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 10 - Output passive level value"]
            #[inline]
            pub fn psl(&self) -> PSLR {
                PSLR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Clamped state exit SW configuration"]
            #[inline]
            pub fn plsw(&self) -> PLSWR {
                PLSWR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 12:13 - Passive level enter configuration"]
            #[inline]
            pub fn plec(&self) -> PLECR {
                PLECR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Passive level exit configuration"]
            #[inline]
            pub fn plxc(&self) -> PLXCR {
                PLXCR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:3 - Clamping control signal selector"]
            #[inline]
            pub fn ipls(&mut self) -> _IPLSW {
                _IPLSW { w: self }
            }
            #[doc = "Bits 8:9 - Clamping control signal level selection"]
            #[inline]
            pub fn plcl(&mut self) -> _PLCLW {
                _PLCLW { w: self }
            }
            #[doc = "Bit 10 - Output passive level value"]
            #[inline]
            pub fn psl(&mut self) -> _PSLW {
                _PSLW { w: self }
            }
            #[doc = "Bit 11 - Clamped state exit SW configuration"]
            #[inline]
            pub fn plsw(&mut self) -> _PLSWW {
                _PLSWW { w: self }
            }
            #[doc = "Bits 12:13 - Passive level enter configuration"]
            #[inline]
            pub fn plec(&mut self) -> _PLECW {
                _PLECW { w: self }
            }
            #[doc = "Bits 14:15 - Passive level exit configuration"]
            #[inline]
            pub fn plxc(&mut self) -> _PLXCW {
                _PLXCW { w: self }
            }
        }
    }
    #[doc = "Comparator blanking value"]
    pub struct BLV {
        register: VolatileCell<u32>,
    }
    #[doc = "Comparator blanking value"]
    pub mod blv {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::BLV {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct BLVR {
            bits: u8,
        }
        impl BLVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _BLVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BLVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Blanking value"]
            #[inline]
            pub fn blv(&self) -> BLVR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BLVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - Blanking value"]
            #[inline]
            pub fn blv(&mut self) -> _BLVW {
                _BLVW { w: self }
            }
        }
    }
    #[doc = "Service request enable"]
    pub struct SRE {
        register: VolatileCell<u32>,
    }
    #[doc = "Service request enable"]
    pub mod sre {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct VLS1ER {
            bits: bool,
        }
        impl VLS1ER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct VLS2ER {
            bits: bool,
        }
        impl VLS2ER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct TRGSER {
            bits: bool,
        }
        impl TRGSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STRSER {
            bits: bool,
        }
        impl STRSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STPSER {
            bits: bool,
        }
        impl STPSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct STDER {
            bits: bool,
        }
        impl STDER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CRSER {
            bits: bool,
        }
        impl CRSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CFSER {
            bits: bool,
        }
        impl CFSER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct CSEER {
            bits: bool,
        }
        impl CSEER {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Proxy"]
        pub struct _VLS1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VLS1EW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _VLS2EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VLS2EW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRGSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRGSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STPSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STPSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STDEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STDEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CFSEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CFSEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSEEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSEEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Value switch from CSGyDSV1 to CSGyDSV2 interrupt enable"]
            #[inline]
            pub fn vls1e(&self) -> VLS1ER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                VLS1ER { bits }
            }
            #[doc = "Bit 1 - Value switch from CSGyDSV2 to CSGyDSV1 interrupt enable"]
            #[inline]
            pub fn vls2e(&self) -> VLS2ER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                VLS2ER { bits }
            }
            #[doc = "Bit 2 - Conversion trigger interrupt enable"]
            #[inline]
            pub fn trgse(&self) -> TRGSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                TRGSER { bits }
            }
            #[doc = "Bit 3 - Start trigger interrupt enable"]
            #[inline]
            pub fn strse(&self) -> STRSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STRSER { bits }
            }
            #[doc = "Bit 4 - Stop trigger interrupt enable"]
            #[inline]
            pub fn stpse(&self) -> STPSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STPSER { bits }
            }
            #[doc = "Bit 5 - Shadow transfer done interrupt enable"]
            #[inline]
            pub fn stde(&self) -> STDER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                STDER { bits }
            }
            #[doc = "Bit 6 - Comparator rise interrupt enable"]
            #[inline]
            pub fn crse(&self) -> CRSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CRSER { bits }
            }
            #[doc = "Bit 7 - Comparator fall interrupt enable"]
            #[inline]
            pub fn cfse(&self) -> CFSER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CFSER { bits }
            }
            #[doc = "Bit 8 - Clamped state interrupt enable"]
            #[inline]
            pub fn csee(&self) -> CSEER {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                CSEER { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Value switch from CSGyDSV1 to CSGyDSV2 interrupt enable"]
            #[inline]
            pub fn vls1e(&mut self) -> _VLS1EW {
                _VLS1EW { w: self }
            }
            #[doc = "Bit 1 - Value switch from CSGyDSV2 to CSGyDSV1 interrupt enable"]
            #[inline]
            pub fn vls2e(&mut self) -> _VLS2EW {
                _VLS2EW { w: self }
            }
            #[doc = "Bit 2 - Conversion trigger interrupt enable"]
            #[inline]
            pub fn trgse(&mut self) -> _TRGSEW {
                _TRGSEW { w: self }
            }
            #[doc = "Bit 3 - Start trigger interrupt enable"]
            #[inline]
            pub fn strse(&mut self) -> _STRSEW {
                _STRSEW { w: self }
            }
            #[doc = "Bit 4 - Stop trigger interrupt enable"]
            #[inline]
            pub fn stpse(&mut self) -> _STPSEW {
                _STPSEW { w: self }
            }
            #[doc = "Bit 5 - Shadow transfer done interrupt enable"]
            #[inline]
            pub fn stde(&mut self) -> _STDEW {
                _STDEW { w: self }
            }
            #[doc = "Bit 6 - Comparator rise interrupt enable"]
            #[inline]
            pub fn crse(&mut self) -> _CRSEW {
                _CRSEW { w: self }
            }
            #[doc = "Bit 7 - Comparator fall interrupt enable"]
            #[inline]
            pub fn cfse(&mut self) -> _CFSEW {
                _CFSEW { w: self }
            }
            #[doc = "Bit 8 - Clamped state interrupt enable"]
            #[inline]
            pub fn csee(&mut self) -> _CSEEW {
                _CSEEW { w: self }
            }
        }
    }
    #[doc = "Service request line selector"]
    pub struct SRS {
        register: VolatileCell<u32>,
    }
    #[doc = "Service request line selector"]
    pub mod srs {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SRS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `VLS1S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VLS1SR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl VLS1SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    VLS1SR::VALUE1 => 0,
                    VLS1SR::VALUE2 => 0x01,
                    VLS1SR::VALUE3 => 0x02,
                    VLS1SR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> VLS1SR {
                match value {
                    0 => VLS1SR::VALUE1,
                    1 => VLS1SR::VALUE2,
                    2 => VLS1SR::VALUE3,
                    3 => VLS1SR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VLS1SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VLS1SR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == VLS1SR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == VLS1SR::VALUE4
            }
        }
        #[doc = "Possible values of the field `VLS2S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VLS2SR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl VLS2SR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    VLS2SR::VALUE1 => 0,
                    VLS2SR::VALUE2 => 0x01,
                    VLS2SR::VALUE3 => 0x02,
                    VLS2SR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> VLS2SR {
                match value {
                    0 => VLS2SR::VALUE1,
                    1 => VLS2SR::VALUE2,
                    2 => VLS2SR::VALUE3,
                    3 => VLS2SR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VLS2SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VLS2SR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == VLS2SR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == VLS2SR::VALUE4
            }
        }
        #[doc = "Possible values of the field `TRLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRLSR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl TRLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TRLSR::VALUE1 => 0,
                    TRLSR::VALUE2 => 0x01,
                    TRLSR::VALUE3 => 0x02,
                    TRLSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TRLSR {
                match value {
                    0 => TRLSR::VALUE1,
                    1 => TRLSR::VALUE2,
                    2 => TRLSR::VALUE3,
                    3 => TRLSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TRLSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TRLSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `SSLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SSLSR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl SSLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    SSLSR::VALUE1 => 0,
                    SSLSR::VALUE2 => 0x01,
                    SSLSR::VALUE3 => 0x02,
                    SSLSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> SSLSR {
                match value {
                    0 => SSLSR::VALUE1,
                    1 => SSLSR::VALUE2,
                    2 => SSLSR::VALUE3,
                    3 => SSLSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SSLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SSLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == SSLSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == SSLSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `STLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STLSR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl STLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    STLSR::VALUE1 => 0,
                    STLSR::VALUE2 => 0x01,
                    STLSR::VALUE3 => 0x02,
                    STLSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> STLSR {
                match value {
                    0 => STLSR::VALUE1,
                    1 => STLSR::VALUE2,
                    2 => STLSR::VALUE3,
                    3 => STLSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == STLSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == STLSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CRFLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CRFLSR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl CRFLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CRFLSR::VALUE1 => 0,
                    CRFLSR::VALUE2 => 0x01,
                    CRFLSR::VALUE3 => 0x02,
                    CRFLSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CRFLSR {
                match value {
                    0 => CRFLSR::VALUE1,
                    1 => CRFLSR::VALUE2,
                    2 => CRFLSR::VALUE3,
                    3 => CRFLSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CRFLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CRFLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CRFLSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CRFLSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `CSLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CSLSR {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl CSLSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    CSLSR::VALUE1 => 0,
                    CSLSR::VALUE2 => 0x01,
                    CSLSR::VALUE3 => 0x02,
                    CSLSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> CSLSR {
                match value {
                    0 => CSLSR::VALUE1,
                    1 => CSLSR::VALUE2,
                    2 => CSLSR::VALUE3,
                    3 => CSLSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CSLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CSLSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == CSLSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == CSLSR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `VLS1S`"]
        pub enum VLS1SW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl VLS1SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    VLS1SW::VALUE1 => 0,
                    VLS1SW::VALUE2 => 1,
                    VLS1SW::VALUE3 => 2,
                    VLS1SW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VLS1SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VLS1SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VLS1SW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VLS1SW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VLS1SW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(VLS1SW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(VLS1SW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `VLS2S`"]
        pub enum VLS2SW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl VLS2SW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    VLS2SW::VALUE1 => 0,
                    VLS2SW::VALUE2 => 1,
                    VLS2SW::VALUE3 => 2,
                    VLS2SW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _VLS2SW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VLS2SW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: VLS2SW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(VLS2SW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(VLS2SW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(VLS2SW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(VLS2SW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TRLS`"]
        pub enum TRLSW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl TRLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TRLSW::VALUE1 => 0,
                    TRLSW::VALUE2 => 1,
                    TRLSW::VALUE3 => 2,
                    TRLSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TRLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TRLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TRLSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TRLSW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TRLSW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TRLSW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TRLSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SSLS`"]
        pub enum SSLSW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl SSLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SSLSW::VALUE1 => 0,
                    SSLSW::VALUE2 => 1,
                    SSLSW::VALUE3 => 2,
                    SSLSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SSLSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SSLSW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SSLSW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(SSLSW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(SSLSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STLS`"]
        pub enum STLSW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl STLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    STLSW::VALUE1 => 0,
                    STLSW::VALUE2 => 1,
                    STLSW::VALUE3 => 2,
                    STLSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STLSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STLSW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STLSW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(STLSW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(STLSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CRFLS`"]
        pub enum CRFLSW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl CRFLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CRFLSW::VALUE1 => 0,
                    CRFLSW::VALUE2 => 1,
                    CRFLSW::VALUE3 => 2,
                    CRFLSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRFLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRFLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CRFLSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CRFLSW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CRFLSW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CRFLSW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CRFLSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CSLS`"]
        pub enum CSLSW {
            #[doc = "CSGySR0"]
            VALUE1,
            #[doc = "CSGySR1"]
            VALUE2,
            #[doc = "CSGySR2"]
            VALUE3,
            #[doc = "CSGySR3"]
            VALUE4,
        }
        impl CSLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CSLSW::VALUE1 => 0,
                    CSLSW::VALUE2 => 1,
                    CSLSW::VALUE3 => 2,
                    CSLSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CSLSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "CSGySR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CSLSW::VALUE1)
            }
            #[doc = "CSGySR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CSLSW::VALUE2)
            }
            #[doc = "CSGySR2"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(CSLSW::VALUE3)
            }
            #[doc = "CSGySR3"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(CSLSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Value switch from CSGyDSV1 to CSGyDSV2 interrupt line selection"]
            #[inline]
            pub fn vls1s(&self) -> VLS1SR {
                VLS1SR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Value switch from CSGyDSV2 to CSGyDSV1 interrupt line selection"]
            #[inline]
            pub fn vls2s(&self) -> VLS2SR {
                VLS2SR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Conversion trigger interrupt line selection"]
            #[inline]
            pub fn trls(&self) -> TRLSR {
                TRLSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Start/Stop trigger interrupt line selection"]
            #[inline]
            pub fn ssls(&self) -> SSLSR {
                SSLSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Shadow transfer done interrupt line selection"]
            #[inline]
            pub fn stls(&self) -> STLSR {
                STLSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Comparator rise/fall interrupt line selection"]
            #[inline]
            pub fn crfls(&self) -> CRFLSR {
                CRFLSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Comparator clamped state interrupt line selection"]
            #[inline]
            pub fn csls(&self) -> CSLSR {
                CSLSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Value switch from CSGyDSV1 to CSGyDSV2 interrupt line selection"]
            #[inline]
            pub fn vls1s(&mut self) -> _VLS1SW {
                _VLS1SW { w: self }
            }
            #[doc = "Bits 2:3 - Value switch from CSGyDSV2 to CSGyDSV1 interrupt line selection"]
            #[inline]
            pub fn vls2s(&mut self) -> _VLS2SW {
                _VLS2SW { w: self }
            }
            #[doc = "Bits 4:5 - Conversion trigger interrupt line selection"]
            #[inline]
            pub fn trls(&mut self) -> _TRLSW {
                _TRLSW { w: self }
            }
            #[doc = "Bits 6:7 - Start/Stop trigger interrupt line selection"]
            #[inline]
            pub fn ssls(&mut self) -> _SSLSW {
                _SSLSW { w: self }
            }
            #[doc = "Bits 8:9 - Shadow transfer done interrupt line selection"]
            #[inline]
            pub fn stls(&mut self) -> _STLSW {
                _STLSW { w: self }
            }
            #[doc = "Bits 10:11 - Comparator rise/fall interrupt line selection"]
            #[inline]
            pub fn crfls(&mut self) -> _CRFLSW {
                _CRFLSW { w: self }
            }
            #[doc = "Bits 12:13 - Comparator clamped state interrupt line selection"]
            #[inline]
            pub fn csls(&mut self) -> _CSLSW {
                _CSLSW { w: self }
            }
        }
    }
    #[doc = "Service request SW set"]
    pub struct SWS {
        register: VolatileCell<u32>,
    }
    #[doc = "Service request SW set"]
    pub mod sws {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SWS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVLS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVLS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SVLS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SVLS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STRGSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STRGSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTRSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTPSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCRSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCFSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCSSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCSSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Value switch from CSGyDSV1 to CSGyDSV2 status set"]
            #[inline]
            pub fn svls1(&mut self) -> _SVLS1W {
                _SVLS1W { w: self }
            }
            #[doc = "Bit 1 - Value switch from CSGyDSV2 to CSGyDSV1 status set"]
            #[inline]
            pub fn svls2(&mut self) -> _SVLS2W {
                _SVLS2W { w: self }
            }
            #[doc = "Bit 2 - Conversion trigger status set"]
            #[inline]
            pub fn strgs(&mut self) -> _STRGSW {
                _STRGSW { w: self }
            }
            #[doc = "Bit 3 - Start trigger status set"]
            #[inline]
            pub fn sstrs(&mut self) -> _SSTRSW {
                _SSTRSW { w: self }
            }
            #[doc = "Bit 4 - Stop trigger status set"]
            #[inline]
            pub fn sstps(&mut self) -> _SSTPSW {
                _SSTPSW { w: self }
            }
            #[doc = "Bit 5 - Shadow transfer status set"]
            #[inline]
            pub fn sstd(&mut self) -> _SSTDW {
                _SSTDW { w: self }
            }
            #[doc = "Bit 6 - Comparator rise status set"]
            #[inline]
            pub fn scrs(&mut self) -> _SCRSW {
                _SCRSW { w: self }
            }
            #[doc = "Bit 7 - Comparator fall status set"]
            #[inline]
            pub fn scfs(&mut self) -> _SCFSW {
                _SCFSW { w: self }
            }
            #[doc = "Bit 8 - Comparator clamped state status set"]
            #[inline]
            pub fn scss(&mut self) -> _SCSSW {
                _SCSSW { w: self }
            }
        }
    }
    #[doc = "Service request SW clear"]
    pub struct SWC {
        register: VolatileCell<u32>,
    }
    #[doc = "Service request SW clear"]
    pub mod swc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SWC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _CVLS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CVLS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CVLS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _CVLS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CTRGSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CTRGSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSTRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSTRSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSTPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSTPSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSTDW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSTDW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCRSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCRSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCFSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCFSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CCSSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CCSSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Value switch from CSGyDSV1 to CSGyDSV2 status clear"]
            #[inline]
            pub fn cvls1(&mut self) -> _CVLS1W {
                _CVLS1W { w: self }
            }
            #[doc = "Bit 1 - Value switch from CSGyDSV2 to CSGyDSV1 status clear"]
            #[inline]
            pub fn cvls2(&mut self) -> _CVLS2W {
                _CVLS2W { w: self }
            }
            #[doc = "Bit 2 - Conversion trigger status clear"]
            #[inline]
            pub fn ctrgs(&mut self) -> _CTRGSW {
                _CTRGSW { w: self }
            }
            #[doc = "Bit 3 - Start trigger status clear"]
            #[inline]
            pub fn cstrs(&mut self) -> _CSTRSW {
                _CSTRSW { w: self }
            }
            #[doc = "Bit 4 - Stop trigger status clear"]
            #[inline]
            pub fn cstps(&mut self) -> _CSTPSW {
                _CSTPSW { w: self }
            }
            #[doc = "Bit 5 - Shadow transfer status clear"]
            #[inline]
            pub fn cstd(&mut self) -> _CSTDW {
                _CSTDW { w: self }
            }
            #[doc = "Bit 6 - Comparator rise status clear"]
            #[inline]
            pub fn ccrs(&mut self) -> _CCRSW {
                _CCRSW { w: self }
            }
            #[doc = "Bit 7 - Comparator fall status clear"]
            #[inline]
            pub fn ccfs(&mut self) -> _CCFSW {
                _CCFSW { w: self }
            }
            #[doc = "Bit 8 - Comparator clamped status clear"]
            #[inline]
            pub fn ccss(&mut self) -> _CCSSW {
                _CCSSW { w: self }
            }
        }
    }
    #[doc = "Service request status"]
    pub struct ISTAT {
        register: VolatileCell<u32>,
    }
    #[doc = "Service request status"]
    pub mod istat {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::ISTAT {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `VLS1S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VLS1SR {
            #[doc = "Value switch not detected"]
            VALUE1,
            #[doc = "Value switch detected"]
            VALUE2,
        }
        impl VLS1SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VLS1SR::VALUE1 => false,
                    VLS1SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VLS1SR {
                match value {
                    false => VLS1SR::VALUE1,
                    true => VLS1SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VLS1SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VLS1SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `VLS2S`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum VLS2SR {
            #[doc = "Value switch not detected"]
            VALUE1,
            #[doc = "Value switch detected"]
            VALUE2,
        }
        impl VLS2SR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    VLS2SR::VALUE1 => false,
                    VLS2SR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> VLS2SR {
                match value {
                    false => VLS2SR::VALUE1,
                    true => VLS2SR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == VLS2SR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == VLS2SR::VALUE2
            }
        }
        #[doc = "Possible values of the field `TRGSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TRGSSR {
            #[doc = "Conversion trigger was not generated"]
            VALUE1,
            #[doc = "Conversion trigger was generated"]
            VALUE2,
        }
        impl TRGSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TRGSSR::VALUE1 => false,
                    TRGSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TRGSSR {
                match value {
                    false => TRGSSR::VALUE1,
                    true => TRGSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TRGSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TRGSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STRSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STRSSR {
            #[doc = "Start trigger not detected"]
            VALUE1,
            #[doc = "Start trigger detected"]
            VALUE2,
        }
        impl STRSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STRSSR::VALUE1 => false,
                    STRSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STRSSR {
                match value {
                    false => STRSSR::VALUE1,
                    true => STRSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STRSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STRSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STPSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STPSSR {
            #[doc = "Stop trigger not detected"]
            VALUE1,
            #[doc = "Stop trigger detected"]
            VALUE2,
        }
        impl STPSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STPSSR::VALUE1 => false,
                    STPSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STPSSR {
                match value {
                    false => STPSSR::VALUE1,
                    true => STPSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STPSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STPSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `STDS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STDSR {
            #[doc = "Shadow transfer was not performed"]
            VALUE1,
            #[doc = "Shadow transfer was performed"]
            VALUE2,
        }
        impl STDSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STDSR::VALUE1 => false,
                    STDSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STDSR {
                match value {
                    false => STDSR::VALUE1,
                    true => STDSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STDSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STDSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CRSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CRSSR {
            #[doc = "Comparator output LOW to HIGH transition not detected"]
            VALUE1,
            #[doc = "Comparator output LOW to HIGH transition detected"]
            VALUE2,
        }
        impl CRSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CRSSR::VALUE1 => false,
                    CRSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CRSSR {
                match value {
                    false => CRSSR::VALUE1,
                    true => CRSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CRSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CRSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CFSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CFSSR {
            #[doc = "Comparator output HIGH to LOW transition not detected"]
            VALUE1,
            #[doc = "Comparator output HIGH to LOW transition detected"]
            VALUE2,
        }
        impl CFSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CFSSR::VALUE1 => false,
                    CFSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CFSSR {
                match value {
                    false => CFSSR::VALUE1,
                    true => CFSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CFSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CFSSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CSES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CSESR {
            #[doc = "Comparator output has been set to the clamped state"]
            VALUE1,
            #[doc = "Comparator output has not been set to the clamped state"]
            VALUE2,
        }
        impl CSESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CSESR::VALUE1 => false,
                    CSESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CSESR {
                match value {
                    false => CSESR::VALUE1,
                    true => CSESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CSESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CSESR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Value switch from CSGyDSV1 to CSGyDSV2 interrupt status"]
            #[inline]
            pub fn vls1s(&self) -> VLS1SR {
                VLS1SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Value switch from CSGyDSV2 to CSGyDSV1 interrupt status"]
            #[inline]
            pub fn vls2s(&self) -> VLS2SR {
                VLS2SR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Conversion trigger status"]
            #[inline]
            pub fn trgss(&self) -> TRGSSR {
                TRGSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Start trigger interrupt status"]
            #[inline]
            pub fn strss(&self) -> STRSSR {
                STRSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Stop trigger interrupt status"]
            #[inline]
            pub fn stpss(&self) -> STPSSR {
                STPSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Shadow transfer interrupt status"]
            #[inline]
            pub fn stds(&self) -> STDSR {
                STDSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Comparator rise interrupt status"]
            #[inline]
            pub fn crss(&self) -> CRSSR {
                CRSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Comparator fall interrupt status"]
            #[inline]
            pub fn cfss(&self) -> CFSSR {
                CFSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Comparator clamped interrupt status"]
            #[inline]
            pub fn cses(&self) -> CSESR {
                CSESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
}
#[doc = "High Resolution PWM Unit"]
pub struct HRPWM0_CSG0 {
    register_block: hrpwm0_csg0::RegisterBlock,
}
impl Deref for HRPWM0_CSG0 {
    type Target = hrpwm0_csg0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_csg0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_CSG1: Peripheral<HRPWM0_CSG1> = unsafe { Peripheral::new(0x4002_0b00) };
#[doc = r" Register block"]
pub struct HRPWM0_CSG1 {
    register_block: hrpwm0_csg0::RegisterBlock,
}
impl Deref for HRPWM0_CSG1 {
    type Target = hrpwm0_csg0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_csg0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_CSG2: Peripheral<HRPWM0_CSG2> = unsafe { Peripheral::new(0x4002_0c00) };
#[doc = r" Register block"]
pub struct HRPWM0_CSG2 {
    register_block: hrpwm0_csg0::RegisterBlock,
}
impl Deref for HRPWM0_CSG2 {
    type Target = hrpwm0_csg0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_csg0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_HRC0: Peripheral<HRPWM0_HRC0> = unsafe { Peripheral::new(0x4002_1300) };
#[doc = "High Resolution PWM Unit"]
pub mod hrpwm0_hrc0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - HRC mode configuration"]
        pub gc: GC,
        #[doc = "0x04 - HRC output passive level"]
        pub pl: PL,
        #[doc = "0x08 - HRC global control selection"]
        pub gsel: GSEL,
        #[doc = "0x0c - HRC timer selection"]
        pub tsel: TSEL,
        #[doc = "0x10 - HRC current source for shadow"]
        pub sc: SC,
        #[doc = "0x14 - HRC dead time rising value"]
        pub dcr: DCR,
        #[doc = "0x18 - HRC dead time falling value"]
        pub dcf: DCF,
        #[doc = "0x1c - HRC rising edge value"]
        pub cr1: CR1,
        #[doc = "0x20 - HRC falling edge value"]
        pub cr2: CR2,
        #[doc = "0x24 - HRC next source for shadow"]
        pub ssc: SSC,
        #[doc = "0x28 - HRC shadow dead time rising"]
        pub sdcr: SDCR,
        #[doc = "0x2c - HRC shadow dead time falling"]
        pub sdcf: SDCF,
        #[doc = "0x30 - HRC shadow rising edge value"]
        pub scr1: SCR1,
        #[doc = "0x34 - HRC shadow falling edge value"]
        pub scr2: SCR2,
    }
    #[doc = "HRC mode configuration"]
    pub struct GC {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC mode configuration"]
    pub mod gc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HRM0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRM0R {
            #[doc = "Rising edge high resolution signal positioning enabled"]
            VALUE1,
            #[doc = "Falling edge high resolution signal positioning enabled"]
            VALUE2,
            #[doc = "Both edges high resolution signal positioning is enabled"]
            VALUE3,
            #[doc = "No high resolution positioning"]
            VALUE4,
        }
        impl HRM0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HRM0R::VALUE1 => 0,
                    HRM0R::VALUE2 => 0x01,
                    HRM0R::VALUE3 => 0x02,
                    HRM0R::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HRM0R {
                match value {
                    0 => HRM0R::VALUE1,
                    1 => HRM0R::VALUE2,
                    2 => HRM0R::VALUE3,
                    3 => HRM0R::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRM0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRM0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HRM0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == HRM0R::VALUE4
            }
        }
        #[doc = "Possible values of the field `HRM1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HRM1R {
            #[doc = "Rising edge high resolution signal positioning enabled"]
            VALUE1,
            #[doc = "Falling edge high resolution signal positioning enabled"]
            VALUE2,
            #[doc = "Both edges high resolution signal positioning is enabled"]
            VALUE3,
            #[doc = "No high resolution positioning"]
            VALUE4,
        }
        impl HRM1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HRM1R::VALUE1 => 0,
                    HRM1R::VALUE2 => 0x01,
                    HRM1R::VALUE3 => 0x02,
                    HRM1R::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HRM1R {
                match value {
                    0 => HRM1R::VALUE1,
                    1 => HRM1R::VALUE2,
                    2 => HRM1R::VALUE3,
                    3 => HRM1R::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HRM1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HRM1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HRM1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == HRM1R::VALUE4
            }
        }
        #[doc = "Possible values of the field `DTE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTER {
            #[doc = "Dead time insertion is disabled"]
            VALUE1,
            #[doc = "Dead time insertion is enabled"]
            VALUE2,
        }
        impl DTER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTER::VALUE1 => false,
                    DTER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTER {
                match value {
                    false => DTER::VALUE1,
                    true => DTER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TR0E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TR0ER {
            #[doc = "Trap function for HRPWMx.HROUTy0 is disabled"]
            VALUE1,
            #[doc = "Trap function for HRPWMx.HROUTy0 is enabled"]
            VALUE2,
        }
        impl TR0ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TR0ER::VALUE1 => false,
                    TR0ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TR0ER {
                match value {
                    false => TR0ER::VALUE1,
                    true => TR0ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TR0ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TR0ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TR1E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TR1ER {
            #[doc = "Trap function for HRPWMx.HROUTy1 is disabled"]
            VALUE1,
            #[doc = "Trap function for HRPWMx.HROUTy1 is enabled"]
            VALUE2,
        }
        impl TR1ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TR1ER::VALUE1 => false,
                    TR1ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TR1ER {
                match value {
                    false => TR1ER::VALUE1,
                    true => TR1ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TR1ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TR1ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `STC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STCR {
            #[doc = "HRCy shadow transfer enable for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values is not linked with the specific Capture/Compare Unit timer."]
            VALUE1,
            #[doc = "HRCy shadow transfer enable for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values is linked with the specific Capture/Compare Unit timer."]
            VALUE2,
        }
        impl STCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STCR::VALUE1 => false,
                    STCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STCR {
                match value {
                    false => STCR::VALUE1,
                    true => STCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DSTC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSTCR {
            #[doc = "HRCy shadow transfer enable for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values is not linked with the specific Capture/Compare Unit timer."]
            VALUE1,
            #[doc = "HRCy shadow transfer enable for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values is linked with the specific Capture/Compare Unit timer."]
            VALUE2,
        }
        impl DSTCR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSTCR::VALUE1 => false,
                    DSTCR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSTCR {
                match value {
                    false => DSTCR::VALUE1,
                    true => DSTCR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSTCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSTCR::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCS0R {
            #[doc = "HRPWMx.OUTy0 is connected to the latch Q channel"]
            VALUE1,
            #[doc = "HRPWMx.OUTy0 is connected to the latch Qn channel"]
            VALUE2,
        }
        impl OCS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OCS0R::VALUE1 => false,
                    OCS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OCS0R {
                match value {
                    false => OCS0R::VALUE1,
                    true => OCS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `OCS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum OCS1R {
            #[doc = "HRPWMx.OUTy1 is connected to the latch Qn channel"]
            VALUE1,
            #[doc = "HRPWMx.OUTy1 is connected to the latch Q channel"]
            VALUE2,
        }
        impl OCS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    OCS1R::VALUE1 => false,
                    OCS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> OCS1R {
                match value {
                    false => OCS1R::VALUE1,
                    true => OCS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == OCS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == OCS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `DTUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DTUSR {
            #[doc = "The update of the values is done with the trigger generated by the timers. This is the same trigger that is used to update the HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, .."]
            VALUE1,
            #[doc = "The update of the dead time values is done when the dead time counter is not running, independently of the HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . registers."]
            VALUE2,
        }
        impl DTUSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DTUSR::VALUE1 => false,
                    DTUSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DTUSR {
                match value {
                    false => DTUSR::VALUE1,
                    true => DTUSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DTUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DTUSR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `HRM0`"]
        pub enum HRM0W {
            #[doc = "Rising edge high resolution signal positioning enabled"]
            VALUE1,
            #[doc = "Falling edge high resolution signal positioning enabled"]
            VALUE2,
            #[doc = "Both edges high resolution signal positioning is enabled"]
            VALUE3,
            #[doc = "No high resolution positioning"]
            VALUE4,
        }
        impl HRM0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HRM0W::VALUE1 => 0,
                    HRM0W::VALUE2 => 1,
                    HRM0W::VALUE3 => 2,
                    HRM0W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRM0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRM0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRM0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Rising edge high resolution signal positioning enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRM0W::VALUE1)
            }
            #[doc = "Falling edge high resolution signal positioning enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRM0W::VALUE2)
            }
            #[doc = "Both edges high resolution signal positioning is enabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HRM0W::VALUE3)
            }
            #[doc = "No high resolution positioning"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(HRM0W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HRM1`"]
        pub enum HRM1W {
            #[doc = "Rising edge high resolution signal positioning enabled"]
            VALUE1,
            #[doc = "Falling edge high resolution signal positioning enabled"]
            VALUE2,
            #[doc = "Both edges high resolution signal positioning is enabled"]
            VALUE3,
            #[doc = "No high resolution positioning"]
            VALUE4,
        }
        impl HRM1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HRM1W::VALUE1 => 0,
                    HRM1W::VALUE2 => 1,
                    HRM1W::VALUE3 => 2,
                    HRM1W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HRM1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HRM1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HRM1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Rising edge high resolution signal positioning enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HRM1W::VALUE1)
            }
            #[doc = "Falling edge high resolution signal positioning enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HRM1W::VALUE2)
            }
            #[doc = "Both edges high resolution signal positioning is enabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HRM1W::VALUE3)
            }
            #[doc = "No high resolution positioning"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(HRM1W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DTE`"]
        pub enum DTEW {
            #[doc = "Dead time insertion is disabled"]
            VALUE1,
            #[doc = "Dead time insertion is enabled"]
            VALUE2,
        }
        impl DTEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DTEW::VALUE1 => false,
                    DTEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DTEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Dead time insertion is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DTEW::VALUE1)
            }
            #[doc = "Dead time insertion is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DTEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TR0E`"]
        pub enum TR0EW {
            #[doc = "Trap function for HRPWMx.HROUTy0 is disabled"]
            VALUE1,
            #[doc = "Trap function for HRPWMx.HROUTy0 is enabled"]
            VALUE2,
        }
        impl TR0EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TR0EW::VALUE1 => false,
                    TR0EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TR0EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TR0EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TR0EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap function for HRPWMx.HROUTy0 is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TR0EW::VALUE1)
            }
            #[doc = "Trap function for HRPWMx.HROUTy0 is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TR0EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TR1E`"]
        pub enum TR1EW {
            #[doc = "Trap function for HRPWMx.HROUTy1 is disabled"]
            VALUE1,
            #[doc = "Trap function for HRPWMx.HROUTy1 is enabled"]
            VALUE2,
        }
        impl TR1EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TR1EW::VALUE1 => false,
                    TR1EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TR1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TR1EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TR1EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Trap function for HRPWMx.HROUTy1 is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TR1EW::VALUE1)
            }
            #[doc = "Trap function for HRPWMx.HROUTy1 is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TR1EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `STC`"]
        pub enum STCW {
            #[doc = "HRCy shadow transfer enable for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values is not linked with the specific Capture/Compare Unit timer."]
            VALUE1,
            #[doc = "HRCy shadow transfer enable for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values is linked with the specific Capture/Compare Unit timer."]
            VALUE2,
        }
        impl STCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    STCW::VALUE1 => false,
                    STCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _STCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: STCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRCy shadow transfer enable for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values is not linked with the specific Capture/Compare Unit timer."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(STCW::VALUE1)
            }
            #[doc = "HRCy shadow transfer enable for HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . values is linked with the specific Capture/Compare Unit timer."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(STCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSTC`"]
        pub enum DSTCW {
            #[doc = "HRCy shadow transfer enable for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values is not linked with the specific Capture/Compare Unit timer."]
            VALUE1,
            #[doc = "HRCy shadow transfer enable for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values is linked with the specific Capture/Compare Unit timer."]
            VALUE2,
        }
        impl DSTCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSTCW::VALUE1 => false,
                    DSTCW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSTCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSTCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSTCW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRCy shadow transfer enable for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values is not linked with the specific Capture/Compare Unit timer."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSTCW::VALUE1)
            }
            #[doc = "HRCy shadow transfer enable for HRCyDCRThis register holds the dead time value that is going to be inserted whenever a rising transition on the output latch is sensed. and HRCyDCFThis register holds the dead time value that is going to be inserted whenever a falling transition on the output latch is sensed. values is linked with the specific Capture/Compare Unit timer."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSTCW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS0`"]
        pub enum OCS0W {
            #[doc = "HRPWMx.OUTy0 is connected to the latch Q channel"]
            VALUE1,
            #[doc = "HRPWMx.OUTy0 is connected to the latch Qn channel"]
            VALUE2,
        }
        impl OCS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OCS0W::VALUE1 => false,
                    OCS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRPWMx.OUTy0 is connected to the latch Q channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCS0W::VALUE1)
            }
            #[doc = "HRPWMx.OUTy0 is connected to the latch Qn channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `OCS1`"]
        pub enum OCS1W {
            #[doc = "HRPWMx.OUTy1 is connected to the latch Qn channel"]
            VALUE1,
            #[doc = "HRPWMx.OUTy1 is connected to the latch Q channel"]
            VALUE2,
        }
        impl OCS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    OCS1W::VALUE1 => false,
                    OCS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _OCS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _OCS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: OCS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRPWMx.OUTy1 is connected to the latch Qn channel"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(OCS1W::VALUE1)
            }
            #[doc = "HRPWMx.OUTy1 is connected to the latch Q channel"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(OCS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DTUS`"]
        pub enum DTUSW {
            #[doc = "The update of the values is done with the trigger generated by the timers. This is the same trigger that is used to update the HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, .."]
            VALUE1,
            #[doc = "The update of the dead time values is done when the dead time counter is not running, independently of the HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . registers."]
            VALUE2,
        }
        impl DTUSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DTUSW::VALUE1 => false,
                    DTUSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DTUSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DTUSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DTUSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The update of the values is done with the trigger generated by the timers. This is the same trigger that is used to update the HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, .."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DTUSW::VALUE1)
            }
            #[doc = "The update of the dead time values is done when the dead time counter is not running, independently of the HRCyCR1This register holds the value for the rising edge high resolution signal placement. the update of this value should be done via the associated shadow register, . and HRCyCR2This register holds the value for the falling edge high resolution signal placement. the update of this value should be done via the associated shadow register, . registers."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DTUSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - HRCy high resolution mode configuration for source selector 0"]
            #[inline]
            pub fn hrm0(&self) -> HRM0R {
                HRM0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - HRCy high resolution mode configuration for source selector 1"]
            #[inline]
            pub fn hrm1(&self) -> HRM1R {
                HRM1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 8 - HRCy dead time enable"]
            #[inline]
            pub fn dte(&self) -> DTER {
                DTER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - HRCy trap enable"]
            #[inline]
            pub fn tr0e(&self) -> TR0ER {
                TR0ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - HRCy complementary trap enable"]
            #[inline]
            pub fn tr1e(&self) -> TR1ER {
                TR1ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - HRCy shadow transfer configuration"]
            #[inline]
            pub fn stc(&self) -> STCR {
                STCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - HRCy dead time shadow transfer configuration"]
            #[inline]
            pub fn dstc(&self) -> DSTCR {
                DSTCR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - HRPWMx.OUTy0 channel selector"]
            #[inline]
            pub fn ocs0(&self) -> OCS0R {
                OCS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - HRPWMx.OUTy1 channel selector"]
            #[inline]
            pub fn ocs1(&self) -> OCS1R {
                OCS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Dead Time update trigger selector"]
            #[inline]
            pub fn dtus(&self) -> DTUSR {
                DTUSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - HRCy high resolution mode configuration for source selector 0"]
            #[inline]
            pub fn hrm0(&mut self) -> _HRM0W {
                _HRM0W { w: self }
            }
            #[doc = "Bits 2:3 - HRCy high resolution mode configuration for source selector 1"]
            #[inline]
            pub fn hrm1(&mut self) -> _HRM1W {
                _HRM1W { w: self }
            }
            #[doc = "Bit 8 - HRCy dead time enable"]
            #[inline]
            pub fn dte(&mut self) -> _DTEW {
                _DTEW { w: self }
            }
            #[doc = "Bit 9 - HRCy trap enable"]
            #[inline]
            pub fn tr0e(&mut self) -> _TR0EW {
                _TR0EW { w: self }
            }
            #[doc = "Bit 10 - HRCy complementary trap enable"]
            #[inline]
            pub fn tr1e(&mut self) -> _TR1EW {
                _TR1EW { w: self }
            }
            #[doc = "Bit 11 - HRCy shadow transfer configuration"]
            #[inline]
            pub fn stc(&mut self) -> _STCW {
                _STCW { w: self }
            }
            #[doc = "Bit 12 - HRCy dead time shadow transfer configuration"]
            #[inline]
            pub fn dstc(&mut self) -> _DSTCW {
                _DSTCW { w: self }
            }
            #[doc = "Bit 13 - HRPWMx.OUTy0 channel selector"]
            #[inline]
            pub fn ocs0(&mut self) -> _OCS0W {
                _OCS0W { w: self }
            }
            #[doc = "Bit 14 - HRPWMx.OUTy1 channel selector"]
            #[inline]
            pub fn ocs1(&mut self) -> _OCS1W {
                _OCS1W { w: self }
            }
            #[doc = "Bit 16 - Dead Time update trigger selector"]
            #[inline]
            pub fn dtus(&mut self) -> _DTUSW {
                _DTUSW { w: self }
            }
        }
    }
    #[doc = "HRC output passive level"]
    pub struct PL {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC output passive level"]
    pub mod pl {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PSL0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSL0R {
            #[doc = "HRPWMx.OUTy0 output passive level is set to LOW"]
            VALUE1,
            #[doc = "HRPWMx.OUTy0 output passive level is set to HIGH"]
            VALUE2,
        }
        impl PSL0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSL0R::VALUE1 => false,
                    PSL0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSL0R {
                match value {
                    false => PSL0R::VALUE1,
                    true => PSL0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSL0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSL0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PSL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PSL1R {
            #[doc = "HRPWMx.OUTy1 output passive level is set to LOW"]
            VALUE1,
            #[doc = "HRPWMx.OUTy1 output passive level is set to HIGH"]
            VALUE2,
        }
        impl PSL1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PSL1R::VALUE1 => false,
                    PSL1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PSL1R {
                match value {
                    false => PSL1R::VALUE1,
                    true => PSL1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PSL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PSL1R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PSL0`"]
        pub enum PSL0W {
            #[doc = "HRPWMx.OUTy0 output passive level is set to LOW"]
            VALUE1,
            #[doc = "HRPWMx.OUTy0 output passive level is set to HIGH"]
            VALUE2,
        }
        impl PSL0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSL0W::VALUE1 => false,
                    PSL0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSL0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSL0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSL0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRPWMx.OUTy0 output passive level is set to LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSL0W::VALUE1)
            }
            #[doc = "HRPWMx.OUTy0 output passive level is set to HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSL0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PSL1`"]
        pub enum PSL1W {
            #[doc = "HRPWMx.OUTy1 output passive level is set to LOW"]
            VALUE1,
            #[doc = "HRPWMx.OUTy1 output passive level is set to HIGH"]
            VALUE2,
        }
        impl PSL1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PSL1W::VALUE1 => false,
                    PSL1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PSL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PSL1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PSL1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "HRPWMx.OUTy1 output passive level is set to LOW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PSL1W::VALUE1)
            }
            #[doc = "HRPWMx.OUTy1 output passive level is set to HIGH"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PSL1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - HRPWMx.OUTy0 passive level"]
            #[inline]
            pub fn psl0(&self) -> PSL0R {
                PSL0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - HRPWMx.OUTy1 passive level"]
            #[inline]
            pub fn psl1(&self) -> PSL1R {
                PSL1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - HRPWMx.OUTy0 passive level"]
            #[inline]
            pub fn psl0(&mut self) -> _PSL0W {
                _PSL0W { w: self }
            }
            #[doc = "Bit 1 - HRPWMx.OUTy1 passive level"]
            #[inline]
            pub fn psl1(&mut self) -> _PSL1W {
                _PSL1W { w: self }
            }
        }
    }
    #[doc = "HRC global control selection"]
    pub struct GSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC global control selection"]
    pub mod gsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::GSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `C0SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C0SSR {
            #[doc = "CMP output of CSG0 unit can be used as set source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG1 unit can be used as set source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C0SSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C0SSR::VALUE1 => 0,
                    C0SSR::VALUE2 => 0x01,
                    C0SSR::VALUE3 => 0x02,
                    C0SSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C0SSR {
                match value {
                    0 => C0SSR::VALUE1,
                    1 => C0SSR::VALUE2,
                    2 => C0SSR::VALUE3,
                    i => C0SSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C0SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C0SSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == C0SSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `C0CS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C0CSR {
            #[doc = "CMP output of CSG0 unit can be used as clear source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG1 unit can be used as clear source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C0CSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C0CSR::VALUE1 => 0,
                    C0CSR::VALUE2 => 0x01,
                    C0CSR::VALUE3 => 0x02,
                    C0CSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C0CSR {
                match value {
                    0 => C0CSR::VALUE1,
                    1 => C0CSR::VALUE2,
                    2 => C0CSR::VALUE3,
                    i => C0CSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C0CSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C0CSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == C0CSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `S0M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0MR {
            #[doc = "Set from source selector 0 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Set from source selector 0 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C0SS field."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl S0MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    S0MR::VALUE1 => 0,
                    S0MR::VALUE2 => 0x01,
                    S0MR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> S0MR {
                match value {
                    0 => S0MR::VALUE1,
                    1 => S0MR::VALUE2,
                    i => S0MR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0MR::VALUE2
            }
        }
        #[doc = "Possible values of the field `C0M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C0MR {
            #[doc = "Clear from source selector 0 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Clear from source selector 0 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C0CS field."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C0MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C0MR::VALUE1 => 0,
                    C0MR::VALUE2 => 0x01,
                    C0MR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C0MR {
                match value {
                    0 => C0MR::VALUE1,
                    1 => C0MR::VALUE2,
                    i => C0MR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C0MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C0MR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S0ES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S0ESR {
            #[doc = "Generation of the set signal is disabled"]
            VALUE1,
            #[doc = "Set signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Set signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Set signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl S0ESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    S0ESR::VALUE1 => 0,
                    S0ESR::VALUE2 => 0x01,
                    S0ESR::VALUE3 => 0x02,
                    S0ESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> S0ESR {
                match value {
                    0 => S0ESR::VALUE1,
                    1 => S0ESR::VALUE2,
                    2 => S0ESR::VALUE3,
                    3 => S0ESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S0ESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S0ESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == S0ESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == S0ESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `C0ES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C0ESR {
            #[doc = "Generation of the clear signal is disabled"]
            VALUE1,
            #[doc = "Clear signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Clear signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Clear signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl C0ESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C0ESR::VALUE1 => 0,
                    C0ESR::VALUE2 => 0x01,
                    C0ESR::VALUE3 => 0x02,
                    C0ESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C0ESR {
                match value {
                    0 => C0ESR::VALUE1,
                    1 => C0ESR::VALUE2,
                    2 => C0ESR::VALUE3,
                    3 => C0ESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C0ESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C0ESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == C0ESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == C0ESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `C1SS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C1SSR {
            #[doc = "CMP output of CSG0 unit can be used as set source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C1SSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C1SSR::VALUE1 => 0,
                    C1SSR::VALUE2 => 0x01,
                    C1SSR::VALUE3 => 0x02,
                    C1SSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C1SSR {
                match value {
                    0 => C1SSR::VALUE1,
                    1 => C1SSR::VALUE2,
                    2 => C1SSR::VALUE3,
                    i => C1SSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C1SSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C1SSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == C1SSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `C1CS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C1CSR {
            #[doc = "CMP output of CSG0 unit can be used as clear source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C1CSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C1CSR::VALUE1 => 0,
                    C1CSR::VALUE2 => 0x01,
                    C1CSR::VALUE3 => 0x02,
                    C1CSR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C1CSR {
                match value {
                    0 => C1CSR::VALUE1,
                    1 => C1CSR::VALUE2,
                    2 => C1CSR::VALUE3,
                    i => C1CSR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C1CSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C1CSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == C1CSR::VALUE3
            }
        }
        #[doc = "Possible values of the field `S1M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1MR {
            #[doc = "Set from source selector 1 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Set from source selector 1 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C1SS field."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl S1MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    S1MR::VALUE1 => 0,
                    S1MR::VALUE2 => 0x01,
                    S1MR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> S1MR {
                match value {
                    0 => S1MR::VALUE1,
                    1 => S1MR::VALUE2,
                    i => S1MR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1MR::VALUE2
            }
        }
        #[doc = "Possible values of the field `C1M`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C1MR {
            #[doc = "Clear from source selector 1 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Clear from source selector 1 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C1CS field."]
            VALUE2,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl C1MR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C1MR::VALUE1 => 0,
                    C1MR::VALUE2 => 0x01,
                    C1MR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C1MR {
                match value {
                    0 => C1MR::VALUE1,
                    1 => C1MR::VALUE2,
                    i => C1MR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C1MR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C1MR::VALUE2
            }
        }
        #[doc = "Possible values of the field `S1ES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum S1ESR {
            #[doc = "Generation of the set signal is disabled"]
            VALUE1,
            #[doc = "Set signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Set signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Set signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl S1ESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    S1ESR::VALUE1 => 0,
                    S1ESR::VALUE2 => 0x01,
                    S1ESR::VALUE3 => 0x02,
                    S1ESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> S1ESR {
                match value {
                    0 => S1ESR::VALUE1,
                    1 => S1ESR::VALUE2,
                    2 => S1ESR::VALUE3,
                    3 => S1ESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == S1ESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == S1ESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == S1ESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == S1ESR::VALUE4
            }
        }
        #[doc = "Possible values of the field `C1ES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum C1ESR {
            #[doc = "Generation of the clear signal is disabled"]
            VALUE1,
            #[doc = "Clear signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Clear signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Clear signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl C1ESR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    C1ESR::VALUE1 => 0,
                    C1ESR::VALUE2 => 0x01,
                    C1ESR::VALUE3 => 0x02,
                    C1ESR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> C1ESR {
                match value {
                    0 => C1ESR::VALUE1,
                    1 => C1ESR::VALUE2,
                    2 => C1ESR::VALUE3,
                    3 => C1ESR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == C1ESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == C1ESR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == C1ESR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == C1ESR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `C0SS`"]
        pub enum C0SSW {
            #[doc = "CMP output of CSG0 unit can be used as set source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG1 unit can be used as set source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            VALUE3,
        }
        impl C0SSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C0SSW::VALUE1 => 0,
                    C0SSW::VALUE2 => 1,
                    C0SSW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C0SSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C0SSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C0SSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CMP output of CSG0 unit can be used as set source for the output latch"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C0SSW::VALUE1)
            }
            #[doc = "CMP output of CSG1 unit can be used as set source for the output latch"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C0SSW::VALUE2)
            }
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(C0SSW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C0CS`"]
        pub enum C0CSW {
            #[doc = "CMP output of CSG0 unit can be used as clear source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG1 unit can be used as clear source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            VALUE3,
        }
        impl C0CSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C0CSW::VALUE1 => 0,
                    C0CSW::VALUE2 => 1,
                    C0CSW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C0CSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C0CSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C0CSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CMP output of CSG0 unit can be used as clear source for the output latch"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C0CSW::VALUE1)
            }
            #[doc = "CMP output of CSG1 unit can be used as clear source for the output latch"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C0CSW::VALUE2)
            }
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(C0CSW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `S0M`"]
        pub enum S0MW {
            #[doc = "Set from source selector 0 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Set from source selector 0 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C0SS field."]
            VALUE2,
        }
        impl S0MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    S0MW::VALUE1 => 0,
                    S0MW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: S0MW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Set from source selector 0 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(S0MW::VALUE1)
            }
            #[doc = "Set from source selector 0 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C0SS field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(S0MW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C0M`"]
        pub enum C0MW {
            #[doc = "Clear from source selector 0 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Clear from source selector 0 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C0CS field."]
            VALUE2,
        }
        impl C0MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C0MW::VALUE1 => 0,
                    C0MW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C0MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C0MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C0MW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Clear from source selector 0 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C0MW::VALUE1)
            }
            #[doc = "Clear from source selector 0 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C0CS field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C0MW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `S0ES`"]
        pub enum S0ESW {
            #[doc = "Generation of the set signal is disabled"]
            VALUE1,
            #[doc = "Set signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Set signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Set signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl S0ESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    S0ESW::VALUE1 => 0,
                    S0ESW::VALUE2 => 1,
                    S0ESW::VALUE3 => 2,
                    S0ESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _S0ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S0ESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: S0ESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Generation of the set signal is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(S0ESW::VALUE1)
            }
            #[doc = "Set signal is generated on a LOW to HIGH transition of the selected input"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(S0ESW::VALUE2)
            }
            #[doc = "Set signal is generated on a HIGH to LOW transition of the selected input"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(S0ESW::VALUE3)
            }
            #[doc = "Set signal is generated on both transitions of the selected input"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(S0ESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C0ES`"]
        pub enum C0ESW {
            #[doc = "Generation of the clear signal is disabled"]
            VALUE1,
            #[doc = "Clear signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Clear signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Clear signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl C0ESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C0ESW::VALUE1 => 0,
                    C0ESW::VALUE2 => 1,
                    C0ESW::VALUE3 => 2,
                    C0ESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C0ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C0ESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C0ESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Generation of the clear signal is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C0ESW::VALUE1)
            }
            #[doc = "Clear signal is generated on a LOW to HIGH transition of the selected input"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C0ESW::VALUE2)
            }
            #[doc = "Clear signal is generated on a HIGH to LOW transition of the selected input"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(C0ESW::VALUE3)
            }
            #[doc = "Clear signal is generated on both transitions of the selected input"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(C0ESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C1SS`"]
        pub enum C1SSW {
            #[doc = "CMP output of CSG0 unit can be used as set source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            VALUE3,
        }
        impl C1SSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C1SSW::VALUE1 => 0,
                    C1SSW::VALUE2 => 1,
                    C1SSW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C1SSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C1SSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C1SSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CMP output of CSG0 unit can be used as set source for the output latch"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C1SSW::VALUE1)
            }
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C1SSW::VALUE2)
            }
            #[doc = "CMP output of CSG2 unit can be used as set source for the output latch"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(C1SSW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C1CS`"]
        pub enum C1CSW {
            #[doc = "CMP output of CSG0 unit can be used as clear source for the output latch"]
            VALUE1,
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            VALUE2,
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            VALUE3,
        }
        impl C1CSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C1CSW::VALUE1 => 0,
                    C1CSW::VALUE2 => 1,
                    C1CSW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C1CSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C1CSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C1CSW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "CMP output of CSG0 unit can be used as clear source for the output latch"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C1CSW::VALUE1)
            }
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C1CSW::VALUE2)
            }
            #[doc = "CMP output of CSG2 unit can be used as clear source for the output latch"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(C1CSW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `S1M`"]
        pub enum S1MW {
            #[doc = "Set from source selector 1 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Set from source selector 1 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C1SS field."]
            VALUE2,
        }
        impl S1MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    S1MW::VALUE1 => 0,
                    S1MW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: S1MW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Set from source selector 1 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(S1MW::VALUE1)
            }
            #[doc = "Set from source selector 1 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C1SS field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(S1MW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C1M`"]
        pub enum C1MW {
            #[doc = "Clear from source selector 1 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            VALUE1,
            #[doc = "Clear from source selector 1 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C1CS field."]
            VALUE2,
        }
        impl C1MW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C1MW::VALUE1 => 0,
                    C1MW::VALUE2 => 1,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C1MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C1MW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C1MW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Clear from source selector 1 is controlled via the Capture/Compare Unit timer, CCSTy signal"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C1MW::VALUE1)
            }
            #[doc = "Clear from source selector 1 is controlled via the CMP output from the CSGy unit. Which unit is being used is configured via the C1CS field."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C1MW::VALUE2)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `S1ES`"]
        pub enum S1ESW {
            #[doc = "Generation of the set signal is disabled"]
            VALUE1,
            #[doc = "Set signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Set signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Set signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl S1ESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    S1ESW::VALUE1 => 0,
                    S1ESW::VALUE2 => 1,
                    S1ESW::VALUE3 => 2,
                    S1ESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _S1ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _S1ESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: S1ESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Generation of the set signal is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(S1ESW::VALUE1)
            }
            #[doc = "Set signal is generated on a LOW to HIGH transition of the selected input"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(S1ESW::VALUE2)
            }
            #[doc = "Set signal is generated on a HIGH to LOW transition of the selected input"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(S1ESW::VALUE3)
            }
            #[doc = "Set signal is generated on both transitions of the selected input"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(S1ESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `C1ES`"]
        pub enum C1ESW {
            #[doc = "Generation of the clear signal is disabled"]
            VALUE1,
            #[doc = "Clear signal is generated on a LOW to HIGH transition of the selected input"]
            VALUE2,
            #[doc = "Clear signal is generated on a HIGH to LOW transition of the selected input"]
            VALUE3,
            #[doc = "Clear signal is generated on both transitions of the selected input"]
            VALUE4,
        }
        impl C1ESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    C1ESW::VALUE1 => 0,
                    C1ESW::VALUE2 => 1,
                    C1ESW::VALUE3 => 2,
                    C1ESW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _C1ESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _C1ESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: C1ESW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Generation of the clear signal is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(C1ESW::VALUE1)
            }
            #[doc = "Clear signal is generated on a LOW to HIGH transition of the selected input"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(C1ESW::VALUE2)
            }
            #[doc = "Clear signal is generated on a HIGH to LOW transition of the selected input"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(C1ESW::VALUE3)
            }
            #[doc = "Clear signal is generated on both transitions of the selected input"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(C1ESW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Source selector 0 comparator set configuration"]
            #[inline]
            pub fn c0ss(&self) -> C0SSR {
                C0SSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 3:5 - Source selector 0 comparator clear configuration"]
            #[inline]
            pub fn c0cs(&self) -> C0CSR {
                C0CSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Source selector 0 set configuration"]
            #[inline]
            pub fn s0m(&self) -> S0MR {
                S0MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Source selector 0 clear configuration"]
            #[inline]
            pub fn c0m(&self) -> C0MR {
                C0MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Source selector 0 set edge configuration"]
            #[inline]
            pub fn s0es(&self) -> S0ESR {
                S0ESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Source selector 0 clear edge configuration"]
            #[inline]
            pub fn c0es(&self) -> C0ESR {
                C0ESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:18 - Source selector 1 comparator set configuration"]
            #[inline]
            pub fn c1ss(&self) -> C1SSR {
                C1SSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:21 - Source selector 1 comparator clear configuration"]
            #[inline]
            pub fn c1cs(&self) -> C1CSR {
                C1CSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Source selector 1 set configuration"]
            #[inline]
            pub fn s1m(&self) -> S1MR {
                S1MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Source selector 1 clear configuration"]
            #[inline]
            pub fn c1m(&self) -> C1MR {
                C1MR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 26:27 - Source selector 1 set edge configuration"]
            #[inline]
            pub fn s1es(&self) -> S1ESR {
                S1ESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:29 - Source selector 1 clear edge configuration"]
            #[inline]
            pub fn c1es(&self) -> C1ESR {
                C1ESR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Source selector 0 comparator set configuration"]
            #[inline]
            pub fn c0ss(&mut self) -> _C0SSW {
                _C0SSW { w: self }
            }
            #[doc = "Bits 3:5 - Source selector 0 comparator clear configuration"]
            #[inline]
            pub fn c0cs(&mut self) -> _C0CSW {
                _C0CSW { w: self }
            }
            #[doc = "Bits 6:7 - Source selector 0 set configuration"]
            #[inline]
            pub fn s0m(&mut self) -> _S0MW {
                _S0MW { w: self }
            }
            #[doc = "Bits 8:9 - Source selector 0 clear configuration"]
            #[inline]
            pub fn c0m(&mut self) -> _C0MW {
                _C0MW { w: self }
            }
            #[doc = "Bits 10:11 - Source selector 0 set edge configuration"]
            #[inline]
            pub fn s0es(&mut self) -> _S0ESW {
                _S0ESW { w: self }
            }
            #[doc = "Bits 12:13 - Source selector 0 clear edge configuration"]
            #[inline]
            pub fn c0es(&mut self) -> _C0ESW {
                _C0ESW { w: self }
            }
            #[doc = "Bits 16:18 - Source selector 1 comparator set configuration"]
            #[inline]
            pub fn c1ss(&mut self) -> _C1SSW {
                _C1SSW { w: self }
            }
            #[doc = "Bits 19:21 - Source selector 1 comparator clear configuration"]
            #[inline]
            pub fn c1cs(&mut self) -> _C1CSW {
                _C1CSW { w: self }
            }
            #[doc = "Bits 22:23 - Source selector 1 set configuration"]
            #[inline]
            pub fn s1m(&mut self) -> _S1MW {
                _S1MW { w: self }
            }
            #[doc = "Bits 24:25 - Source selector 1 clear configuration"]
            #[inline]
            pub fn c1m(&mut self) -> _C1MW {
                _C1MW { w: self }
            }
            #[doc = "Bits 26:27 - Source selector 1 set edge configuration"]
            #[inline]
            pub fn s1es(&mut self) -> _S1ESW {
                _S1ESW { w: self }
            }
            #[doc = "Bits 28:29 - Source selector 1 clear edge configuration"]
            #[inline]
            pub fn c1es(&mut self) -> _C1ESW {
                _C1ESW { w: self }
            }
        }
    }
    #[doc = "HRC timer selection"]
    pub struct TSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC timer selection"]
    pub mod tsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::TSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `TSEL0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSEL0R {
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 0 (CCST0 can be used)"]
            VALUE1,
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 1 (CCST1 can be used)"]
            VALUE2,
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 2 (CCST2 can be used)"]
            VALUE3,
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 3 (CCST3 can be used)"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TSEL0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TSEL0R::VALUE1 => 0,
                    TSEL0R::VALUE2 => 0x01,
                    TSEL0R::VALUE3 => 0x02,
                    TSEL0R::VALUE4 => 0x03,
                    TSEL0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TSEL0R {
                match value {
                    0 => TSEL0R::VALUE1,
                    1 => TSEL0R::VALUE2,
                    2 => TSEL0R::VALUE3,
                    3 => TSEL0R::VALUE4,
                    i => TSEL0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSEL0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSEL0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TSEL0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TSEL0R::VALUE4
            }
        }
        #[doc = "Possible values of the field `TSEL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TSEL1R {
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 0 (CCST0 can be used)"]
            VALUE1,
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 1 (CCST1 can be used)"]
            VALUE2,
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 2 (CCST2 can be used)"]
            VALUE3,
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 3 (CCST3 can be used)"]
            VALUE4,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl TSEL1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    TSEL1R::VALUE1 => 0,
                    TSEL1R::VALUE2 => 0x01,
                    TSEL1R::VALUE3 => 0x02,
                    TSEL1R::VALUE4 => 0x03,
                    TSEL1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> TSEL1R {
                match value {
                    0 => TSEL1R::VALUE1,
                    1 => TSEL1R::VALUE2,
                    2 => TSEL1R::VALUE3,
                    3 => TSEL1R::VALUE4,
                    i => TSEL1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TSEL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TSEL1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == TSEL1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == TSEL1R::VALUE4
            }
        }
        #[doc = "Possible values of the field `TS0E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TS0ER {
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 0 is disabled."]
            VALUE1,
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 0 is enabled."]
            VALUE2,
        }
        impl TS0ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TS0ER::VALUE1 => false,
                    TS0ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TS0ER {
                match value {
                    false => TS0ER::VALUE1,
                    true => TS0ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TS0ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TS0ER::VALUE2
            }
        }
        #[doc = "Possible values of the field `TS1E`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum TS1ER {
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 1 is disabled."]
            VALUE1,
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 1 is enabled."]
            VALUE2,
        }
        impl TS1ER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    TS1ER::VALUE1 => false,
                    TS1ER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> TS1ER {
                match value {
                    false => TS1ER::VALUE1,
                    true => TS1ER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == TS1ER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == TS1ER::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `TSEL0`"]
        pub enum TSEL0W {
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 0 (CCST0 can be used)"]
            VALUE1,
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 1 (CCST1 can be used)"]
            VALUE2,
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 2 (CCST2 can be used)"]
            VALUE3,
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 3 (CCST3 can be used)"]
            VALUE4,
        }
        impl TSEL0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TSEL0W::VALUE1 => 0,
                    TSEL0W::VALUE2 => 1,
                    TSEL0W::VALUE3 => 2,
                    TSEL0W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSEL0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSEL0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSEL0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 0 (CCST0 can be used)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSEL0W::VALUE1)
            }
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 1 (CCST1 can be used)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSEL0W::VALUE2)
            }
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 2 (CCST2 can be used)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TSEL0W::VALUE3)
            }
            #[doc = "Source Selector 0 is connected to Capture/Compare Unit Timer 3 (CCST3 can be used)"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TSEL0W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TSEL1`"]
        pub enum TSEL1W {
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 0 (CCST0 can be used)"]
            VALUE1,
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 1 (CCST1 can be used)"]
            VALUE2,
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 2 (CCST2 can be used)"]
            VALUE3,
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 3 (CCST3 can be used)"]
            VALUE4,
        }
        impl TSEL1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TSEL1W::VALUE1 => 0,
                    TSEL1W::VALUE2 => 1,
                    TSEL1W::VALUE3 => 2,
                    TSEL1W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TSEL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _TSEL1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TSEL1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 0 (CCST0 can be used)"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TSEL1W::VALUE1)
            }
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 1 (CCST1 can be used)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TSEL1W::VALUE2)
            }
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 2 (CCST2 can be used)"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(TSEL1W::VALUE3)
            }
            #[doc = "Source Selector 1 is connected to Capture/Compare Unit Timer 3 (CCST3 can be used)"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(TSEL1W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TS0E`"]
        pub enum TS0EW {
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 0 is disabled."]
            VALUE1,
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 0 is enabled."]
            VALUE2,
        }
        impl TS0EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TS0EW::VALUE1 => false,
                    TS0EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TS0EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TS0EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TS0EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 0 is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TS0EW::VALUE1)
            }
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 0 is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TS0EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `TS1E`"]
        pub enum TS1EW {
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 1 is disabled."]
            VALUE1,
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 1 is enabled."]
            VALUE2,
        }
        impl TS1EW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    TS1EW::VALUE1 => false,
                    TS1EW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _TS1EW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TS1EW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: TS1EW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 1 is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(TS1EW::VALUE1)
            }
            #[doc = "TRAP signal generated from the Timer connected to Source Selector 1 is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(TS1EW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Source Selector 0 Timer connection"]
            #[inline]
            pub fn tsel0(&self) -> TSEL0R {
                TSEL0R::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 3:5 - Source Selector 1 Timer connection"]
            #[inline]
            pub fn tsel1(&self) -> TSEL1R {
                TSEL1R::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Source selector 0 TRAP enable"]
            #[inline]
            pub fn ts0e(&self) -> TS0ER {
                TS0ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Source selector 1 TRAP enable"]
            #[inline]
            pub fn ts1e(&self) -> TS1ER {
                TS1ER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Source Selector 0 Timer connection"]
            #[inline]
            pub fn tsel0(&mut self) -> _TSEL0W {
                _TSEL0W { w: self }
            }
            #[doc = "Bits 3:5 - Source Selector 1 Timer connection"]
            #[inline]
            pub fn tsel1(&mut self) -> _TSEL1W {
                _TSEL1W { w: self }
            }
            #[doc = "Bit 16 - Source selector 0 TRAP enable"]
            #[inline]
            pub fn ts0e(&mut self) -> _TS0EW {
                _TS0EW { w: self }
            }
            #[doc = "Bit 17 - Source selector 1 TRAP enable"]
            #[inline]
            pub fn ts1e(&mut self) -> _TS1EW {
                _TS1EW { w: self }
            }
        }
    }
    #[doc = "HRC current source for shadow"]
    pub struct SC {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC current source for shadow"]
    pub mod sc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::SC {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `ST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum STR {
            #[doc = "Shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 0."]
            VALUE1,
            #[doc = "Shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 1."]
            VALUE2,
        }
        impl STR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    STR::VALUE1 => false,
                    STR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> STR {
                match value {
                    false => STR::VALUE1,
                    true => STR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == STR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == STR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source selector for the shadow transfer"]
            #[inline]
            pub fn st(&self) -> STR {
                STR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "HRC dead time rising value"]
    pub struct DCR {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC dead time rising value"]
    pub mod dcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DCR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DTRVR {
            bits: u16,
        }
        impl DTRVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Dead time rising value"]
            #[inline]
            pub fn dtrv(&self) -> DTRVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DTRVR { bits }
            }
        }
    }
    #[doc = "HRC dead time falling value"]
    pub struct DCF {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC dead time falling value"]
    pub mod dcf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::DCF {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct DTFVR {
            bits: u16,
        }
        impl DTFVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Dead time falling value"]
            #[inline]
            pub fn dtfv(&self) -> DTFVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DTFVR { bits }
            }
        }
    }
    #[doc = "HRC rising edge value"]
    pub struct CR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC rising edge value"]
    pub mod cr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CR1 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR1R {
            bits: u8,
        }
        impl CR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - High resolution rising edge value"]
            #[inline]
            pub fn cr1(&self) -> CR1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CR1R { bits }
            }
        }
    }
    #[doc = "HRC falling edge value"]
    pub struct CR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC falling edge value"]
    pub mod cr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::CR2 {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct CR2R {
            bits: u8,
        }
        impl CR2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - High resolution falling edge value"]
            #[inline]
            pub fn cr2(&self) -> CR2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CR2R { bits }
            }
        }
    }
    #[doc = "HRC next source for shadow"]
    pub struct SSC {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC next source for shadow"]
    pub mod ssc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SSC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `SST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SSTR {
            #[doc = "Next shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 0."]
            VALUE1,
            #[doc = "Next shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 1."]
            VALUE2,
        }
        impl SSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SSTR::VALUE1 => false,
                    SSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SSTR {
                match value {
                    false => SSTR::VALUE1,
                    true => SSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SSTR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `SST`"]
        pub enum SSTW {
            #[doc = "Next shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 0."]
            VALUE1,
            #[doc = "Next shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 1."]
            VALUE2,
        }
        impl SSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SSTW::VALUE1 => false,
                    SSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Next shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SSTW::VALUE1)
            }
            #[doc = "Next shadow transfer signals (shadow transfer trigger and shadow transfer enable) are linked with the timer CC8y connected to the Source Selector 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Source selector for the shadow transfer"]
            #[inline]
            pub fn sst(&self) -> SSTR {
                SSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Source selector for the shadow transfer"]
            #[inline]
            pub fn sst(&mut self) -> _SSTW {
                _SSTW { w: self }
            }
        }
    }
    #[doc = "HRC shadow dead time rising"]
    pub struct SDCR {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC shadow dead time rising"]
    pub mod sdcr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SDCR {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SDTRVR {
            bits: u16,
        }
        impl SDTRVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SDTRVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SDTRVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Shadow dead time rising value"]
            #[inline]
            pub fn sdtrv(&self) -> SDTRVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SDTRVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x01 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Shadow dead time rising value"]
            #[inline]
            pub fn sdtrv(&mut self) -> _SDTRVW {
                _SDTRVW { w: self }
            }
        }
    }
    #[doc = "HRC shadow dead time falling"]
    pub struct SDCF {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC shadow dead time falling"]
    pub mod sdcf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SDCF {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SDTFVR {
            bits: u16,
        }
        impl SDTFVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SDTFVW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SDTFVW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Shadow dead time falling value"]
            #[inline]
            pub fn sdtfv(&self) -> SDTFVR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SDTFVR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x01 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Shadow dead time falling value"]
            #[inline]
            pub fn sdtfv(&mut self) -> _SDTFVW {
                _SDTFVW { w: self }
            }
        }
    }
    #[doc = "HRC shadow rising edge value"]
    pub struct SCR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC shadow rising edge value"]
    pub mod scr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SCR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SCR1R {
            bits: u8,
        }
        impl SCR1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCR1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - High resolution falling edge value"]
            #[inline]
            pub fn scr1(&self) -> SCR1R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SCR1R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - High resolution falling edge value"]
            #[inline]
            pub fn scr1(&mut self) -> _SCR1W {
                _SCR1W { w: self }
            }
        }
    }
    #[doc = "HRC shadow falling edge value"]
    pub struct SCR2 {
        register: VolatileCell<u32>,
    }
    #[doc = "HRC shadow falling edge value"]
    pub mod scr2 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SCR2 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct SCR2R {
            bits: u8,
        }
        impl SCR2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCR2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0xff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - High resolution rising edge value"]
            #[inline]
            pub fn scr2(&self) -> SCR2R {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SCR2R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:7 - High resolution rising edge value"]
            #[inline]
            pub fn scr2(&mut self) -> _SCR2W {
                _SCR2W { w: self }
            }
        }
    }
}
#[doc = "High Resolution PWM Unit"]
pub struct HRPWM0_HRC0 {
    register_block: hrpwm0_hrc0::RegisterBlock,
}
impl Deref for HRPWM0_HRC0 {
    type Target = hrpwm0_hrc0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_hrc0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_HRC1: Peripheral<HRPWM0_HRC1> = unsafe { Peripheral::new(0x4002_1400) };
#[doc = r" Register block"]
pub struct HRPWM0_HRC1 {
    register_block: hrpwm0_hrc0::RegisterBlock,
}
impl Deref for HRPWM0_HRC1 {
    type Target = hrpwm0_hrc0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_hrc0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_HRC2: Peripheral<HRPWM0_HRC2> = unsafe { Peripheral::new(0x4002_1500) };
#[doc = r" Register block"]
pub struct HRPWM0_HRC2 {
    register_block: hrpwm0_hrc0::RegisterBlock,
}
impl Deref for HRPWM0_HRC2 {
    type Target = hrpwm0_hrc0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_hrc0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "High Resolution PWM Unit"]
pub const HRPWM0_HRC3: Peripheral<HRPWM0_HRC3> = unsafe { Peripheral::new(0x4002_1600) };
#[doc = r" Register block"]
pub struct HRPWM0_HRC3 {
    register_block: hrpwm0_hrc0::RegisterBlock,
}
impl Deref for HRPWM0_HRC3 {
    type Target = hrpwm0_hrc0::RegisterBlock;
    fn deref(&self) -> &hrpwm0_hrc0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Position Interface 0"]
pub const POSIF0: Peripheral<POSIF0> = unsafe { Peripheral::new(0x4002_8000) };
#[doc = "Position Interface 0"]
pub mod posif0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Service Request Processing configuration"]
        pub pconf: PCONF,
        #[doc = "0x04 - Service Request Processing Suspend Config"]
        pub psus: PSUS,
        #[doc = "0x08 - Service Request Processing Run Bit Set"]
        pub pruns: PRUNS,
        #[doc = "0x0c - Service Request Processing Run Bit Clear"]
        pub prunc: PRUNC,
        #[doc = "0x10 - Service Request Processing Run Bit Status"]
        pub prun: PRUN,
        _reserved0: [u8; 12usize],
        #[doc = "0x20 - Module Identification register"]
        pub midr: MIDR,
        _reserved1: [u8; 12usize],
        #[doc = "0x30 - Hall Sensor Patterns"]
        pub halp: HALP,
        #[doc = "0x34 - Hall Sensor Shadow Patterns"]
        pub halps: HALPS,
        _reserved2: [u8; 8usize],
        #[doc = "0x40 - Multi-Channel Pattern"]
        pub mcm: MCM,
        #[doc = "0x44 - Multi-Channel Shadow Pattern"]
        pub mcsm: MCSM,
        #[doc = "0x48 - Multi-Channel Pattern Control set"]
        pub mcms: MCMS,
        #[doc = "0x4c - Multi-Channel Pattern Control clear"]
        pub mcmc: MCMC,
        #[doc = "0x50 - Multi-Channel Pattern Control flag"]
        pub mcmf: MCMF,
        _reserved3: [u8; 12usize],
        #[doc = "0x60 - Quadrature Decoder Control"]
        pub qdc: QDC,
        _reserved4: [u8; 12usize],
        #[doc = "0x70 - Service Request Processing Interrupt Flags"]
        pub pflg: PFLG,
        #[doc = "0x74 - Service Request Processing Interrupt Enable"]
        pub pflge: PFLGE,
        #[doc = "0x78 - Service Request Processing Interrupt Set"]
        pub spflg: SPFLG,
        #[doc = "0x7c - Service Request Processing Interrupt Clear"]
        pub rpflg: RPFLG,
        _reserved5: [u8; 128usize],
        #[doc = "0x100 - POSIF Debug register"]
        pub pdbg: PDBG,
    }
    #[doc = "Service Request Processing configuration"]
    pub struct PCONF {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing configuration"]
    pub mod pconf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PCONF {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `FSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum FSELR {
            #[doc = "Hall Sensor Mode enabled"]
            VALUE1,
            #[doc = "Quadrature Decoder Mode enabled"]
            VALUE2,
            #[doc = "stand-alone Multi-Channel Mode enabled"]
            VALUE3,
            #[doc = "Quadrature Decoder and stand-alone Multi-Channel Mode enabled"]
            VALUE4,
        }
        impl FSELR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    FSELR::VALUE1 => 0,
                    FSELR::VALUE2 => 0x01,
                    FSELR::VALUE3 => 0x02,
                    FSELR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> FSELR {
                match value {
                    0 => FSELR::VALUE1,
                    1 => FSELR::VALUE2,
                    2 => FSELR::VALUE3,
                    3 => FSELR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == FSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == FSELR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == FSELR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == FSELR::VALUE4
            }
        }
        #[doc = "Possible values of the field `QDCM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum QDCMR {
            #[doc = "Position encoder is in Quadrature Mode"]
            VALUE1,
            #[doc = "Position encoder is in Direction Count Mode."]
            VALUE2,
        }
        impl QDCMR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    QDCMR::VALUE1 => false,
                    QDCMR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> QDCMR {
                match value {
                    false => QDCMR::VALUE1,
                    true => QDCMR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == QDCMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == QDCMR::VALUE2
            }
        }
        #[doc = r" Value of the field"]
        pub struct HIDGR {
            bits: bool,
        }
        impl HIDGR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = "Possible values of the field `MCUE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MCUER {
            #[doc = "Multi-Channel pattern update is controlled via HW"]
            VALUE1,
            #[doc = "Multi-Channel pattern update is controlled via SW"]
            VALUE2,
        }
        impl MCUER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MCUER::VALUE1 => false,
                    MCUER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MCUER {
                match value {
                    false => MCUER::VALUE1,
                    true => MCUER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MCUER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MCUER::VALUE2
            }
        }
        #[doc = "Possible values of the field `INSEL0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSEL0R {
            #[doc = "POSIFx.IN0A"]
            VALUE1,
            #[doc = "POSIFx.IN0B"]
            VALUE2,
            #[doc = "POSIFx.IN0C"]
            VALUE3,
            #[doc = "POSIFx.IN0D"]
            VALUE4,
        }
        impl INSEL0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    INSEL0R::VALUE1 => 0,
                    INSEL0R::VALUE2 => 0x01,
                    INSEL0R::VALUE3 => 0x02,
                    INSEL0R::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> INSEL0R {
                match value {
                    0 => INSEL0R::VALUE1,
                    1 => INSEL0R::VALUE2,
                    2 => INSEL0R::VALUE3,
                    3 => INSEL0R::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSEL0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSEL0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == INSEL0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == INSEL0R::VALUE4
            }
        }
        #[doc = "Possible values of the field `INSEL1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSEL1R {
            #[doc = "POSIFx.IN1A"]
            VALUE1,
            #[doc = "POSIFx.IN1B"]
            VALUE2,
            #[doc = "POSIFx.IN1C"]
            VALUE3,
            #[doc = "POSIFx.IN1D"]
            VALUE4,
        }
        impl INSEL1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    INSEL1R::VALUE1 => 0,
                    INSEL1R::VALUE2 => 0x01,
                    INSEL1R::VALUE3 => 0x02,
                    INSEL1R::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> INSEL1R {
                match value {
                    0 => INSEL1R::VALUE1,
                    1 => INSEL1R::VALUE2,
                    2 => INSEL1R::VALUE3,
                    3 => INSEL1R::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSEL1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSEL1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == INSEL1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == INSEL1R::VALUE4
            }
        }
        #[doc = "Possible values of the field `INSEL2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INSEL2R {
            #[doc = "POSIFx.IN2A"]
            VALUE1,
            #[doc = "POSIFx.IN2B"]
            VALUE2,
            #[doc = "POSIFx.IN2C"]
            VALUE3,
            #[doc = "POSIFx.IN2D"]
            VALUE4,
        }
        impl INSEL2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    INSEL2R::VALUE1 => 0,
                    INSEL2R::VALUE2 => 0x01,
                    INSEL2R::VALUE3 => 0x02,
                    INSEL2R::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> INSEL2R {
                match value {
                    0 => INSEL2R::VALUE1,
                    1 => INSEL2R::VALUE2,
                    2 => INSEL2R::VALUE3,
                    3 => INSEL2R::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INSEL2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INSEL2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == INSEL2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == INSEL2R::VALUE4
            }
        }
        #[doc = "Possible values of the field `DSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DSELR {
            #[doc = "POSIFx.HSDA"]
            VALUE1,
            #[doc = "POSIFx.HSDB"]
            VALUE2,
        }
        impl DSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DSELR::VALUE1 => false,
                    DSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DSELR {
                match value {
                    false => DSELR::VALUE1,
                    true => DSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `SPES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum SPESR {
            #[doc = "Rising edge"]
            VALUE1,
            #[doc = "Falling edge"]
            VALUE2,
        }
        impl SPESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    SPESR::VALUE1 => false,
                    SPESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> SPESR {
                match value {
                    false => SPESR::VALUE1,
                    true => SPESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == SPESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == SPESR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSETS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSETSR {
            #[doc = "POSIFx.MSETA"]
            VALUE1,
            #[doc = "POSIFx.MSETB"]
            VALUE2,
            #[doc = "POSIFx.MSETC"]
            VALUE3,
            #[doc = "POSIFx.MSETD"]
            VALUE4,
            #[doc = "POSIFx.MSETE"]
            VALUE5,
            #[doc = "POSIFx.MSETF"]
            VALUE6,
            #[doc = "POSIFx.MSETG"]
            VALUE7,
            #[doc = "POSIFx.MSETH"]
            VALUE8,
        }
        impl MSETSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MSETSR::VALUE1 => 0,
                    MSETSR::VALUE2 => 0x01,
                    MSETSR::VALUE3 => 0x02,
                    MSETSR::VALUE4 => 0x03,
                    MSETSR::VALUE5 => 0x04,
                    MSETSR::VALUE6 => 0x05,
                    MSETSR::VALUE7 => 0x06,
                    MSETSR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MSETSR {
                match value {
                    0 => MSETSR::VALUE1,
                    1 => MSETSR::VALUE2,
                    2 => MSETSR::VALUE3,
                    3 => MSETSR::VALUE4,
                    4 => MSETSR::VALUE5,
                    5 => MSETSR::VALUE6,
                    6 => MSETSR::VALUE7,
                    7 => MSETSR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSETSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSETSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MSETSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MSETSR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == MSETSR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == MSETSR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == MSETSR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == MSETSR::VALUE8
            }
        }
        #[doc = "Possible values of the field `MSES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSESR {
            #[doc = "The signal used to enable a pattern update is active on the rising edge"]
            VALUE1,
            #[doc = "The signal used to enable a pattern update is active on the falling edge"]
            VALUE2,
        }
        impl MSESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSESR::VALUE1 => false,
                    MSESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSESR {
                match value {
                    false => MSESR::VALUE1,
                    true => MSESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSESR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSYNS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSYNSR {
            #[doc = "POSIFx.MSYNCA"]
            VALUE1,
            #[doc = "POSIFx.MSYNCB"]
            VALUE2,
            #[doc = "POSIFx.MSYNCC"]
            VALUE3,
            #[doc = "POSIFx.MSYNCD"]
            VALUE4,
        }
        impl MSYNSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MSYNSR::VALUE1 => 0,
                    MSYNSR::VALUE2 => 0x01,
                    MSYNSR::VALUE3 => 0x02,
                    MSYNSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MSYNSR {
                match value {
                    0 => MSYNSR::VALUE1,
                    1 => MSYNSR::VALUE2,
                    2 => MSYNSR::VALUE3,
                    3 => MSYNSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSYNSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSYNSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MSYNSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MSYNSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EWIS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EWISR {
            #[doc = "POSIFx.EWHEA"]
            VALUE1,
            #[doc = "POSIFx.EWHEB"]
            VALUE2,
            #[doc = "POSIFx.EWHEC"]
            VALUE3,
            #[doc = "POSIFx.EWHED"]
            VALUE4,
        }
        impl EWISR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    EWISR::VALUE1 => 0,
                    EWISR::VALUE2 => 0x01,
                    EWISR::VALUE3 => 0x02,
                    EWISR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> EWISR {
                match value {
                    0 => EWISR::VALUE1,
                    1 => EWISR::VALUE2,
                    2 => EWISR::VALUE3,
                    3 => EWISR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EWISR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EWISR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == EWISR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == EWISR::VALUE4
            }
        }
        #[doc = "Possible values of the field `EWIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EWIER {
            #[doc = "External wrong hall event emulation signal, POSIFx.EWHE[D...A], is disabled"]
            VALUE1,
            #[doc = "External wrong hall event emulation signal, POSIFx.EWHE[D...A], is enabled."]
            VALUE2,
        }
        impl EWIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EWIER::VALUE1 => false,
                    EWIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EWIER {
                match value {
                    false => EWIER::VALUE1,
                    true => EWIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EWIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EWIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `EWIL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EWILR {
            #[doc = "POSIFx.EWHE[D...A] signal is active HIGH"]
            VALUE1,
            #[doc = "POSIFx.EWHE[D...A] signal is active LOW"]
            VALUE2,
        }
        impl EWILR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EWILR::VALUE1 => false,
                    EWILR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EWILR {
                match value {
                    false => EWILR::VALUE1,
                    true => EWILR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EWILR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EWILR::VALUE2
            }
        }
        #[doc = "Possible values of the field `LPC`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum LPCR {
            #[doc = "Low pass filter disabled"]
            VALUE1,
            #[doc = "Low pass of 1 clock cycle"]
            VALUE2,
            #[doc = "Low pass of 2 clock cycles"]
            VALUE3,
            #[doc = "Low pass of 4 clock cycles"]
            VALUE4,
            #[doc = "Low pass of 8 clock cycles"]
            VALUE5,
            #[doc = "Low pass of 16 clock cycles"]
            VALUE6,
            #[doc = "Low pass of 32 clock cycles"]
            VALUE7,
            #[doc = "Low pass of 64 clock cycles"]
            VALUE8,
        }
        impl LPCR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    LPCR::VALUE1 => 0,
                    LPCR::VALUE2 => 0x01,
                    LPCR::VALUE3 => 0x02,
                    LPCR::VALUE4 => 0x03,
                    LPCR::VALUE5 => 0x04,
                    LPCR::VALUE6 => 0x05,
                    LPCR::VALUE7 => 0x06,
                    LPCR::VALUE8 => 0x07,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> LPCR {
                match value {
                    0 => LPCR::VALUE1,
                    1 => LPCR::VALUE2,
                    2 => LPCR::VALUE3,
                    3 => LPCR::VALUE4,
                    4 => LPCR::VALUE5,
                    5 => LPCR::VALUE6,
                    6 => LPCR::VALUE7,
                    7 => LPCR::VALUE8,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == LPCR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == LPCR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == LPCR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == LPCR::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == LPCR::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == LPCR::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == LPCR::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == LPCR::VALUE8
            }
        }
        #[doc = "Values that can be written to the field `FSEL`"]
        pub enum FSELW {
            #[doc = "Hall Sensor Mode enabled"]
            VALUE1,
            #[doc = "Quadrature Decoder Mode enabled"]
            VALUE2,
            #[doc = "stand-alone Multi-Channel Mode enabled"]
            VALUE3,
            #[doc = "Quadrature Decoder and stand-alone Multi-Channel Mode enabled"]
            VALUE4,
        }
        impl FSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FSELW::VALUE1 => 0,
                    FSELW::VALUE2 => 1,
                    FSELW::VALUE3 => 2,
                    FSELW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _FSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: FSELW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Hall Sensor Mode enabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(FSELW::VALUE1)
            }
            #[doc = "Quadrature Decoder Mode enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(FSELW::VALUE2)
            }
            #[doc = "stand-alone Multi-Channel Mode enabled"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(FSELW::VALUE3)
            }
            #[doc = "Quadrature Decoder and stand-alone Multi-Channel Mode enabled"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(FSELW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `QDCM`"]
        pub enum QDCMW {
            #[doc = "Position encoder is in Quadrature Mode"]
            VALUE1,
            #[doc = "Position encoder is in Direction Count Mode."]
            VALUE2,
        }
        impl QDCMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    QDCMW::VALUE1 => false,
                    QDCMW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _QDCMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QDCMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: QDCMW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Position encoder is in Quadrature Mode"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(QDCMW::VALUE1)
            }
            #[doc = "Position encoder is in Direction Count Mode."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(QDCMW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIDGW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIDGW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MCUE`"]
        pub enum MCUEW {
            #[doc = "Multi-Channel pattern update is controlled via HW"]
            VALUE1,
            #[doc = "Multi-Channel pattern update is controlled via SW"]
            VALUE2,
        }
        impl MCUEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MCUEW::VALUE1 => false,
                    MCUEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCUEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCUEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MCUEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Multi-Channel pattern update is controlled via HW"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MCUEW::VALUE1)
            }
            #[doc = "Multi-Channel pattern update is controlled via SW"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MCUEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSEL0`"]
        pub enum INSEL0W {
            #[doc = "POSIFx.IN0A"]
            VALUE1,
            #[doc = "POSIFx.IN0B"]
            VALUE2,
            #[doc = "POSIFx.IN0C"]
            VALUE3,
            #[doc = "POSIFx.IN0D"]
            VALUE4,
        }
        impl INSEL0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    INSEL0W::VALUE1 => 0,
                    INSEL0W::VALUE2 => 1,
                    INSEL0W::VALUE3 => 2,
                    INSEL0W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSEL0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSEL0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSEL0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "POSIFx.IN0A"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSEL0W::VALUE1)
            }
            #[doc = "POSIFx.IN0B"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSEL0W::VALUE2)
            }
            #[doc = "POSIFx.IN0C"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(INSEL0W::VALUE3)
            }
            #[doc = "POSIFx.IN0D"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(INSEL0W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSEL1`"]
        pub enum INSEL1W {
            #[doc = "POSIFx.IN1A"]
            VALUE1,
            #[doc = "POSIFx.IN1B"]
            VALUE2,
            #[doc = "POSIFx.IN1C"]
            VALUE3,
            #[doc = "POSIFx.IN1D"]
            VALUE4,
        }
        impl INSEL1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    INSEL1W::VALUE1 => 0,
                    INSEL1W::VALUE2 => 1,
                    INSEL1W::VALUE3 => 2,
                    INSEL1W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSEL1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSEL1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSEL1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "POSIFx.IN1A"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSEL1W::VALUE1)
            }
            #[doc = "POSIFx.IN1B"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSEL1W::VALUE2)
            }
            #[doc = "POSIFx.IN1C"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(INSEL1W::VALUE3)
            }
            #[doc = "POSIFx.IN1D"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(INSEL1W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INSEL2`"]
        pub enum INSEL2W {
            #[doc = "POSIFx.IN2A"]
            VALUE1,
            #[doc = "POSIFx.IN2B"]
            VALUE2,
            #[doc = "POSIFx.IN2C"]
            VALUE3,
            #[doc = "POSIFx.IN2D"]
            VALUE4,
        }
        impl INSEL2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    INSEL2W::VALUE1 => 0,
                    INSEL2W::VALUE2 => 1,
                    INSEL2W::VALUE3 => 2,
                    INSEL2W::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INSEL2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _INSEL2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INSEL2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "POSIFx.IN2A"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INSEL2W::VALUE1)
            }
            #[doc = "POSIFx.IN2B"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INSEL2W::VALUE2)
            }
            #[doc = "POSIFx.IN2C"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(INSEL2W::VALUE3)
            }
            #[doc = "POSIFx.IN2D"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(INSEL2W::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DSEL`"]
        pub enum DSELW {
            #[doc = "POSIFx.HSDA"]
            VALUE1,
            #[doc = "POSIFx.HSDB"]
            VALUE2,
        }
        impl DSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DSELW::VALUE1 => false,
                    DSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "POSIFx.HSDA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DSELW::VALUE1)
            }
            #[doc = "POSIFx.HSDB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `SPES`"]
        pub enum SPESW {
            #[doc = "Rising edge"]
            VALUE1,
            #[doc = "Falling edge"]
            VALUE2,
        }
        impl SPESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    SPESW::VALUE1 => false,
                    SPESW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: SPESW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Rising edge"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(SPESW::VALUE1)
            }
            #[doc = "Falling edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(SPESW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSETS`"]
        pub enum MSETSW {
            #[doc = "POSIFx.MSETA"]
            VALUE1,
            #[doc = "POSIFx.MSETB"]
            VALUE2,
            #[doc = "POSIFx.MSETC"]
            VALUE3,
            #[doc = "POSIFx.MSETD"]
            VALUE4,
            #[doc = "POSIFx.MSETE"]
            VALUE5,
            #[doc = "POSIFx.MSETF"]
            VALUE6,
            #[doc = "POSIFx.MSETG"]
            VALUE7,
            #[doc = "POSIFx.MSETH"]
            VALUE8,
        }
        impl MSETSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MSETSW::VALUE1 => 0,
                    MSETSW::VALUE2 => 1,
                    MSETSW::VALUE3 => 2,
                    MSETSW::VALUE4 => 3,
                    MSETSW::VALUE5 => 4,
                    MSETSW::VALUE6 => 5,
                    MSETSW::VALUE7 => 6,
                    MSETSW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSETSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSETSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSETSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "POSIFx.MSETA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSETSW::VALUE1)
            }
            #[doc = "POSIFx.MSETB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSETSW::VALUE2)
            }
            #[doc = "POSIFx.MSETC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MSETSW::VALUE3)
            }
            #[doc = "POSIFx.MSETD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MSETSW::VALUE4)
            }
            #[doc = "POSIFx.MSETE"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(MSETSW::VALUE5)
            }
            #[doc = "POSIFx.MSETF"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(MSETSW::VALUE6)
            }
            #[doc = "POSIFx.MSETG"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(MSETSW::VALUE7)
            }
            #[doc = "POSIFx.MSETH"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(MSETSW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSES`"]
        pub enum MSESW {
            #[doc = "The signal used to enable a pattern update is active on the rising edge"]
            VALUE1,
            #[doc = "The signal used to enable a pattern update is active on the falling edge"]
            VALUE2,
        }
        impl MSESW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSESW::VALUE1 => false,
                    MSESW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSESW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSESW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSESW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The signal used to enable a pattern update is active on the rising edge"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSESW::VALUE1)
            }
            #[doc = "The signal used to enable a pattern update is active on the falling edge"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSESW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSYNS`"]
        pub enum MSYNSW {
            #[doc = "POSIFx.MSYNCA"]
            VALUE1,
            #[doc = "POSIFx.MSYNCB"]
            VALUE2,
            #[doc = "POSIFx.MSYNCC"]
            VALUE3,
            #[doc = "POSIFx.MSYNCD"]
            VALUE4,
        }
        impl MSYNSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MSYNSW::VALUE1 => 0,
                    MSYNSW::VALUE2 => 1,
                    MSYNSW::VALUE3 => 2,
                    MSYNSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSYNSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSYNSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSYNSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "POSIFx.MSYNCA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSYNSW::VALUE1)
            }
            #[doc = "POSIFx.MSYNCB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSYNSW::VALUE2)
            }
            #[doc = "POSIFx.MSYNCC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MSYNSW::VALUE3)
            }
            #[doc = "POSIFx.MSYNCD"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MSYNSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EWIS`"]
        pub enum EWISW {
            #[doc = "POSIFx.EWHEA"]
            VALUE1,
            #[doc = "POSIFx.EWHEB"]
            VALUE2,
            #[doc = "POSIFx.EWHEC"]
            VALUE3,
            #[doc = "POSIFx.EWHED"]
            VALUE4,
        }
        impl EWISW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EWISW::VALUE1 => 0,
                    EWISW::VALUE2 => 1,
                    EWISW::VALUE3 => 2,
                    EWISW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EWISW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EWISW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EWISW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "POSIFx.EWHEA"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EWISW::VALUE1)
            }
            #[doc = "POSIFx.EWHEB"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EWISW::VALUE2)
            }
            #[doc = "POSIFx.EWHEC"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(EWISW::VALUE3)
            }
            #[doc = "POSIFx.EWHED"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(EWISW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EWIE`"]
        pub enum EWIEW {
            #[doc = "External wrong hall event emulation signal, POSIFx.EWHE[D...A], is disabled"]
            VALUE1,
            #[doc = "External wrong hall event emulation signal, POSIFx.EWHE[D...A], is enabled."]
            VALUE2,
        }
        impl EWIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EWIEW::VALUE1 => false,
                    EWIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EWIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EWIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EWIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "External wrong hall event emulation signal, POSIFx.EWHE[D...A], is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EWIEW::VALUE1)
            }
            #[doc = "External wrong hall event emulation signal, POSIFx.EWHE[D...A], is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EWIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EWIL`"]
        pub enum EWILW {
            #[doc = "POSIFx.EWHE[D...A] signal is active HIGH"]
            VALUE1,
            #[doc = "POSIFx.EWHE[D...A] signal is active LOW"]
            VALUE2,
        }
        impl EWILW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EWILW::VALUE1 => false,
                    EWILW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EWILW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EWILW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EWILW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "POSIFx.EWHE[D...A] signal is active HIGH"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EWILW::VALUE1)
            }
            #[doc = "POSIFx.EWHE[D...A] signal is active LOW"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EWILW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `LPC`"]
        pub enum LPCW {
            #[doc = "Low pass filter disabled"]
            VALUE1,
            #[doc = "Low pass of 1 clock cycle"]
            VALUE2,
            #[doc = "Low pass of 2 clock cycles"]
            VALUE3,
            #[doc = "Low pass of 4 clock cycles"]
            VALUE4,
            #[doc = "Low pass of 8 clock cycles"]
            VALUE5,
            #[doc = "Low pass of 16 clock cycles"]
            VALUE6,
            #[doc = "Low pass of 32 clock cycles"]
            VALUE7,
            #[doc = "Low pass of 64 clock cycles"]
            VALUE8,
        }
        impl LPCW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LPCW::VALUE1 => 0,
                    LPCW::VALUE2 => 1,
                    LPCW::VALUE3 => 2,
                    LPCW::VALUE4 => 3,
                    LPCW::VALUE5 => 4,
                    LPCW::VALUE6 => 5,
                    LPCW::VALUE7 => 6,
                    LPCW::VALUE8 => 7,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _LPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LPCW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: LPCW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Low pass filter disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(LPCW::VALUE1)
            }
            #[doc = "Low pass of 1 clock cycle"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(LPCW::VALUE2)
            }
            #[doc = "Low pass of 2 clock cycles"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(LPCW::VALUE3)
            }
            #[doc = "Low pass of 4 clock cycles"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(LPCW::VALUE4)
            }
            #[doc = "Low pass of 8 clock cycles"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(LPCW::VALUE5)
            }
            #[doc = "Low pass of 16 clock cycles"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(LPCW::VALUE6)
            }
            #[doc = "Low pass of 32 clock cycles"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(LPCW::VALUE7)
            }
            #[doc = "Low pass of 64 clock cycles"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(LPCW::VALUE8)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Function Selector"]
            #[inline]
            pub fn fsel(&self) -> FSELR {
                FSELR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 2 - Position Decoder Mode selection"]
            #[inline]
            pub fn qdcm(&self) -> QDCMR {
                QDCMR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Idle generation enable"]
            #[inline]
            pub fn hidg(&self) -> HIDGR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                HIDGR { bits }
            }
            #[doc = "Bit 5 - Multi-Channel Pattern SW update enable"]
            #[inline]
            pub fn mcue(&self) -> MCUER {
                MCUER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 8:9 - PhaseA/Hal input 1 selector"]
            #[inline]
            pub fn insel0(&self) -> INSEL0R {
                INSEL0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - PhaseB/Hall input 2 selector"]
            #[inline]
            pub fn insel1(&self) -> INSEL1R {
                INSEL1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Index/Hall input 3 selector"]
            #[inline]
            pub fn insel2(&self) -> INSEL2R {
                INSEL2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 16 - Delay Pin selector"]
            #[inline]
            pub fn dsel(&self) -> DSELR {
                DSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Edge selector for the sampling trigger"]
            #[inline]
            pub fn spes(&self) -> SPESR {
                SPESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 18:20 - Pattern update signal select"]
            #[inline]
            pub fn msets(&self) -> MSETSR {
                MSETSR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 21 - Multi-Channel pattern update trigger edge"]
            #[inline]
            pub fn mses(&self) -> MSESR {
                MSESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 22:23 - PWM synchronization signal selector"]
            #[inline]
            pub fn msyns(&self) -> MSYNSR {
                MSYNSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Wrong Hall Event selection"]
            #[inline]
            pub fn ewis(&self) -> EWISR {
                EWISR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 26 - External Wrong Hall Event enable"]
            #[inline]
            pub fn ewie(&self) -> EWIER {
                EWIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - External Wrong Hall Event active level"]
            #[inline]
            pub fn ewil(&self) -> EWILR {
                EWILR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 28:30 - Low Pass Filters Configuration"]
            #[inline]
            pub fn lpc(&self) -> LPCR {
                LPCR::_from({
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Function Selector"]
            #[inline]
            pub fn fsel(&mut self) -> _FSELW {
                _FSELW { w: self }
            }
            #[doc = "Bit 2 - Position Decoder Mode selection"]
            #[inline]
            pub fn qdcm(&mut self) -> _QDCMW {
                _QDCMW { w: self }
            }
            #[doc = "Bit 4 - Idle generation enable"]
            #[inline]
            pub fn hidg(&mut self) -> _HIDGW {
                _HIDGW { w: self }
            }
            #[doc = "Bit 5 - Multi-Channel Pattern SW update enable"]
            #[inline]
            pub fn mcue(&mut self) -> _MCUEW {
                _MCUEW { w: self }
            }
            #[doc = "Bits 8:9 - PhaseA/Hal input 1 selector"]
            #[inline]
            pub fn insel0(&mut self) -> _INSEL0W {
                _INSEL0W { w: self }
            }
            #[doc = "Bits 10:11 - PhaseB/Hall input 2 selector"]
            #[inline]
            pub fn insel1(&mut self) -> _INSEL1W {
                _INSEL1W { w: self }
            }
            #[doc = "Bits 12:13 - Index/Hall input 3 selector"]
            #[inline]
            pub fn insel2(&mut self) -> _INSEL2W {
                _INSEL2W { w: self }
            }
            #[doc = "Bit 16 - Delay Pin selector"]
            #[inline]
            pub fn dsel(&mut self) -> _DSELW {
                _DSELW { w: self }
            }
            #[doc = "Bit 17 - Edge selector for the sampling trigger"]
            #[inline]
            pub fn spes(&mut self) -> _SPESW {
                _SPESW { w: self }
            }
            #[doc = "Bits 18:20 - Pattern update signal select"]
            #[inline]
            pub fn msets(&mut self) -> _MSETSW {
                _MSETSW { w: self }
            }
            #[doc = "Bit 21 - Multi-Channel pattern update trigger edge"]
            #[inline]
            pub fn mses(&mut self) -> _MSESW {
                _MSESW { w: self }
            }
            #[doc = "Bits 22:23 - PWM synchronization signal selector"]
            #[inline]
            pub fn msyns(&mut self) -> _MSYNSW {
                _MSYNSW { w: self }
            }
            #[doc = "Bits 24:25 - Wrong Hall Event selection"]
            #[inline]
            pub fn ewis(&mut self) -> _EWISW {
                _EWISW { w: self }
            }
            #[doc = "Bit 26 - External Wrong Hall Event enable"]
            #[inline]
            pub fn ewie(&mut self) -> _EWIEW {
                _EWIEW { w: self }
            }
            #[doc = "Bit 27 - External Wrong Hall Event active level"]
            #[inline]
            pub fn ewil(&mut self) -> _EWILW {
                _EWILW { w: self }
            }
            #[doc = "Bits 28:30 - Low Pass Filters Configuration"]
            #[inline]
            pub fn lpc(&mut self) -> _LPCW {
                _LPCW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Suspend Config"]
    pub struct PSUS {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Suspend Config"]
    pub mod psus {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PSUS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `QSUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum QSUSR {
            #[doc = "Suspend request ignored"]
            VALUE1,
            #[doc = "Stop immediately"]
            VALUE2,
            #[doc = "Suspend in the next index occurrence"]
            VALUE3,
            #[doc = "Suspend in the next phase (PhaseA or PhaseB) occurrence"]
            VALUE4,
        }
        impl QSUSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    QSUSR::VALUE1 => 0,
                    QSUSR::VALUE2 => 0x01,
                    QSUSR::VALUE3 => 0x02,
                    QSUSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> QSUSR {
                match value {
                    0 => QSUSR::VALUE1,
                    1 => QSUSR::VALUE2,
                    2 => QSUSR::VALUE3,
                    3 => QSUSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == QSUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == QSUSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == QSUSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == QSUSR::VALUE4
            }
        }
        #[doc = "Possible values of the field `MSUS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSUSR {
            #[doc = "Suspend request ignored"]
            VALUE1,
            #[doc = "Stop immediately. Multi-Channel pattern is not set to the reset value."]
            VALUE2,
            #[doc = "Stop immediately. Multi-Channel pattern is set to the reset value."]
            VALUE3,
            #[doc = "Suspend with the synchronization of the PWM signal. Multi-Channel pattern is set to the reset value at the same time of the synchronization."]
            VALUE4,
        }
        impl MSUSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    MSUSR::VALUE1 => 0,
                    MSUSR::VALUE2 => 0x01,
                    MSUSR::VALUE3 => 0x02,
                    MSUSR::VALUE4 => 0x03,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> MSUSR {
                match value {
                    0 => MSUSR::VALUE1,
                    1 => MSUSR::VALUE2,
                    2 => MSUSR::VALUE3,
                    3 => MSUSR::VALUE4,
                    _ => unreachable!(),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSUSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSUSR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == MSUSR::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == MSUSR::VALUE4
            }
        }
        #[doc = "Values that can be written to the field `QSUS`"]
        pub enum QSUSW {
            #[doc = "Suspend request ignored"]
            VALUE1,
            #[doc = "Stop immediately"]
            VALUE2,
            #[doc = "Suspend in the next index occurrence"]
            VALUE3,
            #[doc = "Suspend in the next phase (PhaseA or PhaseB) occurrence"]
            VALUE4,
        }
        impl QSUSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QSUSW::VALUE1 => 0,
                    QSUSW::VALUE2 => 1,
                    QSUSW::VALUE3 => 2,
                    QSUSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _QSUSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QSUSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: QSUSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Suspend request ignored"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(QSUSW::VALUE1)
            }
            #[doc = "Stop immediately"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(QSUSW::VALUE2)
            }
            #[doc = "Suspend in the next index occurrence"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(QSUSW::VALUE3)
            }
            #[doc = "Suspend in the next phase (PhaseA or PhaseB) occurrence"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(QSUSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSUS`"]
        pub enum MSUSW {
            #[doc = "Suspend request ignored"]
            VALUE1,
            #[doc = "Stop immediately. Multi-Channel pattern is not set to the reset value."]
            VALUE2,
            #[doc = "Stop immediately. Multi-Channel pattern is set to the reset value."]
            VALUE3,
            #[doc = "Suspend with the synchronization of the PWM signal. Multi-Channel pattern is set to the reset value at the same time of the synchronization."]
            VALUE4,
        }
        impl MSUSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MSUSW::VALUE1 => 0,
                    MSUSW::VALUE2 => 1,
                    MSUSW::VALUE3 => 2,
                    MSUSW::VALUE4 => 3,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSUSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSUSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSUSW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            #[doc = "Suspend request ignored"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSUSW::VALUE1)
            }
            #[doc = "Stop immediately. Multi-Channel pattern is not set to the reset value."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSUSW::VALUE2)
            }
            #[doc = "Stop immediately. Multi-Channel pattern is set to the reset value."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(MSUSW::VALUE3)
            }
            #[doc = "Suspend with the synchronization of the PWM signal. Multi-Channel pattern is set to the reset value at the same time of the synchronization."]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(MSUSW::VALUE4)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Quadrature Mode Suspend Config"]
            #[inline]
            pub fn qsus(&self) -> QSUSR {
                QSUSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Multi-Channel Mode Suspend Config"]
            #[inline]
            pub fn msus(&self) -> MSUSR {
                MSUSR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Quadrature Mode Suspend Config"]
            #[inline]
            pub fn qsus(&mut self) -> _QSUSW {
                _QSUSW { w: self }
            }
            #[doc = "Bits 2:3 - Multi-Channel Mode Suspend Config"]
            #[inline]
            pub fn msus(&mut self) -> _MSUSW {
                _MSUSW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Run Bit Set"]
    pub struct PRUNS {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Run Bit Set"]
    pub mod pruns {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRUNS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SRBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Set Run bit"]
            #[inline]
            pub fn srb(&mut self) -> _SRBW {
                _SRBW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Run Bit Clear"]
    pub struct PRUNC {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Run Bit Clear"]
    pub mod prunc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PRUNC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _CRBW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CRBW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _CSMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CSMW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Clear Run bit"]
            #[inline]
            pub fn crb(&mut self) -> _CRBW {
                _CRBW { w: self }
            }
            #[doc = "Bit 1 - Clear Current internal status"]
            #[inline]
            pub fn csm(&mut self) -> _CSMW {
                _CSMW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Run Bit Status"]
    pub struct PRUN {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Run Bit Status"]
    pub mod prun {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PRUN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `RB`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum RBR {
            #[doc = "IDLE"]
            VALUE1,
            #[doc = "Running"]
            VALUE2,
        }
        impl RBR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    RBR::VALUE1 => false,
                    RBR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> RBR {
                match value {
                    false => RBR::VALUE1,
                    true => RBR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == RBR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == RBR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Run Bit"]
            #[inline]
            pub fn rb(&self) -> RBR {
                RBR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Module Identification register"]
    pub struct MIDR {
        register: VolatileCell<u32>,
    }
    #[doc = "Module Identification register"]
    pub mod midr {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MIDR {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODRR {
            bits: u8,
        }
        impl MODRR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODTR {
            bits: u8,
        }
        impl MODTR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct MODNR {
            bits: u16,
        }
        impl MODNR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:7 - Module Revision"]
            #[inline]
            pub fn modr(&self) -> MODRR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODRR { bits }
            }
            #[doc = "Bits 8:15 - Module Type"]
            #[inline]
            pub fn modt(&self) -> MODTR {
                let bits = {
                    const MASK: u8 = 0xff;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MODTR { bits }
            }
            #[doc = "Bits 16:31 - Module Number"]
            #[inline]
            pub fn modn(&self) -> MODNR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MODNR { bits }
            }
        }
    }
    #[doc = "Hall Sensor Patterns"]
    pub struct HALP {
        register: VolatileCell<u32>,
    }
    #[doc = "Hall Sensor Patterns"]
    pub mod halp {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::HALP {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct HCPR {
            bits: u8,
        }
        impl HCPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct HEPR {
            bits: u8,
        }
        impl HEPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Hall Current Pattern"]
            #[inline]
            pub fn hcp(&self) -> HCPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HCPR { bits }
            }
            #[doc = "Bits 3:5 - Hall Expected Pattern"]
            #[inline]
            pub fn hep(&self) -> HEPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HEPR { bits }
            }
        }
    }
    #[doc = "Hall Sensor Shadow Patterns"]
    pub struct HALPS {
        register: VolatileCell<u32>,
    }
    #[doc = "Hall Sensor Shadow Patterns"]
    pub mod halps {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HALPS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct HCPSR {
            bits: u8,
        }
        impl HCPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct HEPSR {
            bits: u8,
        }
        impl HEPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _HCPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HCPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _HEPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HEPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Shadow Hall Current Pattern"]
            #[inline]
            pub fn hcps(&self) -> HCPSR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HCPSR { bits }
            }
            #[doc = "Bits 3:5 - Shadow Hall expected Pattern"]
            #[inline]
            pub fn heps(&self) -> HEPSR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HEPSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Shadow Hall Current Pattern"]
            #[inline]
            pub fn hcps(&mut self) -> _HCPSW {
                _HCPSW { w: self }
            }
            #[doc = "Bits 3:5 - Shadow Hall expected Pattern"]
            #[inline]
            pub fn heps(&mut self) -> _HEPSW {
                _HEPSW { w: self }
            }
        }
    }
    #[doc = "Multi-Channel Pattern"]
    pub struct MCM {
        register: VolatileCell<u32>,
    }
    #[doc = "Multi-Channel Pattern"]
    pub mod mcm {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MCM {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct MCMPR {
            bits: u16,
        }
        impl MCMPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Multi-Channel Pattern"]
            #[inline]
            pub fn mcmp(&self) -> MCMPR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MCMPR { bits }
            }
        }
    }
    #[doc = "Multi-Channel Shadow Pattern"]
    pub struct MCSM {
        register: VolatileCell<u32>,
    }
    #[doc = "Multi-Channel Shadow Pattern"]
    pub mod mcsm {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MCSM {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct MCMPSR {
            bits: u16,
        }
        impl MCMPSR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _MCMPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCMPSW<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u16) -> &'a mut W {
                const MASK: u16 = 0xffff;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:15 - Shadow Multi-Channel Pattern"]
            #[inline]
            pub fn mcmps(&self) -> MCMPSR {
                let bits = {
                    const MASK: u16 = 0xffff;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MCMPSR { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:15 - Shadow Multi-Channel Pattern"]
            #[inline]
            pub fn mcmps(&mut self) -> _MCMPSW {
                _MCMPSW { w: self }
            }
        }
    }
    #[doc = "Multi-Channel Pattern Control set"]
    pub struct MCMS {
        register: VolatileCell<u32>,
    }
    #[doc = "Multi-Channel Pattern Control set"]
    pub mod mcms {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MCMS {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _MNPSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MNPSW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STHRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STHRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _STMRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _STMRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Multi-Channel Pattern Update Enable Set"]
            #[inline]
            pub fn mnps(&mut self) -> _MNPSW {
                _MNPSW { w: self }
            }
            #[doc = "Bit 1 - Hall Pattern Shadow Transfer Request"]
            #[inline]
            pub fn sthr(&mut self) -> _STHRW {
                _STHRW { w: self }
            }
            #[doc = "Bit 2 - Multi-Channel Shadow Transfer Request"]
            #[inline]
            pub fn stmr(&mut self) -> _STMRW {
                _STMRW { w: self }
            }
        }
    }
    #[doc = "Multi-Channel Pattern Control clear"]
    pub struct MCMC {
        register: VolatileCell<u32>,
    }
    #[doc = "Multi-Channel Pattern Control clear"]
    pub mod mcmc {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::MCMC {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _MNPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MNPCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _MPCW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MPCW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Multi-Channel Pattern Update Enable Clear"]
            #[inline]
            pub fn mnpc(&mut self) -> _MNPCW {
                _MNPCW { w: self }
            }
            #[doc = "Bit 1 - Multi-Channel Pattern clear"]
            #[inline]
            pub fn mpc(&mut self) -> _MPCW {
                _MPCW { w: self }
            }
        }
    }
    #[doc = "Multi-Channel Pattern Control flag"]
    pub struct MCMF {
        register: VolatileCell<u32>,
    }
    #[doc = "Multi-Channel Pattern Control flag"]
    pub mod mcmf {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::MCMF {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `MSS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSSR {
            #[doc = "Update of the Multi-Channel pattern is set"]
            VALUE1,
            #[doc = "Update of the Multi-Channel pattern is not set"]
            VALUE2,
        }
        impl MSSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSSR::VALUE1 => false,
                    MSSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSSR {
                match value {
                    false => MSSR::VALUE1,
                    true => MSSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSSR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Multi-Channel Pattern update status"]
            #[inline]
            pub fn mss(&self) -> MSSR {
                MSSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Quadrature Decoder Control"]
    pub struct QDC {
        register: VolatileCell<u32>,
    }
    #[doc = "Quadrature Decoder Control"]
    pub mod qdc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::QDC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PALS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PALSR {
            #[doc = "Phase A is active HIGH"]
            VALUE1,
            #[doc = "Phase A is active LOW"]
            VALUE2,
        }
        impl PALSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PALSR::VALUE1 => false,
                    PALSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PALSR {
                match value {
                    false => PALSR::VALUE1,
                    true => PALSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PALSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PALSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PBLS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PBLSR {
            #[doc = "Phase B is active HIGH"]
            VALUE1,
            #[doc = "Phase B is active LOW"]
            VALUE2,
        }
        impl PBLSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PBLSR::VALUE1 => false,
                    PBLSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PBLSR {
                match value {
                    false => PBLSR::VALUE1,
                    true => PBLSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PBLSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PBLSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PHS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PHSR {
            #[doc = "Phase A is the leading signal for clockwise rotation"]
            VALUE1,
            #[doc = "Phase B is the leading signal for clockwise rotation"]
            VALUE2,
        }
        impl PHSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PHSR::VALUE1 => false,
                    PHSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PHSR {
                match value {
                    false => PHSR::VALUE1,
                    true => PHSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PHSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PHSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ICM`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ICMR {
            #[doc = "No index marker generation on POSIFx.OUT3"]
            VALUE1,
            #[doc = "Only first index occurrence generated on POSIFx.OUT3"]
            VALUE2,
            #[doc = "All index occurrences generated on POSIFx.OUT3"]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl ICMR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    ICMR::VALUE1 => 0,
                    ICMR::VALUE2 => 0x01,
                    ICMR::VALUE3 => 0x02,
                    ICMR::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> ICMR {
                match value {
                    0 => ICMR::VALUE1,
                    1 => ICMR::VALUE2,
                    2 => ICMR::VALUE3,
                    i => ICMR::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ICMR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ICMR::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == ICMR::VALUE3
            }
        }
        #[doc = "Possible values of the field `DVAL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DVALR {
            #[doc = "Counterclockwise rotation"]
            VALUE1,
            #[doc = "Clockwise rotation"]
            VALUE2,
        }
        impl DVALR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DVALR::VALUE1 => false,
                    DVALR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DVALR {
                match value {
                    false => DVALR::VALUE1,
                    true => DVALR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DVALR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DVALR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PALS`"]
        pub enum PALSW {
            #[doc = "Phase A is active HIGH"]
            VALUE1,
            #[doc = "Phase A is active LOW"]
            VALUE2,
        }
        impl PALSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PALSW::VALUE1 => false,
                    PALSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PALSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PALSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PALSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Phase A is active HIGH"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PALSW::VALUE1)
            }
            #[doc = "Phase A is active LOW"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PALSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PBLS`"]
        pub enum PBLSW {
            #[doc = "Phase B is active HIGH"]
            VALUE1,
            #[doc = "Phase B is active LOW"]
            VALUE2,
        }
        impl PBLSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PBLSW::VALUE1 => false,
                    PBLSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PBLSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PBLSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PBLSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Phase B is active HIGH"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PBLSW::VALUE1)
            }
            #[doc = "Phase B is active LOW"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PBLSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PHS`"]
        pub enum PHSW {
            #[doc = "Phase A is the leading signal for clockwise rotation"]
            VALUE1,
            #[doc = "Phase B is the leading signal for clockwise rotation"]
            VALUE2,
        }
        impl PHSW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PHSW::VALUE1 => false,
                    PHSW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PHSW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PHSW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PHSW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Phase A is the leading signal for clockwise rotation"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PHSW::VALUE1)
            }
            #[doc = "Phase B is the leading signal for clockwise rotation"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PHSW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ICM`"]
        pub enum ICMW {
            #[doc = "No index marker generation on POSIFx.OUT3"]
            VALUE1,
            #[doc = "Only first index occurrence generated on POSIFx.OUT3"]
            VALUE2,
            #[doc = "All index occurrences generated on POSIFx.OUT3"]
            VALUE3,
        }
        impl ICMW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ICMW::VALUE1 => 0,
                    ICMW::VALUE2 => 1,
                    ICMW::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ICMW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ICMW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ICMW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "No index marker generation on POSIFx.OUT3"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ICMW::VALUE1)
            }
            #[doc = "Only first index occurrence generated on POSIFx.OUT3"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ICMW::VALUE2)
            }
            #[doc = "All index occurrences generated on POSIFx.OUT3"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(ICMW::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Phase A Level selector"]
            #[inline]
            pub fn pals(&self) -> PALSR {
                PALSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Phase B Level selector"]
            #[inline]
            pub fn pbls(&self) -> PBLSR {
                PBLSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Phase signals swap"]
            #[inline]
            pub fn phs(&self) -> PHSR {
                PHSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bits 4:5 - Index Marker generations control"]
            #[inline]
            pub fn icm(&self) -> ICMR {
                ICMR::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bit 8 - Current rotation direction"]
            #[inline]
            pub fn dval(&self) -> DVALR {
                DVALR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Phase A Level selector"]
            #[inline]
            pub fn pals(&mut self) -> _PALSW {
                _PALSW { w: self }
            }
            #[doc = "Bit 1 - Phase B Level selector"]
            #[inline]
            pub fn pbls(&mut self) -> _PBLSW {
                _PBLSW { w: self }
            }
            #[doc = "Bit 2 - Phase signals swap"]
            #[inline]
            pub fn phs(&mut self) -> _PHSW {
                _PHSW { w: self }
            }
            #[doc = "Bits 4:5 - Index Marker generations control"]
            #[inline]
            pub fn icm(&mut self) -> _ICMW {
                _ICMW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Interrupt Flags"]
    pub struct PFLG {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Interrupt Flags"]
    pub mod pflg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PFLG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `CHES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHESR {
            #[doc = "Correct Hall Event not detected"]
            VALUE1,
            #[doc = "Correct Hall Event detected"]
            VALUE2,
        }
        impl CHESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHESR::VALUE1 => false,
                    CHESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHESR {
                match value {
                    false => CHESR::VALUE1,
                    true => CHESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHESR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WHES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WHESR {
            #[doc = "Wrong Hall Event not detected"]
            VALUE1,
            #[doc = "Wrong Hall Event detected"]
            VALUE2,
        }
        impl WHESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WHESR::VALUE1 => false,
                    WHESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WHESR {
                match value {
                    false => WHESR::VALUE1,
                    true => WHESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WHESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WHESR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIES`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIESR {
            #[doc = "Transition on the Hall Inputs not detected"]
            VALUE1,
            #[doc = "Transition on the Hall Inputs detected"]
            VALUE2,
        }
        impl HIESR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIESR::VALUE1 => false,
                    HIESR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIESR {
                match value {
                    false => HIESR::VALUE1,
                    true => HIESR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIESR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIESR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSTSR {
            #[doc = "Shadow transfer not done"]
            VALUE1,
            #[doc = "Shadow transfer done"]
            VALUE2,
        }
        impl MSTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSTSR::VALUE1 => false,
                    MSTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSTSR {
                match value {
                    false => MSTSR::VALUE1,
                    true => MSTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `INDXS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INDXSR {
            #[doc = "Index event not detected"]
            VALUE1,
            #[doc = "Index event detected"]
            VALUE2,
        }
        impl INDXSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INDXSR::VALUE1 => false,
                    INDXSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INDXSR {
                match value {
                    false => INDXSR::VALUE1,
                    true => INDXSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INDXSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INDXSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERRSR {
            #[doc = "Phase Error event not detected"]
            VALUE1,
            #[doc = "Phase Error event detected"]
            VALUE2,
        }
        impl ERRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERRSR::VALUE1 => false,
                    ERRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERRSR {
                match value {
                    false => ERRSR::VALUE1,
                    true => ERRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERRSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CNTS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CNTSR {
            #[doc = "Quadrature clock not generated"]
            VALUE1,
            #[doc = "Quadrature clock generated"]
            VALUE2,
        }
        impl CNTSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CNTSR::VALUE1 => false,
                    CNTSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CNTSR {
                match value {
                    false => CNTSR::VALUE1,
                    true => CNTSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CNTSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CNTSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DIRS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIRSR {
            #[doc = "Change on direction not detected"]
            VALUE1,
            #[doc = "Change on direction detected"]
            VALUE2,
        }
        impl DIRSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIRSR::VALUE1 => false,
                    DIRSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIRSR {
                match value {
                    false => DIRSR::VALUE1,
                    true => DIRSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIRSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIRSR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PCLKS`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCLKSR {
            #[doc = "Period clock not generated"]
            VALUE1,
            #[doc = "Period clock generated"]
            VALUE2,
        }
        impl PCLKSR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PCLKSR::VALUE1 => false,
                    PCLKSR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PCLKSR {
                match value {
                    false => PCLKSR::VALUE1,
                    true => PCLKSR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCLKSR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCLKSR::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Correct Hall Event Status"]
            #[inline]
            pub fn ches(&self) -> CHESR {
                CHESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Wrong Hall Event Status"]
            #[inline]
            pub fn whes(&self) -> WHESR {
                WHESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Hall Inputs Update Status"]
            #[inline]
            pub fn hies(&self) -> HIESR {
                HIESR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Multi-Channel pattern shadow transfer status"]
            #[inline]
            pub fn msts(&self) -> MSTSR {
                MSTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Quadrature Index Status"]
            #[inline]
            pub fn indxs(&self) -> INDXSR {
                INDXSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Quadrature Phase Error Status"]
            #[inline]
            pub fn errs(&self) -> ERRSR {
                ERRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Quadrature CLK Status"]
            #[inline]
            pub fn cnts(&self) -> CNTSR {
                CNTSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Quadrature Direction Change"]
            #[inline]
            pub fn dirs(&self) -> DIRSR {
                DIRSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Quadrature Period Clk Status"]
            #[inline]
            pub fn pclks(&self) -> PCLKSR {
                PCLKSR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Service Request Processing Interrupt Enable"]
    pub struct PFLGE {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Interrupt Enable"]
    pub mod pflge {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PFLGE {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `ECHE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ECHER {
            #[doc = "Correct Hall Event interrupt disabled"]
            VALUE1,
            #[doc = "Correct Hall Event interrupt enabled"]
            VALUE2,
        }
        impl ECHER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ECHER::VALUE1 => false,
                    ECHER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ECHER {
                match value {
                    false => ECHER::VALUE1,
                    true => ECHER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ECHER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ECHER::VALUE2
            }
        }
        #[doc = "Possible values of the field `EWHE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EWHER {
            #[doc = "Wrong Hall Event interrupt disabled"]
            VALUE1,
            #[doc = "Wrong Hall Event interrupt enabled"]
            VALUE2,
        }
        impl EWHER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EWHER::VALUE1 => false,
                    EWHER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EWHER {
                match value {
                    false => EWHER::VALUE1,
                    true => EWHER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EWHER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EWHER::VALUE2
            }
        }
        #[doc = "Possible values of the field `EHIE`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EHIER {
            #[doc = "Update of the Hall Inputs interrupt is disabled"]
            VALUE1,
            #[doc = "Update of the Hall Inputs interrupt is enabled"]
            VALUE2,
        }
        impl EHIER {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EHIER::VALUE1 => false,
                    EHIER::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EHIER {
                match value {
                    false => EHIER::VALUE1,
                    true => EHIER::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EHIER::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EHIER::VALUE2
            }
        }
        #[doc = "Possible values of the field `EMST`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EMSTR {
            #[doc = "Shadow transfer event interrupt disabled"]
            VALUE1,
            #[doc = "Shadow transfer event interrupt enabled"]
            VALUE2,
        }
        impl EMSTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EMSTR::VALUE1 => false,
                    EMSTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EMSTR {
                match value {
                    false => EMSTR::VALUE1,
                    true => EMSTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EMSTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EMSTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EINDX`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EINDXR {
            #[doc = "Index event interrupt disabled"]
            VALUE1,
            #[doc = "Index event interrupt enabled"]
            VALUE2,
        }
        impl EINDXR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EINDXR::VALUE1 => false,
                    EINDXR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EINDXR {
                match value {
                    false => EINDXR::VALUE1,
                    true => EINDXR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EINDXR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EINDXR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EERR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EERRR {
            #[doc = "Phase error event interrupt disabled"]
            VALUE1,
            #[doc = "Phase error event interrupt enabled"]
            VALUE2,
        }
        impl EERRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EERRR::VALUE1 => false,
                    EERRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EERRR {
                match value {
                    false => EERRR::VALUE1,
                    true => EERRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EERRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EERRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ECNT`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ECNTR {
            #[doc = "Quadrature CLK event interrupt disabled"]
            VALUE1,
            #[doc = "Quadrature CLK event interrupt enabled"]
            VALUE2,
        }
        impl ECNTR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ECNTR::VALUE1 => false,
                    ECNTR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ECNTR {
                match value {
                    false => ECNTR::VALUE1,
                    true => ECNTR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ECNTR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ECNTR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EDIR`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EDIRR {
            #[doc = "Direction change event interrupt disabled"]
            VALUE1,
            #[doc = "Direction change event interrupt enabled"]
            VALUE2,
        }
        impl EDIRR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EDIRR::VALUE1 => false,
                    EDIRR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EDIRR {
                match value {
                    false => EDIRR::VALUE1,
                    true => EDIRR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EDIRR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EDIRR::VALUE2
            }
        }
        #[doc = "Possible values of the field `EPCLK`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum EPCLKR {
            #[doc = "Quadrature Period CLK event interrupt disabled"]
            VALUE1,
            #[doc = "Quadrature Period CLK event interrupt enabled"]
            VALUE2,
        }
        impl EPCLKR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    EPCLKR::VALUE1 => false,
                    EPCLKR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> EPCLKR {
                match value {
                    false => EPCLKR::VALUE1,
                    true => EPCLKR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == EPCLKR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == EPCLKR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CHESEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CHESELR {
            #[doc = "Correct Hall Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Correct Hall Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl CHESELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CHESELR::VALUE1 => false,
                    CHESELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CHESELR {
                match value {
                    false => CHESELR::VALUE1,
                    true => CHESELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CHESELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CHESELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `WHESEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum WHESELR {
            #[doc = "Wrong Hall Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Wrong Hall Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl WHESELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    WHESELR::VALUE1 => false,
                    WHESELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> WHESELR {
                match value {
                    false => WHESELR::VALUE1,
                    true => WHESELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == WHESELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == WHESELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `HIESEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HIESELR {
            #[doc = "Hall Inputs Update Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Hall Inputs Update Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl HIESELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    HIESELR::VALUE1 => false,
                    HIESELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> HIESELR {
                match value {
                    false => HIESELR::VALUE1,
                    true => HIESELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HIESELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HIESELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `MSTSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum MSTSELR {
            #[doc = "Multi-Channel pattern Update Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Multi-Channel pattern Update Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl MSTSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    MSTSELR::VALUE1 => false,
                    MSTSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> MSTSELR {
                match value {
                    false => MSTSELR::VALUE1,
                    true => MSTSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == MSTSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == MSTSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `INDSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum INDSELR {
            #[doc = "Quadrature Index Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Index Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl INDSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    INDSELR::VALUE1 => false,
                    INDSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> INDSELR {
                match value {
                    false => INDSELR::VALUE1,
                    true => INDSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == INDSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == INDSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `ERRSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum ERRSELR {
            #[doc = "Quadrature Phase error Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Phase error Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl ERRSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    ERRSELR::VALUE1 => false,
                    ERRSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> ERRSELR {
                match value {
                    false => ERRSELR::VALUE1,
                    true => ERRSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == ERRSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == ERRSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `CNTSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum CNTSELR {
            #[doc = "Quadrature Clock Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Clock Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl CNTSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    CNTSELR::VALUE1 => false,
                    CNTSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> CNTSELR {
                match value {
                    false => CNTSELR::VALUE1,
                    true => CNTSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == CNTSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == CNTSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `DIRSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum DIRSELR {
            #[doc = "Quadrature Direction Update Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Direction Update Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl DIRSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    DIRSELR::VALUE1 => false,
                    DIRSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> DIRSELR {
                match value {
                    false => DIRSELR::VALUE1,
                    true => DIRSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == DIRSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == DIRSELR::VALUE2
            }
        }
        #[doc = "Possible values of the field `PCLSEL`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PCLSELR {
            #[doc = "Quadrature Period clock Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Period clock Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl PCLSELR {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PCLSELR::VALUE1 => false,
                    PCLSELR::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PCLSELR {
                match value {
                    false => PCLSELR::VALUE1,
                    true => PCLSELR::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PCLSELR::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PCLSELR::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `ECHE`"]
        pub enum ECHEW {
            #[doc = "Correct Hall Event interrupt disabled"]
            VALUE1,
            #[doc = "Correct Hall Event interrupt enabled"]
            VALUE2,
        }
        impl ECHEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ECHEW::VALUE1 => false,
                    ECHEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ECHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ECHEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ECHEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Correct Hall Event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ECHEW::VALUE1)
            }
            #[doc = "Correct Hall Event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ECHEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EWHE`"]
        pub enum EWHEW {
            #[doc = "Wrong Hall Event interrupt disabled"]
            VALUE1,
            #[doc = "Wrong Hall Event interrupt enabled"]
            VALUE2,
        }
        impl EWHEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EWHEW::VALUE1 => false,
                    EWHEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EWHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EWHEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EWHEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wrong Hall Event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EWHEW::VALUE1)
            }
            #[doc = "Wrong Hall Event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EWHEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EHIE`"]
        pub enum EHIEW {
            #[doc = "Update of the Hall Inputs interrupt is disabled"]
            VALUE1,
            #[doc = "Update of the Hall Inputs interrupt is enabled"]
            VALUE2,
        }
        impl EHIEW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EHIEW::VALUE1 => false,
                    EHIEW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EHIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EHIEW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EHIEW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Update of the Hall Inputs interrupt is disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EHIEW::VALUE1)
            }
            #[doc = "Update of the Hall Inputs interrupt is enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EHIEW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EMST`"]
        pub enum EMSTW {
            #[doc = "Shadow transfer event interrupt disabled"]
            VALUE1,
            #[doc = "Shadow transfer event interrupt enabled"]
            VALUE2,
        }
        impl EMSTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EMSTW::VALUE1 => false,
                    EMSTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EMSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EMSTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EMSTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Shadow transfer event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EMSTW::VALUE1)
            }
            #[doc = "Shadow transfer event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EMSTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EINDX`"]
        pub enum EINDXW {
            #[doc = "Index event interrupt disabled"]
            VALUE1,
            #[doc = "Index event interrupt enabled"]
            VALUE2,
        }
        impl EINDXW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EINDXW::VALUE1 => false,
                    EINDXW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EINDXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EINDXW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EINDXW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Index event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EINDXW::VALUE1)
            }
            #[doc = "Index event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EINDXW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EERR`"]
        pub enum EERRW {
            #[doc = "Phase error event interrupt disabled"]
            VALUE1,
            #[doc = "Phase error event interrupt enabled"]
            VALUE2,
        }
        impl EERRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EERRW::VALUE1 => false,
                    EERRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EERRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EERRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Phase error event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EERRW::VALUE1)
            }
            #[doc = "Phase error event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EERRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ECNT`"]
        pub enum ECNTW {
            #[doc = "Quadrature CLK event interrupt disabled"]
            VALUE1,
            #[doc = "Quadrature CLK event interrupt enabled"]
            VALUE2,
        }
        impl ECNTW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ECNTW::VALUE1 => false,
                    ECNTW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ECNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ECNTW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ECNTW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature CLK event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ECNTW::VALUE1)
            }
            #[doc = "Quadrature CLK event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ECNTW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EDIR`"]
        pub enum EDIRW {
            #[doc = "Direction change event interrupt disabled"]
            VALUE1,
            #[doc = "Direction change event interrupt enabled"]
            VALUE2,
        }
        impl EDIRW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EDIRW::VALUE1 => false,
                    EDIRW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EDIRW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EDIRW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Direction change event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EDIRW::VALUE1)
            }
            #[doc = "Direction change event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EDIRW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `EPCLK`"]
        pub enum EPCLKW {
            #[doc = "Quadrature Period CLK event interrupt disabled"]
            VALUE1,
            #[doc = "Quadrature Period CLK event interrupt enabled"]
            VALUE2,
        }
        impl EPCLKW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    EPCLKW::VALUE1 => false,
                    EPCLKW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _EPCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EPCLKW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: EPCLKW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature Period CLK event interrupt disabled"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(EPCLKW::VALUE1)
            }
            #[doc = "Quadrature Period CLK event interrupt enabled"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(EPCLKW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CHESEL`"]
        pub enum CHESELW {
            #[doc = "Correct Hall Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Correct Hall Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl CHESELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CHESELW::VALUE1 => false,
                    CHESELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CHESELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CHESELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CHESELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Correct Hall Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CHESELW::VALUE1)
            }
            #[doc = "Correct Hall Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CHESELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `WHESEL`"]
        pub enum WHESELW {
            #[doc = "Wrong Hall Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Wrong Hall Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl WHESELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    WHESELW::VALUE1 => false,
                    WHESELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _WHESELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WHESELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: WHESELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Wrong Hall Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(WHESELW::VALUE1)
            }
            #[doc = "Wrong Hall Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(WHESELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HIESEL`"]
        pub enum HIESELW {
            #[doc = "Hall Inputs Update Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Hall Inputs Update Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl HIESELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    HIESELW::VALUE1 => false,
                    HIESELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HIESELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HIESELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HIESELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Hall Inputs Update Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HIESELW::VALUE1)
            }
            #[doc = "Hall Inputs Update Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HIESELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `MSTSEL`"]
        pub enum MSTSELW {
            #[doc = "Multi-Channel pattern Update Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Multi-Channel pattern Update Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl MSTSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    MSTSELW::VALUE1 => false,
                    MSTSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _MSTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MSTSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: MSTSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Multi-Channel pattern Update Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(MSTSELW::VALUE1)
            }
            #[doc = "Multi-Channel pattern Update Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(MSTSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `INDSEL`"]
        pub enum INDSELW {
            #[doc = "Quadrature Index Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Index Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl INDSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    INDSELW::VALUE1 => false,
                    INDSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _INDSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _INDSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: INDSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature Index Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(INDSELW::VALUE1)
            }
            #[doc = "Quadrature Index Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(INDSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `ERRSEL`"]
        pub enum ERRSELW {
            #[doc = "Quadrature Phase error Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Phase error Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl ERRSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    ERRSELW::VALUE1 => false,
                    ERRSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _ERRSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ERRSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: ERRSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature Phase error Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(ERRSELW::VALUE1)
            }
            #[doc = "Quadrature Phase error Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(ERRSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `CNTSEL`"]
        pub enum CNTSELW {
            #[doc = "Quadrature Clock Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Clock Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl CNTSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    CNTSELW::VALUE1 => false,
                    CNTSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _CNTSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CNTSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: CNTSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature Clock Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(CNTSELW::VALUE1)
            }
            #[doc = "Quadrature Clock Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(CNTSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `DIRSEL`"]
        pub enum DIRSELW {
            #[doc = "Quadrature Direction Update Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Direction Update Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl DIRSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    DIRSELW::VALUE1 => false,
                    DIRSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _DIRSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DIRSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: DIRSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature Direction Update Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(DIRSELW::VALUE1)
            }
            #[doc = "Quadrature Direction Update Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(DIRSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PCLSEL`"]
        pub enum PCLSELW {
            #[doc = "Quadrature Period clock Event interrupt forward to POSIFx.SR0"]
            VALUE1,
            #[doc = "Quadrature Period clock Event interrupt forward to POSIFx.SR1"]
            VALUE2,
        }
        impl PCLSELW {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PCLSELW::VALUE1 => false,
                    PCLSELW::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PCLSELW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PCLSELW<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PCLSELW) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Quadrature Period clock Event interrupt forward to POSIFx.SR0"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PCLSELW::VALUE1)
            }
            #[doc = "Quadrature Period clock Event interrupt forward to POSIFx.SR1"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PCLSELW::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Correct Hall Event Enable"]
            #[inline]
            pub fn eche(&self) -> ECHER {
                ECHER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Wrong Hall Event Enable"]
            #[inline]
            pub fn ewhe(&self) -> EWHER {
                EWHER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Hall Input Update Enable"]
            #[inline]
            pub fn ehie(&self) -> EHIER {
                EHIER::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Multi-Channel pattern shadow transfer enable"]
            #[inline]
            pub fn emst(&self) -> EMSTR {
                EMSTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Quadrature Index Event Enable"]
            #[inline]
            pub fn eindx(&self) -> EINDXR {
                EINDXR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Quadrature Phase Error Enable"]
            #[inline]
            pub fn eerr(&self) -> EERRR {
                EERRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Quadrature CLK interrupt Enable"]
            #[inline]
            pub fn ecnt(&self) -> ECNTR {
                ECNTR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Quadrature direction change interrupt Enable"]
            #[inline]
            pub fn edir(&self) -> EDIRR {
                EDIRR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Quadrature Period CLK interrupt Enable"]
            #[inline]
            pub fn epclk(&self) -> EPCLKR {
                EPCLKR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 16 - Correct Hall Event Service Request Selector"]
            #[inline]
            pub fn chesel(&self) -> CHESELR {
                CHESELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 17 - Wrong Hall Event Service Request Selector"]
            #[inline]
            pub fn whesel(&self) -> WHESELR {
                WHESELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 18 - Hall Inputs Update Event Service Request Selector"]
            #[inline]
            pub fn hiesel(&self) -> HIESELR {
                HIESELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 20 - Multi-Channel pattern Update Event Service Request Selector"]
            #[inline]
            pub fn mstsel(&self) -> MSTSELR {
                MSTSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 24 - Quadrature Index Event Service Request Selector"]
            #[inline]
            pub fn indsel(&self) -> INDSELR {
                INDSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 25 - Quadrature Phase Error Event Service Request Selector"]
            #[inline]
            pub fn errsel(&self) -> ERRSELR {
                ERRSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 26 - Quadrature Clock Event Service Request Selector"]
            #[inline]
            pub fn cntsel(&self) -> CNTSELR {
                CNTSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 27 - Quadrature Direction Update Event Service Request Selector"]
            #[inline]
            pub fn dirsel(&self) -> DIRSELR {
                DIRSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 28 - Quadrature Period clock Event Service Request Selector"]
            #[inline]
            pub fn pclsel(&self) -> PCLSELR {
                PCLSELR::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Correct Hall Event Enable"]
            #[inline]
            pub fn eche(&mut self) -> _ECHEW {
                _ECHEW { w: self }
            }
            #[doc = "Bit 1 - Wrong Hall Event Enable"]
            #[inline]
            pub fn ewhe(&mut self) -> _EWHEW {
                _EWHEW { w: self }
            }
            #[doc = "Bit 2 - Hall Input Update Enable"]
            #[inline]
            pub fn ehie(&mut self) -> _EHIEW {
                _EHIEW { w: self }
            }
            #[doc = "Bit 4 - Multi-Channel pattern shadow transfer enable"]
            #[inline]
            pub fn emst(&mut self) -> _EMSTW {
                _EMSTW { w: self }
            }
            #[doc = "Bit 8 - Quadrature Index Event Enable"]
            #[inline]
            pub fn eindx(&mut self) -> _EINDXW {
                _EINDXW { w: self }
            }
            #[doc = "Bit 9 - Quadrature Phase Error Enable"]
            #[inline]
            pub fn eerr(&mut self) -> _EERRW {
                _EERRW { w: self }
            }
            #[doc = "Bit 10 - Quadrature CLK interrupt Enable"]
            #[inline]
            pub fn ecnt(&mut self) -> _ECNTW {
                _ECNTW { w: self }
            }
            #[doc = "Bit 11 - Quadrature direction change interrupt Enable"]
            #[inline]
            pub fn edir(&mut self) -> _EDIRW {
                _EDIRW { w: self }
            }
            #[doc = "Bit 12 - Quadrature Period CLK interrupt Enable"]
            #[inline]
            pub fn epclk(&mut self) -> _EPCLKW {
                _EPCLKW { w: self }
            }
            #[doc = "Bit 16 - Correct Hall Event Service Request Selector"]
            #[inline]
            pub fn chesel(&mut self) -> _CHESELW {
                _CHESELW { w: self }
            }
            #[doc = "Bit 17 - Wrong Hall Event Service Request Selector"]
            #[inline]
            pub fn whesel(&mut self) -> _WHESELW {
                _WHESELW { w: self }
            }
            #[doc = "Bit 18 - Hall Inputs Update Event Service Request Selector"]
            #[inline]
            pub fn hiesel(&mut self) -> _HIESELW {
                _HIESELW { w: self }
            }
            #[doc = "Bit 20 - Multi-Channel pattern Update Event Service Request Selector"]
            #[inline]
            pub fn mstsel(&mut self) -> _MSTSELW {
                _MSTSELW { w: self }
            }
            #[doc = "Bit 24 - Quadrature Index Event Service Request Selector"]
            #[inline]
            pub fn indsel(&mut self) -> _INDSELW {
                _INDSELW { w: self }
            }
            #[doc = "Bit 25 - Quadrature Phase Error Event Service Request Selector"]
            #[inline]
            pub fn errsel(&mut self) -> _ERRSELW {
                _ERRSELW { w: self }
            }
            #[doc = "Bit 26 - Quadrature Clock Event Service Request Selector"]
            #[inline]
            pub fn cntsel(&mut self) -> _CNTSELW {
                _CNTSELW { w: self }
            }
            #[doc = "Bit 27 - Quadrature Direction Update Event Service Request Selector"]
            #[inline]
            pub fn dirsel(&mut self) -> _DIRSELW {
                _DIRSELW { w: self }
            }
            #[doc = "Bit 28 - Quadrature Period clock Event Service Request Selector"]
            #[inline]
            pub fn pclsel(&mut self) -> _PCLSELW {
                _PCLSELW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Interrupt Set"]
    pub struct SPFLG {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Interrupt Set"]
    pub mod spflg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::SPFLG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCHEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SWHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SWHEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SHIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SHIEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SMSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SMSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SINDXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SINDXW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SERRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SCNTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SDIRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _SPCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SPCLKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Correct Hall Event flag set"]
            #[inline]
            pub fn sche(&mut self) -> _SCHEW {
                _SCHEW { w: self }
            }
            #[doc = "Bit 1 - Wrong Hall Event flag set"]
            #[inline]
            pub fn swhe(&mut self) -> _SWHEW {
                _SWHEW { w: self }
            }
            #[doc = "Bit 2 - Hall Inputs Update Event flag set"]
            #[inline]
            pub fn shie(&mut self) -> _SHIEW {
                _SHIEW { w: self }
            }
            #[doc = "Bit 4 - Multi-Channel Pattern shadow transfer flag set"]
            #[inline]
            pub fn smst(&mut self) -> _SMSTW {
                _SMSTW { w: self }
            }
            #[doc = "Bit 8 - Quadrature Index flag set"]
            #[inline]
            pub fn sindx(&mut self) -> _SINDXW {
                _SINDXW { w: self }
            }
            #[doc = "Bit 9 - Quadrature Phase Error flag set"]
            #[inline]
            pub fn serr(&mut self) -> _SERRW {
                _SERRW { w: self }
            }
            #[doc = "Bit 10 - Quadrature CLK flag set"]
            #[inline]
            pub fn scnt(&mut self) -> _SCNTW {
                _SCNTW { w: self }
            }
            #[doc = "Bit 11 - Quadrature Direction flag set"]
            #[inline]
            pub fn sdir(&mut self) -> _SDIRW {
                _SDIRW { w: self }
            }
            #[doc = "Bit 12 - Quadrature period clock flag set"]
            #[inline]
            pub fn spclk(&mut self) -> _SPCLKW {
                _SPCLKW { w: self }
            }
        }
    }
    #[doc = "Service Request Processing Interrupt Clear"]
    pub struct RPFLG {
        register: VolatileCell<u32>,
    }
    #[doc = "Service Request Processing Interrupt Clear"]
    pub mod rpflg {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::RPFLG {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCHEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RWHEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RWHEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RHIEW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RHIEW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RMSTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RMSTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RINDXW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RINDXW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RERRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RERRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RCNTW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RCNTW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RDIRW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RDIRW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _RPCLKW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RPCLKW<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Correct Hall Event flag clear"]
            #[inline]
            pub fn rche(&mut self) -> _RCHEW {
                _RCHEW { w: self }
            }
            #[doc = "Bit 1 - Wrong Hall Event flag clear"]
            #[inline]
            pub fn rwhe(&mut self) -> _RWHEW {
                _RWHEW { w: self }
            }
            #[doc = "Bit 2 - Hall Inputs Update Event flag clear"]
            #[inline]
            pub fn rhie(&mut self) -> _RHIEW {
                _RHIEW { w: self }
            }
            #[doc = "Bit 4 - Multi-Channel Pattern shadow transfer flag clear"]
            #[inline]
            pub fn rmst(&mut self) -> _RMSTW {
                _RMSTW { w: self }
            }
            #[doc = "Bit 8 - Quadrature Index flag clear"]
            #[inline]
            pub fn rindx(&mut self) -> _RINDXW {
                _RINDXW { w: self }
            }
            #[doc = "Bit 9 - Quadrature Phase Error flag clear"]
            #[inline]
            pub fn rerr(&mut self) -> _RERRW {
                _RERRW { w: self }
            }
            #[doc = "Bit 10 - Quadrature CLK flag clear"]
            #[inline]
            pub fn rcnt(&mut self) -> _RCNTW {
                _RCNTW { w: self }
            }
            #[doc = "Bit 11 - Quadrature Direction flag clear"]
            #[inline]
            pub fn rdir(&mut self) -> _RDIRW {
                _RDIRW { w: self }
            }
            #[doc = "Bit 12 - Quadrature period clock flag clear"]
            #[inline]
            pub fn rpclk(&mut self) -> _RPCLKW {
                _RPCLKW { w: self }
            }
        }
    }
    #[doc = "POSIF Debug register"]
    pub struct PDBG {
        register: VolatileCell<u32>,
    }
    #[doc = "POSIF Debug register"]
    pub mod pdbg {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PDBG {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = r" Value of the field"]
        pub struct QCSVR {
            bits: u8,
        }
        impl QCSVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct QPSVR {
            bits: u8,
        }
        impl QPSVR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct IVALR {
            bits: bool,
        }
        impl IVALR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                self.bits
            }
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
        }
        #[doc = r" Value of the field"]
        pub struct HSPR {
            bits: u8,
        }
        impl HSPR {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LPP0R {
            bits: u8,
        }
        impl LPP0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LPP1R {
            bits: u8,
        }
        impl LPP1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct LPP2R {
            bits: u8,
        }
        impl LPP2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Quadrature Decoder Current state"]
            #[inline]
            pub fn qcsv(&self) -> QCSVR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                QCSVR { bits }
            }
            #[doc = "Bits 2:3 - Quadrature Decoder Previous state"]
            #[inline]
            pub fn qpsv(&self) -> QPSVR {
                let bits = {
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                QPSVR { bits }
            }
            #[doc = "Bit 4 - Current Index Value"]
            #[inline]
            pub fn ival(&self) -> IVALR {
                let bits = {
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                };
                IVALR { bits }
            }
            #[doc = "Bits 5:7 - Hall Current Sampled Pattern"]
            #[inline]
            pub fn hsp(&self) -> HSPR {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HSPR { bits }
            }
            #[doc = "Bits 8:13 - Actual count of the Low Pass Filter for POSI0"]
            #[inline]
            pub fn lpp0(&self) -> LPP0R {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LPP0R { bits }
            }
            #[doc = "Bits 16:21 - Actual count of the Low Pass Filter for POSI1"]
            #[inline]
            pub fn lpp1(&self) -> LPP1R {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LPP1R { bits }
            }
            #[doc = "Bits 22:27 - Actual count of the Low Pass Filter for POSI2"]
            #[inline]
            pub fn lpp2(&self) -> LPP2R {
                let bits = {
                    const MASK: u8 = 0x3f;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LPP2R { bits }
            }
        }
    }
}
#[doc = "Position Interface 0"]
pub struct POSIF0 {
    register_block: posif0::RegisterBlock,
}
impl Deref for POSIF0 {
    type Target = posif0::RegisterBlock;
    fn deref(&self) -> &posif0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Port 0"]
pub const PORT0: Peripheral<PORT0> = unsafe { Peripheral::new(0x4802_8000) };
#[doc = "Port 0"]
pub mod port0 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Port 0 Output Register"]
        pub out: OUT,
        #[doc = "0x04 - Port 0 Output Modification Register"]
        pub omr: OMR,
        _reserved0: [u8; 8usize],
        #[doc = "0x10 - Port 0 Input/Output Control Register 0"]
        pub iocr0: IOCR0,
        #[doc = "0x14 - Port 0 Input/Output Control Register 4"]
        pub iocr4: IOCR4,
        #[doc = "0x18 - Port 0 Input/Output Control Register 8"]
        pub iocr8: IOCR8,
        _reserved1: [u8; 8usize],
        #[doc = "0x24 - Port 0 Input Register"]
        pub in_: IN,
        _reserved2: [u8; 24usize],
        #[doc = "0x40 - Port 0 Pad Driver Mode 0 Register"]
        pub pdr0: PDR0,
        #[doc = "0x44 - Port 0 Pad Driver Mode 1 Register"]
        pub pdr1: PDR1,
        _reserved3: [u8; 24usize],
        #[doc = "0x60 - Port 0 Pin Function Decision Control Register"]
        pub pdisc: PDISC,
        _reserved4: [u8; 12usize],
        #[doc = "0x70 - Port 0 Pin Power Save Register"]
        pub pps: PPS,
        #[doc = "0x74 - Port 0 Pin Hardware Select Register"]
        pub hwsel: HWSEL,
    }
    #[doc = "Port 0 Output Register"]
    pub struct OUT {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Output Register"]
    pub mod out {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OUT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `P0`"]
        pub enum P0W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P0W::VALUE1 => false,
                    P0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P0W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P1`"]
        pub enum P1W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P1W::VALUE1 => false,
                    P1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P1W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P2`"]
        pub enum P2W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P2W::VALUE1 => false,
                    P2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P2W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P3`"]
        pub enum P3W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P3W::VALUE1 => false,
                    P3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P3W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P4`"]
        pub enum P4W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P4W::VALUE1 => false,
                    P4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P4W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P5`"]
        pub enum P5W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P5W::VALUE1 => false,
                    P5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P5W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P6`"]
        pub enum P6W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P6W::VALUE1 => false,
                    P6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P6W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P7`"]
        pub enum P7W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P7W::VALUE1 => false,
                    P7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P7W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P8`"]
        pub enum P8W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P8W::VALUE1 => false,
                    P8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P8W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P9`"]
        pub enum P9W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P9W::VALUE1 => false,
                    P9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P9W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P10`"]
        pub enum P10W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P10W::VALUE1 => false,
                    P10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P10W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P11`"]
        pub enum P11W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P11W::VALUE1 => false,
                    P11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P11W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P12`"]
        pub enum P12W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P12W::VALUE1 => false,
                    P12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P12W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P13`"]
        pub enum P13W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P13W::VALUE1 => false,
                    P13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P13W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P14`"]
        pub enum P14W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P14W::VALUE1 => false,
                    P14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P14W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P15`"]
        pub enum P15W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P15W::VALUE1 => false,
                    P15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P15W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&mut self) -> _P0W {
                _P0W { w: self }
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&mut self) -> _P1W {
                _P1W { w: self }
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&mut self) -> _P2W {
                _P2W { w: self }
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&mut self) -> _P3W {
                _P3W { w: self }
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&mut self) -> _P4W {
                _P4W { w: self }
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&mut self) -> _P5W {
                _P5W { w: self }
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&mut self) -> _P6W {
                _P6W { w: self }
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&mut self) -> _P7W {
                _P7W { w: self }
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&mut self) -> _P8W {
                _P8W { w: self }
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&mut self) -> _P9W {
                _P9W { w: self }
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&mut self) -> _P10W {
                _P10W { w: self }
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&mut self) -> _P11W {
                _P11W { w: self }
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&mut self) -> _P12W {
                _P12W { w: self }
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&mut self) -> _P13W {
                _P13W { w: self }
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&mut self) -> _P14W {
                _P14W { w: self }
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&mut self) -> _P15W {
                _P15W { w: self }
            }
        }
    }
    #[doc = "Port 0 Output Modification Register"]
    pub struct OMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Output Modification Register"]
    pub mod omr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OMR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Set Bit 0"]
            #[inline]
            pub fn ps0(&mut self) -> _PS0W {
                _PS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Set Bit 1"]
            #[inline]
            pub fn ps1(&mut self) -> _PS1W {
                _PS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Set Bit 2"]
            #[inline]
            pub fn ps2(&mut self) -> _PS2W {
                _PS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Set Bit 3"]
            #[inline]
            pub fn ps3(&mut self) -> _PS3W {
                _PS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Set Bit 4"]
            #[inline]
            pub fn ps4(&mut self) -> _PS4W {
                _PS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Set Bit 5"]
            #[inline]
            pub fn ps5(&mut self) -> _PS5W {
                _PS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Set Bit 6"]
            #[inline]
            pub fn ps6(&mut self) -> _PS6W {
                _PS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Set Bit 7"]
            #[inline]
            pub fn ps7(&mut self) -> _PS7W {
                _PS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Set Bit 8"]
            #[inline]
            pub fn ps8(&mut self) -> _PS8W {
                _PS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Set Bit 9"]
            #[inline]
            pub fn ps9(&mut self) -> _PS9W {
                _PS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Set Bit 10"]
            #[inline]
            pub fn ps10(&mut self) -> _PS10W {
                _PS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Set Bit 11"]
            #[inline]
            pub fn ps11(&mut self) -> _PS11W {
                _PS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Set Bit 12"]
            #[inline]
            pub fn ps12(&mut self) -> _PS12W {
                _PS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Set Bit 13"]
            #[inline]
            pub fn ps13(&mut self) -> _PS13W {
                _PS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Set Bit 14"]
            #[inline]
            pub fn ps14(&mut self) -> _PS14W {
                _PS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Set Bit 15"]
            #[inline]
            pub fn ps15(&mut self) -> _PS15W {
                _PS15W { w: self }
            }
            #[doc = "Bit 16 - Port n Reset Bit 0"]
            #[inline]
            pub fn pr0(&mut self) -> _PR0W {
                _PR0W { w: self }
            }
            #[doc = "Bit 17 - Port n Reset Bit 1"]
            #[inline]
            pub fn pr1(&mut self) -> _PR1W {
                _PR1W { w: self }
            }
            #[doc = "Bit 18 - Port n Reset Bit 2"]
            #[inline]
            pub fn pr2(&mut self) -> _PR2W {
                _PR2W { w: self }
            }
            #[doc = "Bit 19 - Port n Reset Bit 3"]
            #[inline]
            pub fn pr3(&mut self) -> _PR3W {
                _PR3W { w: self }
            }
            #[doc = "Bit 20 - Port n Reset Bit 4"]
            #[inline]
            pub fn pr4(&mut self) -> _PR4W {
                _PR4W { w: self }
            }
            #[doc = "Bit 21 - Port n Reset Bit 5"]
            #[inline]
            pub fn pr5(&mut self) -> _PR5W {
                _PR5W { w: self }
            }
            #[doc = "Bit 22 - Port n Reset Bit 6"]
            #[inline]
            pub fn pr6(&mut self) -> _PR6W {
                _PR6W { w: self }
            }
            #[doc = "Bit 23 - Port n Reset Bit 7"]
            #[inline]
            pub fn pr7(&mut self) -> _PR7W {
                _PR7W { w: self }
            }
            #[doc = "Bit 24 - Port n Reset Bit 8"]
            #[inline]
            pub fn pr8(&mut self) -> _PR8W {
                _PR8W { w: self }
            }
            #[doc = "Bit 25 - Port n Reset Bit 9"]
            #[inline]
            pub fn pr9(&mut self) -> _PR9W {
                _PR9W { w: self }
            }
            #[doc = "Bit 26 - Port n Reset Bit 10"]
            #[inline]
            pub fn pr10(&mut self) -> _PR10W {
                _PR10W { w: self }
            }
            #[doc = "Bit 27 - Port n Reset Bit 11"]
            #[inline]
            pub fn pr11(&mut self) -> _PR11W {
                _PR11W { w: self }
            }
            #[doc = "Bit 28 - Port n Reset Bit 12"]
            #[inline]
            pub fn pr12(&mut self) -> _PR12W {
                _PR12W { w: self }
            }
            #[doc = "Bit 29 - Port n Reset Bit 13"]
            #[inline]
            pub fn pr13(&mut self) -> _PR13W {
                _PR13W { w: self }
            }
            #[doc = "Bit 30 - Port n Reset Bit 14"]
            #[inline]
            pub fn pr14(&mut self) -> _PR14W {
                _PR14W { w: self }
            }
            #[doc = "Bit 31 - Port n Reset Bit 15"]
            #[inline]
            pub fn pr15(&mut self) -> _PR15W {
                _PR15W { w: self }
            }
        }
    }
    #[doc = "Port 0 Input/Output Control Register 0"]
    pub struct IOCR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Input/Output Control Register 0"]
    pub mod iocr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC0R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC0R::VALUE1 => 0,
                    PC0R::VALUE2 => 0x01,
                    PC0R::VALUE3 => 0x02,
                    PC0R::VALUE4 => 0x03,
                    PC0R::VALUE5 => 0x04,
                    PC0R::VALUE6 => 0x05,
                    PC0R::VALUE7 => 0x06,
                    PC0R::VALUE8 => 0x07,
                    PC0R::VALUE9 => 0x10,
                    PC0R::VALUE10 => 0x11,
                    PC0R::VALUE11 => 0x12,
                    PC0R::VALUE12 => 0x13,
                    PC0R::VALUE13 => 0x14,
                    PC0R::VALUE14 => 0x18,
                    PC0R::VALUE15 => 0x19,
                    PC0R::VALUE16 => 0x1a,
                    PC0R::VALUE17 => 0x1b,
                    PC0R::VALUE18 => 0x1c,
                    PC0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC0R {
                match value {
                    0 => PC0R::VALUE1,
                    1 => PC0R::VALUE2,
                    2 => PC0R::VALUE3,
                    3 => PC0R::VALUE4,
                    4 => PC0R::VALUE5,
                    5 => PC0R::VALUE6,
                    6 => PC0R::VALUE7,
                    7 => PC0R::VALUE8,
                    16 => PC0R::VALUE9,
                    17 => PC0R::VALUE10,
                    18 => PC0R::VALUE11,
                    19 => PC0R::VALUE12,
                    20 => PC0R::VALUE13,
                    24 => PC0R::VALUE14,
                    25 => PC0R::VALUE15,
                    26 => PC0R::VALUE16,
                    27 => PC0R::VALUE17,
                    28 => PC0R::VALUE18,
                    i => PC0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC0R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC0R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC0R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC0R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC0R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC0R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC0R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC0R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC0R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC0R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC0R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC0R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC0R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC0R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC0R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC1R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC1R::VALUE1 => 0,
                    PC1R::VALUE2 => 0x01,
                    PC1R::VALUE3 => 0x02,
                    PC1R::VALUE4 => 0x03,
                    PC1R::VALUE5 => 0x04,
                    PC1R::VALUE6 => 0x05,
                    PC1R::VALUE7 => 0x06,
                    PC1R::VALUE8 => 0x07,
                    PC1R::VALUE9 => 0x10,
                    PC1R::VALUE10 => 0x11,
                    PC1R::VALUE11 => 0x12,
                    PC1R::VALUE12 => 0x13,
                    PC1R::VALUE13 => 0x14,
                    PC1R::VALUE14 => 0x18,
                    PC1R::VALUE15 => 0x19,
                    PC1R::VALUE16 => 0x1a,
                    PC1R::VALUE17 => 0x1b,
                    PC1R::VALUE18 => 0x1c,
                    PC1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC1R {
                match value {
                    0 => PC1R::VALUE1,
                    1 => PC1R::VALUE2,
                    2 => PC1R::VALUE3,
                    3 => PC1R::VALUE4,
                    4 => PC1R::VALUE5,
                    5 => PC1R::VALUE6,
                    6 => PC1R::VALUE7,
                    7 => PC1R::VALUE8,
                    16 => PC1R::VALUE9,
                    17 => PC1R::VALUE10,
                    18 => PC1R::VALUE11,
                    19 => PC1R::VALUE12,
                    20 => PC1R::VALUE13,
                    24 => PC1R::VALUE14,
                    25 => PC1R::VALUE15,
                    26 => PC1R::VALUE16,
                    27 => PC1R::VALUE17,
                    28 => PC1R::VALUE18,
                    i => PC1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC1R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC1R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC1R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC1R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC1R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC1R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC1R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC1R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC1R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC1R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC1R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC1R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC1R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC1R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC1R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC2R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC2R::VALUE1 => 0,
                    PC2R::VALUE2 => 0x01,
                    PC2R::VALUE3 => 0x02,
                    PC2R::VALUE4 => 0x03,
                    PC2R::VALUE5 => 0x04,
                    PC2R::VALUE6 => 0x05,
                    PC2R::VALUE7 => 0x06,
                    PC2R::VALUE8 => 0x07,
                    PC2R::VALUE9 => 0x10,
                    PC2R::VALUE10 => 0x11,
                    PC2R::VALUE11 => 0x12,
                    PC2R::VALUE12 => 0x13,
                    PC2R::VALUE13 => 0x14,
                    PC2R::VALUE14 => 0x18,
                    PC2R::VALUE15 => 0x19,
                    PC2R::VALUE16 => 0x1a,
                    PC2R::VALUE17 => 0x1b,
                    PC2R::VALUE18 => 0x1c,
                    PC2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC2R {
                match value {
                    0 => PC2R::VALUE1,
                    1 => PC2R::VALUE2,
                    2 => PC2R::VALUE3,
                    3 => PC2R::VALUE4,
                    4 => PC2R::VALUE5,
                    5 => PC2R::VALUE6,
                    6 => PC2R::VALUE7,
                    7 => PC2R::VALUE8,
                    16 => PC2R::VALUE9,
                    17 => PC2R::VALUE10,
                    18 => PC2R::VALUE11,
                    19 => PC2R::VALUE12,
                    20 => PC2R::VALUE13,
                    24 => PC2R::VALUE14,
                    25 => PC2R::VALUE15,
                    26 => PC2R::VALUE16,
                    27 => PC2R::VALUE17,
                    28 => PC2R::VALUE18,
                    i => PC2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC2R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC2R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC2R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC2R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC2R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC2R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC2R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC2R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC2R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC2R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC2R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC2R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC2R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC2R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC2R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC3R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC3R::VALUE1 => 0,
                    PC3R::VALUE2 => 0x01,
                    PC3R::VALUE3 => 0x02,
                    PC3R::VALUE4 => 0x03,
                    PC3R::VALUE5 => 0x04,
                    PC3R::VALUE6 => 0x05,
                    PC3R::VALUE7 => 0x06,
                    PC3R::VALUE8 => 0x07,
                    PC3R::VALUE9 => 0x10,
                    PC3R::VALUE10 => 0x11,
                    PC3R::VALUE11 => 0x12,
                    PC3R::VALUE12 => 0x13,
                    PC3R::VALUE13 => 0x14,
                    PC3R::VALUE14 => 0x18,
                    PC3R::VALUE15 => 0x19,
                    PC3R::VALUE16 => 0x1a,
                    PC3R::VALUE17 => 0x1b,
                    PC3R::VALUE18 => 0x1c,
                    PC3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC3R {
                match value {
                    0 => PC3R::VALUE1,
                    1 => PC3R::VALUE2,
                    2 => PC3R::VALUE3,
                    3 => PC3R::VALUE4,
                    4 => PC3R::VALUE5,
                    5 => PC3R::VALUE6,
                    6 => PC3R::VALUE7,
                    7 => PC3R::VALUE8,
                    16 => PC3R::VALUE9,
                    17 => PC3R::VALUE10,
                    18 => PC3R::VALUE11,
                    19 => PC3R::VALUE12,
                    20 => PC3R::VALUE13,
                    24 => PC3R::VALUE14,
                    25 => PC3R::VALUE15,
                    26 => PC3R::VALUE16,
                    27 => PC3R::VALUE17,
                    28 => PC3R::VALUE18,
                    i => PC3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC3R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC3R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC3R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC3R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC3R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC3R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC3R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC3R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC3R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC3R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC3R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC3R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC3R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC3R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC3R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC3R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC0`"]
        pub enum PC0W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC0W::VALUE1 => 0,
                    PC0W::VALUE2 => 1,
                    PC0W::VALUE3 => 2,
                    PC0W::VALUE4 => 3,
                    PC0W::VALUE5 => 4,
                    PC0W::VALUE6 => 5,
                    PC0W::VALUE7 => 6,
                    PC0W::VALUE8 => 7,
                    PC0W::VALUE9 => 16,
                    PC0W::VALUE10 => 17,
                    PC0W::VALUE11 => 18,
                    PC0W::VALUE12 => 19,
                    PC0W::VALUE13 => 20,
                    PC0W::VALUE14 => 24,
                    PC0W::VALUE15 => 25,
                    PC0W::VALUE16 => 26,
                    PC0W::VALUE17 => 27,
                    PC0W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC0W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC0W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC0W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC0W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC0W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC0W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC0W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC0W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC0W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC0W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC0W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC0W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC0W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC0W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC0W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC0W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC0W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC0W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC1`"]
        pub enum PC1W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC1W::VALUE1 => 0,
                    PC1W::VALUE2 => 1,
                    PC1W::VALUE3 => 2,
                    PC1W::VALUE4 => 3,
                    PC1W::VALUE5 => 4,
                    PC1W::VALUE6 => 5,
                    PC1W::VALUE7 => 6,
                    PC1W::VALUE8 => 7,
                    PC1W::VALUE9 => 16,
                    PC1W::VALUE10 => 17,
                    PC1W::VALUE11 => 18,
                    PC1W::VALUE12 => 19,
                    PC1W::VALUE13 => 20,
                    PC1W::VALUE14 => 24,
                    PC1W::VALUE15 => 25,
                    PC1W::VALUE16 => 26,
                    PC1W::VALUE17 => 27,
                    PC1W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC1W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC1W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC1W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC1W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC1W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC1W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC1W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC1W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC1W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC1W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC1W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC1W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC1W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC1W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC1W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC1W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC1W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC1W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC2`"]
        pub enum PC2W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC2W::VALUE1 => 0,
                    PC2W::VALUE2 => 1,
                    PC2W::VALUE3 => 2,
                    PC2W::VALUE4 => 3,
                    PC2W::VALUE5 => 4,
                    PC2W::VALUE6 => 5,
                    PC2W::VALUE7 => 6,
                    PC2W::VALUE8 => 7,
                    PC2W::VALUE9 => 16,
                    PC2W::VALUE10 => 17,
                    PC2W::VALUE11 => 18,
                    PC2W::VALUE12 => 19,
                    PC2W::VALUE13 => 20,
                    PC2W::VALUE14 => 24,
                    PC2W::VALUE15 => 25,
                    PC2W::VALUE16 => 26,
                    PC2W::VALUE17 => 27,
                    PC2W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC2W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC2W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC2W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC2W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC2W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC2W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC2W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC2W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC2W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC2W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC2W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC2W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC2W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC2W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC2W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC2W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC2W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC2W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC3`"]
        pub enum PC3W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC3W::VALUE1 => 0,
                    PC3W::VALUE2 => 1,
                    PC3W::VALUE3 => 2,
                    PC3W::VALUE4 => 3,
                    PC3W::VALUE5 => 4,
                    PC3W::VALUE6 => 5,
                    PC3W::VALUE7 => 6,
                    PC3W::VALUE8 => 7,
                    PC3W::VALUE9 => 16,
                    PC3W::VALUE10 => 17,
                    PC3W::VALUE11 => 18,
                    PC3W::VALUE12 => 19,
                    PC3W::VALUE13 => 20,
                    PC3W::VALUE14 => 24,
                    PC3W::VALUE15 => 25,
                    PC3W::VALUE16 => 26,
                    PC3W::VALUE17 => 27,
                    PC3W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC3W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC3W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC3W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC3W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC3W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC3W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC3W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC3W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC3W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC3W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC3W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC3W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC3W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC3W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC3W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC3W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC3W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC3W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&self) -> PC0R {
                PC0R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&self) -> PC1R {
                PC1R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&self) -> PC2R {
                PC2R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&self) -> PC3R {
                PC3R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&mut self) -> _PC0W {
                _PC0W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&mut self) -> _PC1W {
                _PC1W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&mut self) -> _PC2W {
                _PC2W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&mut self) -> _PC3W {
                _PC3W { w: self }
            }
        }
    }
    #[doc = "Port 0 Input/Output Control Register 4"]
    pub struct IOCR4 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Input/Output Control Register 4"]
    pub mod iocr4 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR4 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC4R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC4R::VALUE1 => 0,
                    PC4R::VALUE2 => 0x01,
                    PC4R::VALUE3 => 0x02,
                    PC4R::VALUE4 => 0x03,
                    PC4R::VALUE5 => 0x04,
                    PC4R::VALUE6 => 0x05,
                    PC4R::VALUE7 => 0x06,
                    PC4R::VALUE8 => 0x07,
                    PC4R::VALUE9 => 0x10,
                    PC4R::VALUE10 => 0x11,
                    PC4R::VALUE11 => 0x12,
                    PC4R::VALUE12 => 0x13,
                    PC4R::VALUE13 => 0x14,
                    PC4R::VALUE14 => 0x18,
                    PC4R::VALUE15 => 0x19,
                    PC4R::VALUE16 => 0x1a,
                    PC4R::VALUE17 => 0x1b,
                    PC4R::VALUE18 => 0x1c,
                    PC4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC4R {
                match value {
                    0 => PC4R::VALUE1,
                    1 => PC4R::VALUE2,
                    2 => PC4R::VALUE3,
                    3 => PC4R::VALUE4,
                    4 => PC4R::VALUE5,
                    5 => PC4R::VALUE6,
                    6 => PC4R::VALUE7,
                    7 => PC4R::VALUE8,
                    16 => PC4R::VALUE9,
                    17 => PC4R::VALUE10,
                    18 => PC4R::VALUE11,
                    19 => PC4R::VALUE12,
                    20 => PC4R::VALUE13,
                    24 => PC4R::VALUE14,
                    25 => PC4R::VALUE15,
                    26 => PC4R::VALUE16,
                    27 => PC4R::VALUE17,
                    28 => PC4R::VALUE18,
                    i => PC4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC4R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC4R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC4R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC4R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC4R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC4R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC4R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC4R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC4R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC4R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC4R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC4R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC4R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC4R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC4R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC4R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC5R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC5R::VALUE1 => 0,
                    PC5R::VALUE2 => 0x01,
                    PC5R::VALUE3 => 0x02,
                    PC5R::VALUE4 => 0x03,
                    PC5R::VALUE5 => 0x04,
                    PC5R::VALUE6 => 0x05,
                    PC5R::VALUE7 => 0x06,
                    PC5R::VALUE8 => 0x07,
                    PC5R::VALUE9 => 0x10,
                    PC5R::VALUE10 => 0x11,
                    PC5R::VALUE11 => 0x12,
                    PC5R::VALUE12 => 0x13,
                    PC5R::VALUE13 => 0x14,
                    PC5R::VALUE14 => 0x18,
                    PC5R::VALUE15 => 0x19,
                    PC5R::VALUE16 => 0x1a,
                    PC5R::VALUE17 => 0x1b,
                    PC5R::VALUE18 => 0x1c,
                    PC5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC5R {
                match value {
                    0 => PC5R::VALUE1,
                    1 => PC5R::VALUE2,
                    2 => PC5R::VALUE3,
                    3 => PC5R::VALUE4,
                    4 => PC5R::VALUE5,
                    5 => PC5R::VALUE6,
                    6 => PC5R::VALUE7,
                    7 => PC5R::VALUE8,
                    16 => PC5R::VALUE9,
                    17 => PC5R::VALUE10,
                    18 => PC5R::VALUE11,
                    19 => PC5R::VALUE12,
                    20 => PC5R::VALUE13,
                    24 => PC5R::VALUE14,
                    25 => PC5R::VALUE15,
                    26 => PC5R::VALUE16,
                    27 => PC5R::VALUE17,
                    28 => PC5R::VALUE18,
                    i => PC5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC5R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC5R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC5R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC5R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC5R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC5R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC5R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC5R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC5R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC5R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC5R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC5R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC5R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC5R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC5R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC5R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC6R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC6R::VALUE1 => 0,
                    PC6R::VALUE2 => 0x01,
                    PC6R::VALUE3 => 0x02,
                    PC6R::VALUE4 => 0x03,
                    PC6R::VALUE5 => 0x04,
                    PC6R::VALUE6 => 0x05,
                    PC6R::VALUE7 => 0x06,
                    PC6R::VALUE8 => 0x07,
                    PC6R::VALUE9 => 0x10,
                    PC6R::VALUE10 => 0x11,
                    PC6R::VALUE11 => 0x12,
                    PC6R::VALUE12 => 0x13,
                    PC6R::VALUE13 => 0x14,
                    PC6R::VALUE14 => 0x18,
                    PC6R::VALUE15 => 0x19,
                    PC6R::VALUE16 => 0x1a,
                    PC6R::VALUE17 => 0x1b,
                    PC6R::VALUE18 => 0x1c,
                    PC6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC6R {
                match value {
                    0 => PC6R::VALUE1,
                    1 => PC6R::VALUE2,
                    2 => PC6R::VALUE3,
                    3 => PC6R::VALUE4,
                    4 => PC6R::VALUE5,
                    5 => PC6R::VALUE6,
                    6 => PC6R::VALUE7,
                    7 => PC6R::VALUE8,
                    16 => PC6R::VALUE9,
                    17 => PC6R::VALUE10,
                    18 => PC6R::VALUE11,
                    19 => PC6R::VALUE12,
                    20 => PC6R::VALUE13,
                    24 => PC6R::VALUE14,
                    25 => PC6R::VALUE15,
                    26 => PC6R::VALUE16,
                    27 => PC6R::VALUE17,
                    28 => PC6R::VALUE18,
                    i => PC6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC6R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC6R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC6R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC6R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC6R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC6R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC6R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC6R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC6R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC6R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC6R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC6R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC6R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC6R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC6R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC6R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC7R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC7R::VALUE1 => 0,
                    PC7R::VALUE2 => 0x01,
                    PC7R::VALUE3 => 0x02,
                    PC7R::VALUE4 => 0x03,
                    PC7R::VALUE5 => 0x04,
                    PC7R::VALUE6 => 0x05,
                    PC7R::VALUE7 => 0x06,
                    PC7R::VALUE8 => 0x07,
                    PC7R::VALUE9 => 0x10,
                    PC7R::VALUE10 => 0x11,
                    PC7R::VALUE11 => 0x12,
                    PC7R::VALUE12 => 0x13,
                    PC7R::VALUE13 => 0x14,
                    PC7R::VALUE14 => 0x18,
                    PC7R::VALUE15 => 0x19,
                    PC7R::VALUE16 => 0x1a,
                    PC7R::VALUE17 => 0x1b,
                    PC7R::VALUE18 => 0x1c,
                    PC7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC7R {
                match value {
                    0 => PC7R::VALUE1,
                    1 => PC7R::VALUE2,
                    2 => PC7R::VALUE3,
                    3 => PC7R::VALUE4,
                    4 => PC7R::VALUE5,
                    5 => PC7R::VALUE6,
                    6 => PC7R::VALUE7,
                    7 => PC7R::VALUE8,
                    16 => PC7R::VALUE9,
                    17 => PC7R::VALUE10,
                    18 => PC7R::VALUE11,
                    19 => PC7R::VALUE12,
                    20 => PC7R::VALUE13,
                    24 => PC7R::VALUE14,
                    25 => PC7R::VALUE15,
                    26 => PC7R::VALUE16,
                    27 => PC7R::VALUE17,
                    28 => PC7R::VALUE18,
                    i => PC7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC7R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC7R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC7R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC7R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC7R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC7R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC7R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC7R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC7R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC7R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC7R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC7R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC7R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC7R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC7R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC7R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC4`"]
        pub enum PC4W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC4W::VALUE1 => 0,
                    PC4W::VALUE2 => 1,
                    PC4W::VALUE3 => 2,
                    PC4W::VALUE4 => 3,
                    PC4W::VALUE5 => 4,
                    PC4W::VALUE6 => 5,
                    PC4W::VALUE7 => 6,
                    PC4W::VALUE8 => 7,
                    PC4W::VALUE9 => 16,
                    PC4W::VALUE10 => 17,
                    PC4W::VALUE11 => 18,
                    PC4W::VALUE12 => 19,
                    PC4W::VALUE13 => 20,
                    PC4W::VALUE14 => 24,
                    PC4W::VALUE15 => 25,
                    PC4W::VALUE16 => 26,
                    PC4W::VALUE17 => 27,
                    PC4W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC4W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC4W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC4W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC4W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC4W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC4W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC4W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC4W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC4W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC4W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC4W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC4W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC4W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC4W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC4W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC4W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC4W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC4W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC5`"]
        pub enum PC5W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC5W::VALUE1 => 0,
                    PC5W::VALUE2 => 1,
                    PC5W::VALUE3 => 2,
                    PC5W::VALUE4 => 3,
                    PC5W::VALUE5 => 4,
                    PC5W::VALUE6 => 5,
                    PC5W::VALUE7 => 6,
                    PC5W::VALUE8 => 7,
                    PC5W::VALUE9 => 16,
                    PC5W::VALUE10 => 17,
                    PC5W::VALUE11 => 18,
                    PC5W::VALUE12 => 19,
                    PC5W::VALUE13 => 20,
                    PC5W::VALUE14 => 24,
                    PC5W::VALUE15 => 25,
                    PC5W::VALUE16 => 26,
                    PC5W::VALUE17 => 27,
                    PC5W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC5W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC5W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC5W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC5W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC5W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC5W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC5W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC5W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC5W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC5W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC5W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC5W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC5W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC5W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC5W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC5W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC5W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC5W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC6`"]
        pub enum PC6W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC6W::VALUE1 => 0,
                    PC6W::VALUE2 => 1,
                    PC6W::VALUE3 => 2,
                    PC6W::VALUE4 => 3,
                    PC6W::VALUE5 => 4,
                    PC6W::VALUE6 => 5,
                    PC6W::VALUE7 => 6,
                    PC6W::VALUE8 => 7,
                    PC6W::VALUE9 => 16,
                    PC6W::VALUE10 => 17,
                    PC6W::VALUE11 => 18,
                    PC6W::VALUE12 => 19,
                    PC6W::VALUE13 => 20,
                    PC6W::VALUE14 => 24,
                    PC6W::VALUE15 => 25,
                    PC6W::VALUE16 => 26,
                    PC6W::VALUE17 => 27,
                    PC6W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC6W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC6W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC6W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC6W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC6W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC6W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC6W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC6W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC6W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC6W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC6W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC6W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC6W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC6W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC6W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC6W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC6W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC6W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC7`"]
        pub enum PC7W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC7W::VALUE1 => 0,
                    PC7W::VALUE2 => 1,
                    PC7W::VALUE3 => 2,
                    PC7W::VALUE4 => 3,
                    PC7W::VALUE5 => 4,
                    PC7W::VALUE6 => 5,
                    PC7W::VALUE7 => 6,
                    PC7W::VALUE8 => 7,
                    PC7W::VALUE9 => 16,
                    PC7W::VALUE10 => 17,
                    PC7W::VALUE11 => 18,
                    PC7W::VALUE12 => 19,
                    PC7W::VALUE13 => 20,
                    PC7W::VALUE14 => 24,
                    PC7W::VALUE15 => 25,
                    PC7W::VALUE16 => 26,
                    PC7W::VALUE17 => 27,
                    PC7W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC7W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC7W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC7W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC7W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC7W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC7W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC7W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC7W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC7W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC7W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC7W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC7W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC7W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC7W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC7W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC7W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC7W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC7W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&self) -> PC4R {
                PC4R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&self) -> PC5R {
                PC5R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&self) -> PC6R {
                PC6R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&self) -> PC7R {
                PC7R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&mut self) -> _PC4W {
                _PC4W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&mut self) -> _PC5W {
                _PC5W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&mut self) -> _PC6W {
                _PC6W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&mut self) -> _PC7W {
                _PC7W { w: self }
            }
        }
    }
    #[doc = "Port 0 Input/Output Control Register 8"]
    pub struct IOCR8 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Input/Output Control Register 8"]
    pub mod iocr8 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR8 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC8R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC8R::VALUE1 => 0,
                    PC8R::VALUE2 => 0x01,
                    PC8R::VALUE3 => 0x02,
                    PC8R::VALUE4 => 0x03,
                    PC8R::VALUE5 => 0x04,
                    PC8R::VALUE6 => 0x05,
                    PC8R::VALUE7 => 0x06,
                    PC8R::VALUE8 => 0x07,
                    PC8R::VALUE9 => 0x10,
                    PC8R::VALUE10 => 0x11,
                    PC8R::VALUE11 => 0x12,
                    PC8R::VALUE12 => 0x13,
                    PC8R::VALUE13 => 0x14,
                    PC8R::VALUE14 => 0x18,
                    PC8R::VALUE15 => 0x19,
                    PC8R::VALUE16 => 0x1a,
                    PC8R::VALUE17 => 0x1b,
                    PC8R::VALUE18 => 0x1c,
                    PC8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC8R {
                match value {
                    0 => PC8R::VALUE1,
                    1 => PC8R::VALUE2,
                    2 => PC8R::VALUE3,
                    3 => PC8R::VALUE4,
                    4 => PC8R::VALUE5,
                    5 => PC8R::VALUE6,
                    6 => PC8R::VALUE7,
                    7 => PC8R::VALUE8,
                    16 => PC8R::VALUE9,
                    17 => PC8R::VALUE10,
                    18 => PC8R::VALUE11,
                    19 => PC8R::VALUE12,
                    20 => PC8R::VALUE13,
                    24 => PC8R::VALUE14,
                    25 => PC8R::VALUE15,
                    26 => PC8R::VALUE16,
                    27 => PC8R::VALUE17,
                    28 => PC8R::VALUE18,
                    i => PC8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC8R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC8R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC8R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC8R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC8R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC8R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC8R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC8R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC8R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC8R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC8R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC8R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC8R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC8R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC8R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC8R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC9R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC9R::VALUE1 => 0,
                    PC9R::VALUE2 => 0x01,
                    PC9R::VALUE3 => 0x02,
                    PC9R::VALUE4 => 0x03,
                    PC9R::VALUE5 => 0x04,
                    PC9R::VALUE6 => 0x05,
                    PC9R::VALUE7 => 0x06,
                    PC9R::VALUE8 => 0x07,
                    PC9R::VALUE9 => 0x10,
                    PC9R::VALUE10 => 0x11,
                    PC9R::VALUE11 => 0x12,
                    PC9R::VALUE12 => 0x13,
                    PC9R::VALUE13 => 0x14,
                    PC9R::VALUE14 => 0x18,
                    PC9R::VALUE15 => 0x19,
                    PC9R::VALUE16 => 0x1a,
                    PC9R::VALUE17 => 0x1b,
                    PC9R::VALUE18 => 0x1c,
                    PC9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC9R {
                match value {
                    0 => PC9R::VALUE1,
                    1 => PC9R::VALUE2,
                    2 => PC9R::VALUE3,
                    3 => PC9R::VALUE4,
                    4 => PC9R::VALUE5,
                    5 => PC9R::VALUE6,
                    6 => PC9R::VALUE7,
                    7 => PC9R::VALUE8,
                    16 => PC9R::VALUE9,
                    17 => PC9R::VALUE10,
                    18 => PC9R::VALUE11,
                    19 => PC9R::VALUE12,
                    20 => PC9R::VALUE13,
                    24 => PC9R::VALUE14,
                    25 => PC9R::VALUE15,
                    26 => PC9R::VALUE16,
                    27 => PC9R::VALUE17,
                    28 => PC9R::VALUE18,
                    i => PC9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC9R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC9R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC9R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC9R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC9R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC9R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC9R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC9R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC9R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC9R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC9R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC9R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC9R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC9R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC9R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC9R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC10R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC10R::VALUE1 => 0,
                    PC10R::VALUE2 => 0x01,
                    PC10R::VALUE3 => 0x02,
                    PC10R::VALUE4 => 0x03,
                    PC10R::VALUE5 => 0x04,
                    PC10R::VALUE6 => 0x05,
                    PC10R::VALUE7 => 0x06,
                    PC10R::VALUE8 => 0x07,
                    PC10R::VALUE9 => 0x10,
                    PC10R::VALUE10 => 0x11,
                    PC10R::VALUE11 => 0x12,
                    PC10R::VALUE12 => 0x13,
                    PC10R::VALUE13 => 0x14,
                    PC10R::VALUE14 => 0x18,
                    PC10R::VALUE15 => 0x19,
                    PC10R::VALUE16 => 0x1a,
                    PC10R::VALUE17 => 0x1b,
                    PC10R::VALUE18 => 0x1c,
                    PC10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC10R {
                match value {
                    0 => PC10R::VALUE1,
                    1 => PC10R::VALUE2,
                    2 => PC10R::VALUE3,
                    3 => PC10R::VALUE4,
                    4 => PC10R::VALUE5,
                    5 => PC10R::VALUE6,
                    6 => PC10R::VALUE7,
                    7 => PC10R::VALUE8,
                    16 => PC10R::VALUE9,
                    17 => PC10R::VALUE10,
                    18 => PC10R::VALUE11,
                    19 => PC10R::VALUE12,
                    20 => PC10R::VALUE13,
                    24 => PC10R::VALUE14,
                    25 => PC10R::VALUE15,
                    26 => PC10R::VALUE16,
                    27 => PC10R::VALUE17,
                    28 => PC10R::VALUE18,
                    i => PC10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC10R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC10R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC10R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC10R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC10R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC10R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC10R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC10R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC10R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC10R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC10R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC10R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC10R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC10R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC10R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC10R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC11R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC11R::VALUE1 => 0,
                    PC11R::VALUE2 => 0x01,
                    PC11R::VALUE3 => 0x02,
                    PC11R::VALUE4 => 0x03,
                    PC11R::VALUE5 => 0x04,
                    PC11R::VALUE6 => 0x05,
                    PC11R::VALUE7 => 0x06,
                    PC11R::VALUE8 => 0x07,
                    PC11R::VALUE9 => 0x10,
                    PC11R::VALUE10 => 0x11,
                    PC11R::VALUE11 => 0x12,
                    PC11R::VALUE12 => 0x13,
                    PC11R::VALUE13 => 0x14,
                    PC11R::VALUE14 => 0x18,
                    PC11R::VALUE15 => 0x19,
                    PC11R::VALUE16 => 0x1a,
                    PC11R::VALUE17 => 0x1b,
                    PC11R::VALUE18 => 0x1c,
                    PC11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC11R {
                match value {
                    0 => PC11R::VALUE1,
                    1 => PC11R::VALUE2,
                    2 => PC11R::VALUE3,
                    3 => PC11R::VALUE4,
                    4 => PC11R::VALUE5,
                    5 => PC11R::VALUE6,
                    6 => PC11R::VALUE7,
                    7 => PC11R::VALUE8,
                    16 => PC11R::VALUE9,
                    17 => PC11R::VALUE10,
                    18 => PC11R::VALUE11,
                    19 => PC11R::VALUE12,
                    20 => PC11R::VALUE13,
                    24 => PC11R::VALUE14,
                    25 => PC11R::VALUE15,
                    26 => PC11R::VALUE16,
                    27 => PC11R::VALUE17,
                    28 => PC11R::VALUE18,
                    i => PC11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC11R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC11R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC11R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC11R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC11R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC11R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC11R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC11R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC11R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC11R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC11R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC11R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC11R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC11R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC11R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC11R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC8`"]
        pub enum PC8W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC8W::VALUE1 => 0,
                    PC8W::VALUE2 => 1,
                    PC8W::VALUE3 => 2,
                    PC8W::VALUE4 => 3,
                    PC8W::VALUE5 => 4,
                    PC8W::VALUE6 => 5,
                    PC8W::VALUE7 => 6,
                    PC8W::VALUE8 => 7,
                    PC8W::VALUE9 => 16,
                    PC8W::VALUE10 => 17,
                    PC8W::VALUE11 => 18,
                    PC8W::VALUE12 => 19,
                    PC8W::VALUE13 => 20,
                    PC8W::VALUE14 => 24,
                    PC8W::VALUE15 => 25,
                    PC8W::VALUE16 => 26,
                    PC8W::VALUE17 => 27,
                    PC8W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC8W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC8W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC8W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC8W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC8W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC8W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC8W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC8W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC8W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC8W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC8W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC8W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC8W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC8W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC8W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC8W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC8W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC8W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC9`"]
        pub enum PC9W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC9W::VALUE1 => 0,
                    PC9W::VALUE2 => 1,
                    PC9W::VALUE3 => 2,
                    PC9W::VALUE4 => 3,
                    PC9W::VALUE5 => 4,
                    PC9W::VALUE6 => 5,
                    PC9W::VALUE7 => 6,
                    PC9W::VALUE8 => 7,
                    PC9W::VALUE9 => 16,
                    PC9W::VALUE10 => 17,
                    PC9W::VALUE11 => 18,
                    PC9W::VALUE12 => 19,
                    PC9W::VALUE13 => 20,
                    PC9W::VALUE14 => 24,
                    PC9W::VALUE15 => 25,
                    PC9W::VALUE16 => 26,
                    PC9W::VALUE17 => 27,
                    PC9W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC9W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC9W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC9W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC9W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC9W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC9W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC9W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC9W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC9W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC9W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC9W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC9W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC9W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC9W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC9W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC9W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC9W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC9W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC10`"]
        pub enum PC10W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC10W::VALUE1 => 0,
                    PC10W::VALUE2 => 1,
                    PC10W::VALUE3 => 2,
                    PC10W::VALUE4 => 3,
                    PC10W::VALUE5 => 4,
                    PC10W::VALUE6 => 5,
                    PC10W::VALUE7 => 6,
                    PC10W::VALUE8 => 7,
                    PC10W::VALUE9 => 16,
                    PC10W::VALUE10 => 17,
                    PC10W::VALUE11 => 18,
                    PC10W::VALUE12 => 19,
                    PC10W::VALUE13 => 20,
                    PC10W::VALUE14 => 24,
                    PC10W::VALUE15 => 25,
                    PC10W::VALUE16 => 26,
                    PC10W::VALUE17 => 27,
                    PC10W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC10W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC10W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC10W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC10W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC10W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC10W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC10W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC10W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC10W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC10W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC10W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC10W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC10W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC10W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC10W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC10W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC10W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC10W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC11`"]
        pub enum PC11W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC11W::VALUE1 => 0,
                    PC11W::VALUE2 => 1,
                    PC11W::VALUE3 => 2,
                    PC11W::VALUE4 => 3,
                    PC11W::VALUE5 => 4,
                    PC11W::VALUE6 => 5,
                    PC11W::VALUE7 => 6,
                    PC11W::VALUE8 => 7,
                    PC11W::VALUE9 => 16,
                    PC11W::VALUE10 => 17,
                    PC11W::VALUE11 => 18,
                    PC11W::VALUE12 => 19,
                    PC11W::VALUE13 => 20,
                    PC11W::VALUE14 => 24,
                    PC11W::VALUE15 => 25,
                    PC11W::VALUE16 => 26,
                    PC11W::VALUE17 => 27,
                    PC11W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC11W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC11W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC11W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC11W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC11W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC11W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC11W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC11W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC11W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC11W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC11W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC11W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC11W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC11W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC11W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC11W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC11W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC11W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&self) -> PC8R {
                PC8R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&self) -> PC9R {
                PC9R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&self) -> PC10R {
                PC10R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&self) -> PC11R {
                PC11R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&mut self) -> _PC8W {
                _PC8W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&mut self) -> _PC9W {
                _PC9W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&mut self) -> _PC10W {
                _PC10W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&mut self) -> _PC11W {
                _PC11W { w: self }
            }
        }
    }
    #[doc = "Port 0 Input Register"]
    pub struct IN {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Input Register"]
    pub mod in_ {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Input Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Input Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Input Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Input Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Input Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Input Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Input Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Input Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Input Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Input Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Input Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Input Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Input Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Input Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Input Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Input Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 0 Pad Driver Mode 0 Register"]
    pub struct PDR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Pad Driver Mode 0 Register"]
    pub mod pdr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD0R {
            bits: u8,
        }
        impl PD0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD1R {
            bits: u8,
        }
        impl PD1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD2R {
            bits: u8,
        }
        impl PD2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD3R {
            bits: u8,
        }
        impl PD3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD4R {
            bits: u8,
        }
        impl PD4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD5R {
            bits: u8,
        }
        impl PD5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD6R {
            bits: u8,
        }
        impl PD6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD7R {
            bits: u8,
        }
        impl PD7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&self) -> PD0R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD0R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&self) -> PD1R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD1R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&self) -> PD2R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD2R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&self) -> PD3R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD3R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&self) -> PD4R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD4R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&self) -> PD5R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD5R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&self) -> PD6R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD6R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&self) -> PD7R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&mut self) -> _PD0W {
                _PD0W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&mut self) -> _PD1W {
                _PD1W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&mut self) -> _PD2W {
                _PD2W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&mut self) -> _PD3W {
                _PD3W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&mut self) -> _PD4W {
                _PD4W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&mut self) -> _PD5W {
                _PD5W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&mut self) -> _PD6W {
                _PD6W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&mut self) -> _PD7W {
                _PD7W { w: self }
            }
        }
    }
    #[doc = "Port 0 Pad Driver Mode 1 Register"]
    pub struct PDR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Pad Driver Mode 1 Register"]
    pub mod pdr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD8R {
            bits: u8,
        }
        impl PD8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD9R {
            bits: u8,
        }
        impl PD9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD10R {
            bits: u8,
        }
        impl PD10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD11R {
            bits: u8,
        }
        impl PD11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD12R {
            bits: u8,
        }
        impl PD12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD13R {
            bits: u8,
        }
        impl PD13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD14R {
            bits: u8,
        }
        impl PD14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD15R {
            bits: u8,
        }
        impl PD15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD8W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD9W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD10W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD11W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD12W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD13W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD14W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD15W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.8"]
            #[inline]
            pub fn pd8(&self) -> PD8R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD8R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.9"]
            #[inline]
            pub fn pd9(&self) -> PD9R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD9R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.10"]
            #[inline]
            pub fn pd10(&self) -> PD10R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD10R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.11"]
            #[inline]
            pub fn pd11(&self) -> PD11R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD11R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.12"]
            #[inline]
            pub fn pd12(&self) -> PD12R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD12R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.13"]
            #[inline]
            pub fn pd13(&self) -> PD13R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD13R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.14"]
            #[inline]
            pub fn pd14(&self) -> PD14R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD14R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.15"]
            #[inline]
            pub fn pd15(&self) -> PD15R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD15R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.8"]
            #[inline]
            pub fn pd8(&mut self) -> _PD8W {
                _PD8W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.9"]
            #[inline]
            pub fn pd9(&mut self) -> _PD9W {
                _PD9W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.10"]
            #[inline]
            pub fn pd10(&mut self) -> _PD10W {
                _PD10W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.11"]
            #[inline]
            pub fn pd11(&mut self) -> _PD11W {
                _PD11W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.12"]
            #[inline]
            pub fn pd12(&mut self) -> _PD12W {
                _PD12W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.13"]
            #[inline]
            pub fn pd13(&mut self) -> _PD13W {
                _PD13W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.14"]
            #[inline]
            pub fn pd14(&mut self) -> _PD14W {
                _PD14W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.15"]
            #[inline]
            pub fn pd15(&mut self) -> _PD15W {
                _PD15W { w: self }
            }
        }
    }
    #[doc = "Port 0 Pin Function Decision Control Register"]
    pub struct PDISC {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Pin Function Decision Control Register"]
    pub mod pdisc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PDISC {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PDIS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS0R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS0R::VALUE1 => false,
                    PDIS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS0R {
                match value {
                    false => PDIS0R::VALUE1,
                    true => PDIS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS1R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS1R::VALUE1 => false,
                    PDIS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS1R {
                match value {
                    false => PDIS1R::VALUE1,
                    true => PDIS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS2R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS2R::VALUE1 => false,
                    PDIS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS2R {
                match value {
                    false => PDIS2R::VALUE1,
                    true => PDIS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS3R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS3R::VALUE1 => false,
                    PDIS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS3R {
                match value {
                    false => PDIS3R::VALUE1,
                    true => PDIS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS4R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS4R::VALUE1 => false,
                    PDIS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS4R {
                match value {
                    false => PDIS4R::VALUE1,
                    true => PDIS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS5R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS5R::VALUE1 => false,
                    PDIS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS5R {
                match value {
                    false => PDIS5R::VALUE1,
                    true => PDIS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS6R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS6R::VALUE1 => false,
                    PDIS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS6R {
                match value {
                    false => PDIS6R::VALUE1,
                    true => PDIS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS7R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS7R::VALUE1 => false,
                    PDIS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS7R {
                match value {
                    false => PDIS7R::VALUE1,
                    true => PDIS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS8R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS8R::VALUE1 => false,
                    PDIS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS8R {
                match value {
                    false => PDIS8R::VALUE1,
                    true => PDIS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS9R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS9R::VALUE1 => false,
                    PDIS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS9R {
                match value {
                    false => PDIS9R::VALUE1,
                    true => PDIS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS10R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS10R::VALUE1 => false,
                    PDIS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS10R {
                match value {
                    false => PDIS10R::VALUE1,
                    true => PDIS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS11R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS11R::VALUE1 => false,
                    PDIS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS11R {
                match value {
                    false => PDIS11R::VALUE1,
                    true => PDIS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS12R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS12R::VALUE1 => false,
                    PDIS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS12R {
                match value {
                    false => PDIS12R::VALUE1,
                    true => PDIS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS13R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS13R::VALUE1 => false,
                    PDIS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS13R {
                match value {
                    false => PDIS13R::VALUE1,
                    true => PDIS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS14R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS14R::VALUE1 => false,
                    PDIS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS14R {
                match value {
                    false => PDIS14R::VALUE1,
                    true => PDIS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS15R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS15R::VALUE1 => false,
                    PDIS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS15R {
                match value {
                    false => PDIS15R::VALUE1,
                    true => PDIS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Pad Disable for Port n Pin 0"]
            #[inline]
            pub fn pdis0(&self) -> PDIS0R {
                PDIS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Pad Disable for Port n Pin 1"]
            #[inline]
            pub fn pdis1(&self) -> PDIS1R {
                PDIS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Pad Disable for Port n Pin 2"]
            #[inline]
            pub fn pdis2(&self) -> PDIS2R {
                PDIS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Pad Disable for Port n Pin 3"]
            #[inline]
            pub fn pdis3(&self) -> PDIS3R {
                PDIS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Pad Disable for Port n Pin 4"]
            #[inline]
            pub fn pdis4(&self) -> PDIS4R {
                PDIS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Pad Disable for Port n Pin 5"]
            #[inline]
            pub fn pdis5(&self) -> PDIS5R {
                PDIS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Pad Disable for Port n Pin 6"]
            #[inline]
            pub fn pdis6(&self) -> PDIS6R {
                PDIS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Pad Disable for Port n Pin 7"]
            #[inline]
            pub fn pdis7(&self) -> PDIS7R {
                PDIS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Pad Disable for Port n Pin 8"]
            #[inline]
            pub fn pdis8(&self) -> PDIS8R {
                PDIS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Pad Disable for Port n Pin 9"]
            #[inline]
            pub fn pdis9(&self) -> PDIS9R {
                PDIS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Pad Disable for Port n Pin 10"]
            #[inline]
            pub fn pdis10(&self) -> PDIS10R {
                PDIS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Pad Disable for Port n Pin 11"]
            #[inline]
            pub fn pdis11(&self) -> PDIS11R {
                PDIS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Pad Disable for Port n Pin 12"]
            #[inline]
            pub fn pdis12(&self) -> PDIS12R {
                PDIS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Pad Disable for Port n Pin 13"]
            #[inline]
            pub fn pdis13(&self) -> PDIS13R {
                PDIS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Pad Disable for Port n Pin 14"]
            #[inline]
            pub fn pdis14(&self) -> PDIS14R {
                PDIS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Pad Disable for Port n Pin 15"]
            #[inline]
            pub fn pdis15(&self) -> PDIS15R {
                PDIS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 0 Pin Power Save Register"]
    pub struct PPS {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Pin Power Save Register"]
    pub mod pps {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PPS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PPS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS0R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS0R::VALUE1 => false,
                    PPS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS0R {
                match value {
                    false => PPS0R::VALUE1,
                    true => PPS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS1R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS1R::VALUE1 => false,
                    PPS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS1R {
                match value {
                    false => PPS1R::VALUE1,
                    true => PPS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS2R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS2R::VALUE1 => false,
                    PPS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS2R {
                match value {
                    false => PPS2R::VALUE1,
                    true => PPS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS3R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS3R::VALUE1 => false,
                    PPS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS3R {
                match value {
                    false => PPS3R::VALUE1,
                    true => PPS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS4R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS4R::VALUE1 => false,
                    PPS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS4R {
                match value {
                    false => PPS4R::VALUE1,
                    true => PPS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS5R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS5R::VALUE1 => false,
                    PPS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS5R {
                match value {
                    false => PPS5R::VALUE1,
                    true => PPS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS6R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS6R::VALUE1 => false,
                    PPS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS6R {
                match value {
                    false => PPS6R::VALUE1,
                    true => PPS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS7R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS7R::VALUE1 => false,
                    PPS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS7R {
                match value {
                    false => PPS7R::VALUE1,
                    true => PPS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS8R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS8R::VALUE1 => false,
                    PPS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS8R {
                match value {
                    false => PPS8R::VALUE1,
                    true => PPS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS9R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS9R::VALUE1 => false,
                    PPS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS9R {
                match value {
                    false => PPS9R::VALUE1,
                    true => PPS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS10R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS10R::VALUE1 => false,
                    PPS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS10R {
                match value {
                    false => PPS10R::VALUE1,
                    true => PPS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS11R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS11R::VALUE1 => false,
                    PPS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS11R {
                match value {
                    false => PPS11R::VALUE1,
                    true => PPS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS12R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS12R::VALUE1 => false,
                    PPS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS12R {
                match value {
                    false => PPS12R::VALUE1,
                    true => PPS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS13R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS13R::VALUE1 => false,
                    PPS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS13R {
                match value {
                    false => PPS13R::VALUE1,
                    true => PPS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS14R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS14R::VALUE1 => false,
                    PPS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS14R {
                match value {
                    false => PPS14R::VALUE1,
                    true => PPS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS15R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS15R::VALUE1 => false,
                    PPS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS15R {
                match value {
                    false => PPS15R::VALUE1,
                    true => PPS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PPS0`"]
        pub enum PPS0W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS0W::VALUE1 => false,
                    PPS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS0W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS1`"]
        pub enum PPS1W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS1W::VALUE1 => false,
                    PPS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS1W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS2`"]
        pub enum PPS2W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS2W::VALUE1 => false,
                    PPS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS2W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS3`"]
        pub enum PPS3W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS3W::VALUE1 => false,
                    PPS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS3W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS4`"]
        pub enum PPS4W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS4W::VALUE1 => false,
                    PPS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS4W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS5`"]
        pub enum PPS5W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS5W::VALUE1 => false,
                    PPS5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS5W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS6`"]
        pub enum PPS6W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS6W::VALUE1 => false,
                    PPS6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS6W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS7`"]
        pub enum PPS7W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS7W::VALUE1 => false,
                    PPS7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS7W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS8`"]
        pub enum PPS8W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS8W::VALUE1 => false,
                    PPS8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS8W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS9`"]
        pub enum PPS9W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS9W::VALUE1 => false,
                    PPS9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS9W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS10`"]
        pub enum PPS10W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS10W::VALUE1 => false,
                    PPS10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS10W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS11`"]
        pub enum PPS11W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS11W::VALUE1 => false,
                    PPS11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS11W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS12`"]
        pub enum PPS12W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS12W::VALUE1 => false,
                    PPS12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS12W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS13`"]
        pub enum PPS13W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS13W::VALUE1 => false,
                    PPS13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS13W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS14`"]
        pub enum PPS14W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS14W::VALUE1 => false,
                    PPS14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS14W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS15`"]
        pub enum PPS15W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS15W::VALUE1 => false,
                    PPS15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS15W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&self) -> PPS0R {
                PPS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&self) -> PPS1R {
                PPS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&self) -> PPS2R {
                PPS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&self) -> PPS3R {
                PPS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&self) -> PPS4R {
                PPS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&self) -> PPS5R {
                PPS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&self) -> PPS6R {
                PPS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&self) -> PPS7R {
                PPS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&self) -> PPS8R {
                PPS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&self) -> PPS9R {
                PPS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&self) -> PPS10R {
                PPS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&self) -> PPS11R {
                PPS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&self) -> PPS12R {
                PPS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&self) -> PPS13R {
                PPS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&self) -> PPS14R {
                PPS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&self) -> PPS15R {
                PPS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&mut self) -> _PPS0W {
                _PPS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&mut self) -> _PPS1W {
                _PPS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&mut self) -> _PPS2W {
                _PPS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&mut self) -> _PPS3W {
                _PPS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&mut self) -> _PPS4W {
                _PPS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&mut self) -> _PPS5W {
                _PPS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&mut self) -> _PPS6W {
                _PPS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&mut self) -> _PPS7W {
                _PPS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&mut self) -> _PPS8W {
                _PPS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&mut self) -> _PPS9W {
                _PPS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&mut self) -> _PPS10W {
                _PPS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&mut self) -> _PPS11W {
                _PPS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&mut self) -> _PPS12W {
                _PPS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&mut self) -> _PPS13W {
                _PPS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&mut self) -> _PPS14W {
                _PPS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&mut self) -> _PPS15W {
                _PPS15W { w: self }
            }
        }
    }
    #[doc = "Port 0 Pin Hardware Select Register"]
    pub struct HWSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 0 Pin Hardware Select Register"]
    pub mod hwsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HWSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HW0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW0R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW0R::VALUE1 => 0,
                    HW0R::VALUE2 => 0x01,
                    HW0R::VALUE3 => 0x02,
                    HW0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW0R {
                match value {
                    0 => HW0R::VALUE1,
                    1 => HW0R::VALUE2,
                    2 => HW0R::VALUE3,
                    i => HW0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW0R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW1R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW1R::VALUE1 => 0,
                    HW1R::VALUE2 => 0x01,
                    HW1R::VALUE3 => 0x02,
                    HW1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW1R {
                match value {
                    0 => HW1R::VALUE1,
                    1 => HW1R::VALUE2,
                    2 => HW1R::VALUE3,
                    i => HW1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW1R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW2R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW2R::VALUE1 => 0,
                    HW2R::VALUE2 => 0x01,
                    HW2R::VALUE3 => 0x02,
                    HW2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW2R {
                match value {
                    0 => HW2R::VALUE1,
                    1 => HW2R::VALUE2,
                    2 => HW2R::VALUE3,
                    i => HW2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW2R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW3R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW3R::VALUE1 => 0,
                    HW3R::VALUE2 => 0x01,
                    HW3R::VALUE3 => 0x02,
                    HW3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW3R {
                match value {
                    0 => HW3R::VALUE1,
                    1 => HW3R::VALUE2,
                    2 => HW3R::VALUE3,
                    i => HW3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW3R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW4R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW4R::VALUE1 => 0,
                    HW4R::VALUE2 => 0x01,
                    HW4R::VALUE3 => 0x02,
                    HW4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW4R {
                match value {
                    0 => HW4R::VALUE1,
                    1 => HW4R::VALUE2,
                    2 => HW4R::VALUE3,
                    i => HW4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW4R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW5R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW5R::VALUE1 => 0,
                    HW5R::VALUE2 => 0x01,
                    HW5R::VALUE3 => 0x02,
                    HW5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW5R {
                match value {
                    0 => HW5R::VALUE1,
                    1 => HW5R::VALUE2,
                    2 => HW5R::VALUE3,
                    i => HW5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW5R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW6R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW6R::VALUE1 => 0,
                    HW6R::VALUE2 => 0x01,
                    HW6R::VALUE3 => 0x02,
                    HW6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW6R {
                match value {
                    0 => HW6R::VALUE1,
                    1 => HW6R::VALUE2,
                    2 => HW6R::VALUE3,
                    i => HW6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW6R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW7R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW7R::VALUE1 => 0,
                    HW7R::VALUE2 => 0x01,
                    HW7R::VALUE3 => 0x02,
                    HW7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW7R {
                match value {
                    0 => HW7R::VALUE1,
                    1 => HW7R::VALUE2,
                    2 => HW7R::VALUE3,
                    i => HW7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW7R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW8R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW8R::VALUE1 => 0,
                    HW8R::VALUE2 => 0x01,
                    HW8R::VALUE3 => 0x02,
                    HW8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW8R {
                match value {
                    0 => HW8R::VALUE1,
                    1 => HW8R::VALUE2,
                    2 => HW8R::VALUE3,
                    i => HW8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW8R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW9R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW9R::VALUE1 => 0,
                    HW9R::VALUE2 => 0x01,
                    HW9R::VALUE3 => 0x02,
                    HW9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW9R {
                match value {
                    0 => HW9R::VALUE1,
                    1 => HW9R::VALUE2,
                    2 => HW9R::VALUE3,
                    i => HW9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW9R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW10R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW10R::VALUE1 => 0,
                    HW10R::VALUE2 => 0x01,
                    HW10R::VALUE3 => 0x02,
                    HW10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW10R {
                match value {
                    0 => HW10R::VALUE1,
                    1 => HW10R::VALUE2,
                    2 => HW10R::VALUE3,
                    i => HW10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW10R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW11R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW11R::VALUE1 => 0,
                    HW11R::VALUE2 => 0x01,
                    HW11R::VALUE3 => 0x02,
                    HW11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW11R {
                match value {
                    0 => HW11R::VALUE1,
                    1 => HW11R::VALUE2,
                    2 => HW11R::VALUE3,
                    i => HW11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW11R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW12R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW12R::VALUE1 => 0,
                    HW12R::VALUE2 => 0x01,
                    HW12R::VALUE3 => 0x02,
                    HW12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW12R {
                match value {
                    0 => HW12R::VALUE1,
                    1 => HW12R::VALUE2,
                    2 => HW12R::VALUE3,
                    i => HW12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW12R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW13R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW13R::VALUE1 => 0,
                    HW13R::VALUE2 => 0x01,
                    HW13R::VALUE3 => 0x02,
                    HW13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW13R {
                match value {
                    0 => HW13R::VALUE1,
                    1 => HW13R::VALUE2,
                    2 => HW13R::VALUE3,
                    i => HW13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW13R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW14R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW14R::VALUE1 => 0,
                    HW14R::VALUE2 => 0x01,
                    HW14R::VALUE3 => 0x02,
                    HW14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW14R {
                match value {
                    0 => HW14R::VALUE1,
                    1 => HW14R::VALUE2,
                    2 => HW14R::VALUE3,
                    i => HW14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW14R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW15R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW15R::VALUE1 => 0,
                    HW15R::VALUE2 => 0x01,
                    HW15R::VALUE3 => 0x02,
                    HW15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW15R {
                match value {
                    0 => HW15R::VALUE1,
                    1 => HW15R::VALUE2,
                    2 => HW15R::VALUE3,
                    i => HW15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW15R::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `HW0`"]
        pub enum HW0W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW0W::VALUE1 => 0,
                    HW0W::VALUE2 => 1,
                    HW0W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW0W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW0W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW0W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW1`"]
        pub enum HW1W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW1W::VALUE1 => 0,
                    HW1W::VALUE2 => 1,
                    HW1W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW1W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW1W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW1W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW2`"]
        pub enum HW2W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW2W::VALUE1 => 0,
                    HW2W::VALUE2 => 1,
                    HW2W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW2W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW2W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW2W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW3`"]
        pub enum HW3W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW3W::VALUE1 => 0,
                    HW3W::VALUE2 => 1,
                    HW3W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW3W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW3W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW3W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW4`"]
        pub enum HW4W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW4W::VALUE1 => 0,
                    HW4W::VALUE2 => 1,
                    HW4W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW4W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW4W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW4W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW5`"]
        pub enum HW5W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW5W::VALUE1 => 0,
                    HW5W::VALUE2 => 1,
                    HW5W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW5W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW5W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW5W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW6`"]
        pub enum HW6W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW6W::VALUE1 => 0,
                    HW6W::VALUE2 => 1,
                    HW6W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW6W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW6W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW6W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW7`"]
        pub enum HW7W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW7W::VALUE1 => 0,
                    HW7W::VALUE2 => 1,
                    HW7W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW7W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW7W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW7W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW8`"]
        pub enum HW8W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW8W::VALUE1 => 0,
                    HW8W::VALUE2 => 1,
                    HW8W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW8W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW8W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW8W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW9`"]
        pub enum HW9W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW9W::VALUE1 => 0,
                    HW9W::VALUE2 => 1,
                    HW9W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW9W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW9W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW9W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW10`"]
        pub enum HW10W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW10W::VALUE1 => 0,
                    HW10W::VALUE2 => 1,
                    HW10W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW10W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW10W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW10W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW11`"]
        pub enum HW11W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW11W::VALUE1 => 0,
                    HW11W::VALUE2 => 1,
                    HW11W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW11W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW11W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW11W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW12`"]
        pub enum HW12W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW12W::VALUE1 => 0,
                    HW12W::VALUE2 => 1,
                    HW12W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW12W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW12W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW12W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW13`"]
        pub enum HW13W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW13W::VALUE1 => 0,
                    HW13W::VALUE2 => 1,
                    HW13W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW13W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW13W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW13W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW14`"]
        pub enum HW14W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW14W::VALUE1 => 0,
                    HW14W::VALUE2 => 1,
                    HW14W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW14W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW14W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW14W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW15`"]
        pub enum HW15W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW15W::VALUE1 => 0,
                    HW15W::VALUE2 => 1,
                    HW15W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW15W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW15W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW15W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&self) -> HW0R {
                HW0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&self) -> HW1R {
                HW1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&self) -> HW2R {
                HW2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&self) -> HW3R {
                HW3R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&self) -> HW4R {
                HW4R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&self) -> HW5R {
                HW5R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&self) -> HW6R {
                HW6R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&self) -> HW7R {
                HW7R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&self) -> HW8R {
                HW8R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&self) -> HW9R {
                HW9R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&self) -> HW10R {
                HW10R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&self) -> HW11R {
                HW11R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&self) -> HW12R {
                HW12R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&self) -> HW13R {
                HW13R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&self) -> HW14R {
                HW14R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&self) -> HW15R {
                HW15R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x0001_4000 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&mut self) -> _HW0W {
                _HW0W { w: self }
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&mut self) -> _HW1W {
                _HW1W { w: self }
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&mut self) -> _HW2W {
                _HW2W { w: self }
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&mut self) -> _HW3W {
                _HW3W { w: self }
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&mut self) -> _HW4W {
                _HW4W { w: self }
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&mut self) -> _HW5W {
                _HW5W { w: self }
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&mut self) -> _HW6W {
                _HW6W { w: self }
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&mut self) -> _HW7W {
                _HW7W { w: self }
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&mut self) -> _HW8W {
                _HW8W { w: self }
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&mut self) -> _HW9W {
                _HW9W { w: self }
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&mut self) -> _HW10W {
                _HW10W { w: self }
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&mut self) -> _HW11W {
                _HW11W { w: self }
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&mut self) -> _HW12W {
                _HW12W { w: self }
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&mut self) -> _HW13W {
                _HW13W { w: self }
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&mut self) -> _HW14W {
                _HW14W { w: self }
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&mut self) -> _HW15W {
                _HW15W { w: self }
            }
        }
    }
}
#[doc = "Port 0"]
pub struct PORT0 {
    register_block: port0::RegisterBlock,
}
impl Deref for PORT0 {
    type Target = port0::RegisterBlock;
    fn deref(&self) -> &port0::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Port 1"]
pub const PORT1: Peripheral<PORT1> = unsafe { Peripheral::new(0x4802_8100) };
#[doc = "Port 1"]
pub mod port1 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Port 1 Output Register"]
        pub out: OUT,
        #[doc = "0x04 - Port 1 Output Modification Register"]
        pub omr: OMR,
        _reserved0: [u8; 8usize],
        #[doc = "0x10 - Port 1 Input/Output Control Register 0"]
        pub iocr0: IOCR0,
        #[doc = "0x14 - Port 1 Input/Output Control Register 4"]
        pub iocr4: IOCR4,
        #[doc = "0x18 - Port 1 Input/Output Control Register 8"]
        pub iocr8: IOCR8,
        #[doc = "0x1c - Port 1 Input/Output Control Register 12"]
        pub iocr12: IOCR12,
        _reserved1: [u8; 4usize],
        #[doc = "0x24 - Port 1 Input Register"]
        pub in_: IN,
        _reserved2: [u8; 24usize],
        #[doc = "0x40 - Port 1 Pad Driver Mode 0 Register"]
        pub pdr0: PDR0,
        #[doc = "0x44 - Port 1 Pad Driver Mode 1 Register"]
        pub pdr1: PDR1,
        _reserved3: [u8; 24usize],
        #[doc = "0x60 - Port 1 Pin Function Decision Control Register"]
        pub pdisc: PDISC,
        _reserved4: [u8; 12usize],
        #[doc = "0x70 - Port 1 Pin Power Save Register"]
        pub pps: PPS,
        #[doc = "0x74 - Port 1 Pin Hardware Select Register"]
        pub hwsel: HWSEL,
    }
    #[doc = "Port 1 Output Register"]
    pub struct OUT {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Output Register"]
    pub mod out {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OUT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `P0`"]
        pub enum P0W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P0W::VALUE1 => false,
                    P0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P0W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P1`"]
        pub enum P1W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P1W::VALUE1 => false,
                    P1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P1W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P2`"]
        pub enum P2W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P2W::VALUE1 => false,
                    P2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P2W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P3`"]
        pub enum P3W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P3W::VALUE1 => false,
                    P3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P3W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P4`"]
        pub enum P4W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P4W::VALUE1 => false,
                    P4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P4W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P5`"]
        pub enum P5W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P5W::VALUE1 => false,
                    P5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P5W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P6`"]
        pub enum P6W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P6W::VALUE1 => false,
                    P6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P6W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P7`"]
        pub enum P7W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P7W::VALUE1 => false,
                    P7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P7W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P8`"]
        pub enum P8W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P8W::VALUE1 => false,
                    P8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P8W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P9`"]
        pub enum P9W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P9W::VALUE1 => false,
                    P9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P9W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P10`"]
        pub enum P10W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P10W::VALUE1 => false,
                    P10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P10W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P11`"]
        pub enum P11W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P11W::VALUE1 => false,
                    P11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P11W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P12`"]
        pub enum P12W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P12W::VALUE1 => false,
                    P12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P12W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P13`"]
        pub enum P13W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P13W::VALUE1 => false,
                    P13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P13W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P14`"]
        pub enum P14W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P14W::VALUE1 => false,
                    P14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P14W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P15`"]
        pub enum P15W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P15W::VALUE1 => false,
                    P15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P15W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&mut self) -> _P0W {
                _P0W { w: self }
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&mut self) -> _P1W {
                _P1W { w: self }
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&mut self) -> _P2W {
                _P2W { w: self }
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&mut self) -> _P3W {
                _P3W { w: self }
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&mut self) -> _P4W {
                _P4W { w: self }
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&mut self) -> _P5W {
                _P5W { w: self }
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&mut self) -> _P6W {
                _P6W { w: self }
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&mut self) -> _P7W {
                _P7W { w: self }
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&mut self) -> _P8W {
                _P8W { w: self }
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&mut self) -> _P9W {
                _P9W { w: self }
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&mut self) -> _P10W {
                _P10W { w: self }
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&mut self) -> _P11W {
                _P11W { w: self }
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&mut self) -> _P12W {
                _P12W { w: self }
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&mut self) -> _P13W {
                _P13W { w: self }
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&mut self) -> _P14W {
                _P14W { w: self }
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&mut self) -> _P15W {
                _P15W { w: self }
            }
        }
    }
    #[doc = "Port 1 Output Modification Register"]
    pub struct OMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Output Modification Register"]
    pub mod omr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OMR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Set Bit 0"]
            #[inline]
            pub fn ps0(&mut self) -> _PS0W {
                _PS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Set Bit 1"]
            #[inline]
            pub fn ps1(&mut self) -> _PS1W {
                _PS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Set Bit 2"]
            #[inline]
            pub fn ps2(&mut self) -> _PS2W {
                _PS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Set Bit 3"]
            #[inline]
            pub fn ps3(&mut self) -> _PS3W {
                _PS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Set Bit 4"]
            #[inline]
            pub fn ps4(&mut self) -> _PS4W {
                _PS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Set Bit 5"]
            #[inline]
            pub fn ps5(&mut self) -> _PS5W {
                _PS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Set Bit 6"]
            #[inline]
            pub fn ps6(&mut self) -> _PS6W {
                _PS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Set Bit 7"]
            #[inline]
            pub fn ps7(&mut self) -> _PS7W {
                _PS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Set Bit 8"]
            #[inline]
            pub fn ps8(&mut self) -> _PS8W {
                _PS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Set Bit 9"]
            #[inline]
            pub fn ps9(&mut self) -> _PS9W {
                _PS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Set Bit 10"]
            #[inline]
            pub fn ps10(&mut self) -> _PS10W {
                _PS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Set Bit 11"]
            #[inline]
            pub fn ps11(&mut self) -> _PS11W {
                _PS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Set Bit 12"]
            #[inline]
            pub fn ps12(&mut self) -> _PS12W {
                _PS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Set Bit 13"]
            #[inline]
            pub fn ps13(&mut self) -> _PS13W {
                _PS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Set Bit 14"]
            #[inline]
            pub fn ps14(&mut self) -> _PS14W {
                _PS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Set Bit 15"]
            #[inline]
            pub fn ps15(&mut self) -> _PS15W {
                _PS15W { w: self }
            }
            #[doc = "Bit 16 - Port n Reset Bit 0"]
            #[inline]
            pub fn pr0(&mut self) -> _PR0W {
                _PR0W { w: self }
            }
            #[doc = "Bit 17 - Port n Reset Bit 1"]
            #[inline]
            pub fn pr1(&mut self) -> _PR1W {
                _PR1W { w: self }
            }
            #[doc = "Bit 18 - Port n Reset Bit 2"]
            #[inline]
            pub fn pr2(&mut self) -> _PR2W {
                _PR2W { w: self }
            }
            #[doc = "Bit 19 - Port n Reset Bit 3"]
            #[inline]
            pub fn pr3(&mut self) -> _PR3W {
                _PR3W { w: self }
            }
            #[doc = "Bit 20 - Port n Reset Bit 4"]
            #[inline]
            pub fn pr4(&mut self) -> _PR4W {
                _PR4W { w: self }
            }
            #[doc = "Bit 21 - Port n Reset Bit 5"]
            #[inline]
            pub fn pr5(&mut self) -> _PR5W {
                _PR5W { w: self }
            }
            #[doc = "Bit 22 - Port n Reset Bit 6"]
            #[inline]
            pub fn pr6(&mut self) -> _PR6W {
                _PR6W { w: self }
            }
            #[doc = "Bit 23 - Port n Reset Bit 7"]
            #[inline]
            pub fn pr7(&mut self) -> _PR7W {
                _PR7W { w: self }
            }
            #[doc = "Bit 24 - Port n Reset Bit 8"]
            #[inline]
            pub fn pr8(&mut self) -> _PR8W {
                _PR8W { w: self }
            }
            #[doc = "Bit 25 - Port n Reset Bit 9"]
            #[inline]
            pub fn pr9(&mut self) -> _PR9W {
                _PR9W { w: self }
            }
            #[doc = "Bit 26 - Port n Reset Bit 10"]
            #[inline]
            pub fn pr10(&mut self) -> _PR10W {
                _PR10W { w: self }
            }
            #[doc = "Bit 27 - Port n Reset Bit 11"]
            #[inline]
            pub fn pr11(&mut self) -> _PR11W {
                _PR11W { w: self }
            }
            #[doc = "Bit 28 - Port n Reset Bit 12"]
            #[inline]
            pub fn pr12(&mut self) -> _PR12W {
                _PR12W { w: self }
            }
            #[doc = "Bit 29 - Port n Reset Bit 13"]
            #[inline]
            pub fn pr13(&mut self) -> _PR13W {
                _PR13W { w: self }
            }
            #[doc = "Bit 30 - Port n Reset Bit 14"]
            #[inline]
            pub fn pr14(&mut self) -> _PR14W {
                _PR14W { w: self }
            }
            #[doc = "Bit 31 - Port n Reset Bit 15"]
            #[inline]
            pub fn pr15(&mut self) -> _PR15W {
                _PR15W { w: self }
            }
        }
    }
    #[doc = "Port 1 Input/Output Control Register 0"]
    pub struct IOCR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Input/Output Control Register 0"]
    pub mod iocr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC0R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC0R::VALUE1 => 0,
                    PC0R::VALUE2 => 0x01,
                    PC0R::VALUE3 => 0x02,
                    PC0R::VALUE4 => 0x03,
                    PC0R::VALUE5 => 0x04,
                    PC0R::VALUE6 => 0x05,
                    PC0R::VALUE7 => 0x06,
                    PC0R::VALUE8 => 0x07,
                    PC0R::VALUE9 => 0x10,
                    PC0R::VALUE10 => 0x11,
                    PC0R::VALUE11 => 0x12,
                    PC0R::VALUE12 => 0x13,
                    PC0R::VALUE13 => 0x14,
                    PC0R::VALUE14 => 0x18,
                    PC0R::VALUE15 => 0x19,
                    PC0R::VALUE16 => 0x1a,
                    PC0R::VALUE17 => 0x1b,
                    PC0R::VALUE18 => 0x1c,
                    PC0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC0R {
                match value {
                    0 => PC0R::VALUE1,
                    1 => PC0R::VALUE2,
                    2 => PC0R::VALUE3,
                    3 => PC0R::VALUE4,
                    4 => PC0R::VALUE5,
                    5 => PC0R::VALUE6,
                    6 => PC0R::VALUE7,
                    7 => PC0R::VALUE8,
                    16 => PC0R::VALUE9,
                    17 => PC0R::VALUE10,
                    18 => PC0R::VALUE11,
                    19 => PC0R::VALUE12,
                    20 => PC0R::VALUE13,
                    24 => PC0R::VALUE14,
                    25 => PC0R::VALUE15,
                    26 => PC0R::VALUE16,
                    27 => PC0R::VALUE17,
                    28 => PC0R::VALUE18,
                    i => PC0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC0R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC0R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC0R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC0R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC0R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC0R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC0R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC0R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC0R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC0R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC0R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC0R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC0R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC0R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC0R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC1R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC1R::VALUE1 => 0,
                    PC1R::VALUE2 => 0x01,
                    PC1R::VALUE3 => 0x02,
                    PC1R::VALUE4 => 0x03,
                    PC1R::VALUE5 => 0x04,
                    PC1R::VALUE6 => 0x05,
                    PC1R::VALUE7 => 0x06,
                    PC1R::VALUE8 => 0x07,
                    PC1R::VALUE9 => 0x10,
                    PC1R::VALUE10 => 0x11,
                    PC1R::VALUE11 => 0x12,
                    PC1R::VALUE12 => 0x13,
                    PC1R::VALUE13 => 0x14,
                    PC1R::VALUE14 => 0x18,
                    PC1R::VALUE15 => 0x19,
                    PC1R::VALUE16 => 0x1a,
                    PC1R::VALUE17 => 0x1b,
                    PC1R::VALUE18 => 0x1c,
                    PC1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC1R {
                match value {
                    0 => PC1R::VALUE1,
                    1 => PC1R::VALUE2,
                    2 => PC1R::VALUE3,
                    3 => PC1R::VALUE4,
                    4 => PC1R::VALUE5,
                    5 => PC1R::VALUE6,
                    6 => PC1R::VALUE7,
                    7 => PC1R::VALUE8,
                    16 => PC1R::VALUE9,
                    17 => PC1R::VALUE10,
                    18 => PC1R::VALUE11,
                    19 => PC1R::VALUE12,
                    20 => PC1R::VALUE13,
                    24 => PC1R::VALUE14,
                    25 => PC1R::VALUE15,
                    26 => PC1R::VALUE16,
                    27 => PC1R::VALUE17,
                    28 => PC1R::VALUE18,
                    i => PC1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC1R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC1R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC1R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC1R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC1R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC1R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC1R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC1R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC1R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC1R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC1R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC1R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC1R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC1R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC1R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC2R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC2R::VALUE1 => 0,
                    PC2R::VALUE2 => 0x01,
                    PC2R::VALUE3 => 0x02,
                    PC2R::VALUE4 => 0x03,
                    PC2R::VALUE5 => 0x04,
                    PC2R::VALUE6 => 0x05,
                    PC2R::VALUE7 => 0x06,
                    PC2R::VALUE8 => 0x07,
                    PC2R::VALUE9 => 0x10,
                    PC2R::VALUE10 => 0x11,
                    PC2R::VALUE11 => 0x12,
                    PC2R::VALUE12 => 0x13,
                    PC2R::VALUE13 => 0x14,
                    PC2R::VALUE14 => 0x18,
                    PC2R::VALUE15 => 0x19,
                    PC2R::VALUE16 => 0x1a,
                    PC2R::VALUE17 => 0x1b,
                    PC2R::VALUE18 => 0x1c,
                    PC2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC2R {
                match value {
                    0 => PC2R::VALUE1,
                    1 => PC2R::VALUE2,
                    2 => PC2R::VALUE3,
                    3 => PC2R::VALUE4,
                    4 => PC2R::VALUE5,
                    5 => PC2R::VALUE6,
                    6 => PC2R::VALUE7,
                    7 => PC2R::VALUE8,
                    16 => PC2R::VALUE9,
                    17 => PC2R::VALUE10,
                    18 => PC2R::VALUE11,
                    19 => PC2R::VALUE12,
                    20 => PC2R::VALUE13,
                    24 => PC2R::VALUE14,
                    25 => PC2R::VALUE15,
                    26 => PC2R::VALUE16,
                    27 => PC2R::VALUE17,
                    28 => PC2R::VALUE18,
                    i => PC2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC2R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC2R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC2R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC2R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC2R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC2R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC2R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC2R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC2R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC2R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC2R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC2R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC2R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC2R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC2R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC3R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC3R::VALUE1 => 0,
                    PC3R::VALUE2 => 0x01,
                    PC3R::VALUE3 => 0x02,
                    PC3R::VALUE4 => 0x03,
                    PC3R::VALUE5 => 0x04,
                    PC3R::VALUE6 => 0x05,
                    PC3R::VALUE7 => 0x06,
                    PC3R::VALUE8 => 0x07,
                    PC3R::VALUE9 => 0x10,
                    PC3R::VALUE10 => 0x11,
                    PC3R::VALUE11 => 0x12,
                    PC3R::VALUE12 => 0x13,
                    PC3R::VALUE13 => 0x14,
                    PC3R::VALUE14 => 0x18,
                    PC3R::VALUE15 => 0x19,
                    PC3R::VALUE16 => 0x1a,
                    PC3R::VALUE17 => 0x1b,
                    PC3R::VALUE18 => 0x1c,
                    PC3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC3R {
                match value {
                    0 => PC3R::VALUE1,
                    1 => PC3R::VALUE2,
                    2 => PC3R::VALUE3,
                    3 => PC3R::VALUE4,
                    4 => PC3R::VALUE5,
                    5 => PC3R::VALUE6,
                    6 => PC3R::VALUE7,
                    7 => PC3R::VALUE8,
                    16 => PC3R::VALUE9,
                    17 => PC3R::VALUE10,
                    18 => PC3R::VALUE11,
                    19 => PC3R::VALUE12,
                    20 => PC3R::VALUE13,
                    24 => PC3R::VALUE14,
                    25 => PC3R::VALUE15,
                    26 => PC3R::VALUE16,
                    27 => PC3R::VALUE17,
                    28 => PC3R::VALUE18,
                    i => PC3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC3R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC3R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC3R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC3R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC3R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC3R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC3R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC3R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC3R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC3R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC3R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC3R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC3R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC3R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC3R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC3R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC0`"]
        pub enum PC0W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC0W::VALUE1 => 0,
                    PC0W::VALUE2 => 1,
                    PC0W::VALUE3 => 2,
                    PC0W::VALUE4 => 3,
                    PC0W::VALUE5 => 4,
                    PC0W::VALUE6 => 5,
                    PC0W::VALUE7 => 6,
                    PC0W::VALUE8 => 7,
                    PC0W::VALUE9 => 16,
                    PC0W::VALUE10 => 17,
                    PC0W::VALUE11 => 18,
                    PC0W::VALUE12 => 19,
                    PC0W::VALUE13 => 20,
                    PC0W::VALUE14 => 24,
                    PC0W::VALUE15 => 25,
                    PC0W::VALUE16 => 26,
                    PC0W::VALUE17 => 27,
                    PC0W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC0W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC0W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC0W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC0W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC0W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC0W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC0W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC0W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC0W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC0W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC0W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC0W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC0W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC0W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC0W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC0W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC0W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC0W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC1`"]
        pub enum PC1W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC1W::VALUE1 => 0,
                    PC1W::VALUE2 => 1,
                    PC1W::VALUE3 => 2,
                    PC1W::VALUE4 => 3,
                    PC1W::VALUE5 => 4,
                    PC1W::VALUE6 => 5,
                    PC1W::VALUE7 => 6,
                    PC1W::VALUE8 => 7,
                    PC1W::VALUE9 => 16,
                    PC1W::VALUE10 => 17,
                    PC1W::VALUE11 => 18,
                    PC1W::VALUE12 => 19,
                    PC1W::VALUE13 => 20,
                    PC1W::VALUE14 => 24,
                    PC1W::VALUE15 => 25,
                    PC1W::VALUE16 => 26,
                    PC1W::VALUE17 => 27,
                    PC1W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC1W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC1W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC1W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC1W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC1W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC1W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC1W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC1W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC1W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC1W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC1W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC1W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC1W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC1W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC1W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC1W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC1W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC1W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC2`"]
        pub enum PC2W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC2W::VALUE1 => 0,
                    PC2W::VALUE2 => 1,
                    PC2W::VALUE3 => 2,
                    PC2W::VALUE4 => 3,
                    PC2W::VALUE5 => 4,
                    PC2W::VALUE6 => 5,
                    PC2W::VALUE7 => 6,
                    PC2W::VALUE8 => 7,
                    PC2W::VALUE9 => 16,
                    PC2W::VALUE10 => 17,
                    PC2W::VALUE11 => 18,
                    PC2W::VALUE12 => 19,
                    PC2W::VALUE13 => 20,
                    PC2W::VALUE14 => 24,
                    PC2W::VALUE15 => 25,
                    PC2W::VALUE16 => 26,
                    PC2W::VALUE17 => 27,
                    PC2W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC2W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC2W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC2W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC2W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC2W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC2W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC2W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC2W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC2W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC2W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC2W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC2W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC2W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC2W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC2W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC2W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC2W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC2W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC3`"]
        pub enum PC3W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC3W::VALUE1 => 0,
                    PC3W::VALUE2 => 1,
                    PC3W::VALUE3 => 2,
                    PC3W::VALUE4 => 3,
                    PC3W::VALUE5 => 4,
                    PC3W::VALUE6 => 5,
                    PC3W::VALUE7 => 6,
                    PC3W::VALUE8 => 7,
                    PC3W::VALUE9 => 16,
                    PC3W::VALUE10 => 17,
                    PC3W::VALUE11 => 18,
                    PC3W::VALUE12 => 19,
                    PC3W::VALUE13 => 20,
                    PC3W::VALUE14 => 24,
                    PC3W::VALUE15 => 25,
                    PC3W::VALUE16 => 26,
                    PC3W::VALUE17 => 27,
                    PC3W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC3W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC3W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC3W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC3W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC3W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC3W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC3W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC3W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC3W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC3W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC3W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC3W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC3W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC3W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC3W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC3W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC3W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC3W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&self) -> PC0R {
                PC0R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&self) -> PC1R {
                PC1R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&self) -> PC2R {
                PC2R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&self) -> PC3R {
                PC3R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&mut self) -> _PC0W {
                _PC0W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&mut self) -> _PC1W {
                _PC1W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&mut self) -> _PC2W {
                _PC2W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&mut self) -> _PC3W {
                _PC3W { w: self }
            }
        }
    }
    #[doc = "Port 1 Input/Output Control Register 4"]
    pub struct IOCR4 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Input/Output Control Register 4"]
    pub mod iocr4 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR4 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC4R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC4R::VALUE1 => 0,
                    PC4R::VALUE2 => 0x01,
                    PC4R::VALUE3 => 0x02,
                    PC4R::VALUE4 => 0x03,
                    PC4R::VALUE5 => 0x04,
                    PC4R::VALUE6 => 0x05,
                    PC4R::VALUE7 => 0x06,
                    PC4R::VALUE8 => 0x07,
                    PC4R::VALUE9 => 0x10,
                    PC4R::VALUE10 => 0x11,
                    PC4R::VALUE11 => 0x12,
                    PC4R::VALUE12 => 0x13,
                    PC4R::VALUE13 => 0x14,
                    PC4R::VALUE14 => 0x18,
                    PC4R::VALUE15 => 0x19,
                    PC4R::VALUE16 => 0x1a,
                    PC4R::VALUE17 => 0x1b,
                    PC4R::VALUE18 => 0x1c,
                    PC4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC4R {
                match value {
                    0 => PC4R::VALUE1,
                    1 => PC4R::VALUE2,
                    2 => PC4R::VALUE3,
                    3 => PC4R::VALUE4,
                    4 => PC4R::VALUE5,
                    5 => PC4R::VALUE6,
                    6 => PC4R::VALUE7,
                    7 => PC4R::VALUE8,
                    16 => PC4R::VALUE9,
                    17 => PC4R::VALUE10,
                    18 => PC4R::VALUE11,
                    19 => PC4R::VALUE12,
                    20 => PC4R::VALUE13,
                    24 => PC4R::VALUE14,
                    25 => PC4R::VALUE15,
                    26 => PC4R::VALUE16,
                    27 => PC4R::VALUE17,
                    28 => PC4R::VALUE18,
                    i => PC4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC4R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC4R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC4R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC4R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC4R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC4R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC4R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC4R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC4R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC4R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC4R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC4R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC4R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC4R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC4R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC4R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC5R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC5R::VALUE1 => 0,
                    PC5R::VALUE2 => 0x01,
                    PC5R::VALUE3 => 0x02,
                    PC5R::VALUE4 => 0x03,
                    PC5R::VALUE5 => 0x04,
                    PC5R::VALUE6 => 0x05,
                    PC5R::VALUE7 => 0x06,
                    PC5R::VALUE8 => 0x07,
                    PC5R::VALUE9 => 0x10,
                    PC5R::VALUE10 => 0x11,
                    PC5R::VALUE11 => 0x12,
                    PC5R::VALUE12 => 0x13,
                    PC5R::VALUE13 => 0x14,
                    PC5R::VALUE14 => 0x18,
                    PC5R::VALUE15 => 0x19,
                    PC5R::VALUE16 => 0x1a,
                    PC5R::VALUE17 => 0x1b,
                    PC5R::VALUE18 => 0x1c,
                    PC5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC5R {
                match value {
                    0 => PC5R::VALUE1,
                    1 => PC5R::VALUE2,
                    2 => PC5R::VALUE3,
                    3 => PC5R::VALUE4,
                    4 => PC5R::VALUE5,
                    5 => PC5R::VALUE6,
                    6 => PC5R::VALUE7,
                    7 => PC5R::VALUE8,
                    16 => PC5R::VALUE9,
                    17 => PC5R::VALUE10,
                    18 => PC5R::VALUE11,
                    19 => PC5R::VALUE12,
                    20 => PC5R::VALUE13,
                    24 => PC5R::VALUE14,
                    25 => PC5R::VALUE15,
                    26 => PC5R::VALUE16,
                    27 => PC5R::VALUE17,
                    28 => PC5R::VALUE18,
                    i => PC5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC5R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC5R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC5R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC5R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC5R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC5R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC5R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC5R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC5R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC5R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC5R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC5R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC5R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC5R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC5R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC5R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC6R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC6R::VALUE1 => 0,
                    PC6R::VALUE2 => 0x01,
                    PC6R::VALUE3 => 0x02,
                    PC6R::VALUE4 => 0x03,
                    PC6R::VALUE5 => 0x04,
                    PC6R::VALUE6 => 0x05,
                    PC6R::VALUE7 => 0x06,
                    PC6R::VALUE8 => 0x07,
                    PC6R::VALUE9 => 0x10,
                    PC6R::VALUE10 => 0x11,
                    PC6R::VALUE11 => 0x12,
                    PC6R::VALUE12 => 0x13,
                    PC6R::VALUE13 => 0x14,
                    PC6R::VALUE14 => 0x18,
                    PC6R::VALUE15 => 0x19,
                    PC6R::VALUE16 => 0x1a,
                    PC6R::VALUE17 => 0x1b,
                    PC6R::VALUE18 => 0x1c,
                    PC6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC6R {
                match value {
                    0 => PC6R::VALUE1,
                    1 => PC6R::VALUE2,
                    2 => PC6R::VALUE3,
                    3 => PC6R::VALUE4,
                    4 => PC6R::VALUE5,
                    5 => PC6R::VALUE6,
                    6 => PC6R::VALUE7,
                    7 => PC6R::VALUE8,
                    16 => PC6R::VALUE9,
                    17 => PC6R::VALUE10,
                    18 => PC6R::VALUE11,
                    19 => PC6R::VALUE12,
                    20 => PC6R::VALUE13,
                    24 => PC6R::VALUE14,
                    25 => PC6R::VALUE15,
                    26 => PC6R::VALUE16,
                    27 => PC6R::VALUE17,
                    28 => PC6R::VALUE18,
                    i => PC6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC6R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC6R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC6R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC6R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC6R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC6R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC6R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC6R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC6R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC6R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC6R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC6R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC6R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC6R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC6R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC6R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC7R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC7R::VALUE1 => 0,
                    PC7R::VALUE2 => 0x01,
                    PC7R::VALUE3 => 0x02,
                    PC7R::VALUE4 => 0x03,
                    PC7R::VALUE5 => 0x04,
                    PC7R::VALUE6 => 0x05,
                    PC7R::VALUE7 => 0x06,
                    PC7R::VALUE8 => 0x07,
                    PC7R::VALUE9 => 0x10,
                    PC7R::VALUE10 => 0x11,
                    PC7R::VALUE11 => 0x12,
                    PC7R::VALUE12 => 0x13,
                    PC7R::VALUE13 => 0x14,
                    PC7R::VALUE14 => 0x18,
                    PC7R::VALUE15 => 0x19,
                    PC7R::VALUE16 => 0x1a,
                    PC7R::VALUE17 => 0x1b,
                    PC7R::VALUE18 => 0x1c,
                    PC7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC7R {
                match value {
                    0 => PC7R::VALUE1,
                    1 => PC7R::VALUE2,
                    2 => PC7R::VALUE3,
                    3 => PC7R::VALUE4,
                    4 => PC7R::VALUE5,
                    5 => PC7R::VALUE6,
                    6 => PC7R::VALUE7,
                    7 => PC7R::VALUE8,
                    16 => PC7R::VALUE9,
                    17 => PC7R::VALUE10,
                    18 => PC7R::VALUE11,
                    19 => PC7R::VALUE12,
                    20 => PC7R::VALUE13,
                    24 => PC7R::VALUE14,
                    25 => PC7R::VALUE15,
                    26 => PC7R::VALUE16,
                    27 => PC7R::VALUE17,
                    28 => PC7R::VALUE18,
                    i => PC7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC7R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC7R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC7R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC7R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC7R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC7R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC7R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC7R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC7R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC7R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC7R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC7R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC7R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC7R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC7R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC7R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC4`"]
        pub enum PC4W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC4W::VALUE1 => 0,
                    PC4W::VALUE2 => 1,
                    PC4W::VALUE3 => 2,
                    PC4W::VALUE4 => 3,
                    PC4W::VALUE5 => 4,
                    PC4W::VALUE6 => 5,
                    PC4W::VALUE7 => 6,
                    PC4W::VALUE8 => 7,
                    PC4W::VALUE9 => 16,
                    PC4W::VALUE10 => 17,
                    PC4W::VALUE11 => 18,
                    PC4W::VALUE12 => 19,
                    PC4W::VALUE13 => 20,
                    PC4W::VALUE14 => 24,
                    PC4W::VALUE15 => 25,
                    PC4W::VALUE16 => 26,
                    PC4W::VALUE17 => 27,
                    PC4W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC4W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC4W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC4W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC4W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC4W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC4W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC4W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC4W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC4W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC4W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC4W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC4W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC4W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC4W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC4W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC4W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC4W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC4W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC5`"]
        pub enum PC5W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC5W::VALUE1 => 0,
                    PC5W::VALUE2 => 1,
                    PC5W::VALUE3 => 2,
                    PC5W::VALUE4 => 3,
                    PC5W::VALUE5 => 4,
                    PC5W::VALUE6 => 5,
                    PC5W::VALUE7 => 6,
                    PC5W::VALUE8 => 7,
                    PC5W::VALUE9 => 16,
                    PC5W::VALUE10 => 17,
                    PC5W::VALUE11 => 18,
                    PC5W::VALUE12 => 19,
                    PC5W::VALUE13 => 20,
                    PC5W::VALUE14 => 24,
                    PC5W::VALUE15 => 25,
                    PC5W::VALUE16 => 26,
                    PC5W::VALUE17 => 27,
                    PC5W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC5W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC5W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC5W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC5W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC5W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC5W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC5W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC5W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC5W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC5W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC5W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC5W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC5W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC5W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC5W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC5W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC5W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC5W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC6`"]
        pub enum PC6W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC6W::VALUE1 => 0,
                    PC6W::VALUE2 => 1,
                    PC6W::VALUE3 => 2,
                    PC6W::VALUE4 => 3,
                    PC6W::VALUE5 => 4,
                    PC6W::VALUE6 => 5,
                    PC6W::VALUE7 => 6,
                    PC6W::VALUE8 => 7,
                    PC6W::VALUE9 => 16,
                    PC6W::VALUE10 => 17,
                    PC6W::VALUE11 => 18,
                    PC6W::VALUE12 => 19,
                    PC6W::VALUE13 => 20,
                    PC6W::VALUE14 => 24,
                    PC6W::VALUE15 => 25,
                    PC6W::VALUE16 => 26,
                    PC6W::VALUE17 => 27,
                    PC6W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC6W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC6W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC6W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC6W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC6W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC6W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC6W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC6W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC6W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC6W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC6W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC6W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC6W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC6W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC6W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC6W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC6W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC6W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC7`"]
        pub enum PC7W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC7W::VALUE1 => 0,
                    PC7W::VALUE2 => 1,
                    PC7W::VALUE3 => 2,
                    PC7W::VALUE4 => 3,
                    PC7W::VALUE5 => 4,
                    PC7W::VALUE6 => 5,
                    PC7W::VALUE7 => 6,
                    PC7W::VALUE8 => 7,
                    PC7W::VALUE9 => 16,
                    PC7W::VALUE10 => 17,
                    PC7W::VALUE11 => 18,
                    PC7W::VALUE12 => 19,
                    PC7W::VALUE13 => 20,
                    PC7W::VALUE14 => 24,
                    PC7W::VALUE15 => 25,
                    PC7W::VALUE16 => 26,
                    PC7W::VALUE17 => 27,
                    PC7W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC7W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC7W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC7W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC7W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC7W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC7W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC7W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC7W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC7W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC7W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC7W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC7W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC7W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC7W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC7W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC7W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC7W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC7W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&self) -> PC4R {
                PC4R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&self) -> PC5R {
                PC5R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&self) -> PC6R {
                PC6R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&self) -> PC7R {
                PC7R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&mut self) -> _PC4W {
                _PC4W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&mut self) -> _PC5W {
                _PC5W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&mut self) -> _PC6W {
                _PC6W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&mut self) -> _PC7W {
                _PC7W { w: self }
            }
        }
    }
    #[doc = "Port 1 Input/Output Control Register 8"]
    pub struct IOCR8 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Input/Output Control Register 8"]
    pub mod iocr8 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR8 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC8R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC8R::VALUE1 => 0,
                    PC8R::VALUE2 => 0x01,
                    PC8R::VALUE3 => 0x02,
                    PC8R::VALUE4 => 0x03,
                    PC8R::VALUE5 => 0x04,
                    PC8R::VALUE6 => 0x05,
                    PC8R::VALUE7 => 0x06,
                    PC8R::VALUE8 => 0x07,
                    PC8R::VALUE9 => 0x10,
                    PC8R::VALUE10 => 0x11,
                    PC8R::VALUE11 => 0x12,
                    PC8R::VALUE12 => 0x13,
                    PC8R::VALUE13 => 0x14,
                    PC8R::VALUE14 => 0x18,
                    PC8R::VALUE15 => 0x19,
                    PC8R::VALUE16 => 0x1a,
                    PC8R::VALUE17 => 0x1b,
                    PC8R::VALUE18 => 0x1c,
                    PC8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC8R {
                match value {
                    0 => PC8R::VALUE1,
                    1 => PC8R::VALUE2,
                    2 => PC8R::VALUE3,
                    3 => PC8R::VALUE4,
                    4 => PC8R::VALUE5,
                    5 => PC8R::VALUE6,
                    6 => PC8R::VALUE7,
                    7 => PC8R::VALUE8,
                    16 => PC8R::VALUE9,
                    17 => PC8R::VALUE10,
                    18 => PC8R::VALUE11,
                    19 => PC8R::VALUE12,
                    20 => PC8R::VALUE13,
                    24 => PC8R::VALUE14,
                    25 => PC8R::VALUE15,
                    26 => PC8R::VALUE16,
                    27 => PC8R::VALUE17,
                    28 => PC8R::VALUE18,
                    i => PC8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC8R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC8R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC8R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC8R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC8R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC8R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC8R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC8R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC8R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC8R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC8R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC8R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC8R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC8R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC8R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC8R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC9R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC9R::VALUE1 => 0,
                    PC9R::VALUE2 => 0x01,
                    PC9R::VALUE3 => 0x02,
                    PC9R::VALUE4 => 0x03,
                    PC9R::VALUE5 => 0x04,
                    PC9R::VALUE6 => 0x05,
                    PC9R::VALUE7 => 0x06,
                    PC9R::VALUE8 => 0x07,
                    PC9R::VALUE9 => 0x10,
                    PC9R::VALUE10 => 0x11,
                    PC9R::VALUE11 => 0x12,
                    PC9R::VALUE12 => 0x13,
                    PC9R::VALUE13 => 0x14,
                    PC9R::VALUE14 => 0x18,
                    PC9R::VALUE15 => 0x19,
                    PC9R::VALUE16 => 0x1a,
                    PC9R::VALUE17 => 0x1b,
                    PC9R::VALUE18 => 0x1c,
                    PC9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC9R {
                match value {
                    0 => PC9R::VALUE1,
                    1 => PC9R::VALUE2,
                    2 => PC9R::VALUE3,
                    3 => PC9R::VALUE4,
                    4 => PC9R::VALUE5,
                    5 => PC9R::VALUE6,
                    6 => PC9R::VALUE7,
                    7 => PC9R::VALUE8,
                    16 => PC9R::VALUE9,
                    17 => PC9R::VALUE10,
                    18 => PC9R::VALUE11,
                    19 => PC9R::VALUE12,
                    20 => PC9R::VALUE13,
                    24 => PC9R::VALUE14,
                    25 => PC9R::VALUE15,
                    26 => PC9R::VALUE16,
                    27 => PC9R::VALUE17,
                    28 => PC9R::VALUE18,
                    i => PC9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC9R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC9R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC9R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC9R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC9R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC9R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC9R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC9R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC9R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC9R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC9R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC9R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC9R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC9R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC9R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC9R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC10R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC10R::VALUE1 => 0,
                    PC10R::VALUE2 => 0x01,
                    PC10R::VALUE3 => 0x02,
                    PC10R::VALUE4 => 0x03,
                    PC10R::VALUE5 => 0x04,
                    PC10R::VALUE6 => 0x05,
                    PC10R::VALUE7 => 0x06,
                    PC10R::VALUE8 => 0x07,
                    PC10R::VALUE9 => 0x10,
                    PC10R::VALUE10 => 0x11,
                    PC10R::VALUE11 => 0x12,
                    PC10R::VALUE12 => 0x13,
                    PC10R::VALUE13 => 0x14,
                    PC10R::VALUE14 => 0x18,
                    PC10R::VALUE15 => 0x19,
                    PC10R::VALUE16 => 0x1a,
                    PC10R::VALUE17 => 0x1b,
                    PC10R::VALUE18 => 0x1c,
                    PC10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC10R {
                match value {
                    0 => PC10R::VALUE1,
                    1 => PC10R::VALUE2,
                    2 => PC10R::VALUE3,
                    3 => PC10R::VALUE4,
                    4 => PC10R::VALUE5,
                    5 => PC10R::VALUE6,
                    6 => PC10R::VALUE7,
                    7 => PC10R::VALUE8,
                    16 => PC10R::VALUE9,
                    17 => PC10R::VALUE10,
                    18 => PC10R::VALUE11,
                    19 => PC10R::VALUE12,
                    20 => PC10R::VALUE13,
                    24 => PC10R::VALUE14,
                    25 => PC10R::VALUE15,
                    26 => PC10R::VALUE16,
                    27 => PC10R::VALUE17,
                    28 => PC10R::VALUE18,
                    i => PC10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC10R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC10R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC10R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC10R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC10R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC10R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC10R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC10R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC10R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC10R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC10R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC10R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC10R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC10R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC10R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC10R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC11R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC11R::VALUE1 => 0,
                    PC11R::VALUE2 => 0x01,
                    PC11R::VALUE3 => 0x02,
                    PC11R::VALUE4 => 0x03,
                    PC11R::VALUE5 => 0x04,
                    PC11R::VALUE6 => 0x05,
                    PC11R::VALUE7 => 0x06,
                    PC11R::VALUE8 => 0x07,
                    PC11R::VALUE9 => 0x10,
                    PC11R::VALUE10 => 0x11,
                    PC11R::VALUE11 => 0x12,
                    PC11R::VALUE12 => 0x13,
                    PC11R::VALUE13 => 0x14,
                    PC11R::VALUE14 => 0x18,
                    PC11R::VALUE15 => 0x19,
                    PC11R::VALUE16 => 0x1a,
                    PC11R::VALUE17 => 0x1b,
                    PC11R::VALUE18 => 0x1c,
                    PC11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC11R {
                match value {
                    0 => PC11R::VALUE1,
                    1 => PC11R::VALUE2,
                    2 => PC11R::VALUE3,
                    3 => PC11R::VALUE4,
                    4 => PC11R::VALUE5,
                    5 => PC11R::VALUE6,
                    6 => PC11R::VALUE7,
                    7 => PC11R::VALUE8,
                    16 => PC11R::VALUE9,
                    17 => PC11R::VALUE10,
                    18 => PC11R::VALUE11,
                    19 => PC11R::VALUE12,
                    20 => PC11R::VALUE13,
                    24 => PC11R::VALUE14,
                    25 => PC11R::VALUE15,
                    26 => PC11R::VALUE16,
                    27 => PC11R::VALUE17,
                    28 => PC11R::VALUE18,
                    i => PC11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC11R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC11R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC11R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC11R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC11R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC11R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC11R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC11R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC11R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC11R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC11R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC11R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC11R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC11R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC11R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC11R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC8`"]
        pub enum PC8W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC8W::VALUE1 => 0,
                    PC8W::VALUE2 => 1,
                    PC8W::VALUE3 => 2,
                    PC8W::VALUE4 => 3,
                    PC8W::VALUE5 => 4,
                    PC8W::VALUE6 => 5,
                    PC8W::VALUE7 => 6,
                    PC8W::VALUE8 => 7,
                    PC8W::VALUE9 => 16,
                    PC8W::VALUE10 => 17,
                    PC8W::VALUE11 => 18,
                    PC8W::VALUE12 => 19,
                    PC8W::VALUE13 => 20,
                    PC8W::VALUE14 => 24,
                    PC8W::VALUE15 => 25,
                    PC8W::VALUE16 => 26,
                    PC8W::VALUE17 => 27,
                    PC8W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC8W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC8W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC8W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC8W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC8W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC8W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC8W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC8W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC8W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC8W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC8W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC8W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC8W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC8W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC8W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC8W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC8W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC8W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC9`"]
        pub enum PC9W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC9W::VALUE1 => 0,
                    PC9W::VALUE2 => 1,
                    PC9W::VALUE3 => 2,
                    PC9W::VALUE4 => 3,
                    PC9W::VALUE5 => 4,
                    PC9W::VALUE6 => 5,
                    PC9W::VALUE7 => 6,
                    PC9W::VALUE8 => 7,
                    PC9W::VALUE9 => 16,
                    PC9W::VALUE10 => 17,
                    PC9W::VALUE11 => 18,
                    PC9W::VALUE12 => 19,
                    PC9W::VALUE13 => 20,
                    PC9W::VALUE14 => 24,
                    PC9W::VALUE15 => 25,
                    PC9W::VALUE16 => 26,
                    PC9W::VALUE17 => 27,
                    PC9W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC9W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC9W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC9W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC9W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC9W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC9W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC9W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC9W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC9W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC9W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC9W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC9W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC9W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC9W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC9W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC9W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC9W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC9W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC10`"]
        pub enum PC10W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC10W::VALUE1 => 0,
                    PC10W::VALUE2 => 1,
                    PC10W::VALUE3 => 2,
                    PC10W::VALUE4 => 3,
                    PC10W::VALUE5 => 4,
                    PC10W::VALUE6 => 5,
                    PC10W::VALUE7 => 6,
                    PC10W::VALUE8 => 7,
                    PC10W::VALUE9 => 16,
                    PC10W::VALUE10 => 17,
                    PC10W::VALUE11 => 18,
                    PC10W::VALUE12 => 19,
                    PC10W::VALUE13 => 20,
                    PC10W::VALUE14 => 24,
                    PC10W::VALUE15 => 25,
                    PC10W::VALUE16 => 26,
                    PC10W::VALUE17 => 27,
                    PC10W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC10W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC10W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC10W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC10W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC10W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC10W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC10W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC10W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC10W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC10W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC10W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC10W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC10W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC10W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC10W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC10W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC10W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC10W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC11`"]
        pub enum PC11W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC11W::VALUE1 => 0,
                    PC11W::VALUE2 => 1,
                    PC11W::VALUE3 => 2,
                    PC11W::VALUE4 => 3,
                    PC11W::VALUE5 => 4,
                    PC11W::VALUE6 => 5,
                    PC11W::VALUE7 => 6,
                    PC11W::VALUE8 => 7,
                    PC11W::VALUE9 => 16,
                    PC11W::VALUE10 => 17,
                    PC11W::VALUE11 => 18,
                    PC11W::VALUE12 => 19,
                    PC11W::VALUE13 => 20,
                    PC11W::VALUE14 => 24,
                    PC11W::VALUE15 => 25,
                    PC11W::VALUE16 => 26,
                    PC11W::VALUE17 => 27,
                    PC11W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC11W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC11W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC11W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC11W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC11W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC11W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC11W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC11W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC11W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC11W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC11W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC11W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC11W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC11W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC11W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC11W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC11W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC11W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&self) -> PC8R {
                PC8R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&self) -> PC9R {
                PC9R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&self) -> PC10R {
                PC10R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&self) -> PC11R {
                PC11R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&mut self) -> _PC8W {
                _PC8W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&mut self) -> _PC9W {
                _PC9W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&mut self) -> _PC10W {
                _PC10W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&mut self) -> _PC11W {
                _PC11W { w: self }
            }
        }
    }
    #[doc = "Port 1 Input/Output Control Register 12"]
    pub struct IOCR12 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Input/Output Control Register 12"]
    pub mod iocr12 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR12 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC12R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC12R::VALUE1 => 0,
                    PC12R::VALUE2 => 0x01,
                    PC12R::VALUE3 => 0x02,
                    PC12R::VALUE4 => 0x03,
                    PC12R::VALUE5 => 0x04,
                    PC12R::VALUE6 => 0x05,
                    PC12R::VALUE7 => 0x06,
                    PC12R::VALUE8 => 0x07,
                    PC12R::VALUE9 => 0x10,
                    PC12R::VALUE10 => 0x11,
                    PC12R::VALUE11 => 0x12,
                    PC12R::VALUE12 => 0x13,
                    PC12R::VALUE13 => 0x14,
                    PC12R::VALUE14 => 0x18,
                    PC12R::VALUE15 => 0x19,
                    PC12R::VALUE16 => 0x1a,
                    PC12R::VALUE17 => 0x1b,
                    PC12R::VALUE18 => 0x1c,
                    PC12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC12R {
                match value {
                    0 => PC12R::VALUE1,
                    1 => PC12R::VALUE2,
                    2 => PC12R::VALUE3,
                    3 => PC12R::VALUE4,
                    4 => PC12R::VALUE5,
                    5 => PC12R::VALUE6,
                    6 => PC12R::VALUE7,
                    7 => PC12R::VALUE8,
                    16 => PC12R::VALUE9,
                    17 => PC12R::VALUE10,
                    18 => PC12R::VALUE11,
                    19 => PC12R::VALUE12,
                    20 => PC12R::VALUE13,
                    24 => PC12R::VALUE14,
                    25 => PC12R::VALUE15,
                    26 => PC12R::VALUE16,
                    27 => PC12R::VALUE17,
                    28 => PC12R::VALUE18,
                    i => PC12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC12R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC12R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC12R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC12R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC12R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC12R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC12R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC12R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC12R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC12R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC12R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC12R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC12R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC12R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC12R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC12R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC13R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC13R::VALUE1 => 0,
                    PC13R::VALUE2 => 0x01,
                    PC13R::VALUE3 => 0x02,
                    PC13R::VALUE4 => 0x03,
                    PC13R::VALUE5 => 0x04,
                    PC13R::VALUE6 => 0x05,
                    PC13R::VALUE7 => 0x06,
                    PC13R::VALUE8 => 0x07,
                    PC13R::VALUE9 => 0x10,
                    PC13R::VALUE10 => 0x11,
                    PC13R::VALUE11 => 0x12,
                    PC13R::VALUE12 => 0x13,
                    PC13R::VALUE13 => 0x14,
                    PC13R::VALUE14 => 0x18,
                    PC13R::VALUE15 => 0x19,
                    PC13R::VALUE16 => 0x1a,
                    PC13R::VALUE17 => 0x1b,
                    PC13R::VALUE18 => 0x1c,
                    PC13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC13R {
                match value {
                    0 => PC13R::VALUE1,
                    1 => PC13R::VALUE2,
                    2 => PC13R::VALUE3,
                    3 => PC13R::VALUE4,
                    4 => PC13R::VALUE5,
                    5 => PC13R::VALUE6,
                    6 => PC13R::VALUE7,
                    7 => PC13R::VALUE8,
                    16 => PC13R::VALUE9,
                    17 => PC13R::VALUE10,
                    18 => PC13R::VALUE11,
                    19 => PC13R::VALUE12,
                    20 => PC13R::VALUE13,
                    24 => PC13R::VALUE14,
                    25 => PC13R::VALUE15,
                    26 => PC13R::VALUE16,
                    27 => PC13R::VALUE17,
                    28 => PC13R::VALUE18,
                    i => PC13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC13R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC13R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC13R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC13R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC13R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC13R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC13R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC13R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC13R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC13R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC13R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC13R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC13R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC13R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC13R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC13R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC14R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC14R::VALUE1 => 0,
                    PC14R::VALUE2 => 0x01,
                    PC14R::VALUE3 => 0x02,
                    PC14R::VALUE4 => 0x03,
                    PC14R::VALUE5 => 0x04,
                    PC14R::VALUE6 => 0x05,
                    PC14R::VALUE7 => 0x06,
                    PC14R::VALUE8 => 0x07,
                    PC14R::VALUE9 => 0x10,
                    PC14R::VALUE10 => 0x11,
                    PC14R::VALUE11 => 0x12,
                    PC14R::VALUE12 => 0x13,
                    PC14R::VALUE13 => 0x14,
                    PC14R::VALUE14 => 0x18,
                    PC14R::VALUE15 => 0x19,
                    PC14R::VALUE16 => 0x1a,
                    PC14R::VALUE17 => 0x1b,
                    PC14R::VALUE18 => 0x1c,
                    PC14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC14R {
                match value {
                    0 => PC14R::VALUE1,
                    1 => PC14R::VALUE2,
                    2 => PC14R::VALUE3,
                    3 => PC14R::VALUE4,
                    4 => PC14R::VALUE5,
                    5 => PC14R::VALUE6,
                    6 => PC14R::VALUE7,
                    7 => PC14R::VALUE8,
                    16 => PC14R::VALUE9,
                    17 => PC14R::VALUE10,
                    18 => PC14R::VALUE11,
                    19 => PC14R::VALUE12,
                    20 => PC14R::VALUE13,
                    24 => PC14R::VALUE14,
                    25 => PC14R::VALUE15,
                    26 => PC14R::VALUE16,
                    27 => PC14R::VALUE17,
                    28 => PC14R::VALUE18,
                    i => PC14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC14R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC14R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC14R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC14R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC14R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC14R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC14R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC14R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC14R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC14R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC14R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC14R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC14R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC14R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC14R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC14R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC15R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC15R::VALUE1 => 0,
                    PC15R::VALUE2 => 0x01,
                    PC15R::VALUE3 => 0x02,
                    PC15R::VALUE4 => 0x03,
                    PC15R::VALUE5 => 0x04,
                    PC15R::VALUE6 => 0x05,
                    PC15R::VALUE7 => 0x06,
                    PC15R::VALUE8 => 0x07,
                    PC15R::VALUE9 => 0x10,
                    PC15R::VALUE10 => 0x11,
                    PC15R::VALUE11 => 0x12,
                    PC15R::VALUE12 => 0x13,
                    PC15R::VALUE13 => 0x14,
                    PC15R::VALUE14 => 0x18,
                    PC15R::VALUE15 => 0x19,
                    PC15R::VALUE16 => 0x1a,
                    PC15R::VALUE17 => 0x1b,
                    PC15R::VALUE18 => 0x1c,
                    PC15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC15R {
                match value {
                    0 => PC15R::VALUE1,
                    1 => PC15R::VALUE2,
                    2 => PC15R::VALUE3,
                    3 => PC15R::VALUE4,
                    4 => PC15R::VALUE5,
                    5 => PC15R::VALUE6,
                    6 => PC15R::VALUE7,
                    7 => PC15R::VALUE8,
                    16 => PC15R::VALUE9,
                    17 => PC15R::VALUE10,
                    18 => PC15R::VALUE11,
                    19 => PC15R::VALUE12,
                    20 => PC15R::VALUE13,
                    24 => PC15R::VALUE14,
                    25 => PC15R::VALUE15,
                    26 => PC15R::VALUE16,
                    27 => PC15R::VALUE17,
                    28 => PC15R::VALUE18,
                    i => PC15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC15R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC15R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC15R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC15R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC15R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC15R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC15R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC15R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC15R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC15R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC15R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC15R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC15R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC15R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC15R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC15R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC12`"]
        pub enum PC12W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC12W::VALUE1 => 0,
                    PC12W::VALUE2 => 1,
                    PC12W::VALUE3 => 2,
                    PC12W::VALUE4 => 3,
                    PC12W::VALUE5 => 4,
                    PC12W::VALUE6 => 5,
                    PC12W::VALUE7 => 6,
                    PC12W::VALUE8 => 7,
                    PC12W::VALUE9 => 16,
                    PC12W::VALUE10 => 17,
                    PC12W::VALUE11 => 18,
                    PC12W::VALUE12 => 19,
                    PC12W::VALUE13 => 20,
                    PC12W::VALUE14 => 24,
                    PC12W::VALUE15 => 25,
                    PC12W::VALUE16 => 26,
                    PC12W::VALUE17 => 27,
                    PC12W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC12W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC12W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC12W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC12W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC12W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC12W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC12W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC12W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC12W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC12W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC12W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC12W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC12W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC12W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC12W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC12W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC12W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC12W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC13`"]
        pub enum PC13W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC13W::VALUE1 => 0,
                    PC13W::VALUE2 => 1,
                    PC13W::VALUE3 => 2,
                    PC13W::VALUE4 => 3,
                    PC13W::VALUE5 => 4,
                    PC13W::VALUE6 => 5,
                    PC13W::VALUE7 => 6,
                    PC13W::VALUE8 => 7,
                    PC13W::VALUE9 => 16,
                    PC13W::VALUE10 => 17,
                    PC13W::VALUE11 => 18,
                    PC13W::VALUE12 => 19,
                    PC13W::VALUE13 => 20,
                    PC13W::VALUE14 => 24,
                    PC13W::VALUE15 => 25,
                    PC13W::VALUE16 => 26,
                    PC13W::VALUE17 => 27,
                    PC13W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC13W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC13W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC13W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC13W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC13W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC13W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC13W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC13W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC13W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC13W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC13W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC13W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC13W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC13W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC13W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC13W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC13W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC13W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC14`"]
        pub enum PC14W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC14W::VALUE1 => 0,
                    PC14W::VALUE2 => 1,
                    PC14W::VALUE3 => 2,
                    PC14W::VALUE4 => 3,
                    PC14W::VALUE5 => 4,
                    PC14W::VALUE6 => 5,
                    PC14W::VALUE7 => 6,
                    PC14W::VALUE8 => 7,
                    PC14W::VALUE9 => 16,
                    PC14W::VALUE10 => 17,
                    PC14W::VALUE11 => 18,
                    PC14W::VALUE12 => 19,
                    PC14W::VALUE13 => 20,
                    PC14W::VALUE14 => 24,
                    PC14W::VALUE15 => 25,
                    PC14W::VALUE16 => 26,
                    PC14W::VALUE17 => 27,
                    PC14W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC14W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC14W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC14W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC14W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC14W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC14W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC14W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC14W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC14W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC14W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC14W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC14W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC14W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC14W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC14W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC14W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC14W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC14W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC15`"]
        pub enum PC15W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC15W::VALUE1 => 0,
                    PC15W::VALUE2 => 1,
                    PC15W::VALUE3 => 2,
                    PC15W::VALUE4 => 3,
                    PC15W::VALUE5 => 4,
                    PC15W::VALUE6 => 5,
                    PC15W::VALUE7 => 6,
                    PC15W::VALUE8 => 7,
                    PC15W::VALUE9 => 16,
                    PC15W::VALUE10 => 17,
                    PC15W::VALUE11 => 18,
                    PC15W::VALUE12 => 19,
                    PC15W::VALUE13 => 20,
                    PC15W::VALUE14 => 24,
                    PC15W::VALUE15 => 25,
                    PC15W::VALUE16 => 26,
                    PC15W::VALUE17 => 27,
                    PC15W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC15W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC15W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC15W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC15W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC15W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC15W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC15W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC15W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC15W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC15W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC15W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC15W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC15W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC15W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC15W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC15W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC15W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC15W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc12(&self) -> PC12R {
                PC12R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc13(&self) -> PC13R {
                PC13R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc14(&self) -> PC14R {
                PC14R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc15(&self) -> PC15R {
                PC15R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc12(&mut self) -> _PC12W {
                _PC12W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc13(&mut self) -> _PC13W {
                _PC13W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc14(&mut self) -> _PC14W {
                _PC14W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc15(&mut self) -> _PC15W {
                _PC15W { w: self }
            }
        }
    }
    #[doc = "Port 1 Input Register"]
    pub struct IN {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Input Register"]
    pub mod in_ {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Input Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Input Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Input Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Input Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Input Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Input Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Input Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Input Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Input Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Input Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Input Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Input Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Input Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Input Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Input Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Input Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 1 Pad Driver Mode 0 Register"]
    pub struct PDR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Pad Driver Mode 0 Register"]
    pub mod pdr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD0R {
            bits: u8,
        }
        impl PD0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD1R {
            bits: u8,
        }
        impl PD1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD2R {
            bits: u8,
        }
        impl PD2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD3R {
            bits: u8,
        }
        impl PD3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD4R {
            bits: u8,
        }
        impl PD4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD5R {
            bits: u8,
        }
        impl PD5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD6R {
            bits: u8,
        }
        impl PD6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD7R {
            bits: u8,
        }
        impl PD7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&self) -> PD0R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD0R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&self) -> PD1R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD1R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&self) -> PD2R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD2R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&self) -> PD3R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD3R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&self) -> PD4R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD4R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&self) -> PD5R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD5R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&self) -> PD6R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD6R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&self) -> PD7R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&mut self) -> _PD0W {
                _PD0W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&mut self) -> _PD1W {
                _PD1W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&mut self) -> _PD2W {
                _PD2W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&mut self) -> _PD3W {
                _PD3W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&mut self) -> _PD4W {
                _PD4W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&mut self) -> _PD5W {
                _PD5W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&mut self) -> _PD6W {
                _PD6W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&mut self) -> _PD7W {
                _PD7W { w: self }
            }
        }
    }
    #[doc = "Port 1 Pad Driver Mode 1 Register"]
    pub struct PDR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Pad Driver Mode 1 Register"]
    pub mod pdr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD8R {
            bits: u8,
        }
        impl PD8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD9R {
            bits: u8,
        }
        impl PD9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD10R {
            bits: u8,
        }
        impl PD10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD11R {
            bits: u8,
        }
        impl PD11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD12R {
            bits: u8,
        }
        impl PD12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD13R {
            bits: u8,
        }
        impl PD13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD14R {
            bits: u8,
        }
        impl PD14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD15R {
            bits: u8,
        }
        impl PD15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD8W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD9W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD10W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD11W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD12W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD13W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD14W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD15W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.8"]
            #[inline]
            pub fn pd8(&self) -> PD8R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD8R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.9"]
            #[inline]
            pub fn pd9(&self) -> PD9R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD9R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.10"]
            #[inline]
            pub fn pd10(&self) -> PD10R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD10R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.11"]
            #[inline]
            pub fn pd11(&self) -> PD11R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD11R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.12"]
            #[inline]
            pub fn pd12(&self) -> PD12R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD12R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.13"]
            #[inline]
            pub fn pd13(&self) -> PD13R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD13R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.14"]
            #[inline]
            pub fn pd14(&self) -> PD14R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD14R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.15"]
            #[inline]
            pub fn pd15(&self) -> PD15R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD15R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.8"]
            #[inline]
            pub fn pd8(&mut self) -> _PD8W {
                _PD8W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.9"]
            #[inline]
            pub fn pd9(&mut self) -> _PD9W {
                _PD9W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.10"]
            #[inline]
            pub fn pd10(&mut self) -> _PD10W {
                _PD10W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.11"]
            #[inline]
            pub fn pd11(&mut self) -> _PD11W {
                _PD11W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.12"]
            #[inline]
            pub fn pd12(&mut self) -> _PD12W {
                _PD12W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.13"]
            #[inline]
            pub fn pd13(&mut self) -> _PD13W {
                _PD13W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.14"]
            #[inline]
            pub fn pd14(&mut self) -> _PD14W {
                _PD14W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.15"]
            #[inline]
            pub fn pd15(&mut self) -> _PD15W {
                _PD15W { w: self }
            }
        }
    }
    #[doc = "Port 1 Pin Function Decision Control Register"]
    pub struct PDISC {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Pin Function Decision Control Register"]
    pub mod pdisc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PDISC {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PDIS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS0R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS0R::VALUE1 => false,
                    PDIS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS0R {
                match value {
                    false => PDIS0R::VALUE1,
                    true => PDIS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS1R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS1R::VALUE1 => false,
                    PDIS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS1R {
                match value {
                    false => PDIS1R::VALUE1,
                    true => PDIS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS2R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS2R::VALUE1 => false,
                    PDIS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS2R {
                match value {
                    false => PDIS2R::VALUE1,
                    true => PDIS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS3R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS3R::VALUE1 => false,
                    PDIS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS3R {
                match value {
                    false => PDIS3R::VALUE1,
                    true => PDIS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS4R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS4R::VALUE1 => false,
                    PDIS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS4R {
                match value {
                    false => PDIS4R::VALUE1,
                    true => PDIS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS5R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS5R::VALUE1 => false,
                    PDIS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS5R {
                match value {
                    false => PDIS5R::VALUE1,
                    true => PDIS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS6R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS6R::VALUE1 => false,
                    PDIS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS6R {
                match value {
                    false => PDIS6R::VALUE1,
                    true => PDIS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS7R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS7R::VALUE1 => false,
                    PDIS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS7R {
                match value {
                    false => PDIS7R::VALUE1,
                    true => PDIS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS8R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS8R::VALUE1 => false,
                    PDIS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS8R {
                match value {
                    false => PDIS8R::VALUE1,
                    true => PDIS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS9R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS9R::VALUE1 => false,
                    PDIS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS9R {
                match value {
                    false => PDIS9R::VALUE1,
                    true => PDIS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS10R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS10R::VALUE1 => false,
                    PDIS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS10R {
                match value {
                    false => PDIS10R::VALUE1,
                    true => PDIS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS11R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS11R::VALUE1 => false,
                    PDIS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS11R {
                match value {
                    false => PDIS11R::VALUE1,
                    true => PDIS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS12R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS12R::VALUE1 => false,
                    PDIS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS12R {
                match value {
                    false => PDIS12R::VALUE1,
                    true => PDIS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS13R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS13R::VALUE1 => false,
                    PDIS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS13R {
                match value {
                    false => PDIS13R::VALUE1,
                    true => PDIS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS14R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS14R::VALUE1 => false,
                    PDIS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS14R {
                match value {
                    false => PDIS14R::VALUE1,
                    true => PDIS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS15R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS15R::VALUE1 => false,
                    PDIS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS15R {
                match value {
                    false => PDIS15R::VALUE1,
                    true => PDIS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Pad Disable for Port n Pin 0"]
            #[inline]
            pub fn pdis0(&self) -> PDIS0R {
                PDIS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Pad Disable for Port n Pin 1"]
            #[inline]
            pub fn pdis1(&self) -> PDIS1R {
                PDIS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Pad Disable for Port n Pin 2"]
            #[inline]
            pub fn pdis2(&self) -> PDIS2R {
                PDIS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Pad Disable for Port n Pin 3"]
            #[inline]
            pub fn pdis3(&self) -> PDIS3R {
                PDIS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Pad Disable for Port n Pin 4"]
            #[inline]
            pub fn pdis4(&self) -> PDIS4R {
                PDIS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Pad Disable for Port n Pin 5"]
            #[inline]
            pub fn pdis5(&self) -> PDIS5R {
                PDIS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Pad Disable for Port n Pin 6"]
            #[inline]
            pub fn pdis6(&self) -> PDIS6R {
                PDIS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Pad Disable for Port n Pin 7"]
            #[inline]
            pub fn pdis7(&self) -> PDIS7R {
                PDIS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Pad Disable for Port n Pin 8"]
            #[inline]
            pub fn pdis8(&self) -> PDIS8R {
                PDIS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Pad Disable for Port n Pin 9"]
            #[inline]
            pub fn pdis9(&self) -> PDIS9R {
                PDIS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Pad Disable for Port n Pin 10"]
            #[inline]
            pub fn pdis10(&self) -> PDIS10R {
                PDIS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Pad Disable for Port n Pin 11"]
            #[inline]
            pub fn pdis11(&self) -> PDIS11R {
                PDIS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Pad Disable for Port n Pin 12"]
            #[inline]
            pub fn pdis12(&self) -> PDIS12R {
                PDIS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Pad Disable for Port n Pin 13"]
            #[inline]
            pub fn pdis13(&self) -> PDIS13R {
                PDIS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Pad Disable for Port n Pin 14"]
            #[inline]
            pub fn pdis14(&self) -> PDIS14R {
                PDIS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Pad Disable for Port n Pin 15"]
            #[inline]
            pub fn pdis15(&self) -> PDIS15R {
                PDIS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 1 Pin Power Save Register"]
    pub struct PPS {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Pin Power Save Register"]
    pub mod pps {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PPS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PPS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS0R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS0R::VALUE1 => false,
                    PPS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS0R {
                match value {
                    false => PPS0R::VALUE1,
                    true => PPS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS1R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS1R::VALUE1 => false,
                    PPS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS1R {
                match value {
                    false => PPS1R::VALUE1,
                    true => PPS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS2R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS2R::VALUE1 => false,
                    PPS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS2R {
                match value {
                    false => PPS2R::VALUE1,
                    true => PPS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS3R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS3R::VALUE1 => false,
                    PPS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS3R {
                match value {
                    false => PPS3R::VALUE1,
                    true => PPS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS4R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS4R::VALUE1 => false,
                    PPS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS4R {
                match value {
                    false => PPS4R::VALUE1,
                    true => PPS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS5R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS5R::VALUE1 => false,
                    PPS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS5R {
                match value {
                    false => PPS5R::VALUE1,
                    true => PPS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS6R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS6R::VALUE1 => false,
                    PPS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS6R {
                match value {
                    false => PPS6R::VALUE1,
                    true => PPS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS7R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS7R::VALUE1 => false,
                    PPS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS7R {
                match value {
                    false => PPS7R::VALUE1,
                    true => PPS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS8R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS8R::VALUE1 => false,
                    PPS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS8R {
                match value {
                    false => PPS8R::VALUE1,
                    true => PPS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS9R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS9R::VALUE1 => false,
                    PPS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS9R {
                match value {
                    false => PPS9R::VALUE1,
                    true => PPS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS10R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS10R::VALUE1 => false,
                    PPS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS10R {
                match value {
                    false => PPS10R::VALUE1,
                    true => PPS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS11R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS11R::VALUE1 => false,
                    PPS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS11R {
                match value {
                    false => PPS11R::VALUE1,
                    true => PPS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS12R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS12R::VALUE1 => false,
                    PPS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS12R {
                match value {
                    false => PPS12R::VALUE1,
                    true => PPS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS13R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS13R::VALUE1 => false,
                    PPS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS13R {
                match value {
                    false => PPS13R::VALUE1,
                    true => PPS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS14R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS14R::VALUE1 => false,
                    PPS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS14R {
                match value {
                    false => PPS14R::VALUE1,
                    true => PPS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS15R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS15R::VALUE1 => false,
                    PPS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS15R {
                match value {
                    false => PPS15R::VALUE1,
                    true => PPS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PPS0`"]
        pub enum PPS0W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS0W::VALUE1 => false,
                    PPS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS0W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS1`"]
        pub enum PPS1W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS1W::VALUE1 => false,
                    PPS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS1W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS2`"]
        pub enum PPS2W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS2W::VALUE1 => false,
                    PPS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS2W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS3`"]
        pub enum PPS3W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS3W::VALUE1 => false,
                    PPS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS3W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS4`"]
        pub enum PPS4W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS4W::VALUE1 => false,
                    PPS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS4W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS5`"]
        pub enum PPS5W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS5W::VALUE1 => false,
                    PPS5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS5W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS6`"]
        pub enum PPS6W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS6W::VALUE1 => false,
                    PPS6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS6W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS7`"]
        pub enum PPS7W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS7W::VALUE1 => false,
                    PPS7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS7W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS8`"]
        pub enum PPS8W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS8W::VALUE1 => false,
                    PPS8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS8W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS9`"]
        pub enum PPS9W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS9W::VALUE1 => false,
                    PPS9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS9W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS10`"]
        pub enum PPS10W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS10W::VALUE1 => false,
                    PPS10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS10W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS11`"]
        pub enum PPS11W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS11W::VALUE1 => false,
                    PPS11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS11W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS12`"]
        pub enum PPS12W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS12W::VALUE1 => false,
                    PPS12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS12W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS13`"]
        pub enum PPS13W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS13W::VALUE1 => false,
                    PPS13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS13W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS14`"]
        pub enum PPS14W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS14W::VALUE1 => false,
                    PPS14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS14W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS15`"]
        pub enum PPS15W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS15W::VALUE1 => false,
                    PPS15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS15W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&self) -> PPS0R {
                PPS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&self) -> PPS1R {
                PPS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&self) -> PPS2R {
                PPS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&self) -> PPS3R {
                PPS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&self) -> PPS4R {
                PPS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&self) -> PPS5R {
                PPS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&self) -> PPS6R {
                PPS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&self) -> PPS7R {
                PPS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&self) -> PPS8R {
                PPS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&self) -> PPS9R {
                PPS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&self) -> PPS10R {
                PPS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&self) -> PPS11R {
                PPS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&self) -> PPS12R {
                PPS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&self) -> PPS13R {
                PPS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&self) -> PPS14R {
                PPS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&self) -> PPS15R {
                PPS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&mut self) -> _PPS0W {
                _PPS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&mut self) -> _PPS1W {
                _PPS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&mut self) -> _PPS2W {
                _PPS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&mut self) -> _PPS3W {
                _PPS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&mut self) -> _PPS4W {
                _PPS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&mut self) -> _PPS5W {
                _PPS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&mut self) -> _PPS6W {
                _PPS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&mut self) -> _PPS7W {
                _PPS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&mut self) -> _PPS8W {
                _PPS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&mut self) -> _PPS9W {
                _PPS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&mut self) -> _PPS10W {
                _PPS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&mut self) -> _PPS11W {
                _PPS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&mut self) -> _PPS12W {
                _PPS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&mut self) -> _PPS13W {
                _PPS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&mut self) -> _PPS14W {
                _PPS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&mut self) -> _PPS15W {
                _PPS15W { w: self }
            }
        }
    }
    #[doc = "Port 1 Pin Hardware Select Register"]
    pub struct HWSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 1 Pin Hardware Select Register"]
    pub mod hwsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HWSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HW0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW0R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW0R::VALUE1 => 0,
                    HW0R::VALUE2 => 0x01,
                    HW0R::VALUE3 => 0x02,
                    HW0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW0R {
                match value {
                    0 => HW0R::VALUE1,
                    1 => HW0R::VALUE2,
                    2 => HW0R::VALUE3,
                    i => HW0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW0R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW1R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW1R::VALUE1 => 0,
                    HW1R::VALUE2 => 0x01,
                    HW1R::VALUE3 => 0x02,
                    HW1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW1R {
                match value {
                    0 => HW1R::VALUE1,
                    1 => HW1R::VALUE2,
                    2 => HW1R::VALUE3,
                    i => HW1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW1R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW2R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW2R::VALUE1 => 0,
                    HW2R::VALUE2 => 0x01,
                    HW2R::VALUE3 => 0x02,
                    HW2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW2R {
                match value {
                    0 => HW2R::VALUE1,
                    1 => HW2R::VALUE2,
                    2 => HW2R::VALUE3,
                    i => HW2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW2R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW3R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW3R::VALUE1 => 0,
                    HW3R::VALUE2 => 0x01,
                    HW3R::VALUE3 => 0x02,
                    HW3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW3R {
                match value {
                    0 => HW3R::VALUE1,
                    1 => HW3R::VALUE2,
                    2 => HW3R::VALUE3,
                    i => HW3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW3R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW4R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW4R::VALUE1 => 0,
                    HW4R::VALUE2 => 0x01,
                    HW4R::VALUE3 => 0x02,
                    HW4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW4R {
                match value {
                    0 => HW4R::VALUE1,
                    1 => HW4R::VALUE2,
                    2 => HW4R::VALUE3,
                    i => HW4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW4R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW5R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW5R::VALUE1 => 0,
                    HW5R::VALUE2 => 0x01,
                    HW5R::VALUE3 => 0x02,
                    HW5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW5R {
                match value {
                    0 => HW5R::VALUE1,
                    1 => HW5R::VALUE2,
                    2 => HW5R::VALUE3,
                    i => HW5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW5R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW6R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW6R::VALUE1 => 0,
                    HW6R::VALUE2 => 0x01,
                    HW6R::VALUE3 => 0x02,
                    HW6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW6R {
                match value {
                    0 => HW6R::VALUE1,
                    1 => HW6R::VALUE2,
                    2 => HW6R::VALUE3,
                    i => HW6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW6R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW7R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW7R::VALUE1 => 0,
                    HW7R::VALUE2 => 0x01,
                    HW7R::VALUE3 => 0x02,
                    HW7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW7R {
                match value {
                    0 => HW7R::VALUE1,
                    1 => HW7R::VALUE2,
                    2 => HW7R::VALUE3,
                    i => HW7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW7R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW8R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW8R::VALUE1 => 0,
                    HW8R::VALUE2 => 0x01,
                    HW8R::VALUE3 => 0x02,
                    HW8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW8R {
                match value {
                    0 => HW8R::VALUE1,
                    1 => HW8R::VALUE2,
                    2 => HW8R::VALUE3,
                    i => HW8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW8R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW9R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW9R::VALUE1 => 0,
                    HW9R::VALUE2 => 0x01,
                    HW9R::VALUE3 => 0x02,
                    HW9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW9R {
                match value {
                    0 => HW9R::VALUE1,
                    1 => HW9R::VALUE2,
                    2 => HW9R::VALUE3,
                    i => HW9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW9R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW10R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW10R::VALUE1 => 0,
                    HW10R::VALUE2 => 0x01,
                    HW10R::VALUE3 => 0x02,
                    HW10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW10R {
                match value {
                    0 => HW10R::VALUE1,
                    1 => HW10R::VALUE2,
                    2 => HW10R::VALUE3,
                    i => HW10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW10R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW11R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW11R::VALUE1 => 0,
                    HW11R::VALUE2 => 0x01,
                    HW11R::VALUE3 => 0x02,
                    HW11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW11R {
                match value {
                    0 => HW11R::VALUE1,
                    1 => HW11R::VALUE2,
                    2 => HW11R::VALUE3,
                    i => HW11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW11R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW12R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW12R::VALUE1 => 0,
                    HW12R::VALUE2 => 0x01,
                    HW12R::VALUE3 => 0x02,
                    HW12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW12R {
                match value {
                    0 => HW12R::VALUE1,
                    1 => HW12R::VALUE2,
                    2 => HW12R::VALUE3,
                    i => HW12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW12R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW13R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW13R::VALUE1 => 0,
                    HW13R::VALUE2 => 0x01,
                    HW13R::VALUE3 => 0x02,
                    HW13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW13R {
                match value {
                    0 => HW13R::VALUE1,
                    1 => HW13R::VALUE2,
                    2 => HW13R::VALUE3,
                    i => HW13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW13R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW14R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW14R::VALUE1 => 0,
                    HW14R::VALUE2 => 0x01,
                    HW14R::VALUE3 => 0x02,
                    HW14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW14R {
                match value {
                    0 => HW14R::VALUE1,
                    1 => HW14R::VALUE2,
                    2 => HW14R::VALUE3,
                    i => HW14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW14R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW15R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW15R::VALUE1 => 0,
                    HW15R::VALUE2 => 0x01,
                    HW15R::VALUE3 => 0x02,
                    HW15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW15R {
                match value {
                    0 => HW15R::VALUE1,
                    1 => HW15R::VALUE2,
                    2 => HW15R::VALUE3,
                    i => HW15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW15R::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `HW0`"]
        pub enum HW0W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW0W::VALUE1 => 0,
                    HW0W::VALUE2 => 1,
                    HW0W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW0W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW0W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW0W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW1`"]
        pub enum HW1W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW1W::VALUE1 => 0,
                    HW1W::VALUE2 => 1,
                    HW1W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW1W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW1W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW1W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW2`"]
        pub enum HW2W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW2W::VALUE1 => 0,
                    HW2W::VALUE2 => 1,
                    HW2W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW2W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW2W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW2W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW3`"]
        pub enum HW3W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW3W::VALUE1 => 0,
                    HW3W::VALUE2 => 1,
                    HW3W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW3W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW3W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW3W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW4`"]
        pub enum HW4W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW4W::VALUE1 => 0,
                    HW4W::VALUE2 => 1,
                    HW4W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW4W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW4W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW4W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW5`"]
        pub enum HW5W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW5W::VALUE1 => 0,
                    HW5W::VALUE2 => 1,
                    HW5W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW5W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW5W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW5W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW6`"]
        pub enum HW6W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW6W::VALUE1 => 0,
                    HW6W::VALUE2 => 1,
                    HW6W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW6W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW6W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW6W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW7`"]
        pub enum HW7W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW7W::VALUE1 => 0,
                    HW7W::VALUE2 => 1,
                    HW7W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW7W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW7W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW7W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW8`"]
        pub enum HW8W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW8W::VALUE1 => 0,
                    HW8W::VALUE2 => 1,
                    HW8W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW8W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW8W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW8W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW9`"]
        pub enum HW9W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW9W::VALUE1 => 0,
                    HW9W::VALUE2 => 1,
                    HW9W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW9W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW9W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW9W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW10`"]
        pub enum HW10W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW10W::VALUE1 => 0,
                    HW10W::VALUE2 => 1,
                    HW10W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW10W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW10W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW10W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW11`"]
        pub enum HW11W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW11W::VALUE1 => 0,
                    HW11W::VALUE2 => 1,
                    HW11W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW11W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW11W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW11W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW12`"]
        pub enum HW12W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW12W::VALUE1 => 0,
                    HW12W::VALUE2 => 1,
                    HW12W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW12W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW12W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW12W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW13`"]
        pub enum HW13W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW13W::VALUE1 => 0,
                    HW13W::VALUE2 => 1,
                    HW13W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW13W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW13W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW13W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW14`"]
        pub enum HW14W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW14W::VALUE1 => 0,
                    HW14W::VALUE2 => 1,
                    HW14W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW14W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW14W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW14W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW15`"]
        pub enum HW15W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW15W::VALUE1 => 0,
                    HW15W::VALUE2 => 1,
                    HW15W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW15W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW15W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW15W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&self) -> HW0R {
                HW0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&self) -> HW1R {
                HW1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&self) -> HW2R {
                HW2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&self) -> HW3R {
                HW3R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&self) -> HW4R {
                HW4R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&self) -> HW5R {
                HW5R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&self) -> HW6R {
                HW6R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&self) -> HW7R {
                HW7R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&self) -> HW8R {
                HW8R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&self) -> HW9R {
                HW9R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&self) -> HW10R {
                HW10R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&self) -> HW11R {
                HW11R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&self) -> HW12R {
                HW12R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&self) -> HW13R {
                HW13R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&self) -> HW14R {
                HW14R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&self) -> HW15R {
                HW15R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&mut self) -> _HW0W {
                _HW0W { w: self }
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&mut self) -> _HW1W {
                _HW1W { w: self }
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&mut self) -> _HW2W {
                _HW2W { w: self }
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&mut self) -> _HW3W {
                _HW3W { w: self }
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&mut self) -> _HW4W {
                _HW4W { w: self }
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&mut self) -> _HW5W {
                _HW5W { w: self }
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&mut self) -> _HW6W {
                _HW6W { w: self }
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&mut self) -> _HW7W {
                _HW7W { w: self }
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&mut self) -> _HW8W {
                _HW8W { w: self }
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&mut self) -> _HW9W {
                _HW9W { w: self }
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&mut self) -> _HW10W {
                _HW10W { w: self }
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&mut self) -> _HW11W {
                _HW11W { w: self }
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&mut self) -> _HW12W {
                _HW12W { w: self }
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&mut self) -> _HW13W {
                _HW13W { w: self }
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&mut self) -> _HW14W {
                _HW14W { w: self }
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&mut self) -> _HW15W {
                _HW15W { w: self }
            }
        }
    }
}
#[doc = "Port 1"]
pub struct PORT1 {
    register_block: port1::RegisterBlock,
}
impl Deref for PORT1 {
    type Target = port1::RegisterBlock;
    fn deref(&self) -> &port1::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Port 2"]
pub const PORT2: Peripheral<PORT2> = unsafe { Peripheral::new(0x4802_8200) };
#[doc = "Port 2"]
pub mod port2 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Port 2 Output Register"]
        pub out: OUT,
        #[doc = "0x04 - Port 2 Output Modification Register"]
        pub omr: OMR,
        _reserved0: [u8; 8usize],
        #[doc = "0x10 - Port 2 Input/Output Control Register 0"]
        pub iocr0: IOCR0,
        #[doc = "0x14 - Port 2 Input/Output Control Register 4"]
        pub iocr4: IOCR4,
        #[doc = "0x18 - Port 2 Input/Output Control Register 8"]
        pub iocr8: IOCR8,
        #[doc = "0x1c - Port 2 Input/Output Control Register 12"]
        pub iocr12: IOCR12,
        _reserved1: [u8; 4usize],
        #[doc = "0x24 - Port 2 Input Register"]
        pub in_: IN,
        _reserved2: [u8; 24usize],
        #[doc = "0x40 - Port 2 Pad Driver Mode 0 Register"]
        pub pdr0: PDR0,
        #[doc = "0x44 - Port 2 Pad Driver Mode 1 Register"]
        pub pdr1: PDR1,
        _reserved3: [u8; 24usize],
        #[doc = "0x60 - Port 2 Pin Function Decision Control Register"]
        pub pdisc: PDISC,
        _reserved4: [u8; 12usize],
        #[doc = "0x70 - Port 2 Pin Power Save Register"]
        pub pps: PPS,
        #[doc = "0x74 - Port 2 Pin Hardware Select Register"]
        pub hwsel: HWSEL,
    }
    #[doc = "Port 2 Output Register"]
    pub struct OUT {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Output Register"]
    pub mod out {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OUT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `P0`"]
        pub enum P0W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P0W::VALUE1 => false,
                    P0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P0W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P1`"]
        pub enum P1W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P1W::VALUE1 => false,
                    P1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P1W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P2`"]
        pub enum P2W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P2W::VALUE1 => false,
                    P2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P2W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P3`"]
        pub enum P3W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P3W::VALUE1 => false,
                    P3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P3W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P4`"]
        pub enum P4W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P4W::VALUE1 => false,
                    P4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P4W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P5`"]
        pub enum P5W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P5W::VALUE1 => false,
                    P5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P5W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P6`"]
        pub enum P6W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P6W::VALUE1 => false,
                    P6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P6W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P7`"]
        pub enum P7W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P7W::VALUE1 => false,
                    P7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P7W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P8`"]
        pub enum P8W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P8W::VALUE1 => false,
                    P8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P8W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P9`"]
        pub enum P9W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P9W::VALUE1 => false,
                    P9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P9W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P10`"]
        pub enum P10W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P10W::VALUE1 => false,
                    P10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P10W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P11`"]
        pub enum P11W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P11W::VALUE1 => false,
                    P11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P11W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P12`"]
        pub enum P12W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P12W::VALUE1 => false,
                    P12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P12W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P13`"]
        pub enum P13W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P13W::VALUE1 => false,
                    P13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P13W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P14`"]
        pub enum P14W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P14W::VALUE1 => false,
                    P14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P14W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P15`"]
        pub enum P15W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P15W::VALUE1 => false,
                    P15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P15W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&mut self) -> _P0W {
                _P0W { w: self }
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&mut self) -> _P1W {
                _P1W { w: self }
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&mut self) -> _P2W {
                _P2W { w: self }
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&mut self) -> _P3W {
                _P3W { w: self }
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&mut self) -> _P4W {
                _P4W { w: self }
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&mut self) -> _P5W {
                _P5W { w: self }
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&mut self) -> _P6W {
                _P6W { w: self }
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&mut self) -> _P7W {
                _P7W { w: self }
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&mut self) -> _P8W {
                _P8W { w: self }
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&mut self) -> _P9W {
                _P9W { w: self }
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&mut self) -> _P10W {
                _P10W { w: self }
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&mut self) -> _P11W {
                _P11W { w: self }
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&mut self) -> _P12W {
                _P12W { w: self }
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&mut self) -> _P13W {
                _P13W { w: self }
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&mut self) -> _P14W {
                _P14W { w: self }
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&mut self) -> _P15W {
                _P15W { w: self }
            }
        }
    }
    #[doc = "Port 2 Output Modification Register"]
    pub struct OMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Output Modification Register"]
    pub mod omr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OMR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Set Bit 0"]
            #[inline]
            pub fn ps0(&mut self) -> _PS0W {
                _PS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Set Bit 1"]
            #[inline]
            pub fn ps1(&mut self) -> _PS1W {
                _PS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Set Bit 2"]
            #[inline]
            pub fn ps2(&mut self) -> _PS2W {
                _PS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Set Bit 3"]
            #[inline]
            pub fn ps3(&mut self) -> _PS3W {
                _PS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Set Bit 4"]
            #[inline]
            pub fn ps4(&mut self) -> _PS4W {
                _PS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Set Bit 5"]
            #[inline]
            pub fn ps5(&mut self) -> _PS5W {
                _PS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Set Bit 6"]
            #[inline]
            pub fn ps6(&mut self) -> _PS6W {
                _PS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Set Bit 7"]
            #[inline]
            pub fn ps7(&mut self) -> _PS7W {
                _PS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Set Bit 8"]
            #[inline]
            pub fn ps8(&mut self) -> _PS8W {
                _PS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Set Bit 9"]
            #[inline]
            pub fn ps9(&mut self) -> _PS9W {
                _PS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Set Bit 10"]
            #[inline]
            pub fn ps10(&mut self) -> _PS10W {
                _PS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Set Bit 11"]
            #[inline]
            pub fn ps11(&mut self) -> _PS11W {
                _PS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Set Bit 12"]
            #[inline]
            pub fn ps12(&mut self) -> _PS12W {
                _PS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Set Bit 13"]
            #[inline]
            pub fn ps13(&mut self) -> _PS13W {
                _PS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Set Bit 14"]
            #[inline]
            pub fn ps14(&mut self) -> _PS14W {
                _PS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Set Bit 15"]
            #[inline]
            pub fn ps15(&mut self) -> _PS15W {
                _PS15W { w: self }
            }
            #[doc = "Bit 16 - Port n Reset Bit 0"]
            #[inline]
            pub fn pr0(&mut self) -> _PR0W {
                _PR0W { w: self }
            }
            #[doc = "Bit 17 - Port n Reset Bit 1"]
            #[inline]
            pub fn pr1(&mut self) -> _PR1W {
                _PR1W { w: self }
            }
            #[doc = "Bit 18 - Port n Reset Bit 2"]
            #[inline]
            pub fn pr2(&mut self) -> _PR2W {
                _PR2W { w: self }
            }
            #[doc = "Bit 19 - Port n Reset Bit 3"]
            #[inline]
            pub fn pr3(&mut self) -> _PR3W {
                _PR3W { w: self }
            }
            #[doc = "Bit 20 - Port n Reset Bit 4"]
            #[inline]
            pub fn pr4(&mut self) -> _PR4W {
                _PR4W { w: self }
            }
            #[doc = "Bit 21 - Port n Reset Bit 5"]
            #[inline]
            pub fn pr5(&mut self) -> _PR5W {
                _PR5W { w: self }
            }
            #[doc = "Bit 22 - Port n Reset Bit 6"]
            #[inline]
            pub fn pr6(&mut self) -> _PR6W {
                _PR6W { w: self }
            }
            #[doc = "Bit 23 - Port n Reset Bit 7"]
            #[inline]
            pub fn pr7(&mut self) -> _PR7W {
                _PR7W { w: self }
            }
            #[doc = "Bit 24 - Port n Reset Bit 8"]
            #[inline]
            pub fn pr8(&mut self) -> _PR8W {
                _PR8W { w: self }
            }
            #[doc = "Bit 25 - Port n Reset Bit 9"]
            #[inline]
            pub fn pr9(&mut self) -> _PR9W {
                _PR9W { w: self }
            }
            #[doc = "Bit 26 - Port n Reset Bit 10"]
            #[inline]
            pub fn pr10(&mut self) -> _PR10W {
                _PR10W { w: self }
            }
            #[doc = "Bit 27 - Port n Reset Bit 11"]
            #[inline]
            pub fn pr11(&mut self) -> _PR11W {
                _PR11W { w: self }
            }
            #[doc = "Bit 28 - Port n Reset Bit 12"]
            #[inline]
            pub fn pr12(&mut self) -> _PR12W {
                _PR12W { w: self }
            }
            #[doc = "Bit 29 - Port n Reset Bit 13"]
            #[inline]
            pub fn pr13(&mut self) -> _PR13W {
                _PR13W { w: self }
            }
            #[doc = "Bit 30 - Port n Reset Bit 14"]
            #[inline]
            pub fn pr14(&mut self) -> _PR14W {
                _PR14W { w: self }
            }
            #[doc = "Bit 31 - Port n Reset Bit 15"]
            #[inline]
            pub fn pr15(&mut self) -> _PR15W {
                _PR15W { w: self }
            }
        }
    }
    #[doc = "Port 2 Input/Output Control Register 0"]
    pub struct IOCR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Input/Output Control Register 0"]
    pub mod iocr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC0R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC0R::VALUE1 => 0,
                    PC0R::VALUE2 => 0x01,
                    PC0R::VALUE3 => 0x02,
                    PC0R::VALUE4 => 0x03,
                    PC0R::VALUE5 => 0x04,
                    PC0R::VALUE6 => 0x05,
                    PC0R::VALUE7 => 0x06,
                    PC0R::VALUE8 => 0x07,
                    PC0R::VALUE9 => 0x10,
                    PC0R::VALUE10 => 0x11,
                    PC0R::VALUE11 => 0x12,
                    PC0R::VALUE12 => 0x13,
                    PC0R::VALUE13 => 0x14,
                    PC0R::VALUE14 => 0x18,
                    PC0R::VALUE15 => 0x19,
                    PC0R::VALUE16 => 0x1a,
                    PC0R::VALUE17 => 0x1b,
                    PC0R::VALUE18 => 0x1c,
                    PC0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC0R {
                match value {
                    0 => PC0R::VALUE1,
                    1 => PC0R::VALUE2,
                    2 => PC0R::VALUE3,
                    3 => PC0R::VALUE4,
                    4 => PC0R::VALUE5,
                    5 => PC0R::VALUE6,
                    6 => PC0R::VALUE7,
                    7 => PC0R::VALUE8,
                    16 => PC0R::VALUE9,
                    17 => PC0R::VALUE10,
                    18 => PC0R::VALUE11,
                    19 => PC0R::VALUE12,
                    20 => PC0R::VALUE13,
                    24 => PC0R::VALUE14,
                    25 => PC0R::VALUE15,
                    26 => PC0R::VALUE16,
                    27 => PC0R::VALUE17,
                    28 => PC0R::VALUE18,
                    i => PC0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC0R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC0R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC0R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC0R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC0R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC0R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC0R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC0R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC0R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC0R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC0R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC0R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC0R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC0R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC0R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC1R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC1R::VALUE1 => 0,
                    PC1R::VALUE2 => 0x01,
                    PC1R::VALUE3 => 0x02,
                    PC1R::VALUE4 => 0x03,
                    PC1R::VALUE5 => 0x04,
                    PC1R::VALUE6 => 0x05,
                    PC1R::VALUE7 => 0x06,
                    PC1R::VALUE8 => 0x07,
                    PC1R::VALUE9 => 0x10,
                    PC1R::VALUE10 => 0x11,
                    PC1R::VALUE11 => 0x12,
                    PC1R::VALUE12 => 0x13,
                    PC1R::VALUE13 => 0x14,
                    PC1R::VALUE14 => 0x18,
                    PC1R::VALUE15 => 0x19,
                    PC1R::VALUE16 => 0x1a,
                    PC1R::VALUE17 => 0x1b,
                    PC1R::VALUE18 => 0x1c,
                    PC1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC1R {
                match value {
                    0 => PC1R::VALUE1,
                    1 => PC1R::VALUE2,
                    2 => PC1R::VALUE3,
                    3 => PC1R::VALUE4,
                    4 => PC1R::VALUE5,
                    5 => PC1R::VALUE6,
                    6 => PC1R::VALUE7,
                    7 => PC1R::VALUE8,
                    16 => PC1R::VALUE9,
                    17 => PC1R::VALUE10,
                    18 => PC1R::VALUE11,
                    19 => PC1R::VALUE12,
                    20 => PC1R::VALUE13,
                    24 => PC1R::VALUE14,
                    25 => PC1R::VALUE15,
                    26 => PC1R::VALUE16,
                    27 => PC1R::VALUE17,
                    28 => PC1R::VALUE18,
                    i => PC1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC1R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC1R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC1R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC1R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC1R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC1R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC1R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC1R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC1R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC1R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC1R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC1R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC1R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC1R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC1R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC2R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC2R::VALUE1 => 0,
                    PC2R::VALUE2 => 0x01,
                    PC2R::VALUE3 => 0x02,
                    PC2R::VALUE4 => 0x03,
                    PC2R::VALUE5 => 0x04,
                    PC2R::VALUE6 => 0x05,
                    PC2R::VALUE7 => 0x06,
                    PC2R::VALUE8 => 0x07,
                    PC2R::VALUE9 => 0x10,
                    PC2R::VALUE10 => 0x11,
                    PC2R::VALUE11 => 0x12,
                    PC2R::VALUE12 => 0x13,
                    PC2R::VALUE13 => 0x14,
                    PC2R::VALUE14 => 0x18,
                    PC2R::VALUE15 => 0x19,
                    PC2R::VALUE16 => 0x1a,
                    PC2R::VALUE17 => 0x1b,
                    PC2R::VALUE18 => 0x1c,
                    PC2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC2R {
                match value {
                    0 => PC2R::VALUE1,
                    1 => PC2R::VALUE2,
                    2 => PC2R::VALUE3,
                    3 => PC2R::VALUE4,
                    4 => PC2R::VALUE5,
                    5 => PC2R::VALUE6,
                    6 => PC2R::VALUE7,
                    7 => PC2R::VALUE8,
                    16 => PC2R::VALUE9,
                    17 => PC2R::VALUE10,
                    18 => PC2R::VALUE11,
                    19 => PC2R::VALUE12,
                    20 => PC2R::VALUE13,
                    24 => PC2R::VALUE14,
                    25 => PC2R::VALUE15,
                    26 => PC2R::VALUE16,
                    27 => PC2R::VALUE17,
                    28 => PC2R::VALUE18,
                    i => PC2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC2R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC2R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC2R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC2R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC2R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC2R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC2R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC2R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC2R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC2R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC2R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC2R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC2R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC2R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC2R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC3R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC3R::VALUE1 => 0,
                    PC3R::VALUE2 => 0x01,
                    PC3R::VALUE3 => 0x02,
                    PC3R::VALUE4 => 0x03,
                    PC3R::VALUE5 => 0x04,
                    PC3R::VALUE6 => 0x05,
                    PC3R::VALUE7 => 0x06,
                    PC3R::VALUE8 => 0x07,
                    PC3R::VALUE9 => 0x10,
                    PC3R::VALUE10 => 0x11,
                    PC3R::VALUE11 => 0x12,
                    PC3R::VALUE12 => 0x13,
                    PC3R::VALUE13 => 0x14,
                    PC3R::VALUE14 => 0x18,
                    PC3R::VALUE15 => 0x19,
                    PC3R::VALUE16 => 0x1a,
                    PC3R::VALUE17 => 0x1b,
                    PC3R::VALUE18 => 0x1c,
                    PC3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC3R {
                match value {
                    0 => PC3R::VALUE1,
                    1 => PC3R::VALUE2,
                    2 => PC3R::VALUE3,
                    3 => PC3R::VALUE4,
                    4 => PC3R::VALUE5,
                    5 => PC3R::VALUE6,
                    6 => PC3R::VALUE7,
                    7 => PC3R::VALUE8,
                    16 => PC3R::VALUE9,
                    17 => PC3R::VALUE10,
                    18 => PC3R::VALUE11,
                    19 => PC3R::VALUE12,
                    20 => PC3R::VALUE13,
                    24 => PC3R::VALUE14,
                    25 => PC3R::VALUE15,
                    26 => PC3R::VALUE16,
                    27 => PC3R::VALUE17,
                    28 => PC3R::VALUE18,
                    i => PC3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC3R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC3R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC3R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC3R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC3R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC3R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC3R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC3R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC3R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC3R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC3R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC3R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC3R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC3R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC3R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC3R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC0`"]
        pub enum PC0W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC0W::VALUE1 => 0,
                    PC0W::VALUE2 => 1,
                    PC0W::VALUE3 => 2,
                    PC0W::VALUE4 => 3,
                    PC0W::VALUE5 => 4,
                    PC0W::VALUE6 => 5,
                    PC0W::VALUE7 => 6,
                    PC0W::VALUE8 => 7,
                    PC0W::VALUE9 => 16,
                    PC0W::VALUE10 => 17,
                    PC0W::VALUE11 => 18,
                    PC0W::VALUE12 => 19,
                    PC0W::VALUE13 => 20,
                    PC0W::VALUE14 => 24,
                    PC0W::VALUE15 => 25,
                    PC0W::VALUE16 => 26,
                    PC0W::VALUE17 => 27,
                    PC0W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC0W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC0W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC0W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC0W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC0W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC0W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC0W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC0W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC0W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC0W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC0W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC0W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC0W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC0W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC0W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC0W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC0W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC0W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC1`"]
        pub enum PC1W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC1W::VALUE1 => 0,
                    PC1W::VALUE2 => 1,
                    PC1W::VALUE3 => 2,
                    PC1W::VALUE4 => 3,
                    PC1W::VALUE5 => 4,
                    PC1W::VALUE6 => 5,
                    PC1W::VALUE7 => 6,
                    PC1W::VALUE8 => 7,
                    PC1W::VALUE9 => 16,
                    PC1W::VALUE10 => 17,
                    PC1W::VALUE11 => 18,
                    PC1W::VALUE12 => 19,
                    PC1W::VALUE13 => 20,
                    PC1W::VALUE14 => 24,
                    PC1W::VALUE15 => 25,
                    PC1W::VALUE16 => 26,
                    PC1W::VALUE17 => 27,
                    PC1W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC1W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC1W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC1W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC1W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC1W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC1W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC1W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC1W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC1W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC1W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC1W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC1W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC1W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC1W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC1W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC1W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC1W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC1W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC2`"]
        pub enum PC2W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC2W::VALUE1 => 0,
                    PC2W::VALUE2 => 1,
                    PC2W::VALUE3 => 2,
                    PC2W::VALUE4 => 3,
                    PC2W::VALUE5 => 4,
                    PC2W::VALUE6 => 5,
                    PC2W::VALUE7 => 6,
                    PC2W::VALUE8 => 7,
                    PC2W::VALUE9 => 16,
                    PC2W::VALUE10 => 17,
                    PC2W::VALUE11 => 18,
                    PC2W::VALUE12 => 19,
                    PC2W::VALUE13 => 20,
                    PC2W::VALUE14 => 24,
                    PC2W::VALUE15 => 25,
                    PC2W::VALUE16 => 26,
                    PC2W::VALUE17 => 27,
                    PC2W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC2W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC2W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC2W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC2W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC2W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC2W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC2W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC2W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC2W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC2W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC2W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC2W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC2W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC2W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC2W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC2W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC2W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC2W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC3`"]
        pub enum PC3W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC3W::VALUE1 => 0,
                    PC3W::VALUE2 => 1,
                    PC3W::VALUE3 => 2,
                    PC3W::VALUE4 => 3,
                    PC3W::VALUE5 => 4,
                    PC3W::VALUE6 => 5,
                    PC3W::VALUE7 => 6,
                    PC3W::VALUE8 => 7,
                    PC3W::VALUE9 => 16,
                    PC3W::VALUE10 => 17,
                    PC3W::VALUE11 => 18,
                    PC3W::VALUE12 => 19,
                    PC3W::VALUE13 => 20,
                    PC3W::VALUE14 => 24,
                    PC3W::VALUE15 => 25,
                    PC3W::VALUE16 => 26,
                    PC3W::VALUE17 => 27,
                    PC3W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC3W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC3W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC3W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC3W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC3W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC3W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC3W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC3W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC3W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC3W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC3W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC3W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC3W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC3W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC3W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC3W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC3W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC3W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&self) -> PC0R {
                PC0R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&self) -> PC1R {
                PC1R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&self) -> PC2R {
                PC2R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&self) -> PC3R {
                PC3R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&mut self) -> _PC0W {
                _PC0W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&mut self) -> _PC1W {
                _PC1W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&mut self) -> _PC2W {
                _PC2W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&mut self) -> _PC3W {
                _PC3W { w: self }
            }
        }
    }
    #[doc = "Port 2 Input/Output Control Register 4"]
    pub struct IOCR4 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Input/Output Control Register 4"]
    pub mod iocr4 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR4 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC4R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC4R::VALUE1 => 0,
                    PC4R::VALUE2 => 0x01,
                    PC4R::VALUE3 => 0x02,
                    PC4R::VALUE4 => 0x03,
                    PC4R::VALUE5 => 0x04,
                    PC4R::VALUE6 => 0x05,
                    PC4R::VALUE7 => 0x06,
                    PC4R::VALUE8 => 0x07,
                    PC4R::VALUE9 => 0x10,
                    PC4R::VALUE10 => 0x11,
                    PC4R::VALUE11 => 0x12,
                    PC4R::VALUE12 => 0x13,
                    PC4R::VALUE13 => 0x14,
                    PC4R::VALUE14 => 0x18,
                    PC4R::VALUE15 => 0x19,
                    PC4R::VALUE16 => 0x1a,
                    PC4R::VALUE17 => 0x1b,
                    PC4R::VALUE18 => 0x1c,
                    PC4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC4R {
                match value {
                    0 => PC4R::VALUE1,
                    1 => PC4R::VALUE2,
                    2 => PC4R::VALUE3,
                    3 => PC4R::VALUE4,
                    4 => PC4R::VALUE5,
                    5 => PC4R::VALUE6,
                    6 => PC4R::VALUE7,
                    7 => PC4R::VALUE8,
                    16 => PC4R::VALUE9,
                    17 => PC4R::VALUE10,
                    18 => PC4R::VALUE11,
                    19 => PC4R::VALUE12,
                    20 => PC4R::VALUE13,
                    24 => PC4R::VALUE14,
                    25 => PC4R::VALUE15,
                    26 => PC4R::VALUE16,
                    27 => PC4R::VALUE17,
                    28 => PC4R::VALUE18,
                    i => PC4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC4R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC4R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC4R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC4R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC4R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC4R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC4R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC4R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC4R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC4R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC4R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC4R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC4R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC4R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC4R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC4R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC5R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC5R::VALUE1 => 0,
                    PC5R::VALUE2 => 0x01,
                    PC5R::VALUE3 => 0x02,
                    PC5R::VALUE4 => 0x03,
                    PC5R::VALUE5 => 0x04,
                    PC5R::VALUE6 => 0x05,
                    PC5R::VALUE7 => 0x06,
                    PC5R::VALUE8 => 0x07,
                    PC5R::VALUE9 => 0x10,
                    PC5R::VALUE10 => 0x11,
                    PC5R::VALUE11 => 0x12,
                    PC5R::VALUE12 => 0x13,
                    PC5R::VALUE13 => 0x14,
                    PC5R::VALUE14 => 0x18,
                    PC5R::VALUE15 => 0x19,
                    PC5R::VALUE16 => 0x1a,
                    PC5R::VALUE17 => 0x1b,
                    PC5R::VALUE18 => 0x1c,
                    PC5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC5R {
                match value {
                    0 => PC5R::VALUE1,
                    1 => PC5R::VALUE2,
                    2 => PC5R::VALUE3,
                    3 => PC5R::VALUE4,
                    4 => PC5R::VALUE5,
                    5 => PC5R::VALUE6,
                    6 => PC5R::VALUE7,
                    7 => PC5R::VALUE8,
                    16 => PC5R::VALUE9,
                    17 => PC5R::VALUE10,
                    18 => PC5R::VALUE11,
                    19 => PC5R::VALUE12,
                    20 => PC5R::VALUE13,
                    24 => PC5R::VALUE14,
                    25 => PC5R::VALUE15,
                    26 => PC5R::VALUE16,
                    27 => PC5R::VALUE17,
                    28 => PC5R::VALUE18,
                    i => PC5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC5R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC5R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC5R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC5R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC5R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC5R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC5R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC5R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC5R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC5R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC5R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC5R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC5R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC5R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC5R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC5R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC6R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC6R::VALUE1 => 0,
                    PC6R::VALUE2 => 0x01,
                    PC6R::VALUE3 => 0x02,
                    PC6R::VALUE4 => 0x03,
                    PC6R::VALUE5 => 0x04,
                    PC6R::VALUE6 => 0x05,
                    PC6R::VALUE7 => 0x06,
                    PC6R::VALUE8 => 0x07,
                    PC6R::VALUE9 => 0x10,
                    PC6R::VALUE10 => 0x11,
                    PC6R::VALUE11 => 0x12,
                    PC6R::VALUE12 => 0x13,
                    PC6R::VALUE13 => 0x14,
                    PC6R::VALUE14 => 0x18,
                    PC6R::VALUE15 => 0x19,
                    PC6R::VALUE16 => 0x1a,
                    PC6R::VALUE17 => 0x1b,
                    PC6R::VALUE18 => 0x1c,
                    PC6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC6R {
                match value {
                    0 => PC6R::VALUE1,
                    1 => PC6R::VALUE2,
                    2 => PC6R::VALUE3,
                    3 => PC6R::VALUE4,
                    4 => PC6R::VALUE5,
                    5 => PC6R::VALUE6,
                    6 => PC6R::VALUE7,
                    7 => PC6R::VALUE8,
                    16 => PC6R::VALUE9,
                    17 => PC6R::VALUE10,
                    18 => PC6R::VALUE11,
                    19 => PC6R::VALUE12,
                    20 => PC6R::VALUE13,
                    24 => PC6R::VALUE14,
                    25 => PC6R::VALUE15,
                    26 => PC6R::VALUE16,
                    27 => PC6R::VALUE17,
                    28 => PC6R::VALUE18,
                    i => PC6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC6R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC6R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC6R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC6R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC6R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC6R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC6R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC6R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC6R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC6R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC6R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC6R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC6R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC6R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC6R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC6R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC7R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC7R::VALUE1 => 0,
                    PC7R::VALUE2 => 0x01,
                    PC7R::VALUE3 => 0x02,
                    PC7R::VALUE4 => 0x03,
                    PC7R::VALUE5 => 0x04,
                    PC7R::VALUE6 => 0x05,
                    PC7R::VALUE7 => 0x06,
                    PC7R::VALUE8 => 0x07,
                    PC7R::VALUE9 => 0x10,
                    PC7R::VALUE10 => 0x11,
                    PC7R::VALUE11 => 0x12,
                    PC7R::VALUE12 => 0x13,
                    PC7R::VALUE13 => 0x14,
                    PC7R::VALUE14 => 0x18,
                    PC7R::VALUE15 => 0x19,
                    PC7R::VALUE16 => 0x1a,
                    PC7R::VALUE17 => 0x1b,
                    PC7R::VALUE18 => 0x1c,
                    PC7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC7R {
                match value {
                    0 => PC7R::VALUE1,
                    1 => PC7R::VALUE2,
                    2 => PC7R::VALUE3,
                    3 => PC7R::VALUE4,
                    4 => PC7R::VALUE5,
                    5 => PC7R::VALUE6,
                    6 => PC7R::VALUE7,
                    7 => PC7R::VALUE8,
                    16 => PC7R::VALUE9,
                    17 => PC7R::VALUE10,
                    18 => PC7R::VALUE11,
                    19 => PC7R::VALUE12,
                    20 => PC7R::VALUE13,
                    24 => PC7R::VALUE14,
                    25 => PC7R::VALUE15,
                    26 => PC7R::VALUE16,
                    27 => PC7R::VALUE17,
                    28 => PC7R::VALUE18,
                    i => PC7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC7R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC7R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC7R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC7R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC7R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC7R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC7R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC7R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC7R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC7R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC7R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC7R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC7R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC7R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC7R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC7R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC4`"]
        pub enum PC4W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC4W::VALUE1 => 0,
                    PC4W::VALUE2 => 1,
                    PC4W::VALUE3 => 2,
                    PC4W::VALUE4 => 3,
                    PC4W::VALUE5 => 4,
                    PC4W::VALUE6 => 5,
                    PC4W::VALUE7 => 6,
                    PC4W::VALUE8 => 7,
                    PC4W::VALUE9 => 16,
                    PC4W::VALUE10 => 17,
                    PC4W::VALUE11 => 18,
                    PC4W::VALUE12 => 19,
                    PC4W::VALUE13 => 20,
                    PC4W::VALUE14 => 24,
                    PC4W::VALUE15 => 25,
                    PC4W::VALUE16 => 26,
                    PC4W::VALUE17 => 27,
                    PC4W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC4W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC4W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC4W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC4W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC4W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC4W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC4W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC4W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC4W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC4W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC4W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC4W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC4W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC4W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC4W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC4W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC4W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC4W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC5`"]
        pub enum PC5W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC5W::VALUE1 => 0,
                    PC5W::VALUE2 => 1,
                    PC5W::VALUE3 => 2,
                    PC5W::VALUE4 => 3,
                    PC5W::VALUE5 => 4,
                    PC5W::VALUE6 => 5,
                    PC5W::VALUE7 => 6,
                    PC5W::VALUE8 => 7,
                    PC5W::VALUE9 => 16,
                    PC5W::VALUE10 => 17,
                    PC5W::VALUE11 => 18,
                    PC5W::VALUE12 => 19,
                    PC5W::VALUE13 => 20,
                    PC5W::VALUE14 => 24,
                    PC5W::VALUE15 => 25,
                    PC5W::VALUE16 => 26,
                    PC5W::VALUE17 => 27,
                    PC5W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC5W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC5W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC5W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC5W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC5W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC5W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC5W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC5W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC5W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC5W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC5W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC5W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC5W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC5W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC5W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC5W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC5W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC5W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC6`"]
        pub enum PC6W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC6W::VALUE1 => 0,
                    PC6W::VALUE2 => 1,
                    PC6W::VALUE3 => 2,
                    PC6W::VALUE4 => 3,
                    PC6W::VALUE5 => 4,
                    PC6W::VALUE6 => 5,
                    PC6W::VALUE7 => 6,
                    PC6W::VALUE8 => 7,
                    PC6W::VALUE9 => 16,
                    PC6W::VALUE10 => 17,
                    PC6W::VALUE11 => 18,
                    PC6W::VALUE12 => 19,
                    PC6W::VALUE13 => 20,
                    PC6W::VALUE14 => 24,
                    PC6W::VALUE15 => 25,
                    PC6W::VALUE16 => 26,
                    PC6W::VALUE17 => 27,
                    PC6W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC6W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC6W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC6W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC6W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC6W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC6W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC6W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC6W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC6W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC6W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC6W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC6W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC6W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC6W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC6W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC6W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC6W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC6W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC7`"]
        pub enum PC7W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC7W::VALUE1 => 0,
                    PC7W::VALUE2 => 1,
                    PC7W::VALUE3 => 2,
                    PC7W::VALUE4 => 3,
                    PC7W::VALUE5 => 4,
                    PC7W::VALUE6 => 5,
                    PC7W::VALUE7 => 6,
                    PC7W::VALUE8 => 7,
                    PC7W::VALUE9 => 16,
                    PC7W::VALUE10 => 17,
                    PC7W::VALUE11 => 18,
                    PC7W::VALUE12 => 19,
                    PC7W::VALUE13 => 20,
                    PC7W::VALUE14 => 24,
                    PC7W::VALUE15 => 25,
                    PC7W::VALUE16 => 26,
                    PC7W::VALUE17 => 27,
                    PC7W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC7W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC7W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC7W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC7W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC7W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC7W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC7W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC7W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC7W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC7W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC7W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC7W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC7W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC7W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC7W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC7W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC7W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC7W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&self) -> PC4R {
                PC4R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&self) -> PC5R {
                PC5R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&self) -> PC6R {
                PC6R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&self) -> PC7R {
                PC7R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&mut self) -> _PC4W {
                _PC4W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&mut self) -> _PC5W {
                _PC5W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&mut self) -> _PC6W {
                _PC6W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&mut self) -> _PC7W {
                _PC7W { w: self }
            }
        }
    }
    #[doc = "Port 2 Input/Output Control Register 8"]
    pub struct IOCR8 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Input/Output Control Register 8"]
    pub mod iocr8 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR8 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC8R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC8R::VALUE1 => 0,
                    PC8R::VALUE2 => 0x01,
                    PC8R::VALUE3 => 0x02,
                    PC8R::VALUE4 => 0x03,
                    PC8R::VALUE5 => 0x04,
                    PC8R::VALUE6 => 0x05,
                    PC8R::VALUE7 => 0x06,
                    PC8R::VALUE8 => 0x07,
                    PC8R::VALUE9 => 0x10,
                    PC8R::VALUE10 => 0x11,
                    PC8R::VALUE11 => 0x12,
                    PC8R::VALUE12 => 0x13,
                    PC8R::VALUE13 => 0x14,
                    PC8R::VALUE14 => 0x18,
                    PC8R::VALUE15 => 0x19,
                    PC8R::VALUE16 => 0x1a,
                    PC8R::VALUE17 => 0x1b,
                    PC8R::VALUE18 => 0x1c,
                    PC8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC8R {
                match value {
                    0 => PC8R::VALUE1,
                    1 => PC8R::VALUE2,
                    2 => PC8R::VALUE3,
                    3 => PC8R::VALUE4,
                    4 => PC8R::VALUE5,
                    5 => PC8R::VALUE6,
                    6 => PC8R::VALUE7,
                    7 => PC8R::VALUE8,
                    16 => PC8R::VALUE9,
                    17 => PC8R::VALUE10,
                    18 => PC8R::VALUE11,
                    19 => PC8R::VALUE12,
                    20 => PC8R::VALUE13,
                    24 => PC8R::VALUE14,
                    25 => PC8R::VALUE15,
                    26 => PC8R::VALUE16,
                    27 => PC8R::VALUE17,
                    28 => PC8R::VALUE18,
                    i => PC8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC8R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC8R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC8R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC8R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC8R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC8R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC8R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC8R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC8R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC8R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC8R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC8R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC8R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC8R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC8R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC8R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC9R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC9R::VALUE1 => 0,
                    PC9R::VALUE2 => 0x01,
                    PC9R::VALUE3 => 0x02,
                    PC9R::VALUE4 => 0x03,
                    PC9R::VALUE5 => 0x04,
                    PC9R::VALUE6 => 0x05,
                    PC9R::VALUE7 => 0x06,
                    PC9R::VALUE8 => 0x07,
                    PC9R::VALUE9 => 0x10,
                    PC9R::VALUE10 => 0x11,
                    PC9R::VALUE11 => 0x12,
                    PC9R::VALUE12 => 0x13,
                    PC9R::VALUE13 => 0x14,
                    PC9R::VALUE14 => 0x18,
                    PC9R::VALUE15 => 0x19,
                    PC9R::VALUE16 => 0x1a,
                    PC9R::VALUE17 => 0x1b,
                    PC9R::VALUE18 => 0x1c,
                    PC9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC9R {
                match value {
                    0 => PC9R::VALUE1,
                    1 => PC9R::VALUE2,
                    2 => PC9R::VALUE3,
                    3 => PC9R::VALUE4,
                    4 => PC9R::VALUE5,
                    5 => PC9R::VALUE6,
                    6 => PC9R::VALUE7,
                    7 => PC9R::VALUE8,
                    16 => PC9R::VALUE9,
                    17 => PC9R::VALUE10,
                    18 => PC9R::VALUE11,
                    19 => PC9R::VALUE12,
                    20 => PC9R::VALUE13,
                    24 => PC9R::VALUE14,
                    25 => PC9R::VALUE15,
                    26 => PC9R::VALUE16,
                    27 => PC9R::VALUE17,
                    28 => PC9R::VALUE18,
                    i => PC9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC9R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC9R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC9R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC9R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC9R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC9R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC9R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC9R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC9R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC9R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC9R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC9R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC9R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC9R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC9R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC9R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC10R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC10R::VALUE1 => 0,
                    PC10R::VALUE2 => 0x01,
                    PC10R::VALUE3 => 0x02,
                    PC10R::VALUE4 => 0x03,
                    PC10R::VALUE5 => 0x04,
                    PC10R::VALUE6 => 0x05,
                    PC10R::VALUE7 => 0x06,
                    PC10R::VALUE8 => 0x07,
                    PC10R::VALUE9 => 0x10,
                    PC10R::VALUE10 => 0x11,
                    PC10R::VALUE11 => 0x12,
                    PC10R::VALUE12 => 0x13,
                    PC10R::VALUE13 => 0x14,
                    PC10R::VALUE14 => 0x18,
                    PC10R::VALUE15 => 0x19,
                    PC10R::VALUE16 => 0x1a,
                    PC10R::VALUE17 => 0x1b,
                    PC10R::VALUE18 => 0x1c,
                    PC10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC10R {
                match value {
                    0 => PC10R::VALUE1,
                    1 => PC10R::VALUE2,
                    2 => PC10R::VALUE3,
                    3 => PC10R::VALUE4,
                    4 => PC10R::VALUE5,
                    5 => PC10R::VALUE6,
                    6 => PC10R::VALUE7,
                    7 => PC10R::VALUE8,
                    16 => PC10R::VALUE9,
                    17 => PC10R::VALUE10,
                    18 => PC10R::VALUE11,
                    19 => PC10R::VALUE12,
                    20 => PC10R::VALUE13,
                    24 => PC10R::VALUE14,
                    25 => PC10R::VALUE15,
                    26 => PC10R::VALUE16,
                    27 => PC10R::VALUE17,
                    28 => PC10R::VALUE18,
                    i => PC10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC10R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC10R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC10R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC10R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC10R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC10R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC10R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC10R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC10R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC10R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC10R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC10R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC10R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC10R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC10R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC10R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC11R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC11R::VALUE1 => 0,
                    PC11R::VALUE2 => 0x01,
                    PC11R::VALUE3 => 0x02,
                    PC11R::VALUE4 => 0x03,
                    PC11R::VALUE5 => 0x04,
                    PC11R::VALUE6 => 0x05,
                    PC11R::VALUE7 => 0x06,
                    PC11R::VALUE8 => 0x07,
                    PC11R::VALUE9 => 0x10,
                    PC11R::VALUE10 => 0x11,
                    PC11R::VALUE11 => 0x12,
                    PC11R::VALUE12 => 0x13,
                    PC11R::VALUE13 => 0x14,
                    PC11R::VALUE14 => 0x18,
                    PC11R::VALUE15 => 0x19,
                    PC11R::VALUE16 => 0x1a,
                    PC11R::VALUE17 => 0x1b,
                    PC11R::VALUE18 => 0x1c,
                    PC11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC11R {
                match value {
                    0 => PC11R::VALUE1,
                    1 => PC11R::VALUE2,
                    2 => PC11R::VALUE3,
                    3 => PC11R::VALUE4,
                    4 => PC11R::VALUE5,
                    5 => PC11R::VALUE6,
                    6 => PC11R::VALUE7,
                    7 => PC11R::VALUE8,
                    16 => PC11R::VALUE9,
                    17 => PC11R::VALUE10,
                    18 => PC11R::VALUE11,
                    19 => PC11R::VALUE12,
                    20 => PC11R::VALUE13,
                    24 => PC11R::VALUE14,
                    25 => PC11R::VALUE15,
                    26 => PC11R::VALUE16,
                    27 => PC11R::VALUE17,
                    28 => PC11R::VALUE18,
                    i => PC11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC11R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC11R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC11R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC11R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC11R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC11R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC11R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC11R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC11R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC11R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC11R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC11R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC11R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC11R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC11R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC11R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC8`"]
        pub enum PC8W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC8W::VALUE1 => 0,
                    PC8W::VALUE2 => 1,
                    PC8W::VALUE3 => 2,
                    PC8W::VALUE4 => 3,
                    PC8W::VALUE5 => 4,
                    PC8W::VALUE6 => 5,
                    PC8W::VALUE7 => 6,
                    PC8W::VALUE8 => 7,
                    PC8W::VALUE9 => 16,
                    PC8W::VALUE10 => 17,
                    PC8W::VALUE11 => 18,
                    PC8W::VALUE12 => 19,
                    PC8W::VALUE13 => 20,
                    PC8W::VALUE14 => 24,
                    PC8W::VALUE15 => 25,
                    PC8W::VALUE16 => 26,
                    PC8W::VALUE17 => 27,
                    PC8W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC8W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC8W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC8W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC8W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC8W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC8W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC8W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC8W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC8W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC8W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC8W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC8W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC8W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC8W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC8W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC8W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC8W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC8W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC9`"]
        pub enum PC9W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC9W::VALUE1 => 0,
                    PC9W::VALUE2 => 1,
                    PC9W::VALUE3 => 2,
                    PC9W::VALUE4 => 3,
                    PC9W::VALUE5 => 4,
                    PC9W::VALUE6 => 5,
                    PC9W::VALUE7 => 6,
                    PC9W::VALUE8 => 7,
                    PC9W::VALUE9 => 16,
                    PC9W::VALUE10 => 17,
                    PC9W::VALUE11 => 18,
                    PC9W::VALUE12 => 19,
                    PC9W::VALUE13 => 20,
                    PC9W::VALUE14 => 24,
                    PC9W::VALUE15 => 25,
                    PC9W::VALUE16 => 26,
                    PC9W::VALUE17 => 27,
                    PC9W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC9W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC9W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC9W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC9W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC9W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC9W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC9W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC9W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC9W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC9W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC9W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC9W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC9W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC9W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC9W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC9W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC9W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC9W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC10`"]
        pub enum PC10W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC10W::VALUE1 => 0,
                    PC10W::VALUE2 => 1,
                    PC10W::VALUE3 => 2,
                    PC10W::VALUE4 => 3,
                    PC10W::VALUE5 => 4,
                    PC10W::VALUE6 => 5,
                    PC10W::VALUE7 => 6,
                    PC10W::VALUE8 => 7,
                    PC10W::VALUE9 => 16,
                    PC10W::VALUE10 => 17,
                    PC10W::VALUE11 => 18,
                    PC10W::VALUE12 => 19,
                    PC10W::VALUE13 => 20,
                    PC10W::VALUE14 => 24,
                    PC10W::VALUE15 => 25,
                    PC10W::VALUE16 => 26,
                    PC10W::VALUE17 => 27,
                    PC10W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC10W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC10W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC10W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC10W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC10W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC10W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC10W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC10W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC10W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC10W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC10W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC10W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC10W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC10W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC10W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC10W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC10W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC10W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC11`"]
        pub enum PC11W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC11W::VALUE1 => 0,
                    PC11W::VALUE2 => 1,
                    PC11W::VALUE3 => 2,
                    PC11W::VALUE4 => 3,
                    PC11W::VALUE5 => 4,
                    PC11W::VALUE6 => 5,
                    PC11W::VALUE7 => 6,
                    PC11W::VALUE8 => 7,
                    PC11W::VALUE9 => 16,
                    PC11W::VALUE10 => 17,
                    PC11W::VALUE11 => 18,
                    PC11W::VALUE12 => 19,
                    PC11W::VALUE13 => 20,
                    PC11W::VALUE14 => 24,
                    PC11W::VALUE15 => 25,
                    PC11W::VALUE16 => 26,
                    PC11W::VALUE17 => 27,
                    PC11W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC11W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC11W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC11W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC11W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC11W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC11W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC11W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC11W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC11W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC11W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC11W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC11W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC11W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC11W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC11W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC11W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC11W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC11W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&self) -> PC8R {
                PC8R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&self) -> PC9R {
                PC9R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&self) -> PC10R {
                PC10R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&self) -> PC11R {
                PC11R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&mut self) -> _PC8W {
                _PC8W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&mut self) -> _PC9W {
                _PC9W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&mut self) -> _PC10W {
                _PC10W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&mut self) -> _PC11W {
                _PC11W { w: self }
            }
        }
    }
    #[doc = "Port 2 Input/Output Control Register 12"]
    pub struct IOCR12 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Input/Output Control Register 12"]
    pub mod iocr12 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR12 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC12R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC12R::VALUE1 => 0,
                    PC12R::VALUE2 => 0x01,
                    PC12R::VALUE3 => 0x02,
                    PC12R::VALUE4 => 0x03,
                    PC12R::VALUE5 => 0x04,
                    PC12R::VALUE6 => 0x05,
                    PC12R::VALUE7 => 0x06,
                    PC12R::VALUE8 => 0x07,
                    PC12R::VALUE9 => 0x10,
                    PC12R::VALUE10 => 0x11,
                    PC12R::VALUE11 => 0x12,
                    PC12R::VALUE12 => 0x13,
                    PC12R::VALUE13 => 0x14,
                    PC12R::VALUE14 => 0x18,
                    PC12R::VALUE15 => 0x19,
                    PC12R::VALUE16 => 0x1a,
                    PC12R::VALUE17 => 0x1b,
                    PC12R::VALUE18 => 0x1c,
                    PC12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC12R {
                match value {
                    0 => PC12R::VALUE1,
                    1 => PC12R::VALUE2,
                    2 => PC12R::VALUE3,
                    3 => PC12R::VALUE4,
                    4 => PC12R::VALUE5,
                    5 => PC12R::VALUE6,
                    6 => PC12R::VALUE7,
                    7 => PC12R::VALUE8,
                    16 => PC12R::VALUE9,
                    17 => PC12R::VALUE10,
                    18 => PC12R::VALUE11,
                    19 => PC12R::VALUE12,
                    20 => PC12R::VALUE13,
                    24 => PC12R::VALUE14,
                    25 => PC12R::VALUE15,
                    26 => PC12R::VALUE16,
                    27 => PC12R::VALUE17,
                    28 => PC12R::VALUE18,
                    i => PC12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC12R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC12R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC12R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC12R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC12R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC12R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC12R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC12R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC12R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC12R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC12R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC12R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC12R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC12R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC12R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC12R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC13R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC13R::VALUE1 => 0,
                    PC13R::VALUE2 => 0x01,
                    PC13R::VALUE3 => 0x02,
                    PC13R::VALUE4 => 0x03,
                    PC13R::VALUE5 => 0x04,
                    PC13R::VALUE6 => 0x05,
                    PC13R::VALUE7 => 0x06,
                    PC13R::VALUE8 => 0x07,
                    PC13R::VALUE9 => 0x10,
                    PC13R::VALUE10 => 0x11,
                    PC13R::VALUE11 => 0x12,
                    PC13R::VALUE12 => 0x13,
                    PC13R::VALUE13 => 0x14,
                    PC13R::VALUE14 => 0x18,
                    PC13R::VALUE15 => 0x19,
                    PC13R::VALUE16 => 0x1a,
                    PC13R::VALUE17 => 0x1b,
                    PC13R::VALUE18 => 0x1c,
                    PC13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC13R {
                match value {
                    0 => PC13R::VALUE1,
                    1 => PC13R::VALUE2,
                    2 => PC13R::VALUE3,
                    3 => PC13R::VALUE4,
                    4 => PC13R::VALUE5,
                    5 => PC13R::VALUE6,
                    6 => PC13R::VALUE7,
                    7 => PC13R::VALUE8,
                    16 => PC13R::VALUE9,
                    17 => PC13R::VALUE10,
                    18 => PC13R::VALUE11,
                    19 => PC13R::VALUE12,
                    20 => PC13R::VALUE13,
                    24 => PC13R::VALUE14,
                    25 => PC13R::VALUE15,
                    26 => PC13R::VALUE16,
                    27 => PC13R::VALUE17,
                    28 => PC13R::VALUE18,
                    i => PC13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC13R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC13R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC13R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC13R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC13R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC13R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC13R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC13R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC13R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC13R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC13R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC13R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC13R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC13R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC13R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC13R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC14R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC14R::VALUE1 => 0,
                    PC14R::VALUE2 => 0x01,
                    PC14R::VALUE3 => 0x02,
                    PC14R::VALUE4 => 0x03,
                    PC14R::VALUE5 => 0x04,
                    PC14R::VALUE6 => 0x05,
                    PC14R::VALUE7 => 0x06,
                    PC14R::VALUE8 => 0x07,
                    PC14R::VALUE9 => 0x10,
                    PC14R::VALUE10 => 0x11,
                    PC14R::VALUE11 => 0x12,
                    PC14R::VALUE12 => 0x13,
                    PC14R::VALUE13 => 0x14,
                    PC14R::VALUE14 => 0x18,
                    PC14R::VALUE15 => 0x19,
                    PC14R::VALUE16 => 0x1a,
                    PC14R::VALUE17 => 0x1b,
                    PC14R::VALUE18 => 0x1c,
                    PC14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC14R {
                match value {
                    0 => PC14R::VALUE1,
                    1 => PC14R::VALUE2,
                    2 => PC14R::VALUE3,
                    3 => PC14R::VALUE4,
                    4 => PC14R::VALUE5,
                    5 => PC14R::VALUE6,
                    6 => PC14R::VALUE7,
                    7 => PC14R::VALUE8,
                    16 => PC14R::VALUE9,
                    17 => PC14R::VALUE10,
                    18 => PC14R::VALUE11,
                    19 => PC14R::VALUE12,
                    20 => PC14R::VALUE13,
                    24 => PC14R::VALUE14,
                    25 => PC14R::VALUE15,
                    26 => PC14R::VALUE16,
                    27 => PC14R::VALUE17,
                    28 => PC14R::VALUE18,
                    i => PC14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC14R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC14R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC14R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC14R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC14R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC14R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC14R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC14R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC14R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC14R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC14R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC14R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC14R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC14R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC14R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC14R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC15R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC15R::VALUE1 => 0,
                    PC15R::VALUE2 => 0x01,
                    PC15R::VALUE3 => 0x02,
                    PC15R::VALUE4 => 0x03,
                    PC15R::VALUE5 => 0x04,
                    PC15R::VALUE6 => 0x05,
                    PC15R::VALUE7 => 0x06,
                    PC15R::VALUE8 => 0x07,
                    PC15R::VALUE9 => 0x10,
                    PC15R::VALUE10 => 0x11,
                    PC15R::VALUE11 => 0x12,
                    PC15R::VALUE12 => 0x13,
                    PC15R::VALUE13 => 0x14,
                    PC15R::VALUE14 => 0x18,
                    PC15R::VALUE15 => 0x19,
                    PC15R::VALUE16 => 0x1a,
                    PC15R::VALUE17 => 0x1b,
                    PC15R::VALUE18 => 0x1c,
                    PC15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC15R {
                match value {
                    0 => PC15R::VALUE1,
                    1 => PC15R::VALUE2,
                    2 => PC15R::VALUE3,
                    3 => PC15R::VALUE4,
                    4 => PC15R::VALUE5,
                    5 => PC15R::VALUE6,
                    6 => PC15R::VALUE7,
                    7 => PC15R::VALUE8,
                    16 => PC15R::VALUE9,
                    17 => PC15R::VALUE10,
                    18 => PC15R::VALUE11,
                    19 => PC15R::VALUE12,
                    20 => PC15R::VALUE13,
                    24 => PC15R::VALUE14,
                    25 => PC15R::VALUE15,
                    26 => PC15R::VALUE16,
                    27 => PC15R::VALUE17,
                    28 => PC15R::VALUE18,
                    i => PC15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC15R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC15R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC15R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC15R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC15R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC15R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC15R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC15R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC15R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC15R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC15R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC15R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC15R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC15R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC15R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC15R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC12`"]
        pub enum PC12W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC12W::VALUE1 => 0,
                    PC12W::VALUE2 => 1,
                    PC12W::VALUE3 => 2,
                    PC12W::VALUE4 => 3,
                    PC12W::VALUE5 => 4,
                    PC12W::VALUE6 => 5,
                    PC12W::VALUE7 => 6,
                    PC12W::VALUE8 => 7,
                    PC12W::VALUE9 => 16,
                    PC12W::VALUE10 => 17,
                    PC12W::VALUE11 => 18,
                    PC12W::VALUE12 => 19,
                    PC12W::VALUE13 => 20,
                    PC12W::VALUE14 => 24,
                    PC12W::VALUE15 => 25,
                    PC12W::VALUE16 => 26,
                    PC12W::VALUE17 => 27,
                    PC12W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC12W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC12W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC12W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC12W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC12W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC12W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC12W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC12W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC12W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC12W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC12W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC12W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC12W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC12W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC12W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC12W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC12W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC12W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC13`"]
        pub enum PC13W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC13W::VALUE1 => 0,
                    PC13W::VALUE2 => 1,
                    PC13W::VALUE3 => 2,
                    PC13W::VALUE4 => 3,
                    PC13W::VALUE5 => 4,
                    PC13W::VALUE6 => 5,
                    PC13W::VALUE7 => 6,
                    PC13W::VALUE8 => 7,
                    PC13W::VALUE9 => 16,
                    PC13W::VALUE10 => 17,
                    PC13W::VALUE11 => 18,
                    PC13W::VALUE12 => 19,
                    PC13W::VALUE13 => 20,
                    PC13W::VALUE14 => 24,
                    PC13W::VALUE15 => 25,
                    PC13W::VALUE16 => 26,
                    PC13W::VALUE17 => 27,
                    PC13W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC13W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC13W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC13W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC13W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC13W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC13W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC13W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC13W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC13W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC13W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC13W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC13W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC13W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC13W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC13W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC13W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC13W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC13W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC14`"]
        pub enum PC14W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC14W::VALUE1 => 0,
                    PC14W::VALUE2 => 1,
                    PC14W::VALUE3 => 2,
                    PC14W::VALUE4 => 3,
                    PC14W::VALUE5 => 4,
                    PC14W::VALUE6 => 5,
                    PC14W::VALUE7 => 6,
                    PC14W::VALUE8 => 7,
                    PC14W::VALUE9 => 16,
                    PC14W::VALUE10 => 17,
                    PC14W::VALUE11 => 18,
                    PC14W::VALUE12 => 19,
                    PC14W::VALUE13 => 20,
                    PC14W::VALUE14 => 24,
                    PC14W::VALUE15 => 25,
                    PC14W::VALUE16 => 26,
                    PC14W::VALUE17 => 27,
                    PC14W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC14W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC14W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC14W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC14W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC14W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC14W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC14W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC14W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC14W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC14W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC14W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC14W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC14W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC14W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC14W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC14W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC14W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC14W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC15`"]
        pub enum PC15W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC15W::VALUE1 => 0,
                    PC15W::VALUE2 => 1,
                    PC15W::VALUE3 => 2,
                    PC15W::VALUE4 => 3,
                    PC15W::VALUE5 => 4,
                    PC15W::VALUE6 => 5,
                    PC15W::VALUE7 => 6,
                    PC15W::VALUE8 => 7,
                    PC15W::VALUE9 => 16,
                    PC15W::VALUE10 => 17,
                    PC15W::VALUE11 => 18,
                    PC15W::VALUE12 => 19,
                    PC15W::VALUE13 => 20,
                    PC15W::VALUE14 => 24,
                    PC15W::VALUE15 => 25,
                    PC15W::VALUE16 => 26,
                    PC15W::VALUE17 => 27,
                    PC15W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC15W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC15W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC15W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC15W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC15W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC15W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC15W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC15W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC15W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC15W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC15W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC15W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC15W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC15W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC15W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC15W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC15W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC15W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc12(&self) -> PC12R {
                PC12R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc13(&self) -> PC13R {
                PC13R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc14(&self) -> PC14R {
                PC14R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc15(&self) -> PC15R {
                PC15R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc12(&mut self) -> _PC12W {
                _PC12W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc13(&mut self) -> _PC13W {
                _PC13W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc14(&mut self) -> _PC14W {
                _PC14W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc15(&mut self) -> _PC15W {
                _PC15W { w: self }
            }
        }
    }
    #[doc = "Port 2 Input Register"]
    pub struct IN {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Input Register"]
    pub mod in_ {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Input Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Input Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Input Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Input Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Input Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Input Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Input Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Input Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Input Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Input Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Input Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Input Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Input Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Input Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Input Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Input Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 2 Pad Driver Mode 0 Register"]
    pub struct PDR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Pad Driver Mode 0 Register"]
    pub mod pdr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD0R {
            bits: u8,
        }
        impl PD0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD1R {
            bits: u8,
        }
        impl PD1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD2R {
            bits: u8,
        }
        impl PD2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD3R {
            bits: u8,
        }
        impl PD3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD4R {
            bits: u8,
        }
        impl PD4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD5R {
            bits: u8,
        }
        impl PD5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD6R {
            bits: u8,
        }
        impl PD6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD7R {
            bits: u8,
        }
        impl PD7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&self) -> PD0R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD0R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&self) -> PD1R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD1R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&self) -> PD2R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD2R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&self) -> PD3R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD3R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&self) -> PD4R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD4R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&self) -> PD5R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD5R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&self) -> PD6R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD6R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&self) -> PD7R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&mut self) -> _PD0W {
                _PD0W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&mut self) -> _PD1W {
                _PD1W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&mut self) -> _PD2W {
                _PD2W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&mut self) -> _PD3W {
                _PD3W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&mut self) -> _PD4W {
                _PD4W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&mut self) -> _PD5W {
                _PD5W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&mut self) -> _PD6W {
                _PD6W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&mut self) -> _PD7W {
                _PD7W { w: self }
            }
        }
    }
    #[doc = "Port 2 Pad Driver Mode 1 Register"]
    pub struct PDR1 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Pad Driver Mode 1 Register"]
    pub mod pdr1 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR1 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD8R {
            bits: u8,
        }
        impl PD8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD9R {
            bits: u8,
        }
        impl PD9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD10R {
            bits: u8,
        }
        impl PD10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD11R {
            bits: u8,
        }
        impl PD11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD12R {
            bits: u8,
        }
        impl PD12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD13R {
            bits: u8,
        }
        impl PD13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD14R {
            bits: u8,
        }
        impl PD14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD15R {
            bits: u8,
        }
        impl PD15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD8W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD9W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD10W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD11W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD12W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD13W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD14W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD15W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.8"]
            #[inline]
            pub fn pd8(&self) -> PD8R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD8R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.9"]
            #[inline]
            pub fn pd9(&self) -> PD9R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD9R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.10"]
            #[inline]
            pub fn pd10(&self) -> PD10R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD10R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.11"]
            #[inline]
            pub fn pd11(&self) -> PD11R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD11R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.12"]
            #[inline]
            pub fn pd12(&self) -> PD12R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD12R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.13"]
            #[inline]
            pub fn pd13(&self) -> PD13R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD13R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.14"]
            #[inline]
            pub fn pd14(&self) -> PD14R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD14R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.15"]
            #[inline]
            pub fn pd15(&self) -> PD15R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD15R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.8"]
            #[inline]
            pub fn pd8(&mut self) -> _PD8W {
                _PD8W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.9"]
            #[inline]
            pub fn pd9(&mut self) -> _PD9W {
                _PD9W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.10"]
            #[inline]
            pub fn pd10(&mut self) -> _PD10W {
                _PD10W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.11"]
            #[inline]
            pub fn pd11(&mut self) -> _PD11W {
                _PD11W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.12"]
            #[inline]
            pub fn pd12(&mut self) -> _PD12W {
                _PD12W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.13"]
            #[inline]
            pub fn pd13(&mut self) -> _PD13W {
                _PD13W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.14"]
            #[inline]
            pub fn pd14(&mut self) -> _PD14W {
                _PD14W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.15"]
            #[inline]
            pub fn pd15(&mut self) -> _PD15W {
                _PD15W { w: self }
            }
        }
    }
    #[doc = "Port 2 Pin Function Decision Control Register"]
    pub struct PDISC {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Pin Function Decision Control Register"]
    pub mod pdisc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PDISC {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PDIS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS0R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS0R::VALUE1 => false,
                    PDIS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS0R {
                match value {
                    false => PDIS0R::VALUE1,
                    true => PDIS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS1R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS1R::VALUE1 => false,
                    PDIS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS1R {
                match value {
                    false => PDIS1R::VALUE1,
                    true => PDIS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS2R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS2R::VALUE1 => false,
                    PDIS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS2R {
                match value {
                    false => PDIS2R::VALUE1,
                    true => PDIS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS3R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS3R::VALUE1 => false,
                    PDIS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS3R {
                match value {
                    false => PDIS3R::VALUE1,
                    true => PDIS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS4R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS4R::VALUE1 => false,
                    PDIS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS4R {
                match value {
                    false => PDIS4R::VALUE1,
                    true => PDIS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS5R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS5R::VALUE1 => false,
                    PDIS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS5R {
                match value {
                    false => PDIS5R::VALUE1,
                    true => PDIS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS6R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS6R::VALUE1 => false,
                    PDIS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS6R {
                match value {
                    false => PDIS6R::VALUE1,
                    true => PDIS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS7R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS7R::VALUE1 => false,
                    PDIS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS7R {
                match value {
                    false => PDIS7R::VALUE1,
                    true => PDIS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS8R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS8R::VALUE1 => false,
                    PDIS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS8R {
                match value {
                    false => PDIS8R::VALUE1,
                    true => PDIS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS9R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS9R::VALUE1 => false,
                    PDIS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS9R {
                match value {
                    false => PDIS9R::VALUE1,
                    true => PDIS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS10R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS10R::VALUE1 => false,
                    PDIS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS10R {
                match value {
                    false => PDIS10R::VALUE1,
                    true => PDIS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS11R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS11R::VALUE1 => false,
                    PDIS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS11R {
                match value {
                    false => PDIS11R::VALUE1,
                    true => PDIS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS12R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS12R::VALUE1 => false,
                    PDIS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS12R {
                match value {
                    false => PDIS12R::VALUE1,
                    true => PDIS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS13R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS13R::VALUE1 => false,
                    PDIS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS13R {
                match value {
                    false => PDIS13R::VALUE1,
                    true => PDIS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS14R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS14R::VALUE1 => false,
                    PDIS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS14R {
                match value {
                    false => PDIS14R::VALUE1,
                    true => PDIS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS15R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS15R::VALUE1 => false,
                    PDIS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS15R {
                match value {
                    false => PDIS15R::VALUE1,
                    true => PDIS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Pad Disable for Port n Pin 0"]
            #[inline]
            pub fn pdis0(&self) -> PDIS0R {
                PDIS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Pad Disable for Port n Pin 1"]
            #[inline]
            pub fn pdis1(&self) -> PDIS1R {
                PDIS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Pad Disable for Port n Pin 2"]
            #[inline]
            pub fn pdis2(&self) -> PDIS2R {
                PDIS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Pad Disable for Port n Pin 3"]
            #[inline]
            pub fn pdis3(&self) -> PDIS3R {
                PDIS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Pad Disable for Port n Pin 4"]
            #[inline]
            pub fn pdis4(&self) -> PDIS4R {
                PDIS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Pad Disable for Port n Pin 5"]
            #[inline]
            pub fn pdis5(&self) -> PDIS5R {
                PDIS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Pad Disable for Port n Pin 6"]
            #[inline]
            pub fn pdis6(&self) -> PDIS6R {
                PDIS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Pad Disable for Port n Pin 7"]
            #[inline]
            pub fn pdis7(&self) -> PDIS7R {
                PDIS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Pad Disable for Port n Pin 8"]
            #[inline]
            pub fn pdis8(&self) -> PDIS8R {
                PDIS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Pad Disable for Port n Pin 9"]
            #[inline]
            pub fn pdis9(&self) -> PDIS9R {
                PDIS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Pad Disable for Port n Pin 10"]
            #[inline]
            pub fn pdis10(&self) -> PDIS10R {
                PDIS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Pad Disable for Port n Pin 11"]
            #[inline]
            pub fn pdis11(&self) -> PDIS11R {
                PDIS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Pad Disable for Port n Pin 12"]
            #[inline]
            pub fn pdis12(&self) -> PDIS12R {
                PDIS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Pad Disable for Port n Pin 13"]
            #[inline]
            pub fn pdis13(&self) -> PDIS13R {
                PDIS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Pad Disable for Port n Pin 14"]
            #[inline]
            pub fn pdis14(&self) -> PDIS14R {
                PDIS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Pad Disable for Port n Pin 15"]
            #[inline]
            pub fn pdis15(&self) -> PDIS15R {
                PDIS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 2 Pin Power Save Register"]
    pub struct PPS {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Pin Power Save Register"]
    pub mod pps {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PPS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PPS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS0R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS0R::VALUE1 => false,
                    PPS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS0R {
                match value {
                    false => PPS0R::VALUE1,
                    true => PPS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS1R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS1R::VALUE1 => false,
                    PPS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS1R {
                match value {
                    false => PPS1R::VALUE1,
                    true => PPS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS2R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS2R::VALUE1 => false,
                    PPS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS2R {
                match value {
                    false => PPS2R::VALUE1,
                    true => PPS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS3R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS3R::VALUE1 => false,
                    PPS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS3R {
                match value {
                    false => PPS3R::VALUE1,
                    true => PPS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS4R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS4R::VALUE1 => false,
                    PPS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS4R {
                match value {
                    false => PPS4R::VALUE1,
                    true => PPS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS5R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS5R::VALUE1 => false,
                    PPS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS5R {
                match value {
                    false => PPS5R::VALUE1,
                    true => PPS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS6R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS6R::VALUE1 => false,
                    PPS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS6R {
                match value {
                    false => PPS6R::VALUE1,
                    true => PPS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS7R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS7R::VALUE1 => false,
                    PPS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS7R {
                match value {
                    false => PPS7R::VALUE1,
                    true => PPS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS8R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS8R::VALUE1 => false,
                    PPS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS8R {
                match value {
                    false => PPS8R::VALUE1,
                    true => PPS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS9R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS9R::VALUE1 => false,
                    PPS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS9R {
                match value {
                    false => PPS9R::VALUE1,
                    true => PPS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS10R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS10R::VALUE1 => false,
                    PPS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS10R {
                match value {
                    false => PPS10R::VALUE1,
                    true => PPS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS11R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS11R::VALUE1 => false,
                    PPS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS11R {
                match value {
                    false => PPS11R::VALUE1,
                    true => PPS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS12R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS12R::VALUE1 => false,
                    PPS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS12R {
                match value {
                    false => PPS12R::VALUE1,
                    true => PPS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS13R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS13R::VALUE1 => false,
                    PPS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS13R {
                match value {
                    false => PPS13R::VALUE1,
                    true => PPS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS14R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS14R::VALUE1 => false,
                    PPS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS14R {
                match value {
                    false => PPS14R::VALUE1,
                    true => PPS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS15R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS15R::VALUE1 => false,
                    PPS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS15R {
                match value {
                    false => PPS15R::VALUE1,
                    true => PPS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PPS0`"]
        pub enum PPS0W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS0W::VALUE1 => false,
                    PPS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS0W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS1`"]
        pub enum PPS1W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS1W::VALUE1 => false,
                    PPS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS1W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS2`"]
        pub enum PPS2W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS2W::VALUE1 => false,
                    PPS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS2W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS3`"]
        pub enum PPS3W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS3W::VALUE1 => false,
                    PPS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS3W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS4`"]
        pub enum PPS4W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS4W::VALUE1 => false,
                    PPS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS4W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS5`"]
        pub enum PPS5W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS5W::VALUE1 => false,
                    PPS5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS5W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS6`"]
        pub enum PPS6W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS6W::VALUE1 => false,
                    PPS6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS6W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS7`"]
        pub enum PPS7W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS7W::VALUE1 => false,
                    PPS7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS7W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS8`"]
        pub enum PPS8W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS8W::VALUE1 => false,
                    PPS8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS8W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS9`"]
        pub enum PPS9W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS9W::VALUE1 => false,
                    PPS9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS9W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS10`"]
        pub enum PPS10W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS10W::VALUE1 => false,
                    PPS10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS10W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS11`"]
        pub enum PPS11W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS11W::VALUE1 => false,
                    PPS11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS11W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS12`"]
        pub enum PPS12W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS12W::VALUE1 => false,
                    PPS12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS12W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS13`"]
        pub enum PPS13W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS13W::VALUE1 => false,
                    PPS13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS13W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS14`"]
        pub enum PPS14W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS14W::VALUE1 => false,
                    PPS14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS14W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS15`"]
        pub enum PPS15W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS15W::VALUE1 => false,
                    PPS15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS15W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&self) -> PPS0R {
                PPS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&self) -> PPS1R {
                PPS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&self) -> PPS2R {
                PPS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&self) -> PPS3R {
                PPS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&self) -> PPS4R {
                PPS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&self) -> PPS5R {
                PPS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&self) -> PPS6R {
                PPS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&self) -> PPS7R {
                PPS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&self) -> PPS8R {
                PPS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&self) -> PPS9R {
                PPS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&self) -> PPS10R {
                PPS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&self) -> PPS11R {
                PPS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&self) -> PPS12R {
                PPS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&self) -> PPS13R {
                PPS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&self) -> PPS14R {
                PPS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&self) -> PPS15R {
                PPS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&mut self) -> _PPS0W {
                _PPS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&mut self) -> _PPS1W {
                _PPS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&mut self) -> _PPS2W {
                _PPS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&mut self) -> _PPS3W {
                _PPS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&mut self) -> _PPS4W {
                _PPS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&mut self) -> _PPS5W {
                _PPS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&mut self) -> _PPS6W {
                _PPS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&mut self) -> _PPS7W {
                _PPS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&mut self) -> _PPS8W {
                _PPS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&mut self) -> _PPS9W {
                _PPS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&mut self) -> _PPS10W {
                _PPS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&mut self) -> _PPS11W {
                _PPS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&mut self) -> _PPS12W {
                _PPS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&mut self) -> _PPS13W {
                _PPS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&mut self) -> _PPS14W {
                _PPS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&mut self) -> _PPS15W {
                _PPS15W { w: self }
            }
        }
    }
    #[doc = "Port 2 Pin Hardware Select Register"]
    pub struct HWSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 2 Pin Hardware Select Register"]
    pub mod hwsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HWSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HW0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW0R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW0R::VALUE1 => 0,
                    HW0R::VALUE2 => 0x01,
                    HW0R::VALUE3 => 0x02,
                    HW0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW0R {
                match value {
                    0 => HW0R::VALUE1,
                    1 => HW0R::VALUE2,
                    2 => HW0R::VALUE3,
                    i => HW0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW0R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW1R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW1R::VALUE1 => 0,
                    HW1R::VALUE2 => 0x01,
                    HW1R::VALUE3 => 0x02,
                    HW1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW1R {
                match value {
                    0 => HW1R::VALUE1,
                    1 => HW1R::VALUE2,
                    2 => HW1R::VALUE3,
                    i => HW1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW1R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW2R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW2R::VALUE1 => 0,
                    HW2R::VALUE2 => 0x01,
                    HW2R::VALUE3 => 0x02,
                    HW2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW2R {
                match value {
                    0 => HW2R::VALUE1,
                    1 => HW2R::VALUE2,
                    2 => HW2R::VALUE3,
                    i => HW2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW2R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW3R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW3R::VALUE1 => 0,
                    HW3R::VALUE2 => 0x01,
                    HW3R::VALUE3 => 0x02,
                    HW3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW3R {
                match value {
                    0 => HW3R::VALUE1,
                    1 => HW3R::VALUE2,
                    2 => HW3R::VALUE3,
                    i => HW3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW3R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW4R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW4R::VALUE1 => 0,
                    HW4R::VALUE2 => 0x01,
                    HW4R::VALUE3 => 0x02,
                    HW4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW4R {
                match value {
                    0 => HW4R::VALUE1,
                    1 => HW4R::VALUE2,
                    2 => HW4R::VALUE3,
                    i => HW4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW4R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW5R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW5R::VALUE1 => 0,
                    HW5R::VALUE2 => 0x01,
                    HW5R::VALUE3 => 0x02,
                    HW5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW5R {
                match value {
                    0 => HW5R::VALUE1,
                    1 => HW5R::VALUE2,
                    2 => HW5R::VALUE3,
                    i => HW5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW5R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW6R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW6R::VALUE1 => 0,
                    HW6R::VALUE2 => 0x01,
                    HW6R::VALUE3 => 0x02,
                    HW6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW6R {
                match value {
                    0 => HW6R::VALUE1,
                    1 => HW6R::VALUE2,
                    2 => HW6R::VALUE3,
                    i => HW6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW6R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW7R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW7R::VALUE1 => 0,
                    HW7R::VALUE2 => 0x01,
                    HW7R::VALUE3 => 0x02,
                    HW7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW7R {
                match value {
                    0 => HW7R::VALUE1,
                    1 => HW7R::VALUE2,
                    2 => HW7R::VALUE3,
                    i => HW7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW7R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW8R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW8R::VALUE1 => 0,
                    HW8R::VALUE2 => 0x01,
                    HW8R::VALUE3 => 0x02,
                    HW8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW8R {
                match value {
                    0 => HW8R::VALUE1,
                    1 => HW8R::VALUE2,
                    2 => HW8R::VALUE3,
                    i => HW8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW8R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW9R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW9R::VALUE1 => 0,
                    HW9R::VALUE2 => 0x01,
                    HW9R::VALUE3 => 0x02,
                    HW9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW9R {
                match value {
                    0 => HW9R::VALUE1,
                    1 => HW9R::VALUE2,
                    2 => HW9R::VALUE3,
                    i => HW9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW9R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW10R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW10R::VALUE1 => 0,
                    HW10R::VALUE2 => 0x01,
                    HW10R::VALUE3 => 0x02,
                    HW10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW10R {
                match value {
                    0 => HW10R::VALUE1,
                    1 => HW10R::VALUE2,
                    2 => HW10R::VALUE3,
                    i => HW10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW10R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW11R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW11R::VALUE1 => 0,
                    HW11R::VALUE2 => 0x01,
                    HW11R::VALUE3 => 0x02,
                    HW11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW11R {
                match value {
                    0 => HW11R::VALUE1,
                    1 => HW11R::VALUE2,
                    2 => HW11R::VALUE3,
                    i => HW11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW11R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW12R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW12R::VALUE1 => 0,
                    HW12R::VALUE2 => 0x01,
                    HW12R::VALUE3 => 0x02,
                    HW12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW12R {
                match value {
                    0 => HW12R::VALUE1,
                    1 => HW12R::VALUE2,
                    2 => HW12R::VALUE3,
                    i => HW12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW12R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW13R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW13R::VALUE1 => 0,
                    HW13R::VALUE2 => 0x01,
                    HW13R::VALUE3 => 0x02,
                    HW13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW13R {
                match value {
                    0 => HW13R::VALUE1,
                    1 => HW13R::VALUE2,
                    2 => HW13R::VALUE3,
                    i => HW13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW13R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW14R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW14R::VALUE1 => 0,
                    HW14R::VALUE2 => 0x01,
                    HW14R::VALUE3 => 0x02,
                    HW14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW14R {
                match value {
                    0 => HW14R::VALUE1,
                    1 => HW14R::VALUE2,
                    2 => HW14R::VALUE3,
                    i => HW14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW14R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW15R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW15R::VALUE1 => 0,
                    HW15R::VALUE2 => 0x01,
                    HW15R::VALUE3 => 0x02,
                    HW15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW15R {
                match value {
                    0 => HW15R::VALUE1,
                    1 => HW15R::VALUE2,
                    2 => HW15R::VALUE3,
                    i => HW15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW15R::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `HW0`"]
        pub enum HW0W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW0W::VALUE1 => 0,
                    HW0W::VALUE2 => 1,
                    HW0W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW0W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW0W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW0W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW1`"]
        pub enum HW1W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW1W::VALUE1 => 0,
                    HW1W::VALUE2 => 1,
                    HW1W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW1W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW1W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW1W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW2`"]
        pub enum HW2W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW2W::VALUE1 => 0,
                    HW2W::VALUE2 => 1,
                    HW2W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW2W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW2W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW2W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW3`"]
        pub enum HW3W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW3W::VALUE1 => 0,
                    HW3W::VALUE2 => 1,
                    HW3W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW3W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW3W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW3W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW4`"]
        pub enum HW4W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW4W::VALUE1 => 0,
                    HW4W::VALUE2 => 1,
                    HW4W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW4W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW4W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW4W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW5`"]
        pub enum HW5W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW5W::VALUE1 => 0,
                    HW5W::VALUE2 => 1,
                    HW5W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW5W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW5W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW5W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW6`"]
        pub enum HW6W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW6W::VALUE1 => 0,
                    HW6W::VALUE2 => 1,
                    HW6W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW6W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW6W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW6W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW7`"]
        pub enum HW7W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW7W::VALUE1 => 0,
                    HW7W::VALUE2 => 1,
                    HW7W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW7W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW7W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW7W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW8`"]
        pub enum HW8W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW8W::VALUE1 => 0,
                    HW8W::VALUE2 => 1,
                    HW8W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW8W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW8W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW8W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW9`"]
        pub enum HW9W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW9W::VALUE1 => 0,
                    HW9W::VALUE2 => 1,
                    HW9W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW9W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW9W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW9W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW10`"]
        pub enum HW10W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW10W::VALUE1 => 0,
                    HW10W::VALUE2 => 1,
                    HW10W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW10W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW10W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW10W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW11`"]
        pub enum HW11W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW11W::VALUE1 => 0,
                    HW11W::VALUE2 => 1,
                    HW11W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW11W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW11W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW11W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW12`"]
        pub enum HW12W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW12W::VALUE1 => 0,
                    HW12W::VALUE2 => 1,
                    HW12W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW12W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW12W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW12W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW13`"]
        pub enum HW13W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW13W::VALUE1 => 0,
                    HW13W::VALUE2 => 1,
                    HW13W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW13W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW13W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW13W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW14`"]
        pub enum HW14W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW14W::VALUE1 => 0,
                    HW14W::VALUE2 => 1,
                    HW14W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW14W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW14W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW14W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW15`"]
        pub enum HW15W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW15W::VALUE1 => 0,
                    HW15W::VALUE2 => 1,
                    HW15W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW15W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW15W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW15W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&self) -> HW0R {
                HW0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&self) -> HW1R {
                HW1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&self) -> HW2R {
                HW2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&self) -> HW3R {
                HW3R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&self) -> HW4R {
                HW4R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&self) -> HW5R {
                HW5R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&self) -> HW6R {
                HW6R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&self) -> HW7R {
                HW7R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&self) -> HW8R {
                HW8R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&self) -> HW9R {
                HW9R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&self) -> HW10R {
                HW10R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&self) -> HW11R {
                HW11R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&self) -> HW12R {
                HW12R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&self) -> HW13R {
                HW13R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&self) -> HW14R {
                HW14R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&self) -> HW15R {
                HW15R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x04 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&mut self) -> _HW0W {
                _HW0W { w: self }
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&mut self) -> _HW1W {
                _HW1W { w: self }
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&mut self) -> _HW2W {
                _HW2W { w: self }
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&mut self) -> _HW3W {
                _HW3W { w: self }
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&mut self) -> _HW4W {
                _HW4W { w: self }
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&mut self) -> _HW5W {
                _HW5W { w: self }
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&mut self) -> _HW6W {
                _HW6W { w: self }
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&mut self) -> _HW7W {
                _HW7W { w: self }
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&mut self) -> _HW8W {
                _HW8W { w: self }
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&mut self) -> _HW9W {
                _HW9W { w: self }
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&mut self) -> _HW10W {
                _HW10W { w: self }
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&mut self) -> _HW11W {
                _HW11W { w: self }
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&mut self) -> _HW12W {
                _HW12W { w: self }
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&mut self) -> _HW13W {
                _HW13W { w: self }
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&mut self) -> _HW14W {
                _HW14W { w: self }
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&mut self) -> _HW15W {
                _HW15W { w: self }
            }
        }
    }
}
#[doc = "Port 2"]
pub struct PORT2 {
    register_block: port2::RegisterBlock,
}
impl Deref for PORT2 {
    type Target = port2::RegisterBlock;
    fn deref(&self) -> &port2::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Port 3"]
pub const PORT3: Peripheral<PORT3> = unsafe { Peripheral::new(0x4802_8300) };
#[doc = "Port 3"]
pub mod port3 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Port 3 Output Register"]
        pub out: OUT,
        #[doc = "0x04 - Port 3 Output Modification Register"]
        pub omr: OMR,
        _reserved0: [u8; 8usize],
        #[doc = "0x10 - Port 3 Input/Output Control Register 0"]
        pub iocr0: IOCR0,
        _reserved1: [u8; 16usize],
        #[doc = "0x24 - Port 3 Input Register"]
        pub in_: IN,
        _reserved2: [u8; 24usize],
        #[doc = "0x40 - Port 3 Pad Driver Mode 0 Register"]
        pub pdr0: PDR0,
        _reserved3: [u8; 28usize],
        #[doc = "0x60 - Port 3 Pin Function Decision Control Register"]
        pub pdisc: PDISC,
        _reserved4: [u8; 12usize],
        #[doc = "0x70 - Port 3 Pin Power Save Register"]
        pub pps: PPS,
        #[doc = "0x74 - Port 3 Pin Hardware Select Register"]
        pub hwsel: HWSEL,
    }
    #[doc = "Port 3 Output Register"]
    pub struct OUT {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Output Register"]
    pub mod out {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OUT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `P0`"]
        pub enum P0W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P0W::VALUE1 => false,
                    P0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P0W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P1`"]
        pub enum P1W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P1W::VALUE1 => false,
                    P1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P1W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P2`"]
        pub enum P2W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P2W::VALUE1 => false,
                    P2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P2W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P3`"]
        pub enum P3W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P3W::VALUE1 => false,
                    P3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P3W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P4`"]
        pub enum P4W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P4W::VALUE1 => false,
                    P4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P4W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P5`"]
        pub enum P5W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P5W::VALUE1 => false,
                    P5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P5W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P6`"]
        pub enum P6W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P6W::VALUE1 => false,
                    P6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P6W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P7`"]
        pub enum P7W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P7W::VALUE1 => false,
                    P7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P7W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P8`"]
        pub enum P8W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P8W::VALUE1 => false,
                    P8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P8W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P9`"]
        pub enum P9W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P9W::VALUE1 => false,
                    P9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P9W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P10`"]
        pub enum P10W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P10W::VALUE1 => false,
                    P10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P10W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P11`"]
        pub enum P11W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P11W::VALUE1 => false,
                    P11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P11W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P12`"]
        pub enum P12W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P12W::VALUE1 => false,
                    P12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P12W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P13`"]
        pub enum P13W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P13W::VALUE1 => false,
                    P13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P13W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P14`"]
        pub enum P14W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P14W::VALUE1 => false,
                    P14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P14W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P15`"]
        pub enum P15W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P15W::VALUE1 => false,
                    P15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P15W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&mut self) -> _P0W {
                _P0W { w: self }
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&mut self) -> _P1W {
                _P1W { w: self }
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&mut self) -> _P2W {
                _P2W { w: self }
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&mut self) -> _P3W {
                _P3W { w: self }
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&mut self) -> _P4W {
                _P4W { w: self }
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&mut self) -> _P5W {
                _P5W { w: self }
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&mut self) -> _P6W {
                _P6W { w: self }
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&mut self) -> _P7W {
                _P7W { w: self }
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&mut self) -> _P8W {
                _P8W { w: self }
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&mut self) -> _P9W {
                _P9W { w: self }
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&mut self) -> _P10W {
                _P10W { w: self }
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&mut self) -> _P11W {
                _P11W { w: self }
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&mut self) -> _P12W {
                _P12W { w: self }
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&mut self) -> _P13W {
                _P13W { w: self }
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&mut self) -> _P14W {
                _P14W { w: self }
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&mut self) -> _P15W {
                _P15W { w: self }
            }
        }
    }
    #[doc = "Port 3 Output Modification Register"]
    pub struct OMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Output Modification Register"]
    pub mod omr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OMR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Set Bit 0"]
            #[inline]
            pub fn ps0(&mut self) -> _PS0W {
                _PS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Set Bit 1"]
            #[inline]
            pub fn ps1(&mut self) -> _PS1W {
                _PS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Set Bit 2"]
            #[inline]
            pub fn ps2(&mut self) -> _PS2W {
                _PS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Set Bit 3"]
            #[inline]
            pub fn ps3(&mut self) -> _PS3W {
                _PS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Set Bit 4"]
            #[inline]
            pub fn ps4(&mut self) -> _PS4W {
                _PS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Set Bit 5"]
            #[inline]
            pub fn ps5(&mut self) -> _PS5W {
                _PS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Set Bit 6"]
            #[inline]
            pub fn ps6(&mut self) -> _PS6W {
                _PS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Set Bit 7"]
            #[inline]
            pub fn ps7(&mut self) -> _PS7W {
                _PS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Set Bit 8"]
            #[inline]
            pub fn ps8(&mut self) -> _PS8W {
                _PS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Set Bit 9"]
            #[inline]
            pub fn ps9(&mut self) -> _PS9W {
                _PS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Set Bit 10"]
            #[inline]
            pub fn ps10(&mut self) -> _PS10W {
                _PS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Set Bit 11"]
            #[inline]
            pub fn ps11(&mut self) -> _PS11W {
                _PS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Set Bit 12"]
            #[inline]
            pub fn ps12(&mut self) -> _PS12W {
                _PS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Set Bit 13"]
            #[inline]
            pub fn ps13(&mut self) -> _PS13W {
                _PS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Set Bit 14"]
            #[inline]
            pub fn ps14(&mut self) -> _PS14W {
                _PS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Set Bit 15"]
            #[inline]
            pub fn ps15(&mut self) -> _PS15W {
                _PS15W { w: self }
            }
            #[doc = "Bit 16 - Port n Reset Bit 0"]
            #[inline]
            pub fn pr0(&mut self) -> _PR0W {
                _PR0W { w: self }
            }
            #[doc = "Bit 17 - Port n Reset Bit 1"]
            #[inline]
            pub fn pr1(&mut self) -> _PR1W {
                _PR1W { w: self }
            }
            #[doc = "Bit 18 - Port n Reset Bit 2"]
            #[inline]
            pub fn pr2(&mut self) -> _PR2W {
                _PR2W { w: self }
            }
            #[doc = "Bit 19 - Port n Reset Bit 3"]
            #[inline]
            pub fn pr3(&mut self) -> _PR3W {
                _PR3W { w: self }
            }
            #[doc = "Bit 20 - Port n Reset Bit 4"]
            #[inline]
            pub fn pr4(&mut self) -> _PR4W {
                _PR4W { w: self }
            }
            #[doc = "Bit 21 - Port n Reset Bit 5"]
            #[inline]
            pub fn pr5(&mut self) -> _PR5W {
                _PR5W { w: self }
            }
            #[doc = "Bit 22 - Port n Reset Bit 6"]
            #[inline]
            pub fn pr6(&mut self) -> _PR6W {
                _PR6W { w: self }
            }
            #[doc = "Bit 23 - Port n Reset Bit 7"]
            #[inline]
            pub fn pr7(&mut self) -> _PR7W {
                _PR7W { w: self }
            }
            #[doc = "Bit 24 - Port n Reset Bit 8"]
            #[inline]
            pub fn pr8(&mut self) -> _PR8W {
                _PR8W { w: self }
            }
            #[doc = "Bit 25 - Port n Reset Bit 9"]
            #[inline]
            pub fn pr9(&mut self) -> _PR9W {
                _PR9W { w: self }
            }
            #[doc = "Bit 26 - Port n Reset Bit 10"]
            #[inline]
            pub fn pr10(&mut self) -> _PR10W {
                _PR10W { w: self }
            }
            #[doc = "Bit 27 - Port n Reset Bit 11"]
            #[inline]
            pub fn pr11(&mut self) -> _PR11W {
                _PR11W { w: self }
            }
            #[doc = "Bit 28 - Port n Reset Bit 12"]
            #[inline]
            pub fn pr12(&mut self) -> _PR12W {
                _PR12W { w: self }
            }
            #[doc = "Bit 29 - Port n Reset Bit 13"]
            #[inline]
            pub fn pr13(&mut self) -> _PR13W {
                _PR13W { w: self }
            }
            #[doc = "Bit 30 - Port n Reset Bit 14"]
            #[inline]
            pub fn pr14(&mut self) -> _PR14W {
                _PR14W { w: self }
            }
            #[doc = "Bit 31 - Port n Reset Bit 15"]
            #[inline]
            pub fn pr15(&mut self) -> _PR15W {
                _PR15W { w: self }
            }
        }
    }
    #[doc = "Port 3 Input/Output Control Register 0"]
    pub struct IOCR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Input/Output Control Register 0"]
    pub mod iocr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC0R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC0R::VALUE1 => 0,
                    PC0R::VALUE2 => 0x01,
                    PC0R::VALUE3 => 0x02,
                    PC0R::VALUE4 => 0x03,
                    PC0R::VALUE5 => 0x04,
                    PC0R::VALUE6 => 0x05,
                    PC0R::VALUE7 => 0x06,
                    PC0R::VALUE8 => 0x07,
                    PC0R::VALUE9 => 0x10,
                    PC0R::VALUE10 => 0x11,
                    PC0R::VALUE11 => 0x12,
                    PC0R::VALUE12 => 0x13,
                    PC0R::VALUE13 => 0x14,
                    PC0R::VALUE14 => 0x18,
                    PC0R::VALUE15 => 0x19,
                    PC0R::VALUE16 => 0x1a,
                    PC0R::VALUE17 => 0x1b,
                    PC0R::VALUE18 => 0x1c,
                    PC0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC0R {
                match value {
                    0 => PC0R::VALUE1,
                    1 => PC0R::VALUE2,
                    2 => PC0R::VALUE3,
                    3 => PC0R::VALUE4,
                    4 => PC0R::VALUE5,
                    5 => PC0R::VALUE6,
                    6 => PC0R::VALUE7,
                    7 => PC0R::VALUE8,
                    16 => PC0R::VALUE9,
                    17 => PC0R::VALUE10,
                    18 => PC0R::VALUE11,
                    19 => PC0R::VALUE12,
                    20 => PC0R::VALUE13,
                    24 => PC0R::VALUE14,
                    25 => PC0R::VALUE15,
                    26 => PC0R::VALUE16,
                    27 => PC0R::VALUE17,
                    28 => PC0R::VALUE18,
                    i => PC0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC0R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC0R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC0R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC0R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC0R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC0R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC0R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC0R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC0R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC0R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC0R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC0R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC0R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC0R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC0R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC1R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC1R::VALUE1 => 0,
                    PC1R::VALUE2 => 0x01,
                    PC1R::VALUE3 => 0x02,
                    PC1R::VALUE4 => 0x03,
                    PC1R::VALUE5 => 0x04,
                    PC1R::VALUE6 => 0x05,
                    PC1R::VALUE7 => 0x06,
                    PC1R::VALUE8 => 0x07,
                    PC1R::VALUE9 => 0x10,
                    PC1R::VALUE10 => 0x11,
                    PC1R::VALUE11 => 0x12,
                    PC1R::VALUE12 => 0x13,
                    PC1R::VALUE13 => 0x14,
                    PC1R::VALUE14 => 0x18,
                    PC1R::VALUE15 => 0x19,
                    PC1R::VALUE16 => 0x1a,
                    PC1R::VALUE17 => 0x1b,
                    PC1R::VALUE18 => 0x1c,
                    PC1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC1R {
                match value {
                    0 => PC1R::VALUE1,
                    1 => PC1R::VALUE2,
                    2 => PC1R::VALUE3,
                    3 => PC1R::VALUE4,
                    4 => PC1R::VALUE5,
                    5 => PC1R::VALUE6,
                    6 => PC1R::VALUE7,
                    7 => PC1R::VALUE8,
                    16 => PC1R::VALUE9,
                    17 => PC1R::VALUE10,
                    18 => PC1R::VALUE11,
                    19 => PC1R::VALUE12,
                    20 => PC1R::VALUE13,
                    24 => PC1R::VALUE14,
                    25 => PC1R::VALUE15,
                    26 => PC1R::VALUE16,
                    27 => PC1R::VALUE17,
                    28 => PC1R::VALUE18,
                    i => PC1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC1R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC1R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC1R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC1R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC1R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC1R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC1R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC1R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC1R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC1R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC1R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC1R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC1R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC1R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC1R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC2R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC2R::VALUE1 => 0,
                    PC2R::VALUE2 => 0x01,
                    PC2R::VALUE3 => 0x02,
                    PC2R::VALUE4 => 0x03,
                    PC2R::VALUE5 => 0x04,
                    PC2R::VALUE6 => 0x05,
                    PC2R::VALUE7 => 0x06,
                    PC2R::VALUE8 => 0x07,
                    PC2R::VALUE9 => 0x10,
                    PC2R::VALUE10 => 0x11,
                    PC2R::VALUE11 => 0x12,
                    PC2R::VALUE12 => 0x13,
                    PC2R::VALUE13 => 0x14,
                    PC2R::VALUE14 => 0x18,
                    PC2R::VALUE15 => 0x19,
                    PC2R::VALUE16 => 0x1a,
                    PC2R::VALUE17 => 0x1b,
                    PC2R::VALUE18 => 0x1c,
                    PC2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC2R {
                match value {
                    0 => PC2R::VALUE1,
                    1 => PC2R::VALUE2,
                    2 => PC2R::VALUE3,
                    3 => PC2R::VALUE4,
                    4 => PC2R::VALUE5,
                    5 => PC2R::VALUE6,
                    6 => PC2R::VALUE7,
                    7 => PC2R::VALUE8,
                    16 => PC2R::VALUE9,
                    17 => PC2R::VALUE10,
                    18 => PC2R::VALUE11,
                    19 => PC2R::VALUE12,
                    20 => PC2R::VALUE13,
                    24 => PC2R::VALUE14,
                    25 => PC2R::VALUE15,
                    26 => PC2R::VALUE16,
                    27 => PC2R::VALUE17,
                    28 => PC2R::VALUE18,
                    i => PC2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC2R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC2R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC2R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC2R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC2R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC2R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC2R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC2R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC2R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC2R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC2R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC2R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC2R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC2R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC2R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC3R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC3R::VALUE1 => 0,
                    PC3R::VALUE2 => 0x01,
                    PC3R::VALUE3 => 0x02,
                    PC3R::VALUE4 => 0x03,
                    PC3R::VALUE5 => 0x04,
                    PC3R::VALUE6 => 0x05,
                    PC3R::VALUE7 => 0x06,
                    PC3R::VALUE8 => 0x07,
                    PC3R::VALUE9 => 0x10,
                    PC3R::VALUE10 => 0x11,
                    PC3R::VALUE11 => 0x12,
                    PC3R::VALUE12 => 0x13,
                    PC3R::VALUE13 => 0x14,
                    PC3R::VALUE14 => 0x18,
                    PC3R::VALUE15 => 0x19,
                    PC3R::VALUE16 => 0x1a,
                    PC3R::VALUE17 => 0x1b,
                    PC3R::VALUE18 => 0x1c,
                    PC3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC3R {
                match value {
                    0 => PC3R::VALUE1,
                    1 => PC3R::VALUE2,
                    2 => PC3R::VALUE3,
                    3 => PC3R::VALUE4,
                    4 => PC3R::VALUE5,
                    5 => PC3R::VALUE6,
                    6 => PC3R::VALUE7,
                    7 => PC3R::VALUE8,
                    16 => PC3R::VALUE9,
                    17 => PC3R::VALUE10,
                    18 => PC3R::VALUE11,
                    19 => PC3R::VALUE12,
                    20 => PC3R::VALUE13,
                    24 => PC3R::VALUE14,
                    25 => PC3R::VALUE15,
                    26 => PC3R::VALUE16,
                    27 => PC3R::VALUE17,
                    28 => PC3R::VALUE18,
                    i => PC3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC3R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC3R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC3R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC3R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC3R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC3R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC3R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC3R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC3R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC3R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC3R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC3R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC3R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC3R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC3R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC3R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC0`"]
        pub enum PC0W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC0W::VALUE1 => 0,
                    PC0W::VALUE2 => 1,
                    PC0W::VALUE3 => 2,
                    PC0W::VALUE4 => 3,
                    PC0W::VALUE5 => 4,
                    PC0W::VALUE6 => 5,
                    PC0W::VALUE7 => 6,
                    PC0W::VALUE8 => 7,
                    PC0W::VALUE9 => 16,
                    PC0W::VALUE10 => 17,
                    PC0W::VALUE11 => 18,
                    PC0W::VALUE12 => 19,
                    PC0W::VALUE13 => 20,
                    PC0W::VALUE14 => 24,
                    PC0W::VALUE15 => 25,
                    PC0W::VALUE16 => 26,
                    PC0W::VALUE17 => 27,
                    PC0W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC0W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC0W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC0W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC0W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC0W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC0W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC0W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC0W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC0W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC0W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC0W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC0W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC0W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC0W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC0W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC0W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC0W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC0W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC1`"]
        pub enum PC1W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC1W::VALUE1 => 0,
                    PC1W::VALUE2 => 1,
                    PC1W::VALUE3 => 2,
                    PC1W::VALUE4 => 3,
                    PC1W::VALUE5 => 4,
                    PC1W::VALUE6 => 5,
                    PC1W::VALUE7 => 6,
                    PC1W::VALUE8 => 7,
                    PC1W::VALUE9 => 16,
                    PC1W::VALUE10 => 17,
                    PC1W::VALUE11 => 18,
                    PC1W::VALUE12 => 19,
                    PC1W::VALUE13 => 20,
                    PC1W::VALUE14 => 24,
                    PC1W::VALUE15 => 25,
                    PC1W::VALUE16 => 26,
                    PC1W::VALUE17 => 27,
                    PC1W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC1W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC1W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC1W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC1W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC1W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC1W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC1W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC1W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC1W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC1W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC1W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC1W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC1W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC1W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC1W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC1W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC1W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC1W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC2`"]
        pub enum PC2W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC2W::VALUE1 => 0,
                    PC2W::VALUE2 => 1,
                    PC2W::VALUE3 => 2,
                    PC2W::VALUE4 => 3,
                    PC2W::VALUE5 => 4,
                    PC2W::VALUE6 => 5,
                    PC2W::VALUE7 => 6,
                    PC2W::VALUE8 => 7,
                    PC2W::VALUE9 => 16,
                    PC2W::VALUE10 => 17,
                    PC2W::VALUE11 => 18,
                    PC2W::VALUE12 => 19,
                    PC2W::VALUE13 => 20,
                    PC2W::VALUE14 => 24,
                    PC2W::VALUE15 => 25,
                    PC2W::VALUE16 => 26,
                    PC2W::VALUE17 => 27,
                    PC2W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC2W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC2W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC2W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC2W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC2W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC2W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC2W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC2W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC2W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC2W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC2W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC2W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC2W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC2W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC2W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC2W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC2W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC2W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC3`"]
        pub enum PC3W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC3W::VALUE1 => 0,
                    PC3W::VALUE2 => 1,
                    PC3W::VALUE3 => 2,
                    PC3W::VALUE4 => 3,
                    PC3W::VALUE5 => 4,
                    PC3W::VALUE6 => 5,
                    PC3W::VALUE7 => 6,
                    PC3W::VALUE8 => 7,
                    PC3W::VALUE9 => 16,
                    PC3W::VALUE10 => 17,
                    PC3W::VALUE11 => 18,
                    PC3W::VALUE12 => 19,
                    PC3W::VALUE13 => 20,
                    PC3W::VALUE14 => 24,
                    PC3W::VALUE15 => 25,
                    PC3W::VALUE16 => 26,
                    PC3W::VALUE17 => 27,
                    PC3W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC3W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC3W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC3W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC3W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC3W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC3W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC3W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC3W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC3W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC3W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC3W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC3W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC3W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC3W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC3W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC3W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC3W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC3W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&self) -> PC0R {
                PC0R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&self) -> PC1R {
                PC1R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&self) -> PC2R {
                PC2R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&self) -> PC3R {
                PC3R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&mut self) -> _PC0W {
                _PC0W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&mut self) -> _PC1W {
                _PC1W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&mut self) -> _PC2W {
                _PC2W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&mut self) -> _PC3W {
                _PC3W { w: self }
            }
        }
    }
    #[doc = "Port 3 Input Register"]
    pub struct IN {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Input Register"]
    pub mod in_ {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Input Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Input Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Input Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Input Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Input Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Input Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Input Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Input Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Input Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Input Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Input Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Input Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Input Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Input Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Input Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Input Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 3 Pad Driver Mode 0 Register"]
    pub struct PDR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Pad Driver Mode 0 Register"]
    pub mod pdr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD0R {
            bits: u8,
        }
        impl PD0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD1R {
            bits: u8,
        }
        impl PD1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD2R {
            bits: u8,
        }
        impl PD2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD3R {
            bits: u8,
        }
        impl PD3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD4R {
            bits: u8,
        }
        impl PD4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD5R {
            bits: u8,
        }
        impl PD5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD6R {
            bits: u8,
        }
        impl PD6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Value of the field"]
        pub struct PD7R {
            bits: u8,
        }
        impl PD7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD0W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD1W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD2W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD3W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD4W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD5W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD6W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PD7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PD7W<'a> {
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x07;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&self) -> PD0R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD0R { bits }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&self) -> PD1R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD1R { bits }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&self) -> PD2R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD2R { bits }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&self) -> PD3R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD3R { bits }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&self) -> PD4R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD4R { bits }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&self) -> PD5R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD5R { bits }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&self) -> PD6R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD6R { bits }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&self) -> PD7R {
                let bits = {
                    const MASK: u8 = 0x07;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PD7R { bits }
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0x2222_2222 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:2 - Pad Driver Mode for Pn.0"]
            #[inline]
            pub fn pd0(&mut self) -> _PD0W {
                _PD0W { w: self }
            }
            #[doc = "Bits 4:6 - Pad Driver Mode for Pn.1"]
            #[inline]
            pub fn pd1(&mut self) -> _PD1W {
                _PD1W { w: self }
            }
            #[doc = "Bits 8:10 - Pad Driver Mode for Pn.2"]
            #[inline]
            pub fn pd2(&mut self) -> _PD2W {
                _PD2W { w: self }
            }
            #[doc = "Bits 12:14 - Pad Driver Mode for Pn.3"]
            #[inline]
            pub fn pd3(&mut self) -> _PD3W {
                _PD3W { w: self }
            }
            #[doc = "Bits 16:18 - Pad Driver Mode for Pn.4"]
            #[inline]
            pub fn pd4(&mut self) -> _PD4W {
                _PD4W { w: self }
            }
            #[doc = "Bits 20:22 - Pad Driver Mode for Pn.5"]
            #[inline]
            pub fn pd5(&mut self) -> _PD5W {
                _PD5W { w: self }
            }
            #[doc = "Bits 24:26 - Pad Driver Mode for Pn.6"]
            #[inline]
            pub fn pd6(&mut self) -> _PD6W {
                _PD6W { w: self }
            }
            #[doc = "Bits 28:30 - Pad Driver Mode for Pn.7"]
            #[inline]
            pub fn pd7(&mut self) -> _PD7W {
                _PD7W { w: self }
            }
        }
    }
    #[doc = "Port 3 Pin Function Decision Control Register"]
    pub struct PDISC {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Pin Function Decision Control Register"]
    pub mod pdisc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::PDISC {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `PDIS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS0R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS0R::VALUE1 => false,
                    PDIS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS0R {
                match value {
                    false => PDIS0R::VALUE1,
                    true => PDIS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS1R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS1R::VALUE1 => false,
                    PDIS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS1R {
                match value {
                    false => PDIS1R::VALUE1,
                    true => PDIS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS2R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS2R::VALUE1 => false,
                    PDIS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS2R {
                match value {
                    false => PDIS2R::VALUE1,
                    true => PDIS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS3R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS3R::VALUE1 => false,
                    PDIS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS3R {
                match value {
                    false => PDIS3R::VALUE1,
                    true => PDIS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS4R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS4R::VALUE1 => false,
                    PDIS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS4R {
                match value {
                    false => PDIS4R::VALUE1,
                    true => PDIS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS5R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS5R::VALUE1 => false,
                    PDIS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS5R {
                match value {
                    false => PDIS5R::VALUE1,
                    true => PDIS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS6R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS6R::VALUE1 => false,
                    PDIS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS6R {
                match value {
                    false => PDIS6R::VALUE1,
                    true => PDIS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS7R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS7R::VALUE1 => false,
                    PDIS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS7R {
                match value {
                    false => PDIS7R::VALUE1,
                    true => PDIS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS8R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS8R::VALUE1 => false,
                    PDIS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS8R {
                match value {
                    false => PDIS8R::VALUE1,
                    true => PDIS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS9R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS9R::VALUE1 => false,
                    PDIS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS9R {
                match value {
                    false => PDIS9R::VALUE1,
                    true => PDIS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS10R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS10R::VALUE1 => false,
                    PDIS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS10R {
                match value {
                    false => PDIS10R::VALUE1,
                    true => PDIS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS11R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS11R::VALUE1 => false,
                    PDIS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS11R {
                match value {
                    false => PDIS11R::VALUE1,
                    true => PDIS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS12R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS12R::VALUE1 => false,
                    PDIS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS12R {
                match value {
                    false => PDIS12R::VALUE1,
                    true => PDIS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS13R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS13R::VALUE1 => false,
                    PDIS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS13R {
                match value {
                    false => PDIS13R::VALUE1,
                    true => PDIS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS14R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS14R::VALUE1 => false,
                    PDIS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS14R {
                match value {
                    false => PDIS14R::VALUE1,
                    true => PDIS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS15R {
            #[doc = "Pad Pn.x is enabled."]
            VALUE1,
            #[doc = "Pad Pn.x is disabled."]
            VALUE2,
        }
        impl PDIS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS15R::VALUE1 => false,
                    PDIS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS15R {
                match value {
                    false => PDIS15R::VALUE1,
                    true => PDIS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Pad Disable for Port n Pin 0"]
            #[inline]
            pub fn pdis0(&self) -> PDIS0R {
                PDIS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Pad Disable for Port n Pin 1"]
            #[inline]
            pub fn pdis1(&self) -> PDIS1R {
                PDIS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Pad Disable for Port n Pin 2"]
            #[inline]
            pub fn pdis2(&self) -> PDIS2R {
                PDIS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Pad Disable for Port n Pin 3"]
            #[inline]
            pub fn pdis3(&self) -> PDIS3R {
                PDIS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Pad Disable for Port n Pin 4"]
            #[inline]
            pub fn pdis4(&self) -> PDIS4R {
                PDIS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Pad Disable for Port n Pin 5"]
            #[inline]
            pub fn pdis5(&self) -> PDIS5R {
                PDIS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Pad Disable for Port n Pin 6"]
            #[inline]
            pub fn pdis6(&self) -> PDIS6R {
                PDIS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Pad Disable for Port n Pin 7"]
            #[inline]
            pub fn pdis7(&self) -> PDIS7R {
                PDIS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Pad Disable for Port n Pin 8"]
            #[inline]
            pub fn pdis8(&self) -> PDIS8R {
                PDIS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Pad Disable for Port n Pin 9"]
            #[inline]
            pub fn pdis9(&self) -> PDIS9R {
                PDIS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Pad Disable for Port n Pin 10"]
            #[inline]
            pub fn pdis10(&self) -> PDIS10R {
                PDIS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Pad Disable for Port n Pin 11"]
            #[inline]
            pub fn pdis11(&self) -> PDIS11R {
                PDIS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Pad Disable for Port n Pin 12"]
            #[inline]
            pub fn pdis12(&self) -> PDIS12R {
                PDIS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Pad Disable for Port n Pin 13"]
            #[inline]
            pub fn pdis13(&self) -> PDIS13R {
                PDIS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Pad Disable for Port n Pin 14"]
            #[inline]
            pub fn pdis14(&self) -> PDIS14R {
                PDIS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Pad Disable for Port n Pin 15"]
            #[inline]
            pub fn pdis15(&self) -> PDIS15R {
                PDIS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 3 Pin Power Save Register"]
    pub struct PPS {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Pin Power Save Register"]
    pub mod pps {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PPS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PPS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS0R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS0R::VALUE1 => false,
                    PPS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS0R {
                match value {
                    false => PPS0R::VALUE1,
                    true => PPS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS1R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS1R::VALUE1 => false,
                    PPS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS1R {
                match value {
                    false => PPS1R::VALUE1,
                    true => PPS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS2R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS2R::VALUE1 => false,
                    PPS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS2R {
                match value {
                    false => PPS2R::VALUE1,
                    true => PPS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS3R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS3R::VALUE1 => false,
                    PPS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS3R {
                match value {
                    false => PPS3R::VALUE1,
                    true => PPS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS4R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS4R::VALUE1 => false,
                    PPS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS4R {
                match value {
                    false => PPS4R::VALUE1,
                    true => PPS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS5R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS5R::VALUE1 => false,
                    PPS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS5R {
                match value {
                    false => PPS5R::VALUE1,
                    true => PPS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS6R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS6R::VALUE1 => false,
                    PPS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS6R {
                match value {
                    false => PPS6R::VALUE1,
                    true => PPS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS7R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS7R::VALUE1 => false,
                    PPS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS7R {
                match value {
                    false => PPS7R::VALUE1,
                    true => PPS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS8R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS8R::VALUE1 => false,
                    PPS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS8R {
                match value {
                    false => PPS8R::VALUE1,
                    true => PPS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS9R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS9R::VALUE1 => false,
                    PPS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS9R {
                match value {
                    false => PPS9R::VALUE1,
                    true => PPS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS10R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS10R::VALUE1 => false,
                    PPS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS10R {
                match value {
                    false => PPS10R::VALUE1,
                    true => PPS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS11R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS11R::VALUE1 => false,
                    PPS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS11R {
                match value {
                    false => PPS11R::VALUE1,
                    true => PPS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS12R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS12R::VALUE1 => false,
                    PPS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS12R {
                match value {
                    false => PPS12R::VALUE1,
                    true => PPS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS13R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS13R::VALUE1 => false,
                    PPS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS13R {
                match value {
                    false => PPS13R::VALUE1,
                    true => PPS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS14R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS14R::VALUE1 => false,
                    PPS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS14R {
                match value {
                    false => PPS14R::VALUE1,
                    true => PPS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS15R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS15R::VALUE1 => false,
                    PPS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS15R {
                match value {
                    false => PPS15R::VALUE1,
                    true => PPS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PPS0`"]
        pub enum PPS0W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS0W::VALUE1 => false,
                    PPS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS0W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS1`"]
        pub enum PPS1W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS1W::VALUE1 => false,
                    PPS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS1W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS2`"]
        pub enum PPS2W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS2W::VALUE1 => false,
                    PPS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS2W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS3`"]
        pub enum PPS3W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS3W::VALUE1 => false,
                    PPS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS3W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS4`"]
        pub enum PPS4W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS4W::VALUE1 => false,
                    PPS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS4W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS5`"]
        pub enum PPS5W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS5W::VALUE1 => false,
                    PPS5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS5W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS6`"]
        pub enum PPS6W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS6W::VALUE1 => false,
                    PPS6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS6W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS7`"]
        pub enum PPS7W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS7W::VALUE1 => false,
                    PPS7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS7W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS8`"]
        pub enum PPS8W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS8W::VALUE1 => false,
                    PPS8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS8W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS9`"]
        pub enum PPS9W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS9W::VALUE1 => false,
                    PPS9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS9W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS10`"]
        pub enum PPS10W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS10W::VALUE1 => false,
                    PPS10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS10W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS11`"]
        pub enum PPS11W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS11W::VALUE1 => false,
                    PPS11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS11W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS12`"]
        pub enum PPS12W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS12W::VALUE1 => false,
                    PPS12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS12W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS13`"]
        pub enum PPS13W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS13W::VALUE1 => false,
                    PPS13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS13W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS14`"]
        pub enum PPS14W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS14W::VALUE1 => false,
                    PPS14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS14W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS15`"]
        pub enum PPS15W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS15W::VALUE1 => false,
                    PPS15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS15W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&self) -> PPS0R {
                PPS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&self) -> PPS1R {
                PPS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&self) -> PPS2R {
                PPS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&self) -> PPS3R {
                PPS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&self) -> PPS4R {
                PPS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&self) -> PPS5R {
                PPS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&self) -> PPS6R {
                PPS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&self) -> PPS7R {
                PPS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&self) -> PPS8R {
                PPS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&self) -> PPS9R {
                PPS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&self) -> PPS10R {
                PPS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&self) -> PPS11R {
                PPS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&self) -> PPS12R {
                PPS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&self) -> PPS13R {
                PPS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&self) -> PPS14R {
                PPS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&self) -> PPS15R {
                PPS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&mut self) -> _PPS0W {
                _PPS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&mut self) -> _PPS1W {
                _PPS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&mut self) -> _PPS2W {
                _PPS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&mut self) -> _PPS3W {
                _PPS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&mut self) -> _PPS4W {
                _PPS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&mut self) -> _PPS5W {
                _PPS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&mut self) -> _PPS6W {
                _PPS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&mut self) -> _PPS7W {
                _PPS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&mut self) -> _PPS8W {
                _PPS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&mut self) -> _PPS9W {
                _PPS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&mut self) -> _PPS10W {
                _PPS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&mut self) -> _PPS11W {
                _PPS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&mut self) -> _PPS12W {
                _PPS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&mut self) -> _PPS13W {
                _PPS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&mut self) -> _PPS14W {
                _PPS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&mut self) -> _PPS15W {
                _PPS15W { w: self }
            }
        }
    }
    #[doc = "Port 3 Pin Hardware Select Register"]
    pub struct HWSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 3 Pin Hardware Select Register"]
    pub mod hwsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HWSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HW0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW0R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW0R::VALUE1 => 0,
                    HW0R::VALUE2 => 0x01,
                    HW0R::VALUE3 => 0x02,
                    HW0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW0R {
                match value {
                    0 => HW0R::VALUE1,
                    1 => HW0R::VALUE2,
                    2 => HW0R::VALUE3,
                    i => HW0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW0R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW1R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW1R::VALUE1 => 0,
                    HW1R::VALUE2 => 0x01,
                    HW1R::VALUE3 => 0x02,
                    HW1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW1R {
                match value {
                    0 => HW1R::VALUE1,
                    1 => HW1R::VALUE2,
                    2 => HW1R::VALUE3,
                    i => HW1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW1R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW2R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW2R::VALUE1 => 0,
                    HW2R::VALUE2 => 0x01,
                    HW2R::VALUE3 => 0x02,
                    HW2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW2R {
                match value {
                    0 => HW2R::VALUE1,
                    1 => HW2R::VALUE2,
                    2 => HW2R::VALUE3,
                    i => HW2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW2R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW3R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW3R::VALUE1 => 0,
                    HW3R::VALUE2 => 0x01,
                    HW3R::VALUE3 => 0x02,
                    HW3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW3R {
                match value {
                    0 => HW3R::VALUE1,
                    1 => HW3R::VALUE2,
                    2 => HW3R::VALUE3,
                    i => HW3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW3R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW4R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW4R::VALUE1 => 0,
                    HW4R::VALUE2 => 0x01,
                    HW4R::VALUE3 => 0x02,
                    HW4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW4R {
                match value {
                    0 => HW4R::VALUE1,
                    1 => HW4R::VALUE2,
                    2 => HW4R::VALUE3,
                    i => HW4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW4R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW5R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW5R::VALUE1 => 0,
                    HW5R::VALUE2 => 0x01,
                    HW5R::VALUE3 => 0x02,
                    HW5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW5R {
                match value {
                    0 => HW5R::VALUE1,
                    1 => HW5R::VALUE2,
                    2 => HW5R::VALUE3,
                    i => HW5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW5R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW6R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW6R::VALUE1 => 0,
                    HW6R::VALUE2 => 0x01,
                    HW6R::VALUE3 => 0x02,
                    HW6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW6R {
                match value {
                    0 => HW6R::VALUE1,
                    1 => HW6R::VALUE2,
                    2 => HW6R::VALUE3,
                    i => HW6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW6R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW7R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW7R::VALUE1 => 0,
                    HW7R::VALUE2 => 0x01,
                    HW7R::VALUE3 => 0x02,
                    HW7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW7R {
                match value {
                    0 => HW7R::VALUE1,
                    1 => HW7R::VALUE2,
                    2 => HW7R::VALUE3,
                    i => HW7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW7R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW8R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW8R::VALUE1 => 0,
                    HW8R::VALUE2 => 0x01,
                    HW8R::VALUE3 => 0x02,
                    HW8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW8R {
                match value {
                    0 => HW8R::VALUE1,
                    1 => HW8R::VALUE2,
                    2 => HW8R::VALUE3,
                    i => HW8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW8R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW9R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW9R::VALUE1 => 0,
                    HW9R::VALUE2 => 0x01,
                    HW9R::VALUE3 => 0x02,
                    HW9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW9R {
                match value {
                    0 => HW9R::VALUE1,
                    1 => HW9R::VALUE2,
                    2 => HW9R::VALUE3,
                    i => HW9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW9R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW10R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW10R::VALUE1 => 0,
                    HW10R::VALUE2 => 0x01,
                    HW10R::VALUE3 => 0x02,
                    HW10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW10R {
                match value {
                    0 => HW10R::VALUE1,
                    1 => HW10R::VALUE2,
                    2 => HW10R::VALUE3,
                    i => HW10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW10R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW11R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW11R::VALUE1 => 0,
                    HW11R::VALUE2 => 0x01,
                    HW11R::VALUE3 => 0x02,
                    HW11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW11R {
                match value {
                    0 => HW11R::VALUE1,
                    1 => HW11R::VALUE2,
                    2 => HW11R::VALUE3,
                    i => HW11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW11R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW12R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW12R::VALUE1 => 0,
                    HW12R::VALUE2 => 0x01,
                    HW12R::VALUE3 => 0x02,
                    HW12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW12R {
                match value {
                    0 => HW12R::VALUE1,
                    1 => HW12R::VALUE2,
                    2 => HW12R::VALUE3,
                    i => HW12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW12R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW13R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW13R::VALUE1 => 0,
                    HW13R::VALUE2 => 0x01,
                    HW13R::VALUE3 => 0x02,
                    HW13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW13R {
                match value {
                    0 => HW13R::VALUE1,
                    1 => HW13R::VALUE2,
                    2 => HW13R::VALUE3,
                    i => HW13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW13R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW14R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW14R::VALUE1 => 0,
                    HW14R::VALUE2 => 0x01,
                    HW14R::VALUE3 => 0x02,
                    HW14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW14R {
                match value {
                    0 => HW14R::VALUE1,
                    1 => HW14R::VALUE2,
                    2 => HW14R::VALUE3,
                    i => HW14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW14R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW15R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW15R::VALUE1 => 0,
                    HW15R::VALUE2 => 0x01,
                    HW15R::VALUE3 => 0x02,
                    HW15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW15R {
                match value {
                    0 => HW15R::VALUE1,
                    1 => HW15R::VALUE2,
                    2 => HW15R::VALUE3,
                    i => HW15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW15R::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `HW0`"]
        pub enum HW0W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW0W::VALUE1 => 0,
                    HW0W::VALUE2 => 1,
                    HW0W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW0W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW0W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW0W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW1`"]
        pub enum HW1W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW1W::VALUE1 => 0,
                    HW1W::VALUE2 => 1,
                    HW1W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW1W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW1W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW1W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW2`"]
        pub enum HW2W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW2W::VALUE1 => 0,
                    HW2W::VALUE2 => 1,
                    HW2W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW2W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW2W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW2W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW3`"]
        pub enum HW3W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW3W::VALUE1 => 0,
                    HW3W::VALUE2 => 1,
                    HW3W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW3W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW3W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW3W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW4`"]
        pub enum HW4W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW4W::VALUE1 => 0,
                    HW4W::VALUE2 => 1,
                    HW4W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW4W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW4W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW4W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW5`"]
        pub enum HW5W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW5W::VALUE1 => 0,
                    HW5W::VALUE2 => 1,
                    HW5W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW5W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW5W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW5W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW6`"]
        pub enum HW6W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW6W::VALUE1 => 0,
                    HW6W::VALUE2 => 1,
                    HW6W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW6W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW6W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW6W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW7`"]
        pub enum HW7W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW7W::VALUE1 => 0,
                    HW7W::VALUE2 => 1,
                    HW7W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW7W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW7W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW7W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW8`"]
        pub enum HW8W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW8W::VALUE1 => 0,
                    HW8W::VALUE2 => 1,
                    HW8W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW8W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW8W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW8W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW9`"]
        pub enum HW9W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW9W::VALUE1 => 0,
                    HW9W::VALUE2 => 1,
                    HW9W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW9W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW9W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW9W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW10`"]
        pub enum HW10W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW10W::VALUE1 => 0,
                    HW10W::VALUE2 => 1,
                    HW10W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW10W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW10W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW10W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW11`"]
        pub enum HW11W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW11W::VALUE1 => 0,
                    HW11W::VALUE2 => 1,
                    HW11W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW11W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW11W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW11W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW12`"]
        pub enum HW12W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW12W::VALUE1 => 0,
                    HW12W::VALUE2 => 1,
                    HW12W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW12W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW12W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW12W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW13`"]
        pub enum HW13W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW13W::VALUE1 => 0,
                    HW13W::VALUE2 => 1,
                    HW13W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW13W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW13W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW13W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW14`"]
        pub enum HW14W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW14W::VALUE1 => 0,
                    HW14W::VALUE2 => 1,
                    HW14W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW14W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW14W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW14W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW15`"]
        pub enum HW15W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW15W::VALUE1 => 0,
                    HW15W::VALUE2 => 1,
                    HW15W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW15W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW15W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW15W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&self) -> HW0R {
                HW0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&self) -> HW1R {
                HW1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&self) -> HW2R {
                HW2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&self) -> HW3R {
                HW3R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&self) -> HW4R {
                HW4R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&self) -> HW5R {
                HW5R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&self) -> HW6R {
                HW6R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&self) -> HW7R {
                HW7R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&self) -> HW8R {
                HW8R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&self) -> HW9R {
                HW9R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&self) -> HW10R {
                HW10R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&self) -> HW11R {
                HW11R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&self) -> HW12R {
                HW12R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&self) -> HW13R {
                HW13R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&self) -> HW14R {
                HW14R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&self) -> HW15R {
                HW15R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&mut self) -> _HW0W {
                _HW0W { w: self }
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&mut self) -> _HW1W {
                _HW1W { w: self }
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&mut self) -> _HW2W {
                _HW2W { w: self }
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&mut self) -> _HW3W {
                _HW3W { w: self }
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&mut self) -> _HW4W {
                _HW4W { w: self }
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&mut self) -> _HW5W {
                _HW5W { w: self }
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&mut self) -> _HW6W {
                _HW6W { w: self }
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&mut self) -> _HW7W {
                _HW7W { w: self }
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&mut self) -> _HW8W {
                _HW8W { w: self }
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&mut self) -> _HW9W {
                _HW9W { w: self }
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&mut self) -> _HW10W {
                _HW10W { w: self }
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&mut self) -> _HW11W {
                _HW11W { w: self }
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&mut self) -> _HW12W {
                _HW12W { w: self }
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&mut self) -> _HW13W {
                _HW13W { w: self }
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&mut self) -> _HW14W {
                _HW14W { w: self }
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&mut self) -> _HW15W {
                _HW15W { w: self }
            }
        }
    }
}
#[doc = "Port 3"]
pub struct PORT3 {
    register_block: port3::RegisterBlock,
}
impl Deref for PORT3 {
    type Target = port3::RegisterBlock;
    fn deref(&self) -> &port3::RegisterBlock {
        &self.register_block
    }
}
#[doc = "Port 14"]
pub const PORT14: Peripheral<PORT14> = unsafe { Peripheral::new(0x4802_8e00) };
#[doc = "Port 14"]
pub mod port14 {
    use vcell::VolatileCell;
    #[doc = r" Register block"]
    #[repr(C)]
    pub struct RegisterBlock {
        #[doc = "0x00 - Port 14 Output Register"]
        pub out: OUT,
        #[doc = "0x04 - Port 14 Output Modification Register"]
        pub omr: OMR,
        _reserved0: [u8; 8usize],
        #[doc = "0x10 - Port 14 Input/Output Control Register 0"]
        pub iocr0: IOCR0,
        #[doc = "0x14 - Port 14 Input/Output Control Register 4"]
        pub iocr4: IOCR4,
        #[doc = "0x18 - Port 14 Input/Output Control Register 8"]
        pub iocr8: IOCR8,
        #[doc = "0x1c - Port 14 Input/Output Control Register 12"]
        pub iocr12: IOCR12,
        _reserved1: [u8; 4usize],
        #[doc = "0x24 - Port 14 Input Register"]
        pub in_: IN,
        _reserved2: [u8; 56usize],
        #[doc = "0x60 - Port 14 Pin Function Decision Control Register"]
        pub pdisc: PDISC,
        _reserved3: [u8; 12usize],
        #[doc = "0x70 - Port 14 Pin Power Save Register"]
        pub pps: PPS,
        #[doc = "0x74 - Port 14 Pin Hardware Select Register"]
        pub hwsel: HWSEL,
    }
    #[doc = "Port 14 Output Register"]
    pub struct OUT {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Output Register"]
    pub mod out {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OUT {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `P0`"]
        pub enum P0W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P0W::VALUE1 => false,
                    P0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P0W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P1`"]
        pub enum P1W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P1W::VALUE1 => false,
                    P1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P1W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P2`"]
        pub enum P2W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P2W::VALUE1 => false,
                    P2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P2W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P3`"]
        pub enum P3W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P3W::VALUE1 => false,
                    P3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P3W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P4`"]
        pub enum P4W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P4W::VALUE1 => false,
                    P4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P4W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P5`"]
        pub enum P5W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P5W::VALUE1 => false,
                    P5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P5W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P6`"]
        pub enum P6W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P6W::VALUE1 => false,
                    P6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P6W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P7`"]
        pub enum P7W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P7W::VALUE1 => false,
                    P7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P7W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P8`"]
        pub enum P8W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P8W::VALUE1 => false,
                    P8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P8W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P9`"]
        pub enum P9W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P9W::VALUE1 => false,
                    P9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P9W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P10`"]
        pub enum P10W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P10W::VALUE1 => false,
                    P10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P10W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P11`"]
        pub enum P11W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P11W::VALUE1 => false,
                    P11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P11W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P12`"]
        pub enum P12W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P12W::VALUE1 => false,
                    P12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P12W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P13`"]
        pub enum P13W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P13W::VALUE1 => false,
                    P13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P13W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P14`"]
        pub enum P14W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P14W::VALUE1 => false,
                    P14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P14W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `P15`"]
        pub enum P15W {
            #[doc = "The output level of Pn.x is 0."]
            VALUE1,
            #[doc = "The output level of Pn.x is 1."]
            VALUE2,
        }
        impl P15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    P15W::VALUE1 => false,
                    P15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _P15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _P15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: P15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "The output level of Pn.x is 0."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(P15W::VALUE1)
            }
            #[doc = "The output level of Pn.x is 1."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(P15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Output Bit 0"]
            #[inline]
            pub fn p0(&mut self) -> _P0W {
                _P0W { w: self }
            }
            #[doc = "Bit 1 - Port n Output Bit 1"]
            #[inline]
            pub fn p1(&mut self) -> _P1W {
                _P1W { w: self }
            }
            #[doc = "Bit 2 - Port n Output Bit 2"]
            #[inline]
            pub fn p2(&mut self) -> _P2W {
                _P2W { w: self }
            }
            #[doc = "Bit 3 - Port n Output Bit 3"]
            #[inline]
            pub fn p3(&mut self) -> _P3W {
                _P3W { w: self }
            }
            #[doc = "Bit 4 - Port n Output Bit 4"]
            #[inline]
            pub fn p4(&mut self) -> _P4W {
                _P4W { w: self }
            }
            #[doc = "Bit 5 - Port n Output Bit 5"]
            #[inline]
            pub fn p5(&mut self) -> _P5W {
                _P5W { w: self }
            }
            #[doc = "Bit 6 - Port n Output Bit 6"]
            #[inline]
            pub fn p6(&mut self) -> _P6W {
                _P6W { w: self }
            }
            #[doc = "Bit 7 - Port n Output Bit 7"]
            #[inline]
            pub fn p7(&mut self) -> _P7W {
                _P7W { w: self }
            }
            #[doc = "Bit 8 - Port n Output Bit 8"]
            #[inline]
            pub fn p8(&mut self) -> _P8W {
                _P8W { w: self }
            }
            #[doc = "Bit 9 - Port n Output Bit 9"]
            #[inline]
            pub fn p9(&mut self) -> _P9W {
                _P9W { w: self }
            }
            #[doc = "Bit 10 - Port n Output Bit 10"]
            #[inline]
            pub fn p10(&mut self) -> _P10W {
                _P10W { w: self }
            }
            #[doc = "Bit 11 - Port n Output Bit 11"]
            #[inline]
            pub fn p11(&mut self) -> _P11W {
                _P11W { w: self }
            }
            #[doc = "Bit 12 - Port n Output Bit 12"]
            #[inline]
            pub fn p12(&mut self) -> _P12W {
                _P12W { w: self }
            }
            #[doc = "Bit 13 - Port n Output Bit 13"]
            #[inline]
            pub fn p13(&mut self) -> _P13W {
                _P13W { w: self }
            }
            #[doc = "Bit 14 - Port n Output Bit 14"]
            #[inline]
            pub fn p14(&mut self) -> _P14W {
                _P14W { w: self }
            }
            #[doc = "Bit 15 - Port n Output Bit 15"]
            #[inline]
            pub fn p15(&mut self) -> _P15W {
                _P15W { w: self }
            }
        }
    }
    #[doc = "Port 14 Output Modification Register"]
    pub struct OMR {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Output Modification Register"]
    pub mod omr {
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::OMR {
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PS15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR0W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR1W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR2W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR3W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR4W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR5W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR6W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR7W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR8W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR9W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR10W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR11W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR12W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR13W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR14W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = r" Proxy"]
        pub struct _PR15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PR15W<'a> {
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Set Bit 0"]
            #[inline]
            pub fn ps0(&mut self) -> _PS0W {
                _PS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Set Bit 1"]
            #[inline]
            pub fn ps1(&mut self) -> _PS1W {
                _PS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Set Bit 2"]
            #[inline]
            pub fn ps2(&mut self) -> _PS2W {
                _PS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Set Bit 3"]
            #[inline]
            pub fn ps3(&mut self) -> _PS3W {
                _PS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Set Bit 4"]
            #[inline]
            pub fn ps4(&mut self) -> _PS4W {
                _PS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Set Bit 5"]
            #[inline]
            pub fn ps5(&mut self) -> _PS5W {
                _PS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Set Bit 6"]
            #[inline]
            pub fn ps6(&mut self) -> _PS6W {
                _PS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Set Bit 7"]
            #[inline]
            pub fn ps7(&mut self) -> _PS7W {
                _PS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Set Bit 8"]
            #[inline]
            pub fn ps8(&mut self) -> _PS8W {
                _PS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Set Bit 9"]
            #[inline]
            pub fn ps9(&mut self) -> _PS9W {
                _PS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Set Bit 10"]
            #[inline]
            pub fn ps10(&mut self) -> _PS10W {
                _PS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Set Bit 11"]
            #[inline]
            pub fn ps11(&mut self) -> _PS11W {
                _PS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Set Bit 12"]
            #[inline]
            pub fn ps12(&mut self) -> _PS12W {
                _PS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Set Bit 13"]
            #[inline]
            pub fn ps13(&mut self) -> _PS13W {
                _PS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Set Bit 14"]
            #[inline]
            pub fn ps14(&mut self) -> _PS14W {
                _PS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Set Bit 15"]
            #[inline]
            pub fn ps15(&mut self) -> _PS15W {
                _PS15W { w: self }
            }
            #[doc = "Bit 16 - Port n Reset Bit 0"]
            #[inline]
            pub fn pr0(&mut self) -> _PR0W {
                _PR0W { w: self }
            }
            #[doc = "Bit 17 - Port n Reset Bit 1"]
            #[inline]
            pub fn pr1(&mut self) -> _PR1W {
                _PR1W { w: self }
            }
            #[doc = "Bit 18 - Port n Reset Bit 2"]
            #[inline]
            pub fn pr2(&mut self) -> _PR2W {
                _PR2W { w: self }
            }
            #[doc = "Bit 19 - Port n Reset Bit 3"]
            #[inline]
            pub fn pr3(&mut self) -> _PR3W {
                _PR3W { w: self }
            }
            #[doc = "Bit 20 - Port n Reset Bit 4"]
            #[inline]
            pub fn pr4(&mut self) -> _PR4W {
                _PR4W { w: self }
            }
            #[doc = "Bit 21 - Port n Reset Bit 5"]
            #[inline]
            pub fn pr5(&mut self) -> _PR5W {
                _PR5W { w: self }
            }
            #[doc = "Bit 22 - Port n Reset Bit 6"]
            #[inline]
            pub fn pr6(&mut self) -> _PR6W {
                _PR6W { w: self }
            }
            #[doc = "Bit 23 - Port n Reset Bit 7"]
            #[inline]
            pub fn pr7(&mut self) -> _PR7W {
                _PR7W { w: self }
            }
            #[doc = "Bit 24 - Port n Reset Bit 8"]
            #[inline]
            pub fn pr8(&mut self) -> _PR8W {
                _PR8W { w: self }
            }
            #[doc = "Bit 25 - Port n Reset Bit 9"]
            #[inline]
            pub fn pr9(&mut self) -> _PR9W {
                _PR9W { w: self }
            }
            #[doc = "Bit 26 - Port n Reset Bit 10"]
            #[inline]
            pub fn pr10(&mut self) -> _PR10W {
                _PR10W { w: self }
            }
            #[doc = "Bit 27 - Port n Reset Bit 11"]
            #[inline]
            pub fn pr11(&mut self) -> _PR11W {
                _PR11W { w: self }
            }
            #[doc = "Bit 28 - Port n Reset Bit 12"]
            #[inline]
            pub fn pr12(&mut self) -> _PR12W {
                _PR12W { w: self }
            }
            #[doc = "Bit 29 - Port n Reset Bit 13"]
            #[inline]
            pub fn pr13(&mut self) -> _PR13W {
                _PR13W { w: self }
            }
            #[doc = "Bit 30 - Port n Reset Bit 14"]
            #[inline]
            pub fn pr14(&mut self) -> _PR14W {
                _PR14W { w: self }
            }
            #[doc = "Bit 31 - Port n Reset Bit 15"]
            #[inline]
            pub fn pr15(&mut self) -> _PR15W {
                _PR15W { w: self }
            }
        }
    }
    #[doc = "Port 14 Input/Output Control Register 0"]
    pub struct IOCR0 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Input/Output Control Register 0"]
    pub mod iocr0 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR0 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC0R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC0R::VALUE1 => 0,
                    PC0R::VALUE2 => 0x01,
                    PC0R::VALUE3 => 0x02,
                    PC0R::VALUE4 => 0x03,
                    PC0R::VALUE5 => 0x04,
                    PC0R::VALUE6 => 0x05,
                    PC0R::VALUE7 => 0x06,
                    PC0R::VALUE8 => 0x07,
                    PC0R::VALUE9 => 0x10,
                    PC0R::VALUE10 => 0x11,
                    PC0R::VALUE11 => 0x12,
                    PC0R::VALUE12 => 0x13,
                    PC0R::VALUE13 => 0x14,
                    PC0R::VALUE14 => 0x18,
                    PC0R::VALUE15 => 0x19,
                    PC0R::VALUE16 => 0x1a,
                    PC0R::VALUE17 => 0x1b,
                    PC0R::VALUE18 => 0x1c,
                    PC0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC0R {
                match value {
                    0 => PC0R::VALUE1,
                    1 => PC0R::VALUE2,
                    2 => PC0R::VALUE3,
                    3 => PC0R::VALUE4,
                    4 => PC0R::VALUE5,
                    5 => PC0R::VALUE6,
                    6 => PC0R::VALUE7,
                    7 => PC0R::VALUE8,
                    16 => PC0R::VALUE9,
                    17 => PC0R::VALUE10,
                    18 => PC0R::VALUE11,
                    19 => PC0R::VALUE12,
                    20 => PC0R::VALUE13,
                    24 => PC0R::VALUE14,
                    25 => PC0R::VALUE15,
                    26 => PC0R::VALUE16,
                    27 => PC0R::VALUE17,
                    28 => PC0R::VALUE18,
                    i => PC0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC0R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC0R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC0R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC0R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC0R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC0R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC0R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC0R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC0R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC0R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC0R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC0R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC0R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC0R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC0R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC0R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC1R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC1R::VALUE1 => 0,
                    PC1R::VALUE2 => 0x01,
                    PC1R::VALUE3 => 0x02,
                    PC1R::VALUE4 => 0x03,
                    PC1R::VALUE5 => 0x04,
                    PC1R::VALUE6 => 0x05,
                    PC1R::VALUE7 => 0x06,
                    PC1R::VALUE8 => 0x07,
                    PC1R::VALUE9 => 0x10,
                    PC1R::VALUE10 => 0x11,
                    PC1R::VALUE11 => 0x12,
                    PC1R::VALUE12 => 0x13,
                    PC1R::VALUE13 => 0x14,
                    PC1R::VALUE14 => 0x18,
                    PC1R::VALUE15 => 0x19,
                    PC1R::VALUE16 => 0x1a,
                    PC1R::VALUE17 => 0x1b,
                    PC1R::VALUE18 => 0x1c,
                    PC1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC1R {
                match value {
                    0 => PC1R::VALUE1,
                    1 => PC1R::VALUE2,
                    2 => PC1R::VALUE3,
                    3 => PC1R::VALUE4,
                    4 => PC1R::VALUE5,
                    5 => PC1R::VALUE6,
                    6 => PC1R::VALUE7,
                    7 => PC1R::VALUE8,
                    16 => PC1R::VALUE9,
                    17 => PC1R::VALUE10,
                    18 => PC1R::VALUE11,
                    19 => PC1R::VALUE12,
                    20 => PC1R::VALUE13,
                    24 => PC1R::VALUE14,
                    25 => PC1R::VALUE15,
                    26 => PC1R::VALUE16,
                    27 => PC1R::VALUE17,
                    28 => PC1R::VALUE18,
                    i => PC1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC1R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC1R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC1R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC1R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC1R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC1R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC1R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC1R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC1R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC1R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC1R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC1R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC1R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC1R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC1R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC1R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC2R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC2R::VALUE1 => 0,
                    PC2R::VALUE2 => 0x01,
                    PC2R::VALUE3 => 0x02,
                    PC2R::VALUE4 => 0x03,
                    PC2R::VALUE5 => 0x04,
                    PC2R::VALUE6 => 0x05,
                    PC2R::VALUE7 => 0x06,
                    PC2R::VALUE8 => 0x07,
                    PC2R::VALUE9 => 0x10,
                    PC2R::VALUE10 => 0x11,
                    PC2R::VALUE11 => 0x12,
                    PC2R::VALUE12 => 0x13,
                    PC2R::VALUE13 => 0x14,
                    PC2R::VALUE14 => 0x18,
                    PC2R::VALUE15 => 0x19,
                    PC2R::VALUE16 => 0x1a,
                    PC2R::VALUE17 => 0x1b,
                    PC2R::VALUE18 => 0x1c,
                    PC2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC2R {
                match value {
                    0 => PC2R::VALUE1,
                    1 => PC2R::VALUE2,
                    2 => PC2R::VALUE3,
                    3 => PC2R::VALUE4,
                    4 => PC2R::VALUE5,
                    5 => PC2R::VALUE6,
                    6 => PC2R::VALUE7,
                    7 => PC2R::VALUE8,
                    16 => PC2R::VALUE9,
                    17 => PC2R::VALUE10,
                    18 => PC2R::VALUE11,
                    19 => PC2R::VALUE12,
                    20 => PC2R::VALUE13,
                    24 => PC2R::VALUE14,
                    25 => PC2R::VALUE15,
                    26 => PC2R::VALUE16,
                    27 => PC2R::VALUE17,
                    28 => PC2R::VALUE18,
                    i => PC2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC2R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC2R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC2R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC2R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC2R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC2R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC2R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC2R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC2R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC2R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC2R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC2R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC2R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC2R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC2R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC2R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC3R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC3R::VALUE1 => 0,
                    PC3R::VALUE2 => 0x01,
                    PC3R::VALUE3 => 0x02,
                    PC3R::VALUE4 => 0x03,
                    PC3R::VALUE5 => 0x04,
                    PC3R::VALUE6 => 0x05,
                    PC3R::VALUE7 => 0x06,
                    PC3R::VALUE8 => 0x07,
                    PC3R::VALUE9 => 0x10,
                    PC3R::VALUE10 => 0x11,
                    PC3R::VALUE11 => 0x12,
                    PC3R::VALUE12 => 0x13,
                    PC3R::VALUE13 => 0x14,
                    PC3R::VALUE14 => 0x18,
                    PC3R::VALUE15 => 0x19,
                    PC3R::VALUE16 => 0x1a,
                    PC3R::VALUE17 => 0x1b,
                    PC3R::VALUE18 => 0x1c,
                    PC3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC3R {
                match value {
                    0 => PC3R::VALUE1,
                    1 => PC3R::VALUE2,
                    2 => PC3R::VALUE3,
                    3 => PC3R::VALUE4,
                    4 => PC3R::VALUE5,
                    5 => PC3R::VALUE6,
                    6 => PC3R::VALUE7,
                    7 => PC3R::VALUE8,
                    16 => PC3R::VALUE9,
                    17 => PC3R::VALUE10,
                    18 => PC3R::VALUE11,
                    19 => PC3R::VALUE12,
                    20 => PC3R::VALUE13,
                    24 => PC3R::VALUE14,
                    25 => PC3R::VALUE15,
                    26 => PC3R::VALUE16,
                    27 => PC3R::VALUE17,
                    28 => PC3R::VALUE18,
                    i => PC3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC3R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC3R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC3R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC3R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC3R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC3R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC3R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC3R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC3R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC3R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC3R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC3R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC3R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC3R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC3R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC3R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC0`"]
        pub enum PC0W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC0W::VALUE1 => 0,
                    PC0W::VALUE2 => 1,
                    PC0W::VALUE3 => 2,
                    PC0W::VALUE4 => 3,
                    PC0W::VALUE5 => 4,
                    PC0W::VALUE6 => 5,
                    PC0W::VALUE7 => 6,
                    PC0W::VALUE8 => 7,
                    PC0W::VALUE9 => 16,
                    PC0W::VALUE10 => 17,
                    PC0W::VALUE11 => 18,
                    PC0W::VALUE12 => 19,
                    PC0W::VALUE13 => 20,
                    PC0W::VALUE14 => 24,
                    PC0W::VALUE15 => 25,
                    PC0W::VALUE16 => 26,
                    PC0W::VALUE17 => 27,
                    PC0W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC0W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC0W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC0W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC0W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC0W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC0W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC0W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC0W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC0W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC0W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC0W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC0W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC0W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC0W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC0W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC0W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC0W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC0W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC1`"]
        pub enum PC1W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC1W::VALUE1 => 0,
                    PC1W::VALUE2 => 1,
                    PC1W::VALUE3 => 2,
                    PC1W::VALUE4 => 3,
                    PC1W::VALUE5 => 4,
                    PC1W::VALUE6 => 5,
                    PC1W::VALUE7 => 6,
                    PC1W::VALUE8 => 7,
                    PC1W::VALUE9 => 16,
                    PC1W::VALUE10 => 17,
                    PC1W::VALUE11 => 18,
                    PC1W::VALUE12 => 19,
                    PC1W::VALUE13 => 20,
                    PC1W::VALUE14 => 24,
                    PC1W::VALUE15 => 25,
                    PC1W::VALUE16 => 26,
                    PC1W::VALUE17 => 27,
                    PC1W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC1W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC1W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC1W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC1W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC1W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC1W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC1W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC1W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC1W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC1W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC1W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC1W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC1W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC1W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC1W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC1W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC1W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC1W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC2`"]
        pub enum PC2W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC2W::VALUE1 => 0,
                    PC2W::VALUE2 => 1,
                    PC2W::VALUE3 => 2,
                    PC2W::VALUE4 => 3,
                    PC2W::VALUE5 => 4,
                    PC2W::VALUE6 => 5,
                    PC2W::VALUE7 => 6,
                    PC2W::VALUE8 => 7,
                    PC2W::VALUE9 => 16,
                    PC2W::VALUE10 => 17,
                    PC2W::VALUE11 => 18,
                    PC2W::VALUE12 => 19,
                    PC2W::VALUE13 => 20,
                    PC2W::VALUE14 => 24,
                    PC2W::VALUE15 => 25,
                    PC2W::VALUE16 => 26,
                    PC2W::VALUE17 => 27,
                    PC2W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC2W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC2W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC2W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC2W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC2W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC2W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC2W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC2W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC2W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC2W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC2W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC2W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC2W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC2W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC2W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC2W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC2W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC2W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC3`"]
        pub enum PC3W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC3W::VALUE1 => 0,
                    PC3W::VALUE2 => 1,
                    PC3W::VALUE3 => 2,
                    PC3W::VALUE4 => 3,
                    PC3W::VALUE5 => 4,
                    PC3W::VALUE6 => 5,
                    PC3W::VALUE7 => 6,
                    PC3W::VALUE8 => 7,
                    PC3W::VALUE9 => 16,
                    PC3W::VALUE10 => 17,
                    PC3W::VALUE11 => 18,
                    PC3W::VALUE12 => 19,
                    PC3W::VALUE13 => 20,
                    PC3W::VALUE14 => 24,
                    PC3W::VALUE15 => 25,
                    PC3W::VALUE16 => 26,
                    PC3W::VALUE17 => 27,
                    PC3W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC3W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC3W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC3W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC3W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC3W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC3W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC3W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC3W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC3W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC3W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC3W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC3W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC3W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC3W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC3W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC3W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC3W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC3W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&self) -> PC0R {
                PC0R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&self) -> PC1R {
                PC1R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&self) -> PC2R {
                PC2R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&self) -> PC3R {
                PC3R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc0(&mut self) -> _PC0W {
                _PC0W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc1(&mut self) -> _PC1W {
                _PC1W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc2(&mut self) -> _PC2W {
                _PC2W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 0 to 3"]
            #[inline]
            pub fn pc3(&mut self) -> _PC3W {
                _PC3W { w: self }
            }
        }
    }
    #[doc = "Port 14 Input/Output Control Register 4"]
    pub struct IOCR4 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Input/Output Control Register 4"]
    pub mod iocr4 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR4 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC4R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC4R::VALUE1 => 0,
                    PC4R::VALUE2 => 0x01,
                    PC4R::VALUE3 => 0x02,
                    PC4R::VALUE4 => 0x03,
                    PC4R::VALUE5 => 0x04,
                    PC4R::VALUE6 => 0x05,
                    PC4R::VALUE7 => 0x06,
                    PC4R::VALUE8 => 0x07,
                    PC4R::VALUE9 => 0x10,
                    PC4R::VALUE10 => 0x11,
                    PC4R::VALUE11 => 0x12,
                    PC4R::VALUE12 => 0x13,
                    PC4R::VALUE13 => 0x14,
                    PC4R::VALUE14 => 0x18,
                    PC4R::VALUE15 => 0x19,
                    PC4R::VALUE16 => 0x1a,
                    PC4R::VALUE17 => 0x1b,
                    PC4R::VALUE18 => 0x1c,
                    PC4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC4R {
                match value {
                    0 => PC4R::VALUE1,
                    1 => PC4R::VALUE2,
                    2 => PC4R::VALUE3,
                    3 => PC4R::VALUE4,
                    4 => PC4R::VALUE5,
                    5 => PC4R::VALUE6,
                    6 => PC4R::VALUE7,
                    7 => PC4R::VALUE8,
                    16 => PC4R::VALUE9,
                    17 => PC4R::VALUE10,
                    18 => PC4R::VALUE11,
                    19 => PC4R::VALUE12,
                    20 => PC4R::VALUE13,
                    24 => PC4R::VALUE14,
                    25 => PC4R::VALUE15,
                    26 => PC4R::VALUE16,
                    27 => PC4R::VALUE17,
                    28 => PC4R::VALUE18,
                    i => PC4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC4R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC4R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC4R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC4R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC4R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC4R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC4R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC4R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC4R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC4R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC4R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC4R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC4R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC4R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC4R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC4R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC5R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC5R::VALUE1 => 0,
                    PC5R::VALUE2 => 0x01,
                    PC5R::VALUE3 => 0x02,
                    PC5R::VALUE4 => 0x03,
                    PC5R::VALUE5 => 0x04,
                    PC5R::VALUE6 => 0x05,
                    PC5R::VALUE7 => 0x06,
                    PC5R::VALUE8 => 0x07,
                    PC5R::VALUE9 => 0x10,
                    PC5R::VALUE10 => 0x11,
                    PC5R::VALUE11 => 0x12,
                    PC5R::VALUE12 => 0x13,
                    PC5R::VALUE13 => 0x14,
                    PC5R::VALUE14 => 0x18,
                    PC5R::VALUE15 => 0x19,
                    PC5R::VALUE16 => 0x1a,
                    PC5R::VALUE17 => 0x1b,
                    PC5R::VALUE18 => 0x1c,
                    PC5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC5R {
                match value {
                    0 => PC5R::VALUE1,
                    1 => PC5R::VALUE2,
                    2 => PC5R::VALUE3,
                    3 => PC5R::VALUE4,
                    4 => PC5R::VALUE5,
                    5 => PC5R::VALUE6,
                    6 => PC5R::VALUE7,
                    7 => PC5R::VALUE8,
                    16 => PC5R::VALUE9,
                    17 => PC5R::VALUE10,
                    18 => PC5R::VALUE11,
                    19 => PC5R::VALUE12,
                    20 => PC5R::VALUE13,
                    24 => PC5R::VALUE14,
                    25 => PC5R::VALUE15,
                    26 => PC5R::VALUE16,
                    27 => PC5R::VALUE17,
                    28 => PC5R::VALUE18,
                    i => PC5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC5R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC5R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC5R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC5R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC5R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC5R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC5R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC5R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC5R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC5R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC5R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC5R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC5R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC5R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC5R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC5R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC6R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC6R::VALUE1 => 0,
                    PC6R::VALUE2 => 0x01,
                    PC6R::VALUE3 => 0x02,
                    PC6R::VALUE4 => 0x03,
                    PC6R::VALUE5 => 0x04,
                    PC6R::VALUE6 => 0x05,
                    PC6R::VALUE7 => 0x06,
                    PC6R::VALUE8 => 0x07,
                    PC6R::VALUE9 => 0x10,
                    PC6R::VALUE10 => 0x11,
                    PC6R::VALUE11 => 0x12,
                    PC6R::VALUE12 => 0x13,
                    PC6R::VALUE13 => 0x14,
                    PC6R::VALUE14 => 0x18,
                    PC6R::VALUE15 => 0x19,
                    PC6R::VALUE16 => 0x1a,
                    PC6R::VALUE17 => 0x1b,
                    PC6R::VALUE18 => 0x1c,
                    PC6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC6R {
                match value {
                    0 => PC6R::VALUE1,
                    1 => PC6R::VALUE2,
                    2 => PC6R::VALUE3,
                    3 => PC6R::VALUE4,
                    4 => PC6R::VALUE5,
                    5 => PC6R::VALUE6,
                    6 => PC6R::VALUE7,
                    7 => PC6R::VALUE8,
                    16 => PC6R::VALUE9,
                    17 => PC6R::VALUE10,
                    18 => PC6R::VALUE11,
                    19 => PC6R::VALUE12,
                    20 => PC6R::VALUE13,
                    24 => PC6R::VALUE14,
                    25 => PC6R::VALUE15,
                    26 => PC6R::VALUE16,
                    27 => PC6R::VALUE17,
                    28 => PC6R::VALUE18,
                    i => PC6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC6R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC6R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC6R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC6R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC6R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC6R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC6R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC6R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC6R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC6R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC6R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC6R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC6R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC6R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC6R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC6R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC7R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC7R::VALUE1 => 0,
                    PC7R::VALUE2 => 0x01,
                    PC7R::VALUE3 => 0x02,
                    PC7R::VALUE4 => 0x03,
                    PC7R::VALUE5 => 0x04,
                    PC7R::VALUE6 => 0x05,
                    PC7R::VALUE7 => 0x06,
                    PC7R::VALUE8 => 0x07,
                    PC7R::VALUE9 => 0x10,
                    PC7R::VALUE10 => 0x11,
                    PC7R::VALUE11 => 0x12,
                    PC7R::VALUE12 => 0x13,
                    PC7R::VALUE13 => 0x14,
                    PC7R::VALUE14 => 0x18,
                    PC7R::VALUE15 => 0x19,
                    PC7R::VALUE16 => 0x1a,
                    PC7R::VALUE17 => 0x1b,
                    PC7R::VALUE18 => 0x1c,
                    PC7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC7R {
                match value {
                    0 => PC7R::VALUE1,
                    1 => PC7R::VALUE2,
                    2 => PC7R::VALUE3,
                    3 => PC7R::VALUE4,
                    4 => PC7R::VALUE5,
                    5 => PC7R::VALUE6,
                    6 => PC7R::VALUE7,
                    7 => PC7R::VALUE8,
                    16 => PC7R::VALUE9,
                    17 => PC7R::VALUE10,
                    18 => PC7R::VALUE11,
                    19 => PC7R::VALUE12,
                    20 => PC7R::VALUE13,
                    24 => PC7R::VALUE14,
                    25 => PC7R::VALUE15,
                    26 => PC7R::VALUE16,
                    27 => PC7R::VALUE17,
                    28 => PC7R::VALUE18,
                    i => PC7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC7R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC7R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC7R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC7R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC7R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC7R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC7R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC7R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC7R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC7R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC7R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC7R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC7R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC7R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC7R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC7R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC4`"]
        pub enum PC4W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC4W::VALUE1 => 0,
                    PC4W::VALUE2 => 1,
                    PC4W::VALUE3 => 2,
                    PC4W::VALUE4 => 3,
                    PC4W::VALUE5 => 4,
                    PC4W::VALUE6 => 5,
                    PC4W::VALUE7 => 6,
                    PC4W::VALUE8 => 7,
                    PC4W::VALUE9 => 16,
                    PC4W::VALUE10 => 17,
                    PC4W::VALUE11 => 18,
                    PC4W::VALUE12 => 19,
                    PC4W::VALUE13 => 20,
                    PC4W::VALUE14 => 24,
                    PC4W::VALUE15 => 25,
                    PC4W::VALUE16 => 26,
                    PC4W::VALUE17 => 27,
                    PC4W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC4W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC4W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC4W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC4W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC4W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC4W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC4W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC4W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC4W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC4W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC4W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC4W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC4W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC4W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC4W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC4W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC4W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC4W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC5`"]
        pub enum PC5W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC5W::VALUE1 => 0,
                    PC5W::VALUE2 => 1,
                    PC5W::VALUE3 => 2,
                    PC5W::VALUE4 => 3,
                    PC5W::VALUE5 => 4,
                    PC5W::VALUE6 => 5,
                    PC5W::VALUE7 => 6,
                    PC5W::VALUE8 => 7,
                    PC5W::VALUE9 => 16,
                    PC5W::VALUE10 => 17,
                    PC5W::VALUE11 => 18,
                    PC5W::VALUE12 => 19,
                    PC5W::VALUE13 => 20,
                    PC5W::VALUE14 => 24,
                    PC5W::VALUE15 => 25,
                    PC5W::VALUE16 => 26,
                    PC5W::VALUE17 => 27,
                    PC5W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC5W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC5W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC5W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC5W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC5W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC5W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC5W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC5W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC5W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC5W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC5W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC5W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC5W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC5W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC5W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC5W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC5W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC5W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC6`"]
        pub enum PC6W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC6W::VALUE1 => 0,
                    PC6W::VALUE2 => 1,
                    PC6W::VALUE3 => 2,
                    PC6W::VALUE4 => 3,
                    PC6W::VALUE5 => 4,
                    PC6W::VALUE6 => 5,
                    PC6W::VALUE7 => 6,
                    PC6W::VALUE8 => 7,
                    PC6W::VALUE9 => 16,
                    PC6W::VALUE10 => 17,
                    PC6W::VALUE11 => 18,
                    PC6W::VALUE12 => 19,
                    PC6W::VALUE13 => 20,
                    PC6W::VALUE14 => 24,
                    PC6W::VALUE15 => 25,
                    PC6W::VALUE16 => 26,
                    PC6W::VALUE17 => 27,
                    PC6W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC6W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC6W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC6W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC6W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC6W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC6W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC6W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC6W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC6W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC6W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC6W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC6W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC6W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC6W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC6W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC6W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC6W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC6W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC7`"]
        pub enum PC7W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC7W::VALUE1 => 0,
                    PC7W::VALUE2 => 1,
                    PC7W::VALUE3 => 2,
                    PC7W::VALUE4 => 3,
                    PC7W::VALUE5 => 4,
                    PC7W::VALUE6 => 5,
                    PC7W::VALUE7 => 6,
                    PC7W::VALUE8 => 7,
                    PC7W::VALUE9 => 16,
                    PC7W::VALUE10 => 17,
                    PC7W::VALUE11 => 18,
                    PC7W::VALUE12 => 19,
                    PC7W::VALUE13 => 20,
                    PC7W::VALUE14 => 24,
                    PC7W::VALUE15 => 25,
                    PC7W::VALUE16 => 26,
                    PC7W::VALUE17 => 27,
                    PC7W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC7W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC7W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC7W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC7W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC7W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC7W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC7W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC7W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC7W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC7W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC7W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC7W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC7W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC7W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC7W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC7W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC7W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC7W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&self) -> PC4R {
                PC4R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&self) -> PC5R {
                PC5R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&self) -> PC6R {
                PC6R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&self) -> PC7R {
                PC7R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc4(&mut self) -> _PC4W {
                _PC4W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc5(&mut self) -> _PC5W {
                _PC5W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc6(&mut self) -> _PC6W {
                _PC6W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 4 to 7"]
            #[inline]
            pub fn pc7(&mut self) -> _PC7W {
                _PC7W { w: self }
            }
        }
    }
    #[doc = "Port 14 Input/Output Control Register 8"]
    pub struct IOCR8 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Input/Output Control Register 8"]
    pub mod iocr8 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR8 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC8R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC8R::VALUE1 => 0,
                    PC8R::VALUE2 => 0x01,
                    PC8R::VALUE3 => 0x02,
                    PC8R::VALUE4 => 0x03,
                    PC8R::VALUE5 => 0x04,
                    PC8R::VALUE6 => 0x05,
                    PC8R::VALUE7 => 0x06,
                    PC8R::VALUE8 => 0x07,
                    PC8R::VALUE9 => 0x10,
                    PC8R::VALUE10 => 0x11,
                    PC8R::VALUE11 => 0x12,
                    PC8R::VALUE12 => 0x13,
                    PC8R::VALUE13 => 0x14,
                    PC8R::VALUE14 => 0x18,
                    PC8R::VALUE15 => 0x19,
                    PC8R::VALUE16 => 0x1a,
                    PC8R::VALUE17 => 0x1b,
                    PC8R::VALUE18 => 0x1c,
                    PC8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC8R {
                match value {
                    0 => PC8R::VALUE1,
                    1 => PC8R::VALUE2,
                    2 => PC8R::VALUE3,
                    3 => PC8R::VALUE4,
                    4 => PC8R::VALUE5,
                    5 => PC8R::VALUE6,
                    6 => PC8R::VALUE7,
                    7 => PC8R::VALUE8,
                    16 => PC8R::VALUE9,
                    17 => PC8R::VALUE10,
                    18 => PC8R::VALUE11,
                    19 => PC8R::VALUE12,
                    20 => PC8R::VALUE13,
                    24 => PC8R::VALUE14,
                    25 => PC8R::VALUE15,
                    26 => PC8R::VALUE16,
                    27 => PC8R::VALUE17,
                    28 => PC8R::VALUE18,
                    i => PC8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC8R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC8R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC8R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC8R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC8R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC8R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC8R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC8R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC8R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC8R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC8R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC8R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC8R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC8R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC8R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC8R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC9R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC9R::VALUE1 => 0,
                    PC9R::VALUE2 => 0x01,
                    PC9R::VALUE3 => 0x02,
                    PC9R::VALUE4 => 0x03,
                    PC9R::VALUE5 => 0x04,
                    PC9R::VALUE6 => 0x05,
                    PC9R::VALUE7 => 0x06,
                    PC9R::VALUE8 => 0x07,
                    PC9R::VALUE9 => 0x10,
                    PC9R::VALUE10 => 0x11,
                    PC9R::VALUE11 => 0x12,
                    PC9R::VALUE12 => 0x13,
                    PC9R::VALUE13 => 0x14,
                    PC9R::VALUE14 => 0x18,
                    PC9R::VALUE15 => 0x19,
                    PC9R::VALUE16 => 0x1a,
                    PC9R::VALUE17 => 0x1b,
                    PC9R::VALUE18 => 0x1c,
                    PC9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC9R {
                match value {
                    0 => PC9R::VALUE1,
                    1 => PC9R::VALUE2,
                    2 => PC9R::VALUE3,
                    3 => PC9R::VALUE4,
                    4 => PC9R::VALUE5,
                    5 => PC9R::VALUE6,
                    6 => PC9R::VALUE7,
                    7 => PC9R::VALUE8,
                    16 => PC9R::VALUE9,
                    17 => PC9R::VALUE10,
                    18 => PC9R::VALUE11,
                    19 => PC9R::VALUE12,
                    20 => PC9R::VALUE13,
                    24 => PC9R::VALUE14,
                    25 => PC9R::VALUE15,
                    26 => PC9R::VALUE16,
                    27 => PC9R::VALUE17,
                    28 => PC9R::VALUE18,
                    i => PC9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC9R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC9R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC9R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC9R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC9R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC9R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC9R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC9R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC9R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC9R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC9R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC9R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC9R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC9R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC9R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC9R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC10R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC10R::VALUE1 => 0,
                    PC10R::VALUE2 => 0x01,
                    PC10R::VALUE3 => 0x02,
                    PC10R::VALUE4 => 0x03,
                    PC10R::VALUE5 => 0x04,
                    PC10R::VALUE6 => 0x05,
                    PC10R::VALUE7 => 0x06,
                    PC10R::VALUE8 => 0x07,
                    PC10R::VALUE9 => 0x10,
                    PC10R::VALUE10 => 0x11,
                    PC10R::VALUE11 => 0x12,
                    PC10R::VALUE12 => 0x13,
                    PC10R::VALUE13 => 0x14,
                    PC10R::VALUE14 => 0x18,
                    PC10R::VALUE15 => 0x19,
                    PC10R::VALUE16 => 0x1a,
                    PC10R::VALUE17 => 0x1b,
                    PC10R::VALUE18 => 0x1c,
                    PC10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC10R {
                match value {
                    0 => PC10R::VALUE1,
                    1 => PC10R::VALUE2,
                    2 => PC10R::VALUE3,
                    3 => PC10R::VALUE4,
                    4 => PC10R::VALUE5,
                    5 => PC10R::VALUE6,
                    6 => PC10R::VALUE7,
                    7 => PC10R::VALUE8,
                    16 => PC10R::VALUE9,
                    17 => PC10R::VALUE10,
                    18 => PC10R::VALUE11,
                    19 => PC10R::VALUE12,
                    20 => PC10R::VALUE13,
                    24 => PC10R::VALUE14,
                    25 => PC10R::VALUE15,
                    26 => PC10R::VALUE16,
                    27 => PC10R::VALUE17,
                    28 => PC10R::VALUE18,
                    i => PC10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC10R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC10R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC10R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC10R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC10R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC10R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC10R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC10R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC10R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC10R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC10R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC10R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC10R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC10R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC10R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC10R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC11R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC11R::VALUE1 => 0,
                    PC11R::VALUE2 => 0x01,
                    PC11R::VALUE3 => 0x02,
                    PC11R::VALUE4 => 0x03,
                    PC11R::VALUE5 => 0x04,
                    PC11R::VALUE6 => 0x05,
                    PC11R::VALUE7 => 0x06,
                    PC11R::VALUE8 => 0x07,
                    PC11R::VALUE9 => 0x10,
                    PC11R::VALUE10 => 0x11,
                    PC11R::VALUE11 => 0x12,
                    PC11R::VALUE12 => 0x13,
                    PC11R::VALUE13 => 0x14,
                    PC11R::VALUE14 => 0x18,
                    PC11R::VALUE15 => 0x19,
                    PC11R::VALUE16 => 0x1a,
                    PC11R::VALUE17 => 0x1b,
                    PC11R::VALUE18 => 0x1c,
                    PC11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC11R {
                match value {
                    0 => PC11R::VALUE1,
                    1 => PC11R::VALUE2,
                    2 => PC11R::VALUE3,
                    3 => PC11R::VALUE4,
                    4 => PC11R::VALUE5,
                    5 => PC11R::VALUE6,
                    6 => PC11R::VALUE7,
                    7 => PC11R::VALUE8,
                    16 => PC11R::VALUE9,
                    17 => PC11R::VALUE10,
                    18 => PC11R::VALUE11,
                    19 => PC11R::VALUE12,
                    20 => PC11R::VALUE13,
                    24 => PC11R::VALUE14,
                    25 => PC11R::VALUE15,
                    26 => PC11R::VALUE16,
                    27 => PC11R::VALUE17,
                    28 => PC11R::VALUE18,
                    i => PC11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC11R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC11R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC11R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC11R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC11R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC11R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC11R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC11R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC11R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC11R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC11R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC11R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC11R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC11R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC11R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC11R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC8`"]
        pub enum PC8W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC8W::VALUE1 => 0,
                    PC8W::VALUE2 => 1,
                    PC8W::VALUE3 => 2,
                    PC8W::VALUE4 => 3,
                    PC8W::VALUE5 => 4,
                    PC8W::VALUE6 => 5,
                    PC8W::VALUE7 => 6,
                    PC8W::VALUE8 => 7,
                    PC8W::VALUE9 => 16,
                    PC8W::VALUE10 => 17,
                    PC8W::VALUE11 => 18,
                    PC8W::VALUE12 => 19,
                    PC8W::VALUE13 => 20,
                    PC8W::VALUE14 => 24,
                    PC8W::VALUE15 => 25,
                    PC8W::VALUE16 => 26,
                    PC8W::VALUE17 => 27,
                    PC8W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC8W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC8W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC8W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC8W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC8W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC8W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC8W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC8W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC8W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC8W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC8W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC8W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC8W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC8W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC8W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC8W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC8W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC8W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC9`"]
        pub enum PC9W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC9W::VALUE1 => 0,
                    PC9W::VALUE2 => 1,
                    PC9W::VALUE3 => 2,
                    PC9W::VALUE4 => 3,
                    PC9W::VALUE5 => 4,
                    PC9W::VALUE6 => 5,
                    PC9W::VALUE7 => 6,
                    PC9W::VALUE8 => 7,
                    PC9W::VALUE9 => 16,
                    PC9W::VALUE10 => 17,
                    PC9W::VALUE11 => 18,
                    PC9W::VALUE12 => 19,
                    PC9W::VALUE13 => 20,
                    PC9W::VALUE14 => 24,
                    PC9W::VALUE15 => 25,
                    PC9W::VALUE16 => 26,
                    PC9W::VALUE17 => 27,
                    PC9W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC9W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC9W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC9W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC9W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC9W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC9W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC9W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC9W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC9W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC9W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC9W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC9W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC9W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC9W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC9W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC9W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC9W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC9W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC10`"]
        pub enum PC10W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC10W::VALUE1 => 0,
                    PC10W::VALUE2 => 1,
                    PC10W::VALUE3 => 2,
                    PC10W::VALUE4 => 3,
                    PC10W::VALUE5 => 4,
                    PC10W::VALUE6 => 5,
                    PC10W::VALUE7 => 6,
                    PC10W::VALUE8 => 7,
                    PC10W::VALUE9 => 16,
                    PC10W::VALUE10 => 17,
                    PC10W::VALUE11 => 18,
                    PC10W::VALUE12 => 19,
                    PC10W::VALUE13 => 20,
                    PC10W::VALUE14 => 24,
                    PC10W::VALUE15 => 25,
                    PC10W::VALUE16 => 26,
                    PC10W::VALUE17 => 27,
                    PC10W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC10W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC10W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC10W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC10W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC10W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC10W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC10W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC10W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC10W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC10W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC10W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC10W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC10W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC10W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC10W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC10W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC10W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC10W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC11`"]
        pub enum PC11W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC11W::VALUE1 => 0,
                    PC11W::VALUE2 => 1,
                    PC11W::VALUE3 => 2,
                    PC11W::VALUE4 => 3,
                    PC11W::VALUE5 => 4,
                    PC11W::VALUE6 => 5,
                    PC11W::VALUE7 => 6,
                    PC11W::VALUE8 => 7,
                    PC11W::VALUE9 => 16,
                    PC11W::VALUE10 => 17,
                    PC11W::VALUE11 => 18,
                    PC11W::VALUE12 => 19,
                    PC11W::VALUE13 => 20,
                    PC11W::VALUE14 => 24,
                    PC11W::VALUE15 => 25,
                    PC11W::VALUE16 => 26,
                    PC11W::VALUE17 => 27,
                    PC11W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC11W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC11W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC11W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC11W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC11W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC11W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC11W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC11W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC11W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC11W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC11W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC11W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC11W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC11W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC11W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC11W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC11W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC11W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&self) -> PC8R {
                PC8R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&self) -> PC9R {
                PC9R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&self) -> PC10R {
                PC10R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&self) -> PC11R {
                PC11R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc8(&mut self) -> _PC8W {
                _PC8W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc9(&mut self) -> _PC9W {
                _PC9W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc10(&mut self) -> _PC10W {
                _PC10W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 8 to 11"]
            #[inline]
            pub fn pc11(&mut self) -> _PC11W {
                _PC11W { w: self }
            }
        }
    }
    #[doc = "Port 14 Input/Output Control Register 12"]
    pub struct IOCR12 {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Input/Output Control Register 12"]
    pub mod iocr12 {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::IOCR12 {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PC12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC12R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC12R::VALUE1 => 0,
                    PC12R::VALUE2 => 0x01,
                    PC12R::VALUE3 => 0x02,
                    PC12R::VALUE4 => 0x03,
                    PC12R::VALUE5 => 0x04,
                    PC12R::VALUE6 => 0x05,
                    PC12R::VALUE7 => 0x06,
                    PC12R::VALUE8 => 0x07,
                    PC12R::VALUE9 => 0x10,
                    PC12R::VALUE10 => 0x11,
                    PC12R::VALUE11 => 0x12,
                    PC12R::VALUE12 => 0x13,
                    PC12R::VALUE13 => 0x14,
                    PC12R::VALUE14 => 0x18,
                    PC12R::VALUE15 => 0x19,
                    PC12R::VALUE16 => 0x1a,
                    PC12R::VALUE17 => 0x1b,
                    PC12R::VALUE18 => 0x1c,
                    PC12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC12R {
                match value {
                    0 => PC12R::VALUE1,
                    1 => PC12R::VALUE2,
                    2 => PC12R::VALUE3,
                    3 => PC12R::VALUE4,
                    4 => PC12R::VALUE5,
                    5 => PC12R::VALUE6,
                    6 => PC12R::VALUE7,
                    7 => PC12R::VALUE8,
                    16 => PC12R::VALUE9,
                    17 => PC12R::VALUE10,
                    18 => PC12R::VALUE11,
                    19 => PC12R::VALUE12,
                    20 => PC12R::VALUE13,
                    24 => PC12R::VALUE14,
                    25 => PC12R::VALUE15,
                    26 => PC12R::VALUE16,
                    27 => PC12R::VALUE17,
                    28 => PC12R::VALUE18,
                    i => PC12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC12R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC12R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC12R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC12R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC12R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC12R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC12R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC12R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC12R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC12R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC12R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC12R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC12R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC12R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC12R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC12R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC13R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC13R::VALUE1 => 0,
                    PC13R::VALUE2 => 0x01,
                    PC13R::VALUE3 => 0x02,
                    PC13R::VALUE4 => 0x03,
                    PC13R::VALUE5 => 0x04,
                    PC13R::VALUE6 => 0x05,
                    PC13R::VALUE7 => 0x06,
                    PC13R::VALUE8 => 0x07,
                    PC13R::VALUE9 => 0x10,
                    PC13R::VALUE10 => 0x11,
                    PC13R::VALUE11 => 0x12,
                    PC13R::VALUE12 => 0x13,
                    PC13R::VALUE13 => 0x14,
                    PC13R::VALUE14 => 0x18,
                    PC13R::VALUE15 => 0x19,
                    PC13R::VALUE16 => 0x1a,
                    PC13R::VALUE17 => 0x1b,
                    PC13R::VALUE18 => 0x1c,
                    PC13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC13R {
                match value {
                    0 => PC13R::VALUE1,
                    1 => PC13R::VALUE2,
                    2 => PC13R::VALUE3,
                    3 => PC13R::VALUE4,
                    4 => PC13R::VALUE5,
                    5 => PC13R::VALUE6,
                    6 => PC13R::VALUE7,
                    7 => PC13R::VALUE8,
                    16 => PC13R::VALUE9,
                    17 => PC13R::VALUE10,
                    18 => PC13R::VALUE11,
                    19 => PC13R::VALUE12,
                    20 => PC13R::VALUE13,
                    24 => PC13R::VALUE14,
                    25 => PC13R::VALUE15,
                    26 => PC13R::VALUE16,
                    27 => PC13R::VALUE17,
                    28 => PC13R::VALUE18,
                    i => PC13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC13R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC13R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC13R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC13R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC13R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC13R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC13R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC13R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC13R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC13R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC13R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC13R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC13R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC13R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC13R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC13R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC14R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC14R::VALUE1 => 0,
                    PC14R::VALUE2 => 0x01,
                    PC14R::VALUE3 => 0x02,
                    PC14R::VALUE4 => 0x03,
                    PC14R::VALUE5 => 0x04,
                    PC14R::VALUE6 => 0x05,
                    PC14R::VALUE7 => 0x06,
                    PC14R::VALUE8 => 0x07,
                    PC14R::VALUE9 => 0x10,
                    PC14R::VALUE10 => 0x11,
                    PC14R::VALUE11 => 0x12,
                    PC14R::VALUE12 => 0x13,
                    PC14R::VALUE13 => 0x14,
                    PC14R::VALUE14 => 0x18,
                    PC14R::VALUE15 => 0x19,
                    PC14R::VALUE16 => 0x1a,
                    PC14R::VALUE17 => 0x1b,
                    PC14R::VALUE18 => 0x1c,
                    PC14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC14R {
                match value {
                    0 => PC14R::VALUE1,
                    1 => PC14R::VALUE2,
                    2 => PC14R::VALUE3,
                    3 => PC14R::VALUE4,
                    4 => PC14R::VALUE5,
                    5 => PC14R::VALUE6,
                    6 => PC14R::VALUE7,
                    7 => PC14R::VALUE8,
                    16 => PC14R::VALUE9,
                    17 => PC14R::VALUE10,
                    18 => PC14R::VALUE11,
                    19 => PC14R::VALUE12,
                    20 => PC14R::VALUE13,
                    24 => PC14R::VALUE14,
                    25 => PC14R::VALUE15,
                    26 => PC14R::VALUE16,
                    27 => PC14R::VALUE17,
                    28 => PC14R::VALUE18,
                    i => PC14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC14R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC14R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC14R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC14R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC14R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC14R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC14R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC14R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC14R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC14R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC14R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC14R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC14R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC14R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC14R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC14R::VALUE18
            }
        }
        #[doc = "Possible values of the field `PC15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PC15R {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl PC15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    PC15R::VALUE1 => 0,
                    PC15R::VALUE2 => 0x01,
                    PC15R::VALUE3 => 0x02,
                    PC15R::VALUE4 => 0x03,
                    PC15R::VALUE5 => 0x04,
                    PC15R::VALUE6 => 0x05,
                    PC15R::VALUE7 => 0x06,
                    PC15R::VALUE8 => 0x07,
                    PC15R::VALUE9 => 0x10,
                    PC15R::VALUE10 => 0x11,
                    PC15R::VALUE11 => 0x12,
                    PC15R::VALUE12 => 0x13,
                    PC15R::VALUE13 => 0x14,
                    PC15R::VALUE14 => 0x18,
                    PC15R::VALUE15 => 0x19,
                    PC15R::VALUE16 => 0x1a,
                    PC15R::VALUE17 => 0x1b,
                    PC15R::VALUE18 => 0x1c,
                    PC15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> PC15R {
                match value {
                    0 => PC15R::VALUE1,
                    1 => PC15R::VALUE2,
                    2 => PC15R::VALUE3,
                    3 => PC15R::VALUE4,
                    4 => PC15R::VALUE5,
                    5 => PC15R::VALUE6,
                    6 => PC15R::VALUE7,
                    7 => PC15R::VALUE8,
                    16 => PC15R::VALUE9,
                    17 => PC15R::VALUE10,
                    18 => PC15R::VALUE11,
                    19 => PC15R::VALUE12,
                    20 => PC15R::VALUE13,
                    24 => PC15R::VALUE14,
                    25 => PC15R::VALUE15,
                    26 => PC15R::VALUE16,
                    27 => PC15R::VALUE17,
                    28 => PC15R::VALUE18,
                    i => PC15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PC15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PC15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == PC15R::VALUE3
            }
            #[doc = "Checks if the value of the field is `VALUE4`"]
            #[inline]
            pub fn is_value4(&self) -> bool {
                *self == PC15R::VALUE4
            }
            #[doc = "Checks if the value of the field is `VALUE5`"]
            #[inline]
            pub fn is_value5(&self) -> bool {
                *self == PC15R::VALUE5
            }
            #[doc = "Checks if the value of the field is `VALUE6`"]
            #[inline]
            pub fn is_value6(&self) -> bool {
                *self == PC15R::VALUE6
            }
            #[doc = "Checks if the value of the field is `VALUE7`"]
            #[inline]
            pub fn is_value7(&self) -> bool {
                *self == PC15R::VALUE7
            }
            #[doc = "Checks if the value of the field is `VALUE8`"]
            #[inline]
            pub fn is_value8(&self) -> bool {
                *self == PC15R::VALUE8
            }
            #[doc = "Checks if the value of the field is `VALUE9`"]
            #[inline]
            pub fn is_value9(&self) -> bool {
                *self == PC15R::VALUE9
            }
            #[doc = "Checks if the value of the field is `VALUE10`"]
            #[inline]
            pub fn is_value10(&self) -> bool {
                *self == PC15R::VALUE10
            }
            #[doc = "Checks if the value of the field is `VALUE11`"]
            #[inline]
            pub fn is_value11(&self) -> bool {
                *self == PC15R::VALUE11
            }
            #[doc = "Checks if the value of the field is `VALUE12`"]
            #[inline]
            pub fn is_value12(&self) -> bool {
                *self == PC15R::VALUE12
            }
            #[doc = "Checks if the value of the field is `VALUE13`"]
            #[inline]
            pub fn is_value13(&self) -> bool {
                *self == PC15R::VALUE13
            }
            #[doc = "Checks if the value of the field is `VALUE14`"]
            #[inline]
            pub fn is_value14(&self) -> bool {
                *self == PC15R::VALUE14
            }
            #[doc = "Checks if the value of the field is `VALUE15`"]
            #[inline]
            pub fn is_value15(&self) -> bool {
                *self == PC15R::VALUE15
            }
            #[doc = "Checks if the value of the field is `VALUE16`"]
            #[inline]
            pub fn is_value16(&self) -> bool {
                *self == PC15R::VALUE16
            }
            #[doc = "Checks if the value of the field is `VALUE17`"]
            #[inline]
            pub fn is_value17(&self) -> bool {
                *self == PC15R::VALUE17
            }
            #[doc = "Checks if the value of the field is `VALUE18`"]
            #[inline]
            pub fn is_value18(&self) -> bool {
                *self == PC15R::VALUE18
            }
        }
        #[doc = "Values that can be written to the field `PC12`"]
        pub enum PC12W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC12W::VALUE1 => 0,
                    PC12W::VALUE2 => 1,
                    PC12W::VALUE3 => 2,
                    PC12W::VALUE4 => 3,
                    PC12W::VALUE5 => 4,
                    PC12W::VALUE6 => 5,
                    PC12W::VALUE7 => 6,
                    PC12W::VALUE8 => 7,
                    PC12W::VALUE9 => 16,
                    PC12W::VALUE10 => 17,
                    PC12W::VALUE11 => 18,
                    PC12W::VALUE12 => 19,
                    PC12W::VALUE13 => 20,
                    PC12W::VALUE14 => 24,
                    PC12W::VALUE15 => 25,
                    PC12W::VALUE16 => 26,
                    PC12W::VALUE17 => 27,
                    PC12W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC12W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC12W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC12W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC12W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC12W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC12W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC12W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC12W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC12W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC12W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC12W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC12W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC12W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC12W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC12W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC12W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC12W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC12W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC13`"]
        pub enum PC13W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC13W::VALUE1 => 0,
                    PC13W::VALUE2 => 1,
                    PC13W::VALUE3 => 2,
                    PC13W::VALUE4 => 3,
                    PC13W::VALUE5 => 4,
                    PC13W::VALUE6 => 5,
                    PC13W::VALUE7 => 6,
                    PC13W::VALUE8 => 7,
                    PC13W::VALUE9 => 16,
                    PC13W::VALUE10 => 17,
                    PC13W::VALUE11 => 18,
                    PC13W::VALUE12 => 19,
                    PC13W::VALUE13 => 20,
                    PC13W::VALUE14 => 24,
                    PC13W::VALUE15 => 25,
                    PC13W::VALUE16 => 26,
                    PC13W::VALUE17 => 27,
                    PC13W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC13W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC13W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC13W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC13W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC13W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC13W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC13W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC13W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC13W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC13W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC13W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC13W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC13W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC13W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC13W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC13W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC13W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC13W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC14`"]
        pub enum PC14W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC14W::VALUE1 => 0,
                    PC14W::VALUE2 => 1,
                    PC14W::VALUE3 => 2,
                    PC14W::VALUE4 => 3,
                    PC14W::VALUE5 => 4,
                    PC14W::VALUE6 => 5,
                    PC14W::VALUE7 => 6,
                    PC14W::VALUE8 => 7,
                    PC14W::VALUE9 => 16,
                    PC14W::VALUE10 => 17,
                    PC14W::VALUE11 => 18,
                    PC14W::VALUE12 => 19,
                    PC14W::VALUE13 => 20,
                    PC14W::VALUE14 => 24,
                    PC14W::VALUE15 => 25,
                    PC14W::VALUE16 => 26,
                    PC14W::VALUE17 => 27,
                    PC14W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC14W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC14W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC14W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC14W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC14W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC14W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC14W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC14W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC14W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC14W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC14W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC14W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC14W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC14W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC14W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC14W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC14W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC14W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PC15`"]
        pub enum PC15W {
            #[doc = "Input - No internal pull device active"]
            VALUE1,
            #[doc = "Input - Internal pull-down device active"]
            VALUE2,
            #[doc = "Input - Internal pull-up device active"]
            VALUE3,
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            VALUE4,
            #[doc = "Input inverted - No internal pull device active"]
            VALUE5,
            #[doc = "Input inverted - Internal pull-down device active"]
            VALUE6,
            #[doc = "Input inverted - Internal pull-up device active"]
            VALUE7,
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            VALUE8,
            #[doc = "Output Push-Pull - General-purpose output"]
            VALUE9,
            #[doc = "Output Push-Pull - Alternate output function 1"]
            VALUE10,
            #[doc = "Output Push-Pull - Alternate output function 2"]
            VALUE11,
            #[doc = "Output Push-Pull - Alternate output function 3"]
            VALUE12,
            #[doc = "Output Push-Pull - Alternate output function 4"]
            VALUE13,
            #[doc = "Output Open Drain - General-purpose output"]
            VALUE14,
            #[doc = "Output Open Drain - Alternate output function 1"]
            VALUE15,
            #[doc = "Output Open Drain - Alternate output function 2"]
            VALUE16,
            #[doc = "Output Open Drain - Alternate output function 3"]
            VALUE17,
            #[doc = "Output Open Drain - Alternate output function 4"]
            VALUE18,
        }
        impl PC15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PC15W::VALUE1 => 0,
                    PC15W::VALUE2 => 1,
                    PC15W::VALUE3 => 2,
                    PC15W::VALUE4 => 3,
                    PC15W::VALUE5 => 4,
                    PC15W::VALUE6 => 5,
                    PC15W::VALUE7 => 6,
                    PC15W::VALUE8 => 7,
                    PC15W::VALUE9 => 16,
                    PC15W::VALUE10 => 17,
                    PC15W::VALUE11 => 18,
                    PC15W::VALUE12 => 19,
                    PC15W::VALUE13 => 20,
                    PC15W::VALUE14 => 24,
                    PC15W::VALUE15 => 25,
                    PC15W::VALUE16 => 26,
                    PC15W::VALUE17 => 27,
                    PC15W::VALUE18 => 28,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PC15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PC15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PC15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Input - No internal pull device active"]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PC15W::VALUE1)
            }
            #[doc = "Input - Internal pull-down device active"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PC15W::VALUE2)
            }
            #[doc = "Input - Internal pull-up device active"]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(PC15W::VALUE3)
            }
            #[doc = "Input - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value4(self) -> &'a mut W {
                self.variant(PC15W::VALUE4)
            }
            #[doc = "Input inverted - No internal pull device active"]
            #[inline]
            pub fn value5(self) -> &'a mut W {
                self.variant(PC15W::VALUE5)
            }
            #[doc = "Input inverted - Internal pull-down device active"]
            #[inline]
            pub fn value6(self) -> &'a mut W {
                self.variant(PC15W::VALUE6)
            }
            #[doc = "Input inverted - Internal pull-up device active"]
            #[inline]
            pub fn value7(self) -> &'a mut W {
                self.variant(PC15W::VALUE7)
            }
            #[doc = "Input inverted - No internal pull device, Pn_OUTx = input value"]
            #[inline]
            pub fn value8(self) -> &'a mut W {
                self.variant(PC15W::VALUE8)
            }
            #[doc = "Output Push-Pull - General-purpose output"]
            #[inline]
            pub fn value9(self) -> &'a mut W {
                self.variant(PC15W::VALUE9)
            }
            #[doc = "Output Push-Pull - Alternate output function 1"]
            #[inline]
            pub fn value10(self) -> &'a mut W {
                self.variant(PC15W::VALUE10)
            }
            #[doc = "Output Push-Pull - Alternate output function 2"]
            #[inline]
            pub fn value11(self) -> &'a mut W {
                self.variant(PC15W::VALUE11)
            }
            #[doc = "Output Push-Pull - Alternate output function 3"]
            #[inline]
            pub fn value12(self) -> &'a mut W {
                self.variant(PC15W::VALUE12)
            }
            #[doc = "Output Push-Pull - Alternate output function 4"]
            #[inline]
            pub fn value13(self) -> &'a mut W {
                self.variant(PC15W::VALUE13)
            }
            #[doc = "Output Open Drain - General-purpose output"]
            #[inline]
            pub fn value14(self) -> &'a mut W {
                self.variant(PC15W::VALUE14)
            }
            #[doc = "Output Open Drain - Alternate output function 1"]
            #[inline]
            pub fn value15(self) -> &'a mut W {
                self.variant(PC15W::VALUE15)
            }
            #[doc = "Output Open Drain - Alternate output function 2"]
            #[inline]
            pub fn value16(self) -> &'a mut W {
                self.variant(PC15W::VALUE16)
            }
            #[doc = "Output Open Drain - Alternate output function 3"]
            #[inline]
            pub fn value17(self) -> &'a mut W {
                self.variant(PC15W::VALUE17)
            }
            #[doc = "Output Open Drain - Alternate output function 4"]
            #[inline]
            pub fn value18(self) -> &'a mut W {
                self.variant(PC15W::VALUE18)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x1f;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc12(&self) -> PC12R {
                PC12R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc13(&self) -> PC13R {
                PC13R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc14(&self) -> PC14R {
                PC14R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc15(&self) -> PC15R {
                PC15R::_from({
                    const MASK: u8 = 0x1f;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 3:7 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc12(&mut self) -> _PC12W {
                _PC12W { w: self }
            }
            #[doc = "Bits 11:15 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc13(&mut self) -> _PC13W {
                _PC13W { w: self }
            }
            #[doc = "Bits 19:23 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc14(&mut self) -> _PC14W {
                _PC14W { w: self }
            }
            #[doc = "Bits 27:31 - Port Control for Port n Pin 12 to 15"]
            #[inline]
            pub fn pc15(&mut self) -> _PC15W {
                _PC15W { w: self }
            }
        }
    }
    #[doc = "Port 14 Input Register"]
    pub struct IN {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Input Register"]
    pub mod in_ {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        impl super::IN {
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        #[doc = "Possible values of the field `P0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P0R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P0R::VALUE1 => false,
                    P0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P0R {
                match value {
                    false => P0R::VALUE1,
                    true => P0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P1R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P1R::VALUE1 => false,
                    P1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P1R {
                match value {
                    false => P1R::VALUE1,
                    true => P1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P2R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P2R::VALUE1 => false,
                    P2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P2R {
                match value {
                    false => P2R::VALUE1,
                    true => P2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P3R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P3R::VALUE1 => false,
                    P3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P3R {
                match value {
                    false => P3R::VALUE1,
                    true => P3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P4R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P4R::VALUE1 => false,
                    P4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P4R {
                match value {
                    false => P4R::VALUE1,
                    true => P4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P5R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P5R::VALUE1 => false,
                    P5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P5R {
                match value {
                    false => P5R::VALUE1,
                    true => P5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P6R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P6R::VALUE1 => false,
                    P6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P6R {
                match value {
                    false => P6R::VALUE1,
                    true => P6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P7R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P7R::VALUE1 => false,
                    P7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P7R {
                match value {
                    false => P7R::VALUE1,
                    true => P7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P8R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P8R::VALUE1 => false,
                    P8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P8R {
                match value {
                    false => P8R::VALUE1,
                    true => P8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P9R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P9R::VALUE1 => false,
                    P9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P9R {
                match value {
                    false => P9R::VALUE1,
                    true => P9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P10R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P10R::VALUE1 => false,
                    P10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P10R {
                match value {
                    false => P10R::VALUE1,
                    true => P10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P11R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P11R::VALUE1 => false,
                    P11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P11R {
                match value {
                    false => P11R::VALUE1,
                    true => P11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P12R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P12R::VALUE1 => false,
                    P12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P12R {
                match value {
                    false => P12R::VALUE1,
                    true => P12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P13R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P13R::VALUE1 => false,
                    P13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P13R {
                match value {
                    false => P13R::VALUE1,
                    true => P13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P14R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P14R::VALUE1 => false,
                    P14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P14R {
                match value {
                    false => P14R::VALUE1,
                    true => P14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `P15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum P15R {
            #[doc = "The input level of Pn.x is 0."]
            VALUE1,
            #[doc = "The input level of Pn.x is 1."]
            VALUE2,
        }
        impl P15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    P15R::VALUE1 => false,
                    P15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> P15R {
                match value {
                    false => P15R::VALUE1,
                    true => P15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == P15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == P15R::VALUE2
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Input Bit 0"]
            #[inline]
            pub fn p0(&self) -> P0R {
                P0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Input Bit 1"]
            #[inline]
            pub fn p1(&self) -> P1R {
                P1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Input Bit 2"]
            #[inline]
            pub fn p2(&self) -> P2R {
                P2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Input Bit 3"]
            #[inline]
            pub fn p3(&self) -> P3R {
                P3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Input Bit 4"]
            #[inline]
            pub fn p4(&self) -> P4R {
                P4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Input Bit 5"]
            #[inline]
            pub fn p5(&self) -> P5R {
                P5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Input Bit 6"]
            #[inline]
            pub fn p6(&self) -> P6R {
                P6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Input Bit 7"]
            #[inline]
            pub fn p7(&self) -> P7R {
                P7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Input Bit 8"]
            #[inline]
            pub fn p8(&self) -> P8R {
                P8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Input Bit 9"]
            #[inline]
            pub fn p9(&self) -> P9R {
                P9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Input Bit 10"]
            #[inline]
            pub fn p10(&self) -> P10R {
                P10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Input Bit 11"]
            #[inline]
            pub fn p11(&self) -> P11R {
                P11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Input Bit 12"]
            #[inline]
            pub fn p12(&self) -> P12R {
                P12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Input Bit 13"]
            #[inline]
            pub fn p13(&self) -> P13R {
                P13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Input Bit 14"]
            #[inline]
            pub fn p14(&self) -> P14R {
                P14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Input Bit 15"]
            #[inline]
            pub fn p15(&self) -> P15R {
                P15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
    }
    #[doc = "Port 14 Pin Function Decision Control Register"]
    pub struct PDISC {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Pin Function Decision Control Register"]
    pub mod pdisc {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PDISC {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PDIS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS0R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS0R::VALUE1 => false,
                    PDIS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS0R {
                match value {
                    false => PDIS0R::VALUE1,
                    true => PDIS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS1R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS1R::VALUE1 => false,
                    PDIS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS1R {
                match value {
                    false => PDIS1R::VALUE1,
                    true => PDIS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS2R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS2R::VALUE1 => false,
                    PDIS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS2R {
                match value {
                    false => PDIS2R::VALUE1,
                    true => PDIS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS3R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS3R::VALUE1 => false,
                    PDIS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS3R {
                match value {
                    false => PDIS3R::VALUE1,
                    true => PDIS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS4R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS4R::VALUE1 => false,
                    PDIS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS4R {
                match value {
                    false => PDIS4R::VALUE1,
                    true => PDIS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS5R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS5R::VALUE1 => false,
                    PDIS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS5R {
                match value {
                    false => PDIS5R::VALUE1,
                    true => PDIS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS6R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS6R::VALUE1 => false,
                    PDIS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS6R {
                match value {
                    false => PDIS6R::VALUE1,
                    true => PDIS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS7R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS7R::VALUE1 => false,
                    PDIS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS7R {
                match value {
                    false => PDIS7R::VALUE1,
                    true => PDIS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS8R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS8R::VALUE1 => false,
                    PDIS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS8R {
                match value {
                    false => PDIS8R::VALUE1,
                    true => PDIS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS9R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS9R::VALUE1 => false,
                    PDIS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS9R {
                match value {
                    false => PDIS9R::VALUE1,
                    true => PDIS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS10R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS10R::VALUE1 => false,
                    PDIS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS10R {
                match value {
                    false => PDIS10R::VALUE1,
                    true => PDIS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS11R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS11R::VALUE1 => false,
                    PDIS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS11R {
                match value {
                    false => PDIS11R::VALUE1,
                    true => PDIS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS12R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS12R::VALUE1 => false,
                    PDIS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS12R {
                match value {
                    false => PDIS12R::VALUE1,
                    true => PDIS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS13R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS13R::VALUE1 => false,
                    PDIS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS13R {
                match value {
                    false => PDIS13R::VALUE1,
                    true => PDIS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS14R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS14R::VALUE1 => false,
                    PDIS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS14R {
                match value {
                    false => PDIS14R::VALUE1,
                    true => PDIS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PDIS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PDIS15R {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PDIS15R::VALUE1 => false,
                    PDIS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PDIS15R {
                match value {
                    false => PDIS15R::VALUE1,
                    true => PDIS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PDIS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PDIS15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PDIS0`"]
        pub enum PDIS0W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS0W::VALUE1 => false,
                    PDIS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS0W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS1`"]
        pub enum PDIS1W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS1W::VALUE1 => false,
                    PDIS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS1W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS2`"]
        pub enum PDIS2W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS2W::VALUE1 => false,
                    PDIS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS2W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS3`"]
        pub enum PDIS3W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS3W::VALUE1 => false,
                    PDIS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS3W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS4`"]
        pub enum PDIS4W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS4W::VALUE1 => false,
                    PDIS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS4W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS5`"]
        pub enum PDIS5W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS5W::VALUE1 => false,
                    PDIS5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS5W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS6`"]
        pub enum PDIS6W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS6W::VALUE1 => false,
                    PDIS6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS6W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS7`"]
        pub enum PDIS7W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS7W::VALUE1 => false,
                    PDIS7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS7W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS8`"]
        pub enum PDIS8W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS8W::VALUE1 => false,
                    PDIS8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS8W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS9`"]
        pub enum PDIS9W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS9W::VALUE1 => false,
                    PDIS9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS9W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS10`"]
        pub enum PDIS10W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS10W::VALUE1 => false,
                    PDIS10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS10W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS11`"]
        pub enum PDIS11W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS11W::VALUE1 => false,
                    PDIS11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS11W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS12`"]
        pub enum PDIS12W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS12W::VALUE1 => false,
                    PDIS12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS12W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS13`"]
        pub enum PDIS13W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS13W::VALUE1 => false,
                    PDIS13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS13W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS14`"]
        pub enum PDIS14W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS14W::VALUE1 => false,
                    PDIS14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS14W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PDIS15`"]
        pub enum PDIS15W {
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            VALUE1,
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            VALUE2,
        }
        impl PDIS15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PDIS15W::VALUE1 => false,
                    PDIS15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PDIS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PDIS15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PDIS15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Digital Pad input is enabled. Analog and digital input path active."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PDIS15W::VALUE1)
            }
            #[doc = "Digital Pad input is disabled. Analog input path active. (default)"]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PDIS15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Pad Disable for Port n Pin 0"]
            #[inline]
            pub fn pdis0(&self) -> PDIS0R {
                PDIS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Pad Disable for Port n Pin 1"]
            #[inline]
            pub fn pdis1(&self) -> PDIS1R {
                PDIS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Pad Disable for Port n Pin 2"]
            #[inline]
            pub fn pdis2(&self) -> PDIS2R {
                PDIS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Pad Disable for Port n Pin 3"]
            #[inline]
            pub fn pdis3(&self) -> PDIS3R {
                PDIS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Pad Disable for Port n Pin 4"]
            #[inline]
            pub fn pdis4(&self) -> PDIS4R {
                PDIS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Pad Disable for Port n Pin 5"]
            #[inline]
            pub fn pdis5(&self) -> PDIS5R {
                PDIS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Pad Disable for Port n Pin 6"]
            #[inline]
            pub fn pdis6(&self) -> PDIS6R {
                PDIS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Pad Disable for Port n Pin 7"]
            #[inline]
            pub fn pdis7(&self) -> PDIS7R {
                PDIS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Pad Disable for Port n Pin 8"]
            #[inline]
            pub fn pdis8(&self) -> PDIS8R {
                PDIS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Pad Disable for Port n Pin 9"]
            #[inline]
            pub fn pdis9(&self) -> PDIS9R {
                PDIS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Pad Disable for Port n Pin 10"]
            #[inline]
            pub fn pdis10(&self) -> PDIS10R {
                PDIS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Pad Disable for Port n Pin 11"]
            #[inline]
            pub fn pdis11(&self) -> PDIS11R {
                PDIS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Pad Disable for Port n Pin 12"]
            #[inline]
            pub fn pdis12(&self) -> PDIS12R {
                PDIS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Pad Disable for Port n Pin 13"]
            #[inline]
            pub fn pdis13(&self) -> PDIS13R {
                PDIS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Pad Disable for Port n Pin 14"]
            #[inline]
            pub fn pdis14(&self) -> PDIS14R {
                PDIS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Pad Disable for Port n Pin 15"]
            #[inline]
            pub fn pdis15(&self) -> PDIS15R {
                PDIS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Pad Disable for Port n Pin 0"]
            #[inline]
            pub fn pdis0(&mut self) -> _PDIS0W {
                _PDIS0W { w: self }
            }
            #[doc = "Bit 1 - Pad Disable for Port n Pin 1"]
            #[inline]
            pub fn pdis1(&mut self) -> _PDIS1W {
                _PDIS1W { w: self }
            }
            #[doc = "Bit 2 - Pad Disable for Port n Pin 2"]
            #[inline]
            pub fn pdis2(&mut self) -> _PDIS2W {
                _PDIS2W { w: self }
            }
            #[doc = "Bit 3 - Pad Disable for Port n Pin 3"]
            #[inline]
            pub fn pdis3(&mut self) -> _PDIS3W {
                _PDIS3W { w: self }
            }
            #[doc = "Bit 4 - Pad Disable for Port n Pin 4"]
            #[inline]
            pub fn pdis4(&mut self) -> _PDIS4W {
                _PDIS4W { w: self }
            }
            #[doc = "Bit 5 - Pad Disable for Port n Pin 5"]
            #[inline]
            pub fn pdis5(&mut self) -> _PDIS5W {
                _PDIS5W { w: self }
            }
            #[doc = "Bit 6 - Pad Disable for Port n Pin 6"]
            #[inline]
            pub fn pdis6(&mut self) -> _PDIS6W {
                _PDIS6W { w: self }
            }
            #[doc = "Bit 7 - Pad Disable for Port n Pin 7"]
            #[inline]
            pub fn pdis7(&mut self) -> _PDIS7W {
                _PDIS7W { w: self }
            }
            #[doc = "Bit 8 - Pad Disable for Port n Pin 8"]
            #[inline]
            pub fn pdis8(&mut self) -> _PDIS8W {
                _PDIS8W { w: self }
            }
            #[doc = "Bit 9 - Pad Disable for Port n Pin 9"]
            #[inline]
            pub fn pdis9(&mut self) -> _PDIS9W {
                _PDIS9W { w: self }
            }
            #[doc = "Bit 10 - Pad Disable for Port n Pin 10"]
            #[inline]
            pub fn pdis10(&mut self) -> _PDIS10W {
                _PDIS10W { w: self }
            }
            #[doc = "Bit 11 - Pad Disable for Port n Pin 11"]
            #[inline]
            pub fn pdis11(&mut self) -> _PDIS11W {
                _PDIS11W { w: self }
            }
            #[doc = "Bit 12 - Pad Disable for Port n Pin 12"]
            #[inline]
            pub fn pdis12(&mut self) -> _PDIS12W {
                _PDIS12W { w: self }
            }
            #[doc = "Bit 13 - Pad Disable for Port n Pin 13"]
            #[inline]
            pub fn pdis13(&mut self) -> _PDIS13W {
                _PDIS13W { w: self }
            }
            #[doc = "Bit 14 - Pad Disable for Port n Pin 14"]
            #[inline]
            pub fn pdis14(&mut self) -> _PDIS14W {
                _PDIS14W { w: self }
            }
            #[doc = "Bit 15 - Pad Disable for Port n Pin 15"]
            #[inline]
            pub fn pdis15(&mut self) -> _PDIS15W {
                _PDIS15W { w: self }
            }
        }
    }
    #[doc = "Port 14 Pin Power Save Register"]
    pub struct PPS {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Pin Power Save Register"]
    pub mod pps {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::PPS {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `PPS0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS0R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS0R::VALUE1 => false,
                    PPS0R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS0R {
                match value {
                    false => PPS0R::VALUE1,
                    true => PPS0R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS0R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS1R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS1R::VALUE1 => false,
                    PPS1R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS1R {
                match value {
                    false => PPS1R::VALUE1,
                    true => PPS1R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS1R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS2R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS2R::VALUE1 => false,
                    PPS2R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS2R {
                match value {
                    false => PPS2R::VALUE1,
                    true => PPS2R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS2R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS3R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS3R::VALUE1 => false,
                    PPS3R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS3R {
                match value {
                    false => PPS3R::VALUE1,
                    true => PPS3R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS3R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS4R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS4R::VALUE1 => false,
                    PPS4R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS4R {
                match value {
                    false => PPS4R::VALUE1,
                    true => PPS4R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS4R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS5R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS5R::VALUE1 => false,
                    PPS5R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS5R {
                match value {
                    false => PPS5R::VALUE1,
                    true => PPS5R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS5R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS6R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS6R::VALUE1 => false,
                    PPS6R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS6R {
                match value {
                    false => PPS6R::VALUE1,
                    true => PPS6R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS6R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS7R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS7R::VALUE1 => false,
                    PPS7R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS7R {
                match value {
                    false => PPS7R::VALUE1,
                    true => PPS7R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS7R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS8R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS8R::VALUE1 => false,
                    PPS8R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS8R {
                match value {
                    false => PPS8R::VALUE1,
                    true => PPS8R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS8R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS9R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS9R::VALUE1 => false,
                    PPS9R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS9R {
                match value {
                    false => PPS9R::VALUE1,
                    true => PPS9R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS9R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS10R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS10R::VALUE1 => false,
                    PPS10R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS10R {
                match value {
                    false => PPS10R::VALUE1,
                    true => PPS10R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS10R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS11R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS11R::VALUE1 => false,
                    PPS11R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS11R {
                match value {
                    false => PPS11R::VALUE1,
                    true => PPS11R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS11R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS12R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS12R::VALUE1 => false,
                    PPS12R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS12R {
                match value {
                    false => PPS12R::VALUE1,
                    true => PPS12R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS12R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS13R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS13R::VALUE1 => false,
                    PPS13R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS13R {
                match value {
                    false => PPS13R::VALUE1,
                    true => PPS13R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS13R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS14R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS14R::VALUE1 => false,
                    PPS14R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS14R {
                match value {
                    false => PPS14R::VALUE1,
                    true => PPS14R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS14R::VALUE2
            }
        }
        #[doc = "Possible values of the field `PPS15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum PPS15R {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15R {
            #[doc = r" Returns `true` if the bit is clear (0)"]
            #[inline]
            pub fn bit_is_clear(&self) -> bool {
                !self.bit()
            }
            #[doc = r" Returns `true` if the bit is set (1)"]
            #[inline]
            pub fn bit_is_set(&self) -> bool {
                self.bit()
            }
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bit(&self) -> bool {
                match *self {
                    PPS15R::VALUE1 => false,
                    PPS15R::VALUE2 => true,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: bool) -> PPS15R {
                match value {
                    false => PPS15R::VALUE1,
                    true => PPS15R::VALUE2,
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == PPS15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == PPS15R::VALUE2
            }
        }
        #[doc = "Values that can be written to the field `PPS0`"]
        pub enum PPS0W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS0W::VALUE1 => false,
                    PPS0W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS0W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS0W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS0W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS1`"]
        pub enum PPS1W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS1W::VALUE1 => false,
                    PPS1W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS1W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS1W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS1W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS2`"]
        pub enum PPS2W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS2W::VALUE1 => false,
                    PPS2W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS2W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS2W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS2W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS3`"]
        pub enum PPS3W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS3W::VALUE1 => false,
                    PPS3W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS3W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS3W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS3W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS4`"]
        pub enum PPS4W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS4W::VALUE1 => false,
                    PPS4W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS4W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS4W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS4W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS5`"]
        pub enum PPS5W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS5W::VALUE1 => false,
                    PPS5W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS5W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS5W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS5W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS6`"]
        pub enum PPS6W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS6W::VALUE1 => false,
                    PPS6W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS6W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS6W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS6W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS7`"]
        pub enum PPS7W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS7W::VALUE1 => false,
                    PPS7W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS7W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS7W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS7W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS8`"]
        pub enum PPS8W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS8W::VALUE1 => false,
                    PPS8W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS8W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS8W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS8W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS9`"]
        pub enum PPS9W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS9W::VALUE1 => false,
                    PPS9W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS9W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS9W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS9W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS10`"]
        pub enum PPS10W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS10W::VALUE1 => false,
                    PPS10W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS10W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS10W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS10W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS11`"]
        pub enum PPS11W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS11W::VALUE1 => false,
                    PPS11W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS11W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS11W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS11W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS12`"]
        pub enum PPS12W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS12W::VALUE1 => false,
                    PPS12W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS12W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS12W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS12W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS13`"]
        pub enum PPS13W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS13W::VALUE1 => false,
                    PPS13W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS13W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS13W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS13W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS14`"]
        pub enum PPS14W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS14W::VALUE1 => false,
                    PPS14W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS14W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS14W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS14W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `PPS15`"]
        pub enum PPS15W {
            #[doc = "Pin Power Save of Pn.x is disabled."]
            VALUE1,
            #[doc = "Pin Power Save of Pn.x is enabled."]
            VALUE2,
        }
        impl PPS15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> bool {
                match *self {
                    PPS15W::VALUE1 => false,
                    PPS15W::VALUE2 => true,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _PPS15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _PPS15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: PPS15W) -> &'a mut W {
                {
                    self.bit(variant._bits())
                }
            }
            #[doc = "Pin Power Save of Pn.x is disabled."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(PPS15W::VALUE1)
            }
            #[doc = "Pin Power Save of Pn.x is enabled."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(PPS15W::VALUE2)
            }
            #[doc = r" Sets the field bit"]
            pub fn set_bit(self) -> &'a mut W {
                self.bit(true)
            }
            #[doc = r" Clears the field bit"]
            pub fn clear_bit(self) -> &'a mut W {
                self.bit(false)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub fn bit(self, value: bool) -> &'a mut W {
                const MASK: bool = true;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&self) -> PPS0R {
                PPS0R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&self) -> PPS1R {
                PPS1R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&self) -> PPS2R {
                PPS2R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&self) -> PPS3R {
                PPS3R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&self) -> PPS4R {
                PPS4R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&self) -> PPS5R {
                PPS5R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&self) -> PPS6R {
                PPS6R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&self) -> PPS7R {
                PPS7R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&self) -> PPS8R {
                PPS8R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&self) -> PPS9R {
                PPS9R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&self) -> PPS10R {
                PPS10R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&self) -> PPS11R {
                PPS11R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 11;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&self) -> PPS12R {
                PPS12R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&self) -> PPS13R {
                PPS13R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&self) -> PPS14R {
                PPS14R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&self) -> PPS15R {
                PPS15R::_from({
                    const MASK: bool = true;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) != 0
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bit 0 - Port n Pin Power Save Bit 0"]
            #[inline]
            pub fn pps0(&mut self) -> _PPS0W {
                _PPS0W { w: self }
            }
            #[doc = "Bit 1 - Port n Pin Power Save Bit 1"]
            #[inline]
            pub fn pps1(&mut self) -> _PPS1W {
                _PPS1W { w: self }
            }
            #[doc = "Bit 2 - Port n Pin Power Save Bit 2"]
            #[inline]
            pub fn pps2(&mut self) -> _PPS2W {
                _PPS2W { w: self }
            }
            #[doc = "Bit 3 - Port n Pin Power Save Bit 3"]
            #[inline]
            pub fn pps3(&mut self) -> _PPS3W {
                _PPS3W { w: self }
            }
            #[doc = "Bit 4 - Port n Pin Power Save Bit 4"]
            #[inline]
            pub fn pps4(&mut self) -> _PPS4W {
                _PPS4W { w: self }
            }
            #[doc = "Bit 5 - Port n Pin Power Save Bit 5"]
            #[inline]
            pub fn pps5(&mut self) -> _PPS5W {
                _PPS5W { w: self }
            }
            #[doc = "Bit 6 - Port n Pin Power Save Bit 6"]
            #[inline]
            pub fn pps6(&mut self) -> _PPS6W {
                _PPS6W { w: self }
            }
            #[doc = "Bit 7 - Port n Pin Power Save Bit 7"]
            #[inline]
            pub fn pps7(&mut self) -> _PPS7W {
                _PPS7W { w: self }
            }
            #[doc = "Bit 8 - Port n Pin Power Save Bit 8"]
            #[inline]
            pub fn pps8(&mut self) -> _PPS8W {
                _PPS8W { w: self }
            }
            #[doc = "Bit 9 - Port n Pin Power Save Bit 9"]
            #[inline]
            pub fn pps9(&mut self) -> _PPS9W {
                _PPS9W { w: self }
            }
            #[doc = "Bit 10 - Port n Pin Power Save Bit 10"]
            #[inline]
            pub fn pps10(&mut self) -> _PPS10W {
                _PPS10W { w: self }
            }
            #[doc = "Bit 11 - Port n Pin Power Save Bit 11"]
            #[inline]
            pub fn pps11(&mut self) -> _PPS11W {
                _PPS11W { w: self }
            }
            #[doc = "Bit 12 - Port n Pin Power Save Bit 12"]
            #[inline]
            pub fn pps12(&mut self) -> _PPS12W {
                _PPS12W { w: self }
            }
            #[doc = "Bit 13 - Port n Pin Power Save Bit 13"]
            #[inline]
            pub fn pps13(&mut self) -> _PPS13W {
                _PPS13W { w: self }
            }
            #[doc = "Bit 14 - Port n Pin Power Save Bit 14"]
            #[inline]
            pub fn pps14(&mut self) -> _PPS14W {
                _PPS14W { w: self }
            }
            #[doc = "Bit 15 - Port n Pin Power Save Bit 15"]
            #[inline]
            pub fn pps15(&mut self) -> _PPS15W {
                _PPS15W { w: self }
            }
        }
    }
    #[doc = "Port 14 Pin Hardware Select Register"]
    pub struct HWSEL {
        register: VolatileCell<u32>,
    }
    #[doc = "Port 14 Pin Hardware Select Register"]
    pub mod hwsel {
        #[doc = r" Value read from the register"]
        pub struct R {
            bits: u32,
        }
        #[doc = r" Value to write to the register"]
        pub struct W {
            bits: u32,
        }
        impl super::HWSEL {
            #[doc = r" Modifies the contents of the register"]
            #[inline]
            pub fn modify<F>(&self, f: F)
            where
                for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Reads the contents of the register"]
            #[inline]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            #[doc = r" Writes to the register"]
            #[inline]
            pub fn write<F>(&self, f: F)
            where
                F: FnOnce(&mut W) -> &mut W,
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            #[doc = r" Writes the reset value to the register"]
            #[inline]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        #[doc = "Possible values of the field `HW0`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW0R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW0R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW0R::VALUE1 => 0,
                    HW0R::VALUE2 => 0x01,
                    HW0R::VALUE3 => 0x02,
                    HW0R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW0R {
                match value {
                    0 => HW0R::VALUE1,
                    1 => HW0R::VALUE2,
                    2 => HW0R::VALUE3,
                    i => HW0R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW0R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW0R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW0R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW1`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW1R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW1R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW1R::VALUE1 => 0,
                    HW1R::VALUE2 => 0x01,
                    HW1R::VALUE3 => 0x02,
                    HW1R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW1R {
                match value {
                    0 => HW1R::VALUE1,
                    1 => HW1R::VALUE2,
                    2 => HW1R::VALUE3,
                    i => HW1R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW1R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW1R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW1R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW2`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW2R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW2R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW2R::VALUE1 => 0,
                    HW2R::VALUE2 => 0x01,
                    HW2R::VALUE3 => 0x02,
                    HW2R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW2R {
                match value {
                    0 => HW2R::VALUE1,
                    1 => HW2R::VALUE2,
                    2 => HW2R::VALUE3,
                    i => HW2R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW2R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW2R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW2R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW3`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW3R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW3R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW3R::VALUE1 => 0,
                    HW3R::VALUE2 => 0x01,
                    HW3R::VALUE3 => 0x02,
                    HW3R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW3R {
                match value {
                    0 => HW3R::VALUE1,
                    1 => HW3R::VALUE2,
                    2 => HW3R::VALUE3,
                    i => HW3R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW3R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW3R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW3R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW4`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW4R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW4R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW4R::VALUE1 => 0,
                    HW4R::VALUE2 => 0x01,
                    HW4R::VALUE3 => 0x02,
                    HW4R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW4R {
                match value {
                    0 => HW4R::VALUE1,
                    1 => HW4R::VALUE2,
                    2 => HW4R::VALUE3,
                    i => HW4R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW4R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW4R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW4R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW5`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW5R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW5R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW5R::VALUE1 => 0,
                    HW5R::VALUE2 => 0x01,
                    HW5R::VALUE3 => 0x02,
                    HW5R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW5R {
                match value {
                    0 => HW5R::VALUE1,
                    1 => HW5R::VALUE2,
                    2 => HW5R::VALUE3,
                    i => HW5R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW5R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW5R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW5R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW6`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW6R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW6R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW6R::VALUE1 => 0,
                    HW6R::VALUE2 => 0x01,
                    HW6R::VALUE3 => 0x02,
                    HW6R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW6R {
                match value {
                    0 => HW6R::VALUE1,
                    1 => HW6R::VALUE2,
                    2 => HW6R::VALUE3,
                    i => HW6R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW6R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW6R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW6R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW7`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW7R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW7R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW7R::VALUE1 => 0,
                    HW7R::VALUE2 => 0x01,
                    HW7R::VALUE3 => 0x02,
                    HW7R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW7R {
                match value {
                    0 => HW7R::VALUE1,
                    1 => HW7R::VALUE2,
                    2 => HW7R::VALUE3,
                    i => HW7R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW7R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW7R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW7R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW8`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW8R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW8R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW8R::VALUE1 => 0,
                    HW8R::VALUE2 => 0x01,
                    HW8R::VALUE3 => 0x02,
                    HW8R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW8R {
                match value {
                    0 => HW8R::VALUE1,
                    1 => HW8R::VALUE2,
                    2 => HW8R::VALUE3,
                    i => HW8R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW8R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW8R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW8R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW9`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW9R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW9R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW9R::VALUE1 => 0,
                    HW9R::VALUE2 => 0x01,
                    HW9R::VALUE3 => 0x02,
                    HW9R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW9R {
                match value {
                    0 => HW9R::VALUE1,
                    1 => HW9R::VALUE2,
                    2 => HW9R::VALUE3,
                    i => HW9R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW9R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW9R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW9R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW10`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW10R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW10R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW10R::VALUE1 => 0,
                    HW10R::VALUE2 => 0x01,
                    HW10R::VALUE3 => 0x02,
                    HW10R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW10R {
                match value {
                    0 => HW10R::VALUE1,
                    1 => HW10R::VALUE2,
                    2 => HW10R::VALUE3,
                    i => HW10R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW10R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW10R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW10R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW11`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW11R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW11R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW11R::VALUE1 => 0,
                    HW11R::VALUE2 => 0x01,
                    HW11R::VALUE3 => 0x02,
                    HW11R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW11R {
                match value {
                    0 => HW11R::VALUE1,
                    1 => HW11R::VALUE2,
                    2 => HW11R::VALUE3,
                    i => HW11R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW11R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW11R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW11R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW12`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW12R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW12R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW12R::VALUE1 => 0,
                    HW12R::VALUE2 => 0x01,
                    HW12R::VALUE3 => 0x02,
                    HW12R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW12R {
                match value {
                    0 => HW12R::VALUE1,
                    1 => HW12R::VALUE2,
                    2 => HW12R::VALUE3,
                    i => HW12R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW12R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW12R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW12R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW13`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW13R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW13R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW13R::VALUE1 => 0,
                    HW13R::VALUE2 => 0x01,
                    HW13R::VALUE3 => 0x02,
                    HW13R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW13R {
                match value {
                    0 => HW13R::VALUE1,
                    1 => HW13R::VALUE2,
                    2 => HW13R::VALUE3,
                    i => HW13R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW13R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW13R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW13R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW14`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW14R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW14R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW14R::VALUE1 => 0,
                    HW14R::VALUE2 => 0x01,
                    HW14R::VALUE3 => 0x02,
                    HW14R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW14R {
                match value {
                    0 => HW14R::VALUE1,
                    1 => HW14R::VALUE2,
                    2 => HW14R::VALUE3,
                    i => HW14R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW14R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW14R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW14R::VALUE3
            }
        }
        #[doc = "Possible values of the field `HW15`"]
        #[derive(Clone, Copy, Debug, PartialEq)]
        pub enum HW15R {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
            #[doc = r" Reserved"]
            _Reserved(u8),
        }
        impl HW15R {
            #[doc = r" Value of the field as raw bits"]
            #[inline]
            pub fn bits(&self) -> u8 {
                match *self {
                    HW15R::VALUE1 => 0,
                    HW15R::VALUE2 => 0x01,
                    HW15R::VALUE3 => 0x02,
                    HW15R::_Reserved(bits) => bits,
                }
            }
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _from(value: u8) -> HW15R {
                match value {
                    0 => HW15R::VALUE1,
                    1 => HW15R::VALUE2,
                    2 => HW15R::VALUE3,
                    i => HW15R::_Reserved(i),
                }
            }
            #[doc = "Checks if the value of the field is `VALUE1`"]
            #[inline]
            pub fn is_value1(&self) -> bool {
                *self == HW15R::VALUE1
            }
            #[doc = "Checks if the value of the field is `VALUE2`"]
            #[inline]
            pub fn is_value2(&self) -> bool {
                *self == HW15R::VALUE2
            }
            #[doc = "Checks if the value of the field is `VALUE3`"]
            #[inline]
            pub fn is_value3(&self) -> bool {
                *self == HW15R::VALUE3
            }
        }
        #[doc = "Values that can be written to the field `HW0`"]
        pub enum HW0W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW0W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW0W::VALUE1 => 0,
                    HW0W::VALUE2 => 1,
                    HW0W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW0W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW0W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW0W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW0W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW0W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW1`"]
        pub enum HW1W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW1W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW1W::VALUE1 => 0,
                    HW1W::VALUE2 => 1,
                    HW1W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW1W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW1W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW1W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW1W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW1W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW2`"]
        pub enum HW2W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW2W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW2W::VALUE1 => 0,
                    HW2W::VALUE2 => 1,
                    HW2W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW2W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW2W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW2W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW2W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW2W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW3`"]
        pub enum HW3W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW3W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW3W::VALUE1 => 0,
                    HW3W::VALUE2 => 1,
                    HW3W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW3W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW3W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW3W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW3W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW3W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW4`"]
        pub enum HW4W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW4W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW4W::VALUE1 => 0,
                    HW4W::VALUE2 => 1,
                    HW4W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW4W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW4W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW4W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW4W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW4W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW5`"]
        pub enum HW5W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW5W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW5W::VALUE1 => 0,
                    HW5W::VALUE2 => 1,
                    HW5W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW5W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW5W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW5W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW5W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW5W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW6`"]
        pub enum HW6W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW6W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW6W::VALUE1 => 0,
                    HW6W::VALUE2 => 1,
                    HW6W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW6W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW6W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW6W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW6W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW6W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW7`"]
        pub enum HW7W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW7W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW7W::VALUE1 => 0,
                    HW7W::VALUE2 => 1,
                    HW7W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW7W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW7W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW7W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW7W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW7W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW8`"]
        pub enum HW8W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW8W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW8W::VALUE1 => 0,
                    HW8W::VALUE2 => 1,
                    HW8W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW8W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW8W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW8W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW8W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW8W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW9`"]
        pub enum HW9W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW9W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW9W::VALUE1 => 0,
                    HW9W::VALUE2 => 1,
                    HW9W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW9W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW9W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW9W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW9W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW9W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW10`"]
        pub enum HW10W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW10W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW10W::VALUE1 => 0,
                    HW10W::VALUE2 => 1,
                    HW10W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW10W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW10W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW10W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW10W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW10W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW11`"]
        pub enum HW11W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW11W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW11W::VALUE1 => 0,
                    HW11W::VALUE2 => 1,
                    HW11W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW11W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW11W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW11W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW11W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW11W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW12`"]
        pub enum HW12W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW12W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW12W::VALUE1 => 0,
                    HW12W::VALUE2 => 1,
                    HW12W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW12W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW12W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW12W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW12W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW12W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW13`"]
        pub enum HW13W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW13W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW13W::VALUE1 => 0,
                    HW13W::VALUE2 => 1,
                    HW13W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW13W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW13W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW13W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW13W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW13W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW14`"]
        pub enum HW14W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW14W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW14W::VALUE1 => 0,
                    HW14W::VALUE2 => 1,
                    HW14W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW14W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW14W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW14W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW14W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW14W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        #[doc = "Values that can be written to the field `HW15`"]
        pub enum HW15W {
            #[doc = "Software control only."]
            VALUE1,
            #[doc = "HW0 control path can override the software configuration."]
            VALUE2,
            #[doc = "HW1 control path can override the software configuration."]
            VALUE3,
        }
        impl HW15W {
            #[allow(missing_docs)]
            #[doc(hidden)]
            #[inline]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HW15W::VALUE1 => 0,
                    HW15W::VALUE2 => 1,
                    HW15W::VALUE3 => 2,
                }
            }
        }
        #[doc = r" Proxy"]
        pub struct _HW15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _HW15W<'a> {
            #[doc = r" Writes `variant` to the field"]
            #[inline]
            pub fn variant(self, variant: HW15W) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            #[doc = "Software control only."]
            #[inline]
            pub fn value1(self) -> &'a mut W {
                self.variant(HW15W::VALUE1)
            }
            #[doc = "HW0 control path can override the software configuration."]
            #[inline]
            pub fn value2(self) -> &'a mut W {
                self.variant(HW15W::VALUE2)
            }
            #[doc = "HW1 control path can override the software configuration."]
            #[inline]
            pub fn value3(self) -> &'a mut W {
                self.variant(HW15W::VALUE3)
            }
            #[doc = r" Writes raw bits to the field"]
            #[inline]
            pub unsafe fn bits(self, value: u8) -> &'a mut W {
                const MASK: u8 = 0x03;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((value & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            #[doc = r" Value of the register as raw bits"]
            #[inline]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&self) -> HW0R {
                HW0R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&self) -> HW1R {
                HW1R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&self) -> HW2R {
                HW2R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&self) -> HW3R {
                HW3R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&self) -> HW4R {
                HW4R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&self) -> HW5R {
                HW5R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&self) -> HW6R {
                HW6R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&self) -> HW7R {
                HW7R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 14;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&self) -> HW8R {
                HW8R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&self) -> HW9R {
                HW9R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&self) -> HW10R {
                HW10R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&self) -> HW11R {
                HW11R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&self) -> HW12R {
                HW12R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&self) -> HW13R {
                HW13R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&self) -> HW14R {
                HW14R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&self) -> HW15R {
                HW15R::_from({
                    const MASK: u8 = 0x03;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                })
            }
        }
        impl W {
            #[doc = r" Reset value of the register"]
            #[inline]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            #[doc = r" Writes raw bits to the register"]
            #[inline]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            #[doc = "Bits 0:1 - Port n Pin Hardware Select Bit 0"]
            #[inline]
            pub fn hw0(&mut self) -> _HW0W {
                _HW0W { w: self }
            }
            #[doc = "Bits 2:3 - Port n Pin Hardware Select Bit 1"]
            #[inline]
            pub fn hw1(&mut self) -> _HW1W {
                _HW1W { w: self }
            }
            #[doc = "Bits 4:5 - Port n Pin Hardware Select Bit 2"]
            #[inline]
            pub fn hw2(&mut self) -> _HW2W {
                _HW2W { w: self }
            }
            #[doc = "Bits 6:7 - Port n Pin Hardware Select Bit 3"]
            #[inline]
            pub fn hw3(&mut self) -> _HW3W {
                _HW3W { w: self }
            }
            #[doc = "Bits 8:9 - Port n Pin Hardware Select Bit 4"]
            #[inline]
            pub fn hw4(&mut self) -> _HW4W {
                _HW4W { w: self }
            }
            #[doc = "Bits 10:11 - Port n Pin Hardware Select Bit 5"]
            #[inline]
            pub fn hw5(&mut self) -> _HW5W {
                _HW5W { w: self }
            }
            #[doc = "Bits 12:13 - Port n Pin Hardware Select Bit 6"]
            #[inline]
            pub fn hw6(&mut self) -> _HW6W {
                _HW6W { w: self }
            }
            #[doc = "Bits 14:15 - Port n Pin Hardware Select Bit 7"]
            #[inline]
            pub fn hw7(&mut self) -> _HW7W {
                _HW7W { w: self }
            }
            #[doc = "Bits 16:17 - Port n Pin Hardware Select Bit 8"]
            #[inline]
            pub fn hw8(&mut self) -> _HW8W {
                _HW8W { w: self }
            }
            #[doc = "Bits 18:19 - Port n Pin Hardware Select Bit 9"]
            #[inline]
            pub fn hw9(&mut self) -> _HW9W {
                _HW9W { w: self }
            }
            #[doc = "Bits 20:21 - Port n Pin Hardware Select Bit 10"]
            #[inline]
            pub fn hw10(&mut self) -> _HW10W {
                _HW10W { w: self }
            }
            #[doc = "Bits 22:23 - Port n Pin Hardware Select Bit 11"]
            #[inline]
            pub fn hw11(&mut self) -> _HW11W {
                _HW11W { w: self }
            }
            #[doc = "Bits 24:25 - Port n Pin Hardware Select Bit 12"]
            #[inline]
            pub fn hw12(&mut self) -> _HW12W {
                _HW12W { w: self }
            }
            #[doc = "Bits 26:27 - Port n Pin Hardware Select Bit 13"]
            #[inline]
            pub fn hw13(&mut self) -> _HW13W {
                _HW13W { w: self }
            }
            #[doc = "Bits 28:29 - Port n Pin Hardware Select Bit 14"]
            #[inline]
            pub fn hw14(&mut self) -> _HW14W {
                _HW14W { w: self }
            }
            #[doc = "Bits 30:31 - Port n Pin Hardware Select Bit 15"]
            #[inline]
            pub fn hw15(&mut self) -> _HW15W {
                _HW15W { w: self }
            }
        }
    }
}
#[doc = "Port 14"]
pub struct PORT14 {
    register_block: port14::RegisterBlock,
}
impl Deref for PORT14 {
    type Target = port14::RegisterBlock;
    fn deref(&self) -> &port14::RegisterBlock {
        &self.register_block
    }
}
#[doc = r" All the peripherals"]
#[allow(non_snake_case)]
pub struct Peripherals<'a> {
    #[doc = "CPUID"]
    pub CPUID: &'a CPUID,
    #[doc = "DCB"]
    pub DCB: &'a DCB,
    #[doc = "DWT"]
    pub DWT: &'a DWT,
    #[doc = "FPB"]
    pub FPB: &'a FPB,
    #[doc = "FPU"]
    pub FPU: &'a FPU,
    #[doc = "ITM"]
    pub ITM: &'a ITM,
    #[doc = "MPU"]
    pub MPU: &'a MPU,
    #[doc = "NVIC"]
    pub NVIC: &'a NVIC,
    #[doc = "SCB"]
    pub SCB: &'a SCB,
    #[doc = "SYST"]
    pub SYST: &'a SYST,
    #[doc = "TPIU"]
    pub TPIU: &'a TPIU,
    #[doc = "PPB"]
    pub PPB: &'a PPB,
    #[doc = "DLR"]
    pub DLR: &'a DLR,
    #[doc = "ERU0"]
    pub ERU0: &'a ERU0,
    #[doc = "ERU1"]
    pub ERU1: &'a ERU1,
    #[doc = "GPDMA0"]
    pub GPDMA0: &'a GPDMA0,
    #[doc = "GPDMA0_CH0"]
    pub GPDMA0_CH0: &'a GPDMA0_CH0,
    #[doc = "GPDMA0_CH1"]
    pub GPDMA0_CH1: &'a GPDMA0_CH1,
    #[doc = "GPDMA0_CH2"]
    pub GPDMA0_CH2: &'a GPDMA0_CH2,
    #[doc = "GPDMA0_CH3"]
    pub GPDMA0_CH3: &'a GPDMA0_CH3,
    #[doc = "GPDMA0_CH4"]
    pub GPDMA0_CH4: &'a GPDMA0_CH4,
    #[doc = "GPDMA0_CH5"]
    pub GPDMA0_CH5: &'a GPDMA0_CH5,
    #[doc = "GPDMA0_CH6"]
    pub GPDMA0_CH6: &'a GPDMA0_CH6,
    #[doc = "GPDMA0_CH7"]
    pub GPDMA0_CH7: &'a GPDMA0_CH7,
    #[doc = "FCE"]
    pub FCE: &'a FCE,
    #[doc = "FCE_KE0"]
    pub FCE_KE0: &'a FCE_KE0,
    #[doc = "FCE_KE1"]
    pub FCE_KE1: &'a FCE_KE1,
    #[doc = "FCE_KE2"]
    pub FCE_KE2: &'a FCE_KE2,
    #[doc = "FCE_KE3"]
    pub FCE_KE3: &'a FCE_KE3,
    #[doc = "PBA0"]
    pub PBA0: &'a PBA0,
    #[doc = "PBA1"]
    pub PBA1: &'a PBA1,
    #[doc = "FLASH0"]
    pub FLASH0: &'a FLASH0,
    #[doc = "PREF"]
    pub PREF: &'a PREF,
    #[doc = "PMU0"]
    pub PMU0: &'a PMU0,
    #[doc = "WDT"]
    pub WDT: &'a WDT,
    #[doc = "RTC"]
    pub RTC: &'a RTC,
    #[doc = "SCU_CLK"]
    pub SCU_CLK: &'a SCU_CLK,
    #[doc = "SCU_OSC"]
    pub SCU_OSC: &'a SCU_OSC,
    #[doc = "SCU_PLL"]
    pub SCU_PLL: &'a SCU_PLL,
    #[doc = "SCU_GENERAL"]
    pub SCU_GENERAL: &'a SCU_GENERAL,
    #[doc = "SCU_INTERRUPT"]
    pub SCU_INTERRUPT: &'a SCU_INTERRUPT,
    #[doc = "SCU_PARITY"]
    pub SCU_PARITY: &'a SCU_PARITY,
    #[doc = "SCU_TRAP"]
    pub SCU_TRAP: &'a SCU_TRAP,
    #[doc = "SCU_HIBERNATE"]
    pub SCU_HIBERNATE: &'a SCU_HIBERNATE,
    #[doc = "SCU_POWER"]
    pub SCU_POWER: &'a SCU_POWER,
    #[doc = "SCU_RESET"]
    pub SCU_RESET: &'a SCU_RESET,
    #[doc = "LEDTS0"]
    pub LEDTS0: &'a LEDTS0,
    #[doc = "USB0"]
    pub USB0: &'a USB0,
    #[doc = "USB0_EP0"]
    pub USB0_EP0: &'a USB0_EP0,
    #[doc = "USB0_EP1"]
    pub USB0_EP1: &'a USB0_EP1,
    #[doc = "USB0_EP2"]
    pub USB0_EP2: &'a USB0_EP2,
    #[doc = "USB0_EP3"]
    pub USB0_EP3: &'a USB0_EP3,
    #[doc = "USB0_EP4"]
    pub USB0_EP4: &'a USB0_EP4,
    #[doc = "USB0_EP5"]
    pub USB0_EP5: &'a USB0_EP5,
    #[doc = "USB0_EP6"]
    pub USB0_EP6: &'a USB0_EP6,
    #[doc = "USIC0"]
    pub USIC0: &'a USIC0,
    #[doc = "USIC1"]
    pub USIC1: &'a USIC1,
    #[doc = "USIC0_CH0"]
    pub USIC0_CH0: &'a USIC0_CH0,
    #[doc = "USIC0_CH1"]
    pub USIC0_CH1: &'a USIC0_CH1,
    #[doc = "USIC1_CH0"]
    pub USIC1_CH0: &'a USIC1_CH0,
    #[doc = "USIC1_CH1"]
    pub USIC1_CH1: &'a USIC1_CH1,
    #[doc = "CAN"]
    pub CAN: &'a CAN,
    #[doc = "CAN_NODE0"]
    pub CAN_NODE0: &'a CAN_NODE0,
    #[doc = "CAN_NODE1"]
    pub CAN_NODE1: &'a CAN_NODE1,
    #[doc = "CAN_MO0"]
    pub CAN_MO0: &'a CAN_MO0,
    #[doc = "CAN_MO1"]
    pub CAN_MO1: &'a CAN_MO1,
    #[doc = "CAN_MO2"]
    pub CAN_MO2: &'a CAN_MO2,
    #[doc = "CAN_MO3"]
    pub CAN_MO3: &'a CAN_MO3,
    #[doc = "CAN_MO4"]
    pub CAN_MO4: &'a CAN_MO4,
    #[doc = "CAN_MO5"]
    pub CAN_MO5: &'a CAN_MO5,
    #[doc = "CAN_MO6"]
    pub CAN_MO6: &'a CAN_MO6,
    #[doc = "CAN_MO7"]
    pub CAN_MO7: &'a CAN_MO7,
    #[doc = "CAN_MO8"]
    pub CAN_MO8: &'a CAN_MO8,
    #[doc = "CAN_MO9"]
    pub CAN_MO9: &'a CAN_MO9,
    #[doc = "CAN_MO10"]
    pub CAN_MO10: &'a CAN_MO10,
    #[doc = "CAN_MO11"]
    pub CAN_MO11: &'a CAN_MO11,
    #[doc = "CAN_MO12"]
    pub CAN_MO12: &'a CAN_MO12,
    #[doc = "CAN_MO13"]
    pub CAN_MO13: &'a CAN_MO13,
    #[doc = "CAN_MO14"]
    pub CAN_MO14: &'a CAN_MO14,
    #[doc = "CAN_MO15"]
    pub CAN_MO15: &'a CAN_MO15,
    #[doc = "CAN_MO16"]
    pub CAN_MO16: &'a CAN_MO16,
    #[doc = "CAN_MO17"]
    pub CAN_MO17: &'a CAN_MO17,
    #[doc = "CAN_MO18"]
    pub CAN_MO18: &'a CAN_MO18,
    #[doc = "CAN_MO19"]
    pub CAN_MO19: &'a CAN_MO19,
    #[doc = "CAN_MO20"]
    pub CAN_MO20: &'a CAN_MO20,
    #[doc = "CAN_MO21"]
    pub CAN_MO21: &'a CAN_MO21,
    #[doc = "CAN_MO22"]
    pub CAN_MO22: &'a CAN_MO22,
    #[doc = "CAN_MO23"]
    pub CAN_MO23: &'a CAN_MO23,
    #[doc = "CAN_MO24"]
    pub CAN_MO24: &'a CAN_MO24,
    #[doc = "CAN_MO25"]
    pub CAN_MO25: &'a CAN_MO25,
    #[doc = "CAN_MO26"]
    pub CAN_MO26: &'a CAN_MO26,
    #[doc = "CAN_MO27"]
    pub CAN_MO27: &'a CAN_MO27,
    #[doc = "CAN_MO28"]
    pub CAN_MO28: &'a CAN_MO28,
    #[doc = "CAN_MO29"]
    pub CAN_MO29: &'a CAN_MO29,
    #[doc = "CAN_MO30"]
    pub CAN_MO30: &'a CAN_MO30,
    #[doc = "CAN_MO31"]
    pub CAN_MO31: &'a CAN_MO31,
    #[doc = "CAN_MO32"]
    pub CAN_MO32: &'a CAN_MO32,
    #[doc = "CAN_MO33"]
    pub CAN_MO33: &'a CAN_MO33,
    #[doc = "CAN_MO34"]
    pub CAN_MO34: &'a CAN_MO34,
    #[doc = "CAN_MO35"]
    pub CAN_MO35: &'a CAN_MO35,
    #[doc = "CAN_MO36"]
    pub CAN_MO36: &'a CAN_MO36,
    #[doc = "CAN_MO37"]
    pub CAN_MO37: &'a CAN_MO37,
    #[doc = "CAN_MO38"]
    pub CAN_MO38: &'a CAN_MO38,
    #[doc = "CAN_MO39"]
    pub CAN_MO39: &'a CAN_MO39,
    #[doc = "CAN_MO40"]
    pub CAN_MO40: &'a CAN_MO40,
    #[doc = "CAN_MO41"]
    pub CAN_MO41: &'a CAN_MO41,
    #[doc = "CAN_MO42"]
    pub CAN_MO42: &'a CAN_MO42,
    #[doc = "CAN_MO43"]
    pub CAN_MO43: &'a CAN_MO43,
    #[doc = "CAN_MO44"]
    pub CAN_MO44: &'a CAN_MO44,
    #[doc = "CAN_MO45"]
    pub CAN_MO45: &'a CAN_MO45,
    #[doc = "CAN_MO46"]
    pub CAN_MO46: &'a CAN_MO46,
    #[doc = "CAN_MO47"]
    pub CAN_MO47: &'a CAN_MO47,
    #[doc = "CAN_MO48"]
    pub CAN_MO48: &'a CAN_MO48,
    #[doc = "CAN_MO49"]
    pub CAN_MO49: &'a CAN_MO49,
    #[doc = "CAN_MO50"]
    pub CAN_MO50: &'a CAN_MO50,
    #[doc = "CAN_MO51"]
    pub CAN_MO51: &'a CAN_MO51,
    #[doc = "CAN_MO52"]
    pub CAN_MO52: &'a CAN_MO52,
    #[doc = "CAN_MO53"]
    pub CAN_MO53: &'a CAN_MO53,
    #[doc = "CAN_MO54"]
    pub CAN_MO54: &'a CAN_MO54,
    #[doc = "CAN_MO55"]
    pub CAN_MO55: &'a CAN_MO55,
    #[doc = "CAN_MO56"]
    pub CAN_MO56: &'a CAN_MO56,
    #[doc = "CAN_MO57"]
    pub CAN_MO57: &'a CAN_MO57,
    #[doc = "CAN_MO58"]
    pub CAN_MO58: &'a CAN_MO58,
    #[doc = "CAN_MO59"]
    pub CAN_MO59: &'a CAN_MO59,
    #[doc = "CAN_MO60"]
    pub CAN_MO60: &'a CAN_MO60,
    #[doc = "CAN_MO61"]
    pub CAN_MO61: &'a CAN_MO61,
    #[doc = "CAN_MO62"]
    pub CAN_MO62: &'a CAN_MO62,
    #[doc = "CAN_MO63"]
    pub CAN_MO63: &'a CAN_MO63,
    #[doc = "VADC"]
    pub VADC: &'a VADC,
    #[doc = "VADC_G0"]
    pub VADC_G0: &'a VADC_G0,
    #[doc = "VADC_G1"]
    pub VADC_G1: &'a VADC_G1,
    #[doc = "DAC"]
    pub DAC: &'a DAC,
    #[doc = "CCU40"]
    pub CCU40: &'a CCU40,
    #[doc = "CCU41"]
    pub CCU41: &'a CCU41,
    #[doc = "CCU40_CC40"]
    pub CCU40_CC40: &'a CCU40_CC40,
    #[doc = "CCU40_CC41"]
    pub CCU40_CC41: &'a CCU40_CC41,
    #[doc = "CCU40_CC42"]
    pub CCU40_CC42: &'a CCU40_CC42,
    #[doc = "CCU40_CC43"]
    pub CCU40_CC43: &'a CCU40_CC43,
    #[doc = "CCU41_CC40"]
    pub CCU41_CC40: &'a CCU41_CC40,
    #[doc = "CCU41_CC41"]
    pub CCU41_CC41: &'a CCU41_CC41,
    #[doc = "CCU41_CC42"]
    pub CCU41_CC42: &'a CCU41_CC42,
    #[doc = "CCU41_CC43"]
    pub CCU41_CC43: &'a CCU41_CC43,
    #[doc = "CCU80"]
    pub CCU80: &'a CCU80,
    #[doc = "CCU80_CC80"]
    pub CCU80_CC80: &'a CCU80_CC80,
    #[doc = "CCU80_CC81"]
    pub CCU80_CC81: &'a CCU80_CC81,
    #[doc = "CCU80_CC82"]
    pub CCU80_CC82: &'a CCU80_CC82,
    #[doc = "CCU80_CC83"]
    pub CCU80_CC83: &'a CCU80_CC83,
    #[doc = "HRPWM0"]
    pub HRPWM0: &'a HRPWM0,
    #[doc = "HRPWM0_CSG0"]
    pub HRPWM0_CSG0: &'a HRPWM0_CSG0,
    #[doc = "HRPWM0_CSG1"]
    pub HRPWM0_CSG1: &'a HRPWM0_CSG1,
    #[doc = "HRPWM0_CSG2"]
    pub HRPWM0_CSG2: &'a HRPWM0_CSG2,
    #[doc = "HRPWM0_HRC0"]
    pub HRPWM0_HRC0: &'a HRPWM0_HRC0,
    #[doc = "HRPWM0_HRC1"]
    pub HRPWM0_HRC1: &'a HRPWM0_HRC1,
    #[doc = "HRPWM0_HRC2"]
    pub HRPWM0_HRC2: &'a HRPWM0_HRC2,
    #[doc = "HRPWM0_HRC3"]
    pub HRPWM0_HRC3: &'a HRPWM0_HRC3,
    #[doc = "POSIF0"]
    pub POSIF0: &'a POSIF0,
    #[doc = "PORT0"]
    pub PORT0: &'a PORT0,
    #[doc = "PORT1"]
    pub PORT1: &'a PORT1,
    #[doc = "PORT2"]
    pub PORT2: &'a PORT2,
    #[doc = "PORT3"]
    pub PORT3: &'a PORT3,
    #[doc = "PORT14"]
    pub PORT14: &'a PORT14,
}
impl<'a> Peripherals<'a> {
    #[doc = r" Grants access to all the peripherals"]
    pub unsafe fn all() -> Self {
        Peripherals {
            CPUID: &*CPUID.get(),
            DCB: &*DCB.get(),
            DWT: &*DWT.get(),
            FPB: &*FPB.get(),
            FPU: &*FPU.get(),
            ITM: &*ITM.get(),
            MPU: &*MPU.get(),
            NVIC: &*NVIC.get(),
            SCB: &*SCB.get(),
            SYST: &*SYST.get(),
            TPIU: &*TPIU.get(),
            PPB: &*PPB.get(),
            DLR: &*DLR.get(),
            ERU0: &*ERU0.get(),
            ERU1: &*ERU1.get(),
            GPDMA0: &*GPDMA0.get(),
            GPDMA0_CH0: &*GPDMA0_CH0.get(),
            GPDMA0_CH1: &*GPDMA0_CH1.get(),
            GPDMA0_CH2: &*GPDMA0_CH2.get(),
            GPDMA0_CH3: &*GPDMA0_CH3.get(),
            GPDMA0_CH4: &*GPDMA0_CH4.get(),
            GPDMA0_CH5: &*GPDMA0_CH5.get(),
            GPDMA0_CH6: &*GPDMA0_CH6.get(),
            GPDMA0_CH7: &*GPDMA0_CH7.get(),
            FCE: &*FCE.get(),
            FCE_KE0: &*FCE_KE0.get(),
            FCE_KE1: &*FCE_KE1.get(),
            FCE_KE2: &*FCE_KE2.get(),
            FCE_KE3: &*FCE_KE3.get(),
            PBA0: &*PBA0.get(),
            PBA1: &*PBA1.get(),
            FLASH0: &*FLASH0.get(),
            PREF: &*PREF.get(),
            PMU0: &*PMU0.get(),
            WDT: &*WDT.get(),
            RTC: &*RTC.get(),
            SCU_CLK: &*SCU_CLK.get(),
            SCU_OSC: &*SCU_OSC.get(),
            SCU_PLL: &*SCU_PLL.get(),
            SCU_GENERAL: &*SCU_GENERAL.get(),
            SCU_INTERRUPT: &*SCU_INTERRUPT.get(),
            SCU_PARITY: &*SCU_PARITY.get(),
            SCU_TRAP: &*SCU_TRAP.get(),
            SCU_HIBERNATE: &*SCU_HIBERNATE.get(),
            SCU_POWER: &*SCU_POWER.get(),
            SCU_RESET: &*SCU_RESET.get(),
            LEDTS0: &*LEDTS0.get(),
            USB0: &*USB0.get(),
            USB0_EP0: &*USB0_EP0.get(),
            USB0_EP1: &*USB0_EP1.get(),
            USB0_EP2: &*USB0_EP2.get(),
            USB0_EP3: &*USB0_EP3.get(),
            USB0_EP4: &*USB0_EP4.get(),
            USB0_EP5: &*USB0_EP5.get(),
            USB0_EP6: &*USB0_EP6.get(),
            USIC0: &*USIC0.get(),
            USIC1: &*USIC1.get(),
            USIC0_CH0: &*USIC0_CH0.get(),
            USIC0_CH1: &*USIC0_CH1.get(),
            USIC1_CH0: &*USIC1_CH0.get(),
            USIC1_CH1: &*USIC1_CH1.get(),
            CAN: &*CAN.get(),
            CAN_NODE0: &*CAN_NODE0.get(),
            CAN_NODE1: &*CAN_NODE1.get(),
            CAN_MO0: &*CAN_MO0.get(),
            CAN_MO1: &*CAN_MO1.get(),
            CAN_MO2: &*CAN_MO2.get(),
            CAN_MO3: &*CAN_MO3.get(),
            CAN_MO4: &*CAN_MO4.get(),
            CAN_MO5: &*CAN_MO5.get(),
            CAN_MO6: &*CAN_MO6.get(),
            CAN_MO7: &*CAN_MO7.get(),
            CAN_MO8: &*CAN_MO8.get(),
            CAN_MO9: &*CAN_MO9.get(),
            CAN_MO10: &*CAN_MO10.get(),
            CAN_MO11: &*CAN_MO11.get(),
            CAN_MO12: &*CAN_MO12.get(),
            CAN_MO13: &*CAN_MO13.get(),
            CAN_MO14: &*CAN_MO14.get(),
            CAN_MO15: &*CAN_MO15.get(),
            CAN_MO16: &*CAN_MO16.get(),
            CAN_MO17: &*CAN_MO17.get(),
            CAN_MO18: &*CAN_MO18.get(),
            CAN_MO19: &*CAN_MO19.get(),
            CAN_MO20: &*CAN_MO20.get(),
            CAN_MO21: &*CAN_MO21.get(),
            CAN_MO22: &*CAN_MO22.get(),
            CAN_MO23: &*CAN_MO23.get(),
            CAN_MO24: &*CAN_MO24.get(),
            CAN_MO25: &*CAN_MO25.get(),
            CAN_MO26: &*CAN_MO26.get(),
            CAN_MO27: &*CAN_MO27.get(),
            CAN_MO28: &*CAN_MO28.get(),
            CAN_MO29: &*CAN_MO29.get(),
            CAN_MO30: &*CAN_MO30.get(),
            CAN_MO31: &*CAN_MO31.get(),
            CAN_MO32: &*CAN_MO32.get(),
            CAN_MO33: &*CAN_MO33.get(),
            CAN_MO34: &*CAN_MO34.get(),
            CAN_MO35: &*CAN_MO35.get(),
            CAN_MO36: &*CAN_MO36.get(),
            CAN_MO37: &*CAN_MO37.get(),
            CAN_MO38: &*CAN_MO38.get(),
            CAN_MO39: &*CAN_MO39.get(),
            CAN_MO40: &*CAN_MO40.get(),
            CAN_MO41: &*CAN_MO41.get(),
            CAN_MO42: &*CAN_MO42.get(),
            CAN_MO43: &*CAN_MO43.get(),
            CAN_MO44: &*CAN_MO44.get(),
            CAN_MO45: &*CAN_MO45.get(),
            CAN_MO46: &*CAN_MO46.get(),
            CAN_MO47: &*CAN_MO47.get(),
            CAN_MO48: &*CAN_MO48.get(),
            CAN_MO49: &*CAN_MO49.get(),
            CAN_MO50: &*CAN_MO50.get(),
            CAN_MO51: &*CAN_MO51.get(),
            CAN_MO52: &*CAN_MO52.get(),
            CAN_MO53: &*CAN_MO53.get(),
            CAN_MO54: &*CAN_MO54.get(),
            CAN_MO55: &*CAN_MO55.get(),
            CAN_MO56: &*CAN_MO56.get(),
            CAN_MO57: &*CAN_MO57.get(),
            CAN_MO58: &*CAN_MO58.get(),
            CAN_MO59: &*CAN_MO59.get(),
            CAN_MO60: &*CAN_MO60.get(),
            CAN_MO61: &*CAN_MO61.get(),
            CAN_MO62: &*CAN_MO62.get(),
            CAN_MO63: &*CAN_MO63.get(),
            VADC: &*VADC.get(),
            VADC_G0: &*VADC_G0.get(),
            VADC_G1: &*VADC_G1.get(),
            DAC: &*DAC.get(),
            CCU40: &*CCU40.get(),
            CCU41: &*CCU41.get(),
            CCU40_CC40: &*CCU40_CC40.get(),
            CCU40_CC41: &*CCU40_CC41.get(),
            CCU40_CC42: &*CCU40_CC42.get(),
            CCU40_CC43: &*CCU40_CC43.get(),
            CCU41_CC40: &*CCU41_CC40.get(),
            CCU41_CC41: &*CCU41_CC41.get(),
            CCU41_CC42: &*CCU41_CC42.get(),
            CCU41_CC43: &*CCU41_CC43.get(),
            CCU80: &*CCU80.get(),
            CCU80_CC80: &*CCU80_CC80.get(),
            CCU80_CC81: &*CCU80_CC81.get(),
            CCU80_CC82: &*CCU80_CC82.get(),
            CCU80_CC83: &*CCU80_CC83.get(),
            HRPWM0: &*HRPWM0.get(),
            HRPWM0_CSG0: &*HRPWM0_CSG0.get(),
            HRPWM0_CSG1: &*HRPWM0_CSG1.get(),
            HRPWM0_CSG2: &*HRPWM0_CSG2.get(),
            HRPWM0_HRC0: &*HRPWM0_HRC0.get(),
            HRPWM0_HRC1: &*HRPWM0_HRC1.get(),
            HRPWM0_HRC2: &*HRPWM0_HRC2.get(),
            HRPWM0_HRC3: &*HRPWM0_HRC3.get(),
            POSIF0: &*POSIF0.get(),
            PORT0: &*PORT0.get(),
            PORT1: &*PORT1.get(),
            PORT2: &*PORT2.get(),
            PORT3: &*PORT3.get(),
            PORT14: &*PORT14.get(),
        }
    }
}
